/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(J){for(var e=[],D=0,n=J.length;D<n;D++)e[D]=ie[J[D]];return e};define(ie[99],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=D}),define(ie[48],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(R,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(R,C,E){this.id=R,this.definition=C,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(T,R){const C=["codicon","codicon-"+T];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=L;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function C(b){if(b instanceof n)return["codicon","codicon-"+b.id];const d=R.exec(b.id);if(!d)return C(n.error);let[,y,h]=d;const S=["codicon","codicon-"+y];return h&&S.push("codicon-modifier-"+h.substr(1)),S}T.asClassNameArray=C;function E(b){return C(b).join(" ")}T.asClassName=E;function P(b){return"."+C(b).join(".")}T.asCSSSelector=P})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ie[67],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(P){const b=[];for(let d in P)D.call(P,d)&&b.push(P[d]);return b}e.values=n;function L(P,b){for(let d in P)if(D.call(P,d)&&b({key:d,value:P[d]},function(){delete P[d]})===!1)return}e.forEach=L;function A(P,b){const d=Object.create(null);for(const y of P){const h=b(y);let S=d[h];S||(S=d[h]=[]),S.push(y)}return d}e.groupBy=A;function T(P){const b=Object.create(null);return P&&P.forEach((d,y)=>{b[y]=d}),b}e.fromMap=T;function R(P,b){const d=[],y=[];for(let h of P)b.has(h)||d.push(h);for(let h of b)P.has(h)||y.push(h);return{removed:d,added:y}}e.diffSets=R;function C(P,b){const d=[],y=[];for(let[h,S]of P)b.has(h)||d.push(S);for(let[h,S]of b)P.has(h)||y.push(S);return{removed:d,added:y}}e.diffMaps=C;class E{constructor(){this.map=new Map}add(b,d){let y=this.map.get(b);y||(y=new Set,this.map.set(b,y)),y.add(d)}delete(b,d){const y=this.map.get(b);!y||(y.delete(d),y.size===0&&this.map.delete(b))}forEach(b,d){const y=this.map.get(b);!y||y.forEach(d)}}e.SetMap=E}),define(ie[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(R,C,E)=>{let P=null,b=null;if(typeof E.value=="function"?(P="value",b=E.value):typeof E.get=="function"&&(P="get",b=E.get),!b)throw new Error("not supported");E[P]=T(b,C)}}e.createDecorator=D;function n(T,R,C){let E=null,P=null;if(typeof C.value=="function"?(E="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(E="get",P=C.get),!P)throw new Error("not supported");const b=`$memoize$${R}`;C[E]=function(...d){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[b]}}e.memoize=n;function L(T,R,C){return D((E,P)=>{const b=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...y){this[d]||(this[d]=C?C():void 0),clearTimeout(this[b]),R&&(this[d]=R(this[d],...y),y=[this[d]]),this[b]=setTimeout(()=>{E.apply(this,y),this[d]=C?C():void 0},T)}})}e.debounce=L;function A(T,R,C){return D((E,P)=>{const b=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,y=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...S){if(this[d]||(this[d]=C?C():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...S)),this[h])return;const f=this[y]+T;f<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[d]]),this[d]=C?C():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),E.apply(this,[this[d]]),this[d]=C?C():void 0},f-Date.now()))}})}e.throttle=A}),define(ie[9],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function L(l){C(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=L;function A(l){C(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=A;function T(l){if(l instanceof Error){let{name:r,message:a}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:a,stack:i}}return l}e.transformErrorForSerialization=T;const R="Canceled";function C(l){return l instanceof E?!0:l instanceof Error&&l.name===R&&l.message===R}e.isCancellationError=C;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function P(){const l=new Error(R);return l.name=l.message,l}e.canceled=P;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=b;function d(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=d;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function S(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=S;class f extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=f;class v extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=v;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function g(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function p(l,r=Object.create(null)){const a=new Error(l);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=p}),define(ie[16],re([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(q,F=0){return q[q.length-(1+F)]}e.tail=n;function L(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=L;function A(q,F,V=($,B)=>$===B){if(q===F)return!0;if(!q||!F||q.length!==F.length)return!1;for(let $=0,B=q.length;$<B;$++)if(!V(q[$],F[$]))return!1;return!0}e.equals=A;function T(q,F,V){let $=0,B=q.length-1;for(;$<=B;){const te=($+B)/2|0,se=V(q[te],F);if(se<0)$=te+1;else if(se>0)B=te-1;else return te}return-($+1)}e.binarySearch=T;function R(q,F){let V=0,$=q.length;if($===0)return 0;for(;V<$;){const B=Math.floor((V+$)/2);F(q[B])?$=B:V=B+1}return V}e.findFirstInSorted=R;function C(q,F,V){if(q=q|0,q>=F.length)throw new TypeError("invalid index");let $=F[Math.floor(F.length*Math.random())],B=[],te=[],se=[];for(let ce of F){const he=V(ce,$);he<0?B.push(ce):he>0?te.push(ce):se.push(ce)}return q<B.length?C(q,B,V):q<B.length+se.length?se[0]:C(q-(B.length+se.length),te,V)}e.quickSelect=C;function E(q,F){const V=[];let $;for(const B of q.slice(0).sort(F))!$||F($[0],B)!==0?($=[B],V.push($)):$.push(B);return V}e.groupBy=E;function P(q,F,V){const $=[];function B(ce,he,ge){if(he===0&&ge.length===0)return;const me=$[$.length-1];me&&me.start+me.deleteCount===ce?(me.deleteCount+=he,me.toInsert.push(...ge)):$.push({start:ce,deleteCount:he,toInsert:ge})}let te=0,se=0;for(;;){if(te===q.length){B(te,0,F.slice(se));break}if(se===F.length){B(te,q.length-te,[]);break}const ce=q[te],he=F[se],ge=V(ce,he);ge===0?(te+=1,se+=1):ge<0?(B(te,1,[]),te+=1):ge>0&&(B(te,0,[he]),se+=1)}return $}e.sortedDiff=P;function b(q,F,V){const $=P(q,F,V),B=[],te=[];for(const se of $)B.push(...q.slice(se.start,se.start+se.deleteCount)),te.push(...se.toInsert);return{removed:B,added:te}}e.delta=b;function d(q,F,V){if(V===0)return[];const $=q.slice(0,V).sort(F);return h(q,F,$,V,q.length),$}e.top=d;function y(q,F,V,$,B){return V===0?Promise.resolve([]):new Promise((te,se)=>{(async()=>{const ce=q.length,he=q.slice(0,V).sort(F);for(let ge=V,me=Math.min(V+$,ce);ge<ce;ge=me,me=Math.min(me+$,ce)){if(ge>V&&await new Promise(ye=>setTimeout(ye)),B&&B.isCancellationRequested)throw(0,D.canceled)();h(q,F,he,ge,me)}return he})().then(te,se)})}e.topAsync=y;function h(q,F,V,$,B){for(const te=V.length;$<B;$++){const se=q[$];if(F(se,V[te-1])<0){V.pop();const ce=R(V,he=>F(se,he)<0);V.splice(ce,0,se)}}}function S(q){return q.filter(F=>!!F)}e.coalesce=S;function f(q){let F=0;for(let V=0;V<q.length;V++)q[V]&&(q[F]=q[V],F+=1);q.length=F}e.coalesceInPlace=f;function v(q,F,V){q.splice(V,0,q.splice(F,1)[0])}e.move=v;function w(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=w;function g(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=g;function p(q,F=V=>V){const V=new Set;return q.filter($=>{const B=F($);return V.has(B)?!1:(V.add(B),!0)})}e.distinct=p;function l(q){const F=new Set;return V=>{const $=q(V);return F.has($)?!1:(F.add($),!0)}}e.uniqueFilter=l;function r(q,F){const V=a(q,F);if(V!==-1)return q[V]}e.findLast=r;function a(q,F){for(let V=q.length-1;V>=0;V--){const $=q[V];if(F($))return V}return-1}e.lastIndex=a;function i(q,F){return q.length>0?q[0]:F}e.firstOrDefault=i;function t(q,F,V=($,B)=>$===B){let $=0;for(let B=0,te=Math.min(q.length,F.length);B<te&&V(q[B],F[B]);B++)$++;return $}e.commonPrefixLength=t;function s(q){return[].concat(...q)}e.flatten=s;function o(q,F){let V=typeof F=="number"?q:0;typeof F=="number"?V=q:(V=0,F=q);const $=[];if(V<=F)for(let B=V;B<F;B++)$.push(B);else for(let B=V;B>F;B--)$.push(B);return $}e.range=o;function c(q,F,V){return q.reduce(($,B)=>($[F(B)]=V?V(B):B,$),Object.create(null))}e.index=c;function u(q,F){return q.push(F),()=>m(q,F)}e.insert=u;function m(q,F){const V=q.indexOf(F);if(V>-1)return q.splice(V,1),F}e.remove=m;function I(q,F,V){const $=q.slice(0,F),B=q.slice(F);return $.concat(V,B)}e.arrayInsert=I;function _(q,F){let V;if(typeof F=="number"){let $=F;V=()=>{const B=Math.sin($++)*179426549;return B-Math.floor(B)}}else V=Math.random;for(let $=q.length-1;$>0;$-=1){const B=Math.floor(V()*($+1)),te=q[$];q[$]=q[B],q[B]=te}}e.shuffle=_;function O(q,F){const V=q.indexOf(F);V>-1&&(q.splice(V,1),q.unshift(F))}e.pushToStart=O;function N(q,F){const V=q.indexOf(F);V>-1&&(q.splice(V,1),q.push(F))}e.pushToEnd=N;function z(q,F){return Array.isArray(q)?q.map(F):F(q)}e.mapArrayOrNot=z;function k(q){return Array.isArray(q)?q:[q]}e.asArray=k;function M(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=M;function j(q,F){for(const V of q){const $=F(V);if($!==void 0)return $}}e.mapFind=j;function U(q,F,V){const $=K(q,F),B=q.length,te=V.length;q.length=B+te;for(let se=B-1;se>=$;se--)q[se+te]=q[se];for(let se=0;se<te;se++)q[se+$]=V[se]}e.insertInto=U;function G(q,F,V,$){const B=K(q,F),te=q.splice(B,V);return U(q,B,$),te}e.splice=G;function K(q,F){return F<0?Math.max(F+q.length,0):Math.min(F,q.length)}function x(q,F){return(V,$)=>F(q(V),q($))}e.compareBy=x;const W=(q,F)=>q-F;e.numberComparator=W;function X(q,F){if(q.length===0)return;let V=q[0];for(let $=1;$<q.length;$++){const B=q[$];F(B,V)>0&&(V=B)}return V}e.findMaxBy=X;function H(q,F){if(q.length===0)return;let V=q[0];for(let $=1;$<q.length;$++){const B=q[$];F(B,V)>=0&&(V=B)}return V}e.findLastMaxBy=H;function Z(q,F){return X(q,(V,$)=>-F(V,$))}e.findMinBy=Z;class ee{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let V=this.firstIdx;for(;V<this.items.length&&F(this.items[V]);)V++;const $=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,$}takeFromEndWhile(F){let V=this.lastIdx;for(;V>=0&&F(this.items[V]);)V--;const $=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,$}peek(){return this.items[this.firstIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}takeCount(F){const V=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,V}}e.ArrayQueue=ee}),define(ie[68],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const L=this;let A=!1,T;return function(){return A||(A=!0,T=n.apply(L,arguments)),T}}e.once=D}),define(ie[54],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=L;const A=Object.freeze([]);function T(){return A}n.empty=T;function*R(l){yield l}n.single=R;function C(l){return l||A}n.from=C;function E(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=E;function P(l){return l[Symbol.iterator]().next().value}n.first=P;function b(l,r){for(const a of l)if(r(a))return!0;return!1}n.some=b;function d(l,r){for(const a of l)if(r(a))return a}n.find=d;function*y(l,r){for(const a of l)r(a)&&(yield a)}n.filter=y;function*h(l,r){let a=0;for(const i of l)yield r(i,a++)}n.map=h;function*S(...l){for(const r of l)for(const a of r)yield a}n.concat=S;function*f(l){for(const r of l)for(const a of r)yield a}n.concatNested=f;function v(l,r,a){let i=a;for(const t of l)i=r(i,t);return i}n.reduce=v;function*w(l,r,a=l.length){for(r<0&&(r+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);r<a;r++)yield l[r]}n.slice=w;function g(l,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,l];const i=l[Symbol.iterator]();for(let t=0;t<r;t++){const s=i.next();if(s.done)return[a,n.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return i}}]}n.consume=g;function p(l,r,a=(i,t)=>i===t){const i=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=i.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}n.equals=p})(D=e.Iterable||(e.Iterable={}))}),define(ie[35],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(r){r.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(r,a=!1){let i=0,t=r.length,s="",o=0,c=16,u=0;function m(M){let j=0,U=0;for(;j<M;){const G=r.charCodeAt(i);if(G>=48&&G<=57)U=U*16+G-48;else if(G>=65&&G<=70)U=U*16+G-65+10;else if(G>=97&&G<=102)U=U*16+G-97+10;else break;i++,j++}return j<M&&(U=-1),U}function I(M){i=M,s="",o=0,c=16,u=0}function _(){const M=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&E(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&E(r.charCodeAt(i)))for(i++;i<r.length&&E(r.charCodeAt(i));)i++;else return u=3,r.substring(M,i);let j=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&E(r.charCodeAt(i))){for(i++;i<r.length&&E(r.charCodeAt(i));)i++;j=i}else u=3;return r.substring(M,j)}function O(){let M="",j=i;for(;;){if(i>=t){M+=r.substring(j,i),u=2;break}const U=r.charCodeAt(i);if(U===34){M+=r.substring(j,i),i++;break}if(U===92){if(M+=r.substring(j,i),i++,i>=t){u=2;break}switch(r.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const K=m(4);K>=0?M+=String.fromCharCode(K):u=4;break}default:u=5}j=i;continue}if(U>=0&&U<=31)if(C(U)){M+=r.substring(j,i),u=2;break}else u=6;i++}return M}function N(){if(s="",u=0,o=i,i>=t)return o=t,c=17;let M=r.charCodeAt(i);if(R(M)){do i++,s+=String.fromCharCode(M),M=r.charCodeAt(i);while(R(M));return c=15}if(C(M))return i++,s+=String.fromCharCode(M),M===13&&r.charCodeAt(i)===10&&(i++,s+=`
`),c=14;switch(M){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,s=O(),c=10;case 47:{const j=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!C(r.charCodeAt(i));)i++;return s=r.substring(j,i),c=12}if(r.charCodeAt(i+1)===42){i+=2;const U=t-1;let G=!1;for(;i<U;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,u=1),s=r.substring(j,i),c=13}return s+=String.fromCharCode(M),i++,c=16}case 45:if(s+=String.fromCharCode(M),i++,i===t||!E(r.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=_(),c=11;default:for(;i<t&&z(M);)i++,M=r.charCodeAt(i);if(o!==i){switch(s=r.substring(o,i),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(M),i++,c=16}}function z(M){if(R(M)||C(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let M;do M=N();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>i,scan:a?k:N,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>u}}e.createScanner=T;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function C(r){return r===10||r===13||r===8232||r===8233}function E(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function b(r,a){const i=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(m,I,_,O){o.value=m,o.offset=I,o.length=_,o.type=O,o.colonOffset=void 0,s=o}try{g(r,{onObjectBegin:(m,I)=>{if(a<=m)throw t;s=void 0,c=a>m,i.push("")},onObjectProperty:(m,I,_)=>{if(a<I||(u(m,I,_,"property"),i[i.length-1]=m,a<=I+_))throw t},onObjectEnd:(m,I)=>{if(a<=m)throw t;s=void 0,i.pop()},onArrayBegin:(m,I)=>{if(a<=m)throw t;s=void 0,i.push(0)},onArrayEnd:(m,I)=>{if(a<=m)throw t;s=void 0,i.pop()},onLiteralValue:(m,I,_)=>{if(a<I||(u(m,I,_,l(m)),a<=I+_))throw t},onSeparator:(m,I,_)=>{if(a<=I)throw t;if(m===":"&&s&&s.type==="property")s.colonOffset=I,c=!1,s=void 0;else if(m===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(c=!0,i[i.length-1]=""),s=void 0}}})}catch(m){if(m!==t)throw m}return{path:i,previousNode:s,isAtPropertyKey:c,matches:m=>{let I=0;for(let _=0;I<m.length&&_<i.length;_++)if(m[I]===i[_]||m[I]==="*")I++;else if(m[I]!=="**")return!1;return I===m.length}}}e.getLocation=b;function d(r,a=[],i=A.DEFAULT){let t=null,s=[];const o=[];function c(m){Array.isArray(s)?s.push(m):t!==null&&(s[t]=m)}return g(r,{onObjectBegin:()=>{const m={};c(m),o.push(s),s=m,t=null},onObjectProperty:m=>{t=m},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const m=[];c(m),o.push(s),s=m,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(m,I,_)=>{a.push({error:m,offset:I,length:_})}},i),s[0]}e.parse=d;function y(r,a=[],i=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(m){t.type==="property"&&(t.length=m-t.offset,t=t.parent)}function o(m){return t.children.push(m),m}g(r,{onObjectBegin:m=>{t=o({type:"object",offset:m,length:-1,parent:t,children:[]})},onObjectProperty:(m,I,_)=>{t=o({type:"property",offset:I,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:m,offset:I,length:_,parent:t})},onObjectEnd:(m,I)=>{t.length=m+I-t.offset,t=t.parent,s(m+I)},onArrayBegin:(m,I)=>{t=o({type:"array",offset:m,length:-1,parent:t,children:[]})},onArrayEnd:(m,I)=>{t.length=m+I-t.offset,t=t.parent,s(m+I)},onLiteralValue:(m,I,_)=>{o({type:l(m),offset:I,length:_,parent:t,value:m}),s(I+_)},onSeparator:(m,I,_)=>{t.type==="property"&&(m===":"?t.colonOffset=I:m===","&&s(I))},onError:(m,I,_)=>{a.push({error:m,offset:I,length:_})}},i);const u=t.children[0];return u&&delete u.parent,u}e.parseTree=y;function h(r,a){if(!r)return;let i=r;for(let t of a)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===t){i=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=h;function S(r){if(!r.parent||!r.parent.children)return[];const a=S(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;a.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&a.push(i)}return a}e.getNodePath=S;function f(r){switch(r.type){case"array":return r.children.map(f);case"object":{const a=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(a[i.children[0].value]=f(t))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=f;function v(r,a,i=!1){return a>=r.offset&&a<r.offset+r.length||i&&a===r.offset+r.length}e.contains=v;function w(r,a,i=!1){if(v(r,a,i)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=w(t[s],a,i);if(o)return o}return r}}e.findNodeAtOffset=w;function g(r,a,i=A.DEFAULT){const t=T(r,!1);function s(ee){return ee?()=>ee(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(ee){return ee?q=>ee(q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=s(a.onObjectBegin),u=o(a.onObjectProperty),m=s(a.onObjectEnd),I=s(a.onArrayBegin),_=s(a.onArrayEnd),O=o(a.onLiteralValue),N=o(a.onSeparator),z=s(a.onComment),k=o(a.onError),M=i&&i.disallowComments,j=i&&i.allowTrailingComma;function U(){for(;;){const ee=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:M||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(ee){case 12:case 13:M?G(10):z();break;case 16:G(1);break;case 15:case 14:break;default:return ee}}}function G(ee,q=[],F=[]){if(k(ee),q.length+F.length>0){let V=t.getToken();for(;V!==17;){if(q.indexOf(V)!==-1){U();break}else if(F.indexOf(V)!==-1)break;V=U()}}}function K(ee){const q=t.getTokenValue();return ee?O(q):u(q),U(),!0}function x(){switch(t.getToken()){case 11:{let ee=0;try{ee=JSON.parse(t.getTokenValue()),typeof ee!="number"&&(G(2),ee=0)}catch{G(2)}O(ee);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return U(),!0}function W(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(K(!1),t.getToken()===6?(N(":"),U(),Z()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function X(){c(),U();let ee=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),N(","),U(),t.getToken()===2&&j)break}else ee&&G(6,[],[]);W()||G(4,[],[2,5]),ee=!0}return m(),t.getToken()!==2?G(7,[2],[]):U(),!0}function H(){I(),U();let ee=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),N(","),U(),t.getToken()===4&&j)break}else ee&&G(6,[],[]);Z()||G(4,[],[4,5]),ee=!0}return _(),t.getToken()!==4?G(8,[4],[]):U(),!0}function Z(){switch(t.getToken()){case 3:return H();case 1:return X();case 10:return K(!0);default:return x()}}return U(),t.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):Z()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=g;function p(r,a){let i=T(r),t=[],s,o=0,c;do switch(c=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==c&&t.push(r.substring(o,c)),a!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(s!==17);return t.join("")}e.stripComments=p;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ie[49],re([0,1,35]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,P,b){let d,y,h,S,f;if(P){for(S=P.offset,f=S+P.length,h=S;h>0&&!C(E,h-1);)h--;let c=f;for(;c<E.length&&!C(E,c);)c++;y=E.substring(h,c),d=T(y,b)}else y=E,d=0,h=0,S=0,f=E.length;const v=R(b,E);let w=!1,g=0,p;b.insertSpaces?p=A(" ",b.tabSize||4):p="	";const l=(0,D.createScanner)(y,!1);let r=!1;function a(){return v+A(p,d+g)}function i(){let c=l.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=l.scan();return r=c===16||l.getTokenError()!==0,c}const t=[];function s(c,u,m){!r&&u<f&&m>S&&E.substring(u,m)!==c&&t.push({offset:u,length:m-u,content:c})}let o=i();if(o!==17){const c=l.getTokenOffset()+h,u=A(p,d);s(u,h,c)}for(;o!==17;){let c=l.getTokenOffset()+l.getTokenLength()+h,u=i(),m="";for(;!w&&(u===12||u===13);){const _=l.getTokenOffset()+h;s(" ",c,_),c=l.getTokenOffset()+l.getTokenLength()+h,m=u===12?a():"",u=i()}if(u===2)o!==1&&(g--,m=a());else if(u===4)o!==3&&(g--,m=a());else{switch(o){case 3:case 1:g++,m=a();break;case 5:case 12:m=a();break;case 13:w?m=a():m=" ";break;case 6:m=" ";break;case 10:if(u===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?m=" ":u!==5&&u!==17&&(r=!0);break;case 16:r=!0;break}w&&(u===12||u===13)&&(m=a())}const I=l.getTokenOffset()+h;s(m,c,I),o=u}return t}e.format=n;function L(E,P){const b=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?b.replace(/\r\n|\r|\n/g,P.eol):b}e.toFormattedString=L;function A(E,P){let b="";for(let d=0;d<P;d++)b+=E;return b}function T(E,P){let b=0,d=0;const y=P.tabSize||4;for(;b<E.length;){const h=E.charAt(b);if(h===" ")d++;else if(h==="	")d+=y;else break;b++}return Math.floor(d/y)}function R(E,P){for(let b=0;b<P.length;b++){const d=P.charAt(b);if(d==="\r")return b+1<P.length&&P.charAt(b+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=R;function C(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}e.isEOL=C}),define(ie[69],re([0,1,35,49]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(E,P,b){return A(E,P,void 0,b)}e.removeProperty=L;function A(E,P,b,d,y){const h=P.slice(),S=[],f=(0,D.parseTree)(E,S);let v,w;for(;h.length>0&&(w=h.pop(),v=(0,D.findNodeAtLocation)(f,h),v===void 0&&b!==void 0);)typeof w=="string"?b={[w]:b}:b=[b];if(v)if(v.type==="object"&&typeof w=="string"&&Array.isArray(v.children)){const g=(0,D.findNodeAtLocation)(v,[w]);if(g!==void 0)if(b===void 0){if(!g.parent)throw new Error("Malformed AST");const p=v.children.indexOf(g.parent);let l,r=g.parent.offset+g.parent.length;if(p>0){const a=v.children[p-1];l=a.offset+a.length}else l=v.offset+1,v.children.length>1&&(r=v.children[1].offset);return T(E,{offset:l,length:r-l,content:""},d)}else return T(E,{offset:g.offset,length:g.length,content:JSON.stringify(b)},d);else{if(b===void 0)return[];const p=`${JSON.stringify(w)}: ${JSON.stringify(b)}`,l=y?y(v.children.map(a=>a.children[0].value)):v.children.length;let r;if(l>0){const a=v.children[l-1];r={offset:a.offset+a.length,length:0,content:","+p}}else v.children.length===0?r={offset:v.offset+1,length:0,content:p}:r={offset:v.offset+1,length:0,content:p+","};return T(E,r,d)}}else if(v.type==="array"&&typeof w=="number"&&Array.isArray(v.children))if(b!==void 0){const g=`${JSON.stringify(b)}`;let p;if(v.children.length===0||w===0)p={offset:v.offset+1,length:0,content:v.children.length===0?g:g+","};else{const l=w===-1||w>v.children.length?v.children.length:w,r=v.children[l-1];p={offset:r.offset+r.length,length:0,content:","+g}}return T(E,p,d)}else{const g=w,p=v.children[g];let l;if(v.children.length===1)l={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===g){const r=v.children[g-1],a=r.offset+r.length,i=v.offset+v.length;l={offset:a,length:i-2-a,content:""}}else l={offset:p.offset,length:v.children[g+1].offset-p.offset,content:""};return T(E,l,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${v.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return T(E,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(b)},d)}}e.setProperty=A;function T(E,P,b){let d=R(E,P),y=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;y>0&&!(0,n.isEOL)(d,y-1);)y--;for(;h<d.length&&!(0,n.isEOL)(d,h);)h++}const S=(0,n.format)(d,{offset:y,length:h-y},b);for(let v=S.length-1;v>=0;v--){const w=S[v];d=R(d,w),y=Math.min(y,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const f=E.length-(d.length-h)-y;return[{offset:y,length:f,content:d.substring(y,h)}]}e.withFormatting=T;function R(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}e.applyEdit=R;function C(E,P){let b=P.slice(0).sort((y,h)=>{const S=y.offset-h.offset;return S===0?y.length-h.length:S}),d=E.length;for(let y=b.length-1;y>=0;y--){let h=b[y];if(h.offset+h.length<=d)E=R(E,h);else throw new Error("Overlapping edit");d=h.offset}return E}e.applyEdits=C}),define(ie[100],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new D(()=>L(this.getValue()))}}e.Lazy=D}),define(ie[2],re([0,1,68,54]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let A=null;function T(t){A=t}if(e.setDisposableTracker=T,L){const t="__is_disposable_tracked__";T(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function R(t){return A?.trackDisposable(t),t}function C(t){A?.markAsDisposed(t)}function E(t,s){A?.setParent(t,s)}function P(t,s){if(!!A)for(const o of t)A.setParent(o,s)}function b(t){return A?.markAsSingleton(t),t}e.markAsSingleton=b;class d extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=d;function y(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=y;function h(t){if(n.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new d(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function S(...t){const s=f(()=>h(t));return P(t,s),s}e.combinedDisposable=S;function f(t){const s=R({dispose:(0,D.once)(()=>{C(s),t()})});return s}e.toDisposable=f;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return E(s,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new v,R(this),E(this._store,this)}dispose(){C(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&E(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&E(s,null),s}}e.MutableDisposable=g;class p{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class l{constructor(){this.references=new Map}acquire(s,...o){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,c));const{object:u}=c,m=(0,D.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:u,dispose:m}}}e.ReferenceCollection=l;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const c=this.referenceCollection.acquire(s,...o);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(u){throw c.dispose(),u}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function i(t){const s=new v;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=i}),define(ie[101],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let A=this._first;for(;A!==D.Undefined;){const T=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const R=new D(A);if(this._first===D.Undefined)this._first=R,this._last=R;else if(T){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(R))}}shift(){if(this._first!==D.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==D.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===D.Undefined&&A.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):A.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):A.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.LinkedList=n}),function(){function J(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function T(C){A.push(C,Date.now())}function R(){const C=[];for(let E=0;E<A.length;E+=2)C.push({name:A[E],startTime:A[E+1]});return C}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(L+T.startTime)});return A}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(ie[4],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let n=!1,L=!1,A=!1,T=!1,R=!1,C=!1,E=!1,P=!1,b,d=D,y,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?S=e.globals.vscode.process:typeof process!="undefined"&&(S=process);const f=typeof S?.versions?.electron=="string",v=f&&S?.type==="renderer";if(e.isElectronSandboxed=v&&S?.sandboxed,typeof navigator=="object"&&!v)h=navigator.userAgent,n=h.indexOf("Windows")>=0,L=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,C=!0,b=navigator.language,d=b;else if(typeof S=="object"){n=S.platform==="win32",L=S.platform==="darwin",A=S.platform==="linux",T=A&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,E=f,b=D,d=D;const s=S.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),c=o.availableLanguages["*"];b=o.locale,d=c||D,y=o._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let p=0;L?p=1:n?p=3:A&&(p=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=T,e.isNative=R,e.isElectron=E,e.isWeb=C,e.isIOS=P,e.platform=p,e.userAgent=h,e.language=d;var l;(function(s){function o(){return e.language}s.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function u(){return e.language==="en"}s.isDefault=u})(l=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=y,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let u=0,m=s.length;u<m;u++){const I=s[u];if(I.id===c.data.vscodeScheduleAsyncWork){s.splice(u,1),I.callback();return}}});let o=0;return c=>{const u=++o;s.push({id:u,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||P?2:n?1:3;let a=!0,i=!1;function t(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(ie[32],re([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const L=D.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ie[10],re([0,1,32]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,A=90,T=122,R=46,C=47,E=92,P=58,b=63;class d extends Error{constructor(p,l,r){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const i=p.indexOf(".")!==-1?"property":"argument";let t=`The "${p}" ${i} ${a} of type ${l}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function y(g,p){if(typeof g!="string")throw new d(p,"string",g)}function h(g){return g===C||g===E}function S(g){return g===C}function f(g){return g>=n&&g<=A||g>=L&&g<=T}function v(g,p,l,r){let a="",i=0,t=-1,s=0,o=0;for(let c=0;c<=g.length;++c){if(c<g.length)o=g.charCodeAt(c);else{if(r(o))break;o=C}if(r(o)){if(!(t===c-1||s===1))if(s===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const u=a.lastIndexOf(l);u===-1?(a="",i=0):(a=a.slice(0,u),i=a.length-1-a.lastIndexOf(l)),t=c,s=0;continue}else if(a.length!==0){a="",i=0,t=c,s=0;continue}}p&&(a+=a.length>0?`${l}..`:"..",i=2)}else a.length>0?a+=`${l}${g.slice(t+1,c)}`:a=g.slice(t+1,c),i=c-t-1;t=c,s=0}else o===R&&s!==-1?++s:s=-1}return a}function w(g,p){if(p===null||typeof p!="object")throw new d("pathObject","Object",p);const l=p.dir||p.root,r=p.base||`${p.name||""}${p.ext||""}`;return l?l===p.root?`${l}${r}`:`${l}${g}${r}`:r}e.win32={resolve(...g){let p="",l="",r=!1;for(let a=g.length-1;a>=-1;a--){let i;if(a>=0){if(i=g[a],y(i,"path"),i.length===0)continue}else p.length===0?i=D.cwd():(i=D.env[`=${p}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==p.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${p}\\`));const t=i.length;let s=0,o="",c=!1;const u=i.charCodeAt(0);if(t===1)h(u)&&(s=1,c=!0);else if(h(u))if(c=!0,h(i.charCodeAt(1))){let m=2,I=m;for(;m<t&&!h(i.charCodeAt(m));)m++;if(m<t&&m!==I){const _=i.slice(I,m);for(I=m;m<t&&h(i.charCodeAt(m));)m++;if(m<t&&m!==I){for(I=m;m<t&&!h(i.charCodeAt(m));)m++;(m===t||m!==I)&&(o=`\\\\${_}\\${i.slice(I,m)}`,s=m)}}}else s=1;else f(u)&&i.charCodeAt(1)===P&&(o=i.slice(0,2),s=2,t>2&&h(i.charCodeAt(2))&&(c=!0,s=3));if(o.length>0)if(p.length>0){if(o.toLowerCase()!==p.toLowerCase())continue}else p=o;if(r){if(p.length>0)break}else if(l=`${i.slice(s)}\\${l}`,r=c,c&&p.length>0)break}return l=v(l,!r,"\\",h),r?`${p}\\${l}`:`${p}${l}`||"."},normalize(g){y(g,"path");const p=g.length;if(p===0)return".";let l=0,r,a=!1;const i=g.charCodeAt(0);if(p===1)return S(i)?"\\":g;if(h(i))if(a=!0,h(g.charCodeAt(1))){let s=2,o=s;for(;s<p&&!h(g.charCodeAt(s));)s++;if(s<p&&s!==o){const c=g.slice(o,s);for(o=s;s<p&&h(g.charCodeAt(s));)s++;if(s<p&&s!==o){for(o=s;s<p&&!h(g.charCodeAt(s));)s++;if(s===p)return`\\\\${c}\\${g.slice(o)}\\`;s!==o&&(r=`\\\\${c}\\${g.slice(o,s)}`,l=s)}}}else l=1;else f(i)&&g.charCodeAt(1)===P&&(r=g.slice(0,2),l=2,p>2&&h(g.charCodeAt(2))&&(a=!0,l=3));let t=l<p?v(g.slice(l),!a,"\\",h):"";return t.length===0&&!a&&(t="."),t.length>0&&h(g.charCodeAt(p-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){y(g,"path");const p=g.length;if(p===0)return!1;const l=g.charCodeAt(0);return h(l)||p>2&&f(l)&&g.charCodeAt(1)===P&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let p,l;for(let i=0;i<g.length;++i){const t=g[i];y(t,"path"),t.length>0&&(p===void 0?p=l=t:p+=`\\${t}`)}if(p===void 0)return".";let r=!0,a=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++a;const i=l.length;i>1&&h(l.charCodeAt(1))&&(++a,i>2&&(h(l.charCodeAt(2))?++a:r=!1))}if(r){for(;a<p.length&&h(p.charCodeAt(a));)a++;a>=2&&(p=`\\${p.slice(a)}`)}return e.win32.normalize(p)},relative(g,p){if(y(g,"from"),y(p,"to"),g===p)return"";const l=e.win32.resolve(g),r=e.win32.resolve(p);if(l===r||(g=l.toLowerCase(),p=r.toLowerCase(),g===p))return"";let a=0;for(;a<g.length&&g.charCodeAt(a)===E;)a++;let i=g.length;for(;i-1>a&&g.charCodeAt(i-1)===E;)i--;const t=i-a;let s=0;for(;s<p.length&&p.charCodeAt(s)===E;)s++;let o=p.length;for(;o-1>s&&p.charCodeAt(o-1)===E;)o--;const c=o-s,u=t<c?t:c;let m=-1,I=0;for(;I<u;I++){const O=g.charCodeAt(a+I);if(O!==p.charCodeAt(s+I))break;O===E&&(m=I)}if(I!==u){if(m===-1)return r}else{if(c>u){if(p.charCodeAt(s+I)===E)return r.slice(s+I+1);if(I===2)return r.slice(s+I)}t>u&&(g.charCodeAt(a+I)===E?m=I:I===2&&(m=3)),m===-1&&(m=0)}let _="";for(I=a+m+1;I<=i;++I)(I===i||g.charCodeAt(I)===E)&&(_+=_.length===0?"..":"\\..");return s+=m,_.length>0?`${_}${r.slice(s,o)}`:(r.charCodeAt(s)===E&&++s,r.slice(s,o))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const p=e.win32.resolve(g);if(p.length<=2)return g;if(p.charCodeAt(0)===E){if(p.charCodeAt(1)===E){const l=p.charCodeAt(2);if(l!==b&&l!==R)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(f(p.charCodeAt(0))&&p.charCodeAt(1)===P&&p.charCodeAt(2)===E)return`\\\\?\\${p}`;return g},dirname(g){y(g,"path");const p=g.length;if(p===0)return".";let l=-1,r=0;const a=g.charCodeAt(0);if(p===1)return h(a)?g:".";if(h(a)){if(l=r=1,h(g.charCodeAt(1))){let s=2,o=s;for(;s<p&&!h(g.charCodeAt(s));)s++;if(s<p&&s!==o){for(o=s;s<p&&h(g.charCodeAt(s));)s++;if(s<p&&s!==o){for(o=s;s<p&&!h(g.charCodeAt(s));)s++;if(s===p)return g;s!==o&&(l=r=s+1)}}}}else f(a)&&g.charCodeAt(1)===P&&(l=p>2&&h(g.charCodeAt(2))?3:2,r=l);let i=-1,t=!0;for(let s=p-1;s>=r;--s)if(h(g.charCodeAt(s))){if(!t){i=s;break}}else t=!1;if(i===-1){if(l===-1)return".";i=l}return g.slice(0,i)},basename(g,p){p!==void 0&&y(p,"ext"),y(g,"path");let l=0,r=-1,a=!0,i;if(g.length>=2&&f(g.charCodeAt(0))&&g.charCodeAt(1)===P&&(l=2),p!==void 0&&p.length>0&&p.length<=g.length){if(p===g)return"";let t=p.length-1,s=-1;for(i=g.length-1;i>=l;--i){const o=g.charCodeAt(i);if(h(o)){if(!a){l=i+1;break}}else s===-1&&(a=!1,s=i+1),t>=0&&(o===p.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=g.length),g.slice(l,r)}for(i=g.length-1;i>=l;--i)if(h(g.charCodeAt(i))){if(!a){l=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":g.slice(l,r)},extname(g){y(g,"path");let p=0,l=-1,r=0,a=-1,i=!0,t=0;g.length>=2&&g.charCodeAt(1)===P&&f(g.charCodeAt(0))&&(p=r=2);for(let s=g.length-1;s>=p;--s){const o=g.charCodeAt(s);if(h(o)){if(!i){r=s+1;break}continue}a===-1&&(i=!1,a=s+1),o===R?l===-1?l=s:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===r+1?"":g.slice(l,a)},format:w.bind(null,"\\"),parse(g){y(g,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return p;const l=g.length;let r=0,a=g.charCodeAt(0);if(l===1)return h(a)?(p.root=p.dir=g,p):(p.base=p.name=g,p);if(h(a)){if(r=1,h(g.charCodeAt(1))){let m=2,I=m;for(;m<l&&!h(g.charCodeAt(m));)m++;if(m<l&&m!==I){for(I=m;m<l&&h(g.charCodeAt(m));)m++;if(m<l&&m!==I){for(I=m;m<l&&!h(g.charCodeAt(m));)m++;m===l?r=m:m!==I&&(r=m+1)}}}}else if(f(a)&&g.charCodeAt(1)===P){if(l<=2)return p.root=p.dir=g,p;if(r=2,h(g.charCodeAt(2))){if(l===3)return p.root=p.dir=g,p;r=3}}r>0&&(p.root=g.slice(0,r));let i=-1,t=r,s=-1,o=!0,c=g.length-1,u=0;for(;c>=r;--c){if(a=g.charCodeAt(c),h(a)){if(!o){t=c+1;break}continue}s===-1&&(o=!1,s=c+1),a===R?i===-1?i=c:u!==1&&(u=1):i!==-1&&(u=-1)}return s!==-1&&(i===-1||u===0||u===1&&i===s-1&&i===t+1?p.base=p.name=g.slice(t,s):(p.name=g.slice(t,i),p.base=g.slice(t,s),p.ext=g.slice(i,s))),t>0&&t!==r?p.dir=g.slice(0,t-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let p="",l=!1;for(let r=g.length-1;r>=-1&&!l;r--){const a=r>=0?g[r]:D.cwd();y(a,"path"),a.length!==0&&(p=`${a}/${p}`,l=a.charCodeAt(0)===C)}return p=v(p,!l,"/",S),l?`/${p}`:p.length>0?p:"."},normalize(g){if(y(g,"path"),g.length===0)return".";const p=g.charCodeAt(0)===C,l=g.charCodeAt(g.length-1)===C;return g=v(g,!p,"/",S),g.length===0?p?"/":l?"./":".":(l&&(g+="/"),p?`/${g}`:g)},isAbsolute(g){return y(g,"path"),g.length>0&&g.charCodeAt(0)===C},join(...g){if(g.length===0)return".";let p;for(let l=0;l<g.length;++l){const r=g[l];y(r,"path"),r.length>0&&(p===void 0?p=r:p+=`/${r}`)}return p===void 0?".":e.posix.normalize(p)},relative(g,p){if(y(g,"from"),y(p,"to"),g===p||(g=e.posix.resolve(g),p=e.posix.resolve(p),g===p))return"";const l=1,r=g.length,a=r-l,i=1,t=p.length-i,s=a<t?a:t;let o=-1,c=0;for(;c<s;c++){const m=g.charCodeAt(l+c);if(m!==p.charCodeAt(i+c))break;m===C&&(o=c)}if(c===s)if(t>s){if(p.charCodeAt(i+c)===C)return p.slice(i+c+1);if(c===0)return p.slice(i+c)}else a>s&&(g.charCodeAt(l+c)===C?o=c:c===0&&(o=0));let u="";for(c=l+o+1;c<=r;++c)(c===r||g.charCodeAt(c)===C)&&(u+=u.length===0?"..":"/..");return`${u}${p.slice(i+o)}`},toNamespacedPath(g){return g},dirname(g){if(y(g,"path"),g.length===0)return".";const p=g.charCodeAt(0)===C;let l=-1,r=!0;for(let a=g.length-1;a>=1;--a)if(g.charCodeAt(a)===C){if(!r){l=a;break}}else r=!1;return l===-1?p?"/":".":p&&l===1?"//":g.slice(0,l)},basename(g,p){p!==void 0&&y(p,"ext"),y(g,"path");let l=0,r=-1,a=!0,i;if(p!==void 0&&p.length>0&&p.length<=g.length){if(p===g)return"";let t=p.length-1,s=-1;for(i=g.length-1;i>=0;--i){const o=g.charCodeAt(i);if(o===C){if(!a){l=i+1;break}}else s===-1&&(a=!1,s=i+1),t>=0&&(o===p.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=g.length),g.slice(l,r)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===C){if(!a){l=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":g.slice(l,r)},extname(g){y(g,"path");let p=-1,l=0,r=-1,a=!0,i=0;for(let t=g.length-1;t>=0;--t){const s=g.charCodeAt(t);if(s===C){if(!a){l=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===R?p===-1?p=t:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||r===-1||i===0||i===1&&p===r-1&&p===l+1?"":g.slice(p,r)},format:w.bind(null,"/"),parse(g){y(g,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return p;const l=g.charCodeAt(0)===C;let r;l?(p.root="/",r=1):r=0;let a=-1,i=0,t=-1,s=!0,o=g.length-1,c=0;for(;o>=r;--o){const u=g.charCodeAt(o);if(u===C){if(!s){i=o+1;break}continue}t===-1&&(s=!1,t=o+1),u===R?a===-1?a=o:c!==1&&(c=1):a!==-1&&(c=-1)}if(t!==-1){const u=i===0&&l?1:i;a===-1||c===0||c===1&&a===t-1&&a===i+1?p.base=p.name=g.slice(u,t):(p.name=g.slice(u,a),p.base=g.slice(u,t),p.ext=g.slice(a,t))}return i>0?p.dir=g.slice(0,i-1):l&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ie[102],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(b){const d=(0,D.extname)(b),y=L[d.toLowerCase()];return y!==void 0?y:R(b)}e.getMediaOrTextMime=T;function R(b){const d=(0,D.extname)(b);return A[d.toLowerCase()]}e.getMediaMime=R;function C(b){for(const d in A)if(A[d]===b)return d}e.getExtensionForMimeType=C;const E=/^(.+)\/(.+?)(;.+)?$/;function P(b,d){const y=E.exec(b);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:d?void 0:b}e.normalizeMimeType=P}),define(ie[103],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var n;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(A,...T){const R=T.reduce((P,b)=>(P[b]=!0,P),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(P=>!R[P]).forEach(P=>{for(let b=0;b<C.length;b++)if(P.search(C[b])!==-1){delete A[P];break}})}e.sanitizeProcessEnvironment=L}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:J)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(n){if(e[n])return e[n].exports;var L=e[n]={i:n,l:!1,exports:{}};return J[n].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=J,D.c=e,D.d=function(n,L,A){D.o(n,L)||Object.defineProperty(n,L,{enumerable:!0,get:A})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,L){if(1&L&&(n=D(n)),8&L||4&L&&typeof n=="object"&&n&&n.__esModule)return n;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:n}),2&L&&typeof n!="string")for(var T in n)D.d(A,T,function(R){return n[R]}.bind(null,T));return A},D.n=function(n){var L=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(L,"a",L),L},D.o=function(n,L){return Object.prototype.hasOwnProperty.call(n,L)},D.p="",D(D.s=0)}([function(J,e,D){(function(n){var L;e=J.exports=F,L=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ne=Array.prototype.slice.call(arguments,0);ne.unshift("SEMVER"),console.log.apply(console,ne)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],E=0,P=E++;C[P]="0|[1-9]\\d*";var b=E++;C[b]="[0-9]+";var d=E++;C[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;C[y]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var h=E++;C[h]="("+C[b]+")\\.("+C[b]+")\\.("+C[b]+")";var S=E++;C[S]="(?:"+C[P]+"|"+C[d]+")";var f=E++;C[f]="(?:"+C[b]+"|"+C[d]+")";var v=E++;C[v]="(?:-("+C[S]+"(?:\\."+C[S]+")*))";var w=E++;C[w]="(?:-?("+C[f]+"(?:\\."+C[f]+")*))";var g=E++;C[g]="[0-9A-Za-z-]+";var p=E++;C[p]="(?:\\+("+C[g]+"(?:\\."+C[g]+")*))";var l=E++,r="v?"+C[y]+C[v]+"?"+C[p]+"?";C[l]="^"+r+"$";var a="[v=\\s]*"+C[h]+C[w]+"?"+C[p]+"?",i=E++;C[i]="^"+a+"$";var t=E++;C[t]="((?:<|>)?=?)";var s=E++;C[s]=C[b]+"|x|X|\\*";var o=E++;C[o]=C[P]+"|x|X|\\*";var c=E++;C[c]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[v]+")?"+C[p]+"?)?)?";var u=E++;C[u]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[w]+")?"+C[p]+"?)?)?";var m=E++;C[m]="^"+C[t]+"\\s*"+C[c]+"$";var I=E++;C[I]="^"+C[t]+"\\s*"+C[u]+"$";var _=E++;C[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;C[O]="(?:~>?)";var N=E++;C[N]="(\\s*)"+C[O]+"\\s+",R[N]=new RegExp(C[N],"g");var z=E++;C[z]="^"+C[O]+C[c]+"$";var k=E++;C[k]="^"+C[O]+C[u]+"$";var M=E++;C[M]="(?:\\^)";var j=E++;C[j]="(\\s*)"+C[M]+"\\s+",R[j]=new RegExp(C[j],"g");var U=E++;C[U]="^"+C[M]+C[c]+"$";var G=E++;C[G]="^"+C[M]+C[u]+"$";var K=E++;C[K]="^"+C[t]+"\\s*("+a+")$|^$";var x=E++;C[x]="^"+C[t]+"\\s*("+r+")$|^$";var W=E++;C[W]="(\\s*)"+C[t]+"\\s*("+a+"|"+C[c]+")",R[W]=new RegExp(C[W],"g");var X=E++;C[X]="^\\s*("+C[c]+")\\s+-\\s+("+C[c]+")\\s*$";var H=E++;C[H]="^\\s*("+C[u]+")\\s+-\\s+("+C[u]+")\\s*$";var Z=E++;C[Z]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)L(ee,C[ee]),R[ee]||(R[ee]=new RegExp(C[ee]));function q(ne,ae){if(ne instanceof F)return ne;if(typeof ne!="string"||ne.length>A||!(ae?R[i]:R[l]).test(ne))return null;try{return new F(ne,ae)}catch{return null}}function F(ne,ae){if(ne instanceof F){if(ne.loose===ae)return ne;ne=ne.version}else if(typeof ne!="string")throw new TypeError("Invalid Version: "+ne);if(ne.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(ne,ae);L("SemVer",ne,ae),this.loose=ae;var ue=ne.trim().match(ae?R[i]:R[l]);if(!ue)throw new TypeError("Invalid Version: "+ne);if(this.raw=ne,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<T)return Ce}return be}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=q,e.valid=function(ne,ae){var ue=q(ne,ae);return ue?ue.version:null},e.clean=function(ne,ae){var ue=q(ne.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(ne){return L("SemVer.compare",this.version,this.loose,ne),ne instanceof F||(ne=new F(ne,this.loose)),this.compareMain(ne)||this.comparePre(ne)},F.prototype.compareMain=function(ne){return ne instanceof F||(ne=new F(ne,this.loose)),$(this.major,ne.major)||$(this.minor,ne.minor)||$(this.patch,ne.patch)},F.prototype.comparePre=function(ne){if(ne instanceof F||(ne=new F(ne,this.loose)),this.prerelease.length&&!ne.prerelease.length)return-1;if(!this.prerelease.length&&ne.prerelease.length)return 1;if(!this.prerelease.length&&!ne.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],be=ne.prerelease[ae];if(L("prerelease compare",ae,ue,be),ue===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ue===void 0)return-1;if(ue!==be)return $(ue,be)}while(++ae)},F.prototype.inc=function(ne,ae){switch(ne){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ne)}return this.format(),this.raw=this.version,this},e.inc=function(ne,ae,ue,be){typeof ue=="string"&&(be=ue,ue=void 0);try{return new F(ne,ue).inc(ae,be).version}catch{return null}},e.diff=function(ne,ae){if(ce(ne,ae))return null;var ue=q(ne),be=q(ae);if(ue.prerelease.length||be.prerelease.length){for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return Ce},e.compareIdentifiers=$;var V=/^[0-9]+$/;function $(ne,ae){var ue=V.test(ne),be=V.test(ae);return ue&&be&&(ne=+ne,ae=+ae),ue&&!be?-1:be&&!ue?1:ne<ae?-1:ne>ae?1:0}function B(ne,ae,ue){return new F(ne,ue).compare(new F(ae,ue))}function te(ne,ae,ue){return B(ne,ae,ue)>0}function se(ne,ae,ue){return B(ne,ae,ue)<0}function ce(ne,ae,ue){return B(ne,ae,ue)===0}function he(ne,ae,ue){return B(ne,ae,ue)!==0}function ge(ne,ae,ue){return B(ne,ae,ue)>=0}function me(ne,ae,ue){return B(ne,ae,ue)<=0}function ye(ne,ae,ue,be){var Ce;switch(ae){case"===":typeof ne=="object"&&(ne=ne.version),typeof ue=="object"&&(ue=ue.version),Ce=ne===ue;break;case"!==":typeof ne=="object"&&(ne=ne.version),typeof ue=="object"&&(ue=ue.version),Ce=ne!==ue;break;case"":case"=":case"==":Ce=ce(ne,ue,be);break;case"!=":Ce=he(ne,ue,be);break;case">":Ce=te(ne,ue,be);break;case">=":Ce=ge(ne,ue,be);break;case"<":Ce=se(ne,ue,be);break;case"<=":Ce=me(ne,ue,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function Se(ne,ae){if(ne instanceof Se){if(ne.loose===ae)return ne;ne=ne.value}if(!(this instanceof Se))return new Se(ne,ae);L("comparator",ne,ae),this.loose=ae,this.parse(ne),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ne,ae){return $(ae,ne)},e.major=function(ne,ae){return new F(ne,ae).major},e.minor=function(ne,ae){return new F(ne,ae).minor},e.patch=function(ne,ae){return new F(ne,ae).patch},e.compare=B,e.compareLoose=function(ne,ae){return B(ne,ae,!0)},e.rcompare=function(ne,ae,ue){return B(ae,ne,ue)},e.sort=function(ne,ae){return ne.sort(function(ue,be){return e.compare(ue,be,ae)})},e.rsort=function(ne,ae){return ne.sort(function(ue,be){return e.rcompare(ue,be,ae)})},e.gt=te,e.lt=se,e.eq=ce,e.neq=he,e.gte=ge,e.lte=me,e.cmp=ye,e.Comparator=Se;var Ie={};function Ee(ne,ae){if(ne instanceof Ee)return ne.loose===ae?ne:new Ee(ne.raw,ae);if(ne instanceof Se)return new Ee(ne.value,ae);if(!(this instanceof Ee))return new Ee(ne,ae);if(this.loose=ae,this.raw=ne,this.set=ne.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ne);this.format()}function De(ne){return!ne||ne.toLowerCase()==="x"||ne==="*"}function Fe(ne,ae,ue,be,Ce,ze,Te,Oe,_e,Q,oe,le,fe){return((ae=De(ue)?"":De(be)?">="+ue+".0.0":De(Ce)?">="+ue+"."+be+".0":">="+ae)+" "+(Oe=De(_e)?"":De(Q)?"<"+(+_e+1)+".0.0":De(oe)?"<"+_e+"."+(+Q+1)+".0":le?"<="+_e+"."+Q+"."+oe+"-"+le:"<="+Oe)).trim()}function Ue(ne,ae){for(var ue=0;ue<ne.length;ue++)if(!ne[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<ne.length;ue++)if(L(ne[ue].semver),ne[ue].semver!==Ie&&ne[ue].semver.prerelease.length>0){var be=ne[ue].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function Ne(ne,ae,ue){try{ae=new Ee(ae,ue)}catch{return!1}return ae.test(ne)}function $e(ne,ae,ue,be){var Ce,ze,Te,Oe,_e;switch(ne=new F(ne,be),ae=new Ee(ae,be),ue){case">":Ce=te,ze=me,Te=se,Oe=">",_e=">=";break;case"<":Ce=se,ze=ge,Te=te,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ne,ae,be))return!1;for(var Q=0;Q<ae.set.length;++Q){var oe=ae.set[Q],le=null,fe=null;if(oe.forEach(function(ve){ve.semver===Ie&&(ve=new Se(">=0.0.0")),le=le||ve,fe=fe||ve,Ce(ve.semver,le.semver,be)?le=ve:Te(ve.semver,fe.semver,be)&&(fe=ve)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&ze(ne,fe.semver)||fe.operator===_e&&Te(ne,fe.semver))return!1}return!0}Se.prototype.parse=function(ne){var ae=this.loose?R[K]:R[x],ue=ne.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+ne);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new F(ue[2],this.loose):this.semver=Ie},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(ne){return L("Comparator.test",ne,this.loose),this.semver===Ie||(typeof ne=="string"&&(ne=new F(ne,this.loose)),ye(ne,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(ne,ae){if(!(ne instanceof Se))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ee(ne.value,ae),Ne(this.value,ue,ae);if(ne.operator==="")return ue=new Ee(this.value,ae),Ne(ne.semver,ue,ae);var be=!(this.operator!==">="&&this.operator!==">"||ne.operator!==">="&&ne.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ne.operator!=="<="&&ne.operator!=="<"),ze=this.semver.version===ne.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ne.operator!==">="&&ne.operator!=="<="),Oe=ye(this.semver,"<",ne.semver,ae)&&(this.operator===">="||this.operator===">")&&(ne.operator==="<="||ne.operator==="<"),_e=ye(this.semver,">",ne.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ne.operator===">="||ne.operator===">");return be||Ce||ze&&Te||Oe||_e},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ne){return ne.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ne){var ae=this.loose;ne=ne.trim(),L("range",ne,ae);var ue=ae?R[H]:R[X];ne=ne.replace(ue,Fe),L("hyphen replace",ne),ne=ne.replace(R[W],"$1$2$3"),L("comparator trim",ne,R[W]),ne=(ne=(ne=ne.replace(R[N],"$1~")).replace(R[j],"$1^")).split(/\s+/).join(" ");var be=ae?R[K]:R[x],Ce=ne.split(" ").map(function(ze){return function(Te,Oe){return L("comp",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){L("caret",le,fe);var ve=fe?R[G]:R[U];return le.replace(ve,function(Le,we,Re,ke,Pe){var Ae;return L("caret",le,Le,we,Re,ke,Pe),De(we)?Ae="":De(Re)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?Ae=we==="0"?">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+".0 <"+(+we+1)+".0.0":Pe?(L("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=we==="0"?Re==="0"?">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+Re+"."+(+ke+1):">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+"."+ke+Pe+" <"+(+we+1)+".0.0"):(L("no pr"),Ae=we==="0"?Re==="0"?">="+we+"."+Re+"."+ke+" <"+we+"."+Re+"."+(+ke+1):">="+we+"."+Re+"."+ke+" <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+"."+ke+" <"+(+we+1)+".0.0"),L("caret return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),L("caret",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var ve=fe?R[k]:R[z];return le.replace(ve,function(Le,we,Re,ke,Pe){var Ae;return L("tilde",le,Le,we,Re,ke,Pe),De(we)?Ae="":De(Re)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?Ae=">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0":Pe?(L("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+(+Re+1)+".0"):Ae=">="+we+"."+Re+"."+ke+" <"+we+"."+(+Re+1)+".0",L("tilde return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),L("tildes",Te),Te=function(_e,Q){return L("replaceXRanges",_e,Q),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var ve=fe?R[I]:R[m];return le.replace(ve,function(Le,we,Re,ke,Pe,Ae){L("xRange",le,Le,we,Re,ke,Pe,Ae);var qe=De(Re),xe=qe||De(ke),Be=xe||De(Pe);return we==="="&&Be&&(we=""),qe?Le=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(xe&&(ke=0),Be&&(Pe=0),we===">"?(we=">=",xe?(Re=+Re+1,ke=0,Pe=0):Be&&(ke=+ke+1,Pe=0)):we==="<="&&(we="<",xe?Re=+Re+1:ke=+ke+1),Le=we+Re+"."+ke+"."+Pe):xe?Le=">="+Re+".0.0 <"+(+Re+1)+".0.0":Be&&(Le=">="+Re+"."+ke+".0 <"+Re+"."+(+ke+1)+".0"),L("xRange return",Le),Le})}(oe,Q)}).join(" ")}(Te,Oe),L("xrange",Te),Te=function(_e,Q){return L("replaceStars",_e,Q),_e.trim().replace(R[Z],"")}(Te,Oe),L("stars",Te),Te}(ze,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(ze){return!!ze.match(be)})),Ce=Ce.map(function(ze){return new Se(ze,ae)})},Ee.prototype.intersects=function(ne,ae){if(!(ne instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(be){return ne.set.some(function(Ce){return Ce.every(function(ze){return be.intersects(ze,ae)})})})})},e.toComparators=function(ne,ae){return new Ee(ne,ae).set.map(function(ue){return ue.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ne){if(!ne)return!1;typeof ne=="string"&&(ne=new F(ne,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ue(this.set[ae],ne))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ne,ae,ue){var be=null,Ce=null;try{var ze=new Ee(ae,ue)}catch{return null}return ne.forEach(function(Te){ze.test(Te)&&(be&&Ce.compare(Te)!==-1||(Ce=new F(be=Te,ue)))}),be},e.minSatisfying=function(ne,ae,ue){var be=null,Ce=null;try{var ze=new Ee(ae,ue)}catch{return null}return ne.forEach(function(Te){ze.test(Te)&&(be&&Ce.compare(Te)!==1||(Ce=new F(be=Te,ue)))}),be},e.validRange=function(ne,ae){try{return new Ee(ne,ae).range||"*"}catch{return null}},e.ltr=function(ne,ae,ue){return $e(ne,ae,"<",ue)},e.gtr=function(ne,ae,ue){return $e(ne,ae,">",ue)},e.outside=$e,e.prerelease=function(ne,ae){var ue=q(ne,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(ne,ae,ue){return ne=new Ee(ne,ue),ae=new Ee(ae,ue),ne.intersects(ae)},e.coerce=function(ne){if(ne instanceof F)return ne;if(typeof ne!="string")return null;var ae=ne.match(R[_]);return ae==null?null:q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(J,e){var D,n,L=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(f){if(D===setTimeout)return setTimeout(f,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var C,E=[],P=!1,b=-1;function d(){P&&C&&(P=!1,C.length?E=C.concat(E):b=-1,E.length&&y())}function y(){if(!P){var f=R(d);P=!0;for(var v=E.length;v;){for(C=E,E=[];++b<v;)C&&C[b].run();b=-1,v=E.length}C=null,P=!1,function(w){if(n===clearTimeout)return clearTimeout(w);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(w);try{n(w)}catch{try{return n.call(null,w)}catch{return n.call(this,w)}}}(f)}}function h(f,v){this.fun=f,this.array=v}function S(){}L.nextTick=function(f){var v=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)v[w-1]=arguments[w];E.push(new h(f,v)),E.length!==1||P||R(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=S,L.addListener=S,L.once=S,L.off=S,L.removeListener=S,L.removeAllListeners=S,L.emit=S,L.prependListener=S,L.prependOnceListener=S,L.listeners=function(f){return[]},L.binding=function(f){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(f){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ie[104],re([0,1]),function(J,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,C,E){this.level=R,this.key=C,this.value=E,this.forward=[]}}const L=void 0;class A{constructor(R,C=2**16){this.comparator=R,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new n(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,L,L)}has(R){return Boolean(A._search(this,R,this.comparator))}get(R){return A._search(this,R,this.comparator)?.value}set(R,C){return A._insert(this,R,C,this.comparator)&&(this._size+=1),this}delete(R){const C=A._delete(this,R,this.comparator);return C&&(this._size-=1),C}forEach(R,C){let E=this._header.forward[0];for(;E;)R.call(C,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this._header.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static _search(R,C,E){let P=R._header;for(let b=R._level-1;b>=0;b--)for(;P.forward[b]&&E(P.forward[b].key,C)<0;)P=P.forward[b];if(P=P.forward[0],P&&E(P.key,C)===0)return P}static _insert(R,C,E,P){let b=[],d=R._header;for(let y=R._level-1;y>=0;y--){for(;d.forward[y]&&P(d.forward[y].key,C)<0;)d=d.forward[y];b[y]=d}if(d=d.forward[0],d&&P(d.key,C)===0)return d.value=E,!1;{let y=A._randomLevel(R);if(y>R._level){for(let h=R._level;h<y;h++)b[h]=R._header;R._level=y}d=new n(y,C,E);for(let h=0;h<y;h++)d.forward[h]=b[h].forward[h],b[h].forward[h]=d;return!0}}static _randomLevel(R,C=.5){let E=1;for(;Math.random()<C&&E<R._maxLevel;)E+=1;return E}static _delete(R,C,E){let P=[],b=R._header;for(let d=R._level-1;d>=0;d--){for(;b.forward[d]&&E(b.forward[d].key,C)<0;)b=b.forward[d];P[d]=b}if(b=b.forward[0],!b||E(b.key,C)!==0)return!1;for(let d=0;d<R._level&&P[d].forward[d]===b;d++)P[d].forward[d]=b.forward[d];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=A}),define(ie[105],re([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class L{constructor(T){this._highResolution=n&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new L(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=L}),define(ie[3],re([0,1,9,68,2,101,105]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(p){p.None=()=>L.Disposable.None;function l(K){return(x,W=null,X)=>{let H=!1,Z;return Z=K(ee=>{if(!H)return Z?Z.dispose():H=!0,x.call(W,ee)},null,X),H&&Z.dispose(),Z}}p.once=l;function r(K,x){return c((W,X=null,H)=>K(Z=>W.call(X,x(Z)),null,H))}p.map=r;function a(K,x){return c((W,X=null,H)=>K(Z=>{x(Z),W.call(X,Z)},null,H))}p.forEach=a;function i(K,x){return c((W,X=null,H)=>K(Z=>x(Z)&&W.call(X,Z),null,H))}p.filter=i;function t(K){return K}p.signal=t;function s(...K){return(x,W=null,X)=>(0,L.combinedDisposable)(...K.map(H=>H(Z=>x.call(W,Z),null,X)))}p.any=s;function o(K,x,W){let X=W;return r(K,H=>(X=x(X,H),X))}p.reduce=o;function c(K){let x;const W=new d({onFirstListenerAdd(){x=K(W.fire,W)},onLastListenerRemove(){x.dispose()}});return W.event}function u(K,x,W,X=100,H=!1){let Z,ee,q=0;return K(F=>{q++,Z=W(Z,F),H&&!ee&&(x(Z),Z=void 0),clearTimeout(ee),ee=setTimeout(()=>{const V=Z;Z=void 0,ee=void 0,(!H||q>1)&&x(V),q=0},X)})}p.debouncedListener=u;function m(K,x,W=100,X=!1,H){let Z,ee,q,F=0;const V=new d({leakWarningThreshold:H,onFirstListenerAdd(){Z=K($=>{F++,ee=x(ee,$),X&&!q&&(V.fire(ee),ee=void 0),clearTimeout(q),q=setTimeout(()=>{const B=ee;ee=void 0,q=void 0,(!X||F>1)&&V.fire(B),F=0},W)})},onLastListenerRemove(){Z.dispose()}});return V.event}p.debounce=m;function I(K,x=(W,X)=>W===X){let W=!0,X;return i(K,H=>{const Z=W||!x(H,X);return W=!1,X=H,Z})}p.latch=I;function _(K,x){return[p.filter(K,x),p.filter(K,W=>!x(W))]}p.split=_;function O(K,x=!1,W=[]){let X=W.slice(),H=K(q=>{X?X.push(q):ee.fire(q)});const Z=()=>{X&&X.forEach(q=>ee.fire(q)),X=null},ee=new d({onFirstListenerAdd(){H||(H=K(q=>ee.fire(q)))},onFirstListenerDidAdd(){X&&(x?setTimeout(Z):Z())},onLastListenerRemove(){H&&H.dispose(),H=null}});return ee.event}p.buffer=O;class N{constructor(x){this.event=x}map(x){return new N(r(this.event,x))}forEach(x){return new N(a(this.event,x))}filter(x){return new N(i(this.event,x))}reduce(x,W){return new N(o(this.event,x,W))}latch(){return new N(I(this.event))}debounce(x,W=100,X=!1,H){return new N(m(this.event,x,W,X,H))}on(x,W,X){return this.event(x,W,X)}once(x,W,X){return l(this.event)(x,W,X)}}function z(K){return new N(K)}p.chain=z;function k(K,x,W=X=>X){const X=(...q)=>ee.fire(W(...q)),H=()=>K.on(x,X),Z=()=>K.removeListener(x,X),ee=new d({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}p.fromNodeEventEmitter=k;function M(K,x,W=X=>X){const X=(...q)=>ee.fire(W(...q)),H=()=>K.addEventListener(x,X),Z=()=>K.removeEventListener(x,X),ee=new d({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}p.fromDOMEventEmitter=M;function j(K){return new Promise(x=>l(K)(x))}p.toPromise=j;function U(K,x){return x(void 0),K(W=>x(W))}p.runAndSubscribe=U;function G(K,x){let W=null;function X(Z){W?.dispose(),W=new L.DisposableStore,x(Z,W)}X(void 0);const H=K(Z=>X(Z));return(0,L.toDisposable)(()=>{H.dispose(),W?.dispose()})}p.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class C{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${C._idPool++}`}start(l){this._stopWatch=new T.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let E=-1;function P(p){const l=E;return E=p,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=P;class b{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=E;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,c]of this._stacks)(!t||s<c)&&(t=o,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,a)=>{this._listeners||(this._listeners=new A.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,L.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof L.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(i){(0,D.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class y extends d{async fireAsync(l,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,token:r,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(c=a(c,typeof i=="function"?i:i[0])),s.push(c)}};try{typeof i=="function"?i.call(void 0,o):i[0].call(i[1],o)}catch(c){(0,D.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const u of c)u.status==="rejected"&&(0,D.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=y;class h extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class S extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=S;class f extends d{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=f;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,L.toDisposable)((0,n.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,a,i)=>l(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,i)}bufferEvents(l){const r=[];this.buffers.push(r);const a=l();return this.buffers.pop(),r.forEach(i=>i()),a}}e.EventBufferer=w;class g{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=L.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(ie[25],re([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,C){const E=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(E)}}});var L;(function(R){function C(E){return E===R.None||E===R.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=L.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=T}),define(ie[106],re([0,1,25]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new D.CancellationTokenSource,R=this.task(T.token);return this.result={promise:R,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=n;class L{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const R=JSON.stringify(T);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=L}),define(ie[40],re([0,1,9,2]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(g){const p=g;return p?[p.on,p.pause,p.resume,p.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=L;function A(g){const p=g;return p?L(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=A;function T(g,p){return new R(g,p)}e.newWriteableStream=T;class R{constructor(p,l){this.reducer=p,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(l=>l(p))}emitError(p){this.listeners.error.length===0?(0,D.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(l=>l(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,l){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(p,l){if(this.state.destroyed)return;let r;switch(p){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(l);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(g,p){const l=[];let r;for(;(r=g.read())!==null;)l.push(r);return p(l)}e.consumeReadable=C;function E(g,p,l){const r=[];let a;for(;(a=g.read())!==null&&r.length<l;)r.push(a);return a===null&&r.length>0?p(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return g.read()}}}e.peekReadable=E;function P(g,p){return new Promise((l,r)=>{const a=[];b(g,{onData:i=>{p&&a.push(i)},onError:i=>{p?r(i):l(void 0)},onEnd:()=>{l(p?p(a):void 0)}})})}e.consumeStream=P;function b(g,p){let l=!1;return g.on("error",r=>{l||p.onError(r)}),g.on("end",()=>{l||p.onEnd()}),g.on("data",r=>{l||p.onData(r)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=b;function d(g,p){return new Promise((l,r)=>{const a=new n.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>p)return a.dispose(),g.pause(),l({stream:g,buffer:i,ended:!1})},s=c=>r(c),o=()=>l({stream:g,buffer:i,ended:!0});a.add((0,n.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),a.add((0,n.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),a.add((0,n.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=d;function y(g,p){const l=T(p);return l.end(g),l}e.toStream=y;function h(){const g=T(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function S(g){let p=!1;return{read:()=>p?null:(p=!0,g)}}e.toReadable=S;function f(g,p,l){const r=T(l);return b(g,{onData:a=>r.write(p.data(a)),onError:a=>r.error(p.error?p.error(a):a),onEnd:()=>r.end()}),r}e.transform=f;function v(g,p,l){let r=!1;return{read:()=>{const a=p.read();return r?a:(r=!0,a!==null?l([g,a]):g)}}}e.prefixedReadable=v;function w(g,p,l){let r=!1;const a=T(l);return b(p,{onData:i=>r?a.write(i):(r=!0,a.write(l([g,i]))),onError:i=>a.error(i),onEnd:()=>{r||(r=!0,a.write(g)),a.end()}}),a}e.prefixedStream=w}),define(ie[17],re([0,1,40]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,A;class T{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return n?new T(Buffer.allocUnsafe(u)):new T(new Uint8Array(u))}static wrap(u){return n&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new T(u)}static fromString(u,m){return!(m?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(u)):(L||(L=new TextEncoder),new T(L.encode(u)))}static fromByteArray(u){const m=T.alloc(u.length);for(let I=0,_=u.length;I<_;I++)m.buffer[I]=u[I];return m}static concat(u,m){if(typeof m=="undefined"){m=0;for(let O=0,N=u.length;O<N;O++)m+=u[O].byteLength}const I=T.alloc(m);let _=0;for(let O=0,N=u.length;O<N;O++){const z=u[O];I.set(z,_),_+=z.byteLength}return I}clone(){const u=T.alloc(this.byteLength);return u.set(this),u}toString(){return n?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(u,m){return new T(this.buffer.subarray(u,m))}set(u,m){if(u instanceof T)this.buffer.set(u.buffer,m);else if(u instanceof Uint8Array)this.buffer.set(u,m);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),m);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),m);else throw new Error("Unkown argument 'array'")}readUInt32BE(u){return E(this.buffer,u)}writeUInt32BE(u,m){P(this.buffer,u,m)}readUInt32LE(u){return b(this.buffer,u)}writeUInt32LE(u,m){d(this.buffer,u,m)}readUInt8(u){return y(this.buffer,u)}writeUInt8(u,m){h(this.buffer,u,m)}}e.VSBuffer=T;function R(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=R;function C(c,u,m){c[m+0]=u&255,u=u>>>8,c[m+1]=u&255}e.writeUInt16LE=C;function E(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=E;function P(c,u,m){c[m+3]=u,u=u>>>8,c[m+2]=u,u=u>>>8,c[m+1]=u,u=u>>>8,c[m]=u}e.writeUInt32BE=P;function b(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=b;function d(c,u,m){c[m+0]=u&255,u=u>>>8,c[m+1]=u&255,u=u>>>8,c[m+2]=u&255,u=u>>>8,c[m+3]=u&255}e.writeUInt32LE=d;function y(c,u){return c[u]}e.readUInt8=y;function h(c,u,m){c[m]=u}e.writeUInt8=h;function S(c){return D.consumeReadable(c,u=>T.concat(u))}e.readableToBuffer=S;function f(c){return D.toReadable(c)}e.bufferToReadable=f;function v(c){return D.consumeStream(c,u=>T.concat(u))}e.streamToBuffer=v;async function w(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await v(c.stream)])}e.bufferedStreamToBuffer=w;function g(c){return D.toStream(c,u=>T.concat(u))}e.bufferToStream=g;function p(c){return D.transform(c,{data:u=>typeof u=="string"?T.fromString(u):T.wrap(u)},u=>T.concat(u))}e.streamToBufferReadableStream=p;function l(c){return D.newWriteableStream(u=>T.concat(u),c)}e.newWriteableBufferStream=l;function r(c,u){return D.prefixedReadable(c,u,m=>T.concat(m))}e.prefixedBufferReadable=r;function a(c,u){return D.prefixedStream(c,u,m=>T.concat(m))}e.prefixedBufferStream=a;function i(c){let u=0,m=0,I=0;const _=new Uint8Array(Math.floor(c.length/4*3)),O=z=>{switch(m){case 3:_[I++]=u|z,m=0;break;case 2:_[I++]=u|z>>>2,u=z<<6,m=3;break;case 1:_[I++]=u|z>>>4,u=z<<4,m=2;break;default:u=z<<2,m=1}};for(let z=0;z<c.length;z++){const k=c.charCodeAt(z);if(k>=65&&k<=90)O(k-65);else if(k>=97&&k<=122)O(k-97+26);else if(k>=48&&k<=57)O(k-48+52);else if(k===43||k===45)O(62);else if(k===47||k===95)O(63);else{if(k===61)break;throw new SyntaxError(`Unexpected base64 character ${c[z]}`)}}const N=I;for(;m>0;)O(0);return T.wrap(_).slice(0,N)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},u=!0,m=!1){const I=m?s:t;let _="";const O=c.byteLength%3;let N=0;for(;N<c.byteLength-O;N+=3){const z=c[N+0],k=c[N+1],M=c[N+2];_+=I[z>>>2],_+=I[(z<<4|k>>>4)&63],_+=I[(k<<2|M>>>6)&63],_+=I[M&63]}if(O===1){const z=c[N+0];_+=I[z>>>2],_+=I[z<<4&63],u&&(_+="==")}else if(O===2){const z=c[N+0],k=c[N+1];_+=I[z>>>2],_+=I[(z<<4|k>>>4)&63],_+=I[k<<2&63],u&&(_+="=")}return _}e.encodeBase64=o}),define(ie[27],re([0,1,106,100]),function(J,e,D,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function R(Q,...oe){return oe.length===0?Q:Q.replace(T,function(le,fe){const ve=parseInt(fe,10);return isNaN(ve)||ve<0||ve>=oe.length?le:oe[ve]})}e.format=R;const C=/{([^}]+)}/g;function E(Q,oe){return Q.replace(C,(le,fe)=>oe[fe]??le)}e.format2=E;function P(Q){return Q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function b(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function d(Q,oe){let le=0;const fe=oe.charCodeAt(0);for(let ve=Q.length-1;ve>=0;ve--)Q.charCodeAt(ve)===fe&&le++;return le}e.count=d;function y(Q,oe,le="\u2026"){return Q.length<=oe?Q:`${Q.substr(0,oe)}${le}`}e.truncate=y;function h(Q,oe=" "){const le=S(Q,oe);return f(le,oe)}e.trim=h;function S(Q,oe){if(!Q||!oe)return Q;const le=oe.length;if(le===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(oe,fe)===fe;)fe=fe+le;return Q.substring(fe)}e.ltrim=S;function f(Q,oe){if(!Q||!oe)return Q;const le=oe.length,fe=Q.length;if(le===0||fe===0)return Q;let ve=fe,Le=-1;for(;Le=Q.lastIndexOf(oe,ve-1),!(Le===-1||Le+le!==ve);){if(Le===0)return"";ve=Le}return Q.substring(0,ve)}e.rtrim=f;function v(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function w(Q){return Q.replace(/\*/g,"")}e.stripWildcards=w;function g(Q,oe,le={}){if(!Q)throw new Error("Cannot create regex from empty string");oe||(Q=b(Q)),le.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=g;function p(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function l(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=r;function a(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Q){for(let oe=0,le=Q.length;oe<le;oe++){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(Q,oe=0,le=Q.length){for(let fe=oe;fe<le;fe++){const ve=Q.charCodeAt(fe);if(ve!==32&&ve!==9)return Q.substring(oe,fe)}return Q.substring(oe,le)}e.getLeadingWhitespace=t;function s(Q,oe=Q.length-1){for(let le=oe;le>=0;le--){const fe=Q.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function o(Q,oe){return Q<oe?-1:Q>oe?1:0}e.compare=o;function c(Q,oe,le=0,fe=Q.length,ve=0,Le=oe.length){for(;le<fe&&ve<Le;le++,ve++){let ke=Q.charCodeAt(le),Pe=oe.charCodeAt(ve);if(ke<Pe)return-1;if(ke>Pe)return 1}const we=fe-le,Re=Le-ve;return we<Re?-1:we>Re?1:0}e.compareSubstring=c;function u(Q,oe){return m(Q,oe,0,Q.length,0,oe.length)}e.compareIgnoreCase=u;function m(Q,oe,le=0,fe=Q.length,ve=0,Le=oe.length){for(;le<fe&&ve<Le;le++,ve++){let ke=Q.charCodeAt(le),Pe=oe.charCodeAt(ve);if(ke===Pe)continue;if(ke>=128||Pe>=128)return c(Q.toLowerCase(),oe.toLowerCase(),le,fe,ve,Le);I(ke)&&(ke-=32),I(Pe)&&(Pe-=32);const Ae=ke-Pe;if(Ae!==0)return Ae}const we=fe-le,Re=Le-ve;return we<Re?-1:we>Re?1:0}e.compareSubstringIgnoreCase=m;function I(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=I;function _(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=_;function O(Q,oe){return Q.length===oe.length&&m(Q,oe)===0}e.equalsIgnoreCase=O;function N(Q,oe){const le=oe.length;return oe.length>Q.length?!1:m(Q,oe,0,le)===0}e.startsWithIgnoreCase=N;function z(Q,oe){let le,fe=Math.min(Q.length,oe.length);for(le=0;le<fe;le++)if(Q.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=z;function k(Q,oe){let le,fe=Math.min(Q.length,oe.length);const ve=Q.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(Q.charCodeAt(ve-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=k;function M(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=M;function j(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=j;function U(Q,oe){return(Q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=U;function G(Q,oe,le){const fe=Q.charCodeAt(le);if(M(fe)&&le+1<oe){const ve=Q.charCodeAt(le+1);if(j(ve))return U(fe,ve)}return fe}e.getNextCodePoint=G;function K(Q,oe){const le=Q.charCodeAt(oe-1);if(j(le)&&oe>1){const fe=Q.charCodeAt(oe-2);if(M(fe))return U(fe,le)}return le}class x{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=K(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class W{constructor(oe,le=0){this._iterator=new x(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ve=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,we=oe.getGraphemeBreakType(le.nextCodePoint());if($e(ve,we)){le.setOffset(Le);break}ve=we}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ve=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,we=oe.getGraphemeBreakType(le.prevCodePoint());if($e(we,ve)){le.setOffset(Le);break}ve=we}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=W;function X(Q,oe){return new W(Q,oe).nextGraphemeLength()}e.nextCharLength=X;function H(Q,oe){return new W(Q,oe).prevGraphemeLength()}e.prevCharLength=H;function Z(Q,oe){oe>0&&j(Q.charCodeAt(oe))&&oe--;const le=oe+X(Q,oe);return[le-H(Q,le),le]}e.getCharContainingOffset=Z;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function q(Q){return ee.test(Q)}e.containsRTL=q;const F=/^[\t\n\r\x20-\x7E]*$/;function V(Q){return F.test(Q)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=$;function B(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=B;function te(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=te;function se(Q,oe){if(Q.length<oe)return Q;const le=/\b/g;let fe=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function me(Q){return Q&&(Q=Q.replace(ce,""),Q=Q.replace(he,""),Q=Q.replace(ge,"")),Q}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function Se(Q){return ye(Q)?Q.substr(1):Q}e.stripUTF8BOM=Se;function Ie(Q,oe){if(!Q||!oe||Q.length<oe.length)return!1;const le=oe.length,fe=Q.toLowerCase();let ve=0,Le=-1;for(;ve<le;){const we=fe.indexOf(oe[ve],Le+1);if(we<0)return!1;Le=we,ve++}return!0}e.fuzzyContains=Ie;function Ee(Q,oe=!1){return Q?(oe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Ee;function De(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=De;function Fe(Q,oe=1){if(oe===0)return"";let le=-1;do le=Q.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?Q:(Q[le-1]==="\r"&&le--,Q.substr(0,le))}e.getNLines=Fe;function Ue(Q){const oe=90-65+1;return Q=Q%(2*oe),Q<oe?String.fromCharCode(97+Q):String.fromCharCode(65+Q-oe)}e.singleLetterHash=Ue;function Ne(Q){return ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=Ne;function $e(Q,oe){return Q===0?oe!==5&&oe!==7:Q===2&&oe===3?!1:Q===4||Q===2||Q===3||oe===4||oe===2||oe===3?!0:!(Q===8&&(oe===8||oe===9||oe===11||oe===12)||(Q===11||Q===9)&&(oe===9||oe===10)||(Q===12||Q===10)&&oe===10||oe===5||oe===13||oe===7||Q===1||Q===13&&oe===14||Q===6&&oe===6)}var ne;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(ne=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let ve=1;for(;ve<=fe;)if(oe<le[3*ve])ve=2*ve;else if(oe>le[3*ve+1])ve=2*ve+1;else return le[3*ve+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(Q,oe){if(Q===0)return 0;const le=Ce(Q,oe);if(le!==void 0)return le;const fe=new x(oe,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=be;function Ce(Q,oe){const le=new x(oe,Q);let fe=le.prevCodePoint();for(;ze(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!te(fe))return;let ve=le.offset;return ve>0&&le.prevCodePoint()===8205&&(ve=le.offset),ve}function ze(Q){return 127995<=Q&&Q<=127999}var Te;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new D.LRUCachedComputed(Q=>{function oe(Pe){const Ae=new Map;for(let qe=0;qe<Pe.length;qe+=2)Ae.set(Pe[qe],Pe[qe+1]);return Ae}function le(Pe,Ae){const qe=new Map(Pe);for(const[xe,Be]of Ae)qe.set(xe,Be);return qe}function fe(Pe,Ae){if(!Pe)return Ae;const qe=new Map;for(const[xe,Be]of Pe)Ae.has(xe)&&qe.set(xe,Be);return qe}const ve=L.ambiguousCharacterData.getValue();let Le=Q.filter(Pe=>!Pe.startsWith("_")&&Pe in ve);Le.length===0&&(Le=["_default"]);let we;for(const Pe of Le){const Ae=oe(ve[Pe]);we=fe(we,Ae)}const Re=oe(ve._common),ke=le(Re,we);return new Oe(ke)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ie[70],re([0,1,27]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return L(v,0)}e.hash=n;function L(v,w){switch(typeof v){case"object":return v===null?A(349,w):Array.isArray(v)?C(v,w):E(v,w);case"string":return R(v,w);case"boolean":return T(v,w);case"number":return A(v,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=L;function A(v,w){return(w<<5)-w+v|0}e.numberHash=A;function T(v,w){return A(v?433:863,w)}function R(v,w){w=A(149417,w);for(let g=0,p=v.length;g<p;g++)w=A(v.charCodeAt(g),w);return w}e.stringHash=R;function C(v,w){return w=A(104579,w),v.reduce((g,p)=>L(p,g),w)}function E(v,w){return w=A(181387,w),Object.keys(v).sort().reduce((g,p)=>(g=R(p,g),L(v[p],g)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=P;var b;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function d(v,w,g=32){const p=g-w,l=~((1<<p)-1);return(v<<w|(l&v)>>>p)>>>0}function y(v,w=0,g=v.byteLength,p=0){for(let l=0;l<g;l++)v[w+l]=p}function h(v,w,g="0"){for(;v.length<w;)v=g+v;return v}function S(v,w=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((v>>>0).toString(16),w/4)}e.toHexString=S;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const g=w.length;if(g===0)return;const p=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,a,i;for(r!==0?(a=r,i=-1,r=0):(a=w.charCodeAt(0),i=0);;){let t=a;if(D.isHighSurrogate(a))if(i+1<g){const s=w.charCodeAt(i+1);D.isLowSurrogate(s)?(i++,t=D.computeCodePoint(a,s)):t=65533}else{r=a;break}else D.isLowSurrogate(a)&&(t=65533);if(l=this._push(p,l,t),i++,i<g)a=w.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,g,p){return p<128?w[g++]=p:p<2048?(w[g++]=192|(p&1984)>>>6,w[g++]=128|(p&63)>>>0):p<65536?(w[g++]=224|(p&61440)>>>12,w[g++]=128|(p&4032)>>>6,w[g++]=128|(p&63)>>>0):(w[g++]=240|(p&1835008)>>>18,w[g++]=128|(p&258048)>>>12,w[g++]=128|(p&4032)>>>6,w[g++]=128|(p&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=f._bigBlock32,g=this._buffDV;for(let c=0;c<64;c+=4)w.setUint32(c,g.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,d(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let p=this._h0,l=this._h1,r=this._h2,a=this._h3,i=this._h4,t,s,o;for(let c=0;c<80;c++)c<20?(t=l&r|~l&a,s=1518500249):c<40?(t=l^r^a,s=1859775393):c<60?(t=l&r|l&a|r&a,s=2400959708):(t=l^r^a,s=3395469782),o=d(p,5)+t+i+s+w.getUint32(c*4,!1)&4294967295,i=a,a=r,r=d(l,30),l=p,p=o;this._h0=this._h0+p&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(J,e,D,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(J,D):L?L.value=D:e.set(J,D),D},Ke=this&&this.__classPrivateFieldGet||function(J,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(J):n?n.value:e.get(J)};define(ie[39],re([0,1,16,27]),function(J,e,D,n){"use strict";var L,A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,t,s){let o=i.get(t);return o===void 0&&(o=s,i.set(t,o)),o}e.getOrSet=R;function C(i){const t=[];return i.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=C;function E(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class b{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class d{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var y;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(y||(y={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(f||(f={}));class v{constructor(t){this._iter=t}static forUris(t=()=>!1){return new v(new h(t))}static forPaths(t=!1){return new v(new d(void 0,!t))}static forStrings(){return new v(new P)}static forConfigKeys(){return new v(new b)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,D.shuffle)(o);for(let c of o)this.set(c,t)}else{const o=t.slice(0);(0,D.shuffle)(o);for(let c of o)this.set(c[0],c[1])}}set(t,s){const o=this._iter.reset(t);let c;this._root||(this._root=new S,this._root.segment=o.value());const u=[];for(c=this._root;;){const I=o.cmp(c.segment);if(I>0)c.left||(c.left=new S,c.left.segment=o.value()),u.push([-1,c]),c=c.left;else if(I<0)c.right||(c.right=new S,c.right.segment=o.value()),u.push([1,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new S,c.mid.segment=o.value()),u.push([0,c]),c=c.mid;else break}const m=c.value;c.value=s,c.key=t;for(let I=u.length-1;I>=0;I--){const _=u[I][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const N=u[I][0],z=u[I+1][0];if(N===1&&z===1)u[I][1]=_.rotateLeft();else if(N===-1&&z===-1)u[I][1]=_.rotateRight();else if(N===1&&z===-1)_.right=u[I+1][1]=u[I+1][1].rotateRight(),u[I][1]=_.rotateLeft();else if(N===-1&&z===1)_.left=u[I+1][1]=u[I+1][1].rotateLeft(),u[I][1]=_.rotateRight();else throw new Error;if(I>0)switch(u[I-1][0]){case-1:u[I-1][1].left=u[I][1];break;case 1:u[I-1][1].right=u[I][1];break;case 0:u[I-1][1].mid=u[I][1];break}else this._root=u[0][1]}}return m}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),c=[];let u=this._root;for(;u;){const m=o.cmp(u.segment);if(m>0)c.push([-1,u]),u=u.left;else if(m<0)c.push([1,u]),u=u.right;else if(o.hasNext())o.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(s?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this._min(u.right),{key:I,value:_,segment:O}=m;this._delete(m.key,!1),u.key=I,u.value=_,u.segment=O}else{const m=u.left??u.right;if(c.length>0){const[I,_]=c[c.length-1];switch(I){case-1:_.left=m;break;case 0:_.mid=m;break;case 1:_.right=m;break}}else this._root=m}for(let m=c.length-1;m>=0;m--){const I=c[m][1];I.updateHeight();const _=I.balanceFactor();if(_>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),c[m][1]=I.rotateLeft()):_<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),c[m][1]=I.rotateRight()),m>0)switch(c[m-1][0]){case-1:c[m-1][1].left=c[m][1];break;case 1:c[m-1][1].right=c[m][1];break;case 0:c[m-1][1].mid=c[m][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,c;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=v;class w{constructor(t,s){this.uri=t,this.value=s}}class g{constructor(t,s){this[L]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=s??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new w(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=i=>i.toString();var p;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class l{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let c=this._map.get(t);if(c)c.value=s,o!==0&&this.touch(c,o);else{switch(c={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let c=this._head;for(;c;){if(s?t.bind(s)(c.value,c.key,this):t(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:o.key,done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return c}values(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:o.value,done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return c}entries(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:[o.key,o.value],done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,c=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=l;class r extends l{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){T.set(this,void 0),It(this,T,t,"f")}get size(){return Ke(this,T,"f").size}forEach(t,s){Ke(this,T,"f").forEach(t,s)}get(t){return Ke(this,T,"f").get(t)}has(t){return Ke(this,T,"f").has(t)}entries(){return Ke(this,T,"f").entries()}keys(){return Ke(this,T,"f").keys()}values(){return Ke(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Ke(this,T,"f").entries()}}e.ReadonlyMapView=a}),define(ie[71],re([0,1,39]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function L(E){return C(E,"NFC",n)}e.normalizeNFC=L;const A=new D.LRUCache(1e4);function T(E){return C(E,"NFD",A)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function C(E,P,b){if(!E)return E;const d=b.get(E);if(d)return d;let y;return R.test(E)?y=E.normalize(P):y=E,b.set(E,y),y}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return T(P).replace(E,"")}}()}),define(ie[15],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(u){return Array.isArray(u)}e.isArray=D;function n(u){return typeof u=="string"}e.isString=n;function L(u){return Array.isArray(u)&&u.every(m=>n(m))}e.isStringArray=L;function A(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=A;function T(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=T;function R(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=R;function C(u){return u===!0||u===!1}e.isBoolean=C;function E(u){return typeof u=="undefined"}e.isUndefined=E;function P(u){return!b(u)}e.isDefined=P;function b(u){return E(u)||u===null}e.isUndefinedOrNull=b;function d(u,m){if(!u)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=d;function y(u){if(b(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=y;function h(...u){const m=[];for(let I=0;I<u.length;I++){const _=u[I];if(b(_))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);m.push(_)}return m}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function f(u){if(!A(u))return!1;for(let m in u)if(S.call(u,m))return!1;return!0}e.isEmptyObject=f;function v(u){return typeof u=="function"}e.isFunction=v;function w(...u){return u.length>0&&u.every(v)}e.areFunctions=w;function g(u,m){const I=Math.min(u.length,m.length);for(let _=0;_<I;_++)p(u[_],m[_])}e.validateConstraints=g;function p(u,m){if(n(m)){if(typeof u!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(v(m)){try{if(u instanceof m)return}catch{}if(!b(u)&&u.constructor===m||m.length===1&&m.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function l(u){let m=[],I=Object.getPrototypeOf(u);for(;Object.prototype!==I;)m=m.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return m}e.getAllPropertyNames=l;function r(u){const m=[];for(const I of l(u))typeof u[I]=="function"&&m.push(I);return m}e.getAllMethodNames=r;function a(u,m){const I=O=>function(){const N=Array.prototype.slice.call(arguments,0);return m(O,N)};let _={};for(const O of u)_[O]=I(O);return _}e.createProxyObject=a;function i(u){return u===null?void 0:u}e.withNullAsUndefined=i;function t(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=t;function s(u){return class{constructor(){return new Proxy({},{get(m,I){if(m[I])return m[I];throw new Error(`Not Implemented: ${u}->${String(I)}`)}})}}}e.NotImplementedProxy=s;function o(u,m="Unreachable"){throw new Error(m)}e.assertNever=o;function c(u){return!!u&&typeof u.then=="function"&&typeof u.catch=="function"}e.isPromise=c}),define(ie[41],re([0,1,10,4,27,15]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function R(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function C(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function E(s,o=D.posix.sep){if(!s)return"";const c=s.length,u=s.charCodeAt(0);if(T(u)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let I=3;const _=I;for(;I<c&&!T(s.charCodeAt(I));I++);if(_!==I&&!T(s.charCodeAt(I+1))){for(I+=1;I<c;I++)if(T(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(v(u)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<c;m++)if(T(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=E;function P(s){if(!n.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let c=2;const u=c;for(;c<s.length&&(o=s.charCodeAt(c),o!==92);c++);return!(u===c||(o=s.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=P;const b=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,o=n.isWindows){const c=o?b:d;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||o&&y.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function S(s,o,c){const u=s===o;return!c||u?u:!s||!o?!1:(0,L.equalsIgnoreCase)(s,o)}e.isEqual=S;function f(s,o,c,u=D.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(c){if(!(0,L.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let I=o.length;return o.charAt(o.length-1)===u&&I--,s.charAt(I)===u}return o.charAt(o.length-1)!==u&&(o+=u),s.indexOf(o)===0}e.isEqualOrParent=f;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function w(s,o){return n.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(o,s)),s=(0,D.normalize)(s),n.isWindows?(s=(0,L.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,L.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=w;function g(s){const o=(0,D.normalize)(s);return n.isWindows?s.length>3?!1:p(o)&&(s.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=g;function p(s,o){return(o!==void 0?o:n.isWindows)?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function l(s){return p(s)?s[0]:void 0}e.getDriveLetter=l;function r(s,o,c){return o.length>s.length?-1:s===o?0:(c&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=r;function a(s){const o=s.split(":");let c,u,m;for(const I of o){const _=Number(I);(0,A.isNumber)(_)?u===void 0?u=_:m===void 0&&(m=_):c=c?[c,I].join(":"):I}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,o,c=8){let u="";for(let I=0;I<c;I++)u+=i.charAt(Math.floor(Math.random()*i.length));let m;return o?m=`${o}-${u}`:m=u,s?(0,D.join)(s,m):m}e.randomPath=t}),define(ie[28],re([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const f=Array.isArray(S)?[]:{};return Object.keys(S).forEach(v=>{S[v]&&typeof S[v]=="object"?f[v]=n(S[v]):f[v]=S[v]}),f}e.deepClone=n;function L(S){if(!S||typeof S!="object")return S;const f=[S];for(;f.length>0;){const v=f.shift();Object.freeze(v);for(const w in v)if(A.call(v,w)){const g=v[w];typeof g=="object"&&!Object.isFrozen(g)&&f.push(g)}}return S}e.deepFreeze=L;const A=Object.prototype.hasOwnProperty;function T(S,f){return R(S,f,new Set)}e.cloneAndChange=T;function R(S,f,v){if((0,D.isUndefinedOrNull)(S))return S;const w=f(S);if(typeof w!="undefined")return w;if((0,D.isArray)(S)){const g=[];for(const p of S)g.push(R(p,f,v));return g}if((0,D.isObject)(S)){if(v.has(S))throw new Error("Cannot clone recursive data-structure");v.add(S);const g={};for(let p in S)A.call(S,p)&&(g[p]=R(S[p],f,v));return v.delete(S),g}return S}function C(S,f,v=!0){return(0,D.isObject)(S)?((0,D.isObject)(f)&&Object.keys(f).forEach(w=>{w in S?v&&((0,D.isObject)(S[w])&&(0,D.isObject)(f[w])?C(S[w],f[w],v):S[w]=f[w]):S[w]=f[w]}),S):f}e.mixin=C;function E(S,f){if(S===f)return!0;if(S==null||f===null||f===void 0||typeof S!=typeof f||typeof S!="object"||Array.isArray(S)!==Array.isArray(f))return!1;let v,w;if(Array.isArray(S)){if(S.length!==f.length)return!1;for(v=0;v<S.length;v++)if(!E(S[v],f[v]))return!1}else{const g=[];for(w in S)g.push(w);g.sort();const p=[];for(w in f)p.push(w);if(p.sort(),!E(g,p))return!1;for(v=0;v<g.length;v++)if(!E(S[g[v]],f[g[v]]))return!1}return!0}e.equals=E;function P(S){const f=new Set;return JSON.stringify(S,(v,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(f.has(w))return"[Circular]";f.add(w)}return w})}e.safeStringify=P;function b(S,f,v){const w=f(S);return typeof w=="undefined"?v:w}e.getOrDefault=b;function d(S,f){const v=Object.create(null);return!S||!f||Object.keys(f).forEach(g=>{const p=S[g],l=f[g];E(p,l)||(v[g]=l)}),v}e.distinct=d;function y(S,f){const v=f.toLowerCase(),w=Object.keys(S).find(g=>g.toLowerCase()===v);return w?S[w]:S[f]}e.getCaseInsensitive=y;function h(S,f){const v=Object.create(null);for(const[w,g]of Object.entries(S))f(w,g)&&(v[w]=g);return v}e.filter=h}),define(ie[7],re([0,1,10,4]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(i,t){return!i&&!t?"file":i}function E(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const P="",b="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(t,s,o,c,u,m=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=C(t,m),this.authority=s||P,this.path=E(this.scheme,o||P),this.query=c||P,this.fragment=u||P,R(this,m))}static isUri(t){return t instanceof y?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:c,query:u,fragment:m}=t;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),c===void 0?c=this.path:c===null&&(c=P),u===void 0?u=this.query:u===null&&(u=P),m===void 0?m=this.fragment:m===null&&(m=P),s===this.scheme&&o===this.authority&&c===this.path&&u===this.query&&m===this.fragment?this:new S(s,o,c,u,m)}static parse(t,s=!1){const o=d.exec(t);return o?new S(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),s):new S(P,P,P,P,P)}static file(t){let s=P;if(n.isWindows&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const o=t.indexOf(b,2);o===-1?(s=t.substring(2),t=b):(s=t.substring(2,o),t=t.substring(o)||b)}return new S("file",s,t,P,P)}static from(t){const s=new S(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&t.scheme==="file"?o=y.file(D.win32.join(g(t,!0),...s)).path:o=D.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return p(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof y)return t;{const s=new S(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=y;const h=n.isWindows?1:void 0;class S extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(i,t){let s,o=-1;for(let c=0;c<i.length;c++){const u=i.charCodeAt(c);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47)o!==-1&&(s+=encodeURIComponent(i.substring(o,c)),o=-1),s!==void 0&&(s+=i.charAt(c));else{s===void 0&&(s=i.substr(0,c));const m=f[u];m!==void 0?(o!==-1&&(s+=encodeURIComponent(i.substring(o,c)),o=-1),s+=m):o===-1&&(o=c)}}return o!==-1&&(s+=encodeURIComponent(i.substring(o))),s!==void 0?s:i}function w(i){let t;for(let s=0;s<i.length;s++){const o=i.charCodeAt(s);o===35||o===63?(t===void 0&&(t=i.substr(0,s)),t+=f[o]):t!==void 0&&(t+=i[s])}return t!==void 0?t:i}function g(i,t){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function p(i,t){const s=t?w:v;let o="",{scheme:c,authority:u,path:m,query:I,fragment:_}=i;if(c&&(o+=c,o+=":"),(u||c==="file")&&(o+=b,o+=b),u){let O=u.indexOf("@");if(O!==-1){const N=u.substr(0,O);u=u.substr(O+1),O=N.indexOf(":"),O===-1?o+=s(N,!1):(o+=s(N.substr(0,O),!1),o+=":",o+=s(N.substr(O+1),!1)),o+="@"}u=u.toLowerCase(),O=u.indexOf(":"),O===-1?o+=s(u,!1):(o+=s(u.substr(0,O),!1),o+=u.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}o+=s(m,!0)}return I&&(o+="?",o+=s(I,!1)),_&&(o+="#",o+=t?_:v(_,!1)),o}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(r)?i.replace(r,t=>l(t)):i}}),define(ie[107],re([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=n;function L(E){const P=[];let b;try{const d=JSON.parse(E.arguments),y=d[d.length-1];y&&y.__$stack&&(d.pop(),b=y.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:b}}e.parse=L;function A(E){if(typeof E!="string")return A(L(E).stack);const P=E;if(P){const b=T(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=A;function T(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function R(E,P){const{args:b,stack:d}=L(E),y=typeof b[0]=="string"&&b.length===1;let h=T(d);h&&(h=`(${h.trim()})`);let S=[];if(typeof b[0]=="string"?h&&y?S=[`%c[${P}] %c${b[0]} %c${h}`,C("blue"),C(""),C("grey")]:S=[`%c[${P}] %c${b[0]}`,C("blue"),C(""),...b.slice(1)]:S=[`%c[${P}]%`,C("blue"),...b],h&&!y&&S.push(h),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,S)}e.log=R;function C(E){return`color: ${E}`}}),define(ie[108],re([0,1,17,27,7]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,C)}e.stringify=A;function T(P){let b=JSON.parse(P);return b=E(b),b}e.parse=T;var R;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext",P[P.Date=14]="Date"})(R=e.MarshalledId||(e.MarshalledId={}));function C(P,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,n.regExpFlags)(b)}:b}function E(P,b=0){if(!P||b>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return L.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof D.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let d=0;d<P.length;++d)P[d]=E(P[d],b+1);else for(const d in P)Object.hasOwnProperty.call(P,d)&&(P[d]=E(P[d],b+1))}return P}e.revive=E}),define(ie[18],re([0,1,4,7]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,E,P){this._hosts[C]=E,this._ports[C]=P}setConnectionToken(C,E){this._connectionTokens[C]=E}rewrite(C){if(this._delegate)return this._delegate(C);const E=C.authority;let P=this._hosts[E];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const b=this._ports[E],d=this._connectionTokens[E];let y=`path=${encodeURIComponent(C.path)}`;return typeof d=="string"&&(y+=`&tkn=${encodeURIComponent(d)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${P}:${b}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new A;class T{asBrowserUri(C,E){const P=this.toUri(C,E);return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${L.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(C,E){const P=this.toUri(C,E);return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==T.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(C,E){return n.URI.isUri(C)?C:n.URI.parse(E.toUrl(C))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ie[19],re([0,1,41,18,10,4,27,7]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(y){return(0,R.uriToFsPath)(y,!0)}e.originalFSPath=C;class E{constructor(h){this._ignorePathCasing=h}compare(h,S,f=!1){return h===S?0:(0,T.compare)(this.getComparisonKey(h,f),this.getComparisonKey(S,f))}isEqual(h,S,f=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,f)===this.getComparisonKey(S,f)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,f=!1){if(h.scheme===S.scheme){if(h.scheme===n.Schemas.file)return D.isEqualOrParent(C(h),C(S),this._ignorePathCasing(h))&&h.query===S.query&&(f||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return D.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(f||h.fragment===S.fragment)}return!1}joinPath(h,...S){return R.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===n.Schemas.file?S=R.URI.file(L.dirname(C(h))).path:(S=L.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===n.Schemas.file?S=R.URI.file(L.normalize(C(h))).path:S=L.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===n.Schemas.file){const w=L.relative(C(h),C(S));return A.isWindows?D.toSlashes(w):w}let f=h.path||"/",v=S.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const g=Math.min(f.length,v.length);w<g&&!(f.charCodeAt(w)!==v.charCodeAt(w)&&f.charAt(w).toLowerCase()!==v.charAt(w).toLowerCase());w++);f=v.substr(0,w)+f.substr(w)}return L.posix.relative(f,v)}resolvePath(h,S){if(h.scheme===n.Schemas.file){const f=R.URI.file(L.resolve(C(h),S));return h.with({authority:f.authority,path:f.path})}return S=D.toPosixPath(S),h.with({path:L.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||h!==void 0&&S!==void 0&&(0,T.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=L.sep){if(h.scheme===n.Schemas.file){const f=C(h);return f.length>D.getRoot(f).length&&f[f.length-1]===S}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=L.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=L.sep){let f=!1;if(h.scheme===n.Schemas.file){const v=C(h);f=v!==void 0&&v.length===D.getRoot(v).length&&v[v.length-1]===S}else{S="/";const v=h.path;f=v.length===1&&v.charCodeAt(v.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(y=>y.scheme===n.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new E(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(y,h){const S=[];for(let f=0;f<y.length;f++){const v=h(y[f]);y.some((w,g)=>g===f?!1:(0,e.isEqualOrParent)(v,h(w)))||S.push(y[f])}return S}e.distinctParents=P;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(S){const f=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(g=>{const[p,l]=g.split(":");p&&l&&f.set(p,l)});const w=S.path.substring(0,S.path.indexOf(";"));return w&&f.set(y.META_DATA_MIME,w),f}y.parseMetaData=h})(b=e.DataUri||(e.DataUri={}));function d(y,h,S){if(h){let f=y.path;return f&&f[0]!==L.posix.sep&&(f=L.posix.sep+f),y.with({scheme:S,authority:h,path:f})}return y.with({scheme:S})}e.toLocalResource=d}),define(ie[5],re([0,1,25,9,3,2,19,4]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(q){return!!q&&typeof q.then=="function"}e.isThenable=C;function E(q){const F=new D.CancellationTokenSource,V=q(F.token),$=new Promise((B,te)=>{const se=F.token.onCancellationRequested(()=>{se.dispose(),F.dispose(),te(new n.CancellationError)});Promise.resolve(V).then(ce=>{se.dispose(),F.dispose(),B(ce)},ce=>{se.dispose(),F.dispose(),te(ce)})});return new class{cancel(){F.cancel()}then(B,te){return $.then(B,te)}catch(B){return this.then(void 0,B)}finally(B){return $.finally(B)}}}e.createCancelablePromise=E;function P(q,F,V){return new Promise(($,B)=>{const te=F.onCancellationRequested(()=>{te.dispose(),$(V)});q.then($,B).finally(()=>te.dispose())})}e.raceCancellation=P;function b(q,F){return new Promise((V,$)=>{const B=F.onCancellationRequested(()=>{B.dispose(),$(new n.CancellationError)});q.then(V,$).finally(()=>B.dispose())})}e.raceCancellationError=b;async function d(q){let F=-1;const V=q.map((B,te)=>B.then(se=>(F=te,se))),$=await Promise.race(V);return q.forEach((B,te)=>{te!==F&&B.cancel()}),$}e.raceCancellablePromises=d;function y(q,F,V){let $;const B=setTimeout(()=>{$?.(void 0),V?.()},F);return Promise.race([q.finally(()=>clearTimeout(B)),new Promise(te=>$=te)])}e.raceTimeout=y;function h(q){return new Promise((F,V)=>{const $=q();C($)?$.then(F,V):F($)})}e.asPromise=h;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(V,V).then($)})}return new Promise((V,$)=>{this.queuedPromise.then(V,$)})}return this.activePromise=F(),new Promise((V,$)=>{this.activePromise.then(B=>{this.activePromise=null,V(B)},B=>{this.activePromise=null,$(B)})})}}e.Throttler=S;class f{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=f;class v{constructor(){this.promiseMap=new Map}queue(F,V){const B=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(F)===B&&this.promiseMap.delete(F)});return this.promiseMap.set(F,B),B}}e.SequencerByKey=v;const w=(q,F)=>{let V=!0;const $=setTimeout(()=>{V=!1,F()},q);return{isTriggered:()=>V,dispose:()=>{clearTimeout($),V=!1}}},g=q=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,q())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,V=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,te)=>{this.doResolve=B,this.doReject=te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const $=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=V===e.MicrotaskDelay?g($):w(V,$),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class l{constructor(F){this.delayer=new p(F),this.throttler=new S}trigger(F,V){return this.delayer.trigger(()=>this.throttler.queue(F),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise((F,V)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class a extends r{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function i(q,F){return F?new Promise((V,$)=>{const B=setTimeout(()=>{te.dispose(),V()},q),te=F.onCancellationRequested(()=>{clearTimeout(B),te.dispose(),$(new n.CancellationError)})}):E(V=>i(q,V))}e.timeout=i;function t(q,F=0){const V=setTimeout(q,F);return(0,A.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=t;function s(q){const F=[];let V=0;const $=q.length;function B(){return V<$?q[V++]():null}function te(se){se!=null&&F.push(se);const ce=B();return ce?ce.then(te):Promise.resolve(F)}return Promise.resolve(null).then(te)}e.sequence=s;function o(q,F=$=>!!$,V=null){let $=0;const B=q.length,te=()=>{if($>=B)return Promise.resolve(V);const se=q[$++];return Promise.resolve(se()).then(he=>F(he)?Promise.resolve(he):te())};return te()}e.first=o;function c(q,F=$=>!!$,V=null){if(q.length===0)return Promise.resolve(V);let $=q.length;const B=()=>{$=-1;for(const te of q)te.cancel?.()};return new Promise((te,se)=>{for(const ce of q)ce.then(he=>{--$>=0&&F(he)?(B(),te(he)):$===0&&te(V)}).catch(he=>{--$>=0&&(B(),se(he))})})}e.firstParallel=c;class u{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((V,$)=>{this.outstandingPromises.push({factory:F,c:V,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const V=F.factory();V.then(F.c,F.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class m extends u{constructor(){super(1)}}e.Queue=m;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new x;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,V=T.extUri){const $=V.getComparisonKey(F);let B=this.queues.get($);return B||(B=new m,L.Event.once(B.onFinished)(()=>{B?.dispose(),this.queues.delete($),this.onDidQueueFinish()}),this.queues.set($,B)),B}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class _{constructor(F,V){this._token=-1,typeof F=="function"&&typeof V=="number"&&this.setIfNotSet(F,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},V)}setIfNotSet(F,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},V))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,V){this.cancel(),this._token=setInterval(()=>{F()},V)}}e.IntervalTimer=O;class N{constructor(F,V){this.timeoutToken=-1,this.runner=F,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=N;class z{constructor(F,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=z;class k extends N{constructor(F,V){super(F,V);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class M extends A.Disposable{constructor(F,V){super();this.options=F,this.handler=V,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,R.setTimeout0)(()=>{if(F)return;const V=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(q,F)=>{const V=requestIdleCallback(q,typeof F=="number"?{timeout:F}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(V))}}}}();class j{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function U(q,F,V){let $;for(let B=0;B<V;B++)try{return await q()}catch(te){$=te,await i(F)}throw $}e.retry=U;class G{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,V,$){return this._pending={taskId:F,cancel:()=>$?.(),promise:V},V.then(()=>this.donePending(F),()=>this.donePending(F)),V}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let V,$;const B=new Promise((te,se)=>{V=te,$=se});this._next={run:F,promise:B,promiseResolve:V,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=G;class K{constructor(F,V=()=>Date.now()){this.interval=F,this.nowFn=V,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,V)=>{this.completeCallback=F,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(V=>{this.completeCallback(F),this.resolved=!0,V()})}error(F){return new Promise(V=>{this.errorCallback(F),this.rejected=!0,V()})}cancel(){new Promise(F=>{this.errorCallback(new n.CancellationError),this.rejected=!0,F()})}}e.DeferredPromise=x;var W;(function(q){async function F($){let B;const te=await Promise.all($.map(se=>se.then(ce=>ce,ce=>{B||(B=ce)})));if(typeof B!="undefined")throw B;return te}q.settled=F;function V($){return new Promise(async(B,te)=>{try{await $(B,te)}catch(se){te(se)}})}q.withAsyncBody=V})(W=e.Promises||(e.Promises={}));var X;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(X||(X={}));class H{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const V={emitOne:$=>this.emitOne($),emitMany:$=>this.emitMany($),reject:$=>this.reject($)};try{await Promise.resolve(F(V)),this.resolve()}catch($){this.reject($)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}static fromArray(F){return new H(V=>{V.emitMany(F)})}static fromPromise(F){return new H(async V=>{V.emitMany(await F)})}static fromPromises(F){return new H(async V=>{await Promise.all(F.map(async $=>V.emitOne(await $)))})}static merge(F){return new H(async V=>{await Promise.all(F.map(async $=>{for await(const B of $)V.emitOne(B)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,V){return new H(async $=>{for await(const B of F)$.emitOne(V(B))})}map(F){return H.map(this,F)}static filter(F,V){return new H(async $=>{for await(const B of F)V(B)&&$.emitOne(B)})}filter(F){return H.filter(this,F)}static coalesce(F){return H.filter(F,V=>!!V)}coalesce(){return H.coalesce(this)}static async toPromise(F){const V=[];for await(const $ of F)V.push($);return V}toPromise(){return H.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Z extends H{constructor(F,V){super(V);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function ee(q){const F=new D.CancellationTokenSource,V=q(F.token);return new Z(F,async $=>{const B=F.token.onCancellationRequested(()=>{B.dispose(),F.dispose(),$.reject(new n.CancellationError)});try{for await(const te of V){if(F.token.isCancellationRequested)return;$.emitOne(te)}B.dispose(),F.dispose()}catch(te){B.dispose(),F.dispose(),$.reject(te)}})}e.createCancelableAsyncIterable=ee}),define(ie[109],re([0,1,5,41,39,10,27]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",E="[^/\\\\]",P=/\//g;function b(K){switch(K){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}|${C}${E}+)*?`}}function d(K,x){if(!K)return[];const W=[];let X=!1,H=!1,Z="";for(const ee of K){switch(ee){case x:if(!X&&!H){W.push(Z),Z="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":H=!0;break;case"]":H=!1;break}Z+=ee}return Z&&W.push(Z),W}e.splitGlobAware=d;function y(K){if(!K)return"";let x="";const W=d(K,e.GLOB_SPLIT);if(W.every(X=>X===e.GLOBSTAR))x=".*";else{let X=!1;W.forEach((H,Z)=>{if(H===e.GLOBSTAR){X||(x+=b(2),X=!0);return}let ee=!1,q="",F=!1,V="";for(const $ of H){if($!=="}"&&ee){q+=$;continue}if(F&&($!=="]"||!V)){let B;$==="-"?B=$:($==="^"||$==="!")&&!V?B="^":$===e.GLOB_SPLIT?B="":B=T.escapeRegExpCharacters($),V+=B;continue}switch($){case"{":ee=!0;continue;case"[":F=!0;continue;case"}":{x+=`(?:${d(q,",").map(se=>y(se)).join("|")})`,ee=!1,q="";break}case"]":x+="["+V+"]",F=!1,V="";break;case"?":x+=E;continue;case"*":x+=b(1);continue;default:x+=T.escapeRegExpCharacters($)}}Z<W.length-1&&(W[Z+1]!==e.GLOBSTAR||Z+2<W.length)&&(x+=C),X=!1})}return x}const h=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,p=new L.LRUCache(1e4),l=function(){return!1},r=function(){return null};function a(K,x){if(!K)return r;let W;typeof K!="string"?W=K.pattern:W=K,W=W.trim();const X=`${W}_${!!x.trimForExclusions}`;let H=p.get(X);if(H)return i(H,K);let Z;if(h.test(W)){const ee=W.substr(4);H=function(q,F){return typeof q=="string"&&q.endsWith(ee)?W:null}}else(Z=S.exec(t(W,x)))?H=s(Z[1],W):(x.trimForExclusions?v:f).test(W)?H=o(W,x):(Z=w.exec(t(W,x)))?H=c(Z[1].substr(1),W,!0):(Z=g.exec(t(W,x)))?H=c(Z[1],W,!1):H=u(W);return p.set(X,H),i(H,K)}function i(K,x){return typeof x=="string"?K:function(W,X){return n.isEqualOrParent(W,x.base)?K(A.relative(x.base,W),X):null}}function t(K,x){return x.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function s(K,x){const W=`/${K}`,X=`\\${K}`,H=function(ee,q){return typeof ee!="string"?null:q?q===K?x:null:ee===K||ee.endsWith(W)||ee.endsWith(X)?x:null},Z=[K];return H.basenames=Z,H.patterns=[x],H.allBasenames=Z,H}function o(K,x){const W=G(K.slice(1,-1).split(",").map(q=>a(q,x)).filter(q=>q!==r),K),X=W.length;if(!X)return r;if(X===1)return W[0];const H=function(q,F){for(let V=0,$=W.length;V<$;V++)if(W[V](q,F))return K;return null},Z=W.find(q=>!!q.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=W.reduce((q,F)=>F.allPaths?q.concat(F.allPaths):q,[]);return ee.length&&(H.allPaths=ee),H}function c(K,x,W){const X=A.sep===A.posix.sep,H=X?K:K.replace(P,A.sep),Z=A.sep+H,ee=A.posix.sep+K,q=W?function(F,V){return typeof F=="string"&&(F===H||F.endsWith(Z)||!X&&(F===K||F.endsWith(ee)))?x:null}:function(F,V){return typeof F=="string"&&(F===H||!X&&F===K)?x:null};return q.allPaths=[(W?"*/":"./")+K],q}function u(K){try{const x=new RegExp(`^${y(K)}$`);return function(W){return x.lastIndex=0,typeof W=="string"&&x.test(W)?K:null}}catch{return r}}function m(K,x,W){return!K||typeof x!="string"?!1:I(K)(x,void 0,W)}e.match=m;function I(K,x={}){if(!K)return l;if(typeof K=="string"||z(K)){const W=a(K,x);if(W===r)return l;const X=function(H,Z){return!!W(H,Z)};return W.allBasenames&&(X.allBasenames=W.allBasenames),W.allPaths&&(X.allPaths=W.allPaths),X}return j(K,x)}e.parse=I;function _(K){if(!K)return;let x;return W=>(x||(x=(K()||Promise.resolve([])).then(X=>X?N(X):{})),x.then(X=>!!X[W]))}e.hasSiblingPromiseFn=_;function O(K){if(!K)return;let x;return W=>{if(!x){const X=K();x=X?N(X):{}}return!!x[W]}}e.hasSiblingFn=O;function N(K){const x={};for(const W of K)x[W]=!0;return x}function z(K){const x=K;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}e.isRelativePattern=z;function k(K){return K.allBasenames||[]}e.getBasenameTerms=k;function M(K){return K.allPaths||[]}e.getPathTerms=M;function j(K,x){const W=G(Object.getOwnPropertyNames(K).map(q=>U(q,K[q],x)).filter(q=>q!==r)),X=W.length;if(!X)return r;if(!W.some(q=>!!q.requiresSiblings)){if(X===1)return W[0];const q=function($,B){for(let te=0,se=W.length;te<se;te++){const ce=W[te]($,B);if(ce)return ce}return null},F=W.find($=>!!$.allBasenames);F&&(q.allBasenames=F.allBasenames);const V=W.reduce(($,B)=>B.allPaths?$.concat(B.allPaths):$,[]);return V.length&&(q.allPaths=V),q}const H=function(q,F,V){let $;for(let B=0,te=W.length;B<te;B++){const se=W[B];se.requiresSiblings&&V&&(F||(F=A.basename(q)),$||($=F.substr(0,F.length-A.extname(q).length)));const ce=se(q,F,$,V);if(ce)return ce}return null},Z=W.find(q=>!!q.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=W.reduce((q,F)=>F.allPaths?q.concat(F.allPaths):q,[]);return ee.length&&(H.allPaths=ee),H}function U(K,x,W){if(x===!1)return r;const X=a(K,W);if(X===r)return r;if(typeof x=="boolean")return X;if(x){const H=x.when;if(typeof H=="string"){const Z=(ee,q,F,V)=>{if(!V||!X(ee,q))return null;const $=H.replace("$(basename)",F),B=V($);return(0,D.isThenable)(B)?B.then(te=>te?K:null):B?K:null};return Z.requiresSiblings=!0,Z}}return X}function G(K,x){const W=K.filter(q=>!!q.basenames);if(W.length<2)return K;const X=W.reduce((q,F)=>{const V=F.basenames;return V?q.concat(V):q},[]);let H;if(x){H=[];for(let q=0,F=X.length;q<F;q++)H.push(x)}else H=W.reduce((q,F)=>{const V=F.patterns;return V?q.concat(V):q},[]);const Z=function(q,F){if(typeof q!="string")return null;if(!F){let $;for($=q.length;$>0;$--){const B=q.charCodeAt($-1);if(B===47||B===92)break}F=q.substr($)}const V=X.indexOf(F);return V!==-1?H[V]:null};Z.basenames=X,Z.patterns=H,Z.allBasenames=X;const ee=K.filter(q=>!q.basenames);return ee.push(Z),ee}}),define(ie[110],re([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(P){return P.toJSON()}class L{constructor(b){this._uriTransformer=b}transformIncoming(b){const d=this._uriTransformer.transformIncoming(b);return d===b?b:n(D.URI.from(d))}transformOutgoing(b){const d=this._uriTransformer.transformOutgoing(b);return d===b?b:n(D.URI.from(d))}transformOutgoingURI(b){const d=this._uriTransformer.transformOutgoing(b);return d===b?b:D.URI.from(d)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function A(P,b,d){if(!P||d>200)return null;if(typeof P=="object"){if(P instanceof D.URI)return b.transformOutgoing(P);for(let y in P)if(Object.hasOwnProperty.call(P,y)){const h=A(P[y],b,d+1);h!==null&&(P[y]=h)}}return null}function T(P,b){const d=A(P,b,0);return d===null?P:d}e.transformOutgoingURIs=T;function R(P,b,d,y){if(!P||y>200)return null;if(typeof P=="object"){if(P.$mid===1)return d?D.URI.revive(b.transformIncoming(P)):b.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const S=R(P[h],b,d,y+1);S!==null&&(P[h]=S)}}return null}function C(P,b){const d=R(P,b,!1,0);return d===null?P:d}e.transformIncomingURIs=C;function E(P,b){const d=R(P,b,!0,0);return d===null?P:d}e.transformAndReviveIncomingURIs=E}),define(ie[29],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(C){return D.test(C)}e.isUUID=n;const L=new Uint8Array(16),A=[];for(let C=0;C<256;C++)A.push(C.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(C){for(let E=0;E<C.length;E++)C[E]=Math.floor(Math.random()*256);return C};function R(){T(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let C=0,E="";return E+=A[L[C++]],E+=A[L[C++]],E+=A[L[C++]],E+=A[L[C++]],E+="-",E+=A[L[C++]],E+=A[L[C++]],E+="-",E+=A[L[C++]],E+=A[L[C++]],E+="-",E+=A[L[C++]],E+=A[L[C++]],E+="-",E+=A[L[C++]],E+=A[L[C++]],E+=A[L[C++]],E+=A[L[C++]],E+=A[L[C++]],E+=A[L[C++]],E}e.generateUuid=R}),define(ie[111],re([0,1,248]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(A="utf8"){this.stringDecoder=new D.StringDecoder(A),this.remaining=null}write(A){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(R.length<1)return T;let C=0,E,P=C;for(;P<R.length;)if(E=R.charCodeAt(P),E===13||E===10){if(T.push(R.substring(C,P)),P++,P<R.length){const b=E;E=R.charCodeAt(P),(b===13&&E===10||b===10&&E===13)&&P++}C=P}else P++;return this.remaining=C<R.length?R.substr(C):null,T}end(){return this.remaining}}e.LineDecoder=n}),define(ie[112],re([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(T){const R=T.replace(/\-/g,":").toLowerCase();return!n.has(R)}function A(){const T=(0,D.networkInterfaces)();for(let R in T){const C=T[R];if(C){for(const{mac:E}of C)if(L(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ie[113],re([0,1,33,9,39,29,112]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,b=0;const d=(0,D.networkInterfaces)();for(let y in d){const h=d[y];if(h)for(const{mac:S,internal:f}of h)f||(b+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(P+=1))}this._value=b>0?P/b:0}return this._value}};let R;async function C(){return R||(R=(async()=>await E()||A.generateUuid())()),R}e.getMachineId=C;async function E(){try{const P=await new Promise((d,y)=>{J(["crypto"],d,y)}),b=(0,T.getMac)();return P.createHash("sha256").update(b,"utf8").digest("hex")}catch(P){n.onUnexpectedError(P);return}}}),define(ie[22],re([0,1,50,33,249,5,41,71,10,4,19,7]),function(J,e,D,n,L,A,T,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var d;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(d=e.RimRafMode||(e.RimRafMode={}));async function y(M,j=d.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return j===d.UNLINK?S(M):h(M)}async function h(M){try{const j=(0,T.randomPath)((0,n.tmpdir)());try{await D.promises.rename(M,j)}catch{return S(M)}S(j).catch(U=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function S(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function f(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(M,{recursive:!0})}e.rimrafSync=f;async function v(M,j){return p(await(j?w(M):(0,L.promisify)(D.readdir)(M)))}async function w(M){try{return await(0,L.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const j=[],U=await v(M);for(const G of U){let K=!1,x=!1,W=!1;try{const X=await e.Promises.lstat((0,C.join)(M,G));K=X.isFile(),x=X.isDirectory(),W=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}j.push({name:G,isFile:()=>K,isDirectory:()=>x,isSymbolicLink:()=>W})}return j}function g(M){return p(D.readdirSync(M))}e.readdirSync=g;function p(M){return M.map(j=>typeof j=="string"?E.isMacintosh?(0,R.normalizeNFC)(j):j:(j.name=E.isMacintosh?(0,R.normalizeNFC)(j.name):j.name,j))}async function l(M){const j=await v(M),U=[];for(const G of j)await a.existsDirectory((0,C.join)(M,G))&&U.push(G);return U}function r(M,j=1e3){return new Promise(U=>{let G=!1;const K=setInterval(()=>{G||(G=!0,D.access(M,x=>{G=!1,x&&(clearInterval(K),U(void 0))}))},j)})}e.whenDeleted=r;var a;(function(M){async function j(K){let x;try{if(x=await e.Promises.lstat(K),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(E.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw X}throw W}}M.stat=j;async function U(K){try{const{stat:x,symbolicLink:W}=await M.stat(K);return x.isFile()&&W?.dangling!==!0}catch{}return!1}M.existsFile=U;async function G(K){try{const{stat:x,symbolicLink:W}=await M.stat(K);return x.isDirectory()&&W?.dangling!==!0}catch{}return!1}M.existsDirectory=G})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function t(M,j,U){return i.queueFor(b.URI.file(M),P.extUriBiasedIgnorePathCase).queue(()=>{const G=u(U);return new Promise((K,x)=>o(M,j,G,W=>W?x(W):K()))})}let s=!0;function o(M,j,U,G){if(!s)return D.writeFile(M,j,{mode:U.mode,flag:U.flag},G);D.open(M,U.flag,U.mode,(K,x)=>{if(K)return G(K);D.writeFile(x,j,W=>{if(W)return D.close(x,()=>G(W));D.fdatasync(x,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),s=!1),D.close(x,H=>G(H))))})})}function c(M,j,U){const G=u(U);if(!s)return D.writeFileSync(M,j,{mode:G.mode,flag:G.flag});const K=D.openSync(M,G.flag,G.mode);try{D.writeFileSync(K,j);try{D.fdatasyncSync(K)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),s=!1}}finally{D.closeSync(K)}}e.writeFileSync=c;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function m(M,j){if(M===j)return;async function U(G){try{const K=await e.Promises.lstat(G);if(K.isDirectory()||K.isSymbolicLink())return;await e.Promises.utimes(G,K.atime,new Date)}catch{}}try{await e.Promises.rename(M,j),await U(j)}catch(G){if(M.toLowerCase()!==j.toLowerCase()&&G.code==="EXDEV"||M.endsWith("."))await I(M,j,{preserveSymlinks:!1}),await y(M,d.MOVE),await U(j);else throw G}}async function I(M,j,U){return O(M,j,{root:{source:M,target:j},options:U,handledSourcePaths:new Set})}const _=511;async function O(M,j,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:G,symbolicLink:K}=await a.stat(M);if(K){if(U.options.preserveSymlinks)try{return await k(M,j,U)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(K.dangling)return}return G.isDirectory()?N(M,j,G.mode&_,U):z(M,j,G.mode&_)}async function N(M,j,U,G){await e.Promises.mkdir(j,{recursive:!0,mode:U});const K=await v(M);for(const x of K)await O((0,C.join)(M,x),(0,C.join)(j,x),G)}async function z(M,j,U){await e.Promises.copyFile(M,j),await e.Promises.chmod(j,U)}async function k(M,j,U){let G=await e.Promises.readlink(M);(0,T.isEqualOrParent)(G,U.root.source,!E.isLinux)&&(G=(0,C.join)(U.root.target,G.substr(U.root.source.length+1))),await e.Promises.symlink(G,j)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(M,j,U,G,K)=>new Promise((x,W)=>{D.read(M,j,U,G,K,(X,H,Z)=>X?W(X):x({bytesRead:H,buffer:Z}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(M,j,U,G,K)=>new Promise((x,W)=>{D.write(M,j,U,G,K,(X,H,Z)=>X?W(X):x({bytesWritten:H,buffer:Z}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get rename(){return(0,L.promisify)(D.rename)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return y}get move(){return m}get copy(){return I}}}),define(ie[114],re([0,1,50,10,4,27,22]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(d){if(L.isLinux)return d;const y=(0,n.dirname)(d);if(d===y)return d;const h=((0,n.basename)(d)||d).toLowerCase();try{const f=(0,T.readdirSync)(y).filter(v=>v.toLowerCase()===h);if(f.length===1){const v=R(y);if(v)return(0,n.join)(v,f[0])}else if(f.length>1){const v=f.indexOf(h);if(v>=0){const w=R(y);if(w)return(0,n.join)(w,f[v])}}}catch{}return null}e.realcaseSync=R;async function C(d){if(L.isLinux)return d;const y=(0,n.dirname)(d);if(d===y)return d;const h=((0,n.basename)(d)||d).toLowerCase();try{const f=(await T.Promises.readdir(y)).filter(v=>v.toLowerCase()===h);if(f.length===1){const v=await C(y);if(v)return(0,n.join)(v,f[0])}else if(f.length>1){const v=f.indexOf(h);if(v>=0){const w=await C(y);if(w)return(0,n.join)(w,f[v])}}}catch{}return null}e.realcase=C;async function E(d){try{return await T.Promises.realpath(d)}catch{const h=b(d);return await T.Promises.access(h,D.constants.R_OK),h}}e.realpath=E;function P(d){try{return D.realpathSync(d)}catch{const h=b(d);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=P;function b(d){return(0,A.rtrim)((0,n.normalize)(d),n.sep)}}),define(ie[115],re([0,1,55]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,C,E,P=1){let b=!1;return new Promise(d=>{const y=setTimeout(()=>{if(!b)return b=!0,d(0)},E);L(R,C,P,h=>{if(!b)return b=!0,clearTimeout(y),d(h)})})}e.findFreePort=n;function L(R,C,E,P){if(C===0)return P(0);const b=new D.Socket;b.once("connect",()=>(T(b),L(R+E,C-1,E,P))),b.once("data",()=>{}),b.once("error",d=>(T(b),d.code!=="ECONNREFUSED"?L(R+E,C-1,E,P):P(R))),b.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,C,E){let P=!1,b,d=1;const y=D.createServer({pauseOnConnect:!0});function h(S,f){P||(P=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),f(S))}return new Promise(S=>{b=setTimeout(()=>{h(0,S)},E),y.on("listening",()=>{h(R,S)}),y.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&d<C?(R++,d++,y.listen(R,"127.0.0.1")):h(0,S)}),y.on("close",()=>{h(0,S)}),y.listen(R,"127.0.0.1")})}e.findFreePortFaster=A;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(ie[72],re([0,1,33,10,22]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var C;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(C||(C={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class b{constructor(l,r,a){this.exePath=l,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:p=!1}={}){return p?E===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:p=!1,findPreview:l=!1}={}){const r=d({useAlternateBitness:p});if(!r)return null;const a=n.join(r,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(a))return null;let i=-1,t=null;for(const c of await L.Promises.readdir(a)){let u=-1;if(l){const I=c.indexOf("-");if(I<0)continue;const _=c.substring(0,I);if(!A.test(_)||c.substring(I+1)!=="preview")continue;u=parseInt(_,10)}else{if(!A.test(c))continue;u=parseInt(c,10)}if(u<=i)continue;const m=n.join(a,c,"pwsh.exe");!await L.SymlinkSupport.existsFile(m)||(t=m,i=u)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=l?" Preview":"";return new b(t,`PowerShell${o}${s}`,!0)}async function h({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=p?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(l))if(r.test(i)){const t=n.join(l,i,"pwsh.exe");return new b(t,a)}return null}function S(){const p=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new b(p,".NET Core PowerShell Global Tool")}function f(){const p=n.join(process.env.windir,E===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(p,"Windows PowerShell",!0)}async function*v(){let p=await y();p&&(yield p),p=await y({useAlternateBitness:!0}),p&&(yield p),p=await h(),p&&(yield p),p=S(),p&&(yield p),p=await y({findPreview:!0}),p&&(yield p),p=await h({findPreview:!0}),p&&(yield p),p=await y({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=f(),p&&(yield p)}async function*w(){for await(const p of v())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=w;async function g(){for await(const p of w())return p;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ie[116],re([0,1,45,18]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(T){return new Promise((R,C)=>{let E;const P=new Map;function b(y,h,S,f,v){const w=P.get(h);if(y===T||w){const g={name:d(S),cmd:S,pid:y,ppid:h,load:f,mem:v};P.set(y,g),y===T&&(E=g),w&&(w.children||(w.children=[]),w.children.push(g),w.children.length>1&&(w.children=w.children.sort((p,l)=>p.pid-l.pid)))}}function d(y){const h=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,w=/--crashes-directory/,g=/\\pipe\\winpty-control/,p=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(y))return"electron-crash-reporter";if(g.exec(y))return"winpty-process";if(p.exec(y))return"console-window-host (Windows internal process)";let r=l.exec(y);if(r&&r.length===2)return r[1]==="renderer"?h.exec(y)?"shared-process":S.exec(y)?"issue-reporter":f.exec(y)?"process-explorer":"window":r[1]==="utility"&&v.exec(y)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let i="";do r=a.exec(y),r&&(i+=r+" ");while(r);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{J(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(T,S=>{h.getProcessCpuUsage(S,f=>{const v=new Map;f.forEach(w=>{const g=y(w.commandLine||"");v.set(w.pid,{name:d(g),cmd:g,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),E=v.get(T),E?(v.forEach(w=>{const g=v.get(w.ppid);g&&(g.children||(g.children=[]),g.children.push(w))}),v.forEach(w=>{w.children&&(w.children=w.children.sort((g,p)=>g.pid-p.pid))}),R(E)):C(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[E];const S=[];for(;h.length;){const v=h.shift();v&&(S.push(v.pid),v.children&&(h=h.concat(v.children)))}let f=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);f+=" "+S.join(" "),(0,D.exec)(f,{},(v,w,g)=>{if(v||g)C(v||new Error(g.toString()));else{const p=w.toString().split(`
`);for(let l=0;l<S.length;l++){const r=P.get(S[l]);r.load=parseFloat(p[l])}if(!E){C(new Error(`Root process ${T} not found`));return}R(E)}})};(0,D.exec)("which ps",{},(h,S,f)=>{if(h||f)if(process.platform!=="linux")C(h||new Error(f.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(v,{},(w,g,p)=>{w||p?C(w||new Error(p.toString())):(A(g,b),y())})}else{const v=S.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${v} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,p,l)=>{g||l&&!l.includes("screen size is bogus")?C(g||new Error(l.toString())):(A(p,b),process.platform==="linux"?y():E?R(E):C(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=L;function A(T,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=T.toString().split(`
`);for(const P of E){const b=C.exec(P.trim());b&&b.length===6&&R(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var de=this&&this.__decorate||function(J,e,D,n){var L=arguments.length,A=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,D,n);else for(var R=J.length-1;R>=0;R--)(T=J[R])&&(A=(L<3?T(A):L>3?T(e,D,A):T(e,D))||A);return L>3&&A&&Object.defineProperty(e,D,A),A};define(ie[36],re([0,1,16,5,17,25,53,9,3,2,108,27,15]),function(J,e,D,n,L,A,T,R,C,E,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function h(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function f(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(v||(v={}));class w{constructor(W){this.buffer=W,this.pos=0}read(W){const X=this.buffer.slice(this.pos,this.pos+W);return this.pos+=X.byteLength,X}}class g{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}var p;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(p||(p={}));function l(x){const W=L.VSBuffer.alloc(4);return W.writeUInt32BE(x,0),W}function r(x){return x.read(4).readUInt32BE(0)}function a(x){const W=L.VSBuffer.alloc(1);return W.writeUInt8(x,0),W}const i={Undefined:a(p.Undefined),String:a(p.String),Buffer:a(p.Buffer),VSBuffer:a(p.VSBuffer),Array:a(p.Array),Object:a(p.Object)},t=typeof Buffer!="undefined";function s(x,W){if(typeof W=="undefined")x.write(i.Undefined);else if(typeof W=="string"){const X=L.VSBuffer.fromString(W);x.write(i.String),x.write(l(X.byteLength)),x.write(X)}else if(t&&Buffer.isBuffer(W)){const X=L.VSBuffer.wrap(W);x.write(i.Buffer),x.write(l(X.byteLength)),x.write(X)}else if(W instanceof L.VSBuffer)x.write(i.VSBuffer),x.write(l(W.byteLength)),x.write(W);else if(Array.isArray(W)){x.write(i.Array),x.write(l(W.length));for(const X of W)s(x,X)}else{const X=L.VSBuffer.fromString(JSON.stringify(W));x.write(i.Object),x.write(l(X.byteLength)),x.write(X)}}function o(x){switch(x.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return x.read(r(x)).toString();case p.Buffer:return x.read(r(x)).buffer;case p.VSBuffer:return x.read(r(x));case p.Array:{const X=r(x),H=[];for(let Z=0;Z<X;Z++)H.push(o(x));return H}case p.Object:return JSON.parse(x.read(r(x)).toString())}}class c{constructor(W,X,H=null,Z=1e3){this.protocol=W,this.ctx=X,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(W,X){this.channels.set(W,X),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const X=this.send([W.type]);this.logger&&this.logger.logOutgoing(X,0,1,f(W.type));return}case 201:case 202:case 204:case 203:{const X=this.send([W.type,W.id],W.data);this.logger&&this.logger.logOutgoing(X,W.id,1,f(W.type),W.data);return}}}send(W,X=void 0){const H=new g;return s(H,W),s(H,X),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const X=new w(W),H=o(X),Z=o(X),ee=H[0];switch(ee){case 100:return this.logger&&this.logger.logIncoming(W.byteLength,H[1],1,`${h(ee)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger&&this.logger.logIncoming(W.byteLength,H[1],1,`${h(ee)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger&&this.logger.logIncoming(W.byteLength,H[1],1,`${h(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(W.byteLength,H[1],1,`${h(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]})}}onPromise(W){const X=this.channels.get(W.channelName);if(!X){this.collectPendingRequest(W);return}const H=new A.CancellationTokenSource;let Z;try{Z=X.call(this.ctx,W.name,W.arg,H.token)}catch(F){Z=Promise.reject(F)}const ee=W.id;Z.then(F=>{this.sendResponse({id:ee,data:F,type:201}),this.activeRequests.delete(W.id)},F=>{F instanceof Error?this.sendResponse({id:ee,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:ee,data:F,type:203}),this.activeRequests.delete(W.id)});const q=(0,E.toDisposable)(()=>H.cancel());this.activeRequests.set(W.id,q)}onEventListen(W){const X=this.channels.get(W.channelName);if(!X){this.collectPendingRequest(W);return}const H=W.id,ee=X.listen(this.ctx,W.name,W.arg)(q=>this.sendResponse({id:H,data:q,type:204}));this.activeRequests.set(W.id,ee)}disposeActiveRequest(W){const X=this.activeRequests.get(W.id);X&&(X.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let X=this.pendingRequests.get(W.channelName);X||(X=[],this.pendingRequests.set(W.channelName,X));const H=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:W,timeoutTimer:H})}flushPendingRequests(W){const X=this.pendingRequests.get(W);if(X){for(const H of X)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(W=>W.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var u;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(W,X=null){this.protocol=W,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=X}getChannel(W){const X=this;return{call(H,Z,ee){return X.isDisposed?Promise.reject(R.canceled()):X.requestPromise(W,H,Z,ee)},listen(H,Z){return X.isDisposed?Promise.reject(R.canceled()):X.requestEvent(W,H,Z)}}}requestPromise(W,X,H,Z=A.CancellationToken.None){const ee=this.lastRequestId++,F={id:ee,type:100,channelName:W,name:X,arg:H};if(Z.isCancellationRequested)return Promise.reject(R.canceled());let V;return new Promise((B,te)=>{if(Z.isCancellationRequested)return te(R.canceled());const se=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(ee),B(ye.data);break;case 202:{this.handlers.delete(ee);const Se=new Error(ye.data.message);Se.stack=ye.data.stack,Se.name=ye.data.name,te(Se);break}case 203:this.handlers.delete(ee),te(ye.data);break}};this.handlers.set(ee,me),this.sendRequest(F)};let ce=null;this.state===v.Idle?se():(ce=(0,n.createCancelablePromise)(me=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:ee,type:101}),te(R.canceled())},ge=Z.onCancellationRequested(he);V=(0,E.combinedDisposable)((0,E.toDisposable)(he),ge),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(W,X,H){const Z=this.lastRequestId++,q={id:Z,type:102,channelName:W,name:X,arg:H};let F=null;const V=new C.Emitter({onFirstListenerAdd:()=>{F=(0,n.createCancelablePromise)(B=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(V),this.sendRequest(q)})},onLastListenerRemove:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(V),this.sendRequest({id:Z,type:103}))}}),$=B=>V.fire(B.data);return this.handlers.set(Z,$),V.event}sendRequest(W){switch(W.type){case 100:case 102:{const X=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger&&this.logger.logOutgoing(X,W.id,0,`${h(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const X=this.send([W.type,W.id]);this.logger&&this.logger.logOutgoing(X,W.id,0,h(W.type));return}}}send(W,X=void 0){const H=new g;return s(H,W),s(H,X),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const X=new w(W),H=o(X),Z=o(X),ee=H[0];switch(ee){case 200:return this.logger&&this.logger.logIncoming(W.byteLength,0,0,f(ee)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(W.byteLength,H[1],0,f(ee),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(W){if(W.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(W.id);X&&X(W)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(W=>W.dispose()),this.activeRequests.clear()}}de([T.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class I{constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,W(({protocol:X,onDidClientDisconnect:H})=>{C.Event.once(X.onMessage)(ee=>{const q=new w(ee),F=o(q),V=new c(X,F),$=new m(X);this.channels.forEach((te,se)=>V.registerChannel(se,te));const B={channelServer:V,channelClient:$,ctx:F};this._connections.add(B),this._onDidAddConnection.fire(B),H(()=>{V.dispose(),$.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const W=[];return this._connections.forEach(X=>W.push(X)),W}getChannel(W,X){const H=this;return{call(Z,ee,q){let F;if((0,d.isFunction)(X)){let $=(0,D.getRandomElement)(H.connections.filter(X));F=$?Promise.resolve($):C.Event.toPromise(C.Event.filter(H.onDidAddConnection,X))}else F=X.routeCall(H,Z,ee);const V=F.then($=>$.channelClient.getChannel(W));return O(V).call(Z,ee,q)},listen(Z,ee){if((0,d.isFunction)(X))return H.getMulticastEvent(W,X,Z,ee);const q=X.routeEvent(H,Z,ee).then(F=>F.channelClient.getChannel(W));return O(q).listen(Z,ee)}}}getMulticastEvent(W,X,H,Z){const ee=this;let q=new E.DisposableStore;const F=new C.Emitter({onFirstListenerAdd:()=>{q=new E.DisposableStore;const V=new C.EventMultiplexer,$=new Map,B=se=>{const he=se.channelClient.getChannel(W).listen(H,Z),ge=V.add(he);$.set(se,ge)},te=se=>{const ce=$.get(se);!ce||(ce.dispose(),$.delete(se))};ee.connections.filter(X).forEach(B),C.Event.filter(ee.onDidAddConnection,X)(B,void 0,q),ee.onDidRemoveConnection(te,void 0,q),V.event(F.fire,F,q),q.add(V)},onLastListenerRemove:()=>{q.dispose()}});return F.event}registerChannel(W,X){this.channels.set(W,X),this._connections.forEach(H=>{H.channelServer.registerChannel(W,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class _{constructor(W,X,H=null){const Z=new g;s(Z,X),W.send(Z.buffer),this.channelClient=new m(W,H),this.channelServer=new c(W,X,H)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,X){this.channelServer.registerChannel(W,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(x){return{call(W,X,H){return x.then(Z=>Z.call(W,X,H))},listen(W,X){const H=new C.Relay;return x.then(Z=>H.input=Z.listen(W,X)),H.event}}}e.getDelayedChannel=O;function N(x){let W=!1;return{call(X,H,Z){return W?x.call(X,H,Z):(0,n.timeout)(0).then(()=>W=!0).then(()=>x.call(X,H,Z))},listen(X,H){if(W)return x.listen(X,H);const Z=new C.Relay;return(0,n.timeout)(0).then(()=>W=!0).then(()=>Z.input=x.listen(X,H)),Z.event}}}e.getNextTickChannel=N;class z{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const X of W.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await C.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=z;var k;(function(x){function W(ee,q){const F=ee,V=q&&q.disableMarshalling,$=new Map;for(const B in F)H(B)&&$.set(B,C.Event.buffer(F[B],!0));return new class{listen(B,te,se){const ce=$.get(te);if(ce)return ce;if(Z(te)){const he=F[te];if(typeof he=="function")return he.call(F,se)}throw new Error(`Event not found: ${te}`)}call(B,te,se){const ce=F[te];if(typeof ce=="function"){if(!V&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ce.apply(F,se)}throw new Error(`Method not found: ${te}`)}}}x.fromService=W;function X(ee,q){const F=q&&q.disableMarshalling;return new Proxy({},{get(V,$){if(typeof $=="string")return q?.properties?.has($)?q.properties.get($):Z($)?function(B){return ee.listen($,B)}:H($)?ee.listen($):async function(...B){let te;q&&!(0,d.isUndefinedOrNull)(q.context)?te=[q.context,...B]:te=B;const se=await ee.call($,te);return F?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String($)}`)}})}x.toService=X;function H(ee){return ee[0]==="o"&&ee[1]==="n"&&b.isUpperAsciiLetter(ee.charCodeAt(2))}function Z(ee){return/^onDynamic/.test(ee)&&b.isUpperAsciiLetter(ee.charCodeAt(9))}})(k=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let W=x.toString();if(W!=="[object Object]")return W}return x}function U(x){return Array.isArray(x)?x.map(j):j(x)}function G(x,W,X,H,Z,ee,q){q=U(q);const F=M[Z],V=F[H%F.length];let $=[`%c[${x}]%c[${String(W).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(ee)?($=$.concat(q),$.push(")")):$.push(q),console.log.apply(console,$)}e.logWithColors=G;class K{constructor(W,X){this._outgoingPrefix=W,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,X,H,Z,ee){this._totalOutgoing+=W,G(this._outgoingPrefix,this._totalOutgoing,W,X,H,Z,ee)}logIncoming(W,X,H,Z,ee){this._totalIncoming+=W,G(this._incomingPrefix,this._totalIncoming,W,X,H,Z,ee)}}e.IPCLogger=K}),define(ie[117],re([0,1,17,3,36]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(C){this.port=C,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class T extends L.IPCClient{constructor(C,E){const P=new A(C);super(P,E);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ie[73],re([0,1,17,3,2,36]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function c(m,I){if(!s.has(m)){const _=String(++o);s.set(m,_)}return s.get(m)}function u(m,I,_,O){if(!t.enableDiagnostics)return;const N=c(m,I);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const z=D.VSBuffer.alloc(O.byteLength);z.set(O),t.records.push({timestamp:Date.now(),id:N,label:I,type:_,buff:z})}else t.records.push({timestamp:Date.now(),id:N,label:I,type:_,data:O})}t.traceSocketEvent=u})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function P(){return E||(E=D.VSBuffer.alloc(0)),E}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),I}if(this._chunks[0].byteLength>s){const I=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),I}let c=D.VSBuffer.alloc(s),u=0,m=0;for(;s>0;){const I=this._chunks[m];if(I.byteLength>s){const _=I.slice(0,s);c.set(_,u),u+=s,o&&(this._chunks[m]=I.slice(s),this._totalLength-=s),s-=s}else c.set(I,u),u+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):m++,s-=I.byteLength}return c}}e.ChunkStream=b;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(d||(d={}));function y(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(s,o,c,u){this.type=s,this.id=o,this.ack=c,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends L.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,u=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new S(c,u,m,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const c=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,c}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class w extends L.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new S(1,0,0,s))}}e.Protocol=w;class g extends A.IPCClient{constructor(s,o,c=null){super(s,o,c);this.protocol=s}static fromSocket(s,o){return new g(new w(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class l{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,c=this._first;for(;c;)s[o++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new l(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let u=0;u<a._HISTORY_LENGTH;u++)s-this.lastRuns[u]<=o&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class i{constructor(s,o=null,c=a.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new S(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new S(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new S(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let c=0,u=o.length;c<u;c++)this._socketWriter.write(o[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new S(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let c=0,u=o.length;c<u;c++)this._socketWriter.write(o[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new S(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const o=new S(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&c>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const m=Math.max(2e4-o,2e4-c,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(ie[118],re([0,1,74,3,36,117]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends L.IPCServer{static getOnDidClientConnect(){const C=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,P)=>P);return n.Event.map(C,E=>{const{port1:P,port2:b}=new MessageChannel,y={protocol:new A.Protocol(P),onDidClientDisconnect:n.Event.fromDOMEventEmitter(P,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[b]),y})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ie[119],re([0,1,17,9]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(R,C){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((P,b)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),A(E,R),E.responseType="arraybuffer",E.onerror=d=>b(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=d=>{P({res:{statusCode:E.status,headers:T(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=d=>b(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),C.onCancellationRequested(()=>{E.abort(),b((0,n.canceled)())})})}e.request=L;function A(R,C){if(C.headers){e:for(let E in C.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,C.headers[E])}}}function T(R){const C=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const P=E.indexOf(":");C[E.substr(0,P).trim().toLowerCase()]=E.substr(P+1).trim()}return C}}),define(ie[75],re([0,1,5,3,2,15]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function R(b){const d=b;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var C;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(C||(C={}));class E extends L.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((y,h)=>this.accept(h,y)),d.deleted?.forEach(y=>this.accept(y,void 0))}accept(d,y){if(this.state===C.Closed)return;let h=!1;(0,A.isUndefinedOrNull)(y)?h=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const h=this.cache.get(d);return(0,A.isUndefinedOrNull)(h)?y:h}getBoolean(d,y){const h=this.get(d);return(0,A.isUndefinedOrNull)(h)?y:h==="true"}getNumber(d,y){const h=this.get(d);return(0,A.isUndefinedOrNull)(h)?y:parseInt(h,10)}async set(d,y){if(this.state===C.Closed)return;if((0,A.isUndefinedOrNull)(y))return this.delete(d);const h=String(y);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===C.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,h)=>this.items.set(h,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=P}),define(ie[120],re([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[56],re([0,1,120]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,A=L*24,T=A*7,R=A*30,C=A*365;function E(b,d,y){typeof b!="number"&&(b=b.getTime());const h=Math.round((new Date().getTime()-b)/1e3);if(h<-30)return(0,D.localize)(0,null,E(new Date().getTime()+h*1e3,!1));if(h<30)return(0,D.localize)(1,null);let S;return h<n?(S=h,d?S===1?y?(0,D.localize)(2,null,S):(0,D.localize)(3,null,S):y?(0,D.localize)(4,null,S):(0,D.localize)(5,null,S):S===1?y?(0,D.localize)(6,null,S):(0,D.localize)(7,null,S):y?(0,D.localize)(8,null,S):(0,D.localize)(9,null,S)):h<L?(S=Math.floor(h/n),d?S===1?y?(0,D.localize)(10,null,S):(0,D.localize)(11,null,S):y?(0,D.localize)(12,null,S):(0,D.localize)(13,null,S):S===1?y?(0,D.localize)(14,null,S):(0,D.localize)(15,null,S):y?(0,D.localize)(16,null,S):(0,D.localize)(17,null,S)):h<A?(S=Math.floor(h/L),d?S===1?y?(0,D.localize)(18,null,S):(0,D.localize)(19,null,S):y?(0,D.localize)(20,null,S):(0,D.localize)(21,null,S):S===1?y?(0,D.localize)(22,null,S):(0,D.localize)(23,null,S):y?(0,D.localize)(24,null,S):(0,D.localize)(25,null,S)):h<T?(S=Math.floor(h/A),d?S===1?(0,D.localize)(26,null,S):(0,D.localize)(27,null,S):S===1?(0,D.localize)(28,null,S):(0,D.localize)(29,null,S)):h<R?(S=Math.floor(h/T),d?S===1?y?(0,D.localize)(30,null,S):(0,D.localize)(31,null,S):y?(0,D.localize)(32,null,S):(0,D.localize)(33,null,S):S===1?y?(0,D.localize)(34,null,S):(0,D.localize)(35,null,S):y?(0,D.localize)(36,null,S):(0,D.localize)(37,null,S)):h<C?(S=Math.floor(h/R),d?S===1?y?(0,D.localize)(38,null,S):(0,D.localize)(39,null,S):y?(0,D.localize)(40,null,S):(0,D.localize)(41,null,S):S===1?y?(0,D.localize)(42,null,S):(0,D.localize)(43,null,S):y?(0,D.localize)(44,null,S):(0,D.localize)(45,null,S)):(S=Math.floor(h/C),d?S===1?y?(0,D.localize)(46,null,S):(0,D.localize)(47,null,S):y?(0,D.localize)(48,null,S):(0,D.localize)(49,null,S):S===1?y?(0,D.localize)(50,null,S):(0,D.localize)(51,null,S):y?(0,D.localize)(52,null,S):(0,D.localize)(53,null,S))}e.fromNow=E;function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ie[121],re([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[37],re([0,1,16,15,121]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(E,P){return P&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),T(E.stack)||T(E.stacktrace)):R(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function C(E=null,P=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const b=D.coalesce(E),d=C(b[0],P);return b.length>1?L.localize(4,null,d,b.length):d}if(n.isString(E))return E;if(E.detail){const b=E.detail;if(b.error)return A(b.error,P);if(b.exception)return A(b.exception,P)}return E.stack?A(E,P):E.message?E.message:L.localize(5,null)}e.toErrorMessage=C}),define(ie[122],re([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ie[76],re([0,1,45,41,18,28,10,4,32,103,15,111,22,122]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(r,a){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};a&&(i.cwd=a);const t=D.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,c)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?h(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{D.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,c)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function f(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=f;function v(r=C.env){return r.comspec||"cmd.exe"}e.getWindowsShell=v;class w{constructor(a,i,t,s){if(i!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=i,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(C.env).forEach(c=>{o[c]=C.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const i=a.lastIndexOf(T.sep);return i!==-1&&(a=a.substring(i+1)),w.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(C.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(i=>{let t,s;const o=new Promise((c,u)=>{t=c,s=u});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(u,m,I)=>{this.childProcess=null;const _=u;_&&_.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:I.toString()}):this.handleExec(t,a,u,m,I)})}else{let c=null;const u=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,t,a,s);const I={terminated:this.terminateRequested};P.isNumber(m)&&(I.cmdCode=m),t(I)};if(this.shell&&R.isWindows){const m=A.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let I=!1,_=!1;const O=[];let N=this.ensureQuotes(this.cmd);O.push(N.value),I=N.quoted,this.args&&this.args.forEach(k=>{N=this.ensureQuotes(k),O.push(N.value),_=_&&N.quoted});const z=["/s","/c"];I?_?z.push('"'+O.join(" ")+'"'):O.length>1?z.push('"'+O[0]+'" '+O.slice(1).join(" ")):z.push('"'+O[0]+'"'):z.push(O.join(" ")),c=D.spawn(v(),z,m)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),c.pid&&(this.childProcess.on("close",u),this.handleSpawn(c,t,a,s,!0)))}return o})}handleClose(a,i,t,s){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,S(a,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const i=D.spawn(v(),["/s","/c"]);i.on("error",t=>a(!0)),i.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class g extends w{constructor(a,i,t,s){super(a,i,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,i,t,s,o){[s,o].forEach((c,u)=>{const m=new b.LineDecoder;m.write(c).forEach(O=>{i({line:O,source:u===0?0:1})});const _=m.end();_&&i({line:_,source:u===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,i,t,s,o){const c=new b.LineDecoder,u=new b.LineDecoder;a.stdout.on("data",m=>{c.write(m).forEach(_=>t({line:_,source:0}))}),a.stderr.on("data",m=>{u.write(m).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=u}handleClose(a,i,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=g;function p(r){let a=[],i=!1;const t=function(s){if(i){a.push(s);return}(!r.send(s,c=>{if(c&&console.error(c),i=!1,a.length>0){const u=a.slice(0);a=[],u.forEach(m=>t(m))}})||R.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=p;var l;(function(r){async function a(i,t,s){if(T.isAbsolute(i))return i;if(t===void 0&&(t=C.cwd()),T.dirname(i)!=="."||(s===void 0&&P.isString(C.env.PATH)&&(s=C.env.PATH.split(T.delimiter)),s===void 0||s.length===0))return T.join(t,i);async function c(u){if(await d.Promises.exists(u)){let m;try{m=await d.Promises.stat(u)}catch(I){I.message.startsWith("EACCES")&&(m=await d.Promises.lstat(u))}return m?!m.isDirectory():!1}return!1}for(let u of s){let m;if(T.isAbsolute(u)?m=T.join(u,i):m=T.join(t,u,i),await c(m))return m;let I=m+".com";if(await c(I)||(I=m+".exe",await c(I)))return I}return T.join(t,i)}r.findExecutable=a})(l=e.win32||(e.win32={}))}),define(ie[123],re([0,1,33,4,72,76]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(y,h){return y===1?n.isWindows?b():A.getWindowsShell(h):E(y,h)}e.getSystemShell=T;function R(y,h){return y===1?n.isWindows?d(h):A.getWindowsShell(h):E(y,h)}e.getSystemShellSync=R;let C=null;function E(y,h){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!C){let S;if(n.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,D.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}C=S}return C}let P=null;async function b(){return P||(P=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),P}function d(y){if(P)return P;const h=n.isWindows&&parseFloat((0,D.release)())>=10,S=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${y.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?f:A.getWindowsShell(y)}}),define(ie[57],re([0,1,45,5,17,25,107,9,3,2,28,76,36]),function(J,e,D,n,L,A,T,R,C,E,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends d.ChannelServer{constructor(f){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",v=>L.VSBuffer.wrap(Buffer.from(v,"base64")))},f);process.once("disconnect",()=>this.dispose())}}e.Server=y;class h{constructor(f,v){this.modulePath=f,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(f){const v=this;return{call(w,g,p){return v.requestPromise(f,w,g,p)},listen(w,g){return v.requestEvent(f,w,g)}}}requestPromise(f,v,w,g=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const p=this.getCachedChannel(f),l=(0,n.createCancelablePromise)(i=>p.call(v,w,i)),r=g.onCancellationRequested(()=>l.cancel()),a=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(f,v,w){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let g;const p=new C.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(f).listen(v,w)(p.fire,p),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return p.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,b.removeDangerousEnvVariables)(v.env),this.child=(0,D.fork)(this.modulePath,f,v);const w=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,T.isRemoteConsoleLog)(t)){(0,T.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(t,"base64")))});const p=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&p.send(t.buffer.toString("base64")),r=w.event,a={send:l,onMessage:r};this._client=new d.ChannelClient(a);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",i),this.activeRequests.forEach(o=>(0,E.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(f){let v=this.channels.get(f);return v||(v=this.client.getChannel(f),this.channels.set(f,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(ie[124],re([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ie[125],re([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[126],re([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ie[127],re([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ie[128],re([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(ie[129],re([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[130],re([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[131],re([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ie[132],re([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[133],re([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[134],re([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ie[135],re([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[136],re([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[137],re([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ie[138],re([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[139],re([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[140],re([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[141],re([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[142],re([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ie[143],re([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ie[144],re([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ie[145],re([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ie[146],re([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ie[147],re([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ie[148],re([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ie[149],re([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(T){T.Team="team",T.Internal="internal",T.Insiders="insider",T.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(T){T.Market="X-MSEdge-Market",T.CorpNet="X-FD-Corpnet",T.ApplicationVersion="X-VSCode-AppVersion",T.Build="X-VSCode-Build",T.ClientId="X-MSEdge-ClientId",T.ExtensionName="X-VSCode-ExtensionName",T.Language="X-VSCode-Language",T.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class A{constructor(R,C,E,P){this.version=R,this.appName=C,this.machineId=E,this.targetPopulation=P}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return D.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,C=Object.values(L);for(let E of C)R.set(E,this.getFilterValue(E));return R}}e.AssignmentFilterProvider=A}),define(ie[77],re([0,1,56,53,18,10,32,19,7]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(S,f,v){this._args=S,this.paths=f,this.productService=v}get appRoot(){return(0,A.dirname)(L.FileAccess.asFileUri("",J).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(C.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=T.env.VSCODE_PORTABLE;return S?C.URI.file((0,A.join)(S,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,A.resolve)(S):(0,A.normalize)((0,A.join)(L.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,A.resolve)(S):(0,A.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,A.resolve)(S);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const v=T.env.VSCODE_PORTABLE;return v?(0,A.join)(v,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(f=>/^[^:/?#]+?:\/\//.test(f)?C.URI.parse(f):C.URI.file((0,A.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?C.URI.parse(S):C.URI.file((0,A.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],E.prototype,"appRoot",null),de([n.memoize],E.prototype,"userHome",null),de([n.memoize],E.prototype,"userDataPath",null),de([n.memoize],E.prototype,"appSettingsHome",null),de([n.memoize],E.prototype,"tmpDir",null),de([n.memoize],E.prototype,"cacheHome",null),de([n.memoize],E.prototype,"userRoamingDataHome",null),de([n.memoize],E.prototype,"settingsResource",null),de([n.memoize],E.prototype,"userDataSyncHome",null),de([n.memoize],E.prototype,"userDataSyncLogResource",null),de([n.memoize],E.prototype,"sync",null),de([n.memoize],E.prototype,"machineSettingsResource",null),de([n.memoize],E.prototype,"globalStorageHome",null),de([n.memoize],E.prototype,"workspaceStorageHome",null),de([n.memoize],E.prototype,"keybindingsResource",null),de([n.memoize],E.prototype,"keyboardLayoutResource",null),de([n.memoize],E.prototype,"argvResource",null),de([n.memoize],E.prototype,"snippetsHome",null),de([n.memoize],E.prototype,"isExtensionDevelopment",null),de([n.memoize],E.prototype,"untitledWorkspacesHome",null),de([n.memoize],E.prototype,"installSourcePath",null),de([n.memoize],E.prototype,"builtinExtensionsPath",null),de([n.memoize],E.prototype,"extensionsPath",null),de([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],E.prototype,"extensionDevelopmentKind",null),de([n.memoize],E.prototype,"extensionTestsLocationURI",null),de([n.memoize],E.prototype,"debugExtensionHost",null),de([n.memoize],E.prototype,"serviceMachineIdResource",null),de([n.memoize],E.prototype,"telemetryLogResource",null),de([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function P(h,S){return y(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=P;function b(h,S){return y(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=b;function d(h,S){return y(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=d;function y(h,S,f,v,w,g){const l=Number(S||h)||(v?null:f),r=l?Boolean(!!S):!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:l,break:r,debugId:w,env:a}}}),define(ie[150],re([0,1,250,4,126]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,S,f=T){const v={},w=[],g=[];for(let a in S){const i=S[a];i.alias&&(v[a]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(a),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(g.push(a),i.deprecates&&g.push(...i.deprecates))}const p=D(h,{string:w,boolean:g,alias:v}),l={},r=p;l._=p._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in S){const i=S[a];i.alias&&delete r[i.alias];let t=r[a];if(i.deprecates)for(const s of i.deprecates)r.hasOwnProperty(s)&&(t||(t=r[s],t&&f.onDeprecatedOption(s,i.deprecationMessage||(0,L.localize)(33,null))),delete r[s]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),f.onMultipleValues(a,t)),l[a]=t,i.deprecationMessage&&f.onDeprecatedOption(a,i.deprecationMessage)),delete r[a]}for(let a in r)f.onUnknownOption(a);return l}e.parseArgs=R;function C(h,S){let f="";return S.args&&(Array.isArray(S.args)?f=` <${S.args.join("> <")}>`:f=` <${S.args}>`),S.alias?`-${S.alias} --${h}${f}`:`--${h}${f}`}function E(h,S){let f=0,v=[];for(const l in h){const r=h[l],a=C(l,r);f=Math.max(f,a.length),v.push([a,r.description])}let w=f+2+1;if(S-w<25)return v.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=S-w-1,p=[];for(const l of v){let r=l[0],a=b(l[1],g),i=P(w-r.length-2);p.push("  "+r+i+a[0]);for(let t=1;t<a.length;t++)p.push(P(w)+a[t])}return p}e.formatOptions=E;function P(h){return" ".repeat(h)}function b(h,S){let f=[];for(;h.length;){let v=h.length<S?h.length:h.lastIndexOf(" ",S),w=h.slice(0,v).trim();h=h.slice(v),f.push(w)}return f}function d(h,S,f,v,w){const g=process.stdout.isTTY&&process.stdout.columns||80,p=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",l=[`${h} ${f}`];l.push(""),l.push(`${(0,L.localize)(35,null)}: ${S} [${(0,L.localize)(36,null)}]${p}`),l.push(""),w?.noPipe!==!0&&(n.isWindows?l.push((0,L.localize)(37,null,S)):l.push((0,L.localize)(38,null,S)),l.push(""));const r={};for(const a in v){const i=v[a];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[a]=i}}for(let a in r){const i=a;let t=r[i];t&&(l.push(A[i]),l.push(...E(t,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=d;function y(h,S){return`${h||(0,L.localize)(39,null)}
${S||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),function(){"use strict";function J(e,D,n,L){function A(R){const C=T(R),E=[C];return e.isAbsolute(C)||E.unshift(L),e.resolve(...E)}function T(R){const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(b,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:A}}if(typeof define=="function")define(ie[151],re([0,152,33,18,19,32]),function(e,D,n,L,A,T){const R=A.dirname(L.FileAccess.asFileUri("",e)),C=e.__$__nodeRequire(A.joinPath(R,"package.json").fsPath);return J(D,n,C.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=J(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[153],re([0,1,33,77,151]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends n.AbstractNativeEnvironmentService{constructor(R,C){super(R,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},C)}}e.NativeEnvironmentService=A}),define(ie[154],re([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(f){const v=f.match(T);return v?v[1]:null}function P(f){if(f.indexOf("://")===-1){const v=f.match(n);return v?E(v[2]):null}try{const v=D.URI.parse(f);if(v.authority)return E(v.authority)}catch{}return null}function b(f,v){const w=new Set;let g;for(;g=R.exec(f);){const l=P(g[1]);l&&w.add(l)}const p=new Set(v);return Array.from(w).map(l=>p.has(l)?l:l.replace(C,"a"))}e.getDomainsOfRemotes=b;function d(f){const v=f.match(A);return v?v[2]:null}function y(f,v,w){return f&&v?(w&&v.endsWith(".git")&&(v=v.substr(0,v.length-4)),v.indexOf("/")===0?`${f}${v}`:`${f}/${v}`):null}function h(f,v){if(f.indexOf("://")===-1){const w=f.match(L);if(w)return y(w[2],w[3],v)}try{const w=D.URI.parse(f);if(w.authority)return y(d(w.authority),w.path,v)}catch{}return null}function S(f,v=!1){const w=[];let g;for(;g=R.exec(f);){const p=h(g[1],v);p&&w.push(p)}return w}e.getRemotes=S}),define(ie[155],re([0,1,28]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function L(A,T){const R=C=>{if(typeof C!="string")return;const E=n.exec(C);if(!E)return;const P=T[E[1]]??C;return typeof P=="string"?P:typeof P.message=="string"?P.message:C};return(0,D.cloneAndChange)(A,R)}e.localizeManifest=L}),define(ie[156],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,T,R,C){return this.channel.call("promptImportantExtensionsInstallNotification",[A,T,R,C])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(A){this.service=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ie[78],re([0,1,135]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function A(d){return d=d.trim(),d==="*"||n.test(d)}e.isValidVersionStr=A;function T(d){if(!A(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(n);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=T;function R(d){if(!d)return null;let y=d.majorBase,h=d.majorMustEqual,S=d.minorBase,f=d.minorMustEqual,v=d.patchBase,w=d.patchMustEqual;d.hasCaret&&(y===0||(f=!1),w=!1);let g=0;if(d.preRelease){const p=L.exec(d.preRelease);if(p){const[,l,r,a]=p;g=Date.UTC(Number(l),Number(r)-1,Number(a))}}return{majorBase:y,majorMustEqual:h,minorBase:S,minorMustEqual:f,patchBase:v,patchMustEqual:w,isMinimum:d.hasGreaterEquals,notBefore:g}}e.normalizeVersion=R;function C(d,y,h){let S;typeof d=="string"?S=R(T(d)):S=d;let f;y instanceof Date?f=y.getTime():typeof y=="string"&&(f=new Date(y).getTime());let v;if(typeof h=="string"?v=R(T(h)):v=h,!S||!v)return!1;let w=S.majorBase,g=S.minorBase,p=S.patchBase,l=v.majorBase,r=v.minorBase,a=v.patchBase,i=v.notBefore,t=v.majorMustEqual,s=v.minorMustEqual,o=v.patchMustEqual;return v.isMinimum?w>l?!0:w<l?!1:g>r?!0:g<r||f&&f<i?!1:p>=a:(w===1&&l===0&&(!t||!s||!o)&&(l=1,r=0,a=0,t=!0,s=!1,o=!1),w<l?!1:w>l?!t:g<r?!1:g>r?!s:p<a?!1:p>a?!o:!(f&&f<i))}e.isValidVersion=C;function E(d,y,h,S){return h.isBuiltin||typeof h.main=="undefined"?!0:b(d,y,h.engines.vscode,S)}e.isValidExtensionVersion=E;function P(d,y,h){return d==="*"||b(y,h,d)}e.isEngineValid=P;function b(d,y,h,S=[]){let f=R(T(h));if(!f)return S.push(D.localize(0,null,h)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return S.push(D.localize(1,null,h)),!1}else if(!f.majorMustEqual)return S.push(D.localize(2,null,h)),!1;return C(d,y,f)?!0:(S.push(D.localize(3,null,d,h)),!1)}}),define(ie[51],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(L,A=[],T=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(ie[79],re([0,1,51]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function L(T,R,C){R instanceof D.SyncDescriptor||(R=new D.SyncDescriptor(R,[],C)),n.push([T,R])}e.registerSingleton=L;function A(){return n}e.getSingletonServiceDescriptors=A}),define(ie[157],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=D;class n{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const R=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),C),C.incoming.set(this._hashFn(A),R)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let R=this._nodes.get(T);return R||(R=new D(A),this._nodes.set(T,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[T,R]of this._nodes)A.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,T]of this._nodes){const R=new Set([A]),C=this._findCycle(T,R);if(C)return C}}_findCycle(A,T){for(let[R,C]of A.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const E=this._findCycle(C,T);if(E)return E;T.delete(R)}}}e.Graph=n}),define(ie[6],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(D=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(T,R,C,E){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:T,index:C,optional:E}):(R[D.DI_DEPENDENCIES]=[{id:T,index:C,optional:E}],R[D.DI_TARGET]=R)}function L(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const R=function(C,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,C,P,!1)};return R.toString=()=>T,D.serviceIds.set(T,R),R}e.createDecorator=L;function A(T){return T}e.refineServiceDecorator=A}),define(ie[158],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ie[20],re([0,1,15,7,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof n.URI)}e.isConfigurationOverrides=A;function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||D.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function E(f,v){const w=Object.create(null);for(let g in f)P(w,g,f[g],v);return w}e.toValuesTree=E;function P(f,v,w,g){const p=v.split("."),l=p.pop();let r=f;for(let a=0;a<p.length;a++){let i=p[a],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${v} as ${p.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{g(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function b(f,v){const w=v.split(".");d(f,w)}e.removeFromValueTree=b;function d(f,v){const w=v.shift();if(v.length===0){delete f[w];return}if(Object.keys(f).indexOf(w)!==-1){const g=f[w];typeof g=="object"&&!Array.isArray(g)&&(d(g,v),Object.keys(g).length===0&&delete f[w])}}function y(f,v,w){function g(r,a){let i=r;for(const t of a){if(typeof i!="object"||i===null)return;i=i[t]}return i}const p=v.split("."),l=g(f,p);return typeof l=="undefined"?w:l}e.getConfigurationValue=y;function h(f,v,w){Object.keys(v).forEach(g=>{g!=="__proto__"&&(g in f?D.isObject(f[g])&&D.isObject(v[g])?h(f[g],v[g],w):w&&(f[g]=v[g]):f[g]=v[g])})}e.merge=h;function S(f,v,w){const g=f.inspect(v),p=f.inspect(w);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:g.defaultValue}e.getMigratedSettingValue=S}),define(ie[159],re([0,1,4,27,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=D.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",A.indexOf("Edg/")>=0),T.set("isFirefox",A.indexOf("Firefox")>=0),T.set("isChrome",A.indexOf("Chrome")>=0),T.set("isSafari",A.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var C;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return d.INSTANCE}static true(){return y.INSTANCE}static has(k){return h.create(k)}static equals(k,M){return S.create(k,M)}static notEquals(k,M){return w.create(k,M)}static regex(k,M){return t.create(k,M)}static in(k,M){return f.create(k,M)}static not(k){return g.create(k)}static and(...k){return c.create(k,null)}static or(...k){return u.create(k,null,!0)}static greater(k,M){return l.create(k,M)}static greaterEquals(k,M){return r.create(k,M)}static smaller(k,M){return a.create(k,M)}static smallerEquals(k,M){return i.create(k,M)}static deserialize(k,M=!1){if(!!k)return this._deserializeOrExpression(k,M)}static _deserializeOrExpression(k,M){let j=k.split("||");return u.create(j.map(U=>this._deserializeAndExpression(U,M)),null,!0)}static _deserializeAndExpression(k,M){let j=k.split("&&");return c.create(j.map(U=>this._deserializeOne(U,M)),null)}static _deserializeOne(k,M){if(k=k.trim(),k.indexOf("!=")>=0){let j=k.split("!=");return w.create(j[0].trim(),this._deserializeValue(j[1],M))}if(k.indexOf("==")>=0){let j=k.split("==");return S.create(j[0].trim(),this._deserializeValue(j[1],M))}if(k.indexOf("=~")>=0){let j=k.split("=~");return t.create(j[0].trim(),this._deserializeRegexValue(j[1],M))}if(k.indexOf(" in ")>=0){let j=k.split(" in ");return f.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const j=k.split(">=");return r.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const j=k.split(">");return l.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const j=k.split("<=");return i.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const j=k.split("<");return a.create(j[0].trim(),j[1].trim())}return/^\!\s*/.test(k)?g.create(k.substr(1).trim()):h.create(k)}static _deserializeValue(k,M){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let j=/^'([^']*)'$/.exec(k);return j?j[1].trim():k}static _deserializeRegexValue(k,M){if((0,n.isFalsyOrWhitespace)(k)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let j=k.indexOf("/"),U=k.lastIndexOf("/");if(j===U||j<0){if(M)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let G=k.slice(j+1,U),K=k[U+1]==="i"?"i":"";try{return new RegExp(G,K)}catch(x){if(M)throw new Error(`bad regexp-value '${k}', parse error: ${x}`);return console.warn(`bad regexp-value '${k}', parse error: ${x}`),null}}}e.ContextKeyExpr=E;function P(z,k){const M=z?z.substituteConstants():void 0,j=k?k.substituteConstants():void 0;return!M&&!j?!0:!M||!j?!1:M.equals(j)}e.expressionsAreEqualWithConstantSubstitution=P;function b(z,k){return z.cmp(k)}class d{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class y{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class h{constructor(k,M){this.key=k,this.negated=M,this.type=2}static create(k,M=null){const j=T.get(k);return typeof j=="boolean"?j?y.INSTANCE:d.INSTANCE:new h(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:I(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?y.INSTANCE:d.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class S{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=4}static create(k,M,j=null){if(typeof M=="boolean")return M?h.create(k,j):g.create(k,j);const U=T.get(k);return typeof U=="boolean"?M===(U?"true":"false")?y.INSTANCE:d.INSTANCE:new S(k,M,j)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?y.INSTANCE:d.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class f{constructor(k,M){this.key=k,this.valueKey=M,this.type=10,this.negated=null}static create(k,M){return new f(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.valueKey),j=k.getValue(this.key);return Array.isArray(M)?M.indexOf(j)>=0:typeof j=="string"&&typeof M=="object"&&M!==null?R.call(M,j):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=f;class v{constructor(k){this._actual=k,this.type=11}static create(k){return new v(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new v(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class w{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=5}static create(k,M,j=null){if(typeof M=="boolean")return M?g.create(k,j):h.create(k,j);const U=T.get(k);return typeof U=="boolean"?M===(U?"true":"false")?d.INSTANCE:y.INSTANCE:new w(k,M,j)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?d.INSTANCE:y.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class g{constructor(k,M){this.key=k,this.negated=M,this.type=3}static create(k,M=null){const j=T.get(k);return typeof j=="boolean"?j?d.INSTANCE:y.INSTANCE:new g(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:I(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?d.INSTANCE:y.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function p(z,k){if(typeof z=="string"){const M=parseFloat(z);isNaN(M)||(z=M)}return typeof z=="string"||typeof z=="number"?k(z):d.INSTANCE}class l{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=12}static create(k,M,j=null){return p(M,U=>new l(k,U,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=13}static create(k,M,j=null){return p(M,U=>new r(k,U,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=14}static create(k,M,j=null){return p(M,U=>new a(k,U,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class i{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=15}static create(k,M,j=null){return p(M,U=>new i(k,U,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(k,M){this.key=k,this.regexp=M,this.type=7,this.negated=null}static create(k,M){return new t(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const M=this.regexp?this.regexp.source:"",j=k.regexp?k.regexp.source:"";return M<j?-1:M>j?1:0}equals(k){if(k.type===this.type){const M=this.regexp?this.regexp.source:"",j=k.regexp?k.regexp.source:"";return this.key===k.key&&M===j}return!1}substituteConstants(){return this}evaluate(k){let M=k.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(k){this._actual=k,this.type=8}static create(k){return new s(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new s(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o(z){let k=null;for(let M=0,j=z.length;M<j;M++){const U=z[M].substituteConstants();if(z[M]!==U&&k===null){k=[];for(let G=0;G<M;G++)k[G]=z[G]}k!==null&&(k[M]=U)}return k===null?z:k}class c{constructor(k,M){this.expr=k,this.negated=M,this.type=6}static create(k,M){return c._normalizeArr(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,j=this.expr.length;M<j;M++){const U=b(this.expr[M],k.expr[M]);if(U!==0)return U}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,j=this.expr.length;M<j;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:c.create(k,this.negated)}evaluate(k){for(let M=0,j=this.expr.length;M<j;M++)if(!this.expr[M].evaluate(k))return!1;return!0}static _normalizeArr(k,M){const j=[];let U=!1;for(const G of k)if(!!G){if(G.type===1){U=!0;continue}if(G.type===0)return d.INSTANCE;if(G.type===6){j.push(...G.expr);continue}j.push(G)}if(j.length===0&&U)return y.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(b);for(let G=1;G<j.length;G++)j[G-1].equals(j[G])&&(j.splice(G,1),G--);if(j.length===1)return j[0];for(;j.length>1;){const G=j[j.length-1];if(G.type!==9)break;j.pop();const K=j.pop(),x=j.length===0,W=u.create(G.expr.map(X=>c.create([X,K],null)),null,x);W&&(j.push(W),j.sort(b))}return j.length===1?j[0]:new c(j,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let M of this.expr)k.push(...M.keys());return k}map(k){return new c(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(let M of this.expr)k.push(M.negate());this.negated=u.create(k,this,!0)}return this.negated}}class u{constructor(k,M){this.expr=k,this.negated=M,this.type=9}static create(k,M,j){return u._normalizeArr(k,M,j)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,j=this.expr.length;M<j;M++){const U=b(this.expr[M],k.expr[M]);if(U!==0)return U}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,j=this.expr.length;M<j;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:u.create(k,this.negated,!1)}evaluate(k){for(let M=0,j=this.expr.length;M<j;M++)if(this.expr[M].evaluate(k))return!0;return!1}static _normalizeArr(k,M,j){let U=[],G=!1;if(k){for(let K=0,x=k.length;K<x;K++){const W=k[K];if(!!W){if(W.type===0){G=!0;continue}if(W.type===1)return y.INSTANCE;if(W.type===9){U=U.concat(W.expr);continue}U.push(W)}}if(U.length===0&&G)return d.INSTANCE;U.sort(b)}if(U.length!==0){if(U.length===1)return U[0];for(let K=1;K<U.length;K++)U[K-1].equals(U[K])&&(U.splice(K,1),K--);if(U.length===1)return U[0];if(j){for(let K=0;K<U.length;K++)for(let x=K+1;x<U.length;x++)O(U[K],U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0]}return new u(U,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let M of this.expr)k.push(...M.keys());return k}map(k){return new u(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){let k=[];for(let M of this.expr)k.push(M.negate());for(;k.length>1;){const M=k.shift(),j=k.shift(),U=[];for(const K of N(M))for(const x of N(j))U.push(c.create([K,x],null));const G=k.length===0;k.unshift(u.create(U,null,G))}this.negated=k[0]}return this.negated}}class m extends h{constructor(k,M,j){super(k,null);this._defaultValue=M,typeof j=="object"?m._info.push({...j,key:k}):j!==!0&&m._info.push({key:k,description:j,type:M!=null?typeof M:void 0})}static all(){return m._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return S.create(this.key,k)}notEqualsTo(k){return w.create(this.key,k)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I(z,k){return z<k?-1:z>k?1:0}function _(z,k,M,j){return z<M?-1:z>M?1:k<j?-1:k>j?1:0}function O(z,k){if(k.type===6&&z.type!==9&&z.type!==6){for(const U of k.expr)if(z.equals(U))return!0}const M=z.negate(),j=N(M).concat(N(k));j.sort(b);for(let U=0;U<j.length;U++){const K=j[U].negate();for(let x=U+1;x<j.length;x++){const W=j[x];if(K.equals(W))return!0}}return!1}e.implies=O;function N(z){return z.type===9?z.expr:[z]}}),define(ie[80],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n}),define(ie[81],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ie[13],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[30],re([0,1,18,130,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var A;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));function T(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function R(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(g,p){switch(g){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function E(g,p){return p==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function P(g,p,l){return E(p,l)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===l?!0:b(l).includes(g)}e.isTargetPlatformCompatible=P;function b(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function d(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=d;var y;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var S;(function(g){g.Install="install",g.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var f;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var v;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(p,l){super(p);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(ie[160],re([0,1,3,2,28,7,110,30]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(S,f){return A.URI.revive(f?f.transformIncoming(S):S)}function E(S,f){return f?f.transformOutgoingURI(S):S}function P(S,f){f=f||T.DefaultURITransformer;const v=S.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...S,manifest:void 0},f),manifest:v}}function b(S,f){return f?(0,L.cloneAndChange)(S,v=>v instanceof A.URI?f.transformOutgoingURI(v):void 0):S}class d{constructor(f,v){this.service=f,this.getUriTransformer=v,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,v){const w=this.getUriTransformer(f);switch(v){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,g=>g.map(p=>({...p,local:p.local?b(p.local,w):p.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,v,w){const g=this.getUriTransformer(f);switch(v){case"zip":return this.service.zip(P(w[0],g)).then(p=>E(p,g));case"unzip":return this.service.unzip(C(w[0],g));case"install":return this.service.install(C(w[0],g),w[1]);case"getManifest":return this.service.getManifest(C(w[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],g),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],g));case"getInstalled":return this.service.getInstalled(w[0]).then(p=>p.map(l=>b(l,g)));case"updateMetadata":return this.service.updateMetadata(P(w[0],g),w[1]).then(p=>b(p,g));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],g),w[1]).then(p=>b(p,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class y extends n.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(v=>this._onInstallExtension.fire({identifier:v.identifier,source:this.isUriComponents(v.source)?A.URI.revive(v.source):v.source}))),this._register(this.channel.listen("onDidInstallExtensions")(v=>this._onDidInstallExtensions.fire(v.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?A.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(v=>this._onUninstallExtension.fire(v))),this._register(this.channel.listen("onDidUninstallExtension")(v=>this._onDidUninstallExtension.fire(v)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const v=await this.getTargetPlatform();return f.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,f.allTargetPlatforms,v))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(v=>A.URI.revive(v)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,v){return Promise.resolve(this.channel.call("install",[f,v])).then(w=>P(w,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,v){return Promise.resolve(this.channel.call("installFromGallery",[f,v])).then(w=>P(w,null))}uninstall(f,v){return Promise.resolve(this.channel.call("uninstall",[f,v]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(v=>v.map(w=>P(w,null)))}updateMetadata(f,v){return Promise.resolve(this.channel.call("updateMetadata",[f,v])).then(w=>P(w,null))}updateExtensionScope(f,v){return Promise.resolve(this.channel.call("updateExtensionScope",[f,v])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class h{constructor(f){this.service=f}listen(f,v){throw new Error("Invalid listen")}call(f,v,w){switch(v){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(ie[82],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function L(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ie[14],re([0,1,39,10,27,15,7,137,6]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var P;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var d;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=y;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function f(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=f;function v(U){return y(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(G,K){super(G);this.code=K}}e.FileSystemProviderError=g;function p(U,G){const K=new g(U.toString(),G);return r(K,G),K}e.createFileSystemProviderError=p;function l(U){return U||p((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function r(U,G){return U.name=G?`${G} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=r;function a(U){if(!U)return w.Unknown;if(U instanceof g)return U.code;const G=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!G)return w.Unknown;switch(G[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=a;function i(U){if(U instanceof m)return U.fileOperationResult;switch(a(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor(G,K,x){this.resource=G,this.operation=K,this.target=x}isOperation(G){return this.operation===G}}e.FileOperationEvent=s;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class c{constructor(G,K){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const x=new Map;for(const W of G){const X=x.get(W.type);switch(X?X.push([W.resource,W]):x.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,X]of x)switch(W){case 1:this.added=D.TernarySearchTree.forUris(()=>K),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>K),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>K),this.deleted.fill(X);break}}contains(G,...K){return this.doContains(G,{includeChildren:!1},...K)}affects(G,...K){return this.doContains(G,{includeChildren:!0},...K)}doContains(G,K,...x){if(!G)return!1;const W=x.length>0;return!!((!W||x.includes(1))&&(this.added?.get(G)||K.includeChildren&&this.added?.findSuperstr(G))||(!W||x.includes(0))&&(this.updated?.get(G)||K.includeChildren&&this.updated?.findSuperstr(G))||(!W||x.includes(2))&&(this.deleted?.findSubstr(G)||K.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function u(U,G,K){return!U||!G||U===G||G.length>U.length?!1:(G.charAt(G.length-1)!==n.sep&&(G+=n.sep),K?(0,L.startsWithIgnoreCase)(U,G):U.indexOf(G)===0)}e.isParent=u;class m extends Error{constructor(G,K,x){super(G);this.fileOperationResult=K,this.options=x}}e.FileOperationError=m;class I extends m{constructor(G,K,x){super(G,2,x);this.stat=K}}e.NotModifiedSinceFileOperationError=I;var _;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=N;async function z(U,G){if(!G.hasProvider(T.URI.from({scheme:U.scheme})))return new Promise(K=>{const x=G.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===U.scheme&&W.added&&(x.dispose(),K())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class k{static formatSize(G){return(0,A.isNumber)(G)||(G=0),G<k.KB?(0,R.localize)(1,null,G.toFixed(0)):G<k.MB?(0,R.localize)(2,null,(G/k.KB).toFixed(2)):G<k.GB?(0,R.localize)(3,null,(G/k.MB).toFixed(2)):G<k.TB?(0,R.localize)(4,null,(G/k.GB).toFixed(2)):(0,R.localize)(5,null,(G/k.TB).toFixed(2))}}e.ByteSize=k,k.KB=1024,k.MB=k.KB*k.KB,k.GB=k.MB*k.KB,k.TB=k.GB*k.KB;var M;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function j(U){return{maxFileSize:U===0?300*k.MB:16*k.GB,maxHeapSize:U===0?700*k.MB:2*700*k.MB}}e.getPlatformLimits=j});var Y=this&&this.__param||function(J,e){return function(D,n){e(D,n,J)}};define(ie[161],re([0,1,83,40,14]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.fileService=R}async checksum(R){const C=(await this.fileService.readFileStream(R)).value;return new Promise((E,P)=>{const b=(0,D.createHash)("md5");(0,n.listenStream)(C,{onData:d=>b.update(d.buffer),onError:d=>P(d),onEnd:()=>E(b.digest("base64").replace(/=+$/,""))})})}};A=de([Y(0,L.IFileService)],A),e.ChecksumService=A}),define(ie[162],re([0,1,251,127,150,14]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function T(d,y){const h={onUnknownOption:f=>{console.warn((0,n.localize)(0,null,f))},onMultipleValues:(f,v)=>{console.warn((0,n.localize)(1,null,f,v))},onDeprecatedOption:(f,v)=>{console.warn((0,n.localize)(2,null,f,v))}},S=(0,L.parseArgs)(d,L.OPTIONS,y?h:void 0);return S.goto&&S._.forEach(f=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,n.localize)(3,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function R(d){const y=d.findIndex(h=>!/^-/.test(h));if(y>-1)return[...d.slice(0,y),...d.slice(y+1)]}function C(d){let[,...y]=d;process.env.VSCODE_DEV&&(y=R(y)||[]);const h=!b(process.env);return T(y,h)}e.parseMainProcessArgv=C;function E(d){const[,,...y]=d;return T(y,!0)}e.parseCLIProcessArgv=E;function P(d,...y){const h=d.indexOf("--");return h===-1?d.push(...y):d.splice(h,0,...y),d}e.addArg=P;function b(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(ie[163],re([0,1,45,10,128,25,37,9,4,29,123,162,5]),function(J,e,D,n,L,A,T,R,C,E,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let h;async function S(v,w,g){return w["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(g)&&!w["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(g)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(p,l)=>{const r=new A.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),l(new Error((0,L.localize)(0,null)))},y);try{p(await f(v,r.token))}catch(i){!(0,R.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,L.localize)(1,null,(0,T.toErrorMessage)(i)))):p({})}finally{clearTimeout(a),r.dispose()}})),h)}e.getResolvedShellEnv=S;async function f(v,w){const g=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",g);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",p);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",a);const i=await(0,P.getSystemShell)(C.OS,a);return v.trace("getUnixShellEnvironment#shell",i),new Promise((t,s)=>{if(w.isCancellationRequested)return s((0,R.canceled)());const o=(0,n.basename)(i);let c,u;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${m} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,u=["-Login","-Command"]):(c=`'${process.execPath}' ${m} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?u=["-ic"]:u=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),c);const I=(0,D.spawn)(i,[...u,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(I.kill(),s((0,R.canceled)()))),I.on("error",N=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(N)),s(N)});const _=[];I.stdout.on("data",N=>_.push(N));const O=[];I.stderr.on("data",N=>O.push(N)),I.on("close",(N,z)=>{const k=Buffer.concat(_).toString("utf8");v.trace("getUnixShellEnvironment#raw",k);const M=Buffer.concat(O).toString("utf8");if(M.trim()&&v.trace("getUnixShellEnvironment#stderr",M),N||z)return s(new Error((0,L.localize)(2,null,N,z)));const j=r.exec(k),U=j?j[1]:"{}";try{const G=JSON.parse(U);g?G.ELECTRON_RUN_AS_NODE=g:delete G.ELECTRON_RUN_AS_NODE,p?G.ELECTRON_NO_ATTACH_CONSOLE=p:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){v.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(G)),s(G)}})})}}),define(ie[164],re([0,1,17,37,9,3,2,40,7,29,14]),function(J,e,D,n,L,A,T,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends T.Disposable{constructor(y,h){super();this.channel=y,this.extraCapabilities=h,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,h){const{buffer:S}=await this.channel.call("readFile",[y,h]);return S}readFileStream(y,h,S){const f=(0,R.newWriteableStream)(w=>D.VSBuffer.concat(w.map(g=>D.VSBuffer.wrap(g))).buffer),v=this.channel.listen("readFileStream",[y,h])(w=>{if(w instanceof D.VSBuffer)f.write(w.buffer);else{if(w==="end")f.end();else{let g=w;g instanceof Error||(g=(0,P.createFileSystemProviderError)((0,n.toErrorMessage)(g),P.FileSystemProviderErrorCode.Unknown)),f.error(g),f.end()}v.dispose()}});return S.onCancellationRequested(()=>{f.error((0,L.canceled)()),f.end(),v.dispose()}),f}writeFile(y,h,S){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(h),S])}open(y,h){return this.channel.call("open",[y,h])}close(y){return this.channel.call("close",[y])}async read(y,h,S,f,v){const[w,g]=await this.channel.call("read",[y,h,v]);return S.set(w.buffer.slice(0,g),f),g}write(y,h,S,f,v){return this.channel.call("write",[y,h,D.VSBuffer.wrap(S),f,v])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,h){return this.channel.call("delete",[y,h])}rename(y,h,S){return this.channel.call("rename",[y,h,S])}copy(y,h,S){return this.channel.call("copy",[y,h,S])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const h=y;this._onDidChange.fire(h.map(S=>({resource:C.URI.revive(S.resource),type:S.type})))}else{const h=y;this._onDidWatchError.fire(h)}}))}watch(y,h){const S=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,S,y,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=b}),define(ie[84],re([0,1,17,9,138,14]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,b,d,y,h,S){let f;try{await R(P,b,d,y,h,S)}catch(v){f=v}finally{f&&h.errorTransformer&&(f=h.errorTransformer(f)),typeof f!="undefined"&&d.error(f),d.end()}}e.readFileIntoStream=T;async function R(P,b,d,y,h,S){C(S);const f=await P.open(b,{create:!1});try{C(S);let v=0,w=0,g=h&&typeof h.length=="number"?h.length:void 0,p=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,r=0;do w=await P.read(f,l,p.buffer,r,p.byteLength-r),l+=w,r+=w,v+=w,typeof g=="number"&&(g-=w),r===p.byteLength&&(await d.write(y(p)),p=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),r=0);while(w>0&&(typeof g!="number"||g>0)&&C(S)&&E(v,h));if(r>0){let a=r;typeof g=="number"&&(a=Math.min(r,g)),d.write(y(p.slice(0,a)))}}catch(v){throw(0,A.ensureFileSystemProviderError)(v)}finally{await P.close(f)}}function C(P){if(P.isCancellationRequested)throw(0,n.canceled)();return!0}function E(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,A.createFileSystemProviderError)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,A.createFileSystemProviderError)((0,L.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[58],re([0,1,2,4,7,14]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class T extends D.Disposable{constructor(b,d,y){super();this.onFileChanges=b,this.onLogMessage=d,this.verboseLogging=y,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const b=new D.DisposableStore;this.watcherDisposables.value=b,this.watcher=this.createWatcher(b),this.watcher.setVerboseLogging(this.verboseLogging),b.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),b.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),b.add(this.watcher.onDidError(d=>this.onError(d)))}onError(b){this.restartCounter<T.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${b}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${b}`)}restart(b){this.restartCounter++,this.init(),this.watch(b)}async watch(b){this.requests=b,await this.watcher?.watch(b)}async setVerboseLogging(b){this.verboseLogging=b,await this.watcher?.setVerboseLogging(b)}error(b){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${b}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=T,T.MAX_RESTARTS=5;function R(P){return P.map(b=>({type:b.type,resource:L.URI.file(b.path)}))}e.toFileChanges=R;function C(P){const b=new E;for(const d of P)b.processEvent(d);return b.coalesce()}e.coalesceEvents=C;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(b){return n.isLinux?b.path:b.path.toLowerCase()}processEvent(b){const d=this.mapPathToChange.get(this.toKey(b));let y=!1;if(d){const h=d.type,S=b.type;d.path!==b.path&&(b.type===2||b.type===1)?y=!0:h===1&&S===2?(this.mapPathToChange.delete(this.toKey(b)),this.coalesced.delete(d)):h===2&&S===1?d.type=0:h===1&&S===0||(d.type=S)}else y=!0;y&&(this.coalesced.add(b),this.mapPathToChange.set(this.toKey(b),b))}coalesce(){const b=[],d=[];return Array.from(this.coalesced).filter(y=>y.type!==2?(b.push(y),!1):!0).sort((y,h)=>y.path.length-h.path.length).filter(y=>d.some(h=>(0,A.isParent)(y.path,h,!n.isLinux))?!1:(d.push(y.path),!0)).concat(b)}}}),define(ie[165],re([0,1,50,5,25,41,109,2,71,10,4,114,22,58]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcher=void 0;class h extends R.Disposable{constructor(v,w,g,p){super();this.request=v,this.onDidFilesChange=w,this.onLogMessage=g,this.verboseLogging=p,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,T.parse)(l)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;this.trace(`Request to start watching: ${v} (excludes: ${this.request.excludes}))}`);const w=await d.Promises.stat(v);this._register(await this.doWatch(v,w.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let w=v.path;try{w=await d.Promises.realpath(v.path),v.path===w&&(w=await(0,b.realcase)(v.path)??v.path),v.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${w})`)}catch{}return w}async doWatch(v,w){if(P.isMacintosh&&(0,A.isEqualOrParent)(v,"/Volumes/"))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const g=new L.CancellationTokenSource(this.cts.token);let p=new R.DisposableStore;try{const l=(0,E.basename)(v),r=(0,D.watch)(v);p.add((0,R.toDisposable)(()=>{r.removeAllListeners(),r.close()}));const a=new Set;if(w)try{for(const t of await d.Promises.readdir(v))a.add(t)}catch(t){this.error(t)}const i=new Map;p.add((0,R.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,s)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),r.on("change",(t,s)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${s}`);let o="";if(s&&(o=s.toString(),P.isMacintosh&&(o=(0,C.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(w)if(t==="rename"){i.get(o)?.dispose();const c=setTimeout(async()=>{if(i.delete(o),o===l&&!await d.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,E.join)(v,o));if(g.token.isCancellationRequested)return;let m;u?a.has(o)?m=0:(m=1,a.add(o)):(a.delete(o),m=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:m})},h.FILE_DELETE_HANDLER_DELAY);i.set(o,(0,R.toDisposable)(()=>clearTimeout(c)))}else{let c;a.has(o)?c=0:(c=1,a.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:c})}else if(t==="rename"||o!==l){const c=setTimeout(async()=>{const u=await d.Promises.exists(v);g.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),p.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);p.clear(),p.add((0,R.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await d.Promises.exists(v)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${l.toString()})`)}return(0,R.toDisposable)(()=>{g.dispose(!0),p.dispose()})}async onFileChange(v,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!w&&this.excludes.some(g=>g(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,y.coalesceEvents)(g);if(p.length>0){if(this.verboseLogging)for(const r of p)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(p)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${p.length}, most recent change: ${p[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(P.isLinux)return d.Promises.exists(v);try{const w=(0,E.basename)(v);return(await d.Promises.readdir((0,E.dirname)(v))).some(p=>p===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace("stopping file watcher"),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcher=h,h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=50;async function S(f,v,w,g,p=512){const l=await d.Promises.open(f,"r"),r=Buffer.allocUnsafe(p),a=new L.CancellationTokenSource(g);let i,t=!1;const s={path:f,excludes:[]},o=new h(s,c=>{(async()=>{for(const{type:u}of c)if(u===0){if(t)return;t=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:m}=await d.Promises.read(l,r,0,p,null);if(!m||a.token.isCancellationRequested)break;v(r.slice(0,m))}}catch(m){i=new Error(m),a.dispose(!0)}finally{t=!1}}})()});return await o.ready,w(),new Promise((c,u)=>{a.token.onCancellationRequested(async()=>{o.dispose();try{await d.Promises.close(l)}catch(m){i=new Error(m)}i?u(i):c()})})}e.watchFileContents=S}),define(ie[166],re([0,1,18,36,57,58]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class T extends A.AbstractRecursiveWatcherClient{constructor(C,E,P){super(C,E,P);this.init()}createWatcher(C){const E=C.add(new L.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(E.onDidProcessExit(({code:P,signal:b})=>this.onError(`terminated by itself with code ${P}, signal: ${b}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.ParcelWatcherClient=T}),define(ie[85],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...L){this._entries=new Map;for(let[A,T]of L)this.set(A,T)}set(L,A){const T=this._entries.get(L);return this._entries.set(L,A),T}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=D}),define(ie[167],re([0,1,5,9,51,157,6,85]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class E extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new R.ServiceCollection,S=!1,f){this._activeInstantiations=new Set,this._services=h,this._strict=S,this._parent=f,this._services.set(T.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...S){let f=d.traceInvocation(h),v=!1;try{return h({get:g=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(g,f);if(!p)throw new Error(`[invokeFunction] unknown service '${g}'`);return p}},...S)}finally{v=!0,f.stop()}}createInstance(h,...S){let f,v;return h instanceof L.SyncDescriptor?(f=d.traceCreation(h.ctor),v=this._createInstance(h.ctor,h.staticArguments.concat(S),f)):(f=d.traceCreation(h),v=this._createInstance(h,S,f)),f.stop(),v}_createInstance(h,S=[],f){let v=T._util.getServiceDependencies(h).sort((p,l)=>p.index-l.index),w=[];for(const p of v){let l=this._getOrCreateServiceInstance(p.id,f);if(!l&&this._strict&&!p.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${p.id}.`);w.push(l)}let g=v.length>0?v[0].index:S.length;if(S.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${S.length} static arguments`);let p=g-S.length;p>0?S=S.concat(new Array(p)):S=S.slice(0,g)}return new h(...[...S,...w])}_setServiceInstance(h,S){if(this._services.get(h)instanceof L.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){let f=this._getServiceInstanceOrDescriptor(h);return f instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,f,S.branch(h,!0)):(S.branch(h,!1),f)}_safeCreateAndCacheServiceInstance(h,S,f){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,f)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,f){const v=new A.Graph(p=>p.id.toString());let w=0;const g=[{id:h,desc:S,_trace:f}];for(;g.length;){const p=g.pop();if(v.lookupOrInsertNode(p),w++>1e3)throw new E(v);for(let l of T._util.getServiceDependencies(p.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),r instanceof L.SyncDescriptor){const a={id:l.id,desc:r,_trace:p._trace.branch(l.id,!0)};v.insertEdge(p,a),g.push(a)}}}for(;;){const p=v.roots();if(p.length===0){if(!v.isEmpty())throw new E(v);break}for(const{data:l}of p){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}v.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,f=[],v,w){if(this._services.get(h)instanceof L.SyncDescriptor)return this._createServiceInstance(S,f,v,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,f,v,w);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S=[],f,v){if(f){const w=new D.IdleValue(()=>this._createInstance(h,S,v));return new Proxy(Object.create(null),{get(g,p){if(p in g)return g[p];let l=w.value,r=l[p];return typeof r!="function"||(r=r.bind(l),g[p]=r),r},set(g,p,l){return w.value[p]=l,!0}})}else return this._createInstance(h,S,v)}}e.InstantiationService=P;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class d{constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return C?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return C?new d(0,h.name):d._None}branch(h,S){let f=new d(2,h.toString());return this._dep.push([h,S,f]),f}stop(){let h=Date.now()-this._start;d._totals+=h;let S=!1;function f(w,g){let p=[],l=new Array(w+1).join("	");for(const[r,a,i]of g._dep)if(a&&i){S=!0,p.push(`${l}CREATES -> ${r}`);let t=f(w+1,i);t&&p.push(t)}else p.push(`${l}uses -> ${r}`);return p.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||S)&&console.log(v.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ie[168],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(L,A){this.server=L,this.router=A}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,A){this.server.registerChannel(L,A)}}e.MessagePortMainProcessService=D}),define(ie[169],re([0,1,36,51,79,6]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(y,h,S){const f=S.getChannel(y);return R(h)?new h.channelClientCtor(f):D.ProxyChannel.toService(f,h?.proxyOptions)}}function R(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let C=class extends T{constructor(y,h,S){super(y,h,S)}};C=de([Y(2,e.IMainProcessService)],C);function E(d,y,h){(0,L.registerSingleton)(d,new n.SyncDescriptor(C,[y,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let P=class extends T{constructor(y,h,S){super(y,h,S)}};P=de([Y(2,e.ISharedProcessService)],P);function b(d,y,h){(0,L.registerSingleton)(d,new n.SyncDescriptor(P,[y,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=b}),define(ie[59],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function n(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const A of L.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ie[170],re([0,1,2,59]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends D.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,n.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(ie[8],re([0,1,37,3,2,4,6]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function R(){return new Date().toISOString()}var C;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function E(a,i,t){switch(i){case C.Trace:a.trace(t);break;case C.Debug:a.debug(t);break;case C.Info:a.info(t);break;case C.Warning:a.warn(t);break;case C.Error:a.error(t);break;case C.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=E;function P(a){let i="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(t>0?" ":"")+s}return i}e.format=P;class b extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class d extends b{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(C.Trace)&&this.log(C.Trace,P([i,...t]))}debug(i,...t){this.checkLogLevel(C.Debug)&&this.log(C.Debug,P([i,...t]))}info(i,...t){this.checkLogLevel(C.Info)&&this.log(C.Info,P([i,...t]))}warn(i,...t){this.checkLogLevel(C.Warning)&&this.log(C.Warning,P([i,...t]))}error(i,...t){if(this.checkLogLevel(C.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(C.Error,P(s))}else this.log(C.Error,P([i,...t]))}critical(i,...t){this.checkLogLevel(C.Critical)&&this.log(C.Critical,P([i,...t]))}flush(){}}e.AbstractMessageLogger=d;class y extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...t){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}debug(i,...t){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}info(i,...t){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}warn(i,...t){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...t):console.warn(`[main ${R()}]`,i,...t))}error(i,...t){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}critical(i,...t){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class h extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class S extends b{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class f extends b{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const s of this.logServices)s.trace(i,...t)}debug(i,...t){for(const s of this.logServices)s.debug(i,...t)}info(i,...t){for(const s of this.logServices)s.info(i,...t)}warn(i,...t){for(const s of this.logServices)s.warn(i,...t)}error(i,...t){for(const s of this.logServices)s.error(i,...t)}critical(i,...t){for(const s of this.logServices)s.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=f;class v extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=v;class w extends L.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,t?.always?C.Trace:this.logLevel,t),this.loggers.set(i.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class g{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return C.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=g;function p(a){if(a.verbose)return C.Trace;if(typeof a.logLevel=="string"){const i=l(a.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function l(a){switch(a){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=l;function r(a){switch(a){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=r}),define(ie[171],re([0,1,5,9,2,10,22,13,8]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends L.Disposable{constructor(b,d){super();this.environmentService=b,this.logService=d,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,A.basename)(this.environmentService.logsPath),d=(0,A.dirname)(this.environmentService.logsPath),S=(await T.Promises.readdir(d)).filter(v=>/^\d{8}T\d{6}$/.test(v)).sort().filter(v=>v!==b),f=S.slice(0,Math.max(0,S.length-9));f.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(v=>T.Promises.rm((0,A.join)(d,v)))))}catch(b){(0,n.onUnexpectedError)(b)}}};E=de([Y(0,R.IEnvironmentService),Y(1,C.ILogService)],E),e.LogsDataCleaner=E}),define(ie[172],re([0,1,5,9,2,10,22,13,8]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class gt extends L.Disposable{constructor(b,d,y){super();this.backupWorkspacesPath=b,this.environmentService=d,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const b=await T.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(b).emptyWorkspaceInfos.map(S=>S.backupFolder),h=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async S=>{S.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||S===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await T.Promises.rm((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(b){(0,n.onUnexpectedError)(b)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=de([Y(1,R.INativeEnvironmentService),Y(2,C.ILogService)],E),e.StorageDataCleaner=E}),define(ie[173],re([0,1,45,5,37,3,2,18,10,22,13,8]),function(J,e,D,n,L,A,T,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends T.Disposable{constructor(h,S){super();this.environmentService=h,this.logService=S,this.processesLimiter=new n.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),E.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(h,S){const f=`vscode:${S}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const v=h.manifest.scripts[f].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,C.join)(h.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(h,S,f,v,w){return new Promise((g,p)=>{const l=this.start(h,S,f,w);let r;const a=i=>{r&&(clearTimeout(r),r=null),i?p(i):g(void 0)};l.on("error",i=>{a((0,L.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,t)=>{a(i?`post-${S} process exited with code ${i}`:void 0)}),v&&(r=setTimeout(()=>{r=null,l.kill(),p("timed out")},5e3))})}start(h,S,f,v){const w={silent:!0,execArgv:void 0},g=(0,D.fork)(h,[`--type=extension-post-${S}`,...f],w);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(g.stdout,"data"),l=A.Event.fromNodeEventEmitter(g.stderr,"data");p(i=>this.logService.info(v.identifier.id,v.manifest.version,`post-${S}`,i)),l(i=>this.logService.error(v.identifier.id,v.manifest.version,`post-${S}`,i));const r=A.Event.any(A.Event.map(p,i=>({data:`%c${i}`,format:[""]})),A.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(v.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,C.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=de([Y(0,P.IEnvironmentService),Y(1,b.ILogService)],d),e.ExtensionsLifecycle=d}),define(ie[174],re([0,1,16,5,9,3,2,10,58,8]),function(J,e,D,n,L,A,T,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(d){super();this.logService=d,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(d,y){return y.recursive?this.watchRecursive(d,y):this.watchNonRecursive(d,y)}watchRecursive(d,y){const h={path:this.toFilePath(d),excludes:y.excludes},S=(0,D.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,L.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,C.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.massageRecursiveWatchRequests(this.recursiveFoldersToWatch),this.recursiveWatcher.watch(this.recursiveFoldersToWatch)}massageRecursiveWatchRequests(d){}watchNonRecursive(d,y){const h=new T.DisposableStore,S=h.add(this.createNonRecursiveWatcher({path:this.toFilePath(d),excludes:y.excludes},f=>this._onDidChangeFile.fire((0,C.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace));return h.add(this.logService.onDidChangeLogLevel(()=>{S.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})),h}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,R.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ie[175],re([0,1,16,5,17,25,3,70,54,2,39,18,176,19,40,136,14,84,8]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${l}`);const a=new E.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),a.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new f.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&a.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),a.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,E.dispose)(a)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(a){r.push(a)}}),!this.provider.has(l)&&await n.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const a=this.provider.get(l.scheme);return!!(a&&a.capabilities&r)}listCapabilities(){return C.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,y.isAbsolutePath)(l))throw new f.FileOperationError((0,S.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const a=new Error;throw a.name="ENOPRO",a.message=(0,S.localize)(1,null,l.toString()),a}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,f.hasOpenReadWriteCloseCapability)(r)||(0,f.hasReadWriteCapability)(r)||(0,f.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,f.hasOpenReadWriteCloseCapability)(r)||(0,f.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(a){throw(0,f.toFileSystemProviderErrorCode)(a)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,S.localize)(2,null,this.resourceForError(l)),1):(0,f.ensureFileSystemProviderError)(a)}}async doResolveFile(l,r){const a=await this.withProvider(l),i=this.isPathCaseSensitive(a),t=r?.resolveTo,s=r?.resolveSingleChildDescendants,o=r?.resolveMetadata,c=await a.stat(l);let u;return this.toFileStat(a,l,c,void 0,!!o,(m,I)=>(u||(u=P.TernarySearchTree.forUris(()=>!i),u.set(l,!0),t&&u.fill(!0,t)),u.get(m.resource)||u.findSuperstr(m.resource.with({query:null,fragment:null}))?!0:m.isDirectory&&s?I===1:!1))}async toFileStat(l,r,a,i,t,s){const{providerExtUri:o}=this.getExtUri(l),c={resource:r,name:o.basename(r),isFile:(a.type&f.FileType.File)!=0,isDirectory:(a.type&f.FileType.Directory)!=0,isSymbolicLink:(a.type&f.FileType.SymbolicLink)!=0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&f.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,f.etag)({mtime:a.mtime,size:a.size})};if(c.isDirectory&&s(c,i)){try{const u=await l.readdir(r),m=await n.Promises.settled(u.map(async([I,_])=>{try{const O=o.joinPath(r,I),N=t?await l.stat(O):{type:_};return await this.toFileStat(l,O,N,u.length,t,s)}catch(O){return this.logService.trace(O),null}}));c.children=(0,D.coalesce)(m)}catch(u){this.logService.trace(u),c.children=[]}return c}return c}async resolveAll(l){return n.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(a){return a}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new f.FileOperationError((0,S.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=L.VSBuffer.fromString(""),a){await this.doValidateCreateFile(l,a);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new f.FileOperationEvent(l,0,i)),i}async writeFile(l,r,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,l,a)||await this.mkdirp(i,t.dirname(l));let o;if((0,f.hasReadWriteCapability)(i)&&!(r instanceof L.VSBuffer))if((0,h.isReadableStream)(r)){const c=await(0,h.peekStream)(r,3);c.ended?o=L.VSBuffer.concat(c.buffer):o=c}else o=(0,h.peekReadable)(r,c=>L.VSBuffer.concat(c),3);else o=r;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&o instanceof L.VSBuffer?await this.doWriteUnbuffered(i,l,a,o):await this.doWriteBuffered(i,l,a,o instanceof L.VSBuffer?(0,L.bufferToReadable)(o):o)}catch(s){throw new f.FileOperationError((0,S.localize)(4,null,this.resourceForError(l),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),a)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,a){if(!!a?.unlock&&!(l.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(r)));let t;try{t=await l.stat(r)}catch{return}if((t.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,S.localize)(6,null,this.resourceForError(r)),0,a);if(this.throwIfFileIsReadonly(r,t),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==f.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&a.mtime<t.mtime&&a.etag!==(0,f.etag)({mtime:a.mtime,size:t.size}))throw new f.FileOperationError((0,S.localize)(7,null),3,a);return t}async readFile(l,r,a){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,a):this.doReadFile(i,l,r,a)}async doReadFileAtomic(l,r,a,i){return new Promise((t,s)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(l,r,a,i);t(o)}catch(o){s(o)}})})}async doReadFile(l,r,a,i){const t=await this.doReadFileStream(l,r,{...a,preferUnbuffered:!0},i);return{...t,value:await(0,L.streamToBuffer)(t.value)}}async readFileStream(l,r,a){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,a)}async doReadFileStream(l,r,a,i){const t=new A.CancellationTokenSource(i),s=this.validateReadFile(r,a).then(c=>c,c=>{throw t.cancel(),c});let o;try{return typeof a?.etag=="string"&&a.etag!==f.ETAG_DISABLED&&await s,a?.atomic&&(0,f.hasFileAtomicReadCapability)(l)||!((0,f.hasOpenReadWriteCloseCapability)(l)||(0,f.hasFileReadStreamCapability)(l))||(0,f.hasReadWriteCapability)(l)&&a?.preferUnbuffered?o=this.readFileUnbuffered(l,r,a):(0,f.hasFileReadStreamCapability)(l)?o=this.readFileStreamed(l,r,t.token,a):o=this.readFileBuffered(l,r,t.token,a),{...await s,value:o}}catch(c){o&&await(0,h.consumeStream)(o);const u=(0,S.localize)(8,null,this.resourceForError(r),(0,f.ensureFileSystemProviderError)(c).toString());throw c instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(u,c.stat,a):new f.FileOperationError(u,(0,f.toFileOperationResult)(c),a)}}readFileStreamed(l,r,a,i=Object.create(null)){const t=l.readFileStream(r,i,a);return(0,h.transform)(t,{data:s=>s instanceof L.VSBuffer?s:L.VSBuffer.wrap(s),error:s=>new f.FileOperationError((0,S.localize)(9,null,this.resourceForError(r),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),i)},s=>L.VSBuffer.concat(s))}readFileBuffered(l,r,a,i=Object.create(null)){const t=(0,L.newWriteableBufferStream)();return(0,v.readFileIntoStream)(l,r,t,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new f.FileOperationError((0,S.localize)(10,null,this.resourceForError(r),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),i)},a),t}readFileUnbuffered(l,r,a){const i=(0,h.newWriteableStream)(t=>L.VSBuffer.concat(t));return(async()=>{try{let t;a?.atomic&&(0,f.hasFileAtomicReadCapability)(l)?t=await l.readFile(r,{atomic:!0}):t=await l.readFile(r),typeof a?.position=="number"&&(t=t.slice(a.position)),typeof a?.length=="number"&&(t=t.slice(0,a.length)),this.validateReadFileLimits(r,t.byteLength,a),i.end(L.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(l,r){const a=await this.resolve(l,{resolveMetadata:!0});if(a.isDirectory)throw new f.FileOperationError((0,S.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==f.ETAG_DISABLED&&r.etag===a.etag)throw new f.NotModifiedSinceFileOperationError((0,S.localize)(12,null),a,r);return this.validateReadFileLimits(l,a.size,r),a}validateReadFileLimits(l,r,a){if(a?.limits){let i;if(typeof a.limits.memory=="number"&&r>a.limits.memory&&(i=9),typeof a.limits.size=="number"&&r>a.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,S.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,a){return this.doCanMoveCopy(l,r,"move",a)}async canCopy(l,r,a){return this.doCanMoveCopy(l,r,"copy",a)}async doCanMoveCopy(l,r,a,i){if(l.toString()!==r.toString())try{const t=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(t,l,s,r,a,i)}catch(t){return t}return!0}async move(l,r,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,l,t,r,"move",!!a),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(l,s==="move"?2:3,o)),o}async copy(l,r,a){const i=await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,l,t,r,"copy",!!a),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(l,s==="copy"?3:2,o)),o}async doMoveCopy(l,r,a,i,t,s){if(r.toString()===i.toString())return t;const{exists:o,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,r,a,i,t,s);if(o&&!c&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(i)),t==="copy"){if(l===a&&(0,f.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:s});else{const u=await this.resolve(r);u.isDirectory?await this.doCopyFolder(l,u,a,i):await this.doCopyFile(l,r,a,i)}return t}else return l===a?(await l.rename(r,i,{overwrite:s}),t):(await this.doMoveCopy(l,r,a,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,a,i){if((0,f.hasOpenReadWriteCloseCapability)(l)&&(0,f.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(l,r,a,i);if((0,f.hasOpenReadWriteCloseCapability)(l)&&(0,f.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(l,r,a,i);if((0,f.hasReadWriteCapability)(l)&&(0,f.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(l,r,a,i);if((0,f.hasReadWriteCapability)(l)&&(0,f.hasReadWriteCapability)(a))return this.doPipeUnbuffered(l,r,a,i)}async doCopyFolder(l,r,a,i){await a.mkdir(i),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async t=>{const s=this.getExtUri(a).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(l,await this.resolve(t.resource),a,s):this.doCopyFile(l,t.resource,a,s)}))}async doValidateMoveCopy(l,r,a,i,t,s){let o=!1;if(l===a){const{providerExtUri:u,isPathCaseSensitive:m}=this.getExtUri(l);if(m||(o=u.isEqual(r,i)),o&&t==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!o&&u.isEqualOrParent(i,r))throw new Error((0,S.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!o){if(!s)throw new f.FileOperationError((0,S.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===a){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(r,i))throw new Error((0,S.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:o}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(l,0,a)),a}async mkdirp(l,r){const a=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&f.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(r)));break}catch(t){if((0,f.toFileSystemProviderErrorCode)(t)!==f.FileSystemProviderErrorCode.FileNotFound)throw t;a.push(i.basename(r)),r=i.dirname(r)}for(let t=a.length-1;t>=0;t--){r=i.joinPath(r,a[t]);try{await l.mkdir(r)}catch(s){if((0,f.toFileSystemProviderErrorCode)(s)!==f.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(a){return a}return!0}async doValidateDelete(l,r){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(a.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(l)));let t;try{t=await a.stat(l)}catch{}if(t)this.throwIfFileIsReadonly(l,t);else throw new f.FileOperationError((0,S.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const o=await this.resolve(l);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(l)))}return a}async del(l,r){const a=await this.doValidateDelete(l,r),i=!!r?.useTrash,t=!!r?.recursive;await a.delete(l,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(l,1))}watch(l,r={recursive:!1,excludes:[]}){const a=new E.DisposableStore;let i=!1,t=()=>{i=!0};return a.add((0,E.toDisposable)(()=>t())),(async()=>{try{const s=await this.doWatch(l,r);i?(0,E.dispose)(s):t=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),a}async doWatch(l,r){const a=await this.withProvider(l),i=(0,R.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(l),r]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:a.watch(l,r)},this.activeWatchers.set(i,t)),t.count+=1,(0,E.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,E.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,a,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const t=await l.open(r,{create:!0,unlock:a?.unlock??!1});try{(0,h.isReadableStream)(i)||(0,h.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,t,i):await this.doWriteReadableBufferedQueued(l,t,i)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await l.close(t)}})}async doWriteStreamBufferedQueued(l,r,a){let i=0,t;if((0,h.isReadableBufferedStream)(a)){if(a.buffer.length>0){const s=L.VSBuffer.concat(a.buffer);await this.doWriteBuffer(l,r,s,s.byteLength,i,0),i+=s.byteLength}if(a.ended)return;t=a.stream}else t=a;return new Promise((s,o)=>{(0,h.listenStream)(t,{onData:async c=>{t.pause();try{await this.doWriteBuffer(l,r,c,c.byteLength,i,0)}catch(u){return o(u)}i+=c.byteLength,setTimeout(()=>t.resume())},onError:c=>o(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,r,a){let i=0,t;for(;(t=a.read())!==null;)await this.doWriteBuffer(l,r,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(l,r,a,i,t,s){let o=0;for(;o<i;)o+=await l.write(r,t+o,a.buffer,s+o,i-o)}async doWriteUnbuffered(l,r,a,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,a,i))}async doWriteUnbufferedQueued(l,r,a,i){let t;i instanceof L.VSBuffer?t=i:(0,h.isReadableStream)(i)?t=await(0,L.streamToBuffer)(i):(0,h.isReadableBufferedStream)(i)?t=await(0,L.bufferedStreamToBuffer)(i):t=(0,L.readableToBuffer)(i),await l.writeFile(r,t.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,a,i))}async doPipeBufferedQueued(l,r,a,i){let t,s;try{t=await l.open(r,{create:!1}),s=await a.open(i,{create:!0,unlock:!1});const o=L.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,u=0,m=0;do m=await l.read(t,c,o.buffer,u,o.byteLength-u),await this.doWriteBuffer(a,s,o,m,c,u),c+=m,u+=m,u===o.byteLength&&(u=0);while(m>0)}catch(o){throw(0,f.ensureFileSystemProviderError)(o)}finally{await n.Promises.settled([typeof t=="number"?l.close(t):Promise.resolve(),typeof s=="number"?a.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,a,i))}async doPipeUnbufferedQueued(l,r,a,i){return a.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,a,i))}async doPipeUnbufferedToBufferedQueued(l,r,a,i){const t=await a.open(i,{create:!0,unlock:!1});try{const s=await l.readFile(r);await this.doWriteBuffer(a,t,L.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await a.close(t)}}async doPipeBufferedToUnbuffered(l,r,a,i){const t=await(0,L.streamToBuffer)(this.readFileBuffered(l,r,A.CancellationToken.None));await this.doWriteUnbuffered(a,i,void 0,t)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new f.FileOperationError((0,S.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,S.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===b.Schemas.file?l.fsPath:l.toString(!0)}};g=de([Y(0,w.ILogService)],g),e.FileService=g}),define(ie[177],re([0,1,50,252,5,39,17,3,41,2,10,4,19,40,22,139,14,84,165,166,174,37]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(a)}`)}})();class r extends p.AbstractDiskFileSystemProvider{constructor(i,t){super(i);this.options=t,this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new A.ResourceMap(s=>d.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await h.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,d.joinPath)(i,o.name))).type:c=this.toType(o),s.push([o.name,c])}catch(c){this.logService.trace(c)}})),s}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let s;return t?.dangling?s=f.FileType.Unknown:i.isFile()?s=f.FileType.File:i.isDirectory()?s=f.FileType.Directory:s=f.FileType.Unknown,t&&(s|=f.FileType.SymbolicLink),s}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let t;for(;t=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await t.wait();const s=new L.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),s.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const o=this.toFilePath(i);return await h.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(i,t,s){const o=(0,y.newWriteableStream)(c=>T.VSBuffer.concat(c.map(u=>T.VSBuffer.wrap(u))).buffer);return(0,v.readFileIntoStream)(this,i,o,c=>c.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(i,t,s){let o;try{const c=this.toFilePath(i);if(!s.create||!s.overwrite){if(await h.Promises.exists(c)){if(!s.overwrite)throw(0,f.createFileSystemProviderError)((0,S.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,f.createFileSystemProviderError)((0,S.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof o=="number"&&await this.close(o)}}async open(i,t){let s;(0,f.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(i));let o;try{const c=this.toFilePath(i);if((0,f.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:m}=await h.SymlinkSupport.stat(c);m.mode&128||await h.Promises.chmod(c,m.mode|128)}catch(m){this.logService.trace(m)}let u;if((0,f.isFileOpenForWriteOptions)(t)){if(b.isWindows)try{await h.Promises.truncate(c,0),u="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}u||(u="w")}else u="r";o=await h.Promises.open(c,u)}catch(c){throw s?.dispose(),(0,f.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}return this.mapHandleToPos.set(o,0),(0,f.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(o,i),s&&this.mapHandleToLock.set(o,s),o}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await h.Promises.fdatasync(i)}catch(t){this.canFlush=!1,this.logService.error(t)}return await h.Promises.close(i)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(i);t&&(this.mapHandleToLock.delete(i),t.dispose())}}async read(i,t,s,o,c){const u=this.normalizePos(i,t);let m=null;try{const{bytesRead:I}=await h.Promises.read(i,s,o,c,u);return I}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(i,u,m)}}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,s){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,o+s):this.mapHandleToPos.delete(i)))}async write(i,t,s,o,c){return(0,L.retry)(()=>this.doWrite(i,t,s,o,c),100,3)}async doWrite(i,t,s,o,c){const u=this.normalizePos(i,t);let m=null;try{const{bytesWritten:I}=await h.Promises.write(i,s,o,c,u);return I}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),I)}finally{this.updatePos(i,u,m)}}async mkdir(i){try{await h.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const s=this.toFilePath(i);t.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateTargetDeleted(i,t,"move",s.overwrite),await h.Promises.move(o,c)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,S.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateTargetDeleted(i,t,"copy",s.overwrite),await h.Promises.copy(o,c,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,S.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(i,t,s,o){const c=this.toFilePath(i),u=this.toFilePath(t);let m=!1;if(!!(this.capabilities&1024)||(m=(0,C.isEqual)(c,u,!0)),m&&s==="copy")throw(0,f.createFileSystemProviderError)((0,S.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!m&&await h.Promises.exists(u)){if(!o)throw(0,f.createFileSystemProviderError)((0,S.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(i,t,s){return new g.ParcelWatcherClient(o=>i(o),o=>t(o),s)}massageRecursiveWatchRequests(i){const t=this.options?.watcher?.usePolling;if(t===!0)for(const s of i)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const s of i)t.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3)}createNonRecursiveWatcher(i,t,s,o){return new w.NodeJSFileWatcher(i,c=>t(c),c=>s(c),o)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=f.FileSystemProviderErrorCode.NoPermissions;break;default:t=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let s=this.toFileSystemProviderError(t);if(i&&s.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await h.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(s=(0,f.createFileSystemProviderError)(t,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=r}),define(ie[86],re([0,1,3,7,8]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(d){this.service=d,this.onDidChangeLogLevel=D.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(d,y,h){switch(y){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=A;class T{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){T.setLevel(this.channel,d)}static setLevel(d,y){return d.call("setLevel",y)}}e.LogLevelChannelClient=T;class R{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,y){throw new Error(`Event not found: ${y}`)}async call(d,y,h){switch(y){case"createLogger":this.createLogger(n.URI.revive(h[0]),h[1]);return;case"log":return this.log(n.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${y}`)}createLogger(d,y){this.loggers.set(d.toString(),this.loggerService.createLogger(d,y))}consoleLog(d,y){let h=console.log;switch(d){case L.LogLevel.Error:h=console.error;break;case L.LogLevel.Warning:h=console.warn;break;case L.LogLevel.Info:h=console.info;break}h.call(console,...y)}log(d,y){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,f]of y)(0,L.log)(h,S,f)}}e.LoggerChannel=R;class C extends L.AbstractLoggerService{constructor(d,y,h){super(d,y);this.channel=h}createConsoleMainLogger(){return new L.AdapterLogger({log:(d,y)=>{this.channel.call("consoleLog",[d,y])}})}doCreateLogger(d,y,h){return new E(this.channel,d,y,h)}}e.LoggerChannelClient=C;class E extends L.AbstractMessageLogger{constructor(d,y,h,S){super(S?.always);this.channel=d,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[y,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,y){const h=[[d,y]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class P extends L.LogService{constructor(d,y){super(y);this.parent=d,this._register(d.onDidChangeLogLevel(h=>y.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=P}),define(ie[60],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ie[87],re([0,1,18,4,32,19]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const R=n.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,A.dirname)(D.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,A.joinPath)(R,"product.json").fsPath);const C=J.__$__nodeRequire((0,A.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:C.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(ie[26],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[178],re([0,1,5,9,2,10,22,8,26]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends L.Disposable{constructor(b,d,y){super();this.productService=d,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},30*1e3)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),y=(0,A.dirname)(b),h=(0,A.basename)(b),S=await T.Promises.readdir(y);await Promise.all(S.map(async f=>{if(f===h)return;const v=(0,A.join)(y,f),w=await T.Promises.stat(v);if(w.isDirectory()&&d-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),T.Promises.rm(v)}))}catch(d){(0,n.onUnexpectedError)(d)}}};E=de([Y(1,C.IProductService),Y(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(ie[179],re([0,1,5,9,2,10,22,13,8,26]),function(J,e,D,n,L,A,T,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends L.Disposable{constructor(d,y,h){super();this.environmentService=d,this.logService=y,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),y=JSON.parse(await T.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(y)){const g=y[w];d[`${g.hash}.${w}`]=!0}const h=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const f=await T.Promises.readdir(h);for(const w of f){if(d[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await T.Promises.rm((0,A.join)(h,w))}const v=Date.now();for(const w of Object.keys(d)){const g=(0,A.join)(h,w),p=await T.Promises.readdir(g);for(const l of p){if(l==="tcf.json")continue;const r=(0,A.join)(g,l),a=await T.Promises.stat(r);a.isDirectory()&&v-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(w,l)}`),await T.Promises.rm(r))}}}catch(d){(0,n.onUnexpectedError)(d)}}};P=de([Y(0,R.INativeEnvironmentService),Y(1,C.ILogService),Y(2,E.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ie[180],re([0,1,10,6]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var L;(function(A){function T(R,C="noAbsolutePaths"){for(const E of R.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(C,(0,D.basename)(E.callFrame.url)));return R}A.rewriteAbsolutePaths=T})(L=e.Utils||(e.Utils={}))}),define(ie[181],re([0,1,29]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(A){const R=await(await new Promise((E,P)=>{J(["v8-inspect-profiler"],E,P)})).startProfiling({port:A.port,checkForPaused:!0}),C=(0,D.generateUuid)();return this._sessions.set(C,R),C}async stopProfiling(A){const T=this._sessions.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const R=await T.stop();return this._sessions.delete(A),R.profile}}e.InspectProfilingService=n}),define(ie[38],re([0,1,99,15]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(T,R){D.ok(n.isString(T)),D.ok(n.isObject(R)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new L}),define(ie[88],re([0,1,3,38]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,E){this.schemasById[L(C)]=E,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;n.Registry.add(e.Extensions.JSONContribution,T)}),define(ie[42],re([0,1,16,3,15,125,88,38]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(T.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const a=this.doRegisterConfigurations(l,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(l,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(a)})}registerDefaultConfigurations(l){const r=[],a=[];for(const{overrides:i,source:t}of l)for(const s in i)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...i[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const c={type:"object",default:o,description:A.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:L.isString(t)?void 0:t};a.push(...h(s)),this.configurationProperties[s]=c,this.defaultLanguageConfigurationOverridesNode.properties[s]=c}else{this.configurationDefaultsOverrides.set(s,{value:i[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:a,source:i}of l)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=L.isString(i)?i:i?.id,c=L.isString(s?.source)?s?.source:s?.source?.id;if(o===c)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const u=this.configurationProperties[t];u&&(this.updatePropertyDefaultValue(t,u),this.updateSchema(t,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const a=[];return l.forEach(i=>{a.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),a}doDeregisterConfigurations(l){const r=[],a=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>a(t))};for(const i of l){a(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,a,i,t=3){t=L.isUndefinedOrNull(l.scope)?t:l.scope;let s=[],o=l.properties;if(o)for(let u in o){if(r&&w(u)){delete o[u];continue}const m=o[u];if(m.source=a,m.defaultDefaultValue=o[u].default,this.updatePropertyDefaultValue(u,m),e.OVERRIDE_PROPERTY_REGEX.test(u)?m.scope=void 0:(m.scope=L.isUndefinedOrNull(m.scope)?t:m.scope,m.restricted=L.isUndefinedOrNull(m.restricted)?!!i?.includes(u):m.restricted),o[u].hasOwnProperty("included")&&!o[u].included){this.excludedConfigurationProperties[u]=o[u],delete o[u];continue}else this.configurationProperties[u]=o[u];!o[u].deprecationMessage&&o[u].markdownDeprecationMessage&&(o[u].deprecationMessage=o[u].markdownDeprecationMessage),s.push(u)}let c=l.allOf;if(c)for(let u of c)s.push(...this.validateAndRegisterProperties(u,r,a,i,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=a=>{let i=a.properties;if(i)for(const s in i)this.updateSchema(s,i[s]);let t=a.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,a={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const a=this.configurationDefaultsOverrides.get(l);let i=a?.value,t=a?.source;L.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),L.isUndefined(i)&&(i=f(r.type)),r.default=i,r.defaultValueSource=t}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(p){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let r=y.exec(p);for(;r?.length;){const a=r[1].trim();a&&l.push(a),r=y.exec(p)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=h;function S(p){return p.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=S;function f(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new b;R.Registry.add(e.Extensions.Configuration,v);function w(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?A.localize(7,null,p):v.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):null:A.localize(6,null)}e.validateProperty=w;function g(){const p=[],l=v.getConfigurationProperties();for(const r of Object.keys(l))p.push([r,l[r].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=g}),define(ie[89],re([0,1,16,3,35,2,39,28,15,7,20,42,38]),function(J,e,D,n,L,A,T,R,C,E,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},t=[],s=[]){this._contents=i,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const s=this.getContentsForOverrideIdentifer(t);return s?i?(0,P.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return D.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const c of i){this.mergeContents(t,c.contents);for(const u of c.overrides){const[m]=s.filter(I=>D.equals(I.identifiers,u.identifiers));m?(this.mergeContents(m.contents,u.contents),m.keys.push(...u.keys),m.keys=D.distinct(m.keys)):s.push(R.deepClone(u))}for(const u of c.keys)o.indexOf(u)===-1&&o.push(u)}return new y(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o],u=t[o];u&&(typeof c=="object"&&typeof u=="object"?(c=R.deepClone(c),this.mergeContents(c,u)):c=u),s[o]=c}return new y(s,this.keys,this.overrides)}mergeContents(i,t){for(const s of Object.keys(t)){if(s in i&&C.isObject(i[s])&&C.isObject(t[s])){this.mergeContents(i[s],t[s]);continue}i[s]=R.deepClone(t[s])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,s=null;const o=c=>{c&&(s?this.mergeContents(s,c):s=R.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[i])?t=c.contents:c.identifiers.includes(i)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,P.addToValueTree)(this.contents,i,t,s=>{throw new Error(s)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let s=0;s<t;s++)i.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class h extends y{constructor(i={}){const t=d.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),c=[];for(const u in t){const m=i[u],I=m!==void 0?m:t[u].default;(0,P.addToValueTree)(o,u,I,_=>console.error(`Conflict in default settings: ${_}`))}for(const u of Object.keys(o))b.OVERRIDE_PROPERTY_REGEX.test(u)&&c.push({identifiers:(0,b.overrideIdentifiersFromKey)(u),keys:Object.keys(o[u]),contents:(0,P.toValuesTree)(o[u],m=>console.error(`Conflict in default settings file: ${m}`))});super(o,s,c)}}e.DefaultConfigurationModel=h;class S{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!C.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:s,keys:o,overrides:c,restricted:u}=this.doParseRaw(i,t);this._configurationModel=new y(s,o,c),this._restrictedConfigurations=u||[]}doParseContent(i){let t={},s=null,o=[],c=[],u=[];function m(_){Array.isArray(o)?o.push(_):s!==null&&(o[s]=_)}let I={onObjectBegin:()=>{let _={};m(_),c.push(o),o=_,s=null},onObjectProperty:_=>{s=_},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let _=[];m(_),c.push(o),o=_,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:m,onError:(_,O,N)=>{u.push({error:_,offset:O,length:N})}};if(i)try{L.visit(i,I),t=o[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(i,t){const s=d.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,s,!0,t);i=o.raw;const c=(0,P.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),u=Object.keys(i),m=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:c,keys:u,overrides:m,restricted:o.restricted}}filter(i,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const c={},u=[];for(let m in i)if(b.OVERRIDE_PROPERTY_REGEX.test(m)&&s){const I=this.filter(i[m],t,!1,o);c[m]=I.raw,u.push(...I.restricted)}else{const I=t[m],_=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&u.push(m),(_===void 0||o.scopes===void 0||o.scopes.includes(_))&&(o.skipRestricted&&I?.restricted||(c[m]=i[m]))}return{raw:c,restricted:u}}toOverrides(i,t){const s=[];for(const o of Object.keys(i))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const u in i[o])c[u]=i[o][u];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=S;class f extends A.Disposable{constructor(i,t,s,o){super();this.userSettingsResource=i,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class v{constructor(i,t,s=new y,o=new y,c=new T.ResourceMap,u=new y,m=new T.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=u,this._memoryConfigurationByResource=m,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(i)}updateValue(i,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new y,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(i):o.setValue(i,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,s){const o=this.getConsolidateConfigurationModel(t,s),c=this.getFolderConfigurationModelForResource(t.resource,s),u=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,m=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,z=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,k=t.overrideIdentifier?u.override(t.overrideIdentifier).getValue(i):u.getValue(i),M=o.getValue(i),j=D.distinct(D.flatten(o.overrides.map(U=>U.identifiers))).filter(U=>o.getOverrideValue(i,U)!==void 0);return{defaultValue:m,userValue:I,userLocalValue:_,userRemoteValue:O,workspaceValue:N,workspaceFolderValue:z,memoryValue:k,value:M,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:z!==void 0?{value:c?.freeze().getValue(i),override:t.overrideIdentifier?c?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:k!==void 0?{value:u.getValue(i),override:t.overrideIdentifier?u.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:o,updated:c,removed:u}=l(this._defaultConfiguration,i);t=[...o,...c,...u]}for(const o of t)for(const c of(0,b.overrideIdentifiersFromKey)(o)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(c),m=i.getKeysForOverrideIdentifier(c),I=[...m.filter(_=>u.indexOf(_)===-1),...u.filter(_=>m.indexOf(_)===-1),...u.filter(_=>!R.equals(this._defaultConfiguration.override(c).getValue(_),i.override(c).getValue(_)))];s.push([c,I])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=l(this.localUserConfiguration,i),u=[...t,...s,...o];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=l(this.remoteUserConfiguration,i);let u=[...t,...s,...o];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=l(this.workspaceConfiguration,i);let u=[...t,...s,...o];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(i,t){const s=this.folderConfigurations.get(i),{added:o,updated:c,removed:u,overrides:m}=l(s,t);let I=[...o,...c,...u];return(I.length||!s)&&this.updateFolderConfiguration(i,t),{keys:I,overrides:m}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:c,overrides:u}=l(t,void 0);return{keys:[...s,...o,...c],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let s=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?s.override(i.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:i},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const o=t.getFolder(i);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const c=this._memoryConfigurationByResource.get(i);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=s}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:s,overrides:o,keys:c}=this._folderConfigurations.get(t);return i.push([t,{contents:s,overrides:o,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>i.add(s))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((u,m)=>(u.set(E.URI.revive(m[0]),this.parseConfigurationModel(m[1])),u),new T.ResourceMap);return new v(t,s,new y,o,c,new y,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=v;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,t=new Map;for(const o of a)o.keys.forEach(c=>i.add(c)),o.overrides.forEach(([c,u])=>{const m=(0,T.getOrSet)(t,c,new Set);u.forEach(I=>m.add(I))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=w;class g{constructor(i,t,s,o){this.change=i,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(m=>c.add(m)),i.overrides.forEach(([,m])=>m.forEach(I=>c.add(I))),this.affectedKeys=[...c.values()];const u=new y;this.affectedKeys.forEach(m=>u.setValue(m,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let s=(0,P.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(i=i[o],!i)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=g;class p extends g{constructor(i,t,s,o){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=p;function l(a,i){const{added:t,removed:s,updated:o}=r(i,a),c=[],u=a?.getAllOverrideIdentifiers()||[],m=i?.getAllOverrideIdentifiers()||[];if(i){const I=m.filter(_=>!u.includes(_));for(const _ of I)c.push([_,i.getKeysForOverrideIdentifier(_)])}if(a){const I=u.filter(_=>!m.includes(_));for(const _ of I)c.push([_,a.getKeysForOverrideIdentifier(_)])}if(i&&a){for(const I of u)if(m.includes(I)){const _=r({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});c.push([I,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function r(a,i){const t=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],s=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],o=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const u=(0,P.getConfigurationValue)(i.contents,c),m=(0,P.getConfigurationValue)(a.contents,c);R.equals(u,m)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(ie[182],re([0,1,5,3,2,19,20,89,42,38]),function(J,e,D,n,L,A,T,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends L.Disposable{constructor(d,y){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,y)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,y){const h=typeof d=="string"?d:void 0,S=(0,T.isConfigurationOverrides)(d)?d:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(h,S,void 0)}updateValue(d,y,h,S){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,y,1)}onDidDefaultConfigurationChange(d){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,d);this.trigger(h,y,6)}trigger(d,y,h){const S=new R.ConfigurationChangeEvent(d,{data:y},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ie[183],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var n;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(T,R=n.Unknown,C){super(T);this._message=T,this._code=R,this._detail=C,this.isHandled=R===n.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(T){return T instanceof L&&T._code===n.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof L&&T._code===n.NoResolverFound}static isHandled(T){return T instanceof L&&T.isHandled}}e.RemoteAuthorityResolverError=L}),define(ie[184],re([0,1,5,17,25,9,3,2,29,73,183]),function(J,e,D,n,L,A,T,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var d;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function y(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(H){const Z=new L.CancellationTokenSource;return setTimeout(()=>Z.cancel(),H),Z.token}function S(H,Z){if(H.isCancellationRequested||Z.isCancellationRequested)return L.CancellationToken.Cancelled;const ee=new L.CancellationTokenSource;return H.onCancellationRequested(()=>ee.cancel()),Z.onCancellationRequested(()=>ee.cancel()),ee.token}class f{constructor(Z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((ee,q)=>{this._resolvePromise=ee,this._rejectPromise=q}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function v(H,Z){const ee=new f(Z);return ee.registerDisposable(H.onControlMessage(q=>{const F=JSON.parse(q.toString()),V=G(F);V?ee.reject(V):ee.resolve(F)})),ee.promise}function w(H,Z,ee,q,F,V,$){const B=new f($);return Z.connect(ee,q,F,V,(te,se)=>{B.didTimeout?(te&&H.error(te),se?.dispose()):te||!se?B.reject(te):B.resolve(se)}),B.promise}function g(H,Z){const ee=new f(Z);return H.then(q=>{ee.didTimeout||ee.resolve(q)},q=>{ee.didTimeout||ee.reject(q)}),ee.promise}async function p(H,Z,ee,q){const F=W(H,Z);H.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let V;try{V=await w(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${y(Z)}-${H.reconnectionToken}`,q)}catch(ce){throw H.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let $,B;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(V,null),$=H.reconnectionProtocol,B=!1):($=new E.PersistentProtocol(V,null),B=!0),H.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const te=await g(H.signService.createNewMessage((0,C.generateUuid)()),q),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:te.data};$.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await v($,S(q,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(H.logService.trace(`${F} 4/6. received SignRequest control message.`),!await g(H.signService.validate(te,ce.signedData),q)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const ge=await g(H.signService.sign(ce.data),q),me={type:"connectionType",commit:H.commit,signedData:ge,desiredConnectionType:Z};return ee&&(me.args=ee),H.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),$.sendControl(n.VSBuffer.fromString(JSON.stringify(me))),{protocol:$,ownsProtocol:B}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${F} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${F} received error control message when negotiating connection. Error:`),H.logService.error(ce)),B&&U($),ce}}async function l(H,Z,ee,q){const F=Date.now(),V=W(H,Z),{protocol:$,ownsProtocol:B}=await p(H,Z,ee,q),te=new f(q);return te.registerDisposable($.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=G(ce);he?(H.logService.error(`${V} received error control message when negotiating connection. Error:`),H.logService.error(he),B&&U($),te.reject(he)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${X(F)}!`),te.resolve({protocol:$,firstMessage:ce}))})),te.promise}async function r(H,Z){const{protocol:ee}=await l(H,1,void 0,Z);return{protocol:ee}}async function a(H,Z,ee){const{protocol:q,firstMessage:F}=await l(H,2,Z,ee),V=F&&F.debugPort;return{protocol:q,debugPort:V}}async function i(H,Z,ee){const q=Date.now(),F=W(H,3),{protocol:V}=await p(H,3,Z,ee);return H.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${X(q)}!`),V}async function t(H,Z,ee){const{host:q,port:F,connectionToken:V}=await H.addressProvider.getAddress();return{commit:H.commit,host:q,port:F,connectionToken:V,reconnectionToken:Z,reconnectionProtocol:ee,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function s(H,Z,ee){try{const q=(0,C.generateUuid)(),F=await t(H,q,null),{protocol:V}=await r(F,L.CancellationToken.None);return new M(H,Z,ee,q,V)}catch(q){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(q),k.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=s;async function o(H,Z){try{const ee=(0,C.generateUuid)(),q=await t(H,ee,null),{protocol:F,debugPort:V}=await a(q,Z,L.CancellationToken.None);return new j(H,Z,ee,F,V)}catch(ee){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(ee),k.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(ee)),ee}}e.connectRemoteAgentExtensionHost=o;async function c(H,Z,ee){const q=await t(H,(0,C.generateUuid)(),null);return await i(q,{host:Z,port:ee},L.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function u(H){return(0,D.createCancelablePromise)(Z=>new Promise((ee,q)=>{const F=setTimeout(ee,H*1e3);Z.onCancellationRequested(()=>{clearTimeout(F),ee()})}))}var m;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(Z,ee){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.type=0}}e.ConnectionLostEvent=I;class _{constructor(Z,ee,q,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.durationSeconds=q,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Z,ee,q){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=O;class N{constructor(Z,ee,q){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=q,this.type=4}}e.ConnectionGainEvent=N;class z{constructor(Z,ee,q,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=q,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=z;class k extends R.Disposable{constructor(Z,ee,q,F){super();this._connectionType=Z,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=ee,this.reconnectionToken=q,this.protocol=F,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(F.onSocketClose(V=>{const $=x(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${$} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${$} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${$} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(()=>{const V=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} received socket timeout event.`),this._beginReconnecting()})),k._instances.push(this),k._permanentFailure&&this._gotoPermanentFailure(k._permanentFailureMillisSinceLastIncomingData,k._permanentFailureAttempt,k._permanentFailureHandled)}static triggerPermanentFailure(Z,ee,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=ee,this._permanentFailureHandled=q,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(k._permanentFailure)return;const Z=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const F=q<ee.length?ee[q]:ee[ee.length-1];try{if(F>0){const $=u(F);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,$)),this._options.logService.info(`${Z} waiting for ${F} seconds before reconnecting...`);try{await $}catch{}}if(k._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${Z} resolving connection...`);const V=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,h(b)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,A.isCancellationError)(V)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,P.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!k._permanentFailure)}_gotoPermanentFailure(Z,ee,q){this._onDidStateChange.fire(new z(this.reconnectionToken,Z,ee,q)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=k,k._permanentFailure=!1,k._permanentFailureMillisSinceLastIncomingData=0,k._permanentFailureAttempt=0,k._permanentFailureHandled=!1,k._instances=[];class M extends k{constructor(Z,ee,q,F,V){super(1,Z,F,V);this.client=this._register(new E.Client(V,{remoteAuthority:ee,clientId:q},Z.ipcLogger))}async _reconnect(Z,ee){await r(Z,ee)}}e.ManagementPersistentConnection=M;class j extends k{constructor(Z,ee,q,F,V){super(2,Z,q,F);this._startArguments=ee,this.debugPort=V}async _reconnect(Z,ee){await a(Z,this._startArguments,ee)}}e.ExtensionHostPersistentConnection=j;function U(H){try{H.acceptDisconnect();const Z=H.getSocket();H.dispose(),Z.dispose()}catch(Z){(0,A.onUnexpectedError)(Z)}}function G(H){if(H&&H.type==="error"){const Z=new Error(`Connection error: ${H.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function K(H,Z){for(;H.length<Z;)H+=" ";return H}function x(H,Z,ee){return`[remote-connection][${K(y(H),13)}][${Z.substr(0,5)}\u2026][${ee?"reconnect":"initial"}]`}function W(H,Z){return`${x(Z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function X(H){return`${Date.now()-H} ms`}}),define(ie[185],re([0,1,18]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=n;function L(E){if(!E)return;const P=E.indexOf("+");return P<0?E:E.substr(0,P)}e.getRemoteName=L;function A(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=A;function T(E){if(E.folders.length)return E.folders.every(P=>A(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&A(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=T;function R(E){return T(E)?.scheme}e.getVirtualWorkspaceScheme=R;function C(E){return T(E)!==void 0}e.isVirtualWorkspace=C}),define(ie[90],re([0,1,27,6,185]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=A;function T(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,h){if(typeof y=="undefined"||y===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof y=="string"||typeof h=="string"){let S=typeof y=="string"?y:y.value,f=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(S,f)}return y._lower===h._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=C;function E(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function P(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function b(d,y){if(y){const h=`onResolveRemoteAuthority:${(0,L.getRemoteName)(y)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[31],re([0,1,27,90]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(h,S){return h.uuid&&S.uuid?h.uuid===S.uuid:h.id===S.id?!0:(0,D.compareIgnoreCase)(h.id,S.id)===0}e.areSameExtensions=L;class A{constructor(S,f){this.version=f,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof A?L(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=A;function T(h,S){return`${h}.${S}`}e.getExtensionId=T;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function C(h,S){return R(T(h,S))}e.getGalleryExtensionId=C;function E(h,S){const f=[],v=w=>{for(const g of f)if(g.some(p=>L(S(p),S(w))))return g;return null};for(const w of h){const g=v(w);g?g.push(w):f.push([w])}return f}e.groupByExtension=E;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function b(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function d(h){const S=new Set;if(h.malicious)for(const f of h.malicious)S.add(f.id);return S}e.getMaliciousExtensionsSet=d;function y(h,S){const f=[],v=S.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const w=v.shift();if(w&&f.every(g=>!L(g.identifier,{id:w}))){const g=h.filter(p=>L(p.identifier,{id:w}));g.length===1&&(f.push(g[0]),v.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=y}),define(ie[186],re([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function n(L,A,T,R,C){try{const E=await L.getExtensionsControlManifest();if(!E.unsupportedPreReleaseExtensions)return;const P=await L.getInstalled(1);for(const[b,{id:d,migrateStorage:y}]of Object.entries(E.unsupportedPreReleaseExtensions)){const h=P.find(f=>(0,D.areSameExtensions)(f.identifier,{id:b}));if(!h)continue;const S=await A.getCompatibleExtension({id:d},!0,await L.getTargetPlatform());if(!S){C.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{C.info(`Migrating '${h.identifier.id}' extension to '${d}' extension...`);const f=!R.getDisabledExtensions().some(w=>(0,D.areSameExtensions)(w,h.identifier));await L.uninstall(h),C.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let v=P.find(w=>(0,D.areSameExtensions)(w.identifier,{id:d}));(!v||!v.isPreReleaseVersion&&f)&&(v=await L.installFromGallery(S,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),C.info(`Installed the pre-release extension '${v.identifier.id}'`),f||(await R.disableExtension(v.identifier),C.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),y&&(T.addToMigrationList((0,D.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,D.getExtensionId)(v.manifest.publisher,v.manifest.name)),C.info("Added pre-release extension to the storage migration list"))),C.info(`Migrated '${h.identifier.id}' extension to '${d}' extension.`)}catch(f){C.error(f)}}}catch(E){C.error(E)}}e.migrateUnsupportedExtensions=n}),define(ie[187],re([0,1,5,9,2,4,19,61,7,29,22,13,30,31,14,8]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends L.Disposable{constructor(g,p,l,r){super();this.fileService=p,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=C.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,p){await this.cleanUpPromise;const l=this.getName(g),r=(0,T.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const a=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(g,a,p);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(a)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,a.path),i}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,p,l){try{await P.Promises.rename(g.fsPath,p.fsPath)}catch(r){if(A.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${p} with 'EPERM' error. Trying again...`),this.rename(g,p,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const p=[],l=[];for(const i of g.children){const t=this.parse(i.name);t&&l.push([t,i])}const r=(0,y.groupByExtension)(l,([i])=>i),a=[];for(const i of r)i.sort((t,s)=>R.rcompare(t[0].version,s[0].version)),p.push(...i.slice(1).map(t=>t[1].resource)),a.push(i[0][1]);a.sort((i,t)=>i.mtime-t.mtime),p.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(i=>i.resource)),await D.Promises.settled(p.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new y.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(g){const p=f.exec(g);return p&&p[1]&&p[2]?new y.ExtensionIdentifierWithVersion({id:p[1]},p[2]):null}};v=de([Y(0,b.INativeEnvironmentService),Y(1,h.IFileService),Y(2,d.IExtensionGalleryService),Y(3,S.ILogService)],v),e.ExtensionsDownloader=v}),define(ie[188],re([0,1,2,10,22,90]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(C,E){super();this.environmentService=C,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(E.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(C){C.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ie[189],re([0,1,83,16,5,2,18,10,22,13,30,31,59,8]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends A.Disposable{constructor(v,w,g){super();this.extensionManagementService=v,this.logService=g,this.cache=this._register(new S(w,g)),this.extensionManagementService.registerParticipant({postInstall:async p=>this.postInstallExtension(p),postUninstall:async p=>this.postUninstallExtension(p)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),w=["en",...Object.keys(v)];return(0,n.distinct)(w)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const w=await this.cache.getLanguagePacks();Object.keys(w).some(g=>w[g]&&w[g].extensions.some(p=>(0,b.areSameExtensions)(p.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(w);return!(0,n.equals)(Object.keys(v),Object.keys(g))}};h=de([Y(0,P.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,y.ILogService)],h),e.LocalizationsService=h;let S=class extends A.Disposable{constructor(v,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(w=>{Object.keys(w).forEach(g=>delete w[g]),this.createLanguagePacksFromExtensions(w,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...w){for(const g of w)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,g);Object.keys(v).forEach(g=>this.updateHash(v[g]))}createLanguagePacksFromExtension(v,w){const g=w.identifier,p=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of p)if(w.location.scheme===T.Schemas.file&&(0,d.isValidLocalization)(l)){let r=v[l.languageId];r||(r={hash:"",extensions:[],translations:{}},v[l.languageId]=r);let a=r.extensions.filter(i=>(0,b.areSameExtensions)(i.extensionIdentifier,g))[0];a?a.version=w.manifest.version:r.extensions.push({extensionIdentifier:g,version:w.manifest.version});for(const i of l.translations)r.translations[i.id]=(0,R.join)(w.location.fsPath,i.path)}}updateHash(v){if(v){const w=(0,D.createHash)("md5");for(const g of v.extensions)w.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);v.hash=w.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(w=v(g),g)).then(g=>{for(const l of Object.keys(g))g[l]||delete g[l];this.languagePacks=g,this.initializedCache=!0;const p=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",p),C.Promises.writeFile(this.languagePacksFilePath,p)}).then(()=>w,g=>this.logService.error(g))})}};S=de([Y(0,E.INativeEnvironmentService),Y(1,y.ILogService)],S)}),define(ie[190],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ie[62],re([0,1,3,4,6,8]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var T;(function(h){h.Http="http",h.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!S)return{address:S[1],port:+S[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=b;function d(h,S){return S?S!==1&&h<1024:!n.isWindows&&h<1024}e.isPortPrivileged=d;let y=class{constructor(S){this.logService=S,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(S){return this._tunnelProvider=S,S?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(S){this._canElevate=S.elevation,this._privacyOptions=S.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const S=[],f=Array.from(this._tunnels.values());for(let v of f){const w=Array.from(v.values());for(let g of w){const p=await g.value;p&&S.push(p)}}return S}async dispose(){for(const S of this._tunnels.values()){for(const{value:f}of S.values())await f.then(v=>v?.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,f,v,w,g=!1,p=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${w}.`),!S)return;f||(f="localhost");const r=this.retainOrCreateTunnel(S,f,v,w,g,p,l);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(a);return(a.tunnelRemoteHost!==f||a.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const f=this._tunnels.get(S.tunnelRemoteHost);if(f){const v=f.get(S.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,v))}}}}async tryDisposeTunnel(S,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${f}.`);const w=v.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(f),w}}async closeTunnel(S,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${f} `);const v=this._tunnels.get(S);if(v&&v.has(f)){const w=v.get(f);w.refcount=0,await this.tryDisposeTunnel(S,f,w)}}addTunnelToMap(S,f,v){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(S,f){const v=this._tunnels.get(S);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,f){let v=[S];P(S)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):b(S)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const w=v.map(g=>this._tunnels.get(g));for(const g of w){const p=g?.get(f);if(p)return p}}canTunnel(S){return!!E(S)}createWithProvider(S,f,v,w,g,p,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${w}.`);const a={elevationRequired:g?d(w===void 0?v:w):!1},i={remoteAddress:{host:f,port:v},localAddressPort:w,privacy:p,public:p!==R.Private,protocol:l},t=S.forwardPort(i,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(f,v,t),t}};y=de([Y(0,A.ILogService)],y),e.AbstractTunnelService=y}),define(ie[191],re([0,1,8,62,2,9,5]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let C=class Ct extends L.Disposable{constructor(P,b){super();this._tunnelService=P,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,b,d,y,h,S){const f=new R,v=await Promise.resolve(this._tunnelService.openTunnel(P,f,d,y,h,S));if(!v)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${y} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),f.dispose(),await v.dispose(),(0,A.canceled)();return f.setTunnel(v),this._tunnels.set(b,f),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${v.localAddress} (local) to ${d}:${y} (remote).`),{tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress}}async setAddress(P,b){const d=this._tunnels.get(P);!d||d.setAddress(b)}async destroyTunnel(P){const b=this._tunnels.get(P);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await b.dispose();return}this._disposedTunnels.add(P)}};C._lastId=0,C=de([Y(0,n.ISharedTunnelsService),Y(1,D.ILogService)],C),e.SharedProcessTunnelService=C}),define(ie[192],re([0,1,119,20,8]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,C){this.configurationService=R,this.logService=C}request(R,C){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(R,C)}async resolveProxy(R){}};A=de([Y(0,n.IConfigurationService),Y(1,L.ILogService)],A),e.RequestService=A}),define(ie[43],re([0,1,17,140,42,6,38]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function C(h){return h.res.statusCode===204}async function E(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return C(h)?null:(await(0,D.streamToBuffer)(h.stream)).toString()}e.asText=E;async function P(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(C(h))return null;const f=(await(0,D.streamToBuffer)(h.stream)).toString();try{return JSON.parse(f)}catch(v){throw v.message+=`:
`+f,v}}e.asJson=P;function b(h){y(h)}e.updateProxyConfigurationsScope=b;let d;function y(h){const S=T.Registry.as(L.Extensions.Configuration),f=d;d={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[d],remove:f?[f]:[]})}y(2)}),define(ie[193],re([0,1,25,18,14,43]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(C,E){this.requestService=C,this.fileService=E}async download(C,E,P=D.CancellationToken.None){if(C.scheme===n.Schemas.file||C.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(C,E);return}const b={type:"GET",url:C.toString()},d=await this.requestService.request(b,P);if(d.res.statusCode===200)await this.fileService.writeFile(E,d.stream);else{const y=await(0,A.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${y}`)}}};T=de([Y(0,A.IRequestService),Y(1,L.IFileService)],T),e.DownloadService=T}),define(ie[194],re([0,1,16,25,67,2,19,154,14,8,26,43]),function(J,e,D,n,L,A,T,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends A.Disposable{constructor(h,S,f,v){super();this.fileService=h,this.productService=S,this.requestService=f,this.logService=v,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const S=[];for(const[f,v]of this.allConfigBasedTips)if(!(v.configScheme&&v.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,T.joinPath)(h,f)),g=new Map;(0,L.forEach)(v.recommendations,({key:l,value:r})=>{if((0,D.isNonEmptyArray)(r.remotes))for(const a of r.remotes)g.set(a,{extensionId:l,extensionName:r.name,configName:v.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else S.push({extensionId:l,extensionName:r.name,configName:v.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const p=(0,R.getDomainsOfRemotes)(w.value.toString(),[...g.keys()]);for(const l of p){const r=g.get(l);r&&S.push(r)}}catch{}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(h.res.statusCode!==200)return[];const S=await(0,b.asJson)(h);return S?S.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=de([Y(0,C.IFileService),Y(1,P.IProductService),Y(2,b.IRequestService),Y(3,E.ILogService)],d),e.ExtensionTipsService=d}),define(ie[46],re([0,1,17,29]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(A,T,R){let C=R&&R.get("storage.serviceMachineId",0)||null;if(C)return C;try{const P=(await T.readFile(A.serviceMachineIdResource)).value.toString();C=(0,n.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,n.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,D.VSBuffer.fromString(C))}catch{}}return R&&R.store("storage.serviceMachineId",C,0,1),C}e.getServiceMachineId=L}),define(ie[91],re([0,1,70,6]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(A){return(0,D.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ie[195],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ie[196],re([0,1,74,152,5,25,3,2,18,4,29,13,8,26,91,195]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let f=class{constructor(g,p,l){this.logService=g,this.productService=p,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(g){const p=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${p})`);const l=(0,h.hash)(g);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${p})`),this.doDisposeWorker(g));const r=new A.CancellationTokenSource;let a,i,t;this.processeDisposables.set(l,u=>{r.dispose(!0),a?.terminate(g,A.CancellationToken.None),i?.close(),t?.close(),this.processeDisposables.delete(l);const m=this.processResolvers.get(l);m&&(this.processResolvers.delete(l),m({reason:u}))}),a=await this.getOrCreateWebWorker(g);const s=new Promise(u=>{this.processResolvers.set(l,u)});if(r.token.isCancellationRequested)return s;const{port1:o,port2:c}=new MessageChannel;return i=o,t=c,await a.spawn(g,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${p})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[i])),s}getOrCreateWebWorker(g){let p=this.workers.get(g.process.moduleId);if(!p){this.logService.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const l=new v(g.process.type,this.logService,this.productService,this.environmentService);p=l.init(),l.onDidProcessSelfTerminate(({configuration:r,reason:a})=>{this.doDisposeWorker(r,a)}),this.workers.set(g.process.moduleId,p)}return p}async disposeWorker(g){return this.doDisposeWorker(g)}doDisposeWorker(g,p){const l=this.processeDisposables.get((0,h.hash)(g));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),l(p))}};f=de([Y(0,d.ILogService),Y(1,y.IProductService),Y(2,b.INativeEnvironmentService)],f),e.SharedProcessWorkerService=f;class v extends R.Disposable{constructor(g,p,l,r){super();this.type=g,this.logService=p,this.productService=l,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const g=new L.DeferredPromise,p=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return p.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},p.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},p.onmessage=l=>{const{id:r,message:a,configuration:i,nonce:t}=l.data;switch(r){case S.SharedProcessWorkerMessages.Ready:g.complete(p);break;case S.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case S.SharedProcessWorkerMessages.SelfTerminated:i&&a&&this._onDidProcessSelfTerminate.fire({configuration:i,reason:JSON.parse(a)});break;case S.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case S.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case S.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case S.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},p.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async send(g,p,l){const r=await this.workerReady;if(!p.isCancellationRequested)return new Promise(a=>{const i=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(i,a);const t={...g,nonce:i};l?r.postMessage(t,[l]):r.postMessage(t),p.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(i)&&a()})})}spawn(g,p,l){const r={id:S.SharedProcessWorkerMessages.Spawn,configuration:g,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,l,p)}getSharedProcessWorkerEnvironment(){const g={bootstrapPath:C.FileAccess.asFileUri("bootstrap-fork",J).fsPath,env:Object.create(null)};if(E.isLinux){const p={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&l&&(0,P.isUUID)(l)){const t=r["linux-x64"];p.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),p.uploadToServer=!0}const i=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;g.env.BREAKPAD_DUMP_LOCATION=(0,n.join)(i,this.type),g.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(p)}return g}terminate(g,p){const l={id:S.SharedProcessWorkerMessages.Terminate,configuration:g};return this.send(l,p)}}}),define(ie[197],re([0,1,53,18,153]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}de([D.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(ie[92],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ie[198],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((L,A)=>J(["vsda"],L,A))}async createNewMessage(L){try{const A=await this.vsda(),T=new A.validator;if(T){const R=String(D._nextId++);return this.validators.set(R,T),{id:R,data:T.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const T=this.validators.get(L.id);if(!T)return!1;this.validators.delete(L.id);try{return T.validate(A)==="ok"}catch{return!1}}async sign(L){try{const A=await this.vsda(),T=new A.signer;if(T)return T.sign(L)}catch{}return L}}e.SignService=D,D._nextId=1}),define(ie[23],re([0,1,5,3,2,176,15,75,6]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var d;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class y extends L.Disposable{constructor(v={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,w){w===E?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:w,target:this.getKeyTargets(v)[w]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,w,g){return this.getStorage(w)?.get(v,g)}getBoolean(v,w,g){return this.getStorage(w)?.getBoolean(v,g)}getNumber(v,w,g){return this.getStorage(w)?.getNumber(v,g)}store(v,w,g,p){if((0,T.isUndefinedOrNull)(w)){this.remove(v,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,g,p),this.getStorage(g)?.set(v,w)})}remove(v,w){this.withPausedEmitters(()=>{this.updateKeyTarget(v,w,void 0),this.getStorage(w)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,w){const g=[],p=this.getKeyTargets(v);for(const l of Object.keys(p))p[l]===w&&g.push(l);return g}updateKeyTarget(v,w,g){const p=this.getKeyTargets(w);typeof g=="number"?p[v]!==g&&(p[v]=g,this.getStorage(w)?.set(E,JSON.stringify(p))):typeof p[v]=="number"&&(delete p[v],this.getStorage(w)?.set(E,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const w=this.get(E,v);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=P.NONE){this._onWillSaveState.fire({reason:v});const w=this.getStorage(0),g=this.getStorage(1);switch(v){case P.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return S(v,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends y{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=h;async function S(f,v,w,g){const p=o=>{try{return JSON.parse(o)}catch{return o}},l=new Map,r=new Map;f.forEach((o,c)=>{l.set(c,o),r.set(c,p(o))});const a=new Map,i=new Map;v.forEach((o,c)=>{a.set(c,o),i.set(c,p(o))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((o,c)=>{t.push({key:c,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let s=[];a.forEach((o,c)=>{s.push({key:c,value:o})}),console.table(s),console.groupEnd(),console.log(i)}e.logStorage=S}),define(ie[199],re([0,1,3,2,15,30,31,23]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends n.Disposable{constructor(b,d){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(b)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(d.onDidInstallExtensions(y=>y.forEach(({local:h,operation:S})=>{h&&S===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(b,d){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:d}),!0):!1}async disableExtension(b,d){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){let d=this.getDisabledExtensions();return d.every(y=>!(0,T.areSameExtensions)(y,b))?(d.push(b),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(b){let d=this.getDisabledExtensions();for(let y=0;y<d.length;y++){const h=d[y];if((0,T.areSameExtensions)(h,b))return d.splice(y,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(b){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,d){this.storageManger.set(b,d,0)}};C=de([Y(0,R.IStorageService),Y(1,A.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class E extends n.Disposable{constructor(b){super();this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(b,d){let y;return d===0?((0,L.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,d)),y=this.storage[b]):y=this._get(b,d),JSON.parse(y)}set(b,d,y){let h=JSON.stringify(d.map(({id:f,uuid:v})=>({id:f,uuid:v})));this._get(b,y)!==h&&(y===0&&(d.length?this.storage[b]=h:delete this.storage[b]),this._set(b,d.length?h:void 0,y))}onDidStorageChange(b){if(b.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const y=this.get(b.key,b.scope);delete this.storage[b.key];const h=this.get(b.key,b.scope),S=y.filter(v=>!h.some(w=>(0,T.areSameExtensions)(v,w))),f=h.filter(v=>!y.some(w=>(0,T.areSameExtensions)(w,v)));(S.length||f.length)&&this._onDidChange.fire([...S,...f])}}_get(b,d){return this.storageService.get(b,d,"[]")}_set(b,d,y){d?this.storageService.store(b,d,y,1):this.storageService.remove(b,y)}}e.StorageManager=E}),define(ie[63],re([0,1,6,3,2,23,31,26,16,8,15]),function(J,e,D,n,L,A,T,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let d=class nt extends L.Disposable{constructor(h,S,f){super();this.storageService=h,this.productService=S,this.logService=f,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(v=>this.onDidChangeStorageValue(v)))}static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const S=b.exec(h);if(S&&S[1])return{id:S[1],version:S[2]}}initialize(){const h=this.storageService.keys(0,1);for(const S of h){const f=nt.fromKey(S);f&&this.extensionsWithKeysForSync.add(f.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=nt.fromKey(h.key);if(S){this.extensionsWithKeysForSync.add(S.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(h){if((0,P.isString)(h))return h;const S=h.manifest?h.manifest.publisher:h.publisher,f=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(S,f)}getExtensionState(h,S){const f=this.getExtensionId(h),v=this.storageService.get(f,S?0:1);if(v)try{return JSON.parse(v)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${S}): ${w}`)}}setExtensionState(h,S,f){const v=this.getExtensionId(h);S===void 0?this.storageService.remove(v,f?0:1):this.storageService.store(v,JSON.stringify(S),f?0:1,1)}setKeysForSync(h,S){this.storageService.store(nt.toKey(h),JSON.stringify(S),0,1)}getKeysForSync(h){const S=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],f=this.storageService.get(nt.toKey(h),0),v=f?JSON.parse(f):void 0;return v&&S?(0,C.distinct)([...v,...S]):v||S}addToMigrationList(h,S){if(h!==S){const f=this.migrationList.filter(v=>!v.includes(h)&&!v.includes(S));f.push([h,S]),this.migrationList=f}}getSourceExtensionToMigrate(h){const S=this.migrationList.find(([,f])=>h===f);return S?S[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const S=JSON.parse(h);if((0,P.isArray)(S))return S}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};d=de([Y(0,A.IStorageService),Y(1,R.IProductService),Y(2,E.ILogService)],d),e.ExtensionStorageService=d}),define(ie[200],re([0,1,2,30,63,186,8]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(E,P,b,d,y){super();E.removeDeprecatedExtensions(),(0,A.migrateUnsupportedExtensions)(E,P,b,d,y)}};R=de([Y(0,n.IExtensionManagementService),Y(1,n.IExtensionGalleryService),Y(2,L.IExtensionStorageService),Y(3,n.IGlobalExtensionEnablementService),Y(4,T.ILogService)],R),e.ExtensionsCleaner=R}),define(ie[201],re([0,1,3,2]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P}async getItems(){const E={workspace:this.workspace},P=await this.channel.call("getItems",E);return new Map(P)}updateItems(E){const P={workspace:this.workspace};return E.insert&&(P.insert=Array.from(E.insert.entries())),E.delete&&(P.delete=Array.from(E.delete.values())),this.channel.call("updateItems",P)}}class A extends L{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class T extends L{constructor(E,P){super(E,P);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends n.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ie[202],re([0,1,5,2,19,75,23,201]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class C extends T.AbstractStorageService{constructor(P,b,d){super();this.mainProcessService=b,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),b=new A.Storage(P.globalStorage);return this._register(b.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),b}createWorkspaceStorage(P){const b=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(b.workspaceStorage){const d=new A.Storage(b.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)),this.workspaceStorageId=P?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const b=this.workspaceStorage,d=b?.items??new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[y,h]of d)this.workspaceStorage.set(y,h)}}e.NativeStorageService=C}),define(ie[203],re([0,1,4,32,7,29]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,P,b,d,y,h,S,f,v,w){const g=Object.create(null);g["common.machineId"]=S,g.sessionID=(0,A.generateUuid)()+Date.now(),g.commitHash=y,g.version=h,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,D.PlatformToString)(D.platform),g["common.nodePlatform"]=n.platform,g["common.nodeArch"]=d,g["common.product"]=w||"desktop";const p=C(f||[]);p&&(g["common.msftInternal"]=p);let l=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(g["common.snap"]="true");const a=T(b);a&&(g["common.platformDetail"]=a);try{const i=await E.readFile(L.URI.file(v));g["common.source"]=i.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=R;function C(E){const P=n.env.USERDNSDOMAIN;if(!P)return!1;const b=P.toLowerCase();return E.some(d=>b===d)}e.verifyMicrosoftInternalDomain=C}),define(ie[21],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[204],re([0,1,33,54,5,35,18,10,4,7,113,22,116,80,14,26,21]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(r,a){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=D.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:O=>/^[a-z]:\\(my drive|shared drives)\\/.test(O)||O.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:O=>O.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"\\onedrive")},{tag:"box",matcher:O=>O.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:O=>O.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:O=>O.startsWith("/volumes/googledrive/")||O.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:O=>O.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"/onedrive")||O.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:O=>O.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:O=>O.startsWith(s+"/box/")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:O=>O.startsWith(s+"/owncloud/")}];break}const o=new Map,c=new Map,u=2e4;function m(O,N,z,k){for(const j of t){const U=O.toLowerCase();j.matcher(U)&&c.set(j.tag,1)}const M=N.substring(O.length+1);return L.Promises.withAsyncBody(async j=>{let U;try{U=await b.Promises.readdir(N,{withFileTypes:!0})}catch{j();return}if(k.count>=u){k.count+=U.length,k.maxReached=!0,j();return}let G=U.length;if(G===0){j();return}let K=U;k.count+U.length>u&&(k.maxReached=!0,G=u-k.count,K=U.slice(0,G)),k.count+=U.length;for(const x of K)if(x.isDirectory()){if(z.includes(x.name)||await m(O,(0,R.join)(N,x.name),z,k),--G==0){j();return}}else{const W=x.name.lastIndexOf(".");if(W>=0){const X=x.name.substring(W+1);X&&o.set(X,(o.get(X)??0)+1)}for(const X of i)X.relativePathPattern?.test(M)!==!1&&X.filePattern.test(x.name)&&c.set(X.tag,(c.get(X.tag)??0)+1);if(--G==0){j();return}}})}const I={count:0,maxReached:!1};await m(r,r,a,I);const _=await p(r);return{configFiles:w(c),fileTypes:w(o),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:_}}e.collectWorkspaceStats=v;function w(r){return[...n.Iterable.map(r.entries(),([a,i])=>({name:a,count:i}))].sort((a,i)=>i.count-a.count)}function g(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=g;async function p(r){try{const a=new Map,i=(0,R.join)(r,".vscode","launch.json"),t=await b.Promises.readFile(i),s=[],o=(0,A.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,A.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const u=c.type;u&&(a.has(u)?a.set(u,a.get(u)+1):a.set(u,1))}return w(a)}catch{return[]}}e.collectLaunchConfigs=p;let l=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||i.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,d.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,c=this.formatProcessList(a,s);return i.forEach(u=>{if((0,y.isRemoteDiagnosticError)(u))c+=`
${u.errorMessage}`,o+=`
${u.errorMessage}`;else if(c+=`

Remote: ${u.hostName}`,u.processes&&(c+=`
${this.formatProcessList(a,u.processes)}`),u.workspaceMetadata){o+=`
|  Remote: ${u.hostName}`;for(const m of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[m];let _=`${I.fileCount} files`;I.maxFilesReached&&(_=`more than ${_}`),o+=`|    Folder (${m}): ${_}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:t,vmHint:s,os:o,cpus:c}=g(),u={os:o,memory:t,cpus:c,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return C.isWindows||(u.load=`${D.loadavg().map(m=>Math.round(m)).join(", ")}`),C.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(a,i){const t=[];return(0,d.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),i.forEach(o=>{if((0,y.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const u=o.workspaceMetadata[c];let m=`${u.fileCount} files`;u.maxFilesReached&&(m=`more than ${m}`),t.push(`Folder (${c}): ${m}`),t.push(this.formatWorkspaceStats(u))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const i=[],t=60;let s=0;const o=(I,_)=>{const O=` ${I}(${_})`;s+O.length>t?(i.push(c),c="|                 ",s=c.length):s+=O.length,c+=O};let c="|      File types:";const u=10;let m=a.fileTypes.length>u?u:a.fileTypes.length;for(let I=0;I<m;I++){const _=a.fileTypes[I];o(_.name,_.count)}if(i.push(c),a.configFiles.length>=0&&(c="|      Conf files:",s=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),i.push(c)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(_=>{I+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),i.push(I)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=E.URI.revive(o);if(c.scheme===T.Schemas.file){const u=c.fsPath;t.push(v(u,["node_modules",".git"]).then(m=>{let I=`${m.fileCount} files`;m.maxFilesReached&&(I=`more than ${I}`),i.push(`|    Folder (${(0,R.basename)(u)}): ${I}`),i.push(this.formatWorkspaceStats(m))}).catch(m=>{i.push(`|      Error: Unable to collect workspace stats for folder ${u} (${m.toString()})`)}))}else i.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,i){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,t,s,i,0),s.join(`
`)}formatProcessItem(a,i,t,s,o){const c=o===0;let u;c?u=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(u=`${u} (${i.get(s.pid)})`));const m=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(m/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(s.children)&&s.children.forEach(I=>this.formatProcessItem(a,i,t,I,o+1))}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const t=E.URI.revive(i);if(t.scheme!==T.Schemas.file)continue;const s=t.fsPath;try{const o=await v(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};l=de([Y(0,f.ITelemetryService),Y(1,S.IProductService)],l),e.DiagnosticsService=l}),define(ie[205],re([0,1,16,5,25,9,3,2,4,15,7,129,30,31,8,26,21]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let v=class extends R.Disposable{constructor(a,i,t,s){super();this.galleryService=a,this.telemetryService=i,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const i=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,d.isTargetPlatformCompatible)(t,a.allTargetPlatforms,i))}async installFromGallery(a,i={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(b.localize(0,null),d.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw p(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),g(t)}}async uninstall(a,i={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,i)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const i=await this.findGalleryExtension(a);if(!i)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,i,t){if(!P.URI.isUri(i)){let m=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(m)return this.logService.info("Extensions is already requested to install",i.identifier.id),m.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],c=this.createInstallExtensionTask(a,i,t);P.URI.isUri(i)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:i}),this.logService.info("Installing extension:",c.identifier.id),s.push({task:c,manifest:a});let u=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:_,manifest:O}of I)if(u=u||!!O.extensionDependencies?.some(N=>(0,y.areSameExtensions)({id:N},c.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const N=this.createInstallExtensionTask(O,_,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(N.identifier,O.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:_}),this.logService.info("Installing extension:",N.identifier.id),s.push({task:N,manifest:O})}}catch(I){if(P.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,I.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),I}const m=s.reduce((I,{task:_,manifest:O})=>(I.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),I),new Map);for(;m.size;){let I;const _=[...m.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(N=>m.has(N.toLowerCase())));_.length?I=m.size===1?_:_.filter(({task:O})=>!(O===c&&!u)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),I=[...m.values()]),await this.joinAllSettled(I.map(async({task:O})=>{const N=new Date().getTime(),z=(0,E.isUndefined)(t.operation)?O.operation:t.operation;try{const k=await O.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(k,O.source,t,L.CancellationToken.None))),!P.URI.isUri(O.source)&&(p(this.telemetryService,z===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,void 0),C.isWeb&&z!==3))try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"install")}catch{}o.push({local:k,identifier:O.identifier,operation:z,source:O.source})}catch(k){throw P.URI.isUri(O.source)||p(this.telemetryService,z===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,k),this.logService.error("Error while installing the extension:",O.identifier.id),k}finally{m.delete(O.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,y.areSameExtensions)(I,c.identifier))[0].local}catch(m){if(s.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<I.length;_++){const O=I[_],{identifier:N}=o[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,A.getErrorMessage)(O.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(I),o.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),m}finally{for(const{task:m,manifest:I}of s)if(!P.URI.isUri(m.source)){const _=new y.ExtensionIdentifierWithVersion(m.identifier,I.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(a){const i=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?i.push(o.value):t.push(o.reason);if(t.length)throw w(t);return i}async getAllDepsAndPackExtensionsToInstall(a,i,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const c=[a,...o.map(I=>I.identifier)],u=[],m=async(I,_)=>{const O=_.extensionDependencies||[],N=[...O];if(_.extensionPack){const z=t?o.find(k=>(0,y.areSameExtensions)(k.identifier,I)):void 0;for(const k of _.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(M=>(0,y.areSameExtensions)({id:M},{id:k}))||N.every(M=>!(0,y.areSameExtensions)({id:M},{id:k}))&&N.push(k)}if(N.length){const z=[...c,...u.map(M=>M.gallery.identifier)],k=N.filter(M=>z.every(j=>!(0,y.areSameExtensions)(j,{id:M})));if(k.length){const M=await this.galleryService.query({names:k,pageSize:N.length},L.CancellationToken.None);for(const j of M.firstPage){if(z.find(K=>(0,y.areSameExtensions)(K,j.identifier)))continue;const U=O.some(K=>(0,y.areSameExtensions)({id:K},j.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(j,!0,s)}catch(K){if(K instanceof d.ExtensionManagementError&&K.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw K}u.push({gallery:G.extension,manifest:G.manifest}),await m(G.extension.identifier,_)}}}};return await m(a,i),o=await this.getInstalled(),u.filter(I=>!o.some(_=>(0,y.areSameExtensions)(_.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,i,t){const s=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new d.ExtensionManagementError(b.localize(3,null,a.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new d.ExtensionManagementError(b.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const u=await this.getTargetPlatform();throw new d.ExtensionManagementError(b.localize(5,null,a.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(u)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,i,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(b.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new d.ExtensionManagementError(b.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const c=await this.galleryService.getManifest(o,L.CancellationToken.None);if(c===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new d.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(a,i,t){const s=await this.getTargetPlatform();let o=null;return i&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&i&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,i){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(m,I)=>{const _=this.createUninstallExtensionTask(m,I);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",m.identifier.id),this._onUninstallExtension.fire(m.identifier),_},o=(m,I)=>{I?this.logService.error("Failed to uninstall extension:",m.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",m.identifier.id),p(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(m),void 0,I),this._onDidUninstallExtension.fire({identifier:m.identifier,error:I?.code})},c=[],u=[];try{c.push(s(a,{}));const m=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,m);for(const _ of I)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):c.push(s(_,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(I=>I.extension),m,a),await this.joinAllSettled(c.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(I.extension,i,L.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(_){const O=_ instanceof d.ExtensionManagementError?_:new d.ExtensionManagementError((0,A.getErrorMessage)(_),d.ExtensionManagementErrorCode.Internal);throw o(I.extension,O),O}finally{u.push(I)}}))}catch(m){const I=m instanceof d.ExtensionManagementError?m:new d.ExtensionManagementError((0,A.getErrorMessage)(m),d.ExtensionManagementErrorCode.Internal);for(const _ of c){try{_.cancel()}catch{}u.includes(_)||o(_.extension,I)}throw I}finally{for(const m of c)this.uninstallingExtensions.delete(m.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",m.extension.identifier.id)}}checkForDependents(a,i,t){for(const s of a){const o=this.getDependents(s,i);if(o.length){const c=o.filter(u=>!a.some(m=>(0,y.areSameExtensions)(m.identifier,u.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(s,c,t))}}}getDependentsErrorMessage(a,i,t){return t===a?i.length===1?b.localize(8,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?b.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):b.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?b.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?b.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):b.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(a,i,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=i.filter(u=>!u.isBuiltin&&s.some(m=>(0,y.areSameExtensions)({id:m},u.identifier))),c=[];for(const u of o)c.push(...this.getAllPackExtensionsToUninstall(u,i,t));return[...o,...c]}return[]}getDependents(a,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,y.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const i=await this.findGalleryExtensionById(a.identifier.uuid);return i||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};v=de([Y(0,d.IExtensionGalleryService),Y(1,f.ITelemetryService),Y(2,h.ILogService),Y(3,S.IProductService)],v),e.AbstractExtensionManagementService=v;function w(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function g(r){if(r instanceof d.ExtensionManagementError)return r;const a=new d.ExtensionManagementError(r.message,d.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function p(r,a,i,t,s){const o=s?s instanceof d.ExtensionManagementError?s.code:d.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...i,success:!s,duration:t,errorcode:o})}e.reportTelemetry=p;class l{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>new Promise((i,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,A.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(ie[206],re([0,1,16,5,67,3,10,4,32,7,131,13,30,194,82,14,8,60,26,43,23,21]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let i=class extends y.ExtensionTipsService{constructor(s,o,c,u,m,I,_,O,N,z){super(_,O,N,z);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=c,this.storageService=u,this.nativeHostService=m,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,L.forEach)(O.exeBasedExtensionTips,({key:k,value:M})=>{const j=[],U=[],G=[];(0,L.forEach)(M.recommendations,({key:K,value:x})=>{x.important?M.important?j.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):U.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):G.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),j.length&&this.highImportanceExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:j}),U.length&&this.mediumImportanceExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:U}),G.length&&this.allOtherExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:G})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,c)}groupImportantTipsByExe(s,o){const c=new Map;s.forEach(O=>c.set(O.extensionId.toLowerCase(),O));const{installed:u,uninstalled:m}=this.groupByInstalled([...c.keys()],o);for(const O of u){const N=c.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of m){const N=c.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const I=this.getPromptedExecutableTips(),_=new Map;for(const O of m){const N=c.get(O);if(N&&(!I[N.exeName]||!I[N.exeName].includes(N.extensionId))){let z=_.get(N.exeName);z||(z=[],_.set(N.exeName,z)),z.push(N)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const u=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(u(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const u=this._register((0,n.disposableTimeout)(()=>{u.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,c=7*24*60*60*1e3;if(o<c){const I=this._register((0,n.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},c-o));return}const[u,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(I=>{switch(I){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(u),this.addToRecommendedExecutables(m[0].exeName,m);const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(u),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(s){const o=s.map(({extensionId:u})=>u.toLowerCase()),c=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,c,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const c=this.getPromptedExecutableTips();c[s]=o.map(({extensionId:u})=>u.toLowerCase()),this.storageService.store(r,JSON.stringify(c),0,0)}groupByInstalled(s,o){const c=[],u=[],m=o.reduce((I,_)=>(I.add(_.identifier.id.toLowerCase()),I),new Set);return s.forEach(I=>{m.has(I.toLowerCase())?c.push(I):u.push(I)}),{installed:c,uninstalled:u}}async getValidExecutableBasedExtensionTips(s){const o=[],c=new Map;for(const u of s.keys()){const m=s.get(u);if(!m||!(0,D.isNonEmptyArray)(m.recommendations))continue;const I=[];R.isWindows?m.windowsPath&&I.push(m.windowsPath.replace("%USERPROFILE%",C.env.USERPROFILE).replace("%ProgramFiles(x86)%",C.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",C.env.ProgramFiles).replace("%APPDATA%",C.env.APPDATA).replace("%WINDIR%",C.env.WINDIR)):(I.push((0,T.join)("/usr/local/bin",u)),I.push((0,T.join)("/usr/bin",u)),I.push((0,T.join)(this.environmentService.userHome.fsPath,u)));for(const _ of I){let O=c.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),c.set(_,O)),O)for(const{extensionId:N,extensionName:z,isExtensionPack:k}of m.recommendations)o.push({extensionId:N,extensionName:z,isExtensionPack:k,exeName:u,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return o}};i=de([Y(0,b.INativeEnvironmentService),Y(1,l.ITelemetryService),Y(2,d.IExtensionManagementService),Y(3,p.IStorageService),Y(4,v.INativeHostService),Y(5,h.IExtensionRecommendationNotificationService),Y(6,S.IFileService),Y(7,w.IProductService),Y(8,g.IRequestService),Y(9,f.ILogService)],i),e.ExtensionTipsService=i}),define(ie[93],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(A){this.appenders=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:R,data:C}){return this.appenders.forEach(E=>E.log(R,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(A){this.channel=A}log(A,T){return this.channel.call("log",{eventName:A,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ie[44],re([0,1,28,15,20,21]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,w){return Promise.resolve(void 0)}publicLog2(v,w){return this.publicLog(v,w)}publicLogError(v,w){return Promise.resolve(void 0)}publicLogError2(v,w){return this.publicLogError(v,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class R{async publicLog(v,w,g){}async publicLogError(v,w,g){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(f,v){return v.onDidChangeConfiguration(w=>{w.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=C;function E(f,v){return!(v.disableTelemetry||!f.enableTelemetry)}e.supportsTelemetry=E;function P(f){const v=f.getValue(A.TELEMETRY_SETTING_ID),w=f.getValue("telemetry.enableCrashReporter");if(f.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function b(f){const v=Object.create(null),w=Object.create(null),g=Object.create(null);y(f,g);for(let p in g){p=p.length>150?p.substr(p.length-149):p;const l=g[p];typeof l=="number"?w[p]=l:typeof l=="boolean"?w[p]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${l.length}`),v[p]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(v[p]=l)}return{properties:v,measurements:w}}e.validateTelemetryData=b;function d(f){if(!f)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{f.indexOf(`${g}+`)===0&&(v=g)}),v}e.cleanRemoteAuthority=d;function y(f,v,w=0,g){if(!!f)for(let p of Object.getOwnPropertyNames(f)){const l=f[p],r=g?g+p:p;Array.isArray(l)?v[r]=(0,D.safeStringify)(l):l instanceof Date?v[r]=l.toISOString():(0,n.isObject)(l)?w<2?y(l,v,w+1,r+"."):v[r]=(0,D.safeStringify)(l):v[r]=l}}function h(f){if(!f)return[];const v=[];return S(v,"",f),v}function S(f,v,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(g=>S(f,v?`${v}.${g}`:g,w[g])):f.push(v)}}),define(ie[207],re([0,1,44,149]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(C,E){}postEvent(C,E){}}class A{constructor(C,E,P,b,d){this.getMachineId=C,this.configurationService=E,this.productService=P,this.telemetry=b,this.keyValueStorage=d,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const y=this.configurationService.getValue("experiments.overrideDelay"),h=typeof y=="number"?y:0;this.overrideInitDelay=new Promise(S=>setTimeout(S,h))}get experimentsEnabled(){return!0}async getTreatment(C){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+C);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let P;const b=await this.tasClient;return this.networkInitialized?P=b.getTreatmentVariable("vscode",C):P=await b.getTreatmentVariableAsync("vscode",C,!0),P=b.getTreatmentVariable("vscode",C),P}async setupTASClient(){const C=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,E=await this.getMachineId(),P=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,C),b=this.productService.tasConfig,d=new(await new Promise((y,h)=>{J(["tas-client-umd"],y,h)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:b.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:b.assignmentContextTelemetryPropertyName,telemetryEventName:b.telemetryEventName,endpoint:b.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=A;class T extends A{constructor(C,E,P){super(()=>Promise.resolve(C),E,P,new L)}}e.AssignmentService=T}),define(ie[208],re([0,1,16,25,9,28,4,32,15,7,20,13,30,31,78,14,8,26,43,46,23,21,44]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=T.isWeb?"web":(0,d.getTargetPlatform)(T.platform,R.arch);var i;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished"})(i||(i={}));function t(...$){return String($.reduce((B,te)=>B|te,0))}var s;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class I{constructor(B=m){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,te=this.state.pageSize){return new I({...this.state,pageNumber:B,pageSize:te})}withFilter(B,...te){const se=[...this.state.criteria,...te.length?te.map(ce=>({filterType:B,value:ce})):[{filterType:B}]];return new I({...this.state,criteria:se})}withSortBy(B){return new I({...this.state,sortBy:B})}withSortOrder(B){return new I({...this.state,sortOrder:B})}withFlags(...B){return new I({...this.state,flags:B.reduce((te,se)=>te|se,0)})}withAssetTypes(...B){return new I({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he,flags:ge,assetTypes:me}=this.state;return{filters:[{criteria:B,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:me,flags:ge}}get searchText(){const B=this.state.criteria.filter(te=>te.filterType===s.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function _($,B){const te=($||[]).filter(se=>se.statisticName===B)[0];return te?te.value:0}function O($){const B="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(se=>se.assetType.indexOf(B)===0).reduce((se,ce)=>{const he=M($,ce.assetType);return he&&se.push([ce.assetType.substring(B.length),he]),se},[])}function N($){if($.properties){const B=$.properties.filter(ce=>ce.key===o.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=B.filter(ce=>te.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return M($,o.Repository)}function z($){return{uri:`${$.fallbackAssetUri}/${o.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${o.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function k($){const B=M($,o.Icon);if(B)return B;const te=d.DefaultIconPath;return{uri:te,fallbackUri:te}}function M($,B){return $.files.filter(se=>se.assetType===B)[0]?{uri:`${$.assetUri}/${B}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${B}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function j($,B){const te=$.properties?$.properties.filter(ce=>ce.key===B):[],se=te.length>0&&te[0].value;return se?se.split(",").map(ce=>(0,y.adoptToGalleryExtensionId)(ce)):[]}function U($){const B=$.properties?$.properties.filter(te=>te.key===c.Engine):[];return B.length>0&&B[0].value||""}function G($){const B=$.properties?$.properties.filter(te=>te.key===c.PreRelease):[];return B.length>0&&B[0].value==="true"}function K($){const B=$.properties?$.properties.filter(se=>se.key===c.LocalizedLanguages):[],te=B.length>0&&B[0].value||"";return te?te.split(","):[]}function x($){return $.indexOf("preview")!==-1}function W($){return $.targetPlatform?(0,d.toTargetPlatform)($.targetPlatform):"undefined"}function X($){const B=(0,D.distinct)($.versions.map(W)),te=!!$.tags?.includes(d.WEB_EXTENSION_TAG),se=B.indexOf("web");return te?se===-1&&B.push("web"):se!==-1&&B.splice(se,1),B}function H($,B){const te=(0,d.getFallbackTargetPlarforms)(B);for(let se=0;se<$.length;se++){const ce=$[se];if(ce.version===$[se-1]?.version){let he=se;const ge=W(ce);if(ge===B)for(;he>0&&$[he-1].version===ce.version;)he--;else if(te.includes(ge))for(;he>0&&$[he-1].version===ce.version&&W($[he-1])!==B;)he--;he!==se&&($.splice(se,1),$.splice(he,0,ce))}}return $}e.sortExtensionVersions=H;function Z($,B,te,se,ce){const he=$.versions[0],ge={manifest:M(B,o.Manifest),readme:M(B,o.Details),changelog:M(B,o.Changelog),license:M(B,o.License),repository:N(B),download:z(B),icon:k(B),coreTranslations:O(B)};return{identifier:{id:(0,y.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:B.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,description:$.shortDescription||"",installCount:_($.statistics,"install"),rating:_($.statistics,"averagerating"),ratingCount:_($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:te,assets:ge,properties:{dependencies:j(B,c.Dependency),extensionPack:j(B,c.ExtensionPack),engine:U(B),localizedLanguages:K(B),targetPlatform:W(B),isPreReleaseVersion:G(B)},hasPreReleaseVersion:G(he),hasReleaseVersion:se,preview:x($.flags),telemetryData:ce}}let ee=class{constructor(B,te,se,ce,he,ge,me,ye){this.requestService=te,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=ge,this.productService=me,this.configurationService=ye;const Se=me.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=V(me.version,me,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,te,se){const ce=(0,C.isBoolean)(te)?te:!1,he=(0,C.isBoolean)(te)?se:te;let ge=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,B.length).withFilter(s.ExtensionName,...B.map(({id:Se})=>Se.toLowerCase()));B.every(Se=>!Se.version)&&(ge=ge.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:me}=await this.queryGallery(ge,a,n.CancellationToken.None),ye=me.map(Se=>{const Ie=(0,y.getGalleryExtensionId)(Se.publisher.publisherName,Se.extensionName);return{rawGalleryExtension:Se,version:B.find(Ee=>(0,y.areSameExtensions)(Ee,{id:Ie}))?.version,preRelease:ce}});return this.converToGalleryExtensions(ye,ge,a,()=>{},he)}async getExtensions2(B){const te=[],se=[];for(const me of B)me.uuid?se.push(me.uuid):te.push(me.id.toLowerCase());let ce=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly).withPage(1,B.length);se.length&&(ce=ce.withFilter(s.ExtensionId,...se)),te.length&&(ce=ce.withFilter(s.ExtensionId,...te));const{galleryExtensions:he}=await this.queryGallery(ce,a,n.CancellationToken.None),ge=he.map(me=>{const ye=(0,y.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName),Se=B.find(Ie=>(0,y.areSameExtensions)(Ie,{id:ye,uuid:me.extensionId}));return{rawGalleryExtension:me,preRelease:!!Se?.preRelease}});return this.converToGalleryExtensions(ge,ce,a,()=>{},n.CancellationToken.None)}async getCompatibleExtension(B,te,se){const ce=(0,d.isIExtensionIdentifier)(B)?null:B;if(ce){if((0,d.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(ce,te,se))return ce}const{id:he,uuid:ge}=ce?ce.identifier:B;let me=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);ge?me=me.withFilter(s.ExtensionId,ge):me=me.withFilter(s.ExtensionName,he);const{galleryExtensions:ye}=await this.queryGallery(me,se,n.CancellationToken.None),[Se]=ye;if(!Se||!Se.versions.length)return null;const Ie=X(Se);if((0,d.isNotWebExtensionInWebTargetPlatform)(Ie,se))return null;for(let Ee of Se.versions){if(!U(Ee)){const De=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:c.Engine,value:De}]}}if(await this.isRawExtensionVersionCompatible(Ee,te,Ie,se)){const De=Se.versions.some(Fe=>!G(Fe));return Z(Se,Ee,Ie,De)}}return null}async isExtensionCompatible(B,te,se){if(!(0,d.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,se)||!te&&B.properties.isPreReleaseVersion)return!1;let ce=B.properties.engine;if(!ce){const he=await this.getManifest(B,n.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,h.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(B,te,se,ce){if(!(0,d.isTargetPlatformCompatible)(W(B),se,ce)||!te&&G(B))return!1;const he=await this.getEngine(B);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(B,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=B.text||"";const ce=(0,A.getOrDefault)(B,Ee=>Ee.pageSize,50);let he=new I().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ce);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,Fe)=>(he=he.withFilter(s.Category,Fe||De),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,Fe)=>(he=he.withFilter(s.Tag,Fe||De),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(s.SearchText,se)),he=he.withSortBy(0)):B.ids?he=he.withFilter(s.ExtensionId,...B.ids):B.names?he=he.withFilter(s.ExtensionName,...B.names):he=he.withSortBy(4),typeof B.sortBy=="number"&&(he=he.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(he=he.withSortOrder(B.sortOrder));const{galleryExtensions:ge,total:me}=await this.queryGallery(he,a,te),ye=Ee=>({index:(he.pageNumber-1)*he.pageSize+Ee,querySource:B.source}),Se=await this.converToGalleryExtensions(ge.map(Ee=>({rawGalleryExtension:Ee,preRelease:!!B.includePreRelease})),he,a,ye,te),Ie=async(Ee,De)=>{if(De.isCancellationRequested)throw(0,L.canceled)();const Fe=he.withPage(Ee+1),{galleryExtensions:Ue}=await this.queryGallery(Fe,a,De);return await this.converToGalleryExtensions(Ue.map(Ne=>({rawGalleryExtension:Ne,preRelease:!!B.includePreRelease})),Fe,a,ye,te)};return{firstPage:Se,total:me,pageSize:he.pageSize,getPage:Ie}}async converToGalleryExtensions(B,te,se,ce,he){const ge=(Se,Ie,Ee,De,Fe)=>{const Ue=!(Ee.flags&i.IncludeLatestVersionOnly),Ne=X(Se);let $e=Se.versions[0];return $e=Se.versions.find(ne=>ne.version===$e.version&&(0,d.isTargetPlatformCompatible)(W(ne),Ne,se))||$e,Ue&&G($e)&&!Fe&&($e=Se.versions.find(ne=>ne.version!==$e.version&&!G(ne))||$e),Z(Se,$e,Ne,De,ce(Ie))},me=[],ye=new Map;for(let Se=0;Se<B.length;Se++){const{rawGalleryExtension:Ie,version:Ee,preRelease:De}=B[Se],Fe=Ie.versions.some(Ue=>!G(Ue));if(Ee){const Ue=Ie.versions.find(Ne=>Ne.version===Ee);Ue&&me.push([Se,Z(Ie,Ue,X(Ie),Fe)])}else{const Ue=ge(Ie,Se,te,Fe,De);Ue.properties.isPreReleaseVersion?ye.set(Ue.identifier.uuid,{index:Se,preRelease:De}):me.push([Se,Ue])}}if(ye.size){const Se=new Date().getTime(),Ie=new I().withFlags(i.IncludeVersions,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ye.size).withFilter(s.ExtensionId,...ye.keys()),{galleryExtensions:Ee}=await this.queryGallery(Ie,se,he);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-Se,count:ye.size}),Ee.length!==ye.size)throw new Error("Not all extensions with latest versions are returned");for(const De of Ee){const Fe=De.versions.some(ne=>!G(ne)),{index:Ue,preRelease:Ne}=ye.get(De.extensionId),$e=ge(De,Ue,Ie,Fe,Ne);me.push([Ue,$e])}}return me.sort((Se,Ie)=>Se[0]-Ie[0]).map(([,Se])=>Se)}async queryGallery(B,te,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,t(i.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(B.raw),ge={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},me=new Date().getTime();let ye,Se,Ie=0;try{if(ye=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:ge},se),ye.res.statusCode&&ye.res.statusCode>=400&&ye.res.statusCode<500)return{galleryExtensions:[],total:Ie};const Ee=await(0,w.asJson)(ye);if(Ee){const De=Ee.results[0],Fe=De.extensions;Fe.forEach(Ne=>H(Ne.versions,te));const Ue=De.resultMetadata&&De.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ie=Ue&&Ue.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Fe,total:Ie}}return{galleryExtensions:[],total:Ie}}catch(Ee){throw Se=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-me,success:!!ye&&(0,w.isSuccess)(ye),responseBodySize:ye?.res.headers["Content-Length"],statusCode:ye?String(ye.res.statusCode):void 0,errorCode:Se?(0,L.isCancellationError)(Se)?"canceled":(0,L.getErrorMessage)(Se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ie)})}}async reportStatistic(B,te,se,ce){if(!this.isEnabled())return;const he=T.isWeb?this.api(`/itemName/${B}.${te}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${te}/${se}/stats?statType=${ce}`),ge=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ye={...await this.commonHeadersPromise,Accept:ge};try{await this.requestService.request({type:"POST",url:he,headers:ye},n.CancellationToken.None)}catch{}}async download(B,te,se){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ce=(0,y.getGalleryExtensionTelemetryData)(B),he=new Date().getTime(),ge=Ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ie}),me=se===2?"install":se===3?"update":"",ye=me?{uri:`${B.assets.download.uri}${E.URI.parse(B.assets.download.uri).query?"&":"?"}${me}=true`,fallbackUri:`${B.assets.download.fallbackUri}${E.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${me}=true`}:B.assets.download,Se=await this.getAsset(ye);await this.fileService.writeFile(te,Se.stream),ge(new Date().getTime()-he)}async getReadme(B,te){if(B.assets.readme){const se=await this.getAsset(B.assets.readme,{},te);return await(0,w.asText)(se)||""}return""}async getManifest(B,te){if(B.assets.manifest){const se=await this.getAsset(B.assets.manifest,{},te),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(B,te){const se=M(B,o.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(B,te){const se=B.assets.coreTranslations.filter(ce=>ce[0]===te.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(B,te){if(B.assets.changelog){const se=await this.getAsset(B.assets.changelog,{},te);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(B,te,se){let ce=new I().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?ce=ce.withFilter(s.ExtensionId,B.identifier.uuid):ce=ce.withFilter(s.ExtensionName,B.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,se,n.CancellationToken.None);if(!he.length)return[];const ge=X(he[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(ge,se))return[];const me=[];for(const ye of he[0].versions)try{me[me.length-1]?.version!==ye.version&&await this.isRawExtensionVersionCompatible(ye,te,ge,se)&&me.push({version:ye.version,date:ye.lastUpdated,isPreReleaseVersion:G(ye)})}catch{}return me}async getAsset(B,te={},se=n.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},ge={...ce,...te.headers||{}};te={...te,...he,headers:ge};const me=B.uri,ye=B.fallbackUri,Se={...te,url:me};try{const Ie=await this.requestService.request(Se,se);if(Ie.res.statusCode===200)return Ie;const Ee=await(0,w.asText)(Ie);throw new Error(`Expected 200, got back ${Ie.res.statusCode} instead.

${Ee}`)}catch(Ie){if((0,L.isCancellationError)(Ie))throw Ie;const Ee=(0,L.getErrorMessage)(Ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:me,message:Ee});const De={...te,url:ye};return this.requestService.request(De,se)}}async getEngine(B){let te=U(B);if(!te){const se=await this.getManifestFromRawExtensionVersion(B,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");te=se.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,w.asJson)(B),se=[],ce={};if(te){for(const he of te.malicious)se.push({id:he});if(te.unsupported)for(const he of Object.keys(te.unsupported)){const ge=te.unsupported[he];(0,C.isBoolean)(ge)||(ce[he.toLowerCase()]=ge.preReleaseExtension)}if(te.migrateToPreRelease)for(const[he,ge]of Object.entries(te.migrateToPreRelease))(!ge.engine||(0,h.isEngineValid)(ge.engine,this.productService.version,this.productService.date))&&(ce[he.toLowerCase()]=ge)}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};ee=de([Y(1,w.IRequestService),Y(2,f.ILogService),Y(3,b.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,S.IFileService),Y(6,v.IProductService),Y(7,P.IConfigurationService)],ee);let q=class extends ee{constructor(B,te,se,ce,he,ge,me,ye){super(B,te,se,ce,he,ge,me,ye)}};q=de([Y(0,p.IStorageService),Y(1,w.IRequestService),Y(2,f.ILogService),Y(3,b.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,S.IFileService),Y(6,v.IProductService),Y(7,P.IConfigurationService)],q),e.ExtensionGalleryService=q;let F=class extends ee{constructor(B,te,se,ce,he,ge,me){super(void 0,B,te,se,ce,he,ge,me)}};F=de([Y(0,w.IRequestService),Y(1,f.ILogService),Y(2,b.IEnvironmentService),Y(3,l.ITelemetryService),Y(4,S.IFileService),Y(5,v.IProductService),Y(6,P.IConfigurationService)],F),e.ExtensionGalleryServiceWithNoStorageService=F;async function V($,B,te,se,ce,he){const ge={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$} (${B.nameShort})`},me=await(0,g.getServiceMachineId)(te,ce,he);return(0,r.supportsTelemetry)(B,te)&&(0,r.getTelemetryLevel)(se)===3&&(ge["X-Market-User-Id"]=me),ge}e.resolveMarketplaceHeaders=V}),define(ie[94],re([0,1,2,13,8,44]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(C,E,P=""){super();this.prefix=P;const b=C.getLogger(E.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(C.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(C,E){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,A.validateTelemetryData)(E))}};T=de([Y(0,L.ILoggerService),Y(1,n.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ie[95],re([0,1,2,28,4,27,141,20,42,87,38,21,44]),function(J,e,D,n,L,A,T,R,C,E,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(f,v){this._configurationService=v,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const g=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(f,v){this._experimentProperties[f]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let v=f.sessionID,w=f["common.machineId"],g=f["common.firstSessionDate"],p=f["common.msftInternal"];return{sessionId:v,machineId:w,firstSessionDate:g,msftInternal:p}}dispose(){this._disposables.dispose()}_log(f,v,w,g){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(p=>{w=(0,n.mixin)(w,p),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,g)}),this._appenders.forEach(l=>l.log(f,w))},p=>{console.error(p)})}publicLog(f,v,w){return this._log(f,3,v,w)}publicLog2(f,v,w){return this.publicLog(f,v,w)}publicLogError(f,v){return this.sendErrorTelemetry?this._log(f,2,v,!0):Promise.resolve(void 0)}publicLogError2(f,v){return this.publicLogError(f,v)}_anonymizeFilePaths(f){let v=f;const w=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(f);if(!a)break;w.push([a.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(v="";;){const r=p.exec(f);if(!r)break;!g.test(r[0])&&w.every(([a,i])=>r.index<a||r.index>=i)&&(v+=f.substring(l,r.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<f.length&&(v+=f.substr(l)),v}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const v=f.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,g=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,p=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return g.test(v)?"<REDACTED: secret>":w.test(v)?"<REDACTED: email>":p.test(v)?"<REDACTED: token>":f}_cleanupInfo(f,v){let w=f;v&&(w=this._anonymizeFilePaths(w));for(let g of this._cleanupPatterns)w=w.replace(g,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=de([Y(1,R.IConfigurationService)],y),e.TelemetryService=y;function h(){const S=(0,T.localize)(0,null,E.default.nameLong),f=E.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=L.isWeb?"":(0,T.localize)(3,null),w=(0,T.localize)(4,null),g=(0,T.localize)(5,null),p=(0,T.localize)(6,null),l=(0,T.localize)(7,null),r=`
|       | ${w} | ${g} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,T.localize)(8,null);return`
${S} ${f} ${v}

&nbsp;

${l}
${r}

&nbsp;

${a}
`}P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,T.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,T.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[209],re([0,1,9,28,44]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(R,C){const E=await new Promise((b,d)=>{J(["applicationinsights"],b,d)});let P;return E.defaultClient?(P=new E.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(E.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=E.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=C?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class T{constructor(C,E,P,b,d){this._eventPrefix=C,this._defaultData=E,this.testCollector=b,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(C){if(!!this._aiClient){if(typeof this._aiClient!="string"){C(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{C(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(C,E){!this._aiClient||(E=(0,n.mixin)(E,this._defaultData),E=(0,L.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+C,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(C=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,C(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(ie[210],re([0,1,18,57,20,13,8,21,93,94,95]),function(J,e,D,n,L,A,T,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let b=class{constructor(y,h,S,f){this.configurationService=y,this.telemetryService=h,this.loggerService=S,this.environmentService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(y){if(!this.customTelemetryServices.has(y.id)){const{machineId:h,sessionId:S}=await this.telemetryService.getTelemetryInfo(),f=Object.create(null);f["common.vscodemachineid"]=h,f["common.vscodesessionid"]=S;const v=[y.id,JSON.stringify(f),y.aiKey],g=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),p=[new C.TelemetryAppenderClient(g),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${y.id}] `)];this.customTelemetryServices.set(y.id,new P.TelemetryService({appenders:p,sendErrorTelemetry:y.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(y.id)}async publicLog(y,h,S){await(await this.getCustomTelemetryService(y)).publicLog(h,S)}async publicLogError(y,h,S){await(await this.getCustomTelemetryService(y)).publicLogError(h,S)}};b=de([Y(0,L.IConfigurationService),Y(1,R.ITelemetryService),Y(2,T.ILoggerService),Y(3,A.IEnvironmentService)],b),e.CustomEndpointTelemetryService=b}),define(ie[211],re([0,1,5,25,3,2,8]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(E,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((P,b)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,P),this._onCreateRequest.fire({requestId:d,...E});const y=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>b(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,A.toDisposable)(()=>y.cancel())])})}acceptReply(E,P){const b=this._pendingRequests.get(E);b?(this._pendingRequests.delete(E),(0,A.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),b(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=de([Y(1,T.ILogService)],R),e.RequestStore=R}),define(ie[96],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var T;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(T=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var C;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var b;(function(f){f.TerminalView="view",f.Editor="editor"})(b=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(f){f[f.CwdDetection=0]="CwdDetection",f[f.NaiveCwdDetection=1]="NaiveCwdDetection",f[f.CommandDetection=2]="CommandDetection",f[f.PartialCommandDetection=3]="PartialCommandDetection"})(d=e.TerminalCapability||(e.TerminalCapability={}));var y;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(ie[212],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ie[213],re([0,1,33,28,10,4,32,15,22]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let d=0;return b&&b.length===4&&(d=parseInt(b[3])),d}e.getWindowsBuildNumber=E;async function P(b,d,y,h=T.env,S=C.Promises.exists){if(L.isAbsolute(b))return await S(b)?b:void 0;if(d===void 0&&(d=T.cwd()),L.dirname(b)!=="."){const g=L.join(d,b);return await S(g)?g:void 0}const v=(0,n.getCaseInsensitive)(h,"PATH");if(y===void 0&&(0,R.isString)(v)&&(y=v.split(L.delimiter)),y===void 0||y.length===0){const g=L.join(d,b);return await S(g)?g:void 0}for(let g of y){let p;if(L.isAbsolute(g)?p=L.join(g,b):p=L.join(d,g,b),await S(p))return p;if(A.isWindows){let l=p+".com";if(await S(l)||(l=p+".exe",await S(l)))return l}}const w=L.join(d,b);return await S(w)?w:void 0}e.findExecutable=P}),define(ie[214],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(ie[97],re([0,1,48,3,2,6,38,214]),function(J,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var C;(function(f){function v(w){return w&&typeof w=="object"&&typeof w.id=="string"}f.isThemeColor=v})(C=e.ThemeColor||(e.ThemeColor={}));function E(f){return{id:f}}e.themeColorFromId=E;var P;(function(f){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||C.isThemeColor(t.color))}f.isThemeIcon=v;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const s=w.exec(t);if(!s)return;let[,o]=s;return{id:o}}f.fromString=g;function p(t){return{id:t}}f.fromId=p;function l(t,s){let o=t.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),s&&(o=`${o}~${s}`),{id:o}}f.modify=l;function r(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}f.getModifier=r;function a(t,s){return t.id===s.id&&t.color?.id===s.color?.id}f.isEqual=a;function i(t,s){return{id:t.id,color:s?E(s):void 0}}f.asThemeIcon=i,f.asClassNameArray=D.CSSIcon.asClassNameArray,f.asClassName=D.CSSIcon.asClassName,f.asCSSSelector=D.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function b(f){switch(f){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(v);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new d;T.Registry.add(e.Extensions.ThemingContribution,y);function h(f){return y.onColorThemeChange(f)}e.registerThemingParticipant=h;class S extends L.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,w){let g=this.theme.getColor(v);return g&&w&&(g=w(g,this.theme)),g?g.toString():null}}e.Themable=S}),define(ie[215],re([0,1,48,7,97]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(b,d){const y=b.map(h=>({name:h.profileName,description:T(h)}));return d&&y.push(...d.map(h=>({name:h.title,description:R(h)}))),{values:y.map(h=>h.name),markdownDescriptions:y.map(h=>h.description)}}e.createProfileSchemaEnums=A;function T(b){let d=`$(${L.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:D.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?d+=`
- args: "${b.args}"`:d+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(d+=`
- overrideName: ${b.overrideName}`),b.color&&(d+=`
- color: ${b.color}`),b.env&&(d+=`
- env: ${JSON.stringify(b.env)}`),d}function R(b){return`$(${L.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:D.Codicon.terminal.id}) ${b.title}
- extensionIdenfifier: ${b.extensionIdentifier}`}function C(b,d){if(!b&&!d)return!0;if(typeof b=="string"&&typeof d=="string")return b===d;if(Array.isArray(b)&&Array.isArray(d)){if(b.length!==d.length)return!1;for(let y=0;y<b.length;y++)if(b[y]!==d[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function E(b,d){if(!b&&!d)return!0;if(!b||!d)return!1;if(L.ThemeIcon.isThemeIcon(b)&&L.ThemeIcon.isThemeIcon(d))return b.id===d.id&&b.color===d.color;if(typeof b=="object"&&b&&"light"in b&&"dark"in b&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const y=b,h=d;if((n.URI.isUri(y.light)||P(y.light))&&(n.URI.isUri(y.dark)||P(y.dark))&&(n.URI.isUri(h.light)||P(h.light))&&(n.URI.isUri(h.dark)||P(h.dark)))return y.light.path===h.light.path&&y.dark.path===h.dark.path}if(n.URI.isUri(b)&&n.URI.isUri(d)||P(b)||P(d)){const y=b,h=d;return y.path===h.path&&y.scheme===h.scheme}return!1}e.terminalIconsEqual=E;function P(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.isUriComponents=P}),define(ie[216],re([0,1,48,142,42,38,215]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),p=>p.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),p=>`$(${p.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),d=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:d},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function v(){A.Registry.as(L.Extensions.Configuration).registerConfiguration(f),g()}e.registerTerminalPlatformConfiguration=v;let w;function g(p,l){const r=A.Registry.as(L.Extensions.Configuration);let a;p&&(a=(0,T.createProfileSchemaEnums)(p?.profiles,l));const i=w;w={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:p?.os===3?a?.values:void 0,markdownEnumDescriptions:p?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:p?.os===2?a?.values:void 0,markdownEnumDescriptions:p?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:p?.os===1?a?.values:void 0,markdownEnumDescriptions:p?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(ie[217],re([0,1,45,48,10,4,22,72,213,97]),function(J,e,D,n,L,A,T,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,b=!0;function d(a,i,t,s,o=process.env,c,u,m,I){return c=c||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},A.isWindows?y(t,c,o,u,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:s.getValue("terminal.integrated.defaultProfile.windows"),I,m):p(c,u,t,a&&typeof a=="object"?{...a}:s.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:s.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,m,o)}e.detectAvailableProfiles=d;async function y(a,i,t,s,o,c,u,m,I){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let N=!1;(0,C.getWindowsBuildNumber)()>=16299&&(N=!0),await f(m);const z=new Map;a&&(z.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),z.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),z.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),l(c,z);const k=await h(z.entries(),u,i,t,s,I);if(a||!a&&o)try{const M=await w(`${O}\\${N?"wsl":"bash"}.exe`,u);for(const j of M)(!c||!(j.profileName in c))&&k.push(j)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return k}async function h(a,i,t,s=process.env,o,c){const u=[];for(const[m,I]of a){if(I===null)continue;let _,O,N;if("source"in I){const M=P?.get(I.source);if(!M)continue;_=M.paths,O=I.args||M.args,I.icon?N=S(I.icon):M.icon&&(N=M.icon)}else _=Array.isArray(I.path)?I.path:[I.path],O=A.isWindows||Array.isArray(I.args)?I.args:void 0,N=S(I.icon);const z=await c?.(_)||_.slice(),k=await r(m,i,z,t,s,O,I.env,I.overrideName,I.isAutoDetected,o);k?(k.isAutoDetected=I.isAutoDetected,k.icon=N,k.color=I.color,u.push(k)):o?.trace("profile not validated",m,_)}return u}function S(a){return typeof a=="string"?{id:a}:a}async function f(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await v(),icon:E.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function v(){const a=[];for await(const i of(0,R.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function w(a,i){const t=[],s=await new Promise((u,m)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,_)=>{if(I)return m("Problem occurred when getting wsl distros");u(_)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),c=s.split(o).filter(u=>u.trim().length>0&&u!=="");for(const u of c){if(u===""||u.startsWith("docker-desktop"))continue;const m=`${u} (WSL)`,I={profileName:m,path:a,args:["-d",`${u}`],isDefault:m===i,icon:g(u),isAutoDetected:!1};t.push(I)}return t}function g(a){return a.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):a.includes("Debian")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function p(a,i,t,s,o,c,u,m){const I=new Map;if(t){const _=(await a.readFile("/etc/shells")).toString(),O=c||_.split(`
`).filter(z=>z.trim().indexOf("#")!==0&&z.trim().length>0),N=new Map;for(const z of O){let k=(0,L.basename)(z),M=N.get(k)||0;M++,M>1&&(k=`${k} (${M})`),N.set(k,M),I.set(k,{path:z,isAutoDetected:!0})}}return l(s,I),await h(I.entries(),o,a,m,i,u)}function l(a,i){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?i.delete(t):(s.icon=s.icon||i.get(t)?.icon,i.set(t,s))}async function r(a,i,t,s,o,c,u,m,I,_){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(a,i,t,s,o,c,u,m,I);const N={profileName:a,path:O,args:c,env:u,overrideName:m,isAutoDetected:I,isDefault:a===i};if((0,L.basename)(O)===O){const k=o.PATH?o.PATH.split(L.delimiter):void 0,M=await(0,C.findExecutable)(O,void 0,k,void 0,s.existsFile);return M?(N.path=M,N.isFromPath=!0,N):r(a,i,t,s,o,c)}return await s.existsFile((0,L.normalize)(O))?N:r(a,i,t,s,o,c,u,m,I)}}),define(ie[218],re([0,1,3,2,18,4,36,57,20,13,77,163,8,86,21,211,96,216,217]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let p=0,l=class extends n.Disposable{constructor(a,i,t,s,o){super();this._reconnectConstants=a,this._configurationService=i,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,v.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(A.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:p,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?a.debugBrk=i.port:!i.break&&i.port&&(a.debug=i.port));const t=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(u=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const o=t.getChannel(f.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(u=>this._onProcessData.fire(u))),this._register(c.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(c.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(c.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(c.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(c.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(c.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,i,t,s,o,c,u,m,I,_,O){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),z=await this._proxy.createProcess(a,i,t,s,o,c,u,m,I,_,O);return clearTimeout(N),p=Math.max(p,z),z}updateTitle(a,i,t){return this._proxy.updateTitle(a,i,t)}updateIcon(a,i,t){return this._proxy.updateIcon(a,i,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,i){return this._proxy.shutdown(a,i)}input(a,i){return this._proxy.input(a,i)}processBinary(a,i){return this._proxy.processBinary(a,i)}resize(a,i,t){return this._proxy.resize(a,i,t)}acknowledgeDataEvent(a,i){return this._proxy.acknowledgeDataEvent(a,i)}setUnicodeVersion(a,i){return this._proxy.setUnicodeVersion(a,i)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,i){return this._proxy.installAutoReply(a,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,i,t,s=!1){const o=await this._shellEnv;return(0,w.detectAvailableProfiles)(i,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,i){return this._proxy.requestDetachInstance(a,i)}async acceptDetachInstanceReply(a,i){return this._proxy.acceptDetachInstanceReply(a,i)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,i){return this._proxy.reviveTerminalProcesses(a,i)}async refreshProperty(a,i){return this._proxy.refreshProperty(a,i)}async updateProperty(a,i,t){return this._proxy.updateProperty(a,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:i})}async acceptPtyHostResolvedVariables(a,i){this._resolveVariablesRequestStore.acceptReply(a,i)}};l=de([Y(1,C.IConfigurationService),Y(2,E.IEnvironmentService),Y(3,d.ILogService),Y(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(ie[34],re([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ie[219],re([0,1,3,2,7,13,31,14,8,34]),function(J,e,D,n,L,A,T,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends n.Disposable{constructor(d,y,h,S,f){super();this.extensionsManagementService=d,this.logService=S,this.uriIdentityService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(w=>this.onInstallExtension(w))),this._register(d.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(d.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const v=L.URI.file(h.extensionsPath);this._register(y.watch(v)),this._register(D.Event.filter(y.onDidFilesChange,w=>w.rawChanges.some(g=>this.doesChangeAffects(g,v)))(()=>this.onDidChange()))}doesChangeAffects(d,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),y)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const y of d)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),y=d.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,T.areSameExtensions)(f,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(f=>(0,T.areSameExtensions)(f,S))?!1:d.every(f=>!(0,T.areSameExtensions)(f.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=d.map(S=>S.identifier),(y.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:h})}}};P=de([Y(1,R.IFileService),Y(2,A.INativeEnvironmentService),Y(3,C.ILogService),Y(4,E.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(ie[220],re([0,1,34,79,14,19,104,3,2]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(d){this.uri=d,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let P=class{constructor(d){this._fileService=d,this._dispooables=new C.DisposableStore,this._limit=2**16;const y=new Map,h=S=>{let f=y.get(S.scheme);return f===void 0&&(f=d.hasProvider(S)&&!this._fileService.hasCapability(S,1024),y.set(S.scheme,f)),f};this._dispooables.add(R.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new A.ExtUri(h),this._canonicalUris=new T.SkipList((S,f)=>this.extUri.compare(S,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,A.normalizePath)(d));let y=this._canonicalUris.get(d);return y?y.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new E(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,S)=>h[1].touch<S[1].touch?1:h[1].touch>S[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let h=0;h<y;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};P=de([Y(0,L.IFileService)],P),e.UriIdentityService=P,(0,n.registerSingleton)(D.IUriIdentityService,P,!0)}),define(ie[221],re([0,1,3,2,40,39,17]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends n.Disposable{constructor(E,P,b,d,y){super();this.fileSystemScheme=E,this.fileSystemProvider=P,this.userDataScheme=b,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(d.onDidFilesChange(h=>this.handleFileChanges(h)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,P){this.watchResources.set(E,E);const b=this.fileSystemProvider.watch(this.toFileSystemResource(E),P);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),b.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,P,b){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(P),b)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,P,b){const d=(0,L.newWriteableStream)(y=>T.VSBuffer.concat(y.map(h=>T.VSBuffer.wrap(h))).buffer);return(async()=>{try{const y=await this.readFile(E);d.end(y)}catch(y){d.error(y),d.end()}})(),d}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,P,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),P,b)}delete(E,P){return this.fileSystemProvider.delete(this.toFileSystemResource(E),P)}handleFileChanges(E){const P=[];for(const b of E.rawChanges){if(b.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(b.resource);this.watchResources.findSubstr(d)&&P.push({resource:d,type:b.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ie[52],re([0,1,69]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(T,R,C,E){const P=(0,D.setProperty)(T,R,C,E)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=n;function L(T,R,C){let E=C;for(;E>=0;){if(T.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&T.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=L;function A(T,R,C){let E=C;for(;E>=0;)if(T.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&T.charAt(E)===R.charAt(1)))return E;return T.length-1}e.getLineEndOffset=A}),define(ie[222],re([0,1,28,61,15]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(d,y,h,S,f){const v=[],w=[],g=[];if(!y){const O=d.filter(({identifier:N})=>f.every(z=>z.toLowerCase()!==N.id.toLowerCase()));return{local:{added:v,removed:w,updated:g},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}d=d.map(P),y=y.map(P),h=h?h.map(P):null;const p=new Map,l=O=>{O.uuid&&p.set(O.id.toLowerCase(),O.uuid)};d.forEach(({identifier:O})=>l(O)),y.forEach(({identifier:O})=>l(O)),h&&h.forEach(({identifier:O})=>l(O));const r=O=>{const N=O.identifier.uuid||p.get(O.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${O.identifier.id.toLowerCase()}`},a=(O,N)=>(O.set(r(N),N),O),i=d.reduce(a,new Map),t=y.reduce(a,new Map),s=y.reduce((O,N)=>{const z=r(N);N=(0,D.deepClone)(N);const k=i.get(z);return k&&(k.installed&&(N.installed=!0),N.version||(N.version=k.version)),a(O,N)},new Map),o=h?h.reduce(a,new Map):null,c=S.reduce(a,new Map),u=f.reduce((O,N)=>{const z=p.get(N.toLowerCase());return O.add(z?`uuid:${z}`:`id:${N.toLowerCase()}`)},new Set),m=T(i,t,u);if(m.added.size>0||m.removed.size>0||m.updated.size>0){const O=T(o,i,u),N=T(o,t,u),z=(k,M)=>{const j=i.get(k);if(j){const U=t.get(k),G=M?U:j;return{...G,version:(U.version&&n.gt(U.version,j.version),j.version),state:R(j,U,o?.get(k)),preRelease:(0,L.isUndefined)(G.preRelease)?j.preRelease:G.preRelease}}};for(const k of N.removed.values()){const M=i.get(k);M&&w.push(M.identifier)}for(const k of N.added.values())if(O.added.has(k)){if(m.updated.has(k)){const M=z(k,!0);M&&(g.push(b(M,k)),s.set(k,M))}}else{const M=t.get(k);M.installed&&v.push(b(M,k))}for(const k of N.updated.values()){const M=z(k,!0);M&&(g.push(b(M,k)),s.set(k,M))}for(const k of O.added.values())N.added.has(k)||s.set(k,i.get(k));for(const k of O.updated.values())if(!N.removed.has(k)&&!N.updated.has(k)){const M=z(k,!1);M&&(s.get(k)?.installed&&(M.installed=!0),s.set(k,M))}for(const k of O.removed.values())!c.has(k)&&!N.updated.has(k)&&o?.get(k)?.installed&&s.delete(k)}const I=[],_=T(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&s.forEach((O,N)=>I.push(b(O,N))),{local:{added:v,removed:w,updated:g},remote:I.length?{added:[..._.added].map(O=>s.get(O)),updated:[..._.updated].map(O=>s.get(O)),removed:[..._.removed].map(O=>t.get(O)),all:I}:null}}e.merge=A;function T(d,y,h,{checkInstalledProperty:S,checkVersionProperty:f}={checkInstalledProperty:!1,checkVersionProperty:!1}){const v=d?[...d.keys()].filter(r=>!h.has(r)):[],w=[...y.keys()].filter(r=>!h.has(r)),g=w.filter(r=>v.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),p=v.filter(r=>w.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=new Set;for(const r of v){if(p.has(r))continue;const a=d.get(r),i=y.get(r);(!i||a.disabled!==i.disabled||a.preRelease!==i.preRelease||!E(a.state,i.state)||f&&a.version!==i.version||S&&a.installed!==i.installed)&&l.add(r)}return{added:g,removed:p,updated:l}}function R(d,y,h){const S=d.state,f=y.state,v=h?.state;if(!y.version||S&&n.gt(d.version,y.version))return S;if(f&&n.gt(y.version,d.version)||!S)return f;if(!f)return S;const w=(0,D.deepClone)(S),g=v?C(v,f):{added:Object.keys(f).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},p=v?C(v,S):{added:Object.keys(S).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...g.added.values(),...g.updated.values()])w[l]=f[l];for(const l of g.removed.values())p.updated.has(l)||delete w[l];return w}function C(d,y){const h=Object.keys(d),S=Object.keys(y),f=S.filter(g=>h.indexOf(g)===-1).reduce((g,p)=>(g.add(p),g),new Set),v=h.filter(g=>S.indexOf(g)===-1).reduce((g,p)=>(g.add(p),g),new Set),w=new Set;for(const g of h){if(v.has(g))continue;const p=d[g],l=y[g];(0,D.equals)(p,l)||w.add(g)}return{added:f,removed:v,updated:w}}function E(d={},y={}){const{added:h,removed:S,updated:f}=C(d,y);return h.size===0&&S.size===0&&f.size===0}function P(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function b(d,y){const h={identifier:{id:d.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!d.preRelease};return d.version&&(h.version=d.version),d.disabled&&(h.disabled=!0),d.installed&&(h.installed=!0),d.state&&(h.state=d.state),h}}),define(ie[98],re([0,1,16,20,6]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),C&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,C){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),C&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const C=R.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),P=[],b=[];if(Array.isArray(E))for(const d of E)d.startsWith("-")?b.push(d.substring(1)):P.push(d);return(0,D.distinct)([...C,...P].filter(d=>b.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};A=de([Y(0,n.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(ie[223],re([0,1,16,35,28,159,52]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(p){return(0,n.parse)(p)||[]}e.parseKeybindings=R;async function C(p,l,r,a,i){const t=R(p),s=R(l),o=r?R(r):null,c=[...t,...s,...o||[]].map(U=>U.key),u=await i.resolveUserBindings(c);let m=P(t,s,o,u);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const I=d(t),_=d(s),O=o?d(o):null,N=h(I,_,u),z=O?h(O,I,u):{added:[...I.keys()].reduce((U,G)=>(U.add(G),U),new Set),removed:new Set,updated:new Set},k=O?h(O,_,u):{added:[..._.keys()].reduce((U,G)=>(U.add(G),U),new Set),removed:new Set,updated:new Set},M=E(N,z,k);let j=p;for(const U of M.removed.values())M.conflicts.has(U)||(j=w(j,U,a));for(const U of M.added.values()){if(M.conflicts.has(U))continue;const G=_.get(U);if(G.some(K=>K.command!==`-${U}`&&m.conflicts.has(u[K.key]))){M.conflicts.add(U);continue}j=v(j,G,a)}for(const U of M.updated.values()){if(M.conflicts.has(U))continue;const G=_.get(U);if(G.some(K=>K.command!==`-${U}`&&m.conflicts.has(u[K.key]))){M.conflicts.add(U);continue}j=g(j,U,G,a)}return{mergeContent:j,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=C;function E(p,l,r){const a=new Set,i=new Set,t=new Set,s=new Set;for(const o of l.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(l.updated.has(o)?s.add(o):i.add(o));for(const o of l.added.values())s.has(o)||r.added.has(o)&&p.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(l.added.has(o)?p.updated.has(o)&&s.add(o):a.add(o));for(const o of l.updated.values())s.has(o)||r.updated.has(o)&&p.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(l.updated.has(o)?p.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:i,updated:t,conflicts:s}}function P(p,l,r,a){const i=new Set,t=b(p,a),s=b(l,a),o=r?b(r,a):null,c=y(t,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const u=o?y(o,t):{added:[...t.keys()].reduce((z,k)=>(z.add(k),z),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const m=o?y(o,s):{added:[...s.keys()].reduce((z,k)=>(z.add(k),z),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:I,removed:_,updated:O,conflicts:N}=E(c,u,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:_,updated:O,conflicts:N}}function b(p,l){const r=new Map;for(const a of p){const i=l[a.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(a)}return r}function d(p){const l=new Map;for(const r of p){const a=r.command[0]==="-"?r.command.substring(1):r.command;let i=l.get(a);i||(i=[],l.set(a,i)),i.push(r)}return l}function y(p,l){const r=[...p.keys()],a=[...l.keys()],i=a.filter(o=>r.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const c=p.get(o).map(m=>({...m,key:o})),u=l.get(o).map(m=>({...m,key:o}));(0,D.equals)(c,u,(m,I)=>f(m,I))||s.add(o)}return{added:i,removed:t,updated:s}}function h(p,l,r){const a=[...p.keys()],i=[...l.keys()],t=i.filter(c=>a.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),s=a.filter(c=>i.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),o=new Set;for(const c of a){if(s.has(c))continue;const u=p.get(c).map(I=>({...I,key:r[I.key]})),m=l.get(c).map(I=>({...I,key:r[I.key]}));S(u,m)||o.add(c)}return{added:t,removed:s,updated:o}}function S(p,l){return!(!(0,D.equals)(p.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,a)=>f(r,a))||!(0,D.equals)(p.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,a)=>f(r,a)))}function f(p,l){if(p.command!==l.command||p.key!==l.key)return!1;const r=A.ContextKeyExpr.deserialize(p.when),a=A.ContextKeyExpr.deserialize(l.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!L.equals(p.args,l.args))}function v(p,l,r){for(const a of l)p=T.edit(p,[-1],a,r);return p}function w(p,l,r){const a=R(p);for(let i=a.length-1;i>=0;i--)(a[i].command===l||a[i].command===`-${l}`)&&(p=T.edit(p,[i],void 0,r));return p}function g(p,l,r,a){const i=R(p),t=i.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=i.length-1;s>=0;s--)(i[s].command===l||i[s].command===`-${l}`)&&(p=T.edit(p,[s],void 0,a));for(let s=r.length-1;s>=0;s--)p=T.edit(p,[t],r[s],a);return p}}),define(ie[224],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(A,T,R){const C={},E={},P=new Set;if(!T)return{local:{added:C,updated:E,removed:[...P.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const b=n(A,T);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:C,updated:E,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=n(R,A),y=n(R,T),h={},S={},f=new Set,v=new Set;for(const w of d.removed.values())y.updated.has(w)?C[w]=T[w]:f.add(w);for(const w of y.removed.values())v.has(w)||(d.updated.has(w)?v.add(w):P.add(w));for(const w of d.updated.values())v.has(w)||(y.updated.has(w)?b.updated.has(w)&&v.add(w):S[w]=A[w]);for(const w of y.updated.values())v.has(w)||(d.updated.has(w)?b.updated.has(w)&&v.add(w):A[w]!==void 0&&(E[w]=T[w]));for(const w of d.added.values())v.has(w)||(y.added.has(w)?b.updated.has(w)&&v.add(w):h[w]=A[w]);for(const w of y.added.values())v.has(w)||(d.added.has(w)?b.updated.has(w)&&v.add(w):C[w]=T[w]);return{local:{added:C,removed:[...P.values()],updated:E},remote:{added:h,removed:[...f.values()],updated:S},conflicts:[...v.values()]}}e.merge=D;function n(A,T){const R=A?Object.keys(A):[],C=T?Object.keys(T):[],E=C.filter(d=>R.indexOf(d)===-1).reduce((d,y)=>(d.add(y),d),new Set),P=R.filter(d=>C.indexOf(d)===-1).reduce((d,y)=>(d.add(y),d),new Set),b=new Set;for(const d of R){if(P.has(d))continue;const y=A[d],h=T[d];y!==h&&b.add(d)}return{added:E,removed:P,updated:b}}function L(A,T){const{added:R,removed:C,updated:E}=n(A,T);return R.size===0&&C.size===0&&E.size===0}e.areSame=L}),define(ie[24],re([0,1,16,19,15,147,42,30,6,88,38]),function(J,e,D,n,L,A,T,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const o=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(c=>!!o[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function d(){const o=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(o).filter(I=>!!o[I].ignoreSync),u=Object.keys(o).filter(I=>o[I].scope===2||o[I].scope===6),m=b();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...u,...m])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const o="vscode://schemas/ignoredSettings",c=P.Registry.as(T.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=P.Registry.as(E.Extensions.JSONContribution),m=()=>{const I=b(),_=d().filter(k=>k!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(T.allSettings.properties).filter(k=>_.indexOf(k)===-1),N=_.filter(k=>I.indexOf(k)===-1),z={items:{type:"string",enum:[...O,...N.map(k=>`-${k}`)]}};u.registerSchema(o,z)};return c.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=y;function h(o){return o&&(0,L.isObject)(o)&&(0,L.isString)(o.id)&&(0,L.isArray)(o.scopes)}e.isAuthenticationProvider=h;var S;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function f(o,c,u){return u.joinPath(c.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,C.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,C.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,C.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function v(o){const c={};return c[e.HEADER_EXECUTION_ID]=o,c}e.createSyncHeaders=v;var w;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(c,u,m,I){super(c);this.code=u,this.resource=m,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class p extends g{constructor(c,u,m,I,_){super(c,m,void 0,_);this.url=u,this.serverCode=I}}e.UserDataSyncStoreError=p;class l extends g{constructor(c,u){super(c,u)}}e.UserDataAutoSyncError=l,function(o){function c(u){if(u instanceof o)return u;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(m&&m[1]){const I=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new o(u.message,m[1],I,_)}return new o(u.message,"Unknown")}o.toUserDataSyncError=c}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,C.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,C.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,C.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,C.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,C.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,c){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,n.isEqualOrParent)(o,(0,n.joinPath)(c.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(ie[47],re([0,1,16,5,17,25,3,35,2,27,15,7,143,20,13,14,8,46,23,21,34,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends C.Disposable{constructor(c,u,m,I,_,O,N,z,k,M,j){super();this.resource=c,this.fileService=u,this.environmentService=m,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=N,this.telemetryService=z,this.logService=k,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(m.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(c,m,this.extUri),this.currentMachineIdPromise=(0,v.getServiceMachineId)(m,u,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const u=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,u={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),u)}async preview(c,u,m={}){return this._sync(c,!1,u,m)}async apply(c,u={}){try{this.syncHeaders={...u};const m=await this.doApply(c);return this.setStatus(m),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,u,m,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(c,O);return _=await this.performSync(N,O,u,m),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(c){const u=await this.resolveContent(c);if(!u)return!1;const m=this.parseSyncData(u);if(!m)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,I),O=await this.isRemoteDataFromCurrentMachine(_),N=await this.generateSyncPreview({ref:_.ref,syncData:m},I,O,this.getUserDataSyncConfiguration(),A.CancellationToken.None),z=[];for(const k of N){const M=await this.getAcceptResult(k,k.remoteResource,void 0,A.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(k,k.previewResource,k.remoteContent,A.CancellationToken.None);z.push([k,{...M,remoteChange:j!==0?j:2}])}await this.applyResult(_,I,z,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const u=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===u}async getLatestRemoteUserData(c,u){if(u){const m=c&&c.latest?c.latest[this.resource]:void 0;if(u.ref===m||m===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(c,u,m,I){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,u,m,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,u,m,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(c,u,m,I)}throw _}}async doSync(c,u,m,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(c,u,m,I,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":m?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(c){return await this.updateSyncResourcePreview(c,async u=>{const m=await this.getMergeResult(u,A.CancellationToken.None);await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(m?.content||""));const I=m&&!m.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,A.CancellationToken.None):void 0;return u.acceptResult=I,u.mergeState=m.hasConflicts?"conflict":I?"accepted":"preview",u.localChange=I?I.localChange:m.localChange,u.remoteChange=I?I.remoteChange:m.remoteChange,u}),this.syncPreviewPromise}async accept(c,u){return await this.updateSyncResourcePreview(c,async m=>{const I=await this.getAcceptResult(m,c,u,A.CancellationToken.None);return m.acceptResult=I,m.mergeState="accepted",m.localChange=I.localChange,m.remoteChange=I.remoteChange,m}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async u=>{const m=await this.getMergeResult(u,A.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(m.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=m.localChange,u.remoteChange=m.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(c,u){if(!this.syncPreviewPromise)return;let m=await this.syncPreviewPromise;const I=m.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:N})=>this.extUri.isEqual(_,c)||this.extUri.isEqual(O,c)||this.extUri.isEqual(N,c));I!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const O=[...m.resourcePreviews];return O[I]=await u(O[I]),{...m,resourcePreviews:O}}),m=await this.syncPreviewPromise,this.updateConflicts(m.resourcePreviews),m.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(m=>[m,m.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(c){const u=c.filter(({mergeState:m})=>m==="conflict");(0,D.equals)(this._conflicts,u,(m,I)=>this.extUri.isEqual(m.previewResource,I.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:m})=>({created:u,uri:this.toRemoteBackupResource(m)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:m})=>({created:u,uri:this.toLocalBackupResource(m)}))}toRemoteBackupResource(c){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const u=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(u))){const{content:m}=await this.getUserData(u);if(m)return this.parseSyncData(m)?.machineId}}async resolveContent(c){const u=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(u))){const{content:m}=await this.getUserData(u);return m}return this.extUri.isEqual(c,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(c){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const m of u.resourcePreviews){if(this.extUri.isEqual(m.acceptedResource,c))return m.acceptResult?m.acceptResult.content:null;if(this.extUri.isEqual(m.remoteResource,c))return m.remoteContent;if(this.extUri.isEqual(m.localResource,c))return m.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(c,u,m,I,_){const O=await this.isRemoteDataFromCurrentMachine(c),N=await this.generateSyncPreview(c,u,O,I,_),z=[];for(const k of N){const M=k.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(k.localChange===0&&k.remoteChange===0)z.push({...k,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const j=m?await this.getMergeResult(k,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(k.previewResource,L.VSBuffer.fromString(j?.content||""));const U=j&&!j.hasConflicts?await this.getAcceptResult(k,k.previewResource,void 0,_):void 0;z.push({...k,acceptResult:U,mergeState:j?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:j?j.localChange:k.localChange,remoteChange:U?U.remoteChange:j?j.remoteChange:k.remoteChange})}}return{remoteUserData:c,lastSyncUserData:u,resourcePreviews:z,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(c.value.toString()),m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&m&&u.version!==m,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;const I=u;if(I.content===null)return{ref:u.ref,syncData:null};const _=JSON.parse(I.content);if(r(_))return{...u,syncData:_,content:void 0}}catch(c){c instanceof S.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const m=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:m,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(c){const{ref:u,content:m}=await this.getUserData(c);let I=null;return m!==null&&(I=this.parseSyncData(m)),{ref:u,syncData:I}}parseSyncData(c){try{const u=JSON.parse(c);if(r(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,P.isString)(c)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:u}}else{const u=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(c,u){const m=await this.currentMachineIdPromise,I={version:this.version,machineId:m,content:c};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),u,this.syncHeaders),{ref:u,syncData:I}}async backupLocal(c){const u={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([Y(1,S.IFileService),Y(2,h.IEnvironmentService),Y(3,w.IStorageService),Y(4,l.IUserDataSyncStoreService),Y(5,l.IUserDataSyncBackupStoreService),Y(6,l.IUserDataSyncEnablementService),Y(7,g.ITelemetryService),Y(8,l.IUserDataSyncLogService),Y(9,y.IConfigurationService),Y(10,p.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(c,u,m,I,_,O,N,z,k,M,j,U){super(u,m,I,_,O,N,z,k,M,j,U);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(c,u,m){try{u?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(c),m?void 0:u):await this.fileService.createFile(this.file,L.VSBuffer.fromString(c),{overwrite:m})}catch(I){throw I instanceof S.FileOperationError&&I.fileOperationResult===1||I instanceof S.FileOperationError&&I.fileOperationResult===3?new l.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};i=de([Y(2,S.IFileService),Y(3,h.IEnvironmentService),Y(4,w.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,g.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,y.IConfigurationService),Y(11,p.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(c,u,m,I,_,O,N,z,k,M,j,U,G){super(c,u,m,I,_,O,N,z,k,M,U,G);this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(c){const u=[];return(0,R.parse)(c,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([Y(2,S.IFileService),Y(3,h.IEnvironmentService),Y(4,w.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,g.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,l.IUserDataSyncUtilService),Y(11,y.IConfigurationService),Y(12,p.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(c,u,m,I,_){this.resource=c,this.environmentService=u,this.logService=m,this.fileService=I,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:c,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const m=this.parseSyncData(u);if(!!m)try{await this.doInitialize({ref:c,syncData:m})}catch(I){this.logService.error(I)}}parseSyncData(c){try{const u=JSON.parse(c);if(r(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,u={}){const m={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(m)))}};s=de([Y(1,h.IEnvironmentService),Y(2,f.ILogService),Y(3,S.IFileService),Y(4,p.IUriIdentityService)],s),e.AbstractInitializer=s}),define(ie[225],re([0,1,5,25,9,3,49,27,7,20,13,30,31,63,14,8,23,21,34,47,222,98,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function a(s,o){const c=JSON.parse(s.content);if(s.version===1||s.version===2){const u=(await o.getInstalled(0)).filter(m=>m.isBuiltin);for(const m of c)s.version===1&&(m.enabled===!1&&(m.disabled=!0),delete m.enabled),s.version===2&&u.every(I=>!(0,d.areSameExtensions)(I.identifier,m.identifier))&&(m.installed=!0)}return c}let i=class mt extends g.AbstractSynchroniser{constructor(o,c,u,m,I,_,O,N,z,k,M,j,U,G,K){super("extensions",c,o,u,m,I,j,U,z,M,K);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=N,this.extensionGalleryService=k,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.debounce(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:W})=>!!W)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(o,c){const u=o.syncData?await a(o.syncData,this.extensionManagementService):null,m=c?.skippedExtensions||[],I=c?.syncData?await a(c.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);u?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:k}=(0,p.merge)(O,u,I,m,N),M={local:z,remote:k,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:k!==null?2:0};return[{skippedExtensions:m,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:u?this.stringify(u,!1):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const c=o.syncData?await a(o.syncData,this.extensionManagementService):null,u=await this.extensionManagementService.getInstalled(void 0,!0),m=this.getLocalExtensions(u),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),{remote:_}=(0,p.merge)(m,c,c,o.skippedExtensions||[],I);return _!==null}getPreviewContent(o,c,u,m){const I=[...c,...u],_=new Set,O=N=>{_.add(N.id.toLowerCase()),N.uuid&&_.add(N.uuid)};I.forEach(({identifier:N})=>O(N)),m.forEach(O);for(const N of o)_.has(N.identifier.id.toLowerCase())||N.identifier.uuid&&_.has(N.identifier.uuid)||I.push(N);return this.stringify(I,!1)}async getMergeResult(o,c){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,c,u,m){if(this.extUri.isEqual(c,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(c,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(c,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${c.toString()}`)}async acceptLocal(o){const c=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),m=(0,p.merge)(o.localExtensions,null,null,o.skippedExtensions,u),{local:I,remote:_}=m;return{content:o.localContent,local:I,remote:_,localChange:I.added.length>0||I.removed.length>0||I.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(o){const c=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),m=o.remoteContent?JSON.parse(o.remoteContent):null;if(m!==null){const I=(0,p.merge)(o.localExtensions,m,o.localExtensions,[],u),{local:_,remote:O}=I;return{content:o.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,c,u,m){let{skippedExtensions:I,localExtensions:_}=u[0][0],{local:O,remote:N,localChange:z,remoteChange:k}=u[0][1];if(z===0&&k===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(_)),I=await this.updateLocalExtensions(O.added,O.removed,O.updated,I)),N){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(N.all);o=await this.updateRemoteUserData(M,m?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${N.added.length?` Added: ${JSON.stringify(N.added.map(j=>j.identifier.id))}.`:""}${N.updated.length?` Updated: ${JSON.stringify(N.updated.map(j=>j.identifier.id))}.`:""}${N.removed.length?` Removed: ${JSON.stringify(N.removed.map(j=>j.identifier.id))}.`:""}`)}c?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:I}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${I.length?` Skipped: ${JSON.stringify(I.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,mt.EXTENSIONS_DATA_URI)){const u=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),I=this.getLocalExtensions(u).filter(_=>!m.some(O=>(0,d.areSameExtensions)({id:O},_.identifier)));return this.stringify(I,!0)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)){const u=await this.resolvePreviewContent(o);return u&&this.stringify(JSON.parse(u),!0)}let c=await super.resolveContent(o);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(o)),c){const u=this.parseSyncData(c);if(u)switch(this.extUri.basename(o)){case"extensions.json":return this.stringify(this.parseExtensions(u),!0)}}return null}stringify(o,c){return o.sort((u,m)=>!u.identifier.uuid&&m.identifier.uuid?-1:u.identifier.uuid&&!m.identifier.uuid?1:(0,R.compare)(u.identifier.id,m.identifier.id)),c?(0,T.toFormattedString)(o,{}):JSON.stringify(o)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(u=>u.installed||u.disabled))return!0}catch{}return!1}async updateLocalExtensions(o,c,u,m){const I=[],_=[],O=await this.extensionManagementService.getInstalled();if(c.length){const z=O.filter(({identifier:k,isBuiltin:M})=>!M&&c.some(j=>(0,d.areSameExtensions)(k,j)));await D.Promises.settled(z.map(async k=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,k.identifier.id),await this.extensionManagementService.uninstall(k,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,k.identifier.id),I.push(k.identifier)}))}(o.length||u.length)&&await D.Promises.settled([...o,...u].map(async z=>{const k=O.find(j=>(0,d.areSameExtensions)(j.identifier,z.identifier));if(k&&k.isBuiltin){z.state&&k.manifest.version===z.version&&this.updateExtensionState(z.state,k,k.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(U=>(0,d.areSameExtensions)(U,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id))),I.push(z.identifier);return}const M=(await this.extensionGalleryService.getExtensions([z.identifier],!!z.preRelease,n.CancellationToken.None))[0];if(z.state&&(k?k.manifest.version===z.version:!!M)&&this.updateExtensionState(z.state,k||M,k?.manifest.version),M)try{this.extensionEnablementService.getDisabledExtensions().some(U=>(0,d.areSameExtensions)(U,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,M.version))),(!k||k.preRelease!==z.preRelease)&&(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:z.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,M.version),I.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),_.push(z)))}catch(j){_.push(z),j instanceof b.ExtensionManagementError&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatiblePreRelease,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else _.push(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,z.identifier.id)}));const N=[];for(const z of m)I.some(k=>(0,d.areSameExtensions)(k,z.identifier))||N.push(z);for(const z of _)N.some(k=>(0,d.areSameExtensions)(k.identifier,z.identifier))||N.push(z);return N}updateExtensionState(o,c,u){const m=this.extensionStorageService.getExtensionState(c,!0)||{},I=u?this.extensionStorageService.getKeysForSync({id:c.identifier.id,version:u}):void 0;I?I.forEach(_=>{m[_]=o[_]}):Object.keys(o).forEach(_=>m[_]=o[_]),this.extensionStorageService.setExtensionState(c,m,!0)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const c=this.extensionEnablementService.getDisabledExtensions();return o.map(u=>{const{identifier:m,isBuiltin:I,manifest:_,preRelease:O}=u,N={identifier:m,preRelease:O,version:_.version};c.some(z=>(0,d.areSameExtensions)(z,m))&&(N.disabled=!0),I||(N.installed=!0);try{const z=this.extensionStorageService.getKeysForSync({id:m.id,version:_.version});if(z){const k=this.extensionStorageService.getExtensionState(u,!0)||{};N.state=Object.keys(k).reduce((M,j)=>(z.includes(j)&&(M[j]=k[j]),M),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(z))}return N})}};i.EXTENSIONS_DATA_URI=C.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,P.IEnvironmentService),Y(1,h.IFileService),Y(2,f.IStorageService),Y(3,r.IUserDataSyncStoreService),Y(4,r.IUserDataSyncBackupStoreService),Y(5,b.IExtensionManagementService),Y(6,b.IGlobalExtensionEnablementService),Y(7,l.IIgnoredExtensionsManagementService),Y(8,r.IUserDataSyncLogService),Y(9,b.IExtensionGalleryService),Y(10,E.IConfigurationService),Y(11,r.IUserDataSyncEnablementService),Y(12,v.ITelemetryService),Y(13,y.IExtensionStorageService),Y(14,w.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let t=class extends g.AbstractInitializer{constructor(o,c,u,m,I,_){super("extensions",m,I,u,_);this.extensionManagementService=o,this.ignoredExtensionsManagementService=c}async parseExtensions(o){return o.syncData?await a(o.syncData,this.extensionManagementService):null}generatePreview(o,c){const u=[],m=[],I=[];for(const _ of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=c.find(N=>(0,d.areSameExtensions)(N.identifier,_.identifier));O?(u.push(O),_.disabled&&I.push(_.identifier)):_.installed&&(m.push(_.identifier),_.disabled&&I.push(_.identifier))}return{installedExtensions:u,newExtensions:m,disabledExtensions:I,remoteExtensions:o}}};t=de([Y(0,b.IExtensionManagementService),Y(1,l.IIgnoredExtensionsManagementService),Y(2,h.IFileService),Y(3,P.IEnvironmentService),Y(4,S.ILogService),Y(5,w.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(ie[226],re([0,1,28,24]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,C,E,P,b){if(!C)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const d=A(R,C);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=E?A(E,C):{added:Object.keys(C).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},h=E?A(E,R):{added:Object.keys(R).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},f=D.deepClone(C),v=!E;for(const w of h.added.values())w!==n.SYNC_SERVICE_URL_TYPE&&v&&y.added.has(w)||(f[w]=R[w]);for(const w of h.updated.values())f[w]=R[w];for(const w of h.removed.values())P.unregistered.includes(w)||delete f[w];for(const w of y.added.values()){const g=C[w];if(P.machine.includes(w)){b.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(E&&h.added.has(w))continue;const p=R[w];p&&p.value===g.value||w===n.SYNC_SERVICE_URL_TYPE&&v&&h.added.has(w)||(p?S.updated[w]=g:S.added[w]=g)}for(const w of y.updated.values()){const g=C[w];if(P.machine.includes(w)){b.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const p=R[w];p&&p.value===g.value||(S.updated[w]=g)}for(const w of y.removed.values()){if(P.machine.includes(w)){b.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||S.removed.push(w)}return{local:S,remote:T(f,C)?null:f}}e.merge=L;function A(R,C){const E=Object.keys(R),P=Object.keys(C),b=P.filter(h=>E.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),d=E.filter(h=>P.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),y=new Set;for(const h of E){if(d.has(h))continue;const S=R[h],f=C[h];D.equals(S,f)||y.add(h)}return{added:b,removed:d,updated:y}}function T(R,C){const{added:E,removed:P,updated:b}=A(R,C);return E.size===0&&P.size===0&&b.size===0}}),define(ie[227],re([0,1,17,9,3,35,49,4,7,29,20,13,14,8,46,23,21,34,47,52,226,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function i(u,m){const I=u.storage?Object.keys(u.storage).sort():[],_={};return I.forEach(O=>_[O]=u.storage[O]),u.storage=_,m?(0,T.toFormattedString)(u,{}):JSON.stringify(u)}const t=1;let s=class vt extends w.AbstractSynchroniser{constructor(m,I,_,O,N,z,k,M,j,U){super("globalState",m,N,j,I,_,z,k,O,M,U);this.storageService=j,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(m.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(m.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),L.Event.filter(j.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:j.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(m,I,_){const O=m.syncData?JSON.parse(m.syncData.content):null;I=I===null&&_?m:I;const N=I&&I.syncData?JSON.parse(I.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const k=this.getStorageKeys(N),{local:M,remote:j}=(0,p.merge)(z.storage,O?O.storage:null,N?N.storage:null,k,this.logService),U={content:null,local:M,remote:j,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:i(z,!1),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:k}]}async hasRemoteChanged(m){const I=m.syncData?JSON.parse(m.syncData.content):null;if(I===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(I),{remote:N}=(0,p.merge)(_.storage,I.storage,I.storage,O,this.logService);return N!==null}async getMergeResult(m,I){return{...m.previewResult,hasConflicts:!1}}async getAcceptResult(m,I,_,O){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(I,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(m){return{content:m.localContent,local:{added:{},removed:[],updated:{}},remote:m.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(m){if(m.remoteContent!==null){const I=JSON.parse(m.remoteContent),{local:_,remote:O}=(0,p.merge)(m.localUserData.storage,I.storage,null,m.storageKeys,this.logService);return{content:m.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:m.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(m,I,_,O){let{localUserData:N}=_[0][0],{local:z,remote:k,localChange:M,remoteChange:j}=_[0][1];if(M===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(z),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:k});m=await this.updateRemoteUserData(U,O?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m)){const _=await this.resolvePreviewContent(m);return _&&i(JSON.parse(_),!0)}let I=await super.resolveContent(m);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(m)),I){const _=this.parseSyncData(I);if(_)switch(this.extUri.basename(m)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:m}=await this.getLocalGlobalState();if(Object.keys(m).length>1||m[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const m={},I=await this.getLocalArgvContent(),_=(0,A.parse)(I);for(const O of a)_[O]!==void 0&&(m[`${r}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const N=this.storageService.get(O,0);N&&(m[O]={version:1,value:N})}return{storage:m}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const m=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),m.value.toString()}catch(m){this.logService.debug((0,n.getErrorMessage)(m))}return"{}"}async writeLocalGlobalState({added:m,removed:I,updated:_}){const O={},N={},z=(M,j)=>{for(const U of M){if(U.startsWith(r)){O[U.substring(r.length)]=j?j[U].value:void 0;continue}if(j){const G=j[U];G.value!==String(this.storageService.get(U,0))&&(N[U]=G.value)}else this.storageService.get(U,0)!==void 0&&(N[U]=void 0)}};if(z(Object.keys(m),m),z(Object.keys(_),_),z(I),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(N))this.storageService.store(M,N[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(m){const I=await this.getLocalArgvContent();let _=I;for(const O of Object.keys(m))_=(0,g.edit)(_,[O],m[O],{});I!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(m){const I=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...I,..._],N=m?.storage?Object.keys(m.storage).filter(z=>!z.startsWith(r)&&!O.includes(z)&&this.storageService.get(z,0)!==void 0):[];if(!R.isWeb){const z=[...l.ALL_SYNC_RESOURCES.map(k=>(0,l.getEnablementKey)(k)),l.SYNC_SERVICE_URL_TYPE];N.push(...z),_.push(...z)}return{user:I,machine:_,unregistered:N}}};s.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([Y(0,d.IFileService),Y(1,l.IUserDataSyncStoreService),Y(2,l.IUserDataSyncBackupStoreService),Y(3,l.IUserDataSyncLogService),Y(4,b.IEnvironmentService),Y(5,l.IUserDataSyncEnablementService),Y(6,f.ITelemetryService),Y(7,P.IConfigurationService),Y(8,S.IStorageService),Y(9,v.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends w.AbstractInitializer{constructor(m,I,_,O,N){super("globalState",_,O,I,N);this.storageService=m}async doInitialize(m){const I=m.syncData?JSON.parse(m.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const N of Object.keys(I.storage))N.startsWith(r)?_[N.substring(r.length)]=I.storage[N].value:this.storageService.get(N,0)===void 0&&(O[N]=I.storage[N].value);if(Object.keys(_).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const z of Object.keys(_))N=(0,g.edit)(N,[z],_[z],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N))}if(Object.keys(O).length)for(const N of Object.keys(O))this.storageService.store(N,O[N],0,0)}};o=de([Y(0,S.IStorageService),Y(1,d.IFileService),Y(2,b.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,v.IUriIdentityService)],o),e.GlobalStateInitializer=o;let c=class{constructor(m,I,_,O,N){this.userDataSyncStoreClient=m,this.storageService=I,this.environmentService=_,this.fileService=O,this.logService=N}getSyncStoreType(m){return this.parseGlobalState(m)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(m){const I=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(m,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(m,I)}throw _}}async doSync(m,I){const _=await this.userDataSyncStoreClient.read("globalState",null,I),O=this.parseGlobalState(_)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:m,version:t};const N=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:t,machineId:N,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(z),_.ref,I)}parseGlobalState({content:m}){if(!m)return null;const I=JSON.parse(m);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};c=de([Y(1,S.IStorageService),Y(2,b.IEnvironmentService),Y(3,d.IFileService),Y(4,y.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(ie[228],re([0,1,16,17,3,35,4,15,144,20,13,14,23,21,34,47,223,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,a){try{const i=JSON.parse(l);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return a.error(i),null}}e.getKeybindingsContentFromSyncContent=w;let g=class extends S.AbstractJsonFileSynchroniser{constructor(r,a,i,t,s,o,c,u,m,I,_){super(c.keybindingsResource,"keybindings",o,c,u,r,a,s,I,i,m,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,i,t){const s=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&i?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,c=await this.getLocalFileContent(),u=await this.getFormattingOptions();let m=null,I=!1,_=!1,O=!1;if(s){let z=c?c.value.toString():"[]";if(z=z||"[]",this.hasErrors(z))throw new v.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==z||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const k=await(0,f.merge)(z,s,o,u,this.userDataSyncUtilService);k.hasChanges&&(m=k.mergeContent,O=k.hasConflicts,I=O||k.mergeContent!==z,_=O||k.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),m=c.value.toString(),_=!0);const N={content:m,localChange:I?c?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",s=await this.getFormattingOptions(),o=await(0,f.merge)(t||"[]",a,a,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,i,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:c,remoteChange:u}=i[0][1];if(c===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new v.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const m=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(m,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,A.parse)(r.value.toString());if((0,D.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return w(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let i={};try{i=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,T.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=de([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncBackupStoreService),Y(2,v.IUserDataSyncLogService),Y(3,E.IConfigurationService),Y(4,v.IUserDataSyncEnablementService),Y(5,b.IFileService),Y(6,P.IEnvironmentService),Y(7,d.IStorageService),Y(8,v.IUserDataSyncUtilService),Y(9,y.ITelemetryService),Y(10,h.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let p=class extends S.AbstractInitializer{constructor(r,a,i,t){super("keybindings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,A.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};p=de([Y(0,b.IFileService),Y(1,P.IEnvironmentService),Y(2,v.IUserDataSyncLogService),Y(3,h.IUriIdentityService)],p),e.KeybindingsInitializer=p}),define(ie[229],re([0,1,16,35,69,49,28,52,24]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(o,c,u){let m=[];u?m=b(u):m=P(c);const I=[],_=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const O of m)O.startsWith("-")?_.push(O.substring(1)):I.push(O);return(0,D.distinct)([...o,...I].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function P(o){let c=o.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=o.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:o.getValue("settingsSync.ignoredSettings")||[]}function b(o){const c=(0,n.parse)(o);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function d(o,c,u,m){if(u.length){const I=s(c),_=(0,n.parse)(c),O=(0,n.parse)(o),N=[];for(const z of u){const k=_[z],M=O[z];k===void 0?o=R.edit(o,[z],void 0,m):M!==void 0?o=R.edit(o,[z],k,m):N.push(l(z,I))}N.sort((z,k)=>z.startOffset-k.startOffset),N.forEach(z=>o=v(z.setting.key,c,o,m))}return o}e.updateIgnoredSettings=d;function y(o,c,u,m,I,_){const O=d(o,c,m,_),N=u!==O,z=u!==c;if(!N&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!N)return{conflictsSettings:[],localContent:d(c,o,m,_),remoteContent:null,hasConflicts:!1};if(u===null&&S(o)){const $=h(o,c,m)?null:d(c,o,m,_);return{conflictsSettings:[],localContent:$,remoteContent:null,hasConflicts:!1}}let k=o,M=c;const j=(0,n.parse)(o),U=(0,n.parse)(c),G=u?(0,n.parse)(u):null,K=m.reduce(($,B)=>($.add(B),$),new Set),x=f(j,U,K),W=f(G,j,K),X=f(G,U,K),H=new Map,Z=new Set,ee=$=>{Z.add($);const B=I.filter(({key:te})=>te===$)[0];B?(k=R.edit(k,[$],B.value,_),M=R.edit(M,[$],B.value,_)):H.set($,{key:$,localValue:j[$],remoteValue:U[$]})};for(const $ of W.removed.values())X.updated.has($)?ee($):M=R.edit(M,[$],void 0,_);for(const $ of X.removed.values())Z.has($)||(W.updated.has($)?ee($):k=R.edit(k,[$],void 0,_));for(const $ of W.updated.values())Z.has($)||(X.updated.has($)?x.updated.has($)&&ee($):M=R.edit(M,[$],j[$],_));for(const $ of X.updated.values())Z.has($)||(W.updated.has($)?x.updated.has($)&&ee($):k=R.edit(k,[$],U[$],_));for(const $ of W.added.values())Z.has($)||(X.added.has($)?x.updated.has($)&&ee($):M=v($,k,M,_));for(const $ of X.added.values())Z.has($)||(W.added.has($)?x.updated.has($)&&ee($):k=v($,M,k,_));const q=H.size>0||!h(k,M,m),F=q||!h(k,o,[]),V=q||!h(M,c,[]);return{localContent:F?k:null,remoteContent:V?M:null,conflictsSettings:[...H.values()],hasConflicts:q}}e.merge=y;function h(o,c,u){if(o===c)return!0;const m=(0,n.parse)(o),I=(0,n.parse)(c),_=u.reduce((z,k)=>(z.add(k),z),new Set),O=s(o).filter(z=>!(z.setting&&_.has(z.setting.key))),N=s(c).filter(z=>!(z.setting&&_.has(z.setting.key)));if(O.length!==N.length)return!1;for(let z=0;z<O.length;z++){const k=O[z],M=N[z];if(k.setting&&M.setting){if(k.setting.key!==M.setting.key||!T.equals(m[k.setting.key],I[k.setting.key]))return!1}else if(!k.setting&&!M.setting){if(k.value!==M.value)return!1}else return!1}return!0}e.areSame=h;function S(o){return o?s(o).length===0:!0}e.isEmpty=S;function f(o,c,u){const m=o?Object.keys(o).filter(z=>!u.has(z)):[],I=Object.keys(c).filter(z=>!u.has(z)),_=I.filter(z=>m.indexOf(z)===-1).reduce((z,k)=>(z.add(k),z),new Set),O=m.filter(z=>I.indexOf(z)===-1).reduce((z,k)=>(z.add(k),z),new Set),N=new Set;if(o)for(const z of m){if(O.has(z))continue;const k=o[z],M=c[z];T.equals(k,M)||N.add(z)}return{added:_,removed:O,updated:N}}function v(o,c,u,m){const I=(0,n.parse)(c),_=s(c),O=s(u),N=w(o,_,O);return g(u,o,I[o],N,O,m)}e.addSetting=v;function w(o,c,u){const m=c.findIndex(_=>_.setting?.key===o),I=c[m-1];if(I){if(I.setting){const O=l(I.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!0}}else{const O=r(m,c);if(O){const N=l(O.setting.key,u);if(N){const z=a(u.indexOf(N),u),k=i(c,O,c[m]);if(z){const M=i(u,N,z),j=t(k,M);return j?{index:u.indexOf(j),insertAfter:!0}:{index:u.indexOf(z),insertAfter:!1}}else{const M=i(u,N,u[u.length-1]),j=t(k,M);return j?{index:u.indexOf(j),insertAfter:!0}:{index:u.length-1,insertAfter:!0}}}}}const _=c[m+1];if(_)if(_.setting){const O=l(_.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!1}}else{const O=a(m,c);if(O){const N=l(O.setting.key,u);if(N){const z=r(u.indexOf(N),u),k=i(c,c[m],O);if(z){const M=i(u,z,N),j=t(k.reverse(),M.reverse());return j?{index:u.indexOf(j),insertAfter:!1}:{index:u.indexOf(z),insertAfter:!0}}else{const M=i(u,u[0],N),j=t(k.reverse(),M.reverse());return j?{index:u.indexOf(j),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:u.length-1,insertAfter:!0}}function g(o,c,u,m,I,_){let O;return m.index===-1?O=(0,L.setProperty)(o,[c],u,_):O=p(o,c,u,m,I,_).map(N=>(0,L.withFormatting)(o,N,_)[0]),(0,L.applyEdits)(o,O)}function p(o,c,u,m,I,_){const O=`${JSON.stringify(c)}: ${JSON.stringify(u)}`,N=(0,A.getEOL)(_,o),z=I[m.index];if(m.insertAfter){const k=[];if(z.setting)k.push({offset:z.endOffset,length:0,content:","+O});else{const M=a(m.index,I),j=r(m.index,I),U=j?.setting?.commaOffset;j&&U===void 0&&k.push({offset:j.endOffset,length:0,content:","});const G=U!==void 0&&U>z.endOffset;k.push({offset:G?U+1:z.endOffset,length:0,content:M?N+O+",":N+O})}return k}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const k=(I[m.index-1]&&!I[m.index-1].setting?N:"")+O+(a(m.index,I)?",":"")+N;return[{offset:z.startOffset,length:0,content:k}]}}function l(o,c){return c.filter(u=>u.setting?.key===o)[0]}function r(o,c){for(let u=o-1;u>=0;u--)if(c[u].setting)return c[u]}function a(o,c){for(let u=o+1;u<c.length;u++)if(c[u].setting)return c[u]}function i(o,c,u){const m=o.indexOf(c),I=o.indexOf(u);return o.filter((_,O)=>m<O&&O<I)}function t(o,c){if(o.length&&c.length){let u=0;for(;u<c.length&&u<o.length;u++)if(o[u].value!==c[u].value)return c[u-1];return c[u-1]}}function s(o){const c=[];let u=-1,m,I;const _={onObjectBegin:O=>{u++},onObjectProperty:(O,N,z)=>{u===0&&(m=N,I=O)},onObjectEnd:(O,N)=>{u--,u===0&&c.push({startOffset:m,endOffset:O+N,value:o.substring(m,O+N),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(O,N)=>{u++},onArrayEnd:(O,N)=>{u--,u===0&&c.push({startOffset:m,endOffset:O+N,value:o.substring(m,O+N),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(O,N,z)=>{u===0&&c.push({startOffset:m,endOffset:N+z,value:o.substring(m,N+z),setting:{key:I,commaOffset:void 0}})},onSeparator:(O,N,z)=>{if(u===0&&O===","){let k=c.length-1;for(;k>=0&&!c[k].setting;k--);const M=c[k];M&&c.splice(k,1,{startOffset:M.startOffset,endOffset:M.endOffset,value:M.value,setting:{key:M.setting.key,commaOffset:N}})}},onComment:(O,N)=>{u===0&&c.push({startOffset:O,endOffset:O+N,value:o.substring(O,O+N)})}};return(0,n.visit)(o,_),c}}),define(ie[230],re([0,1,17,3,145,20,89,13,30,14,23,21,34,47,52,229,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function v(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const r=JSON.parse(l);return v(r)?r:{settings:l}}e.parseSettingsSyncContent=w;let g=class extends y.AbstractJsonFileSynchroniser{constructor(r,a,i,t,s,o,c,u,m,I,_,O){super(a.settingsResource,"settings",r,a,i,t,s,m,I,o,c,u,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const a=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,a),t=this.getSettingsSyncContent(i),s=new T.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&s.parse(t.settings),s.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,a,i){const t=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(r);a=a===null&&i?r:a;const c=a?this.getSettingsSyncContent(a):null,u=await this.getIgnoredSettings();let m=null,I=!1,_=!1,O=!1;if(o){let z=t?t.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const k=(0,S.merge)(z,o.settings,c?c.settings:null,u,[],s);m=k.localContent||k.remoteContent,I=k.localContent!==null,_=k.remoteContent!==null,O=k.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),m=t.value.toString(),_=!0);const N={content:m,localChange:I?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getSettingsSyncContent(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,S.merge)(t||"{}",a.settings,a.settings,s,[],o).remoteContent!==null}async getMergeResult(r,a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,S.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,a,i,t){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?(0,S.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent!==null?(0,S.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,S.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:c,remoteChange:u}=i[0][1];if(c===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),u!==0){const m=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(o);o=(0,S.updateIgnoredSettings)(o,I?I.settings:"{}",_,m),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=await this.getFormattingOptions(),i=(0,h.edit)(r.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,S.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let a=await super.resolvePreviewContent(r);if(a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,S.updateIgnoredSettings)(a,"{}",t,i)}return a}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:s})=>!!s)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,S.getIgnoredSettings)(a,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new f.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};g=de([Y(0,E.IFileService),Y(1,R.IEnvironmentService),Y(2,P.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncBackupStoreService),Y(5,f.IUserDataSyncLogService),Y(6,f.IUserDataSyncUtilService),Y(7,A.IConfigurationService),Y(8,f.IUserDataSyncEnablementService),Y(9,b.ITelemetryService),Y(10,C.IExtensionManagementService),Y(11,d.IUriIdentityService)],g),e.SettingsSynchroniser=g;let p=class extends y.AbstractInitializer{constructor(r,a,i,t){super("settings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,S.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}};p=de([Y(0,E.IFileService),Y(1,R.IEnvironmentService),Y(2,f.IUserDataSyncLogService),Y(3,d.IUriIdentityService)],p),e.SettingsInitializer=p}),define(ie[231],re([0,1,17,3,28,20,13,14,23,21,34,47,224,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends b.AbstractSynchroniser{constructor(v,w,g,p,l,r,a,i,t,s){super("snippets",w,v,g,p,l,i,t,r,a,s);this.version=1,this.snippetsFolder=v.snippetsHome,this._register(this.fileService.watch(v.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(v,w,g){const p=await this.getSnippetsFileContents(),l=this.toSnippetsContents(p),r=v.syncData?this.parseSnippets(v.syncData):null;w=w===null&&g?v:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,d.merge)(l,r,a);return this.getResourcePreviews(i,p,r||{})}async hasRemoteChanged(v){const w=v.syncData?this.parseSnippets(v.syncData):null;if(w===null)return!0;const g=await this.getSnippetsFileContents(),p=this.toSnippetsContents(g),l=(0,d.merge)(p,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(v,w){return v.previewResult}async getAcceptResult(v,w,g,p){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:v.fileContent?v.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:v.remoteContent,localChange:v.remoteContent!==null?v.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return g===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:g,localChange:g===null?v.fileContent!==null?3:0:2,remoteChange:g===null?v.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(v,w,g,p){const l=g.map(([r,a])=>({...r,acceptResult:a}));l.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,p)),l.some(({remoteChange:r})=>r!==0)&&(v=await this.updateRemoteSnippets(l,v,p)),w?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(v,w,g){const p=new Map;for(const l of Object.keys(v.local.added)){const r={content:v.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};p.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(v.local.updated)){const r={content:v.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of v.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(v.remote.added)){const r={content:v.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(v.remote.updated)){const r={content:v.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of v.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of v.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:g[l]?2:1};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!p.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:v}){let w=await super.resolveContent(v);if(w){const g=this.parseSyncData(w);if(g){const p=this.parseSnippets(g),l=[];for(const r of Object.keys(p)){const a=this.extUri.joinPath(v,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);l.push({resource:a,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(v){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(v);let w=await super.resolveContent(v);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(v)),w){const g=this.parseSyncData(w);if(g)return this.parseSnippets(g)[this.extUri.basename(v)]||null}return null}async hasLocalData(){try{const v=await this.getSnippetsFileContents();if(Object.keys(v).length)return!0}catch{}return!1}async updateLocalBackup(v){const w={};for(const g of v)g.fileContent&&(w[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(v,w){for(const{fileContent:g,acceptResult:p,localResource:l,remoteResource:r,localChange:a}of v)if(a!==0){const i=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,i);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(p.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(p.content),w?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(v,w,g){const p=w.syncData?this.parseSnippets(w.syncData):{},l=(0,L.deepClone)(p);for(const{acceptResult:r,localResource:a,remoteResource:i,remoteChange:t}of v)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(i);t===3?delete l[s]:l[s]=r.content}return(0,d.areSame)(p,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),g?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(v){return JSON.parse(v.content)}toSnippetsContents(v){const w={};for(const g of Object.keys(v))w[g]=v[g].value.toString();return w}async getSnippetsFileContents(){const v={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof R.FileOperationError&&g.fileOperationResult===1)return v;throw g}for(const g of w.children||[]){const p=g.resource,l=this.extUri.extname(p);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,p),a=await this.fileService.readFile(p);v[r]=a}}return v}};h=de([Y(0,T.IEnvironmentService),Y(1,R.IFileService),Y(2,C.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,A.IConfigurationService),Y(7,y.IUserDataSyncEnablementService),Y(8,E.ITelemetryService),Y(9,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let S=class extends b.AbstractInitializer{constructor(v,w,g,p){super("snippets",w,g,v,p)}async doInitialize(v){const w=v.syncData?JSON.parse(v.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(w)){const l=w[p];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(r,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(v)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(v){return v.fileOperationResult===1}}};S=de([Y(0,R.IFileService),Y(1,T.IEnvironmentService),Y(2,y.IUserDataSyncLogService),Y(3,P.IUriIdentityService)],S),e.SnippetsInitializer=S}),define(ie[64],re([0,1,3,2,6,24]),function(J,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let T=class extends n.Disposable{constructor(C,E){super();this.userDataSyncStoreService=C,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};T=de([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ie[232],re([0,1,5,17,56,2,19,20,13,14,24]),function(J,e,D,n,L,A,T,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let b=class extends A.Disposable{constructor(y,h,S,f){super();this.environmentService=y,this.fileService=h,this.configurationService=S,this.logService=f,P.ALL_SYNC_RESOURCES.forEach(v=>this.cleanUpBackup(v))}async getAllRefs(y){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,y),S=await this.fileService.resolve(h);return S.children?S.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort().reverse().map(v=>({ref:v.name,created:this.getCreationTime(v)})):[]}async resolveContent(y,h){if(!h){const S=await this.getAllRefs(y);S.length&&(h=S[S.length-1].ref)}if(h){const S=(0,T.joinPath)(this.environmentService.userDataSyncHome,y,h);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(y,h){const S=(0,T.joinPath)(this.environmentService.userDataSyncHome,y),f=(0,T.joinPath)(S,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,n.VSBuffer.fromString(h))}catch(v){this.logService.error(v)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(h))return}catch{return}const S=await this.fileService.resolve(h);if(S.children){const f=S.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),v=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=f.filter(p=>Date.now()-this.getCreationTime(p)>v);const g=f.length-w.length;g<10&&(w=w.slice(10-g)),await D.Promises.settled(w.map(async p=>{this.logService.info("Deleting from backup",p.resource.path),await this.fileService.del(p.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};b=de([Y(0,C.IEnvironmentService),Y(1,E.IFileService),Y(2,R.IConfigurationService),Y(3,P.IUserDataSyncLogService)],b),e.UserDataSyncBackupStoreService=b}),define(ie[233],re([0,1,3,2,4,13,23,21,24]),function(J,e,D,n,L,A,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let P=class extends n.Disposable{constructor(d,y,h,S){super();this.storageService=d,this.telemetryService=y,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(d.onDidChangeValue(f=>this.onDidStorageChange(f)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:d}),this.storageService.store(E,d,0,1))}isResourceEnabled(d){return this.storageService.getBoolean((0,C.getEnablementKey)(d),0,!0)}setResourceEnablement(d,y){if(this.isResourceEnabled(d)!==y){const h=(0,C.getEnablementKey)(d);this.telemetryService.publicLog2(h,{enabled:y}),this.storeResourceEnablement(h,y)}}getResourceSyncStateVersion(d){}storeResourceEnablement(d,y){this.storageService.store(d,y,0,L.isWeb?0:1)}onDidStorageChange(d){if(d.scope!==0)return;if(E===d.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=C.ALL_SYNC_RESOURCES.filter(h=>(0,C.getEnablementKey)(h)===d.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};P=de([Y(0,T.IStorageService),Y(1,R.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,C.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ie[234],re([0,1,2,7]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(d){this.service=d}listen(d,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(d,y,h){switch(y){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class A{constructor(d){this.service=d}listen(d,y){throw new Error(`Event not found: ${y}`)}call(d,y,h){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class T{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(d){this.service=d}listen(d,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(d,y,h){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class C{constructor(d){this.service=d}listen(d,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(d,y,h){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class E{constructor(d){this.service=d}listen(d,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(d,y,h){switch(y){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class P extends D.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:n.URI.revive(d.url),type:d.type,defaultUrl:n.URI.revive(d.defaultUrl),insidersUrl:n.URI.revive(d.insidersUrl),stableUrl:n.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ie[235],re([0,1,13,8]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends n.AbstractLogger{constructor(T,R){super();this.logger=this._register(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.logger.trace(T,...R)}debug(T,...R){this.logger.debug(T,...R)}info(T,...R){this.logger.info(T,...R)}warn(T,...R){this.logger.warn(T,...R)}error(T,...R){this.logger.error(T,...R)}critical(T,...R){this.logger.critical(T,...R)}flush(){this.logger.flush()}};L=de([Y(0,n.ILoggerService),Y(1,D.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(ie[65],re([0,1,3,2,4,27,148,13,14,6,26,46,23,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let S=class Ze extends n.Disposable{constructor(v,w,g,p,l,r){super();this.storageService=g,this.userDataSyncStoreService=p,this.logService=l,this.productService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(v,w,g)}async getMachines(v){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(v)).machines.map(p=>({...p,isCurrent:p.id===w}))}async addCurrentMachine(v){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(v);g.machines.some(({id:p})=>p===w)||(g.machines.push({id:w,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(v){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(v),p=g.machines.filter(({id:l})=>l!==w);p.length!==g.machines.length&&(g.machines=p,await this.writeMachinesData(g))}async renameMachine(v,w,g){const p=await this.currentMachineIdPromise,l=await this.readMachinesData(g),r=l.machines.find(({id:a})=>a===v);r&&(r.name=w,await this.writeMachinesData(l),l.machines.some(({id:a})=>a===p)&&this.storageService.store(h,w,0,1))}async setEnablement(v,w){const g=await this.readMachinesData(),p=g.machines.find(({id:l})=>l===v);p&&(p.disabled=w?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(v){const w=this.storageService.get(h,0);if(w)return w;const g=`${this.productService.nameLong} (${(0,L.PlatformToString)(L.isWeb?0:L.platform)})`,p=new RegExp(`${(0,A.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let l=0;for(const r of v){const a=p.exec(r.name),i=a?parseInt(a[1]):0;l=i>l?i:l}return`${g} #${l+1}`}async readMachinesData(v){this.userData=await this.readUserData(v);const w=this.parse(this.userData);if(w.version!==Ze.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(v){const w=JSON.stringify(v),g=await this.userDataSyncStoreService.write(Ze.RESOURCE,w,this.userData?.ref||null);this.userData={ref:g,content:w},this._onDidChange.fire()}async readUserData(v){if(this.userData){const w=v&&v.latest?v.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(v){if(v.content!==null)try{return JSON.parse(v.content)}catch(w){this.logService.error(w)}return{version:Ze.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=de([Y(0,R.IEnvironmentService),Y(1,C.IFileService),Y(2,d.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncLogService),Y(5,P.IProductService)],S),e.UserDataSyncMachinesService=S}),define(ie[236],re([0,1,5,56,37,9,3,2,4,19,7,146,26,23,21,24,64,65]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",g="sync.sessionId",p="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(t,s,o,c,u,m,I,_,O,N){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=c,this.userDataSyncService=u,this.logService=m,this.userDataSyncAccountService=I,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(T.Event.debounce(u.onDidChangeLocal,(z,k)=>z?[...z,k]:[k],1e3)(z=>this.triggerSync(z,!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(p,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(p,t.toString(),0,1):this.storageService.remove(p,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(s)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=S.UserDataSyncError.toUserDataSyncError(t);s instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?C.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([Y(0,d.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncEnablementService),Y(4,S.IUserDataSyncService),Y(5,S.IUserDataSyncLogService),Y(6,f.IUserDataSyncAccountService),Y(7,h.ITelemetryService),Y(8,v.IUserDataSyncMachinesService),Y(9,y.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,s,o,c,u,m,I,_){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncService=u,this.userDataSyncMachinesService=m,this.logService=I,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,D.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,A.isCancellationError)(u))return}return this.doSync(t,s,c)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,E.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const u=this.storageService.get(g,0);if(u&&this.manifest&&u!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const m=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const I=m.find(_=>_.isCurrent);if(I?.disabled)throw new S.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new S.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof S.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==u&&this.storageService.store(g,this.manifest.session,0,1),o.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(u){this.logService.error(u),c=u}this._onDidFinishSync.fire(c)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(ie[237],re([0,1,16,5,37,3,2,19,15,29,20,30,6,23,21,225,227,228,230,231,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let r=class extends T.Disposable{constructor(o,c,u,m,I,_,O,N){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=c,this.instantiationService=u,this.configurationService=m,this.logService=I,this.telemetryService=_,this.storageService=O,this.userDataSyncEnablementService=N,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new T.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,c){this.checkEnablement();const u=(0,E.generateUuid)();try{const N=(0,p.createSyncHeaders)(u);c&&(N["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,N)}catch(N){const z=p.UserDataSyncError.toUserDataSyncError(N);throw this.reportUserDataSyncError(z,u),z}let m=!1;const I=this,_=this.getEnabledSynchronizers();let O;return{manifest:o,async run(){if(m)throw new Error("Can run a task only once");return O=(0,n.createCancelablePromise)(N=>I.sync(_,o,u,N)),O.finally(()=>O=void 0)},async stop(){if(O&&O.cancel(),I.status!=="idle")return I.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new p.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,E.generateUuid)(),c=(0,p.createSyncHeaders)(o);let u;try{u=await this.userDataSyncStoreService.manifest(null,c)}catch(I){const _=p.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(_,o),_}await this.resetLocal();const m=this.getEnabledSynchronizers();return new a(o,u,c,m,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(o,c,u,m){if(m.isCancellationRequested||!o.length)return;const I=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,p.createSyncHeaders)(u);for(const O of o){if(m.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(c,_)}catch(N){let z=!1;if(N instanceof p.UserDataSyncError)switch(N.code){case"TooLarge":N=new p.UserDataSyncError(N.message,N.code,O.resource),z=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":z=!0;break}const k=p.UserDataSyncError.toUserDataSyncError(N);if(this.reportUserDataSyncError(k,u),z)throw k;this.logService.error(N),this.logService.error(`${O.resource}: ${(0,L.toErrorMessage)(N)}`),this._syncErrors.push([O.resource,k])}}this.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),this.updateLastSyncTime()}catch(_){const O=p.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(O,u),O}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const c of o)try{c.status!=="idle"&&await c.stop()}catch(u){this.logService.error(u)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(o))return!0})}async accept(o,c,u,m){this.checkEnablement(),await this.performSynchronizerAction(async I=>{if(I.resource===o)return await I.accept(c,u),m&&await I.apply(!1,(0,p.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async c=>{const u=await c.resolveContent(o);if(u)return u})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async u=>{if(u.resource===o)return u.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async u=>{if(u.resource===o)return u.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,c){return await this.performSynchronizerAction(async m=>{if(m.resource===o)return m.getAssociatedResources(c)})||[]}async getMachineId(o,c){return await this.performSynchronizerAction(async m=>{if(m.resource===o)return await m.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(c){this.logService.error(`${o.resource}: ${(0,L.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const c=new T.DisposableStore;try{const u=this.synchronizers.value||c.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),m=[...u.enabled,...u.disabled.map(I=>c.add(u.createSynchronizer(I)))];for(const I of m){const _=await o(I);if(!(0,C.isUndefined)(_))return _}return null}finally{c.dispose()}}setStatus(o){const c=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const c=this.computeStatus(o);this.setStatus(c)}updateConflicts(o){const c=this.computeConflicts(o);(0,D.equals)(this._conflicts,c,([u,m],[I,_])=>u===u&&(0,D.equals)(m,_,(O,N)=>(0,R.isEqual)(O.previewResource,N.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(c))}computeConflicts(o){return o.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(t)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(c=>c.status==="hasConflicts")?"hasConflicts":o.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,c){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof p.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof p.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([Y(0,p.IUserDataSyncStoreService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,d.IInstantiationService),Y(3,P.IConfigurationService),Y(4,p.IUserDataSyncLogService),Y(5,h.ITelemetryService),Y(6,y.IStorageService),Y(7,p.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends T.Disposable{constructor(o,c,u,m,I,_,O){super();this.id=o,this.manifest=c,this.syncHeaders=u,this.synchronisers=m,this.onStop=I,this.configurationService=_,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,c){try{return await this.performAction(o,u=>u.accept(o,c))}catch(u){throw this.logService.error(u),u}}async merge(o){try{return o?await this.performAction(o,c=>c.merge(o)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(o){try{return await this.performAction(o,c=>c.discard(o))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,c]of this.previews)for(const u of c.resourcePreviews)u.mergeState==="conflict"&&o.push(u.previewResource);for(const c of o)await this.discard(c);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[c,u]of this.previews){this.synchronizingResources.push([c,u.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(_=>_.resource===c);for(const _ of u.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await m.merge(_.previewResource);const I=await m.apply(!1,this.syncHeaders);I&&o.push(this.toSyncResourcePreview(m.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===o);for(const m of c.resourcePreviews)await u.accept(m.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===o);for(const m of c.resourcePreviews)await u.accept(m.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,M])=>M.resourcePreviews.some(({localResource:j,previewResource:U,remoteResource:G})=>(0,R.isEqual)(o,j)||(0,R.isEqual)(o,U)||(0,R.isEqual)(o,G)));if(u===-1)return this.previews;const[m,I]=this.previews[u],_=I.resourcePreviews.find(({localResource:M,remoteResource:j,previewResource:U})=>(0,R.isEqual)(M,o)||(0,R.isEqual)(j,o)||(0,R.isEqual)(U,o));if(!_)return this.previews;let O=this.synchronizingResources.find(M=>M[0]===m);O||(O=[m,[]],this.synchronizingResources.push(O)),O[1].some(M=>(0,R.isEqual)(M,_.localResource))||(O[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const N=this.synchronisers.find(M=>M.resource===this.previews[u][0]),z=await c(N);z?this.previews.splice(u,1,this.toSyncResourcePreview(N.resource,z)):this.previews.splice(u,1);const k=this.synchronizingResources.findIndex(M=>M[0]===m);return this.synchronizingResources[k][1].splice(O[1].findIndex(M=>(0,R.isEqual)(M,_.localResource)),1),O[1].length||(this.synchronizingResources.splice(k,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[c,u]of this.previews){this.synchronizingResources.push([c,u.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(_=>_.resource===c);let I=u;for(const _ of u.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(I=await m.merge(_.previewResource));I&&o.push(this.toSyncResourcePreview(m.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const c=[],u=await this.getUserDataSyncConfiguration();for(const m of this.synchronisers){if(o.isCancellationRequested)return[];const I=await m.preview(this.manifest,u,this.syncHeaders);I&&c.push(this.toSyncResourcePreview(m.resource,I))}return c}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=await this.synchronisers.find(u=>u instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...c}}toSyncResourcePreview(o,c){return[o,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends T.Disposable{constructor(o,c,u,m,I,_,O){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=c,this.onDidChangeLocal=u,this.userDataSyncEnablementService=m,this.instantiationService=I,this.extensionGalleryService=_,this.logService=O,this._enabled=[],this._register(m.onDidChangeResourceEnablement(([N,z])=>this.onDidChangeResourceEnablement(N,z))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,N])=>N.dispose())));for(const N of p.ALL_SYNC_RESOURCES)m.isResourceEnabled(N)&&this.registerSynchronizer(N)}get enabled(){return this._enabled.sort((o,c)=>o[1]-c[1]).map(([o])=>o)}get disabled(){return p.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,c){c?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([I])=>I.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new T.DisposableStore,u=c.add(this.createSynchronizer(o));c.add(u.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(u.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(u.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const m=this.getOrder(o);this._enabled.push([u,m,c])}deRegisterSynchronizer(o){const c=this._enabled.findIndex(([u])=>u.resource===o);if(c!==-1){const u=this._enabled.splice(c,1);for(const[m,,I]of u){if(m.status!=="idle"){const _=m.conflicts.length>0;m.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}I.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(v.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(f.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};i=de([Y(3,p.IUserDataSyncEnablementService),Y(4,d.IInstantiationService),Y(5,b.IExtensionGalleryService),Y(6,p.IUserDataSyncLogService)],i);function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(ie[238],re([0,1,3,2,15,7,24]),function(J,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(b,d){this.service=b,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(b,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(b,d,y){try{return await this._call(b,d,y)}catch(h){throw this.logService.error(h),h}}async _call(b,d,y){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(y[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(y[0],A.URI.revive(y[1]),y[2],y[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(y[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0]);case"getAssociatedResources":return this.service.getAssociatedResources(y[0],{created:y[1].created,uri:A.URI.revive(y[1].uri)});case"getMachineId":return this.service.getMachineId(y[0],{created:y[1].created,uri:A.URI.revive(y[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),S=y[0],f=this.getManualSyncTask(S);switch(y=y.slice(1),h){case"preview":return f.preview();case"accept":return f.accept(A.URI.revive(y[0]),y[1]);case"merge":return f.merge(A.URI.revive(y[0]));case"discard":return f.discard(A.URI.revive(y[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(b){const d=this.manualSyncTasks.get(this.createKey(b));if(!d)throw new Error(`Manual sync taks not found: ${b}`);return d.manualSyncTask}async createManualSyncTask(){const b=new n.DisposableStore,d=b.add(await this.service.createManualSyncTask());return b.add(d.onSynchronizeResources(y=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:y}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:b}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(b){b.dispose();const d=this.createKey(b.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(b){return`manualSyncTask-${b}`}}e.UserDataSyncChannel=R;class C extends n.Disposable{constructor(b){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,y,h){return b.call(d,y,h).then(null,S=>{throw T.UserDataSyncError.toUserDataSyncError(S)})},listen(d,y){return b.listen(d,y)}},this.channel.call("_getInitialData").then(([d,y,h])=>{this.updateStatus(d),this.updateConflicts(y),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([y,h])=>[y,T.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:b,manifest:d,status:y}=await this.channel.call("createManualSyncTask"),h=this,S=new E(b,d,y,{async call(f,v,w){return h.channel.call(`manualSync/${f}`,[b,...(0,L.isArray)(v)?v:[v]],w)},listen(f,v){return D.Event.map(D.Event.filter(h.channel.listen(`manualSync/${f}`,v),w=>!S.isDiposed()&&w.manualSyncTaskId===b),w=>w.data)}});return S}replace(b){return this.channel.call("replace",[b])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(b,d,y,h){return this.channel.call("accept",[b,d,y,h])}resolveContent(b){return this.channel.call("resolveContent",[b])}async getLocalSyncResourceHandles(b){return(await this.channel.call("getLocalSyncResourceHandles",[b])).map(({created:y,uri:h})=>({created:y,uri:A.URI.revive(h)}))}async getRemoteSyncResourceHandles(b){return(await this.channel.call("getRemoteSyncResourceHandles",[b])).map(({created:y,uri:h})=>({created:y,uri:A.URI.revive(h)}))}async getAssociatedResources(b,d){return(await this.channel.call("getAssociatedResources",[b,d])).map(({resource:h,comparableResource:S})=>({resource:A.URI.revive(h),comparableResource:A.URI.revive(S)}))}async getMachineId(b,d){return this.channel.call("getMachineId",[b,d])}async updateStatus(b){this._status=b,this._onDidChangeStatus.fire(b)}async updateConflicts(b){this._conflicts=b.map(([d,y])=>[d,y.map(h=>({...h,localResource:A.URI.revive(h.localResource),remoteResource:A.URI.revive(h.remoteResource),previewResource:A.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(b){this._lastSyncTime!==b&&(this._lastSyncTime=b,this._onDidChangeLastSyncTime.fire(b))}}e.UserDataSyncChannelClient=C;class E extends n.Disposable{constructor(b,d,y,h){super();this.id=b,this.manifest=d,this._disposed=!1,this._status=y;const S=this;this.channel={async call(f,v,w){try{const g=await h.call(f,v,w);return S.isDiposed()||(S._status=await h.call("_getStatus")),g}catch(g){throw T.UserDataSyncError.toUserDataSyncError(g)}},listen(f,v){return h.listen(f,v)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const b=await this.channel.call("preview");return this.deserializePreviews(b)}async accept(b,d){const y=await this.channel.call("accept",[b,d]);return this.deserializePreviews(y)}async merge(b){const d=await this.channel.call("merge",[b]);return this.deserializePreviews(d)}async discard(b){const d=await this.channel.call("discard",[b]);return this.deserializePreviews(d)}async discardConflicts(){const b=await this.channel.call("discardConflicts");return this.deserializePreviews(b)}async apply(){const b=await this.channel.call("apply");return this.deserializePreviews(b)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(b){return b.map(([d,y])=>[d,{isLastSyncFromCurrentMachine:y.isLastSyncFromCurrentMachine,resourcePreviews:y.resourcePreviews.map(h=>({...h,localResource:A.URI.revive(h.localResource),remoteResource:A.URI.revive(h.remoteResource),previewResource:A.URI.revive(h.previewResource),acceptedResource:A.URI.revive(h.acceptedResource)}))}])}}}),define(ie[239],re([0,1,5,25,9,3,2,102,4,19,15,7,29,20,13,14,26,43,46,23,24]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends T.Disposable{constructor(O,N,z){super();this.productService=O,this.configurationService=N,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter(z.onDidChangeValue,k=>k.key===p.SYNC_SERVICE_URL_TYPE&&k.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(p.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(p.SYNC_SERVICE_URL_TYPE,O,0,C.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[p.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(p.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=C.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},...N||{}};if(z&&(0,P.isString)(z.url)&&(0,P.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(k=>(0,P.isArray)(z.authenticationProviders[k].scopes))){const k=z,M=!!k.canSwitch&&!N?.url,j=k.url===k.insidersUrl?"insiders":"stable",U=(M?this.userDataSyncStoreType:void 0)||j,G=N?.url||(U==="insiders"?k.insidersUrl:U==="stable"?k.stableUrl:k.url);return{url:b.URI.parse(G),type:U,defaultType:j,defaultUrl:b.URI.parse(k.url),stableUrl:b.URI.parse(k.stableUrl),insidersUrl:b.URI.parse(k.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(k.authenticationProviders).reduce((K,x)=>(K.push({id:x,scopes:k.authenticationProviders[x].scopes}),K),[])}}}};o=de([Y(0,f.IProductService),Y(1,y.IConfigurationService),Y(2,g.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let c=class extends o{constructor(O,N,z){super(O,N,z);const k=this.storageService.get(l,0);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const M=this.productService[p.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(l,JSON.stringify(M),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=de([Y(0,f.IProductService),Y(1,y.IConfigurationService),Y(2,g.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let u=class extends T.Disposable{constructor(O,N,z,k,M,j,U){super();this.requestService=z,this.logService=k,this.storageService=U,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(M,j,U).then(G=>{const K={"X-Client-Name":`${N.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(K["X-Client-Commit"]=N.commit),K}),this.session=new I(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},k=await this.request(N.toString(),{type:"GET",headers:z},[],n.CancellationToken.None);return(await(0,v.asJson)(k)||[]).map(({url:j,created:U})=>({ref:(0,E.relativePath)(N,N.with({path:j})),created:U*1e3}))}async resolveContent(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,N).toString(),k={};k["Cache-Control"]="no-cache";const M=await this.request(z,{type:"GET",headers:k},[],n.CancellationToken.None);return await(0,v.asText)(M)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request(N,{type:"DELETE",headers:z},[],n.CancellationToken.None)}async read(O,N,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",N&&(z["If-None-Match"]=N.ref);const M=await this.request(k,{type:"GET",headers:z},[304],n.CancellationToken.None);let j=null;if(M.res.statusCode===304&&(j=N),j===null){const U=M.res.headers.etag;if(!U)throw new p.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",M.res.statusCode,M.res.headers[p.HEADER_OPERATION_ID]);const G=await(0,v.asText)(M);if(!G&&M.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",k,"EmptyResponse",M.res.statusCode,M.res.headers[p.HEADER_OPERATION_ID]);j={ref:U,content:G}}return j}async write(O,N,z,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();k={...k},k["Content-Type"]=R.Mimes.text,z&&(k["If-Match"]=z);const j=await this.request(M,{type:"POST",data:N,headers:k},[],n.CancellationToken.None),U=j.res.headers.etag;if(!U)throw new p.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",j.res.statusCode,j.res.headers[p.HEADER_OPERATION_ID]);return U}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const k=await this.request(z,{type:"GET",headers:N},[304],n.CancellationToken.None);let M=null;if(k.res.statusCode===304&&(M=O),!M){const U=k.res.headers.etag;if(!U)throw new p.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",k.res.statusCode,k.res.headers[p.HEADER_OPERATION_ID]);const G=await(0,v.asText)(k);if(!G&&k.res.statusCode===304)throw new p.UserDataSyncStoreError("Empty response",z,"EmptyResponse",k.res.statusCode,k.res.headers[p.HEADER_OPERATION_ID]);G&&(M={...JSON.parse(G),ref:U})}const j=this.storageService.get(a,0);return j&&M&&j!==M.session&&this.clearSession(),M===null&&j&&this.clearSession(),M&&this.storageService.store(a,M.session,0,1),M}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(i,0)}async request(O,N,z,k){if(!this.authToken)throw new p.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new p.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;N.headers={...N.headers||{},...M,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let j;try{j=await this.session.request(O,N,k)}catch(x){if(!(x instanceof p.UserDataSyncStoreError)){let W="RequestFailed";const X=(0,L.getErrorMessage)(x).toLowerCase();X.includes("xhr timeout")?W="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?W="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?W="RequestPathNotEscaped":X.includes("headers must be an object")?W="RequestHeadersNotObject":(0,L.isCancellationError)(x)&&(W="RequestCanceled"),x=new p.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,W,void 0,void 0)}throw this.logService.info("Request failed",O),x}const U=j.res.headers[p.HEADER_OPERATION_ID],G={url:O,status:j.res.statusCode,"execution-id":N.headers[p.HEADER_EXECUTION_ID],"operation-id":U},K=(0,v.isSuccess)(j)||j.res.statusCode&&z.indexOf(j.res.statusCode)!==-1;if(K?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new p.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",j.res.statusCode,U);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new p.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",j.res.statusCode,U);if(j.res.statusCode===410)throw new p.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",j.res.statusCode,U);if(j.res.statusCode===412)throw new p.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",j.res.statusCode,U);if(j.res.statusCode===413)throw new p.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",j.res.statusCode,U);if(j.res.statusCode===426)throw new p.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",j.res.statusCode,U);if(j.res.statusCode===429){const x=j.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new p.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",j.res.statusCode,U)):new p.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",j.res.statusCode,U)}if(!K)throw new p.UserDataSyncStoreError("Server returned "+j.res.statusCode,O,"Unknown",j.res.statusCode,U);return j}addSessionHeaders(O){let N=this.storageService.get(i,0);N===void 0&&(N=(0,d.generateUuid)(),this.storageService.store(i,N,0,1)),O["X-Machine-Session-Id"]=N;const z=this.storageService.get(a,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};u=de([Y(1,f.IProductService),Y(2,v.IRequestService),Y(3,p.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,S.IFileService),Y(6,g.IStorageService)],u),e.UserDataSyncStoreClient=u;let m=class extends u{constructor(O,N,z,k,M,j,U){super(O.userDataSyncStore?.url,N,z,k,M,j,U);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};m=de([Y(0,p.IUserDataSyncStoreManagementService),Y(1,f.IProductService),Y(2,v.IRequestService),Y(3,p.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,S.IFileService),Y(6,g.IStorageService)],m),e.UserDataSyncStoreService=m;class I{constructor(O,N,z,k){this.limit=O,this.interval=N,this.requestService=z,this.logService=k,this.requests=[],this.startTime=void 0}request(O,N,z){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new p.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(ie[240],re([0,1,3,60,26,23,21,236,24,64,65]),function(J,e,D,n,L,A,T,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends R.UserDataAutoSyncService{constructor(y,h,S,f,v,w,g,p,l,r,a){super(y,h,S,f,v,g,p,l,r,a);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};b=de([Y(0,L.IProductService),Y(1,C.IUserDataSyncStoreManagementService),Y(2,C.IUserDataSyncStoreService),Y(3,C.IUserDataSyncEnablementService),Y(4,C.IUserDataSyncService),Y(5,n.INativeHostService),Y(6,C.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,P.IUserDataSyncMachinesService),Y(10,A.IStorageService)],b),e.UserDataAutoSyncService=b}),define(ie[241],re([0,1,5,3,2]),function(J,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:C,getActiveWindowId:E}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(R,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(ie[66],re([0,1,50,5,10,15,22,124,253,254]),function(J,e,D,n,L,A,T,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,a){let i=a.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=a}}e.ExtractError=P;function b(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,i)=>a+i,r&61440)}function d(l){if(l instanceof P)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new P(r,l)}function y(l,r,a,i,t,s){const o=L.dirname(r),c=L.join(i,o);if(!c.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const u=L.join(i,r);let m;return s.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(T.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((I,_)=>{if(!s.isCancellationRequested)try{m=(0,D.createWriteStream)(u,{mode:a}),m.once("close",()=>I()),m.once("error",_),l.once("error",_),l.pipe(m)}catch(O){_(O)}}))}function h(l,r,a,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((o,c)=>{const u=new n.Sequencer,m=I=>{I.isCancellationRequested||(s++,l.readEntry())};l.once("error",c),l.once("close",()=>t.then(()=>{i.isCancellationRequested||l.entryCount===s?o():c(new P("Incomplete",new Error(R.localize(1,null,s,l.entryCount))))},c)),l.readEntry(),l.on("entry",I=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){m(i);return}const _=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(_)){const z=L.join(r,_);t=(0,n.createCancelablePromise)(k=>T.Promises.mkdir(z,{recursive:!0}).then(()=>m(k)).then(void 0,c));return}const O=f(l,I),N=b(I);t=(0,n.createCancelablePromise)(z=>u.queue(()=>O.then(k=>y(k,_,N,r,a,z).then(()=>m(z)))).then(null,c))})})}function S(l,r=!1){return new Promise((a,i)=>{(0,C.open)(l,r?{lazyEntries:!0}:void 0,(t,s)=>{t?i(d(t)):a((0,A.assertIsDefined)(s))})})}function f(l,r){return new Promise((a,i)=>{l.openReadStream(r,(t,s)=>{t?i(d(t)):a((0,A.assertIsDefined)(s))})})}function v(l,r){return new Promise((a,i)=>{const t=new E.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,D.createWriteStream)(l);t.outputStream.pipe(s),t.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>a(l))})}e.zip=v;function w(l,r,a={},i){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=S(l,!0);return a.overwrite&&(s=s.then(o=>T.Promises.rm(r).then(()=>o))),s.then(o=>h(o,r,{sourcePathRegex:t},i))}e.extract=w;function g(l,r){return S(l).then(a=>new Promise((i,t)=>{a.on("entry",s=>{s.fileName===r&&f(a,s).then(o=>i(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function p(l,r){return g(l,r).then(a=>new Promise((i,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=p}),define(ie[242],re([0,1,66,133]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(A){return(0,D.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=L}),define(ie[243],re([0,1,16,5,9,2,18,10,4,19,61,7,29,22,66,134,13,30,31,155,14,8,26]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends A.Disposable{constructor(t,s,o,c,u){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=c,this.productService=u,this._devSystemExtensionsPath=null,this.systemExtensionsPath=c.builtinExtensionsPath,this.extensionsPath=c.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(o).message,v.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(o).message,v.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,D.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(c=>!s[new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).key()]),t&&(o=(0,w.groupByExtension)(o,u=>u.identifier).map(u=>u.sort((m,I)=>P.rcompare(m.manifest.version,I.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,c){const u=t.key(),m=R.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),I=R.join(this.extensionsPath,u);try{await y.Promises.rm(I)}catch{try{await y.Promises.rm(I)}catch{}throw new v.ExtensionManagementError((0,S.localize)(0,null,I,t.id),v.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,m,c);let _=await this.scanExtension(b.URI.file(m),1);if(!_)throw new Error((0,S.localize)(1,null,m));await this.storeMetadata(_,{...o,installedTimestamp:Date.now()});try{await this.rename(t,m,I,Date.now()+2*60*1e3),this.logService.info("Renamed to",I)}catch(O){try{await y.Promises.rm(m)}catch{}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(O)}. Deleted from extracted location`,m),O}try{_=await this.scanExtension(b.URI.file(I),1)}catch{}if(_)return _;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),c=await y.Promises.readFile(o,"utf8"),{manifest:u}=await this.parseManifest(c);return u.__metadata=s,await y.Promises.writeFile(o,JSON.stringify(u,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(c=>o[c.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(c=>delete c[t.key()]);const o=(await this.scanExtensions(1)).find(c=>new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(c){if(c.code!=="ENOENT")throw c}let o={};if(s)try{o=JSON.parse(s)}catch{}return t&&(t(o),Object.keys(o).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await y.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await y.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,c){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await y.Promises.rm(o)}catch(u){throw new v.ExtensionManagementError(this.joinErrors(u).message,v.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,o,{sourcePath:"extension",overwrite:!0},c),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(u){try{await y.Promises.rm(o)}catch{}let m=v.ExtensionManagementErrorCode.Extract;throw u instanceof h.ExtractError&&(u.type==="CorruptZip"?m=v.ExtensionManagementErrorCode.CorruptZip:u.type==="Incomplete"&&(m=v.ExtensionManagementErrorCode.IncompleteZip)),new v.ExtensionManagementError(u.message,m)}}async rename(t,s,o,c){try{await y.Promises.rename(s,o)}catch(u){if(C.isWindows&&u&&u.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,c);throw new v.ExtensionManagementError(u.message||(0,S.localize)(3,null,s,o),u.code||v.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,c]=await Promise.all([t,s]);return[...o,...c]}async scanExtensionsInDir(t,s){const o=new n.Limiter(10),c=await this.fileService.resolve(b.URI.file(t));return c.children?(await Promise.all(c.children.filter(m=>m.isDirectory).map(m=>o.queue(async()=>s===1&&(0,E.basename)(m.resource).indexOf(".")===0?null:this.scanExtension(m.resource,s))))).filter(m=>m&&m.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:c,metadata:u}=await this.readManifest(t.fsPath),m=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,I=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,_={id:(0,w.getGalleryExtensionId)(c.publisher,c.name)},O={type:s,identifier:_,manifest:c,location:t,readmeUrl:m,changelogUrl:I,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(O,u),O}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(c=>(0,w.areSameExtensions)(o.identifier,{id:c})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const m of s)t[new w.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]||o.add(m.identifier.id.toLowerCase());const c=(0,w.groupByExtension)(s,m=>m.identifier);await n.Promises.settled(c.map(async m=>{const I=m.sort((_,O)=>P.rcompare(_.manifest.version,O.manifest.version))[0];o.has(I.identifier.id.toLowerCase())||await this.beforeRemovingExtension(I)}));const u=s.filter(m=>t[new w.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]);await n.Promises.settled(u.map(m=>this.removeUninstalledExtension(m)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,w.groupByExtension)(t,c=>c.identifier);s.push(...(0,D.flatten)(o.map(c=>c.sort((u,m)=>P.rcompare(u.manifest.version,m.manifest.version)).slice(1)))),await n.Promises.settled(s.map(c=>this.removeExtension(c,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(T.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[y.Promises.readFile(R.join(t,"package.json"),"utf8").then(m=>this.parseManifest(m)),y.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,m=>m.code!=="ENOENT"?Promise.reject(m):"{}").then(m=>JSON.parse(m))],[{manifest:o,metadata:c},u]=await Promise.all(s);return{manifest:(0,g.localizeManifest)(o,u),metadata:c}}parseManifest(t){return new Promise((s,o)=>{try{const c=JSON.parse(t),u=c.__metadata||null;s({manifest:c,metadata:u})}catch{o(new Error((0,S.localize)(4,null)))}})}};a=de([Y(1,p.IFileService),Y(2,l.ILogService),Y(3,f.INativeEnvironmentService),Y(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(ie[244],re([0,1,37,9,18,10,4,32,19,61,7,29,22,66,132,81,13,205,30,31,187,173,242,188,243,219,78,14,6,8,26,21,34]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l,r,a,i,t,s,o,c,u,m,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends v.AbstractExtensionManagementService{constructor(U,G,K,x,W,X,H,Z,ee){super(U,G,K,Z);this.environmentService=x,this.downloadService=W,this.fileService=H;const q=this._register(X.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(i.ExtensionsScanner,V=>q.postUninstall(V))),this.manifestCache=this._register(new a.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(X.createInstance(p.ExtensionsDownloader));const F=this._register(new t.ExtensionsWatcher(this,H,x,K,ee));this._register(F.onDidChangeExtensionsByAnotherSource(({added:V,removed:$})=>{V.length&&this._onDidInstallExtensions.fire(V.map(B=>({identifier:B.identifier,operation:1,local:B}))),$.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const U=await this.isAlpineLinux(),G=(0,w.getTargetPlatform)(U?"alpine":T.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let U;try{U=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{U=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(K){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(K))}}return!!U&&(U.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const G=await this.collectFiles(U),K=await(0,y.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)()).fsPath,G);return P.URI.file(K)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const G=await this.downloadVsix(U),K=A.resolve(G.fsPath);return(0,r.getManifest)(K)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async install(U,G={}){this.logService.trace("ExtensionManagementService#install",U.toString());const K=await this.downloadVsix(U),x=await(0,r.getManifest)(A.resolve(K.fsPath));if(x.engines&&x.engines.vscode&&!(0,s.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,K,G)}async updateMetadata(U,G){this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const K={...U.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(K.preRelease=!0),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,K),this.manifestCache.invalidate(),U}async updateExtensionScope(U,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===L.Schemas.file)return U;const G=(0,C.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)());return await this.downloadService.download(U,G),G}createInstallExtensionTask(U,G,K){return P.URI.isUri(G)?new k(U,G,K,this.galleryService,this.extensionsScanner,this.logService):new z(G,K,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,G){return new M(U,G,this.extensionsScanner)}async collectFiles(U){const G=async x=>{let W=await d.Promises.readdir(x);W=W.map(Z=>A.join(x,Z));const X=await Promise.all(W.map(Z=>d.Promises.stat(Z)));let H=Promise.resolve([]);return X.forEach((Z,ee)=>{const q=W[ee];Z.isFile()&&(H=H.then(F=>[...F,q])),Z.isDirectory()&&(H=H.then(F=>G(q).then(V=>[...F,...V])))}),H};return(await G(U.location.fsPath)).map(x=>({path:`extension/${A.relative(U.location.fsPath,x)}`,localPath:x}))}};O=de([Y(0,w.IExtensionGalleryService),Y(1,I.ITelemetryService),Y(2,u.ILogService),Y(3,f.INativeEnvironmentService),Y(4,S.IDownloadService),Y(5,c.IInstantiationService),Y(6,o.IFileService),Y(7,m.IProductService),Y(8,_.IUriIdentityService)],O),e.ExtensionManagementService=O;class N extends v.AbstractExtensionTask{constructor(U,G,K,x){super();this.identifier=U,this.source=G,this.extensionsScanner=K,this.logService=x,this._operation=2}get operation(){return this._operation}async installExtension(U,G){try{const K=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(K)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(K,{...K.manifest.__metadata||{},...U.metadata}):K}catch{throw T.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(U,G)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const K=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),K}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:G,metadata:K},x){let W=await this.extensionsScanner.extractUserExtension(G,U,K,x);return this.logService.info("Extracting completed.",G.id),W}}class z extends N{constructor(U,G,K,x,W){super(U.identifier,U,x,W);this.gallery=U,this.options=G,this.extensionsDownloader=K}async doRun(U){const K=(await this.extensionsScanner.scanExtensions(null)).find(W=>(0,g.areSameExtensions)(W.identifier,this.gallery.identifier));K&&(this._operation=3);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||K?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||K?.isBuiltin,x.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,x.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:K?.preRelease;try{const W=await this.installExtension(x,U);return K&&E.neq(K.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(K),W}catch(W){throw await this.deleteDownloadedVSIX(x.zipPath),W}}async deleteDownloadedVSIX(U){try{await this.extensionsDownloader.delete(P.URI.file(U))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",U.toString(),(0,n.getErrorMessage)(G))}}async downloadInstallableExtension(U,G){const K={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let x;try{this.logService.trace("Started downloading extension:",U.identifier.id),x=(await this.extensionsDownloader.downloadExtension(U,G)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,x)}catch(W){throw new w.ExtensionManagementError((0,v.joinErrors)(W).message,w.ExtensionManagementErrorCode.Download)}try{const W=await(0,r.getManifest)(x);return{zipPath:x,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,W.version),metadata:K}}catch(W){throw await this.deleteDownloadedVSIX(x),new w.ExtensionManagementError((0,v.joinErrors)(W).message,w.ExtensionManagementErrorCode.Invalid)}}}class k extends N{constructor(U,G,K,x,W,X){super({id:(0,g.getGalleryExtensionId)(U.publisher,U.name)},G,W,X);this.manifest=U,this.location=G,this.options=K,this.galleryService=x}async doRun(U){const G=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(X=>(0,g.areSameExtensions)(this.identifier,X.identifier)),W=await this.getMetadata(this.identifier.id,this.manifest.version,U);if(W.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,W.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=3,G.equals(new g.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const X=await this.unsetUninstalledAndGetLocal(G);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:A.resolve(this.location.fsPath),identifierWithVersion:G,metadata:W},U)}async getMetadata(U,G,K){try{let[x]=await this.galleryService.getExtensions([{id:U,version:G}],K);if(x||([x]=await this.galleryService.getExtensions([{id:U}],K)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion}}catch{}return{}}}class M extends v.AbstractExtensionTask{constructor(U,G,K){super();this.extension=U,this.options=G,this.extensionsScanner=K}async doRun(U){const G=[],K=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...K.filter(W=>x.equals(new g.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version))))}else G.push(...K.filter(x=>(0,g.areSameExtensions)(x.identifier,this.extension.identifier)));if(!G.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const x of G)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(W){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(W)))}}}}),define(ie[245],re([0,1,83,55,33,17,9,3,2,10,4,29,36,73,255]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(I,_=""){this.debugLabel=_,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,T.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,_){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const _=O=>{this.traceSocketEvent("read",O),I(A.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(I){const _=O=>{this.traceSocketEvent("close",{hadError:O}),I({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(I){const _=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=S;var f;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var v;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(v||(v={}));class w extends C.Disposable{constructor(I,_,O,N){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new g(this,_,O,N,this._onData,(z,k)=>this._write(z,k))),this._register(this._flowManager.onError(z=>{console.error(z),(0,T.onUnexpectedError)(z),this._onClose.fire({type:0,hadError:!0,error:z})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(z=>this._acceptChunk(z))),this._register(this.socket.onClose(z=>this._onClose.fire(z)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,_){this.socket.traceSocketEvent(I,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let O=2;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const N=A.VSBuffer.alloc(O);if(_?N.writeUInt8(194,0):N.writeUInt8(130,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let z=1;N.writeUInt8(I.byteLength>>>8&255,++z),N.writeUInt8(I.byteLength>>>0&255,++z)}else{N.writeUInt8(127,1);let z=1;N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(I.byteLength>>>24&255,++z),N.writeUInt8(I.byteLength>>>16&255,++z),N.writeUInt8(I.byteLength>>>8&255,++z),N.writeUInt8(I.byteLength>>>0&255,++z)}this.socket.write(A.VSBuffer.concat([N,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),N=(O&128)>>>7,z=(O&64)>>>6,k=_.readUInt8(1),M=(k&128)>>>7,j=k&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(z)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),N=(O&128)>>>7;let z=O&127,k=1;z===126?z=_.readUInt8(++k)*2**8+_.readUInt8(++k):z===127&&(z=_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*2**24+_.readUInt8(++k)*2**16+_.readUInt8(++k)*2**8+_.readUInt8(++k));let M=0;N&&(M=_.readUInt8(++k)*2**24+_.readUInt8(++k)*2**16+_.readUInt8(++k)*2**8+_.readUInt8(++k)),this._state.state=3,this._state.readLen=z,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class g extends C.Disposable{constructor(I,_,O,N,z,k){super();this._tracer=I,this._onData=z,this._writeFn=k,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new p(this._tracer,N,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(_,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,_){return new Promise((O,N)=>{I.write(_),I.flush(z=>O(z))})}acceptFrame(I,_,O){this._readQueue.push({data:I,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,_,O){return new Promise((N,z)=>{I.write(_),O&&I.write(A.VSBuffer.fromByteArray([0,0,255,255])),I.flush(k=>N(k))})}}class p extends C.Disposable{constructor(I,_,O,N){super();this._tracer=I,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",z=>{this._tracer.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibInflate.on("data",z=>{this._tracer.traceSocketEvent("zlibInflateData",z),this._pendingInflateData.push(A.VSBuffer.wrap(z))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(_)})}}class l extends C.Disposable{constructor(I,_){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(A.VSBuffer.wrap(O))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),I(_)})}}function r(m,I){if(I===0)return;let _=m.byteLength>>>2;for(let j=0;j<_;j++){const U=m.readUInt32BE(j*4);m.writeUInt32BE(U^I,j*4)}let O=_*4,N=m.byteLength-O;const z=I>>>24&255,k=I>>>16&255,M=I>>>8&255;N>=1&&m.writeUInt8(m.readUInt8(O)^z,O),N>=2&&m.writeUInt8(m.readUInt8(O+1)^k,O+1),N>=3&&m.writeUInt8(m.readUInt8(O+2)^M,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const m=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):I=(0,E.join)((0,L.tmpdir)(),`vscode-ipc-${m}.sock`),s(I),I}e.createRandomIPCHandle=i;function t(m,I,_){const O=(0,D.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${I}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${I}.sock`):N=(0,E.join)(m,`${_}-${I}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(m){const I=a[P.platform];typeof I=="number"&&m.length>=I&&console.warn(`WARNING: IPC handle "${m}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const _=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(_,O=>({protocol:new y.Protocol(new S(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(m){return new Promise((I,_)=>{const O=(0,n.createServer)();O.on("error",_),O.listen(m,()=>{O.removeListener("error",_),I(new o(O))})})}e.serve=c;function u(m,I){return new Promise((_,O)=>{const N=(0,n.createConnection)(m,()=>{N.removeListener("error",O),_(y.Client.fromSocket(new S(N,`ipc-client${I}`),I))});N.once("error",O)})}e.connect=u}),define(ie[246],re([0,1,55,245]),function(J,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,A,T,R,C){const E=b=>C(b,void 0),P=D.createConnection({host:L,port:A},()=>{P.removeListener("error",E);const b=Buffer.alloc(16);for(let S=0;S<16;S++)b[S]=Math.round(Math.random()*256);const d=b.toString("base64"),y=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${A}/?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];P.write(y.join(`\r
`)+`\r
\r
`);const h=S=>{S.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",h),C(void 0,new n.NodeSocket(P,R)))};P.on("data",h)});P.setNoDelay(!0),P.once("error",E)}}}),define(ie[247],re([0,1,55,115,246,5,2,20,8,26,184,62,92]),function(J,e,D,n,L,A,T,R,C,E,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(w,g,p,l,r){let a;for(let i=3;i&&(a&&a.dispose(),a=await new h(w,g,p,l,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));i--);return a}class h extends T.Disposable{constructor(g,p,l,r,a){super();this.defaultTunnelHost=p,this.suggestedLocalPort=a,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=D.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(p=>{p()})}async waitForReady(){let g=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),p=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(g){g.pause();const p=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,p,this.tunnelRemotePort),r=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&g.write(a.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let S=class extends b.AbstractTunnelService{constructor(g,p,l,r,a){super(p);this.socketFactory=g,this.signService=l,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,p,l,r,a,i,t){const s=this.getTunnelFromMap(p,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,p,l,r,a,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${p}:${l} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},c=y(o,this.defaultTunnelHost,p,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(p,l,c),c}}};S=de([Y(1,C.ILogService),Y(2,d.ISignService),Y(3,E.IProductService),Y(4,R.IConfigurationService)],S),e.BaseTunnelService=S;let f=class extends S{constructor(g,p,l,r){super(L.nodeSocketFactory,g,p,l,r)}};f=de([Y(0,C.ILogService),Y(1,d.ISignService),Y(2,E.IProductService),Y(3,R.IConfigurationService)],f),e.TunnelService=f;let v=class extends T.Disposable{constructor(g,p,l,r){super();this.logService=g,this.productService=p,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,p,l,r,a,i,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${a}.`),!this._tunnelServices.has(g)){const o=new f(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(g,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(p,l,r,a,i,t,s)}};v=de([Y(0,C.ILogService),Y(1,E.IProductService),Y(2,d.ISignService),Y(3,R.IConfigurationService)],v),e.SharedTunnelsService=v}),define(ie[256],re([0,1,74,33,37,9,2,18,19,7,36,118,178,200,179,170,171,172,158,161,20,182,80,204,81,193,13,197,199,208,30,160,206,244,82,156,14,175,177,51,6,167,85,168,169,59,189,8,86,60,87,26,192,43,23,202,203,21,93,94,95,44,209,210,96,212,218,63,98,24,64,232,234,235,65,233,237,238,239,240,241,92,198,62,247,190,191,91,196,207,34,220,4,221,164,181,180]),function(J,e,D,n,L,A,T,R,C,E,P,b,d,y,h,S,f,v,w,g,p,l,r,a,i,t,s,o,c,u,m,I,_,O,N,z,k,M,j,U,G,K,x,W,X,H,Z,ee,q,F,V,$,B,te,se,ce,he,ge,me,ye,Se,Ie,Ee,De,Fe,Ue,Ne,$e,ne,ae,ue,be,Ce,ze,Te,Oe,_e,Q,oe,le,fe,ve,Le,we,Re,ke,Pe,Ae,qe,xe,Be,Pt,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends T.Disposable{constructor(pe){super();this.configuration=pe,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const pe=()=>this.dispose();process.once("exit",pe),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",pe);const Me="vscode:electron-main->shared-process=disposeWorker",je=(Ye,We)=>this.onDisposeWorker(We);D.ipcRenderer.on(Me,je),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Me,je)))}onDisposeWorker(pe){this.sharedProcessWorkerService?.disposeWorker(pe)}async open(){const pe=await this.initServices();(0,ae.registerConfiguration)(),pe.invokeFunction(Me=>{const je=Me.get(ee.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(pe.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),pe.createInstance(h.LanguagePackCachedDataCleaner),pe.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),pe.createInstance(f.LogsDataCleaner),pe.createInstance(S.LocalizationsUpdater),pe.createInstance(y.ExtensionsCleaner)))}async initServices(){const pe=new x.ServiceCollection,Me={_serviceBrand:void 0,...V.default};pe.set($.IProductService,Me);const je=new P.StaticRouter(Ge=>Ge==="main"),Ye=new W.MessagePortMainProcessService(this.server,je);pe.set(X.IMainProcessService,Ye);const We=new o.SharedProcessEnvironmentService(this.configuration.args,Me);pe.set(s.INativeEnvironmentService,We);const it=new q.LogLevelChannelClient(this.server.getChannel("logLevel",je)),Xe=new q.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Ye.getChannel("logger"));pe.set(ee.ILoggerService,Xe);const ot=this._register(new ee.MultiplexLogService([this._register(new ee.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,C.joinPath)(E.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new q.FollowerLogService(it,ot));pe.set(ee.ILogService,Je),this.sharedProcessWorkerService=new qe.SharedProcessWorkerService(Je,Me,We),pe.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new M.FileService(Je));pe.set(k.IFileService,Ve);const at=this._register(new j.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ye.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,ct);const He=this._register(new l.ConfigurationService(We.settingsResource,Ve));pe.set(p.IConfigurationService,He);const et=new ce.NativeStorageService(void 0,Ye,We);pe.set(se.IStorageService,et),this._register((0,T.toDisposable)(()=>et.flush())),await Promise.all([He.initialize(),et.initialize()]),pe.set(Be.IUriIdentityService,new Pt.UriIdentityService(Ve)),pe.set(te.IRequestService,new U.SyncDescriptor(B.RequestService)),pe.set(w.IChecksumService,new U.SyncDescriptor(g.ChecksumService)),pe.set(St.IV8InspectProfilingService,new U.SyncDescriptor(kt.InspectProfilingService));const rt=P.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});pe.set(F.INativeHostService,rt),pe.set(i.IDownloadService,new U.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(rt)),ut=new P.StaticRouter(Ge=>lt.getActiveClientId().then(dt=>Ge===dt));pe.set(N.IExtensionRecommendationNotificationService,new z.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new xe.AssignmentService(this.configuration.machineId,He,Me);let tt;const Qe=[];if((0,Ie.supportsTelemetry)(Me,We)){const Ge=new ye.TelemetryLogAppender(Xe,We);Qe.push(Ge);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=We;if(Me.aiConfig&&Me.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Me.quality!=="stable";if(ft&&st){const bt=new Ee.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,st,!0);this._register((0,T.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new Ee.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,T.toDisposable)(()=>Et.flush())),Qe.push(Et)}tt=new Se.TelemetryService({appenders:Qe,commonProperties:(0,he.resolveCommonProperties)(Ve,(0,n.release)(),(0,n.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},He)}else{tt=Ie.NullTelemetryService;const Ge=Ie.NullAppender;Qe.push(Ge)}this.server.registerChannel("telemetryAppender",new me.TelemetryAppenderChannel(Qe)),pe.set(ge.ITelemetryService,tt);const At=new De.CustomEndpointTelemetryService(He,tt,Xe,We);pe.set(ge.ICustomEndpointTelemetryService,At),pe.set(m.IExtensionManagementService,new U.SyncDescriptor(O.ExtensionManagementService)),pe.set(m.IExtensionGalleryService,new U.SyncDescriptor(u.ExtensionGalleryService)),pe.set(m.IExtensionTipsService,new U.SyncDescriptor(_.ExtensionTipsService)),pe.set(H.ILocalizationsService,new U.SyncDescriptor(Z.LocalizationsService)),pe.set(r.IDiagnosticsService,new U.SyncDescriptor(a.DiagnosticsService)),pe.set(ue.IUserDataSyncAccountService,new U.SyncDescriptor(ue.UserDataSyncAccountService)),pe.set(ae.IUserDataSyncLogService,new U.SyncDescriptor(ze.UserDataSyncLogService)),pe.set(ae.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),pe.set(m.IGlobalExtensionEnablementService,new U.SyncDescriptor(c.GlobalExtensionEnablementService)),pe.set(ne.IIgnoredExtensionsManagementService,new U.SyncDescriptor(ne.IgnoredExtensionsManagementService)),pe.set($e.IExtensionStorageService,new U.SyncDescriptor($e.ExtensionStorageService)),pe.set(ae.IUserDataSyncStoreManagementService,new U.SyncDescriptor(oe.UserDataSyncStoreManagementService)),pe.set(ae.IUserDataSyncStoreService,new U.SyncDescriptor(oe.UserDataSyncStoreService)),pe.set(Te.IUserDataSyncMachinesService,new U.SyncDescriptor(Te.UserDataSyncMachinesService)),pe.set(ae.IUserDataSyncBackupStoreService,new U.SyncDescriptor(be.UserDataSyncBackupStoreService)),pe.set(ae.IUserDataSyncEnablementService,new U.SyncDescriptor(Oe.UserDataSyncEnablementService)),pe.set(ae.IUserDataSyncService,new U.SyncDescriptor(_e.UserDataSyncService));const wt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,We,Je,tt);return await wt.initialize(),pe.set(Ue.ILocalPtyService,this._register(wt)),pe.set(ve.ISignService,new U.SyncDescriptor(Le.SignService)),pe.set(we.ISharedTunnelsService,new U.SyncDescriptor(Re.SharedTunnelsService)),pe.set(ke.ISharedProcessTunnelService,new U.SyncDescriptor(Pe.SharedProcessTunnelService)),new K.InstantiationService(pe)}initChannels(pe){const Me=new I.ExtensionManagementChannel(pe.get(m.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const je=P.ProxyChannel.fromService(pe.get(H.ILocalizationsService));this.server.registerChannel("localizations",je);const Ye=P.ProxyChannel.fromService(pe.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const We=new I.ExtensionTipsChannel(pe.get(m.IExtensionTipsService));this.server.registerChannel("extensionTipsService",We);const it=P.ProxyChannel.fromService(pe.get(w.IChecksumService));this.server.registerChannel("checksum",it);const Xe=P.ProxyChannel.fromService(pe.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Ce.UserDataSyncMachinesServiceChannel(pe.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Je=P.ProxyChannel.fromService(pe.get(ge.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Ce.UserDataSyncAccountServiceChannel(pe.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const at=new Ce.UserDataSyncStoreManagementServiceChannel(pe.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new Q.UserDataSyncChannel(pe.get(ae.IUserDataSyncService),pe.get(ee.ILogService));this.server.registerChannel("userDataSync",ct);const He=this._register(pe.get(G.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new Ce.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",et);const rt=pe.get(Ue.ILocalPtyService),lt=P.ProxyChannel.fromService(rt);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(pe.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(pe.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(pe){window.addEventListener("unhandledrejection",Me=>{(0,A.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Me=>{const je=(0,L.toErrorMessage)(Me,!0);!je||pe.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Tt(yt){const pe=new Lt(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await pe.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0e435cf51d0e45293a94466fc3b1299ba70fa9b1/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
