/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/node/pfs","vs/base/common/strings","os","vs/base/common/extpath","fs","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/labels","vs/base/common/process","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","child_process","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/platform/backup/electron-main/backup","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/node/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/credentials/node/credentialsMainService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/url/common/url","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/credentials/common/credentials","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],te=function(K){for(var e=[],v=0,n=K.length;v<n;v++)e[v]=ee[K[v]];return e};define(ee[104],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(n,D){if(!n)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(ee[105],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(k){return k?k.replace(/\$\((.*?)\)/g,(I,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=v;class n{constructor(I,g,w){this.id=I,this.definition=g,this.description=w,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(k,I){const g=["codicon","codicon-"+k];return I&&g.push("codicon-modifier-"+I),g}e.getClassNamesArray=D;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function g(P){if(P instanceof n)return["codicon","codicon-"+P.id];const S=I.exec(P.id);if(!S)return g(n.error);let[,y,t]=S;const f=["codicon","codicon-"+y];return t&&f.push("codicon-modifier-"+t.substr(1)),f}k.asClassNameArray=g;function w(P){return g(P).join(" ")}k.asClassName=w;function E(P){return"."+g(P).join(".")}k.asCSSSelector=E})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ee[46],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(k){return(I,g,w)=>{let E=null,P=null;if(typeof w.value=="function"?(E="value",P=w.value):typeof w.get=="function"&&(E="get",P=w.get),!P)throw new Error("not supported");w[E]=k(P,g)}}e.createDecorator=v;function n(k,I,g){let w=null,E=null;if(typeof g.value=="function"?(w="value",E=g.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",E=g.get),!E)throw new Error("not supported");const P=`$memoize$${I}`;g[w]=function(...S){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,S)}),this[P]}}e.memoize=n;function D(k,I,g){return v((w,E)=>{const P=`$debounce$${E}`,S=`$debounce$result$${E}`;return function(...y){this[S]||(this[S]=g?g():void 0),clearTimeout(this[P]),I&&(this[S]=I(this[S],...y),y=[this[S]]),this[P]=setTimeout(()=>{w.apply(this,y),this[S]=g?g():void 0},k)}})}e.debounce=D;function C(k,I,g){return v((w,E)=>{const P=`$throttle$timer$${E}`,S=`$throttle$result$${E}`,y=`$throttle$lastRun$${E}`,t=`$throttle$pending$${E}`;return function(...f){if(this[S]||(this[S]=g?g():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),I&&(this[S]=I(this[S],...f)),this[t])return;const m=this[y]+k;m<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[S]]),this[S]=g?g():void 0):(this[t]=!0,this[P]=setTimeout(()=>{this[t]=!1,this[y]=Date.now(),w.apply(this,[this[S]]),this[S]=g?g():void 0},m-Date.now()))}})}e.throttle=C}),define(ee[15],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(u=>{u(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=v,e.errorHandler=new v;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function D(c){g(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function C(c){g(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=C;function k(c){if(c instanceof Error){let{name:o,message:u}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:o,message:u,stack:s}}return c}e.transformErrorForSerialization=k;const I="Canceled";function g(c){return c instanceof w?!0:c instanceof Error&&c.name===I&&c.message===I}e.isCancellationError=g;class w extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=w;function E(){const c=new Error(I);return c.name=c.message,c}e.canceled=E;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=S;function y(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function t(c){const o=new Error(`${c} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function f(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=f;class m extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=m;class p extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=p;class M extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=M;function a(c){const o=c;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=a;function d(c,o=Object.create(null)){const u=new Error(c);return o.actions&&(u.actions=o.actions),u}e.createErrorWithActions=d}),define(ee[31],te([0,1,15]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(A,T=0){return A[A.length-(1+T)]}e.tail=n;function D(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}e.tail2=D;function C(A,T,_=(O,U)=>O===U){if(A===T)return!0;if(!A||!T||A.length!==T.length)return!1;for(let O=0,U=A.length;O<U;O++)if(!_(A[O],T[O]))return!1;return!0}e.equals=C;function k(A,T,_){let O=0,U=A.length-1;for(;O<=U;){const J=(O+U)/2|0,ie=_(A[J],T);if(ie<0)O=J+1;else if(ie>0)U=J-1;else return J}return-(O+1)}e.binarySearch=k;function I(A,T){let _=0,O=A.length;if(O===0)return 0;for(;_<O;){const U=Math.floor((_+O)/2);T(A[U])?O=U:_=U+1}return _}e.findFirstInSorted=I;function g(A,T,_){if(A=A|0,A>=T.length)throw new TypeError("invalid index");let O=T[Math.floor(T.length*Math.random())],U=[],J=[],ie=[];for(let se of T){const Z=_(se,O);Z<0?U.push(se):Z>0?J.push(se):ie.push(se)}return A<U.length?g(A,U,_):A<U.length+ie.length?ie[0]:g(A-(U.length+ie.length),J,_)}e.quickSelect=g;function w(A,T){const _=[];let O;for(const U of A.slice(0).sort(T))!O||T(O[0],U)!==0?(O=[U],_.push(O)):O.push(U);return _}e.groupBy=w;function E(A,T,_){const O=[];function U(se,Z,ce){if(Z===0&&ce.length===0)return;const le=O[O.length-1];le&&le.start+le.deleteCount===se?(le.deleteCount+=Z,le.toInsert.push(...ce)):O.push({start:se,deleteCount:Z,toInsert:ce})}let J=0,ie=0;for(;;){if(J===A.length){U(J,0,T.slice(ie));break}if(ie===T.length){U(J,A.length-J,[]);break}const se=A[J],Z=T[ie],ce=_(se,Z);ce===0?(J+=1,ie+=1):ce<0?(U(J,1,[]),J+=1):ce>0&&(U(J,0,[Z]),ie+=1)}return O}e.sortedDiff=E;function P(A,T,_){const O=E(A,T,_),U=[],J=[];for(const ie of O)U.push(...A.slice(ie.start,ie.start+ie.deleteCount)),J.push(...ie.toInsert);return{removed:U,added:J}}e.delta=P;function S(A,T,_){if(_===0)return[];const O=A.slice(0,_).sort(T);return t(A,T,O,_,A.length),O}e.top=S;function y(A,T,_,O,U){return _===0?Promise.resolve([]):new Promise((J,ie)=>{(async()=>{const se=A.length,Z=A.slice(0,_).sort(T);for(let ce=_,le=Math.min(_+O,se);ce<se;ce=le,le=Math.min(le+O,se)){if(ce>_&&await new Promise(he=>setTimeout(he)),U&&U.isCancellationRequested)throw(0,v.canceled)();t(A,T,Z,ce,le)}return Z})().then(J,ie)})}e.topAsync=y;function t(A,T,_,O,U){for(const J=_.length;O<U;O++){const ie=A[O];if(T(ie,_[J-1])<0){_.pop();const se=I(_,Z=>T(ie,Z)<0);_.splice(se,0,ie)}}}function f(A){return A.filter(T=>!!T)}e.coalesce=f;function m(A){let T=0;for(let _=0;_<A.length;_++)A[_]&&(A[T]=A[_],T+=1);A.length=T}e.coalesceInPlace=m;function p(A,T,_){A.splice(_,0,A.splice(T,1)[0])}e.move=p;function M(A){return!Array.isArray(A)||A.length===0}e.isFalsyOrEmpty=M;function a(A){return Array.isArray(A)&&A.length>0}e.isNonEmptyArray=a;function d(A,T=_=>_){const _=new Set;return A.filter(O=>{const U=T(O);return _.has(U)?!1:(_.add(U),!0)})}e.distinct=d;function c(A){const T=new Set;return _=>{const O=A(_);return T.has(O)?!1:(T.add(O),!0)}}e.uniqueFilter=c;function o(A,T){const _=u(A,T);if(_!==-1)return A[_]}e.findLast=o;function u(A,T){for(let _=A.length-1;_>=0;_--){const O=A[_];if(T(O))return _}return-1}e.lastIndex=u;function s(A,T){return A.length>0?A[0]:T}e.firstOrDefault=s;function i(A,T,_=(O,U)=>O===U){let O=0;for(let U=0,J=Math.min(A.length,T.length);U<J&&_(A[U],T[U]);U++)O++;return O}e.commonPrefixLength=i;function r(A){return[].concat(...A)}e.flatten=r;function l(A,T){let _=typeof T=="number"?A:0;typeof T=="number"?_=A:(_=0,T=A);const O=[];if(_<=T)for(let U=_;U<T;U++)O.push(U);else for(let U=_;U>T;U--)O.push(U);return O}e.range=l;function h(A,T,_){return A.reduce((O,U)=>(O[T(U)]=_?_(U):U,O),Object.create(null))}e.index=h;function b(A,T){return A.push(T),()=>R(A,T)}e.insert=b;function R(A,T){const _=A.indexOf(T);if(_>-1)return A.splice(_,1),T}e.remove=R;function L(A,T,_){const O=A.slice(0,T),U=A.slice(T);return O.concat(_,U)}e.arrayInsert=L;function F(A,T){let _;if(typeof T=="number"){let O=T;_=()=>{const U=Math.sin(O++)*179426549;return U-Math.floor(U)}}else _=Math.random;for(let O=A.length-1;O>0;O-=1){const U=Math.floor(_()*(O+1)),J=A[O];A[O]=A[U],A[U]=J}}e.shuffle=F;function z(A,T){const _=A.indexOf(T);_>-1&&(A.splice(_,1),A.unshift(T))}e.pushToStart=z;function Q(A,T){const _=A.indexOf(T);_>-1&&(A.splice(_,1),A.push(T))}e.pushToEnd=Q;function oe(A,T){return Array.isArray(A)?A.map(T):T(A)}e.mapArrayOrNot=oe;function re(A){return Array.isArray(A)?A:[A]}e.asArray=re;function q(A){return A[Math.floor(Math.random()*A.length)]}e.getRandomElement=q;function x(A,T){for(const _ of A){const O=T(_);if(O!==void 0)return O}}e.mapFind=x;function H(A,T,_){const O=j(A,T),U=A.length,J=_.length;A.length=U+J;for(let ie=U-1;ie>=O;ie--)A[ie+J]=A[ie];for(let ie=0;ie<J;ie++)A[ie+O]=_[ie]}e.insertInto=H;function G(A,T,_,O){const U=j(A,T),J=A.splice(U,_);return H(A,U,O),J}e.splice=G;function j(A,T){return T<0?Math.max(T+A.length,0):Math.min(T,A.length)}function N(A,T){return(_,O)=>T(A(_),A(O))}e.compareBy=N;const B=(A,T)=>A-T;e.numberComparator=B;function Y(A,T){if(A.length===0)return;let _=A[0];for(let O=1;O<A.length;O++){const U=A[O];T(U,_)>0&&(_=U)}return _}e.findMaxBy=Y;function V(A,T){if(A.length===0)return;let _=A[0];for(let O=1;O<A.length;O++){const U=A[O];T(U,_)>=0&&(_=U)}return _}e.findLastMaxBy=V;function W(A,T){return Y(A,(_,O)=>-T(_,O))}e.findMinBy=W;class ${constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let _=this.firstIdx;for(;_<this.items.length&&T(this.items[_]);)_++;const O=_===this.firstIdx?null:this.items.slice(this.firstIdx,_);return this.firstIdx=_,O}takeFromEndWhile(T){let _=this.lastIdx;for(;_>=0&&T(this.items[_]);)_--;const O=_===this.lastIdx?null:this.items.slice(_+1,this.lastIdx+1);return this.lastIdx=_,O}peek(){return this.items[this.firstIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}takeCount(T){const _=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,_}}e.ArrayQueue=$}),define(ee[42],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(n){const D=this;let C=!1,k;return function(){return C||(C=!0,k=n.apply(D,arguments)),k}}e.once=v}),define(ee[70],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(n){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=D;const C=Object.freeze([]);function k(){return C}n.empty=k;function*I(c){yield c}n.single=I;function g(c){return c||C}n.from=g;function w(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=w;function E(c){return c[Symbol.iterator]().next().value}n.first=E;function P(c,o){for(const u of c)if(o(u))return!0;return!1}n.some=P;function S(c,o){for(const u of c)if(o(u))return u}n.find=S;function*y(c,o){for(const u of c)o(u)&&(yield u)}n.filter=y;function*t(c,o){let u=0;for(const s of c)yield o(s,u++)}n.map=t;function*f(...c){for(const o of c)for(const u of o)yield u}n.concat=f;function*m(c){for(const o of c)for(const u of o)yield u}n.concatNested=m;function p(c,o,u){let s=u;for(const i of c)s=o(s,i);return s}n.reduce=p;function*M(c,o,u=c.length){for(o<0&&(o+=c.length),u<0?u+=c.length:u>c.length&&(u=c.length);o<u;o++)yield c[o]}n.slice=M;function a(c,o=Number.POSITIVE_INFINITY){const u=[];if(o===0)return[u,c];const s=c[Symbol.iterator]();for(let i=0;i<o;i++){const r=s.next();if(r.done)return[u,n.empty()];u.push(r.value)}return[u,{[Symbol.iterator](){return s}}]}n.consume=a;function d(c,o,u=(s,i)=>s===i){const s=c[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const r=s.next(),l=i.next();if(r.done!==l.done)return!1;if(r.done)return!0;if(!u(r.value,l.value))return!1}}n.equals=d})(v=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function k(o,u=!1){let s=0,i=o.length,r="",l=0,h=16,b=0;function R(q){let x=0,H=0;for(;x<q;){const G=o.charCodeAt(s);if(G>=48&&G<=57)H=H*16+G-48;else if(G>=65&&G<=70)H=H*16+G-65+10;else if(G>=97&&G<=102)H=H*16+G-97+10;else break;s++,x++}return x<q&&(H=-1),H}function L(q){s=q,r="",l=0,h=16,b=0}function F(){const q=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&w(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&w(o.charCodeAt(s)))for(s++;s<o.length&&w(o.charCodeAt(s));)s++;else return b=3,o.substring(q,s);let x=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&w(o.charCodeAt(s))){for(s++;s<o.length&&w(o.charCodeAt(s));)s++;x=s}else b=3;return o.substring(q,x)}function z(){let q="",x=s;for(;;){if(s>=i){q+=o.substring(x,s),b=2;break}const H=o.charCodeAt(s);if(H===34){q+=o.substring(x,s),s++;break}if(H===92){if(q+=o.substring(x,s),s++,s>=i){b=2;break}switch(o.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const j=R(4);j>=0?q+=String.fromCharCode(j):b=4;break}default:b=5}x=s;continue}if(H>=0&&H<=31)if(g(H)){q+=o.substring(x,s),b=2;break}else b=6;s++}return q}function Q(){if(r="",b=0,l=s,s>=i)return l=i,h=17;let q=o.charCodeAt(s);if(I(q)){do s++,r+=String.fromCharCode(q),q=o.charCodeAt(s);while(I(q));return h=15}if(g(q))return s++,r+=String.fromCharCode(q),q===13&&o.charCodeAt(s)===10&&(s++,r+=`
`),h=14;switch(q){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,r=z(),h=10;case 47:{const x=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<i&&!g(o.charCodeAt(s));)s++;return r=o.substring(x,s),h=12}if(o.charCodeAt(s+1)===42){s+=2;const H=i-1;let G=!1;for(;s<H;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,G=!0;break}s++}return G||(s++,b=1),r=o.substring(x,s),h=13}return r+=String.fromCharCode(q),s++,h=16}case 45:if(r+=String.fromCharCode(q),s++,s===i||!w(o.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),h=11;default:for(;s<i&&oe(q);)s++,q=o.charCodeAt(s);if(l!==s){switch(r=o.substring(l,s),r){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return r+=String.fromCharCode(q),s++,h=16}}function oe(q){if(I(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let q;do q=Q();while(q>=12&&q<=15);return q}return{setPosition:L,getPosition:()=>s,scan:u?re:Q,getToken:()=>h,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>b}}e.createScanner=k;function I(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function g(o){return o===10||o===13||o===8232||o===8233}function w(o){return o>=48&&o<=57}var E;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(E||(E={}));function P(o,u){const s=[],i=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function b(R,L,F,z){l.value=R,l.offset=L,l.length=F,l.type=z,l.colonOffset=void 0,r=l}try{a(o,{onObjectBegin:(R,L)=>{if(u<=R)throw i;r=void 0,h=u>R,s.push("")},onObjectProperty:(R,L,F)=>{if(u<L||(b(R,L,F,"property"),s[s.length-1]=R,u<=L+F))throw i},onObjectEnd:(R,L)=>{if(u<=R)throw i;r=void 0,s.pop()},onArrayBegin:(R,L)=>{if(u<=R)throw i;r=void 0,s.push(0)},onArrayEnd:(R,L)=>{if(u<=R)throw i;r=void 0,s.pop()},onLiteralValue:(R,L,F)=>{if(u<L||(b(R,L,F,c(R)),u<=L+F))throw i},onSeparator:(R,L,F)=>{if(u<=L)throw i;if(R===":"&&r&&r.type==="property")r.colonOffset=L,h=!1,r=void 0;else if(R===","){const z=s[s.length-1];typeof z=="number"?s[s.length-1]=z+1:(h=!0,s[s.length-1]=""),r=void 0}}})}catch(R){if(R!==i)throw R}return{path:s,previousNode:r,isAtPropertyKey:h,matches:R=>{let L=0;for(let F=0;L<R.length&&F<s.length;F++)if(R[L]===s[F]||R[L]==="*")L++;else if(R[L]!=="**")return!1;return L===R.length}}}e.getLocation=P;function S(o,u=[],s=C.DEFAULT){let i=null,r=[];const l=[];function h(R){Array.isArray(r)?r.push(R):i!==null&&(r[i]=R)}return a(o,{onObjectBegin:()=>{const R={};h(R),l.push(r),r=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const R=[];h(R),l.push(r),r=R,i=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:h,onError:(R,L,F)=>{u.push({error:R,offset:L,length:F})}},s),r[0]}e.parse=S;function y(o,u=[],s=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function l(R){return i.children.push(R),R}a(o,{onObjectBegin:R=>{i=l({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,L,F)=>{i=l({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:L,length:F,parent:i})},onObjectEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onArrayBegin:(R,L)=>{i=l({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onLiteralValue:(R,L,F)=>{l({type:c(R),offset:L,length:F,parent:i,value:R}),r(L+F)},onSeparator:(R,L,F)=>{i.type==="property"&&(R===":"?i.colonOffset=L:R===","&&r(L))},onError:(R,L,F)=>{u.push({error:R,offset:L,length:F})}},s);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=y;function t(o,u){if(!o)return;let s=o;for(let i of u)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===i){s=l.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=t;function f(o){if(!o.parent||!o.parent.children)return[];const u=f(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;u.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&u.push(s)}return u}e.getNodePath=f;function m(o){switch(o.type){case"array":return o.children.map(m);case"object":{const u=Object.create(null);for(let s of o.children){const i=s.children[1];i&&(u[s.children[0].value]=m(i))}return u}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=m;function p(o,u,s=!1){return u>=o.offset&&u<o.offset+o.length||s&&u===o.offset+o.length}e.contains=p;function M(o,u,s=!1){if(p(o,u,s)){const i=o.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=u;r++){const l=M(i[r],u,s);if(l)return l}return o}}e.findNodeAtOffset=M;function a(o,u,s=C.DEFAULT){const i=k(o,!1);function r($){return $?()=>$(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l($){return $?A=>$(A,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=r(u.onObjectBegin),b=l(u.onObjectProperty),R=r(u.onObjectEnd),L=r(u.onArrayBegin),F=r(u.onArrayEnd),z=l(u.onLiteralValue),Q=l(u.onSeparator),oe=r(u.onComment),re=l(u.onError),q=s&&s.disallowComments,x=s&&s.allowTrailingComma;function H(){for(;;){const $=i.scan();switch(i.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:q||G(11);break;case 2:G(12);break;case 6:G(16);break}switch($){case 12:case 13:q?G(10):oe();break;case 16:G(1);break;case 15:case 14:break;default:return $}}}function G($,A=[],T=[]){if(re($),A.length+T.length>0){let _=i.getToken();for(;_!==17;){if(A.indexOf(_)!==-1){H();break}else if(T.indexOf(_)!==-1)break;_=H()}}}function j($){const A=i.getTokenValue();return $?z(A):b(A),H(),!0}function N(){switch(i.getToken()){case 11:{let $=0;try{$=JSON.parse(i.getTokenValue()),typeof $!="number"&&(G(2),$=0)}catch{G(2)}z($);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return H(),!0}function B(){return i.getToken()!==10?(G(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(Q(":"),H(),W()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function Y(){h(),H();let $=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if($||G(4,[],[]),Q(","),H(),i.getToken()===2&&x)break}else $&&G(6,[],[]);B()||G(4,[],[2,5]),$=!0}return R(),i.getToken()!==2?G(7,[2],[]):H(),!0}function V(){L(),H();let $=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if($||G(4,[],[]),Q(","),H(),i.getToken()===4&&x)break}else $&&G(6,[],[]);W()||G(4,[],[4,5]),$=!0}return F(),i.getToken()!==4?G(8,[4],[]):H(),!0}function W(){switch(i.getToken()){case 3:return V();case 1:return Y();case 10:return j(!0);default:return N()}}return H(),i.getToken()===17?s.allowEmptyContent?!0:(G(4,[],[]),!1):W()?(i.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=a;function d(o,u){let s=k(o),i=[],r,l=0,h;do switch(h=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:l!==h&&i.push(o.substring(l,h)),u!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,u)),l=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=d;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ee[106],te([0,1,43]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(w,E,P){let S,y,t,f,m;if(E){for(f=E.offset,m=f+E.length,t=f;t>0&&!g(w,t-1);)t--;let h=m;for(;h<w.length&&!g(w,h);)h++;y=w.substring(t,h),S=k(y,P)}else y=w,S=0,t=0,f=0,m=w.length;const p=I(P,w);let M=!1,a=0,d;P.insertSpaces?d=C(" ",P.tabSize||4):d="	";const c=(0,v.createScanner)(y,!1);let o=!1;function u(){return p+C(d,S+a)}function s(){let h=c.scan();for(M=!1;h===15||h===14;)M=M||h===14,h=c.scan();return o=h===16||c.getTokenError()!==0,h}const i=[];function r(h,b,R){!o&&b<m&&R>f&&w.substring(b,R)!==h&&i.push({offset:b,length:R-b,content:h})}let l=s();if(l!==17){const h=c.getTokenOffset()+t,b=C(d,S);r(b,t,h)}for(;l!==17;){let h=c.getTokenOffset()+c.getTokenLength()+t,b=s(),R="";for(;!M&&(b===12||b===13);){const F=c.getTokenOffset()+t;r(" ",h,F),h=c.getTokenOffset()+c.getTokenLength()+t,R=b===12?u():"",b=s()}if(b===2)l!==1&&(a--,R=u());else if(b===4)l!==3&&(a--,R=u());else{switch(l){case 3:case 1:a++,R=u();break;case 5:case 12:R=u();break;case 13:M?R=u():R=" ";break;case 6:R=" ";break;case 10:if(b===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?R=" ":b!==5&&b!==17&&(o=!0);break;case 16:o=!0;break}M&&(b===12||b===13)&&(R=u())}const L=c.getTokenOffset()+t;r(R,h,L),l=b}return i}e.format=n;function D(w,E){const P=JSON.stringify(w,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?P.replace(/\r\n|\r|\n/g,E.eol):P}e.toFormattedString=D;function C(w,E){let P="";for(let S=0;S<E;S++)P+=w;return P}function k(w,E){let P=0,S=0;const y=E.tabSize||4;for(;P<w.length;){const t=w.charAt(P);if(t===" ")S++;else if(t==="	")S+=y;else break;P++}return Math.floor(S/y)}function I(w,E){for(let P=0;P<E.length;P++){const S=E.charAt(P);if(S==="\r")return P+1<E.length&&E.charAt(P+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=I;function g(w,E){return`\r
`.indexOf(w.charAt(E))!==-1}e.isEOL=g}),define(ee[107],te([0,1,43,106]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(w,E,P){return C(w,E,void 0,P)}e.removeProperty=D;function C(w,E,P,S,y){const t=E.slice(),f=[],m=(0,v.parseTree)(w,f);let p,M;for(;t.length>0&&(M=t.pop(),p=(0,v.findNodeAtLocation)(m,t),p===void 0&&P!==void 0);)typeof M=="string"?P={[M]:P}:P=[P];if(p)if(p.type==="object"&&typeof M=="string"&&Array.isArray(p.children)){const a=(0,v.findNodeAtLocation)(p,[M]);if(a!==void 0)if(P===void 0){if(!a.parent)throw new Error("Malformed AST");const d=p.children.indexOf(a.parent);let c,o=a.parent.offset+a.parent.length;if(d>0){const u=p.children[d-1];c=u.offset+u.length}else c=p.offset+1,p.children.length>1&&(o=p.children[1].offset);return k(w,{offset:c,length:o-c,content:""},S)}else return k(w,{offset:a.offset,length:a.length,content:JSON.stringify(P)},S);else{if(P===void 0)return[];const d=`${JSON.stringify(M)}: ${JSON.stringify(P)}`,c=y?y(p.children.map(u=>u.children[0].value)):p.children.length;let o;if(c>0){const u=p.children[c-1];o={offset:u.offset+u.length,length:0,content:","+d}}else p.children.length===0?o={offset:p.offset+1,length:0,content:d}:o={offset:p.offset+1,length:0,content:d+","};return k(w,o,S)}}else if(p.type==="array"&&typeof M=="number"&&Array.isArray(p.children))if(P!==void 0){const a=`${JSON.stringify(P)}`;let d;if(p.children.length===0||M===0)d={offset:p.offset+1,length:0,content:p.children.length===0?a:a+","};else{const c=M===-1||M>p.children.length?p.children.length:M,o=p.children[c-1];d={offset:o.offset+o.length,length:0,content:","+a}}return k(w,d,S)}else{const a=M,d=p.children[a];let c;if(p.children.length===1)c={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===a){const o=p.children[a-1],u=o.offset+o.length,s=p.offset+p.length;c={offset:u,length:s-2-u,content:""}}else c={offset:d.offset,length:p.children[a+1].offset-d.offset,content:""};return k(w,c,S)}else throw new Error(`Can not add ${typeof M!="number"?"index":"property"} to parent of type ${p.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return k(w,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(P)},S)}}e.setProperty=C;function k(w,E,P){let S=I(w,E),y=E.offset,t=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;y>0&&!(0,n.isEOL)(S,y-1);)y--;for(;t<S.length&&!(0,n.isEOL)(S,t);)t++}const f=(0,n.format)(S,{offset:y,length:t-y},P);for(let p=f.length-1;p>=0;p--){const M=f[p];S=I(S,M),y=Math.min(y,M.offset),t=Math.max(t,M.offset+M.length),t+=M.content.length-M.length}const m=w.length-(S.length-t)-y;return[{offset:y,length:m,content:S.substring(y,t)}]}e.withFormatting=k;function I(w,E){return w.substring(0,E.offset)+E.content+w.substring(E.offset+E.length)}e.applyEdit=I;function g(w,E){let P=E.slice(0).sort((y,t)=>{const f=y.offset-t.offset;return f===0?y.length-t.length:f}),S=w.length;for(let y=P.length-1;y>=0;y--){let t=P[y];if(t.offset+t.length<=S)w=I(w,t);else throw new Error("Overlapping edit");S=t.offset}return w}e.applyEdits=g}),define(ee[81],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var v;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(v=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(f,m){this._keyCodeToStr[f]=m,this._strToKeyCode[m.toLowerCase()]=f}keyCodeToStr(f){return this._keyCodeToStr[f]}strToKeyCode(f){return this._strToKeyCode[f.toLowerCase()]||0}}const C=new D,k=new D,I=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],w=Object.create(null),E=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>E[t]||0,toEnum:t=>w[t]||0,toString:t=>g[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",f=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let m=[],p=[];for(const M of f){const[a,d,c,o,u,s,i,r,l,h]=M;if(p[c]||(p[c]=!0,g[c]=o,w[o]=c,E[o.toLowerCase()]=c,d&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[u]=c))),!m[u]){if(m[u]=!0,!s)throw new Error(`String representation missing for key code ${u} around scan code ${o}`);C.define(u,s),k.define(u,l||s),I.define(u,h||l||s)}i&&(e.EVENT_KEY_CODE_MAP[i]=u),r&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=u)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(t){function f(c){return C.keyCodeToStr(c)}t.toString=f;function m(c){return C.strToKeyCode(c)}t.fromString=m;function p(c){return k.keyCodeToStr(c)}t.toUserSettingsUS=p;function M(c){return I.keyCodeToStr(c)}t.toUserSettingsGeneral=M;function a(c){return k.strToKeyCode(c)||I.strToKeyCode(c)}t.fromUserSettings=a;function d(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(c)}t.toElectronAccelerator=d})(P=e.KeyCodeUtils||(e.KeyCodeUtils={}));var S;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(S=e.KeyMod||(e.KeyMod={}));function y(t,f){const m=(f&65535)<<16>>>0;return(t|m)>>>0}e.KeyChord=y}),define(ee[59],te([0,1,15]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(n||(n={}));function D(P,S){if(P===0)return null;const y=(P&65535)>>>0,t=(P&4294901760)>>>16;return t!==0?new I([C(y,S),C(t,S)]):new I([C(y,S)])}e.createKeybinding=D;function C(P,S){const y=!!(P&2048),t=!!(P&256),f=S===2?t:y,m=!!(P&1024),p=!!(P&512),M=S===2?y:t,a=P&255;return new k(f,m,p,M,a)}e.createSimpleKeybinding=C;class k{constructor(S,y,t,f,m){this.ctrlKey=S,this.shiftKey=y,this.altKey=t,this.metaKey=f,this.keyCode=m}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.keyCode===S.keyCode}getHashCode(){const S=this.ctrlKey?"1":"0",y=this.shiftKey?"1":"0",t=this.altKey?"1":"0",f=this.metaKey?"1":"0";return`${S}${y}${t}${f}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=k;class I{constructor(S){if(S.length===0)throw(0,v.illegalArgument)("parts");this.parts=S}getHashCode(){let S="";for(let y=0,t=this.parts.length;y<t;y++)y!==0&&(S+=";"),S+=this.parts[y].getHashCode();return S}equals(S){if(S===null||this.parts.length!==S.parts.length)return!1;for(let y=0;y<this.parts.length;y++)if(!this.parts[y].equals(S.parts[y]))return!1;return!0}}e.ChordKeybinding=I;class g{constructor(S,y,t,f,m){this.ctrlKey=S,this.shiftKey=y,this.altKey=t,this.metaKey=f,this.scanCode=m}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=g;class w{constructor(S,y,t,f,m,p){this.ctrlKey=S,this.shiftKey=y,this.altKey=t,this.metaKey=f,this.keyLabel=m,this.keyAriaLabel=p}}e.ResolvedKeybindingPart=w;class E{}e.ResolvedKeybinding=E}),define(ee[108],te([0,1,81,59]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(k){k=k.toLowerCase().trim();let I=!1,g=!1,w=!1,E=!1,P;do P=!1,/^ctrl(\+|\-)/.test(k)&&(I=!0,k=k.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(k)&&(g=!0,k=k.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(k)&&(w=!0,k=k.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(k)&&(E=!0,k=k.substr("meta-".length),P=!0),/^win(\+|\-)/.test(k)&&(E=!0,k=k.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(k)&&(E=!0,k=k.substr("cmd-".length),P=!0);while(P);let S;const y=k.indexOf(" ");return y>0?(S=k.substring(0,y),k=k.substring(y)):(S=k,k=""),{remains:k,ctrl:I,shift:g,alt:w,meta:E,key:S}}static parseSimpleKeybinding(k){const I=this._readModifiers(k),g=v.KeyCodeUtils.fromUserSettings(I.key);return[new n.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,g),I.remains]}static parseKeybinding(k,I){if(!k)return null;const g=[];let w;do[w,k]=this.parseSimpleKeybinding(k),g.push(w);while(k.length>0);return new n.ChordKeybinding(g)}static parseSimpleUserBinding(k){const I=this._readModifiers(k),g=I.key.match(/^\[([^\]]+)\]$/);if(g){const E=g[1],P=v.ScanCodeUtils.lowerCaseToEnum(E);return[new n.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,P),I.remains]}const w=v.KeyCodeUtils.fromUserSettings(I.key);return[new n.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,w),I.remains]}static parseUserBinding(k){if(!k)return[];const I=[];let g;for(;k.length>0;)[g,k]=this.parseSimpleUserBinding(k),I.push(g);return I}}e.KeybindingParser=D}),define(ee[109],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(ee[2],te([0,1,42,70]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function k(i){C=i}if(e.setDisposableTracker=k,D){const i="__is_disposable_tracked__";k(new class{trackDisposable(r){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(l)},3e3)}setParent(r,l){if(r&&r!==M.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==M.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function I(i){return C?.trackDisposable(i),i}function g(i){C?.markAsDisposed(i)}function w(i,r){C?.setParent(i,r)}function E(i,r){if(!!C)for(const l of i)C.setParent(l,r)}function P(i){return C?.markAsSingleton(i),i}e.markAsSingleton=P;class S extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=S;function y(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=y;function t(i){if(n.Iterable.is(i)){let r=[];for(const l of i)if(l)try{l.dispose()}catch(h){r.push(h)}if(r.length===1)throw r[0];if(r.length>1)throw new S(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function f(...i){const r=m(()=>t(i));return E(i,r),r}e.combinedDisposable=f;function m(i){const r=I({dispose:(0,v.once)(()=>{g(r),i()})});return r}e.toDisposable=m;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return w(r,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class M{constructor(){this._store=new p,I(this),w(this._store,this)}dispose(){g(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=M,M.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&w(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&w(r,null),r}}e.MutableDisposable=a;class d{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class c{constructor(){this.references=new Map}acquire(r,...l){let h=this.references.get(r);h||(h={counter:0,object:this.createReferencedObject(r,...l)},this.references.set(r,h));const{object:b}=h,R=(0,v.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(r,h.object),this.references.delete(r))});return h.counter++,{object:b,dispose:R}}}e.ReferenceCollection=c;class o{constructor(r){this.referenceCollection=r}async acquire(r,...l){const h=this.referenceCollection.acquire(r,...l);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(b){throw h.dispose(),b}}}e.AsyncReferenceCollection=o;class u{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=u;function s(i){const r=new p;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=s}),define(ee[110],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(C){this.element=C,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class n{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let C=this._first;for(;C!==v.Undefined;){const k=C.next;C.prev=v.Undefined,C.next=v.Undefined,C=k}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,k){const I=new v(C);if(this._first===v.Undefined)this._first=I,this._last=I;else if(k){const w=this._last;this._last=I,I.prev=w,w.next=I}else{const w=this._first;this._first=I,I.next=w,w.prev=I}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(I))}}shift(){if(this._first!==v.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==v.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==v.Undefined&&C.next!==v.Undefined){const k=C.prev;k.next=C.next,C.next.prev=k}else C.prev===v.Undefined&&C.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):C.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):C.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==v.Undefined;)yield C.element,C=C.next}}e.LinkedList=n}),function(){function K(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function k(g){C.push(g,Date.now())}function I(){const g=[];for(let w=0;w<C.length;w+=2)g.push({name:C[w],startTime:C[w+1]});return g}return{mark:k,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))C.push({name:k.name,startTime:Math.round(D+k.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=v(n))}(),define(ee[3],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let n=!1,D=!1,C=!1,k=!1,I=!1,g=!1,w=!1,E=!1,P,S=v,y,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const m=typeof f?.versions?.electron=="string",p=m&&f?.type==="renderer";if(e.isElectronSandboxed=p&&f?.sandboxed,typeof navigator=="object"&&!p)t=navigator.userAgent,n=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,E=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=t.indexOf("Linux")>=0,g=!0,P=navigator.language,S=P;else if(typeof f=="object"){n=f.platform==="win32",D=f.platform==="darwin",C=f.platform==="linux",k=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,w=m,P=v,S=v;const r=f.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),h=l.availableLanguages["*"];P=l.locale,S=h||v,y=l._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var M;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(M=e.Platform||(e.Platform={}));function a(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let d=0;D?d=1:n?d=3:C&&(d=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=k,e.isNative=I,e.isElectron=w,e.isWeb=g,e.isIOS=E,e.platform=d,e.userAgent=t,e.language=S;var c;(function(r){function l(){return e.language}r.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function b(){return e.language==="en"}r.isDefault=b})(c=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=y,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let b=0,R=r.length;b<R;b++){const L=r[b];if(L.id===h.data.vscodeScheduleAsyncWork){r.splice(b,1),L.callback();return}}});let l=0;return h=>{const b=++l;r.push({id:b,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return r=>setTimeout(r)})();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||E?2:n?1:3;let u=!0,s=!1;function i(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,u=new Uint16Array(r.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=i}),define(ee[34],te([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ee[9],te([0,1,34]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,C=90,k=122,I=46,g=47,w=92,E=58,P=63;class S extends Error{constructor(d,c,o){let u;typeof c=="string"&&c.indexOf("not ")===0?(u="must not be",c=c.replace(/^not /,"")):u="must be";const s=d.indexOf(".")!==-1?"property":"argument";let i=`The "${d}" ${s} ${u} of type ${c}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function y(a,d){if(typeof a!="string")throw new S(d,"string",a)}function t(a){return a===g||a===w}function f(a){return a===g}function m(a){return a>=n&&a<=C||a>=D&&a<=k}function p(a,d,c,o){let u="",s=0,i=-1,r=0,l=0;for(let h=0;h<=a.length;++h){if(h<a.length)l=a.charCodeAt(h);else{if(o(l))break;l=g}if(o(l)){if(!(i===h-1||r===1))if(r===2){if(u.length<2||s!==2||u.charCodeAt(u.length-1)!==I||u.charCodeAt(u.length-2)!==I){if(u.length>2){const b=u.lastIndexOf(c);b===-1?(u="",s=0):(u=u.slice(0,b),s=u.length-1-u.lastIndexOf(c)),i=h,r=0;continue}else if(u.length!==0){u="",s=0,i=h,r=0;continue}}d&&(u+=u.length>0?`${c}..`:"..",s=2)}else u.length>0?u+=`${c}${a.slice(i+1,h)}`:u=a.slice(i+1,h),s=h-i-1;i=h,r=0}else l===I&&r!==-1?++r:r=-1}return u}function M(a,d){if(d===null||typeof d!="object")throw new S("pathObject","Object",d);const c=d.dir||d.root,o=d.base||`${d.name||""}${d.ext||""}`;return c?c===d.root?`${c}${o}`:`${c}${a}${o}`:o}e.win32={resolve(...a){let d="",c="",o=!1;for(let u=a.length-1;u>=-1;u--){let s;if(u>=0){if(s=a[u],y(s,"path"),s.length===0)continue}else d.length===0?s=v.cwd():(s=v.env[`=${d}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==d.toLowerCase()&&s.charCodeAt(2)===w)&&(s=`${d}\\`));const i=s.length;let r=0,l="",h=!1;const b=s.charCodeAt(0);if(i===1)t(b)&&(r=1,h=!0);else if(t(b))if(h=!0,t(s.charCodeAt(1))){let R=2,L=R;for(;R<i&&!t(s.charCodeAt(R));)R++;if(R<i&&R!==L){const F=s.slice(L,R);for(L=R;R<i&&t(s.charCodeAt(R));)R++;if(R<i&&R!==L){for(L=R;R<i&&!t(s.charCodeAt(R));)R++;(R===i||R!==L)&&(l=`\\\\${F}\\${s.slice(L,R)}`,r=R)}}}else r=1;else m(b)&&s.charCodeAt(1)===E&&(l=s.slice(0,2),r=2,i>2&&t(s.charCodeAt(2))&&(h=!0,r=3));if(l.length>0)if(d.length>0){if(l.toLowerCase()!==d.toLowerCase())continue}else d=l;if(o){if(d.length>0)break}else if(c=`${s.slice(r)}\\${c}`,o=h,h&&d.length>0)break}return c=p(c,!o,"\\",t),o?`${d}\\${c}`:`${d}${c}`||"."},normalize(a){y(a,"path");const d=a.length;if(d===0)return".";let c=0,o,u=!1;const s=a.charCodeAt(0);if(d===1)return f(s)?"\\":a;if(t(s))if(u=!0,t(a.charCodeAt(1))){let r=2,l=r;for(;r<d&&!t(a.charCodeAt(r));)r++;if(r<d&&r!==l){const h=a.slice(l,r);for(l=r;r<d&&t(a.charCodeAt(r));)r++;if(r<d&&r!==l){for(l=r;r<d&&!t(a.charCodeAt(r));)r++;if(r===d)return`\\\\${h}\\${a.slice(l)}\\`;r!==l&&(o=`\\\\${h}\\${a.slice(l,r)}`,c=r)}}}else c=1;else m(s)&&a.charCodeAt(1)===E&&(o=a.slice(0,2),c=2,d>2&&t(a.charCodeAt(2))&&(u=!0,c=3));let i=c<d?p(a.slice(c),!u,"\\",t):"";return i.length===0&&!u&&(i="."),i.length>0&&t(a.charCodeAt(d-1))&&(i+="\\"),o===void 0?u?`\\${i}`:i:u?`${o}\\${i}`:`${o}${i}`},isAbsolute(a){y(a,"path");const d=a.length;if(d===0)return!1;const c=a.charCodeAt(0);return t(c)||d>2&&m(c)&&a.charCodeAt(1)===E&&t(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let d,c;for(let s=0;s<a.length;++s){const i=a[s];y(i,"path"),i.length>0&&(d===void 0?d=c=i:d+=`\\${i}`)}if(d===void 0)return".";let o=!0,u=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++u;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++u,s>2&&(t(c.charCodeAt(2))?++u:o=!1))}if(o){for(;u<d.length&&t(d.charCodeAt(u));)u++;u>=2&&(d=`\\${d.slice(u)}`)}return e.win32.normalize(d)},relative(a,d){if(y(a,"from"),y(d,"to"),a===d)return"";const c=e.win32.resolve(a),o=e.win32.resolve(d);if(c===o||(a=c.toLowerCase(),d=o.toLowerCase(),a===d))return"";let u=0;for(;u<a.length&&a.charCodeAt(u)===w;)u++;let s=a.length;for(;s-1>u&&a.charCodeAt(s-1)===w;)s--;const i=s-u;let r=0;for(;r<d.length&&d.charCodeAt(r)===w;)r++;let l=d.length;for(;l-1>r&&d.charCodeAt(l-1)===w;)l--;const h=l-r,b=i<h?i:h;let R=-1,L=0;for(;L<b;L++){const z=a.charCodeAt(u+L);if(z!==d.charCodeAt(r+L))break;z===w&&(R=L)}if(L!==b){if(R===-1)return o}else{if(h>b){if(d.charCodeAt(r+L)===w)return o.slice(r+L+1);if(L===2)return o.slice(r+L)}i>b&&(a.charCodeAt(u+L)===w?R=L:L===2&&(R=3)),R===-1&&(R=0)}let F="";for(L=u+R+1;L<=s;++L)(L===s||a.charCodeAt(L)===w)&&(F+=F.length===0?"..":"\\..");return r+=R,F.length>0?`${F}${o.slice(r,l)}`:(o.charCodeAt(r)===w&&++r,o.slice(r,l))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const d=e.win32.resolve(a);if(d.length<=2)return a;if(d.charCodeAt(0)===w){if(d.charCodeAt(1)===w){const c=d.charCodeAt(2);if(c!==P&&c!==I)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(m(d.charCodeAt(0))&&d.charCodeAt(1)===E&&d.charCodeAt(2)===w)return`\\\\?\\${d}`;return a},dirname(a){y(a,"path");const d=a.length;if(d===0)return".";let c=-1,o=0;const u=a.charCodeAt(0);if(d===1)return t(u)?a:".";if(t(u)){if(c=o=1,t(a.charCodeAt(1))){let r=2,l=r;for(;r<d&&!t(a.charCodeAt(r));)r++;if(r<d&&r!==l){for(l=r;r<d&&t(a.charCodeAt(r));)r++;if(r<d&&r!==l){for(l=r;r<d&&!t(a.charCodeAt(r));)r++;if(r===d)return a;r!==l&&(c=o=r+1)}}}}else m(u)&&a.charCodeAt(1)===E&&(c=d>2&&t(a.charCodeAt(2))?3:2,o=c);let s=-1,i=!0;for(let r=d-1;r>=o;--r)if(t(a.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(c===-1)return".";s=c}return a.slice(0,s)},basename(a,d){d!==void 0&&y(d,"ext"),y(a,"path");let c=0,o=-1,u=!0,s;if(a.length>=2&&m(a.charCodeAt(0))&&a.charCodeAt(1)===E&&(c=2),d!==void 0&&d.length>0&&d.length<=a.length){if(d===a)return"";let i=d.length-1,r=-1;for(s=a.length-1;s>=c;--s){const l=a.charCodeAt(s);if(t(l)){if(!u){c=s+1;break}}else r===-1&&(u=!1,r=s+1),i>=0&&(l===d.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=a.length),a.slice(c,o)}for(s=a.length-1;s>=c;--s)if(t(a.charCodeAt(s))){if(!u){c=s+1;break}}else o===-1&&(u=!1,o=s+1);return o===-1?"":a.slice(c,o)},extname(a){y(a,"path");let d=0,c=-1,o=0,u=-1,s=!0,i=0;a.length>=2&&a.charCodeAt(1)===E&&m(a.charCodeAt(0))&&(d=o=2);for(let r=a.length-1;r>=d;--r){const l=a.charCodeAt(r);if(t(l)){if(!s){o=r+1;break}continue}u===-1&&(s=!1,u=r+1),l===I?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||u===-1||i===0||i===1&&c===u-1&&c===o+1?"":a.slice(c,u)},format:M.bind(null,"\\"),parse(a){y(a,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return d;const c=a.length;let o=0,u=a.charCodeAt(0);if(c===1)return t(u)?(d.root=d.dir=a,d):(d.base=d.name=a,d);if(t(u)){if(o=1,t(a.charCodeAt(1))){let R=2,L=R;for(;R<c&&!t(a.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&t(a.charCodeAt(R));)R++;if(R<c&&R!==L){for(L=R;R<c&&!t(a.charCodeAt(R));)R++;R===c?o=R:R!==L&&(o=R+1)}}}}else if(m(u)&&a.charCodeAt(1)===E){if(c<=2)return d.root=d.dir=a,d;if(o=2,t(a.charCodeAt(2))){if(c===3)return d.root=d.dir=a,d;o=3}}o>0&&(d.root=a.slice(0,o));let s=-1,i=o,r=-1,l=!0,h=a.length-1,b=0;for(;h>=o;--h){if(u=a.charCodeAt(h),t(u)){if(!l){i=h+1;break}continue}r===-1&&(l=!1,r=h+1),u===I?s===-1?s=h:b!==1&&(b=1):s!==-1&&(b=-1)}return r!==-1&&(s===-1||b===0||b===1&&s===r-1&&s===i+1?d.base=d.name=a.slice(i,r):(d.name=a.slice(i,s),d.base=a.slice(i,r),d.ext=a.slice(s,r))),i>0&&i!==o?d.dir=a.slice(0,i-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let d="",c=!1;for(let o=a.length-1;o>=-1&&!c;o--){const u=o>=0?a[o]:v.cwd();y(u,"path"),u.length!==0&&(d=`${u}/${d}`,c=u.charCodeAt(0)===g)}return d=p(d,!c,"/",f),c?`/${d}`:d.length>0?d:"."},normalize(a){if(y(a,"path"),a.length===0)return".";const d=a.charCodeAt(0)===g,c=a.charCodeAt(a.length-1)===g;return a=p(a,!d,"/",f),a.length===0?d?"/":c?"./":".":(c&&(a+="/"),d?`/${a}`:a)},isAbsolute(a){return y(a,"path"),a.length>0&&a.charCodeAt(0)===g},join(...a){if(a.length===0)return".";let d;for(let c=0;c<a.length;++c){const o=a[c];y(o,"path"),o.length>0&&(d===void 0?d=o:d+=`/${o}`)}return d===void 0?".":e.posix.normalize(d)},relative(a,d){if(y(a,"from"),y(d,"to"),a===d||(a=e.posix.resolve(a),d=e.posix.resolve(d),a===d))return"";const c=1,o=a.length,u=o-c,s=1,i=d.length-s,r=u<i?u:i;let l=-1,h=0;for(;h<r;h++){const R=a.charCodeAt(c+h);if(R!==d.charCodeAt(s+h))break;R===g&&(l=h)}if(h===r)if(i>r){if(d.charCodeAt(s+h)===g)return d.slice(s+h+1);if(h===0)return d.slice(s+h)}else u>r&&(a.charCodeAt(c+h)===g?l=h:h===0&&(l=0));let b="";for(h=c+l+1;h<=o;++h)(h===o||a.charCodeAt(h)===g)&&(b+=b.length===0?"..":"/..");return`${b}${d.slice(s+l)}`},toNamespacedPath(a){return a},dirname(a){if(y(a,"path"),a.length===0)return".";const d=a.charCodeAt(0)===g;let c=-1,o=!0;for(let u=a.length-1;u>=1;--u)if(a.charCodeAt(u)===g){if(!o){c=u;break}}else o=!1;return c===-1?d?"/":".":d&&c===1?"//":a.slice(0,c)},basename(a,d){d!==void 0&&y(d,"ext"),y(a,"path");let c=0,o=-1,u=!0,s;if(d!==void 0&&d.length>0&&d.length<=a.length){if(d===a)return"";let i=d.length-1,r=-1;for(s=a.length-1;s>=0;--s){const l=a.charCodeAt(s);if(l===g){if(!u){c=s+1;break}}else r===-1&&(u=!1,r=s+1),i>=0&&(l===d.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return c===o?o=r:o===-1&&(o=a.length),a.slice(c,o)}for(s=a.length-1;s>=0;--s)if(a.charCodeAt(s)===g){if(!u){c=s+1;break}}else o===-1&&(u=!1,o=s+1);return o===-1?"":a.slice(c,o)},extname(a){y(a,"path");let d=-1,c=0,o=-1,u=!0,s=0;for(let i=a.length-1;i>=0;--i){const r=a.charCodeAt(i);if(r===g){if(!u){c=i+1;break}continue}o===-1&&(u=!1,o=i+1),r===I?d===-1?d=i:s!==1&&(s=1):d!==-1&&(s=-1)}return d===-1||o===-1||s===0||s===1&&d===o-1&&d===c+1?"":a.slice(d,o)},format:M.bind(null,"/"),parse(a){y(a,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return d;const c=a.charCodeAt(0)===g;let o;c?(d.root="/",o=1):o=0;let u=-1,s=0,i=-1,r=!0,l=a.length-1,h=0;for(;l>=o;--l){const b=a.charCodeAt(l);if(b===g){if(!r){s=l+1;break}continue}i===-1&&(r=!1,i=l+1),b===I?u===-1?u=l:h!==1&&(h=1):u!==-1&&(h=-1)}if(i!==-1){const b=s===0&&c?1:s;u===-1||h===0||h===1&&u===i-1&&u===s+1?d.base=d.name=a.slice(b,i):(d.name=a.slice(b,u),d.base=a.slice(b,i),d.ext=a.slice(u,i))}return s>0?d.dir=a.slice(0,s-1):c&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[82],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var n;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...k){const I=k.reduce((E,P)=>(E[P]=!0,E),{}),g=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(E=>!I[E]).forEach(E=>{for(let P=0;P<g.length;P++)if(E.search(g[P])!==-1){delete C[E];break}})}e.sanitizeProcessEnvironment=D}),define(ee[83],te([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(k){this._highResolution=n&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ee[4],te([0,1,15,42,2,110,83]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(d){d.None=()=>D.Disposable.None;function c(j){return(N,B=null,Y)=>{let V=!1,W;return W=j($=>{if(!V)return W?W.dispose():V=!0,N.call(B,$)},null,Y),V&&W.dispose(),W}}d.once=c;function o(j,N){return h((B,Y=null,V)=>j(W=>B.call(Y,N(W)),null,V))}d.map=o;function u(j,N){return h((B,Y=null,V)=>j(W=>{N(W),B.call(Y,W)},null,V))}d.forEach=u;function s(j,N){return h((B,Y=null,V)=>j(W=>N(W)&&B.call(Y,W),null,V))}d.filter=s;function i(j){return j}d.signal=i;function r(...j){return(N,B=null,Y)=>(0,D.combinedDisposable)(...j.map(V=>V(W=>N.call(B,W),null,Y)))}d.any=r;function l(j,N,B){let Y=B;return o(j,V=>(Y=N(Y,V),Y))}d.reduce=l;function h(j){let N;const B=new S({onFirstListenerAdd(){N=j(B.fire,B)},onLastListenerRemove(){N.dispose()}});return B.event}function b(j,N,B,Y=100,V=!1){let W,$,A=0;return j(T=>{A++,W=B(W,T),V&&!$&&(N(W),W=void 0),clearTimeout($),$=setTimeout(()=>{const _=W;W=void 0,$=void 0,(!V||A>1)&&N(_),A=0},Y)})}d.debouncedListener=b;function R(j,N,B=100,Y=!1,V){let W,$,A,T=0;const _=new S({leakWarningThreshold:V,onFirstListenerAdd(){W=j(O=>{T++,$=N($,O),Y&&!A&&(_.fire($),$=void 0),clearTimeout(A),A=setTimeout(()=>{const U=$;$=void 0,A=void 0,(!Y||T>1)&&_.fire(U),T=0},B)})},onLastListenerRemove(){W.dispose()}});return _.event}d.debounce=R;function L(j,N=(B,Y)=>B===Y){let B=!0,Y;return s(j,V=>{const W=B||!N(V,Y);return B=!1,Y=V,W})}d.latch=L;function F(j,N){return[d.filter(j,N),d.filter(j,B=>!N(B))]}d.split=F;function z(j,N=!1,B=[]){let Y=B.slice(),V=j(A=>{Y?Y.push(A):$.fire(A)});const W=()=>{Y&&Y.forEach(A=>$.fire(A)),Y=null},$=new S({onFirstListenerAdd(){V||(V=j(A=>$.fire(A)))},onFirstListenerDidAdd(){Y&&(N?setTimeout(W):W())},onLastListenerRemove(){V&&V.dispose(),V=null}});return $.event}d.buffer=z;class Q{constructor(N){this.event=N}map(N){return new Q(o(this.event,N))}forEach(N){return new Q(u(this.event,N))}filter(N){return new Q(s(this.event,N))}reduce(N,B){return new Q(l(this.event,N,B))}latch(){return new Q(L(this.event))}debounce(N,B=100,Y=!1,V){return new Q(R(this.event,N,B,Y,V))}on(N,B,Y){return this.event(N,B,Y)}once(N,B,Y){return c(this.event)(N,B,Y)}}function oe(j){return new Q(j)}d.chain=oe;function re(j,N,B=Y=>Y){const Y=(...A)=>$.fire(B(...A)),V=()=>j.on(N,Y),W=()=>j.removeListener(N,Y),$=new S({onFirstListenerAdd:V,onLastListenerRemove:W});return $.event}d.fromNodeEventEmitter=re;function q(j,N,B=Y=>Y){const Y=(...A)=>$.fire(B(...A)),V=()=>j.addEventListener(N,Y),W=()=>j.removeEventListener(N,Y),$=new S({onFirstListenerAdd:V,onLastListenerRemove:W});return $.event}d.fromDOMEventEmitter=q;function x(j){return new Promise(N=>c(j)(N))}d.toPromise=x;function H(j,N){return N(void 0),j(B=>N(B))}d.runAndSubscribe=H;function G(j,N){let B=null;function Y(W){B?.dispose(),B=new D.DisposableStore,N(W,B)}Y(void 0);const V=j(W=>Y(W));return(0,D.toDisposable)(()=>{V.dispose(),B?.dispose()})}d.runAndSubscribeWithStore=G})(I=e.Event||(e.Event={}));class g{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${g._idPool++}`}start(c){this._stopWatch=new k.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let w=-1;function E(d){const c=w;return w=d,{dispose(){w=c}}}e.setGlobalLeakWarningThreshold=E;class P{constructor(c,o=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let o=w;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||c<o)return;this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(u)||0;if(this._stacks.set(u,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,r=0;for(const[l,h]of this._stacks)(!i||r<h)&&(i=l,r=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(u)||0;this._stacks.set(u,i-1)}}}class S{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=w>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0}get event(){return this._event||(this._event=(c,o,u)=>{this._listeners||(this._listeners=new C.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[c,o]:c);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,o);const r=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof D.DisposableStore?u.add(l):Array.isArray(u)&&u.push(l),l}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,u]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,u):o[0].call(o[1],u)}catch(s){(0,v.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=S;class y extends S{async fireAsync(c,o,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,c]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[s,i]=this._asyncDeliveryQueue.shift(),r=[],l={...i,token:o,waitUntil:h=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");u&&(h=u(h,typeof s=="function"?s:s[0])),r.push(h)}};try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(h){(0,v.onUnexpectedError)(h);continue}Object.freeze(r),await Promise.allSettled(r).then(h=>{for(const b of h)b.status==="rejected"&&(0,v.onUnexpectedError)(b.reason)})}}}}e.AsyncEmitter=y;class t extends S{constructor(c){super(c);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=t;class f extends t{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=f;class m extends S{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=m;class p{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const o={event:c,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const u=()=>{this.hasListeners&&this.unhook(o);const s=this.events.indexOf(o);this.events.splice(s,1)};return(0,D.toDisposable)((0,n.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(o=>this.emitter.fire(o))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=p;class M{constructor(){this.buffers=[]}wrapEvent(c){return(o,u,s)=>c(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>o.call(u,i)):o.call(u,i)},void 0,s)}bufferEvents(c){const o=[];this.buffers.push(o);const u=c();return this.buffers.pop(),o.forEach(s=>s()),u}}e.EventBufferer=M;class a{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new S({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(ee[21],te([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(I,g){const w=setTimeout(I.bind(g),0);return{dispose(){clearTimeout(w)}}});var D;(function(I){function g(w){return w===I.None||w===I.Cancelled||w instanceof C?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}I.isCancellationToken=g,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(ee[111],te([0,1,21]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new v.CancellationTokenSource,I=this.task(k.token);return this.result={promise:I,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=n;class D{constructor(k){this.computeFn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const I=JSON.stringify(k);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.computeFn(k)),this.lastCache}}e.LRUCachedComputed=D}),define(ee[51],te([0,1,15,2]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(a){const d=a;return d?[d.on,d.pause,d.resume,d.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function C(a){const d=a;return d?D(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(a,d){return new I(a,d)}e.newWriteableStream=k;class I{constructor(d,c){this.reducer=d,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(c=>c(d))}emitError(d){this.listeners.error.length===0?(0,v.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(c=>c(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,c){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(d,c){if(this.state.destroyed)return;let o;switch(d){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const u=o.indexOf(c);u>=0&&o.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(a,d){const c=[];let o;for(;(o=a.read())!==null;)c.push(o);return d(c)}e.consumeReadable=g;function w(a,d,c){const o=[];let u;for(;(u=a.read())!==null&&o.length<c;)o.push(u);return u===null&&o.length>0?d(o):{read:()=>{if(o.length>0)return o.shift();if(typeof u!="undefined"){const s=u;return u=void 0,s}return a.read()}}}e.peekReadable=w;function E(a,d){return new Promise((c,o)=>{const u=[];P(a,{onData:s=>{d&&u.push(s)},onError:s=>{d?o(s):c(void 0)},onEnd:()=>{c(d?d(u):void 0)}})})}e.consumeStream=E;function P(a,d){let c=!1;return a.on("error",o=>{c||d.onError(o)}),a.on("end",()=>{c||d.onEnd()}),a.on("data",o=>{c||d.onData(o)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=P;function S(a,d){return new Promise((c,o)=>{const u=new n.DisposableStore,s=[],i=h=>{if(s.push(h),s.length>d)return u.dispose(),a.pause(),c({stream:a,buffer:s,ended:!1})},r=h=>o(h),l=()=>c({stream:a,buffer:s,ended:!0});u.add((0,n.toDisposable)(()=>a.removeListener("error",r))),a.on("error",r),u.add((0,n.toDisposable)(()=>a.removeListener("end",l))),a.on("end",l),u.add((0,n.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=S;function y(a,d){const c=k(d);return c.end(a),c}e.toStream=y;function t(){const a=k(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=t;function f(a){let d=!1;return{read:()=>d?null:(d=!0,a)}}e.toReadable=f;function m(a,d,c){const o=k(c);return P(a,{onData:u=>o.write(d.data(u)),onError:u=>o.error(d.error?d.error(u):u),onEnd:()=>o.end()}),o}e.transform=m;function p(a,d,c){let o=!1;return{read:()=>{const u=d.read();return o?u:(o=!0,u!==null?c([a,u]):a)}}}e.prefixedReadable=p;function M(a,d,c){let o=!1;const u=k(c);return P(d,{onData:s=>o?u.write(s):(o=!0,u.write(c([a,s]))),onError:s=>u.error(s),onEnd:()=>{o||(o=!0,u.write(a)),u.end()}}),u}e.prefixedStream=M}),define(ee[17],te([0,1,51]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let D,C;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return n?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return n&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,R){return!(R?.dontUseNodeBuffer||!1)&&n?new k(Buffer.from(b)):(D||(D=new TextEncoder),new k(D.encode(b)))}static fromByteArray(b){const R=k.alloc(b.length);for(let L=0,F=b.length;L<F;L++)R.buffer[L]=b[L];return R}static concat(b,R){if(typeof R=="undefined"){R=0;for(let z=0,Q=b.length;z<Q;z++)R+=b[z].byteLength}const L=k.alloc(R);let F=0;for(let z=0,Q=b.length;z<Q;z++){const oe=b[z];L.set(oe,F),F+=oe.byteLength}return L}clone(){const b=k.alloc(this.byteLength);return b.set(this),b}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(b,R){return new k(this.buffer.subarray(b,R))}set(b,R){if(b instanceof k)this.buffer.set(b.buffer,R);else if(b instanceof Uint8Array)this.buffer.set(b,R);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),R);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),R);else throw new Error("Unkown argument 'array'")}readUInt32BE(b){return w(this.buffer,b)}writeUInt32BE(b,R){E(this.buffer,b,R)}readUInt32LE(b){return P(this.buffer,b)}writeUInt32LE(b,R){S(this.buffer,b,R)}readUInt8(b){return y(this.buffer,b)}writeUInt8(b,R){t(this.buffer,b,R)}}e.VSBuffer=k;function I(h,b){return h[b+0]<<0>>>0|h[b+1]<<8>>>0}e.readUInt16LE=I;function g(h,b,R){h[R+0]=b&255,b=b>>>8,h[R+1]=b&255}e.writeUInt16LE=g;function w(h,b){return h[b]*2**24+h[b+1]*2**16+h[b+2]*2**8+h[b+3]}e.readUInt32BE=w;function E(h,b,R){h[R+3]=b,b=b>>>8,h[R+2]=b,b=b>>>8,h[R+1]=b,b=b>>>8,h[R]=b}e.writeUInt32BE=E;function P(h,b){return h[b+0]<<0>>>0|h[b+1]<<8>>>0|h[b+2]<<16>>>0|h[b+3]<<24>>>0}e.readUInt32LE=P;function S(h,b,R){h[R+0]=b&255,b=b>>>8,h[R+1]=b&255,b=b>>>8,h[R+2]=b&255,b=b>>>8,h[R+3]=b&255}e.writeUInt32LE=S;function y(h,b){return h[b]}e.readUInt8=y;function t(h,b,R){h[R]=b}e.writeUInt8=t;function f(h){return v.consumeReadable(h,b=>k.concat(b))}e.readableToBuffer=f;function m(h){return v.toReadable(h)}e.bufferToReadable=m;function p(h){return v.consumeStream(h,b=>k.concat(b))}e.streamToBuffer=p;async function M(h){return h.ended?k.concat(h.buffer):k.concat([...h.buffer,await p(h.stream)])}e.bufferedStreamToBuffer=M;function a(h){return v.toStream(h,b=>k.concat(b))}e.bufferToStream=a;function d(h){return v.transform(h,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=d;function c(h){return v.newWriteableStream(b=>k.concat(b),h)}e.newWriteableBufferStream=c;function o(h,b){return v.prefixedReadable(h,b,R=>k.concat(R))}e.prefixedBufferReadable=o;function u(h,b){return v.prefixedStream(h,b,R=>k.concat(R))}e.prefixedBufferStream=u;function s(h){let b=0,R=0,L=0;const F=new Uint8Array(Math.floor(h.length/4*3)),z=oe=>{switch(R){case 3:F[L++]=b|oe,R=0;break;case 2:F[L++]=b|oe>>>2,b=oe<<6,R=3;break;case 1:F[L++]=b|oe>>>4,b=oe<<4,R=2;break;default:b=oe<<2,R=1}};for(let oe=0;oe<h.length;oe++){const re=h.charCodeAt(oe);if(re>=65&&re<=90)z(re-65);else if(re>=97&&re<=122)z(re-97+26);else if(re>=48&&re<=57)z(re-48+52);else if(re===43||re===45)z(62);else if(re===47||re===95)z(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${h[oe]}`)}}const Q=L;for(;R>0;)z(0);return k.wrap(F).slice(0,Q)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:h},b=!0,R=!1){const L=R?r:i;let F="";const z=h.byteLength%3;let Q=0;for(;Q<h.byteLength-z;Q+=3){const oe=h[Q+0],re=h[Q+1],q=h[Q+2];F+=L[oe>>>2],F+=L[(oe<<4|re>>>4)&63],F+=L[(re<<2|q>>>6)&63],F+=L[q&63]}if(z===1){const oe=h[Q+0];F+=L[oe>>>2],F+=L[oe<<4&63],b&&(F+="==")}else if(z===2){const oe=h[Q+0],re=h[Q+1];F+=L[oe>>>2],F+=L[(oe<<4|re>>>4)&63],F+=L[re<<2&63],b&&(F+="=")}return F}e.encodeBase64=l}),define(ee[25],te([0,1,111,109]),function(K,e,v,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=C;const k=/{(\d+)}/g;function I(X,...ae){return ae.length===0?X:X.replace(k,function(ue,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=ae.length?ue:ae[Ie]})}e.format=I;const g=/{([^}]+)}/g;function w(X,ae){return X.replace(g,(ue,ve)=>ae[ve]??ue)}e.format2=w;function E(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=E;function P(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function S(X,ae){let ue=0;const ve=ae.charCodeAt(0);for(let Ie=X.length-1;Ie>=0;Ie--)X.charCodeAt(Ie)===ve&&ue++;return ue}e.count=S;function y(X,ae,ue="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${ue}`}e.truncate=y;function t(X,ae=" "){const ue=f(X,ae);return m(ue,ae)}e.trim=t;function f(X,ae){if(!X||!ae)return X;const ue=ae.length;if(ue===0||X.length===0)return X;let ve=0;for(;X.indexOf(ae,ve)===ve;)ve=ve+ue;return X.substring(ve)}e.ltrim=f;function m(X,ae){if(!X||!ae)return X;const ue=ae.length,ve=X.length;if(ue===0||ve===0)return X;let Ie=ve,Le=-1;for(;Le=X.lastIndexOf(ae,Ie-1),!(Le===-1||Le+ue!==Ie);){if(Le===0)return"";Ie=Le}return X.substring(0,Ie)}e.rtrim=m;function p(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function M(X){return X.replace(/\*/g,"")}e.stripWildcards=M;function a(X,ae,ue={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=P(X)),ue.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let ve="";return ue.global&&(ve+="g"),ue.matchCase||(ve+="i"),ue.multiline&&(ve+="m"),ue.unicode&&(ve+="u"),new RegExp(X,ve)}e.createRegExp=a;function d(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function c(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=o;function u(X){return X.split(/\r\n|\r|\n/)}e.splitLines=u;function s(X){for(let ae=0,ue=X.length;ae<ue;ae++){const ve=X.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=s;function i(X,ae=0,ue=X.length){for(let ve=ae;ve<ue;ve++){const Ie=X.charCodeAt(ve);if(Ie!==32&&Ie!==9)return X.substring(ae,ve)}return X.substring(ae,ue)}e.getLeadingWhitespace=i;function r(X,ae=X.length-1){for(let ue=ae;ue>=0;ue--){const ve=X.charCodeAt(ue);if(ve!==32&&ve!==9)return ue}return-1}e.lastNonWhitespaceIndex=r;function l(X,ae){return X<ae?-1:X>ae?1:0}e.compare=l;function h(X,ae,ue=0,ve=X.length,Ie=0,Le=ae.length){for(;ue<ve&&Ie<Le;ue++,Ie++){let Ve=X.charCodeAt(ue),Ae=ae.charCodeAt(Ie);if(Ve<Ae)return-1;if(Ve>Ae)return 1}const We=ve-ue,Ke=Le-Ie;return We<Ke?-1:We>Ke?1:0}e.compareSubstring=h;function b(X,ae){return R(X,ae,0,X.length,0,ae.length)}e.compareIgnoreCase=b;function R(X,ae,ue=0,ve=X.length,Ie=0,Le=ae.length){for(;ue<ve&&Ie<Le;ue++,Ie++){let Ve=X.charCodeAt(ue),Ae=ae.charCodeAt(Ie);if(Ve===Ae)continue;if(Ve>=128||Ae>=128)return h(X.toLowerCase(),ae.toLowerCase(),ue,ve,Ie,Le);L(Ve)&&(Ve-=32),L(Ae)&&(Ae-=32);const Be=Ve-Ae;if(Be!==0)return Be}const We=ve-ue,Ke=Le-Ie;return We<Ke?-1:We>Ke?1:0}e.compareSubstringIgnoreCase=R;function L(X){return X>=97&&X<=122}e.isLowerAsciiLetter=L;function F(X){return X>=65&&X<=90}e.isUpperAsciiLetter=F;function z(X,ae){return X.length===ae.length&&R(X,ae)===0}e.equalsIgnoreCase=z;function Q(X,ae){const ue=ae.length;return ae.length>X.length?!1:R(X,ae,0,ue)===0}e.startsWithIgnoreCase=Q;function oe(X,ae){let ue,ve=Math.min(X.length,ae.length);for(ue=0;ue<ve;ue++)if(X.charCodeAt(ue)!==ae.charCodeAt(ue))return ue;return ve}e.commonPrefixLength=oe;function re(X,ae){let ue,ve=Math.min(X.length,ae.length);const Ie=X.length-1,Le=ae.length-1;for(ue=0;ue<ve;ue++)if(X.charCodeAt(Ie-ue)!==ae.charCodeAt(Le-ue))return ue;return ve}e.commonSuffixLength=re;function q(X){return 55296<=X&&X<=56319}e.isHighSurrogate=q;function x(X){return 56320<=X&&X<=57343}e.isLowSurrogate=x;function H(X,ae){return(X-55296<<10)+(ae-56320)+65536}e.computeCodePoint=H;function G(X,ae,ue){const ve=X.charCodeAt(ue);if(q(ve)&&ue+1<ae){const Ie=X.charCodeAt(ue+1);if(x(Ie))return H(ve,Ie)}return ve}e.getNextCodePoint=G;function j(X,ae){const ue=X.charCodeAt(ae-1);if(x(ue)&&ae>1){const ve=X.charCodeAt(ae-2);if(q(ve))return H(ve,ue)}return ue}class N{constructor(ae,ue=0){this._str=ae,this._len=ae.length,this._offset=ue}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=j(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=G(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=N;class B{constructor(ae,ue=0){this._iterator=new N(ae,ue)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=$e.getInstance(),ue=this._iterator,ve=ue.offset;let Ie=ae.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Le=ue.offset,We=ae.getGraphemeBreakType(ue.nextCodePoint());if(Re(Ie,We)){ue.setOffset(Le);break}Ie=We}return ue.offset-ve}prevGraphemeLength(){const ae=$e.getInstance(),ue=this._iterator,ve=ue.offset;let Ie=ae.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Le=ue.offset,We=ae.getGraphemeBreakType(ue.prevCodePoint());if(Re(We,Ie)){ue.setOffset(Le);break}Ie=We}return ve-ue.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=B;function Y(X,ae){return new B(X,ae).nextGraphemeLength()}e.nextCharLength=Y;function V(X,ae){return new B(X,ae).prevGraphemeLength()}e.prevCharLength=V;function W(X,ae){ae>0&&x(X.charCodeAt(ae))&&ae--;const ue=ae+Y(X,ae);return[ue-V(X,ue),ue]}e.getCharContainingOffset=W;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(X){return $.test(X)}e.containsRTL=A;const T=/^[\t\n\r\x20-\x7E]*$/;function _(X){return T.test(X)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=O;function U(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=U;function J(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=J;function ie(X,ae){if(X.length<ae)return X;const ue=/\b/g;let ve=0;for(;ue.test(X)&&!(X.length-ue.lastIndex<ae);)ve=ue.lastIndex,ue.lastIndex+=1;return X.substring(ve).replace(/^\s/,"")}e.lcut=ie;const se=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(X){return X&&(X=X.replace(se,""),X=X.replace(Z,""),X=X.replace(ce,"")),X}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function ge(X){return he(X)?X.substr(1):X}e.stripUTF8BOM=ge;function ye(X,ae){if(!X||!ae||X.length<ae.length)return!1;const ue=ae.length,ve=X.toLowerCase();let Ie=0,Le=-1;for(;Ie<ue;){const We=ve.indexOf(ae[Ie],Le+1);if(We<0)return!1;Le=We,Ie++}return!0}e.fuzzyContains=ye;function fe(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=fe;function me(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=me;function be(X,ae=1){if(ae===0)return"";let ue=-1;do ue=X.indexOf(`
`,ue+1),ae--;while(ae>0&&ue>=0);return ue===-1?X:(X[ue-1]==="\r"&&ue--,X.substr(0,ue))}e.getNLines=be;function Pe(X){const ae=90-65+1;return X=X%(2*ae),X<ae?String.fromCharCode(97+X):String.fromCharCode(65+X-ae)}e.singleLetterHash=Pe;function Ce(X){return $e.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ce;function Re(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var _e;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(_e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Qe()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ue=this._data,ve=ue.length/3;let Ie=1;for(;Ie<=ve;)if(ae<ue[3*Ie])Ie=2*Ie;else if(ae>ue[3*Ie+1])Ie=2*Ie+1;else return ue[3*Ie+2];return 0}}$e._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(X,ae){if(X===0)return 0;const ue=mt(X,ae);if(ue!==void 0)return ue;const ve=new N(ae,X);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=Ye;function mt(X,ae){const ue=new N(ae,X);let ve=ue.prevCodePoint();for(;lt(ve)||ve===65039||ve===8419;){if(ue.offset===0)return;ve=ue.prevCodePoint()}if(!J(ve))return;let Ie=ue.offset;return Ie>0&&ue.prevCodePoint()===8205&&(Ie=ue.offset),Ie}function lt(X){return 127995<=X&&X<=127999}var rt;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class qe{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return qe.cache.get(Array.from(ae))}static getLocales(){return qe._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=qe,D=qe,qe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.cache=new v.LRUCachedComputed(X=>{function ae(Ae){const Be=new Map;for(let He=0;He<Ae.length;He+=2)Be.set(Ae[He],Ae[He+1]);return Be}function ue(Ae,Be){const He=new Map(Ae);for(const[Je,Ze]of Be)He.set(Je,Ze);return He}function ve(Ae,Be){if(!Ae)return Be;const He=new Map;for(const[Je,Ze]of Ae)Be.has(Je)&&He.set(Je,Ze);return He}const Ie=D.ambiguousCharacterData.getValue();let Le=X.filter(Ae=>!Ae.startsWith("_")&&Ae in Ie);Le.length===0&&(Le=["_default"]);let We;for(const Ae of Le){const Be=ae(Ie[Ae]);We=ve(We,Be)}const Ke=ae(Ie._common),Ve=ue(Ke,We);return new qe(Ve)}),qe._locales=new n.Lazy(()=>Object.keys(qe.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(ae){return je.getData().has(ae)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(ee[71],te([0,1,25]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(p){return D(p,0)}e.hash=n;function D(p,M){switch(typeof p){case"object":return p===null?C(349,M):Array.isArray(p)?g(p,M):w(p,M);case"string":return I(p,M);case"boolean":return k(p,M);case"number":return C(p,M);case"undefined":return C(937,M);default:return C(617,M)}}e.doHash=D;function C(p,M){return(M<<5)-M+p|0}e.numberHash=C;function k(p,M){return C(p?433:863,M)}function I(p,M){M=C(149417,M);for(let a=0,d=p.length;a<d;a++)M=C(p.charCodeAt(a),M);return M}e.stringHash=I;function g(p,M){return M=C(104579,M),p.reduce((a,d)=>D(d,a),M)}function w(p,M){return M=C(181387,M),Object.keys(p).sort().reduce((a,d)=>(a=I(d,a),D(p[d],a)),M)}class E{constructor(){this._value=0}get value(){return this._value}hash(M){return this._value=D(M,this._value),this._value}}e.Hasher=E;var P;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function S(p,M,a=32){const d=a-M,c=~((1<<d)-1);return(p<<M|(c&p)>>>d)>>>0}function y(p,M=0,a=p.byteLength,d=0){for(let c=0;c<a;c++)p[M+c]=d}function t(p,M,a="0"){for(;p.length<M;)p=a+p;return p}function f(p,M=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(a=>a.toString(16).padStart(2,"0")).join(""):t((p>>>0).toString(16),M/4)}e.toHexString=f;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(M){const a=M.length;if(a===0)return;const d=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,u,s;for(o!==0?(u=o,s=-1,o=0):(u=M.charCodeAt(0),s=0);;){let i=u;if(v.isHighSurrogate(u))if(s+1<a){const r=M.charCodeAt(s+1);v.isLowSurrogate(r)?(s++,i=v.computeCodePoint(u,r)):i=65533}else{o=u;break}else v.isLowSurrogate(u)&&(i=65533);if(c=this._push(d,c,i),s++,s<a)u=M.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(M,a,d){return d<128?M[a++]=d:d<2048?(M[a++]=192|(d&1984)>>>6,M[a++]=128|(d&63)>>>0):d<65536?(M[a++]=224|(d&61440)>>>12,M[a++]=128|(d&4032)>>>6,M[a++]=128|(d&63)>>>0):(M[a++]=240|(d&1835008)>>>18,M[a++]=128|(d&258048)>>>12,M[a++]=128|(d&4032)>>>6,M[a++]=128|(d&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,M[0]=M[64+0],M[1]=M[64+1],M[2]=M[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const M=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(M/4294967296),!1),this._buffDV.setUint32(60,M%4294967296,!1),this._step()}_step(){const M=m._bigBlock32,a=this._buffDV;for(let h=0;h<64;h+=4)M.setUint32(h,a.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)M.setUint32(h,S(M.getUint32(h-12,!1)^M.getUint32(h-32,!1)^M.getUint32(h-56,!1)^M.getUint32(h-64,!1),1),!1);let d=this._h0,c=this._h1,o=this._h2,u=this._h3,s=this._h4,i,r,l;for(let h=0;h<80;h++)h<20?(i=c&o|~c&u,r=1518500249):h<40?(i=c^o^u,r=1859775393):h<60?(i=c&o|c&u|o&u,r=2400959708):(i=c^o^u,r=3395469782),l=S(d,5)+i+s+r+M.getUint32(h*4,!1)&4294967295,s=u,u=o,o=S(c,30),c=d,d=l;this._h0=this._h0+d&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(K,e,v,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!D:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(K,v):D?D.value=v:e.set(K,v),v},Ge=this&&this.__classPrivateFieldGet||function(K,e,v,n){if(v==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!n:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?n:v==="a"?n.call(K):n?n.value:e.get(K)};define(ee[35],te([0,1,31,25]),function(K,e,v,n){"use strict";var D,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(s,i,r){let l=s.get(i);return l===void 0&&(l=r,s.set(i,l)),l}e.getOrSet=I;function g(s){const i=[];return s.forEach((r,l)=>{i.push(`${l} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=g;function w(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=w;class E{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),l=this._value.charCodeAt(this._pos);return r-l}value(){return this._value[this._pos]}}e.StringIterator=E;class P{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class S{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const l=this._value.charCodeAt(r);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var y;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(y||(y={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(m||(m={}));class p{constructor(i){this._iter=i}static forUris(i=()=>!1){return new p(new t(i))}static forPaths(i=!1){return new p(new S(void 0,!i))}static forStrings(){return new p(new E)}static forConfigKeys(){return new p(new P)}clear(){this._root=void 0}fill(i,r){if(r){const l=r.slice(0);(0,v.shuffle)(l);for(let h of l)this.set(h,i)}else{const l=i.slice(0);(0,v.shuffle)(l);for(let h of l)this.set(h[0],h[1])}}set(i,r){const l=this._iter.reset(i);let h;this._root||(this._root=new f,this._root.segment=l.value());const b=[];for(h=this._root;;){const L=l.cmp(h.segment);if(L>0)h.left||(h.left=new f,h.left.segment=l.value()),b.push([-1,h]),h=h.left;else if(L<0)h.right||(h.right=new f,h.right.segment=l.value()),b.push([1,h]),h=h.right;else if(l.hasNext())l.next(),h.mid||(h.mid=new f,h.mid.segment=l.value()),b.push([0,h]),h=h.mid;else break}const R=h.value;h.value=r,h.key=i;for(let L=b.length-1;L>=0;L--){const F=b[L][1];F.updateHeight();const z=F.balanceFactor();if(z<-1||z>1){const Q=b[L][0],oe=b[L+1][0];if(Q===1&&oe===1)b[L][1]=F.rotateLeft();else if(Q===-1&&oe===-1)b[L][1]=F.rotateRight();else if(Q===1&&oe===-1)F.right=b[L+1][1]=b[L+1][1].rotateRight(),b[L][1]=F.rotateLeft();else if(Q===-1&&oe===1)F.left=b[L+1][1]=b[L+1][1].rotateLeft(),b[L][1]=F.rotateRight();else throw new Error;if(L>0)switch(b[L-1][0]){case-1:b[L-1][1].left=b[L][1];break;case 1:b[L-1][1].right=b[L][1];break;case 0:b[L-1][1].mid=b[L][1];break}else this._root=b[0][1]}}return R}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let l=this._root;for(;l;){const h=r.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else break}return l}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const l=this._iter.reset(i),h=[];let b=this._root;for(;b;){const R=l.cmp(b.segment);if(R>0)h.push([-1,b]),b=b.left;else if(R<0)h.push([1,b]),b=b.right;else if(l.hasNext())l.next(),h.push([0,b]),b=b.mid;else break}if(!!b){if(r?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const R=this._min(b.right),{key:L,value:F,segment:z}=R;this._delete(R.key,!1),b.key=L,b.value=F,b.segment=z}else{const R=b.left??b.right;if(h.length>0){const[L,F]=h[h.length-1];switch(L){case-1:F.left=R;break;case 0:F.mid=R;break;case 1:F.right=R;break}}else this._root=R}for(let R=h.length-1;R>=0;R--){const L=h[R][1];L.updateHeight();const F=L.balanceFactor();if(F>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),h[R][1]=L.rotateLeft()):F<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),h[R][1]=L.rotateRight()),R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let l=this._root,h;for(;l;){const b=r.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(r.hasNext())r.next(),h=l.value||h,l=l.mid;else break}return l&&l.value||h}findSuperstr(i){const r=this._iter.reset(i);let l=this._root;for(;l;){const h=r.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(r.hasNext())r.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(i){for(const[r,l]of this)i(l,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const l=r.balanceFactor();return l<-1||l>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=p;class M{constructor(i,r){this.uri=i,this.value=r}}class a{constructor(i,r){this[D]="ResourceMap",i instanceof a?(this.map=new Map(i.map),this.toKey=r??a.defaultToKey):(this.map=new Map,this.toKey=i??a.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new M(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[l,h]of this.map)i(h.value,h.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=a,a.defaultToKey=s=>s.toString();var d;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class c{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const l=this._map.get(i);if(!!l)return r!==0&&this.touch(l,r),l.value}set(i,r,l=0){let h=this._map.get(i);if(h)h.value=r,l!==0&&this.touch(h,l);else{switch(h={key:i,value:r,next:void 0,previous:void 0},l){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const l=this._state;let h=this._head;for(;h;){if(r?i.bind(r)(h.value,h.key,this):i(h.value,h.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,r=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return h}values(){const i=this,r=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return h}entries(){const i=this,r=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return h}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,l=this.size;for(;r&&l>i;)this._map.delete(r.key),r=r.next,l--;this._head=r,this._size=l,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,l=i.previous;if(!r||!l)throw new Error("Invalid list");r.previous=l,l.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const l=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(l.previous=h,h.next=l),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const l=i.next,h=i.previous;i===this._head?(l.previous=void 0,this._head=l):(l.previous=h,h.next=l),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,l)=>{i.push([l,r])}),i}fromJSON(i){this.clear();for(const[r,l]of i)this.set(r,l)}}e.LinkedMap=c;class o extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class u{constructor(i){k.set(this,void 0),Pt(this,k,i,"f")}get size(){return Ge(this,k,"f").size}forEach(i,r){Ge(this,k,"f").forEach(i,r)}get(i){return Ge(this,k,"f").get(i)}has(i){return Ge(this,k,"f").has(i)}entries(){return Ge(this,k,"f").entries()}keys(){return Ge(this,k,"f").keys()}values(){return Ge(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ge(this,k,"f").entries()}}e.ReadonlyMapView=u}),define(ee[72],te([0,1,35]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new v.LRUCache(1e4);function D(w){return g(w,"NFC",n)}e.normalizeNFC=D;const C=new v.LRUCache(1e4);function k(w){return g(w,"NFD",C)}e.normalizeNFD=k;const I=/[^\u0000-\u0080]/;function g(w,E,P){if(!w)return w;const S=P.get(w);if(S)return S;let y;return I.test(w)?y=w.normalize(E):y=w,P.set(w,y),y}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(E){return k(E).replace(w,"")}}()}),define(ee[13],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(b){return Array.isArray(b)}e.isArray=v;function n(b){return typeof b=="string"}e.isString=n;function D(b){return Array.isArray(b)&&b.every(R=>n(R))}e.isStringArray=D;function C(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=C;function k(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=k;function I(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=I;function g(b){return b===!0||b===!1}e.isBoolean=g;function w(b){return typeof b=="undefined"}e.isUndefined=w;function E(b){return!P(b)}e.isDefined=E;function P(b){return w(b)||b===null}e.isUndefinedOrNull=P;function S(b,R){if(!b)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=S;function y(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=y;function t(...b){const R=[];for(let L=0;L<b.length;L++){const F=b[L];if(P(F))throw new Error(`Assertion Failed: argument at index ${L} is undefined or null`);R.push(F)}return R}e.assertAllDefined=t;const f=Object.prototype.hasOwnProperty;function m(b){if(!C(b))return!1;for(let R in b)if(f.call(b,R))return!1;return!0}e.isEmptyObject=m;function p(b){return typeof b=="function"}e.isFunction=p;function M(...b){return b.length>0&&b.every(p)}e.areFunctions=M;function a(b,R){const L=Math.min(b.length,R.length);for(let F=0;F<L;F++)d(b[F],R[F])}e.validateConstraints=a;function d(b,R){if(n(R)){if(typeof b!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(p(R)){try{if(b instanceof R)return}catch{}if(!P(b)&&b.constructor===R||R.length===1&&R.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function c(b){let R=[],L=Object.getPrototypeOf(b);for(;Object.prototype!==L;)R=R.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return R}e.getAllPropertyNames=c;function o(b){const R=[];for(const L of c(b))typeof b[L]=="function"&&R.push(L);return R}e.getAllMethodNames=o;function u(b,R){const L=z=>function(){const Q=Array.prototype.slice.call(arguments,0);return R(z,Q)};let F={};for(const z of b)F[z]=L(z);return F}e.createProxyObject=u;function s(b){return b===null?void 0:b}e.withNullAsUndefined=s;function i(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=i;function r(b){return class{constructor(){return new Proxy({},{get(R,L){if(R[L])return R[L];throw new Error(`Not Implemented: ${b}->${String(L)}`)}})}}}e.NotImplementedProxy=r;function l(b,R="Unreachable"){throw new Error(R)}e.assertNever=l;function h(b){return!!b&&typeof b.then=="function"&&typeof b.catch=="function"}e.isPromise=h}),define(ee[27],te([0,1,9,3,25,13]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function I(r){return r.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=I;function g(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=g;function w(r,l=v.posix.sep){if(!r)return"";const h=r.length,b=r.charCodeAt(0);if(k(b)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let L=3;const F=L;for(;L<h&&!k(r.charCodeAt(L));L++);if(F!==L&&!k(r.charCodeAt(L+1))){for(L+=1;L<h;L++)if(k(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,l)}}return l}else if(p(b)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let R=r.indexOf("://");if(R!==-1){for(R+=3;R<h;R++)if(k(r.charCodeAt(R)))return r.slice(0,R+1)}return""}e.getRoot=w;function E(r){if(!n.isWindows||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let h=2;const b=h;for(;h<r.length&&(l=r.charCodeAt(h),l!==92);h++);return!(b===h||(l=r.charCodeAt(h+1),isNaN(l)||l===92))}e.isUNC=E;const P=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,l=n.isWindows){const h=l?P:S;return!(!r||r.length===0||/^\s+$/.test(r)||(h.lastIndex=0,h.test(r))||l&&y.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function f(r,l,h){const b=r===l;return!h||b?b:!r||!l?!1:(0,D.equalsIgnoreCase)(r,l)}e.isEqual=f;function m(r,l,h,b=v.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(h){if(!(0,D.startsWithIgnoreCase)(r,l))return!1;if(l.length===r.length)return!0;let L=l.length;return l.charAt(l.length-1)===b&&L--,r.charAt(L)===b}return l.charAt(l.length-1)!==b&&(l+=b),r.indexOf(l)===0}e.isEqualOrParent=m;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function M(r,l){return n.isWindows&&r.endsWith(":")&&(r+=v.sep),(0,v.isAbsolute)(r)||(r=(0,v.join)(l,r)),r=(0,v.normalize)(r),n.isWindows?(r=(0,D.rtrim)(r,v.sep),r.endsWith(":")&&(r+=v.sep)):(r=(0,D.rtrim)(r,v.sep),r||(r=v.sep)),r}e.sanitizeFilePath=M;function a(r){const l=(0,v.normalize)(r);return n.isWindows?r.length>3?!1:d(l)&&(r.length===2||l.charCodeAt(2)===92):l===v.posix.sep}e.isRootOrDriveLetter=a;function d(r,l){return(l!==void 0?l:n.isWindows)?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function c(r){return d(r)?r[0]:void 0}e.getDriveLetter=c;function o(r,l,h){return l.length>r.length?-1:r===l?0:(h&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.indexOfPath=o;function u(r){const l=r.split(":");let h,b,R;for(const L of l){const F=Number(L);(0,C.isNumber)(F)?b===void 0?b=F:R===void 0&&(R=F):h=h?[h,L].join(":"):L}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:b!==void 0?b:void 0,column:R!==void 0?R:b!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,l,h=8){let b="";for(let L=0;L<h;L++)b+=s.charAt(Math.floor(Math.random()*s.length));let R;return l?R=`${l}-${b}`:R=b,r?(0,v.join)(r,R):R}e.randomPath=i}),define(ee[47],te([0,1,13]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const m=Array.isArray(f)?[]:{};return Object.keys(f).forEach(p=>{f[p]&&typeof f[p]=="object"?m[p]=n(f[p]):m[p]=f[p]}),m}e.deepClone=n;function D(f){if(!f||typeof f!="object")return f;const m=[f];for(;m.length>0;){const p=m.shift();Object.freeze(p);for(const M in p)if(C.call(p,M)){const a=p[M];typeof a=="object"&&!Object.isFrozen(a)&&m.push(a)}}return f}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function k(f,m){return I(f,m,new Set)}e.cloneAndChange=k;function I(f,m,p){if((0,v.isUndefinedOrNull)(f))return f;const M=m(f);if(typeof M!="undefined")return M;if((0,v.isArray)(f)){const a=[];for(const d of f)a.push(I(d,m,p));return a}if((0,v.isObject)(f)){if(p.has(f))throw new Error("Cannot clone recursive data-structure");p.add(f);const a={};for(let d in f)C.call(f,d)&&(a[d]=I(f[d],m,p));return p.delete(f),a}return f}function g(f,m,p=!0){return(0,v.isObject)(f)?((0,v.isObject)(m)&&Object.keys(m).forEach(M=>{M in f?p&&((0,v.isObject)(f[M])&&(0,v.isObject)(m[M])?g(f[M],m[M],p):f[M]=m[M]):f[M]=m[M]}),f):m}e.mixin=g;function w(f,m){if(f===m)return!0;if(f==null||m===null||m===void 0||typeof f!=typeof m||typeof f!="object"||Array.isArray(f)!==Array.isArray(m))return!1;let p,M;if(Array.isArray(f)){if(f.length!==m.length)return!1;for(p=0;p<f.length;p++)if(!w(f[p],m[p]))return!1}else{const a=[];for(M in f)a.push(M);a.sort();const d=[];for(M in m)d.push(M);if(d.sort(),!w(a,d))return!1;for(p=0;p<a.length;p++)if(!w(f[a[p]],m[a[p]]))return!1}return!0}e.equals=w;function E(f){const m=new Set;return JSON.stringify(f,(p,M)=>{if((0,v.isObject)(M)||Array.isArray(M)){if(m.has(M))return"[Circular]";m.add(M)}return M})}e.safeStringify=E;function P(f,m,p){const M=m(f);return typeof M=="undefined"?p:M}e.getOrDefault=P;function S(f,m){const p=Object.create(null);return!f||!m||Object.keys(m).forEach(a=>{const d=f[a],c=m[a];w(d,c)||(p[a]=c)}),p}e.distinct=S;function y(f,m){const p=m.toLowerCase(),M=Object.keys(f).find(a=>a.toLowerCase()===p);return M?f[M]:f[m]}e.getCaseInsensitive=y;function t(f,m){const p=Object.create(null);for(const[M,a]of Object.entries(f))m(M,a)&&(p[M]=a);return p}e.filter=t}),define(ee[7],te([0,1,9,3]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,k=/^\/\//;function I(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!C.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(s,i){return!s&&!i?"file":s}function w(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const E="",P="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(i,r,l,h,b,R=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=g(i,R),this.authority=r||E,this.path=w(this.scheme,l||E),this.query=h||E,this.fragment=b||E,I(this,R))}static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:l,path:h,query:b,fragment:R}=i;return r===void 0?r=this.scheme:r===null&&(r=E),l===void 0?l=this.authority:l===null&&(l=E),h===void 0?h=this.path:h===null&&(h=E),b===void 0?b=this.query:b===null&&(b=E),R===void 0?R=this.fragment:R===null&&(R=E),r===this.scheme&&l===this.authority&&h===this.path&&b===this.query&&R===this.fragment?this:new f(r,l,h,b,R)}static parse(i,r=!1){const l=S.exec(i);return l?new f(l[2]||E,u(l[4]||E),u(l[5]||E),u(l[7]||E),u(l[9]||E),r):new f(E,E,E,E,E)}static file(i){let r=E;if(n.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const l=i.indexOf(P,2);l===-1?(r=i.substring(2),i=P):(r=i.substring(2,l),i=i.substring(l)||P)}return new f("file",r,i,E,E)}static from(i){const r=new f(i.scheme,i.authority,i.path,i.query,i.fragment);return I(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return n.isWindows&&i.scheme==="file"?l=y.file(v.win32.join(a(i,!0),...r)).path:l=v.posix.join(i.path,...r),i.with({path:l})}toString(i=!1){return d(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const r=new f(i);return r._formatted=i.external,r._fsPath=i._sep===t?i.fsPath:null,r}}else return i}}e.URI=y;const t=n.isWindows?1:void 0;class f extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(s,i){let r,l=-1;for(let h=0;h<s.length;h++){const b=s.charCodeAt(h);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)l!==-1&&(r+=encodeURIComponent(s.substring(l,h)),l=-1),r!==void 0&&(r+=s.charAt(h));else{r===void 0&&(r=s.substr(0,h));const R=m[b];R!==void 0?(l!==-1&&(r+=encodeURIComponent(s.substring(l,h)),l=-1),r+=R):l===-1&&(l=h)}}return l!==-1&&(r+=encodeURIComponent(s.substring(l))),r!==void 0?r:s}function M(s){let i;for(let r=0;r<s.length;r++){const l=s.charCodeAt(r);l===35||l===63?(i===void 0&&(i=s.substr(0,r)),i+=m[l]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function a(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=a;function d(s,i){const r=i?M:p;let l="",{scheme:h,authority:b,path:R,query:L,fragment:F}=s;if(h&&(l+=h,l+=":"),(b||h==="file")&&(l+=P,l+=P),b){let z=b.indexOf("@");if(z!==-1){const Q=b.substr(0,z);b=b.substr(z+1),z=Q.indexOf(":"),z===-1?l+=r(Q,!1):(l+=r(Q.substr(0,z),!1),l+=":",l+=r(Q.substr(z+1),!1)),l+="@"}b=b.toLowerCase(),z=b.indexOf(":"),z===-1?l+=r(b,!1):(l+=r(b.substr(0,z),!1),l+=b.substr(z))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const z=R.charCodeAt(1);z>=65&&z<=90&&(R=`/${String.fromCharCode(z+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const z=R.charCodeAt(0);z>=65&&z<=90&&(R=`${String.fromCharCode(z+32)}:${R.substr(2)}`)}l+=r(R,!0)}return L&&(l+="?",l+=r(L,!1)),F&&(l+="#",l+=i?F:p(F,!1)),l}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(s){return s.match(o)?s.replace(o,i=>c(i)):s}}),define(ee[112],te([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(w){const E=w;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=n;function D(w){const E=[];let P;try{const S=JSON.parse(w.arguments),y=S[S.length-1];y&&y.__$stack&&(S.pop(),P=y.__$stack),E.push(...S)}catch{E.push("Unable to log remote console arguments",w.arguments)}return{args:E,stack:P}}e.parse=D;function C(w){if(typeof w!="string")return C(D(w).stack);const E=w;if(E){const P=k(E),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(S&&S.length===4)return{uri:v.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=C;function k(w){if(!w)return w;const E=w.indexOf(`
`);return E===-1?w:w.substring(0,E)}function I(w,E){const{args:P,stack:S}=D(w),y=typeof P[0]=="string"&&P.length===1;let t=k(S);t&&(t=`(${t.trim()})`);let f=[];if(typeof P[0]=="string"?t&&y?f=[`%c[${E}] %c${P[0]} %c${t}`,g("blue"),g(""),g("grey")]:f=[`%c[${E}] %c${P[0]}`,g("blue"),g(""),...P.slice(1)]:f=[`%c[${E}]%`,g("blue"),...P],t&&!y&&f.push(t),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,f)}e.log=I;function g(w){return`color: ${w}`}}),define(ee[113],te([0,1,17,25,7]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(E){return JSON.stringify(E,g)}e.stringify=C;function k(E){let P=JSON.parse(E);return P=w(P),P}e.parse=k;var I;(function(E){E[E.Uri=1]="Uri",E[E.Regexp=2]="Regexp",E[E.ScmResource=3]="ScmResource",E[E.ScmResourceGroup=4]="ScmResourceGroup",E[E.ScmProvider=5]="ScmProvider",E[E.CommentController=6]="CommentController",E[E.CommentThread=7]="CommentThread",E[E.CommentThreadReply=8]="CommentThreadReply",E[E.CommentNode=9]="CommentNode",E[E.CommentThreadNode=10]="CommentThreadNode",E[E.TimelineActionContext=11]="TimelineActionContext",E[E.NotebookCellActionContext=12]="NotebookCellActionContext",E[E.TestItemContext=13]="TestItemContext",E[E.Date=14]="Date"})(I=e.MarshalledId||(e.MarshalledId={}));function g(E,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,n.regExpFlags)(P)}:P}function w(E,P=0){if(!E||P>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return D.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 14:return new Date(E.source)}if(E instanceof v.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let S=0;S<E.length;++S)E[S]=w(E[S],P+1);else for(const S in E)Object.hasOwnProperty.call(E,S)&&(E[S]=w(E[S],P+1))}return E}e.revive=w}),define(ee[10],te([0,1,3,7]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,w,E){this._hosts[g]=w,this._ports[g]=E}setConnectionToken(g,w){this._connectionTokens[g]=w}rewrite(g){if(this._delegate)return this._delegate(g);const w=g.authority;let E=this._hosts[w];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const P=this._ports[w],S=this._connectionTokens[w];let y=`path=${encodeURIComponent(g.path)}`;return typeof S=="string"&&(y+=`&tkn=${encodeURIComponent(S)}`),n.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${E}:${P}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new C;class k{asBrowserUri(g,w){const E=this.toUri(g,w);return E.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===D.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?E.with({scheme:D.vscodeFileResource,authority:E.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(g,w){const E=this.toUri(g,w);return E.scheme===D.vscodeFileResource?E.with({scheme:D.file,authority:E.authority!==k.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(g,w){return n.URI.isUri(g)?g:n.URI.parse(w.toUrl(g))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ee[16],te([0,1,27,10,9,3,25,7]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(y){return(0,I.uriToFsPath)(y,!0)}e.originalFSPath=g;class w{constructor(t){this._ignorePathCasing=t}compare(t,f,m=!1){return t===f?0:(0,k.compare)(this.getComparisonKey(t,m),this.getComparisonKey(f,m))}isEqual(t,f,m=!1){return t===f?!0:!t||!f?!1:this.getComparisonKey(t,m)===this.getComparisonKey(f,m)}getComparisonKey(t,f=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,f,m=!1){if(t.scheme===f.scheme){if(t.scheme===n.Schemas.file)return v.isEqualOrParent(g(t),g(f),this._ignorePathCasing(t))&&t.query===f.query&&(m||t.fragment===f.fragment);if((0,e.isEqualAuthority)(t.authority,f.authority))return v.isEqualOrParent(t.path,f.path,this._ignorePathCasing(t),"/")&&t.query===f.query&&(m||t.fragment===f.fragment)}return!1}joinPath(t,...f){return I.URI.joinPath(t,...f)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let f;return t.scheme===n.Schemas.file?f=I.URI.file(D.dirname(g(t))).path:(f=D.posix.dirname(t.path),t.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),f="/")),t.with({path:f})}normalizePath(t){if(!t.path.length)return t;let f;return t.scheme===n.Schemas.file?f=I.URI.file(D.normalize(g(t))).path:f=D.posix.normalize(t.path),t.with({path:f})}relativePath(t,f){if(t.scheme!==f.scheme||!(0,e.isEqualAuthority)(t.authority,f.authority))return;if(t.scheme===n.Schemas.file){const M=D.relative(g(t),g(f));return C.isWindows?v.toSlashes(M):M}let m=t.path||"/",p=f.path||"/";if(this._ignorePathCasing(t)){let M=0;for(const a=Math.min(m.length,p.length);M<a&&!(m.charCodeAt(M)!==p.charCodeAt(M)&&m.charAt(M).toLowerCase()!==p.charAt(M).toLowerCase());M++);m=p.substr(0,M)+m.substr(M)}return D.posix.relative(m,p)}resolvePath(t,f){if(t.scheme===n.Schemas.file){const m=I.URI.file(D.resolve(g(t),f));return t.with({authority:m.authority,path:m.path})}return f=v.toPosixPath(f),t.with({path:D.posix.resolve(t.path,f)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,f){return t===f||t!==void 0&&f!==void 0&&(0,k.equalsIgnoreCase)(t,f)}hasTrailingPathSeparator(t,f=D.sep){if(t.scheme===n.Schemas.file){const m=g(t);return m.length>v.getRoot(m).length&&m[m.length-1]===f}else{const m=t.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,f=D.sep){return(0,e.hasTrailingPathSeparator)(t,f)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,f=D.sep){let m=!1;if(t.scheme===n.Schemas.file){const p=g(t);m=p!==void 0&&p.length===v.getRoot(p).length&&p[p.length-1]===f}else{f="/";const p=t.path;m=p.length===1&&p.charCodeAt(p.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(t,f)?t.with({path:t.path+"/"}):t}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(y=>y.scheme===n.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new w(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(y,t){const f=[];for(let m=0;m<y.length;m++){const p=t(y[m]);y.some((M,a)=>a===m?!1:(0,e.isEqualOrParent)(p,t(M)))||f.push(y[m])}return f}e.distinctParents=E;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function t(f){const m=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(a=>{const[d,c]=a.split(":");d&&c&&m.set(d,c)});const M=f.path.substring(0,f.path.indexOf(";"));return M&&m.set(y.META_DATA_MIME,M),m}y.parseMetaData=t})(P=e.DataUri||(e.DataUri={}));function S(y,t,f){if(t){let m=y.path;return m&&m[0]!==D.posix.sep&&(m=D.posix.sep+m),y.with({scheme:f,authority:t,path:m})}return y.with({scheme:f})}e.toLocalResource=S}),define(ee[8],te([0,1,21,15,4,2,16,3]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(A){return!!A&&typeof A.then=="function"}e.isThenable=g;function w(A){const T=new v.CancellationTokenSource,_=A(T.token),O=new Promise((U,J)=>{const ie=T.token.onCancellationRequested(()=>{ie.dispose(),T.dispose(),J(new n.CancellationError)});Promise.resolve(_).then(se=>{ie.dispose(),T.dispose(),U(se)},se=>{ie.dispose(),T.dispose(),J(se)})});return new class{cancel(){T.cancel()}then(U,J){return O.then(U,J)}catch(U){return this.then(void 0,U)}finally(U){return O.finally(U)}}}e.createCancelablePromise=w;function E(A,T,_){return new Promise((O,U)=>{const J=T.onCancellationRequested(()=>{J.dispose(),O(_)});A.then(O,U).finally(()=>J.dispose())})}e.raceCancellation=E;function P(A,T){return new Promise((_,O)=>{const U=T.onCancellationRequested(()=>{U.dispose(),O(new n.CancellationError)});A.then(_,O).finally(()=>U.dispose())})}e.raceCancellationError=P;async function S(A){let T=-1;const _=A.map((U,J)=>U.then(ie=>(T=J,ie))),O=await Promise.race(_);return A.forEach((U,J)=>{J!==T&&U.cancel()}),O}e.raceCancellablePromises=S;function y(A,T,_){let O;const U=setTimeout(()=>{O?.(void 0),_?.()},T);return Promise.race([A.finally(()=>clearTimeout(U)),new Promise(J=>O=J)])}e.raceTimeout=y;function t(A){return new Promise((T,_)=>{const O=A();g(O)?O.then(T,_):T(O)})}e.asPromise=t;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const _=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(_,_).then(O)})}return new Promise((_,O)=>{this.queuedPromise.then(_,O)})}return this.activePromise=T(),new Promise((_,O)=>{this.activePromise.then(U=>{this.activePromise=null,_(U)},U=>{this.activePromise=null,O(U)})})}}e.Throttler=f;class m{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=m;class p{constructor(){this.promiseMap=new Map}queue(T,_){const U=(this.promiseMap.get(T)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.promiseMap.get(T)===U&&this.promiseMap.delete(T)});return this.promiseMap.set(T,U),U}}e.SequencerByKey=p;const M=(A,T)=>{let _=!0;const O=setTimeout(()=>{_=!1,T()},A);return{isTriggered:()=>_,dispose:()=>{clearTimeout(O),_=!1}}},a=A=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,A())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(T){this.defaultDelay=T,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,_=this.defaultDelay){this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,J)=>{this.doResolve=U,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const O=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=_===e.MicrotaskDelay?a(O):M(_,O),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class c{constructor(T){this.delayer=new d(T),this.throttler=new f}trigger(T,_){return this.delayer.trigger(()=>this.throttler.queue(T),_)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((T,_)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class u extends o{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function s(A,T){return T?new Promise((_,O)=>{const U=setTimeout(()=>{J.dispose(),_()},A),J=T.onCancellationRequested(()=>{clearTimeout(U),J.dispose(),O(new n.CancellationError)})}):w(_=>s(A,_))}e.timeout=s;function i(A,T=0){const _=setTimeout(A,T);return(0,C.toDisposable)(()=>clearTimeout(_))}e.disposableTimeout=i;function r(A){const T=[];let _=0;const O=A.length;function U(){return _<O?A[_++]():null}function J(ie){ie!=null&&T.push(ie);const se=U();return se?se.then(J):Promise.resolve(T)}return Promise.resolve(null).then(J)}e.sequence=r;function l(A,T=O=>!!O,_=null){let O=0;const U=A.length,J=()=>{if(O>=U)return Promise.resolve(_);const ie=A[O++];return Promise.resolve(ie()).then(Z=>T(Z)?Promise.resolve(Z):J())};return J()}e.first=l;function h(A,T=O=>!!O,_=null){if(A.length===0)return Promise.resolve(_);let O=A.length;const U=()=>{O=-1;for(const J of A)J.cancel?.()};return new Promise((J,ie)=>{for(const se of A)se.then(Z=>{--O>=0&&T(Z)?(U(),J(Z)):O===0&&J(_)}).catch(Z=>{--O>=0&&(U(),ie(Z))})})}e.firstParallel=h;class b{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((_,O)=>{this.outstandingPromises.push({factory:T,c:_,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const _=T.factory();_.then(T.c,T.e),_.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=b;class R extends b{constructor(){super(1)}}e.Queue=R;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const T=new N;return this.drainers.add(T),T.p}isDrained(){for(const[,T]of this.queues)if(T.size>0)return!1;return!0}queueFor(T,_=k.extUri){const O=_.getComparisonKey(T);let U=this.queues.get(O);return U||(U=new R,D.Event.once(U.onFinished)(()=>{U?.dispose(),this.queues.delete(O),this.onDidQueueFinish()}),this.queues.set(O,U)),U}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const T of this.drainers)T.complete();this.drainers.clear()}dispose(){for(const[,T]of this.queues)T.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class F{constructor(T,_){this._token=-1,typeof T=="function"&&typeof _=="number"&&this.setIfNotSet(T,_)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,_){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},_)}setIfNotSet(T,_){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},_))}}e.TimeoutTimer=F;class z{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,_){this.cancel(),this._token=setInterval(()=>{T()},_)}}e.IntervalTimer=z;class Q{constructor(T,_){this.timeoutToken=-1,this.runner=T,this.timeout=_,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=Q;class oe{constructor(T,_){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.runner=T,this.timeout=_,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(T=this.timeout){T%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(T/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=oe;class re extends Q{constructor(T,_){super(T,_);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=re;class q extends C.Disposable{constructor(T,_){super();this.options=T,this.handler=_,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(T){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+T.length>this.options.maxBufferedWork)return!1}else if(this.pending+T.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...T),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=A=>{(0,I.setTimeout0)(()=>{if(T)return;const _=Date.now()+15;A(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(A,T)=>{const _=requestIdleCallback(A,typeof T=="number"?{timeout:T}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(_))}}}}();class x{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(_){this._error=_}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function H(A,T,_){let O;for(let U=0;U<_;U++)try{return await A()}catch(J){O=J,await s(T)}throw O}e.retry=H;class G{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(T,_,O){return this._pending={taskId:T,cancel:()=>O?.(),promise:_},_.then(()=>this.donePending(T),()=>this.donePending(T)),_}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let _,O;const U=new Promise((J,ie)=>{_=J,O=ie});this._next={run:T,promise:U,promiseResolve:_,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=G;class j{constructor(T,_=()=>Date.now()){this.interval=T,this.nowFn=_,this.lastIncrementTime=0,this.value=0}increment(){const T=this.nowFn();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,_)=>{this.completeCallback=T,this.errorCallback=_})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(_=>{this.completeCallback(T),this.resolved=!0,_()})}error(T){return new Promise(_=>{this.errorCallback(T),this.rejected=!0,_()})}cancel(){new Promise(T=>{this.errorCallback(new n.CancellationError),this.rejected=!0,T()})}}e.DeferredPromise=N;var B;(function(A){async function T(O){let U;const J=await Promise.all(O.map(ie=>ie.then(se=>se,se=>{U||(U=se)})));if(typeof U!="undefined")throw U;return J}A.settled=T;function _(O){return new Promise(async(U,J)=>{try{await O(U,J)}catch(ie){J(ie)}})}A.withAsyncBody=_})(B=e.Promises||(e.Promises={}));var Y;(function(A){A[A.Initial=0]="Initial",A[A.DoneOK=1]="DoneOK",A[A.DoneError=2]="DoneError"})(Y||(Y={}));class V{constructor(T){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const _={emitOne:O=>this.emitOne(O),emitMany:O=>this.emitMany(O),reject:O=>this.reject(O)};try{await Promise.resolve(T(_)),this.resolve()}catch(O){this.reject(O)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}static fromArray(T){return new V(_=>{_.emitMany(T)})}static fromPromise(T){return new V(async _=>{_.emitMany(await T)})}static fromPromises(T){return new V(async _=>{await Promise.all(T.map(async O=>_.emitOne(await O)))})}static merge(T){return new V(async _=>{await Promise.all(T.map(async O=>{for await(const U of O)_.emitOne(U)}))})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(T<this._results.length)return{done:!1,value:this._results[T++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(T,_){return new V(async O=>{for await(const U of T)O.emitOne(_(U))})}map(T){return V.map(this,T)}static filter(T,_){return new V(async O=>{for await(const U of T)_(U)&&O.emitOne(U)})}filter(T){return V.filter(this,T)}static coalesce(T){return V.filter(T,_=>!!_)}coalesce(){return V.coalesce(this)}static async toPromise(T){const _=[];for await(const O of T)_.push(O);return _}toPromise(){return V.toPromise(this)}emitOne(T){this._state===0&&(this._results.push(T),this._onStateChanged.fire())}emitMany(T){this._state===0&&(this._results=this._results.concat(T),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(T){this._state===0&&(this._state=2,this._error=T,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class W extends V{constructor(T,_){super(_);this._source=T}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=W;function $(A){const T=new v.CancellationTokenSource,_=A(T.token);return new W(T,async O=>{const U=T.token.onCancellationRequested(()=>{U.dispose(),T.dispose(),O.reject(new n.CancellationError)});try{for await(const J of _){if(T.token.isCancellationRequested)return;O.emitOne(J)}U.dispose(),T.dispose()}catch(J){U.dispose(),T.dispose(),O.reject(J)}})}e.createCancelableAsyncIterable=$}),define(ee[114],te([0,1,8,27,35,9,25]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const g="[/\\\\]",w="[^/\\\\]",E=/\//g;function P(j){switch(j){case 0:return"";case 1:return`${w}*?`;default:return`(?:${g}|${w}+${g}|${g}${w}+)*?`}}function S(j,N){if(!j)return[];const B=[];let Y=!1,V=!1,W="";for(const $ of j){switch($){case N:if(!Y&&!V){B.push(W),W="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":V=!0;break;case"]":V=!1;break}W+=$}return W&&B.push(W),B}e.splitGlobAware=S;function y(j){if(!j)return"";let N="";const B=S(j,e.GLOB_SPLIT);if(B.every(Y=>Y===e.GLOBSTAR))N=".*";else{let Y=!1;B.forEach((V,W)=>{if(V===e.GLOBSTAR){Y||(N+=P(2),Y=!0);return}let $=!1,A="",T=!1,_="";for(const O of V){if(O!=="}"&&$){A+=O;continue}if(T&&(O!=="]"||!_)){let U;O==="-"?U=O:(O==="^"||O==="!")&&!_?U="^":O===e.GLOB_SPLIT?U="":U=k.escapeRegExpCharacters(O),_+=U;continue}switch(O){case"{":$=!0;continue;case"[":T=!0;continue;case"}":{N+=`(?:${S(A,",").map(ie=>y(ie)).join("|")})`,$=!1,A="";break}case"]":N+="["+_+"]",T=!1,_="";break;case"?":N+=w;continue;case"*":N+=P(1);continue;default:N+=k.escapeRegExpCharacters(O)}}W<B.length-1&&(B[W+1]!==e.GLOBSTAR||W+2<B.length)&&(N+=g),Y=!1})}return N}const t=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,M=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,d=new D.LRUCache(1e4),c=function(){return!1},o=function(){return null};function u(j,N){if(!j)return o;let B;typeof j!="string"?B=j.pattern:B=j,B=B.trim();const Y=`${B}_${!!N.trimForExclusions}`;let V=d.get(Y);if(V)return s(V,j);let W;if(t.test(B)){const $=B.substr(4);V=function(A,T){return typeof A=="string"&&A.endsWith($)?B:null}}else(W=f.exec(i(B,N)))?V=r(W[1],B):(N.trimForExclusions?p:m).test(B)?V=l(B,N):(W=M.exec(i(B,N)))?V=h(W[1].substr(1),B,!0):(W=a.exec(i(B,N)))?V=h(W[1],B,!1):V=b(B);return d.set(Y,V),s(V,j)}function s(j,N){return typeof N=="string"?j:function(B,Y){return n.isEqualOrParent(B,N.base)?j(C.relative(N.base,B),Y):null}}function i(j,N){return N.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function r(j,N){const B=`/${j}`,Y=`\\${j}`,V=function($,A){return typeof $!="string"?null:A?A===j?N:null:$===j||$.endsWith(B)||$.endsWith(Y)?N:null},W=[j];return V.basenames=W,V.patterns=[N],V.allBasenames=W,V}function l(j,N){const B=G(j.slice(1,-1).split(",").map(A=>u(A,N)).filter(A=>A!==o),j),Y=B.length;if(!Y)return o;if(Y===1)return B[0];const V=function(A,T){for(let _=0,O=B.length;_<O;_++)if(B[_](A,T))return j;return null},W=B.find(A=>!!A.allBasenames);W&&(V.allBasenames=W.allBasenames);const $=B.reduce((A,T)=>T.allPaths?A.concat(T.allPaths):A,[]);return $.length&&(V.allPaths=$),V}function h(j,N,B){const Y=C.sep===C.posix.sep,V=Y?j:j.replace(E,C.sep),W=C.sep+V,$=C.posix.sep+j,A=B?function(T,_){return typeof T=="string"&&(T===V||T.endsWith(W)||!Y&&(T===j||T.endsWith($)))?N:null}:function(T,_){return typeof T=="string"&&(T===V||!Y&&T===j)?N:null};return A.allPaths=[(B?"*/":"./")+j],A}function b(j){try{const N=new RegExp(`^${y(j)}$`);return function(B){return N.lastIndex=0,typeof B=="string"&&N.test(B)?j:null}}catch{return o}}function R(j,N,B){return!j||typeof N!="string"?!1:L(j)(N,void 0,B)}e.match=R;function L(j,N={}){if(!j)return c;if(typeof j=="string"||oe(j)){const B=u(j,N);if(B===o)return c;const Y=function(V,W){return!!B(V,W)};return B.allBasenames&&(Y.allBasenames=B.allBasenames),B.allPaths&&(Y.allPaths=B.allPaths),Y}return x(j,N)}e.parse=L;function F(j){if(!j)return;let N;return B=>(N||(N=(j()||Promise.resolve([])).then(Y=>Y?Q(Y):{})),N.then(Y=>!!Y[B]))}e.hasSiblingPromiseFn=F;function z(j){if(!j)return;let N;return B=>{if(!N){const Y=j();N=Y?Q(Y):{}}return!!N[B]}}e.hasSiblingFn=z;function Q(j){const N={};for(const B of j)N[B]=!0;return N}function oe(j){const N=j;return N&&typeof N.base=="string"&&typeof N.pattern=="string"}e.isRelativePattern=oe;function re(j){return j.allBasenames||[]}e.getBasenameTerms=re;function q(j){return j.allPaths||[]}e.getPathTerms=q;function x(j,N){const B=G(Object.getOwnPropertyNames(j).map(A=>H(A,j[A],N)).filter(A=>A!==o)),Y=B.length;if(!Y)return o;if(!B.some(A=>!!A.requiresSiblings)){if(Y===1)return B[0];const A=function(O,U){for(let J=0,ie=B.length;J<ie;J++){const se=B[J](O,U);if(se)return se}return null},T=B.find(O=>!!O.allBasenames);T&&(A.allBasenames=T.allBasenames);const _=B.reduce((O,U)=>U.allPaths?O.concat(U.allPaths):O,[]);return _.length&&(A.allPaths=_),A}const V=function(A,T,_){let O;for(let U=0,J=B.length;U<J;U++){const ie=B[U];ie.requiresSiblings&&_&&(T||(T=C.basename(A)),O||(O=T.substr(0,T.length-C.extname(A).length)));const se=ie(A,T,O,_);if(se)return se}return null},W=B.find(A=>!!A.allBasenames);W&&(V.allBasenames=W.allBasenames);const $=B.reduce((A,T)=>T.allPaths?A.concat(T.allPaths):A,[]);return $.length&&(V.allPaths=$),V}function H(j,N,B){if(N===!1)return o;const Y=u(j,B);if(Y===o)return o;if(typeof N=="boolean")return Y;if(N){const V=N.when;if(typeof V=="string"){const W=($,A,T,_)=>{if(!_||!Y($,A))return null;const O=V.replace("$(basename)",T),U=_(O);return(0,v.isThenable)(U)?U.then(J=>J?j:null):U?j:null};return W.requiresSiblings=!0,W}}return Y}function G(j,N){const B=j.filter(A=>!!A.basenames);if(B.length<2)return j;const Y=B.reduce((A,T)=>{const _=T.basenames;return _?A.concat(_):A},[]);let V;if(N){V=[];for(let A=0,T=Y.length;A<T;A++)V.push(N)}else V=B.reduce((A,T)=>{const _=T.patterns;return _?A.concat(_):A},[]);const W=function(A,T){if(typeof A!="string")return null;if(!T){let O;for(O=A.length;O>0;O--){const U=A.charCodeAt(O-1);if(U===47||U===92)break}T=A.substr(O)}const _=Y.indexOf(T);return _!==-1?V[_]:null};W.basenames=Y,W.patterns=V,W.allBasenames=Y;const $=j.filter(A=>!A.basenames);return $.push(W),$}}),define(ee[33],te([0,1,27,10,9,3,16,25,7]),function(K,e,v,n,D,C,k,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(i,r,l){if(typeof i=="string"&&(i=g.URI.file(i)),l){const b=l.getWorkspaceFolder(i);if(b){const R=l.getWorkspace().folders.length>1;let L;if((0,k.isEqual)(b.uri,i)?L="":L=(0,k.relativePath)(b.uri,i),R){const F=b.name?b.name:(0,k.basename)(b.uri);L=L?F+" \u2022 "+L:F}return L}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(i.fsPath))return(0,D.normalize)(P(i.fsPath));let h=(0,D.normalize)(i.fsPath);return!C.isWindows&&r?.userHome&&(h=y(h,r.userHome.fsPath)),h}e.getPathLabel=w;function E(i){if(!i)return;typeof i=="string"&&(i=g.URI.file(i));const r=(0,k.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,v.isRootOrDriveLetter)(r)?P(r):r}e.getBaseLabel=E;function P(i,r){return(0,v.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=P;let S=Object.create(null);function y(i,r){if(C.isWindows||!i||!r)return i;let l=S.original===r?S.normalized:void 0;return l||(l=`${(0,I.rtrim)(r,D.posix.sep)}${D.posix.sep}`,S={original:r,normalized:l}),(C.isLinux?i.startsWith(l):(0,I.startsWithIgnoreCase)(i,l))&&(i=`~/${i.substr(l.length)}`),i}e.tildify=y;function t(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=t;const f="\u2026",m="\\\\",p="~";function M(i,r=D.sep){const l=new Array(i.length);let h=!1;for(let b=0;b<i.length;b++){let R=i[b];if(R===""){l[b]=`.${r}`;continue}if(!R){l[b]=R;continue}h=!0;let L="";R.indexOf(m)===0?(L=R.substr(0,R.indexOf(m)+m.length),R=R.substr(R.indexOf(m)+m.length)):R.indexOf(r)===0?(L=R.substr(0,R.indexOf(r)+r.length),R=R.substr(R.indexOf(r)+r.length)):R.indexOf(p)===0&&(L=R.substr(0,R.indexOf(p)+p.length),R=R.substr(R.indexOf(p)+p.length));const F=R.split(r);for(let z=1;h&&z<=F.length;z++)for(let Q=F.length-z;h&&Q>=0;Q--){h=!1;let oe=F.slice(Q,Q+z).join(r);for(let re=0;!h&&re<i.length;re++)if(re!==b&&i[re]&&i[re].indexOf(oe)>-1){const q=Q+z===F.length,x=Q>0&&i[re].indexOf(r)>-1?r+oe:oe,H=i[re].endsWith(x);h=!q||H}if(!h){let re="";(F[0].endsWith(":")||L!=="")&&(Q===1&&(Q=0,z++,oe=F[0]+r+oe),Q>0&&(re=F[0]+r),re=L+re),Q>0&&(re=re+f+r),re=re+oe,Q+z<F.length&&(re=re+r+f),l[b]=re}}h&&(l[b]=R)}return l}e.shorten=M;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function d(i,r=Object.create(null)){const l=[];let h=!1,b="";for(const R of i)if(R==="$"||h&&R==="{")b&&l.push({value:b,type:a.TEXT}),b="",h=!0;else if(R==="}"&&h){const L=r[b];if(typeof L=="string")L.length&&l.push({value:L,type:a.VARIABLE});else if(L){const F=l[l.length-1];(!F||F.type!==a.SEPARATOR)&&l.push({value:L.label,type:a.SEPARATOR})}b="",h=!1}else b+=R;return b&&!h&&l.push({value:b,type:a.TEXT}),l.filter((R,L)=>{if(R.type===a.SEPARATOR){const F=l[L-1],z=l[L+1];return[F,z].every(Q=>Q&&(Q.type===a.VARIABLE||Q.type===a.TEXT)&&Q.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=d;function c(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function o(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function s(i){const r=i.indexOf("/")!==-1?D.posix:D.win32,l=r.basename(i),h=r.dirname(i);return l.length?{name:l,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(ee[115],te([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(E){return E.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const S=this._uriTransformer.transformIncoming(P);return S===P?P:n(v.URI.from(S))}transformOutgoing(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:n(v.URI.from(S))}transformOutgoingURI(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:v.URI.from(S)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function C(E,P,S){if(!E||S>200)return null;if(typeof E=="object"){if(E instanceof v.URI)return P.transformOutgoing(E);for(let y in E)if(Object.hasOwnProperty.call(E,y)){const t=C(E[y],P,S+1);t!==null&&(E[y]=t)}}return null}function k(E,P){const S=C(E,P,0);return S===null?E:S}e.transformOutgoingURIs=k;function I(E,P,S,y){if(!E||y>200)return null;if(typeof E=="object"){if(E.$mid===1)return S?v.URI.revive(P.transformIncoming(E)):P.transformIncoming(E);for(let t in E)if(Object.hasOwnProperty.call(E,t)){const f=I(E[t],P,S,y+1);f!==null&&(E[t]=f)}}return null}function g(E,P){const S=I(E,P,!1,0);return S===null?E:S}e.transformIncomingURIs=g;function w(E,P){const S=I(E,P,!0,0);return S===null?E:S}e.transformAndReviveIncomingURIs=w}),define(ee[32],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(g){return v.test(g)}e.isUUID=n;const D=new Uint8Array(16),C=[];for(let g=0;g<256;g++)C.push(g.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(g){for(let w=0;w<g.length;w++)g[w]=Math.floor(Math.random()*256);return g};function I(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let g=0,w="";return w+=C[D[g++]],w+=C[D[g++]],w+=C[D[g++]],w+=C[D[g++]],w+="-",w+=C[D[g++]],w+=C[D[g++]],w+="-",w+=C[D[g++]],w+=C[D[g++]],w+="-",w+=C[D[g++]],w+=C[D[g++]],w+="-",w+=C[D[g++]],w+=C[D[g++]],w+=C[D[g++]],w+=C[D[g++]],w+=C[D[g++]],w+=C[D[g++]],w}e.generateUuid=I}),define(ee[116],te([0,1,15,4,2,3,13,25]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const g="$initialize";let w=!1;function E(s){!C.isWeb||(w||(w=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=E;var P;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(P||(P={}));class S{constructor(i,r,l,h){this.vsWorker=i,this.req=r,this.method=l,this.args=h,this.type=0}}class y{constructor(i,r,l,h){this.vsWorker=i,this.seq=r,this.res=l,this.err=h,this.type=1}}class t{constructor(i,r,l,h){this.vsWorker=i,this.req=r,this.eventName=l,this.arg=h,this.type=2}}class f{constructor(i,r,l){this.vsWorker=i,this.req=r,this.event=l,this.type=3}}class m{constructor(i,r){this.vsWorker=i,this.req=r,this.type=4}}class p{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,r){const l=String(++this._lastSentReq);return new Promise((h,b)=>{this._pendingReplies[l]={resolve:h,reject:b},this._send(new S(this._workerId,l,i,r))})}listen(i,r){let l=null;const h=new n.Emitter({onFirstListenerAdd:()=>{l=String(++this._lastSentReq),this._pendingEmitters.set(l,h),this._send(new t(this._workerId,l,i,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(l),this._send(new m(this._workerId,l)),l=null}});return h.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let l=i.err;i.err.$isError&&(l=new Error,l.name=i.err.name,l.message=i.err.message,l.stack=i.err.stack),r.reject(l);return}r.resolve(i.res)}_handleRequestMessage(i){let r=i.req;this._handler.handleMessage(i.method,i.args).then(h=>{this._send(new y(this._workerId,r,h,void 0))},h=>{h.detail instanceof Error&&(h.detail=(0,v.transformErrorForSerialization)(h.detail)),this._send(new y(this._workerId,r,void 0,(0,v.transformErrorForSerialization)(h)))})}_handleSubscribeEventMessage(i){const r=i.req,l=this._handler.handleEvent(i.eventName,i.arg)(h=>{this._send(new f(this._workerId,r,h))});this._pendingEvents.set(r,l)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let r=[];if(i.type===0)for(let l=0;l<i.args.length;l++)i.args[l]instanceof ArrayBuffer&&r.push(i.args[l]);else i.type===1&&i.res instanceof ArrayBuffer&&r.push(i.res);this._handler.sendMessage(i,r)}}class M extends D.Disposable{constructor(i,r,l){super();let h=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",z=>{this._protocol.handleMessage(z)},z=>{h&&h(z)})),this._protocol=new p({sendMessage:(z,Q)=>{this._worker.postMessage(z,Q)},handleMessage:(z,Q)=>{if(typeof l[z]!="function")return Promise.reject(new Error("Missing method "+z+" on main thread host."));try{return Promise.resolve(l[z].apply(l,Q))}catch(oe){return Promise.reject(oe)}},handleEvent:(z,Q)=>{if(d(z)){const oe=l[z].call(l,Q);if(typeof oe!="function")throw new Error(`Missing dynamic event ${z} on main thread host.`);return oe}if(a(z)){const oe=l[z];if(typeof oe!="function")throw new Error(`Missing event ${z} on main thread host.`);return oe}throw new Error(`Malformed event name ${z}`)}}),this._protocol.setWorkerId(this._worker.getId());let b=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?b=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(b=C.globals.requirejs.s.contexts._.config);const R=k.getAllMethodNames(l);this._onModuleLoaded=this._protocol.sendMessage(g,[this._worker.getId(),JSON.parse(JSON.stringify(b)),r,R]);const L=(z,Q)=>this._request(z,Q),F=(z,Q)=>this._protocol.listen(z,Q);this._lazyProxy=new Promise((z,Q)=>{h=Q,this._onModuleLoaded.then(oe=>{z(c(oe,L,F))},oe=>{Q(oe),this._onError("Worker failed to load "+r,oe)})})}getProxyObject(){return this._lazyProxy}_request(i,r){return new Promise((l,h)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,r).then(l,h)},h)})}_onError(i,r){console.error(i),console.info(r)}}e.SimpleWorkerClient=M;function a(s){return s[0]==="o"&&s[1]==="n"&&I.isUpperAsciiLetter(s.charCodeAt(2))}function d(s){return/^onDynamic/.test(s)&&I.isUpperAsciiLetter(s.charCodeAt(9))}function c(s,i,r){const l=R=>function(){const L=Array.prototype.slice.call(arguments,0);return i(R,L)},h=R=>function(L){return r(R,L)};let b={};for(const R of s){if(d(R)){b[R]=h(R);continue}if(a(R)){b[R]=r(R,void 0);continue}b[R]=l(R)}return b}class o{constructor(i,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new p({sendMessage:(l,h)=>{i(l,h)},handleMessage:(l,h)=>this._handleMessage(l,h),handleEvent:(l,h)=>this._handleEvent(l,h)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,r){if(i===g)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,r))}catch(l){return Promise.reject(l)}}_handleEvent(i,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(d(i)){const l=this._requestHandler[i].call(this._requestHandler,r);if(typeof l!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return l}if(a(i)){const l=this._requestHandler[i];if(typeof l!="function")throw new Error(`Missing event ${i} on request handler.`);return l}throw new Error(`Malformed event name ${i}`)}initialize(i,r,l,h){this._protocol.setWorkerId(i);const L=c(h,(F,z)=>this._protocol.sendMessage(F,z),(F,z)=>this._protocol.listen(F,z));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(k.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,C.globals.require.config(r)),new Promise((F,z)=>{(C.globals.require||K)([l],oe=>{if(this._requestHandler=oe.create(L),!this._requestHandler){z(new Error("No RequestHandler!"));return}F(k.getAllMethodNames(this._requestHandler))},z)}))}}e.SimpleWorkerServer=o;function u(s){return new o(s,null)}e.create=u}),define(ee[117],te([0,1,60,28,42]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(k,I){if(await new Promise((E,P)=>{const S=n.createReadStream(k),y=v.createHash("sha1");S.pipe(y);const t=(0,D.once)((f,m)=>{S.removeAllListeners(),y.removeAllListeners(),f?P(f):E(m)});S.once("error",t),S.once("end",t),y.once("error",t),y.once("data",f=>t(void 0,f.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=C}),define(ee[118],te([0,1,250]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(C="utf8"){this.stringDecoder=new v.StringDecoder(C),this.remaining=null}write(C){const k=[],I=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(I.length<1)return k;let g=0,w,E=g;for(;E<I.length;)if(w=I.charCodeAt(E),w===13||w===10){if(k.push(I.substring(g,E)),E++,E<I.length){const P=w;w=I.charCodeAt(E),(P===13&&w===10||P===10&&w===13)&&E++}g=E}else E++;return this.remaining=g<I.length?I.substr(g):null,k}end(){return this.remaining}}e.LineDecoder=n}),define(ee[119],te([0,1,26]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const I=k.replace(/\-/g,":").toLowerCase();return!n.has(I)}function C(){const k=(0,v.networkInterfaces)();for(let I in k){const g=k[I];if(g){for(const{mac:w}of g)if(D(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ee[73],te([0,1,26,15,35,32,119]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,P=0;const S=(0,v.networkInterfaces)();for(let y in S){const t=S[y];if(t)for(const{mac:f,internal:m}of t)m||(P+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(E+=1))}this._value=P>0?E/P:0}return this._value}};let I;async function g(){return I||(I=(async()=>await w()||C.generateUuid())()),I}e.getMachineId=g;async function w(){try{const E=await new Promise((S,y)=>{K(["crypto"],S,y)}),P=(0,k.getMac)();return E.createHash("sha256").update(P,"utf8").digest("hex")}catch(E){n.onUnexpectedError(E);return}}}),define(ee[24],te([0,1,28,26,120,8,27,72,9,3,16,7]),function(K,e,v,n,D,C,k,I,g,w,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function y(q,x=S.UNLINK){if((0,k.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return x===S.UNLINK?f(q):t(q)}async function t(q){try{const x=(0,k.randomPath)((0,n.tmpdir)());try{await v.promises.rename(q,x)}catch{return f(q)}f(x).catch(H=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function f(q){return e.Promises.rmdir(q,{recursive:!0,maxRetries:3})}function m(q){if((0,k.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(q,{recursive:!0})}e.rimrafSync=m;async function p(q,x){return d(await(x?M(q):(0,D.promisify)(v.readdir)(q)))}async function M(q){try{return await(0,D.promisify)(v.readdir)(q,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const x=[],H=await p(q);for(const G of H){let j=!1,N=!1,B=!1;try{const Y=await e.Promises.lstat((0,g.join)(q,G));j=Y.isFile(),N=Y.isDirectory(),B=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}x.push({name:G,isFile:()=>j,isDirectory:()=>N,isSymbolicLink:()=>B})}return x}function a(q){return d(v.readdirSync(q))}e.readdirSync=a;function d(q){return q.map(x=>typeof x=="string"?w.isMacintosh?(0,I.normalizeNFC)(x):x:(x.name=w.isMacintosh?(0,I.normalizeNFC)(x.name):x.name,x))}async function c(q){const x=await p(q),H=[];for(const G of x)await u.existsDirectory((0,g.join)(q,G))&&H.push(G);return H}function o(q,x=1e3){return new Promise(H=>{let G=!1;const j=setInterval(()=>{G||(G=!0,v.access(q,N=>{G=!1,N&&(clearInterval(j),H(void 0))}))},x)})}e.whenDeleted=o;var u;(function(q){async function x(j){let N;try{if(N=await e.Promises.lstat(j),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(j),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(w.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw Y}throw B}}q.stat=x;async function H(j){try{const{stat:N,symbolicLink:B}=await q.stat(j);return N.isFile()&&B?.dangling!==!0}catch{}return!1}q.existsFile=H;async function G(j){try{const{stat:N,symbolicLink:B}=await q.stat(j);return N.isDirectory()&&B?.dangling!==!0}catch{}return!1}q.existsDirectory=G})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new C.ResourceQueue;function i(q,x,H){return s.queueFor(P.URI.file(q),E.extUriBiasedIgnorePathCase).queue(()=>{const G=b(H);return new Promise((j,N)=>l(q,x,G,B=>B?N(B):j()))})}let r=!0;function l(q,x,H,G){if(!r)return v.writeFile(q,x,{mode:H.mode,flag:H.flag},G);v.open(q,H.flag,H.mode,(j,N)=>{if(j)return G(j);v.writeFile(N,x,B=>{if(B)return v.close(N,()=>G(B));v.fdatasync(N,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),r=!1),v.close(N,V=>G(V))))})})}function h(q,x,H){const G=b(H);if(!r)return v.writeFileSync(q,x,{mode:G.mode,flag:G.flag});const j=v.openSync(q,G.flag,G.mode);try{v.writeFileSync(j,x);try{v.fdatasyncSync(j)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),r=!1}}finally{v.closeSync(j)}}e.writeFileSync=h;function b(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function R(q,x){if(q===x)return;async function H(G){try{const j=await e.Promises.lstat(G);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes(G,j.atime,new Date)}catch{}}try{await e.Promises.rename(q,x),await H(x)}catch(G){if(q.toLowerCase()!==x.toLowerCase()&&G.code==="EXDEV"||q.endsWith("."))await L(q,x,{preserveSymlinks:!1}),await y(q,S.MOVE),await H(x);else throw G}}async function L(q,x,H){return z(q,x,{root:{source:q,target:x},options:H,handledSourcePaths:new Set})}const F=511;async function z(q,x,H){if(H.handledSourcePaths.has(q))return;H.handledSourcePaths.add(q);const{stat:G,symbolicLink:j}=await u.stat(q);if(j){if(H.options.preserveSymlinks)try{return await re(q,x,H)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(j.dangling)return}return G.isDirectory()?Q(q,x,G.mode&F,H):oe(q,x,G.mode&F)}async function Q(q,x,H,G){await e.Promises.mkdir(x,{recursive:!0,mode:H});const j=await p(q);for(const N of j)await z((0,g.join)(q,N),(0,g.join)(x,N),G)}async function oe(q,x,H){await e.Promises.copyFile(q,x),await e.Promises.chmod(x,H)}async function re(q,x,H){let G=await e.Promises.readlink(q);(0,k.isEqualOrParent)(G,H.root.source,!w.isLinux)&&(G=(0,g.join)(H.root.target,G.substr(H.root.source.length+1))),await e.Promises.symlink(G,x)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(q,x,H,G,j)=>new Promise((N,B)=>{v.read(q,x,H,G,j,(Y,V,W)=>Y?B(Y):N({bytesRead:V,buffer:W}))})}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(q,x,H,G,j)=>new Promise((N,B)=>{v.write(q,x,H,G,j,(Y,V,W)=>Y?B(Y):N({bytesWritten:V,buffer:W}))})}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return y}get move(){return R}get copy(){return L}}}),define(ee[84],te([0,1,28,9,3,25,24]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(S){if(D.isLinux)return S;const y=(0,n.dirname)(S);if(S===y)return S;const t=((0,n.basename)(S)||S).toLowerCase();try{const m=(0,k.readdirSync)(y).filter(p=>p.toLowerCase()===t);if(m.length===1){const p=I(y);if(p)return(0,n.join)(p,m[0])}else if(m.length>1){const p=m.indexOf(t);if(p>=0){const M=I(y);if(M)return(0,n.join)(M,m[p])}}}catch{}return null}e.realcaseSync=I;async function g(S){if(D.isLinux)return S;const y=(0,n.dirname)(S);if(S===y)return S;const t=((0,n.basename)(S)||S).toLowerCase();try{const m=(await k.Promises.readdir(y)).filter(p=>p.toLowerCase()===t);if(m.length===1){const p=await g(y);if(p)return(0,n.join)(p,m[0])}else if(m.length>1){const p=m.indexOf(t);if(p>=0){const M=await g(y);if(M)return(0,n.join)(M,m[p])}}}catch{}return null}e.realcase=g;async function w(S){try{return await k.Promises.realpath(S)}catch{const t=P(S);return await k.Promises.access(t,v.constants.R_OK),t}}e.realpath=w;function E(S){try{return v.realpathSync(S)}catch{const t=P(S);return v.accessSync(t,v.constants.R_OK),t}}e.realpathSync=E;function P(S){return(0,C.rtrim)((0,n.normalize)(S),n.sep)}}),define(ee[121],te([0,1,61]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(I,g,w,E=1){let P=!1;return new Promise(S=>{const y=setTimeout(()=>{if(!P)return P=!0,S(0)},w);D(I,g,E,t=>{if(!P)return P=!0,clearTimeout(y),S(t)})})}e.findFreePort=n;function D(I,g,w,E){if(g===0)return E(0);const P=new v.Socket;P.once("connect",()=>(k(P),D(I+w,g-1,w,E))),P.once("data",()=>{}),P.once("error",S=>(k(P),S.code!=="ECONNREFUSED"?D(I+w,g-1,w,E):E(I))),P.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(I,g,w){let E=!1,P,S=1;const y=v.createServer({pauseOnConnect:!0});function t(f,m){E||(E=!0,y.removeAllListeners(),y.close(),P&&clearTimeout(P),m(f))}return new Promise(f=>{P=setTimeout(()=>{t(0,f)},w),y.on("listening",()=>{t(I,f)}),y.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&S<g?(I++,S++,y.listen(I,"127.0.0.1")):t(0,f)}),y.on("close",()=>{t(0,f)}),y.listen(I,"127.0.0.1")})}e.findFreePortFaster=C;function k(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(g){console.error(g)}}}),define(ee[122],te([0,1,26,9,24]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,k=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var g;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(g||(g={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class P{constructor(c,o,u){this.exePath=c,this.displayName=o,this.knownToExist=u}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:d=!1}={}){return d?w===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:d=!1,findPreview:c=!1}={}){const o=S({useAlternateBitness:d});if(!o)return null;const u=n.join(o,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(u))return null;let s=-1,i=null;for(const h of await D.Promises.readdir(u)){let b=-1;if(c){const L=h.indexOf("-");if(L<0)continue;const F=h.substring(0,L);if(!C.test(F)||h.substring(L+1)!=="preview")continue;b=parseInt(F,10)}else{if(!C.test(h))continue;b=parseInt(h,10)}if(b<=s)continue;const R=n.join(u,h,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(i=R,s=b)}if(!i)return null;const r=o.includes("x86")?" (x86)":"",l=c?" Preview":"";return new P(i,`PowerShell${l}${r}`,!0)}async function t({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:u}=d?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(c))if(o.test(s)){const i=n.join(c,s,"pwsh.exe");return new P(i,u)}return null}function f(){const d=n.join(v.homedir(),".dotnet","tools","pwsh.exe");return new P(d,".NET Core PowerShell Global Tool")}function m(){const d=n.join(process.env.windir,w===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(d,"Windows PowerShell",!0)}async function*p(){let d=await y();d&&(yield d),d=await y({useAlternateBitness:!0}),d&&(yield d),d=await t(),d&&(yield d),d=f(),d&&(yield d),d=await y({findPreview:!0}),d&&(yield d),d=await t({findPreview:!0}),d&&(yield d),d=await y({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=m(),d&&(yield d)}async function*M(){for await(const d of p())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=M;async function a(){for await(const d of M())return d;return null}e.getFirstAvailablePowerShellInstallation=a}),define(ee[85],te([0,1,44,10]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((I,g)=>{let w;const E=new Map;function P(y,t,f,m,p){const M=E.get(t);if(y===k||M){const a={name:S(f),cmd:f,pid:y,ppid:t,load:m,mem:p};E.set(y,a),y===k&&(w=a),M&&(M.children||(M.children=[]),M.children.push(a),M.children.length>1&&(M.children=M.children.sort((d,c)=>d.pid-c.pid)))}}function S(y){const t=/--vscode-window-kind=shared-process/,f=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,M=/--crashes-directory/,a=/\\pipe\\winpty-control/,d=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(M.exec(y))return"electron-crash-reporter";if(a.exec(y))return"winpty-process";if(d.exec(y))return"console-window-host (Windows internal process)";let o=c.exec(y);if(o&&o.length===2)return o[1]==="renderer"?t.exec(y)?"shared-process":f.exec(y)?"issue-reporter":m.exec(y)?"process-explorer":"window":o[1]==="utility"&&p.exec(y)?"utility-network-service":o[1];const u=/[a-zA-Z-]+\.js/g;let s="";do o=u.exec(y),o&&(s+=o+" ");while(o);return s&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${s}`:y}if(process.platform==="win32"){const y=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,f)=>{K(["windows-process-tree"],t,f)}).then(t=>{t.getProcessList(k,f=>{t.getProcessCpuUsage(f,m=>{const p=new Map;m.forEach(M=>{const a=y(M.commandLine||"");p.set(M.pid,{name:S(a),cmd:a,pid:M.pid,ppid:M.ppid,load:M.cpu||0,mem:M.memory||0})}),w=p.get(k),w?(p.forEach(M=>{const a=p.get(M.ppid);a&&(a.children||(a.children=[]),a.children.push(M))}),p.forEach(M=>{M.children&&(M.children=M.children.sort((a,d)=>a.pid-d.pid))}),I(w)):g(new Error(`Root process ${k} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let y=function(){let t=[w];const f=[];for(;t.length;){const p=t.shift();p&&(f.push(p.pid),p.children&&(t=t.concat(p.children)))}let m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);m+=" "+f.join(" "),(0,v.exec)(m,{},(p,M,a)=>{if(p||a)g(p||new Error(a.toString()));else{const d=M.toString().split(`
`);for(let c=0;c<f.length;c++){const o=E.get(f[c]);o.load=parseFloat(d[c])}if(!w){g(new Error(`Root process ${k} not found`));return}I(w)}})};(0,v.exec)("which ps",{},(t,f,m)=>{if(t||m)if(process.platform!=="linux")g(t||new Error(m.toString()));else{const p=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,v.exec)(p,{},(M,a,d)=>{M||d?g(M||new Error(d.toString())):(C(a,P),y())})}else{const p=f.toString().trim(),M="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${p} ${M}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,d,c)=>{a||c&&!c.includes("screen size is bogus")?g(a||new Error(c.toString())):(C(d,P),process.platform==="linux"?y():w?I(w):g(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function C(k,I){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=k.toString().split(`
`);for(const E of w){const P=g.exec(E.trim());P&&P.length===6&&I(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(ee[123],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[124],te([0,1,14,13,123]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){v.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(I,g,w,E,P)=>{const S=k(I,E,w);S.popup({window:(0,n.withNullAsUndefined)(v.BrowserWindow.fromWebContents(I.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{S&&I.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,g)}})})}e.registerContextMenuListener=C;function k(I,g,w){const E=new v.Menu;return w.forEach(P=>{let S;P.type==="separator"?S=new v.MenuItem({type:P.type}):Array.isArray(P.submenu)?S=new v.MenuItem({submenu:k(I,g,P.submenu),label:P.label}):S=new v.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(y,t,f)=>I.sender.send(g,P.id,f)}),E.append(S)}),E}});var de=this&&this.__decorate||function(K,e,v,n){var D=arguments.length,C=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,v):n,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(K,e,v,n);else for(var I=K.length-1;I>=0;I--)(k=K[I])&&(C=(D<3?k(C):D>3?k(e,v,C):k(e,v))||C);return D>3&&C&&Object.defineProperty(e,v,C),C};define(ee[37],te([0,1,31,8,17,21,46,15,4,2,113,25,13]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function t(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function m(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(p||(p={}));class M{constructor(B){this.buffer=B,this.pos=0}read(B){const Y=this.buffer.slice(this.pos,this.pos+B);return this.pos+=Y.byteLength,Y}}class a{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var d;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(d||(d={}));function c(N){const B=D.VSBuffer.alloc(4);return B.writeUInt32BE(N,0),B}function o(N){return N.read(4).readUInt32BE(0)}function u(N){const B=D.VSBuffer.alloc(1);return B.writeUInt8(N,0),B}const s={Undefined:u(d.Undefined),String:u(d.String),Buffer:u(d.Buffer),VSBuffer:u(d.VSBuffer),Array:u(d.Array),Object:u(d.Object)},i=typeof Buffer!="undefined";function r(N,B){if(typeof B=="undefined")N.write(s.Undefined);else if(typeof B=="string"){const Y=D.VSBuffer.fromString(B);N.write(s.String),N.write(c(Y.byteLength)),N.write(Y)}else if(i&&Buffer.isBuffer(B)){const Y=D.VSBuffer.wrap(B);N.write(s.Buffer),N.write(c(Y.byteLength)),N.write(Y)}else if(B instanceof D.VSBuffer)N.write(s.VSBuffer),N.write(c(B.byteLength)),N.write(B);else if(Array.isArray(B)){N.write(s.Array),N.write(c(B.length));for(const Y of B)r(N,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(B));N.write(s.Object),N.write(c(Y.byteLength)),N.write(Y)}}function l(N){switch(N.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return N.read(o(N)).toString();case d.Buffer:return N.read(o(N)).buffer;case d.VSBuffer:return N.read(o(N));case d.Array:{const Y=o(N),V=[];for(let W=0;W<Y;W++)V.push(l(N));return V}case d.Object:return JSON.parse(N.read(o(N)).toString())}}class h{constructor(B,Y,V=null,W=1e3){this.protocol=B,this.ctx=Y,this.logger=V,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(B,Y){this.channels.set(B,Y),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const Y=this.send([B.type]);this.logger&&this.logger.logOutgoing(Y,0,1,m(B.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([B.type,B.id],B.data);this.logger&&this.logger.logOutgoing(Y,B.id,1,m(B.type),B.data);return}}}send(B,Y=void 0){const V=new a;return r(V,B),r(V,Y),this.sendBuffer(V.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const Y=new M(B),V=l(Y),W=l(Y),$=V[0];switch($){case 100:return this.logger&&this.logger.logIncoming(B.byteLength,V[1],1,`${t($)}: ${V[2]}.${V[3]}`,W),this.onPromise({type:$,id:V[1],channelName:V[2],name:V[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(B.byteLength,V[1],1,`${t($)}: ${V[2]}.${V[3]}`,W),this.onEventListen({type:$,id:V[1],channelName:V[2],name:V[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(B.byteLength,V[1],1,`${t($)}`),this.disposeActiveRequest({type:$,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(B.byteLength,V[1],1,`${t($)}`),this.disposeActiveRequest({type:$,id:V[1]})}}onPromise(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const V=new C.CancellationTokenSource;let W;try{W=Y.call(this.ctx,B.name,B.arg,V.token)}catch(T){W=Promise.reject(T)}const $=B.id;W.then(T=>{this.sendResponse({id:$,data:T,type:201}),this.activeRequests.delete(B.id)},T=>{T instanceof Error?this.sendResponse({id:$,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.sendResponse({id:$,data:T,type:203}),this.activeRequests.delete(B.id)});const A=(0,w.toDisposable)(()=>V.cancel());this.activeRequests.set(B.id,A)}onEventListen(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const V=B.id,$=Y.listen(this.ctx,B.name,B.arg)(A=>this.sendResponse({id:V,data:A,type:204}));this.activeRequests.set(B.id,$)}disposeActiveRequest(B){const Y=this.activeRequests.get(B.id);Y&&(Y.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let Y=this.pendingRequests.get(B.channelName);Y||(Y=[],this.pendingRequests.set(B.channelName,Y));const V=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:B,timeoutTimer:V})}flushPendingRequests(B){const Y=this.pendingRequests.get(B);if(Y){for(const V of Y)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var b;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(B,Y=null){this.protocol=B,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=Y}getChannel(B){const Y=this;return{call(V,W,$){return Y.isDisposed?Promise.reject(I.canceled()):Y.requestPromise(B,V,W,$)},listen(V,W){return Y.isDisposed?Promise.reject(I.canceled()):Y.requestEvent(B,V,W)}}}requestPromise(B,Y,V,W=C.CancellationToken.None){const $=this.lastRequestId++,T={id:$,type:100,channelName:B,name:Y,arg:V};if(W.isCancellationRequested)return Promise.reject(I.canceled());let _;return new Promise((U,J)=>{if(W.isCancellationRequested)return J(I.canceled());const ie=()=>{const le=he=>{switch(he.type){case 201:this.handlers.delete($),U(he.data);break;case 202:{this.handlers.delete($);const ge=new Error(he.data.message);ge.stack=he.data.stack,ge.name=he.data.name,J(ge);break}case 203:this.handlers.delete($),J(he.data);break}};this.handlers.set($,le),this.sendRequest(T)};let se=null;this.state===p.Idle?ie():(se=(0,n.createCancelablePromise)(le=>this.whenInitialized()),se.then(()=>{se=null,ie()}));const Z=()=>{se?(se.cancel(),se=null):this.sendRequest({id:$,type:101}),J(I.canceled())},ce=W.onCancellationRequested(Z);_=(0,w.combinedDisposable)((0,w.toDisposable)(Z),ce),this.activeRequests.add(_)}).finally(()=>{this.activeRequests.delete(_)})}requestEvent(B,Y,V){const W=this.lastRequestId++,A={id:W,type:102,channelName:B,name:Y,arg:V};let T=null;const _=new g.Emitter({onFirstListenerAdd:()=>{T=(0,n.createCancelablePromise)(U=>this.whenInitialized()),T.then(()=>{T=null,this.activeRequests.add(_),this.sendRequest(A)})},onLastListenerRemove:()=>{T?(T.cancel(),T=null):(this.activeRequests.delete(_),this.sendRequest({id:W,type:103}))}}),O=U=>_.fire(U.data);return this.handlers.set(W,O),_.event}sendRequest(B){switch(B.type){case 100:case 102:{const Y=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger&&this.logger.logOutgoing(Y,B.id,0,`${t(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Y=this.send([B.type,B.id]);this.logger&&this.logger.logOutgoing(Y,B.id,0,t(B.type));return}}}send(B,Y=void 0){const V=new a;return r(V,B),r(V,Y),this.sendBuffer(V.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const Y=new M(B),V=l(Y),W=l(Y),$=V[0];switch($){case 200:return this.logger&&this.logger.logIncoming(B.byteLength,0,0,m($)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(B.byteLength,V[1],0,m($),W),this.onResponse({type:V[0],id:V[1],data:W})}}onResponse(B){if(B.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(B.id);Y&&Y(B)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}de([k.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class L{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:Y,onDidClientDisconnect:V})=>{g.Event.once(Y.onMessage)($=>{const A=new M($),T=l(A),_=new h(Y,T),O=new R(Y);this.channels.forEach((J,ie)=>_.registerChannel(ie,J));const U={channelServer:_,channelClient:O,ctx:T};this._connections.add(U),this._onDidAddConnection.fire(U),V(()=>{_.dispose(),O.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}get connections(){const B=[];return this._connections.forEach(Y=>B.push(Y)),B}getChannel(B,Y){const V=this;return{call(W,$,A){let T;if((0,S.isFunction)(Y)){let O=(0,v.getRandomElement)(V.connections.filter(Y));T=O?Promise.resolve(O):g.Event.toPromise(g.Event.filter(V.onDidAddConnection,Y))}else T=Y.routeCall(V,W,$);const _=T.then(O=>O.channelClient.getChannel(B));return z(_).call(W,$,A)},listen(W,$){if((0,S.isFunction)(Y))return V.getMulticastEvent(B,Y,W,$);const A=Y.routeEvent(V,W,$).then(T=>T.channelClient.getChannel(B));return z(A).listen(W,$)}}}getMulticastEvent(B,Y,V,W){const $=this;let A=new w.DisposableStore;const T=new g.Emitter({onFirstListenerAdd:()=>{A=new w.DisposableStore;const _=new g.EventMultiplexer,O=new Map,U=ie=>{const Z=ie.channelClient.getChannel(B).listen(V,W),ce=_.add(Z);O.set(ie,ce)},J=ie=>{const se=O.get(ie);!se||(se.dispose(),O.delete(ie))};$.connections.filter(Y).forEach(U),g.Event.filter($.onDidAddConnection,Y)(U,void 0,A),$.onDidRemoveConnection(J,void 0,A),_.event(T.fire,T,A),A.add(_)},onLastListenerRemove:()=>{A.dispose()}});return T.event}registerChannel(B,Y){this.channels.set(B,Y),this._connections.forEach(V=>{V.channelServer.registerChannel(B,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class F{constructor(B,Y,V=null){const W=new a;r(W,Y),B.send(W.buffer),this.channelClient=new R(B,V),this.channelServer=new h(B,Y,V)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,Y){this.channelServer.registerChannel(B,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function z(N){return{call(B,Y,V){return N.then(W=>W.call(B,Y,V))},listen(B,Y){const V=new g.Relay;return N.then(W=>V.input=W.listen(B,Y)),V.event}}}e.getDelayedChannel=z;function Q(N){let B=!1;return{call(Y,V,W){return B?N.call(Y,V,W):(0,n.timeout)(0).then(()=>B=!0).then(()=>N.call(Y,V,W))},listen(Y,V){if(B)return N.listen(Y,V);const W=new g.Relay;return(0,n.timeout)(0).then(()=>B=!0).then(()=>W.input=N.listen(Y,V)),W.event}}}e.getNextTickChannel=Q;class oe{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const Y of B.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await g.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=oe;var re;(function(N){function B($,A){const T=$,_=A&&A.disableMarshalling,O=new Map;for(const U in T)V(U)&&O.set(U,g.Event.buffer(T[U],!0));return new class{listen(U,J,ie){const se=O.get(J);if(se)return se;if(W(J)){const Z=T[J];if(typeof Z=="function")return Z.call(T,ie)}throw new Error(`Event not found: ${J}`)}call(U,J,ie){const se=T[J];if(typeof se=="function"){if(!_&&Array.isArray(ie))for(let Z=0;Z<ie.length;Z++)ie[Z]=(0,E.revive)(ie[Z]);return se.apply(T,ie)}throw new Error(`Method not found: ${J}`)}}}N.fromService=B;function Y($,A){const T=A&&A.disableMarshalling;return new Proxy({},{get(_,O){if(typeof O=="string")return A?.properties?.has(O)?A.properties.get(O):W(O)?function(U){return $.listen(O,U)}:V(O)?$.listen(O):async function(...U){let J;A&&!(0,S.isUndefinedOrNull)(A.context)?J=[A.context,...U]:J=U;const ie=await $.call(O,J);return T?ie:(0,E.revive)(ie)};throw new Error(`Property not found: ${String(O)}`)}})}N.toService=Y;function V($){return $[0]==="o"&&$[1]==="n"&&P.isUpperAsciiLetter($.charCodeAt(2))}function W($){return/^onDynamic/.test($)&&P.isUpperAsciiLetter($.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let B=N.toString();if(B!=="[object Object]")return B}return N}function H(N){return Array.isArray(N)?N.map(x):x(N)}function G(N,B,Y,V,W,$,A){A=H(A);const T=q[W],_=T[V%T.length];let O=[`%c[${N}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test($)?(O=O.concat(A),O.push(")")):O.push(A),console.log.apply(console,O)}e.logWithColors=G;class j{constructor(B,Y){this._outgoingPrefix=B,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,Y,V,W,$){this._totalOutgoing+=B,G(this._outgoingPrefix,this._totalOutgoing,B,Y,V,W,$)}logIncoming(B,Y,V,W,$){this._totalIncoming+=B,G(this._incomingPrefix,this._totalIncoming,B,Y,V,W,$)}}e.IPCLogger=j}),define(ee[125],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,C){this.sender=D,this.onMessage=C}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(ee[126],te([0,1,17,4,37]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(g){this.port=g,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",w=>v.VSBuffer.wrap(w.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class k extends D.IPCClient{constructor(g,w){const E=new C(g);super(E,w);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=k}),define(ee[86],te([0,1,17,4,2,37]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let l=0;function h(R,L){if(!r.has(R)){const F=String(++l);r.set(R,F)}return r.get(R)}function b(R,L,F,z){if(!i.enableDiagnostics)return;const Q=h(R,L);if(z instanceof v.VSBuffer||z instanceof Uint8Array||z instanceof ArrayBuffer||ArrayBuffer.isView(z)){const oe=v.VSBuffer.alloc(z.byteLength);oe.set(z),i.records.push({timestamp:Date.now(),id:Q,label:L,type:F,buff:oe})}else i.records.push({timestamp:Date.now(),id:Q,label:L,type:F,data:z})}i.traceSocketEvent=b})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function E(){return w||(w=v.VSBuffer.alloc(0)),w}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return E();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const L=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),L}if(this._chunks[0].byteLength>r){const L=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),L}let h=v.VSBuffer.alloc(r),b=0,R=0;for(;r>0;){const L=this._chunks[R];if(L.byteLength>r){const F=L.slice(0,r);h.set(F,b),b+=r,l&&(this._chunks[R]=L.slice(r),this._totalLength-=r),r-=r}else h.set(L,b),b+=L.byteLength,l?(this._chunks.shift(),this._totalLength-=L.byteLength):R++,r-=L.byteLength}return h}}e.ChunkStream=P;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(S||(S={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(r,l,h,b){this.type=r,this.id=l,this.ack=h,this.data=b,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const h=this._state.messageType,b=this._state.id,R=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new f(h,b,R,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=v.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(l,r.data)}_bufferAdd(r,l){const h=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,h}_bufferTake(){const r=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class M extends D.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new f(1,0,0,r))}}e.Protocol=M;class a extends C.IPCClient{constructor(r,l,h=null){super(r,l,h);this.protocol=r}static fromSocket(r,l){return new a(new M(r),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=a;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],l=0,h=this._first;for(;h;)r[l++]=h.data,h=h.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new c(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class u{constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<u._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=u._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const r=Date.now(),l=(1+u._HISTORY_LENGTH)*1e3;let h=0;for(let b=0;b<u._HISTORY_LENGTH;b++)r-this.lastRuns[b]<=l&&h++;return 1-h/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class s{constructor(r,l=null,h=u.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=h,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(b=>this._receiveMessage(b))),this._socketDisposables.push(this._socket.onClose(b=>this._onSocketClose.fire(b))),l&&this._socketReader.acceptChunk(l)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new f(5,0,0,E());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new f(7,0,0,E());this._socketWriter.write(r)}sendResume(){const r=new f(8,0,0,E());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new f(3,0,this._incomingAckId,E());this._socketWriter.write(r);const l=this._outgoingUnackMsg.toArray();for(let h=0,b=l.length;h<b;h++)this._socketWriter.write(l[h]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new f(6,0,0,E())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let h=0,b=l.length;h<b;h++)this._socketWriter.write(l[h]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new f(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(r){const l=new f(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime,h=Date.now()-this._socketReader.lastReadTime,b=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&h>=2e4&&b>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const R=Math.max(2e4-l,2e4-h,2e4-b,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},R)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new f(3,0,this._incomingAckId,E());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(ee[127],te([0,1,14,17,4,2,37,125]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(E,P){const S=D.Event.fromNodeEventEmitter(v.ipcMain,P,(t,f)=>({event:t,message:f})),y=D.Event.filter(S,({event:t})=>t.sender.id===E);return D.Event.map(y,({message:t})=>t&&n.VSBuffer.wrap(t))}class w extends k.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const P=D.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:S})=>S);return D.Event.map(P,S=>{const y=S.id,t=w.Clients.get(y);t&&t.dispose();const f=new D.Emitter;w.Clients.set(y,(0,C.toDisposable)(()=>f.fire()));const m=g(y,"vscode:message"),p=D.Event.any(D.Event.signal(g(y,"vscode:disconnect")),f.event);return{protocol:new I.Protocol(S,m),onDidClientDisconnect:p}})}}e.Server=w,w.Clients=new Map}),define(ee[87],te([0,1,14,4,32,126]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends C.Client{constructor(w,E){super({addEventListener:(P,S)=>w.addListener(P,S),removeEventListener:(P,S)=>w.removeListener(P,S),postMessage:P=>w.postMessage(P),start:()=>w.start(),close:()=>w.close()},E)}}e.Client=k;async function I(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,D.generateUuid)();g.webContents.send("vscode:createMessageChannel",w);const E=n.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(S,y)=>({nonce:y,port:S.ports[0]})),{port:P}=await n.Event.toPromise(n.Event.once(n.Event.filter(E,S=>S.nonce===w)));return P}e.connect=I}),define(ee[88],te([0,1,8,4,2,13]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function I(P){const S=P;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var g;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(g||(g={}));class w extends D.Disposable{constructor(S,y=Object.create(null)){super();this.database=S,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((y,t)=>this.accept(t,y)),S.deleted?.forEach(y=>this.accept(y,void 0))}accept(S,y){if(this.state===g.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(y)?t=this.cache.delete(S):this.cache.get(S)!==y&&(this.cache.set(S,y),t=!0),t&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,y){const t=this.cache.get(S);return(0,C.isUndefinedOrNull)(t)?y:t}getBoolean(S,y){const t=this.get(S);return(0,C.isUndefinedOrNull)(t)?y:t==="true"}getNumber(S,y){const t=this.get(S);return(0,C.isUndefinedOrNull)(t)?y:parseInt(t,10)}async set(S,y){if(this.state===g.Closed)return;if((0,C.isUndefinedOrNull)(y))return this.delete(S);const t=String(y);if(this.cache.get(S)!==t)return this.cache.set(S,t),this.pendingInserts.set(S,t),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===g.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert&&S.insert.forEach((y,t)=>this.items.set(t,y)),S.delete&&S.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=E}),define(ee[128],te([0,1,8,4,35,9,24]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(E,P=Object.create(null)){this.path=E,this.options=P,this.name=(0,C.basename)(this.path),this.logger=new g(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const E=await this.whenConnected,P=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(y=>P.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(E){const P=await this.whenConnected;return this.doUpdateItems(P,E)}doUpdateItems(E,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,D.mapToString)(P.insert):"0"}), delete(${P.delete?(0,D.setToString)(P.delete):"0"})`),this.transaction(E,()=>{const S=P.insert,y=P.delete;if(S&&S.size>0){const t=[];t.push([]);let f=0;S.forEach((m,p)=>{let M=t[f];M.length>I.MAX_HOST_PARAMETERS&&(f++,M=[],t.push(M)),M.push(p,m)}),t.forEach(m=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,p=>p.run(m),()=>{const p=[];let M=0;return S.forEach((a,d)=>{p.push(d),M+=a.length}),`Keys: ${p.join(", ")} Length: ${M}`})})}if(y&&y.size){const t=[];t.push([]);let f=0;y.forEach(m=>{let p=t[f];p.length>I.MAX_HOST_PARAMETERS&&(f++,p=[],t.push(p)),p.push(m)}),t.forEach(m=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,p=>p.run(m),()=>{const p=[];return y.forEach(M=>{p.push(M)}),`Keys: ${p.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,E)}doClose(E,P){return new Promise((S,y)=>{E.db.close(t=>(t&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?S():!E.isErroneous&&!E.isInMemory?this.backup().then(S,f=>(this.logger.error(`[storage ${this.name}] backup(): ${f}`),S())):typeof P=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(f=>{const m=()=>this.doClose(f,void 0);return this.doUpdateItems(f,{insert:P()}).then(()=>m(),p=>(m(),Promise.reject(p)))})).then(S,y):y(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return k.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const P=await this.whenConnected,S=await this.get(P,E?"PRAGMA integrity_check":"PRAGMA quick_check"),y=E?S.integrity_check:S.quick_check;return P.isErroneous?`${y} (last error: ${P.lastError})`:P.isInMemory?`${y} (in-memory!)`:y}async connect(E,P=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${P})`);try{return await this.doConnect(E)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&P)return await(0,v.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await k.Promises.unlink(E);try{await k.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(E,P){E.isErroneous=!0,E.lastError=P,this.logger.error(P)}doConnect(E){return new Promise((P,S)=>{new Promise((y,t)=>{K(["@vscode/sqlite3"],y,t)}).then(y=>{const t={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(E,f=>f?t.db?t.db.close(()=>S(f)):S(f):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(t),m=>t.db.close(()=>S(m)))),isInMemory:E===I.IN_MEMORY_PATH};t.db.on("error",f=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${f}`)),this.logger.isTracing&&t.db.on("trace",f=>this.logger.trace(`[storage ${this.name}] Trace (event): ${f}`))},S)})}exec(E,P){return new Promise((S,y)=>{E.db.exec(P,t=>t?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${t}`),y(t)):S())})}get(E,P){return new Promise((S,y)=>{E.db.get(P,(t,f)=>t?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${t}`),y(t)):S(f))})}all(E,P){return new Promise((S,y)=>{E.db.all(P,(t,f)=>t?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${t}`),y(t)):S(f))})}transaction(E,P){return new Promise((S,y)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),P(),E.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${t}`),y(t)):S())})})}prepare(E,P,S,y){const t=E.db.prepare(P),f=m=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${m} (${P}). Details: ${y()}`)};t.on("error",f),S(t),t.finalize(m=>{m&&f(m),t.removeListener("error",f)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class g{constructor(E){E&&typeof E.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace&&this.logTrace(E)}error(E){this.logError&&this.logError(E)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[129],te([12,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(ee[130],te([0,1,129]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,C=D*24,k=C*7,I=C*30,g=C*365;function w(P,S,y){typeof P!="number"&&(P=P.getTime());const t=Math.round((new Date().getTime()-P)/1e3);if(t<-30)return(0,v.localize)(0,null,w(new Date().getTime()+t*1e3,!1));if(t<30)return(0,v.localize)(1,null);let f;return t<n?(f=t,S?f===1?y?(0,v.localize)(2,null,f):(0,v.localize)(3,null,f):y?(0,v.localize)(4,null,f):(0,v.localize)(5,null,f):f===1?y?(0,v.localize)(6,null,f):(0,v.localize)(7,null,f):y?(0,v.localize)(8,null,f):(0,v.localize)(9,null,f)):t<D?(f=Math.floor(t/n),S?f===1?y?(0,v.localize)(10,null,f):(0,v.localize)(11,null,f):y?(0,v.localize)(12,null,f):(0,v.localize)(13,null,f):f===1?y?(0,v.localize)(14,null,f):(0,v.localize)(15,null,f):y?(0,v.localize)(16,null,f):(0,v.localize)(17,null,f)):t<C?(f=Math.floor(t/D),S?f===1?y?(0,v.localize)(18,null,f):(0,v.localize)(19,null,f):y?(0,v.localize)(20,null,f):(0,v.localize)(21,null,f):f===1?y?(0,v.localize)(22,null,f):(0,v.localize)(23,null,f):y?(0,v.localize)(24,null,f):(0,v.localize)(25,null,f)):t<k?(f=Math.floor(t/C),S?f===1?(0,v.localize)(26,null,f):(0,v.localize)(27,null,f):f===1?(0,v.localize)(28,null,f):(0,v.localize)(29,null,f)):t<I?(f=Math.floor(t/k),S?f===1?y?(0,v.localize)(30,null,f):(0,v.localize)(31,null,f):y?(0,v.localize)(32,null,f):(0,v.localize)(33,null,f):f===1?y?(0,v.localize)(34,null,f):(0,v.localize)(35,null,f):y?(0,v.localize)(36,null,f):(0,v.localize)(37,null,f)):t<g?(f=Math.floor(t/I),S?f===1?y?(0,v.localize)(38,null,f):(0,v.localize)(39,null,f):y?(0,v.localize)(40,null,f):(0,v.localize)(41,null,f):f===1?y?(0,v.localize)(42,null,f):(0,v.localize)(43,null,f):y?(0,v.localize)(44,null,f):(0,v.localize)(45,null,f)):(f=Math.floor(t/g),S?f===1?y?(0,v.localize)(46,null,f):(0,v.localize)(47,null,f):y?(0,v.localize)(48,null,f):(0,v.localize)(49,null,f):f===1?y?(0,v.localize)(50,null,f):(0,v.localize)(51,null,f):y?(0,v.localize)(52,null,f):(0,v.localize)(53,null,f))}e.fromNow=w;function E(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(ee[131],te([12,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ee[39],te([0,1,31,13,131]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(w,E){return E&&(w.stack||w.stacktrace)?D.localize(0,null,I(w),k(w.stack)||k(w.stacktrace)):I(w)}function k(w){return Array.isArray(w)?w.join(`
`):w}function I(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function g(w=null,E=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const P=v.coalesce(w),S=g(P[0],E);return P.length>1?D.localize(4,null,S,P.length):S}if(n.isString(w))return w;if(w.detail){const P=w.detail;if(P.error)return C(P.error,E);if(P.exception)return C(P.exception,E)}return w.stack?C(w,E):w.message?w.message:D.localize(5,null)}e.toErrorMessage=g}),define(ee[132],te([12,11]),function(K,e){return K.create("vs/base/common/keybindingLabels",e)}),define(ee[133],te([0,1,132]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(k,I,g=I){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=I,this.modifierLabels[3]=g}toLabel(k,I,g){if(I.length===0)return null;const w=[];for(let E=0,P=I.length;E<P;E++){const S=I[E],y=g(S);if(y===null)return null;w[E]=D(S,y,this.modifierLabels[k])}return w.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(C,k,I){if(k===null)return"";const g=[];return C.ctrlKey&&g.push(I.ctrlKey),C.shiftKey&&g.push(I.shiftKey),C.altKey&&g.push(I.altKey),C.metaKey&&g.push(I.metaKey),k!==""&&g.push(k),g.join(I.separator)}}),define(ee[134],te([12,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(ee[74],te([0,1,44,27,10,47,9,3,34,82,13,118,24,134]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(o,u){if(I.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};u&&(s.cwd=u);const i=v.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{i.once("error",l=>{r({success:!1,error:l})}),i.once("exit",(l,h)=>{r(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(I.isLinux||I.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(i=>{v.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,l,h)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function m(o){!o||(delete o.DEBUG,I.isMacintosh&&delete o.DYLD_LIBRARY_PATH,I.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=m;function p(o=g.env){return o.comspec||"cmd.exe"}e.getWindowsShell=p;class M{constructor(u,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=u,this.args=s,this.shell=i,this.options=r;else{const l=u;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(g.env).forEach(h=>{l[h]=g.env[h]}),Object.keys(this.options.env).forEach(h=>{l[h]=this.options.env[h]}),this.options.env=l}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const s=u.lastIndexOf(k.sep);return s!==-1&&(u=u.substring(s+1)),M.WellKnowCommands[u]?u:"other"}start(u){return I.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(g.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(s=>{let i,r;const l=new Promise((h,b)=>{i=h,r=b});if(s){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=v.exec(h,this.options,(b,R,L)=>{this.childProcess=null;const F=b;F&&F.killed?r({killed:this.terminateRequested,stdout:R.toString(),stderr:L.toString()}):this.handleExec(i,u,b,R,L)})}else{let h=null;const b=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,i,u,r);const L={terminated:this.terminateRequested};E.isNumber(R)&&(L.cmdCode=R),i(L)};if(this.shell&&I.isWindows){const R=C.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let L=!1,F=!1;const z=[];let Q=this.ensureQuotes(this.cmd);z.push(Q.value),L=Q.quoted,this.args&&this.args.forEach(re=>{Q=this.ensureQuotes(re),z.push(Q.value),F=F&&Q.quoted});const oe=["/s","/c"];L?F?oe.push('"'+z.join(" ")+'"'):z.length>1?oe.push('"'+z[0]+'" '+z.slice(1).join(" ")):oe.push('"'+z[0]+'"'):oe.push(z.join(" ")),h=v.spawn(p(),oe,R)}else this.cmd&&(h=v.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(E.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",R=>{this.childProcess=null,r({terminated:this.terminateRequested,error:R})}),h.pid&&(this.childProcess.on("close",b),this.handleSpawn(h,i,u,r,!0)))}return l})}handleClose(u,s,i,r){}ensureQuotes(u){return M.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,f(u,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!I.isWindows)return u(!1);const s=v.spawn(p(),["/s","/c"]);s.on("error",i=>u(!0)),s.on("exit",i=>u(!1))})}}e.AbstractProcess=M,M.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},M.regexp=/^[^"].* .*[^"]/;class a extends M{constructor(u,s,i,r){super(u,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,s,i,r,l){[r,l].forEach((h,b)=>{const R=new P.LineDecoder;R.write(h).forEach(z=>{s({line:z,source:b===0?0:1})});const F=R.end();F&&s({line:F,source:b===0?0:1})}),u({terminated:this.terminateRequested,error:i})}handleSpawn(u,s,i,r,l){const h=new P.LineDecoder,b=new P.LineDecoder;u.stdout.on("data",R=>{h.write(R).forEach(F=>i({line:F,source:0}))}),u.stderr.on("data",R=>{b.write(R).forEach(F=>i({line:F,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=b}handleClose(u,s,i,r){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&i({line:l,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&i({line:h,source:1})}}e.LineProcess=a;function d(o){let u=[],s=!1;const i=function(r){if(s){u.push(r);return}(!o.send(r,h=>{if(h&&console.error(h),s=!1,u.length>0){const b=u.slice(0);u=[],b.forEach(R=>i(R))}})||I.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=d;var c;(function(o){async function u(s,i,r){if(k.isAbsolute(s))return s;if(i===void 0&&(i=g.cwd()),k.dirname(s)!=="."||(r===void 0&&E.isString(g.env.PATH)&&(r=g.env.PATH.split(k.delimiter)),r===void 0||r.length===0))return k.join(i,s);async function h(b){if(await S.Promises.exists(b)){let R;try{R=await S.Promises.stat(b)}catch(L){L.message.startsWith("EACCES")&&(R=await S.Promises.lstat(b))}return R?!R.isDirectory():!1}return!1}for(let b of r){let R;if(k.isAbsolute(b)?R=k.join(b,s):R=k.join(i,b,s),await h(R))return R;let L=R+".com";if(await h(L)||(L=R+".exe",await h(L)))return L}return k.join(i,s)}o.findExecutable=u})(c=e.win32||(e.win32={}))}),define(ee[135],te([0,1,26,3,122,74]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(y,t){return y===1?n.isWindows?P():C.getWindowsShell(t):w(y,t)}e.getSystemShell=k;function I(y,t){return y===1?n.isWindows?S(t):C.getWindowsShell(t):w(y,t)}e.getSystemShellSync=I;let g=null;function w(y,t){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!g){let f;if(n.isWindows)f="/bin/bash";else{if(f=t.SHELL,!f)try{f=(0,v.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}g=f}return g}let E=null;async function P(){return E||(E=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),E}function S(y){if(E)return E;const t=n.isWindows&&parseFloat((0,v.release)())>=10,f=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${y.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?m:C.getWindowsShell(y)}}),define(ee[136],te([0,1,44,8,17,21,112,15,4,2,47,74,37]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends S.ChannelServer{constructor(m){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",p=>D.VSBuffer.wrap(Buffer.from(p,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=y;class t{constructor(m,p){this.modulePath=m,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const M=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new n.Delayer(M),this.child=null,this._client=null}getChannel(m){const p=this;return{call(M,a,d){return p.requestPromise(m,M,a,d)},listen(M,a){return p.requestEvent(m,M,a)}}}requestPromise(m,p,M,a=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const d=this.getCachedChannel(m),c=(0,n.createCancelablePromise)(s=>d.call(p,M,s)),o=a.onCancellationRequested(()=>c.cancel()),u=(0,w.toDisposable)(()=>c.cancel());return this.activeRequests.add(u),c.finally(()=>{o.dispose(),this.activeRequests.delete(u),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(m,p,M){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let a;const d=new g.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(m).listen(p,M)(d.fire,d),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return d.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,P.removeDangerousEnvVariables)(p.env),this.child=(0,v.fork)(this.modulePath,m,p);const M=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,k.isRemoteConsoleLog)(i)){(0,k.log)(i,`IPC Library: ${this.options.serverName}`);return}M.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const d=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&d.send(i.buffer.toString("base64")),o=M.event,u={send:c,onMessage:o};this._client=new S.ChannelClient(u);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(l=>(0,w.dispose)(l)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(m){let p=this.channels.get(m);return p||(p=this.client.getChannel(m),this.channels.set(m,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(ee[137],te([12,11]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(ee[138],te([12,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[139],te([12,11]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[140],te([12,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(ee[141],te([12,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(ee[142],te([12,11]),function(K,e){return K.create("vs/platform/environment/node/shellEnv",e)}),define(ee[143],te([12,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[144],te([12,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[145],te([12,11]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[146],te([12,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(ee[147],te([12,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(ee[148],te([12,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(ee[149],te([12,11]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[150],te([12,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[151],te([12,11]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[152],te([12,11]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[153],te([12,11]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[154],te([12,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(ee[155],te([12,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[156],te([12,11]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[157],te([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/window",e)}),define(ee[158],te([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[159],te([12,11]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(ee[160],te([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[161],te([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[162],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function v(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=v}),define(ee[163],te([0,1,4,2]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(I,g,w){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(I,g,w){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends n.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,g,w){this.channel.call("attach",[I,g,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,g){this.channel.call("terminate",[I,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,g){return this.channel.call("openExtensionDevelopmentHostWindow",[I,g])}}e.ExtensionHostDebugChannelClient=C}),define(ee[164],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(k){this.driver=k}listen(k,I){throw new Error(`No event found: ${I}`)}call(k,I,g){switch(I){case"click":return this.driver.click(g[0],g[1],g[2]);case"doubleClick":return this.driver.doubleClick(g);case"setValue":return this.driver.setValue(g[0],g[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(g);case"getElements":return this.driver.getElements(g[0],g[1]);case"getElementXY":return this.driver.getElementXY(g[0],g[1],g[2]);case"typeInEditor":return this.driver.typeInEditor(g[0],g[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(g);case"writeInTerminal":return this.driver.writeInTerminal(g[0],g[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=v;class n{constructor(k){this.channel=k}click(k,I,g){return this.channel.call("click",[k,I,g])}doubleClick(k){return this.channel.call("doubleClick",k)}setValue(k,I){return this.channel.call("setValue",[k,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(k){return this.channel.call("isActiveElement",k)}getElements(k,I){return this.channel.call("getElements",[k,I])}getElementXY(k,I,g){return this.channel.call("getElementXY",[k,I,g])}typeInEditor(k,I){return this.channel.call("typeInEditor",[k,I])}getTerminalBuffer(k){return this.channel.call("getTerminalBuffer",k)}writeInTerminal(k,I){return this.channel.call("writeInTerminal",[k,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class D{constructor(k){this.channel=k}registerWindowDriver(k){return this.channel.call("registerWindowDriver",k)}reloadWindowDriver(k){return this.channel.call("reloadWindowDriver",k)}}e.WindowDriverRegistryChannelClient=D}),define(ee[165],te([0,1,130,46,10,9,34,16,7]),function(K,e,v,n,D,C,k,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(f,m,p){this._args=f,this.paths=m,this.productService=p}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",K).fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(g.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return g.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return g.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=k.env.VSCODE_PORTABLE;return f?g.URI.file((0,C.join)(f,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,C.resolve)(f):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?(0,C.resolve)(f):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,C.resolve)(f);const m=k.env.VSCODE_EXTENSIONS;if(m)return m;const p=k.env.VSCODE_PORTABLE;return p?(0,C.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(m=>/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,C.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?g.URI.parse(f):g.URI.file((0,C.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return g.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],w.prototype,"appRoot",null),de([n.memoize],w.prototype,"userHome",null),de([n.memoize],w.prototype,"userDataPath",null),de([n.memoize],w.prototype,"appSettingsHome",null),de([n.memoize],w.prototype,"tmpDir",null),de([n.memoize],w.prototype,"cacheHome",null),de([n.memoize],w.prototype,"userRoamingDataHome",null),de([n.memoize],w.prototype,"settingsResource",null),de([n.memoize],w.prototype,"userDataSyncHome",null),de([n.memoize],w.prototype,"userDataSyncLogResource",null),de([n.memoize],w.prototype,"sync",null),de([n.memoize],w.prototype,"machineSettingsResource",null),de([n.memoize],w.prototype,"globalStorageHome",null),de([n.memoize],w.prototype,"workspaceStorageHome",null),de([n.memoize],w.prototype,"keybindingsResource",null),de([n.memoize],w.prototype,"keyboardLayoutResource",null),de([n.memoize],w.prototype,"argvResource",null),de([n.memoize],w.prototype,"snippetsHome",null),de([n.memoize],w.prototype,"isExtensionDevelopment",null),de([n.memoize],w.prototype,"untitledWorkspacesHome",null),de([n.memoize],w.prototype,"installSourcePath",null),de([n.memoize],w.prototype,"builtinExtensionsPath",null),de([n.memoize],w.prototype,"extensionsPath",null),de([n.memoize],w.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],w.prototype,"extensionDevelopmentKind",null),de([n.memoize],w.prototype,"extensionTestsLocationURI",null),de([n.memoize],w.prototype,"debugExtensionHost",null),de([n.memoize],w.prototype,"serviceMachineIdResource",null),de([n.memoize],w.prototype,"telemetryLogResource",null),de([n.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function E(t,f){return y(t["inspect-extensions"],t["inspect-brk-extensions"],5870,f,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=E;function P(t,f){return y(t["inspect-search"],t["inspect-brk-search"],5876,f,t.extensionEnvironment)}e.parseSearchPort=P;function S(t,f){return y(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,f,t.extensionEnvironment)}e.parsePtyHostPort=S;function y(t,f,m,p,M,a){const c=Number(f||t)||(p?null:m),o=c?Boolean(!!f):!1;let u;if(a)try{u=JSON.parse(a)}catch{}return{port:c,break:o,debugId:M,env:u}}}),define(ee[89],te([0,1,251,3,140]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(t,f,m=k){const p={},M=[],a=[];for(let u in f){const s=f[u];s.alias&&(p[u]=s.alias),s.type==="string"||s.type==="string[]"?(M.push(u),s.deprecates&&M.push(...s.deprecates)):s.type==="boolean"&&(a.push(u),s.deprecates&&a.push(...s.deprecates))}const d=v(t,{string:M,boolean:a,alias:p}),c={},o=d;c._=d._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(let u in f){const s=f[u];s.alias&&delete o[s.alias];let i=o[u];if(s.deprecates)for(const r of s.deprecates)o.hasOwnProperty(r)&&(i||(i=o[r],i&&m.onDeprecatedOption(r,s.deprecationMessage||(0,D.localize)(33,null))),delete o[r]);typeof i!="undefined"&&(s.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):s.type==="string"&&Array.isArray(i)&&(i=i.pop(),m.onMultipleValues(u,i)),c[u]=i,s.deprecationMessage&&m.onDeprecatedOption(u,s.deprecationMessage)),delete o[u]}for(let u in o)m.onUnknownOption(u);return c}e.parseArgs=I;function g(t,f){let m="";return f.args&&(Array.isArray(f.args)?m=` <${f.args.join("> <")}>`:m=` <${f.args}>`),f.alias?`-${f.alias} --${t}${m}`:`--${t}${m}`}function w(t,f){let m=0,p=[];for(const c in t){const o=t[c],u=g(c,o);m=Math.max(m,u.length),p.push([u,o.description])}let M=m+2+1;if(f-M<25)return p.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let a=f-M-1,d=[];for(const c of p){let o=c[0],u=P(c[1],a),s=E(M-o.length-2);d.push("  "+o+s+u[0]);for(let i=1;i<u.length;i++)d.push(E(M)+u[i])}return d}e.formatOptions=w;function E(t){return" ".repeat(t)}function P(t,f){let m=[];for(;t.length;){let p=t.length<f?t.length:t.lastIndexOf(" ",f),M=t.slice(0,p).trim();t=t.slice(p),m.push(M)}return m}function S(t,f,m,p,M){const a=process.stdout.isTTY&&process.stdout.columns||80,d=M?.noInputFiles!==!0?`[${(0,D.localize)(34,null)}...]`:"",c=[`${t} ${m}`];c.push(""),c.push(`${(0,D.localize)(35,null)}: ${f} [${(0,D.localize)(36,null)}]${d}`),c.push(""),M?.noPipe!==!0&&(n.isWindows?c.push((0,D.localize)(37,null,f)):c.push((0,D.localize)(38,null,f)),c.push(""));const o={};for(const u in p){const s=p[u];if(s.description&&s.cat){let i=o[s.cat];i||(o[s.cat]=i={}),i[u]=s}}for(let u in o){const s=u;let i=o[s];i&&(c.push(C[s]),c.push(...w(i,a)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=S;function y(t,f){return`${t||(0,D.localize)(39,null)}
${f||(0,D.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ee[166],te([0,1,61,163,89]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends n.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,g,w){return g==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1]):super.call(I,g,w)}async openExtensionDevelopmentHostWindow(I,g){const w=(0,D.parseArgs)(I,D.OPTIONS);w.debugRenderer=g;const E=w.extensionDevelopmentPath;if(!E)return{success:!1};const[P]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:w});if(!g)return{success:!0};const S=P.win;if(!S)return{success:!0};const y=S.webContents.debugger;let t=y.isAttached()?1/0:0;const f=(0,v.createServer)(m=>{t++==0&&y.attach();let p=!1;const M=c=>{p||m.write(JSON.stringify(c)+"\0")},a=(c,o,u,s)=>M({method:o,params:u,sessionId:s});S.on("close",()=>{y.removeListener("message",a),m.end(),p=!0}),y.addListener("message",a);let d=Buffer.alloc(0);m.on("data",c=>{d=Buffer.concat([d,c]);for(let o=d.indexOf(0);o!==-1;o=d.indexOf(0)){let u;try{const s=d.slice(0,o).toString("utf8");d=d.slice(o+1),u=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}y.sendCommand(u.method,u.params,u.sessionId).then(s=>M({id:u.id,sessionId:u.sessionId,result:s})).catch(s=>M({id:u.id,sessionId:u.sessionId,error:{code:0,message:s.message}}))}}),m.on("error",c=>{console.error("error on cdp pipe:",c)}),m.on("close",()=>{p=!0,--t==0&&y.detach()})});return await new Promise(m=>f.listen(0,m)),S.on("close",()=>f.close()),{rendererDebugPort:f.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function K(e,v,n,D){function C(I){const g=k(I),w=[g];return e.isAbsolute(g)||w.unshift(D),e.resolve(...w)}function k(I){const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,n);const E=I["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(P,"AppData","Roaming")}break;case"darwin":w=e.join(v.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,n)}return{getUserDataPath:C}}if(typeof define=="function")define(ee[167],te([0,252,26,10,16,34]),function(e,v,n,D,C,k){const I=C.dirname(D.FileAccess.asFileUri("",e)),g=e.__$__nodeRequire(C.joinPath(I,"package.json").fsPath);return K(v,n,g.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),n=require("os");module.exports=K(v,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[168],te([0,1,26,165,167]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends n.AbstractNativeEnvironmentService{constructor(I,g){super(I,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I)},g)}}e.NativeEnvironmentService=C}),define(ee[169],te([0,1,28,26,27]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(k){const I=(0,D.randomPath)((0,n.tmpdir)());try{return(0,v.writeFileSync)(I,""),k&&console.log(`Marker file for --wait created: ${I}`),I}catch(g){k&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFile=C}),define(ee[170],te([0,1,144]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(S){return S=S.trim(),S==="*"||n.test(S)}e.isValidVersionStr=C;function k(S){if(!C(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=S.match(n);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=k;function I(S){if(!S)return null;let y=S.majorBase,t=S.majorMustEqual,f=S.minorBase,m=S.minorMustEqual,p=S.patchBase,M=S.patchMustEqual;S.hasCaret&&(y===0||(m=!1),M=!1);let a=0;if(S.preRelease){const d=D.exec(S.preRelease);if(d){const[,c,o,u]=d;a=Date.UTC(Number(c),Number(o)-1,Number(u))}}return{majorBase:y,majorMustEqual:t,minorBase:f,minorMustEqual:m,patchBase:p,patchMustEqual:M,isMinimum:S.hasGreaterEquals,notBefore:a}}e.normalizeVersion=I;function g(S,y,t){let f;typeof S=="string"?f=I(k(S)):f=S;let m;y instanceof Date?m=y.getTime():typeof y=="string"&&(m=new Date(y).getTime());let p;if(typeof t=="string"?p=I(k(t)):p=t,!f||!p)return!1;let M=f.majorBase,a=f.minorBase,d=f.patchBase,c=p.majorBase,o=p.minorBase,u=p.patchBase,s=p.notBefore,i=p.majorMustEqual,r=p.minorMustEqual,l=p.patchMustEqual;return p.isMinimum?M>c?!0:M<c?!1:a>o?!0:a<o||m&&m<s?!1:d>=u:(M===1&&c===0&&(!i||!r||!l)&&(c=1,o=0,u=0,i=!0,r=!1,l=!1),M<c?!1:M>c?!i:a<o?!1:a>o?!r:d<u?!1:d>u?!l:!(m&&m<s))}e.isValidVersion=g;function w(S,y,t,f){return t.isBuiltin||typeof t.main=="undefined"?!0:P(S,y,t.engines.vscode,f)}e.isValidExtensionVersion=w;function E(S,y,t){return S==="*"||P(y,t,S)}e.isEngineValid=E;function P(S,y,t,f=[]){let m=I(k(t));if(!m)return f.push(v.localize(0,null,t)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return f.push(v.localize(1,null,t)),!1}else if(!m.majorMustEqual)return f.push(v.localize(2,null,t)),!1;return g(S,y,m)?!0:(f.push(v.localize(3,null,S,t)),!1)}}),define(ee[171],te([0,1,4,2,17,51,21]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends n.Disposable{constructor(w,E){super();this.provider=w,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(w,E,P){const S=this.getUriTransformer(w);switch(E){case"stat":return this.stat(S,P[0]);case"readdir":return this.readdir(S,P[0]);case"open":return this.open(S,P[0],P[1]);case"close":return this.close(P[0]);case"read":return this.read(P[0],P[1],P[2]);case"readFile":return this.readFile(S,P[0],P[1]);case"write":return this.write(P[0],P[1],P[2],P[3],P[4]);case"writeFile":return this.writeFile(S,P[0],P[1],P[2]);case"rename":return this.rename(S,P[0],P[1],P[2]);case"copy":return this.copy(S,P[0],P[1],P[2]);case"mkdir":return this.mkdir(S,P[0]);case"delete":return this.delete(S,P[0],P[1]);case"watch":return this.watch(S,P[0],P[1],P[2],P[3]);case"unwatch":return this.unwatch(P[0],P[1])}throw new Error(`IPC Command ${E} not found`)}listen(w,E,P){const S=this.getUriTransformer(w);switch(E){case"fileChange":return this.onFileChange(S,P[0]);case"readFileStream":return this.onReadFileStream(S,P[0],P[1])}throw new Error(`Unknown event ${E}`)}stat(w,E){const P=this.transformIncoming(w,E,!0);return this.provider.stat(P)}readdir(w,E){const P=this.transformIncoming(w,E);return this.provider.readdir(P)}async readFile(w,E,P){const S=this.transformIncoming(w,E,!0),y=await this.provider.readFile(S,P);return D.VSBuffer.wrap(y)}onReadFileStream(w,E,P){const S=this.transformIncoming(w,E,!0),y=new k.CancellationTokenSource,t=new v.Emitter({onLastListenerRemove:()=>{y.cancel()}}),f=this.provider.readFileStream(S,P,y.token);return(0,C.listenStream)(f,{onData:m=>t.fire(D.VSBuffer.wrap(m)),onError:m=>t.fire(m),onEnd:()=>{t.fire("end"),t.dispose(),y.dispose()}}),t.event}writeFile(w,E,P,S){const y=this.transformIncoming(w,E);return this.provider.writeFile(y,P.buffer,S)}open(w,E,P){const S=this.transformIncoming(w,E,!0);return this.provider.open(S,P)}close(w){return this.provider.close(w)}async read(w,E,P){const S=D.VSBuffer.alloc(P),y=0,t=await this.provider.read(w,E,S.buffer,y,P);return[S,t]}write(w,E,P,S,y){return this.provider.write(w,E,P.buffer,S,y)}mkdir(w,E){const P=this.transformIncoming(w,E);return this.provider.mkdir(P)}delete(w,E,P){const S=this.transformIncoming(w,E);return this.provider.delete(S,P)}rename(w,E,P,S){const y=this.transformIncoming(w,E),t=this.transformIncoming(w,P);return this.provider.rename(y,t,S)}copy(w,E,P,S){const y=this.transformIncoming(w,E),t=this.transformIncoming(w,P);return this.provider.copy(y,t,S)}onFileChange(w,E){const P=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(w,P))},onLastListenerRemove:()=>{(0,n.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return P.event}async watch(w,E,P,S,y){const t=this.sessionToWatcher.get(E);if(t){const f=this.transformIncoming(w,S),m=t.watch(P,f,y);this.watchRequests.set(E+P,m)}}async unwatch(w,E){const P=w+E,S=this.watchRequests.get(P);S&&((0,n.dispose)(S),this.watchRequests.delete(P))}dispose(){super.dispose();for(const[,w]of this.watchRequests)w.dispose();this.watchRequests.clear();for(const[,w]of this.sessionToWatcher)w.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(ee[62],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,C=[],k=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=v}),define(ee[172],te([0,1,62]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function D(k,I,g){I instanceof v.SyncDescriptor||(I=new v.SyncDescriptor(I,[],g)),n.push([k,I])}e.registerSingleton=D;function C(){return n}e.getSingletonServiceDescriptors=C}),define(ee[173],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=v;class n{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let k of this._nodes.values())k.outgoing.size===0&&C.push(k);return C}insertEdge(C,k){const I=this.lookupOrInsertNode(C),g=this.lookupOrInsertNode(k);I.outgoing.set(this._hashFn(k),g),g.incoming.set(this._hashFn(C),I)}removeNode(C){const k=this._hashFn(C);this._nodes.delete(k);for(let I of this._nodes.values())I.outgoing.delete(k),I.incoming.delete(k)}lookupOrInsertNode(C){const k=this._hashFn(C);let I=this._nodes.get(k);return I||(I=new v(C),this._nodes.set(k,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[k,I]of this._nodes)C.push(`${k}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,k]of this._nodes){const I=new Set([C]),g=this._findCycle(k,I);if(g)return g}}_findCycle(C,k){for(let[I,g]of C.outgoing){if(k.has(I))return[...k,I].join(" -> ");k.add(I);const w=this._findCycle(g,k);if(w)return w;k.delete(I)}}}e.Graph=n}),define(ee[5],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function I(g){return g[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=I})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(k,I,g,w){I[v.DI_TARGET]===I?I[v.DI_DEPENDENCIES].push({id:k,index:g,optional:w}):(I[v.DI_DEPENDENCIES]=[{id:k,index:g,optional:w}],I[v.DI_TARGET]=I)}function D(k){if(v.serviceIds.has(k))return v.serviceIds.get(k);const I=function(g,w,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(I,g,E,!1)};return I.toString=()=>k,v.serviceIds.set(k,I),I}e.createDecorator=D;function C(k){return k}e.refineServiceDecorator=C}),define(ee[52],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(ee[19],te([0,1,13,7,5]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationOverrides=C;function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||v.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=k;var I;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=g;function w(m,p){const M=Object.create(null);for(let a in m)E(M,a,m[a],p);return M}e.toValuesTree=w;function E(m,p,M,a){const d=p.split("."),c=d.pop();let o=m;for(let u=0;u<d.length;u++){let s=d[u],i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${p} as ${d.slice(0,u+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[c]=M}catch{a(`Ignoring ${p} as ${d.join(".")} is ${JSON.stringify(o)}`)}else a(`Ignoring ${p} as ${d.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=E;function P(m,p){const M=p.split(".");S(m,M)}e.removeFromValueTree=P;function S(m,p){const M=p.shift();if(p.length===0){delete m[M];return}if(Object.keys(m).indexOf(M)!==-1){const a=m[M];typeof a=="object"&&!Array.isArray(a)&&(S(a,p),Object.keys(a).length===0&&delete m[M])}}function y(m,p,M){function a(o,u){let s=o;for(const i of u){if(typeof s!="object"||s===null)return;s=s[i]}return s}const d=p.split("."),c=a(m,d);return typeof c=="undefined"?M:c}e.getConfigurationValue=y;function t(m,p,M){Object.keys(p).forEach(a=>{a!=="__proto__"&&(a in m?v.isObject(m[a])&&v.isObject(p[a])?t(m[a],p[a],M):M&&(m[a]=p[a]):m[a]=p[a])})}e.merge=t;function f(m,p,M){const a=m.inspect(p),d=m.inspect(M);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:a.defaultValue}e.getMigratedSettingValue=f}),define(ee[174],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService")}),define(ee[75],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n}),define(ee[90],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class n{constructor(C){this.machineId=C}encryption(){return new Promise((C,k)=>K(["vscode-encrypt"],C,k))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch{return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch{return C}}}e.EncryptionMainService=n}),define(ee[48],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[175],te([0,1,10,143,5]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(a){a.WIN32_X64="win32-x64",a.WIN32_IA32="win32-ia32",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function k(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function I(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function g(a,d){switch(a){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=g;function w(a,d){return d==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function E(a,d,c){return w(d,c)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===c?!0:P(c).includes(a)}e.isTargetPlatformCompatible=E;function P(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function S(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=S;var y;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var t;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var f;(function(a){a.Install="install",a.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var m;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var p;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class M extends Error{constructor(d,c){super(d);this.code=c,this.name=c}}e.ExtensionManagementError=M,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(ee[176],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(ee[177],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[91],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(ee[178],te([0,1,44,10,9,3,82,24,74,145,91]),function(K,e,v,n,D,C,k,I,g,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=w.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends S{openTerminal(d,c){return this.spawnTerminal(v,d,g.getWindowsShell(),c)}spawnTerminal(d,c,o,u){const s=c.windowsExec||y.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=D.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return d.spawn(s,u?[u]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((l,h)=>{const b=m(process),R=d.spawn(o,r,{cwd:u,env:b});R.on("error",h),R.on("exit",()=>l())})}runInTerminal(d,c,o,u,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:y.getDefaultTerminalWindows();return new Promise((r,l)=>{const h=`"${c} - ${P}"`,b=`""${o.join('" "')}" & pause"`,R=["/c","start",h,"/wait",i,"/c",b],L=Object.assign({},m(process),u);Object.keys(L).filter(Q=>L[Q]===null).forEach(Q=>delete L[Q]);const F={cwd:c,env:L,windowsVerbatimArguments:!0};v.spawn(y.CMD,R,F).on("error",Q=>{l(p(Q))}),r(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class t extends S{openTerminal(d,c){return this.spawnTerminal(v,d,c)}runInTerminal(d,c,o,u,s){const i=s.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(i===E.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,K).fsPath,"-t",d||P,"-w",c];for(let z of o)R.push("-a"),R.push(z);if(u){const z=Object.assign({},m(process),u);for(let Q in z){const oe=z[Q];oe===null?(R.push("-u"),R.push(Q)):(R.push("-e"),R.push(`${Q}=${oe}`))}}let L="";const F=v.spawn(t.OSASCRIPT,R);F.on("error",z=>{l(p(z))}),F.stderr.on("data",z=>{L+=z.toString()}),F.on("exit",z=>{if(z===0)r(void 0);else if(L){const Q=L.split(`
`,1);l(new Error(Q[0]))}else l(new Error(w.localize(1,null,h,z)))})}else l(new Error(w.localize(2,null,i)))})}spawnTerminal(d,c,o){const u=c.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",u];o&&r.push(o);const l=m(process),h=d.spawn("/usr/bin/open",r,{cwd:o,env:l});h.on("error",i),h.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class f extends S{openTerminal(d,c){return this.spawnTerminal(v,d,c)}runInTerminal(d,c,o,u,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{let h=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const R=`${M(o)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;h.push(`''${R}''`);const L=Object.assign({},m(process),u);Object.keys(L).filter(oe=>L[oe]===null).forEach(oe=>delete L[oe]);const F={cwd:c,env:L};let z="";const Q=v.spawn(b,h,F);Q.on("error",oe=>{l(p(oe))}),Q.stderr.on("data",oe=>{z+=oe.toString()}),Q.on("exit",oe=>{if(oe===0)r(void 0);else if(z){const re=z.split(`
`,1);l(new Error(re[0]))}else l(new Error(w.localize(4,null,b,oe)))})})})}static async getDefaultTerminalLinuxReady(){if(!f._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)f._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const d=await I.Promises.exists("/etc/debian_version");f._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{d?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(d,c,o){const u=c.linuxExec?Promise.resolve(c.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{u.then(r=>{const l=m(process),h=d.spawn(r,[],{cwd:o,env:l});h.on("error",i),h.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=f,f.WAIT_MESSAGE=w.localize(3,null);function m(a){const d={...a.env};return(0,k.sanitizeProcessEnvironment)(d),d}function p(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(w.localize(5,null,a.path)):a}function M(a){let d="";for(let c of a)c.indexOf(" ")>=0?d+='"'+c+'"':d+=c,d+=" ";return d}}),define(ee[18],te([0,1,35,9,25,13,7,147,5]),function(K,e,v,n,D,C,k,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function w(H){return H.create===!0}e.isFileOpenForWriteOptions=w;var E;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var P;(function(H){H[H.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var S;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=y;function t(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=t;function f(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function p(H){return y(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var M;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(M=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(G,j){super(G);this.code=j}}e.FileSystemProviderError=a;function d(H,G){const j=new a(H.toString(),G);return o(j,G),j}e.createFileSystemProviderError=d;function c(H){return H||d((0,I.localize)(0,null),M.Unknown)}e.ensureFileSystemProviderError=c;function o(H,G){return H.name=G?`${G} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function u(H){if(!H)return M.Unknown;if(H instanceof a)return H.code;const G=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!G)return M.Unknown;switch(G[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileExceedsMemoryLimit:return M.FileExceedsMemoryLimit;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}e.toFileSystemProviderErrorCode=u;function s(H){if(H instanceof R)return H.fileOperationResult;switch(u(H)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 10;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileExceedsMemoryLimit:return 9;case M.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(G,j,N){this.resource=G,this.operation=j,this.target=N}isOperation(G){return this.operation===G}}e.FileOperationEvent=r;var l;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class h{constructor(G,j){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const N=new Map;for(const B of G){const Y=N.get(B.type);switch(Y?Y.push([B.resource,B]):N.set(B.type,[[B.resource,B]]),B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}}for(const[B,Y]of N)switch(B){case 1:this.added=v.TernarySearchTree.forUris(()=>j),this.added.fill(Y);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>j),this.updated.fill(Y);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>j),this.deleted.fill(Y);break}}contains(G,...j){return this.doContains(G,{includeChildren:!1},...j)}affects(G,...j){return this.doContains(G,{includeChildren:!0},...j)}doContains(G,j,...N){if(!G)return!1;const B=N.length>0;return!!((!B||N.includes(1))&&(this.added?.get(G)||j.includeChildren&&this.added?.findSuperstr(G))||(!B||N.includes(0))&&(this.updated?.get(G)||j.includeChildren&&this.updated?.findSuperstr(G))||(!B||N.includes(2))&&(this.deleted?.findSubstr(G)||j.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function b(H,G,j){return!H||!G||H===G||G.length>H.length?!1:(G.charAt(G.length-1)!==n.sep&&(G+=n.sep),j?(0,D.startsWithIgnoreCase)(H,G):H.indexOf(G)===0)}e.isParent=b;class R extends Error{constructor(G,j,N){super(G);this.fileOperationResult=j,this.options=N}}e.FileOperationError=R;class L extends R{constructor(G,j,N){super(G,2,N);this.stat=j}}e.NotModifiedSinceFileOperationError=L;var F;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var z;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=Q;async function oe(H,G){if(!G.hasProvider(k.URI.from({scheme:H.scheme})))return new Promise(j=>{const N=G.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===H.scheme&&B.added&&(N.dispose(),j())})})}e.whenProviderRegistered=oe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(G){return(0,C.isNumber)(G)||(G=0),G<re.KB?(0,I.localize)(1,null,G.toFixed(0)):G<re.MB?(0,I.localize)(2,null,(G/re.KB).toFixed(2)):G<re.GB?(0,I.localize)(3,null,(G/re.MB).toFixed(2)):G<re.TB?(0,I.localize)(4,null,(G/re.GB).toFixed(2)):(0,I.localize)(5,null,(G/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var q;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function x(H){return{maxFileSize:H===0?300*re.MB:16*re.GB,maxHeapSize:H===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=x}),define(ee[53],te([0,1,253,141,89,18]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(S,y){const t={onUnknownOption:m=>{console.warn((0,n.localize)(0,null,m))},onMultipleValues:(m,p)=>{console.warn((0,n.localize)(1,null,m,p))},onDeprecatedOption:(m,p)=>{console.warn((0,n.localize)(2,null,m,p))}},f=(0,D.parseArgs)(S,D.OPTIONS,y?t:void 0);return f.goto&&f._.forEach(m=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,n.localize)(3,null))),f["max-memory"]&&v(parseInt(f["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),f}function I(S){const y=S.findIndex(t=>!/^-/.test(t));if(y>-1)return[...S.slice(0,y),...S.slice(y+1)]}function g(S){let[,...y]=S;process.env.VSCODE_DEV&&(y=I(y)||[]);const t=!P(process.env);return k(y,t)}e.parseMainProcessArgv=g;function w(S){const[,,...y]=S;return k(y,!0)}e.parseCLIProcessArgv=w;function E(S,...y){const t=S.indexOf("--");return t===-1?S.push(...y):S.splice(t,0,...y),S}e.addArg=E;function P(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(ee[92],te([0,1,44,9,142,21,39,15,3,32,135,53,8]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let t;async function f(p,M,a){return M["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(a)&&!M["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(a)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=S.Promises.withAsyncBody(async(d,c)=>{const o=new C.CancellationTokenSource,u=setTimeout(()=>{o.dispose(!0),c(new Error((0,D.localize)(0,null)))},y);try{d(await m(p,o.token))}catch(s){!(0,I.isCancellationError)(s)&&!o.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(s)))):d({})}finally{clearTimeout(u),o.dispose()}})),t)}e.getResolvedShellEnv=f;async function m(p,M){const a=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",a);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",d);const c=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",u);const s=await(0,E.getSystemShell)(g.OS,u);return p.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(M.isCancellationRequested)return r((0,I.canceled)());const l=(0,n.basename)(s);let h,b;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(h=`& '${process.execPath}' ${R} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,b=["-Login","-Command"]):(h=`'${process.execPath}' ${R} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"?b=["-ic"]:b=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),h);const L=(0,v.spawn)(s,[...b,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});M.onCancellationRequested(()=>(L.kill(),r((0,I.canceled)()))),L.on("error",Q=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),r(Q)});const F=[];L.stdout.on("data",Q=>F.push(Q));const z=[];L.stderr.on("data",Q=>z.push(Q)),L.on("close",(Q,oe)=>{const re=Buffer.concat(F).toString("utf8");p.trace("getUnixShellEnvironment#raw",re);const q=Buffer.concat(z).toString("utf8");if(q.trim()&&p.trace("getUnixShellEnvironment#stderr",q),Q||oe)return r(new Error((0,D.localize)(2,null,Q,oe)));const x=o.exec(re),H=x?x[1]:"{}";try{const G=JSON.parse(H);a?G.ELECTRON_RUN_AS_NODE=a:delete G.ELECTRON_RUN_AS_NODE,d?G.ELECTRON_NO_ATTACH_CONSOLE=d:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",G),i(G)}catch(G){p.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(G)),r(G)}})})}}),define(ee[179],te([0,1,17,39,15,4,2,51,7,32,18]),function(K,e,v,n,D,C,k,I,g,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends k.Disposable{constructor(y,t){super();this.channel=y,this.extraCapabilities=t,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,t){const{buffer:f}=await this.channel.call("readFile",[y,t]);return f}readFileStream(y,t,f){const m=(0,I.newWriteableStream)(M=>v.VSBuffer.concat(M.map(a=>v.VSBuffer.wrap(a))).buffer),p=this.channel.listen("readFileStream",[y,t])(M=>{if(M instanceof v.VSBuffer)m.write(M.buffer);else{if(M==="end")m.end();else{let a=M;a instanceof Error||(a=(0,E.createFileSystemProviderError)((0,n.toErrorMessage)(a),E.FileSystemProviderErrorCode.Unknown)),m.error(a),m.end()}p.dispose()}});return f.onCancellationRequested(()=>{m.error((0,D.canceled)()),m.end(),p.dispose()}),m}writeFile(y,t,f){return this.channel.call("writeFile",[y,v.VSBuffer.wrap(t),f])}open(y,t){return this.channel.call("open",[y,t])}close(y){return this.channel.call("close",[y])}async read(y,t,f,m,p){const[M,a]=await this.channel.call("read",[y,t,p]);return f.set(M.buffer.slice(0,a),m),a}write(y,t,f,m,p){return this.channel.call("write",[y,t,v.VSBuffer.wrap(f),m,p])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,t){return this.channel.call("delete",[y,t])}rename(y,t,f){return this.channel.call("rename",[y,t,f])}copy(y,t,f){return this.channel.call("copy",[y,t,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const t=y;this._onDidChange.fire(t.map(f=>({resource:g.URI.revive(f.resource),type:f.type})))}else{const t=y;this._onDidWatchError.fire(t)}}))}watch(y,t){const f=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,f,y,t]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,f]))}}e.DiskFileSystemProviderClient=P}),define(ee[93],te([0,1,17,15,148,18]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(E,P,S,y,t,f){let m;try{await I(E,P,S,y,t,f)}catch(p){m=p}finally{m&&t.errorTransformer&&(m=t.errorTransformer(m)),typeof m!="undefined"&&S.error(m),S.end()}}e.readFileIntoStream=k;async function I(E,P,S,y,t,f){g(f);const m=await E.open(P,{create:!1});try{g(f);let p=0,M=0,a=t&&typeof t.length=="number"?t.length:void 0,d=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof a=="number"?a:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,o=0;do M=await E.read(m,c,d.buffer,o,d.byteLength-o),c+=M,o+=M,p+=M,typeof a=="number"&&(a-=M),o===d.byteLength&&(await S.write(y(d)),d=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof a=="number"?a:t.bufferSize)),o=0);while(M>0&&(typeof a!="number"||a>0)&&g(f)&&w(p,t));if(o>0){let u=o;typeof a=="number"&&(u=Math.min(o,a)),S.write(y(d.slice(0,u)))}}catch(p){throw(0,C.ensureFileSystemProviderError)(p)}finally{await E.close(m)}}function g(E){if(E.isCancellationRequested)throw(0,n.canceled)();return!0}function w(E,P){if(P?.limits){if(typeof P.limits.memory=="number"&&E>P.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&E>P.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[63],te([0,1,2,3,7,18]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class k extends v.Disposable{constructor(P,S,y){super();this.onFileChanges=P,this.onLogMessage=S,this.verboseLogging=y,this.watcherDisposables=this._register(new v.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const P=new v.DisposableStore;this.watcherDisposables.value=P,this.watcher=this.createWatcher(P),this.watcher.setVerboseLogging(this.verboseLogging),P.add(this.watcher.onDidChangeFile(S=>this.onFileChanges(S))),P.add(this.watcher.onDidLogMessage(S=>this.onLogMessage(S))),P.add(this.watcher.onDidError(S=>this.onError(S)))}onError(P){this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${P}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${P}`)}restart(P){this.restartCounter++,this.init(),this.watch(P)}async watch(P){this.requests=P,await this.watcher?.watch(P)}async setVerboseLogging(P){this.verboseLogging=P,await this.watcher?.setVerboseLogging(P)}error(P){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${P}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=k,k.MAX_RESTARTS=5;function I(E){return E.map(P=>({type:P.type,resource:D.URI.file(P.path)}))}e.toFileChanges=I;function g(E){const P=new w;for(const S of E)P.processEvent(S);return P.coalesce()}e.coalesceEvents=g;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(P){return n.isLinux?P.path:P.path.toLowerCase()}processEvent(P){const S=this.mapPathToChange.get(this.toKey(P));let y=!1;if(S){const t=S.type,f=P.type;S.path!==P.path&&(P.type===2||P.type===1)?y=!0:t===1&&f===2?(this.mapPathToChange.delete(this.toKey(P)),this.coalesced.delete(S)):t===2&&f===1?S.type=0:t===1&&f===0||(S.type=f)}else y=!0;y&&(this.coalesced.add(P),this.mapPathToChange.set(this.toKey(P),P))}coalesce(){const P=[],S=[];return Array.from(this.coalesced).filter(y=>y.type!==2?(P.push(y),!1):!0).sort((y,t)=>y.path.length-t.path.length).filter(y=>S.some(t=>(0,C.isParent)(y.path,t,!n.isLinux))?!1:(S.push(y.path),!0)).concat(P)}}}),define(ee[94],te([0,1,28,8,21,27,114,2,72,9,3,84,24,63]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcher=void 0;class t extends I.Disposable{constructor(p,M,a,d){super();this.request=p,this.onDidFilesChange=M,this.onLogMessage=a,this.verboseLogging=d,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,k.parse)(c)),this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const p=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;this.trace(`Request to start watching: ${p} (excludes: ${this.request.excludes}))}`);const M=await S.Promises.stat(p);this._register(await this.doWatch(p,M.isDirectory()))}catch(p){p.code!=="ENOENT"?this.error(p):this.trace(p)}}async normalizePath(p){let M=p.path;try{M=await S.Promises.realpath(p.path),p.path===M&&(M=await(0,P.realcase)(p.path)??p.path),p.path!==M&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${M})`)}catch{}return M}async doWatch(p,M){if(E.isMacintosh&&(0,C.isEqualOrParent)(p,"/Volumes/"))return this.error(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.Disposable.None;const a=new D.CancellationTokenSource(this.cts.token);let d=new I.DisposableStore;try{const c=(0,w.basename)(p),o=(0,v.watch)(p);d.add((0,I.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const u=new Set;if(M)try{for(const i of await S.Promises.readdir(p))u.add(i)}catch(i){this.error(i)}const s=new Map;d.add((0,I.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),o.on("error",(i,r)=>{this.error(`Failed to watch ${p} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),o.on("change",(i,r)=>{if(a.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let l="";if(r&&(l=r.toString(),E.isMacintosh&&(l=(0,g.normalizeNFC)(l))),!(!l||i!=="change"&&i!=="rename"))if(M)if(i==="rename"){s.get(l)?.dispose();const h=setTimeout(async()=>{if(s.delete(l),l===c&&!await S.Promises.exists(p)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.existsChildStrictCase((0,w.join)(p,l));if(a.token.isCancellationRequested)return;let R;b?u.has(l)?R=0:(R=1,u.add(l)):(u.delete(l),R=2),this.onFileChange({path:(0,w.join)(this.request.path,l),type:R})},t.FILE_DELETE_HANDLER_DELAY);s.set(l,(0,I.toDisposable)(()=>clearTimeout(h)))}else{let h;u.has(l)?h=0:(h=1,u.add(l)),this.onFileChange({path:(0,w.join)(this.request.path,l),type:h})}else if(i==="rename"||l!==c){const h=setTimeout(async()=>{const b=await S.Promises.exists(p);a.token.isCancellationRequested||(b?(this.onFileChange({path:this.request.path,type:0},!0),d.add(await this.doWatch(p,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);d.clear(),d.add((0,I.toDisposable)(()=>clearTimeout(h)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await S.Promises.exists(p)&&!a.token.isCancellationRequested&&this.error(`Failed to watch ${p} for changes using fs.watch() (${c.toString()})`)}return(0,I.toDisposable)(()=>{a.dispose(!0),d.dispose()})}async onFileChange(p,M=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),!M&&this.excludes.some(a=>a(p.path))?this.verboseLogging&&this.trace(` >> ignored ${p.path}`):this.fileChangesBuffer.push(p);try{await this.fileChangesDelayer.trigger(async()=>{const a=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,y.coalesceEvents)(a);if(d.length>0){if(this.verboseLogging)for(const o of d)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(d)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(p){if(E.isLinux)return S.Promises.exists(p);try{const M=(0,w.basename)(p);return(await S.Promises.readdir((0,w.dirname)(p))).some(d=>d===M)}catch(M){return this.trace(M),!1}}setVerboseLogging(p){this.verboseLogging=p}error(p){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}warn(p){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}trace(p){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.trace("stopping file watcher"),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcher=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function f(m,p,M,a,d=512){const c=await S.Promises.open(m,"r"),o=Buffer.allocUnsafe(d),u=new D.CancellationTokenSource(a);let s,i=!1;const r={path:m,excludes:[]},l=new t(r,h=>{(async()=>{for(const{type:b}of h)if(b===0){if(i)return;i=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:R}=await S.Promises.read(c,o,0,d,null);if(!R||u.token.isCancellationRequested)break;p(o.slice(0,R))}}catch(R){s=new Error(R),u.dispose(!0)}finally{i=!1}}})()});return await l.ready,M(),new Promise((h,b)=>{u.token.onCancellationRequested(async()=>{l.dispose();try{await S.Promises.close(c)}catch(R){s=new Error(R)}s?b(s):h()})})}e.watchFileContents=f}),define(ee[180],te([0,1,10,37,136,63]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class k extends C.AbstractRecursiveWatcherClient{constructor(g,w,E){super(g,w,E);this.init()}createWatcher(g){const w=g.add(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(w.onDidProcessExit(({code:E,signal:P})=>this.onError(`terminated by itself with code ${E}, signal: ${P}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(w.getChannel("watcher")))}}e.ParcelWatcherClient=k}),define(ee[76],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[C,k]of D)this.set(C,k)}set(D,C){const k=this._entries.get(D);return this._entries.set(D,C),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(ee[181],te([0,1,8,15,62,173,5,76]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const g=!1;class w extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class E{constructor(t=new I.ServiceCollection,f=!1,m){this._activeInstantiations=new Set,this._services=t,this._strict=f,this._parent=m,this._services.set(k.IInstantiationService,this)}createChild(t){return new E(t,this._strict,this)}invokeFunction(t,...f){let m=S.traceInvocation(t),p=!1;try{return t({get:a=>{if(p)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(a,m);if(!d)throw new Error(`[invokeFunction] unknown service '${a}'`);return d}},...f)}finally{p=!0,m.stop()}}createInstance(t,...f){let m,p;return t instanceof D.SyncDescriptor?(m=S.traceCreation(t.ctor),p=this._createInstance(t.ctor,t.staticArguments.concat(f),m)):(m=S.traceCreation(t),p=this._createInstance(t,f,m)),m.stop(),p}_createInstance(t,f=[],m){let p=k._util.getServiceDependencies(t).sort((d,c)=>d.index-c.index),M=[];for(const d of p){let c=this._getOrCreateServiceInstance(d.id,m);if(!c&&this._strict&&!d.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${d.id}.`);M.push(c)}let a=p.length>0?p[0].index:f.length;if(f.length!==a){console.warn(`[createInstance] First service dependency of ${t.name} at position ${a+1} conflicts with ${f.length} static arguments`);let d=a-f.length;d>0?f=f.concat(new Array(d)):f=f.slice(0,a)}return new t(...[...f,...M])}_setServiceInstance(t,f){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,f);else if(this._parent)this._parent._setServiceInstance(t,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let f=this._services.get(t);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):f}_getOrCreateServiceInstance(t,f){let m=this._getServiceInstanceOrDescriptor(t);return m instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,m,f.branch(t,!0)):(f.branch(t,!1),m)}_safeCreateAndCacheServiceInstance(t,f,m){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,f,m)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,f,m){const p=new C.Graph(d=>d.id.toString());let M=0;const a=[{id:t,desc:f,_trace:m}];for(;a.length;){const d=a.pop();if(p.lookupOrInsertNode(d),M++>1e3)throw new w(p);for(let c of k._util.getServiceDependencies(d.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(c.id);if(!o&&!c.optional&&console.warn(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const u={id:c.id,desc:o,_trace:d._trace.branch(c.id,!0)};p.insertEdge(d,u),a.push(u)}}}for(;;){const d=p.roots();if(d.length===0){if(!p.isEmpty())throw new w(p);break}for(const{data:c}of d){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const u=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,u)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,f,m=[],p,M){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(f,m,p,M);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,f,m,p,M);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(t,f=[],m,p){if(m){const M=new v.IdleValue(()=>this._createInstance(t,f,p));return new Proxy(Object.create(null),{get(a,d){if(d in a)return a[d];let c=M.value,o=c[d];return typeof o!="function"||(o=o.bind(c),a[d]=o),o},set(a,d,c){return M.value[d]=c,!0}})}else return this._createInstance(t,f,p)}}e.InstantiationService=E;var P;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(P||(P={}));class S{constructor(t,f){this.type=t,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return g?new S(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(t){return g?new S(0,t.name):S._None}branch(t,f){let m=new S(2,t.toString());return this._dep.push([t,f,m]),m}stop(){let t=Date.now()-this._start;S._totals+=t;let f=!1;function m(M,a){let d=[],c=new Array(M+1).join("	");for(const[o,u,s]of a._dep)if(u&&s){f=!0,d.push(`${c}CREATES -> ${o}`);let i=m(M+1,s);i&&d.push(i)}else d.push(`${c}uses -> ${o}`);return d.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(t>2||f)&&console.log(p.join(`
`))}}S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(ee[182],te([0,1,15,133,59]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends D.ResolvedKeybinding{constructor(I,g){super();if(g.length===0)throw(0,v.illegalArgument)("parts");this._os=I,this._parts=g}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new D.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=C}),define(ee[183],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class v{constructor(C,k,I,g,w,E,P){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?n(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=n(C.getSingleModifierDispatchParts())),this.bubble=k?k.charCodeAt(0)===94:!1,this.command=this.bubble?k.substr(1):k,this.commandArgs=I,this.when=g,this.isDefault=w,this.extensionId=E,this.isBuiltinExtension=P}}e.ResolvedKeybindingItem=v;function n(D){let C=[];for(let k=0,I=D.length;k<I;k++){const g=D[k];if(!g)return C;C.push(g)}return C}e.removeElementsAfterNulls=n}),define(ee[184],te([0,1,81,59,182,183]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends D.BaseResolvedKeybinding{constructor(g,w){super(w,g.parts)}_keyCodeToUILabel(g){if(this._os===2)switch(g){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(g)}_getLabel(g){return g.isDuplicateModifierCase()?"":this._keyCodeToUILabel(g.keyCode)}_getAriaLabel(g){return g.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(g.keyCode)}_getElectronAccelerator(g){return v.KeyCodeUtils.toElectronAccelerator(g.keyCode)}_getUserSettingsLabel(g){if(g.isDuplicateModifierCase())return"";const w=v.KeyCodeUtils.toUserSettingsUS(g.keyCode);return w&&w.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(g){return k.getDispatchStr(g)}static getDispatchStr(g){if(g.isModifierKey())return null;let w="";return g.ctrlKey&&(w+="ctrl+"),g.shiftKey&&(w+="shift+"),g.altKey&&(w+="alt+"),g.metaKey&&(w+="meta+"),w+=v.KeyCodeUtils.toString(g.keyCode),w}_getSingleModifierDispatchPart(g){return g.keyCode===5&&!g.shiftKey&&!g.altKey&&!g.metaKey?"ctrl":g.keyCode===4&&!g.ctrlKey&&!g.altKey&&!g.metaKey?"shift":g.keyCode===6&&!g.ctrlKey&&!g.shiftKey&&!g.metaKey?"alt":g.keyCode===57&&!g.ctrlKey&&!g.shiftKey&&!g.altKey?"meta":null}static _scanCodeToKeyCode(g){const w=v.IMMUTABLE_CODE_TO_KEY_CODE[g];if(w!==-1)return w;switch(g){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(g){if(!g)return null;if(g instanceof n.SimpleKeybinding)return g;const w=this._scanCodeToKeyCode(g.scanCode);return w===0?null:new n.SimpleKeybinding(g.ctrlKey,g.shiftKey,g.altKey,g.metaKey,w)}static resolveUserBinding(g,w){const E=(0,C.removeElementsAfterNulls)(g.map(P=>this._resolveSimpleUserBinding(P)));return E.length>0?[new k(new n.ChordKeybinding(E),w)]:[]}}e.USLayoutResolvedKeybinding=k}),define(ee[185],te([0,1,8]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(D,C){if(D.length===0)return Promise.resolve(!1);const k=[];let I=!1;for(let g of D){if(g===!0)return Promise.resolve(!0);(0,v.isThenable)(g)&&k.push(g.then(w=>{w&&(I=!0)},w=>{C(w),I=!0}))}return v.Promises.settled(k).then(()=>I)}e.handleVetos=n}),define(ee[6],te([0,1,39,4,2,3,5]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function I(){return new Date().toISOString()}var g;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;function w(u,s,i){switch(s){case g.Trace:u.trace(i);break;case g.Debug:u.debug(i);break;case g.Info:u.info(i);break;case g.Warning:u.warn(i);break;case g.Error:u.error(i);break;case g.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=w;function E(u){let s="";for(let i=0;i<u.length;i++){let r=u[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=E;class P extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class S extends P{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(g.Trace)&&this.log(g.Trace,E([s,...i]))}debug(s,...i){this.checkLogLevel(g.Debug)&&this.log(g.Debug,E([s,...i]))}info(s,...i){this.checkLogLevel(g.Info)&&this.log(g.Info,E([s,...i]))}warn(s,...i){this.checkLogLevel(g.Warning)&&this.log(g.Warning,E([s,...i]))}error(s,...i){if(this.checkLogLevel(g.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(g.Error,E(r))}else this.log(g.Error,E([s,...i]))}critical(s,...i){this.checkLogLevel(g.Critical)&&this.log(g.Critical,E([s,...i]))}flush(){}}e.AbstractMessageLogger=S;class y extends P{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!C.isWindows}trace(s,...i){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}debug(s,...i){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}info(s,...i){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}warn(s,...i){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,s,...i):console.warn(`[main ${I()}]`,s,...i))}error(s,...i){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,s,...i):console.error(`[main ${I()}]`,s,...i))}critical(s,...i){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,s,...i):console.error(`[main ${I()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class t extends P{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class f extends P{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,v.toErrorMessage)(s,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class m extends P{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=m;class p extends D.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=p;class M extends D.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?g.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=M;class a{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(s){}getLevel(){return g.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=a;function d(u){if(u.verbose)return g.Trace;if(typeof u.logLevel=="string"){const s=c(u.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function c(u){switch(u){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=c;function o(u){switch(u){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=o});var ne=this&&this.__param||function(K,e){return function(v,n){e(v,n,K)}};define(ee[95],te([0,1,174,172,4,2,6,3,48,5]),function(K,e,v,n,D,C,k,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=e.ICredentialsMainService=void 0,e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");let E=class ft extends C.Disposable{constructor(S,y){super();this.logService=S,this.environmentMainService=y,this._onDidChangePassword=this._register(new D.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(S,y){const t=await this.withKeytar(),f=await t.getPassword(S,y);if(f)try{let{content:m,hasNextChunk:p}=JSON.parse(f);if(!m||!p)return f;let M=1;for(;p;){const a=await t.getPassword(S,`${y}-${M}`),d=JSON.parse(a);m+=d.content,p=d.hasNextChunk,M++}return m}catch{return f}return f}async setPassword(S,y,t){const f=await this.withKeytar(),m=3,p=async(M,a,d)=>{let c=0,o;for(;c<m;)try{await f.setPassword(M,a,d);return}catch(u){o=u,this.logService.warn("Error attempting to set a password: ",u),c++,await new Promise(s=>setTimeout(s,200))}throw o};if(I.isWindows&&t.length>ft.MAX_PASSWORD_LENGTH){let M=0,a=0,d=!0;for(;d;){const c=t.substring(M,M+ft.PASSWORD_CHUNK_SIZE);M+=ft.PASSWORD_CHUNK_SIZE,d=t.length-M>0;const o={content:c,hasNextChunk:d};await p(S,a?`${y}-${a}`:y,JSON.stringify(o)),a++}}else await p(S,y,t);this._onDidChangePassword.fire({service:S,account:y})}async deletePassword(S,y){const f=await(await this.withKeytar()).deletePassword(S,y);return f&&this._onDidChangePassword.fire({service:S,account:y}),f}async findPassword(S){return(await this.withKeytar()).findPassword(S)}async findCredentials(S){return(await this.withKeytar()).findCredentials(S)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((S,y)=>{K(["keytar"],S,y)})}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=de([ne(0,k.ILogService),ne(1,g.INativeEnvironmentService)],E),e.CredentialsMainService=E,(0,n.registerSingleton)(v.ICredentialsService,E,!0)}),define(ee[186],te([0,1,31,8,15,4,2,9,63,6]),function(K,e,v,n,D,C,k,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends k.Disposable{constructor(S){super();this.logService=S,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(S,y){return y.recursive?this.watchRecursive(S,y):this.watchNonRecursive(S,y)}watchRecursive(S,y){const t={path:this.toFilePath(S),excludes:y.excludes},f=(0,v.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(S=>this._onDidChangeFile.fire((0,g.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.massageRecursiveWatchRequests(this.recursiveFoldersToWatch),this.recursiveWatcher.watch(this.recursiveFoldersToWatch)}massageRecursiveWatchRequests(S){}watchNonRecursive(S,y){const t=new k.DisposableStore,f=t.add(this.createNonRecursiveWatcher({path:this.toFilePath(S),excludes:y.excludes},m=>this._onDidChangeFile.fire((0,g.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===w.LogLevel.Trace));return t.add(this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})),t}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,I.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(ee[187],te([0,1,31,8,17,21,4,71,70,2,35,10,64,16,51,146,18,93,6]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends w.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${c}`);const u=new w.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),u.add(o.onDidChangeFile(s=>this._onDidFilesChange.fire(new m.FileChangesEvent(s,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&u.add(o.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),u.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,w.dispose)(u)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(u){o.push(u)}}),!this.provider.has(c)&&await n.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const u=this.provider.get(c.scheme);return!!(u&&u.capabilities&o)}listCapabilities(){return g.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,y.isAbsolutePath)(c))throw new m.FileOperationError((0,f.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const u=new Error;throw u.name="ENOPRO",u.message=(0,f.localize)(1,null,c.toString()),u}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o)||(0,m.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(u){throw(0,m.toFileSystemProviderErrorCode)(u)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,f.localize)(2,null,this.resourceForError(c)),1):(0,m.ensureFileSystemProviderError)(u)}}async doResolveFile(c,o){const u=await this.withProvider(c),s=this.isPathCaseSensitive(u),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,l=o?.resolveMetadata,h=await u.stat(c);let b;return this.toFileStat(u,c,h,void 0,!!l,(R,L)=>(b||(b=E.TernarySearchTree.forUris(()=>!s),b.set(c,!0),i&&b.fill(!0,i)),b.get(R.resource)||b.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&r?L===1:!1))}async toFileStat(c,o,u,s,i,r){const{providerExtUri:l}=this.getExtUri(c),h={resource:o,name:l.basename(o),isFile:(u.type&m.FileType.File)!=0,isDirectory:(u.type&m.FileType.Directory)!=0,isSymbolicLink:(u.type&m.FileType.SymbolicLink)!=0,mtime:u.mtime,ctime:u.ctime,size:u.size,readonly:Boolean((u.permissions??0)&m.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,m.etag)({mtime:u.mtime,size:u.size})};if(h.isDirectory&&r(h,s)){try{const b=await c.readdir(o),R=await n.Promises.settled(b.map(async([L,F])=>{try{const z=l.joinPath(o,L),Q=i?await c.stat(z):{type:F};return await this.toFileStat(c,z,Q,b.length,i,r)}catch(z){return this.logService.trace(z),null}}));h.children=(0,v.coalesce)(R)}catch(b){this.logService.trace(b),h.children=[]}return h}return h}async resolveAll(c){return n.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(u){return this.logService.trace(u),{stat:void 0,success:!1}}}))}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(u){return u}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new m.FileOperationError((0,f.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=D.VSBuffer.fromString(""),u){await this.doValidateCreateFile(c,u);const s=await this.writeFile(c,o);return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,s)),s}async writeFile(c,o,u){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,u)||await this.mkdirp(s,i.dirname(c));let l;if((0,m.hasReadWriteCapability)(s)&&!(o instanceof D.VSBuffer))if((0,t.isReadableStream)(o)){const h=await(0,t.peekStream)(o,3);h.ended?l=D.VSBuffer.concat(h.buffer):l=h}else l=(0,t.peekReadable)(o,h=>D.VSBuffer.concat(h),3);else l=o;!(0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)&&l instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,u,l):await this.doWriteBuffered(s,c,u,l instanceof D.VSBuffer?(0,D.bufferToReadable)(l):l)}catch(r){throw new m.FileOperationError((0,f.localize)(4,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),u)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,u){if(!!u?.unlock&&!(c.capabilities&8192))throw new Error((0,f.localize)(5,null,this.resourceForError(o)));let i;try{i=await c.stat(o)}catch{return}if((i.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,f.localize)(6,null,this.resourceForError(o)),0,u);if(this.throwIfFileIsReadonly(o,i),typeof u?.mtime=="number"&&typeof u.etag=="string"&&u.etag!==m.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&u.mtime<i.mtime&&u.etag!==(0,m.etag)({mtime:u.mtime,size:i.size}))throw new m.FileOperationError((0,f.localize)(7,null),3,u);return i}async readFile(c,o,u){const s=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(s,c,o,u):this.doReadFile(s,c,o,u)}async doReadFileAtomic(c,o,u,s){return new Promise((i,r)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(c,o,u,s);i(l)}catch(l){r(l)}})})}async doReadFile(c,o,u,s){const i=await this.doReadFileStream(c,o,{...u,preferUnbuffered:!0},s);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(c,o,u){const s=await this.withReadProvider(c);return this.doReadFileStream(s,c,o,u)}async doReadFileStream(c,o,u,s){const i=new C.CancellationTokenSource(s),r=this.validateReadFile(o,u).then(h=>h,h=>{throw i.cancel(),h});let l;try{return typeof u?.etag=="string"&&u.etag!==m.ETAG_DISABLED&&await r,u?.atomic&&(0,m.hasFileAtomicReadCapability)(c)||!((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasFileReadStreamCapability)(c))||(0,m.hasReadWriteCapability)(c)&&u?.preferUnbuffered?l=this.readFileUnbuffered(c,o,u):(0,m.hasFileReadStreamCapability)(c)?l=this.readFileStreamed(c,o,i.token,u):l=this.readFileBuffered(c,o,i.token,u),{...await r,value:l}}catch(h){l&&await(0,t.consumeStream)(l);const b=(0,f.localize)(8,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(h).toString());throw h instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(b,h.stat,u):new m.FileOperationError(b,(0,m.toFileOperationResult)(h),u)}}readFileStreamed(c,o,u,s=Object.create(null)){const i=c.readFileStream(o,s,u);return(0,t.transform)(i,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new m.FileOperationError((0,f.localize)(9,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},r=>D.VSBuffer.concat(r))}readFileBuffered(c,o,u,s=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,o,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new m.FileOperationError((0,f.localize)(10,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},u),i}readFileUnbuffered(c,o,u){const s=(0,t.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;u?.atomic&&(0,m.hasFileAtomicReadCapability)(c)?i=await c.readFile(o,{atomic:!0}):i=await c.readFile(o),typeof u?.position=="number"&&(i=i.slice(u.position)),typeof u?.length=="number"&&(i=i.slice(0,u.length)),this.validateReadFileLimits(o,i.byteLength,u),s.end(D.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,o){const u=await this.resolve(c,{resolveMetadata:!0});if(u.isDirectory)throw new m.FileOperationError((0,f.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.ETAG_DISABLED&&o.etag===u.etag)throw new m.NotModifiedSinceFileOperationError((0,f.localize)(12,null),u,o);return this.validateReadFileLimits(c,u.size,o),u}validateReadFileLimits(c,o,u){if(u?.limits){let s;if(typeof u.limits.memory=="number"&&o>u.limits.memory&&(s=9),typeof u.limits.size=="number"&&o>u.limits.size&&(s=7),typeof s=="number")throw new m.FileOperationError((0,f.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,o,u){return this.doCanMoveCopy(c,o,"move",u)}async canCopy(c,o,u){return this.doCanMoveCopy(c,o,"copy",u)}async doCanMoveCopy(c,o,u,s){if(c.toString()!==o.toString())try{const i=u==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,c,r,o,u,s)}catch(i){return i}return!0}async move(c,o,u){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"move",!!u),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="move"?2:3,l)),l}async copy(c,o,u){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"copy",!!u),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="copy"?3:2,l)),l}async doMoveCopy(c,o,u,s,i,r){if(o.toString()===s.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(c,o,u,s,i,r);if(l&&!h&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(u,this.getExtUri(u).providerExtUri.dirname(s)),i==="copy"){if(c===u&&(0,m.hasFileFolderCopyCapability)(c))await c.copy(o,s,{overwrite:r});else{const b=await this.resolve(o);b.isDirectory?await this.doCopyFolder(c,b,u,s):await this.doCopyFile(c,o,u,s)}return i}else return c===u?(await c.rename(o,s,{overwrite:r}),i):(await this.doMoveCopy(c,o,u,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,u,s){if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(u))return this.doPipeBuffered(c,o,u,s);if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasReadWriteCapability)(u))return this.doPipeBufferedToUnbuffered(c,o,u,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(u))return this.doPipeUnbufferedToBuffered(c,o,u,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasReadWriteCapability)(u))return this.doPipeUnbuffered(c,o,u,s)}async doCopyFolder(c,o,u,s){await u.mkdir(s),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(u).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),u,r):this.doCopyFile(c,i.resource,u,r)}))}async doValidateMoveCopy(c,o,u,s,i,r){let l=!1;if(c===u){const{providerExtUri:b,isPathCaseSensitive:R}=this.getExtUri(c);if(R||(l=b.isEqual(o,s)),l&&i==="copy")throw new Error((0,f.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!l&&b.isEqualOrParent(s,o))throw new Error((0,f.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const h=await this.exists(s);if(h&&!l){if(!r)throw new m.FileOperationError((0,f.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(c===u){const{providerExtUri:b}=this.getExtUri(c);if(b.isEqualOrParent(o,s))throw new Error((0,f.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:h,isSameResourceWithDifferentPathCase:l}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,u)),u}async mkdirp(c,o){const u=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(o,s.dirname(o));)try{if(((await c.stat(o)).type&m.FileType.Directory)==0)throw new Error((0,f.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;u.push(s.basename(o)),o=s.dirname(o)}for(let i=u.length-1;i>=0;i--){o=s.joinPath(o,u[i]);try{await c.mkdir(o)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(u){return u}return!0}async doValidateDelete(c,o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(u.capabilities&4096))throw new Error((0,f.localize)(19,null,this.resourceForError(c)));let i;try{i=await u.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new m.FileOperationError((0,f.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,f.localize)(21,null,this.resourceForError(c)))}return u}async del(c,o){const u=await this.doValidateDelete(c,o),s=!!o?.useTrash,i=!!o?.recursive;await u.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new m.FileOperationEvent(c,1))}watch(c,o={recursive:!1,excludes:[]}){const u=new w.DisposableStore;let s=!1,i=()=>{s=!0};return u.add((0,w.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(c,o);s?(0,w.dispose)(r):i=()=>(0,w.dispose)(r)}catch(r){this.logService.error(r)}})(),u}async doWatch(c,o){const u=await this.withProvider(c),s=(0,I.hash)([this.getExtUri(u).providerExtUri.getComparisonKey(c),o]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:u.watch(c,o)},this.activeWatchers.set(s,i)),i.count+=1,(0,w.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,w.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,w.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,u,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(o,{create:!0,unlock:u?.unlock??!1});try{(0,t.isReadableStream)(s)||(0,t.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,o,u){let s=0,i;if((0,t.isReadableBufferedStream)(u)){if(u.buffer.length>0){const r=D.VSBuffer.concat(u.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,s,0),s+=r.byteLength}if(u.ended)return;i=u.stream}else i=u;return new Promise((r,l)=>{(0,t.listenStream)(i,{onData:async h=>{i.pause();try{await this.doWriteBuffer(c,o,h,h.byteLength,s,0)}catch(b){return l(b)}s+=h.byteLength,setTimeout(()=>i.resume())},onError:h=>l(h),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,u){let s=0,i;for(;(i=u.read())!==null;)await this.doWriteBuffer(c,o,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,o,u,s,i,r){let l=0;for(;l<s;)l+=await c.write(o,i+l,u.buffer,r+l,s-l)}async doWriteUnbuffered(c,o,u,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,u,s))}async doWriteUnbufferedQueued(c,o,u,s){let i;s instanceof D.VSBuffer?i=s:(0,t.isReadableStream)(s)?i=await(0,D.streamToBuffer)(s):(0,t.isReadableBufferedStream)(s)?i=await(0,D.bufferedStreamToBuffer)(s):i=(0,D.readableToBuffer)(s),await c.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:u?.unlock??!1})}async doPipeBuffered(c,o,u,s){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,u,s))}async doPipeBufferedQueued(c,o,u,s){let i,r;try{i=await c.open(o,{create:!1}),r=await u.open(s,{create:!0,unlock:!1});const l=D.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,b=0,R=0;do R=await c.read(i,h,l.buffer,b,l.byteLength-b),await this.doWriteBuffer(u,r,l,R,h,b),h+=R,b+=R,b===l.byteLength&&(b=0);while(R>0)}catch(l){throw(0,m.ensureFileSystemProviderError)(l)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?u.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,u,s){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,u,s))}async doPipeUnbufferedQueued(c,o,u,s){return u.writeFile(s,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,u,s){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,u,s))}async doPipeUnbufferedToBufferedQueued(c,o,u,s){const i=await u.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(u,i,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await u.close(i)}}async doPipeBufferedToUnbuffered(c,o,u,s){const i=await(0,D.streamToBuffer)(this.readFileBuffered(c,o,C.CancellationToken.None));await this.doWriteUnbuffered(u,s,void 0,i)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new m.FileOperationError((0,f.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,f.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===P.Schemas.file?c.fsPath:c.toString(!0)}};a=de([ne(0,M.ILogService)],a),e.FileService=a}),define(ee[188],te([0,1,14,149,3,7,18,94,9,2,63,6,171,115]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends S.AbstractDiskFileSystemProviderChannel{constructor(p,M){super(p,M)}getUriTransformer(p){return y.DefaultURITransformer}transformIncoming(p,M){return C.URI.revive(M)}async delete(p,M,a){if(!a.useTrash)return super.delete(p,M,a);const d=this.transformIncoming(p,M),c=(0,g.normalize)(d.fsPath);try{await v.shell.trashItem(c)}catch{throw(0,k.createFileSystemProviderError)(D.isWindows?(0,n.localize)(0,null,(0,g.basename)(c)):(0,n.localize)(1,null,(0,g.basename)(c)),k.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(p,M){return new f(M,this.logService)}}e.DiskFileSystemProviderChannel=t;class f extends w.Disposable{constructor(p,M){super();this.sessionEmitter=p,this.logService=M,this.watcherRequests=new Map}watch(p,M,a){if(a.recursive)throw(0,k.createFileSystemProviderError)("Recursive watcher is not supported from main process",k.FileSystemProviderErrorCode.Unavailable);const d=new w.DisposableStore;this.watcherRequests.set(p,d),d.add((0,w.toDisposable)(()=>this.watcherRequests.delete(p)));const c=d.add(new I.NodeJSFileWatcher({path:(0,g.normalize)(M.fsPath),excludes:a.excludes},o=>this.sessionEmitter.fire((0,E.toFileChanges)(o)),o=>this.onWatcherLogMessage(o),this.logService.getLevel()===P.LogLevel.Trace));return d.add(this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})),d}onWatcherLogMessage(p){p.type==="error"&&this.sessionEmitter.fire(p.message),this.logService[p.type](p.message)}dispose(){super.dispose();for(const[,p]of this.watcherRequests)p.dispose();this.watcherRequests.clear()}}}),define(ee[96],te([0,1,28,254,8,35,17,4,27,2,9,3,16,51,24,150,18,93,94,180,186,39]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(v)}catch(u){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(u)}`)}})();class o extends d.AbstractDiskFileSystemProvider{constructor(s,i){super(s);this.options=i,this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new C.ResourceMap(r=>S.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await t.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await t.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async l=>{try{let h;l.isSymbolicLink()?h=(await this.stat((0,S.joinPath)(s,l.name))).type:h=this.toType(l),r.push([l.name,h])}catch(h){this.logService.trace(h)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=m.FileType.Unknown:s.isFile()?r=m.FileType.File:s.isDirectory()?r=m.FileType.Directory:r=m.FileType.Unknown,i&&(r|=m.FileType.SymbolicLink),r}async createResourceLock(s){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(s)})`);let i;for(;i=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(s)})`),await i.wait();const r=new D.Barrier;return this.resourceLocks.set(s,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(s)})`),(0,w.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(s)})`),this.resourceLocks.delete(s),r.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const l=this.toFilePath(s);return await t.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{r?.dispose()}}readFileStream(s,i,r){const l=(0,y.newWriteableStream)(h=>k.VSBuffer.concat(h.map(b=>k.VSBuffer.wrap(b))).buffer);return(0,p.readFileIntoStream)(this,s,l,h=>h.buffer,{...i,bufferSize:256*1024},r),l}async writeFile(s,i,r){let l;try{const h=this.toFilePath(s);if(!r.create||!r.overwrite){if(await t.Promises.exists(h)){if(!r.overwrite)throw(0,m.createFileSystemProviderError)((0,f.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,m.createFileSystemProviderError)((0,f.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof l=="number"&&await this.close(l)}}async open(s,i){let r;(0,m.isFileOpenForWriteOptions)(i)&&(r=await this.createResourceLock(s));let l;try{const h=this.toFilePath(s);if((0,m.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:R}=await t.SymlinkSupport.stat(h);R.mode&128||await t.Promises.chmod(h,R.mode|128)}catch(R){this.logService.trace(R)}let b;if((0,m.isFileOpenForWriteOptions)(i)){if(P.isWindows)try{await t.Promises.truncate(h,0),b="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}b||(b="w")}else b="r";l=await t.Promises.open(h,b)}catch(h){throw r?.dispose(),(0,m.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}return this.mapHandleToPos.set(l,0),(0,m.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(l,s),r&&this.mapHandleToLock.set(l,r),l}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await t.Promises.fdatasync(s)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(s)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(s);i&&(this.mapHandleToLock.delete(s),i.dispose())}}async read(s,i,r,l,h){const b=this.normalizePos(s,i);let R=null;try{const{bytesRead:L}=await t.Promises.read(s,r,l,h,b);return L}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(s,b,R)}}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const l=this.mapHandleToPos.get(s);typeof l=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,l+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,l,h){return(0,D.retry)(()=>this.doWrite(s,i,r,l,h),100,3)}async doWrite(s,i,r,l,h){const b=this.normalizePos(s,i);let R=null;try{const{bytesWritten:L}=await t.Promises.write(s,r,l,h,b);return L}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),L)}finally{this.updatePos(s,b,R)}}async mkdir(s){try{await t.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);i.recursive?await t.Promises.rm(r,t.RimRafMode.MOVE):await t.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const l=this.toFilePath(s),h=this.toFilePath(i);if(l!==h)try{await this.validateTargetDeleted(s,i,"move",r.overwrite),await t.Promises.move(l,h)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,f.localize)(2,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(h)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(s,i,r){const l=this.toFilePath(s),h=this.toFilePath(i);if(l!==h)try{await this.validateTargetDeleted(s,i,"copy",r.overwrite),await t.Promises.copy(l,h,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,f.localize)(3,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(h)),b.toString()))),this.toFileSystemProviderError(b)}}async validateTargetDeleted(s,i,r,l){const h=this.toFilePath(s),b=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,g.isEqual)(h,b,!0)),R&&r==="copy")throw(0,m.createFileSystemProviderError)((0,f.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!R&&await t.Promises.exists(b)){if(!l)throw(0,m.createFileSystemProviderError)((0,f.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,i,r){return new a.ParcelWatcherClient(l=>s(l),l=>i(l),r)}massageRecursiveWatchRequests(s){const i=this.options?.watcher?.usePolling;if(i===!0)for(const r of s)r.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(i))for(const r of s)i.includes(r.path)&&(r.pollingInterval=this.options?.watcher?.pollingInterval??5e3)}createNonRecursiveWatcher(s,i,r,l){return new M.NodeJSFileWatcher(s,h=>i(h),h=>r(h),l)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=m.FileSystemProviderErrorCode.NoPermissions;break;default:i=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await t.SymlinkSupport.stat(this.toFilePath(s));l.mode&128||(r=(0,m.createFileSystemProviderError)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return r}}e.DiskFileSystemProvider=o}),define(ee[97],te([0,1,6]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(C,k){switch(k){case v.LogLevel.Trace:return C.trace;case v.LogLevel.Debug:return C.debug;case v.LogLevel.Info:return C.info;case v.LogLevel.Warning:return C.warn;case v.LogLevel.Error:return C.error;case v.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(k=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(k){this._logger=k;for(const{level:I,args:g}of this.buffer)n(k,I).apply(k,g);this.buffer=[]}_log(k,...I){this._logger?n(this._logger,k).apply(this._logger,I):this.getLevel()<=k&&this.buffer.push({level:k,args:I})}trace(k,...I){this._log(v.LogLevel.Trace,k,...I)}debug(k,...I){this._log(v.LogLevel.Debug,k,...I)}info(k,...I){this._log(v.LogLevel.Info,k,...I)}warn(k,...I){this._log(v.LogLevel.Warning,k,...I)}error(k,...I){this._log(v.LogLevel.Error,k,...I)}critical(k,...I){this._log(v.LogLevel.Critical,k,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(ee[189],te([0,1,8,17,16,18,5,97,6]),function(K,e,v,n,D,C,k,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*C.ByteSize.MB;let E=class extends g.AbstractLogger{constructor(y,t,f,m,p){super();this.name=y,this.resource=t,this.donotUseFormatters=m,this.fileService=p,this.backupIndex=1,this.setLevel(f),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=g.LogLevel.Trace&&this._log(g.LogLevel.Trace,(0,g.format)(arguments))}debug(){this.getLevel()<=g.LogLevel.Debug&&this._log(g.LogLevel.Debug,(0,g.format)(arguments))}info(){this.getLevel()<=g.LogLevel.Info&&this._log(g.LogLevel.Info,(0,g.format)(arguments))}warn(){this.getLevel()<=g.LogLevel.Warning&&this._log(g.LogLevel.Warning,(0,g.format)(arguments))}error(){if(this.getLevel()<=g.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=y.stack,this._log(g.LogLevel.Error,(0,g.format)(t))}else this._log(g.LogLevel.Error,(0,g.format)(arguments))}}critical(){this.getLevel()<=g.LogLevel.Critical&&this._log(g.LogLevel.Critical,(0,g.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,t){this.queue.queue(async()=>{await this.initializePromise;let f=await this.loadContent();f.length>w&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(f)),f=""),this.donotUseFormatters?f+=t:f+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(f))})}getCurrentTimestamp(){const y=m=>m<10?`0${m}`:m,t=m=>m<10?`00${m}`:m<100?`0${m}`:m,f=new Date;return`${f.getFullYear()}-${y(f.getMonth()+1)}-${y(f.getDate())} ${y(f.getHours())}:${y(f.getMinutes())}:${y(f.getSeconds())}.${t(f.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(y){switch(y){case g.LogLevel.Critical:return"critical";case g.LogLevel.Debug:return"debug";case g.LogLevel.Error:return"error";case g.LogLevel.Info:return"info";case g.LogLevel.Trace:return"trace";case g.LogLevel.Warning:return"warning"}return""}};E=de([ne(4,C.IFileService)],E),e.FileLogger=E;let P=class extends g.AbstractLoggerService{constructor(y,t,f){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=t,this.fileService=f}doCreateLogger(y,t,f){const m=new I.BufferLogService(t);return(0,C.whenProviderRegistered)(y,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(E,f?.name||(0,D.basename)(y),y,m.getLevel(),!!f?.donotUseFormatters)),m}};P=de([ne(0,g.ILogService),ne(1,k.IInstantiationService),ne(2,C.IFileService)],P),e.FileLoggerService=P}),define(ee[190],te([0,1,4,7,6]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(S){this.service=S,this.onDidChangeLogLevel=v.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(S,y,t){switch(y){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=C;class k{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){k.setLevel(this.channel,S)}static setLevel(S,y){return S.call("setLevel",y)}}e.LogLevelChannelClient=k;class I{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,y){throw new Error(`Event not found: ${y}`)}async call(S,y,t){switch(y){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${y}`)}createLogger(S,y){this.loggers.set(S.toString(),this.loggerService.createLogger(S,y))}consoleLog(S,y){let t=console.log;switch(S){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...y)}log(S,y){const t=this.loggers.get(S.toString());if(!t)throw new Error("Create the logger before logging");for(const[f,m]of y)(0,D.log)(t,f,m)}}e.LoggerChannel=I;class g extends D.AbstractLoggerService{constructor(S,y,t){super(S,y);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,y)=>{this.channel.call("consoleLog",[S,y])}})}doCreateLogger(S,y,t){return new w(this.channel,S,y,t)}}e.LoggerChannelClient=g;class w extends D.AbstractMessageLogger{constructor(S,y,t,f){super(f?.always);this.channel=S,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[y,f]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,y){const t=[[S,y]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(S){this.channel.call("log",[this.file,S])}}class E extends D.LogService{constructor(S,y){super(y);this.parent=S,this._register(S.onDidChangeLogLevel(t=>y.setLevel(t)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=E}),define(ee[98],te([0,1,18,6]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(I,g,w,E,P){try{const S=await new Promise((t,f)=>{K(["spdlog"],t,f)});S.setFlushOn(n.LogLevel.Trace);const y=await S.createAsyncRotatingLogger(I,g,w,E);return P&&y.clearFormatters(),y}catch(S){console.error(S)}return null}function C(I,g,w){switch(g){case n.LogLevel.Trace:I.trace(w);break;case n.LogLevel.Debug:I.debug(w);break;case n.LogLevel.Info:I.info(w);break;case n.LogLevel.Warning:I.warn(w);break;case n.LogLevel.Error:I.error(w);break;case n.LogLevel.Critical:I.critical(w);break;default:throw new Error("Invalid log level")}}class k extends n.AbstractMessageLogger{constructor(g,w,E,P,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(g,w,E,P),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(g,w,E,P){const S=E?6:1,y=30/S*v.ByteSize.MB,t=await D(g,w,y,S,P);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:f,message:m}of this.buffer)C(this._logger,f,m);this.buffer=[]}}log(g,w){this._logger?C(this._logger,g,w):this.getLevel()<=g&&this.buffer.push({level:g,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ee[191],te([0,1,10,16,32,18,189,6,98]),function(K,e,v,n,D,C,k,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends I.AbstractLoggerService{constructor(P,S){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=S}doCreateLogger(P,S,y){return P.scheme===v.Schemas.file?new g.SpdLogLogger(y?.name||(0,D.generateUuid)(),P.fsPath,!y?.donotRotate,!!y?.donotUseFormatters,S):new k.FileLogger(y?.name??(0,n.basename)(P),P,S,!!y?.donotUseFormatters,this.fileService)}};w=de([ne(0,I.ILogService),ne(1,C.IFileService)],w),e.LoggerService=w}),define(ee[192],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function n(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function D(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function C(k){return!v(k)&&!n(k)&&!D(k)}e.isMenubarMenuItemAction=C}),define(ee[54],te([0,1,10,3,34,16]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const I=n.globals.vscode.context.configuration();if(I)k=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const I=(0,C.dirname)(v.FileAccess.asFileUri("",K));k=K.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath);const g=K.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:g.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(ee[22],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[193],te([0,1,60,6,22]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(I,g){this.productService=I,this.logService=g,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,g){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(g);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,E,P]=w;let S=this.trustedExtensionUrlPublicKeys.get(I);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[I],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...S])}const y=Buffer.from(decodeURIComponent(P),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const t=y.slice(0,6),f=y.readUIntBE(0,6),m=Date.now()-f;if(m<0||m>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const p=y.slice(6),M=v.createVerify("SHA256");M.write(t),M.write(Buffer.from(E)),M.end();for(let a=0;a<S.length;a++){let d=S[a];if(d!==null){if(typeof d=="string")try{d=v.createPublicKey({key:Buffer.from(d,"base64"),format:"der",type:"spki"}),S[a]=d}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${a+1} for ${I}:`,c),S[a]=null;continue}if(M.verify(d,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};C=de([ne(0,D.IProductService),ne(1,n.ILogService)],C),e.ExtensionUrlTrustService=C}),define(ee[55],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(ee[194],te([0,1,14,2,35,10,3,16,7,32,48,6]),function(K,e,v,n,D,C,k,I,g,w,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=class extends n.Disposable{constructor(t,f){super();this.logService=f,this.validRoots=D.TernarySearchTree.forUris(()=>!k.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(g.URI.file(t.appRoot)),this.addValidFileRoot(g.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=v.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(f,m)=>this.handleResourceRequest(f,m)),t.protocol.interceptFileProtocol(C.Schemas.file,(f,m)=>this.handleFileRequest(f,m)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?n.Disposable.None:(this.validRoots.set(t,!0),(0,n.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,f){const m=g.URI.parse(t.url);return this.logService.error(`Refused to load resource ${m.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),f({error:-3})}handleResourceRequest(t,f){const m=g.URI.parse(t.url),p=C.FileAccess.asFileUri(m);return this.validRoots.findSubstr(p)?f({path:p.fsPath}):this.validExtensions.has((0,I.extname)(p))?f({path:p.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${p.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),f({error:-3}))}createIPCObjectUrl(){let t;const f=g.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),m=f.toString(),p=async()=>t;return v.ipcMain.handle(m,p),this.logService.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:f,update:M=>t=M,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${m}.`),v.ipcMain.removeHandler(m)}}}};S=de([ne(0,E.INativeEnvironmentService),ne(1,P.ILogService)],S),e.ProtocolMainService=S}),define(ee[40],te([0,1,104,13]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,I){v.ok(n.isString(k)),v.ok(n.isObject(I)),v.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,I)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(ee[195],te([0,1,4,40]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,w){this.schemasById[D(g)]=w,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new C;n.Registry.add(e.Extensions.JSONContribution,k)}),define(ee[56],te([0,1,31,4,13,138,195,40]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=I.Registry.as(k.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,o=!0){this.registerConfigurations([c],o)}registerConfigurations(c,o=!0){const u=this.doRegisterConfigurations(c,o);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}deregisterConfigurations(c){const o=this.doDeregisterConfigurations(c);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:c,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(c,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(u)})}registerDefaultConfigurations(c){const o=[],u=[];for(const{overrides:s,source:i}of c)for(const r in s)if(o.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const l={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:l});const h={type:"object",default:l,description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:D.isString(i)?void 0:i};u.push(...t(r)),this.configurationProperties[r]=h,this.defaultLanguageConfigurationOverridesNode.properties[r]=h}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const l=this.configurationProperties[r];l&&(this.updatePropertyDefaultValue(r,l),this.updateSchema(r,l))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const o=[];for(const{overrides:u,source:s}of c)for(const i in u){const r=this.configurationDefaultsOverrides.get(i),l=D.isString(s)?s:s?.id,h=D.isString(r?.source)?r?.source:r?.source?.id;if(l===h)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const b=this.configurationProperties[i];b&&(this.updatePropertyDefaultValue(i,b),this.updateSchema(i,b))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const o of c)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,o){const u=[];return c.forEach(s=>{u.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),u}doDeregisterConfigurations(c){const o=[],u=s=>{if(s.properties)for(const i in s.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>u(i))};for(const s of c){u(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(c,o=!0,u,s,i=3){i=D.isUndefinedOrNull(c.scope)?i:c.scope;let r=[],l=c.properties;if(l)for(let b in l){if(o&&M(b)){delete l[b];continue}const R=l[b];if(R.source=u,R.defaultDefaultValue=l[b].default,this.updatePropertyDefaultValue(b,R),e.OVERRIDE_PROPERTY_REGEX.test(b)?R.scope=void 0:(R.scope=D.isUndefinedOrNull(R.scope)?i:R.scope,R.restricted=D.isUndefinedOrNull(R.restricted)?!!s?.includes(b):R.restricted),l[b].hasOwnProperty("included")&&!l[b].included){this.excludedConfigurationProperties[b]=l[b],delete l[b];continue}else this.configurationProperties[b]=l[b];!l[b].deprecationMessage&&l[b].markdownDeprecationMessage&&(l[b].deprecationMessage=l[b].markdownDeprecationMessage),r.push(b)}let h=c.allOf;if(h)for(let b of h)r.push(...this.validateAndRegisterProperties(b,o,u,s,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const o=u=>{let s=u.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let i=u.allOf;i&&i.forEach(o)};o(c)}updateSchema(c,o){switch(e.allSettings.properties[c]=o,o.scope){case 1:e.applicationSettings.properties[c]=o;break;case 2:e.machineSettings.properties[c]=o;break;case 6:e.machineOverridableSettings.properties[c]=o;break;case 3:e.windowSettings.properties[c]=o;break;case 4:e.resourceSettings.properties[c]=o;break;case 5:e.resourceSettings.properties[c]=o,this.resourceLanguageSettingsSchema.properties[c]=o;break}}removeFromSchema(c,o){switch(delete e.allSettings.properties[c],o.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const o=`[${c}]`,u={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,o){const u=this.configurationDefaultsOverrides.get(c);let s=u?.value,i=u?.source;D.isUndefined(s)&&(s=o.defaultDefaultValue,i=void 0),D.isUndefined(s)&&(s=m(o.type)),o.default=s,o.defaultValueSource=i}}const S="\\[([^\\]]+)\\]",y=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(d){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let o=y.exec(d);for(;o?.length;){const u=o[1].trim();u&&c.push(u),o=y.exec(d)}}return(0,v.distinct)(c)}e.overrideIdentifiersFromKey=t;function f(d){return d.reduce((c,o)=>`${c}[${o}]`,"")}e.keyFromOverrideIdentifiers=f;function m(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const p=new P;I.Registry.add(e.Extensions.Configuration,p);function M(d){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?C.localize(7,null,d):p.getConfigurationProperties()[d]!==void 0?C.localize(8,null,d):null:C.localize(6,null)}e.validateProperty=M;function a(){const d=[],c=p.getConfigurationProperties();for(const o of Object.keys(c))d.push([o,c[o].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=a}),define(ee[196],te([0,1,31,4,43,2,35,47,13,7,19,56,40]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(s={},i=[],r=[]){this._contents=s,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,E.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,E.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return v.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return v.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=I.deepClone(this.contents),r=I.deepClone(this.overrides),l=[...this.keys];for(const h of s){this.mergeContents(i,h.contents);for(const b of h.overrides){const[R]=r.filter(L=>v.equals(L.identifiers,b.identifiers));R?(this.mergeContents(R.contents,b.contents),R.keys.push(...b.keys),R.keys=v.distinct(R.keys)):r.push(I.deepClone(b))}for(const b of h.keys)l.indexOf(b)===-1&&l.push(b)}return new y(i,l,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const l of v.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[l],b=i[l];b&&(typeof h=="object"&&typeof b=="object"?(h=I.deepClone(h),this.mergeContents(h,b)):h=b),r[l]=h}return new y(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&g.isObject(s[r])&&g.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=I.deepClone(i[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?I.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,r=null;const l=h=>{h&&(r?this.mergeContents(r,h):r=I.deepClone(h))};for(const h of this.overrides)v.equals(h.identifiers,[s])?i=h.contents:h.identifiers.includes(s)&&l(h.contents);return l(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,E.addToValueTree)(this.contents,s,i,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,E.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let r=0;r<i;r++)s.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=y;class t extends y{constructor(s={}){const i=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),l=Object.create(null),h=[];for(const b in i){const R=s[b],L=R!==void 0?R:i[b].default;(0,E.addToValueTree)(l,b,L,F=>console.error(`Conflict in default settings: ${F}`))}for(const b of Object.keys(l))P.OVERRIDE_PROPERTY_REGEX.test(b)&&h.push({identifiers:(0,P.overrideIdentifiersFromKey)(b),keys:Object.keys(l[b]),contents:(0,E.toValuesTree)(l[b],R=>console.error(`Conflict in default settings file: ${R}`))});super(l,r,h)}}e.DefaultConfigurationModel=t;class f{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!g.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:l,overrides:h,restricted:b}=this.doParseRaw(s,i);this._configurationModel=new y(r,l,h),this._restrictedConfigurations=b||[]}doParseContent(s){let i={},r=null,l=[],h=[],b=[];function R(F){Array.isArray(l)?l.push(F):r!==null&&(l[r]=F)}let L={onObjectBegin:()=>{let F={};R(F),h.push(l),l=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{let F=[];R(F),h.push(l),l=F,r=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:R,onError:(F,z,Q)=>{b.push({error:F,offset:z,length:Q})}};if(s)try{D.visit(s,L),i=l[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return i}doParseRaw(s,i){const r=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),l=this.filter(s,r,!0,i);s=l.raw;const h=(0,E.toValuesTree)(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),b=Object.keys(s),R=this.toOverrides(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:h,keys:b,overrides:R,restricted:l.restricted}}filter(s,i,r,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:s,restricted:[]};const h={},b=[];for(let R in s)if(P.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const L=this.filter(s[R],i,!1,l);h[R]=L.raw,b.push(...L.restricted)}else{const L=i[R],F=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&b.push(R),(F===void 0||l.scopes===void 0||l.scopes.includes(F))&&(l.skipRestricted&&L?.restricted||(h[R]=s[R]))}return{raw:h,restricted:b}}toOverrides(s,i){const r=[];for(const l of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(l)){const h={};for(const b in s[l])h[b]=s[l][b];r.push({identifiers:(0,P.overrideIdentifiersFromKey)(l),keys:Object.keys(h),contents:(0,E.toValuesTree)(h,i)})}return r}}e.ConfigurationModelParser=f;class m extends C.Disposable{constructor(s,i,r,l){super();this.userSettingsResource=s,this.scopes=i,this.fileService=l,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class p{constructor(s,i,r=new y,l=new y,h=new k.ResourceMap,b=new y,R=new k.ResourceMap,L=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=l,this._folderConfigurations=h,this._memoryConfiguration=b,this._memoryConfigurationByResource=R,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(s)}updateValue(s,i,r={}){let l;r.resource?(l=this._memoryConfigurationByResource.get(r.resource),l||(l=new y,this._memoryConfigurationByResource.set(r.resource,l))):l=this._memoryConfiguration,i===void 0?l.removeValue(s):l.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const l=this.getConsolidateConfigurationModel(i,r),h=this.getFolderConfigurationModelForResource(i.resource,r),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),z=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),Q=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,oe=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(s):h.freeze().getValue(s):void 0,re=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(s):b.getValue(s),q=l.getValue(s),x=v.distinct(v.flatten(l.overrides.map(H=>H.identifiers))).filter(H=>l.getOverrideValue(s,H)!==void 0);return{defaultValue:R,userValue:L,userLocalValue:F,userRemoteValue:z,workspaceValue:Q,workspaceFolderValue:oe,memoryValue:re,value:q,default:R!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:z!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:oe!==void 0?{value:h?.freeze().getValue(s),override:i.overrideIdentifier?h?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:b.getValue(s),override:i.overrideIdentifier?b.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:l,updated:h,removed:b}=c(this._defaultConfiguration,s);i=[...l,...h,...b]}for(const l of i)for(const h of(0,P.overrideIdentifiersFromKey)(l)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(h),R=s.getKeysForOverrideIdentifier(h),L=[...R.filter(F=>b.indexOf(F)===-1),...b.filter(F=>R.indexOf(F)===-1),...b.filter(F=>!I.equals(this._defaultConfiguration.override(h).getValue(F),s.override(h).getValue(F)))];r.push([h,L])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:l,overrides:h}=c(this.localUserConfiguration,s),b=[...i,...r,...l];return b.length&&this.updateLocalUserConfiguration(s),{keys:b,overrides:h}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:l,overrides:h}=c(this.remoteUserConfiguration,s);let b=[...i,...r,...l];return b.length&&this.updateRemoteUserConfiguration(s),{keys:b,overrides:h}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:l,overrides:h}=c(this.workspaceConfiguration,s);let b=[...i,...r,...l];return b.length&&this.updateWorkspaceConfiguration(s),{keys:b,overrides:h}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:l,updated:h,removed:b,overrides:R}=c(r,i);let L=[...l,...h,...b];return(L.length||!r)&&this.updateFolderConfiguration(s,i),{keys:L,overrides:R}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:l,removed:h,overrides:b}=c(i,void 0);return{keys:[...r,...l,...h],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const l=i.getFolder(s);l&&(r=this.getFolderConsolidatedConfiguration(l.uri)||r);const h=this._memoryConfigurationByResource.get(s);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(s);l?(i=r.merge(l),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:l,keys:h}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:l,keys:h}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(l=>i.add(l))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),l=this.parseConfigurationModel(s.workspace),h=s.folders.reduce((b,R)=>(b.set(w.URI.revive(R[0]),this.parseConfigurationModel(R[1])),b),new k.ResourceMap);return new p(i,r,new y,l,h,new y,new k.ResourceMap,!1)}static parseConfigurationModel(s){return new y(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=p;function M(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const s=new Set,i=new Map;for(const l of u)l.keys.forEach(h=>s.add(h)),l.overrides.forEach(([h,b])=>{const R=(0,k.getOrSet)(i,h,new Set);b.forEach(L=>R.add(L))});const r=[];return i.forEach((l,h)=>r.push([h,[...l.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=M;class a{constructor(s,i,r,l){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=l,this._previousConfiguration=void 0;const h=new Set;s.keys.forEach(R=>h.add(R)),s.overrides.forEach(([,R])=>R.forEach(L=>h.add(L))),this.affectedKeys=[...h.values()];const b=new y;this.affectedKeys.forEach(R=>b.setValue(R,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!I.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let r=(0,E.toValuesTree)({[i]:!0},()=>{}),l;for(;typeof r=="object"&&(l=Object.keys(r)[0]);){if(s=s[l],!s)return!1;r=r[l]}return!0}}e.ConfigurationChangeEvent=a;class d extends a{constructor(s,i,r,l){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=r,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=d;function c(u,s){const{added:i,removed:r,updated:l}=o(s,u),h=[],b=u?.getAllOverrideIdentifiers()||[],R=s?.getAllOverrideIdentifiers()||[];if(s){const L=R.filter(F=>!b.includes(F));for(const F of L)h.push([F,s.getKeysForOverrideIdentifier(F)])}if(u){const L=b.filter(F=>!R.includes(F));for(const F of L)h.push([F,u.getKeysForOverrideIdentifier(F)])}if(s&&u){for(const L of b)if(R.includes(L)){const F=o({contents:u.getOverrideValue(void 0,L)||{},keys:u.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});h.push([L,[...F.added,...F.removed,...F.updated]])}}return{added:i,removed:r,updated:l,overrides:h}}function o(u,s){const i=u?s?u.keys.filter(h=>s.keys.indexOf(h)===-1):[...u.keys]:[],r=s?u?s.keys.filter(h=>u.keys.indexOf(h)===-1):[...s.keys]:[],l=[];if(u&&s){for(const h of s.keys)if(u.keys.indexOf(h)!==-1){const b=(0,E.getConfigurationValue)(s.contents,h),R=(0,E.getConfigurationValue)(u.contents,h);I.equals(b,R)||l.push(h)}}return{added:i,removed:r,updated:l}}}),define(ee[197],te([0,1,8,4,2,16,19,196,56,40]),function(K,e,v,n,D,C,k,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends D.Disposable{constructor(S,y){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,y)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const S=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,S)}getConfigurationData(){return this.configuration.toData()}getValue(S,y){const t=typeof S=="string"?S:void 0,f=(0,k.isConfigurationOverrides)(S)?S:(0,k.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(t,f,void 0)}updateValue(S,y,t,f){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const y=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(t,y,1)}onDidDefaultConfigurationChange(S){const y=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,S);this.trigger(t,y,6)}trigger(S,y,t){const f=new I.ConfigurationChangeEvent(S,{data:y},this.configuration);f.source=t,f.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(S){switch(S){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(ee[198],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var n;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,I=n.Unknown,g){super(k);this._message=k,this._code=I,this._detail=g,this.isHandled=I===n.NotAvailable&&g===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===n.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===n.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(ee[199],te([0,1,8,17,21,15,4,2,32,86,198]),function(K,e,v,n,D,C,k,I,g,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var S;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function y(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(V){const W=new D.CancellationTokenSource;return setTimeout(()=>W.cancel(),V),W.token}function f(V,W){if(V.isCancellationRequested||W.isCancellationRequested)return D.CancellationToken.Cancelled;const $=new D.CancellationTokenSource;return V.onCancellationRequested(()=>$.cancel()),W.onCancellationRequested(()=>$.cancel()),$.token}class m{constructor(W){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise(($,A)=>{this._resolvePromise=$,this._rejectPromise=A}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function p(V,W){const $=new m(W);return $.registerDisposable(V.onControlMessage(A=>{const T=JSON.parse(A.toString()),_=G(T);_?$.reject(_):$.resolve(T)})),$.promise}function M(V,W,$,A,T,_,O){const U=new m(O);return W.connect($,A,T,_,(J,ie)=>{U.didTimeout?(J&&V.error(J),ie?.dispose()):J||!ie?U.reject(J):U.resolve(ie)}),U.promise}function a(V,W){const $=new m(W);return V.then(A=>{$.didTimeout||$.resolve(A)},A=>{$.didTimeout||$.reject(A)}),$.promise}async function d(V,W,$,A){const T=B(V,W);V.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let _;try{_=await M(V.logService,V.socketFactory,V.host,V.port,`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,`renderer-${y(W)}-${V.reconnectionToken}`,A)}catch(se){throw V.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),V.logService.error(se),se}V.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let O,U;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection(_,null),O=V.reconnectionProtocol,U=!1):(O=new w.PersistentProtocol(_,null),U=!0),V.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const J=await a(V.signService.createNewMessage((0,g.generateUuid)()),A),ie={type:"auth",auth:V.connectionToken||"00000000000000000000",data:J.data};O.sendControl(n.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await p(O,f(A,t(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(V.logService.trace(`${T} 4/6. received SignRequest control message.`),!await a(V.signService.validate(J,se.signedData),A)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ce=await a(V.signService.sign(se.data),A),le={type:"connectionType",commit:V.commit,signedData:ce,desiredConnectionType:W};return $&&(le.args=$),V.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),O.sendControl(n.VSBuffer.fromString(JSON.stringify(le))),{protocol:O,ownsProtocol:U}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(V.logService.error(`${T} the handshake timed out. Error:`),V.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${T} received error control message when negotiating connection. Error:`),V.logService.error(se)),U&&H(O),se}}async function c(V,W,$,A){const T=Date.now(),_=B(V,W),{protocol:O,ownsProtocol:U}=await d(V,W,$,A),J=new m(A);return J.registerDisposable(O.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),Z=G(se);Z?(V.logService.error(`${_} received error control message when negotiating connection. Error:`),V.logService.error(Z),U&&H(O),J.reject(Z)):(V.reconnectionProtocol&&V.reconnectionProtocol.endAcceptReconnection(),V.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${Y(T)}!`),J.resolve({protocol:O,firstMessage:se}))})),J.promise}async function o(V,W){const{protocol:$}=await c(V,1,void 0,W);return{protocol:$}}async function u(V,W,$){const{protocol:A,firstMessage:T}=await c(V,2,W,$),_=T&&T.debugPort;return{protocol:A,debugPort:_}}async function s(V,W,$){const A=Date.now(),T=B(V,3),{protocol:_}=await d(V,3,W,$);return V.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${Y(A)}!`),_}async function i(V,W,$){const{host:A,port:T,connectionToken:_}=await V.addressProvider.getAddress();return{commit:V.commit,host:A,port:T,connectionToken:_,reconnectionToken:W,reconnectionProtocol:$,socketFactory:V.socketFactory,signService:V.signService,logService:V.logService}}async function r(V,W,$){try{const A=(0,g.generateUuid)(),T=await i(V,A,null),{protocol:_}=await o(T,D.CancellationToken.None);return new q(V,W,$,A,_)}catch(A){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error(A),re.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(A)),A}}e.connectRemoteAgentManagement=r;async function l(V,W){try{const $=(0,g.generateUuid)(),A=await i(V,$,null),{protocol:T,debugPort:_}=await u(A,W,D.CancellationToken.None);return new x(V,W,$,T,_)}catch($){throw V.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),V.logService.error($),re.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled($)),$}}e.connectRemoteAgentExtensionHost=l;async function h(V,W,$){const A=await i(V,(0,g.generateUuid)(),null);return await s(A,{host:W,port:$},D.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function b(V){return(0,v.createCancelablePromise)(W=>new Promise(($,A)=>{const T=setTimeout($,V*1e3);W.onCancellationRequested(()=>{clearTimeout(T),$()})}))}var R;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(W,$){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=L;class F{constructor(W,$,A,T){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.durationSeconds=A,this.cancellableTimer=T,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class z{constructor(W,$,A){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.attempt=A,this.type=2}}e.ReconnectionRunningEvent=z;class Q{constructor(W,$,A){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.attempt=A,this.type=4}}e.ConnectionGainEvent=Q;class oe{constructor(W,$,A,T){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.attempt=A,this.handled=T,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class re extends I.Disposable{constructor(W,$,A,T){super();this._connectionType=W,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=$,this.reconnectionToken=A,this.protocol=T,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(T.onSocketClose(_=>{const O=N(this._connectionType,this.reconnectionToken,!0);_?_.type===0?(this._options.logService.info(`${O} received socket close event (hadError: ${_.hadError}).`),_.error&&this._options.logService.error(_.error)):(this._options.logService.info(`${O} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this._options.logService.error(_.event)):this._options.logService.info(`${O} received socket close event.`),this._beginReconnecting()})),this._register(T.onSocketTimeout(()=>{const _=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${_} received socket timeout event.`),this._beginReconnecting()})),re._instances.push(this),re._permanentFailure&&this._gotoPermanentFailure(re._permanentFailureMillisSinceLastIncomingData,re._permanentFailureAttempt,re._permanentFailureHandled)}static triggerPermanentFailure(W,$,A){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=$,this._permanentFailureHandled=A,this._instances.forEach(T=>T._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(re._permanentFailure)return;const W=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let A=-1;do{A++;const T=A<$.length?$[A]:$[$.length-1];try{if(T>0){const O=b(T);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,O)),this._options.logService.info(`${W} waiting for ${T} seconds before reconnecting...`);try{await O}catch{}}if(re._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1)),this._options.logService.info(`${W} resolving connection...`);const _=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${_.host}:${_.port}...`),await this._reconnect(_,t(P)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(_),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(A>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(_),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(_)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(_);continue}if((0,C.isCancellationError)(_)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(_);continue}if(_ instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(_),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,E.RemoteAuthorityResolverError.isHandled(_));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(_),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}}while(!re._permanentFailure)}_gotoPermanentFailure(W,$,A){this._onDidStateChange.fire(new oe(this.reconnectionToken,W,$,A)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re._permanentFailureMillisSinceLastIncomingData=0,re._permanentFailureAttempt=0,re._permanentFailureHandled=!1,re._instances=[];class q extends re{constructor(W,$,A,T,_){super(1,W,T,_);this.client=this._register(new w.Client(_,{remoteAuthority:$,clientId:A},W.ipcLogger))}async _reconnect(W,$){await o(W,$)}}e.ManagementPersistentConnection=q;class x extends re{constructor(W,$,A,T,_){super(2,W,A,T);this._startArguments=$,this.debugPort=_}async _reconnect(W,$){await u(W,this._startArguments,$)}}e.ExtensionHostPersistentConnection=x;function H(V){try{V.acceptDisconnect();const W=V.getSocket();V.dispose(),W.dispose()}catch(W){(0,C.onUnexpectedError)(W)}}function G(V){if(V&&V.type==="error"){const W=new Error(`Connection error: ${V.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function j(V,W){for(;V.length<W;)V+=" ";return V}function N(V,W,$){return`[remote-connection][${j(y(V),13)}][${W.substr(0,5)}\u2026][${$?"reconnect":"initial"}]`}function B(V,W){return`${N(W,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.host}:${V.port}]`}function Y(V){return`${Date.now()-V} ms`}}),define(ee[65],te([0,1,10]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(w){return w.scheme===v.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=n;function D(w){if(!w)return;const E=w.indexOf("+");return E<0?w:w.substr(0,E)}e.getRemoteName=D;function C(w){return w.scheme!==v.Schemas.file&&w.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=C;function k(w){if(w.folders.length)return w.folders.every(E=>C(E.uri))?w.folders[0].uri:void 0;if(w.configuration&&C(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=k;function I(w){return k(w)?.scheme}e.getVirtualWorkspaceScheme=I;function g(w){return k(w)!==void 0}e.isVirtualWorkspace=g}),define(ee[200],te([0,1,25,5,65]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=C;function k(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class g{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,t){if(typeof y=="undefined"||y===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof y=="string"||typeof t=="string"){let f=typeof y=="string"?y:y.value,m=typeof t=="string"?t:t.value;return v.equalsIgnoreCase(f,m)}return y._lower===t._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=g;function w(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function E(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function P(S,y){if(y){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(y)}`;return S.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[201],te([0,1,25,200]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,f){return t.uuid&&f.uuid?t.uuid===f.uuid:t.id===f.id?!0:(0,v.compareIgnoreCase)(t.id,f.id)===0}e.areSameExtensions=D;class C{constructor(f,m){this.version=m,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof C?D(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=C;function k(t,f){return`${t}.${f}`}e.getExtensionId=k;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function g(t,f){return I(k(t,f))}e.getGalleryExtensionId=g;function w(t,f){const m=[],p=M=>{for(const a of m)if(a.some(d=>D(f(d),f(M))))return a;return null};for(const M of t){const a=p(M);a?a.push(M):m.push([M])}return m}e.groupByExtension=w;function E(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function P(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function S(t){const f=new Set;if(t.malicious)for(const m of t.malicious)f.add(m.id);return f}e.getMaliciousExtensionsSet=S;function y(t,f){const m=[],p=f.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const M=p.shift();if(M&&m.every(a=>!D(a.identifier,{id:M}))){const a=t.filter(d=>D(d.identifier,{id:M}));a.length===1&&(m.push(a[0]),p.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=y}),define(ee[99],te([0,1,4,3,5,6]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var k;(function(t){t.Http="http",t.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=P;function S(t,f){return f?f!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=S;let y=class{constructor(f){this.logService=f,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(f){return this._tunnelProvider=f,f?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const f=[],m=Array.from(this._tunnels.values());for(let p of m){const M=Array.from(p.values());for(let a of M){const d=await a.value;d&&f.push(d)}}return f}async dispose(){for(const f of this._tunnels.values()){for(const{value:m}of f.values())await m.then(p=>p?.dispose());f.clear()}this._tunnels.clear()}openTunnel(f,m,p,M,a=!1,d=I.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${p} on local port ${M}.`),!f)return;m||(m="localhost");const o=this.retainOrCreateTunnel(f,m,p,M,a,d,c);return o?o.then(u=>{if(!u){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(u);return(u.tunnelRemoteHost!==m||u.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const m=this._tunnels.get(f.tunnelRemoteHost);if(m){const p=m.get(f.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(f.tunnelRemoteHost,f.tunnelRemotePort,p))}}}}async tryDisposeTunnel(f,m,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${m}.`);const M=p.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(f)&&this._tunnels.get(f).delete(m),M}}async closeTunnel(f,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${m} `);const p=this._tunnels.get(f);if(p&&p.has(m)){const M=p.get(m);M.refcount=0,await this.tryDisposeTunnel(f,m,M)}}addTunnelToMap(f,m,p){this._tunnels.has(f)||this._tunnels.set(f,new Map),this._tunnels.get(f).set(m,{refcount:1,value:p})}async removeEmptyTunnelFromMap(f,m){const p=this._tunnels.get(f);p&&(await p.get(m)||p.delete(m),p.size===0&&this._tunnels.delete(f))}getTunnelFromMap(f,m){let p=[f];E(f)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):P(f)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const M=p.map(a=>this._tunnels.get(a));for(const a of M){const d=a?.get(m);if(d)return d}}canTunnel(f){return!!w(f)}createWithProvider(f,m,p,M,a,d,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${p} on local port ${M}.`);const u={elevationRequired:a?S(M===void 0?p:M):!1},s={remoteAddress:{host:m,port:p},localAddressPort:M,privacy:d,public:d!==I.Private,protocol:c},i=f.forwardPort(s,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(m,p,i),i}};y=de([ne(0,C.ILogService)],y),e.AbstractTunnelService=y}),define(ee[49],te([0,1,17,154,56,5,40]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function g(t){return t.res.statusCode===204}async function w(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return g(t)?null:(await(0,v.streamToBuffer)(t.stream)).toString()}e.asText=w;async function E(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(g(t))return null;const m=(await(0,v.streamToBuffer)(t.stream)).toString();try{return JSON.parse(m)}catch(p){throw p.message+=`:
`+m,p}}e.asJson=E;function P(t){y(t)}e.updateProxyConfigurationsScope=P;let S;function y(t){const f=k.Registry.as(D.Extensions.Configuration),m=S;S={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[S],remove:m?[m]:[]})}y(2)}),define(ee[202],te([0,1,203,13]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,I){return k.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:k.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(k,I,g={}){const w=(0,v.parse)(k),E=g.proxyUrl||D(w,I);if(!E)return null;const P=(0,v.parse)(E);if(!/^https?:$/.test(P.protocol||""))return null;const S={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,n.isBoolean)(g.strictSSL)?g.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((y,t)=>{K(["http-proxy-agent"],y,t)}))(S):new(await new Promise((y,t)=>{K(["https-proxy-agent"],y,t)}))(S)}e.getProxyAgent=C}),define(ee[204],te([0,1,17,32]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,k,I){let g=I&&I.get("storage.serviceMachineId",0)||null;if(g)return g;try{const E=(await k.readFile(C.serviceMachineIdResource)).value.toString();g=(0,n.isUUID)(E)?E:null}catch{g=null}if(!g){g=(0,n.generateUuid)();try{await k.writeFile(C.serviceMachineIdResource,v.VSBuffer.fromString(g))}catch{}}return I&&I.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=D}),define(ee[77],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[205],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>K(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),k=new C.validator;if(k){const I=String(v._nextId++);return this.validators.set(I,k),{id:I,data:k.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const k=this.validators.get(D.id);if(!k)return!1;this.validators.delete(D.id);try{return k.validate(C)==="ok"}catch{return!1}}async sign(D){try{const C=await this.vsda(),k=new C.signer;if(k)return k.sign(D)}catch{}return D}}e.SignService=v,v._nextId=1}),define(ee[38],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(ee[20],te([0,1,14,8,4,2,3,34,13,5,185,6,38]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var y;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class gt extends C.Disposable{constructor(m,p){super();this.logService=m,this.stateMainService=p,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(gt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(gt.QUIT_AND_RESTART_KEY)}registerListeners(){const m=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};v.app.addListener("before-quit",m);const p=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",p),v.app.once("will-quit",M=>{this.logService.trace("Lifecycle#app.on(will-quit)"),M.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",m),v.app.removeListener("window-all-closed",p),v.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const m=[];return this._onWillShutdown.fire({join(p){m.push(p)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(m)}catch(p){this.logService.error(p)}try{await this.stateMainService.close()}catch(p){this.logService.error(p)}})(),this.pendingWillShutdownPromise}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===m)return;this.logService.trace(`lifecycle (main): phase changed (value: ${m})`),this._phase=m;const p=this.phaseWhen.get(this._phase);p&&(p.open(),this.phaseWhen.delete(this._phase))}async when(m){if(m<=this._phase)return;let p=this.phaseWhen.get(m);p||(p=new n.Barrier,this.phaseWhen.set(m,p)),await p.wait()}registerWindow(m){const p=new C.DisposableStore;this.windowCounter++,p.add(m.onWillLoad(a=>this._onWillLoadWindow.fire({window:m,workspace:a.workspace,reason:a.reason})));const M=(0,g.assertIsDefined)(m.win);M.on("close",a=>{const d=m.id;if(this.windowToCloseRequest.has(d)){this.windowToCloseRequest.delete(d);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${m.id}`),a.preventDefault(),this.unload(m,1).then(c=>{if(c){this.windowToCloseRequest.delete(d);return}this.windowToCloseRequest.add(d),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${d}`),this._onBeforeCloseWindow.fire(m),m.close()})}),M.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.windowCounter--,p.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(m,p){await this.unload(m,3)||m.reload(p)}async unload(m,p){if(!m.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${m.id}`);const M=this._quitRequested?2:p;let a=await this.onBeforeUnloadWindowInRenderer(m,M);return a?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.handleWindowUnloadVeto(a)):(a=await this.onBeforeUnloadWindowInMain(m,M),a?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${m.id})`),this.handleWindowUnloadVeto(a)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${m.id})`),await this.onWillUnloadWindowInRenderer(m,M),!1))}handleWindowUnloadVeto(m){return m?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(m){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(m),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(m,p){return new Promise(M=>{const a=this.oneTimeListenerTokenGenerator++,d=`vscode:ok${a}`,c=`vscode:cancel${a}`;v.ipcMain.once(d,()=>{M(!1)}),v.ipcMain.once(c,()=>{M(!0)}),m.send("vscode:onBeforeUnload",{okChannel:d,cancelChannel:c,reason:p})})}onBeforeUnloadWindowInMain(m,p){const M=[];return this._onBeforeUnloadWindow.fire({reason:p,window:m,veto(a){M.push(a)}}),(0,E.handleVetos)(M,a=>this.logService.error(a))}onWillUnloadWindowInRenderer(m,p){return new Promise(M=>{const d=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(d,()=>M()),m.send("vscode:onWillUnload",{replyChannel:d,reason:p})})}quit(m){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${m}`),m&&this.stateMainService.setItem(gt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(p=>{this.pendingQuitPromiseResolve=p,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(m){this.logService.trace("Lifecycle#relaunch()");const p=process.argv.slice(1);if(m?.addArgs&&p.push(...m.addArgs),m?.removeArgs)for(const d of m.removeArgs){const c=p.indexOf(d);c>=0&&p.splice(c,1)}const M=()=>{try{if(k.isWindows){const d=(0,I.cwd)();d!==process.cwd()&&process.chdir(d)}}catch(d){this.logService.error(d)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:p})};v.app.once("quit",M),await this.quit(!0)&&v.app.removeListener("quit",M)}async kill(m){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const p of v.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let M;p.webContents&&!p.webContents.isDestroyed()?M=new Promise(a=>p.once("closed",a)):M=Promise.resolve(),p.destroy(),await M}})()]),v.app.exit(m)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=de([ne(0,P.ILogService),ne(1,S.IStateMainService)],t),e.LifecycleMainService=t}),define(ee[206],te([0,1,4,2,5,20]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((E,P)=>{K(["native-keymap"],E,P)});this._keyboardLayoutData=I(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=de([ne(0,C.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function I(g){const w=g.getKeyMap(),E=g.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:E}}}),define(ee[78],te([0,1,8,4,2,64,13,88,5]),function(K,e,v,n,D,C,k,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,g.createDecorator)("storageService");var E;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var S;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));class y extends D.Disposable{constructor(p={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,M){M===w?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:M,target:this.getKeyTargets(p)[M]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,M,a){return this.getStorage(M)?.get(p,a)}getBoolean(p,M,a){return this.getStorage(M)?.getBoolean(p,a)}getNumber(p,M,a){return this.getStorage(M)?.getNumber(p,a)}store(p,M,a,d){if((0,k.isUndefinedOrNull)(M)){this.remove(p,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,a,d),this.getStorage(a)?.set(p,M)})}remove(p,M){this.withPausedEmitters(()=>{this.updateKeyTarget(p,M,void 0),this.getStorage(M)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,M){const a=[],d=this.getKeyTargets(p);for(const c of Object.keys(d))d[c]===M&&a.push(c);return a}updateKeyTarget(p,M,a){const d=this.getKeyTargets(M);typeof a=="number"?d[p]!==a&&(d[p]=a,this.getStorage(M)?.set(w,JSON.stringify(d))):typeof d[p]=="number"&&(delete d[p],this.getStorage(M)?.set(w,JSON.stringify(d)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const M=this.get(w,p);if(M)try{return JSON.parse(M)}catch{}return Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=E.NONE){this._onWillSaveState.fire({reason:p});const M=this.getStorage(0),a=this.getStorage(1);switch(p){case E.NONE:await v.Promises.settled([M?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await v.Promises.settled([M?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async logStorage(){const p=this.getStorage(0)?.items??new Map,M=this.getStorage(1)?.items??new Map;return f(p,M,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends y{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}e.InMemoryStorageService=t;async function f(m,p,M,a){const d=l=>{try{return JSON.parse(l)}catch{return l}},c=new Map,o=new Map;m.forEach((l,h)=>{c.set(h,l),o.set(h,d(l))});const u=new Map,s=new Map;p.forEach((l,h)=>{u.set(h,l),s.set(h,d(l))}),console.group(`Storage: Global (path: ${M})`);let i=[];c.forEach((l,h)=>{i.push({key:h,value:l})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${a})`);let r=[];u.forEach((l,h)=>{r.push({key:h,value:l})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=f}),define(ee[207],te([0,1,3,34,7,32]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(w){if(v.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function I(w,E,P,S,y,t,f,m,p,M){const a=Object.create(null);a["common.machineId"]=f,a.sessionID=(0,C.generateUuid)()+Date.now(),a.commitHash=y,a.version=t,a["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,v.PlatformToString)(v.platform),a["common.nodePlatform"]=n.platform,a["common.nodeArch"]=S,a["common.product"]=M||"desktop";const d=g(m||[]);d&&(a["common.msftInternal"]=d);let c=0;const o=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),v.isLinuxSnap&&(a["common.snap"]="true");const u=k(P);u&&(a["common.platformDetail"]=u);try{const s=await w.readFile(D.URI.file(p));a["common.source"]=s.value.toString().slice(0,30)}catch{}return a}e.resolveCommonProperties=I;function g(w){const E=n.env.USERDNSDOMAIN;if(!E)return!1;const P=E.toLowerCase();return w.some(S=>P===S)}e.verifyMicrosoftInternalDomain=g}),define(ee[29],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[208],te([0,1,26,70,8,43,10,9,3,7,73,24,85,75,18,22,29]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function p(o,u){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const r=v.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:z=>/^[a-z]:\\(my drive|shared drives)\\/.test(z)||z.startsWith(r+"\\my drive\\")},{tag:"dropbox",matcher:z=>z.startsWith(r+"\\dropbox")},{tag:"onedrive",matcher:z=>z.startsWith(r+"\\onedrive")},{tag:"box",matcher:z=>z.startsWith(r+"\\box\\")},{tag:"nextcloud",matcher:z=>z.startsWith(r+"\\nextcloud\\")},{tag:"owncloud",matcher:z=>z.startsWith(r+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:z=>z.startsWith("/volumes/googledrive/")||z.startsWith(r+"/my drive/")},{tag:"dropbox",matcher:z=>z.startsWith(r+"/dropbox")},{tag:"onedrive",matcher:z=>z.startsWith(r+"/onedrive")||z.startsWith(r+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:z=>z.startsWith(r+"/library/mobile documents/")},{tag:"box",matcher:z=>z.startsWith(r+"/box/")},{tag:"nextcloud",matcher:z=>z.startsWith(r+"/nextcloud/")},{tag:"owncloud",matcher:z=>z.startsWith(r+"/owncloud/")}];break}const l=new Map,h=new Map,b=2e4;function R(z,Q,oe,re){for(const x of i){const H=z.toLowerCase();x.matcher(H)&&h.set(x.tag,1)}const q=Q.substring(z.length+1);return D.Promises.withAsyncBody(async x=>{let H;try{H=await P.Promises.readdir(Q,{withFileTypes:!0})}catch{x();return}if(re.count>=b){re.count+=H.length,re.maxReached=!0,x();return}let G=H.length;if(G===0){x();return}let j=H;re.count+H.length>b&&(re.maxReached=!0,G=b-re.count,j=H.slice(0,G)),re.count+=H.length;for(const N of j)if(N.isDirectory()){if(oe.includes(N.name)||await R(z,(0,I.join)(Q,N.name),oe,re),--G==0){x();return}}else{const B=N.name.lastIndexOf(".");if(B>=0){const Y=N.name.substring(B+1);Y&&l.set(Y,(l.get(Y)??0)+1)}for(const Y of s)Y.relativePathPattern?.test(q)!==!1&&Y.filePattern.test(N.name)&&h.set(Y.tag,(h.get(Y.tag)??0)+1);if(--G==0){x();return}}})}const L={count:0,maxReached:!1};await R(o,o,u,L);const F=await d(o);return{configFiles:M(h),fileTypes:M(l),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:F}}e.collectWorkspaceStats=p;function M(o){return[...n.Iterable.map(o.entries(),([u,s])=>({name:u,count:s}))].sort((u,s)=>s.count-u.count)}function a(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},u=v.cpus();return u&&u.length>0&&(o.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),o}e.getMachineInfo=a;async function d(o){try{const u=new Map,s=(0,I.join)(o,".vscode","launch.json"),i=await P.Promises.readFile(s),r=[],l=(0,C.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,C.getNodeType)(l)==="object"&&l.configurations)for(const h of l.configurations){const b=h.type;b&&(u.has(b)?u.set(b,u.get(b)+1):u.set(b,1))}return M(u)}catch{return[]}}e.collectLaunchConfigs=d;let c=class{constructor(u,s){this.telemetryService=u,this.productService=s}formatMachineInfo(u){const s=[];return s.push(`OS Version:       ${u.os}`),s.push(`CPUs:             ${u.cpus}`),s.push(`Memory (System):  ${u.memory}`),s.push(`VM:               ${u.vmHint}`),s.join(`
`)}formatEnvironment(u){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const i=v.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),g.isWindows||s.push(`Load (avg):       ${v.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${u.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(u.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(u,s){return Promise.all([(0,S.listProcesses)(u.mainPID),this.formatWorkspaceMetadata(u)]).then(async i=>{let[r,l]=i,h=this.formatProcessList(u,r);return s.forEach(b=>{if((0,y.isRemoteDiagnosticError)(b))h+=`
${b.errorMessage}`,l+=`
${b.errorMessage}`;else if(h+=`

Remote: ${b.hostName}`,b.processes&&(h+=`
${this.formatProcessList(u,b.processes)}`),b.workspaceMetadata){l+=`
|  Remote: ${b.hostName}`;for(const R of Object.keys(b.workspaceMetadata)){const L=b.workspaceMetadata[R];let F=`${L.fileCount} files`;L.maxFilesReached&&(F=`more than ${F}`),l+=`|    Folder (${R}): ${F}`,l+=this.formatWorkspaceStats(L)}}}),{processInfo:h,workspaceInfo:l}})}async getSystemInfo(u,s){const{memory:i,vmHint:r,os:l,cpus:h}=a(),b={os:l,memory:i,cpus:h,vmHint:r,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:s};return g.isWindows||(b.load=`${v.loadavg().map(R=>Math.round(R)).join(", ")}`),g.isLinux&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(u,s){const i=[];return(0,S.listProcesses)(u.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(u)),i.push(""),i.push(this.formatProcessList(u,r)),u.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(u))),s.forEach(l=>{if((0,y.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.formatMachineInfo(l.machineInfo)),l.processes&&i.push(this.formatProcessList(u,l.processes)),l.workspaceMetadata)for(const h of Object.keys(l.workspaceMetadata)){const b=l.workspaceMetadata[h];let R=`${b.fileCount} files`;b.maxFilesReached&&(R=`more than ${R}`),i.push(`Folder (${h}): ${R}`),i.push(this.formatWorkspaceStats(b))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(u){const s=[],i=60;let r=0;const l=(L,F)=>{const z=` ${L}(${F})`;r+z.length>i?(s.push(h),h="|                 ",r=h.length):r+=z.length,h+=z};let h="|      File types:";const b=10;let R=u.fileTypes.length>b?b:u.fileTypes.length;for(let L=0;L<R;L++){const F=u.fileTypes[L];l(F.name,F.count)}if(s.push(h),u.configFiles.length>=0&&(h="|      Conf files:",r=0,u.configFiles.forEach(L=>{l(L.name,L.count)}),s.push(h)),u.launchConfigFiles.length>0){let L="|      Launch Configs:";u.launchConfigFiles.forEach(F=>{L+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),s.push(L)}return s.join(`
`)}expandGPUFeatures(u){const s=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${u[i]}`).join(`
                  `)}formatWorkspaceMetadata(u){const s=[],i=[];return u.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(l=>{const h=w.URI.revive(l);if(h.scheme===k.Schemas.file){const b=h.fsPath;i.push(p(b,["node_modules",".git"]).then(R=>{let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,I.basename)(b)}): ${L}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${b} (${R.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(u,s){const i=new Map;u.windows.forEach(l=>i.set(l.pid,l.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(u.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(u,s,i,r,l){const h=l===0;let b;h?b=r.pid===u?`${this.productService.applicationName} main`:"remote agent":(b=`${"  ".repeat(l)} ${r.name}`,r.name==="window"&&(b=`${b} (${s.get(r.pid)})`));const R=process.platform==="win32"?r.mem:v.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(r.children)&&r.children.forEach(L=>this.formatProcessItem(u,s,i,L,l+1))}async reportWorkspaceStats(u){for(const{uri:s}of u.folders){const i=w.URI.revive(s);if(i.scheme!==k.Schemas.file)continue;const r=i.fsPath;try{const l=await p(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),l.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:h.name,count:h.count})}),l.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:h.name,count:h.count})}),l.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};c=de([ne(0,m.ITelemetryService),ne(1,f.IProductService)],c),e.DiagnosticsService=c}),define(ee[209],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(C){this.appenders=C}listen(C,k){throw new Error(`Event not found: ${k}`)}call(C,k,{eventName:I,data:g}){return this.appenders.forEach(w=>w.log(I,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class n{constructor(C){this.channel=C}log(C,k){return this.channel.call("log",{eventName:C,data:k}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ee[66],te([0,1,47,13,19,29]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,M){return Promise.resolve(void 0)}publicLog2(p,M){return this.publicLog(p,M)}publicLogError(p,M){return Promise.resolve(void 0)}publicLogError2(p,M){return this.publicLogError(p,M)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class I{async publicLog(p,M,a){}async publicLogError(p,M,a){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(m,p){return p.onDidChangeConfiguration(M=>{M.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(M.source),configurationKeys:t(M.sourceConfig)})})}e.configurationTelemetry=g;function w(m,p){return!(p.disableTelemetry||!m.enableTelemetry)}e.supportsTelemetry=w;function E(m){const p=m.getValue(C.TELEMETRY_SETTING_ID),M=m.getValue("telemetry.enableCrashReporter");if(m.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||M===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function P(m){const p=Object.create(null),M=Object.create(null),a=Object.create(null);y(m,a);for(let d in a){d=d.length>150?d.substr(d.length-149):d;const c=a[d];typeof c=="number"?M[d]=c:typeof c=="boolean"?M[d]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${c.length}`),p[d]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(p[d]=c)}return{properties:p,measurements:M}}e.validateTelemetryData=P;function S(m){if(!m)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(a=>{m.indexOf(`${a}+`)===0&&(p=a)}),p}e.cleanRemoteAuthority=S;function y(m,p,M=0,a){if(!!m)for(let d of Object.getOwnPropertyNames(m)){const c=m[d],o=a?a+d:d;Array.isArray(c)?p[o]=(0,v.safeStringify)(c):c instanceof Date?p[o]=c.toISOString():(0,n.isObject)(c)?M<2?y(c,p,M+1,o+"."):p[o]=(0,v.safeStringify)(c):p[o]=c}}function t(m){if(!m)return[];const p=[];return f(p,"",m),p}function f(m,p,M){M&&typeof M=="object"&&!Array.isArray(M)?Object.keys(M).forEach(a=>f(m,p?`${p}.${a}`:a,M[a])):m.push(p)}}),define(ee[210],te([0,1,31,21,15,47,3,34,13,7,19,48,175,201,170,18,6,22,49,204,78,29,66]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=k.isWeb?"web":(0,S.getTargetPlatform)(k.platform,I.arch);var s;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished"})(s||(s={}));function i(...O){return String(O.reduce((U,J)=>U|J,0))}var r;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class L{constructor(U=R){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,J=this.state.pageSize){return new L({...this.state,pageNumber:U,pageSize:J})}withFilter(U,...J){const ie=[...this.state.criteria,...J.length?J.map(se=>({filterType:U,value:se})):[{filterType:U}]];return new L({...this.state,criteria:ie})}withSortBy(U){return new L({...this.state,sortBy:U})}withSortOrder(U){return new L({...this.state,sortOrder:U})}withFlags(...U){return new L({...this.state,flags:U.reduce((J,ie)=>J|ie,0)})}withAssetTypes(...U){return new L({...this.state,assetTypes:U})}get raw(){const{criteria:U,pageNumber:J,pageSize:ie,sortBy:se,sortOrder:Z,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:U,pageNumber:J,pageSize:ie,sortBy:se,sortOrder:Z}],assetTypes:le,flags:ce}}get searchText(){const U=this.state.criteria.filter(J=>J.filterType===r.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function F(O,U){const J=(O||[]).filter(ie=>ie.statisticName===U)[0];return J?J.value:0}function z(O){const U="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(ie=>ie.assetType.indexOf(U)===0).reduce((ie,se)=>{const Z=q(O,se.assetType);return Z&&ie.push([se.assetType.substring(U.length),Z]),ie},[])}function Q(O){if(O.properties){const U=O.properties.filter(se=>se.key===l.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=U.filter(se=>J.test(se.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return q(O,l.Repository)}function oe(O){return{uri:`${O.fallbackAssetUri}/${l.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${l.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function re(O){const U=q(O,l.Icon);if(U)return U;const J=S.DefaultIconPath;return{uri:J,fallbackUri:J}}function q(O,U){return O.files.filter(ie=>ie.assetType===U)[0]?{uri:`${O.assetUri}/${U}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${U}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function x(O,U){const J=O.properties?O.properties.filter(se=>se.key===U):[],ie=J.length>0&&J[0].value;return ie?ie.split(",").map(se=>(0,y.adoptToGalleryExtensionId)(se)):[]}function H(O){const U=O.properties?O.properties.filter(J=>J.key===h.Engine):[];return U.length>0&&U[0].value||""}function G(O){const U=O.properties?O.properties.filter(J=>J.key===h.PreRelease):[];return U.length>0&&U[0].value==="true"}function j(O){const U=O.properties?O.properties.filter(ie=>ie.key===h.LocalizedLanguages):[],J=U.length>0&&U[0].value||"";return J?J.split(","):[]}function N(O){return O.indexOf("preview")!==-1}function B(O){return O.targetPlatform?(0,S.toTargetPlatform)(O.targetPlatform):"undefined"}function Y(O){const U=(0,v.distinct)(O.versions.map(B)),J=!!O.tags?.includes(S.WEB_EXTENSION_TAG),ie=U.indexOf("web");return J?ie===-1&&U.push("web"):ie!==-1&&U.splice(ie,1),U}function V(O,U){const J=(0,S.getFallbackTargetPlarforms)(U);for(let ie=0;ie<O.length;ie++){const se=O[ie];if(se.version===O[ie-1]?.version){let Z=ie;const ce=B(se);if(ce===U)for(;Z>0&&O[Z-1].version===se.version;)Z--;else if(J.includes(ce))for(;Z>0&&O[Z-1].version===se.version&&B(O[Z-1])!==U;)Z--;Z!==ie&&(O.splice(ie,1),O.splice(Z,0,se))}}return O}e.sortExtensionVersions=V;function W(O,U,J,ie,se){const Z=O.versions[0],ce={manifest:q(U,l.Manifest),readme:q(U,l.Details),changelog:q(U,l.Changelog),license:q(U,l.License),repository:Q(U),download:oe(U),icon:re(U),coreTranslations:z(U)};return{identifier:{id:(0,y.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:U.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,description:O.shortDescription||"",installCount:F(O.statistics,"install"),rating:F(O.statistics,"averagerating"),ratingCount:F(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:J,assets:ce,properties:{dependencies:x(U,h.Dependency),extensionPack:x(U,h.ExtensionPack),engine:H(U),localizedLanguages:j(U),targetPlatform:B(U),isPreReleaseVersion:G(U)},hasPreReleaseVersion:G(Z),hasReleaseVersion:ie,preview:N(O.flags),telemetryData:se}}let $=class{constructor(U,J,ie,se,Z,ce,le,he){this.requestService=J,this.logService=ie,this.environmentService=se,this.telemetryService=Z,this.fileService=ce,this.productService=le,this.configurationService=he;const ge=le.extensionsGallery;this.extensionsGalleryUrl=ge&&ge.serviceUrl,this.extensionsControlUrl=ge&&ge.controlUrl,this.commonHeadersPromise=_(le.version,le,this.environmentService,this.configurationService,this.fileService,U)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,J,ie){const se=(0,g.isBoolean)(J)?J:!1,Z=(0,g.isBoolean)(J)?ie:J;let ce=new L().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,U.length).withFilter(r.ExtensionName,...U.map(({id:ge})=>ge.toLowerCase()));U.every(ge=>!ge.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,u,n.CancellationToken.None),he=le.map(ge=>{const ye=(0,y.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName);return{rawGalleryExtension:ge,version:U.find(fe=>(0,y.areSameExtensions)(fe,{id:ye}))?.version,preRelease:se}});return this.converToGalleryExtensions(he,ce,u,()=>{},Z)}async getExtensions2(U){const J=[],ie=[];for(const le of U)le.uuid?ie.push(le.uuid):J.push(le.id.toLowerCase());let se=new L().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly).withPage(1,U.length);ie.length&&(se=se.withFilter(r.ExtensionId,...ie)),J.length&&(se=se.withFilter(r.ExtensionId,...J));const{galleryExtensions:Z}=await this.queryGallery(se,u,n.CancellationToken.None),ce=Z.map(le=>{const he=(0,y.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName),ge=U.find(ye=>(0,y.areSameExtensions)(ye,{id:he,uuid:le.extensionId}));return{rawGalleryExtension:le,preRelease:!!ge?.preRelease}});return this.converToGalleryExtensions(ce,se,u,()=>{},n.CancellationToken.None)}async getCompatibleExtension(U,J,ie){const se=(0,S.isIExtensionIdentifier)(U)?null:U;if(se){if((0,S.isNotWebExtensionInWebTargetPlatform)(se.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(se,J,ie))return se}const{id:Z,uuid:ce}=se?se.identifier:U;let le=new L().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);ce?le=le.withFilter(r.ExtensionId,ce):le=le.withFilter(r.ExtensionName,Z);const{galleryExtensions:he}=await this.queryGallery(le,ie,n.CancellationToken.None),[ge]=he;if(!ge||!ge.versions.length)return null;const ye=Y(ge);if((0,S.isNotWebExtensionInWebTargetPlatform)(ye,ie))return null;for(let fe of ge.versions){if(!H(fe)){const me=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:h.Engine,value:me}]}}if(await this.isRawExtensionVersionCompatible(fe,J,ye,ie)){const me=ge.versions.some(be=>!G(be));return W(ge,fe,ye,me)}}return null}async isExtensionCompatible(U,J,ie){if(!(0,S.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,ie)||!J&&U.properties.isPreReleaseVersion)return!1;let se=U.properties.engine;if(!se){const Z=await this.getManifest(U,n.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");se=Z.engines.vscode}return(0,t.isEngineValid)(se,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(U,J,ie,se){if(!(0,S.isTargetPlatformCompatible)(B(U),ie,se)||!J&&G(U))return!1;const Z=await this.getEngine(U);return(0,t.isEngineValid)(Z,this.productService.version,this.productService.date)}async query(U,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ie=U.text||"";const se=(0,C.getOrDefault)(U,fe=>fe.pageSize,50);let Z=new L().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,se);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,be)=>(Z=Z.withFilter(r.Category,be||me),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,be)=>(Z=Z.withFilter(r.Tag,be||me),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(r.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),Z=Z.withFilter(r.SearchText,ie)),Z=Z.withSortBy(0)):U.ids?Z=Z.withFilter(r.ExtensionId,...U.ids):U.names?Z=Z.withFilter(r.ExtensionName,...U.names):Z=Z.withSortBy(4),typeof U.sortBy=="number"&&(Z=Z.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(Z=Z.withSortOrder(U.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(Z,u,J),he=fe=>({index:(Z.pageNumber-1)*Z.pageSize+fe,querySource:U.source}),ge=await this.converToGalleryExtensions(ce.map(fe=>({rawGalleryExtension:fe,preRelease:!!U.includePreRelease})),Z,u,he,J),ye=async(fe,me)=>{if(me.isCancellationRequested)throw(0,D.canceled)();const be=Z.withPage(fe+1),{galleryExtensions:Pe}=await this.queryGallery(be,u,me);return await this.converToGalleryExtensions(Pe.map(Ce=>({rawGalleryExtension:Ce,preRelease:!!U.includePreRelease})),be,u,he,J)};return{firstPage:ge,total:le,pageSize:Z.pageSize,getPage:ye}}async converToGalleryExtensions(U,J,ie,se,Z){const ce=(ge,ye,fe,me,be)=>{const Pe=!(fe.flags&s.IncludeLatestVersionOnly),Ce=Y(ge);let Re=ge.versions[0];return Re=ge.versions.find(_e=>_e.version===Re.version&&(0,S.isTargetPlatformCompatible)(B(_e),Ce,ie))||Re,Pe&&G(Re)&&!be&&(Re=ge.versions.find(_e=>_e.version!==Re.version&&!G(_e))||Re),W(ge,Re,Ce,me,se(ye))},le=[],he=new Map;for(let ge=0;ge<U.length;ge++){const{rawGalleryExtension:ye,version:fe,preRelease:me}=U[ge],be=ye.versions.some(Pe=>!G(Pe));if(fe){const Pe=ye.versions.find(Ce=>Ce.version===fe);Pe&&le.push([ge,W(ye,Pe,Y(ye),be)])}else{const Pe=ce(ye,ge,J,be,me);Pe.properties.isPreReleaseVersion?he.set(Pe.identifier.uuid,{index:ge,preRelease:me}):le.push([ge,Pe])}}if(he.size){const ge=new Date().getTime(),ye=new L().withFlags(s.IncludeVersions,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,he.size).withFilter(r.ExtensionId,...he.keys()),{galleryExtensions:fe}=await this.queryGallery(ye,ie,Z);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ge,count:he.size}),fe.length!==he.size)throw new Error("Not all extensions with latest versions are returned");for(const me of fe){const be=me.versions.some(_e=>!G(_e)),{index:Pe,preRelease:Ce}=he.get(me.extensionId),Re=ce(me,Pe,ye,be,Ce);le.push([Pe,Re])}}return le.sort((ge,ye)=>ge[0]-ye[0]).map(([,ge])=>ge)}async queryGallery(U,J,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,i(s.Unpublished));const se=await this.commonHeadersPromise,Z=JSON.stringify(U.raw),ce={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},le=new Date().getTime();let he,ge,ye=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:ce},ie),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,M.asJson)(he);if(fe){const me=fe.results[0],be=me.extensions;be.forEach(Ce=>V(Ce.versions,J));const Pe=me.resultMetadata&&me.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ye=Pe&&Pe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:ye}}return{galleryExtensions:[],total:ye}}catch(fe){throw ge=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-le,success:!!he&&(0,M.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ge?(0,D.isCancellationError)(ge)?"canceled":(0,D.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(U,J,ie,se){if(!this.isEnabled())return;const Z=k.isWeb?this.api(`/itemName/${U}.${J}/version/${ie}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${J}/${ie}/stats?statType=${se}`),ce=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:Z,headers:he},n.CancellationToken.None)}catch{}}async download(U,J,ie){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const se=(0,y.getGalleryExtensionTelemetryData)(U),Z=new Date().getTime(),ce=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:ye}),le=ie===2?"install":ie===3?"update":"",he=le?{uri:`${U.assets.download.uri}${w.URI.parse(U.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${U.assets.download.fallbackUri}${w.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:U.assets.download,ge=await this.getAsset(he);await this.fileService.writeFile(J,ge.stream),ce(new Date().getTime()-Z)}async getReadme(U,J){if(U.assets.readme){const ie=await this.getAsset(U.assets.readme,{},J);return await(0,M.asText)(ie)||""}return""}async getManifest(U,J){if(U.assets.manifest){const ie=await this.getAsset(U.assets.manifest,{},J),se=await(0,M.asText)(ie);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion(U,J){const ie=q(U,l.Manifest);if(!ie)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},Z=await this.getAsset(ie,{headers:se});return await(0,M.asJson)(Z)}async getCoreTranslation(U,J){const ie=U.assets.coreTranslations.filter(se=>se[0]===J.toUpperCase())[0];if(ie){const se=await this.getAsset(ie[1]),Z=await(0,M.asText)(se);return Z?JSON.parse(Z):null}return null}async getChangelog(U,J){if(U.assets.changelog){const ie=await this.getAsset(U.assets.changelog,{},J);return await(0,M.asText)(ie)||""}return""}async getAllCompatibleVersions(U,J,ie){let se=new L().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?se=se.withFilter(r.ExtensionId,U.identifier.uuid):se=se.withFilter(r.ExtensionName,U.identifier.id);const{galleryExtensions:Z}=await this.queryGallery(se,ie,n.CancellationToken.None);if(!Z.length)return[];const ce=Y(Z[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(ce,ie))return[];const le=[];for(const he of Z[0].versions)try{le[le.length-1]?.version!==he.version&&await this.isRawExtensionVersionCompatible(he,J,ce,ie)&&le.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:G(he)})}catch{}return le}async getAsset(U,J={},ie=n.CancellationToken.None){const se=await this.commonHeadersPromise,Z={type:"GET"},ce={...se,...J.headers||{}};J={...J,...Z,headers:ce};const le=U.uri,he=U.fallbackUri,ge={...J,url:le};try{const ye=await this.requestService.request(ge,ie);if(ye.res.statusCode===200)return ye;const fe=await(0,M.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${fe}`)}catch(ye){if((0,D.isCancellationError)(ye))throw ye;const fe=(0,D.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:fe});const me={...J,url:he};return this.requestService.request(me,ie)}}async getEngine(U){let J=H(U);if(!J){const ie=await this.getManifestFromRawExtensionVersion(U,n.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");J=ie.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,M.asJson)(U),ie=[],se={};if(J){for(const Z of J.malicious)ie.push({id:Z});if(J.unsupported)for(const Z of Object.keys(J.unsupported)){const ce=J.unsupported[Z];(0,g.isBoolean)(ce)||(se[Z.toLowerCase()]=ce.preReleaseExtension)}if(J.migrateToPreRelease)for(const[Z,ce]of Object.entries(J.migrateToPreRelease))(!ce.engine||(0,t.isEngineValid)(ce.engine,this.productService.version,this.productService.date))&&(se[Z.toLowerCase()]=ce)}return{malicious:ie,unsupportedPreReleaseExtensions:se}}};$=de([ne(1,M.IRequestService),ne(2,m.ILogService),ne(3,P.IEnvironmentService),ne(4,c.ITelemetryService),ne(5,f.IFileService),ne(6,p.IProductService),ne(7,E.IConfigurationService)],$);let A=class extends ${constructor(U,J,ie,se,Z,ce,le,he){super(U,J,ie,se,Z,ce,le,he)}};A=de([ne(0,d.IStorageService),ne(1,M.IRequestService),ne(2,m.ILogService),ne(3,P.IEnvironmentService),ne(4,c.ITelemetryService),ne(5,f.IFileService),ne(6,p.IProductService),ne(7,E.IConfigurationService)],A),e.ExtensionGalleryService=A;let T=class extends ${constructor(U,J,ie,se,Z,ce,le){super(void 0,U,J,ie,se,Z,ce,le)}};T=de([ne(0,M.IRequestService),ne(1,m.ILogService),ne(2,P.IEnvironmentService),ne(3,c.ITelemetryService),ne(4,f.IFileService),ne(5,p.IProductService),ne(6,E.IConfigurationService)],T),e.ExtensionGalleryServiceWithNoStorageService=T;async function _(O,U,J,ie,se,Z){const ce={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${U.nameShort})`},le=await(0,a.getServiceMachineId)(J,se,Z);return(0,o.supportsTelemetry)(U,J)&&(0,o.getTelemetryLevel)(ie)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=_}),define(ee[211],te([0,1,2,47,3,25,155,19,56,54,40,29,66]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(m,p){this._configurationService=p,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let M of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(M),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(M=>{const a=/^[a-f0-9]+$/i.test(M["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!a})})}setExperimentProperty(m,p){this._experimentProperties[m]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,S.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let p=m.sessionID,M=m["common.machineId"],a=m["common.firstSessionDate"],d=m["common.msftInternal"];return{sessionId:p,machineId:M,firstSessionDate:a,msftInternal:d}}dispose(){this._disposables.dispose()}_log(m,p,M,a){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(d=>{M=(0,n.mixin)(M,d),M=(0,n.mixin)(M,this._experimentProperties),M=(0,n.cloneAndChange)(M,c=>{if(typeof c=="string")return this._cleanupInfo(c,a)}),this._appenders.forEach(c=>c.log(m,M))},d=>{console.error(d)})}publicLog(m,p,M){return this._log(m,3,p,M)}publicLog2(m,p,M){return this.publicLog(m,p,M)}publicLogError(m,p){return this.sendErrorTelemetry?this._log(m,2,p,!0):Promise.resolve(void 0)}publicLogError2(m,p){return this.publicLogError(m,p)}_anonymizeFilePaths(m){let p=m;const M=[];for(let o of this._cleanupPatterns)for(;;){const u=o.exec(m);if(!u)break;M.push([u.index,o.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(p="";;){const o=d.exec(m);if(!o)break;!a.test(o[0])&&M.every(([u,s])=>o.index<u||o.index>=s)&&(p+=m.substring(c,o.index)+"<REDACTED: user-file-path>",c=d.lastIndex)}return c<m.length&&(p+=m.substr(c)),p}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const p=m.toLowerCase(),M=/@[a-zA-Z0-9-.]+/,a=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,d=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return a.test(p)?"<REDACTED: secret>":M.test(p)?"<REDACTED: email>":d.test(p)?"<REDACTED: token>":m}_cleanupInfo(m,p){let M=m;p&&(M=this._anonymizeFilePaths(M));for(let a of this._cleanupPatterns)M=M.replace(a,"");return M=this._removePropertiesWithPossibleUserInfo(M),M}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=de([ne(1,I.IConfigurationService)],y),e.TelemetryService=y;function t(){const f=(0,k.localize)(0,null,w.default.nameLong),m=w.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=D.isWeb?"":(0,k.localize)(3,null),M=(0,k.localize)(4,null),a=(0,k.localize)(5,null),d=(0,k.localize)(6,null),c=(0,k.localize)(7,null),o=`
|       | ${M} | ${a} | ${d} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,u=(0,k.localize)(8,null);return`
${f} ${m} ${p}

&nbsp;

${c}
${o}

&nbsp;

${u}
`}E.Registry.as(g.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(g.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,k.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,k.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[212],te([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(ee[213],te([0,1,105,4,2,5,40,212]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var g;(function(m){function p(M){return M&&typeof M=="object"&&typeof M.id=="string"}m.isThemeColor=p})(g=e.ThemeColor||(e.ThemeColor={}));function w(m){return{id:m}}e.themeColorFromId=w;var E;(function(m){function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||g.isThemeColor(i.color))}m.isThemeIcon=p;const M=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function a(i){const r=M.exec(i);if(!r)return;let[,l]=r;return{id:l}}m.fromString=a;function d(i){return{id:i}}m.fromId=d;function c(i,r){let l=i.id;const h=l.lastIndexOf("~");return h!==-1&&(l=l.substring(0,h)),r&&(l=`${l}~${r}`),{id:l}}m.modify=c;function o(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}m.getModifier=o;function u(i,r){return i.id===r.id&&i.color?.id===r.color?.id}m.isEqual=u;function s(i,r){return{id:i.id,color:r?w(r):void 0}}m.asThemeIcon=s,m.asClassNameArray=v.CSSIcon.asClassNameArray,m.asClassName=v.CSSIcon.asClassName,m.asCSSSelector=v.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function P(m){switch(m){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,D.toDisposable)(()=>{const M=this.themingParticipants.indexOf(p);this.themingParticipants.splice(M,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new S;k.Registry.add(e.Extensions.ThemingContribution,y);function t(m){return y.onColorThemeChange(m)}e.registerThemingParticipant=t;class f extends D.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(M=>this.onThemeChange(M)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,M){let a=this.theme.getColor(p);return a&&M&&(a=M(a,this.theme)),a?a.toString():null}}e.Themable=f}),define(ee[67],te([0,1,14,3,5,38]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",I="#1E1E1E",g="#000000",w="theme",E="themeBackground",P="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let S=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return g;let t=this.stateMainService.getItem(E,null);if(!t){let f;(n.isWindows||n.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?f="hc-black":f=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],t=f==="hc-black"?g:f==="vs"?k:I}return n.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,f){this.stateMainService.setItems([{key:w,data:f.baseTheme},{key:E,data:f.colorInfo.background},{key:P,data:f}]),typeof t=="number"&&this.updateBackgroundColor(t,f)}updateBackgroundColor(t,f){for(const m of v.BrowserWindow.getAllWindows())if(m.id===t){m.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};S=de([ne(0,C.IStateMainService)],S),e.ThemeMainService=S}),define(ee[41],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(n=e.StateType||(e.StateType={}));var D;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,k)=>({type:"idle",updateType:C,error:k}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(ee[214],te([0,1,3,156,56,40]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[215],te([0,1,4,41]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(I){this.service=I}listen(I,g){switch(g){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${g}`)}call(I,g,w){switch(g){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=D;class C{constructor(I){this.channel=I,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(g=>this.state=g),this.channel.call("_getInitialState").then(g=>this.state=g)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(ee[100],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(ee[216],te([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(I){this.handler=I}listen(I,g){throw new Error(`Event not found: ${g}`)}call(I,g,w){switch(g){case"handleURL":return this.handler.handleURL(v.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=n;class D{constructor(I){this.channel=I}handleURL(I,g){return this.channel.call("handleURL",[I.toJSON(),g])}}e.URLHandlerChannelClient=D;class C{constructor(I){this.next=I}async routeCall(I,g,w,E){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(w){const P=v.URI.revive(w);if(P&&P.query){const S=/\bwindowId=(\d+)/.exec(P.query);if(S){const y=S[1],t=new RegExp(`window:${y}`),f=I.connections.find(m=>t.test(m.ctx));if(f)return f}}}return this.next.routeCall(I,g,w,E)}routeEvent(I,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=C}),define(ee[217],te([0,1,8,2,7,22]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,E){const P=[...this.handlers.values()];return(0,v.first)(P.map(S=>()=>S.handleURL(w,E)),void 0,!1).then(S=>S||!1)}registerHandler(w){return this.handlers.add(w),(0,n.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=k;let I=class extends k{constructor(w){super();this.productService=w}create(w){let{authority:E,path:P,query:S,fragment:y}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return E&&P&&P.indexOf("/")!==0&&(P=`/${P}`),D.URI.from({scheme:this.productService.urlProtocol,authority:E,path:P,query:S,fragment:y})}};I=de([ne(0,C.IProductService)],I),e.NativeURLService=I}),define(ee[218],te([0,1,14,8,4,2,3,7]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function g(E){try{return I.URI.parse(E)}catch{return null}}class w{constructor(P,S,y,t,f){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=P,k.isWindows){const M=t.isBuilt?[]:[`"${t.appRoot}"`];M.push("--open-url","--"),v.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,M)}const m=D.Event.map(D.Event.fromNodeEventEmitter(v.app,"open-url",(M,a)=>({event:M,url:a})),({event:M,url:a})=>(M.preventDefault(),a));this.disposables.add(m(M=>{const a=g(M);!a||this.urlService.open(a,{originalUrl:M})})),y.getWindows().filter(M=>M.isReady).length>0?this.flush():D.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||P.push(S);P.length!==0&&(this.uris=P,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(ee[219],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(ee[220],te([0,1,14,2,10,7]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends n.Disposable{constructor(){super();const g=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(D.Schemas.vscodeWebview,g)}handleWebviewRequest(g,w){try{const E=C.URI.parse(g.url),P=k.validWebviewFilePaths.get(E.path);if(typeof P=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${P}`,y=D.FileAccess.asFileUri(S,K);return w(decodeURIComponent(y.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=k,k.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(ee[68],te([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(w){return!!w.workspaceUri}e.isWorkspaceToOpen=n;function D(w){return!!w.folderUri}e.isFolderToOpen=D;function C(w){return!!w.fileUri}e.isFileToOpen=C;function k(w){const E=I(w),P=w.getValue("window.menuBarVisibility");return P==="default"||E==="native"&&P==="compact"||v.isMacintosh&&v.isNative?"classic":P}e.getMenuBarVisibility=k;function I(w){if(v.isWeb)return"custom";const E=w.getValue("window");if(E){if(v.isMacintosh&&E.nativeTabs===!0||v.isMacintosh&&E.nativeFullScreen===!1)return"native";const y=w.getValue("workbench.colorCustomizations");if(y?.["window.activeBorder"]||y?.["window.inactiveBorder"])return"custom";const t=E.titleBarStyle;if(t==="native"||t==="custom")return t}return v.isLinux?"native":"custom"}e.getTitleBarStyle=I;function g(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=g}),define(ee[36],te([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var n;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(n=e.LoadReason||(e.LoadReason={}));var D;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var C;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const k=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=k;var I;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var g;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(g=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(ee[221],te([0,1,14,21,4,71,2,32,90,6,22,36,95]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let t=class extends k.Disposable{constructor(m,p,M,a,d){super();this.logService=m,this.windowsMainService=p,this.credentialsService=M,this.encryptionMainService=a,this.productService=d,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const m=D.Event.fromNodeEventEmitter(v.app,"login",(p,M,a,d,c)=>({event:p,webContents:M,req:a,authInfo:d,callback:c}));this._register(m(this.onLogin,this))}async onLogin({event:m,authInfo:p,req:M,callback:a}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&M.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let d;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),d=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{d=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}a(d?.username,d?.password)}async resolveProxyCredentials(m){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(m);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(m){this.logService.trace("auth#doResolveProxyCredentials - enter",m);const p=String((0,C.hash)({scheme:m.scheme,host:m.host,port:m.port}));let M,a;try{const u=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(u){const s=JSON.parse(await this.encryptionMainService.decrypt(u));M=s.username,a=s.password}}catch(u){this.logService.error(u)}if(this.state!==y.StoredCredentialsUsed&&typeof M=="string"&&typeof a=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:M,password:a};const d=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!d){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${d.id} to handle proxy login`);const c={authInfo:m,username:this.sessionCredentials?.username??M,password:this.sessionCredentials?.password??a,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};d.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=y.LoginDialogShown;const o=await new Promise(u=>{const s=async(i,r,l)=>{if(r===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${d.id}`),d.win?.webContents.off("ipc-message",s),l){const h={username:l.username,password:l.password};try{if(l.remember){const b=await this.encryptionMainService.encrypt(JSON.stringify(h));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,b)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(b){this.logService.error(b)}u({username:h.username,password:h.password})}else u(void 0)};d.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=o,o}};t=de([ne(0,w.ILogService),ne(1,P.IWindowsMainService),ne(2,S.ICredentialsMainService),ne(3,g.IEncryptionMainService),ne(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(ee[222],te([0,1,14,4,2,220,36]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends D.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,E){let P;if(typeof w.windowId=="number"){const{windowId:S}=w,y=this.windowsMainService.getWindowById(S);if(!y?.win)throw new Error(`Invalid windowId: ${S}`);P=y.win.webContents}else{const{webContentsId:S}=w;if(P=v.webContents.fromId(S),!P)throw new Error(`Invalid webContentsId: ${S}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(E)}async findInFrame(w,E,P,S){const y=this.getFrameByName(w,E),t=y;if(typeof t.findInFrame=="function"){t.findInFrame(P,{findNext:S.findNext,forward:S.forward});const f=(m,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),y.removeListener("found-in-frame",f))};y.on("found-in-frame",f)}}async stopFindInFrame(w,E,P){const y=this.getFrameByName(w,E);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,E){const P=this.windowsMainService.getWindowById(w.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${w}`);const S=P.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===E);if(!S)throw new Error(`Unknown frame: ${E}`);return S}};I=de([ne(0,k.IWindowsMainService)],I),e.WebviewMainService=I}),define(ee[223],te([0,1,8,4,2]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends D.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:g,getActiveWindowId:w}){super();this.disposables=this._register(new D.DisposableStore),n.Event.latch(n.Event.any(I,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>w()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(ee[224],te([0,1,35,16,7,5]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var k;(function(S){S[S.EMPTY=1]="EMPTY",S[S.FOLDER=2]="FOLDER",S[S.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function I(S){const y=S;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=I;function g(S){const y=S;return!!(y&&typeof y=="object"&&D.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=g;class w{constructor(y,t,f,m,p){this._id=y,this._transient=f,this._configuration=m,this._ignorePathCasing=p,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(y){this._id=y.id,this._configuration=y.configuration,this._transient=y.transient,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class E{constructor(y,t){this.raw=t,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,n.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=E;function P(S){return new E({uri:S,index:0,name:(0,n.basenameOrAuthority)(S)},{uri:S.toString()})}e.toWorkspaceFolder=P}),define(ee[30],te([0,1,27,43,107,33,10,9,3,16,7,159,5,65,224]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(G){return(typeof G=="string"?(0,I.extname)(G):(0,w.extname)(G))===f}e.hasWorkspaceFileExtension=m,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function p(G){return G.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function M(G){return G.hasOwnProperty("folderUri")}e.isRecentFolder=M;function a(G){return G.hasOwnProperty("fileUri")}e.isRecentFile=a;function d(G){return G&&G.hasOwnProperty("folderUri")}e.isFolderBackupInfo=d;function c(G){return G&&G.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=c;function o(G){const j=G;return typeof j?.id=="string"&&E.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(G){if(G.configuration)return{id:G.id,configPath:G.configuration};if(G.folders.length===1)return{id:G.id,uri:G.folders[0].uri}}e.toWorkspaceIdentifier=u;function s(G){const j=G;return typeof j?.id=="string"&&E.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=s;function i(G){const j=G;if(j?.uri)return{id:j.id,uri:E.URI.revive(j.uri)};const N=G;if(N?.configPath)return{id:N.id,configPath:E.URI.revive(N.configPath)};if(G?.id)return{id:G.id}}e.reviveIdentifier=i;function r(G,j){return w.extUriBiasedIgnorePathCase.isEqualOrParent(G,j.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function l(G){return h(G)||b(G)}e.isStoredWorkspaceFolder=l;function h(G){const j=G;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=h;function b(G){const j=G;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=b;function R(G,j,N,B,Y=!g.isWindows,V){if(G.scheme!==B.scheme)return{name:N,uri:G.toString(!0)};let W=j?void 0:V.relativePath(B,G);if(W!==void 0)W.length===0?W=".":g.isWindows&&G.scheme===k.Schemas.file&&!Y&&(W=W.replace(/\//g,"\\"));else if(G.scheme===k.Schemas.file)W=G.fsPath,g.isWindows&&(W=(0,C.normalizeDriveLetter)(W),Y&&(W=(0,v.toSlashes)(W)));else{if(!V.isEqualAuthority(G.authority,B.authority))return{name:N,uri:G.toString(!0)};W=G.path}return{name:N,path:W}}e.getStoredWorkspaceFolder=R;function L(G,j,N){let B=[],Y=new Set;const V=N.dirname(j);for(let W of G){let $;if(h(W))W.path&&($=N.resolvePath(V,W.path));else if(b(W))try{$=E.URI.parse(W.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(A){console.warn(A)}if($){let A=N.getComparisonKey($);if(!Y.has(A)){Y.add(A);const T=W.name||N.basenameOrAuthority($);B.push(new t.WorkspaceFolder({uri:$,name:T,index:B.length},W))}}}return B}e.toWorkspaceFolders=L;function F(G,j,N,B,Y){let V=z(j,G);const W=Y.dirname(j),$=Y.dirname(B),A=[],T=Q(V.folders);for(const J of V.folders){const ie=h(J)?Y.resolvePath(W,J.path):E.URI.parse(J.uri);let se;N?se=!1:se=!h(J)||(0,I.isAbsolute)(J.path),A.push(R(ie,se,J.name,$,T,Y))}const _={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},O=D.setProperty(G,["folders"],A,_);let U=D.applyEdits(G,O);return(0,w.isEqualAuthority)(V.remoteAuthority,(0,y.getRemoteAuthority)(B))&&(U=D.applyEdits(U,D.removeProperty(U,["remoteAuthority"],_))),U}e.rewriteWorkspaceFileForNewLocation=F;function z(G,j){let N=n.parse(j);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(B=>l(B));else throw new Error(`${G} looks like an invalid workspace file.`);return N}function Q(G){return g.isWindows?G.some(j=>h(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function oe(G){return G.workspace&&typeof G.workspace=="object"&&typeof G.workspace.id=="string"&&typeof G.workspace.configPath=="string"}function re(G){return typeof G.folderUri=="string"}function q(G){return typeof G.fileUri=="string"}function x(G,j){const N={workspaces:[],files:[]};if(G){const B=function(V,W){for(let $=0;$<V.length;$++)try{W(V[$],$)}catch(A){j.warn(`Error restoring recent entry ${JSON.stringify(V[$])}: ${A.toString()}. Skip entry.`)}},Y=G;if(Array.isArray(Y.entries))B(Y.entries,V=>{const W=V.label,$=V.remoteAuthority;oe(V)?N.workspaces.push({label:W,remoteAuthority:$,workspace:{id:V.workspace.id,configPath:E.URI.parse(V.workspace.configPath)}}):re(V)?N.workspaces.push({label:W,remoteAuthority:$,folderUri:E.URI.parse(V.folderUri)}):q(V)&&N.files.push({label:W,remoteAuthority:$,fileUri:E.URI.parse(V.fileUri)})});else{const V=G;Array.isArray(V.workspaces3)&&B(V.workspaces3,(W,$)=>{const A=Array.isArray(V.workspaceLabels)&&V.workspaceLabels[$]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?N.workspaces.push({label:A,workspace:{id:W.id,configPath:E.URI.parse(W.configURIPath)}}):typeof W=="string"&&N.workspaces.push({label:A,folderUri:E.URI.parse(W)})}),Array.isArray(V.files2)&&B(V.files2,(W,$)=>{const A=Array.isArray(V.fileLabels)&&V.fileLabels[$]||void 0;typeof W=="string"&&N.files.push({label:A,fileUri:E.URI.parse(W)})})}}return N}e.restoreRecentlyOpened=x;function H(G){const j={entries:[]};for(const N of G.workspaces)M(N)?j.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):j.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of G.files)j.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return j}e.toStoreData=H}),define(ee[50],te([0,1,14,8,71,33,2,72,9,3,13,24,139,5,6,38,30]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let p=class vt{constructor(a,d){this.stateMainService=a,this.logService=d,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(a,d){return this.doPick({...a,pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)},d)}pickFolder(a,d){return this.doPick({...a,pickFolders:!0,title:(0,S.localize)(1,null)},d)}pickFile(a,d){return this.doPick({...a,pickFiles:!0,title:(0,S.localize)(2,null)},d)}pickWorkspace(a,d){const c=(0,S.localize)(3,null),o=(0,C.mnemonicButtonLabel)((0,S.localize)(4,null)),u=m.WORKSPACE_FILTER;return this.doPick({...a,pickFiles:!0,title:c,filters:u,buttonLabel:o},d)}async doPick(a,d){const c={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters};c.defaultPath=a.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(c.properties=void 0,a.pickFiles&&a.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&c.properties.push("treatPackageAsDirectory");const o=d||v.BrowserWindow.getFocusedWindow(),u=await this.showOpenDialog(c,(0,E.withNullAsUndefined)(o));if(u&&u.filePaths&&u.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,g.dirname)(u.filePaths[0])),u.filePaths}getWindowDialogQueue(a){if(a){let d=this.windowDialogQueues.get(a.id);return d||(d=new n.Queue,this.windowDialogQueues.set(a.id,d)),d}else return this.noWindowDialogueQueue}showMessageBox(a,d){return this.getWindowDialogQueue(d).queue(async()=>d?v.dialog.showMessageBox(d,a):v.dialog.showMessageBox(a))}async showSaveDialog(a,d){const c=this.acquireFileDialogLock(a,d);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(d).queue(async()=>{let o;return d?o=await v.dialog.showSaveDialog(d,a):o=await v.dialog.showSaveDialog(a),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,k.dispose)(c)}}normalizePath(a){return a&&w.isMacintosh&&(a=(0,I.normalizeNFC)(a)),a}normalizePaths(a){return a.map(d=>this.normalizePath(d))}async showOpenDialog(a,d){a.defaultPath&&(await P.Promises.exists(a.defaultPath)||(a.defaultPath=void 0));const c=this.acquireFileDialogLock(a,d);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(d).queue(async()=>{let o;return d?o=await v.dialog.showOpenDialog(d,a):o=await v.dialog.showOpenDialog(a),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,k.dispose)(c)}}acquireFileDialogLock(a,d){if(!d)return k.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",a);let c=this.windowFileDialogLocks.get(d.id);c||(c=new Set,this.windowFileDialogLocks.set(d.id,c));const o=(0,D.hash)(a);if(!c.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",a),c.add(o),(0,k.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",a),c?.delete(o),c?.size===0&&this.windowFileDialogLocks.delete(d.id)})}};p.workingDirPickerStorageKey="pickerWorkingDir",p=de([ne(0,f.IStateMainService),ne(1,t.ILogService)],p),e.DialogMainService=p}),define(ee[225],te([0,1,4,2,30]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends n.Disposable{constructor(I,g){super();this.logService=I,this.storageMainService=g,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,g)=>(I?I.push(g):I=[g],I),C.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const g=new Map,w=new Set;return I.forEach(E=>{const P=this.storageMainService.globalStorage.get(E.key);typeof P=="string"?g.set(E.key,P):w.add(E.key)}),{changed:Array.from(g.entries()),deleted:Array.from(w.values())}}listen(I,g){switch(g){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${g}`)}async call(I,g,w){const E=(0,D.reviveIdentifier)(w.workspace),P=await this.withStorageInitialized(E);switch(g){case"getItems":return Array.from(P.items.entries());case"updateItems":{const S=w;if(S.insert)for(const[y,t]of S.insert)P.set(y,t);S.delete&&S.delete.forEach(y=>P.delete(y));break}case"close":{if(E)return P.close();break}default:throw new Error(`Call not found: ${g}`)}}async withStorageInitialized(I){const g=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await g.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${w}`)}return g}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[226],te([0,1,8,4,2,9,24,88,128,6,78,29,30]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends D.Disposable{constructor(p){super();this.logService=p,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new v.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const p=await this.doCreate();this._storage.dispose(),this._storage=p,this._register(p.onDidChangeStorage(a=>this._onDidChangeStorage.fire({key:a}))),await this.doInit(p);const M=p.getBoolean(E.IS_NEW_KEY);M===void 0?p.set(E.IS_NEW_KEY,!0):M&&p.set(E.IS_NEW_KEY,!1)}catch(p){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${p}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?p=>this.logService.trace(p):void 0,logError:p=>this.logService.error(p)}}doInit(p){return p.init()}get items(){return this._storage.items}get(p,M){return this._storage.get(p,M)}set(p,M){return this._storage.set(p,M)}delete(p){return this._storage.delete(p)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends y{constructor(p,M,a){super(M);this.options=p,this.environmentService=a}async doCreate(){let p;return this.options.useInMemoryStorage?p=g.SQLiteStorageDatabase.IN_MEMORY_PATH:p=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new I.Storage(new g.SQLiteStorageDatabase(p,{logging:this.createLoggingOptions()}))}async doInit(p){await super.doInit(p),this.updateTelemetryState(p)}updateTelemetryState(p){p.get(P.firstSessionDateStorageKey,void 0)===void 0&&p.set(P.firstSessionDateStorageKey,new Date().toUTCString());const a=p.get(P.currentSessionDateStorageKey,void 0),d=new Date().toUTCString();p.set(P.lastSessionDateStorageKey,typeof a=="undefined"?null:a),p.set(P.currentSessionDateStorageKey,d)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class f extends y{constructor(p,M,a,d){super(a);this.workspace=p,this.options=M,this.environmentService=d}async doCreate(){const{storageFilePath:p,wasCreated:M}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new g.SQLiteStorageDatabase(p,{logging:this.createLoggingOptions()}),{hint:M?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:g.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const p=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),M=(0,C.join)(p,f.WORKSPACE_STORAGE_NAME);return await k.Promises.exists(p)?{storageFilePath:M,wasCreated:!1}:(await k.Promises.mkdir(p,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(p),{storageFilePath:M,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(p){let M;if((0,S.isSingleFolderWorkspaceIdentifier)(this.workspace)?M={folder:this.workspace.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.workspace)&&(M={workspace:this.workspace.configPath.toString()}),M)try{const a=(0,C.join)(p,f.WORKSPACE_META_NAME);await k.Promises.exists(a)||await k.Promises.writeFile(a,JSON.stringify(M,void 0,2))}catch(a){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=f,f.WORKSPACE_STORAGE_NAME="state.vscdb",f.WORKSPACE_META_NAME="workspace.json"}),define(ee[101],te([0,1,16,7,30]),function(K,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(g,w,E){for(const S of g){const y=S.openedWorkspace;if((0,D.isWorkspaceIdentifier)(y)){const t=E(y);if(t){if(t.folders.some(f=>v.extUriBiasedIgnorePathCase.isEqualOrParent(w,f.uri)))return S}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(w,y.configPath))return S}}const P=g.filter(S=>(0,D.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(w,S.openedWorkspace.uri));if(P.length)return P.sort((S,y)=>-(S.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function k(g,w){for(const E of g)if((0,D.isWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.configPath,w)||(0,D.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.uri,w))return E}e.findWindowOnWorkspaceOrFolder=k;function I(g,w){const E=P=>w.some(S=>v.extUriBiasedIgnorePathCase.isEqual(n.URI.file(S),n.URI.file(P)));for(const P of g)if(P.config?.extensionDevelopmentPath?.some(S=>E(S)))return P}e.findWindowOnExtensionDevelopmentPath=I}),define(ee[227],te([0,1,14,2,3,16,7,19,20,6,38,36,30]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class St extends n.Disposable{constructor(a,d,c,o,u){super();this.windowsMainService=a,this.stateMainService=d,this.lifecycleMainService=c,this.logService=o,this.configurationService=u,this._state=t(this.stateMainService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(a=>this.onBeforeCloseWindow(a)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(a=>this.onBeforeCloseWindow(a))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const a={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!a.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(u=>!u.isExtensionDevelopmentHost)),o&&(a.lastActiveWindow=this.toWindowState(o))}const d=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);d&&(a.lastPluginDevelopmentHostWindow=this.toWindowState(d)),this.windowsMainService.getWindowCount()>1&&(a.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const c=m(a);this.stateMainService.setItem(St.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(a){if(this.lifecycleMainService.quitRequested)return;const d=this.toWindowState(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=d:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this._state.openedWindows.forEach(c=>{const o=(0,S.isWorkspaceIdentifier)(a.openedWorkspace)&&c.workspace?.id===a.openedWorkspace.id,u=(0,S.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)&&c.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(c.folderUri,a.openedWorkspace.uri);(o||u)&&(c.uiState=d.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=d)}toWindowState(a){return{workspace:(0,S.isWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,S.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const d=this.doGetNewWindowState(a),c=this.configurationService.getValue("window");let o;return d.hasDefaultState?o=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),o&&D.isMacintosh&&this.windowsMainService.getWindows().some(u=>u.isFullScreen)&&(o=!1)),d.mode===3&&!o&&(d.mode=1),d}doGetNewWindowState(a){const d=this.windowsMainService.getLastActiveWindow();if(!a.extensionTestsPath){if(!!a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const r=a.workspace;if((0,S.isWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(b=>b.workspace&&b.workspace.id===r.id).map(b=>b.uiState);if(h.length)return h[0]}if((0,S.isSingleFolderWorkspaceIdentifier)(r)){const h=this.state.openedWindows.filter(b=>b.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(b.folderUri,r.uri)).map(b=>b.uiState);if(h.length)return h[0]}else if(a.backupPath){const h=this.state.openedWindows.filter(b=>b.backupPath===a.backupPath).map(b=>b.uiState);if(h.length)return h[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!d&&l)return l.uiState}let c;const o=v.screen.getAllDisplays();if(o.length===1)c=o[0];else{if(D.isMacintosh){const r=v.screen.getCursorScreenPoint();c=v.screen.getDisplayNearestPoint(r)}!c&&d&&(c=v.screen.getDisplayMatching(d.getBounds())),c||(c=v.screen.getPrimaryDisplay()||o[0])}let u=(0,P.defaultWindowState)();u.x=Math.round(c.bounds.x+c.bounds.width/2-u.width/2),u.y=Math.round(c.bounds.y+c.bounds.height/2-u.height/2);const s=this.configurationService.getValue("window");let i=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")u.mode=0,i=!1;else if(s.newWindowDimensions==="fullscreen")u.mode=3,i=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&d){const r=d.serializeWindowState();r.mode===3?u.mode=3:u=r,i=u.mode!==3&&s.newWindowDimensions==="offset"}}return i&&(u=this.ensureNoOverlap(u)),u.hasDefaultState=!0,u}ensureNoOverlap(a){if(this.windowsMainService.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const d=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;d.some(c=>c.x===a.x||c.y===a.y);)a.x+=30,a.y+=30;return a}};y.windowsStateStorageKey="windowsState",y=de([ne(0,P.IWindowsMainService),ne(1,E.IStateMainService),ne(2,g.ILifecycleMainService),ne(3,w.ILogService),ne(4,I.IConfigurationService)],y),e.WindowsStateHandler=y;function t(M){const a={openedWindows:[]},d=M||{openedWindows:[]};return d.lastActiveWindow&&(a.lastActiveWindow=f(d.lastActiveWindow)),d.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=f(d.lastPluginDevelopmentHostWindow)),Array.isArray(d.openedWindows)&&(a.openedWindows=d.openedWindows.map(c=>f(c))),a}e.restoreWindowsState=t;function f(M){const a={uiState:M.uiState};return M.backupPath&&(a.backupPath=M.backupPath),M.remoteAuthority&&(a.remoteAuthority=M.remoteAuthority),M.folder&&(a.folderUri=k.URI.parse(M.folder)),M.workspaceIdentifier&&(a.workspace={id:M.workspaceIdentifier.id,configPath:k.URI.parse(M.workspaceIdentifier.configURIPath)}),a}function m(M){return{lastActiveWindow:M.lastActiveWindow&&p(M.lastActiveWindow),lastPluginDevelopmentHostWindow:M.lastPluginDevelopmentHostWindow&&p(M.lastPluginDevelopmentHostWindow),openedWindows:M.openedWindows.map(a=>p(a))}}e.getWindowsStateStoreData=m;function p(M){return{workspaceIdentifier:M.workspace&&{id:M.workspace.id,configURIPath:M.workspace.configPath.toString()},folder:M.folderUri&&M.folderUri.toString(),backupPath:M.backupPath,remoteAuthority:M.remoteAuthority,uiState:M.uiState}}}),define(ee[102],te([0,1,60,28,10,3,16]),function(K,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(w){function E(){let P=w.scheme===D.Schemas.file?(0,k.originalFSPath)(w):w.toString();return C.isLinux||(P=P.toLowerCase()),(0,v.createHash)("md5").update(P).digest("hex")}return{id:E(),configPath:w}}e.getWorkspaceIdentifier=I;function g(w,E){function P(){if(w.scheme!==D.Schemas.file)return(0,v.createHash)("md5").update(w.toString()).digest("hex");if(!E)try{E=(0,n.statSync)(w.fsPath)}catch{return}let y;return C.isLinux?y=E.ino:C.isMacintosh?y=E.birthtime.getTime():C.isWindows&&(typeof E.birthtimeMs=="number"?y=Math.floor(E.birthtimeMs):y=E.birthtime.getTime()),(0,v.createHash)("md5").update(w.fsPath).update(y?String(y):"").digest("hex")}const S=P();if(typeof S=="string")return{id:S,uri:w}}e.getSingleFolderWorkspaceIdentifier=g}),define(ee[228],te([0,1,15,4,10,6,255,116,20,83]),function(K,e,v,n,D,C,k,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class E{constructor(t,f){this._worker=new k.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",K).fsPath),this._worker.on("message",t),this._worker.on("error",f),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,f){this._worker.postMessage(t,f)}dispose(){this._worker.terminate()}}let P=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};P=de([ne(0,C.ILogService)],P);let S=class{constructor(t,f){this._logService=t,this._shutdown=!1,this._proxy=null;const m={create:(p,M,a)=>{const d=new E(M,a);return d.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),d.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),d.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),d.postMessage(p,[]),d}};this._worker=new I.SimpleWorkerClient(m,"vs/platform/extensions/node/extensionHostStarterWorker",new P(this._logService)),this._initialize(),f.onWillShutdown(p=>{this._shutdown=!0,this._proxy&&p.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return t.createExtensionHost()}async start(t,f){const m=w.StopWatch.create(!1),p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();const M=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),a=await p.start(t,f),d=m.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${d} ms.`),clearTimeout(M),a}async enableInspectPort(t){const f=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return f.enableInspectPort(t)}async kill(t){const f=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return f.kill(t)}};S=de([ne(0,C.ILogService),ne(1,g.ILifecycleMainService)],S),e.WorkerMainProcessExtensionHostStarter=S}),define(ee[57],te([0,1,60,61,26,17,15,4,2,9,3,32,37,86,229]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(L,F=""){this.debugLabel=F,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=z=>{if(this.traceSocketEvent("error",{code:z?.code,message:z?.message}),z){if(z.code==="EPIPE")return;(0,k.onUnexpectedError)(z)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,F){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,F)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const F=z=>{this.traceSocketEvent("read",z),L(C.VSBuffer.wrap(z))};return this.socket.on("data",F),{dispose:()=>this.socket.off("data",F)}}onClose(L){const F=z=>{this.traceSocketEvent("close",{hadError:z}),L({type:0,hadError:z,error:void 0})};return this.socket.on("close",F),{dispose:()=>this.socket.off("close",F)}}onEnd(L){const F=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",F),{dispose:()=>this.socket.off("end",F)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,F=>{if(F){if(F.code==="EPIPE")return;(0,k.onUnexpectedError)(F)}})}catch(F){if(F.code==="EPIPE")return;(0,k.onUnexpectedError)(F)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,F)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const z=()=>{this.socket.off("close",z),this.socket.off("end",z),this.socket.off("error",z),this.socket.off("timeout",z),this.socket.off("drain",z),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",z),this.socket.on("end",z),this.socket.on("error",z),this.socket.on("timeout",z),this.socket.on("drain",z)})}}e.NodeSocket=f;var m;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var p;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(p||(p={}));class M extends g.Disposable{constructor(L,F,z,Q){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:F,inflateBytesLength:z?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new a(this,F,z,Q,this._onData,(oe,re)=>this._write(oe,re))),this._register(this._flowManager.onError(oe=>{console.error(oe),(0,k.onUnexpectedError)(oe),this._onClose.fire({type:0,hadError:!0,error:oe})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(oe=>this._acceptChunk(oe))),this._register(this.socket.onClose(oe=>this._onClose.fire(oe)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,F){this.socket.traceSocketEvent(L,F)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,F){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let z=2;L.byteLength<126?z+=0:L.byteLength<2**16?z+=2:z+=8;const Q=C.VSBuffer.alloc(z);if(F?Q.writeUInt8(194,0):Q.writeUInt8(130,0),L.byteLength<126)Q.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){Q.writeUInt8(126,1);let oe=1;Q.writeUInt8(L.byteLength>>>8&255,++oe),Q.writeUInt8(L.byteLength>>>0&255,++oe)}else{Q.writeUInt8(127,1);let oe=1;Q.writeUInt8(0,++oe),Q.writeUInt8(0,++oe),Q.writeUInt8(0,++oe),Q.writeUInt8(0,++oe),Q.writeUInt8(L.byteLength>>>24&255,++oe),Q.writeUInt8(L.byteLength>>>16&255,++oe),Q.writeUInt8(L.byteLength>>>8&255,++oe),Q.writeUInt8(L.byteLength>>>0&255,++oe)}this.socket.write(C.VSBuffer.concat([Q,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const F=this._incomingData.peek(this._state.readLen),z=F.readUInt8(0),Q=(z&128)>>>7,oe=(z&64)>>>6,re=F.readUInt8(1),q=(re&128)>>>7,x=re&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(oe)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const F=this._incomingData.read(this._state.readLen),z=F.readUInt8(1),Q=(z&128)>>>7;let oe=z&127,re=1;oe===126?oe=F.readUInt8(++re)*2**8+F.readUInt8(++re):oe===127&&(oe=F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*2**24+F.readUInt8(++re)*2**16+F.readUInt8(++re)*2**8+F.readUInt8(++re));let q=0;Q&&(q=F.readUInt8(++re)*2**24+F.readUInt8(++re)*2**16+F.readUInt8(++re)*2**8+F.readUInt8(++re)),this._state.state=3,this._state.readLen=oe,this._state.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const F=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",F),o(F,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",F),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(F,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=M;class a extends g.Disposable{constructor(L,F,z,Q,oe,re){super();this._tracer=L,this._onData=oe,this._writeFn=re,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,F?(this._zlibInflateStream=this._register(new d(this._tracer,Q,z,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(q=>this._onError.fire(q))),this._register(this._zlibDeflateStream.onError(q=>this._onError.fire(q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const F=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(F,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,F){return new Promise((z,Q)=>{L.write(F),L.flush(oe=>z(oe))})}acceptFrame(L,F,z){this._readQueue.push({data:L,isCompressed:F,isLastFrameOfMessage:z}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const F=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(F)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,F,z){return new Promise((Q,oe)=>{L.write(F),z&&L.write(C.VSBuffer.fromByteArray([0,0,255,255])),L.flush(re=>Q(re))})}}class d extends g.Disposable{constructor(L,F,z,Q){super();this._tracer=L,this._recordInflateBytes=F,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",oe=>{this._tracer.traceSocketEvent("zlibInflateError",{message:oe?.message,code:oe?.code}),this._onError.fire(oe)}),this._zlibInflate.on("data",oe=>{this._tracer.traceSocketEvent("zlibInflateData",oe),this._pendingInflateData.push(C.VSBuffer.wrap(oe))}),z&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",z.buffer),this._zlibInflate.write(z.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const F=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(F)})}}class c extends g.Disposable{constructor(L,F){super();this._tracer=L,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",z=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibDeflate.on("data",z=>{this._tracer.traceSocketEvent("zlibDeflateData",z),this._pendingDeflateData.push(C.VSBuffer.wrap(z))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let F=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,F=F.slice(0,F.byteLength-4),L(F)})}}function o(R,L){if(L===0)return;let F=R.byteLength>>>2;for(let x=0;x<F;x++){const H=R.readUInt32BE(x*4);R.writeUInt32BE(H^L,x*4)}let z=F*4,Q=R.byteLength-z;const oe=L>>>24&255,re=L>>>16&255,q=L>>>8&255;Q>=1&&R.writeUInt8(R.readUInt8(z)^oe,z),Q>=2&&R.writeUInt8(R.readUInt8(z+1)^re,z+1),Q>=3&&R.writeUInt8(R.readUInt8(z+2)^q,z+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function s(){const R=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${R}.sock`):L=(0,w.join)((0,D.tmpdir)(),`vscode-ipc-${R}.sock`),r(L),L}e.createRandomIPCHandle=s;function i(R,L,F){const z=(0,v.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${z}-${F}-${L}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${z.substr(0,8)}-${F}-${L}.sock`):Q=(0,w.join)(R,`${F}-${L}.sock`),r(Q),Q}e.createStaticIPCHandle=i;function r(R){const L=u[E.platform];typeof L=="number"&&R.length>=L&&console.warn(`WARNING: IPC handle "${R}" is longer than ${L} chars, try a shorter --user-data-dir`)}class l extends S.IPCServer{constructor(L){super(l.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const F=I.Event.fromNodeEventEmitter(L,"connection");return I.Event.map(F,z=>({protocol:new y.Protocol(new f(z,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(z,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=l;function h(R){return new Promise((L,F)=>{const z=(0,n.createServer)();z.on("error",F),z.listen(R,()=>{z.removeListener("error",F),L(new l(z))})})}e.serve=h;function b(R,L){return new Promise((F,z)=>{const Q=(0,n.createConnection)(R,()=>{Q.removeListener("error",z),F(y.Client.fromSocket(new f(Q,`ipc-client${L}`),L))});Q.once("error",z)})}e.connect=b}),define(ee[230],te([0,1,57]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(g){this.driver=g}listen(g,w){throw new Error("No event found")}call(g,w,E){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(E);case"startTracing":return this.driver.startTracing(E[0],E[1]);case"stopTracing":return this.driver.stopTracing(E[0],E[1],E[2]);case"reloadWindow":return this.driver.reloadWindow(E);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(E[0],E[1]);case"click":return this.driver.click(E[0],E[1],E[2],E[3]);case"doubleClick":return this.driver.doubleClick(E[0],E[1]);case"setValue":return this.driver.setValue(E[0],E[1],E[2]);case"getTitle":return this.driver.getTitle(E[0]);case"isActiveElement":return this.driver.isActiveElement(E[0],E[1]);case"getElements":return this.driver.getElements(E[0],E[1],E[2]);case"getElementXY":return this.driver.getElementXY(E[0],E[1],E[2]);case"typeInEditor":return this.driver.typeInEditor(E[0],E[1],E[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(E[0],E[1]);case"writeInTerminal":return this.driver.writeInTerminal(E[0],E[1],E[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(E);case"getLocalizedStrings":return this.driver.getLocalizedStrings(E)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=n;class D{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}startTracing(g,w){return this.channel.call("startTracing",[g,w])}stopTracing(g,w,E){return this.channel.call("stopTracing",[g,w,E])}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,w){return this.channel.call("dispatchKeybinding",[g,w])}click(g,w,E,P){return this.channel.call("click",[g,w,E,P])}doubleClick(g,w){return this.channel.call("doubleClick",[g,w])}setValue(g,w,E){return this.channel.call("setValue",[g,w,E])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,w){return this.channel.call("isActiveElement",[g,w])}getElements(g,w,E){return this.channel.call("getElements",[g,w,E])}getElementXY(g,w,E,P){return this.channel.call("getElementXY",[g,w,E,P])}typeInEditor(g,w,E){return this.channel.call("typeInEditor",[g,w,E])}getTerminalBuffer(g,w){return this.channel.call("getTerminalBuffer",[g,w])}writeInTerminal(g,w,E){return this.channel.call("writeInTerminal",[g,w,E])}getLocaleInfo(g){return this.channel.call("getLocaleInfo",g)}getLocalizedStrings(g){return this.channel.call("getLocalizedStrings",g)}}e.DriverChannelClient=D;class C{constructor(g){this.registry=g}listen(g,w){throw new Error(`Event not found: ${w}`)}call(g,w,E){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(E);case"reloadWindowDriver":return this.registry.reloadWindowDriver(E)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=C;async function k(I){const g=await(0,v.connect)(I,"driverClient"),w=g.getChannel("driver"),E=new D(w);return{client:g,driver:E}}e.connect=k}),define(ee[23],te([0,1,46,9,57,48,168,5]),function(K,e,v,n,D,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(C.IEnvironmentService);class g extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}de([v.memoize],g.prototype,"cachedLanguagesPath",null),de([v.memoize],g.prototype,"backupHome",null),de([v.memoize],g.prototype,"backupWorkspacesPath",null),de([v.memoize],g.prototype,"mainIPCHandle",null),de([v.memoize],g.prototype,"mainLockfile",null),de([v.memoize],g.prototype,"sandbox",null),de([v.memoize],g.prototype,"driverVerbose",null),de([v.memoize],g.prototype,"disableUpdates",null),de([v.memoize],g.prototype,"disableKeytar",null),de([v.memoize],g.prototype,"codeCachePath",null),de([v.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(ee[231],te([0,1,60,28,27,10,9,3,16,7,24,162,19,23,18,6,30]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class{constructor(a,d,c){this.configurationService=d,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=g.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,u)=>(0,D.isEqual)(o,u,!I.isLinux)},this.backupHome=a.backupHome,this.workspacesJsonPath=a.backupWorkspacesPath}async initialize(){let a;try{a=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{a=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(a.emptyWorkspaceInfos);let d=[];try{Array.isArray(a.rootURIWorkspaces)&&(d=a.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:w.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(d);let c=[];try{Array.isArray(a.folderWorkspaceInfos)?c=a.folderWorkspaceInfos.map(o=>({folderUri:w.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(a.folderURIWorkspaces)&&(c=a.folderURIWorkspaces.map(o=>({folderUri:w.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(a,d){this.workspaces.some(o=>a.workspace.id===o.workspace.id)||(this.workspaces.push(a),this.saveSync());const c=this.getBackupPath(a.workspace.id);return d&&this.moveBackupFolderSync(c,d),c}moveBackupFolderSync(a,d){if(n.existsSync(a)&&this.convertToEmptyWindowBackupSync(a),n.existsSync(d))try{n.renameSync(d,a)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(a){const d=a.id,c=this.workspaces.findIndex(o=>o.workspace.id===d);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(a){return this.folders.some(d=>this.backupUriComparer.isEqual(a.folderUri,d.folderUri))||(this.folders.push(a),this.saveSync()),this.getBackupPath(this.getFolderHash(a))}unregisterFolderBackupSync(a){const d=this.folders.findIndex(c=>this.backupUriComparer.isEqual(a,c.folderUri));d!==-1&&(this.folders.splice(d,1),this.saveSync())}registerEmptyWindowBackupSync(a,d){const c=a||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:d}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(a){const d=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,a));d!==-1&&(this.emptyWindows.splice(d,1),this.saveSync())}getBackupPath(a){return(0,k.join)(this.backupHome,a)}async validateWorkspaces(a){if(!Array.isArray(a))return[];const d=new Set,c=[];for(let o of a){const u=o.workspace;if(!(0,m.isWorkspaceIdentifier)(u))return[];if(!d.has(u.id)){d.add(u.id);const s=this.getBackupPath(u.id);await this.doHasBackups(s)?u.configPath.scheme!==C.Schemas.file||await E.Promises.exists(u.configPath.fsPath)?c.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(a){if(!Array.isArray(a))return[];const d=[],c=new Set;for(let o of a){const u=o.folderUri,s=this.backupUriComparer.getComparisonKey(u);if(!c.has(s)){c.add(s);const i=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(i)?u.scheme!==C.Schemas.file||await E.Promises.exists(u.fsPath)?d.push(o):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return d}async validateEmptyWorkspaces(a){if(!Array.isArray(a))return[];const d=[],c=new Set;for(let o of a){const u=o.backupFolder;if(typeof u!="string")return[];if(!c.has(u)){c.add(u);const s=this.getBackupPath(u);await this.doHasBackups(s)?d.push(o):await this.deleteStaleBackup(s)}}return d}async deleteStaleBackup(a){try{await E.Promises.exists(a)&&await E.Promises.rm(a,E.RimRafMode.MOVE)}catch(d){this.logService.error(`Backup: Could not delete stale backup: ${d.toString()}`)}}async convertToEmptyWindowBackup(a){let d=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,d));)d=this.getRandomEmptyWindowId();const c=this.getBackupPath(d);try{await E.Promises.rename(a,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:d}),!0}convertToEmptyWindowBackupSync(a){let d=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,d));)d=this.getRandomEmptyWindowId();const c=this.getBackupPath(d);try{n.renameSync(a,c)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:d}),!0}async getDirtyWorkspaces(){const a=[];for(const d of this.workspaces)await this.hasBackups(d)&&a.push(d);for(const d of this.folders)await this.hasBackups(d)&&a.push(d);return a}hasBackups(a){let d;return(0,P.isEmptyWindowBackupInfo)(a)?d=a.backupFolder:(0,m.isFolderBackupInfo)(a)?d=this.getBackupPath(this.getFolderHash(a)):d=this.getBackupPath(a.workspace.id),this.doHasBackups(d)}async doHasBackups(a){try{const d=await E.Promises.readdir(a);for(const c of d)try{if((await E.Promises.readdir((0,k.join)(a,c))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(a){this.logService.error(`Backup: Could not save workspaces.json: ${a.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(a){this.logService.error(`Backup: Could not save workspaces.json: ${a.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(a=>({id:a.workspace.id,configURIPath:a.workspace.configPath.toString(),remoteAuthority:a.remoteAuthority})),folderWorkspaceInfos:this.folders.map(a=>({folderUri:a.folderUri.toString(),remoteAuthority:a.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(a){const d=a.folderUri;let c;return d.scheme===C.Schemas.file?c=I.isLinux?d.fsPath:d.fsPath.toLowerCase():c=d.toString().toLowerCase(),(0,v.createHash)("md5").update(c).digest("hex")}};p=de([ne(0,y.IEnvironmentMainService),ne(1,S.IConfigurationService),ne(2,f.ILogService)],p),e.BackupMainService=p}),define(ee[232],te([0,1,8,4,108,59,2,3,37,57,164,230,23,184,20,36,18,7,9,17,6]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(s){return s<21}let o=class{constructor(i,r,l,h,b,R,L){this.windowServer=i,this.options=r,this.windowsMainService=l,this.lifecycleMainService=h,this.fileService=b,this.environmentMainService=R,this.logService=L,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(i){const r=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!r?.win)throw new Error("Invalid window");return(await r.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,r){}async stopTracing(i,r,l){if(!l)return;const h=await this.capturePage(i),b=Buffer.from(h,"base64");await this.fileService.writeFile(p.URI.file((0,M.join)(this.environmentMainService.logsPath,`${r}.png`)),a.VSBuffer.wrap(b))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const r=this.windowsMainService.getWindowById(i);if(!r)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(r)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,r){await this.whenUnfrozen(i);const l=D.KeybindingParser.parseUserBinding(r);for(let h of l)await this._dispatchKeybinding(i,h)}async _dispatchKeybinding(i,r){if(r instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const l=this.windowsMainService.getWindowById(i);if(!l?.win)throw new Error("Invalid window");const h=l.win.webContents,b=new C.SimpleKeybinding(!1,!1,!1,!1,r.keyCode),L=new y.USLayoutResolvedKeybinding(b.toChord(),I.OS).getElectronAccelerator(),F=[];r.ctrlKey&&F.push("ctrl"),r.metaKey&&F.push("meta"),r.shiftKey&&F.push("shift"),r.altKey&&F.push("alt"),h.sendInputEvent({type:"keyDown",keyCode:L,modifiers:F}),c(r.keyCode)||h.sendInputEvent({type:"char",keyCode:L,modifiers:F}),h.sendInputEvent({type:"keyUp",keyCode:L,modifiers:F}),await(0,v.timeout)(100)}async click(i,r,l,h){await(await this.getWindowDriver(i)).click(r,l,h)}async doubleClick(i,r){await(await this.getWindowDriver(i)).doubleClick(r)}async setValue(i,r,l){await(await this.getWindowDriver(i)).setValue(r,l)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,r){return await(await this.getWindowDriver(i)).isActiveElement(r)}async getElements(i,r,l){return await(await this.getWindowDriver(i)).getElements(r,l)}async getElementXY(i,r,l,h){return await(await this.getWindowDriver(i)).getElementXY(r,l,h)}async typeInEditor(i,r,l){await(await this.getWindowDriver(i)).typeInEditor(r,l)}async getTerminalBuffer(i,r){return await(await this.getWindowDriver(i)).getTerminalBuffer(r)}async writeInTerminal(i,r,l){await(await this.getWindowDriver(i)).writeInTerminal(r,l)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){this.logService.info(`[driver] getWindowDriver(${i})`),await this.whenUnfrozen(i);const r=`window:${i}`,l=new g.StaticRouter(b=>b===r),h=this.windowServer.getChannel("windowDriver",l);return new E.WindowDriverChannelClient(h)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};o=de([ne(2,f.IWindowsMainService),ne(3,t.ILifecycleMainService),ne(4,m.IFileService),ne(5,S.IEnvironmentMainService),ne(6,d.ILogService)],o),e.Driver=o;async function u(s,i,r,l){const h=r.driverVerbose,b=l.createInstance(o,s,{verbose:h}),R=new P.WindowDriverRegistryChannel(b);s.registerChannel("windowDriverRegistry",R);const L=await(0,w.serve)(i),F=new P.DriverChannel(b);return L.registerChannel("driver",F),(0,k.combinedDisposable)(L,s)}e.serve=u}),define(ee[233],te([0,1,61,57]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,C,k,I,g){const w=P=>g(P,void 0),E=v.createConnection({host:D,port:C},()=>{E.removeListener("error",w);const P=Buffer.alloc(16);for(let f=0;f<16;f++)P[f]=Math.round(Math.random()*256);const S=P.toString("base64"),y=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${C}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];E.write(y.join(`\r
`)+`\r
\r
`);const t=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",t),g(void 0,new n.NodeSocket(E,I)))};E.on("data",t)});E.setNoDelay(!0),E.once("error",w)}}}),define(ee[234],te([0,1,61,121,233,8,2,19,6,22,199,99,77]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(M,a,d,c,o){let u;for(let s=3;s&&(u&&u.dispose(),u=await new t(M,a,d,c,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));s--);return u}class t extends k.Disposable{constructor(a,d,c,o,u){super();this.defaultTunnelHost=d,this.suggestedLocalPort=u,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=a,this._server=v.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(d=>{d()})}async waitForReady(){let a=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),d=null;return this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address(),d||(a=0,this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address()),this.tunnelLocalPort=d.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${d.port}`,this}async _onConnection(a){a.pause();const d=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,E.connectRemoteAgentTunnel)(this._options,d,this.tunnelRemotePort),o=c.getSocket().socket,u=c.readEntireBuffer();c.dispose(),u.byteLength>0&&a.write(u.buffer),a.on("end",()=>{this._socketsDispose.delete(a.localAddress),o.end()}),a.on("close",()=>o.end()),a.on("error",()=>{this._socketsDispose.delete(a.localAddress),o.destroy()}),o.on("end",()=>a.end()),o.on("close",()=>a.end()),o.on("error",()=>{a.destroy()}),a.pipe(o),o.pipe(a),this._socketsDispose.set(a.localAddress,()=>{a.end(),o.end()})}}let f=class extends P.AbstractTunnelService{constructor(a,d,c,o,u){super(d);this.socketFactory=a,this.signService=c,this.productService=o,this.configurationService=u}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(a,d,c,o,u,s,i){const r=this.getTunnelFromMap(d,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,d,c,o,u,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${c} on local port ${o}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:a,signService:this.signService,logService:this.logService,ipcLogger:null},h=y(l,this.defaultTunnelHost,d,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(d,c,h),h}}};f=de([ne(1,g.ILogService),ne(2,S.ISignService),ne(3,w.IProductService),ne(4,I.IConfigurationService)],f),e.BaseTunnelService=f;let m=class extends f{constructor(a,d,c,o){super(D.nodeSocketFactory,a,d,c,o)}};m=de([ne(0,g.ILogService),ne(1,S.ISignService),ne(2,w.IProductService),ne(3,I.IConfigurationService)],m),e.TunnelService=m;let p=class extends k.Disposable{constructor(a,d,c,o){super();this.logService=a,this.productService=d,this.signService=c,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(a,d,c,o,u,s,i,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${o} on local port ${u}.`),!this._tunnelServices.has(a)){const l=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(l),this._tunnelServices.set(a,l),l.onTunnelClosed(async()=>{(await l.tunnels).length===0&&(l.dispose(),this._tunnelServices.delete(a))})}return this._tunnelServices.get(a).openTunnel(d,c,o,u,s,i,r)}};p=de([ne(0,g.ILogService),ne(1,w.IProductService),ne(2,S.ISignService),ne(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ee[235],te([0,1,203,8,17,15,2,13,19,48,92,6,202,229]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends k.Disposable{constructor(m,p,M){super();this.environmentService=p,this.logService=M,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,p){this.logService.trace("RequestService#request",m.url);const{proxyUrl:M,strictSSL:a}=this;let d;try{d=await(0,E.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(u){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",u))}const c={...process.env,...d},o=m.agent?m.agent:await(0,S.getProxyAgent)(m.url||"",c,{proxyUrl:M,strictSSL:a});return m.agent=o,m.strictSSL=a,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,p)}async getNodeRequest(m){return((0,v.parse)(m.url).protocol==="https:"?await new Promise((a,d)=>{K(["https"],a,d)}):await new Promise((a,d)=>{K(["http"],a,d)})).request}_request(m,p){return n.Promises.withAsyncBody(async(M,a)=>{let d;const c=(0,v.parse)(m.url),o=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),u={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,I.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(u.auth=m.user+":"+m.password),d=o(u,s=>{const i=(0,I.isNumber)(m.followRedirects)?m.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)this._request({...m,url:s.headers.location,followRedirects:i-1},p).then(M,a);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,y.createGunzip)())),M({res:s,stream:(0,D.streamToBufferReadableStream)(r)})}}),d.on("error",a),m.timeout&&d.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&d.write(m.data),d.end(),p.onCancellationRequested(()=>{d.abort(),a((0,C.canceled)())})})}async resolveProxy(m){}};t=de([ne(0,g.IConfigurationService),ne(1,w.INativeEnvironmentService),ne(2,P.ILogService)],t),e.RequestService=t}),define(ee[236],te([0,1,14,235]),function(K,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(k){return v.net.request}class C extends n.RequestService{request(I,g){return super.request({...I||{},getRawRequest:D},g)}}e.RequestMainService=C}),define(ee[237],te([0,1,14,8,4,2,10,13,87,23,20,6,54,55,67,39]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends C.Disposable{constructor(M,a,d,c,o,u,s){super();this.machineId=M,this.userEnv=a,this.environmentMainService=d,this.lifecycleMainService=c,this.logService=o,this.themeMainService=u,this.protocolMainService=s,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:createSharedProcessMessageChannel",(M,a)=>this.onWindowConnection(M,a)),v.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(M,a)=>this.onWorkerConnection(M,a)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(M,a){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const d=await this.connect();if(M.sender.isDestroyed())return d.close();M.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[d])}onWorkerConnection(M,a){this.logService.trace("SharedProcess: onWorkerConnection",a);const d=new C.DisposableStore,c=u=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${u}')`,a),d.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",a))},o=v.BrowserWindow.fromId(a.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!a.reply.channel){c("unavailable");return}d.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===o)(()=>c("load"))),d.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>c("closed"))),o.webContents.postMessage(a.reply.channel,a.reply.nonce,M.ports)}onWillShutdown(){const M=this.window;!M||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(M.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{M.close()}catch{}this.window=void 0},0))}send(M,...a){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${M}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(M,...a)}catch(d){this.logService.warn(`Error sending IPC message to channel '${M}' of shared process: ${(0,f.toErrorMessage)(d)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(M=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),M()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(M=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),M()}))})()),this._whenIpcReady}createWindow(){const M=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),M.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:S.default}),this.window.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",K).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=M=>{this.logService.trace("SharedProcess#close prevented"),M.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(M,a)=>this._onDidError.fire({type:2,details:a})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(M,a,d)=>this._onDidError.fire({type:3,details:{reason:d,exitCode:a}})))}async connect(){await this.whenIpcReady;const M=(0,I.assertIsDefined)(this.window);return(0,g.connect)(M)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const M=this.window;return M?!M.isDestroyed()&&!M.webContents.isDestroyed():!1}};m=de([ne(2,w.IEnvironmentMainService),ne(3,E.ILifecycleMainService),ne(4,P.ILogService),ne(5,t.IThemeMainService),ne(6,y.IProtocolMainService)],m),e.SharedProcess=m}),define(ee[238],te([0,1,8,17,9,13,7,23,18,6]),function(K,e,v,n,D,C,k,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class E{constructor(y,t,f){this.storagePath=y,this.logService=t,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,t){const f=this.storage[y];return(0,C.isUndefinedOrNull)(f)?t:f}setItem(y,t){this.setItems([{key:y,data:t}])}setItems(y){let t=!1;for(const{key:f,data:m}of y)this.storage[f]!==m&&((0,C.isUndefinedOrNull)(m)?(0,C.isUndefined)(this.storage[f])||(this.storage[f]=void 0,t=!0):(this.storage[f]=m,t=!0));t&&this.save()}removeItem(y){(0,C.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=E;let P=class Et{constructor(y,t,f){this.fileStorage=new E(k.URI.file((0,D.join)(y.userDataPath,Et.STATE_FILE)),t,f)}async init(){return this.fileStorage.init()}getItem(y,t){return this.fileStorage.getItem(y,t)}setItem(y,t){this.fileStorage.setItem(y,t)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=de([ne(0,I.IEnvironmentMainService),ne(1,w.ILogService),ne(2,g.IFileService)],P),e.StateMainService=P}),define(ee[79],te([0,1,42,2,48,23,5,20,6,78,226]),function(K,e,v,n,D,C,k,I,g,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let P=class extends n.Disposable{constructor(t,f,m){super();this.logService=t,this.environmentService=f,this.lifecycleMainService=m,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{t.join(this.globalStorage.close());for(const[,f]of this.mapWorkspaceToStorage)t.join(f.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new E.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new E.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let f=this.mapWorkspaceToStorage.get(t.id);return f||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),f=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,f),(0,v.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),f}};P=de([ne(0,g.ILogService),ne(1,D.IEnvironmentService),ne(2,I.ILifecycleMainService)],P),e.StorageMainService=P,e.IGlobalStorageMainService=(0,k.createDecorator)("globalStorageMainService");let S=class extends w.AbstractStorageService{constructor(t,f){super();this.environmentMainService=t,this.storageMainService=f,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};S=de([ne(0,C.IEnvironmentMainService),ne(1,e.IStorageMainService)],S),e.GlobalStorageMainService=S}),define(ee[80],te([0,1,8,21,4,19,23,20,6,22,49,41]),function(K,e,v,n,D,C,k,I,g,w,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(t,f,m){return`${m.updateUrl}/api/update/${t}/${f}/${m.commit}`}e.createUpdateURL=S;let y=class{constructor(f,m,p,M,a,d){this.lifecycleMainService=f,this.configurationService=m,this.environmentMainService=p,this.requestService=M,this.logService=a,this.productService=d,this._state=P.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(f){this.logService.info("update#setState",f.type),this._state=f,this._onStateChange.fire(f)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const f=this.getUpdateMode(),m=this.getProductQuality(f);if(!m){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),f==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}f==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(f){return f==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(f=60*60*1e3){return(0,v.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(f){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(f)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(f){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(f=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};y=de([ne(0,I.ILifecycleMainService),ne(1,C.IConfigurationService),ne(2,k.IEnvironmentMainService),ne(3,E.IRequestService),ne(4,g.ILogService),ne(5,w.IProductService)],y),e.AbstractUpdateService=y}),define(ee[239],te([0,1,14,46,4,2,19,23,20,6,22,49,29,41,80]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let f=class extends t.AbstractUpdateService{constructor(p,M,a,d,c,o,u){super(p,M,d,c,o,u);this.telemetryService=a,this.disposables=new C.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(p,M)=>M)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(p,M,a)=>({url:M,version:a,productVersion:a}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(p,M,a,d)=>({releaseNotes:M,version:a,productVersion:a,date:d}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const a=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(y.State.Idle(1,a))}buildUpdateFeedUrl(p){let M;this.productService.darwinUniversalAssetId?M=this.productService.darwinUniversalAssetId:M=process.arch==="x64"?"darwin":"darwin-arm64";const a=(0,t.createUpdateURL)(M,p,this.productService);try{v.autoUpdater.setFeedURL({url:a})}catch(d){this.logService.error("Failed to set update feed URL",d);return}return a}doCheckForUpdates(p){this.setState(y.State.CheckingForUpdates(p)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(y.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([n.memoize],f.prototype,"onRawError",null),de([n.memoize],f.prototype,"onRawUpdateNotAvailable",null),de([n.memoize],f.prototype,"onRawUpdateAvailable",null),de([n.memoize],f.prototype,"onRawUpdateDownloaded",null),f=de([ne(0,g.ILifecycleMainService),ne(1,k.IConfigurationService),ne(2,S.ITelemetryService),ne(3,I.IEnvironmentMainService),ne(4,P.IRequestService),ne(5,w.ILogService),ne(6,E.IProductService)],f),e.DarwinUpdateService=f}),define(ee[240],te([0,1,44,28,8,4,9,23,20,6,29,41]),function(K,e,v,n,D,C,k,I,g,w,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(f,m,p){if(this.lifecycleMainService=f,this.logService=p,this._state=P.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,M=>this.logService.error(M))}get state(){return this._state}setState(f){this.logService.info("update#setState",f.type),this._state=f,this._onStateChange.fire(f)}scheduleCheckForUpdates(f=60*60*1e3){return(0,D.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(f){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(f)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(f){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(f=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};S=de([ne(0,g.ILifecycleMainService),ne(1,I.IEnvironmentMainService),ne(2,w.ILogService)],S);let y=class extends S{constructor(f,m,p,M,a,d){super(p,M,a);this.snap=f,this.snapRevision=m,this.telemetryService=d;const c=(0,n.watch)(k.dirname(this.snap)),o=C.Event.fromNodeEventEmitter(c,"change",(r,l)=>l),u=C.Event.filter(o,r=>r==="current"),i=C.Event.debounce(u,(r,l)=>l,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(f=>{f?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},f=>{this.logService.error(f),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,f.message||f))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const f=await new Promise((p,M)=>(0,n.realpath)(`${k.dirname(this.snap)}/current`,(a,d)=>a?M(a):p(d))),m=k.basename(f);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,f=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=de([ne(2,g.ILifecycleMainService),ne(3,I.IEnvironmentMainService),ne(4,w.ILogService),ne(5,E.ITelemetryService)],y),e.SnapUpdateService=y}),define(ee[45],te([0,1,14,28,4,43,33,2,10,9,3,16,13,24,161,52,50,23,5,6,22,101,30,102]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,M.createDecorator)("workspacesManagementMainService");let s=class extends I.Disposable{constructor(r,l,h,b,R){super();this.environmentMainService=r,this.logService=l,this.backupMainService=h,this.dialogMainService=b,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(r){return this.doResolveLocalWorkspace(r,l=>(0,n.readFileSync)(l,"utf8"))}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,l=>y.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(r,l){if(!!this.isWorkspacePath(r)&&r.scheme===g.Schemas.file)try{const h=l(r.fsPath);return h instanceof Promise?h.then(b=>this.doResolveWorkspace(r,b),b=>{}):this.doResolveWorkspace(r,h)}catch{return}}isWorkspacePath(r){return(0,o.isUntitledWorkspace)(r,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,l){try{const h=this.doParseStoredWorkspace(r,l),b=(0,u.getWorkspaceIdentifier)(r);return{id:b.id,configPath:b.configPath,folders:(0,o.toWorkspaceFolders)(h.folders,b.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:h.remoteAuthority,transient:h.transient}}catch(h){this.logService.warn(h.toString())}}doParseStoredWorkspace(r,l){const h=(0,C.parse)(l);if(h&&Array.isArray(h.folders))h.folders=h.folders.filter(b=>(0,o.isStoredWorkspaceFolder)(b));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return h}async createUntitledWorkspace(r,l){const{workspace:h,storedWorkspace:b}=this.newUntitledWorkspace(r,l),R=h.configPath.fsPath;return await y.Promises.mkdir((0,w.dirname)(R),{recursive:!0}),await y.Promises.writeFile(R,JSON.stringify(b,null,"	")),h}createUntitledWorkspaceSync(r,l){const{workspace:h,storedWorkspace:b}=this.newUntitledWorkspace(r,l),R=h.configPath.fsPath;return(0,n.mkdirSync)((0,w.dirname)(R),{recursive:!0}),(0,y.writeFileSync)(R,JSON.stringify(b,null,"	")),h}newUntitledWorkspace(r=[],l){const h=(Date.now()+Math.round(Math.random()*1e3)).toString(),b=(0,P.joinPath)(this.untitledWorkspacesHome,h),R=(0,P.joinPath)(b,o.UNTITLED_WORKSPACE_NAME),L=[];for(const F of r)L.push((0,o.getStoredWorkspaceFolder)(F.uri,!0,F.name,b,!E.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,u.getWorkspaceIdentifier)(R),storedWorkspace:{folders:L,remoteAuthority:l}}}async getWorkspaceIdentifier(r){return(0,u.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,o.isUntitledWorkspace)(r.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(r){!this.isUntitledWorkspace(r)||(this.doDeleteUntitledWorkspaceSync(r),this._onDidDeleteUntitledWorkspace.fire(r))}async deleteUntitledWorkspace(r){this.deleteUntitledWorkspaceSync(r)}doDeleteUntitledWorkspaceSync(r){const l=(0,P.originalFSPath)(r.configPath);try{(0,y.rimrafSync)((0,w.dirname)(l));const h=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);(0,n.existsSync)(h)&&(0,y.writeFileSync)((0,w.join)(h,"obsolete"),"")}catch(h){this.logService.warn(`Unable to delete untitled workspace ${l} (${h}).`)}}getUntitledWorkspacesSync(){const r=[];try{const l=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(h=>(0,P.joinPath)(this.untitledWorkspacesHome,h,o.UNTITLED_WORKSPACE_NAME));for(const h of l){const b=(0,u.getWorkspaceIdentifier)(h),R=this.resolveLocalWorkspaceSync(h);R?r.push({workspace:b,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(b)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return r}async enterWorkspace(r,l,h){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,l,h))return;const R=this.doEnterWorkspace(r,(0,u.getWorkspaceIdentifier)(h));if(!!R)return this._onDidEnterWorkspace.fire({window:r,workspace:R.workspace}),R}async isValidTargetWorkspacePath(r,l,h){if(!h)return!0;if((0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,h))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,h)){const b={title:this.productService.nameLong,type:"info",buttons:[(0,k.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,P.basename)(h)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(b,(0,S.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(r,l){if(!r.config)return;r.focus();let h;return r.config.extensionDevelopmentPath||(h=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:r.remoteAuthority},r.config.backupPath)),(0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&this.deleteUntitledWorkspaceSync(r.openedWorkspace),r.config.workspace=l,r.config.backupPath=h,{workspace:l,backupPath:h}}};s=de([ne(0,p.IEnvironmentMainService),ne(1,a.ILogService),ne(2,f.IBackupMainService),ne(3,m.IDialogMainService),ne(4,d.IProductService)],s),e.WorkspacesManagementMainService=s}),define(ee[103],te([0,1,14,31,21,3,13,7,24,19,53,5,6,100,36,30,45]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let p=class{constructor(a,d,c,o,u){this.logService=a,this.windowsMainService=d,this.urlService=c,this.workspacesManagementMainService=o,this.configurationService=u}async start(a,d){this.logService.trace("Received data from other instance: ",a,d),C.isMacintosh&&v.app.focus({steal:!0});const c=this.parseOpenUrl(a);if(c.length){let o=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(o=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),o.then(()=>{for(const{uri:u,url:s}of c)this.urlService.open(u,{originalUrl:s})})}else return this.startOpenWindow(a,d)}parseOpenUrl(a){return a["open-url"]&&a._urls&&a._urls.length>0?(0,n.coalesce)(a._urls.map(d=>{try{return{uri:I.URI.parse(d),url:d}}catch{return null}})):[]}async startOpenWindow(a,d){const c=(0,E.isLaunchedFromCli)(d)?0:4;let o=[];const u=a.wait&&a.waitMarkerFilePath?I.URI.file(a.waitMarkerFilePath):void 0,s=a.remote||void 0,i={context:c,cli:a,userEnv:d,waitMarkerFileURI:u,remoteAuthority:s};if(a.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(a.extensionDevelopmentPath,i);else if(!a._.length&&!a["folder-uri"]&&!a["file-uri"]){let r=!1;if(a["new-window"]||a["unity-launch"])r=!0;else if(a["reuse-window"])r=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!C.isMacintosh}if(r)o=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const l=this.windowsMainService.getLastActiveWindow();l?(this.windowsMainService.openExistingWindow(l,i),o=[l]):o=this.windowsMainService.open({...i,forceEmpty:!0})}}else o=this.windowsMainService.open({...i,forceNewWindow:a["new-window"],preferNewWindow:!a["reuse-window"]&&!a.wait,forceReuseWindow:a["reuse-window"],diffMode:a.diff,addMode:a.add,noRecentEntry:!!a["skip-add-to-recently-opened"],gotoLineMode:a.goto});if(u&&o.length===1&&o[0])return Promise.race([o[0].whenClosedOrLoaded,(0,g.whenDeleted)(u.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const a=[];return v.BrowserWindow.getAllWindows().forEach(d=>{const c=this.windowsMainService.getWindowById(d.id);c?a.push(this.codeWindowToInfo(c)):a.push(this.browserWindowToInfo(d))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:a,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(a){const d=this.windowsMainService.getWindows();return(await Promise.all(d.map(o=>new Promise(u=>{const s=o.remoteAuthority;if(s){const i=`vscode:getDiagnosticInfoResponse${o.id}`,r={includeProcesses:a.includeProcesses,folders:a.includeWorkspaceMetadata?this.getFolderURIs(o):void 0};o.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:i,args:r}),v.ipcMain.once(i,(l,h)=>{h||u({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),u(h)}),setTimeout(()=>{u({hostName:s,errorMessage:`Connection to '${s}' could not be established`})},5e3)}else u(void 0)})))).filter(o=>!!o)}getFolderURIs(a){const d=[],c=a.openedWorkspace;if((0,f.isSingleFolderWorkspaceIdentifier)(c))d.push(c.uri);else if((0,f.isWorkspaceIdentifier)(c)){const o=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);o&&o.folders.forEach(s=>{d.push(s.uri)})}return d}codeWindowToInfo(a){const d=this.getFolderURIs(a),c=(0,k.assertIsDefined)(a.win);return this.browserWindowToInfo(c,d,a.remoteAuthority)}browserWindowToInfo(a,d=[],c){return{pid:a.webContents.getOSProcessId(),title:a.getTitle(),folderURIs:d,remoteAuthority:c}}};p=de([ne(0,S.ILogService),ne(1,t.IWindowsMainService),ne(2,y.IURLService),ne(3,m.IWorkspacesManagementMainService),ne(4,w.IConfigurationService)],p),e.LaunchMainService=p}),define(ee[58],te([0,1,44,14,26,120,46,4,33,2,10,9,3,7,84,73,24,153,50,23,5,20,6,22,29,67,36,30,45]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c,o,u,s,i,r,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,d.createDecorator)("nativeHostMainService");let b=class extends w.Disposable{constructor(L,F,z,Q,oe,re,q,x,H,G){super();this.sharedProcess=L,this.windowsMainService=F,this.dialogMainService=z,this.lifecycleMainService=Q,this.environmentMainService=oe,this.telemetryService=re,this.logService=q,this.productService=x,this.themeMainService=H,this.workspacesManagementMainService=G,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,j=>j.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(j,N)=>N.id),j=>!!this.windowsMainService.getWindowById(j)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(j,N)=>N.id),j=>!!this.windowsMainService.getWindowById(j)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(j,N)=>N.id),j=>!!this.windowsMainService.getWindowById(j)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),j=>!!j),j=>j.id),I.Event.filter(I.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(j,N)=>N.id),j=>!!this.windowsMainService.getWindowById(j))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(j,N,B)=>B),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),I.Event.fromNodeEventEmitter(n.screen,"display-added"),I.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace,title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(L){return this.windowsMainService.getWindowCount()}async getActiveWindowId(L){const F=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(L,F,z){return Array.isArray(F)?this.doOpenWindow(L,F,z):this.doOpenEmptyWindow(L,F)}async doOpenWindow(L,F,z=Object.create(null)){F.length>0&&this.windowsMainService.open({context:5,contextWindowId:L,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0})}async doOpenEmptyWindow(L,F){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:L},F)}async toggleFullScreen(L){const F=this.windowById(L);F&&F.toggleFullScreen()}async handleTitleDoubleClick(L){const F=this.windowById(L);F&&F.handleTitleDoubleClick()}async isMaximized(L){const F=this.windowById(L);return F?.win?F.win.isMaximized():!1}async maximizeWindow(L){const F=this.windowById(L);F?.win&&F.win.maximize()}async unmaximizeWindow(L){const F=this.windowById(L);F?.win&&F.win.unmaximize()}async minimizeWindow(L){const F=this.windowById(L);F?.win&&F.win.minimize()}async focusWindow(L,F){F&&typeof F.windowId=="number"&&(L=F.windowId);const z=this.windowById(L);z&&z.focus({force:F?.force??!1})}async setMinimumSize(L,F,z){const Q=this.windowById(L);if(Q?.win){const[oe,re]=Q.win.getSize(),[q,x]=Q.win.getMinimumSize(),[H,G]=[F??q,z??x],[j,N]=[Math.max(oe,H),Math.max(re,G)];(q!==H||x!==G)&&Q.win.setMinimumSize(H,G),(oe!==j||re!==N)&&Q.win.setSize(j,N)}}async saveWindowSplash(L,F){this.themeMainService.saveWindowSplash(L,F)}async installShellCommand(L){const{source:F,target:z}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await m.SymlinkSupport.stat(F);if(Q&&!Q.dangling){const oe=await(0,t.realpath)(F);if(z===oe)return}await m.Promises.unlink(F)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await m.Promises.symlink(z,F)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:oe}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(0,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,g.mnemonicButtonLabel)((0,p.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${F}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(re)}catch{throw new Error((0,p.localize)(3,null,F))}}}async uninstallShellCommand(L){const{source:F}=await this.getShellCommandLink();try{await m.Promises.unlink(F)}catch(z){switch(z.code){case"EACCES":{const{response:Q}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(4,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,g.mnemonicButtonLabel)((0,p.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const oe=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(oe)}catch{throw new Error((0,p.localize)(7,null,F))}break}case"ENOENT":break;default:throw z}}}async getShellCommandLink(){const L=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(L))throw new Error((0,p.localize)(8,null,L));return{source:F,target:L}}async showMessageBox(L,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(L))}async showSaveDialog(L,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(L))}async showOpenDialog(L,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(L))}toBrowserWindow(L){const F=this.windowById(L);if(F?.win)return F.win}async pickFileFolderAndOpen(L,F){const z=await this.dialogMainService.pickFileFolder(F);z&&(this.sendPickerTelemetry(z,F.telemetryEventName||"openFileFolder",F.telemetryExtraData),this.doOpenPicked(await Promise.all(z.map(async Q=>await m.SymlinkSupport.existsDirectory(Q)?{folderUri:y.URI.file(Q)}:{fileUri:y.URI.file(Q)})),F,L))}async pickFolderAndOpen(L,F){const z=await this.dialogMainService.pickFolder(F);z&&(this.sendPickerTelemetry(z,F.telemetryEventName||"openFolder",F.telemetryExtraData),this.doOpenPicked(z.map(Q=>({folderUri:y.URI.file(Q)})),F,L))}async pickFileAndOpen(L,F){const z=await this.dialogMainService.pickFile(F);z&&(this.sendPickerTelemetry(z,F.telemetryEventName||"openFile",F.telemetryExtraData),this.doOpenPicked(z.map(Q=>({fileUri:y.URI.file(Q)})),F,L))}async pickWorkspaceAndOpen(L,F){const z=await this.dialogMainService.pickWorkspace(F);z&&(this.sendPickerTelemetry(z,F.telemetryEventName||"openWorkspace",F.telemetryExtraData),this.doOpenPicked(z.map(Q=>({workspaceUri:y.URI.file(Q)})),F,L))}doOpenPicked(L,F,z){this.windowsMainService.open({context:3,contextWindowId:z,cli:this.environmentMainService.args,urisToOpen:L,forceNewWindow:F.forceNewWindow})}sendPickerTelemetry(L,F,z){const Q=L?L.length:0;this.telemetryService.publicLog(F,{...z,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(L,F){n.shell.showItemInFolder(F)}async setRepresentedFilename(L,F){const z=this.windowById(L);z&&z.setRepresentedFilename(F)}async setDocumentEdited(L,F){const z=this.windowById(L);z&&z.setDocumentEdited(F)}async openExternal(L,F){return S.isLinuxSnap?this.safeSnapOpenExternal(F):n.shell.openExternal(F),!0}safeSnapOpenExternal(L){const F=process.env.GDK_PIXBUF_MODULE_FILE,z=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(L),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=z}moveItemToTrash(L,F){return n.shell.trashItem(F)}async isAdmin(){let L;return S.isWindows?L=(await new Promise((F,z)=>{K(["native-is-elevated"],F,z)}))():L=process.getuid()===0,L}async writeElevated(L,F,z,Q){const oe=await new Promise((re,q)=>{K(["@vscode/sudo-prompt"],re,q)});return new Promise((re,q)=>{const x=[`"${this.cliPath}"`];Q?.unlock&&x.push("--file-chmod"),x.push("--file-write",`"${F.fsPath}"`,`"${z.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(x.join(" "),H,(G,j,N)=>{j&&this.logService.trace(`[sudo-prompt] received stdout: ${j}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),G?q(G):re(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return f.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(L,F,z){process.kill(F,z)}async readClipboardText(L,F){return n.clipboard.readText(F)}async writeClipboardText(L,F,z){return n.clipboard.writeText(F,z)}async readClipboardFindText(L){return n.clipboard.readFindText()}async writeClipboardFindText(L,F){return n.clipboard.writeFindText(F)}async writeClipboardBuffer(L,F,z,Q){return n.clipboard.writeBuffer(F,Buffer.from(z),Q)}async readClipboardBuffer(L,F){return n.clipboard.readBuffer(F)}async hasClipboard(L,F,z){return n.clipboard.has(F,z)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,F){const z=this.windowById(L);z&&z.updateTouchBar(F)}async notifyReady(L){const F=this.windowById(L);F&&F.setReady()}async relaunch(L,F){return this.lifecycleMainService.relaunch(F)}async reload(L,F){const z=this.windowById(L);if(z){if((0,l.isWorkspaceIdentifier)(z.openedWorkspace)){const Q=z.openedWorkspace.configPath;if(Q.scheme===E.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(z,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,F){const z=this.windowById(F);if(z?.win)return z.win.close()}async quit(L){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(L,F){await this.lifecycleMainService.kill(F)}async resolveProxy(L,F){const Q=this.windowById(L)?.win?.webContents?.session;if(Q)return Q.resolveProxy(F)}async openDevTools(L,F){const z=this.windowById(L);z?.win&&z.win.webContents.openDevTools(F)}async toggleDevTools(L){const F=this.windowById(L);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(L,F){const z=this.windowById(L);z?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&z.win.webContents.sendInputEvent(F)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(L,F,z,Q){if(!S.isWindows)return;const oe=await new Promise((re,q)=>{K(["@vscode/windows-registry"],re,q)});try{return oe.GetStringRegKey(F,z,Q)}catch{return}}windowById(L){if(typeof L=="number")return this.windowsMainService.getWindowById(L)}};de([k.memoize],b.prototype,"cliPath",null),b=de([ne(1,r.IWindowsMainService),ne(2,M.IDialogMainService),ne(3,c.ILifecycleMainService),ne(4,a.IEnvironmentMainService),ne(5,s.ITelemetryService),ne(6,o.ILogService),ne(7,u.IProductService),ne(8,i.IThemeMainService),ne(9,h.IWorkspacesManagementMainService)],b),e.NativeHostMainService=b}),define(ee[241],te([0,1,14,26,33,2,10,3,85,151,75,50,23,5,103,6,58,54,22,55,68]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let c=class It{constructor(u,s,i,r,l,h,b,R,L){this.userEnv=u,this.environmentMainService=s,this.launchMainService=i,this.logService=r,this.diagnosticsService=l,this.dialogMainService=h,this.nativeHostMainService=b,this.protocolMainService=R,this.productService=L,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async u=>{const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),r=await this.diagnosticsService.getSystemInfo(s,i);this.safeSend(u,"vscode:issueSystemInfoResponse",r)}),v.ipcMain.on("vscode:listProcesses",async u=>{const s=[];try{const i=await this.launchMainService.getMainProcessId();s.push({name:(0,w.localize)(0,null),rootProcess:await(0,g.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(l=>{(0,E.isRemoteDiagnosticError)(l)?s.push({name:l.hostName,rootProcess:l}):l.processes&&s.push({name:l.hostName,rootProcess:l.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(u,"vscode:listProcessesResponse",s)}),v.ipcMain.on("vscode:issueReporterClipboard",async u=>{const s={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(u,"vscode:issueReporterClipboardResponse",i.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async u=>{const s=await this.getPerformanceInfo();this.safeSend(u,"vscode:issuePerformanceInfoResponse",s)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const u={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(u,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(u,s)=>{const{id:i,from:r,args:l}=s;let h;switch(r){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${r}`)}h&&h.webContents.send("vscode:runAction",{id:i,from:r,args:l})}),v.ipcMain.on("vscode:openExternal",(u,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),v.ipcMain.on("vscode:closeIssueReporter",u=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",u=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async u=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(u,"vscode:windowsInfoResponse",s.windows)})}safeSend(u,s,...i){u.sender.isDestroyed()||u.sender.send(s,...i)}async openReporter(u){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new C.DisposableStore,i=s.add(this.protocolMainService.createIPCObjectUrl()),r=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(r,i,{backgroundColor:u.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:u,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:p.default}),this.issueReporterWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",K).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(u){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new C.DisposableStore,i=s.add(this.protocolMainService.createIPCObjectUrl()),r=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(r,i,{backgroundColor:u.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:u.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:u,product:p.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",K).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(u){u.isMinimized()&&u.restore(),u.focus()}createBrowserWindow(u,s,i,r){const l=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:i.title,backgroundColor:i.backgroundColor||It.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,`--vscode-window-kind=${r}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[u,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(u,s)}getWindowPosition(u,s,i){let r;const l=v.screen.getAllDisplays();if(l.length===1)r=l[0];else{if(I.isMacintosh){const R=v.screen.getCursorScreenPoint();r=v.screen.getDisplayNearestPoint(R)}!r&&u&&(r=v.screen.getDisplayMatching(u.getBounds())),r||(r=v.screen.getPrimaryDisplay()||l[0])}const h={width:s,height:i},b=r.bounds;return h.x=b.x+b.width/2-h.width/2,h.y=b.y+b.height/2-h.height/2,b.width>0&&b.height>0&&(h.x<b.x&&(h.x=b.x),h.y<b.y&&(h.y=b.y),h.x>b.x+b.width&&(h.x=b.x),h.y>b.y+b.height&&(h.y=b.y),h.width>b.width&&(h.width=b.width),h.height>b.height&&(h.height=b.height)),h}async getPerformanceInfo(){try{const[u,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(u,s)}catch(u){throw this.logService.warn("issueService#getPerformanceInfo ",u.message),u}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=de([ne(1,S.IEnvironmentMainService),ne(2,t.ILaunchMainService),ne(3,f.ILogService),ne(4,E.IDiagnosticsService),ne(5,P.IDialogMainService),ne(6,m.INativeHostMainService),ne(7,a.IProtocolMainService),ne(8,M.IProductService)],c),e.IssueMainService=c}),define(ee[242],te([0,1,21,19,23,20,6,58,22,49,29,41,80]),function(K,e,v,n,D,C,k,I,g,w,E,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends S.AbstractUpdateService{constructor(f,m,p,M,a,d,c,o){super(f,m,M,a,d,o);this.telemetryService=p,this.nativeHostMainService=c}buildUpdateFeedUrl(f){return(0,S.createUpdateURL)(`linux-${process.arch}`,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(P.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},v.CancellationToken.None).then(w.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const p=f?m.message||m:void 0;this.setState(P.State.Idle(1,p))}))}async doDownloadUpdate(f){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(P.State.Idle(1))}};y=de([ne(0,C.ILifecycleMainService),ne(1,n.IConfigurationService),ne(2,E.ITelemetryService),ne(3,D.IEnvironmentMainService),ne(4,w.IRequestService),ne(5,k.ILogService),ne(6,I.INativeHostMainService),ne(7,g.IProductService)],y),e.LinuxUpdateService=y}),define(ee[243],te([0,1,44,28,26,8,21,46,9,7,117,24,19,23,18,20,6,58,22,49,29,41,80]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function u(l,h=1e3){for(;!l();)await(0,C.timeout)(h)}let s;function i(){return typeof s=="undefined"&&(s=n.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),s}let r=class extends o.AbstractUpdateService{constructor(h,b,R,L,F,z,Q,oe,re){super(h,b,L,F,z,re);this.telemetryService=R,this.fileService=Q,this.nativeHostMainService=oe}get cachePath(){const h=g.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(h,{recursive:!0}).then(()=>h)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(h){let b="win32";return process.arch!=="ia32"&&(b+=`-${process.arch}`),i()===1?b+="-archive":this.productService.target==="user"&&(b+="-user"),(0,o.createUpdateURL)(b,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(c.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},k.CancellationToken.None).then(a.asJson).then(b=>{const R=i();return!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(b)),Promise.resolve(null)):(this.setState(c.State.Downloading(b)),this.cleanup(b.version).then(()=>this.getUpdatePackagePath(b.version).then(L=>P.Promises.exists(L).then(F=>{if(F)return Promise.resolve(L);const z=b.url,Q=b.hash,oe=`${L}.tmp`;return this.requestService.request({url:z},k.CancellationToken.None).then(re=>this.fileService.writeFile(w.URI.file(oe),re.stream)).then(Q?()=>(0,E.checksum)(oe,b.hash):()=>{}).then(()=>P.Promises.rename(oe,L)).then(()=>L)})).then(L=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},F&&b.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(b)):this.setState(c.State.Ready(b))})))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const R=h?b.message||b:void 0;this.setState(c.State.Idle(i(),R))}))}async doDownloadUpdate(h){h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(h){const b=await this.cachePath;return g.join(b,`CodeSetup-${this.productService.quality}-${h}.exe`)}async cleanup(h=null){const b=h?z=>!new RegExp(`${this.productService.quality}-${h}\\.exe$`).test(z):()=>!0,R=await this.cachePath,F=(await P.Promises.readdir(R)).filter(b).map(async z=>{try{await P.Promises.unlink(g.join(R,z))}catch{}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const h=this.state.update;this.setState(c.State.Updating(h));const b=await this.cachePath;this.availableUpdate.updateFilePath=g.join(b,`CodeSetup-${this.productService.quality}-${h.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,F=await new Promise((z,Q)=>{K(["windows-mutex"],z,Q)});u(()=>F.isActive(L)).then(()=>this.setState(c.State.Ready(h)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};de([I.memoize],r.prototype,"cachePath",null),r=de([ne(0,f.ILifecycleMainService),ne(1,S.IConfigurationService),ne(2,d.ITelemetryService),ne(3,y.IEnvironmentMainService),ne(4,a.IRequestService),ne(5,m.ILogService),ne(6,t.IFileService),ne(7,p.INativeHostMainService),ne(8,M.IProductService)],r),e.Win32UpdateService=r}),define(ee[244],te([0,1,14,8,21,39,4,33,2,10,9,64,3,7,157,52,19,50,23,53,210,18,20,6,22,55,79,29,213,67,68,36,30,45]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c,o,u,s,i,r,l,h,b,R,L,F,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(Q||(Q={}));let oe=class extends g.Disposable{constructor(q,x,H,G,j,N,B,Y,V,W,$,A,T,_,O){super();this.logService=x,this.environmentMainService=H,this.fileService=G,this.globalStorageMainService=j,this.configurationService=N,this.themeMainService=B,this.workspacesManagementMainService=Y,this.backupMainService=V,this.telemetryService=W,this.dialogMainService=$,this.lifecycleMainService=A,this.productService=T,this.protocolMainService=_,this.windowsMainService=O,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[U,J]=this.restoreWindowState(q.state);this.windowState=U,this.logService.trace("window#ctor: using window state",U);const ie=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),Z={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:R.WindowMinimumSize.WIDTH,minHeight:R.WindowMinimumSize.HEIGHT,show:!ie,title:this.productService.nameLong,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,R.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};S.isLinux?Z.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(Z.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(Z.fullscreenable=!1),S.isMacintosh&&(Z.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(Z.acceptFirstMouse=!1));const ce=S.isMacintosh&&se?.nativeTabs===!0;ce&&(Z.tabbingIdentifier=this.productService.nameShort);const le=(0,R.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(Z.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,S.isMacintosh||(Z.frame=!1)),(0,P.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(Z),(0,P.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),S.isMacintosh&&le&&this._win.setSheetOffset(22),S.isMacintosh&&J&&(!ce||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}ie&&((0,P.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(q){S.isMacintosh?this._win.setRepresentedFilename(q):this.representedFilename=q}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(q){S.isMacintosh&&this._win.setDocumentEdited(q),this.documentEdited=q}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(q){S.isMacintosh&&q?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(q=>{if(this.isReady)return q(this);this.whenReadyCallbacks.push(q)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(q=>{function x(){H.dispose(),G.dispose(),q()}const H=this.onDidClose(()=>x()),G=this.onWillLoad(()=>x())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(j,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(j,N,B)=>this.onWindowError(3,{reason:B,exitCode:N})),this._win.webContents.on("will-prevent-unload",j=>{j.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const q=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,"devtools"]),x=j=>{for(let N=j;N;N=N.parent)if(N.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},H=j=>j.resourceType==="xhr"||x(j.frame);this._win.webContents.session.webRequest.onBeforeRequest((j,N)=>{const B=y.URI.parse(j.url);return B.path.endsWith(".svg")&&!q.has(B.scheme)?N({cancel:!H(j)}):N({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((j,N)=>{const B=j.responseHeaders,Y=B["content-type"]||B["Content-Type"];if(Y&&Array.isArray(Y)){const V=y.URI.parse(j.url);if(V.path.endsWith(".svg")&&q.has(V.scheme))return B["Content-Type"]=["image/svg+xml"],N({cancel:!1,responseHeaders:B});if(!V.path.includes(w.Schemas.vscodeRemoteResource)&&Y.some(W=>W.toLowerCase().includes("image/svg")))return N({cancel:!H(j)})}return N({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",j=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",j,this._win)}),this._win.on("unmaximize",j=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",j,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(j=>this.onDidDeleteUntitledWorkspace(j)));const G=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:G},async(j,N)=>{const B=await this.getMarketplaceHeaders();N({cancel:!1,requestHeaders:Object.assign(j.requestHeaders,B)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,d.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(q,x){switch(q){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:q,reason:x?.reason,code:x?.exitCode}),q){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(q===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(H.response!==1){const G=H.response===0;this.destroyWindow(G)}}else if(q===2){let H;x?H=(0,t.localize)(6,null,x.reason,x.exitCode??"<unknown>"):H=(0,t.localize)(5,null);const j=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:H,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(j)}break}}destroyWindow(q){if(this._onDidDestroy.fire(),this._win?.destroy(),q&&this.config){let x,H;(0,F.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?x={folderUri:this.openedWorkspace.uri}:(0,F.isWorkspaceIdentifier)(this.openedWorkspace)?x={workspaceUri:this.openedWorkspace.configPath}:H=!0;const[G]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:x?[x]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});G.focus()}}onDidDeleteUntitledWorkspace(q){this.openedWorkspace?.id===q.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const q=this.getMenuBarVisibility();q!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=q,this.setMenuBarVisibility(q));let x=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;x?.endsWith("/")&&(x=x.substr(0,x.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((x||"").indexOf("@")===-1&&(x!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=x,this.currentNoProxy=H;const G=x||"",j=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${G}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:G,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(q){S.isMacintosh&&q.win&&this._win.addTabbedWindow(q.win)}load(q,x=Object.create(null)){this.isDocumentEdited()&&(!x.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),x.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(q,x),this.readyState===0?this.currentConfig=q:(this.pendingLoadConfig=q,this.readyState=2),this._win.loadURL(w.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",K).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:q.workspace,reason:x.isReload?3:H?2:1})}updateConfiguration(q,x){const H=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(H){const G=(0,a.isLaunchedFromCli)(H)&&!(0,a.isLaunchedFromCli)(q.userEnv),j=this.isExtensionDevelopmentHost;(G||j)&&(q.userEnv={...H,...q.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(q.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),x.disableExtensions!==void 0&&(q["disable-extensions"]=x.disableExtensions),q.fullscreen=this.isFullScreen,q.maximized=this._win.isMaximized(),q.partsSplash=this.themeMainService.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),q.perfMarks=(0,P.getMarks)(),this.configObjectUrl.update(q)}async reload(q){const x=Object.assign({},this.currentConfig);x.workspace=await this.validateWorkspaceBeforeReload(x),delete x.filesToOpenOrCreate,delete x.filesToDiff,delete x.filesToWait,this.isExtensionDevelopmentHost&&q&&(x.verbose=q.verbose,x.debugId=q.debugId,x.extensionEnvironment=q.extensionEnvironment,x["inspect-extensions"]=q["inspect-extensions"],x["inspect-brk-extensions"]=q["inspect-brk-extensions"],x["extensions-dir"]=q["extensions-dir"]),x.isInitialStartup=!1,this.load(x,{isReload:!0,disableExtensions:q?.["disable-extensions"]})}async validateWorkspaceBeforeReload(q){if((0,F.isWorkspaceIdentifier)(q.workspace)){const x=q.workspace.configPath;if(x.scheme===w.Schemas.file&&!await this.fileService.exists(x))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(q.workspace)){const x=q.workspace.uri;if(x.scheme===w.Schemas.file&&!await this.fileService.exists(x))return}return q.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let H;try{H=v.screen.getDisplayMatching(this.getBounds())}catch{}const G=(0,L.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||G.width,height:this.windowState.height||G.height,x:this.windowState.x||0,y:this.windowState.y||0}}const q=Object.create(null);let x;if(!S.isMacintosh&&this._win.isMaximized()?x=0:x=1,x===0?q.mode=0:q.mode=1,x===1||x===0){let H;x===1?H=this.getBounds():H=this._win.getNormalBounds(),q.x=H.x,q.y=H.y,q.width=H.width,q.height=H.height}return q}restoreWindowState(q){(0,P.mark)("code/willRestoreCodeWindowState");let x=!1;if(q)try{const H=v.screen.getAllDisplays();x=H.length>1,q=this.validateWindowState(q,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[q||(0,L.defaultWindowState)(),x]}validateWindowState(q,x){if(this.logService.trace(`window#validateWindowState: validating window state on ${x.length} display(s)`,q),typeof q.x!="number"||typeof q.y!="number"||typeof q.width!="number"||typeof q.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(q.width<=0||q.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(x.length===1){const j=this.getWorkingArea(x[0]);if(j){let N=function(){!q||typeof q.x!="number"||typeof q.y!="number"||!j||(q.x<j.x&&(q.x=j.x),q.y<j.y&&(q.y=j.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",j),N(),q.width>j.width&&(q.width=j.width),q.height>j.height&&(q.height=j.height),q.x>j.x+j.width-128&&(q.x=j.x+j.width-q.width),q.y>j.y+j.height-128&&(q.y=j.y+j.height-q.height),N()}return q}if(q.display&&q.mode===3){const j=x.find(N=>N.id===q.display);if(j&&typeof j.bounds?.x=="number"&&typeof j.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,L.defaultWindowState)(3);return N.x=j.bounds.x,N.y=j.bounds.y,N}}let H,G;try{H=v.screen.getDisplayMatching({x:q.x,y:q.y,width:q.width,height:q.height}),G=this.getWorkingArea(H)}catch{}if(H&&G&&q.x+q.width>G.x&&q.y+q.height>G.y&&q.x<G.x+G.width&&q.y<G.y+G.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",G),q}getWorkingArea(q){if(q.workArea.width>0&&q.workArea.height>0)return q.workArea;if(q.bounds.width>0&&q.bounds.height>0)return q.bounds}getBounds(){const[q,x]=this._win.getPosition(),[H,G]=this._win.getSize();return{x:q,y:x,width:H,height:G}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(q){this.useNativeFullScreen()?this.setNativeFullScreen(q):this.setSimpleFullScreen(q),this.sendWhenReady(q?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(q){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(q)}setSimpleFullScreen(q){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(q),this._win.webContents.focus()}useNativeFullScreen(){const q=this.configurationService.getValue("window");return!q||typeof q.nativeFullScreen!="boolean"||q.nativeTabs?!0:q.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let q=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(q)<0&&(q="classic"),q}setMenuBarVisibility(q,x=!0){S.isMacintosh||(q==="toggle"&&x&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),q==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(q)}):this.doSetMenuBarVisibility(q))}doSetMenuBarVisibility(q){const x=this.isFullScreen;switch(q){case"classic":this._win.setMenuBarVisibility(!x),this._win.autoHideMenuBar=x;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(q,x,...H){this.isReady?this.send(q,...H):this.ready().then(()=>{x.isCancellationRequested||this.send(q,...H)})}send(q,...x){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${q}' for window that is destroyed`);return}try{this._win.webContents.send(q,...x)}catch(H){this.logService.warn(`Error sending IPC message to channel '${q}' of window ${this._id}: ${(0,C.toErrorMessage)(H)}`)}}}updateTouchBar(q){!S.isMacintosh||this.touchBarGroups.forEach((x,H)=>{const G=q[H];x.segments=this.createTouchBarGroupSegments(G)})}createTouchBar(){if(!!S.isMacintosh){for(let q=0;q<10;q++){const x=this.createTouchBarGroup();this.touchBarGroups.push(x)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(q=[]){const x=this.createTouchBarGroupSegments(q),H=new v.TouchBar.TouchBarSegmentedControl({segments:x,mode:"buttons",segmentStyle:"automatic",change:G=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:H.segments[G].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(q=[]){return q.map(H=>{let G;H.icon&&!h.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===w.Schemas.file&&(G=v.nativeImage.createFromPath(y.URI.revive(H.icon.dark).fsPath),G.isEmpty()&&(G=void 0));let j;return typeof H.title=="string"?j=H.title:j=H.title.value,{id:H.id,label:G?void 0:j,icon:G}})}dispose(){super.dispose(),this._win=null}};oe=de([ne(1,u.ILogService),ne(2,M.IEnvironmentMainService),ne(3,c.IFileService),ne(4,r.IGlobalStorageMainService),ne(5,m.IConfigurationService),ne(6,b.IThemeMainService),ne(7,z.IWorkspacesManagementMainService),ne(8,f.IBackupMainService),ne(9,l.ITelemetryService),ne(10,p.IDialogMainService),ne(11,o.ILifecycleMainService),ne(12,s.IProductService),ne(13,i.IProtocolMainService),ne(14,L.IWindowsMainService)],oe),e.CodeWindow=oe}),define(ee[69],te([0,1,14,31,8,4,33,2,10,3,16,7,24,160,5,20,6,38,79,30,45]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let c=class ze extends I.Disposable{constructor(u,s,i,r,l){super();this.stateMainService=u,this.logService=s,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.globalStorageMainService=l,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(u=>this.addRecentlyOpened([{workspace:u.workspace,remoteAuthority:u.window.remoteAuthority}])))}async addRecentlyOpened(u){const s=[],i=[];for(let r of u)if((0,a.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&this.indexOfWorkspace(s,r.workspace)===-1&&s.push(r);else if((0,a.isRecentFolder)(r))this.indexOfFolder(s,r.folderUri)===-1&&s.push(r);else{const l=this.indexOfFile(i,r.fileUri)>=0,h=r.fileUri.scheme===g.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf((0,E.basename)(r.fileUri))>=0;!l&&!h&&(i.push(r),w.isWindows&&r.fileUri.scheme===g.Schemas.file&&v.app.addRecentDocument(r.fileUri.fsPath))}await this.addEntriesFromStorage(s,i),s.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(s.length=ze.MAX_TOTAL_RECENT_ENTRIES),i.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(i.length=ze.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:s,files:i}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(u){const s=h=>{const b=this.location(h);for(const R of u)if(E.extUriBiasedIgnorePathCase.isEqual(R,b))return!1;return!0},i=await this.getRecentlyOpened(),r=i.workspaces.filter(s),l=i.files.filter(s);(r.length!==i.workspaces.length||l.length!==i.files.length)&&(await this.saveRecentlyOpened({files:l,workspaces:r}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(u){const s=[],i=[];if(u){const l=u.config?.workspace;(0,a.isWorkspaceIdentifier)(l)&&!this.workspacesManagementMainService.isUntitledWorkspace(l)?s.push({workspace:l,remoteAuthority:u.remoteAuthority}):(0,a.isSingleFolderWorkspaceIdentifier)(l)&&s.push({folderUri:l.uri,remoteAuthority:u.remoteAuthority})}const r=u?.config?.filesToOpenOrCreate;if(r)for(let l of r){const h=l.fileUri;h&&this.indexOfFile(i,h)===-1&&i.push({fileUri:h})}return await this.addEntriesFromStorage(s,i),{workspaces:s,files:i}}async addEntriesFromStorage(u,s){let i=await this.getRecentlyOpenedFromStorage();for(let r of i.workspaces){let l=(0,a.isRecentFolder)(r)?this.indexOfFolder(u,r.folderUri):this.indexOfWorkspace(u,r.workspace);l>=0?u[l].label=u[l].label||r.label:u.push(r)}for(let r of i.files){let l=this.indexOfFile(s,r.fileUri);l>=0?s[l].label=s[l].label||r.label:s.push(r)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let u;const s=this.globalStorageMainService.get(ze.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof s=="string")try{u=JSON.parse(s)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}else u=this.stateMainService.getItem(ze.legacyRecentlyOpenedStorageKey),u&&(this.stateMainService.removeItem(ze.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(u),0,1));return(0,a.restoreRecentlyOpened)(u,this.logService)}async saveRecentlyOpened(u){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,a.toStoreData)(u)),0,1)}location(u){return(0,a.isRecentFolder)(u)?u.folderUri:(0,a.isRecentFile)(u)?u.fileUri:u.workspace.configPath}indexOfWorkspace(u,s){return u.findIndex(i=>(0,a.isRecentWorkspace)(i)&&i.workspace.id===s.id)}indexOfFolder(u,s){return u.findIndex(i=>(0,a.isRecentFolder)(i)&&E.extUriBiasedIgnorePathCase.isEqual(i.folderUri,s))}indexOfFile(u,s){return u.findIndex(i=>E.extUriBiasedIgnorePathCase.isEqual(i.fileUri,s))}async handleWindowsJumpList(){!w.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!w.isWindows)return;const u=[];if(u.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let s=[];for(let l of v.app.getJumpListSettings().removedItems){const h=l.args;if(h){const b=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);b&&s.push(P.URI.parse(b[2]))}}await this.removeRecentlyOpened(s);let i=!1;const r=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,ze.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(l=>{const h=(0,a.isRecentWorkspace)(l)?l.workspace:l.folderUri,{title:b,description:R}=this.getWindowsJumpListLabel(h,l.label);let L;return P.URI.isUri(h)?L=`--folder-uri "${h.toString()}"`:(i=!0,L=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:b.substr(0,255),description:R.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));r.length>0&&u.push({type:"custom",name:i?(0,y.localize)(2,null):(0,y.localize)(3,null),items:r})}u.push({type:"recent"});try{v.app.setJumpList(u)}catch(s){this.logService.warn("updateWindowsJumpList#setJumpList",s)}}getWindowsJumpListLabel(u,s){if(s)return{title:(0,k.splitName)(s).name,description:s};if(P.URI.isUri(u))return{title:(0,E.basename)(u),description:this.renderJumpListPathDescription(u)};if(this.workspacesManagementMainService.isUntitledWorkspace(u))return{title:(0,y.localize)(4,null),description:""};let i=(0,E.basename)(u.configPath);return i.endsWith(a.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-a.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,i),description:this.renderJumpListPathDescription(u.configPath)}}renderJumpListPathDescription(u){return u.scheme==="file"?(0,k.normalizeDriveLetter)(u.fsPath):u.toString()}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;v.app.clearRecentDocuments();const u=await this.getRecentlyOpened(),s=[];let i=0;for(let l=0;l<u.workspaces.length&&i<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;l++){const h=this.location(u.workspaces[l]);if(h.scheme===g.Schemas.file){const b=(0,E.originalFSPath)(h);await S.Promises.exists(b)&&(s.push(b),i++)}}const r=[];for(let l=0;l<u.files.length&&i<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;l++){const h=this.location(u.files[l]);if(h.scheme===g.Schemas.file){const b=(0,E.originalFSPath)(h);if(ze.COMMON_FILES_FILTER.includes((0,E.basename)(h))||s.includes(b))continue;await S.Promises.exists(b)&&(r.push(b),i++)}}r.reverse().forEach(l=>v.app.addRecentDocument(l)),s.reverse().forEach(l=>v.app.addRecentDocument(l))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.legacyRecentlyOpenedStorageKey="openedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=de([ne(0,p.IStateMainService),ne(1,m.ILogService),ne(2,d.IWorkspacesManagementMainService),ne(3,f.ILifecycleMainService),ne(4,M.IGlobalStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(ee[245],te([0,1,14,8,21,33,3,7,152,19,23,20,6,192,58,22,38,29,41,68,36,69]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let u=class yt{constructor(r,l,h,b,R,L,F,z,Q,oe,re){this.updateService=r,this.configurationService=l,this.windowsMainService=h,this.environmentMainService=b,this.telemetryService=R,this.workspacesHistoryMainService=L,this.stateMainService=F,this.lifecycleMainService=z,this.logService=Q,this.nativeHostMainService=oe,this.productService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,a.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(yt.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,F,z)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,F,z)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,F,z)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,F,z)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(z),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const l=this.productService.requestFeatureUrl;l&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(l,"openUserVoiceUrl"));const h=this.productService.reportIssueUrl;h&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(h,"openReportIssues"));const b=this.productService.licenseUrl;b&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const L=b.indexOf("?")>0?"&":"?";this.openUrl(`${b}${L}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(b,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&b&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;let r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,l){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(yt.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!k.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!k.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=v.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(k.isMacintosh?new v.Menu:null);return}const l=new v.Menu;let h;if(k.isMacintosh){const R=new v.Menu;h=new v.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),l.append(h)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new v.Menu;R.append(new v.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:R});this.setMenuById(R,"File"),l.append(L)}if(this.shouldDrawMenu("Edit")){const R=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),l.append(L)}if(this.shouldDrawMenu("Selection")){const R=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),l.append(L)}if(this.shouldDrawMenu("View")){const R=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:R});this.setMenuById(R,"View"),l.append(L)}if(this.shouldDrawMenu("Go")){const R=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),l.append(L)}if(this.shouldDrawMenu("Run")){const R=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),l.append(L)}if(this.shouldDrawMenu("Terminal")){const R=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),l.append(L)}let b;if(this.shouldDrawMenu("Window")){const R=new v.Menu;b=new v.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(b&&l.append(b),this.shouldDrawMenu("Help")){const R=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),l.append(L)}l.items&&l.items.length>0?v.Menu.setApplicationMenu(l):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const l=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),h=this.getUpdateMenuItems();let b;if(this.shouldDrawMenu("Preferences")){const q=new v.Menu;this.setMenuById(q,"Preferences"),b=new v.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:q})}const R=new v.Menu,L=new v.MenuItem({label:g.localize(12,null),role:"services",submenu:R}),F=new v.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),z=new v.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new v.MenuItem({label:g.localize(15,null),role:"unhide"}),oe=new v.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:()=>{const q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),re=[l];re.push(...h),b&&re.push(s(),b),re.push(s(),L,s(),F,z,Q,s(),oe),re.forEach(q=>r.append(q))}shouldDrawMenu(r){if(!k.isMacintosh&&(0,a.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,l){l.forEach(h=>{if((0,y.isMenubarMenuItemSeparator)(h))r.append(s());else if((0,y.isMenubarMenuItemSubmenu)(h)){const b=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(h.label),submenu:b});this.setMenu(b,h.submenu.items),r.append(R)}else(0,y.isMenubarMenuItemRecentAction)(h)?r.append(this.createOpenRecentMenuItem(h)):(0,y.isMenubarMenuItemAction)(h)&&(h.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[h.id]?r.append(new v.MenuItem(this.likeAction(h.id,{label:this.mnemonicLabel(h.label),click:this.fallbackMenuHandlers[h.id]}))):r.append(this.createMenuItem(h.label,h.id,!1,h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)):r.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)))})}setMenuById(r,l){this.menubarMenus&&this.menubarMenus[l]&&this.setMenu(r,this.menubarMenus[l].items)}insertCheckForUpdatesItems(r){const l=this.getUpdateMenuItems();l.length&&(l.forEach(h=>r.append(h)),r.append(s()))}createOpenRecentMenuItem(r){const l=I.URI.revive(r.uri),h=r.id,b=h==="openRecentFile"?{fileUri:l}:h==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new v.MenuItem(this.likeAction(h,{label:r.label,click:(R,L,F)=>{const z=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[b],forceNewWindow:z,gotoLineMode:!1,remoteAuthority:r.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([l])}},!1))}isOptionClick(r){return!!(r&&(!k.isMacintosh&&(r.ctrlKey||r.shiftKey)||k.isMacintosh&&(r.metaKey||r.altKey)))}createRoleMenuItem(r,l,h){const b={label:this.mnemonicLabel(r),role:h,enabled:!0};return new v.MenuItem(this.withKeybinding(l,b))}setMacWindowMenu(r){const l=new v.MenuItem({label:g.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),h=new v.MenuItem({label:g.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),b=new v.MenuItem({label:g.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(g.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(s()),L.push(this.createMenuItem(g.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(g.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(g.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(g.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,h,s(),R,...L,s(),b].forEach(F=>r.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(g.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:g.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(g.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:g.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(g.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:g.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(g.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,l,h,b){const R=this.mnemonicLabel(r),L=typeof l=="function"?l:(re,q,x)=>{const H=re?re.userSettingsLabel:null;let G=l;Array.isArray(l)&&(G=this.isOptionClick(x)?l[1]:l[0]),H&&x.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:G})},F=typeof h=="boolean"?h:this.windowsMainService.getWindowCount()>0,z=typeof b=="boolean"?b:!1,Q={label:R,click:L,enabled:F};z&&(Q.type="checkbox",Q.checked=z);let oe;return typeof l=="string"?oe=l:Array.isArray(l)&&(oe=l[0]),k.isMacintosh&&(oe==="editor.action.clipboardCutAction"?Q.role="cut":oe==="editor.action.clipboardCopyAction"?Q.role="copy":oe==="editor.action.clipboardPasteAction"&&(Q.role="paste"),oe==="undo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(oe,Q))}makeContextAwareClickHandler(r,l){return(h,b,R)=>{const L=v.BrowserWindow.getFocusedWindow();if(!L)return l.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return l.inDevTools(L.webContents.devToolsWebContents);r(h,b||L,R)}}runActionInRenderer(r){let l=v.BrowserWindow.getFocusedWindow();if(!l){const b=this.windowsMainService.getLastActiveWindow();b?.isMinimized()&&(l=b.win)}const h=l?this.windowsMainService.getWindowById(l.id):void 0;if(h){if(this.logService.trace("menubar#runActionInRenderer",r),k.isMacintosh&&!this.environmentMainService.isBuilt&&!h.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const b={id:r.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",D.CancellationToken.None,b)}else{const b={userSettingsLabel:r.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,b)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,l){const h=typeof r=="string"?this.keybindings[r]:void 0;if(h?.label){if(h.isNative!==!1)l.accelerator=h.label,l.userSettingsLabel=h.userSettingsLabel;else if(typeof l.label=="string"){const b=l.label.indexOf("[");b>=0?l.label=`${l.label.substr(0,b)} [${h.label}]`:l.label=`${l.label} [${h.label}]`}}else l.accelerator=void 0;return l}likeAction(r,l,h=!l.accelerator){h&&(l=this.withKeybinding(r,l));const b=l.click;return l.click=(R,L,F)=>{this.reportMenuActionTelemetry(r),b&&b(R,L,F)},l}openUrl(r,l){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(l)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:o})}mnemonicLabel(r){return(0,C.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};u.lastKnownMenubarStorageKey="lastKnownMenubarData",u=de([ne(0,M.IUpdateService),ne(1,w.IConfigurationService),ne(2,d.IWindowsMainService),ne(3,E.IEnvironmentMainService),ne(4,p.ITelemetryService),ne(5,c.IWorkspacesHistoryMainService),ne(6,m.IStateMainService),ne(7,P.ILifecycleMainService),ne(8,S.ILogService),ne(9,t.INativeHostMainService),ne(10,f.IProductService)],u),e.Menubar=u;function s(){return new v.MenuItem({type:"separator"})}}),define(ee[246],te([0,1,5,20,6,245]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let k=class{constructor(g,w,E){this.instantiationService=g,this.lifecycleMainService=w,this.logService=E,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(g,w){this.logService.trace("menubarService#updateMenubar",g),(await this.menubar).updateMenu(w,g)}};k=de([ne(0,v.IInstantiationService),ne(1,n.ILifecycleMainService),ne(2,D.ILogService)],k),e.MenubarMainService=k}),define(ee[247],te([0,1,14,28,26,31,21,4,27,42,33,2,10,9,64,3,34,16,13,7,158,52,19,50,23,18,5,20,6,54,22,55,65,38,68,244,101,227,30,102,69,45]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c,o,u,s,i,r,l,h,b,R,L,F,z,Q,oe,re,q,x,H,G,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(V){return(0,x.isWorkspaceIdentifier)(V?.workspace)}function B(V){return(0,x.isSingleFolderWorkspaceIdentifier)(V?.workspace)}let Y=class nt extends P.Disposable{constructor(W,$,A,T,_,O,U,J,ie,se,Z,ce,le,he,ge){super();this.machineId=W,this.initialUserEnv=$,this.logService=A,this.stateMainService=T,this.environmentMainService=_,this.lifecycleMainService=O,this.backupMainService=U,this.configurationService=J,this.workspacesHistoryMainService=ie,this.workspacesManagementMainService=se,this.instantiationService=Z,this.dialogMainService=ce,this.fileService=le,this.productService=he,this.protocolMainService=ge,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(W=>this._onDidSignalReadyWindow.fire(W.window))),this._register(this.onDidSignalReadyWindow(W=>{if(W.config?.extensionDevelopmentPath||W.config?.extensionTestsPath){const $=new P.DisposableStore;if($.add(I.Event.any(W.onDidClose,W.onDidDestroy)(()=>$.dispose())),W.config.extensionDevelopmentPath)for(const A of W.config.extensionDevelopmentPath)$.add(this.protocolMainService.addValidFileRoot(a.URI.file(A)));W.config.extensionTestsPath&&$.add(this.protocolMainService.addValidFileRoot(a.URI.file(W.config.extensionTestsPath)))}}))}openEmptyWindow(W,$){let A=this.environmentMainService.args;const T=$?.remoteAuthority||void 0,_=!0,O=$?.forceReuseWindow,U=!O;return this.open({...W,cli:A,forceEmpty:_,forceNewWindow:U,forceReuseWindow:O,remoteAuthority:T})}openExistingWindow(W,$){W.focus(),this.handleWaitMarkerFile($,[W])}open(W){this.logService.trace("windowsManager#open"),W.addMode&&(W.initialStartup||!this.getLastActiveWindow())&&(W.addMode=!1);const $=[],A=[],T=[],_=[],O=[];let U,J=0;const ie=this.getPathsToOpen(W);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const le of ie)B(le)?W.addMode?$.push(le):A.push(le):N(le)?T.push(le):le.fileUri?(U||(U={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),U.filesToOpenOrCreate.push(le)):le.backupPath?O.push({backupFolder:(0,y.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):J++;W.diffMode&&U&&U.filesToOpenOrCreate.length>=2&&(U.filesToDiff=U.filesToOpenOrCreate.slice(0,2),U.filesToOpenOrCreate=[]),U&&W.waitMarkerFileURI&&(U.filesToWait={paths:[...U.filesToDiff,...U.filesToOpenOrCreate],waitMarkerFileUri:W.waitMarkerFileURI}),W.initialStartup?(_.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),T.push(..._),O.push(...this.backupMainService.getEmptyWindowBackupPaths())):O.length=0;const{windows:se,filesOpenedInWindow:Z}=this.doOpen(W,T,A,O,J,U,$);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${A.length}, emptyToRestore: ${O.length}, emptyToOpen: ${J})`),se.length>1)if(Z)Z.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!W.forceEmpty&&!W.cli._.length&&!W.cli["file-uri"]&&!W.cli["folder-uri"]&&!(W.urisToOpen&&W.urisToOpen.length);let he=!0,ge=!0;if(le){const ye=se.filter(fe=>this.windowsStateHandler.state.lastActiveWindow&&fe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),he=!1,ge=!1)}if(he)for(let ye=se.length-1;ye>=0;ye--){const fe=se[ye];if(!(fe.openedWorkspace&&_.some(me=>fe.openedWorkspace&&me.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&O.some(me=>fe.backupPath&&me.backupFolder===(0,y.basename)(fe.backupPath)))){fe.focus(),ge=!1;break}}ge&&se[se.length-1].focus()}const ce=U&&U.filesToDiff.length>0;if(!se.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!W.noRecentEntry){const le=[];for(const he of ie)N(he)&&!he.transient?le.push({label:he.label,workspace:he.workspace,remoteAuthority:he.remoteAuthority}):B(he)?le.push({label:he.label,folderUri:he.workspace.uri,remoteAuthority:he.remoteAuthority}):he.fileUri&&le.push({label:he.label,fileUri:he.fileUri,remoteAuthority:he.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(W,se),se}handleWaitMarkerFile(W,$){const A=W.waitMarkerFileURI;W.context===0&&A&&$.length===1&&$[0]&&(async()=>{await $[0].whenClosedOrLoaded;try{await this.fileService.del(A)}catch{}})()}doOpen(W,$,A,T,_,O,U){const J=[];let ie;function se(fe,me){J.push(fe),me&&(ie=fe,O=void 0)}let{openFolderInNewWindow:Z,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(W);if(!W.initialStartup&&U.length>0){const fe=U[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(fe);me&&se(this.doAddFoldersToExistingWindow(me,U.map(be=>be.workspace.uri)))}const le=A.length+$.length+T.length;if(O&&le===0){const fe=O.filesToOpenOrCreate[0]||O.filesToDiff[0],me=this.getWindows().filter(Pe=>O&&(0,p.isEqualAuthority)(Pe.remoteAuthority,O.remoteAuthority));let be;fe?.fileUri&&!ce&&((W.context===4||W.context===0||W.context===1)&&(be=(0,re.findWindowOnFile)(me,fe.fileUri,Pe=>Pe.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Pe.configPath):void 0)),be||(be=this.doGetLastActiveWindow(me))),be?(0,x.isWorkspaceIdentifier)(be.openedWorkspace)?$.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,x.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?A.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):se(this.doOpenFilesInExistingWindow(W,be,O),!0):se(this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,filesToOpen:O,forceNewWindow:!0,remoteAuthority:O.remoteAuthority,forceNewTabbedWindow:W.forceNewTabbedWindow}),!0)}const he=(0,C.distinct)($,fe=>fe.workspace.id);if(he.length>0){const fe=(0,C.coalesce)(he.map(me=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(fe.length>0){const me=fe[0],be=(0,p.isEqualAuthority)(O?.remoteAuthority,me.remoteAuthority)?O:void 0;se(this.doOpenFilesInExistingWindow(W,me,be),!!be),Z=!0}he.forEach(me=>{if(fe.some(Ce=>Ce.openedWorkspace&&Ce.openedWorkspace.id===me.workspace.id))return;const be=me.remoteAuthority,Pe=(0,p.isEqualAuthority)(O?.remoteAuthority,be)?O:void 0;se(this.doOpenFolderOrWorkspace(W,me,Z,Pe),!!Pe),Z=!0})}const ge=(0,C.distinct)(A,fe=>p.extUriBiasedIgnorePathCase.getComparisonKey(fe.workspace.uri));if(ge.length>0){const fe=(0,C.coalesce)(ge.map(me=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(fe.length>0){const me=fe[0],be=(0,p.isEqualAuthority)(O?.remoteAuthority,me.remoteAuthority)?O:void 0;se(this.doOpenFilesInExistingWindow(W,me,be),!!be),Z=!0}ge.forEach(me=>{if(fe.some(Ce=>(0,x.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(Ce.openedWorkspace.uri,me.workspace.uri)))return;const be=me.remoteAuthority,Pe=(0,p.isEqualAuthority)(O?.remoteAuthority,be)?O:void 0;se(this.doOpenFolderOrWorkspace(W,me,Z,Pe),!!Pe),Z=!0})}const ye=(0,C.distinct)(T,fe=>fe.backupFolder);if(ye.length>0&&ye.forEach(fe=>{const me=fe.remoteAuthority,be=(0,p.isEqualAuthority)(O?.remoteAuthority,me)?O:void 0;se(this.doOpenEmpty(W,!0,me,be,fe),!!be),Z=!0}),J.length===0||O){O&&!_&&_++;const fe=O?O.remoteAuthority:W.remoteAuthority;for(let me=0;me<_;me++)se(this.doOpenEmpty(W,Z,fe,O),!!O),Z=!0}return{windows:(0,C.distinct)(J),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(W,$,A){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:A}),$.focus();const T={filesToOpenOrCreate:A?.filesToOpenOrCreate,filesToDiff:A?.filesToDiff,filesToWait:A?.filesToWait,termProgram:W?.userEnv?.TERM_PROGRAM};return $.sendWhenReady("vscode:openFiles",k.CancellationToken.None,T),$}doAddFoldersToExistingWindow(W,$){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:$}),W.focus();const A={foldersToAdd:$};return W.sendWhenReady("vscode:addFolders",k.CancellationToken.None,A),W}doOpenEmpty(W,$,A,T,_){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!_,remoteAuthority:A,filesToOpen:T,forceNewWindow:$});let O;return!$&&typeof W.contextWindowId=="number"&&(O=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:A,forceNewWindow:$,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:T,windowToUse:O,emptyWindowBackupInfo:_})}doOpenFolderOrWorkspace(W,$,A,T,_){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:$,filesToOpen:T}),!A&&!_&&typeof W.contextWindowId=="number"&&(_=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({workspace:$.workspace,userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:$.remoteAuthority,forceNewWindow:A,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:T,windowToUse:_})}getPathsToOpen(W){let $,A=!1,T=!1;if(W.urisToOpen&&W.urisToOpen.length>0?($=this.doExtractPathsFromAPI(W),A=!0):W.forceEmpty?$=[Object.create(null)]:W.cli._.length||W.cli["folder-uri"]||W.cli["file-uri"]?($=this.doExtractPathsFromCLI(W.cli),$.length===0&&$.push(Object.create(null)),A=!0):($=this.doGetPathsFromLastSession(),$.length===0&&$.push(Object.create(null)),T=!0),!W.addMode&&A){const _=$.filter(O=>B(O));if(_.length>1){const O=_[0].remoteAuthority;if(_.every(U=>(0,p.isEqualAuthority)(U.remoteAuthority,O))){const U=this.workspacesManagementMainService.createUntitledWorkspaceSync(_.map(J=>({uri:J.workspace.uri})));$.push({workspace:U,remoteAuthority:O}),$=$.filter(J=>!B(J))}}}return W.initialStartup&&!T&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&$.unshift(...this.doGetPathsFromLastSession().filter(_=>N(_)||B(_)||_.backupPath)),$}doExtractPathsFromAPI(W){const $=[],A={gotoLineMode:W.gotoLineMode,remoteAuthority:W.remoteAuthority};for(const T of(0,C.coalesce)(W.urisToOpen||[])){const _=this.resolveOpenable(T,A);if(_)_.label=T.label,$.push(_);else{const O=this.resourceFromOpenable(T),U={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(0,null))],defaultId:0,message:O.scheme===S.Schemas.file?(0,d.localize)(1,null):(0,d.localize)(2,null),detail:O.scheme===S.Schemas.file?(0,d.localize)(3,null,(0,E.getPathLabel)(O.fsPath,this.environmentMainService)):(0,d.localize)(4,null,O.toString()),noLink:!0};this.dialogMainService.showMessageBox(U,(0,M.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return $}doExtractPathsFromCLI(W){const $=[],A={ignoreFileNotFound:!0,gotoLineMode:W.goto,remoteAuthority:W.remote||void 0,forceOpenWorkspaceAsFile:!1},T=W["folder-uri"];if(T)for(const U of T){const J=this.cliArgToUri(U);if(J){const ie=this.resolveOpenable({folderUri:J},A);ie&&$.push(ie)}}const _=W["file-uri"];if(_)for(const U of _){const J=this.cliArgToUri(U);if(J){const ie=this.resolveOpenable((0,x.hasWorkspaceFileExtension)(U)?{workspaceUri:J}:{fileUri:J},A);ie&&$.push(ie)}}const O=W._;for(const U of O){const J=A.remoteAuthority?this.doResolvePathRemote(U,A):this.doResolveFilePath(U,A);J&&$.push(J)}return $}cliArgToUri(W){try{const $=a.URI.parse(W);if(!$.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${W}`);return}return $}catch($){this.logService.error(`Invalid URI input string: ${W}, ${$.message}`)}}doGetPathsFromLastSession(){const W=this.getRestoreWindowsSetting();switch(W){case"none":return[];case"one":case"all":case"preserve":case"folders":{const $=[];W!=="one"&&$.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&$.push(this.windowsStateHandler.state.lastActiveWindow);const A=[];for(const T of $)if(T.workspace){const _=this.resolveOpenable({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority,rejectTransientWorkspaces:!0});N(_)&&A.push(_)}else if(T.folderUri){const _=this.resolveOpenable({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});B(_)&&A.push(_)}else W!=="folders"&&T.backupPath&&A.push({backupPath:T.backupPath,remoteAuthority:T.remoteAuthority});return A}}}getRestoreWindowsSetting(){let W;return this.lifecycleMainService.wasRestarted?W="all":(W=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(W)||(W="all")),W}resolveOpenable(W,$=Object.create(null)){let A=this.resourceFromOpenable(W);return A.scheme===S.Schemas.file?((0,Q.isFileToOpen)(W)&&($={...$,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(A.fsPath,$)):this.doResolveRemoteOpenable(W,$)}doResolveRemoteOpenable(W,$){let A=this.resourceFromOpenable(W);const T=(0,F.getRemoteAuthority)(A)||$.remoteAuthority;if(A=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(A)),(0,Q.isFileToOpen)(W)){if($.gotoLineMode){const{path:_,line:O,column:U}=(0,g.parseLineAndColumnAware)(A.path);return{fileUri:A.with({path:_}),selection:O?{startLineNumber:O,startColumn:U||1}:void 0,remoteAuthority:T}}return{fileUri:A,remoteAuthority:T}}else if((0,Q.isWorkspaceToOpen)(W))return{workspace:(0,H.getWorkspaceIdentifier)(A),remoteAuthority:T};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(A),remoteAuthority:T}}resourceFromOpenable(W){return(0,Q.isWorkspaceToOpen)(W)?W.workspaceUri:(0,Q.isFolderToOpen)(W)?W.folderUri:W.fileUri}doResolveFilePath(W,$){let A,T;$.gotoLineMode&&({path:W,line:A,column:T}=(0,g.parseLineAndColumnAware)(W)),W=(0,g.sanitizeFilePath)((0,y.normalize)(W),(0,m.cwd)());try{const _=(0,n.statSync)(W);if(_.isFile()){if(!$.forceOpenWorkspaceAsFile){const O=this.workspacesManagementMainService.resolveLocalWorkspaceSync(a.URI.file(W));if(O)return O.transient&&$.rejectTransientWorkspaces?void 0:{workspace:{id:O.id,configPath:O.configPath},type:i.FileType.File,exists:!0,remoteAuthority:O.remoteAuthority,transient:O.transient}}return{fileUri:a.URI.file(W),type:i.FileType.File,exists:!0,selection:A?{startLineNumber:A,startColumn:T||1}:void 0}}else{if(_.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(a.URI.file(W),_),type:i.FileType.Directory,exists:!0};if(!f.isWindows&&W==="/dev/null")return{fileUri:a.URI.file(W),type:i.FileType.File,exists:!0}}}catch{const O=a.URI.file(W);if(this.workspacesHistoryMainService.removeRecentlyOpened([O]),$.ignoreFileNotFound)return{fileUri:O,type:i.FileType.File,exists:!1}}}doResolvePathRemote(W,$){const A=W.charCodeAt(0),T=$.remoteAuthority;let _,O;$.gotoLineMode&&({path:W,line:_,column:O}=(0,g.parseLineAndColumnAware)(W)),A!==47&&((0,g.isWindowsDriveLetter)(A)&&W.charCodeAt(W.charCodeAt(1))===58&&(W=(0,g.toSlashes)(W)),W=`/${W}`);const U=a.URI.from({scheme:S.Schemas.vscodeRemote,authority:T,path:W});if(W.charCodeAt(W.length-1)!==47){if((0,x.hasWorkspaceFileExtension)(W))return $.forceOpenWorkspaceAsFile?{fileUri:U,selection:_?{startLineNumber:_,startColumn:O||1}:void 0,remoteAuthority:$.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(U),remoteAuthority:T};if($.gotoLineMode||y.posix.basename(W).indexOf(".")!==-1)return{fileUri:U,selection:_?{startLineNumber:_,startColumn:O||1}:void 0,remoteAuthority:T}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:T}}shouldOpenNewWindow(W){const $=this.configurationService.getValue("window"),A=$?.openFoldersInNewWindow||"default",T=$?.openFilesInNewWindow||"off";let _=(W.preferNewWindow||W.forceNewWindow)&&!W.forceReuseWindow;!W.forceNewWindow&&!W.forceReuseWindow&&(A==="on"||A==="off")&&(_=A==="on");let O=!1;return W.forceNewWindow||W.forceReuseWindow?O=!!W.forceNewWindow&&!W.forceReuseWindow:(f.isMacintosh?W.context===1&&(O=!0):W.context!==3&&W.context!==2&&!(W.userEnv&&W.userEnv.TERM_PROGRAM==="vscode")&&(O=!0),!W.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(O=T==="on")),{openFolderInNewWindow:!!_,openFilesInNewWindow:O}}openExtensionDevelopmentHostWindow(W,$){const A=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),W);if(A)return this.lifecycleMainService.reload(A,$.cli),A.focus(),[A];let T=$.cli["folder-uri"]||[],_=$.cli["file-uri"]||[],O=$.cli._;if(!O.length&&!T.length&&!_.length&&!$.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,Z=se&&(se.workspace||se.folderUri);Z&&(a.URI.isUri(Z)?Z.scheme===S.Schemas.file?O=[Z.fsPath]:T=[Z.toString()]:Z.configPath.scheme===S.Schemas.file?O=[(0,p.originalFSPath)(Z.configPath)]:_=[Z.configPath.toString()])}let U=$.remoteAuthority;for(const se of W)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const Z=a.URI.parse(se),ce=(0,F.getRemoteAuthority)(Z);ce&&(U?(0,p.isEqualAuthority)(ce,U)||this.logService.error("more than one extension development path authority"):U=ce)}O=O.filter(se=>{const Z=a.URI.file(se);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(Z),U)}),T=T.filter(se=>{const Z=this.cliArgToUri(se);return Z&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:Z?(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(Z),U):!1}),_=_.filter(se=>{const Z=this.cliArgToUri(se);return Z&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:Z?(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(Z),U):!1}),$.cli._=O,$.cli["folder-uri"]=T,$.cli["file-uri"]=_;const J=!O.length&&!T.length&&!_.length,ie={context:$.context,cli:$.cli,forceNewWindow:!0,forceEmpty:J,userEnv:$.userEnv,noRecentEntry:!0,waitMarkerFileURI:$.waitMarkerFileURI,remoteAuthority:U};return this.open(ie)}openInBrowserWindow(W){const $=this.configurationService.getValue("window"),A={...this.environmentMainService.args,...W.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:W.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,W.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:W.remoteAuthority,workspace:W.workspace,userEnv:{...this.initialUserEnv,...W.userEnv},filesToOpenOrCreate:W.filesToOpen?.filesToOpenOrCreate,filesToDiff:W.filesToOpen?.filesToDiff,filesToWait:W.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:b.default,isInitialStartup:W.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof $?.zoomLevel=="number"?$.zoomLevel:void 0,autoDetectHighContrast:$?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let T;if(!W.forceNewWindow&&!W.forceNewTabbedWindow&&(T=W.windowToUse||this.getLastActiveWindow(),T&&T.focus()),T){const _=T.config;!A.extensionDevelopmentPath&&_&&!!_.extensionDevelopmentPath&&(A.extensionDevelopmentPath=_.extensionDevelopmentPath,A.verbose=_.verbose,A["inspect-brk-extensions"]=_["inspect-brk-extensions"],A.debugId=_.debugId,A.extensionEnvironment=_.extensionEnvironment,A["inspect-extensions"]=_["inspect-extensions"],A["extensions-dir"]=_["extensions-dir"])}else{const _=this.windowsStateHandler.getNewWindowState(A);(0,t.mark)("code/willCreateCodeWindow");const O=T=this.instantiationService.createInstance(oe.CodeWindow,{state:_,extensionDevelopmentPath:A.extensionDevelopmentPath,isExtensionTestHost:!!A.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),W.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(O)}nt.WINDOWS.push(O),this._onDidOpenWindow.fire(O),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(O.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(O)),(0,w.once)(O.onDidClose)(()=>this.onWindowClosed(O)),(0,w.once)(O.onDidDestroy)(()=>this._onDidDestroyWindow.fire(O));const U=(0,M.assertIsDefined)(O.win?.webContents);U.removeAllListeners("devtools-reload-page"),U.on("devtools-reload-page",()=>this.lifecycleMainService.reload(O)),this.lifecycleMainService.registerWindow(O)}return A.windowId=T.id,T.isReady?this.lifecycleMainService.unload(T,4).then(_=>{_||this.doOpenInBrowserWindow(T,A,W)}):this.doOpenInBrowserWindow(T,A,W),T}doOpenInBrowserWindow(W,$,A){if(!$.extensionDevelopmentPath)if((0,x.isWorkspaceIdentifier)($.workspace))$.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:$.workspace,remoteAuthority:$.remoteAuthority});else if((0,x.isSingleFolderWorkspaceIdentifier)($.workspace))$.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:$.workspace.uri,remoteAuthority:$.remoteAuthority});else{const T=A.emptyWindowBackupInfo&&A.emptyWindowBackupInfo.backupFolder;$.backupPath=this.backupMainService.registerEmptyWindowBackupSync(T,$.remoteAuthority)}W.load($)}onWindowClosed(W){const $=nt.WINDOWS.indexOf(W);nt.WINDOWS.splice($,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const W=v.BrowserWindow.getFocusedWindow();if(W)return this.getWindowById(W.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(W){return this.doGetLastActiveWindow(this.getWindows().filter($=>(0,p.isEqualAuthority)($.remoteAuthority,W)))}doGetLastActiveWindow(W){const $=Math.max.apply(Math,W.map(A=>A.lastFocusTime));return W.find(A=>A.lastFocusTime===$)}sendToFocused(W,...$){const A=this.getFocusedWindow()||this.getLastActiveWindow();A&&A.sendWhenReady(W,k.CancellationToken.None,...$)}sendToAll(W,$,A){for(const T of this.getWindows())A&&A.indexOf(T.id)>=0||T.sendWhenReady(W,k.CancellationToken.None,$)}getWindows(){return nt.WINDOWS}getWindowCount(){return nt.WINDOWS.length}getWindowById(W){const $=this.getWindows().filter(A=>A.id===W);return(0,C.firstOrDefault)($)}getWindowByWebContents(W){const $=v.BrowserWindow.fromWebContents(W);if(!!$)return this.getWindowById($.id)}};Y.WINDOWS=[],Y=de([ne(2,h.ILogService),ne(3,z.IStateMainService),ne(4,s.IEnvironmentMainService),ne(5,l.ILifecycleMainService),ne(6,c.IBackupMainService),ne(7,o.IConfigurationService),ne(8,G.IWorkspacesHistoryMainService),ne(9,j.IWorkspacesManagementMainService),ne(10,r.IInstantiationService),ne(11,u.IDialogMainService),ne(12,i.IFileService),ne(13,R.IProductService),ne(14,L.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(ee[248],te([0,1,52,36,69,45]),function(K,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(g,w,E,P){this.workspacesManagementMainService=g,this.windowsMainService=w,this.workspacesHistoryMainService=E,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(g,w){const E=this.windowsMainService.getWindowById(g);if(E)return this.workspacesManagementMainService.enterWorkspace(E,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(g,w,E){return this.workspacesManagementMainService.createUntitledWorkspace(w,E)}deleteUntitledWorkspace(g,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(g,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}getRecentlyOpened(g){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(g))}addRecentlyOpened(g,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}removeRecentlyOpened(g,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}clearRecentlyOpened(g){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=de([ne(0,C.IWorkspacesManagementMainService),ne(1,n.IWindowsMainService),ne(2,D.IWorkspacesHistoryMainService),ne(3,v.IBackupMainService)],k),e.WorkspacesMainService=k}),define(ee[249],te([0,1,14,28,26,17,39,15,27,42,43,33,2,10,9,3,13,7,32,73,124,37,127,87,221,137,52,231,19,95,166,75,50,232,90,23,53,92,176,193,177,228,91,178,179,18,188,96,62,5,76,241,206,103,20,6,190,246,58,22,65,237,77,38,225,79,207,29,209,211,66,41,215,239,242,240,243,100,216,217,218,219,222,36,247,223,30,69,248,45]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c,o,u,s,i,r,l,h,b,R,L,F,z,Q,oe,re,q,x,H,G,j,N,B,Y,V,W,$,A,T,_,O,U,J,ie,se,Z,ce,le,he,ge,ye,fe,me,be,Pe,Ce,Re,_e,$e,Qe,Ye,mt,lt,rt,qe,je,X,ae,ue,ve,Ie,Le,We,Ke,Ve,Ae,Be,He,Je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ze=class extends S.Disposable{constructor(we,Se,Ee,pe,ke,De,Me,Te,Fe,Xe){super();this.mainProcessNodeIpcServer=we,this.userEnv=Se,this.mainInstantiationService=Ee,this.logService=pe,this.environmentMainService=ke,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Te,this.fileService=Fe,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const we=pe=>pe?.startsWith(`${y.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((pe,ke,De,Me)=>we(Me.requestingUrl)?De(Se.has(ke)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((pe,ke,De,Me)=>we(Me.requestingUrl)?Se.has(ke):!1);const Ee=v.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,I.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,I.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,d.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Ee,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),v.app.on("activate",(Ee,pe)=>{this.logService.trace("app#activate"),pe||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Ee,pe)=>{pe.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),pe.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let we=[],Se;v.app.on("open-file",(Ee,pe)=>{this.logService.trace("app#open-file: ",pe),Ee.preventDefault(),we.push(this.getWindowOpenableFromPathSync(pe)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],Se=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const pe=this.windowsMainService?.getWindowByWebContents(Ee.sender);let ke,De;return pe?.config?(ke=pe.config,De={...process.env,...pe.config.userEnv}):(ke=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(ke,De,!1)}),v.ipcMain.handle("vscode:writeNlsFile",(Ee,pe,ke)=>{const De=this.validateNlsPath([pe]);if(!De||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(ke))}),v.ipcMain.handle("vscode:readNlsFile",async(Ee,...pe)=>{const ke=this.validateNlsPath(pe);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(we){let Se;for(const Ee of we)typeof Ee=="string"&&(typeof Se!="string"?Se=Ee:Se=(0,t.join)(Se,Ee));if(!(typeof Se!="string"||!(0,t.isAbsolute)(Se)||!(0,g.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!f.isLinux)))return p.URI.file(Se)}onUnexpectedError(we){if(we){const Se={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;f.isWindows&&we&&v.app.setAppUserModelId(we);try{f.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const Se=new o.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:pe,sharedProcessReady:ke,sharedProcessClient:De}=this.setupSharedProcess(Ee),Me=await this.initServices(Ee,pe,ke);if(this.environmentMainService.driverHandle){const Fe=await(0,z.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Fe)}this._register(Me.createInstance(s.ProxyAuthHandler)),Me.invokeFunction(Fe=>this.initChannels(Fe,Se,De));const Te=Me.invokeFunction(Fe=>this.openFirstWindow(Fe,Se));Me.invokeFunction(Fe=>this.afterWindowOpen(Fe,pe)),this.environmentMainService.args.trace&&Me.invokeFunction(Fe=>this.stopTracingEventually(Fe,Te))}async resolveMachineId(){let we=this.stateMainService.getItem(Re.machineIdKey);return(!we||f.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,a.getMachineId)(),this.stateMainService.setItem(Re.machineIdKey,we)),we}setupSharedProcess(we){const Se=this._register(this.mainInstantiationService.createInstance(ye.SharedProcess,we,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new u.Client(ke,"main")})(),pe=(async()=>(await Se.whenReady(),Ee))();return{sharedProcess:Se,sharedProcessReady:pe,sharedProcessClient:Ee}}async initServices(we,Se,Ee){const pe=new _.ServiceCollection;switch(process.platform){case"win32":pe.set(Ye.IUpdateService,new A.SyncDescriptor(je.Win32UpdateService));break;case"linux":f.isLinuxSnap?pe.set(Ye.IUpdateService,new A.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Ye.IUpdateService,new A.SyncDescriptor(rt.LinuxUpdateService));break;case"darwin":pe.set(Ye.IUpdateService,new A.SyncDescriptor(lt.DarwinUpdateService));break}pe.set(We.IWindowsMainService,new A.SyncDescriptor(Ke.WindowsMainService,[we,this.userEnv])),pe.set(F.IDialogMainService,new A.SyncDescriptor(F.DialogMainService)),pe.set(J.ILaunchMainService,new A.SyncDescriptor(J.LaunchMainService)),pe.set(L.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(Ee.then(De=>De.getChannel("diagnostics"))))),pe.set(O.IIssueMainService,new A.SyncDescriptor(O.IssueMainService,[this.userEnv])),pe.set(Q.IEncryptionMainService,new A.SyncDescriptor(Q.EncryptionMainService,[we])),pe.set(U.IKeyboardLayoutMainService,new A.SyncDescriptor(U.KeyboardLayoutMainService)),pe.set(le.INativeHostMainService,new A.SyncDescriptor(le.NativeHostMainService,[Se])),pe.set(b.ICredentialsMainService,new A.SyncDescriptor(b.CredentialsMainService)),pe.set(Ie.IWebviewManagerService,new A.SyncDescriptor(Le.WebviewMainService)),pe.set(Ae.IWorkspacesService,new A.SyncDescriptor(He.WorkspacesMainService)),pe.set(Je.IWorkspacesManagementMainService,new A.SyncDescriptor(Je.WorkspacesManagementMainService)),pe.set(Be.IWorkspacesHistoryMainService,new A.SyncDescriptor(Be.WorkspacesHistoryMainService)),pe.set(ce.IMenubarMainService,new A.SyncDescriptor(ce.MenubarMainService)),pe.set(x.IExtensionUrlTrustService,new A.SyncDescriptor(H.ExtensionUrlTrustService)),pe.set(G.IExtensionHostStarter,new A.SyncDescriptor(j.WorkerMainProcessExtensionHostStarter)),pe.set(Pe.IStorageMainService,new A.SyncDescriptor(Pe.StorageMainService)),pe.set(Pe.IGlobalStorageMainService,new A.SyncDescriptor(Pe.GlobalStorageMainService)),f.isWindows?pe.set(N.IExternalTerminalMainService,new A.SyncDescriptor(B.WindowsExternalTerminalService)):f.isMacintosh?pe.set(N.IExternalTerminalMainService,new A.SyncDescriptor(B.MacExternalTerminalService)):f.isLinux&&pe.set(N.IExternalTerminalMainService,new A.SyncDescriptor(B.LinuxExternalTerminalService));const ke=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(pe.set(r.IBackupMainService,ke),pe.set(X.IURLService,new A.SyncDescriptor(ue.NativeURLService)),(0,Qe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,c.getDelayedChannel)(Ee.then(xe=>xe.getChannel("telemetryAppender"))),Me=new _e.TelemetryAppenderClient(De),Te=(0,Ce.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Fe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[Me],commonProperties:Te,piiPaths:Fe,sendErrorTelemetry:!0};pe.set(Re.ITelemetryService,new A.SyncDescriptor($e.TelemetryService,[Xe]))}else pe.set(Re.ITelemetryService,Qe.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(pe)}initChannels(we,Se,Ee){const pe=c.ProxyChannel.fromService(we.get(J.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",pe);const ke=this.fileService.getProvider(y.Schemas.file);(0,m.assertType)(ke instanceof $.DiskFileSystemProvider);const De=new W.DiskFileSystemProviderChannel(ke,this.logService);Se.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De),Ee.then(Ne=>Ne.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De));const Me=new mt.UpdateChannel(we.get(Ye.IUpdateService));Se.registerChannel("update",Me);const Te=c.ProxyChannel.fromService(we.get(O.IIssueMainService));Se.registerChannel("issue",Te);const Fe=c.ProxyChannel.fromService(we.get(Q.IEncryptionMainService));Se.registerChannel("encryption",Fe);const Xe=c.ProxyChannel.fromService(we.get(b.ICredentialsMainService));Se.registerChannel("credentials",Xe);const xe=c.ProxyChannel.fromService(we.get(fe.ISignService));Se.registerChannel("sign",xe);const st=c.ProxyChannel.fromService(we.get(U.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",st),this.nativeHostMainService=we.get(le.INativeHostMainService);const et=c.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",et),Ee.then(Ne=>Ne.registerChannel("nativeHost",et));const wt=c.ProxyChannel.fromService(we.get(Ae.IWorkspacesService));Se.registerChannel("workspaces",wt);const Ue=c.ProxyChannel.fromService(we.get(ce.IMenubarMainService));Se.registerChannel("menubar",Ue);const ut=c.ProxyChannel.fromService(we.get(X.IURLService));Se.registerChannel("url",ut);const ot=c.ProxyChannel.fromService(we.get(x.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",ot);const at=c.ProxyChannel.fromService(we.get(Ie.IWebviewManagerService));Se.registerChannel("webview",at);const ct=this._register(new be.StorageDatabaseChannel(this.logService,we.get(Pe.IStorageMainService)));Se.registerChannel("storage",ct),Ee.then(Ne=>Ne.registerChannel("storage",ct));const ht=c.ProxyChannel.fromService(we.get(N.IExternalTerminalMainService));Se.registerChannel("externalTerminal",ht);const tt=new Z.LogLevelChannel(we.get(se.ILogService));Se.registerChannel("logLevel",tt),Ee.then(Ne=>Ne.registerChannel("logLevel",tt));const it=new Z.LoggerChannel(we.get(se.ILoggerService));Se.registerChannel("logger",it),Ee.then(Ne=>Ne.registerChannel("logger",it));const dt=new R.ElectronExtensionHostDebugBroadcastChannel(we.get(We.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",dt);const Oe=c.ProxyChannel.fromService(we.get(G.IExtensionHostStarter));Se.registerChannel(G.ipcExtensionHostStarterChannelName,Oe)}openFirstWindow(we,Se){const Ee=this.windowsMainService=we.get(We.IWindowsMainService),pe=we.get(X.IURLService),ke=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:p.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Ne=this.getWindowOpenableFromProtocolLink(Oe.uri);return Ne?(De.push(Ne),!1):!0}),Te=this,Fe=this.environmentMainService,Xe=this.productService;pe.registerHandler({async handleURL(Oe,Ne){if(Oe.scheme===Xe.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:p.URI.parse(Oe.query).path,query:""})),Te.shouldBlockURI(Oe))return!0;const bt=Te.getWindowOpenableFromProtocolLink(Oe);if(bt){const[pt]=Ee.open({context:5,cli:{...Fe.args},urisToOpen:[bt],gotoLineMode:!0});return pt.focus(),!0}if(f.isMacintosh&&Ee.getWindowCount()===0){const[pt]=Ee.open({context:5,cli:{...Fe.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ge.getRemoteAuthority)(Oe)});return await pt.ready(),pe.open(Oe,Ne)}return!1}});const xe=this._register(new Ve.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),st=new c.StaticRouter(Oe=>xe.getActiveClientId().then(Ne=>Oe===Ne)),et=new ae.URLHandlerRouter(st),wt=Se.getChannel("urlHandler",et);pe.registerHandler(new ae.URLHandlerChannelClient(wt)),this._register(new ve.ElectronURLListener(Me,pe,Ee,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ut=global.macOpenFiles,ot=(0,re.isLaunchedFromCli)(process.env)?0:4,at=Ue._.length,ct=!!Ue["folder-uri"],ht=!!Ue["file-uri"],tt=Ue["skip-add-to-recently-opened"]===!0,it=Ue.wait&&Ue.waitMarkerFilePath?p.URI.file(Ue.waitMarkerFilePath):void 0,dt=Ue.remote||void 0;return De.length>0?Ee.open({context:ot,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!at&&!ct&&!ht?Ee.open({context:ot,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:tt,waitMarkerFileURI:it,initialStartup:!0,remoteAuthority:dt}):ut.length&&!at&&!ct&&!ht?Ee.open({context:1,cli:Ue,urisToOpen:ut.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:tt,waitMarkerFileURI:it,initialStartup:!0}):Ee.open({context:ot,cli:Ue,forceNewWindow:Ue["new-window"]||!at&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:tt,waitMarkerFileURI:it,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:dt})}shouldBlockURI(we){return!!(we.authority===y.Schemas.file&&f.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,P.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,P.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===y.Schemas.file){const Se=p.URI.file(we.fsPath);return(0,Ae.hasWorkspaceFileExtension)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(we.authority===y.Schemas.vscodeRemote){const Se=we.path.indexOf(t.posix.sep,1);if(Se!==-1){const Ee=we.path.substring(1,Se),pe=we.path.substring(Se),ke=p.URI.from({scheme:y.Schemas.vscodeRemote,authority:Ee,path:pe,query:we.query,fragment:we.fragment});return(0,Ae.hasWorkspaceFileExtension)(pe)?{workspaceUri:ke}:/:[\d]+$/.test(pe)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(we){try{if((0,n.statSync)(we).isDirectory())return{folderUri:p.URI.file(we)};if((0,Ae.hasWorkspaceFileExtension)(we))return{workspaceUri:p.URI.file(we)}}catch{}return{fileUri:p.URI.file(we)}}async afterWindowOpen(we,Se){this.lifecycleMainService.phase=3;let Ee=!1;(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const pe=we.get(Re.ITelemetryService);this._register(Se.onDidError(({type:Me,details:Te})=>{let Fe;switch(Me){case 1:Fe="SharedProcess: detected unresponsive window";break;case 2:Fe=`SharedProcess: crashed (detail: ${Te?.reason??"<unknown>"}, code: ${Te?.exitCode??"<unknown>"})`;break;case 3:Fe=`SharedProcess: failed to load (detail: ${Te?.reason??"<unknown>"}, code: ${Te?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Fe)),pe.publicLog2("sharedprocesserror",{type:Me,reason:Te?.reason,code:Te?.exitCode,visible:Se.isVisible(),shuttingdown:Ee})}));const ke=this.productService.win32MutexName;if(f.isWindows&&ke)try{const Me=K.__$__nodeRequire("windows-mutex").Mutex,Te=new Me(ke);(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Te.release())}catch(Me){this.logService.error(Me)}v.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Me,Te)=>{Te({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=we.get(Ye.IUpdateService);(De instanceof je.Win32UpdateService||De instanceof rt.LinuxUpdateService||De instanceof lt.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Te=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,E.stripComments)(Te))["enable-crash-reporter"]===void 0){const xe=(0,Qe.getTelemetryLevel)(this.configurationService)>=1,st=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${xe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,M.generateUuid)()}"`,"}"],et=Te.substring(0,Te.length-2).concat(`,
`,st.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(et))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(we,Se,Ee){try{return await(0,q.getResolvedShellEnv)(this.logService,we,Se)}catch(pe){const ke=(0,k.toErrorMessage)(pe);Ee?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(we,Se){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=we.get(F.IDialogMainService);let pe=!1;const ke=async Me=>{if(pe)return;pe=!0;const Te=await v.contentTracing.stopRecording(`${(0,g.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Te}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Te),buttons:[(0,P.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,m.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>ke(!0),3e4);Promise.all(Se.map(Me=>Me.ready())).then(()=>{clearTimeout(De),ke(!1)})}};Ze=de([ne(2,T.IInstantiationService),ne(3,se.ILogService),ne(4,oe.IEnvironmentMainService),ne(5,ie.ILifecycleMainService),ne(6,h.IConfigurationService),ne(7,me.IStateMainService),ne(8,V.IFileService),ne(9,he.IProductService)],Ze),e.CodeApplication=Ze}),define(ee[256],te([0,1,14,28,31,8,39,15,27,42,33,10,9,64,3,34,25,24,37,57,249,11,19,197,208,23,53,169,18,187,96,62,181,76,20,97,6,191,98,54,22,55,194,99,234,49,236,77,205,38,238,66,67,214]),function(K,e,v,n,D,C,k,I,g,w,E,P,S,y,t,f,m,p,M,a,d,c,o,u,s,i,r,l,h,b,R,L,F,z,Q,oe,re,q,x,H,G,j,N,B,Y,V,W,$,A,T,_,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(Z){console.error(Z.message),v.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(me=>console.error(me));const[Z,ce,le,he,ge,ye,fe]=this.createServices();try{try{await this.initServices(le,he,ge)}catch(me){throw this.handleStartupDataDirError(le,fe.nameLong,me),me}await Z.invokeFunction(async me=>{const be=me.get(re.ILogService),Pe=me.get(Q.ILifecycleMainService),Ce=me.get(h.IFileService),Re=await this.claimInstance(be,le,Pe,Z,fe,!0);return p.Promises.writeFile(le.mainLockfile,String(process.pid)).catch(_e=>{be.warn(`Error writing main lockfile: ${_e.stack}`)}),ye.logger=new x.SpdLogLogger("main",(0,S.join)(le.logsPath,"main.log"),!0,!1,ye.getLevel()),(0,w.once)(Pe.onWillShutdown)(_e=>{Ce.dispose(),he.dispose(),_e.join(p.Promises.unlink(le.mainLockfile).catch(()=>{}))}),Z.createInstance(d.CodeApplication,Re,ce).startup()})}catch(me){Z.invokeFunction(this.quit,me)}}createServices(){const Z=new z.ServiceCollection,ce={_serviceBrand:void 0,...H.default};Z.set(G.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),he=this.patchEnvironment(le);Z.set(i.IEnvironmentMainService,le);const ge=new oe.BufferLogService,ye=new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(le)),ge]);process.once("exit",()=>ye.dispose()),Z.set(re.ILogService,ye);const fe=new b.FileService(ye);Z.set(h.IFileService,fe);const me=new R.DiskFileSystemProvider(ye);fe.registerProvider(P.Schemas.file,me),Z.set(re.ILoggerService,new q.LoggerService(ye,fe));const be=new u.ConfigurationService(le.settingsResource,fe);Z.set(o.IConfigurationService,be),Z.set(Q.ILifecycleMainService,new L.SyncDescriptor(Q.LifecycleMainService));const Pe=new _.StateMainService(le,ye,fe);return Z.set(T.IStateMainService,Pe),Z.set(V.IRequestService,new L.SyncDescriptor(W.RequestMainService)),Z.set(U.IThemeMainService,new L.SyncDescriptor(U.ThemeMainService)),Z.set($.ISignService,new L.SyncDescriptor(A.SignService)),Z.set(B.ITunnelService,new L.SyncDescriptor(Y.TunnelService)),Z.set(j.IProtocolMainService,new L.SyncDescriptor(N.ProtocolMainService)),[new F.InstantiationService(Z,!0),he,le,be,Pe,ge,ce]}patchEnvironment(Z){const ce={VSCODE_IPC_HOOK:Z.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const he=process.env[le];typeof he=="string"&&(ce[le]=he)}),Object.assign(process.env,ce),ce}initServices(Z,ce,le){return C.Promises.settled([Promise.all([Z.extensionsPath,Z.codeCachePath,Z.logsPath,Z.globalStorageHome.fsPath,Z.workspaceStorageHome.fsPath,Z.backupHome].map(he=>he?p.Promises.mkdir(he,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(Z,ce,le,he,ge,ye){let fe;try{(0,y.mark)("code/willStartMainServer"),fe=await(0,a.serve)(ce.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,w.once)(le.onWillShutdown)(()=>fe.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,ge.nameLong,me),me;let be;try{be=await(0,a.connect)(ce.mainIPCHandle,"main")}catch(Re){if(!ye||t.isWindows||Re.code!=="ECONNREFUSED")throw Re.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,ge.nameShort),(0,c.localize)(1,null),ge.nameLong),Re;try{(0,n.unlinkSync)(ce.mainIPCHandle)}catch(_e){throw Z.warn("Could not delete obsolete instance handle",_e),_e}return this.claimInstance(Z,ce,le,he,ge,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Re="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw Z.error(Re),be.dispose(),new Error(Re)}let Pe;!ce.args.wait&&!ce.args.status&&(Pe=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,ge.nameShort),(0,c.localize)(3,null),ge.nameLong)},1e4));const Ce=M.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return he.invokeFunction(async()=>{const Re=new s.DiagnosticsService(O.NullTelemetryService,ge),_e=await Ce.getMainProcessInfo(),$e=await Ce.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Qe=await Re.getDiagnostics(_e,$e);throw console.log(Qe),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ce,Z),Z.trace("Sending env to running instance..."),await Ce.start(ce.args,process.env),be.dispose(),Pe&&clearTimeout(Pe),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw Z.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),fe}handleStartupDataDirError(Z,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const he=(0,D.coalesce)([Z.userDataPath,Z.extensionsPath,a.XDG_RUNTIME_DIR]).map(ge=>(0,E.getPathLabel)(ge,Z));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,k.toErrorMessage)(le),he.join(`
`)),ce)}}showStartupWarningDialog(Z,ce,le){v.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,c.localize)(6,null))],message:Z,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(Z,ce){if(t.isWindows){const le=await Z.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((he,ge)=>{K(["windows-foreground-love"],he,ge)})).allowSetForegroundWindow(le)}catch(he){ce.error(he)}}}quit(Z,ce){const le=Z.get(re.ILogService),he=Z.get(Q.ILifecycleMainService);let ge=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(ge=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),he.kill(ge)}resolveArgs(){const Z=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(Z.wait&&!Z.waitMarkerFilePath){const ce=(0,l.createWaitMarkerFile)(Z.verbose);ce&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",ce),Z.waitMarkerFilePath=ce)}return Z}validatePaths(Z){if(Z["open-url"]&&(Z._urls=Z._,Z._=[]),!Z.remote){const ce=this.doValidatePaths(Z._,Z.goto);Z._=ce}return Z}doValidatePaths(Z,ce){const le=(0,f.cwd)(),he=Z.map(fe=>{let me=String(fe),be;ce&&(be=(0,g.parseLineAndColumnAware)(me),me=be.path),me&&(me=this.preparePath(le,me));const Pe=(0,g.sanitizeFilePath)(me,le),Ce=(0,S.basename)(Pe);return Ce&&!(0,g.isValidBasename)(Ce)?null:ce&&be?(be.path=Pe,this.toPath(be)):Pe}),ge=t.isWindows||t.isMacintosh,ye=(0,D.distinct)(he,fe=>fe&&ge?fe.toLowerCase():fe||"");return(0,D.coalesce)(ye)}preparePath(Z,ce){return t.isWindows&&(ce=(0,m.rtrim)(ce,'"')),ce=(0,m.trim)((0,m.trim)(ce," "),"	"),t.isWindows&&(ce=(0,S.resolve)(Z,ce),ce=(0,m.rtrim)(ce,".")),ce}toPath(Z){const ce=[Z.path];return typeof Z.line=="number"&&ce.push(String(Z.line)),typeof Z.column=="number"&&ce.push(String(Z.column)),ce.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0e435cf51d0e45293a94466fc3b1299ba70fa9b1/core/vs/code/electron-main/main.js.map
