/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/types","vs/base/common/event","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/platform","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/files/common/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/common/iterator","graceful-fs","vs/platform/files/node/watcher/nodejs/nodejsWatcher","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(z){for(var t=[],C=0,D=z.length;C<D;C++)t[C]=Q[z[C]];return t};define(Q[54],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function C(D,S){if(!D)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=C}),define(Q[44],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(L){return(b,u,v)=>{let I=null,O=null;if(typeof v.value=="function"?(I="value",O=v.value):typeof v.get=="function"&&(I="get",O=v.get),!O)throw new Error("not supported");v[I]=L(O,u)}}t.createDecorator=C;function D(L,b,u){let v=null,I=null;if(typeof u.value=="function"?(v="value",I=u.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(v="get",I=u.get),!I)throw new Error("not supported");const O=`$memoize$${b}`;u[v]=function(...g){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,g)}),this[O]}}t.memoize=D;function S(L,b,u){return C((v,I)=>{const O=`$debounce$${I}`,g=`$debounce$result$${I}`;return function(...P){this[g]||(this[g]=u?u():void 0),clearTimeout(this[O]),b&&(this[g]=b(this[g],...P),P=[this[g]]),this[O]=setTimeout(()=>{v.apply(this,P),this[g]=u?u():void 0},L)}})}t.debounce=S;function R(L,b,u){return C((v,I)=>{const O=`$throttle$timer$${I}`,g=`$throttle$result$${I}`,P=`$throttle$lastRun$${I}`,p=`$throttle$pending$${I}`;return function(...h){if(this[g]||(this[g]=u?u():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),b&&(this[g]=b(this[g],...h)),this[p])return;const l=this[P]+L;l<=Date.now()?(this[P]=Date.now(),v.apply(this,[this[g]]),this[g]=u?u():void 0):(this[p]=!0,this[O]=setTimeout(()=>{this[p]=!1,this[P]=Date.now(),v.apply(this,[this[g]]),this[g]=u?u():void 0},l-Date.now()))}})}t.throttle=R}),define(Q[55],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var D;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(D=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function L(n,r=!1){let e=0,i=n.length,s="",c=0,f=16,E=0;function w(te){let ge=0,B=0;for(;ge<te;){const $=n.charCodeAt(e);if($>=48&&$<=57)B=B*16+$-48;else if($>=65&&$<=70)B=B*16+$-65+10;else if($>=97&&$<=102)B=B*16+$-97+10;else break;e++,ge++}return ge<te&&(B=-1),B}function T(te){e=te,s="",c=0,f=16,E=0}function F(){const te=e;if(n.charCodeAt(e)===48)e++;else for(e++;e<n.length&&v(n.charCodeAt(e));)e++;if(e<n.length&&n.charCodeAt(e)===46)if(e++,e<n.length&&v(n.charCodeAt(e)))for(e++;e<n.length&&v(n.charCodeAt(e));)e++;else return E=3,n.substring(te,e);let ge=e;if(e<n.length&&(n.charCodeAt(e)===69||n.charCodeAt(e)===101))if(e++,(e<n.length&&n.charCodeAt(e)===43||n.charCodeAt(e)===45)&&e++,e<n.length&&v(n.charCodeAt(e))){for(e++;e<n.length&&v(n.charCodeAt(e));)e++;ge=e}else E=3;return n.substring(te,ge)}function W(){let te="",ge=e;for(;;){if(e>=i){te+=n.substring(ge,e),E=2;break}const B=n.charCodeAt(e);if(B===34){te+=n.substring(ge,e),e++;break}if(B===92){if(te+=n.substring(ge,e),e++,e>=i){E=2;break}switch(n.charCodeAt(e++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const re=w(4);re>=0?te+=String.fromCharCode(re):E=4;break}default:E=5}ge=e;continue}if(B>=0&&B<=31)if(u(B)){te+=n.substring(ge,e),E=2;break}else E=6;e++}return te}function J(){if(s="",E=0,c=e,e>=i)return c=i,f=17;let te=n.charCodeAt(e);if(b(te)){do e++,s+=String.fromCharCode(te),te=n.charCodeAt(e);while(b(te));return f=15}if(u(te))return e++,s+=String.fromCharCode(te),te===13&&n.charCodeAt(e)===10&&(e++,s+=`
`),f=14;switch(te){case 123:return e++,f=1;case 125:return e++,f=2;case 91:return e++,f=3;case 93:return e++,f=4;case 58:return e++,f=6;case 44:return e++,f=5;case 34:return e++,s=W(),f=10;case 47:{const ge=e-1;if(n.charCodeAt(e+1)===47){for(e+=2;e<i&&!u(n.charCodeAt(e));)e++;return s=n.substring(ge,e),f=12}if(n.charCodeAt(e+1)===42){e+=2;const B=i-1;let $=!1;for(;e<B;){if(n.charCodeAt(e)===42&&n.charCodeAt(e+1)===47){e+=2,$=!0;break}e++}return $||(e++,E=1),s=n.substring(ge,e),f=13}return s+=String.fromCharCode(te),e++,f=16}case 45:if(s+=String.fromCharCode(te),e++,e===i||!v(n.charCodeAt(e)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),f=11;default:for(;e<i&&se(te);)e++,te=n.charCodeAt(e);if(c!==e){switch(s=n.substring(c,e),s){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return s+=String.fromCharCode(te),e++,f=16}}function se(te){if(b(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let te;do te=J();while(te>=12&&te<=15);return te}return{setPosition:T,getPosition:()=>e,scan:r?ie:J,getToken:()=>f,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>e-c,getTokenError:()=>E}}t.createScanner=L;function b(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function u(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function O(n,r){const e=[],i=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function E(w,T,F,W){c.value=w,c.offset=T,c.length=F,c.type=W,c.colonOffset=void 0,s=c}try{a(n,{onObjectBegin:(w,T)=>{if(r<=w)throw i;s=void 0,f=r>w,e.push("")},onObjectProperty:(w,T,F)=>{if(r<T||(E(w,T,F,"property"),e[e.length-1]=w,r<=T+F))throw i},onObjectEnd:(w,T)=>{if(r<=w)throw i;s=void 0,e.pop()},onArrayBegin:(w,T)=>{if(r<=w)throw i;s=void 0,e.push(0)},onArrayEnd:(w,T)=>{if(r<=w)throw i;s=void 0,e.pop()},onLiteralValue:(w,T,F)=>{if(r<T||(E(w,T,F,o(w)),r<=T+F))throw i},onSeparator:(w,T,F)=>{if(r<=T)throw i;if(w===":"&&s&&s.type==="property")s.colonOffset=T,f=!1,s=void 0;else if(w===","){const W=e[e.length-1];typeof W=="number"?e[e.length-1]=W+1:(f=!0,e[e.length-1]=""),s=void 0}}})}catch(w){if(w!==i)throw w}return{path:e,previousNode:s,isAtPropertyKey:f,matches:w=>{let T=0;for(let F=0;T<w.length&&F<e.length;F++)if(w[T]===e[F]||w[T]==="*")T++;else if(w[T]!=="**")return!1;return T===w.length}}}t.getLocation=O;function g(n,r=[],e=R.DEFAULT){let i=null,s=[];const c=[];function f(w){Array.isArray(s)?s.push(w):i!==null&&(s[i]=w)}return a(n,{onObjectBegin:()=>{const w={};f(w),c.push(s),s=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const w=[];f(w),c.push(s),s=w,i=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:f,onError:(w,T,F)=>{r.push({error:w,offset:T,length:F})}},e),s[0]}t.parse=g;function P(n,r=[],e=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function c(w){return i.children.push(w),w}a(n,{onObjectBegin:w=>{i=c({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,T,F)=>{i=c({type:"property",offset:T,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:T,length:F,parent:i})},onObjectEnd:(w,T)=>{i.length=w+T-i.offset,i=i.parent,s(w+T)},onArrayBegin:(w,T)=>{i=c({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,T)=>{i.length=w+T-i.offset,i=i.parent,s(w+T)},onLiteralValue:(w,T,F)=>{c({type:o(w),offset:T,length:F,parent:i,value:w}),s(T+F)},onSeparator:(w,T,F)=>{i.type==="property"&&(w===":"?i.colonOffset=T:w===","&&s(T))},onError:(w,T,F)=>{r.push({error:w,offset:T,length:F})}},e);const E=i.children[0];return E&&delete E.parent,E}t.parseTree=P;function p(n,r){if(!n)return;let e=n;for(let i of r)if(typeof i=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const c of e.children)if(Array.isArray(c.children)&&c.children[0].value===i){e=c.children[1],s=!0;break}if(!s)return}else{const s=i;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}t.findNodeAtLocation=p;function h(n){if(!n.parent||!n.parent.children)return[];const r=h(n.parent);if(n.parent.type==="property"){const e=n.parent.children[0].value;r.push(e)}else if(n.parent.type==="array"){const e=n.parent.children.indexOf(n);e!==-1&&r.push(e)}return r}t.getNodePath=h;function l(n){switch(n.type){case"array":return n.children.map(l);case"object":{const r=Object.create(null);for(let e of n.children){const i=e.children[1];i&&(r[e.children[0].value]=l(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}t.getNodeValue=l;function d(n,r,e=!1){return r>=n.offset&&r<n.offset+n.length||e&&r===n.offset+n.length}t.contains=d;function y(n,r,e=!1){if(d(n,r,e)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const c=y(i[s],r,e);if(c)return c}return n}}t.findNodeAtOffset=y;function a(n,r,e=R.DEFAULT){const i=L(n,!1);function s(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(X){return X?ee=>X(ee,i.getTokenOffset(),i.getTokenLength()):()=>!0}const f=s(r.onObjectBegin),E=c(r.onObjectProperty),w=s(r.onObjectEnd),T=s(r.onArrayBegin),F=s(r.onArrayEnd),W=c(r.onLiteralValue),J=c(r.onSeparator),se=s(r.onComment),ie=c(r.onError),te=e&&e.disallowComments,ge=e&&e.allowTrailingComma;function B(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:te||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(X){case 12:case 13:te?$(10):se();break;case 16:$(1);break;case 15:case 14:break;default:return X}}}function $(X,ee=[],G=[]){if(ie(X),ee.length+G.length>0){let le=i.getToken();for(;le!==17;){if(ee.indexOf(le)!==-1){B();break}else if(G.indexOf(le)!==-1)break;le=B()}}}function re(X){const ee=i.getTokenValue();return X?W(ee):E(ee),B(),!0}function M(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&($(2),X=0)}catch{$(2)}W(X);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return B(),!0}function A(){return i.getToken()!==10?($(3,[],[2,5]),!1):(re(!1),i.getToken()===6?(J(":"),B(),ne()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function j(){f(),B();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||$(4,[],[]),J(","),B(),i.getToken()===2&&ge)break}else X&&$(6,[],[]);A()||$(4,[],[2,5]),X=!0}return w(),i.getToken()!==2?$(7,[2],[]):B(),!0}function H(){T(),B();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||$(4,[],[]),J(","),B(),i.getToken()===4&&ge)break}else X&&$(6,[],[]);ne()||$(4,[],[4,5]),X=!0}return F(),i.getToken()!==4?$(8,[4],[]):B(),!0}function ne(){switch(i.getToken()){case 3:return H();case 1:return j();case 10:return re(!0);default:return M()}}return B(),i.getToken()===17?e.allowEmptyContent?!0:($(4,[],[]),!1):ne()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}t.visit=a;function m(n,r){let e=L(n),i=[],s,c=0,f;do switch(f=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:c!==f&&i.push(n.substring(c,f)),r!==void 0&&i.push(e.getTokenValue().replace(/[^\r\n]/g,r)),c=e.getPosition();break}while(s!==17);return i.join("")}t.stripComments=m;function o(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function z(S){const R=[];typeof S=="number"&&R.push("code/timeOrigin",S);function L(u){R.push(u,Date.now())}function b(){const u=[];for(let v=0;v<R.length;v+=2)u.push({name:R[v],startTime:R[v+1]});return u}return{mark:L,getMarks:b}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(S+L.startTime)});return R}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function C(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=C(D))}(),define(Q[56],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var C;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(C=t.Source||(t.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=t.TerminateResponseCode||(t.TerminateResponseCode={}));function S(R,...L){const b=L.reduce((I,O)=>(I[O]=!0,I),{}),u=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(I=>!b[I]).forEach(I=>{for(let O=0;O<u.length;O++)if(I.search(u[O])!==-1){delete R[I];break}})}t.sanitizeProcessEnvironment=S}),function(z,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var D in C)(typeof exports=="object"?exports:z)[D]=C[D]}}(typeof self!="undefined"?self:this,function(){return function(z){var t={};function C(D){if(t[D])return t[D].exports;var S=t[D]={i:D,l:!1,exports:{}};return z[D].call(S.exports,S,S.exports,C),S.l=!0,S.exports}return C.m=z,C.c=t,C.d=function(D,S,R){C.o(D,S)||Object.defineProperty(D,S,{enumerable:!0,get:R})},C.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},C.t=function(D,S){if(1&S&&(D=C(D)),8&S||4&S&&typeof D=="object"&&D&&D.__esModule)return D;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:D}),2&S&&typeof D!="string")for(var L in D)C.d(R,L,function(b){return D[b]}.bind(null,L));return R},C.n=function(D){var S=D&&D.__esModule?function(){return D.default}:function(){return D};return C.d(S,"a",S),S},C.o=function(D,S){return Object.prototype.hasOwnProperty.call(D,S)},C.p="",C(C.s=0)}([function(z,t,C){(function(D){var S;t=z.exports=G,S=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var k=Array.prototype.slice.call(arguments,0);k.unshift("SEMVER"),console.log.apply(console,k)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=t.re=[],u=t.src=[],v=0,I=v++;u[I]="0|[1-9]\\d*";var O=v++;u[O]="[0-9]+";var g=v++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=v++;u[P]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var p=v++;u[p]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var h=v++;u[h]="(?:"+u[I]+"|"+u[g]+")";var l=v++;u[l]="(?:"+u[O]+"|"+u[g]+")";var d=v++;u[d]="(?:-("+u[h]+"(?:\\."+u[h]+")*))";var y=v++;u[y]="(?:-?("+u[l]+"(?:\\."+u[l]+")*))";var a=v++;u[a]="[0-9A-Za-z-]+";var m=v++;u[m]="(?:\\+("+u[a]+"(?:\\."+u[a]+")*))";var o=v++,n="v?"+u[P]+u[d]+"?"+u[m]+"?";u[o]="^"+n+"$";var r="[v=\\s]*"+u[p]+u[y]+"?"+u[m]+"?",e=v++;u[e]="^"+r+"$";var i=v++;u[i]="((?:<|>)?=?)";var s=v++;u[s]=u[O]+"|x|X|\\*";var c=v++;u[c]=u[I]+"|x|X|\\*";var f=v++;u[f]="[v=\\s]*("+u[c]+")(?:\\.("+u[c]+")(?:\\.("+u[c]+")(?:"+u[d]+")?"+u[m]+"?)?)?";var E=v++;u[E]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[y]+")?"+u[m]+"?)?)?";var w=v++;u[w]="^"+u[i]+"\\s*"+u[f]+"$";var T=v++;u[T]="^"+u[i]+"\\s*"+u[E]+"$";var F=v++;u[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=v++;u[W]="(?:~>?)";var J=v++;u[J]="(\\s*)"+u[W]+"\\s+",b[J]=new RegExp(u[J],"g");var se=v++;u[se]="^"+u[W]+u[f]+"$";var ie=v++;u[ie]="^"+u[W]+u[E]+"$";var te=v++;u[te]="(?:\\^)";var ge=v++;u[ge]="(\\s*)"+u[te]+"\\s+",b[ge]=new RegExp(u[ge],"g");var B=v++;u[B]="^"+u[te]+u[f]+"$";var $=v++;u[$]="^"+u[te]+u[E]+"$";var re=v++;u[re]="^"+u[i]+"\\s*("+r+")$|^$";var M=v++;u[M]="^"+u[i]+"\\s*("+n+")$|^$";var A=v++;u[A]="(\\s*)"+u[i]+"\\s*("+r+"|"+u[f]+")",b[A]=new RegExp(u[A],"g");var j=v++;u[j]="^\\s*("+u[f]+")\\s+-\\s+("+u[f]+")\\s*$";var H=v++;u[H]="^\\s*("+u[E]+")\\s+-\\s+("+u[E]+")\\s*$";var ne=v++;u[ne]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)S(X,u[X]),b[X]||(b[X]=new RegExp(u[X]));function ee(k,V){if(k instanceof G)return k;if(typeof k!="string"||k.length>R||!(V?b[e]:b[o]).test(k))return null;try{return new G(k,V)}catch{return null}}function G(k,V){if(k instanceof G){if(k.loose===V)return k;k=k.version}else if(typeof k!="string")throw new TypeError("Invalid Version: "+k);if(k.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(k,V);S("SemVer",k,V),this.loose=V;var q=k.trim().match(V?b[e]:b[o]);if(!q)throw new TypeError("Invalid Version: "+k);if(this.raw=k,this.major=+q[1],this.minor=+q[2],this.patch=+q[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");q[4]?this.prerelease=q[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var me=+fe;if(me>=0&&me<L)return me}return fe}):this.prerelease=[],this.build=q[5]?q[5].split("."):[],this.format()}t.parse=ee,t.valid=function(k,V){var q=ee(k,V);return q?q.version:null},t.clean=function(k,V){var q=ee(k.trim().replace(/^[=v]+/,""),V);return q?q.version:null},t.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(k){return S("SemVer.compare",this.version,this.loose,k),k instanceof G||(k=new G(k,this.loose)),this.compareMain(k)||this.comparePre(k)},G.prototype.compareMain=function(k){return k instanceof G||(k=new G(k,this.loose)),U(this.major,k.major)||U(this.minor,k.minor)||U(this.patch,k.patch)},G.prototype.comparePre=function(k){if(k instanceof G||(k=new G(k,this.loose)),this.prerelease.length&&!k.prerelease.length)return-1;if(!this.prerelease.length&&k.prerelease.length)return 1;if(!this.prerelease.length&&!k.prerelease.length)return 0;var V=0;do{var q=this.prerelease[V],fe=k.prerelease[V];if(S("prerelease compare",V,q,fe),q===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(q===void 0)return-1;if(q!==fe)return U(q,fe)}while(++V)},G.prototype.inc=function(k,V){switch(k){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var q=this.prerelease.length;--q>=0;)typeof this.prerelease[q]=="number"&&(this.prerelease[q]++,q=-2);q===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+k)}return this.format(),this.raw=this.version,this},t.inc=function(k,V,q,fe){typeof q=="string"&&(fe=q,q=void 0);try{return new G(k,q).inc(V,fe).version}catch{return null}},t.diff=function(k,V){if(K(k,V))return null;var q=ee(k),fe=ee(V);if(q.prerelease.length||fe.prerelease.length){for(var me in q)if((me==="major"||me==="minor"||me==="patch")&&q[me]!==fe[me])return"pre"+me;return"prerelease"}for(var me in q)if((me==="major"||me==="minor"||me==="patch")&&q[me]!==fe[me])return me},t.compareIdentifiers=U;var le=/^[0-9]+$/;function U(k,V){var q=le.test(k),fe=le.test(V);return q&&fe&&(k=+k,V=+V),q&&!fe?-1:fe&&!q?1:k<V?-1:k>V?1:0}function N(k,V,q){return new G(k,q).compare(new G(V,q))}function _(k,V,q){return N(k,V,q)>0}function x(k,V,q){return N(k,V,q)<0}function K(k,V,q){return N(k,V,q)===0}function Y(k,V,q){return N(k,V,q)!==0}function de(k,V,q){return N(k,V,q)>=0}function ce(k,V,q){return N(k,V,q)<=0}function he(k,V,q,fe){var me;switch(V){case"===":typeof k=="object"&&(k=k.version),typeof q=="object"&&(q=q.version),me=k===q;break;case"!==":typeof k=="object"&&(k=k.version),typeof q=="object"&&(q=q.version),me=k!==q;break;case"":case"=":case"==":me=K(k,q,fe);break;case"!=":me=Y(k,q,fe);break;case">":me=_(k,q,fe);break;case">=":me=de(k,q,fe);break;case"<":me=x(k,q,fe);break;case"<=":me=ce(k,q,fe);break;default:throw new TypeError("Invalid operator: "+V)}return me}function oe(k,V){if(k instanceof oe){if(k.loose===V)return k;k=k.value}if(!(this instanceof oe))return new oe(k,V);S("comparator",k,V),this.loose=V,this.parse(k),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(k,V){return U(V,k)},t.major=function(k,V){return new G(k,V).major},t.minor=function(k,V){return new G(k,V).minor},t.patch=function(k,V){return new G(k,V).patch},t.compare=N,t.compareLoose=function(k,V){return N(k,V,!0)},t.rcompare=function(k,V,q){return N(V,k,q)},t.sort=function(k,V){return k.sort(function(q,fe){return t.compare(q,fe,V)})},t.rsort=function(k,V){return k.sort(function(q,fe){return t.rcompare(q,fe,V)})},t.gt=_,t.lt=x,t.eq=K,t.neq=Y,t.gte=de,t.lte=ce,t.cmp=he,t.Comparator=oe;var pe={};function ue(k,V){if(k instanceof ue)return k.loose===V?k:new ue(k.raw,V);if(k instanceof oe)return new ue(k.value,V);if(!(this instanceof ue))return new ue(k,V);if(this.loose=V,this.raw=k,this.set=k.split(/\s*\|\|\s*/).map(function(q){return this.parseRange(q.trim())},this).filter(function(q){return q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+k);this.format()}function ye(k){return!k||k.toLowerCase()==="x"||k==="*"}function De(k,V,q,fe,me,Te,Se,Ne,Pe,Ae,ze,Re,Oe){return((V=ye(q)?"":ye(fe)?">="+q+".0.0":ye(me)?">="+q+"."+fe+".0":">="+V)+" "+(Ne=ye(Pe)?"":ye(Ae)?"<"+(+Pe+1)+".0.0":ye(ze)?"<"+Pe+"."+(+Ae+1)+".0":Re?"<="+Pe+"."+Ae+"."+ze+"-"+Re:"<="+Ne)).trim()}function Ce(k,V){for(var q=0;q<k.length;q++)if(!k[q].test(V))return!1;if(V.prerelease.length){for(q=0;q<k.length;q++)if(S(k[q].semver),k[q].semver!==pe&&k[q].semver.prerelease.length>0){var fe=k[q].semver;if(fe.major===V.major&&fe.minor===V.minor&&fe.patch===V.patch)return!0}return!1}return!0}function Le(k,V,q){try{V=new ue(V,q)}catch{return!1}return V.test(k)}function Fe(k,V,q,fe){var me,Te,Se,Ne,Pe;switch(k=new G(k,fe),V=new ue(V,fe),q){case">":me=_,Te=ce,Se=x,Ne=">",Pe=">=";break;case"<":me=x,Te=de,Se=_,Ne="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(k,V,fe))return!1;for(var Ae=0;Ae<V.set.length;++Ae){var ze=V.set[Ae],Re=null,Oe=null;if(ze.forEach(function(Me){Me.semver===pe&&(Me=new oe(">=0.0.0")),Re=Re||Me,Oe=Oe||Me,me(Me.semver,Re.semver,fe)?Re=Me:Se(Me.semver,Oe.semver,fe)&&(Oe=Me)}),Re.operator===Ne||Re.operator===Pe||(!Oe.operator||Oe.operator===Ne)&&Te(k,Oe.semver)||Oe.operator===Pe&&Se(k,Oe.semver))return!1}return!0}oe.prototype.parse=function(k){var V=this.loose?b[re]:b[M],q=k.match(V);if(!q)throw new TypeError("Invalid comparator: "+k);this.operator=q[1],this.operator==="="&&(this.operator=""),q[2]?this.semver=new G(q[2],this.loose):this.semver=pe},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(k){return S("Comparator.test",k,this.loose),this.semver===pe||(typeof k=="string"&&(k=new G(k,this.loose)),he(k,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(k,V){if(!(k instanceof oe))throw new TypeError("a Comparator is required");var q;if(this.operator==="")return q=new ue(k.value,V),Le(this.value,q,V);if(k.operator==="")return q=new ue(this.value,V),Le(k.semver,q,V);var fe=!(this.operator!==">="&&this.operator!==">"||k.operator!==">="&&k.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||k.operator!=="<="&&k.operator!=="<"),Te=this.semver.version===k.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||k.operator!==">="&&k.operator!=="<="),Ne=he(this.semver,"<",k.semver,V)&&(this.operator===">="||this.operator===">")&&(k.operator==="<="||k.operator==="<"),Pe=he(this.semver,">",k.semver,V)&&(this.operator==="<="||this.operator==="<")&&(k.operator===">="||k.operator===">");return fe||me||Te&&Se||Ne||Pe},t.Range=ue,ue.prototype.format=function(){return this.range=this.set.map(function(k){return k.join(" ").trim()}).join("||").trim(),this.range},ue.prototype.toString=function(){return this.range},ue.prototype.parseRange=function(k){var V=this.loose;k=k.trim(),S("range",k,V);var q=V?b[H]:b[j];k=k.replace(q,De),S("hyphen replace",k),k=k.replace(b[A],"$1$2$3"),S("comparator trim",k,b[A]),k=(k=(k=k.replace(b[J],"$1~")).replace(b[ge],"$1^")).split(/\s+/).join(" ");var fe=V?b[re]:b[M],me=k.split(" ").map(function(Te){return function(Se,Ne){return S("comp",Se),Se=function(Pe,Ae){return Pe.trim().split(/\s+/).map(function(ze){return function(Re,Oe){S("caret",Re,Oe);var Me=Oe?b[$]:b[B];return Re.replace(Me,function(Ue,Ee,we,be,Ie){var ke;return S("caret",Re,Ue,Ee,we,be,Ie),ye(Ee)?ke="":ye(we)?ke=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ye(be)?ke=Ee==="0"?">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+".0 <"+(+Ee+1)+".0.0":Ie?(S("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+Ie+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+Ie+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+Ie+" <"+(+Ee+1)+".0.0"):(S("no pr"),ke=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+" <"+(+Ee+1)+".0.0"),S("caret return",ke),ke})}(ze,Ae)}).join(" ")}(Se,Ne),S("caret",Se),Se=function(Pe,Ae){return Pe.trim().split(/\s+/).map(function(ze){return function(Re,Oe){var Me=Oe?b[ie]:b[se];return Re.replace(Me,function(Ue,Ee,we,be,Ie){var ke;return S("tilde",Re,Ue,Ee,we,be,Ie),ye(Ee)?ke="":ye(we)?ke=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ye(be)?ke=">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":Ie?(S("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=">="+Ee+"."+we+"."+be+Ie+" <"+Ee+"."+(+we+1)+".0"):ke=">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0",S("tilde return",ke),ke})}(ze,Ae)}).join(" ")}(Se,Ne),S("tildes",Se),Se=function(Pe,Ae){return S("replaceXRanges",Pe,Ae),Pe.split(/\s+/).map(function(ze){return function(Re,Oe){Re=Re.trim();var Me=Oe?b[T]:b[w];return Re.replace(Me,function(Ue,Ee,we,be,Ie,ke){S("xRange",Re,Ue,Ee,we,be,Ie,ke);var je=ye(we),xe=je||ye(be),Ve=xe||ye(Ie);return Ee==="="&&Ve&&(Ee=""),je?Ue=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(xe&&(be=0),Ve&&(Ie=0),Ee===">"?(Ee=">=",xe?(we=+we+1,be=0,Ie=0):Ve&&(be=+be+1,Ie=0)):Ee==="<="&&(Ee="<",xe?we=+we+1:be=+be+1),Ue=Ee+we+"."+be+"."+Ie):xe?Ue=">="+we+".0.0 <"+(+we+1)+".0.0":Ve&&(Ue=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),S("xRange return",Ue),Ue})}(ze,Ae)}).join(" ")}(Se,Ne),S("xrange",Se),Se=function(Pe,Ae){return S("replaceStars",Pe,Ae),Pe.trim().replace(b[ne],"")}(Se,Ne),S("stars",Se),Se}(Te,V)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Te){return!!Te.match(fe)})),me=me.map(function(Te){return new oe(Te,V)})},ue.prototype.intersects=function(k,V){if(!(k instanceof ue))throw new TypeError("a Range is required");return this.set.some(function(q){return q.every(function(fe){return k.set.some(function(me){return me.every(function(Te){return fe.intersects(Te,V)})})})})},t.toComparators=function(k,V){return new ue(k,V).set.map(function(q){return q.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},ue.prototype.test=function(k){if(!k)return!1;typeof k=="string"&&(k=new G(k,this.loose));for(var V=0;V<this.set.length;V++)if(Ce(this.set[V],k))return!0;return!1},t.satisfies=Le,t.maxSatisfying=function(k,V,q){var fe=null,me=null;try{var Te=new ue(V,q)}catch{return null}return k.forEach(function(Se){Te.test(Se)&&(fe&&me.compare(Se)!==-1||(me=new G(fe=Se,q)))}),fe},t.minSatisfying=function(k,V,q){var fe=null,me=null;try{var Te=new ue(V,q)}catch{return null}return k.forEach(function(Se){Te.test(Se)&&(fe&&me.compare(Se)!==1||(me=new G(fe=Se,q)))}),fe},t.validRange=function(k,V){try{return new ue(k,V).range||"*"}catch{return null}},t.ltr=function(k,V,q){return Fe(k,V,"<",q)},t.gtr=function(k,V,q){return Fe(k,V,">",q)},t.outside=Fe,t.prerelease=function(k,V){var q=ee(k,V);return q&&q.prerelease.length?q.prerelease:null},t.intersects=function(k,V,q){return k=new ue(k,q),V=new ue(V,q),k.intersects(V)},t.coerce=function(k){if(k instanceof G)return k;if(typeof k!="string")return null;var V=k.match(b[F]);return V==null?null:ee((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,C(1))},function(z,t){var C,D,S=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(l){if(C===setTimeout)return setTimeout(l,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(l,0);try{return C(l,0)}catch{try{return C.call(null,l,0)}catch{return C.call(this,l,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{D=typeof clearTimeout=="function"?clearTimeout:L}catch{D=L}})();var u,v=[],I=!1,O=-1;function g(){I&&u&&(I=!1,u.length?v=u.concat(v):O=-1,v.length&&P())}function P(){if(!I){var l=b(g);I=!0;for(var d=v.length;d;){for(u=v,v=[];++O<d;)u&&u[O].run();O=-1,d=v.length}u=null,I=!1,function(y){if(D===clearTimeout)return clearTimeout(y);if((D===L||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(y);try{D(y)}catch{try{return D.call(null,y)}catch{return D.call(this,y)}}}(l)}}function p(l,d){this.fun=l,this.array=d}function h(){}S.nextTick=function(l){var d=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)d[y-1]=arguments[y];v.push(new p(l,d)),v.length!==1||I||b(P)},p.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=h,S.addListener=h,S.once=h,S.off=h,S.removeListener=h,S.removeAllListeners=h,S.emit=h,S.prependListener=h,S.prependOnceListener=h,S.listeners=function(l){return[]},S.binding=function(l){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(l){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Q[57],Z([0,1]),function(z,t){"use strict";var C;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class D{constructor(b,u,v){this.level=b,this.key=u,this.value=v,this.forward=[]}}const S=void 0;class R{constructor(b,u=2**16){this.comparator=b,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new D(this._maxLevel,S,S)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,S,S)}has(b){return Boolean(R._search(this,b,this.comparator))}get(b){return R._search(this,b,this.comparator)?.value}set(b,u){return R._insert(this,b,u,this.comparator)&&(this._size+=1),this}delete(b){const u=R._delete(this,b,this.comparator);return u&&(this._size-=1),u}forEach(b,u){let v=this._header.forward[0];for(;v;)b.call(u,v.value,v.key,this),v=v.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this._header.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static _search(b,u,v){let I=b._header;for(let O=b._level-1;O>=0;O--)for(;I.forward[O]&&v(I.forward[O].key,u)<0;)I=I.forward[O];if(I=I.forward[0],I&&v(I.key,u)===0)return I}static _insert(b,u,v,I){let O=[],g=b._header;for(let P=b._level-1;P>=0;P--){for(;g.forward[P]&&I(g.forward[P].key,u)<0;)g=g.forward[P];O[P]=g}if(g=g.forward[0],g&&I(g.key,u)===0)return g.value=v,!1;{let P=R._randomLevel(b);if(P>b._level){for(let p=b._level;p<P;p++)O[p]=b._header;b._level=P}g=new D(P,u,v);for(let p=0;p<P;p++)g.forward[p]=O[p].forward[p],O[p].forward[p]=g;return!0}}static _randomLevel(b,u=.5){let v=1;for(;Math.random()<u&&v<b._maxLevel;)v+=1;return v}static _delete(b,u,v){let I=[],O=b._header;for(let g=b._level-1;g>=0;g--){for(;O.forward[g]&&v(O.forward[g].key,u)<0;)O=O.forward[g];I[g]=O}if(O=O.forward[0],!O||v(O.key,u)!==0)return!1;for(let g=0;g<b._level&&I[g].forward[g]===O;g++)I[g].forward[g]=O.forward[g];for(;b._level>0&&b._header.forward[b._level-1]===S;)b._level-=1;return!0}}t.SkipList=R}),define(Q[37],Z([0,1,6,2]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(a){const m=a;return m?[m.on,m.pause,m.resume,m.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=S;function R(a){const m=a;return m?S(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}t.isReadableBufferedStream=R;function L(a,m){return new b(a,m)}t.newWriteableStream=L;class b{constructor(m,o){this.reducer=m,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(o=>o(m))}emitError(m){this.listeners.error.length===0?(0,C.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(o=>o(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,o){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(m,o){if(this.state.destroyed)return;let n;switch(m){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const r=n.indexOf(o);r>=0&&n.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(a,m){const o=[];let n;for(;(n=a.read())!==null;)o.push(n);return m(o)}t.consumeReadable=u;function v(a,m,o){const n=[];let r;for(;(r=a.read())!==null&&n.length<o;)n.push(r);return r===null&&n.length>0?m(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return a.read()}}}t.peekReadable=v;function I(a,m){return new Promise((o,n)=>{const r=[];O(a,{onData:e=>{m&&r.push(e)},onError:e=>{m?n(e):o(void 0)},onEnd:()=>{o(m?m(r):void 0)}})})}t.consumeStream=I;function O(a,m){let o=!1;return a.on("error",n=>{o||m.onError(n)}),a.on("end",()=>{o||m.onEnd()}),a.on("data",n=>{o||m.onData(n)}),(0,D.toDisposable)(()=>o=!0)}t.listenStream=O;function g(a,m){return new Promise((o,n)=>{const r=new D.DisposableStore,e=[],i=f=>{if(e.push(f),e.length>m)return r.dispose(),a.pause(),o({stream:a,buffer:e,ended:!1})},s=f=>n(f),c=()=>o({stream:a,buffer:e,ended:!0});r.add((0,D.toDisposable)(()=>a.removeListener("error",s))),a.on("error",s),r.add((0,D.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),r.add((0,D.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}t.peekStream=g;function P(a,m){const o=L(m);return o.end(a),o}t.toStream=P;function p(){const a=L(()=>{throw new Error("not supported")});return a.end(),a}t.emptyStream=p;function h(a){let m=!1;return{read:()=>m?null:(m=!0,a)}}t.toReadable=h;function l(a,m,o){const n=L(o);return O(a,{onData:r=>n.write(m.data(r)),onError:r=>n.error(m.error?m.error(r):r),onEnd:()=>n.end()}),n}t.transform=l;function d(a,m,o){let n=!1;return{read:()=>{const r=m.read();return n?r:(n=!0,r!==null?o([a,r]):a)}}}t.prefixedReadable=d;function y(a,m,o){let n=!1;const r=L(o);return O(m,{onData:e=>n?r.write(e):(n=!0,r.write(o([a,e]))),onError:e=>r.error(e),onEnd:()=>{n||(n=!0,r.write(a)),r.end()}}),r}t.prefixedStream=y}),define(Q[17],Z([0,1,37]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined";let S,R;class L{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return D?new L(Buffer.allocUnsafe(E)):new L(new Uint8Array(E))}static wrap(E){return D&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new L(E)}static fromString(E,w){return!(w?.dontUseNodeBuffer||!1)&&D?new L(Buffer.from(E)):(S||(S=new TextEncoder),new L(S.encode(E)))}static fromByteArray(E){const w=L.alloc(E.length);for(let T=0,F=E.length;T<F;T++)w.buffer[T]=E[T];return w}static concat(E,w){if(typeof w=="undefined"){w=0;for(let W=0,J=E.length;W<J;W++)w+=E[W].byteLength}const T=L.alloc(w);let F=0;for(let W=0,J=E.length;W<J;W++){const se=E[W];T.set(se,F),F+=se.byteLength}return T}clone(){const E=L.alloc(this.byteLength);return E.set(this),E}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(E,w){return new L(this.buffer.subarray(E,w))}set(E,w){if(E instanceof L)this.buffer.set(E.buffer,w);else if(E instanceof Uint8Array)this.buffer.set(E,w);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),w);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),w);else throw new Error("Unkown argument 'array'")}readUInt32BE(E){return v(this.buffer,E)}writeUInt32BE(E,w){I(this.buffer,E,w)}readUInt32LE(E){return O(this.buffer,E)}writeUInt32LE(E,w){g(this.buffer,E,w)}readUInt8(E){return P(this.buffer,E)}writeUInt8(E,w){p(this.buffer,E,w)}}t.VSBuffer=L;function b(f,E){return f[E+0]<<0>>>0|f[E+1]<<8>>>0}t.readUInt16LE=b;function u(f,E,w){f[w+0]=E&255,E=E>>>8,f[w+1]=E&255}t.writeUInt16LE=u;function v(f,E){return f[E]*2**24+f[E+1]*2**16+f[E+2]*2**8+f[E+3]}t.readUInt32BE=v;function I(f,E,w){f[w+3]=E,E=E>>>8,f[w+2]=E,E=E>>>8,f[w+1]=E,E=E>>>8,f[w]=E}t.writeUInt32BE=I;function O(f,E){return f[E+0]<<0>>>0|f[E+1]<<8>>>0|f[E+2]<<16>>>0|f[E+3]<<24>>>0}t.readUInt32LE=O;function g(f,E,w){f[w+0]=E&255,E=E>>>8,f[w+1]=E&255,E=E>>>8,f[w+2]=E&255,E=E>>>8,f[w+3]=E&255}t.writeUInt32LE=g;function P(f,E){return f[E]}t.readUInt8=P;function p(f,E,w){f[w]=E}t.writeUInt8=p;function h(f){return C.consumeReadable(f,E=>L.concat(E))}t.readableToBuffer=h;function l(f){return C.toReadable(f)}t.bufferToReadable=l;function d(f){return C.consumeStream(f,E=>L.concat(E))}t.streamToBuffer=d;async function y(f){return f.ended?L.concat(f.buffer):L.concat([...f.buffer,await d(f.stream)])}t.bufferedStreamToBuffer=y;function a(f){return C.toStream(f,E=>L.concat(E))}t.bufferToStream=a;function m(f){return C.transform(f,{data:E=>typeof E=="string"?L.fromString(E):L.wrap(E)},E=>L.concat(E))}t.streamToBufferReadableStream=m;function o(f){return C.newWriteableStream(E=>L.concat(E),f)}t.newWriteableBufferStream=o;function n(f,E){return C.prefixedReadable(f,E,w=>L.concat(w))}t.prefixedBufferReadable=n;function r(f,E){return C.prefixedStream(f,E,w=>L.concat(w))}t.prefixedBufferStream=r;function e(f){let E=0,w=0,T=0;const F=new Uint8Array(Math.floor(f.length/4*3)),W=se=>{switch(w){case 3:F[T++]=E|se,w=0;break;case 2:F[T++]=E|se>>>2,E=se<<6,w=3;break;case 1:F[T++]=E|se>>>4,E=se<<4,w=2;break;default:E=se<<2,w=1}};for(let se=0;se<f.length;se++){const ie=f.charCodeAt(se);if(ie>=65&&ie<=90)W(ie-65);else if(ie>=97&&ie<=122)W(ie-97+26);else if(ie>=48&&ie<=57)W(ie-48+52);else if(ie===43||ie===45)W(62);else if(ie===47||ie===95)W(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${f[se]}`)}}const J=T;for(;w>0;)W(0);return L.wrap(F).slice(0,J)}t.decodeBase64=e;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:f},E=!0,w=!1){const T=w?s:i;let F="";const W=f.byteLength%3;let J=0;for(;J<f.byteLength-W;J+=3){const se=f[J+0],ie=f[J+1],te=f[J+2];F+=T[se>>>2],F+=T[(se<<4|ie>>>4)&63],F+=T[(ie<<2|te>>>6)&63],F+=T[te&63]}if(W===1){const se=f[J+0];F+=T[se>>>2],F+=T[se<<4&63],E&&(F+="==")}else if(W===2){const se=f[J+0],ie=f[J+1];F+=T[se>>>2],F+=T[(se<<4|ie>>>4)&63],F+=T[ie<<2&63],E&&(F+="=")}return F}t.encodeBase64=c}),define(Q[58],Z([0,1,26]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function D(d){return S(d,0)}t.hash=D;function S(d,y){switch(typeof d){case"object":return d===null?R(349,y):Array.isArray(d)?u(d,y):v(d,y);case"string":return b(d,y);case"boolean":return L(d,y);case"number":return R(d,y);case"undefined":return R(937,y);default:return R(617,y)}}t.doHash=S;function R(d,y){return(y<<5)-y+d|0}t.numberHash=R;function L(d,y){return R(d?433:863,y)}function b(d,y){y=R(149417,y);for(let a=0,m=d.length;a<m;a++)y=R(d.charCodeAt(a),y);return y}t.stringHash=b;function u(d,y){return y=R(104579,y),d.reduce((a,m)=>S(m,a),y)}function v(d,y){return y=R(181387,y),Object.keys(d).sort().reduce((a,m)=>(a=b(m,a),S(d[m],a)),y)}class I{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=S(y,this._value),this._value}}t.Hasher=I;var O;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function g(d,y,a=32){const m=a-y,o=~((1<<m)-1);return(d<<y|(o&d)>>>m)>>>0}function P(d,y=0,a=d.byteLength,m=0){for(let o=0;o<a;o++)d[y+o]=m}function p(d,y,a="0"){for(;d.length<y;)d=a+d;return d}function h(d,y=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(a=>a.toString(16).padStart(2,"0")).join(""):p((d>>>0).toString(16),y/4)}t.toHexString=h;class l{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const a=y.length;if(a===0)return;const m=this._buff;let o=this._buffLen,n=this._leftoverHighSurrogate,r,e;for(n!==0?(r=n,e=-1,n=0):(r=y.charCodeAt(0),e=0);;){let i=r;if(C.isHighSurrogate(r))if(e+1<a){const s=y.charCodeAt(e+1);C.isLowSurrogate(s)?(e++,i=C.computeCodePoint(r,s)):i=65533}else{n=r;break}else C.isLowSurrogate(r)&&(i=65533);if(o=this._push(m,o,i),e++,e<a)r=y.charCodeAt(e);else break}this._buffLen=o,this._leftoverHighSurrogate=n}_push(y,a,m){return m<128?y[a++]=m:m<2048?(y[a++]=192|(m&1984)>>>6,y[a++]=128|(m&63)>>>0):m<65536?(y[a++]=224|(m&61440)>>>12,y[a++]=128|(m&4032)>>>6,y[a++]=128|(m&63)>>>0):(y[a++]=240|(m&1835008)>>>18,y[a++]=128|(m&258048)>>>12,y[a++]=128|(m&4032)>>>6,y[a++]=128|(m&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,P(this._buff,this._buffLen),this._buffLen>56&&(this._step(),P(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=l._bigBlock32,a=this._buffDV;for(let f=0;f<64;f+=4)y.setUint32(f,a.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)y.setUint32(f,g(y.getUint32(f-12,!1)^y.getUint32(f-32,!1)^y.getUint32(f-56,!1)^y.getUint32(f-64,!1),1),!1);let m=this._h0,o=this._h1,n=this._h2,r=this._h3,e=this._h4,i,s,c;for(let f=0;f<80;f++)f<20?(i=o&n|~o&r,s=1518500249):f<40?(i=o^n^r,s=1859775393):f<60?(i=o&n|o&r|n&r,s=2400959708):(i=o^n^r,s=3395469782),c=g(m,5)+i+e+s+y.getUint32(f*4,!1)&4294967295,e=r,r=n,n=g(o,30),o=m,m=c;this._h0=this._h0+m&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+e&4294967295}}t.StringSHA1=l,l._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[21],Z([0,1,7]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const l=Array.isArray(h)?[]:{};return Object.keys(h).forEach(d=>{h[d]&&typeof h[d]=="object"?l[d]=D(h[d]):l[d]=h[d]}),l}t.deepClone=D;function S(h){if(!h||typeof h!="object")return h;const l=[h];for(;l.length>0;){const d=l.shift();Object.freeze(d);for(const y in d)if(R.call(d,y)){const a=d[y];typeof a=="object"&&!Object.isFrozen(a)&&l.push(a)}}return h}t.deepFreeze=S;const R=Object.prototype.hasOwnProperty;function L(h,l){return b(h,l,new Set)}t.cloneAndChange=L;function b(h,l,d){if((0,C.isUndefinedOrNull)(h))return h;const y=l(h);if(typeof y!="undefined")return y;if((0,C.isArray)(h)){const a=[];for(const m of h)a.push(b(m,l,d));return a}if((0,C.isObject)(h)){if(d.has(h))throw new Error("Cannot clone recursive data-structure");d.add(h);const a={};for(let m in h)R.call(h,m)&&(a[m]=b(h[m],l,d));return d.delete(h),a}return h}function u(h,l,d=!0){return(0,C.isObject)(h)?((0,C.isObject)(l)&&Object.keys(l).forEach(y=>{y in h?d&&((0,C.isObject)(h[y])&&(0,C.isObject)(l[y])?u(h[y],l[y],d):h[y]=l[y]):h[y]=l[y]}),h):l}t.mixin=u;function v(h,l){if(h===l)return!0;if(h==null||l===null||l===void 0||typeof h!=typeof l||typeof h!="object"||Array.isArray(h)!==Array.isArray(l))return!1;let d,y;if(Array.isArray(h)){if(h.length!==l.length)return!1;for(d=0;d<h.length;d++)if(!v(h[d],l[d]))return!1}else{const a=[];for(y in h)a.push(y);a.sort();const m=[];for(y in l)m.push(y);if(m.sort(),!v(a,m))return!1;for(d=0;d<a.length;d++)if(!v(h[a[d]],l[a[d]]))return!1}return!0}t.equals=v;function I(h){const l=new Set;return JSON.stringify(h,(d,y)=>{if((0,C.isObject)(y)||Array.isArray(y)){if(l.has(y))return"[Circular]";l.add(y)}return y})}t.safeStringify=I;function O(h,l,d){const y=l(h);return typeof y=="undefined"?d:y}t.getOrDefault=O;function g(h,l){const d=Object.create(null);return!h||!l||Object.keys(l).forEach(a=>{const m=h[a],o=l[a];v(m,o)||(d[a]=o)}),d}t.distinct=g;function P(h,l){const d=l.toLowerCase(),y=Object.keys(h).find(a=>a.toLowerCase()===d);return y?h[y]:h[l]}t.getCaseInsensitive=P;function p(h,l){const d=Object.create(null);for(const[y,a]of Object.entries(h))l(y,a)&&(d[y]=a);return d}t.filter=p}),define(Q[59],Z([0,1,9]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function D(v){const I=v;return I&&typeof I.type=="string"&&typeof I.severity=="string"}t.isRemoteConsoleLog=D;function S(v){const I=[];let O;try{const g=JSON.parse(v.arguments),P=g[g.length-1];P&&P.__$stack&&(g.pop(),O=P.__$stack),I.push(...g)}catch{I.push("Unable to log remote console arguments",v.arguments)}return{args:I,stack:O}}t.parse=S;function R(v){if(typeof v!="string")return R(S(v).stack);const I=v;if(I){const O=L(I),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(g&&g.length===4)return{uri:C.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=R;function L(v){if(!v)return v;const I=v.indexOf(`
`);return I===-1?v:v.substring(0,I)}function b(v,I){const{args:O,stack:g}=S(v),P=typeof O[0]=="string"&&O.length===1;let p=L(g);p&&(p=`(${p.trim()})`);let h=[];if(typeof O[0]=="string"?p&&P?h=[`%c[${I}] %c${O[0]} %c${p}`,u("blue"),u(""),u("grey")]:h=[`%c[${I}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:h=[`%c[${I}]%`,u("blue"),...O],p&&!P&&h.push(p),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,h)}t.log=b;function u(v){return`color: ${v}`}}),define(Q[60],Z([0,1,17,26,9]),function(z,t,C,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(I){return JSON.stringify(I,u)}t.stringify=R;function L(I){let O=JSON.parse(I);return O=v(O),O}t.parse=L;var b;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext",I[I.Date=14]="Date"})(b=t.MarshalledId||(t.MarshalledId={}));function u(I,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,D.regExpFlags)(O)}:O}function v(I,O=0){if(!I||O>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return S.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof C.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let g=0;g<I.length;++g)I[g]=v(I[g],O+1);else for(const g in I)Object.hasOwnProperty.call(I,g)&&(I[g]=v(I[g],O+1))}return I}t.revive=v}),define(Q[61],Z([0,1,45,10,11,14,18,26,9]),function(z,t,C,D,S,R,L,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function v(i,s,c){if(typeof i=="string"&&(i=u.URI.file(i)),c){const E=c.getWorkspaceFolder(i);if(E){const w=c.getWorkspace().folders.length>1;let T;if((0,L.isEqual)(E.uri,i)?T="":T=(0,L.relativePath)(E.uri,i),w){const F=E.name?E.name:(0,L.basename)(E.uri);T=T?F+" \u2022 "+T:F}return T}}if(i.scheme!==D.Schemas.file&&i.scheme!==D.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(i.fsPath))return(0,S.normalize)(O(i.fsPath));let f=(0,S.normalize)(i.fsPath);return!R.isWindows&&s?.userHome&&(f=P(f,s.userHome.fsPath)),f}t.getPathLabel=v;function I(i){if(!i)return;typeof i=="string"&&(i=u.URI.file(i));const s=(0,L.basename)(i)||(i.scheme===D.Schemas.file?i.fsPath:i.path);return R.isWindows&&(0,C.isRootOrDriveLetter)(s)?O(s):s}t.getBaseLabel=I;function O(i,s){return(0,C.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}t.normalizeDriveLetter=O;let g=Object.create(null);function P(i,s){if(R.isWindows||!i||!s)return i;let c=g.original===s?g.normalized:void 0;return c||(c=`${(0,b.rtrim)(s,S.posix.sep)}${S.posix.sep}`,g={original:s,normalized:c}),(R.isLinux?i.startsWith(c):(0,b.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}t.tildify=P;function p(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}t.untildify=p;const h="\u2026",l="\\\\",d="~";function y(i,s=S.sep){const c=new Array(i.length);let f=!1;for(let E=0;E<i.length;E++){let w=i[E];if(w===""){c[E]=`.${s}`;continue}if(!w){c[E]=w;continue}f=!0;let T="";w.indexOf(l)===0?(T=w.substr(0,w.indexOf(l)+l.length),w=w.substr(w.indexOf(l)+l.length)):w.indexOf(s)===0?(T=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(d)===0&&(T=w.substr(0,w.indexOf(d)+d.length),w=w.substr(w.indexOf(d)+d.length));const F=w.split(s);for(let W=1;f&&W<=F.length;W++)for(let J=F.length-W;f&&J>=0;J--){f=!1;let se=F.slice(J,J+W).join(s);for(let ie=0;!f&&ie<i.length;ie++)if(ie!==E&&i[ie]&&i[ie].indexOf(se)>-1){const te=J+W===F.length,ge=J>0&&i[ie].indexOf(s)>-1?s+se:se,B=i[ie].endsWith(ge);f=!te||B}if(!f){let ie="";(F[0].endsWith(":")||T!=="")&&(J===1&&(J=0,W++,se=F[0]+s+se),J>0&&(ie=F[0]+s),ie=T+ie),J>0&&(ie=ie+h+s),ie=ie+se,J+W<F.length&&(ie=ie+s+h),c[E]=ie}}f&&(c[E]=w)}return c}t.shorten=y;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function m(i,s=Object.create(null)){const c=[];let f=!1,E="";for(const w of i)if(w==="$"||f&&w==="{")E&&c.push({value:E,type:a.TEXT}),E="",f=!0;else if(w==="}"&&f){const T=s[E];if(typeof T=="string")T.length&&c.push({value:T,type:a.VARIABLE});else if(T){const F=c[c.length-1];(!F||F.type!==a.SEPARATOR)&&c.push({value:T.label,type:a.SEPARATOR})}E="",f=!1}else E+=w;return E&&!f&&c.push({value:E,type:a.TEXT}),c.filter((w,T)=>{if(w.type===a.SEPARATOR){const F=c[T-1],W=c[T+1];return[F,W].every(J=>J&&(J.type===a.VARIABLE||J.type===a.TEXT)&&J.value.length>0)}return!0}).map(w=>w.value).join("")}t.template=m;function o(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function n(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}t.mnemonicButtonLabel=n;function r(i){return i.replace(/&/g,"&&")}t.unmnemonicLabel=r;function e(i){const s=i.indexOf("/")!==-1?S.posix:S.win32,c=s.basename(i),f=s.dirname(i);return c.length?{name:c,parentPath:f}:{name:f,parentPath:""}}t.splitName=e}),define(Q[27],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(u){return C.test(u)}t.isUUID=D;const S=new Uint8Array(16),R=[];for(let u=0;u<256;u++)R.push(u.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(u){for(let v=0;v<u.length;v++)u[v]=Math.floor(Math.random()*256);return u};function b(){L(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let u=0,v="";return v+=R[S[u++]],v+=R[S[u++]],v+=R[S[u++]],v+=R[S[u++]],v+="-",v+=R[S[u++]],v+=R[S[u++]],v+="-",v+=R[S[u++]],v+=R[S[u++]],v+="-",v+=R[S[u++]],v+=R[S[u++]],v+="-",v+=R[S[u++]],v+=R[S[u++]],v+=R[S[u++]],v+=R[S[u++]],v+=R[S[u++]],v+=R[S[u++]],v}t.generateUuid=b}),define(Q[62],Z([0,1,129]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class D{constructor(R="utf8"){this.stringDecoder=new C.StringDecoder(R),this.remaining=null}write(R){const L=[],b=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(b.length<1)return L;let u=0,v,I=u;for(;I<b.length;)if(v=b.charCodeAt(I),v===13||v===10){if(L.push(b.substring(u,I)),I++,I<b.length){const O=v;v=b.charCodeAt(I),(O===13&&v===10||O===10&&v===13)&&I++}u=I}else I++;return this.remaining=u<b.length?b.substr(u):null,L}end(){return this.remaining}}t.LineDecoder=D}),define(Q[63],Z([0,1,33,11,15]),function(z,t,C,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,L=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(u||(u={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class O{constructor(o,n,r){this.exePath=o,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:m=!1}={}){return m?v===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:m=!1,findPreview:o=!1}={}){const n=g({useAlternateBitness:m});if(!n)return null;const r=D.join(n,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let e=-1,i=null;for(const f of await S.Promises.readdir(r)){let E=-1;if(o){const T=f.indexOf("-");if(T<0)continue;const F=f.substring(0,T);if(!R.test(F)||f.substring(T+1)!=="preview")continue;E=parseInt(F,10)}else{if(!R.test(f))continue;E=parseInt(f,10)}if(E<=e)continue;const w=D.join(r,f,"pwsh.exe");!await S.SymlinkSupport.existsFile(w)||(i=w,e=E)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",c=o?" Preview":"";return new O(i,`PowerShell${c}${s}`,!0)}async function p({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const o=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=m?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const e of await S.Promises.readdir(o))if(n.test(e)){const i=D.join(o,e,"pwsh.exe");return new O(i,r)}return null}function h(){const m=D.join(C.homedir(),".dotnet","tools","pwsh.exe");return new O(m,".NET Core PowerShell Global Tool")}function l(){const m=D.join(process.env.windir,v===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(m,"Windows PowerShell",!0)}async function*d(){let m=await P();m&&(yield m),m=await P({useAlternateBitness:!0}),m&&(yield m),m=await p(),m&&(yield m),m=h(),m&&(yield m),m=await P({findPreview:!0}),m&&(yield m),m=await p({findPreview:!0}),m&&(yield m),m=await P({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=l(),m&&(yield m)}async function*y(){for await(const m of d())await m.exists()&&(yield m)}t.enumeratePowerShellInstallations=y;async function a(){for await(const m of y())return m;return null}t.getFirstAvailablePowerShellInstallation=a});var ve=this&&this.__decorate||function(z,t,C,D){var S=arguments.length,R=S<3?t:D===null?D=Object.getOwnPropertyDescriptor(t,C):D,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,t,C,D);else for(var b=z.length-1;b>=0;b--)(L=z[b])&&(R=(S<3?L(R):S>3?L(t,C,R):L(t,C))||R);return S>3&&R&&Object.defineProperty(t,C,R),R};define(Q[46],Z([0,1,19,3,17,24,44,6,8,2,60,26,7]),function(z,t,C,D,S,R,L,b,u,v,I,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var P;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(P=t.RequestType||(t.RequestType={}));function p(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function l(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(d||(d={}));class y{constructor(A){this.buffer=A,this.pos=0}read(A){const j=this.buffer.slice(this.pos,this.pos+A);return this.pos+=j.byteLength,j}}class a{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var m;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(m||(m={}));function o(M){const A=S.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function n(M){return M.read(4).readUInt32BE(0)}function r(M){const A=S.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const e={Undefined:r(m.Undefined),String:r(m.String),Buffer:r(m.Buffer),VSBuffer:r(m.VSBuffer),Array:r(m.Array),Object:r(m.Object)},i=typeof Buffer!="undefined";function s(M,A){if(typeof A=="undefined")M.write(e.Undefined);else if(typeof A=="string"){const j=S.VSBuffer.fromString(A);M.write(e.String),M.write(o(j.byteLength)),M.write(j)}else if(i&&Buffer.isBuffer(A)){const j=S.VSBuffer.wrap(A);M.write(e.Buffer),M.write(o(j.byteLength)),M.write(j)}else if(A instanceof S.VSBuffer)M.write(e.VSBuffer),M.write(o(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(e.Array),M.write(o(A.length));for(const j of A)s(M,j)}else{const j=S.VSBuffer.fromString(JSON.stringify(A));M.write(e.Object),M.write(o(j.byteLength)),M.write(j)}}function c(M){switch(M.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return M.read(n(M)).toString();case m.Buffer:return M.read(n(M)).buffer;case m.VSBuffer:return M.read(n(M));case m.Array:{const j=n(M),H=[];for(let ne=0;ne<j;ne++)H.push(c(M));return H}case m.Object:return JSON.parse(M.read(n(M)).toString())}}class f{constructor(A,j,H=null,ne=1e3){this.protocol=A,this.ctx=j,this.logger=H,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(A,j){this.channels.set(A,j),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const j=this.send([A.type]);this.logger&&this.logger.logOutgoing(j,0,1,l(A.type));return}case 201:case 202:case 204:case 203:{const j=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(j,A.id,1,l(A.type),A.data);return}}}send(A,j=void 0){const H=new a;return s(H,A),s(H,j),this.sendBuffer(H.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const j=new y(A),H=c(j),ne=c(j),X=H[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],1,`${p(X)}: ${H[2]}.${H[3]}`,ne),this.onPromise({type:X,id:H[1],channelName:H[2],name:H[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],1,`${p(X)}: ${H[2]}.${H[3]}`,ne),this.onEventListen({type:X,id:H[1],channelName:H[2],name:H[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],1,`${p(X)}`),this.disposeActiveRequest({type:X,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],1,`${p(X)}`),this.disposeActiveRequest({type:X,id:H[1]})}}onPromise(A){const j=this.channels.get(A.channelName);if(!j){this.collectPendingRequest(A);return}const H=new R.CancellationTokenSource;let ne;try{ne=j.call(this.ctx,A.name,A.arg,H.token)}catch(G){ne=Promise.reject(G)}const X=A.id;ne.then(G=>{this.sendResponse({id:X,data:G,type:201}),this.activeRequests.delete(A.id)},G=>{G instanceof Error?this.sendResponse({id:X,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:X,data:G,type:203}),this.activeRequests.delete(A.id)});const ee=(0,v.toDisposable)(()=>H.cancel());this.activeRequests.set(A.id,ee)}onEventListen(A){const j=this.channels.get(A.channelName);if(!j){this.collectPendingRequest(A);return}const H=A.id,X=j.listen(this.ctx,A.name,A.arg)(ee=>this.sendResponse({id:H,data:ee,type:204}));this.activeRequests.set(A.id,X)}disposeActiveRequest(A){const j=this.activeRequests.get(A.id);j&&(j.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let j=this.pendingRequests.get(A.channelName);j||(j=[],this.pendingRequests.set(A.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:A,timeoutTimer:H})}flushPendingRequests(A){const j=this.pendingRequests.get(A);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}t.ChannelServer=f;var E;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(E=t.RequestInitiator||(t.RequestInitiator={}));class w{constructor(A,j=null){this.protocol=A,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(A){const j=this;return{call(H,ne,X){return j.isDisposed?Promise.reject(b.canceled()):j.requestPromise(A,H,ne,X)},listen(H,ne){return j.isDisposed?Promise.reject(b.canceled()):j.requestEvent(A,H,ne)}}}requestPromise(A,j,H,ne=R.CancellationToken.None){const X=this.lastRequestId++,G={id:X,type:100,channelName:A,name:j,arg:H};if(ne.isCancellationRequested)return Promise.reject(b.canceled());let le;return new Promise((N,_)=>{if(ne.isCancellationRequested)return _(b.canceled());const x=()=>{const ce=he=>{switch(he.type){case 201:this.handlers.delete(X),N(he.data);break;case 202:{this.handlers.delete(X);const oe=new Error(he.data.message);oe.stack=he.data.stack,oe.name=he.data.name,_(oe);break}case 203:this.handlers.delete(X),_(he.data);break}};this.handlers.set(X,ce),this.sendRequest(G)};let K=null;this.state===d.Idle?x():(K=(0,D.createCancelablePromise)(ce=>this.whenInitialized()),K.then(()=>{K=null,x()}));const Y=()=>{K?(K.cancel(),K=null):this.sendRequest({id:X,type:101}),_(b.canceled())},de=ne.onCancellationRequested(Y);le=(0,v.combinedDisposable)((0,v.toDisposable)(Y),de),this.activeRequests.add(le)}).finally(()=>{this.activeRequests.delete(le)})}requestEvent(A,j,H){const ne=this.lastRequestId++,ee={id:ne,type:102,channelName:A,name:j,arg:H};let G=null;const le=new u.Emitter({onFirstListenerAdd:()=>{G=(0,D.createCancelablePromise)(N=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(le),this.sendRequest(ee)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(le),this.sendRequest({id:ne,type:103}))}}),U=N=>le.fire(N.data);return this.handlers.set(ne,U),le.event}sendRequest(A){switch(A.type){case 100:case 102:{const j=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(j,A.id,0,`${p(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const j=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(j,A.id,0,p(A.type));return}}}send(A,j=void 0){const H=new a;return s(H,A),s(H,j),this.sendBuffer(H.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const j=new y(A),H=c(j),ne=c(j),X=H[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,l(X)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,H[1],0,l(X),ne),this.onResponse({type:H[0],id:H[1],data:ne})}}onResponse(A){if(A.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(A.id);j&&j(A)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}ve([L.memoize],w.prototype,"onDidInitializePromise",null),t.ChannelClient=w;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:j,onDidClientDisconnect:H})=>{u.Event.once(j.onMessage)(X=>{const ee=new y(X),G=c(ee),le=new f(j,G),U=new w(j);this.channels.forEach((_,x)=>le.registerChannel(x,_));const N={channelServer:le,channelClient:U,ctx:G};this._connections.add(N),this._onDidAddConnection.fire(N),H(()=>{le.dispose(),U.dispose(),this._connections.delete(N),this._onDidRemoveConnection.fire(N)})})})}get connections(){const A=[];return this._connections.forEach(j=>A.push(j)),A}getChannel(A,j){const H=this;return{call(ne,X,ee){let G;if((0,g.isFunction)(j)){let U=(0,C.getRandomElement)(H.connections.filter(j));G=U?Promise.resolve(U):u.Event.toPromise(u.Event.filter(H.onDidAddConnection,j))}else G=j.routeCall(H,ne,X);const le=G.then(U=>U.channelClient.getChannel(A));return W(le).call(ne,X,ee)},listen(ne,X){if((0,g.isFunction)(j))return H.getMulticastEvent(A,j,ne,X);const ee=j.routeEvent(H,ne,X).then(G=>G.channelClient.getChannel(A));return W(ee).listen(ne,X)}}}getMulticastEvent(A,j,H,ne){const X=this;let ee=new v.DisposableStore;const G=new u.Emitter({onFirstListenerAdd:()=>{ee=new v.DisposableStore;const le=new u.EventMultiplexer,U=new Map,N=x=>{const Y=x.channelClient.getChannel(A).listen(H,ne),de=le.add(Y);U.set(x,de)},_=x=>{const K=U.get(x);!K||(K.dispose(),U.delete(x))};X.connections.filter(j).forEach(N),u.Event.filter(X.onDidAddConnection,j)(N,void 0,ee),X.onDidRemoveConnection(_,void 0,ee),le.event(G.fire,G,ee),ee.add(le)},onLastListenerRemove:()=>{ee.dispose()}});return G.event}registerChannel(A,j){this.channels.set(A,j),this._connections.forEach(H=>{H.channelServer.registerChannel(A,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=T;class F{constructor(A,j,H=null){const ne=new a;s(ne,j),A.send(ne.buffer),this.channelClient=new w(A,H),this.channelServer=new f(A,j,H)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,j){this.channelServer.registerChannel(A,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=F;function W(M){return{call(A,j,H){return M.then(ne=>ne.call(A,j,H))},listen(A,j){const H=new u.Relay;return M.then(ne=>H.input=ne.listen(A,j)),H.event}}}t.getDelayedChannel=W;function J(M){let A=!1;return{call(j,H,ne){return A?M.call(j,H,ne):(0,D.timeout)(0).then(()=>A=!0).then(()=>M.call(j,H,ne))},listen(j,H){if(A)return M.listen(j,H);const ne=new u.Relay;return(0,D.timeout)(0).then(()=>A=!0).then(()=>ne.input=M.listen(j,H)),ne.event}}}t.getNextTickChannel=J;class se{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const j of A.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await u.Event.toPromise(A.onDidAddConnection),await this.route(A)}}t.StaticRouter=se;var ie;(function(M){function A(X,ee){const G=X,le=ee&&ee.disableMarshalling,U=new Map;for(const N in G)H(N)&&U.set(N,u.Event.buffer(G[N],!0));return new class{listen(N,_,x){const K=U.get(_);if(K)return K;if(ne(_)){const Y=G[_];if(typeof Y=="function")return Y.call(G,x)}throw new Error(`Event not found: ${_}`)}call(N,_,x){const K=G[_];if(typeof K=="function"){if(!le&&Array.isArray(x))for(let Y=0;Y<x.length;Y++)x[Y]=(0,I.revive)(x[Y]);return K.apply(G,x)}throw new Error(`Method not found: ${_}`)}}}M.fromService=A;function j(X,ee){const G=ee&&ee.disableMarshalling;return new Proxy({},{get(le,U){if(typeof U=="string")return ee?.properties?.has(U)?ee.properties.get(U):ne(U)?function(N){return X.listen(U,N)}:H(U)?X.listen(U):async function(...N){let _;ee&&!(0,g.isUndefinedOrNull)(ee.context)?_=[ee.context,...N]:_=N;const x=await X.call(U,_);return G?x:(0,I.revive)(x)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=j;function H(X){return X[0]==="o"&&X[1]==="n"&&O.isUpperAsciiLetter(X.charCodeAt(2))}function ne(X){return/^onDynamic/.test(X)&&O.isUpperAsciiLetter(X.charCodeAt(9))}})(ie=t.ProxyChannel||(t.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let A=M.toString();if(A!=="[object Object]")return A}return M}function B(M){return Array.isArray(M)?M.map(ge):ge(M)}function $(M,A,j,H,ne,X,ee){ee=B(ee);const G=te[ne],le=G[H%G.length];let U=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${le}`];/\($/.test(X)?(U=U.concat(ee),U.push(")")):U.push(ee),console.log.apply(console,U)}t.logWithColors=$;class re{constructor(A,j){this._outgoingPrefix=A,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,j,H,ne,X){this._totalOutgoing+=A,$(this._outgoingPrefix,this._totalOutgoing,A,j,H,ne,X)}logIncoming(A,j,H,ne,X){this._totalIncoming+=A,$(this._incomingPrefix,this._totalIncoming,A,j,H,ne,X)}}t.IPCLogger=re}),define(Q[64],Z([0,1,3,8,2,7]),function(z,t,C,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var L;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=t.StorageHint||(t.StorageHint={}));function b(O){const g=O;return g?.changed instanceof Map||g?.deleted instanceof Set}t.isStorageItemsChangeEvent=b;var u;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(u||(u={}));class v extends S.Disposable{constructor(g,P=Object.create(null)){super();this.database=g,this.options=P,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((P,p)=>this.accept(p,P)),g.deleted?.forEach(P=>this.accept(P,void 0))}accept(g,P){if(this.state===u.Closed)return;let p=!1;(0,R.isUndefinedOrNull)(P)?p=this.cache.delete(g):this.cache.get(g)!==P&&(this.cache.set(g,P),p=!0),p&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,P){const p=this.cache.get(g);return(0,R.isUndefinedOrNull)(p)?P:p}getBoolean(g,P){const p=this.get(g);return(0,R.isUndefinedOrNull)(p)?P:p==="true"}getNumber(g,P){const p=this.get(g);return(0,R.isUndefinedOrNull)(p)?P:parseInt(p,10)}async set(g,P){if(this.state===u.Closed)return;if((0,R.isUndefinedOrNull)(P))return this.delete(g);const p=String(P);if(this.cache.get(g)!==p)return this.cache.set(g,p),this.pendingInserts.set(g,p),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===u.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((P,p)=>this.items.set(p,P)),g.delete&&g.delete.forEach(P=>this.items.delete(P))}async close(){}}t.InMemoryStorageDatabase=I}),define(Q[65],Z([4,5]),function(z,t){return z.create("vs/base/common/date",t)}),define(Q[66],Z([0,1,65]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const D=60,S=D*60,R=S*24,L=R*7,b=R*30,u=R*365;function v(O,g,P){typeof O!="number"&&(O=O.getTime());const p=Math.round((new Date().getTime()-O)/1e3);if(p<-30)return(0,C.localize)(0,null,v(new Date().getTime()+p*1e3,!1));if(p<30)return(0,C.localize)(1,null);let h;return p<D?(h=p,g?h===1?P?(0,C.localize)(2,null,h):(0,C.localize)(3,null,h):P?(0,C.localize)(4,null,h):(0,C.localize)(5,null,h):h===1?P?(0,C.localize)(6,null,h):(0,C.localize)(7,null,h):P?(0,C.localize)(8,null,h):(0,C.localize)(9,null,h)):p<S?(h=Math.floor(p/D),g?h===1?P?(0,C.localize)(10,null,h):(0,C.localize)(11,null,h):P?(0,C.localize)(12,null,h):(0,C.localize)(13,null,h):h===1?P?(0,C.localize)(14,null,h):(0,C.localize)(15,null,h):P?(0,C.localize)(16,null,h):(0,C.localize)(17,null,h)):p<R?(h=Math.floor(p/S),g?h===1?P?(0,C.localize)(18,null,h):(0,C.localize)(19,null,h):P?(0,C.localize)(20,null,h):(0,C.localize)(21,null,h):h===1?P?(0,C.localize)(22,null,h):(0,C.localize)(23,null,h):P?(0,C.localize)(24,null,h):(0,C.localize)(25,null,h)):p<L?(h=Math.floor(p/R),g?h===1?(0,C.localize)(26,null,h):(0,C.localize)(27,null,h):h===1?(0,C.localize)(28,null,h):(0,C.localize)(29,null,h)):p<b?(h=Math.floor(p/L),g?h===1?P?(0,C.localize)(30,null,h):(0,C.localize)(31,null,h):P?(0,C.localize)(32,null,h):(0,C.localize)(33,null,h):h===1?P?(0,C.localize)(34,null,h):(0,C.localize)(35,null,h):P?(0,C.localize)(36,null,h):(0,C.localize)(37,null,h)):p<u?(h=Math.floor(p/b),g?h===1?P?(0,C.localize)(38,null,h):(0,C.localize)(39,null,h):P?(0,C.localize)(40,null,h):(0,C.localize)(41,null,h):h===1?P?(0,C.localize)(42,null,h):(0,C.localize)(43,null,h):P?(0,C.localize)(44,null,h):(0,C.localize)(45,null,h)):(h=Math.floor(p/u),g?h===1?P?(0,C.localize)(46,null,h):(0,C.localize)(47,null,h):P?(0,C.localize)(48,null,h):(0,C.localize)(49,null,h):h===1?P?(0,C.localize)(50,null,h):(0,C.localize)(51,null,h):P?(0,C.localize)(52,null,h):(0,C.localize)(53,null,h))}t.fromNow=v;function I(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=I}),define(Q[67],Z([4,5]),function(z,t){return z.create("vs/base/common/errorMessage",t)}),define(Q[28],Z([0,1,19,7,67]),function(z,t,C,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function R(v,I){return I&&(v.stack||v.stacktrace)?S.localize(0,null,b(v),L(v.stack)||L(v.stacktrace)):b(v)}function L(v){return Array.isArray(v)?v.join(`
`):v}function b(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?S.localize(1,null,v.message):v.message||S.localize(2,null)}function u(v=null,I=!1){if(!v)return S.localize(3,null);if(Array.isArray(v)){const O=C.coalesce(v),g=u(O[0],I);return O.length>1?S.localize(4,null,g,O.length):g}if(D.isString(v))return v;if(v.detail){const O=v.detail;if(O.error)return R(O.error,I);if(O.exception)return R(O.exception,I)}return v.stack?R(v,I):v.message?v.message:S.localize(5,null)}t.toErrorMessage=u}),define(Q[68],Z([4,5]),function(z,t){return z.create("vs/base/node/processes",t)}),define(Q[47],Z([0,1,38,45,10,21,11,14,29,56,7,62,15,68]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return v.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return v.TerminateResponseCode}});function p(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(n,r){if(b.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const i=C.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],e);return new Promise(s=>{i.once("error",c=>{s({success:!1,error:c})}),i.once("exit",(c,f)=>{s(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?p(e.status):1})}else if(b.isLinux||b.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(i=>{C.execFile(e,[n.pid.toString()],{encoding:"utf8",shell:!0},(s,c,f)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function l(n){!n||(delete n.DEBUG,b.isMacintosh&&delete n.DYLD_LIBRARY_PATH,b.isLinux&&delete n.LD_PRELOAD)}t.removeDangerousEnvVariables=l;function d(n=u.env){return n.comspec||"cmd.exe"}t.getWindowsShell=d;class y{constructor(r,e,i,s){if(e!==void 0&&i!==void 0&&s!==void 0)this.cmd=r,this.args=e,this.shell=i,this.options=s;else{const c=r;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(u.env).forEach(f=>{c[f]=u.env[f]}),Object.keys(this.options.env).forEach(f=>{c[f]=this.options.env[f]}),this.options.env=c}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(L.sep);return e!==-1&&(r=r.substring(e+1)),y.WellKnowCommands[r]?r:"other"}start(r){return b.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(u.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(e=>{let i,s;const c=new Promise((f,E)=>{i=f,s=E});if(e){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=C.exec(f,this.options,(E,w,T)=>{this.childProcess=null;const F=E;F&&F.killed?s({killed:this.terminateRequested,stdout:w.toString(),stderr:T.toString()}):this.handleExec(i,r,E,w,T)})}else{let f=null;const E=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,i,r,s);const T={terminated:this.terminateRequested};I.isNumber(w)&&(T.cmdCode=w),i(T)};if(this.shell&&b.isWindows){const w=R.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let T=!1,F=!1;const W=[];let J=this.ensureQuotes(this.cmd);W.push(J.value),T=J.quoted,this.args&&this.args.forEach(ie=>{J=this.ensureQuotes(ie),W.push(J.value),F=F&&J.quoted});const se=["/s","/c"];T?F?se.push('"'+W.join(" ")+'"'):W.length>1?se.push('"'+W[0]+'" '+W.slice(1).join(" ")):se.push('"'+W[0]+'"'):se.push(W.join(" ")),f=C.spawn(d(),se,w)}else this.cmd&&(f=C.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(I.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",w=>{this.childProcess=null,s({terminated:this.terminateRequested,error:w})}),f.pid&&(this.childProcess.on("close",E),this.handleSpawn(f,i,r,s,!0)))}return c})}handleClose(r,e,i,s){}ensureQuotes(r){return y.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,h(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!b.isWindows)return r(!1);const e=C.spawn(d(),["/s","/c"]);e.on("error",i=>r(!0)),e.on("exit",i=>r(!1))})}}t.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class a extends y{constructor(r,e,i,s){super(r,e,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,i,s,c){[s,c].forEach((f,E)=>{const w=new O.LineDecoder;w.write(f).forEach(W=>{e({line:W,source:E===0?0:1})});const F=w.end();F&&e({line:F,source:E===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,e,i,s,c){const f=new O.LineDecoder,E=new O.LineDecoder;r.stdout.on("data",w=>{f.write(w).forEach(F=>i({line:F,source:0}))}),r.stderr.on("data",w=>{E.write(w).forEach(F=>i({line:F,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=E}handleClose(r,e,i,s){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&i({line:c,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&i({line:f,source:1})}}t.LineProcess=a;function m(n){let r=[],e=!1;const i=function(s){if(e){r.push(s);return}(!n.send(s,f=>{if(f&&console.error(f),e=!1,r.length>0){const E=r.slice(0);r=[],E.forEach(w=>i(w))}})||b.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=m;var o;(function(n){async function r(e,i,s){if(L.isAbsolute(e))return e;if(i===void 0&&(i=u.cwd()),L.dirname(e)!=="."||(s===void 0&&I.isString(u.env.PATH)&&(s=u.env.PATH.split(L.delimiter)),s===void 0||s.length===0))return L.join(i,e);async function f(E){if(await g.Promises.exists(E)){let w;try{w=await g.Promises.stat(E)}catch(T){T.message.startsWith("EACCES")&&(w=await g.Promises.lstat(E))}return w?!w.isDirectory():!1}return!1}for(let E of s){let w;if(L.isAbsolute(E)?w=L.join(E,e):w=L.join(i,E,e),await f(w))return w;let T=w+".com";if(await f(T)||(T=w+".exe",await f(T)))return T}return L.join(i,e)}n.findExecutable=r})(o=t.win32||(t.win32={}))}),define(Q[69],Z([0,1,33,14,63,47]),function(z,t,C,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function L(P,p){return P===1?D.isWindows?O():R.getWindowsShell(p):v(P,p)}t.getSystemShell=L;function b(P,p){return P===1?D.isWindows?g(p):R.getWindowsShell(p):v(P,p)}t.getSystemShellSync=b;let u=null;function v(P,p){if(D.isLinux&&P===2||D.isMacintosh&&P===3)return"/bin/bash";if(!u){let h;if(D.isWindows)h="/bin/bash";else{if(h=p.SHELL,!h)try{h=(0,C.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}u=h}return u}let I=null;async function O(){return I||(I=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),I}function g(P){if(I)return I;const p=D.isWindows&&parseFloat((0,C.release)())>=10,h=P.hasOwnProperty("PROCESSOR_ARCHITEW6432"),l=`${P.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return p?l:R.getWindowsShell(P)}}),define(Q[70],Z([0,1,38,3,17,24,59,6,8,2,21,47,46]),function(z,t,C,D,S,R,L,b,u,v,I,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class P extends g.ChannelServer{constructor(l){super({send:d=>{try{process.send&&process.send(d.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",d=>S.VSBuffer.wrap(Buffer.from(d,"base64")))},l);process.once("disconnect",()=>this.dispose())}}t.Server=P;class p{constructor(l,d){this.modulePath=l,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new D.Delayer(y),this.child=null,this._client=null}getChannel(l){const d=this;return{call(y,a,m){return d.requestPromise(l,y,a,m)},listen(y,a){return d.requestEvent(l,y,a)}}}requestPromise(l,d,y,a=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const m=this.getCachedChannel(l),o=(0,D.createCancelablePromise)(e=>m.call(d,y,e)),n=a.onCancellationRequested(()=>o.cancel()),r=(0,v.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(l,d,y){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let a;const m=new u.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(l).listen(d,y)(m.fire,m),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return m.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,O.removeDangerousEnvVariables)(d.env),this.child=(0,C.fork)(this.modulePath,l,d);const y=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,L.isRemoteConsoleLog)(i)){(0,L.log)(i,`IPC Library: ${this.options.serverName}`);return}y.fire(S.VSBuffer.wrap(Buffer.from(i,"base64")))});const m=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,o=i=>this.child&&this.child.connected&&m.send(i.buffer.toString("base64")),n=y.event,r={send:o,onMessage:n};this._client=new g.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(c=>(0,v.dispose)(c)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(l){let d=this.channels.get(l);return d||(d=this.client.getChannel(l),this.channels.set(l,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=p}),define(Q[71],Z([4,5]),function(z,t){return z.create("vs/base/node/zip",t)}),define(Q[72],Z([4,5]),function(z,t){return z.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[73],Z([4,5]),function(z,t){return z.create("vs/platform/environment/node/shellEnv",t)}),define(Q[74],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Q[75],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],Z([4,5]),function(z,t){return z.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],Z([4,5]),function(z,t){return z.create("vs/platform/files/common/fileService",t)}),define(Q[82],Z([4,5]),function(z,t){return z.create("vs/platform/files/common/io",t)}),define(Q[83],Z([4,5]),function(z,t){return z.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],Z([4,5]),function(z,t){return z.create("vs/platform/request/common/request",t)}),define(Q[85],Z([4,5]),function(z,t){return z.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[86],Z([0,1,66,44,10,11,29,18,9]),function(z,t,C,D,S,R,L,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class v{constructor(h,l,d){this._args=h,this.paths=l,this.productService=d}get appRoot(){return(0,R.dirname)(S.FileAccess.asFileUri("",z).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(u.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return u.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return u.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=L.env.VSCODE_PORTABLE;return h?u.URI.file((0,R.join)(h,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,R.resolve)(h):(0,R.normalize)((0,R.join)(S.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,R.resolve)(h):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,R.resolve)(h);const l=L.env.VSCODE_EXTENSIONS;if(l)return l;const d=L.env.VSCODE_PORTABLE;return d?(0,R.join)(d,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(l=>/^[^:/?#]+?:\/\//.test(l)?u.URI.parse(l):u.URI.file((0,R.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?u.URI.parse(h):u.URI.file((0,R.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ve([D.memoize],v.prototype,"appRoot",null),ve([D.memoize],v.prototype,"userHome",null),ve([D.memoize],v.prototype,"userDataPath",null),ve([D.memoize],v.prototype,"appSettingsHome",null),ve([D.memoize],v.prototype,"tmpDir",null),ve([D.memoize],v.prototype,"cacheHome",null),ve([D.memoize],v.prototype,"userRoamingDataHome",null),ve([D.memoize],v.prototype,"settingsResource",null),ve([D.memoize],v.prototype,"userDataSyncHome",null),ve([D.memoize],v.prototype,"userDataSyncLogResource",null),ve([D.memoize],v.prototype,"sync",null),ve([D.memoize],v.prototype,"machineSettingsResource",null),ve([D.memoize],v.prototype,"globalStorageHome",null),ve([D.memoize],v.prototype,"workspaceStorageHome",null),ve([D.memoize],v.prototype,"keybindingsResource",null),ve([D.memoize],v.prototype,"keyboardLayoutResource",null),ve([D.memoize],v.prototype,"argvResource",null),ve([D.memoize],v.prototype,"snippetsHome",null),ve([D.memoize],v.prototype,"isExtensionDevelopment",null),ve([D.memoize],v.prototype,"untitledWorkspacesHome",null),ve([D.memoize],v.prototype,"installSourcePath",null),ve([D.memoize],v.prototype,"builtinExtensionsPath",null),ve([D.memoize],v.prototype,"extensionsPath",null),ve([D.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ve([D.memoize],v.prototype,"extensionDevelopmentKind",null),ve([D.memoize],v.prototype,"extensionTestsLocationURI",null),ve([D.memoize],v.prototype,"debugExtensionHost",null),ve([D.memoize],v.prototype,"serviceMachineIdResource",null),ve([D.memoize],v.prototype,"telemetryLogResource",null),ve([D.memoize],v.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=v;function I(p,h){return P(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId,p.extensionEnvironment)}t.parseExtensionHostPort=I;function O(p,h){return P(p["inspect-search"],p["inspect-brk-search"],5876,h,p.extensionEnvironment)}t.parseSearchPort=O;function g(p,h){return P(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,h,p.extensionEnvironment)}t.parsePtyHostPort=g;function P(p,h,l,d,y,a){const o=Number(h||p)||(d?null:l),n=o?Boolean(!!h):!1;let r;if(a)try{r=JSON.parse(a)}catch{}return{port:o,break:n,debugId:y,env:r}}}),function(){"use strict";function z(t,C,D,S){function R(b){const u=L(b),v=[u];return t.isAbsolute(u)||v.unshift(S),t.resolve(...v)}function L(b){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return t.join(v,D);const I=b["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=t.join(O,"AppData","Roaming")}break;case"darwin":v=t.join(C.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(v,D)}return{getUserDataPath:R}}if(typeof define=="function")define(Q[87],Z([0,130,33,10,18,29]),function(t,C,D,S,R,L){const b=R.dirname(S.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(R.joinPath(b,"package.json").fsPath);return z(C,D,u.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),C=require("path"),D=require("os");module.exports=z(C,D,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[88],Z([0,1,33,86,87]),function(z,t,C,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends D.AbstractNativeEnvironmentService{constructor(b,u){super(b,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,S.getUserDataPath)(b)},u)}}t.NativeEnvironmentService=R}),define(Q[89],Z([0,1,21]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function S(R,L){const b=u=>{if(typeof u!="string")return;const v=D.exec(u);if(!v)return;const I=L[v[1]]??u;return typeof I=="string"?I:typeof I.message=="string"?I.message:u};return(0,C.cloneAndChange)(R,b)}t.localizeManifest=S}),define(Q[48],Z([0,1,80]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function R(g){return g=g.trim(),g==="*"||D.test(g)}t.isValidVersionStr=R;function L(g){if(!R(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let P=g.match(D);return P?{hasCaret:P[1]==="^",hasGreaterEquals:P[1]===">=",majorBase:P[2]==="x"?0:parseInt(P[2],10),majorMustEqual:P[2]!=="x",minorBase:P[4]==="x"?0:parseInt(P[4],10),minorMustEqual:P[4]!=="x",patchBase:P[6]==="x"?0:parseInt(P[6],10),patchMustEqual:P[6]!=="x",preRelease:P[8]||null}:null}t.parseVersion=L;function b(g){if(!g)return null;let P=g.majorBase,p=g.majorMustEqual,h=g.minorBase,l=g.minorMustEqual,d=g.patchBase,y=g.patchMustEqual;g.hasCaret&&(P===0||(l=!1),y=!1);let a=0;if(g.preRelease){const m=S.exec(g.preRelease);if(m){const[,o,n,r]=m;a=Date.UTC(Number(o),Number(n)-1,Number(r))}}return{majorBase:P,majorMustEqual:p,minorBase:h,minorMustEqual:l,patchBase:d,patchMustEqual:y,isMinimum:g.hasGreaterEquals,notBefore:a}}t.normalizeVersion=b;function u(g,P,p){let h;typeof g=="string"?h=b(L(g)):h=g;let l;P instanceof Date?l=P.getTime():typeof P=="string"&&(l=new Date(P).getTime());let d;if(typeof p=="string"?d=b(L(p)):d=p,!h||!d)return!1;let y=h.majorBase,a=h.minorBase,m=h.patchBase,o=d.majorBase,n=d.minorBase,r=d.patchBase,e=d.notBefore,i=d.majorMustEqual,s=d.minorMustEqual,c=d.patchMustEqual;return d.isMinimum?y>o?!0:y<o?!1:a>n?!0:a<n||l&&l<e?!1:m>=r:(y===1&&o===0&&(!i||!s||!c)&&(o=1,n=0,r=0,i=!0,s=!1,c=!1),y<o?!1:y>o?!i:a<n?!1:a>n?!s:m<r?!1:m>r?!c:!(l&&l<e))}t.isValidVersion=u;function v(g,P,p,h){return p.isBuiltin||typeof p.main=="undefined"?!0:O(g,P,p.engines.vscode,h)}t.isValidExtensionVersion=v;function I(g,P,p){return g==="*"||O(P,p,g)}t.isEngineValid=I;function O(g,P,p,h=[]){let l=b(L(p));if(!l)return h.push(C.localize(0,null,p)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return h.push(C.localize(1,null,p)),!1}else if(!l.majorMustEqual)return h.push(C.localize(2,null,p)),!1;return u(g,P,l)?!0:(h.push(C.localize(3,null,g,p)),!1)}}),define(Q[39],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(S,R=[],L=!1){this.ctor=S,this.staticArguments=R,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=C}),define(Q[90],Z([0,1,39]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const D=[];function S(L,b,u){b instanceof C.SyncDescriptor||(b=new C.SyncDescriptor(b,[],u)),D.push([L,b])}t.registerSingleton=S;function R(){return D}t.getSingletonServiceDescriptors=R}),define(Q[91],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=C;class D{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let L of this._nodes.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const b=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(L);b.outgoing.set(this._hashFn(L),u),u.incoming.set(this._hashFn(R),b)}removeNode(R){const L=this._hashFn(R);this._nodes.delete(L);for(let b of this._nodes.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(R){const L=this._hashFn(R);let b=this._nodes.get(L);return b||(b=new C(R),this._nodes.set(L,b)),b}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[L,b]of this._nodes)R.push(`${L}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,L]of this._nodes){const b=new Set([R]),u=this._findCycle(L,b);if(u)return u}}_findCycle(R,L){for(let[b,u]of R.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const v=this._findCycle(u,L);if(v)return v;L.delete(b)}}}t.Graph=D}),define(Q[25],Z([0,1,7,9,12]),function(z,t,C,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,S.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}t.isConfigurationOverrides=R;function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||C.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}t.isConfigurationUpdateOverrides=L;var b;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(b=t.ConfigurationTarget||(t.ConfigurationTarget={}));function u(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=u;function v(l,d){const y=Object.create(null);for(let a in l)I(y,a,l[a],d);return y}t.toValuesTree=v;function I(l,d,y,a){const m=d.split("."),o=m.pop();let n=l;for(let r=0;r<m.length;r++){let e=m[r],i=n[e];switch(typeof i){case"undefined":i=n[e]=Object.create(null);break;case"object":break;default:a(`Ignoring ${d} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[o]=y}catch{a(`Ignoring ${d} as ${m.join(".")} is ${JSON.stringify(n)}`)}else a(`Ignoring ${d} as ${m.join(".")} is ${JSON.stringify(n)}`)}t.addToValueTree=I;function O(l,d){const y=d.split(".");g(l,y)}t.removeFromValueTree=O;function g(l,d){const y=d.shift();if(d.length===0){delete l[y];return}if(Object.keys(l).indexOf(y)!==-1){const a=l[y];typeof a=="object"&&!Array.isArray(a)&&(g(a,d),Object.keys(a).length===0&&delete l[y])}}function P(l,d,y){function a(n,r){let e=n;for(const i of r){if(typeof e!="object"||e===null)return;e=e[i]}return e}const m=d.split("."),o=a(l,m);return typeof o=="undefined"?y:o}t.getConfigurationValue=P;function p(l,d,y){Object.keys(d).forEach(a=>{a!=="__proto__"&&(a in l?C.isObject(l[a])&&C.isObject(d[a])?p(l[a],d[a],y):y&&(l[a]=d[a]):l[a]=d[a])})}t.merge=p;function h(l,d,y){const a=l.inspect(d),m=l.inspect(y);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}t.getMigratedSettingValue=h}),define(Q[49],Z([0,1,12]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Q[20],Z([0,1,12]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[22],Z([0,1,10,75,12]),function(z,t,C,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var R;(function(a){a.WIN32_X64="win32-x64",a.WIN32_IA32="win32-ia32",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(R=t.TargetPlatform||(t.TargetPlatform={}));function L(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=L;function b(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=b;function u(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=u;function v(a,m){return m==="web"&&!a.includes("web")}t.isNotWebExtensionInWebTargetPlatform=v;function I(a,m,o){return v(m,o)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===o?!0:O(o).includes(a)}t.isTargetPlatformCompatible=I;function O(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=O;function g(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}t.isIExtensionIdentifier=g;var P;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(P=t.SortBy||(t.SortBy={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p=t.SortOrder||(t.SortOrder={}));var h;(function(a){a.Install="install",a.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var l;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(l=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService");var d;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(d=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class y extends Error{constructor(m,o){super(m);this.code=o,this.name=o}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(Q[92],Z([0,1,38,11,73,24,28,6,14,27,69,131,3]),function(z,t,C,D,S,R,L,b,u,v,I,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const P=1e4;let p;async function h(d,y,a){return y["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.isLaunchedFromCli)(a)&&!y["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.isLaunchedFromCli)(a)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=g.Promises.withAsyncBody(async(m,o)=>{const n=new R.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),o(new Error((0,S.localize)(0,null)))},P);try{m(await l(d,n.token))}catch(e){!(0,b.isCancellationError)(e)&&!n.token.isCancellationRequested?o(new Error((0,S.localize)(1,null,(0,L.toErrorMessage)(e)))):m({})}finally{clearTimeout(r),n.dispose()}})),p)}t.getResolvedShellEnv=h;async function l(d,y){const a=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",a);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",m);const o=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",r);const e=await(0,I.getSystemShell)(u.OS,r);return d.trace("getUnixShellEnvironment#shell",e),new Promise((i,s)=>{if(y.isCancellationRequested)return s((0,b.canceled)());const c=(0,D.basename)(e);let f,E;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(f=`& '${process.execPath}' ${w} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,E=["-Login","-Command"]):(f=`'${process.execPath}' ${w} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,c==="tcsh"?E=["-ic"]:E=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),f);const T=(0,C.spawn)(e,[...E,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});y.onCancellationRequested(()=>(T.kill(),s((0,b.canceled)()))),T.on("error",J=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(J)),s(J)});const F=[];T.stdout.on("data",J=>F.push(J));const W=[];T.stderr.on("data",J=>W.push(J)),T.on("close",(J,se)=>{const ie=Buffer.concat(F).toString("utf8");d.trace("getUnixShellEnvironment#raw",ie);const te=Buffer.concat(W).toString("utf8");if(te.trim()&&d.trace("getUnixShellEnvironment#stderr",te),J||se)return s(new Error((0,S.localize)(2,null,J,se)));const ge=n.exec(ie),B=ge?ge[1]:"{}";try{const $=JSON.parse(B);a?$.ELECTRON_RUN_AS_NODE=a:delete $.ELECTRON_RUN_AS_NODE,m?$.ELECTRON_NO_ATTACH_CONSOLE=m:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",$),i($)}catch($){d.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)($)),s($)}})})}}),define(Q[50],Z([0,1,17,6,82,16]),function(z,t,C,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(I,O,g,P,p,h){let l;try{await b(I,O,g,P,p,h)}catch(d){l=d}finally{l&&p.errorTransformer&&(l=p.errorTransformer(l)),typeof l!="undefined"&&g.error(l),g.end()}}t.readFileIntoStream=L;async function b(I,O,g,P,p,h){u(h);const l=await I.open(O,{create:!1});try{u(h);let d=0,y=0,a=p&&typeof p.length=="number"?p.length:void 0,m=C.VSBuffer.alloc(Math.min(p.bufferSize,typeof a=="number"?a:p.bufferSize)),o=p&&typeof p.position=="number"?p.position:0,n=0;do y=await I.read(l,o,m.buffer,n,m.byteLength-n),o+=y,n+=y,d+=y,typeof a=="number"&&(a-=y),n===m.byteLength&&(await g.write(P(m)),m=C.VSBuffer.alloc(Math.min(p.bufferSize,typeof a=="number"?a:p.bufferSize)),n=0);while(y>0&&(typeof a!="number"||a>0)&&u(h)&&v(d,p));if(n>0){let r=n;typeof a=="number"&&(r=Math.min(n,a)),g.write(P(m.slice(0,r)))}}catch(d){throw(0,R.ensureFileSystemProviderError)(d)}finally{await I.close(l)}}function u(I){if(I.isCancellationRequested)throw(0,D.canceled)();return!0}function v(I,O){if(O?.limits){if(typeof O.limits.memory=="number"&&I>O.limits.memory)throw(0,R.createFileSystemProviderError)((0,S.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof O.limits.size=="number"&&I>O.limits.size)throw(0,R.createFileSystemProviderError)((0,S.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[93],Z([0,1,10,46,70,94]),function(z,t,C,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParcelWatcherClient=void 0;class L extends R.AbstractRecursiveWatcherClient{constructor(u,v,I){super(u,v,I);this.init()}createWatcher(u){const v=u.add(new S.Client(C.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(v.onDidProcessExit(({code:I,signal:O})=>this.onError(`terminated by itself with code ${I}, signal: ${O}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(v.getChannel("watcher")))}}t.ParcelWatcherClient=L}),define(Q[51],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...S){this._entries=new Map;for(let[R,L]of S)this.set(R,L)}set(S,R){const L=this._entries.get(S);return this._entries.set(S,R),L}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=C}),define(Q[95],Z([0,1,3,6,39,91,12,51]),function(z,t,C,D,S,R,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class v extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class I{constructor(p=new b.ServiceCollection,h=!1,l){this._activeInstantiations=new Set,this._services=p,this._strict=h,this._parent=l,this._services.set(L.IInstantiationService,this)}createChild(p){return new I(p,this._strict,this)}invokeFunction(p,...h){let l=g.traceInvocation(p),d=!1;try{return p({get:a=>{if(d)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(a,l);if(!m)throw new Error(`[invokeFunction] unknown service '${a}'`);return m}},...h)}finally{d=!0,l.stop()}}createInstance(p,...h){let l,d;return p instanceof S.SyncDescriptor?(l=g.traceCreation(p.ctor),d=this._createInstance(p.ctor,p.staticArguments.concat(h),l)):(l=g.traceCreation(p),d=this._createInstance(p,h,l)),l.stop(),d}_createInstance(p,h=[],l){let d=L._util.getServiceDependencies(p).sort((m,o)=>m.index-o.index),y=[];for(const m of d){let o=this._getOrCreateServiceInstance(m.id,l);if(!o&&this._strict&&!m.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${m.id}.`);y.push(o)}let a=d.length>0?d[0].index:h.length;if(h.length!==a){console.warn(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${h.length} static arguments`);let m=a-h.length;m>0?h=h.concat(new Array(m)):h=h.slice(0,a)}return new p(...[...h,...y])}_setServiceInstance(p,h){if(this._services.get(p)instanceof S.SyncDescriptor)this._services.set(p,h);else if(this._parent)this._parent._setServiceInstance(p,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let h=this._services.get(p);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):h}_getOrCreateServiceInstance(p,h){let l=this._getServiceInstanceOrDescriptor(p);return l instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,l,h.branch(p,!0)):(h.branch(p,!1),l)}_safeCreateAndCacheServiceInstance(p,h,l){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,h,l)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,h,l){const d=new R.Graph(m=>m.id.toString());let y=0;const a=[{id:p,desc:h,_trace:l}];for(;a.length;){const m=a.pop();if(d.lookupOrInsertNode(m),y++>1e3)throw new v(d);for(let o of L._util.getServiceDependencies(m.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(o.id);if(!n&&!o.optional&&console.warn(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`),n instanceof S.SyncDescriptor){const r={id:o.id,desc:n,_trace:m._trace.branch(o.id,!0)};d.insertEdge(m,r),a.push(r)}}}for(;;){const m=d.roots();if(m.length===0){if(!d.isEmpty())throw new v(d);break}for(const{data:o}of m){if(this._getServiceInstanceOrDescriptor(o.id)instanceof S.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}d.removeNode(o)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,h,l=[],d,y){if(this._services.get(p)instanceof S.SyncDescriptor)return this._createServiceInstance(h,l,d,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,h,l,d,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(p,h=[],l,d){if(l){const y=new C.IdleValue(()=>this._createInstance(p,h,d));return new Proxy(Object.create(null),{get(a,m){if(m in a)return a[m];let o=y.value,n=o[m];return typeof n!="function"||(n=n.bind(o),a[m]=n),n},set(a,m,o){return y.value[m]=o,!0}})}else return this._createInstance(p,h,d)}}t.InstantiationService=I;var O;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(O||(O={}));class g{constructor(p,h){this.type=p,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return u?new g(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(p){return u?new g(0,p.name):g._None}branch(p,h){let l=new g(2,p.toString());return this._dep.push([p,h,l]),l}stop(){let p=Date.now()-this._start;g._totals+=p;let h=!1;function l(y,a){let m=[],o=new Array(y+1).join("	");for(const[n,r,e]of a._dep)if(r&&e){h=!0,m.push(`${o}CREATES -> ${n}`);let i=l(y+1,e);i&&m.push(i)}else m.push(`${o}uses -> ${n}`);return m.join(`
`)}let d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(p>2||h)&&console.log(d.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Q[52],Z([0,1,12]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,C.createDecorator)("localizationsService");function D(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const R of S.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=D}),define(Q[13],Z([0,1,28,8,2,14,12]),function(z,t,C,D,S,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,L.createDecorator)("logService"),t.ILoggerService=(0,L.createDecorator)("loggerService");function b(){return new Date().toISOString()}var u;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;function v(r,e,i){switch(e){case u.Trace:r.trace(i);break;case u.Debug:r.debug(i);break;case u.Info:r.info(i);break;case u.Warning:r.warn(i);break;case u.Error:r.error(i);break;case u.Critical:r.critical(i);break;default:throw new Error("Invalid log level")}}t.log=v;function I(r){let e="";for(let i=0;i<r.length;i++){let s=r[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}e+=(i>0?" ":"")+s}return e}t.format=I;class O extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=O;class g extends O{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,I([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,I([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,I([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,I([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(u.Error,I(s))}else this.log(u.Error,I([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,I([e,...i]))}flush(){}}t.AbstractMessageLogger=g;class P extends O{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...i):console.log(`[main ${b()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...i):console.log(`[main ${b()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,e,...i):console.log(`[main ${b()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,e,...i):console.warn(`[main ${b()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,e,...i):console.error(`[main ${b()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,e,...i):console.error(`[main ${b()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=P;class p extends O{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=p;class h extends O{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=h;class l extends O{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const s of this.logServices)s.trace(e,...i)}debug(e,...i){for(const s of this.logServices)s.debug(e,...i)}info(e,...i){for(const s of this.logServices)s.info(e,...i)}warn(e,...i){for(const s of this.logServices)s.warn(e,...i)}error(e,...i){for(const s of this.logServices)s.error(e,...i)}critical(e,...i){for(const s of this.logServices)s.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=l;class d extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=d;class y extends S.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,i?.always?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=y;class a{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=a;function m(r){if(r.verbose)return u.Trace;if(typeof r.logLevel=="string"){const e=o(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=m;function o(r){switch(r){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=o;function n(r){switch(r){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=n});var ae=this&&this.__param||function(z,t){return function(C,D){t(C,D,z)}};define(Q[96],Z([0,1,38,3,28,8,2,10,11,15,20,13]),function(z,t,C,D,S,R,L,b,u,v,I,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends L.Disposable{constructor(p,h){super();this.environmentService=p,this.logService=h,this.processesLimiter=new D.Limiter(5)}async postUninstall(p){const h=this.parseScript(p,"uninstall");return h&&(this.logService.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,p).then(()=>this.logService.info(p.identifier.id,p.manifest.version,"Finished running post uninstall script"),l=>this.logService.error(p.identifier.id,p.manifest.version,`Failed to run post uninstall script: ${l}`)))),v.Promises.rm(this.getExtensionStoragePath(p)).then(void 0,l=>this.logService.error("Error while removing extension storage path",l))}parseScript(p,h){const l=`vscode:${h}`;if(p.location.scheme===b.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[l]=="string"){const d=p.manifest.scripts[l].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(p.identifier.id,p.manifest.version,`${l} should be a node script`),null):{script:(0,u.join)(p.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(p,h,l,d,y){return new Promise((a,m)=>{const o=this.start(p,h,l,y);let n;const r=e=>{n&&(clearTimeout(n),n=null),e?m(e):a(void 0)};o.on("error",e=>{r((0,S.toErrorMessage)(e)||"Unknown")}),o.on("exit",(e,i)=>{r(e?`post-${h} process exited with code ${e}`:void 0)}),d&&(n=setTimeout(()=>{n=null,o.kill(),m("timed out")},5e3))})}start(p,h,l,d){const y={silent:!0,execArgv:void 0},a=(0,C.fork)(p,[`--type=extension-post-${h}`,...l],y);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const m=R.Event.fromNodeEventEmitter(a.stdout,"data"),o=R.Event.fromNodeEventEmitter(a.stderr,"data");m(e=>this.logService.info(d.identifier.id,d.manifest.version,`post-${h}`,e)),o(e=>this.logService.error(d.identifier.id,d.manifest.version,`post-${h}`,e));const n=R.Event.any(R.Event.map(m,e=>({data:`%c${e}`,format:[""]})),R.Event.map(o,e=>({data:`%c${e}`,format:["color: red"]})));return R.Event.debounce(n,(e,i)=>e?{data:e.data+i.data,format:[...e.format,...i.format]}:{data:i.data,format:i.format},100)(e=>{console.group(d.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),a}getExtensionStoragePath(p){return(0,u.join)(this.environmentService.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};g=ve([ae(0,I.IEnvironmentService),ae(1,O.ILogService)],g),t.ExtensionsLifecycle=g}),define(Q[97],Z([0,1,19,3,6,8,2,11,94,13]),function(z,t,C,D,S,R,L,b,u,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class I extends L.Disposable{constructor(g){super();this.logService=g,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(g,P){return P.recursive?this.watchRecursive(g,P):this.watchNonRecursive(g,P)}watchRecursive(g,P){const p={path:this.toFilePath(g),excludes:P.excludes},h=(0,C.insert)(this.recursiveFoldersToWatch,p);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(g=>(0,S.onUnexpectedError)(g))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(g=>this._onDidChangeFile.fire((0,u.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.massageRecursiveWatchRequests(this.recursiveFoldersToWatch),this.recursiveWatcher.watch(this.recursiveFoldersToWatch)}massageRecursiveWatchRequests(g){}watchNonRecursive(g,P){const p=new L.DisposableStore,h=p.add(this.createNonRecursiveWatcher({path:this.toFilePath(g),excludes:P.excludes},l=>this._onDidChangeFile.fire((0,u.toFileChanges)(l)),l=>this.onWatcherLogMessage(l),this.logService.getLevel()===v.LogLevel.Trace));return p.add(this.logService.onDidChangeLogLevel(()=>{h.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)})),p}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,b.normalize)(g.fsPath)}}t.AbstractDiskFileSystemProvider=I}),define(Q[98],Z([0,1,19,3,17,24,8,58,132,2,53,10,99,18,37,81,16,50,13]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P,p,h,l,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let a=class extends v.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,n){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${o}`);const r=new v.DisposableStore;return this.provider.set(o,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:n}),r.add(n.onDidChangeFile(e=>this._onDidFilesChange.fire(new l.FileChangesEvent(e,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),r.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:o}))),(0,v.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:n}),this.provider.delete(o),(0,v.dispose)(r)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(r){n.push(r)}}),!this.provider.has(o)&&await D.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,n){const r=this.provider.get(o.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return u.Iterable.map(this.provider,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async withProvider(o){if(!(0,P.isAbsolutePath)(o))throw new l.FileOperationError((0,h.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const n=this.provider.get(o.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,o.toString()),r}return n}async withReadProvider(o){const n=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(n)||(0,l.hasReadWriteCapability)(n)||(0,l.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const n=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(n)||(0,l.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.doResolveFile(o,n)}catch(r){throw(0,l.toFileSystemProviderErrorCode)(r)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,h.localize)(2,null,this.resourceForError(o)),1):(0,l.ensureFileSystemProviderError)(r)}}async doResolveFile(o,n){const r=await this.withProvider(o),e=this.isPathCaseSensitive(r),i=n?.resolveTo,s=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,f=await r.stat(o);let E;return this.toFileStat(r,o,f,void 0,!!c,(w,T)=>(E||(E=I.TernarySearchTree.forUris(()=>!e),E.set(o,!0),i&&E.fill(!0,i)),E.get(w.resource)||E.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&s?T===1:!1))}async toFileStat(o,n,r,e,i,s){const{providerExtUri:c}=this.getExtUri(o),f={resource:n,name:c.basename(n),isFile:(r.type&l.FileType.File)!=0,isDirectory:(r.type&l.FileType.Directory)!=0,isSymbolicLink:(r.type&l.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&l.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,l.etag)({mtime:r.mtime,size:r.size})};if(f.isDirectory&&s(f,e)){try{const E=await o.readdir(n),w=await D.Promises.settled(E.map(async([T,F])=>{try{const W=c.joinPath(n,T),J=i?await o.stat(W):{type:F};return await this.toFileStat(o,W,J,E.length,i,s)}catch(W){return this.logService.trace(W),null}}));f.children=(0,C.coalesce)(w)}catch(E){this.logService.trace(E),f.children=[]}return f}return f}async resolveAll(o){return D.Promises.settled(o.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(o){const n=await this.withProvider(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.doValidateCreateFile(o,n)}catch(r){return r}return!0}async doValidateCreateFile(o,n){if(!n?.overwrite&&await this.exists(o))throw new l.FileOperationError((0,h.localize)(3,null,this.resourceForError(o)),3,n)}async createFile(o,n=S.VSBuffer.fromString(""),r){await this.doValidateCreateFile(o,r);const e=await this.writeFile(o,n);return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,e)),e}async writeFile(o,n,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(e);try{await this.validateWriteFile(e,o,r)||await this.mkdirp(e,i.dirname(o));let c;if((0,l.hasReadWriteCapability)(e)&&!(n instanceof S.VSBuffer))if((0,p.isReadableStream)(n)){const f=await(0,p.peekStream)(n,3);f.ended?c=S.VSBuffer.concat(f.buffer):c=f}else c=(0,p.peekReadable)(n,f=>S.VSBuffer.concat(f),3);else c=n;!(0,l.hasOpenReadWriteCloseCapability)(e)||(0,l.hasReadWriteCapability)(e)&&c instanceof S.VSBuffer?await this.doWriteUnbuffered(e,o,r,c):await this.doWriteBuffered(e,o,r,c instanceof S.VSBuffer?(0,S.bufferToReadable)(c):c)}catch(s){throw new l.FileOperationError((0,h.localize)(4,null,this.resourceForError(o),(0,l.ensureFileSystemProviderError)(s).toString()),(0,l.toFileOperationResult)(s),r)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,n,r){if(!!r?.unlock&&!(o.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(n)));let i;try{i=await o.stat(n)}catch{return}if((i.type&l.FileType.Directory)!=0)throw new l.FileOperationError((0,h.localize)(6,null,this.resourceForError(n)),0,r);if(this.throwIfFileIsReadonly(n,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==l.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,l.etag)({mtime:r.mtime,size:i.size}))throw new l.FileOperationError((0,h.localize)(7,null),3,r);return i}async readFile(o,n,r){const e=await this.withReadProvider(o);return n?.atomic?this.doReadFileAtomic(e,o,n,r):this.doReadFile(e,o,n,r)}async doReadFileAtomic(o,n,r,e){return new Promise((i,s)=>{this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(o,n,r,e);i(c)}catch(c){s(c)}})})}async doReadFile(o,n,r,e){const i=await this.doReadFileStream(o,n,{...r,preferUnbuffered:!0},e);return{...i,value:await(0,S.streamToBuffer)(i.value)}}async readFileStream(o,n,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,n,r)}async doReadFileStream(o,n,r,e){const i=new R.CancellationTokenSource(e),s=this.validateReadFile(n,r).then(f=>f,f=>{throw i.cancel(),f});let c;try{return typeof r?.etag=="string"&&r.etag!==l.ETAG_DISABLED&&await s,r?.atomic&&(0,l.hasFileAtomicReadCapability)(o)||!((0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasFileReadStreamCapability)(o))||(0,l.hasReadWriteCapability)(o)&&r?.preferUnbuffered?c=this.readFileUnbuffered(o,n,r):(0,l.hasFileReadStreamCapability)(o)?c=this.readFileStreamed(o,n,i.token,r):c=this.readFileBuffered(o,n,i.token,r),{...await s,value:c}}catch(f){c&&await(0,p.consumeStream)(c);const E=(0,h.localize)(8,null,this.resourceForError(n),(0,l.ensureFileSystemProviderError)(f).toString());throw f instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(E,f.stat,r):new l.FileOperationError(E,(0,l.toFileOperationResult)(f),r)}}readFileStreamed(o,n,r,e=Object.create(null)){const i=o.readFileStream(n,e,r);return(0,p.transform)(i,{data:s=>s instanceof S.VSBuffer?s:S.VSBuffer.wrap(s),error:s=>new l.FileOperationError((0,h.localize)(9,null,this.resourceForError(n),(0,l.ensureFileSystemProviderError)(s).toString()),(0,l.toFileOperationResult)(s),e)},s=>S.VSBuffer.concat(s))}readFileBuffered(o,n,r,e=Object.create(null)){const i=(0,S.newWriteableBufferStream)();return(0,d.readFileIntoStream)(o,n,i,s=>s,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new l.FileOperationError((0,h.localize)(10,null,this.resourceForError(n),(0,l.ensureFileSystemProviderError)(s).toString()),(0,l.toFileOperationResult)(s),e)},r),i}readFileUnbuffered(o,n,r){const e=(0,p.newWriteableStream)(i=>S.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,l.hasFileAtomicReadCapability)(o)?i=await o.readFile(n,{atomic:!0}):i=await o.readFile(n),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(n,i.byteLength,r),e.end(S.VSBuffer.wrap(i))}catch(i){e.error(i),e.end()}})(),e}async validateReadFile(o,n){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new l.FileOperationError((0,h.localize)(11,null,this.resourceForError(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==l.ETAG_DISABLED&&n.etag===r.etag)throw new l.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,n);return this.validateReadFileLimits(o,r.size,n),r}validateReadFileLimits(o,n,r){if(r?.limits){let e;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(e=9),typeof r.limits.size=="number"&&n>r.limits.size&&(e=7),typeof e=="number")throw new l.FileOperationError((0,h.localize)(13,null,this.resourceForError(o)),e)}}async canMove(o,n,r){return this.doCanMoveCopy(o,n,"move",r)}async canCopy(o,n,r){return this.doCanMoveCopy(o,n,"copy",r)}async doCanMoveCopy(o,n,r,e){if(o.toString()!==n.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(i,o,s,n,r,e)}catch(i){return i}return!0}async move(o,n,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(e,o,i,n,"move",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,s==="move"?2:3,c)),c}async copy(o,n,r){const e=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(e,o,i,n,"copy",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,s==="copy"?3:2,c)),c}async doMoveCopy(o,n,r,e,i,s){if(n.toString()===e.toString())return i;const{exists:c,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,n,r,e,i,s);if(c&&!f&&s&&await this.del(e,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(e)),i==="copy"){if(o===r&&(0,l.hasFileFolderCopyCapability)(o))await o.copy(n,e,{overwrite:s});else{const E=await this.resolve(n);E.isDirectory?await this.doCopyFolder(o,E,r,e):await this.doCopyFile(o,n,r,e)}return i}else return o===r?(await o.rename(n,e,{overwrite:s}),i):(await this.doMoveCopy(o,n,r,e,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(o,n,r,e){if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(o,n,r,e);if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(o,n,r,e);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(o,n,r,e);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasReadWriteCapability)(r))return this.doPipeUnbuffered(o,n,r,e)}async doCopyFolder(o,n,r,e){await r.mkdir(e),Array.isArray(n.children)&&await D.Promises.settled(n.children.map(async i=>{const s=this.getExtUri(r).providerExtUri.joinPath(e,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),r,s):this.doCopyFile(o,i.resource,r,s)}))}async doValidateMoveCopy(o,n,r,e,i,s){let c=!1;if(o===r){const{providerExtUri:E,isPathCaseSensitive:w}=this.getExtUri(o);if(w||(c=E.isEqual(n,e)),c&&i==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(n),this.resourceForError(e)));if(!c&&E.isEqualOrParent(e,n))throw new Error((0,h.localize)(15,null,this.resourceForError(n),this.resourceForError(e)))}const f=await this.exists(e);if(f&&!c){if(!s)throw new l.FileOperationError((0,h.localize)(16,null,this.resourceForError(n),this.resourceForError(e)),4);if(o===r){const{providerExtUri:E}=this.getExtUri(o);if(E.isEqualOrParent(n,e))throw new Error((0,h.localize)(17,null,this.resourceForError(n),this.resourceForError(e)))}}return{exists:f,isSameResourceWithDifferentPathCase:c}}getExtUri(o){const n=this.isPathCaseSensitive(o);return{providerExtUri:n?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(n,o);const r=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,r)),r}async mkdirp(o,n){const r=[],{providerExtUri:e}=this.getExtUri(o);for(;!e.isEqual(n,e.dirname(n));)try{if(((await o.stat(n)).type&l.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(n)));break}catch(i){if((0,l.toFileSystemProviderErrorCode)(i)!==l.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(e.basename(n)),n=e.dirname(n)}for(let i=r.length-1;i>=0;i--){n=e.joinPath(n,r[i]);try{await o.mkdir(n)}catch(s){if((0,l.toFileSystemProviderErrorCode)(s)!==l.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,n){try{await this.doValidateDelete(o,n)}catch(r){return r}return!0}async doValidateDelete(o,n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(o)));let i;try{i=await r.stat(o)}catch{}if(i)this.throwIfFileIsReadonly(o,i);else throw new l.FileOperationError((0,h.localize)(20,null,this.resourceForError(o)),1);if(!!!n?.recursive){const c=await this.resolve(o);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(o)))}return r}async del(o,n){const r=await this.doValidateDelete(o,n),e=!!n?.useTrash,i=!!n?.recursive;await r.delete(o,{recursive:i,useTrash:e}),this._onDidRunOperation.fire(new l.FileOperationEvent(o,1))}watch(o,n={recursive:!1,excludes:[]}){const r=new v.DisposableStore;let e=!1,i=()=>{e=!0};return r.add((0,v.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(o,n);e?(0,v.dispose)(s):i=()=>(0,v.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(o,n){const r=await this.withProvider(o),e=(0,b.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(o),n]);let i=this.activeWatchers.get(e);return i||(i={count:0,disposable:r.watch(o,n)},this.activeWatchers.set(e,i)),i.count+=1,(0,v.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,v.dispose)(i.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,v.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,n,r,e){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(e)||(0,p.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(o,i,e):await this.doWriteReadableBufferedQueued(o,i,e)}catch(s){throw(0,l.ensureFileSystemProviderError)(s)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,n,r){let e=0,i;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=S.VSBuffer.concat(r.buffer);await this.doWriteBuffer(o,n,s,s.byteLength,e,0),e+=s.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((s,c)=>{(0,p.listenStream)(i,{onData:async f=>{i.pause();try{await this.doWriteBuffer(o,n,f,f.byteLength,e,0)}catch(E){return c(E)}e+=f.byteLength,setTimeout(()=>i.resume())},onError:f=>c(f),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,n,r){let e=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(o,n,i,i.byteLength,e,0),e+=i.byteLength}async doWriteBuffer(o,n,r,e,i,s){let c=0;for(;c<e;)c+=await o.write(n,i+c,r.buffer,s+c,e-c)}async doWriteUnbuffered(o,n,r,e){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,n,r,e))}async doWriteUnbufferedQueued(o,n,r,e){let i;e instanceof S.VSBuffer?i=e:(0,p.isReadableStream)(e)?i=await(0,S.streamToBuffer)(e):(0,p.isReadableBufferedStream)(e)?i=await(0,S.bufferedStreamToBuffer)(e):i=(0,S.readableToBuffer)(e),await o.writeFile(n,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(o,n,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,n,r,e))}async doPipeBufferedQueued(o,n,r,e){let i,s;try{i=await o.open(n,{create:!1}),s=await r.open(e,{create:!0,unlock:!1});const c=S.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,E=0,w=0;do w=await o.read(i,f,c.buffer,E,c.byteLength-E),await this.doWriteBuffer(r,s,c,w,f,E),f+=w,E+=w,E===c.byteLength&&(E=0);while(w>0)}catch(c){throw(0,l.ensureFileSystemProviderError)(c)}finally{await D.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,n,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,n,r,e))}async doPipeUnbufferedQueued(o,n,r,e){return r.writeFile(e,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,n,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,n,r,e))}async doPipeUnbufferedToBufferedQueued(o,n,r,e){const i=await r.open(e,{create:!0,unlock:!1});try{const s=await o.readFile(n);await this.doWriteBuffer(r,i,S.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,l.ensureFileSystemProviderError)(s)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(o,n,r,e){const i=await(0,S.streamToBuffer)(this.readFileBuffered(o,n,R.CancellationToken.None));await this.doWriteUnbuffered(r,e,void 0,i)}throwIfFileSystemIsReadonly(o,n){if(o.capabilities&2048)throw new l.FileOperationError((0,h.localize)(22,null,this.resourceForError(n)),6);return o}throwIfFileIsReadonly(o,n){if((n.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,h.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===O.Schemas.file?o.fsPath:o.toString(!0)}};a=ve([ae(0,y.ILogService)],a),t.FileService=a}),define(Q[100],Z([0,1,101,133,3,53,17,8,45,2,11,14,18,37,15,83,16,50,134,93,97,28]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P,p,h,l,d,y,a,m,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(C)}catch(r){console.error(`Error enabling graceful-fs: ${(0,o.toErrorMessage)(r)}`)}})();class n extends m.AbstractDiskFileSystemProvider{constructor(e,i){super(e);this.options=i,this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new R.ResourceMap(s=>g.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:i,symbolicLink:s}=await p.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(e){try{const i=await p.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async c=>{try{let f;c.isSymbolicLink()?f=(await this.stat((0,g.joinPath)(e,c.name))).type:f=this.toType(c),s.push([c.name,f])}catch(f){this.logService.trace(f)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(e,i){let s;return i?.dangling?s=l.FileType.Unknown:e.isFile()?s=l.FileType.File:e.isDirectory()?s=l.FileType.Directory:s=l.FileType.Unknown,i&&(s|=l.FileType.SymbolicLink),s}async createResourceLock(e){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(e)})`);let i;for(;i=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(e)})`),await i.wait();const s=new S.Barrier;return this.resourceLocks.set(e,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(e)})`),(0,v.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(e)})`),this.resourceLocks.delete(e),s.open()})}async readFile(e,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),s=await this.createResourceLock(e));const c=this.toFilePath(e);return await p.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}readFileStream(e,i,s){const c=(0,P.newWriteableStream)(f=>L.VSBuffer.concat(f.map(E=>L.VSBuffer.wrap(E))).buffer);return(0,d.readFileIntoStream)(this,e,c,f=>f.buffer,{...i,bufferSize:256*1024},s),c}async writeFile(e,i,s){let c;try{const f=this.toFilePath(e);if(!s.create||!s.overwrite){if(await p.Promises.exists(f)){if(!s.overwrite)throw(0,l.createFileSystemProviderError)((0,h.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,l.createFileSystemProviderError)((0,h.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(e,{create:!0,unlock:s.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(e,f)}finally{typeof c=="number"&&await this.close(c)}}async open(e,i){let s;(0,l.isFileOpenForWriteOptions)(i)&&(s=await this.createResourceLock(e));let c;try{const f=this.toFilePath(e);if((0,l.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:w}=await p.SymlinkSupport.stat(f);w.mode&128||await p.Promises.chmod(f,w.mode|128)}catch(w){this.logService.trace(w)}let E;if((0,l.isFileOpenForWriteOptions)(i)){if(O.isWindows)try{await p.Promises.truncate(f,0),E="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}E||(E="w")}else E="r";c=await p.Promises.open(f,E)}catch(f){throw s?.dispose(),(0,l.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(e,f):this.toFileSystemProviderError(f)}return this.mapHandleToPos.set(c,0),(0,l.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(c,e),s&&this.mapHandleToLock.set(c,s),c}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await p.Promises.fdatasync(e)}catch(i){this.canFlush=!1,this.logService.error(i)}return await p.Promises.close(e)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(e);i&&(this.mapHandleToLock.delete(e),i.dispose())}}async read(e,i,s,c,f){const E=this.normalizePos(e,i);let w=null;try{const{bytesRead:T}=await p.Promises.read(e,s,c,f,E);return T}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(e,E,w)}}normalizePos(e,i){return i===this.mapHandleToPos.get(e)?null:i}updatePos(e,i,s){const c=this.mapHandleToPos.get(e);typeof c=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(e,c+s):this.mapHandleToPos.delete(e)))}async write(e,i,s,c,f){return(0,S.retry)(()=>this.doWrite(e,i,s,c,f),100,3)}async doWrite(e,i,s,c,f){const E=this.normalizePos(e,i);let w=null;try{const{bytesWritten:T}=await p.Promises.write(e,s,c,f,E);return T}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),T)}finally{this.updatePos(e,E,w)}}async mkdir(e){try{await p.Promises.mkdir(this.toFilePath(e))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(e,i){try{const s=this.toFilePath(e);i.recursive?await p.Promises.rm(s,p.RimRafMode.MOVE):await p.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(e,i,s){const c=this.toFilePath(e),f=this.toFilePath(i);if(c!==f)try{await this.validateTargetDeleted(e,i,"move",s.overwrite),await p.Promises.move(c,f)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,h.localize)(2,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(f)),E.toString()))),this.toFileSystemProviderError(E)}}async copy(e,i,s){const c=this.toFilePath(e),f=this.toFilePath(i);if(c!==f)try{await this.validateTargetDeleted(e,i,"copy",s.overwrite),await p.Promises.copy(c,f,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,h.localize)(3,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(f)),E.toString()))),this.toFileSystemProviderError(E)}}async validateTargetDeleted(e,i,s,c){const f=this.toFilePath(e),E=this.toFilePath(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,u.isEqual)(f,E,!0)),w&&s==="copy")throw(0,l.createFileSystemProviderError)((0,h.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!w&&await p.Promises.exists(E)){if(!c)throw(0,l.createFileSystemProviderError)((0,h.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(e,i,s){return new a.ParcelWatcherClient(c=>e(c),c=>i(c),s)}massageRecursiveWatchRequests(e){const i=this.options?.watcher?.usePolling;if(i===!0)for(const s of e)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(i))for(const s of e)i.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3)}createNonRecursiveWatcher(e,i,s,c){return new y.NodeJSFileWatcher(e,f=>i(f),f=>s(f),c)}toFileSystemProviderError(e){if(e instanceof l.FileSystemProviderError)return e;let i;switch(e.code){case"ENOENT":i=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=l.FileSystemProviderErrorCode.NoPermissions;break;default:i=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(e,i)}async toFileSystemProviderWriteError(e,i){let s=this.toFileSystemProviderError(i);if(e&&s.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await p.SymlinkSupport.stat(this.toFilePath(e));c.mode&128||(s=(0,l.createFileSystemProviderError)(i,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}t.DiskFileSystemProvider=n}),define(Q[102],Z([0,1,16,13]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function S(b,u,v,I,O){try{const g=await new Promise((p,h)=>{z(["spdlog"],p,h)});g.setFlushOn(D.LogLevel.Trace);const P=await g.createAsyncRotatingLogger(b,u,v,I);return O&&P.clearFormatters(),P}catch(g){console.error(g)}return null}function R(b,u,v){switch(u){case D.LogLevel.Trace:b.trace(v);break;case D.LogLevel.Debug:b.debug(v);break;case D.LogLevel.Info:b.info(v);break;case D.LogLevel.Warning:b.warn(v);break;case D.LogLevel.Error:b.error(v);break;case D.LogLevel.Critical:b.critical(v);break;default:throw new Error("Invalid log level")}}class L extends D.AbstractMessageLogger{constructor(u,v,I,O,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(u,v,I,O),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}async _createSpdLogLogger(u,v,I,O){const g=I?6:1,P=30/g*C.ByteSize.MB,p=await S(u,v,P,g,O);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:h,message:l}of this.buffer)R(this._logger,h,l);this.buffer=[]}}log(u,v){this._logger?R(this._logger,u,v):this.getLevel()<=u&&this.buffer.push({level:u,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Q[32],Z([0,1,12]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Q[30],Z([0,1,54,7]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(L,b){C.ok(D.isString(L)),C.ok(D.isObject(b)),C.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,b)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}t.Registry=new S}),define(Q[103],Z([0,1,8,30]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,v){this.schemasById[S(u)]=v,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new R;D.Registry.add(t.Extensions.JSONContribution,L)}),define(Q[34],Z([0,1,19,8,7,72,103,30]),function(z,t,C,D,S,R,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var u;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(u=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var v;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=b.Registry.as(L.Extensions.JSONContribution);class O{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,n=!0){this.registerConfigurations([o],n)}registerConfigurations(o,n=!0){const r=this.doRegisterConfigurations(o,n);I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const n=this.doDeregisterConfigurations(o);I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:o,remove:n}){const r=[];r.push(...this.doDeregisterConfigurations(n)),r.push(...this.doRegisterConfigurations(o,!1)),I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(r)})}registerDefaultConfigurations(o){const n=[],r=[];for(const{overrides:e,source:i}of o)for(const s in e)if(n.push(s),t.OVERRIDE_PROPERTY_REGEX.test(s)){const c={...this.configurationDefaultsOverrides.get(s)?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:c});const f={type:"object",default:c,description:R.localize(1,null,s),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:S.isString(i)?void 0:i};r.push(...p(s)),this.configurationProperties[s]=f,this.defaultLanguageConfigurationOverridesNode.properties[s]=f}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:i});const c=this.configurationProperties[s];c&&(this.updatePropertyDefaultValue(s,c),this.updateSchema(s,c))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const n=[];for(const{overrides:r,source:e}of o)for(const i in r){const s=this.configurationDefaultsOverrides.get(i),c=S.isString(e)?e:e?.id,f=S.isString(s?.source)?s?.source:s?.source?.id;if(c===f)if(n.push(i),this.configurationDefaultsOverrides.delete(i),t.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const E=this.configurationProperties[i];E&&(this.updatePropertyDefaultValue(i,E),this.updateSchema(i,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const n of o)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,n){const r=[];return o.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,n,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(o){const n=[],r=e=>{if(e.properties)for(const i in e.properties)n.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>r(i))};for(const e of o){r(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return n}validateAndRegisterProperties(o,n=!0,r,e,i=3){i=S.isUndefinedOrNull(o.scope)?i:o.scope;let s=[],c=o.properties;if(c)for(let E in c){if(n&&y(E)){delete c[E];continue}const w=c[E];if(w.source=r,w.defaultDefaultValue=c[E].default,this.updatePropertyDefaultValue(E,w),t.OVERRIDE_PROPERTY_REGEX.test(E)?w.scope=void 0:(w.scope=S.isUndefinedOrNull(w.scope)?i:w.scope,w.restricted=S.isUndefinedOrNull(w.restricted)?!!e?.includes(E):w.restricted),c[E].hasOwnProperty("included")&&!c[E].included){this.excludedConfigurationProperties[E]=c[E],delete c[E];continue}else this.configurationProperties[E]=c[E];!c[E].deprecationMessage&&c[E].markdownDeprecationMessage&&(c[E].deprecationMessage=c[E].markdownDeprecationMessage),s.push(E)}let f=o.allOf;if(f)for(let E of f)s.push(...this.validateAndRegisterProperties(E,n,r,e,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const n=r=>{let e=r.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);let i=r.allOf;i&&i.forEach(n)};n(o)}updateSchema(o,n){switch(t.allSettings.properties[o]=n,n.scope){case 1:t.applicationSettings.properties[o]=n;break;case 2:t.machineSettings.properties[o]=n;break;case 6:t.machineOverridableSettings.properties[o]=n;break;case 3:t.windowSettings.properties[o]=n;break;case 4:t.resourceSettings.properties[o]=n;break;case 5:t.resourceSettings.properties[o]=n,this.resourceLanguageSettingsSchema.properties[o]=n;break}}removeFromSchema(o,n){switch(delete t.allSettings.properties[o],n.scope){case 1:delete t.applicationSettings.properties[o];break;case 2:delete t.machineSettings.properties[o];break;case 6:delete t.machineOverridableSettings.properties[o];break;case 3:delete t.windowSettings.properties[o];break;case 4:case 5:delete t.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const n=`[${o}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,r),t.allSettings.properties[n]=r,t.applicationSettings.properties[n]=r,t.machineSettings.properties[n]=r,t.machineOverridableSettings.properties[n]=r,t.windowSettings.properties[n]=r,t.resourceSettings.properties[n]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,n){const r=this.configurationDefaultsOverrides.get(o);let e=r?.value,i=r?.source;S.isUndefined(e)&&(e=n.defaultDefaultValue,i=void 0),S.isUndefined(e)&&(e=l(n.type)),n.default=e,n.defaultValueSource=i}}const g="\\[([^\\]]+)\\]",P=new RegExp(g,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function p(m){const o=[];if(t.OVERRIDE_PROPERTY_REGEX.test(m)){let n=P.exec(m);for(;n?.length;){const r=n[1].trim();r&&o.push(r),n=P.exec(m)}}return(0,C.distinct)(o)}t.overrideIdentifiersFromKey=p;function h(m){return m.reduce((o,n)=>`${o}[${n}]`,"")}t.keyFromOverrideIdentifiers=h;function l(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=l;const d=new O;b.Registry.add(t.Extensions.Configuration,d);function y(m){return m.trim()?t.OVERRIDE_PROPERTY_REGEX.test(m)?R.localize(7,null,m):d.getConfigurationProperties()[m]!==void 0?R.localize(8,null,m):null:R.localize(6,null)}t.validateProperty=y;function a(){const m=[],o=d.getConfigurationProperties();for(const n of Object.keys(o))m.push([n,o[n].scope]);return m.push(["launch",4]),m.push(["task",4]),m}t.getScopes=a}),define(Q[104],Z([0,1,19,8,55,2,53,21,7,9,25,34,30]),function(z,t,C,D,S,R,L,b,u,v,I,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class P{constructor(e={},i=[],s=[]){this._contents=e,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,I.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const s=this.getContentsForOverrideIdentifer(i);return s?e?(0,I.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const i=[];for(const s of this.overrides)s.identifiers.includes(e)&&i.push(...s.keys);return C.distinct(i)}getAllOverrideIdentifiers(){const e=[];for(const i of this.overrides)e.push(...i.identifiers);return C.distinct(e)}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=b.deepClone(this.contents),s=b.deepClone(this.overrides),c=[...this.keys];for(const f of e){this.mergeContents(i,f.contents);for(const E of f.overrides){const[w]=s.filter(T=>C.equals(T.identifiers,E.identifiers));w?(this.mergeContents(w.contents,E.contents),w.keys.push(...E.keys),w.keys=C.distinct(w.keys)):s.push(b.deepClone(E))}for(const E of f.keys)c.indexOf(E)===-1&&c.push(E)}return new P(i,c,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const c of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let f=this.contents[c],E=i[c];E&&(typeof f=="object"&&typeof E=="object"?(f=b.deepClone(f),this.mergeContents(f,E)):f=E),s[c]=f}return new P(s,this.keys,this.overrides)}mergeContents(e,i){for(const s of Object.keys(i)){if(s in e&&u.isObject(e[s])&&u.isObject(i[s])){this.mergeContents(e[s],i[s]);continue}e[s]=b.deepClone(i[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?b.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let i=null,s=null;const c=f=>{f&&(s?this.mergeContents(s,f):s=b.deepClone(f))};for(const f of this.overrides)C.equals(f.identifiers,[e])?i=f.contents:f.identifiers.includes(e)&&c(f.contents);return c(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,I.addToValueTree)(this.contents,e,i,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,I.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let s=0;s<i;s++)e.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=P;class p extends P{constructor(e={}){const i=g.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),c=Object.create(null),f=[];for(const E in i){const w=e[E],T=w!==void 0?w:i[E].default;(0,I.addToValueTree)(c,E,T,F=>console.error(`Conflict in default settings: ${F}`))}for(const E of Object.keys(c))O.OVERRIDE_PROPERTY_REGEX.test(E)&&f.push({identifiers:(0,O.overrideIdentifiersFromKey)(E),keys:Object.keys(c[E]),contents:(0,I.toValuesTree)(c[E],w=>console.error(`Conflict in default settings file: ${w}`))});super(c,s,f)}}t.DefaultConfigurationModel=p;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!u.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:s,keys:c,overrides:f,restricted:E}=this.doParseRaw(e,i);this._configurationModel=new P(s,c,f),this._restrictedConfigurations=E||[]}doParseContent(e){let i={},s=null,c=[],f=[],E=[];function w(F){Array.isArray(c)?c.push(F):s!==null&&(c[s]=F)}let T={onObjectBegin:()=>{let F={};w(F),f.push(c),c=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{c=f.pop()},onArrayBegin:()=>{let F=[];w(F),f.push(c),c=F,s=null},onArrayEnd:()=>{c=f.pop()},onLiteralValue:w,onError:(F,W,J)=>{E.push({error:F,offset:W,length:J})}};if(e)try{S.visit(e,T),i=c[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return i}doParseRaw(e,i){const s=g.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),c=this.filter(e,s,!0,i);e=c.raw;const f=(0,I.toValuesTree)(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),E=Object.keys(e),w=this.toOverrides(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:f,keys:E,overrides:w,restricted:c.restricted}}filter(e,i,s,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:e,restricted:[]};const f={},E=[];for(let w in e)if(O.OVERRIDE_PROPERTY_REGEX.test(w)&&s){const T=this.filter(e[w],i,!1,c);f[w]=T.raw,E.push(...T.restricted)}else{const T=i[w],F=T?typeof T.scope!="undefined"?T.scope:3:void 0;T?.restricted&&E.push(w),(F===void 0||c.scopes===void 0||c.scopes.includes(F))&&(c.skipRestricted&&T?.restricted||(f[w]=e[w]))}return{raw:f,restricted:E}}toOverrides(e,i){const s=[];for(const c of Object.keys(e))if(O.OVERRIDE_PROPERTY_REGEX.test(c)){const f={};for(const E in e[c])f[E]=e[c][E];s.push({identifiers:(0,O.overrideIdentifiersFromKey)(c),keys:Object.keys(f),contents:(0,I.toValuesTree)(f,i)})}return s}}t.ConfigurationModelParser=h;class l extends R.Disposable{constructor(e,i,s,c){super();this.userSettingsResource=e,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new P}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=l;class d{constructor(e,i,s=new P,c=new P,f=new L.ResourceMap,E=new P,w=new L.ResourceMap,T=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=f,this._memoryConfiguration=E,this._memoryConfigurationByResource=w,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(e)}updateValue(e,i,s={}){let c;s.resource?(c=this._memoryConfigurationByResource.get(s.resource),c||(c=new P,this._memoryConfigurationByResource.set(s.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(e):c.setValue(e,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,s){const c=this.getConsolidateConfigurationModel(i,s),f=this.getFolderConfigurationModelForResource(i.resource,s),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),T=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),W=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),J=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,se=f?i.overrideIdentifier?f.freeze().override(i.overrideIdentifier).getValue(e):f.freeze().getValue(e):void 0,ie=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(e):E.getValue(e),te=c.getValue(e),ge=C.distinct(C.flatten(c.overrides.map(B=>B.identifiers))).filter(B=>c.getOverrideValue(e,B)!==void 0);return{defaultValue:w,userValue:T,userLocalValue:F,userRemoteValue:W,workspaceValue:J,workspaceFolderValue:se,memoryValue:ie,value:te,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:W!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:f?.freeze().getValue(e),override:i.overrideIdentifier?f?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:E.getValue(e),override:i.overrideIdentifier?E.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ge.length?ge:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const s=[];if(!i){const{added:c,updated:f,removed:E}=o(this._defaultConfiguration,e);i=[...c,...f,...E]}for(const c of i)for(const f of(0,O.overrideIdentifiersFromKey)(c)){const E=this._defaultConfiguration.getKeysForOverrideIdentifier(f),w=e.getKeysForOverrideIdentifier(f),T=[...w.filter(F=>E.indexOf(F)===-1),...E.filter(F=>w.indexOf(F)===-1),...E.filter(F=>!b.equals(this._defaultConfiguration.override(f).getValue(F),e.override(f).getValue(F)))];s.push([f,T])}return this.updateDefaultConfiguration(e),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:s,removed:c,overrides:f}=o(this.localUserConfiguration,e),E=[...i,...s,...c];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:f}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:s,removed:c,overrides:f}=o(this.remoteUserConfiguration,e);let E=[...i,...s,...c];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:f}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:s,removed:c,overrides:f}=o(this.workspaceConfiguration,e);let E=[...i,...s,...c];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:f}}compareAndUpdateFolderConfiguration(e,i){const s=this.folderConfigurations.get(e),{added:c,updated:f,removed:E,overrides:w}=o(s,i);let T=[...c,...f,...E];return(T.length||!s)&&this.updateFolderConfiguration(e,i),{keys:T,overrides:w}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:c,removed:f,overrides:E}=o(i,void 0);return{keys:[...s,...c,...f],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let s=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const c=i.getFolder(e);c&&(s=this.getFolderConsolidatedConfiguration(c.uri)||s);const f=this._memoryConfigurationByResource.get(e);f&&(s=s.merge(f))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(e);c?(i=s.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=s}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const s=i.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:s,overrides:c,keys:f}=this._folderConfigurations.get(i);return e.push([i,{contents:s,overrides:c,keys:f}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(c=>i.add(c))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),c=this.parseConfigurationModel(e.workspace),f=e.folders.reduce((E,w)=>(E.set(v.URI.revive(w[0]),this.parseConfigurationModel(w[1])),E),new L.ResourceMap);return new d(i,s,new P,c,f,new P,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new P(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=d;function y(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const c of r)c.keys.forEach(f=>e.add(f)),c.overrides.forEach(([f,E])=>{const w=(0,L.getOrSet)(i,f,new Set);E.forEach(T=>w.add(T))});const s=[];return i.forEach((c,f)=>s.push([f,[...c.values()]])),{keys:[...e.values()],overrides:s}}t.mergeChanges=y;class a{constructor(e,i,s,c){this.change=e,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=c,this._previousConfiguration=void 0;const f=new Set;e.keys.forEach(w=>f.add(w)),e.overrides.forEach(([,w])=>w.forEach(T=>f.add(T))),this.affectedKeys=[...f.values()];const E=new P;this.affectedKeys.forEach(w=>E.setValue(w,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!b.equals(s,c)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let s=(0,I.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof s=="object"&&(c=Object.keys(s)[0]);){if(e=e[c],!e)return!1;s=s[c]}return!0}}t.ConfigurationChangeEvent=a;class m extends a{constructor(e,i,s,c){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=s,this.sourceConfig=c}}t.AllKeysConfigurationChangeEvent=m;function o(r,e){const{added:i,removed:s,updated:c}=n(e,r),f=[],E=r?.getAllOverrideIdentifiers()||[],w=e?.getAllOverrideIdentifiers()||[];if(e){const T=w.filter(F=>!E.includes(F));for(const F of T)f.push([F,e.getKeysForOverrideIdentifier(F)])}if(r){const T=E.filter(F=>!w.includes(F));for(const F of T)f.push([F,r.getKeysForOverrideIdentifier(F)])}if(e&&r){for(const T of E)if(w.includes(T)){const F=n({contents:r.getOverrideValue(void 0,T)||{},keys:r.getKeysForOverrideIdentifier(T)},{contents:e.getOverrideValue(void 0,T)||{},keys:e.getKeysForOverrideIdentifier(T)});f.push([T,[...F.added,...F.removed,...F.updated]])}}return{added:i,removed:s,updated:c,overrides:f}}function n(r,e){const i=r?e?r.keys.filter(f=>e.keys.indexOf(f)===-1):[...r.keys]:[],s=e?r?e.keys.filter(f=>r.keys.indexOf(f)===-1):[...e.keys]:[],c=[];if(r&&e){for(const f of e.keys)if(r.keys.indexOf(f)!==-1){const E=(0,I.getConfigurationValue)(e.contents,f),w=(0,I.getConfigurationValue)(r.contents,f);b.equals(E,w)||c.push(f)}}return{added:i,removed:s,updated:c}}}),define(Q[105],Z([0,1,3,8,2,18,25,104,34,30]),function(z,t,C,D,S,R,L,b,u,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class I extends S.Disposable{constructor(g,P){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,P)),this.configuration=new b.Configuration(new b.DefaultConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:p})=>this.onDidDefaultConfigurationChange(p))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new b.Configuration(new b.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,P){const p=typeof g=="string"?g:void 0,h=(0,L.isConfigurationOverrides)(g)?g:(0,L.isConfigurationOverrides)(P)?P:{};return this.configuration.getValue(p,h,void 0)}updateValue(g,P,p,h){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const P=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(p,P,1)}onDidDefaultConfigurationChange(g){const P=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(new b.DefaultConfigurationModel,g);this.trigger(p,P,6)}trigger(g,P,p){const h=new b.ConfigurationChangeEvent(g,{data:P},this.configuration);h.source=p,h.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=I}),define(Q[106],Z([0,1,10]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function D(v){return v.scheme===C.Schemas.vscodeRemote?v.authority:void 0}t.getRemoteAuthority=D;function S(v){if(!v)return;const I=v.indexOf("+");return I<0?v:v.substr(0,I)}t.getRemoteName=S;function R(v){return v.scheme!==C.Schemas.file&&v.scheme!==C.Schemas.vscodeRemote}t.isVirtualResource=R;function L(v){if(v.folders.length)return v.folders.every(I=>R(I.uri))?v.folders[0].uri:void 0;if(v.configuration&&R(v.configuration))return v.configuration}t.getVirtualWorkspaceLocation=L;function b(v){return L(v)?.scheme}t.getVirtualWorkspaceScheme=b;function u(v){return L(v)!==void 0}t.isVirtualWorkspace=u}),define(Q[40],Z([0,1,26,12,106]),function(z,t,C,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=R;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(b=t.ExtensionType||(t.ExtensionType={}));class u{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,p){if(typeof P=="undefined"||P===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof P=="string"||typeof p=="string"){let h=typeof P=="string"?P:P.value,l=typeof p=="string"?p:p.value;return C.equalsIgnoreCase(h,l)}return P._lower===p._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}t.ExtensionIdentifier=u;function v(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=v;function I(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=I;function O(g,P){if(P){const p=`onResolveRemoteAuthority:${(0,S.getRemoteName)(P)}`;return g.activationEvents?.indexOf(p)!==-1}return!1}t.isResolverExtension=O,t.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,26,40]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(p,h){return p.uuid&&h.uuid?p.uuid===h.uuid:p.id===h.id?!0:(0,C.compareIgnoreCase)(p.id,h.id)===0}t.areSameExtensions=S;class R{constructor(h,l){this.version=l,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof R?S(this,h)&&this.version===h.version:!1}}t.ExtensionIdentifierWithVersion=R;function L(p,h){return`${p}.${h}`}t.getExtensionId=L;function b(p){return p.toLocaleLowerCase()}t.adoptToGalleryExtensionId=b;function u(p,h){return b(L(p,h))}t.getGalleryExtensionId=u;function v(p,h){const l=[],d=y=>{for(const a of l)if(a.some(m=>S(h(m),h(y))))return a;return null};for(const y of p){const a=d(y);a?a.push(y):l.push([y])}return l}t.groupByExtension=v;function I(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=I;function O(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}t.getGalleryExtensionTelemetryData=O,t.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function g(p){const h=new Set;if(p.malicious)for(const l of p.malicious)h.add(l.id);return h}t.getMaliciousExtensionsSet=g;function P(p,h){const l=[],d=h.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const y=d.shift();if(y&&l.every(a=>!S(a.identifier,{id:y}))){const a=p.filter(m=>S(m.identifier,{id:y}));a.length===1&&(l.push(a[0]),d.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}t.getExtensionDependencies=P}),define(Q[107],Z([0,1,24,6,61,10,41,9,76,22,23,40]),function(z,t,C,D,S,R,L,b,u,v,I,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const g=y=>(0,u.localize)(0,null,y),P=(0,u.localize)(1,null,"ms-dotnettools.csharp");function p(y,a){return a?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function l(y){const a=h.exec(y);return a&&a[1]?[(0,I.adoptToGalleryExtensionId)(a[1]),a[2]]:[(0,I.adoptToGalleryExtensionId)(y),void 0]}t.getIdAndVersion=l;let d=class{constructor(a,m){this.extensionManagementService=a,this.extensionGalleryService=m}get location(){}async listExtensions(a,m,o=console){let n=await this.extensionManagementService.getInstalled(1);const r=O.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(m&&m!==""){if(r.indexOf(m.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(i=>i.manifest.categories?i.manifest.categories.map(c=>c.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){o.log("Possible Categories: "),r.forEach(i=>{o.log(i)});return}this.location&&o.log((0,u.localize)(2,null,this.location)),n=n.sort((i,s)=>i.identifier.id.localeCompare(s.identifier.id));let e;for(let i of n)e!==i.identifier.id&&(e=i.identifier.id,o.log(p(i.manifest,a)))}async installExtensions(a,m,o,n,r=console){const e=[],i=[];a.length&&r.log(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const s=await this.extensionManagementService.getInstalled(1),c=(w,T)=>{const F=s.find(W=>(0,I.areSameExtensions)(W.identifier,{id:w}));if(F){if(!T&&!n)return r.log((0,u.localize)(5,null,w,F.manifest.version,w)),!1;if(T&&F.manifest.version===T)return r.log((0,u.localize)(6,null,`${w}@${T}`)),!1}return!0},f=[],E=[];for(const w of a)if(w instanceof b.URI)f.push(w);else{const[T,F]=l(w);c(T,F)&&E.push({id:T,version:F,installOptions:{...o,isBuiltin:!1}})}for(const w of m){const[T,F]=l(w);c(T,F)&&E.push({id:T,version:F,installOptions:{...o,isBuiltin:!0}})}if(f.length&&await Promise.all(f.map(async w=>{try{const T=await this.installVSIX(w,{...o,isBuiltin:!1},n,r);T&&i.push(T)}catch(T){r.error(T.message||T.stack||T),e.push(w.toString())}})),E.length){const w=await this.getGalleryExtensions(E);await Promise.all(E.map(async T=>{const F=w.get(T.id.toLowerCase());if(F)try{const W=await this.installFromGallery(T,F,s,n,r);W&&i.push(W)}catch(W){r.error(W.message||W.stack||W),e.push(T.id)}else r.error(`${g(T.version?`${T.id}@${T.version}`:T.id)}
${P}`),e.push(T.id)}))}if(e.length)throw new Error((0,u.localize)(7,null,e.join(", ")))}async installVSIX(a,m,o,n){const r=await this.extensionManagementService.getManifest(a);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,o,n))try{return await this.extensionManagementService.install(a,m),n.log((0,u.localize)(8,null,(0,S.getBaseLabel)(a))),r}catch(i){if((0,D.isCancellationError)(i))return n.log((0,u.localize)(9,null,(0,S.getBaseLabel)(a))),null;throw i}return null}async getGalleryExtensions(a){const m=new Map,o=await this.extensionGalleryService.getExtensions(a,a.some(n=>n.installOptions.installPreReleaseVersion),C.CancellationToken.None);for(const n of o)m.set(n.identifier.id.toLowerCase(),n);return m}async installFromGallery({id:a,version:m,installOptions:o},n,r,e,i){const s=await this.extensionGalleryService.getManifest(n,C.CancellationToken.None);if(s&&!this.validateExtensionKind(s,i))return null;const c=r.find(f=>(0,I.areSameExtensions)(f.identifier,n.identifier));if(c){if(n.version===c.manifest.version)return i.log((0,u.localize)(10,null,m?`${a}@${m}`:a)),null;i.log((0,u.localize)(11,null,a,n.version))}try{return o.isBuiltin?i.log(m?(0,u.localize)(12,null,a,m):(0,u.localize)(13,null,a)):i.log(m?(0,u.localize)(14,null,a,m):(0,u.localize)(15,null,a)),await this.extensionManagementService.installFromGallery(n,{...o,installGivenVersion:!!m}),i.log((0,u.localize)(16,null,a,n.version)),s}catch(f){if((0,D.isCancellationError)(f))return i.log((0,u.localize)(17,null,a)),null;throw f}}validateExtensionKind(a,m){return!0}async validateVSIX(a,m,o){const n={id:(0,I.getGalleryExtensionId)(a.publisher,a.name)},e=(await this.extensionManagementService.getInstalled(1)).find(i=>(0,I.areSameExtensions)(n,i.identifier)&&(0,L.gt)(i.manifest.version,a.version));return e&&!m?(o.log((0,u.localize)(18,null,e.identifier.id,e.manifest.version,a.version)),!1):this.validateExtensionKind(a,o)}async uninstallExtensions(a,m,o=console){const n=async e=>{if(e instanceof b.URI){const i=await this.extensionManagementService.getManifest(e);return p(i)}return e},r=[];for(const e of a){const i=await n(e),c=(await this.extensionManagementService.getInstalled()).filter(f=>(0,I.areSameExtensions)(f.identifier,{id:i}));if(!c.length)throw new Error(`${this.notInstalled(i)}
${P}`);if(c.some(f=>f.type===0)){o.log((0,u.localize)(19,null,i));return}if(!m&&c.some(f=>f.isBuiltin)){o.log((0,u.localize)(20,null,i));return}o.log((0,u.localize)(21,null,i));for(const f of c)await this.extensionManagementService.uninstall(f),r.push(f);this.location?o.log((0,u.localize)(22,null,i,this.location)):o.log((0,u.localize)(23,null,i))}}async locateExtension(a,m=console){const o=await this.extensionManagementService.getInstalled();a.forEach(n=>{o.forEach(r=>{if(r.identifier.id===n&&r.location.scheme===R.Schemas.file){m.log(r.location.fsPath);return}})})}notInstalled(a){return this.location?(0,u.localize)(24,null,a,this.location):(0,u.localize)(25,null,a)}};d=ve([ae(0,v.IExtensionManagementService),ae(1,v.IExtensionGalleryService)],d),t.ExtensionManagementCLIService=d}),define(Q[108],Z([0,1,3,6,2,14,18,41,9,27,15,20,22,23,16,13]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P,p,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const l=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let d=class extends S.Disposable{constructor(a,m,o,n){super();this.fileService=m,this.extensionGalleryService=o,this.logService=n,this.extensionsDownloadDir=u.URI.file(a.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(a,m){await this.cleanUpPromise;const o=this.getName(a),n=(0,L.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(n)){const r=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(a,r,m);try{await this.rename(r,n,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",a.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return n}async delete(a){await this.cleanUpPromise,await this.fileService.del(a)}async rename(a,m,o){try{await I.Promises.rename(a.fsPath,m.fsPath)}catch(n){if(R.isWindows&&n&&n.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${a} to ${m} with 'EPERM' error. Trying again...`),this.rename(a,m,o);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const a=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(a.children){const m=[],o=[];for(const e of a.children){const i=this.parse(e.name);i&&o.push([i,e])}const n=(0,P.groupByExtension)(o,([e])=>e),r=[];for(const e of n)e.sort((i,s)=>b.rcompare(i[0].version,s[0].version)),m.push(...e.slice(1).map(i=>i[1].resource)),r.push(e[0][1]);r.sort((e,i)=>e.mtime-i.mtime),m.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await C.Promises.settled(m.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(a){this.logService.error(a)}}getName(a){return this.cache?`${new P.ExtensionIdentifierWithVersion(a.identifier,a.version).key().toLowerCase()}${a.properties.targetPlatform!=="undefined"?`-${a.properties.targetPlatform}`:""}`:(0,v.generateUuid)()}parse(a){const m=l.exec(a);return m&&m[1]&&m[2]?new P.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};d=ve([ae(0,O.INativeEnvironmentService),ae(1,p.IFileService),ae(2,g.IExtensionGalleryService),ae(3,h.ILogService)],d),t.ExtensionsDownloader=d}),define(Q[109],Z([0,1,2,11,15,40]),function(z,t,C,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class L extends C.Disposable{constructor(u,v){super();this.environmentService=u,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(v.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(u){u.some(v=>!!v.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=L}),define(Q[110],Z([0,1,135,19,3,2,10,11,15,20,22,23,52,13]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let p=class extends R.Disposable{constructor(d,y,a){super();this.extensionManagementService=d,this.logService=a,this.cache=this._register(new h(y,a)),this.extensionManagementService.registerParticipant({postInstall:async m=>this.postInstallExtension(m),postUninstall:async m=>this.postUninstallExtension(m)})}async getLanguageIds(){const d=await this.cache.getLanguagePacks(),y=["en",...Object.keys(d)];return(0,D.distinct)(y)}async postInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",d.identifier.id),await this.update())}async postUninstallExtension(d){const y=await this.cache.getLanguagePacks();Object.keys(y).some(a=>y[a]&&y[a].extensions.some(m=>(0,O.areSameExtensions)(m.extensionIdentifier,d.identifier)))&&(this.logService.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(y);return!(0,D.equals)(Object.keys(d),Object.keys(a))}};p=ve([ae(0,I.IExtensionManagementService),ae(1,v.INativeEnvironmentService),ae(2,P.ILogService)],p),t.LocalizationsService=p;let h=class extends R.Disposable{constructor(d,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(y=>{Object.keys(y).forEach(a=>delete y[a]),this.createLanguagePacksFromExtensions(y,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,...y){for(const a of y)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,a);Object.keys(d).forEach(a=>this.updateHash(d[a]))}createLanguagePacksFromExtension(d,y){const a=y.identifier,m=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const o of m)if(y.location.scheme===L.Schemas.file&&(0,g.isValidLocalization)(o)){let n=d[o.languageId];n||(n={hash:"",extensions:[],translations:{}},d[o.languageId]=n);let r=n.extensions.filter(e=>(0,O.areSameExtensions)(e.extensionIdentifier,a))[0];r?r.version=y.manifest.version:n.extensions.push({extensionIdentifier:a,version:y.manifest.version});for(const e of o.translations)n.translations[e.id]=(0,b.join)(y.location.fsPath,e.path)}}updateHash(d){if(d){const y=(0,C.createHash)("md5");for(const a of d.extensions)y.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);d.hash=y.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(y=d(a),a)).then(a=>{for(const o of Object.keys(a))a[o]||delete a[o];this.languagePacks=a,this.initializedCache=!0;const m=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",m),u.Promises.writeFile(this.languagePacksFilePath,m)}).then(()=>y,a=>this.logService.error(a))})}};h=ve([ae(0,v.INativeEnvironmentService),ae(1,P.ILogService)],h)}),define(Q[42],Z([0,1,17,84,34,12,30]),function(z,t,C,D,S,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,R.createDecorator)("requestService");function b(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}t.isSuccess=b;function u(p){return p.res.statusCode===204}async function v(p){if(!b(p))throw new Error("Server returned "+p.res.statusCode);return u(p)?null:(await(0,C.streamToBuffer)(p.stream)).toString()}t.asText=v;async function I(p){if(!b(p))throw new Error("Server returned "+p.res.statusCode);if(u(p))return null;const l=(await(0,C.streamToBuffer)(p.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}t.asJson=I;function O(p){P(p)}t.updateProxyConfigurationsScope=O;let g;function P(p){const h=L.Registry.as(S.Extensions.Configuration),l=g;g={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[g],remove:l?[l]:[]})}P(2)}),define(Q[111],Z([0,1,24,10,16,42]),function(z,t,C,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let L=class{constructor(u,v){this.requestService=u,this.fileService=v}async download(u,v,I=C.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(u,v);return}const O={type:"GET",url:u.toString()},g=await this.requestService.request(O,I);if(g.res.statusCode===200)await this.fileService.writeFile(v,g.stream);else{const P=await(0,R.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${P}`)}}};L=ve([ae(0,R.IRequestService),ae(1,S.IFileService)],L),t.DownloadService=L}),define(Q[112],Z([0,1,113,7]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(L,b){return L.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:L.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function R(L,b,u={}){const v=(0,C.parse)(L),I=u.proxyUrl||S(v,b);if(!I)return null;const O=(0,C.parse)(I);if(!/^https?:$/.test(O.protocol||""))return null;const g={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((P,p)=>{z(["http-proxy-agent"],P,p)}))(g):new(await new Promise((P,p)=>{z(["https-proxy-agent"],P,p)}))(g)}t.getProxyAgent=R}),define(Q[114],Z([0,1,17,27]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(R,L,b){let u=b&&b.get("storage.serviceMachineId",0)||null;if(u)return u;try{const I=(await L.readFile(R.serviceMachineIdResource)).value.toString();u=(0,D.isUUID)(I)?I:null}catch{u=null}if(!u){u=(0,D.generateUuid)();try{await L.writeFile(R.serviceMachineIdResource,C.VSBuffer.fromString(u))}catch{}}return b&&b.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=S}),define(Q[115],Z([0,1,3,8,2,99,7,64,12]),function(z,t,C,D,S,R,L,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";t.IStorageService=(0,u.createDecorator)("storageService");var I;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(I=t.WillSaveStateReason||(t.WillSaveStateReason={}));var O;(function(l){l[l.GLOBAL=0]="GLOBAL",l[l.WORKSPACE=1]="WORKSPACE"})(O=t.StorageScope||(t.StorageScope={}));var g;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(g=t.StorageTarget||(t.StorageTarget={}));class P extends S.Disposable{constructor(d={flushInterval:P.DEFAULT_FLUSH_INTERVAL}){super();this.options=d,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,y){y===v?(d===0?this._globalKeyTargets=void 0:d===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:d})):this._onDidChangeValue.fire({scope:d,key:y,target:this.getKeyTargets(d)[y]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,y,a){return this.getStorage(y)?.get(d,a)}getBoolean(d,y,a){return this.getStorage(y)?.getBoolean(d,a)}getNumber(d,y,a){return this.getStorage(y)?.getNumber(d,a)}store(d,y,a,m){if((0,L.isUndefinedOrNull)(y)){this.remove(d,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,a,m),this.getStorage(a)?.set(d,y)})}remove(d,y){this.withPausedEmitters(()=>{this.updateKeyTarget(d,y,void 0),this.getStorage(y)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,y){const a=[],m=this.getKeyTargets(d);for(const o of Object.keys(m))m[o]===y&&a.push(o);return a}updateKeyTarget(d,y,a){const m=this.getKeyTargets(y);typeof a=="number"?m[d]!==a&&(m[d]=a,this.getStorage(y)?.set(v,JSON.stringify(m))):typeof m[d]=="number"&&(delete m[d],this.getStorage(y)?.set(v,JSON.stringify(m)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(d){return d===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(d){const y=this.get(v,d);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}isNew(d){return this.getBoolean(t.IS_NEW_KEY,d)===!0}async flush(d=I.NONE){this._onWillSaveState.fire({reason:d});const y=this.getStorage(0),a=this.getStorage(1);switch(d){case I.NONE:await C.Promises.settled([y?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await C.Promises.settled([y?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async logStorage(){const d=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return h(d,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=P,P.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends P{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.globalStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d)))}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(d){}}t.InMemoryStorageService=p;async function h(l,d,y,a){const m=c=>{try{return JSON.parse(c)}catch{return c}},o=new Map,n=new Map;l.forEach((c,f)=>{o.set(f,c),n.set(f,m(c))});const r=new Map,e=new Map;d.forEach((c,f)=>{r.set(f,c),e.set(f,m(c))}),console.group(`Storage: Global (path: ${y})`);let i=[];o.forEach((c,f)=>{i.push({key:f,value:c})}),console.table(i),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${a})`);let s=[];r.forEach((c,f)=>{s.push({key:f,value:c})}),console.table(s),console.groupEnd(),console.log(e)}t.logStorage=h}),define(Q[116],Z([0,1,14,29,9,27]),function(z,t,C,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function L(v){if(C.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function b(v,I,O,g,P,p,h,l,d,y){const a=Object.create(null);a["common.machineId"]=h,a.sessionID=(0,R.generateUuid)()+Date.now(),a.commitHash=P,a.version=p,a["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,C.PlatformToString)(C.platform),a["common.nodePlatform"]=D.platform,a["common.nodeArch"]=g,a["common.product"]=y||"desktop";const m=u(l||[]);m&&(a["common.msftInternal"]=m);let o=0;const n=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),C.isLinuxSnap&&(a["common.snap"]="true");const r=L(O);r&&(a["common.platformDetail"]=r);try{const e=await v.readFile(S.URI.file(d));a["common.source"]=e.value.toString().slice(0,30)}catch{}return a}t.resolveCommonProperties=b;function u(v){const I=D.env.USERDNSDOMAIN;if(!I)return!1;const O=I.toLowerCase();return v.some(g=>O===g)}t.verifyMicrosoftInternalDomain=u}),define(Q[31],Z([0,1,12]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(D=t.TelemetryLevel||(t.TelemetryLevel={}));var S;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(S=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Q[117],Z([0,1,19,3,24,6,8,2,14,7,9,74,22,23,13,32,31]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P,p,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let d=class extends b.Disposable{constructor(r,e,i,s){super();this.galleryService=r,this.telemetryService=e,this.logService=i,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(c=>c.cancel()),this.uninstallingExtensions.forEach(c=>c.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const e=await this.getTargetPlatform();return r.allTargetPlatforms.some(i=>(0,g.isTargetPlatformCompatible)(i,r.allTargetPlatforms,e))}async installFromGallery(r,e={}){try{if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(O.localize(0,null),g.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,e)}catch(i){throw m(this.telemetryService,"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(r),void 0,i),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(i),a(i)}}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(O.localize(1,null));const e=await this.findGalleryExtension(r);if(!e)throw new Error(O.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,i){if(!I.URI.isUri(e)){let w=this.installingExtensions.get(new P.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(w)return this.logService.info("Extensions is already requested to install",e.identifier.id),w.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],c=[],f=this.createInstallExtensionTask(r,e,i);I.URI.isUri(e)||this.installingExtensions.set(new P.ExtensionIdentifierWithVersion(f.identifier,r.version).key(),f),this._onInstallExtension.fire({identifier:f.identifier,source:e}),this.logService.info("Installing extension:",f.identifier.id),s.push({task:f,manifest:r});let E=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",f.identifier.id);else try{const T=await this.getAllDepsAndPackExtensionsToInstall(f.identifier,r,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:F,manifest:W}of T)if(E=E||!!W.extensionDependencies?.some(J=>(0,P.areSameExtensions)({id:J},f.identifier)),this.installingExtensions.has(new P.ExtensionIdentifierWithVersion(F.identifier,F.version).key()))this.logService.info("Extension is already requested to install",F.identifier.id);else{const J=this.createInstallExtensionTask(W,F,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new P.ExtensionIdentifierWithVersion(J.identifier,W.version).key(),J),this._onInstallExtension.fire({identifier:J.identifier,source:F}),this.logService.info("Installing extension:",J.identifier.id),s.push({task:J,manifest:W})}}catch(T){if(I.URI.isUri(f.source))(0,C.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",f.identifier.id,T.message),(0,C.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",f.identifier.id,T.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",f.identifier.id),T}const w=s.reduce((T,{task:F,manifest:W})=>(T.set(F.identifier.id.toLowerCase(),{task:F,manifest:W}),T),new Map);for(;w.size;){let T;const F=[...w.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(J=>w.has(J.toLowerCase())));F.length?T=w.size===1?F:F.filter(({task:W})=>!(W===f&&!E)):(this.logService.info("Found extensions with circular dependencies",F.map(({task:W})=>W.identifier.id)),T=[...w.values()]),await this.joinAllSettled(T.map(async({task:W})=>{const J=new Date().getTime(),se=(0,v.isUndefined)(i.operation)?W.operation:i.operation;try{const ie=await W.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(ie,W.source,i,S.CancellationToken.None))),!I.URI.isUri(W.source)&&(m(this.telemetryService,se===3?"extensionGallery:update":"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(W.source),new Date().getTime()-J,void 0),u.isWeb&&se!==3))try{await this.galleryService.reportStatistic(ie.manifest.publisher,ie.manifest.name,ie.manifest.version,"install")}catch{}c.push({local:ie,identifier:W.identifier,operation:se,source:W.source})}catch(ie){throw I.URI.isUri(W.source)||m(this.telemetryService,se===3?"extensionGallery:update":"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(W.source),new Date().getTime()-J,ie),this.logService.error("Error while installing the extension:",W.identifier.id),ie}finally{w.delete(W.identifier.id.toLowerCase())}}))}return c.forEach(({identifier:T})=>this.logService.info("Extension installed successfully:",T.id)),this._onDidInstallExtensions.fire(c),c.filter(({identifier:T})=>(0,P.areSameExtensions)(T,f.identifier))[0].local}catch(w){if(s.forEach(({task:T})=>T.cancel()),c.length)try{const T=await Promise.allSettled(c.map(({local:F})=>this.createUninstallExtensionTask(F,{versionOnly:!0}).run()));for(let F=0;F<T.length;F++){const W=T[F],{identifier:J}=c[F];W.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,R.getErrorMessage)(W.reason))}}catch(T){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(T),c.map(({identifier:F})=>F.id))}throw this._onDidInstallExtensions.fire(s.map(({task:T})=>({identifier:T.identifier,operation:2,source:T.source}))),w}finally{for(const{task:w,manifest:T}of s)if(!I.URI.isUri(w.source)){const F=new P.ExtensionIdentifierWithVersion(w.identifier,T.version).key();this.installingExtensions.delete(F)||this.logService.warn("Installation task is not found in the cache",F)}}}async joinAllSettled(r){const e=[],i=[],s=await Promise.allSettled(r);for(const c of s)c.status==="fulfilled"?e.push(c.value):i.push(c.reason);if(i.length)throw y(i);return e}async getAllDepsAndPackExtensionsToInstall(r,e,i,s){if(!this.galleryService.isEnabled())return[];let c=await this.getInstalled();const f=[r,...c.map(T=>T.identifier)],E=[],w=async(T,F)=>{const W=F.extensionDependencies||[],J=[...W];if(F.extensionPack){const se=i?c.find(ie=>(0,P.areSameExtensions)(ie.identifier,T)):void 0;for(const ie of F.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(te=>(0,P.areSameExtensions)({id:te},{id:ie}))||J.every(te=>!(0,P.areSameExtensions)({id:te},{id:ie}))&&J.push(ie)}if(J.length){const se=[...f,...E.map(te=>te.gallery.identifier)],ie=J.filter(te=>se.every(ge=>!(0,P.areSameExtensions)(ge,{id:te})));if(ie.length){const te=await this.galleryService.query({names:ie,pageSize:J.length},S.CancellationToken.None);for(const ge of te.firstPage){if(se.find(re=>(0,P.areSameExtensions)(re,ge.identifier)))continue;const B=W.some(re=>(0,P.areSameExtensions)({id:re},ge.identifier));let $;try{$=await this.checkAndGetCompatibleVersion(ge,!0,s)}catch(re){if(re instanceof g.ExtensionManagementError&&re.code===g.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!B){this.logService.info("Skipping the packed extension as it cannot be installed",ge.identifier.id);continue}else throw re}E.push({gallery:$.extension,manifest:$.manifest}),await w($.extension.identifier,F)}}}};return await w(r,e),c=await this.getInstalled(),E.filter(T=>!c.some(F=>(0,P.areSameExtensions)(F.identifier,T.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e,i){const s=await this.getExtensionsControlManifest();if((0,P.getMaliciousExtensionsSet)(s).has(r.identifier.id))throw new g.ExtensionManagementError(O.localize(3,null,r.identifier.id),g.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[r.identifier.id])throw new g.ExtensionManagementError(O.localize(4,null,r.identifier.id,s.unsupportedPreReleaseExtensions[r.identifier.id].displayName),g.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const E=await this.getTargetPlatform();throw new g.ExtensionManagementError(O.localize(5,null,r.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(E)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(r,e,i);if(c){if(i&&r.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new g.ExtensionManagementError(O.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new g.ExtensionManagementError(O.localize(7,null,r.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const f=await this.galleryService.getManifest(c,S.CancellationToken.None);if(f===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(f.version!==c.version)throw new g.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:f}}async getCompatibleVersion(r,e,i){const s=await this.getTargetPlatform();let c=null;return e&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==i&&(c=await this.galleryService.getCompatibleExtension(r.identifier,i,s)),!c&&await this.galleryService.isExtensionCompatible(r,i,s)&&(c=r),!c&&e&&(c=await this.galleryService.getCompatibleExtension(r,i,s)),c}async unininstallExtension(r,e){const i=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),i.waitUntilTaskIsFinished();const s=(w,T)=>{const F=this.createUninstallExtensionTask(w,T);return this.uninstallingExtensions.set(F.extension.identifier.id.toLowerCase(),F),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),F},c=(w,T)=>{T?this.logService.error("Failed to uninstall extension:",w.identifier.id,T.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,P.getLocalExtensionTelemetryData)(w),void 0,T),this._onDidUninstallExtension.fire({identifier:w.identifier,error:T?.code})},f=[],E=[];try{f.push(s(r,{}));const w=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const T=this.getAllPackExtensionsToUninstall(r,w);for(const F of T)this.uninstallingExtensions.has(F.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",F.identifier.id):f.push(s(F,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(f.map(T=>T.extension),w,r),await this.joinAllSettled(f.map(async T=>{try{if(await T.run(),await this.joinAllSettled(this.participants.map(F=>F.postUninstall(T.extension,e,S.CancellationToken.None))),T.extension.identifier.uuid)try{await this.galleryService.reportStatistic(T.extension.manifest.publisher,T.extension.manifest.name,T.extension.manifest.version,"uninstall")}catch{}c(T.extension)}catch(F){const W=F instanceof g.ExtensionManagementError?F:new g.ExtensionManagementError((0,R.getErrorMessage)(F),g.ExtensionManagementErrorCode.Internal);throw c(T.extension,W),W}finally{E.push(T)}}))}catch(w){const T=w instanceof g.ExtensionManagementError?w:new g.ExtensionManagementError((0,R.getErrorMessage)(w),g.ExtensionManagementErrorCode.Internal);for(const F of f){try{F.cancel()}catch{}E.includes(F)||c(F.extension,T)}throw T}finally{for(const w of f)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(r,e,i){for(const s of r){const c=this.getDependents(s,e);if(c.length){const f=c.filter(E=>!r.some(w=>(0,P.areSameExtensions)(w.identifier,E.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(s,f,i))}}}getDependentsErrorMessage(r,e,i){return i===r?e.length===1?O.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(9,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(10,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?O.localize(11,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(12,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(13,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,i=[]){if(i.indexOf(r)!==-1)return[];i.push(r);const s=r.manifest.extensionPack?r.manifest.extensionPack:[];if(s.length){const c=e.filter(E=>!E.isBuiltin&&s.some(w=>(0,P.areSameExtensions)({id:w},E.identifier))),f=[];for(const E of c)f.push(...this.getAllPackExtensionsToUninstall(E,e,i));return[...c,...f]}return[]}getDependents(r,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(s=>(0,P.areSameExtensions)({id:s},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const e=await this.findGalleryExtensionById(r.identifier.uuid);return e||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};d=ve([ae(0,g.IExtensionGalleryService),ae(1,l.ITelemetryService),ae(2,p.ILogService),ae(3,h.IProductService)],d),t.AbstractExtensionManagementService=d;function y(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=y;function a(n){if(n instanceof g.ExtensionManagementError)return n;const r=new g.ExtensionManagementError(n.message,g.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}function m(n,r,e,i,s){const c=s?s instanceof g.ExtensionManagementError?s.code:g.ExtensionManagementErrorCode.Internal:void 0;n.publicLogError(r,{...e,success:!s,duration:i,errorcode:c})}t.reportTelemetry=m;class o{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(r=>new Promise((e,i)=>{const s=r.onCancellationRequested(()=>{s.dispose(),i((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=o}),define(Q[35],Z([0,1,21,7,25,31]),function(z,t,C,D,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(d,y){return Promise.resolve(void 0)}publicLog2(d,y){return this.publicLog(d,y)}publicLogError(d,y){return Promise.resolve(void 0)}publicLogError2(d,y){return this.publicLogError(d,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=L,t.NullTelemetryService=new L;class b{async publicLog(d,y,a){}async publicLogError(d,y,a){}}t.NullEndpointTelemetryService=b,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(l,d){return d.onDidChangeConfiguration(y=>{y.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(y.source),configurationKeys:p(y.sourceConfig)})})}t.configurationTelemetry=u;function v(l,d){return!(d.disableTelemetry||!l.enableTelemetry)}t.supportsTelemetry=v;function I(l){const d=l.getValue(R.TELEMETRY_SETTING_ID),y=l.getValue("telemetry.enableCrashReporter");if(l.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=I;function O(l){const d=Object.create(null),y=Object.create(null),a=Object.create(null);P(l,a);for(let m in a){m=m.length>150?m.substr(m.length-149):m;const o=a[m];typeof o=="number"?y[m]=o:typeof o=="boolean"?y[m]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${o.length}`),d[m]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(d[m]=o)}return{properties:d,measurements:y}}t.validateTelemetryData=O;function g(l){if(!l)return"none";let d="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(a=>{l.indexOf(`${a}+`)===0&&(d=a)}),d}t.cleanRemoteAuthority=g;function P(l,d,y=0,a){if(!!l)for(let m of Object.getOwnPropertyNames(l)){const o=l[m],n=a?a+m:m;Array.isArray(o)?d[n]=(0,C.safeStringify)(o):o instanceof Date?d[n]=o.toISOString():(0,D.isObject)(o)?y<2?P(o,d,y+1,n+"."):d[n]=(0,C.safeStringify)(o):d[n]=o}}function p(l){if(!l)return[];const d=[];return h(d,"",l),d}function h(l,d,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(a=>h(l,d?`${d}.${a}`:a,y[a])):l.push(d)}}),define(Q[118],Z([0,1,19,24,6,21,14,29,7,9,25,20,22,23,48,16,13,32,42,114,115,31,35]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P,p,h,l,d,y,a,m,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const r=L.isWeb?"web":(0,g.getTargetPlatform)(L.platform,b.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(e||(e={}));function i(...U){return String(U.reduce((N,_)=>N|_,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class T{constructor(N=w){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,_=this.state.pageSize){return new T({...this.state,pageNumber:N,pageSize:_})}withFilter(N,..._){const x=[...this.state.criteria,..._.length?_.map(K=>({filterType:N,value:K})):[{filterType:N}]];return new T({...this.state,criteria:x})}withSortBy(N){return new T({...this.state,sortBy:N})}withSortOrder(N){return new T({...this.state,sortOrder:N})}withFlags(...N){return new T({...this.state,flags:N.reduce((_,x)=>_|x,0)})}withAssetTypes(...N){return new T({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:_,pageSize:x,sortBy:K,sortOrder:Y,flags:de,assetTypes:ce}=this.state;return{filters:[{criteria:N,pageNumber:_,pageSize:x,sortBy:K,sortOrder:Y}],assetTypes:ce,flags:de}}get searchText(){const N=this.state.criteria.filter(_=>_.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function F(U,N){const _=(U||[]).filter(x=>x.statisticName===N)[0];return _?_.value:0}function W(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(x=>x.assetType.indexOf(N)===0).reduce((x,K)=>{const Y=te(U,K.assetType);return Y&&x.push([K.assetType.substring(N.length),Y]),x},[])}function J(U){if(U.properties){const N=U.properties.filter(K=>K.key===c.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=N.filter(K=>_.test(K.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return te(U,c.Repository)}function se(U){return{uri:`${U.fallbackAssetUri}/${c.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${c.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ie(U){const N=te(U,c.Icon);if(N)return N;const _=g.DefaultIconPath;return{uri:_,fallbackUri:_}}function te(U,N){return U.files.filter(x=>x.assetType===N)[0]?{uri:`${U.assetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ge(U,N){const _=U.properties?U.properties.filter(K=>K.key===N):[],x=_.length>0&&_[0].value;return x?x.split(",").map(K=>(0,P.adoptToGalleryExtensionId)(K)):[]}function B(U){const N=U.properties?U.properties.filter(_=>_.key===f.Engine):[];return N.length>0&&N[0].value||""}function $(U){const N=U.properties?U.properties.filter(_=>_.key===f.PreRelease):[];return N.length>0&&N[0].value==="true"}function re(U){const N=U.properties?U.properties.filter(x=>x.key===f.LocalizedLanguages):[],_=N.length>0&&N[0].value||"";return _?_.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function A(U){return U.targetPlatform?(0,g.toTargetPlatform)(U.targetPlatform):"undefined"}function j(U){const N=(0,C.distinct)(U.versions.map(A)),_=!!U.tags?.includes(g.WEB_EXTENSION_TAG),x=N.indexOf("web");return _?x===-1&&N.push("web"):x!==-1&&N.splice(x,1),N}function H(U,N){const _=(0,g.getFallbackTargetPlarforms)(N);for(let x=0;x<U.length;x++){const K=U[x];if(K.version===U[x-1]?.version){let Y=x;const de=A(K);if(de===N)for(;Y>0&&U[Y-1].version===K.version;)Y--;else if(_.includes(de))for(;Y>0&&U[Y-1].version===K.version&&A(U[Y-1])!==N;)Y--;Y!==x&&(U.splice(x,1),U.splice(Y,0,K))}}return U}t.sortExtensionVersions=H;function ne(U,N,_,x,K){const Y=U.versions[0],de={manifest:te(N,c.Manifest),readme:te(N,c.Details),changelog:te(N,c.Changelog),license:te(N,c.License),repository:J(N),download:se(N),icon:ie(N),coreTranslations:W(N)};return{identifier:{id:(0,P.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:F(U.statistics,"install"),rating:F(U.statistics,"averagerating"),ratingCount:F(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:_,assets:de,properties:{dependencies:ge(N,f.Dependency),extensionPack:ge(N,f.ExtensionPack),engine:B(N),localizedLanguages:re(N),targetPlatform:A(N),isPreReleaseVersion:$(N)},hasPreReleaseVersion:$(Y),hasReleaseVersion:x,preview:M(U.flags),telemetryData:K}}let X=class{constructor(N,_,x,K,Y,de,ce,he){this.requestService=_,this.logService=x,this.environmentService=K,this.telemetryService=Y,this.fileService=de,this.productService=ce,this.configurationService=he;const oe=ce.extensionsGallery;this.extensionsGalleryUrl=oe&&oe.serviceUrl,this.extensionsControlUrl=oe&&oe.controlUrl,this.commonHeadersPromise=le(ce.version,ce,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,_,x){const K=(0,u.isBoolean)(_)?_:!1,Y=(0,u.isBoolean)(_)?x:_;let de=new T().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,N.length).withFilter(s.ExtensionName,...N.map(({id:oe})=>oe.toLowerCase()));N.every(oe=>!oe.version)&&(de=de.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:ce}=await this.queryGallery(de,r,D.CancellationToken.None),he=ce.map(oe=>{const pe=(0,P.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName);return{rawGalleryExtension:oe,version:N.find(ue=>(0,P.areSameExtensions)(ue,{id:pe}))?.version,preRelease:K}});return this.converToGalleryExtensions(he,de,r,()=>{},Y)}async getExtensions2(N){const _=[],x=[];for(const ce of N)ce.uuid?x.push(ce.uuid):_.push(ce.id.toLowerCase());let K=new T().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly).withPage(1,N.length);x.length&&(K=K.withFilter(s.ExtensionId,...x)),_.length&&(K=K.withFilter(s.ExtensionId,..._));const{galleryExtensions:Y}=await this.queryGallery(K,r,D.CancellationToken.None),de=Y.map(ce=>{const he=(0,P.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),oe=N.find(pe=>(0,P.areSameExtensions)(pe,{id:he,uuid:ce.extensionId}));return{rawGalleryExtension:ce,preRelease:!!oe?.preRelease}});return this.converToGalleryExtensions(de,K,r,()=>{},D.CancellationToken.None)}async getCompatibleExtension(N,_,x){const K=(0,g.isIExtensionIdentifier)(N)?null:N;if(K){if((0,g.isNotWebExtensionInWebTargetPlatform)(K.allTargetPlatforms,x))return null;if(await this.isExtensionCompatible(K,_,x))return K}const{id:Y,uuid:de}=K?K.identifier:N;let ce=new T().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);de?ce=ce.withFilter(s.ExtensionId,de):ce=ce.withFilter(s.ExtensionName,Y);const{galleryExtensions:he}=await this.queryGallery(ce,x,D.CancellationToken.None),[oe]=he;if(!oe||!oe.versions.length)return null;const pe=j(oe);if((0,g.isNotWebExtensionInWebTargetPlatform)(pe,x))return null;for(let ue of oe.versions){if(!B(ue)){const ye=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:f.Engine,value:ye}]}}if(await this.isRawExtensionVersionCompatible(ue,_,pe,x)){const ye=oe.versions.some(De=>!$(De));return ne(oe,ue,pe,ye)}}return null}async isExtensionCompatible(N,_,x){if(!(0,g.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,x)||!_&&N.properties.isPreReleaseVersion)return!1;let K=N.properties.engine;if(!K){const Y=await this.getManifest(N,D.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");K=Y.engines.vscode}return(0,p.isEngineValid)(K,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,_,x,K){if(!(0,g.isTargetPlatformCompatible)(A(N),x,K)||!_&&$(N))return!1;const Y=await this.getEngine(N);return(0,p.isEngineValid)(Y,this.productService.version,this.productService.date)}async query(N,_){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let x=N.text||"";const K=(0,R.getOrDefault)(N,ue=>ue.pageSize,50);let Y=new T().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,K);x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,De)=>(Y=Y.withFilter(s.Category,De||ye),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,De)=>(Y=Y.withFilter(s.Tag,De||ye),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(s.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),Y=Y.withFilter(s.SearchText,x)),Y=Y.withSortBy(0)):N.ids?Y=Y.withFilter(s.ExtensionId,...N.ids):N.names?Y=Y.withFilter(s.ExtensionName,...N.names):Y=Y.withSortBy(4),typeof N.sortBy=="number"&&(Y=Y.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Y=Y.withSortOrder(N.sortOrder));const{galleryExtensions:de,total:ce}=await this.queryGallery(Y,r,_),he=ue=>({index:(Y.pageNumber-1)*Y.pageSize+ue,querySource:N.source}),oe=await this.converToGalleryExtensions(de.map(ue=>({rawGalleryExtension:ue,preRelease:!!N.includePreRelease})),Y,r,he,_),pe=async(ue,ye)=>{if(ye.isCancellationRequested)throw(0,S.canceled)();const De=Y.withPage(ue+1),{galleryExtensions:Ce}=await this.queryGallery(De,r,ye);return await this.converToGalleryExtensions(Ce.map(Le=>({rawGalleryExtension:Le,preRelease:!!N.includePreRelease})),De,r,he,_)};return{firstPage:oe,total:ce,pageSize:Y.pageSize,getPage:pe}}async converToGalleryExtensions(N,_,x,K,Y){const de=(oe,pe,ue,ye,De)=>{const Ce=!(ue.flags&e.IncludeLatestVersionOnly),Le=j(oe);let Fe=oe.versions[0];return Fe=oe.versions.find(k=>k.version===Fe.version&&(0,g.isTargetPlatformCompatible)(A(k),Le,x))||Fe,Ce&&$(Fe)&&!De&&(Fe=oe.versions.find(k=>k.version!==Fe.version&&!$(k))||Fe),ne(oe,Fe,Le,ye,K(pe))},ce=[],he=new Map;for(let oe=0;oe<N.length;oe++){const{rawGalleryExtension:pe,version:ue,preRelease:ye}=N[oe],De=pe.versions.some(Ce=>!$(Ce));if(ue){const Ce=pe.versions.find(Le=>Le.version===ue);Ce&&ce.push([oe,ne(pe,Ce,j(pe),De)])}else{const Ce=de(pe,oe,_,De,ye);Ce.properties.isPreReleaseVersion?he.set(Ce.identifier.uuid,{index:oe,preRelease:ye}):ce.push([oe,Ce])}}if(he.size){const oe=new Date().getTime(),pe=new T().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,he.size).withFilter(s.ExtensionId,...he.keys()),{galleryExtensions:ue}=await this.queryGallery(pe,x,Y);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-oe,count:he.size}),ue.length!==he.size)throw new Error("Not all extensions with latest versions are returned");for(const ye of ue){const De=ye.versions.some(k=>!$(k)),{index:Ce,preRelease:Le}=he.get(ye.extensionId),Fe=de(ye,Ce,pe,De,Le);ce.push([Ce,Fe])}}return ce.sort((oe,pe)=>oe[0]-pe[0]).map(([,oe])=>oe)}async queryGallery(N,_,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,e.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(e.Unpublished));const K=await this.commonHeadersPromise,Y=JSON.stringify(N.raw),de={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},ce=new Date().getTime();let he,oe,pe=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Y,headers:de},x),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:pe};const ue=await(0,y.asJson)(he);if(ue){const ye=ue.results[0],De=ye.extensions;De.forEach(Le=>H(Le.versions,_));const Ce=ye.resultMetadata&&ye.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return pe=Ce&&Ce.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:De,total:pe}}return{galleryExtensions:[],total:pe}}catch(ue){throw oe=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-ce,success:!!he&&(0,y.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:oe?(0,S.isCancellationError)(oe)?"canceled":(0,S.getErrorMessage)(oe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(N,_,x,K){if(!this.isEnabled())return;const Y=L.isWeb?this.api(`/itemName/${N}.${_}/version/${x}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${_}/${x}/stats?statType=${K}`),de=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:Y,headers:he},D.CancellationToken.None)}catch{}}async download(N,_,x){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const K=(0,P.getGalleryExtensionTelemetryData)(N),Y=new Date().getTime(),de=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...K,duration:pe}),ce=x===2?"install":x===3?"update":"",he=ce?{uri:`${N.assets.download.uri}${v.URI.parse(N.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${N.assets.download.fallbackUri}${v.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:N.assets.download,oe=await this.getAsset(he);await this.fileService.writeFile(_,oe.stream),de(new Date().getTime()-Y)}async getReadme(N,_){if(N.assets.readme){const x=await this.getAsset(N.assets.readme,{},_);return await(0,y.asText)(x)||""}return""}async getManifest(N,_){if(N.assets.manifest){const x=await this.getAsset(N.assets.manifest,{},_),K=await(0,y.asText)(x);return K?JSON.parse(K):null}return null}async getManifestFromRawExtensionVersion(N,_){const x=te(N,c.Manifest);if(!x)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},Y=await this.getAsset(x,{headers:K});return await(0,y.asJson)(Y)}async getCoreTranslation(N,_){const x=N.assets.coreTranslations.filter(K=>K[0]===_.toUpperCase())[0];if(x){const K=await this.getAsset(x[1]),Y=await(0,y.asText)(K);return Y?JSON.parse(Y):null}return null}async getChangelog(N,_){if(N.assets.changelog){const x=await this.getAsset(N.assets.changelog,{},_);return await(0,y.asText)(x)||""}return""}async getAllCompatibleVersions(N,_,x){let K=new T().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?K=K.withFilter(s.ExtensionId,N.identifier.uuid):K=K.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:Y}=await this.queryGallery(K,x,D.CancellationToken.None);if(!Y.length)return[];const de=j(Y[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(de,x))return[];const ce=[];for(const he of Y[0].versions)try{ce[ce.length-1]?.version!==he.version&&await this.isRawExtensionVersionCompatible(he,_,de,x)&&ce.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:$(he)})}catch{}return ce}async getAsset(N,_={},x=D.CancellationToken.None){const K=await this.commonHeadersPromise,Y={type:"GET"},de={...K,..._.headers||{}};_={..._,...Y,headers:de};const ce=N.uri,he=N.fallbackUri,oe={..._,url:ce};try{const pe=await this.requestService.request(oe,x);if(pe.res.statusCode===200)return pe;const ue=await(0,y.asText)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${ue}`)}catch(pe){if((0,S.isCancellationError)(pe))throw pe;const ue=(0,S.getErrorMessage)(pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:ue});const ye={..._,url:he};return this.requestService.request(ye,x)}}async getEngine(N){let _=B(N);if(!_){const x=await this.getManifestFromRawExtensionVersion(N,D.CancellationToken.None);if(!x)throw new Error("Manifest was not found");_=x.engines.vscode}return _}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,y.asJson)(N),x=[],K={};if(_){for(const Y of _.malicious)x.push({id:Y});if(_.unsupported)for(const Y of Object.keys(_.unsupported)){const de=_.unsupported[Y];(0,u.isBoolean)(de)||(K[Y.toLowerCase()]=de.preReleaseExtension)}if(_.migrateToPreRelease)for(const[Y,de]of Object.entries(_.migrateToPreRelease))(!de.engine||(0,p.isEngineValid)(de.engine,this.productService.version,this.productService.date))&&(K[Y.toLowerCase()]=de)}return{malicious:x,unsupportedPreReleaseExtensions:K}}};X=ve([ae(1,y.IRequestService),ae(2,l.ILogService),ae(3,O.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,h.IFileService),ae(6,d.IProductService),ae(7,I.IConfigurationService)],X);let ee=class extends X{constructor(N,_,x,K,Y,de,ce,he){super(N,_,x,K,Y,de,ce,he)}};ee=ve([ae(0,m.IStorageService),ae(1,y.IRequestService),ae(2,l.ILogService),ae(3,O.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,h.IFileService),ae(6,d.IProductService),ae(7,I.IConfigurationService)],ee),t.ExtensionGalleryService=ee;let G=class extends X{constructor(N,_,x,K,Y,de,ce){super(void 0,N,_,x,K,Y,de,ce)}};G=ve([ae(0,y.IRequestService),ae(1,l.ILogService),ae(2,O.IEnvironmentService),ae(3,o.ITelemetryService),ae(4,h.IFileService),ae(5,d.IProductService),ae(6,I.IConfigurationService)],G),t.ExtensionGalleryServiceWithNoStorageService=G;async function le(U,N,_,x,K,Y){const de={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${N.nameShort})`},ce=await(0,a.getServiceMachineId)(_,K,Y);return(0,n.supportsTelemetry)(N,_)&&(0,n.getTelemetryLevel)(x)===3&&(de["X-Market-User-Id"]=ce),de}t.resolveMarketplaceHeaders=le}),define(Q[119],Z([0,1,2,21,14,26,85,25,34,120,30,31,35]),function(z,t,C,D,S,R,L,b,u,v,I,O,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let P=class{constructor(l,d){this._configurationService=d,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=l.appenders,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const a=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!a})})}setExperimentProperty(l,d){this._experimentProperties[l]=d}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const l=await this._commonProperties;let d=l.sessionID,y=l["common.machineId"],a=l["common.firstSessionDate"],m=l["common.msftInternal"];return{sessionId:d,machineId:y,firstSessionDate:a,msftInternal:m}}dispose(){this._disposables.dispose()}_log(l,d,y,a){return this.telemetryLevel<d?Promise.resolve(void 0):this._commonProperties.then(m=>{y=(0,D.mixin)(y,m),y=(0,D.mixin)(y,this._experimentProperties),y=(0,D.cloneAndChange)(y,o=>{if(typeof o=="string")return this._cleanupInfo(o,a)}),this._appenders.forEach(o=>o.log(l,y))},m=>{console.error(m)})}publicLog(l,d,y){return this._log(l,3,d,y)}publicLog2(l,d,y){return this.publicLog(l,d,y)}publicLogError(l,d){return this.sendErrorTelemetry?this._log(l,2,d,!0):Promise.resolve(void 0)}publicLogError2(l,d){return this.publicLogError(l,d)}_anonymizeFilePaths(l){let d=l;const y=[];for(let n of this._cleanupPatterns)for(;;){const r=n.exec(l);if(!r)break;y.push([r.index,n.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(d="";;){const n=m.exec(l);if(!n)break;!a.test(n[0])&&y.every(([r,e])=>n.index<r||n.index>=e)&&(d+=l.substring(o,n.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}return o<l.length&&(d+=l.substr(o)),d}_removePropertiesWithPossibleUserInfo(l){if(!l)return l;const d=l.toLowerCase(),y=/@[a-zA-Z0-9-.]+/,a=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,m=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return a.test(d)?"<REDACTED: secret>":y.test(d)?"<REDACTED: email>":m.test(d)?"<REDACTED: token>":l}_cleanupInfo(l,d){let y=l;d&&(y=this._anonymizeFilePaths(y));for(let a of this._cleanupPatterns)y=y.replace(a,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=ve([ae(1,b.IConfigurationService)],P),t.TelemetryService=P;function p(){const h=(0,L.localize)(0,null,v.default.nameLong),l=v.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=S.isWeb?"":(0,L.localize)(3,null),y=(0,L.localize)(4,null),a=(0,L.localize)(5,null),m=(0,L.localize)(6,null),o=(0,L.localize)(7,null),n=`
|       | ${y} | ${a} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${h} ${l} ${d}

&nbsp;

${o}
${n}

&nbsp;

${r}
`}I.Registry.as(u.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[O.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(u.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[O.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,L.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,L.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${O.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[121],Z([0,1,6,21,35]),function(z,t,C,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(b,u){const v=await new Promise((O,g)=>{z(["applicationinsights"],O,g)});let I;return v.defaultClient?(I=new v.TelemetryClient(b),I.channel.setUseDiskRetryCaching(!0)):(v.setup(b).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=v.defaultClient),b.indexOf("AIF-")===0&&(I.config.endpointUrl=u?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class L{constructor(u,v,I,O,g){this._eventPrefix=u,this._defaultData=v,this.testCollector=O,this.mirrored=g,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(v=>{u(v)},v=>{(0,C.onUnexpectedError)(v),console.error(v)})}}log(u,v){!this._aiClient||(v=(0,D.mixin)(v,this._defaultData),v=(0,S.validateTelemetryData)(v),this.testCollector&&(v.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+u,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=L}),define(Q[122],Z([0,1,11,15]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(R,L){const b=Object.create(null),u=(I,O)=>{const g=JSON.parse(I);b[O]=g};if(L){const I=[],O=await D.Promises.readdir(L);for(const P of O)try{(await D.Promises.stat((0,C.join)(L,P))).isDirectory()&&I.push(P)}catch{}const g=[];for(const P of I)(await D.Promises.readdir((0,C.join)(L,P))).filter(h=>h==="telemetry.json").length===1&&g.push(P);for(const P of g){const p=(await D.Promises.readFile((0,C.join)(L,P,"telemetry.json"))).toString();u(p,P)}}let v=(await D.Promises.readFile((0,C.join)(R,"telemetry-core.json"))).toString();return u(v,"vscode-core"),v=(await D.Promises.readFile((0,C.join)(R,"telemetry-extensions.json"))).toString(),u(v,"vscode-extensions"),JSON.stringify(b,null,4)}t.buildTelemetryMessage=S}),define(Q[36],Z([0,1,12]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Q[123],Z([0,1,8,2,9,20,23,16,13,36]),function(z,t,C,D,S,R,L,b,u,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let I=class extends D.Disposable{constructor(g,P,p,h,l){super();this.extensionsManagementService=g,this.logService=h,this.uriIdentityService=l,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(a=>a.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(y=>this.onInstallExtension(y))),this._register(g.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(g.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const d=S.URI.file(p.extensionsPath);this._register(P.watch(d)),this._register(C.Event.filter(P.onDidFilesChange,y=>y.rawChanges.some(a=>this.doesChangeAffects(a,d)))(()=>this.onDidChange()))}doesChangeAffects(g,P){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),P)?this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(P,".obsolete"))?!0:!(g.type!==1&&g.type!==2||this.uriIdentityService.extUri.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const P of g)this.removeInstallingExtension(P.identifier),P.local&&this.addInstalledExtension(P.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(P=>!(0,L.areSameExtensions)(P,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(P=>!(0,L.areSameExtensions)(P,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),P=g.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(l=>(0,L.areSameExtensions)(l,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),p=this.installedExtensions.filter(h=>this.installingExtensions.some(l=>(0,L.areSameExtensions)(l,h))?!1:g.every(l=>!(0,L.areSameExtensions)(l.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=g.map(h=>h.identifier),(P.length||p.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P,removed:p})}}};I=ve([ae(1,b.IFileService),ae(2,R.INativeEnvironmentService),ae(3,u.ILogService),ae(4,v.IUriIdentityService)],I),t.ExtensionsWatcher=I}),define(Q[124],Z([0,1,36,90,16,18,57,8,2]),function(z,t,C,D,S,R,L,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class v{constructor(g){this.uri=g,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let I=class{constructor(g){this._fileService=g,this._dispooables=new u.DisposableStore,this._limit=2**16;const P=new Map,p=h=>{let l=P.get(h.scheme);return l===void 0&&(l=g.hasProvider(h)&&!this._fileService.hasCapability(h,1024),P.set(h.scheme,l)),l};this._dispooables.add(b.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(h=>{P.delete(h.scheme)})),this.extUri=new R.ExtUri(p),this._canonicalUris=new L.SkipList((h,l)=>this.extUri.compare(h,l,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,R.normalizePath)(g));let P=this._canonicalUris.get(g);return P?P.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new v(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((p,h)=>p[1].touch<h[1].touch?1:p[1].touch>h[1].touch?-1:0);v._clock=0,this._canonicalUris.clear();const P=this._limit*.5;for(let p=0;p<P;p++)this._canonicalUris.set(g[p][0],g[p][1].touch())}};I=ve([ae(0,S.IFileService)],I),t.UriIdentityService=I,(0,D.registerSingleton)(C.IUriIdentityService,I,!0)}),define(Q[43],Z([0,1,101,3,11,7,15,71,136,137]),function(z,t,C,D,S,R,L,b,u,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class I extends Error{constructor(n,r){let e=r.message;switch(n){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=n,this.cause=r}}t.ExtractError=I;function O(o){const n=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,e)=>r+e,n&61440)}function g(o){if(o instanceof I)return o;let n;return/end of central directory record signature not found/.test(o.message)&&(n="CorruptZip"),new I(n,o)}function P(o,n,r,e,i,s){const c=S.dirname(n),f=S.join(e,c);if(!f.startsWith(e))return Promise.reject(new Error(b.localize(0,null,n)));const E=S.join(e,n);let w;return s.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(L.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((T,F)=>{if(!s.isCancellationRequested)try{w=(0,C.createWriteStream)(E,{mode:r}),w.once("close",()=>T()),w.once("error",F),o.once("error",F),o.pipe(w)}catch(W){F(W)}}))}function p(o,n,r,e){let i=(0,D.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{i.cancel(),o.close()}),new Promise((c,f)=>{const E=new D.Sequencer,w=T=>{T.isCancellationRequested||(s++,o.readEntry())};o.once("error",f),o.once("close",()=>i.then(()=>{e.isCancellationRequested||o.entryCount===s?c():f(new I("Incomplete",new Error(b.localize(1,null,s,o.entryCount))))},f)),o.readEntry(),o.on("entry",T=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(T.fileName)){w(e);return}const F=T.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(F)){const se=S.join(n,F);i=(0,D.createCancelablePromise)(ie=>L.Promises.mkdir(se,{recursive:!0}).then(()=>w(ie)).then(void 0,f));return}const W=l(o,T),J=O(T);i=(0,D.createCancelablePromise)(se=>E.queue(()=>W.then(ie=>P(ie,F,J,n,r,se).then(()=>w(se)))).then(null,f))})})}function h(o,n=!1){return new Promise((r,e)=>{(0,u.open)(o,n?{lazyEntries:!0}:void 0,(i,s)=>{i?e(g(i)):r((0,R.assertIsDefined)(s))})})}function l(o,n){return new Promise((r,e)=>{o.openReadStream(n,(i,s)=>{i?e(g(i)):r((0,R.assertIsDefined)(s))})})}function d(o,n){return new Promise((r,e)=>{const i=new v.ZipFile;n.forEach(c=>{c.contents?i.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&i.addFile(c.localPath,c.path)}),i.end();const s=(0,C.createWriteStream)(o);i.outputStream.pipe(s),i.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>r(o))})}t.zip=d;function y(o,n,r={},e){const i=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=h(o,!0);return r.overwrite&&(s=s.then(c=>L.Promises.rm(n).then(()=>c))),s.then(c=>p(c,n,{sourcePathRegex:i},e))}t.extract=y;function a(o,n){return h(o).then(r=>new Promise((e,i)=>{r.on("entry",s=>{s.fileName===n&&l(r,s).then(c=>e(c),c=>i(c))}),r.once("close",()=>i(new Error(b.localize(2,null,n))))}))}function m(o,n){return a(o,n).then(r=>new Promise((e,i)=>{const s=[];r.once("error",i),r.on("data",c=>s.push(c)),r.on("end",()=>e(Buffer.concat(s)))}))}t.buffer=m}),define(Q[125],Z([0,1,43,78]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(R){return(0,C.buffer)(R,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}t.getManifest=S}),define(Q[126],Z([0,1,19,3,6,2,10,11,14,18,41,9,27,15,43,79,20,22,23,89,16,13,32]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P,p,h,l,d,y,a,m,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let r=class extends R.Disposable{constructor(i,s,c,f,E){super();this.beforeRemovingExtension=i,this.fileService=s,this.logService=c,this.environmentService=f,this.productService=E,this._devSystemExtensionsPath=null,this.systemExtensionsPath=f.builtinExtensionsPath,this.extensionsPath=f.extensionsPath,this.uninstalledPath=b.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(i){const s=[];(i===null||i===0)&&s.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new d.ExtensionManagementError(this.joinErrors(c).message,d.ExtensionManagementErrorCode.Internal)))),(i===null||i===1)&&s.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new d.ExtensionManagementError(this.joinErrors(c).message,d.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(s);return(0,C.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(i){this.logService.trace("Started scanning user extensions");let[s,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(f=>!s[new y.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).key()]),i&&(c=(0,y.groupByExtension)(c,E=>E.identifier).map(E=>E.sort((w,T)=>I.rcompare(w.manifest.version,T.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(i,s,c,f){const E=i.key(),w=b.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),T=b.join(this.extensionsPath,E);try{await P.Promises.rm(T)}catch{try{await P.Promises.rm(T)}catch{}throw new d.ExtensionManagementError((0,h.localize)(0,null,T,i.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(i,s,w,f);let F=await this.scanExtension(O.URI.file(w),1);if(!F)throw new Error((0,h.localize)(1,null,w));await this.storeMetadata(F,{...c,installedTimestamp:Date.now()});try{await this.rename(i,w,T,Date.now()+2*60*1e3),this.logService.info("Renamed to",T)}catch(W){try{await P.Promises.rm(w)}catch{}if(W.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",i.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(W)}. Deleted from extracted location`,w),W}try{F=await this.scanExtension(O.URI.file(T),1)}catch{}if(F)return F;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(i,s){return this.setMetadata(i,s),await this.storeMetadata(i,{...s,installedTimestamp:i.installedTimestamp}),i}async storeMetadata(i,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const c=b.join(i.location.fsPath,"package.json"),f=await P.Promises.readFile(c,"utf8"),{manifest:E}=await this.parseManifest(f);return E.__metadata=s,await P.Promises.writeFile(c,JSON.stringify(E,null,"	")),i}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...i){const s=i.map(c=>new y.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{s.forEach(f=>c[f.key()]=!0)})}async setInstalled(i){await this.withUninstalledExtensions(f=>delete f[i.key()]);const c=(await this.scanExtensions(1)).find(f=>new y.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).equals(i))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(i){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await P.Promises.readFile(this.uninstalledPath,"utf8")}catch(f){if(f.code!=="ENOENT")throw f}let c={};if(s)try{c=JSON.parse(s)}catch{}return i&&(i(c),Object.keys(c).length?await P.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await P.Promises.rm(this.uninstalledPath)),c})}async removeExtension(i,s){this.logService.trace(`Deleting ${s} extension from disk`,i.identifier.id,i.location.fsPath),await P.Promises.rm(i.location.fsPath),this.logService.info("Deleted from disk",i.identifier.id,i.location.fsPath)}async removeUninstalledExtension(i){await this.removeExtension(i,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new y.ExtensionIdentifierWithVersion(i.identifier,i.manifest.version).key()])}async extractAtLocation(i,s,c,f){this.logService.trace(`Started extracting the extension from ${s} to ${c}`);try{await P.Promises.rm(c)}catch(E){throw new d.ExtensionManagementError(this.joinErrors(E).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)(s,c,{sourcePath:"extension",overwrite:!0},f),this.logService.info(`Extracted extension to ${c}:`,i.id)}catch(E){try{await P.Promises.rm(c)}catch{}let w=d.ExtensionManagementErrorCode.Extract;throw E instanceof p.ExtractError&&(E.type==="CorruptZip"?w=d.ExtensionManagementErrorCode.CorruptZip:E.type==="Incomplete"&&(w=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(E.message,w)}}async rename(i,s,c,f){try{await P.Promises.rename(s,c)}catch(E){if(u.isWindows&&E&&E.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${s} to ${c} with 'EPERM' error. Trying again...`,i.id),this.rename(i,s,c,f);throw new d.ExtensionManagementError(E.message||(0,h.localize)(3,null,s,c),E.code||d.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const i=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return i;const s=this.scanDevSystemExtensions(),[c,f]=await Promise.all([i,s]);return[...c,...f]}async scanExtensionsInDir(i,s){const c=new D.Limiter(10),f=await this.fileService.resolve(O.URI.file(i));return f.children?(await Promise.all(f.children.filter(w=>w.isDirectory).map(w=>c.queue(async()=>s===1&&(0,v.basename)(w.resource).indexOf(".")===0?null:this.scanExtension(w.resource,s))))).filter(w=>w&&w.identifier):[]}async scanExtension(i,s){try{const c=await this.fileService.resolve(i);if(c.children){const{manifest:f,metadata:E}=await this.readManifest(i.fsPath),w=c.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,T=c.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource,F={id:(0,y.getGalleryExtensionId)(f.publisher,f.name)},W={type:s,identifier:F,manifest:f,location:i,readmeUrl:w,changelogUrl:T,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(W,E),W}}catch(c){s!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const i=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",i.length),i}async scanDevSystemExtensions(){const i=this.getDevSystemExtensionsList();if(i.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(c=>i.some(f=>(0,y.areSameExtensions)(c.identifier,{id:f})))}else return[]}setMetadata(i,s){i.publisherDisplayName=s?.publisherDisplayName||null,i.publisherId=s?.publisherId||null,i.identifier.uuid=s?.id,i.isMachineScoped=!!s?.isMachineScoped,i.isPreReleaseVersion=!!s?.isPreReleaseVersion,i.preRelease=!!s?.preRelease,i.isBuiltin=i.type===0||!!s?.isBuiltin,i.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const i=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),c=new Set;for(const w of s)i[new y.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]||c.add(w.identifier.id.toLowerCase());const f=(0,y.groupByExtension)(s,w=>w.identifier);await D.Promises.settled(f.map(async w=>{const T=w.sort((F,W)=>I.rcompare(F.manifest.version,W.manifest.version))[0];c.has(T.identifier.id.toLowerCase())||await this.beforeRemovingExtension(T)}));const E=s.filter(w=>i[new y.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]);await D.Promises.settled(E.map(w=>this.removeUninstalledExtension(w)))}async removeOutdatedExtensions(){const i=await this.scanAllUserExtensions(),s=[],c=(0,y.groupByExtension)(i,f=>f.identifier);s.push(...(0,C.flatten)(c.map(f=>f.sort((E,w)=>I.rcompare(E.manifest.version,w.manifest.version)).slice(1)))),await D.Promises.settled(s.map(f=>this.removeExtension(f,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(i=>i.name)}joinErrors(i){const s=Array.isArray(i)?i:[i];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((c,f)=>new Error(`${c.message}${c.message?",":""}${f instanceof Error?f.message:f}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=b.normalize(b.join(L.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(i){const s=[P.Promises.readFile(b.join(i,"package.json"),"utf8").then(w=>this.parseManifest(w)),P.Promises.readFile(b.join(i,"package.nls.json"),"utf8").then(void 0,w=>w.code!=="ENOENT"?Promise.reject(w):"{}").then(w=>JSON.parse(w))],[{manifest:c,metadata:f},E]=await Promise.all(s);return{manifest:(0,a.localizeManifest)(c,E),metadata:f}}parseManifest(i){return new Promise((s,c)=>{try{const f=JSON.parse(i),E=f.__metadata||null;s({manifest:f,metadata:E})}catch{c(new Error((0,h.localize)(4,null)))}})}};r=ve([ae(1,m.IFileService),ae(2,o.ILogService),ae(3,l.INativeEnvironmentService),ae(4,n.IProductService)],r),t.ExtensionsScanner=r}),define(Q[127],Z([0,1,28,6,10,11,14,29,18,41,9,27,15,43,77,49,20,117,22,23,108,96,125,109,126,123,48,16,12,13,32,31,36]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P,p,h,l,d,y,a,m,o,n,r,e,i,s,c,f,E,w,T,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let W=class extends d.AbstractExtensionManagementService{constructor(B,$,re,M,A,j,H,ne,X){super(B,$,re,ne);this.environmentService=M,this.downloadService=A,this.fileService=H;const ee=this._register(j.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(e.ExtensionsScanner,le=>ee.postUninstall(le))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(j.createInstance(m.ExtensionsDownloader));const G=this._register(new i.ExtensionsWatcher(this,H,M,re,X));this._register(G.onDidChangeExtensionsByAnotherSource(({added:le,removed:U})=>{le.length&&this._onDidInstallExtensions.fire(le.map(N=>({identifier:N.identifier,operation:1,local:N}))),U.forEach(N=>this._onDidUninstallExtension.fire({identifier:N}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const B=await this.isAlpineLinux(),$=(0,y.getTargetPlatform)(B?"alpine":L.platform,b.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",$),$})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let B;try{B=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{B=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(re){this.logService.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(re))}}return!!B&&(B.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const $=await this.collectFiles(B),re=await(0,P.zip)((0,u.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)()).fsPath,$);return I.URI.file(re)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const $=await this.downloadVsix(B),re=R.resolve($.fsPath);return(0,n.getManifest)(re)}getInstalled(B=null){return this.extensionsScanner.scanExtensions(B)}async install(B,$={}){this.logService.trace("ExtensionManagementService#install",B.toString());const re=await this.downloadVsix(B),M=await(0,n.getManifest)(R.resolve(re.fsPath));if(M.engines&&M.engines.vscode&&!(0,s.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,(0,a.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,re,$)}async updateMetadata(B,$){this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id);const re={...B.manifest.__metadata||{},...$};return $.isPreReleaseVersion&&(re.preRelease=!0),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,re),this.manifestCache.invalidate(),B}async updateExtensionScope(B,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),B}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(B){if(B.scheme===S.Schemas.file)return B;const $=(0,u.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)());return await this.downloadService.download(B,$),$}createInstallExtensionTask(B,$,re){return I.URI.isUri($)?new ie(B,$,re,this.galleryService,this.extensionsScanner,this.logService):new se($,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(B,$){return new te(B,$,this.extensionsScanner)}async collectFiles(B){const $=async M=>{let A=await g.Promises.readdir(M);A=A.map(ne=>R.join(M,ne));const j=await Promise.all(A.map(ne=>g.Promises.stat(ne)));let H=Promise.resolve([]);return j.forEach((ne,X)=>{const ee=A[X];ne.isFile()&&(H=H.then(G=>[...G,ee])),ne.isDirectory()&&(H=H.then(G=>$(ee).then(le=>[...G,...le])))}),H};return(await $(B.location.fsPath)).map(M=>({path:`extension/${R.relative(B.location.fsPath,M)}`,localPath:M}))}};W=ve([ae(0,y.IExtensionGalleryService),ae(1,T.ITelemetryService),ae(2,E.ILogService),ae(3,l.INativeEnvironmentService),ae(4,h.IDownloadService),ae(5,f.IInstantiationService),ae(6,c.IFileService),ae(7,w.IProductService),ae(8,F.IUriIdentityService)],W),t.ExtensionManagementService=W;class J extends d.AbstractExtensionTask{constructor(B,$,re,M){super();this.identifier=B,this.source=$,this.extensionsScanner=re,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension(B,$){try{const re=await this.unsetUninstalledAndGetLocal(B.identifierWithVersion);if(re)return B.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,{...re.manifest.__metadata||{},...B.metadata}):re}catch{throw L.isMacintosh?new y.ExtensionManagementError(p.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(p.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(B,$)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const re=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),re}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.key()]}async extract({zipPath:B,identifierWithVersion:$,metadata:re},M){let A=await this.extensionsScanner.extractUserExtension($,B,re,M);return this.logService.info("Extracting completed.",$.id),A}}class se extends J{constructor(B,$,re,M,A){super(B.identifier,B,M,A);this.gallery=B,this.options=$,this.extensionsDownloader=re}async doRun(B){const re=(await this.extensionsScanner.scanExtensions(null)).find(A=>(0,a.areSameExtensions)(A.identifier,this.gallery.identifier));re&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:re?.preRelease;try{const A=await this.installExtension(M,B);return re&&v.neq(re.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(re),A}catch(A){throw await this.deleteDownloadedVSIX(M.zipPath),A}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(I.URI.file(B))}catch($){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,D.getErrorMessage)($))}}async downloadInstallableExtension(B,$){const re={id:B.identifier.uuid,publisherId:B.publisherId,publisherDisplayName:B.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",B.identifier.id),M=(await this.extensionsDownloader.downloadExtension(B,$)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,M)}catch(A){throw new y.ExtensionManagementError((0,d.joinErrors)(A).message,y.ExtensionManagementErrorCode.Download)}try{const A=await(0,n.getManifest)(M);return{zipPath:M,identifierWithVersion:new a.ExtensionIdentifierWithVersion(B.identifier,A.version),metadata:re}}catch(A){throw await this.deleteDownloadedVSIX(M),new y.ExtensionManagementError((0,d.joinErrors)(A).message,y.ExtensionManagementErrorCode.Invalid)}}}class ie extends J{constructor(B,$,re,M,A,j){super({id:(0,a.getGalleryExtensionId)(B.publisher,B.name)},$,A,j);this.manifest=B,this.location=$,this.options=re,this.galleryService=M}async doRun(B){const $=new a.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,a.areSameExtensions)(this.identifier,j.identifier)),A=await this.getMetadata(this.identifier.id,this.manifest.version,B);if(A.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,A.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,$.equals(new a.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(p.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const j=await this.unsetUninstalledAndGetLocal($);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(p.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:$,metadata:A},B)}async getMetadata(B,$,re){try{let[M]=await this.galleryService.getExtensions([{id:B,version:$}],re);if(M||([M]=await this.galleryService.getExtensions([{id:B}],re)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion}}catch{}return{}}}class te extends d.AbstractExtensionTask{constructor(B,$,re){super();this.extension=B,this.options=$,this.extensionsScanner=re}async doRun(B){const $=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new a.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...re.filter(A=>M.equals(new a.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version))))}else $.push(...re.filter(M=>(0,a.areSameExtensions)(M.identifier,this.extension.identifier)));if(!$.length)throw new Error(p.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const M of $)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(A){throw new Error(p.localize(6,null,(0,C.toErrorMessage)(A)))}}}}),define(Q[128],Z([0,1,113,3,17,6,2,7,25,20,92,13,112,138]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let p=class extends L.Disposable{constructor(l,d,y){super();this.environmentService=d,this.logService=y,this.configure(l.getValue()),this._register(l.onDidChangeConfiguration(()=>this.configure(l.getValue()),this))}configure(l){this.proxyUrl=l.http&&l.http.proxy,this.strictSSL=!!(l.http&&l.http.proxyStrictSSL),this.authorization=l.http&&l.http.proxyAuthorization}async request(l,d){this.logService.trace("RequestService#request",l.url);const{proxyUrl:y,strictSSL:a}=this;let m;try{m=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const o={...process.env,...m},n=l.agent?l.agent:await(0,g.getProxyAgent)(l.url||"",o,{proxyUrl:y,strictSSL:a});return l.agent=n,l.strictSSL=a,this.authorization&&(l.headers={...l.headers||{},"Proxy-Authorization":this.authorization}),this._request(l,d)}async getNodeRequest(l){return((0,C.parse)(l.url).protocol==="https:"?await new Promise((a,m)=>{z(["https"],a,m)}):await new Promise((a,m)=>{z(["http"],a,m)})).request}_request(l,d){return D.Promises.withAsyncBody(async(y,a)=>{let m;const o=(0,C.parse)(l.url),n=l.getRawRequest?l.getRawRequest(l):await this.getNodeRequest(l),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,b.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(r.auth=l.user+":"+l.password),m=n(r,e=>{const i=(0,b.isNumber)(l.followRedirects)?l.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&i>0&&e.headers.location)this._request({...l,url:e.headers.location,followRedirects:i-1},d).then(y,a);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,P.createGunzip)())),y({res:e,stream:(0,S.streamToBufferReadableStream)(s)})}}),m.on("error",a),l.timeout&&m.setTimeout(l.timeout),l.data&&typeof l.data=="string"&&m.write(l.data),m.end(),d.onCancellationRequested(()=>{m.abort(),a((0,R.canceled)())})})}async resolveProxy(l){}};p=ve([ae(0,u.IConfigurationService),ae(1,v.INativeEnvironmentService),ae(2,O.ILogService)],p),t.RequestService=p}),define(Q[139],Z([0,1,33,3,17,28,6,2,10,11,29,9,15,25,105,49,111,20,88,118,22,107,127,16,98,100,39,95,51,52,110,13,102,120,32,42,128,116,31,119,35,121,122,36,124]),function(z,t,C,D,S,R,L,b,u,v,I,O,g,P,p,h,l,d,y,a,m,o,n,r,e,i,s,c,f,E,w,T,F,W,J,se,ie,te,ge,B,$,re,M,A,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class H extends b.Disposable{constructor(ee){super();this.argv=ee,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ee,G]=await this.initServices();return ee.invokeFunction(async le=>{const U=le.get(T.ILogService),N=le.get(r.IFileService),_=le.get(d.INativeEnvironmentService),x=le.get(m.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun(_,x,N),await Promise.all(G.map(K=>{(0,D.raceTimeout)(K.flush(),1e3)}))})}async initServices(){const ee=new f.ServiceCollection,G={_serviceBrand:void 0,...W.default};ee.set(J.IProductService,G);const le=new y.NativeEnvironmentService(this.argv,G);ee.set(d.INativeEnvironmentService,le),await Promise.all([le.appSettingsHome.fsPath,le.extensionsPath].map(ce=>ce?g.Promises.mkdir(ce,{recursive:!0}):void 0));const U=(0,T.getLogLevel)(le),N=[];N.push(new F.SpdLogLogger("cli",(0,v.join)(le.logsPath,"cli.log"),!0,!1,U)),U===T.LogLevel.Trace&&N.push(new T.ConsoleLogger(U));const _=this._register(new T.MultiplexLogService(N));ee.set(T.ILogService,_);const x=this._register(new e.FileService(_));ee.set(r.IFileService,x);const K=this._register(new i.DiskFileSystemProvider(_));x.registerProvider(u.Schemas.file,K);const Y=this._register(new p.ConfigurationService(le.settingsResource,x));ee.set(P.IConfigurationService,Y),await Y.initialize(),ee.set(A.IUriIdentityService,new j.UriIdentityService(x)),ee.set(se.IRequestService,new s.SyncDescriptor(ie.RequestService)),ee.set(h.IDownloadService,new s.SyncDescriptor(l.DownloadService)),ee.set(m.IExtensionManagementService,new s.SyncDescriptor(n.ExtensionManagementService)),ee.set(m.IExtensionGalleryService,new s.SyncDescriptor(a.ExtensionGalleryServiceWithNoStorageService)),ee.set(m.IExtensionManagementCLIService,new s.SyncDescriptor(o.ExtensionManagementCLIService)),ee.set(E.ILocalizationsService,new s.SyncDescriptor(w.LocalizationsService));const de=[];if((0,$.supportsTelemetry)(G,le)){G.aiConfig&&G.aiConfig.asimovKey&&de.push(new re.AppInsightsAppender("monacoworkbench",null,G.aiConfig.asimovKey));const{appRoot:ce,extensionsPath:he,installSourcePath:oe}=le,pe={appenders:de,sendErrorTelemetry:!1,commonProperties:(async()=>{let ue;try{const ye=await g.Promises.readFile((0,v.join)(le.userDataPath,"storage.json"));ue=JSON.parse(ye.toString())[ge.machineIdKey]}catch(ye){ye.code!=="ENOENT"&&_.error(ye)}return(0,te.resolveCommonProperties)(x,(0,C.release)(),(0,C.hostname)(),process.arch,G.commit,G.version,ue,G.msftInternalDomains,oe)})(),piiPaths:[ce,he]};ee.set(ge.ITelemetryService,new s.SyncDescriptor(B.TelemetryService,[pe]))}else ee.set(ge.ITelemetryService,$.NullTelemetryService);return[new c.InstantiationService(ee),de]}registerErrorHandler(ee){(0,L.setUnexpectedErrorHandler)(G=>{const le=(0,R.toErrorMessage)(G,!0);!le||ee.error(`[uncaught exception in CLI]: ${le}`)}),process.on("uncaughtException",G=>(0,L.onUnexpectedError)(G)),process.on("unhandledRejection",G=>(0,L.onUnexpectedError)(G))}async doRun(ee,G,le){if(this.argv["install-source"])return this.setInstallSource(ee,le,this.argv["install-source"]);if(this.argv["list-extensions"])return G.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return G.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return G.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return G.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(ee.appRoot,ee.extensionsPath))}}asExtensionIdOrVSIX(ee){return ee.map(G=>/\.vsix$/i.test(G)?O.URI.file((0,v.isAbsolute)(G)?G:(0,v.join)((0,I.cwd)(),G)):G)}async setInstallSource(ee,G,le){await G.writeFile(O.URI.file(ee.installSourcePath),S.VSBuffer.fromString(le.slice(0,30)))}}async function ne(X){const ee=new H(X);try{await ee.run()}finally{ee.dispose()}}t.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0e435cf51d0e45293a94466fc3b1299ba70fa9b1/core/vs/code/node/cliProcessMain.js.map
