/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languages/tokenizationRegistry","vs/editor/common/model/textModelSearch","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Z){for(var e=[],f=0,t=Z.length;f<t;f++)e[f]=pe[Z[f]];return e};define(pe[55],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(t,I){if(!t)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=f}),define(pe[74],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function f(T){return T?T.replace(/\$\((.*?)\)/g,(P,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=f;class t{constructor(P,C,A){this.id=P,this.definition=C,this.description=A,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(T,P){const C=["codicon","codicon-"+T];return P&&C.push("codicon-modifier-"+P),C}e.getClassNamesArray=I;var D;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function C(y){if(y instanceof t)return["codicon","codicon-"+y.id];const l=P.exec(y.id);if(!l)return C(t.error);let[,b,p]=l;const g=["codicon","codicon-"+b];return p&&g.push("codicon-modifier-"+p.substr(1)),g}T.asClassNameArray=C;function A(y){return C(y).join(" ")}T.asClassName=A;function R(y){return"."+C(y).join(".")}T.asCSSSelector=R})(D=e.CSSIcon||(e.CSSIcon={}))}),define(pe[75],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function t(R){const y=[];for(let l in R)f.call(R,l)&&y.push(R[l]);return y}e.values=t;function I(R,y){for(let l in R)if(f.call(R,l)&&y({key:l,value:R[l]},function(){delete R[l]})===!1)return}e.forEach=I;function D(R,y){const l=Object.create(null);for(const b of R){const p=y(b);let g=l[p];g||(g=l[p]=[]),g.push(b)}return l}e.groupBy=D;function T(R){const y=Object.create(null);return R&&R.forEach((l,b)=>{y[b]=l}),y}e.fromMap=T;function P(R,y){const l=[],b=[];for(let p of R)y.has(p)||l.push(p);for(let p of y)R.has(p)||b.push(p);return{removed:l,added:b}}e.diffSets=P;function C(R,y){const l=[],b=[];for(let[p,g]of R)y.has(p)||l.push(g);for(let[p,g]of y)R.has(p)||b.push(g);return{removed:l,added:b}}e.diffMaps=C;class A{constructor(){this.map=new Map}add(y,l){let b=this.map.get(y);b||(b=new Set,this.map.set(y,b)),b.add(l)}delete(y,l){const b=this.map.get(y);!b||(b.delete(l),b.size===0&&this.map.delete(y))}forEach(y,l){const b=this.map.get(y);!b||b.forEach(l)}}e.SetMap=A}),define(pe[56],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(T){return(P,C,A)=>{let R=null,y=null;if(typeof A.value=="function"?(R="value",y=A.value):typeof A.get=="function"&&(R="get",y=A.get),!y)throw new Error("not supported");A[R]=T(y,C)}}e.createDecorator=f;function t(T,P,C){let A=null,R=null;if(typeof C.value=="function"?(A="value",R=C.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(A="get",R=C.get),!R)throw new Error("not supported");const y=`$memoize$${P}`;C[A]=function(...l){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[y]}}e.memoize=t;function I(T,P,C){return f((A,R)=>{const y=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...b){this[l]||(this[l]=C?C():void 0),clearTimeout(this[y]),P&&(this[l]=P(this[l],...b),b=[this[l]]),this[y]=setTimeout(()=>{A.apply(this,b),this[l]=C?C():void 0},T)}})}e.debounce=I;function D(T,P,C){return f((A,R)=>{const y=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,b=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...g){if(this[l]||(this[l]=C?C():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),P&&(this[l]=P(this[l],...g)),this[p])return;const E=this[b]+T;E<=Date.now()?(this[b]=Date.now(),A.apply(this,[this[l]]),this[l]=C?C():void 0):(this[p]=!0,this[y]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),A.apply(this,[this[l]]),this[l]=C?C():void 0},E-Date.now()))}})}e.throttle=D}),define(pe[15],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(S=>{S(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=f,e.errorHandler=new f;function t(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=t;function I(m){C(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=I;function D(m){C(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=D;function T(m){if(m instanceof Error){let{name:o,message:S}=m;const r=m.stacktrace||m.stack;return{$isError:!0,name:o,message:S,stack:r}}return m}e.transformErrorForSerialization=T;const P="Canceled";function C(m){return m instanceof A?!0:m instanceof Error&&m.name===P&&m.message===P}e.isCancellationError=C;class A extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=A;function R(){const m=new Error(P);return m.name=m.message,m}e.canceled=R;function y(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=y;function l(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=l;function b(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function p(m){const o=new Error(`${m} has been disposed`);return o.name="DISPOSED",o}e.disposed=p;function g(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=g;class E extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=E;class L extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=L;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function a(m){const o=m;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=a;function s(m,o=Object.create(null)){const S=new Error(m);return o.actions&&(S.actions=o.actions),S}e.createErrorWithActions=s}),define(pe[16],ve([0,1,15]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(K,Y=0){return K[K.length-(1+Y)]}e.tail=t;function I(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=I;function D(K,Y,le=(fe,Se)=>fe===Se){if(K===Y)return!0;if(!K||!Y||K.length!==Y.length)return!1;for(let fe=0,Se=K.length;fe<Se;fe++)if(!le(K[fe],Y[fe]))return!1;return!0}e.equals=D;function T(K,Y,le){let fe=0,Se=K.length-1;for(;fe<=Se;){const Me=(fe+Se)/2|0,Ve=le(K[Me],Y);if(Ve<0)fe=Me+1;else if(Ve>0)Se=Me-1;else return Me}return-(fe+1)}e.binarySearch=T;function P(K,Y){let le=0,fe=K.length;if(fe===0)return 0;for(;le<fe;){const Se=Math.floor((le+fe)/2);Y(K[Se])?fe=Se:le=Se+1}return le}e.findFirstInSorted=P;function C(K,Y,le){if(K=K|0,K>=Y.length)throw new TypeError("invalid index");let fe=Y[Math.floor(Y.length*Math.random())],Se=[],Me=[],Ve=[];for(let Ge of Y){const Ye=le(Ge,fe);Ye<0?Se.push(Ge):Ye>0?Me.push(Ge):Ve.push(Ge)}return K<Se.length?C(K,Se,le):K<Se.length+Ve.length?Ve[0]:C(K-(Se.length+Ve.length),Me,le)}e.quickSelect=C;function A(K,Y){const le=[];let fe;for(const Se of K.slice(0).sort(Y))!fe||Y(fe[0],Se)!==0?(fe=[Se],le.push(fe)):fe.push(Se);return le}e.groupBy=A;function R(K,Y,le){const fe=[];function Se(Ge,Ye,q){if(Ye===0&&q.length===0)return;const te=fe[fe.length-1];te&&te.start+te.deleteCount===Ge?(te.deleteCount+=Ye,te.toInsert.push(...q)):fe.push({start:Ge,deleteCount:Ye,toInsert:q})}let Me=0,Ve=0;for(;;){if(Me===K.length){Se(Me,0,Y.slice(Ve));break}if(Ve===Y.length){Se(Me,K.length-Me,[]);break}const Ge=K[Me],Ye=Y[Ve],q=le(Ge,Ye);q===0?(Me+=1,Ve+=1):q<0?(Se(Me,1,[]),Me+=1):q>0&&(Se(Me,0,[Ye]),Ve+=1)}return fe}e.sortedDiff=R;function y(K,Y,le){const fe=R(K,Y,le),Se=[],Me=[];for(const Ve of fe)Se.push(...K.slice(Ve.start,Ve.start+Ve.deleteCount)),Me.push(...Ve.toInsert);return{removed:Se,added:Me}}e.delta=y;function l(K,Y,le){if(le===0)return[];const fe=K.slice(0,le).sort(Y);return p(K,Y,fe,le,K.length),fe}e.top=l;function b(K,Y,le,fe,Se){return le===0?Promise.resolve([]):new Promise((Me,Ve)=>{(async()=>{const Ge=K.length,Ye=K.slice(0,le).sort(Y);for(let q=le,te=Math.min(le+fe,Ge);q<Ge;q=te,te=Math.min(te+fe,Ge)){if(q>le&&await new Promise(G=>setTimeout(G)),Se&&Se.isCancellationRequested)throw(0,f.canceled)();p(K,Y,Ye,q,te)}return Ye})().then(Me,Ve)})}e.topAsync=b;function p(K,Y,le,fe,Se){for(const Me=le.length;fe<Se;fe++){const Ve=K[fe];if(Y(Ve,le[Me-1])<0){le.pop();const Ge=P(le,Ye=>Y(Ve,Ye)<0);le.splice(Ge,0,Ve)}}}function g(K){return K.filter(Y=>!!Y)}e.coalesce=g;function E(K){let Y=0;for(let le=0;le<K.length;le++)K[le]&&(K[Y]=K[le],Y+=1);K.length=Y}e.coalesceInPlace=E;function L(K,Y,le){K.splice(le,0,K.splice(Y,1)[0])}e.move=L;function _(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=_;function a(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=a;function s(K,Y=le=>le){const le=new Set;return K.filter(fe=>{const Se=Y(fe);return le.has(Se)?!1:(le.add(Se),!0)})}e.distinct=s;function m(K){const Y=new Set;return le=>{const fe=K(le);return Y.has(fe)?!1:(Y.add(fe),!0)}}e.uniqueFilter=m;function o(K,Y){const le=S(K,Y);if(le!==-1)return K[le]}e.findLast=o;function S(K,Y){for(let le=K.length-1;le>=0;le--){const fe=K[le];if(Y(fe))return le}return-1}e.lastIndex=S;function r(K,Y){return K.length>0?K[0]:Y}e.firstOrDefault=r;function i(K,Y,le=(fe,Se)=>fe===Se){let fe=0;for(let Se=0,Me=Math.min(K.length,Y.length);Se<Me&&le(K[Se],Y[Se]);Se++)fe++;return fe}e.commonPrefixLength=i;function n(K){return[].concat(...K)}e.flatten=n;function u(K,Y){let le=typeof Y=="number"?K:0;typeof Y=="number"?le=K:(le=0,Y=K);const fe=[];if(le<=Y)for(let Se=le;Se<Y;Se++)fe.push(Se);else for(let Se=le;Se>Y;Se--)fe.push(Se);return fe}e.range=u;function c(K,Y,le){return K.reduce((fe,Se)=>(fe[Y(Se)]=le?le(Se):Se,fe),Object.create(null))}e.index=c;function d(K,Y){return K.push(Y),()=>h(K,Y)}e.insert=d;function h(K,Y){const le=K.indexOf(Y);if(le>-1)return K.splice(le,1),Y}e.remove=h;function w(K,Y,le){const fe=K.slice(0,Y),Se=K.slice(Y);return fe.concat(le,Se)}e.arrayInsert=w;function v(K,Y){let le;if(typeof Y=="number"){let fe=Y;le=()=>{const Se=Math.sin(fe++)*179426549;return Se-Math.floor(Se)}}else le=Math.random;for(let fe=K.length-1;fe>0;fe-=1){const Se=Math.floor(le()*(fe+1)),Me=K[fe];K[fe]=K[Se],K[Se]=Me}}e.shuffle=v;function k(K,Y){const le=K.indexOf(Y);le>-1&&(K.splice(le,1),K.unshift(Y))}e.pushToStart=k;function O(K,Y){const le=K.indexOf(Y);le>-1&&(K.splice(le,1),K.push(Y))}e.pushToEnd=O;function U(K,Y){return Array.isArray(K)?K.map(Y):Y(K)}e.mapArrayOrNot=U;function F(K){return Array.isArray(K)?K:[K]}e.asArray=F;function M(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=M;function V(K,Y){for(const le of K){const fe=Y(le);if(fe!==void 0)return fe}}e.mapFind=V;function $(K,Y,le){const fe=B(K,Y),Se=K.length,Me=le.length;K.length=Se+Me;for(let Ve=Se-1;Ve>=fe;Ve--)K[Ve+Me]=K[Ve];for(let Ve=0;Ve<Me;Ve++)K[Ve+fe]=le[Ve]}e.insertInto=$;function N(K,Y,le,fe){const Se=B(K,Y),Me=K.splice(Se,le);return $(K,Se,fe),Me}e.splice=N;function B(K,Y){return Y<0?Math.max(Y+K.length,0):Math.min(Y,K.length)}function x(K,Y){return(le,fe)=>Y(K(le),K(fe))}e.compareBy=x;const z=(K,Y)=>K-Y;e.numberComparator=z;function W(K,Y){if(K.length===0)return;let le=K[0];for(let fe=1;fe<K.length;fe++){const Se=K[fe];Y(Se,le)>0&&(le=Se)}return le}e.findMaxBy=W;function J(K,Y){if(K.length===0)return;let le=K[0];for(let fe=1;fe<K.length;fe++){const Se=K[fe];Y(Se,le)>=0&&(le=Se)}return le}e.findLastMaxBy=J;function se(K,Y){return W(K,(le,fe)=>-Y(le,fe))}e.findMinBy=se;class ie{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let le=this.firstIdx;for(;le<this.items.length&&Y(this.items[le]);)le++;const fe=le===this.firstIdx?null:this.items.slice(this.firstIdx,le);return this.firstIdx=le,fe}takeFromEndWhile(Y){let le=this.lastIdx;for(;le>=0&&Y(this.items[le]);)le--;const fe=le===this.lastIdx?null:this.items.slice(le+1,this.lastIdx+1);return this.lastIdx=le,fe}peek(){return this.items[this.firstIdx]}dequeue(){const Y=this.items[this.firstIdx];return this.firstIdx++,Y}takeCount(Y){const le=this.items.slice(this.firstIdx,this.firstIdx+Y);return this.firstIdx+=Y,le}}e.ArrayQueue=ie}),define(pe[76],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(t){const I=this;let D=!1,T;return function(){return D||(D=!0,T=t.apply(I,arguments)),T}}e.once=f}),define(pe[77],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(pe[78],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(t){function I(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}t.is=I;const D=Object.freeze([]);function T(){return D}t.empty=T;function*P(m){yield m}t.single=P;function C(m){return m||D}t.from=C;function A(m){return!m||m[Symbol.iterator]().next().done===!0}t.isEmpty=A;function R(m){return m[Symbol.iterator]().next().value}t.first=R;function y(m,o){for(const S of m)if(o(S))return!0;return!1}t.some=y;function l(m,o){for(const S of m)if(o(S))return S}t.find=l;function*b(m,o){for(const S of m)o(S)&&(yield S)}t.filter=b;function*p(m,o){let S=0;for(const r of m)yield o(r,S++)}t.map=p;function*g(...m){for(const o of m)for(const S of o)yield S}t.concat=g;function*E(m){for(const o of m)for(const S of o)yield S}t.concatNested=E;function L(m,o,S){let r=S;for(const i of m)r=o(r,i);return r}t.reduce=L;function*_(m,o,S=m.length){for(o<0&&(o+=m.length),S<0?S+=m.length:S>m.length&&(S=m.length);o<S;o++)yield m[o]}t.slice=_;function a(m,o=Number.POSITIVE_INFINITY){const S=[];if(o===0)return[S,m];const r=m[Symbol.iterator]();for(let i=0;i<o;i++){const n=r.next();if(n.done)return[S,t.empty()];S.push(n.value)}return[S,{[Symbol.iterator](){return r}}]}t.consume=a;function s(m,o,S=(r,i)=>r===i){const r=m[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const n=r.next(),u=i.next();if(n.done!==u.done)return!1;if(n.done)return!0;if(!S(n.value,u.value))return!1}}t.equals=s})(f=e.Iterable||(e.Iterable={}))}),define(pe[57],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(o){o.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function T(o,S=!1){let r=0,i=o.length,n="",u=0,c=16,d=0;function h(M){let V=0,$=0;for(;V<M;){const N=o.charCodeAt(r);if(N>=48&&N<=57)$=$*16+N-48;else if(N>=65&&N<=70)$=$*16+N-65+10;else if(N>=97&&N<=102)$=$*16+N-97+10;else break;r++,V++}return V<M&&($=-1),$}function w(M){r=M,n="",u=0,c=16,d=0}function v(){const M=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&A(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&A(o.charCodeAt(r)))for(r++;r<o.length&&A(o.charCodeAt(r));)r++;else return d=3,o.substring(M,r);let V=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&A(o.charCodeAt(r))){for(r++;r<o.length&&A(o.charCodeAt(r));)r++;V=r}else d=3;return o.substring(M,V)}function k(){let M="",V=r;for(;;){if(r>=i){M+=o.substring(V,r),d=2;break}const $=o.charCodeAt(r);if($===34){M+=o.substring(V,r),r++;break}if($===92){if(M+=o.substring(V,r),r++,r>=i){d=2;break}switch(o.charCodeAt(r++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const B=h(4);B>=0?M+=String.fromCharCode(B):d=4;break}default:d=5}V=r;continue}if($>=0&&$<=31)if(C($)){M+=o.substring(V,r),d=2;break}else d=6;r++}return M}function O(){if(n="",d=0,u=r,r>=i)return u=i,c=17;let M=o.charCodeAt(r);if(P(M)){do r++,n+=String.fromCharCode(M),M=o.charCodeAt(r);while(P(M));return c=15}if(C(M))return r++,n+=String.fromCharCode(M),M===13&&o.charCodeAt(r)===10&&(r++,n+=`
`),c=14;switch(M){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,n=k(),c=10;case 47:{const V=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<i&&!C(o.charCodeAt(r));)r++;return n=o.substring(V,r),c=12}if(o.charCodeAt(r+1)===42){r+=2;const $=i-1;let N=!1;for(;r<$;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,N=!0;break}r++}return N||(r++,d=1),n=o.substring(V,r),c=13}return n+=String.fromCharCode(M),r++,c=16}case 45:if(n+=String.fromCharCode(M),r++,r===i||!A(o.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=v(),c=11;default:for(;r<i&&U(M);)r++,M=o.charCodeAt(r);if(u!==r){switch(n=o.substring(u,r),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(M),r++,c=16}}function U(M){if(P(M)||C(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:w,getPosition:()=>r,scan:S?F:O,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>d}}e.createScanner=T;function P(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function C(o){return o===10||o===13||o===8232||o===8233}function A(o){return o>=48&&o<=57}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function y(o,S){const r=[],i=new Object;let n;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function d(h,w,v,k){u.value=h,u.offset=w,u.length=v,u.type=k,u.colonOffset=void 0,n=u}try{a(o,{onObjectBegin:(h,w)=>{if(S<=h)throw i;n=void 0,c=S>h,r.push("")},onObjectProperty:(h,w,v)=>{if(S<w||(d(h,w,v,"property"),r[r.length-1]=h,S<=w+v))throw i},onObjectEnd:(h,w)=>{if(S<=h)throw i;n=void 0,r.pop()},onArrayBegin:(h,w)=>{if(S<=h)throw i;n=void 0,r.push(0)},onArrayEnd:(h,w)=>{if(S<=h)throw i;n=void 0,r.pop()},onLiteralValue:(h,w,v)=>{if(S<w||(d(h,w,v,m(h)),S<=w+v))throw i},onSeparator:(h,w,v)=>{if(S<=w)throw i;if(h===":"&&n&&n.type==="property")n.colonOffset=w,c=!1,n=void 0;else if(h===","){const k=r[r.length-1];typeof k=="number"?r[r.length-1]=k+1:(c=!0,r[r.length-1]=""),n=void 0}}})}catch(h){if(h!==i)throw h}return{path:r,previousNode:n,isAtPropertyKey:c,matches:h=>{let w=0;for(let v=0;w<h.length&&v<r.length;v++)if(h[w]===r[v]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.getLocation=y;function l(o,S=[],r=D.DEFAULT){let i=null,n=[];const u=[];function c(h){Array.isArray(n)?n.push(h):i!==null&&(n[i]=h)}return a(o,{onObjectBegin:()=>{const h={};c(h),u.push(n),n=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{n=u.pop()},onArrayBegin:()=>{const h=[];c(h),u.push(n),n=h,i=null},onArrayEnd:()=>{n=u.pop()},onLiteralValue:c,onError:(h,w,v)=>{S.push({error:h,offset:w,length:v})}},r),n[0]}e.parse=l;function b(o,S=[],r=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function u(h){return i.children.push(h),h}a(o,{onObjectBegin:h=>{i=u({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,w,v)=>{i=u({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:w,length:v,parent:i})},onObjectEnd:(h,w)=>{i.length=h+w-i.offset,i=i.parent,n(h+w)},onArrayBegin:(h,w)=>{i=u({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,w)=>{i.length=h+w-i.offset,i=i.parent,n(h+w)},onLiteralValue:(h,w,v)=>{u({type:m(h),offset:w,length:v,parent:i,value:h}),n(w+v)},onSeparator:(h,w,v)=>{i.type==="property"&&(h===":"?i.colonOffset=w:h===","&&n(w))},onError:(h,w,v)=>{S.push({error:h,offset:w,length:v})}},r);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=b;function p(o,S){if(!o)return;let r=o;for(let i of S)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=p;function g(o){if(!o.parent||!o.parent.children)return[];const S=g(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;S.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&S.push(r)}return S}e.getNodePath=g;function E(o){switch(o.type){case"array":return o.children.map(E);case"object":{const S=Object.create(null);for(let r of o.children){const i=r.children[1];i&&(S[r.children[0].value]=E(i))}return S}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=E;function L(o,S,r=!1){return S>=o.offset&&S<o.offset+o.length||r&&S===o.offset+o.length}e.contains=L;function _(o,S,r=!1){if(L(o,S,r)){const i=o.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=S;n++){const u=_(i[n],S,r);if(u)return u}return o}}e.findNodeAtOffset=_;function a(o,S,r=D.DEFAULT){const i=T(o,!1);function n(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(ie){return ie?K=>ie(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=n(S.onObjectBegin),d=u(S.onObjectProperty),h=n(S.onObjectEnd),w=n(S.onArrayBegin),v=n(S.onArrayEnd),k=u(S.onLiteralValue),O=u(S.onSeparator),U=n(S.onComment),F=u(S.onError),M=r&&r.disallowComments,V=r&&r.allowTrailingComma;function $(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:M||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(ie){case 12:case 13:M?N(10):U();break;case 16:N(1);break;case 15:case 14:break;default:return ie}}}function N(ie,K=[],Y=[]){if(F(ie),K.length+Y.length>0){let le=i.getToken();for(;le!==17;){if(K.indexOf(le)!==-1){$();break}else if(Y.indexOf(le)!==-1)break;le=$()}}}function B(ie){const K=i.getTokenValue();return ie?k(K):d(K),$(),!0}function x(){switch(i.getToken()){case 11:{let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(N(2),ie=0)}catch{N(2)}k(ie);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return $(),!0}function z(){return i.getToken()!==10?(N(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(O(":"),$(),se()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){c(),$();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||N(4,[],[]),O(","),$(),i.getToken()===2&&V)break}else ie&&N(6,[],[]);z()||N(4,[],[2,5]),ie=!0}return h(),i.getToken()!==2?N(7,[2],[]):$(),!0}function J(){w(),$();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||N(4,[],[]),O(","),$(),i.getToken()===4&&V)break}else ie&&N(6,[],[]);se()||N(4,[],[4,5]),ie=!0}return v(),i.getToken()!==4?N(8,[4],[]):$(),!0}function se(){switch(i.getToken()){case 3:return J();case 1:return W();case 10:return B(!0);default:return x()}}return $(),i.getToken()===17?r.allowEmptyContent?!0:(N(4,[],[]),!1):se()?(i.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=a;function s(o,S){let r=T(o),i=[],n,u=0,c;do switch(c=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:u!==c&&i.push(o.substring(u,c)),S!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,S)),u=r.getPosition();break}while(n!==17);return i.join("")}e.stripComments=s;function m(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(pe[139],ve([0,1,57]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(A,R,y){let l,b,p,g,E;if(R){for(g=R.offset,E=g+R.length,p=g;p>0&&!C(A,p-1);)p--;let c=E;for(;c<A.length&&!C(A,c);)c++;b=A.substring(p,c),l=T(b,y)}else b=A,l=0,p=0,g=0,E=A.length;const L=P(y,A);let _=!1,a=0,s;y.insertSpaces?s=D(" ",y.tabSize||4):s="	";const m=(0,f.createScanner)(b,!1);let o=!1;function S(){return L+D(s,l+a)}function r(){let c=m.scan();for(_=!1;c===15||c===14;)_=_||c===14,c=m.scan();return o=c===16||m.getTokenError()!==0,c}const i=[];function n(c,d,h){!o&&d<E&&h>g&&A.substring(d,h)!==c&&i.push({offset:d,length:h-d,content:c})}let u=r();if(u!==17){const c=m.getTokenOffset()+p,d=D(s,l);n(d,p,c)}for(;u!==17;){let c=m.getTokenOffset()+m.getTokenLength()+p,d=r(),h="";for(;!_&&(d===12||d===13);){const v=m.getTokenOffset()+p;n(" ",c,v),c=m.getTokenOffset()+m.getTokenLength()+p,h=d===12?S():"",d=r()}if(d===2)u!==1&&(a--,h=S());else if(d===4)u!==3&&(a--,h=S());else{switch(u){case 3:case 1:a++,h=S();break;case 5:case 12:h=S();break;case 13:_?h=S():h=" ";break;case 6:h=" ";break;case 10:if(d===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?h=" ":d!==5&&d!==17&&(o=!0);break;case 16:o=!0;break}_&&(d===12||d===13)&&(h=S())}const w=m.getTokenOffset()+p;n(h,c,w),u=d}return i}e.format=t;function I(A,R){const y=JSON.stringify(A,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?y.replace(/\r\n|\r|\n/g,R.eol):y}e.toFormattedString=I;function D(A,R){let y="";for(let l=0;l<R;l++)y+=A;return y}function T(A,R){let y=0,l=0;const b=R.tabSize||4;for(;y<A.length;){const p=A.charAt(y);if(p===" ")l++;else if(p==="	")l+=b;else break;y++}return Math.floor(l/b)}function P(A,R){for(let y=0;y<R.length;y++){const l=R.charAt(y);if(l==="\r")return y+1<R.length&&R.charAt(y+1)===`
`?`\r
`:"\r";if(l===`
`)return`
`}return A&&A.eol||`
`}e.getEOL=P;function C(A,R){return`\r
`.indexOf(A.charAt(R))!==-1}e.isEOL=C}),define(pe[140],ve([0,1,57,139]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(A,R,y){return D(A,R,void 0,y)}e.removeProperty=I;function D(A,R,y,l,b){const p=R.slice(),g=[],E=(0,f.parseTree)(A,g);let L,_;for(;p.length>0&&(_=p.pop(),L=(0,f.findNodeAtLocation)(E,p),L===void 0&&y!==void 0);)typeof _=="string"?y={[_]:y}:y=[y];if(L)if(L.type==="object"&&typeof _=="string"&&Array.isArray(L.children)){const a=(0,f.findNodeAtLocation)(L,[_]);if(a!==void 0)if(y===void 0){if(!a.parent)throw new Error("Malformed AST");const s=L.children.indexOf(a.parent);let m,o=a.parent.offset+a.parent.length;if(s>0){const S=L.children[s-1];m=S.offset+S.length}else m=L.offset+1,L.children.length>1&&(o=L.children[1].offset);return T(A,{offset:m,length:o-m,content:""},l)}else return T(A,{offset:a.offset,length:a.length,content:JSON.stringify(y)},l);else{if(y===void 0)return[];const s=`${JSON.stringify(_)}: ${JSON.stringify(y)}`,m=b?b(L.children.map(S=>S.children[0].value)):L.children.length;let o;if(m>0){const S=L.children[m-1];o={offset:S.offset+S.length,length:0,content:","+s}}else L.children.length===0?o={offset:L.offset+1,length:0,content:s}:o={offset:L.offset+1,length:0,content:s+","};return T(A,o,l)}}else if(L.type==="array"&&typeof _=="number"&&Array.isArray(L.children))if(y!==void 0){const a=`${JSON.stringify(y)}`;let s;if(L.children.length===0||_===0)s={offset:L.offset+1,length:0,content:L.children.length===0?a:a+","};else{const m=_===-1||_>L.children.length?L.children.length:_,o=L.children[m-1];s={offset:o.offset+o.length,length:0,content:","+a}}return T(A,s,l)}else{const a=_,s=L.children[a];let m;if(L.children.length===1)m={offset:L.offset+1,length:L.length-2,content:""};else if(L.children.length-1===a){const o=L.children[a-1],S=o.offset+o.length,r=L.offset+L.length;m={offset:S,length:r-2-S,content:""}}else m={offset:s.offset,length:L.children[a+1].offset-s.offset,content:""};return T(A,m,l)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${L.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return T(A,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(y)},l)}}e.setProperty=D;function T(A,R,y){let l=P(A,R),b=R.offset,p=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;b>0&&!(0,t.isEOL)(l,b-1);)b--;for(;p<l.length&&!(0,t.isEOL)(l,p);)p++}const g=(0,t.format)(l,{offset:b,length:p-b},y);for(let L=g.length-1;L>=0;L--){const _=g[L];l=P(l,_),b=Math.min(b,_.offset),p=Math.max(p,_.offset+_.length),p+=_.content.length-_.length}const E=A.length-(l.length-p)-b;return[{offset:b,length:E,content:l.substring(b,p)}]}e.withFormatting=T;function P(A,R){return A.substring(0,R.offset)+R.content+A.substring(R.offset+R.length)}e.applyEdit=P;function C(A,R){let y=R.slice(0).sort((b,p)=>{const g=b.offset-p.offset;return g===0?b.length-p.length:g}),l=A.length;for(let b=y.length-1;b>=0;b--){let p=y[b];if(p.offset+p.length<=l)A=P(A,p);else throw new Error("Overlapping edit");l=p.offset}return A}e.applyEdits=C}),define(pe[92],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new f(()=>I(this.getValue()))}}e.Lazy=f}),define(pe[6],ve([0,1,76,78]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let D=null;function T(i){D=i}if(e.setDisposableTracker=T,I){const i="__is_disposable_tracked__";T(new class{trackDisposable(n){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[i]||console.log(u)},3e3)}setParent(n,u){if(n&&n!==_.None)try{n[i]=!0}catch{}}markAsDisposed(n){if(n&&n!==_.None)try{n[i]=!0}catch{}}markAsSingleton(n){}})}function P(i){return D?.trackDisposable(i),i}function C(i){D?.markAsDisposed(i)}function A(i,n){D?.setParent(i,n)}function R(i,n){if(!!D)for(const u of i)D.setParent(u,n)}function y(i){return D?.markAsSingleton(i),i}e.markAsSingleton=y;class l extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=l;function b(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=b;function p(i){if(t.Iterable.is(i)){let n=[];for(const u of i)if(u)try{u.dispose()}catch(c){n.push(c)}if(n.length===1)throw n[0];if(n.length>1)throw new l(n);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=p;function g(...i){const n=E(()=>p(i));return R(i,n),n}e.combinedDisposable=g;function E(i){const n=P({dispose:(0,f.once)(()=>{C(n),i()})});return n}e.toDisposable=E;class L{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{p(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return A(n,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=L,L.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new L,P(this),A(this._store,this)}dispose(){C(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&A(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&A(n,null),n}}e.MutableDisposable=a;class s{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class m{constructor(){this.references=new Map}acquire(n,...u){let c=this.references.get(n);c||(c={counter:0,object:this.createReferencedObject(n,...u)},this.references.set(n,c));const{object:d}=c,h=(0,f.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(n,c.object),this.references.delete(n))});return c.counter++,{object:d,dispose:h}}}e.ReferenceCollection=m;class o{constructor(n){this.referenceCollection=n}async acquire(n,...u){const c=this.referenceCollection.acquire(n,...u);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(d){throw c.dispose(),d}}}e.AsyncReferenceCollection=o;class S{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=S;function r(i){const n=new L;try{i(n)}finally{n.dispose()}}e.disposeOnReturn=r}),define(pe[93],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(D){this.element=D,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class t{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let D=this._first;for(;D!==f.Undefined;){const T=D.next;D.prev=f.Undefined,D.next=f.Undefined,D=T}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,T){const P=new f(D);if(this._first===f.Undefined)this._first=P,this._last=P;else if(T){const A=this._last;this._last=P,P.prev=A,A.next=P}else{const A=this._first;this._first=P,P.next=A,A.prev=P}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(P))}}shift(){if(this._first!==f.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==f.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==f.Undefined&&D.next!==f.Undefined){const T=D.prev;T.next=D.next,D.next.prev=T}else D.prev===f.Undefined&&D.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):D.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):D.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==f.Undefined;)yield D.element,D=D.next}}e.LinkedList=t}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Re,Ae){for(var De=0;De<Ae.length;De++){var ce=Ae[De];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Re,ce.key,ce)}}function e(Re,Ae,De){return Ae&&Z(Re.prototype,Ae),De&&Z(Re,De),Re}function f(Re,Ae){if(!!Re){if(typeof Re=="string")return t(Re,Ae);var De=Object.prototype.toString.call(Re).slice(8,-1);if(De==="Object"&&Re.constructor&&(De=Re.constructor.name),De==="Map"||De==="Set")return Array.from(Re);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return t(Re,Ae)}}function t(Re,Ae){(Ae==null||Ae>Re.length)&&(Ae=Re.length);for(var De=0,ce=new Array(Ae);De<Ae;De++)ce[De]=Re[De];return ce}function I(Re,Ae){var De=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(De)return(De=De.call(Re)).next.bind(De);if(Array.isArray(Re)||(De=f(Re))||Ae&&Re&&typeof Re.length=="number"){De&&(Re=De);var ce=0;return function(){return ce>=Re.length?{done:!0}:{done:!1,value:Re[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var D={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Re){D.exports.defaults=Re}D.exports={defaults:T(),getDefaults:T,changeDefaults:P};var C=/[&<>"']/,A=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ae){return l[Ae]};function p(Re,Ae){if(Ae){if(C.test(Re))return Re.replace(A,b)}else if(R.test(Re))return Re.replace(y,b);return Re}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function E(Re){return Re.replace(g,function(Ae,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var L=/(^|[^\[])\^/g;function _(Re,Ae){Re=Re.source||Re,Ae=Ae||"";var De={replace:function(de,we){return we=we.source||we,we=we.replace(L,"$1"),Re=Re.replace(de,we),De},getRegex:function(){return new RegExp(Re,Ae)}};return De}var a=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Re,Ae,De){if(Re){var ce;try{ce=decodeURIComponent(E(De)).replace(a,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}Ae&&!s.test(De)&&(De=n(Ae,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var o={},S=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Re,Ae){o[" "+Re]||(S.test(Re)?o[" "+Re]=Re+"/":o[" "+Re]=h(Re,"/",!0)),Re=o[" "+Re];var De=Re.indexOf(":")===-1;return Ae.substring(0,2)==="//"?De?Ae:Re.replace(r,"$1")+Ae:Ae.charAt(0)==="/"?De?Ae:Re.replace(i,"$1")+Ae:Re+Ae}var u={exec:function(){}};function c(Re){for(var Ae=1,De,ce;Ae<arguments.length;Ae++){De=arguments[Ae];for(ce in De)Object.prototype.hasOwnProperty.call(De,ce)&&(Re[ce]=De[ce])}return Re}function d(Re,Ae){var De=Re.replace(/\|/g,function(we,ye,Oe){for(var Ke=!1,We=ye;--We>=0&&Oe[We]==="\\";)Ke=!Ke;return Ke?"|":" |"}),ce=De.split(/ \|/),de=0;if(ce[0].trim()||ce.shift(),ce[ce.length-1].trim()||ce.pop(),ce.length>Ae)ce.splice(Ae);else for(;ce.length<Ae;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function h(Re,Ae,De){var ce=Re.length;if(ce===0)return"";for(var de=0;de<ce;){var we=Re.charAt(ce-de-1);if(we===Ae&&!De)de++;else if(we!==Ae&&De)de++;else break}return Re.substr(0,ce-de)}function w(Re,Ae){if(Re.indexOf(Ae[1])===-1)return-1;for(var De=Re.length,ce=0,de=0;de<De;de++)if(Re[de]==="\\")de++;else if(Re[de]===Ae[0])ce++;else if(Re[de]===Ae[1]&&(ce--,ce<0))return de;return-1}function v(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Re,Ae){if(Ae<1)return"";for(var De="";Ae>1;)Ae&1&&(De+=Re),Ae>>=1,Re+=Re;return De+Re}var O={escape:p,unescape:E,edit:_,cleanUrl:m,resolveUrl:n,noopTest:u,merge:c,splitCells:d,rtrim:h,findClosingBracket:w,checkSanitizeDeprecation:v,repeatString:k},U=D.exports.defaults,F=O.rtrim,M=O.splitCells,V=O.escape,$=O.findClosingBracket;function N(Re,Ae,De,ce){var de=Ae.href,we=Ae.title?V(Ae.title):null,ye=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){ce.state.inLink=!0;var Oe={type:"link",raw:De,href:de,title:we,text:ye,tokens:ce.inlineTokens(ye,[])};return ce.state.inLink=!1,Oe}else return{type:"image",raw:De,href:de,title:we,text:V(ye)}}function B(Re,Ae){var De=Re.match(/^(\s+)(?:```)/);if(De===null)return Ae;var ce=De[1];return Ae.split(`
`).map(function(de){var we=de.match(/^\s+/);if(we===null)return de;var ye=we[0];return ye.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var x=function(){function Re(De){this.options=De||U}var Ae=Re.prototype;return Ae.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Ae.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var we=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?we:F(we,`
`)}}},Ae.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var we=de[0],ye=B(we,de[3]||"");return{type:"code",raw:we,lang:de[2]?de[2].trim():de[2],text:ye}}},Ae.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var we=de[2].trim();if(/#$/.test(we)){var ye=F(we,"#");(this.options.pedantic||!ye||/ $/.test(ye))&&(we=ye.trim())}var Oe={type:"heading",raw:de[0],depth:de[1].length,text:we,tokens:[]};return this.lexer.inline(Oe.text,Oe.tokens),Oe}},Ae.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},Ae.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var we=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},Ae.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var we,ye,Oe,Ke,We,Ze,lt,ct,$e,be,_e=de[1].trim(),he=_e.length>1,X={type:"list",raw:"",ordered:he,start:he?+_e.slice(0,-1):"",loose:!1,items:[]};_e=he?"\\d{1,9}\\"+_e.slice(-1):"\\"+_e,this.options.pedantic&&(_e=he?_e:"[*+-]");for(var ke=new RegExp("^( {0,3}"+_e+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ce&&!(this.rules.block.hr.test(ce)||!(de=ke.exec(ce)));){$e=de[2].split(`
`),this.options.pedantic?(Ke=2,be=$e[0].trimLeft()):(Ke=de[2].search(/[^ ]/),Ke=de[1].length+(Ke>4?1:Ke),be=$e[0].slice(Ke-de[1].length)),Ze=!1,we=de[0],!$e[0]&&/^ *$/.test($e[1])&&(we=de[1]+$e.slice(0,2).join(`
`)+`
`,X.loose=!0,$e=[]);var Be=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(We=1;We<$e.length;We++){if(ct=$e[We],this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Be.test(ct)){we=de[1]+$e.slice(0,We).join(`
`)+`
`;break}if(!Ze){ct.trim()||(Ze=!0),ct.search(/[^ ]/)>=Ke?be+=`
`+ct.slice(Ke):be+=`
`+ct;continue}if(ct.search(/[^ ]/)>=Ke||!ct.trim()){be+=`
`+ct.slice(Ke);continue}else{we=de[1]+$e.slice(0,We).join(`
`)+`
`;break}}X.loose||(lt?X.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(ye=/^\[[ xX]\] /.exec(be),ye&&(Oe=ye[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),X.items.push({type:"list_item",raw:we,task:!!ye,checked:Oe,loose:!1,text:be}),X.raw+=we,ce=ce.slice(we.length)}X.items[X.items.length-1].raw=we.trimRight(),X.items[X.items.length-1].text=be.trimRight(),X.raw=X.raw.trimRight();var Je=X.items.length;for(We=0;We<Je;We++)this.lexer.state.top=!1,X.items[We].tokens=this.lexer.blockTokens(X.items[We].text,[]),X.items[We].tokens.some(function(Qe){return Qe.type==="space"})&&(X.loose=!0,X.items[We].loose=!0);return X}},Ae.html=function(ce){var de=this.rules.block.html.exec(ce);if(de){var we={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},Ae.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var we=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:de[0],href:de[2],title:de[3]}}},Ae.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var we={type:"table",header:M(de[1]).map(function(lt){return{text:lt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=de[0];var ye=we.align.length,Oe,Ke,We,Ze;for(Oe=0;Oe<ye;Oe++)/^ *-+: *$/.test(we.align[Oe])?we.align[Oe]="right":/^ *:-+: *$/.test(we.align[Oe])?we.align[Oe]="center":/^ *:-+ *$/.test(we.align[Oe])?we.align[Oe]="left":we.align[Oe]=null;for(ye=we.rows.length,Oe=0;Oe<ye;Oe++)we.rows[Oe]=M(we.rows[Oe],we.header.length).map(function(lt){return{text:lt}});for(ye=we.header.length,Ke=0;Ke<ye;Ke++)we.header[Ke].tokens=[],this.lexer.inlineTokens(we.header[Ke].text,we.header[Ke].tokens);for(ye=we.rows.length,Ke=0;Ke<ye;Ke++)for(Ze=we.rows[Ke],We=0;We<Ze.length;We++)Ze[We].tokens=[],this.lexer.inlineTokens(Ze[We].text,Ze[We].tokens);return we}}},Ae.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de){var we={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de){var we={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.text=function(ce){var de=this.rules.block.text.exec(ce);if(de){var we={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:V(de[1])}},Ae.tag=function(ce){var de=this.rules.inline.tag.exec(ce);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]):de[0]}},Ae.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var we=de[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var ye=F(we.slice(0,-1),"\\");if((we.length-ye.length)%2==0)return}else{var Oe=$(de[2],"()");if(Oe>-1){var Ke=de[0].indexOf("!")===0?5:4,We=Ke+de[1].length+Oe;de[2]=de[2].substring(0,Oe),de[0]=de[0].substring(0,We).trim(),de[3]=""}}var Ze=de[2],lt="";if(this.options.pedantic){var ct=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ze);ct&&(Ze=ct[1],lt=ct[3])}else lt=de[3]?de[3].slice(1,-1):"";return Ze=Ze.trim(),/^</.test(Ze)&&(this.options.pedantic&&!/>$/.test(we)?Ze=Ze.slice(1):Ze=Ze.slice(1,-1)),N(de,{href:Ze&&Ze.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Ae.reflink=function(ce,de){var we;if((we=this.rules.inline.reflink.exec(ce))||(we=this.rules.inline.nolink.exec(ce))){var ye=(we[2]||we[1]).replace(/\s+/g," ");if(ye=de[ye.toLowerCase()],!ye||!ye.href){var Oe=we[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return N(we,ye,we[0],this.lexer)}},Ae.emStrong=function(ce,de,we){we===void 0&&(we="");var ye=this.rules.inline.emStrong.lDelim.exec(ce);if(!!ye&&!(ye[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=ye[1]||ye[2]||"";if(!Oe||Oe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ke=ye[0].length-1,We,Ze,lt=Ke,ct=0,$e=ye[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,de=de.slice(-1*ce.length+Ke);(ye=$e.exec(de))!=null;)if(We=ye[1]||ye[2]||ye[3]||ye[4]||ye[5]||ye[6],!!We){if(Ze=We.length,ye[3]||ye[4]){lt+=Ze;continue}else if((ye[5]||ye[6])&&Ke%3&&!((Ke+Ze)%3)){ct+=Ze;continue}if(lt-=Ze,!(lt>0)){if(Ze=Math.min(Ze,Ze+lt+ct),Math.min(Ke,Ze)%2){var be=ce.slice(1,Ke+ye.index+Ze);return{type:"em",raw:ce.slice(0,Ke+ye.index+Ze+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var _e=ce.slice(2,Ke+ye.index+Ze-1);return{type:"strong",raw:ce.slice(0,Ke+ye.index+Ze+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}}}}},Ae.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var we=de[2].replace(/\n/g," "),ye=/[^ ]/.test(we),Oe=/^ /.test(we)&&/ $/.test(we);return ye&&Oe&&(we=we.substring(1,we.length-1)),we=V(we,!0),{type:"codespan",raw:de[0],text:we}}},Ae.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},Ae.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Ae.autolink=function(ce,de){var we=this.rules.inline.autolink.exec(ce);if(we){var ye,Oe;return we[2]==="@"?(ye=V(this.options.mangle?de(we[1]):we[1]),Oe="mailto:"+ye):(ye=V(we[1]),Oe=ye),{type:"link",raw:we[0],text:ye,href:Oe,tokens:[{type:"text",raw:ye,text:ye}]}}},Ae.url=function(ce,de){var we;if(we=this.rules.inline.url.exec(ce)){var ye,Oe;if(we[2]==="@")ye=V(this.options.mangle?de(we[0]):we[0]),Oe="mailto:"+ye;else{var Ke;do Ke=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ke!==we[0]);ye=V(we[0]),we[1]==="www."?Oe="http://"+ye:Oe=ye}return{type:"link",raw:we[0],text:ye,href:Oe,tokens:[{type:"text",raw:ye,text:ye}]}}},Ae.inlineText=function(ce,de){var we=this.rules.inline.text.exec(ce);if(we){var ye;return this.lexer.state.inRawBlock?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):V(we[0]):we[0]:ye=V(this.options.smartypants?de(we[0]):we[0]),{type:"text",raw:we[0],text:ye}}},Re}(),z=O.noopTest,W=O.edit,J=O.merge,se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=W(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=W(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=W(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=W(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=W(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=W(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=J({},se),se.gfm=J({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=W(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=J({},se.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:W(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=W(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=W(se._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=W(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=W(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=W(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=W(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=W(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=W(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=W(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=W(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=J({},ie),ie.pedantic=J({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=J({},ie.normal,{escape:W(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=W(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=J({},ie.gfm,{br:W(ie.br).replace("{2,}","*").getRegex(),text:W(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var K={block:se,inline:ie},Y=x,le=D.exports.defaults,fe=K.block,Se=K.inline,Me=O.repeatString;function Ve(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ge(Re){var Ae="",De,ce,de=Re.length;for(De=0;De<de;De++)ce=Re.charCodeAt(De),Math.random()>.5&&(ce="x"+ce.toString(16)),Ae+="&#"+ce+";";return Ae}var Ye=function(){function Re(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||le,this.options.tokenizer=this.options.tokenizer||new Y,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:fe.normal,inline:Se.normal};this.options.pedantic?(ce.block=fe.pedantic,ce.inline=Se.pedantic):this.options.gfm&&(ce.block=fe.gfm,this.options.breaks?ce.inline=Se.breaks:ce.inline=Se.gfm),this.tokenizer.rules=ce}Re.lex=function(ce,de){var we=new Re(de);return we.lex(ce)},Re.lexInline=function(ce,de){var we=new Re(de);return we.inlineTokens(ce)};var Ae=Re.prototype;return Ae.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Ae.blockTokens=function(ce,de){var we=this;de===void 0&&(de=[]),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var ye,Oe,Ke,We;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(ye=lt.call({lexer:we},ce,de))?(ce=ce.substring(ye.raw.length),de.push(ye),!0):!1}))){if(ye=this.tokenizer.space(ce)){ce=ce.substring(ye.raw.length),ye.type&&de.push(ye);continue}if(ye=this.tokenizer.code(ce)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye);continue}if(ye=this.tokenizer.fences(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.heading(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.hr(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.blockquote(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.list(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.html(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.def(ce)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[ye.tag]||(this.tokens.links[ye.tag]={href:ye.href,title:ye.title});continue}if(ye=this.tokenizer.table(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.lheading(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=1/0,ct=ce.slice(1),$e=void 0;we.options.extensions.startBlock.forEach(function(be){$e=be.call({lexer:this},ct),typeof $e=="number"&&$e>=0&&(lt=Math.min(lt,$e))}),lt<1/0&&lt>=0&&(Ke=ce.substring(0,lt+1))}(),this.state.top&&(ye=this.tokenizer.paragraph(Ke))){Oe=de[de.length-1],We&&Oe.type==="paragraph"?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye),We=Ke.length!==ce.length,ce=ce.substring(ye.raw.length);continue}if(ye=this.tokenizer.text(ce)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye);continue}if(ce){var Ze="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ze);break}else throw new Error(Ze)}}return this.state.top=!0,de},Ae.inline=function(ce,de){this.inlineQueue.push({src:ce,tokens:de})},Ae.inlineTokens=function(ce,de){var we=this;de===void 0&&(de=[]);var ye,Oe,Ke,We=ce,Ze,lt,ct;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(Ze=this.tokenizer.rules.inline.reflinkSearch.exec(We))!=null;)$e.includes(Ze[0].slice(Ze[0].lastIndexOf("[")+1,-1))&&(We=We.slice(0,Ze.index)+"["+Me("a",Ze[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ze=this.tokenizer.rules.inline.blockSkip.exec(We))!=null;)We=We.slice(0,Ze.index)+"["+Me("a",Ze[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ze=this.tokenizer.rules.inline.escapedEmSt.exec(We))!=null;)We=We.slice(0,Ze.index)+"++"+We.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(lt||(ct=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_e){return(ye=_e.call({lexer:we},ce,de))?(ce=ce.substring(ye.raw.length),de.push(ye),!0):!1}))){if(ye=this.tokenizer.escape(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.tag(ce)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&ye.type==="text"&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ye=this.tokenizer.link(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&ye.type==="text"&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ye=this.tokenizer.emStrong(ce,We,ct)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.codespan(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.br(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.del(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.autolink(ce,Ge)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(ce,Ge))){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var _e=1/0,he=ce.slice(1),X=void 0;we.options.extensions.startInline.forEach(function(ke){X=ke.call({lexer:this},he),typeof X=="number"&&X>=0&&(_e=Math.min(_e,X))}),_e<1/0&&_e>=0&&(Ke=ce.substring(0,_e+1))}(),ye=this.tokenizer.inlineText(Ke,Ve)){ce=ce.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(ct=ye.raw.slice(-1)),lt=!0,Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ce){var be="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:fe,inline:Se}}}]),Re}(),q=D.exports.defaults,te=O.cleanUrl,G=O.escape,Q=function(){function Re(De){this.options=De||q}var Ae=Re.prototype;return Ae.code=function(ce,de,we){var ye=(de||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(ce,ye);Oe!=null&&Oe!==ce&&(we=!0,ce=Oe)}return ce=ce.replace(/\n$/,"")+`
`,ye?'<pre><code class="'+this.options.langPrefix+G(ye,!0)+'">'+(we?ce:G(ce,!0))+`</code></pre>
`:"<pre><code>"+(we?ce:G(ce,!0))+`</code></pre>
`},Ae.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},Ae.html=function(ce){return ce},Ae.heading=function(ce,de,we,ye){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+ye.slug(we)+'">'+ce+"</h"+de+`>
`:"<h"+de+">"+ce+"</h"+de+`>
`},Ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ae.list=function(ce,de,we){var ye=de?"ol":"ul",Oe=de&&we!==1?' start="'+we+'"':"";return"<"+ye+Oe+`>
`+ce+"</"+ye+`>
`},Ae.listitem=function(ce){return"<li>"+ce+`</li>
`},Ae.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ae.paragraph=function(ce){return"<p>"+ce+`</p>
`},Ae.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},Ae.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},Ae.tablecell=function(ce,de){var we=de.header?"th":"td",ye=de.align?"<"+we+' align="'+de.align+'">':"<"+we+">";return ye+ce+"</"+we+`>
`},Ae.strong=function(ce){return"<strong>"+ce+"</strong>"},Ae.em=function(ce){return"<em>"+ce+"</em>"},Ae.codespan=function(ce){return"<code>"+ce+"</code>"},Ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ae.del=function(ce){return"<del>"+ce+"</del>"},Ae.link=function(ce,de,we){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return we;var ye='<a href="'+G(ce)+'"';return de&&(ye+=' title="'+de+'"'),ye+=">"+we+"</a>",ye},Ae.image=function(ce,de,we){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return we;var ye='<img src="'+ce+'" alt="'+we+'"';return de&&(ye+=' title="'+de+'"'),ye+=this.options.xhtml?"/>":">",ye},Ae.text=function(ce){return ce},Re}(),oe=function(){function Re(){}var Ae=Re.prototype;return Ae.strong=function(ce){return ce},Ae.em=function(ce){return ce},Ae.codespan=function(ce){return ce},Ae.del=function(ce){return ce},Ae.html=function(ce){return ce},Ae.text=function(ce){return ce},Ae.link=function(ce,de,we){return""+we},Ae.image=function(ce,de,we){return""+we},Ae.br=function(){return""},Re}(),me=function(){function Re(){this.seen={}}var Ae=Re.prototype;return Ae.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ae.getNextSafeSlug=function(ce,de){var we=ce,ye=0;if(this.seen.hasOwnProperty(we)){ye=this.seen[ce];do ye++,we=ce+"-"+ye;while(this.seen.hasOwnProperty(we))}return de||(this.seen[ce]=ye,this.seen[we]=0),we},Ae.slug=function(ce,de){de===void 0&&(de={});var we=this.serialize(ce);return this.getNextSafeSlug(we,de.dryrun)},Re}(),Ie=Q,xe=oe,Xe=me,it=D.exports.defaults,st=O.unescape,ot=function(){function Re(De){this.options=De||it,this.options.renderer=this.options.renderer||new Ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new xe,this.slugger=new Xe}Re.parse=function(ce,de){var we=new Re(de);return we.parse(ce)},Re.parseInline=function(ce,de){var we=new Re(de);return we.parseInline(ce)};var Ae=Re.prototype;return Ae.parse=function(ce,de){de===void 0&&(de=!0);var we="",ye,Oe,Ke,We,Ze,lt,ct,$e,be,_e,he,X,ke,Be,Je,Qe,pt,St,Ct,ft=ce.length;for(ye=0;ye<ft;ye++){if(_e=ce[ye],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_e.type]&&(Ct=this.options.extensions.renderers[_e.type].call({parser:this},_e),Ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_e.type))){we+=Ct||"";continue}switch(_e.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,st(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for($e="",ct="",We=_e.header.length,Oe=0;Oe<We;Oe++)ct+=this.renderer.tablecell(this.parseInline(_e.header[Oe].tokens),{header:!0,align:_e.align[Oe]});for($e+=this.renderer.tablerow(ct),be="",We=_e.rows.length,Oe=0;Oe<We;Oe++){for(lt=_e.rows[Oe],ct="",Ze=lt.length,Ke=0;Ke<Ze;Ke++)ct+=this.renderer.tablecell(this.parseInline(lt[Ke].tokens),{header:!1,align:_e.align[Ke]});be+=this.renderer.tablerow(ct)}we+=this.renderer.table($e,be);continue}case"blockquote":{be=this.parse(_e.tokens),we+=this.renderer.blockquote(be);continue}case"list":{for(he=_e.ordered,X=_e.start,ke=_e.loose,We=_e.items.length,be="",Oe=0;Oe<We;Oe++)Je=_e.items[Oe],Qe=Je.checked,pt=Je.task,Be="",Je.task&&(St=this.renderer.checkbox(Qe),ke?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=St+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=St+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:St}):Be+=St),Be+=this.parse(Je.tokens,ke),be+=this.renderer.listitem(Be,pt,Qe);we+=this.renderer.list(be,he,X);continue}case"html":{we+=this.renderer.html(_e.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(be=_e.tokens?this.parseInline(_e.tokens):_e.text;ye+1<ft&&ce[ye+1].type==="text";)_e=ce[++ye],be+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);we+=de?this.renderer.paragraph(be):be;continue}default:{var wt='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(wt);return}else throw new Error(wt)}}}return we},Ae.parseInline=function(ce,de){de=de||this.renderer;var we="",ye,Oe,Ke,We=ce.length;for(ye=0;ye<We;ye++){if(Oe=ce[ye],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(Ke=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){we+=Ke||"";continue}switch(Oe.type){case"escape":{we+=de.text(Oe.text);break}case"html":{we+=de.html(Oe.text);break}case"link":{we+=de.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,de));break}case"image":{we+=de.image(Oe.href,Oe.title,Oe.text);break}case"strong":{we+=de.strong(this.parseInline(Oe.tokens,de));break}case"em":{we+=de.em(this.parseInline(Oe.tokens,de));break}case"codespan":{we+=de.codespan(Oe.text);break}case"br":{we+=de.br();break}case"del":{we+=de.del(this.parseInline(Oe.tokens,de));break}case"text":{we+=de.text(Oe.text);break}default:{var Ze='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return we},Re}(),tt=Ye,rt=ot,gt=x,Ne=Q,It=oe,ee=me,ne=O.merge,Ee=O.checkSanitizeDeprecation,re=O.escape,Ce=D.exports.getDefaults,Fe=D.exports.changeDefaults,qe=D.exports.defaults;function ze(Re,Ae,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Ae=="function"&&(De=Ae,Ae=null),Ae=ne({},ze.defaults,Ae||{}),Ee(Ae),De){var ce=Ae.highlight,de;try{de=tt.lex(Re,Ae)}catch(Ke){return De(Ke)}var we=function(We){var Ze;if(!We)try{Ae.walkTokens&&ze.walkTokens(de,Ae.walkTokens),Ze=rt.parse(de,Ae)}catch(lt){We=lt}return Ae.highlight=ce,We?De(We):De(null,Ze)};if(!ce||ce.length<3||(delete Ae.highlight,!de.length))return we();var ye=0;ze.walkTokens(de,function(Ke){Ke.type==="code"&&(ye++,setTimeout(function(){ce(Ke.text,Ke.lang,function(We,Ze){if(We)return we(We);Ze!=null&&Ze!==Ke.text&&(Ke.text=Ze,Ke.escaped=!0),ye--,ye===0&&we()})},0))}),ye===0&&we();return}try{var Oe=tt.lex(Re,Ae);return Ae.walkTokens&&ze.walkTokens(Oe,Ae.walkTokens),rt.parse(Oe,Ae)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+re(Ke.message+"",!0)+"</pre>";throw Ke}}ze.options=ze.setOptions=function(Re){return ne(ze.defaults,Re),Fe(ze.defaults),ze},ze.getDefaults=Ce,ze.defaults=qe,ze.use=function(){for(var Re=this,Ae=arguments.length,De=new Array(Ae),ce=0;ce<Ae;ce++)De[ce]=arguments[ce];var de=ne.apply(void 0,[{}].concat(De)),we=ze.defaults.extensions||{renderers:{},childTokens:{}},ye;De.forEach(function(Oe){if(Oe.extensions&&(ye=!0,Oe.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var Ze=we.renderers?we.renderers[We.name]:null;Ze?we.renderers[We.name]=function(){for(var lt=arguments.length,ct=new Array(lt),$e=0;$e<lt;$e++)ct[$e]=arguments[$e];var be=We.renderer.apply(this,ct);return be===!1&&(be=Ze.apply(this,ct)),be}:we.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[We.level]?we[We.level].unshift(We.tokenizer):we[We.level]=[We.tokenizer],We.start&&(We.level==="block"?we.startBlock?we.startBlock.push(We.start):we.startBlock=[We.start]:We.level==="inline"&&(we.startInline?we.startInline.push(We.start):we.startInline=[We.start]))}We.childTokens&&(we.childTokens[We.name]=We.childTokens)})),Oe.renderer&&function(){var We=ze.defaults.renderer||new Ne,Ze=function($e){var be=We[$e];We[$e]=function(){for(var _e=arguments.length,he=new Array(_e),X=0;X<_e;X++)he[X]=arguments[X];var ke=Oe.renderer[$e].apply(We,he);return ke===!1&&(ke=be.apply(We,he)),ke}};for(var lt in Oe.renderer)Ze(lt);de.renderer=We}(),Oe.tokenizer&&function(){var We=ze.defaults.tokenizer||new gt,Ze=function($e){var be=We[$e];We[$e]=function(){for(var _e=arguments.length,he=new Array(_e),X=0;X<_e;X++)he[X]=arguments[X];var ke=Oe.tokenizer[$e].apply(We,he);return ke===!1&&(ke=be.apply(We,he)),ke}};for(var lt in Oe.tokenizer)Ze(lt);de.tokenizer=We}(),Oe.walkTokens){var Ke=ze.defaults.walkTokens;de.walkTokens=function(We){Oe.walkTokens.call(Re,We),Ke&&Ke(We)}}ye&&(de.extensions=we),ze.setOptions(de)})},ze.walkTokens=function(Re,Ae){for(var De=function(){var ye=de.value;switch(Ae(ye),ye.type){case"table":{for(var Oe=I(ye.header),Ke;!(Ke=Oe()).done;){var We=Ke.value;ze.walkTokens(We.tokens,Ae)}for(var Ze=I(ye.rows),lt;!(lt=Ze()).done;)for(var ct=lt.value,$e=I(ct),be;!(be=$e()).done;){var _e=be.value;ze.walkTokens(_e.tokens,Ae)}break}case"list":{ze.walkTokens(ye.items,Ae);break}default:ze.defaults.extensions&&ze.defaults.extensions.childTokens&&ze.defaults.extensions.childTokens[ye.type]?ze.defaults.extensions.childTokens[ye.type].forEach(function(he){ze.walkTokens(ye[he],Ae)}):ye.tokens&&ze.walkTokens(ye.tokens,Ae)}},ce=I(Re),de;!(de=ce()).done;)De()},ze.parseInline=function(Re,Ae){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Ae=ne({},ze.defaults,Ae||{}),Ee(Ae);try{var De=tt.lexInline(Re,Ae);return Ae.walkTokens&&ze.walkTokens(De,Ae.walkTokens),rt.parseInline(De,Ae)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+re(ce.message+"",!0)+"</pre>";throw ce}},ze.Parser=rt,ze.parser=rt.parse,ze.Renderer=Ne,ze.TextRenderer=It,ze.Lexer=tt,ze.lexer=tt.lex,ze.Tokenizer=gt,ze.Slugger=ee,ze.parse=ze;var ut=ze;return ut}),define(pe[94],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(P,C,A){return Math.min(Math.max(P,C),A)}e.clamp=f;function t(P,C){return(C+P%C)%C}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class D{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=D;class T{constructor(C){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(C),this._values.fill(0,0,C)}update(C){const A=this._values[this._index];return this._values[this._index]=C,this._index=(this._index+1)%this._values.length,this._sum-=A,this._sum+=C,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function Z(I){const D=[];typeof I=="number"&&D.push("code/timeOrigin",I);function T(C){D.push(C,Date.now())}function P(){const C=[];for(let A=0;A<D.length;A+=2)C.push({name:D[A],startTime:D[A+1]});return C}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(I+T.startTime)});return D}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function f(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=f(t))}(),define(pe[12],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let t=!1,I=!1,D=!1,T=!1,P=!1,C=!1,A=!1,R=!1,y,l=f,b,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const E=typeof g?.versions?.electron=="string",L=E&&g?.type==="renderer";if(e.isElectronSandboxed=L&&g?.sandboxed,typeof navigator=="object"&&!L)p=navigator.userAgent,t=p.indexOf("Windows")>=0,I=p.indexOf("Macintosh")>=0,R=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=p.indexOf("Linux")>=0,C=!0,y=navigator.language,l=y;else if(typeof g=="object"){t=g.platform==="win32",I=g.platform==="darwin",D=g.platform==="linux",T=D&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,A=E,y=f,l=f;const n=g.env.VSCODE_NLS_CONFIG;if(n)try{const u=JSON.parse(n),c=u.availableLanguages["*"];y=u.locale,l=c||f,b=u._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var _;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function a(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let s=0;I?s=1:t?s=3:D&&(s=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=D,e.isLinuxSnap=T,e.isNative=P,e.isElectron=A,e.isWeb=C,e.isIOS=R,e.platform=s,e.userAgent=p,e.language=l;var m;(function(n){function u(){return e.language}n.value=u;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=c;function d(){return e.language==="en"}n.isDefault=d})(m=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=b,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let d=0,h=n.length;d<h;d++){const w=n[d];if(w.id===c.data.vscodeScheduleAsyncWork){n.splice(d,1),w.callback();return}}});let u=0;return c=>{const d=++u;n.push({id:d,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return n=>setTimeout(n)})();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||R?2:t?1:3;let S=!0,r=!1;function i(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,S=new Uint16Array(n.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=i}),define(pe[40],ve([0,1,12]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const I=f.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(pe[9],ve([0,1,40]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,D=90,T=122,P=46,C=47,A=92,R=58,y=63;class l extends Error{constructor(s,m,o){let S;typeof m=="string"&&m.indexOf("not ")===0?(S="must not be",m=m.replace(/^not /,"")):S="must be";const r=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${r} ${S} of type ${m}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function b(a,s){if(typeof a!="string")throw new l(s,"string",a)}function p(a){return a===C||a===A}function g(a){return a===C}function E(a){return a>=t&&a<=D||a>=I&&a<=T}function L(a,s,m,o){let S="",r=0,i=-1,n=0,u=0;for(let c=0;c<=a.length;++c){if(c<a.length)u=a.charCodeAt(c);else{if(o(u))break;u=C}if(o(u)){if(!(i===c-1||n===1))if(n===2){if(S.length<2||r!==2||S.charCodeAt(S.length-1)!==P||S.charCodeAt(S.length-2)!==P){if(S.length>2){const d=S.lastIndexOf(m);d===-1?(S="",r=0):(S=S.slice(0,d),r=S.length-1-S.lastIndexOf(m)),i=c,n=0;continue}else if(S.length!==0){S="",r=0,i=c,n=0;continue}}s&&(S+=S.length>0?`${m}..`:"..",r=2)}else S.length>0?S+=`${m}${a.slice(i+1,c)}`:S=a.slice(i+1,c),r=c-i-1;i=c,n=0}else u===P&&n!==-1?++n:n=-1}return S}function _(a,s){if(s===null||typeof s!="object")throw new l("pathObject","Object",s);const m=s.dir||s.root,o=s.base||`${s.name||""}${s.ext||""}`;return m?m===s.root?`${m}${o}`:`${m}${a}${o}`:o}e.win32={resolve(...a){let s="",m="",o=!1;for(let S=a.length-1;S>=-1;S--){let r;if(S>=0){if(r=a[S],b(r,"path"),r.length===0)continue}else s.length===0?r=f.cwd():(r=f.env[`=${s}`]||f.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==s.toLowerCase()&&r.charCodeAt(2)===A)&&(r=`${s}\\`));const i=r.length;let n=0,u="",c=!1;const d=r.charCodeAt(0);if(i===1)p(d)&&(n=1,c=!0);else if(p(d))if(c=!0,p(r.charCodeAt(1))){let h=2,w=h;for(;h<i&&!p(r.charCodeAt(h));)h++;if(h<i&&h!==w){const v=r.slice(w,h);for(w=h;h<i&&p(r.charCodeAt(h));)h++;if(h<i&&h!==w){for(w=h;h<i&&!p(r.charCodeAt(h));)h++;(h===i||h!==w)&&(u=`\\\\${v}\\${r.slice(w,h)}`,n=h)}}}else n=1;else E(d)&&r.charCodeAt(1)===R&&(u=r.slice(0,2),n=2,i>2&&p(r.charCodeAt(2))&&(c=!0,n=3));if(u.length>0)if(s.length>0){if(u.toLowerCase()!==s.toLowerCase())continue}else s=u;if(o){if(s.length>0)break}else if(m=`${r.slice(n)}\\${m}`,o=c,c&&s.length>0)break}return m=L(m,!o,"\\",p),o?`${s}\\${m}`:`${s}${m}`||"."},normalize(a){b(a,"path");const s=a.length;if(s===0)return".";let m=0,o,S=!1;const r=a.charCodeAt(0);if(s===1)return g(r)?"\\":a;if(p(r))if(S=!0,p(a.charCodeAt(1))){let n=2,u=n;for(;n<s&&!p(a.charCodeAt(n));)n++;if(n<s&&n!==u){const c=a.slice(u,n);for(u=n;n<s&&p(a.charCodeAt(n));)n++;if(n<s&&n!==u){for(u=n;n<s&&!p(a.charCodeAt(n));)n++;if(n===s)return`\\\\${c}\\${a.slice(u)}\\`;n!==u&&(o=`\\\\${c}\\${a.slice(u,n)}`,m=n)}}}else m=1;else E(r)&&a.charCodeAt(1)===R&&(o=a.slice(0,2),m=2,s>2&&p(a.charCodeAt(2))&&(S=!0,m=3));let i=m<s?L(a.slice(m),!S,"\\",p):"";return i.length===0&&!S&&(i="."),i.length>0&&p(a.charCodeAt(s-1))&&(i+="\\"),o===void 0?S?`\\${i}`:i:S?`${o}\\${i}`:`${o}${i}`},isAbsolute(a){b(a,"path");const s=a.length;if(s===0)return!1;const m=a.charCodeAt(0);return p(m)||s>2&&E(m)&&a.charCodeAt(1)===R&&p(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let s,m;for(let r=0;r<a.length;++r){const i=a[r];b(i,"path"),i.length>0&&(s===void 0?s=m=i:s+=`\\${i}`)}if(s===void 0)return".";let o=!0,S=0;if(typeof m=="string"&&p(m.charCodeAt(0))){++S;const r=m.length;r>1&&p(m.charCodeAt(1))&&(++S,r>2&&(p(m.charCodeAt(2))?++S:o=!1))}if(o){for(;S<s.length&&p(s.charCodeAt(S));)S++;S>=2&&(s=`\\${s.slice(S)}`)}return e.win32.normalize(s)},relative(a,s){if(b(a,"from"),b(s,"to"),a===s)return"";const m=e.win32.resolve(a),o=e.win32.resolve(s);if(m===o||(a=m.toLowerCase(),s=o.toLowerCase(),a===s))return"";let S=0;for(;S<a.length&&a.charCodeAt(S)===A;)S++;let r=a.length;for(;r-1>S&&a.charCodeAt(r-1)===A;)r--;const i=r-S;let n=0;for(;n<s.length&&s.charCodeAt(n)===A;)n++;let u=s.length;for(;u-1>n&&s.charCodeAt(u-1)===A;)u--;const c=u-n,d=i<c?i:c;let h=-1,w=0;for(;w<d;w++){const k=a.charCodeAt(S+w);if(k!==s.charCodeAt(n+w))break;k===A&&(h=w)}if(w!==d){if(h===-1)return o}else{if(c>d){if(s.charCodeAt(n+w)===A)return o.slice(n+w+1);if(w===2)return o.slice(n+w)}i>d&&(a.charCodeAt(S+w)===A?h=w:w===2&&(h=3)),h===-1&&(h=0)}let v="";for(w=S+h+1;w<=r;++w)(w===r||a.charCodeAt(w)===A)&&(v+=v.length===0?"..":"\\..");return n+=h,v.length>0?`${v}${o.slice(n,u)}`:(o.charCodeAt(n)===A&&++n,o.slice(n,u))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const s=e.win32.resolve(a);if(s.length<=2)return a;if(s.charCodeAt(0)===A){if(s.charCodeAt(1)===A){const m=s.charCodeAt(2);if(m!==y&&m!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(E(s.charCodeAt(0))&&s.charCodeAt(1)===R&&s.charCodeAt(2)===A)return`\\\\?\\${s}`;return a},dirname(a){b(a,"path");const s=a.length;if(s===0)return".";let m=-1,o=0;const S=a.charCodeAt(0);if(s===1)return p(S)?a:".";if(p(S)){if(m=o=1,p(a.charCodeAt(1))){let n=2,u=n;for(;n<s&&!p(a.charCodeAt(n));)n++;if(n<s&&n!==u){for(u=n;n<s&&p(a.charCodeAt(n));)n++;if(n<s&&n!==u){for(u=n;n<s&&!p(a.charCodeAt(n));)n++;if(n===s)return a;n!==u&&(m=o=n+1)}}}}else E(S)&&a.charCodeAt(1)===R&&(m=s>2&&p(a.charCodeAt(2))?3:2,o=m);let r=-1,i=!0;for(let n=s-1;n>=o;--n)if(p(a.charCodeAt(n))){if(!i){r=n;break}}else i=!1;if(r===-1){if(m===-1)return".";r=m}return a.slice(0,r)},basename(a,s){s!==void 0&&b(s,"ext"),b(a,"path");let m=0,o=-1,S=!0,r;if(a.length>=2&&E(a.charCodeAt(0))&&a.charCodeAt(1)===R&&(m=2),s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let i=s.length-1,n=-1;for(r=a.length-1;r>=m;--r){const u=a.charCodeAt(r);if(p(u)){if(!S){m=r+1;break}}else n===-1&&(S=!1,n=r+1),i>=0&&(u===s.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=n))}return m===o?o=n:o===-1&&(o=a.length),a.slice(m,o)}for(r=a.length-1;r>=m;--r)if(p(a.charCodeAt(r))){if(!S){m=r+1;break}}else o===-1&&(S=!1,o=r+1);return o===-1?"":a.slice(m,o)},extname(a){b(a,"path");let s=0,m=-1,o=0,S=-1,r=!0,i=0;a.length>=2&&a.charCodeAt(1)===R&&E(a.charCodeAt(0))&&(s=o=2);for(let n=a.length-1;n>=s;--n){const u=a.charCodeAt(n);if(p(u)){if(!r){o=n+1;break}continue}S===-1&&(r=!1,S=n+1),u===P?m===-1?m=n:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||S===-1||i===0||i===1&&m===S-1&&m===o+1?"":a.slice(m,S)},format:_.bind(null,"\\"),parse(a){b(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const m=a.length;let o=0,S=a.charCodeAt(0);if(m===1)return p(S)?(s.root=s.dir=a,s):(s.base=s.name=a,s);if(p(S)){if(o=1,p(a.charCodeAt(1))){let h=2,w=h;for(;h<m&&!p(a.charCodeAt(h));)h++;if(h<m&&h!==w){for(w=h;h<m&&p(a.charCodeAt(h));)h++;if(h<m&&h!==w){for(w=h;h<m&&!p(a.charCodeAt(h));)h++;h===m?o=h:h!==w&&(o=h+1)}}}}else if(E(S)&&a.charCodeAt(1)===R){if(m<=2)return s.root=s.dir=a,s;if(o=2,p(a.charCodeAt(2))){if(m===3)return s.root=s.dir=a,s;o=3}}o>0&&(s.root=a.slice(0,o));let r=-1,i=o,n=-1,u=!0,c=a.length-1,d=0;for(;c>=o;--c){if(S=a.charCodeAt(c),p(S)){if(!u){i=c+1;break}continue}n===-1&&(u=!1,n=c+1),S===P?r===-1?r=c:d!==1&&(d=1):r!==-1&&(d=-1)}return n!==-1&&(r===-1||d===0||d===1&&r===n-1&&r===i+1?s.base=s.name=a.slice(i,n):(s.name=a.slice(i,r),s.base=a.slice(i,n),s.ext=a.slice(r,n))),i>0&&i!==o?s.dir=a.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let s="",m=!1;for(let o=a.length-1;o>=-1&&!m;o--){const S=o>=0?a[o]:f.cwd();b(S,"path"),S.length!==0&&(s=`${S}/${s}`,m=S.charCodeAt(0)===C)}return s=L(s,!m,"/",g),m?`/${s}`:s.length>0?s:"."},normalize(a){if(b(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===C,m=a.charCodeAt(a.length-1)===C;return a=L(a,!s,"/",g),a.length===0?s?"/":m?"./":".":(m&&(a+="/"),s?`/${a}`:a)},isAbsolute(a){return b(a,"path"),a.length>0&&a.charCodeAt(0)===C},join(...a){if(a.length===0)return".";let s;for(let m=0;m<a.length;++m){const o=a[m];b(o,"path"),o.length>0&&(s===void 0?s=o:s+=`/${o}`)}return s===void 0?".":e.posix.normalize(s)},relative(a,s){if(b(a,"from"),b(s,"to"),a===s||(a=e.posix.resolve(a),s=e.posix.resolve(s),a===s))return"";const m=1,o=a.length,S=o-m,r=1,i=s.length-r,n=S<i?S:i;let u=-1,c=0;for(;c<n;c++){const h=a.charCodeAt(m+c);if(h!==s.charCodeAt(r+c))break;h===C&&(u=c)}if(c===n)if(i>n){if(s.charCodeAt(r+c)===C)return s.slice(r+c+1);if(c===0)return s.slice(r+c)}else S>n&&(a.charCodeAt(m+c)===C?u=c:c===0&&(u=0));let d="";for(c=m+u+1;c<=o;++c)(c===o||a.charCodeAt(c)===C)&&(d+=d.length===0?"..":"/..");return`${d}${s.slice(r+u)}`},toNamespacedPath(a){return a},dirname(a){if(b(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===C;let m=-1,o=!0;for(let S=a.length-1;S>=1;--S)if(a.charCodeAt(S)===C){if(!o){m=S;break}}else o=!1;return m===-1?s?"/":".":s&&m===1?"//":a.slice(0,m)},basename(a,s){s!==void 0&&b(s,"ext"),b(a,"path");let m=0,o=-1,S=!0,r;if(s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let i=s.length-1,n=-1;for(r=a.length-1;r>=0;--r){const u=a.charCodeAt(r);if(u===C){if(!S){m=r+1;break}}else n===-1&&(S=!1,n=r+1),i>=0&&(u===s.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=n))}return m===o?o=n:o===-1&&(o=a.length),a.slice(m,o)}for(r=a.length-1;r>=0;--r)if(a.charCodeAt(r)===C){if(!S){m=r+1;break}}else o===-1&&(S=!1,o=r+1);return o===-1?"":a.slice(m,o)},extname(a){b(a,"path");let s=-1,m=0,o=-1,S=!0,r=0;for(let i=a.length-1;i>=0;--i){const n=a.charCodeAt(i);if(n===C){if(!S){m=i+1;break}continue}o===-1&&(S=!1,o=i+1),n===P?s===-1?s=i:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||o===-1||r===0||r===1&&s===o-1&&s===m+1?"":a.slice(s,o)},format:_.bind(null,"/"),parse(a){b(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const m=a.charCodeAt(0)===C;let o;m?(s.root="/",o=1):o=0;let S=-1,r=0,i=-1,n=!0,u=a.length-1,c=0;for(;u>=o;--u){const d=a.charCodeAt(u);if(d===C){if(!n){r=u+1;break}continue}i===-1&&(n=!1,i=u+1),d===P?S===-1?S=u:c!==1&&(c=1):S!==-1&&(c=-1)}if(i!==-1){const d=r===0&&m?1:r;S===-1||c===0||c===1&&S===i-1&&S===r+1?s.base=s.name=a.slice(d,i):(s.name=a.slice(d,S),s.base=a.slice(d,i),s.ext=a.slice(S,i))}return r>0?s.dir=a.slice(0,r-1):m&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[95],ve([0,1,9]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(y){y.text="text/plain",y.binary="application/octet-stream",y.unknown="application/unknown",y.markdown="text/markdown",y.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(y){const l=(0,f.extname)(y),b=I[l.toLowerCase()];return b!==void 0?b:P(y)}e.getMediaOrTextMime=T;function P(y){const l=(0,f.extname)(y);return D[l.toLowerCase()]}e.getMediaMime=P;function C(y){for(const l in D)if(D[l]===y)return l}e.getExtensionForMimeType=C;const A=/^(.+)\/(.+?)(;.+)?$/;function R(y,l){const b=A.exec(y);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:l?void 0:y}e.normalizeMimeType=R}),define(pe[96],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var t;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(D,...T){const P=T.reduce((R,y)=>(R[y]=!0,R),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(R=>!P[R]).forEach(R=>{for(let y=0;y<C.length;y++)if(R.search(C[y])!==-1){delete D[R];break}})}e.sanitizeProcessEnvironment=I}),define(pe[46],ve([0,1,12]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=f.globals.performance&&typeof f.globals.performance.now=="function";class I{constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new I(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=I}),define(pe[3],ve([0,1,15,76,6,93,46]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(s){s.None=()=>I.Disposable.None;function m(B){return(x,z=null,W)=>{let J=!1,se;return se=B(ie=>{if(!J)return se?se.dispose():J=!0,x.call(z,ie)},null,W),J&&se.dispose(),se}}s.once=m;function o(B,x){return c((z,W=null,J)=>B(se=>z.call(W,x(se)),null,J))}s.map=o;function S(B,x){return c((z,W=null,J)=>B(se=>{x(se),z.call(W,se)},null,J))}s.forEach=S;function r(B,x){return c((z,W=null,J)=>B(se=>x(se)&&z.call(W,se),null,J))}s.filter=r;function i(B){return B}s.signal=i;function n(...B){return(x,z=null,W)=>(0,I.combinedDisposable)(...B.map(J=>J(se=>x.call(z,se),null,W)))}s.any=n;function u(B,x,z){let W=z;return o(B,J=>(W=x(W,J),W))}s.reduce=u;function c(B){let x;const z=new l({onFirstListenerAdd(){x=B(z.fire,z)},onLastListenerRemove(){x.dispose()}});return z.event}function d(B,x,z,W=100,J=!1){let se,ie,K=0;return B(Y=>{K++,se=z(se,Y),J&&!ie&&(x(se),se=void 0),clearTimeout(ie),ie=setTimeout(()=>{const le=se;se=void 0,ie=void 0,(!J||K>1)&&x(le),K=0},W)})}s.debouncedListener=d;function h(B,x,z=100,W=!1,J){let se,ie,K,Y=0;const le=new l({leakWarningThreshold:J,onFirstListenerAdd(){se=B(fe=>{Y++,ie=x(ie,fe),W&&!K&&(le.fire(ie),ie=void 0),clearTimeout(K),K=setTimeout(()=>{const Se=ie;ie=void 0,K=void 0,(!W||Y>1)&&le.fire(Se),Y=0},z)})},onLastListenerRemove(){se.dispose()}});return le.event}s.debounce=h;function w(B,x=(z,W)=>z===W){let z=!0,W;return r(B,J=>{const se=z||!x(J,W);return z=!1,W=J,se})}s.latch=w;function v(B,x){return[s.filter(B,x),s.filter(B,z=>!x(z))]}s.split=v;function k(B,x=!1,z=[]){let W=z.slice(),J=B(K=>{W?W.push(K):ie.fire(K)});const se=()=>{W&&W.forEach(K=>ie.fire(K)),W=null},ie=new l({onFirstListenerAdd(){J||(J=B(K=>ie.fire(K)))},onFirstListenerDidAdd(){W&&(x?setTimeout(se):se())},onLastListenerRemove(){J&&J.dispose(),J=null}});return ie.event}s.buffer=k;class O{constructor(x){this.event=x}map(x){return new O(o(this.event,x))}forEach(x){return new O(S(this.event,x))}filter(x){return new O(r(this.event,x))}reduce(x,z){return new O(u(this.event,x,z))}latch(){return new O(w(this.event))}debounce(x,z=100,W=!1,J){return new O(h(this.event,x,z,W,J))}on(x,z,W){return this.event(x,z,W)}once(x,z,W){return m(this.event)(x,z,W)}}function U(B){return new O(B)}s.chain=U;function F(B,x,z=W=>W){const W=(...K)=>ie.fire(z(...K)),J=()=>B.on(x,W),se=()=>B.removeListener(x,W),ie=new l({onFirstListenerAdd:J,onLastListenerRemove:se});return ie.event}s.fromNodeEventEmitter=F;function M(B,x,z=W=>W){const W=(...K)=>ie.fire(z(...K)),J=()=>B.addEventListener(x,W),se=()=>B.removeEventListener(x,W),ie=new l({onFirstListenerAdd:J,onLastListenerRemove:se});return ie.event}s.fromDOMEventEmitter=M;function V(B){return new Promise(x=>m(B)(x))}s.toPromise=V;function $(B,x){return x(void 0),B(z=>x(z))}s.runAndSubscribe=$;function N(B,x){let z=null;function W(se){z?.dispose(),z=new I.DisposableStore,x(se,z)}W(void 0);const J=B(se=>W(se));return(0,I.toDisposable)(()=>{J.dispose(),z?.dispose()})}s.runAndSubscribeWithStore=N})(P=e.Event||(e.Event={}));class C{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${C._idPool++}`}start(m){this._stopWatch=new T.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let A=-1;function R(s){const m=A;return A=s,{dispose(){A=m}}}e.setGlobalLeakWarningThreshold=R;class y{constructor(m,o=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let o=A;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||m<o)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(S)||0;if(this._stacks.set(S,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,n=0;for(const[u,c]of this._stacks)(!i||n<c)&&(i=u,n=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${n}):`),console.warn(i)}return()=>{const i=this._stacks.get(S)||0;this._stacks.set(S,i-1)}}}class l{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=A>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(m,o,S)=>{this._listeners||(this._listeners=new D.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[m,o]:m);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,o);const n=this._leakageMon?.check(this._listeners.size),u=(0,I.toDisposable)(()=>{n&&n(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof I.DisposableStore?S.add(u):Array.isArray(S)&&S.push(u),u}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,m]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,S]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,S):o[0].call(o[1],S)}catch(r){(0,f.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class b extends l{async fireAsync(m,o,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,m]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),n=[],u={...i,token:o,waitUntil:c=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");S&&(c=S(c,typeof r=="function"?r:r[0])),n.push(c)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(c){(0,f.onUnexpectedError)(c);continue}Object.freeze(n),await Promise.allSettled(n).then(c=>{for(const d of c)d.status==="rejected"&&(0,f.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=b;class p extends l{constructor(m){super(m);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=p;class g extends p{constructor(m){super(m);this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=g;class E extends l{constructor(m){super(m);this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const o={event:m,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const S=()=>{this.hasListeners&&this.unhook(o);const r=this.events.indexOf(o);this.events.splice(r,1)};return(0,I.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(o=>this.emitter.fire(o))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=L;class _{constructor(){this.buffers=[]}wrapEvent(m){return(o,S,r)=>m(i=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>o.call(S,i)):o.call(S,i)},void 0,r)}bufferEvents(m){const o=[];this.buffers.push(o);const S=m();return this.buffers.pop(),o.forEach(r=>r()),S}}e.EventBufferer=_;class a{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=I.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(pe[21],ve([0,1,3]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,C){const A=setTimeout(P.bind(C),0);return{dispose(){clearTimeout(A)}}});var I;(function(P){function C(A){return A===P.None||A===P.Cancelled||A instanceof D?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}P.isCancellationToken=C,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=I.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=T}),define(pe[141],ve([0,1,21]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new f.CancellationTokenSource,P=this.task(T.token);return this.result={promise:P,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=t;class I{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const P=JSON.stringify(T);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=I}),define(pe[97],ve([0,1,15,6]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=I;function D(a){const s=a;return s?I(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=D;function T(a,s){return new P(a,s)}e.newWriteableStream=T;class P{constructor(s,m){this.reducer=s,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(m=>m(s))}emitError(s){this.listeners.error.length===0?(0,f.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(m=>m(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,m){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(s,m){if(this.state.destroyed)return;let o;switch(s){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const S=o.indexOf(m);S>=0&&o.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(a,s){const m=[];let o;for(;(o=a.read())!==null;)m.push(o);return s(m)}e.consumeReadable=C;function A(a,s,m){const o=[];let S;for(;(S=a.read())!==null&&o.length<m;)o.push(S);return S===null&&o.length>0?s(o):{read:()=>{if(o.length>0)return o.shift();if(typeof S!="undefined"){const r=S;return S=void 0,r}return a.read()}}}e.peekReadable=A;function R(a,s){return new Promise((m,o)=>{const S=[];y(a,{onData:r=>{s&&S.push(r)},onError:r=>{s?o(r):m(void 0)},onEnd:()=>{m(s?s(S):void 0)}})})}e.consumeStream=R;function y(a,s){let m=!1;return a.on("error",o=>{m||s.onError(o)}),a.on("end",()=>{m||s.onEnd()}),a.on("data",o=>{m||s.onData(o)}),(0,t.toDisposable)(()=>m=!0)}e.listenStream=y;function l(a,s){return new Promise((m,o)=>{const S=new t.DisposableStore,r=[],i=c=>{if(r.push(c),r.length>s)return S.dispose(),a.pause(),m({stream:a,buffer:r,ended:!1})},n=c=>o(c),u=()=>m({stream:a,buffer:r,ended:!0});S.add((0,t.toDisposable)(()=>a.removeListener("error",n))),a.on("error",n),S.add((0,t.toDisposable)(()=>a.removeListener("end",u))),a.on("end",u),S.add((0,t.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=l;function b(a,s){const m=T(s);return m.end(a),m}e.toStream=b;function p(){const a=T(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=p;function g(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}e.toReadable=g;function E(a,s,m){const o=T(m);return y(a,{onData:S=>o.write(s.data(S)),onError:S=>o.error(s.error?s.error(S):S),onEnd:()=>o.end()}),o}e.transform=E;function L(a,s,m){let o=!1;return{read:()=>{const S=s.read();return o?S:(o=!0,S!==null?m([a,S]):a)}}}e.prefixedReadable=L;function _(a,s,m){let o=!1;const S=T(m);return y(s,{onData:r=>o?S.write(r):(o=!0,S.write(m([a,r]))),onError:r=>S.error(r),onEnd:()=>{o||(o=!0,S.write(a)),S.end()}}),S}e.prefixedStream=_}),define(pe[22],ve([0,1,97]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let I,D;class T{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new T(Buffer.allocUnsafe(d)):new T(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new T(d)}static fromString(d,h){return!(h?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(d)):(I||(I=new TextEncoder),new T(I.encode(d)))}static fromByteArray(d){const h=T.alloc(d.length);for(let w=0,v=d.length;w<v;w++)h.buffer[w]=d[w];return h}static concat(d,h){if(typeof h=="undefined"){h=0;for(let k=0,O=d.length;k<O;k++)h+=d[k].byteLength}const w=T.alloc(h);let v=0;for(let k=0,O=d.length;k<O;k++){const U=d[k];w.set(U,v),v+=U.byteLength}return w}clone(){const d=T.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(d,h){return new T(this.buffer.subarray(d,h))}set(d,h){if(d instanceof T)this.buffer.set(d.buffer,h);else if(d instanceof Uint8Array)this.buffer.set(d,h);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),h);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),h);else throw new Error("Unkown argument 'array'")}readUInt32BE(d){return A(this.buffer,d)}writeUInt32BE(d,h){R(this.buffer,d,h)}readUInt32LE(d){return y(this.buffer,d)}writeUInt32LE(d,h){l(this.buffer,d,h)}readUInt8(d){return b(this.buffer,d)}writeUInt8(d,h){p(this.buffer,d,h)}}e.VSBuffer=T;function P(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0}e.readUInt16LE=P;function C(c,d,h){c[h+0]=d&255,d=d>>>8,c[h+1]=d&255}e.writeUInt16LE=C;function A(c,d){return c[d]*2**24+c[d+1]*2**16+c[d+2]*2**8+c[d+3]}e.readUInt32BE=A;function R(c,d,h){c[h+3]=d,d=d>>>8,c[h+2]=d,d=d>>>8,c[h+1]=d,d=d>>>8,c[h]=d}e.writeUInt32BE=R;function y(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0|c[d+2]<<16>>>0|c[d+3]<<24>>>0}e.readUInt32LE=y;function l(c,d,h){c[h+0]=d&255,d=d>>>8,c[h+1]=d&255,d=d>>>8,c[h+2]=d&255,d=d>>>8,c[h+3]=d&255}e.writeUInt32LE=l;function b(c,d){return c[d]}e.readUInt8=b;function p(c,d,h){c[h]=d}e.writeUInt8=p;function g(c){return f.consumeReadable(c,d=>T.concat(d))}e.readableToBuffer=g;function E(c){return f.toReadable(c)}e.bufferToReadable=E;function L(c){return f.consumeStream(c,d=>T.concat(d))}e.streamToBuffer=L;async function _(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await L(c.stream)])}e.bufferedStreamToBuffer=_;function a(c){return f.toStream(c,d=>T.concat(d))}e.bufferToStream=a;function s(c){return f.transform(c,{data:d=>typeof d=="string"?T.fromString(d):T.wrap(d)},d=>T.concat(d))}e.streamToBufferReadableStream=s;function m(c){return f.newWriteableStream(d=>T.concat(d),c)}e.newWriteableBufferStream=m;function o(c,d){return f.prefixedReadable(c,d,h=>T.concat(h))}e.prefixedBufferReadable=o;function S(c,d){return f.prefixedStream(c,d,h=>T.concat(h))}e.prefixedBufferStream=S;function r(c){let d=0,h=0,w=0;const v=new Uint8Array(Math.floor(c.length/4*3)),k=U=>{switch(h){case 3:v[w++]=d|U,h=0;break;case 2:v[w++]=d|U>>>2,d=U<<6,h=3;break;case 1:v[w++]=d|U>>>4,d=U<<4,h=2;break;default:d=U<<2,h=1}};for(let U=0;U<c.length;U++){const F=c.charCodeAt(U);if(F>=65&&F<=90)k(F-65);else if(F>=97&&F<=122)k(F-97+26);else if(F>=48&&F<=57)k(F-48+52);else if(F===43||F===45)k(62);else if(F===47||F===95)k(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${c[U]}`)}}const O=w;for(;h>0;)k(0);return T.wrap(v).slice(0,O)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:c},d=!0,h=!1){const w=h?n:i;let v="";const k=c.byteLength%3;let O=0;for(;O<c.byteLength-k;O+=3){const U=c[O+0],F=c[O+1],M=c[O+2];v+=w[U>>>2],v+=w[(U<<4|F>>>4)&63],v+=w[(F<<2|M>>>6)&63],v+=w[M&63]}if(k===1){const U=c[O+0];v+=w[U>>>2],v+=w[U<<4&63],d&&(v+="==")}else if(k===2){const U=c[O+0],F=c[O+1];v+=w[U>>>2],v+=w[(U<<4|F>>>4)&63],v+=w[F<<2&63],d&&(v+="=")}return v}e.encodeBase64=u}),define(pe[8],ve([0,1,141,92]),function(Z,e,f,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=D;const T=/{(\d+)}/g;function P(re,...Ce){return Ce.length===0?re:re.replace(T,function(Fe,qe){const ze=parseInt(qe,10);return isNaN(ze)||ze<0||ze>=Ce.length?Fe:Ce[ze]})}e.format=P;const C=/{([^}]+)}/g;function A(re,Ce){return re.replace(C,(Fe,qe)=>Ce[qe]??Fe)}e.format2=A;function R(re){return re.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=R;function y(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function l(re,Ce){let Fe=0;const qe=Ce.charCodeAt(0);for(let ze=re.length-1;ze>=0;ze--)re.charCodeAt(ze)===qe&&Fe++;return Fe}e.count=l;function b(re,Ce,Fe="\u2026"){return re.length<=Ce?re:`${re.substr(0,Ce)}${Fe}`}e.truncate=b;function p(re,Ce=" "){const Fe=g(re,Ce);return E(Fe,Ce)}e.trim=p;function g(re,Ce){if(!re||!Ce)return re;const Fe=Ce.length;if(Fe===0||re.length===0)return re;let qe=0;for(;re.indexOf(Ce,qe)===qe;)qe=qe+Fe;return re.substring(qe)}e.ltrim=g;function E(re,Ce){if(!re||!Ce)return re;const Fe=Ce.length,qe=re.length;if(Fe===0||qe===0)return re;let ze=qe,ut=-1;for(;ut=re.lastIndexOf(Ce,ze-1),!(ut===-1||ut+Fe!==ze);){if(ut===0)return"";ze=ut}return re.substring(0,ze)}e.rtrim=E;function L(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=L;function _(re){return re.replace(/\*/g,"")}e.stripWildcards=_;function a(re,Ce,Fe={}){if(!re)throw new Error("Cannot create regex from empty string");Ce||(re=y(re)),Fe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let qe="";return Fe.global&&(qe+="g"),Fe.matchCase||(qe+="i"),Fe.multiline&&(qe+="m"),Fe.unicode&&(qe+="u"),new RegExp(re,qe)}e.createRegExp=a;function s(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function m(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function o(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=o;function S(re){return re.split(/\r\n|\r|\n/)}e.splitLines=S;function r(re){for(let Ce=0,Fe=re.length;Ce<Fe;Ce++){const qe=re.charCodeAt(Ce);if(qe!==32&&qe!==9)return Ce}return-1}e.firstNonWhitespaceIndex=r;function i(re,Ce=0,Fe=re.length){for(let qe=Ce;qe<Fe;qe++){const ze=re.charCodeAt(qe);if(ze!==32&&ze!==9)return re.substring(Ce,qe)}return re.substring(Ce,Fe)}e.getLeadingWhitespace=i;function n(re,Ce=re.length-1){for(let Fe=Ce;Fe>=0;Fe--){const qe=re.charCodeAt(Fe);if(qe!==32&&qe!==9)return Fe}return-1}e.lastNonWhitespaceIndex=n;function u(re,Ce){return re<Ce?-1:re>Ce?1:0}e.compare=u;function c(re,Ce,Fe=0,qe=re.length,ze=0,ut=Ce.length){for(;Fe<qe&&ze<ut;Fe++,ze++){let De=re.charCodeAt(Fe),ce=Ce.charCodeAt(ze);if(De<ce)return-1;if(De>ce)return 1}const Re=qe-Fe,Ae=ut-ze;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=c;function d(re,Ce){return h(re,Ce,0,re.length,0,Ce.length)}e.compareIgnoreCase=d;function h(re,Ce,Fe=0,qe=re.length,ze=0,ut=Ce.length){for(;Fe<qe&&ze<ut;Fe++,ze++){let De=re.charCodeAt(Fe),ce=Ce.charCodeAt(ze);if(De===ce)continue;if(De>=128||ce>=128)return c(re.toLowerCase(),Ce.toLowerCase(),Fe,qe,ze,ut);w(De)&&(De-=32),w(ce)&&(ce-=32);const de=De-ce;if(de!==0)return de}const Re=qe-Fe,Ae=ut-ze;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=h;function w(re){return re>=97&&re<=122}e.isLowerAsciiLetter=w;function v(re){return re>=65&&re<=90}e.isUpperAsciiLetter=v;function k(re,Ce){return re.length===Ce.length&&h(re,Ce)===0}e.equalsIgnoreCase=k;function O(re,Ce){const Fe=Ce.length;return Ce.length>re.length?!1:h(re,Ce,0,Fe)===0}e.startsWithIgnoreCase=O;function U(re,Ce){let Fe,qe=Math.min(re.length,Ce.length);for(Fe=0;Fe<qe;Fe++)if(re.charCodeAt(Fe)!==Ce.charCodeAt(Fe))return Fe;return qe}e.commonPrefixLength=U;function F(re,Ce){let Fe,qe=Math.min(re.length,Ce.length);const ze=re.length-1,ut=Ce.length-1;for(Fe=0;Fe<qe;Fe++)if(re.charCodeAt(ze-Fe)!==Ce.charCodeAt(ut-Fe))return Fe;return qe}e.commonSuffixLength=F;function M(re){return 55296<=re&&re<=56319}e.isHighSurrogate=M;function V(re){return 56320<=re&&re<=57343}e.isLowSurrogate=V;function $(re,Ce){return(re-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=$;function N(re,Ce,Fe){const qe=re.charCodeAt(Fe);if(M(qe)&&Fe+1<Ce){const ze=re.charCodeAt(Fe+1);if(V(ze))return $(qe,ze)}return qe}e.getNextCodePoint=N;function B(re,Ce){const Fe=re.charCodeAt(Ce-1);if(V(Fe)&&Ce>1){const qe=re.charCodeAt(Ce-2);if(M(qe))return $(qe,Fe)}return Fe}class x{constructor(Ce,Fe=0){this._str=Ce,this._len=Ce.length,this._offset=Fe}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=B(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=N(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class z{constructor(Ce,Fe=0){this._iterator=new x(Ce,Fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=tt.getInstance(),Fe=this._iterator,qe=Fe.offset;let ze=Ce.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const ut=Fe.offset,Re=Ce.getGraphemeBreakType(Fe.nextCodePoint());if(st(ze,Re)){Fe.setOffset(ut);break}ze=Re}return Fe.offset-qe}prevGraphemeLength(){const Ce=tt.getInstance(),Fe=this._iterator,qe=Fe.offset;let ze=Ce.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const ut=Fe.offset,Re=Ce.getGraphemeBreakType(Fe.prevCodePoint());if(st(Re,ze)){Fe.setOffset(ut);break}ze=Re}return qe-Fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function W(re,Ce){return new z(re,Ce).nextGraphemeLength()}e.nextCharLength=W;function J(re,Ce){return new z(re,Ce).prevGraphemeLength()}e.prevCharLength=J;function se(re,Ce){Ce>0&&V(re.charCodeAt(Ce))&&Ce--;const Fe=Ce+W(re,Ce);return[Fe-J(re,Fe),Fe]}e.getCharContainingOffset=se;const ie=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(re){return ie.test(re)}e.containsRTL=K;const Y=/^[\t\n\r\x20-\x7E]*$/;function le(re){return Y.test(re)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=fe;function Se(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=Se;function Me(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=Me;function Ve(re,Ce){if(re.length<Ce)return re;const Fe=/\b/g;let qe=0;for(;Fe.test(re)&&!(re.length-Fe.lastIndex<Ce);)qe=Fe.lastIndex,Fe.lastIndex+=1;return re.substring(qe).replace(/^\s/,"")}e.lcut=Ve;const Ge=/\x1B\x5B[12]?K/g,Ye=/\x1b\[\d+m/g,q=/\x1b\[0?m/g;function te(re){return re&&(re=re.replace(Ge,""),re=re.replace(Ye,""),re=re.replace(q,"")),re}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function Q(re){return G(re)?re.substr(1):re}e.stripUTF8BOM=Q;function oe(re,Ce){if(!re||!Ce||re.length<Ce.length)return!1;const Fe=Ce.length,qe=re.toLowerCase();let ze=0,ut=-1;for(;ze<Fe;){const Re=qe.indexOf(Ce[ze],ut+1);if(Re<0)return!1;ut=Re,ze++}return!0}e.fuzzyContains=oe;function me(re,Ce=!1){return re?(Ce&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=me;function Ie(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=Ie;function xe(re,Ce=1){if(Ce===0)return"";let Fe=-1;do Fe=re.indexOf(`
`,Fe+1),Ce--;while(Ce>0&&Fe>=0);return Fe===-1?re:(re[Fe-1]==="\r"&&Fe--,re.substr(0,Fe))}e.getNLines=xe;function Xe(re){const Ce=90-65+1;return re=re%(2*Ce),re<Ce?String.fromCharCode(97+re):String.fromCharCode(65+re-Ce)}e.singleLetterHash=Xe;function it(re){return tt.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=it;function st(re,Ce){return re===0?Ce!==5&&Ce!==7:re===2&&Ce===3?!1:re===4||re===2||re===3||Ce===4||Ce===2||Ce===3?!0:!(re===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(re===11||re===9)&&(Ce===9||Ce===10)||(re===12||re===10)&&Ce===10||Ce===5||Ce===13||Ce===7||re===1||re===13&&Ce===14||re===6&&Ce===6)}var ot;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class tt{constructor(){this._data=rt()}static getInstance(){return tt._INSTANCE||(tt._INSTANCE=new tt),tt._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Fe=this._data,qe=Fe.length/3;let ze=1;for(;ze<=qe;)if(Ce<Fe[3*ze])ze=2*ze;else if(Ce>Fe[3*ze+1])ze=2*ze+1;else return Fe[3*ze+2];return 0}}tt._INSTANCE=null;function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function gt(re,Ce){if(re===0)return 0;const Fe=Ne(re,Ce);if(Fe!==void 0)return Fe;const qe=new x(Ce,re);return qe.prevCodePoint(),qe.offset}e.getLeftDeleteOffset=gt;function Ne(re,Ce){const Fe=new x(Ce,re);let qe=Fe.prevCodePoint();for(;It(qe)||qe===65039||qe===8419;){if(Fe.offset===0)return;qe=Fe.prevCodePoint()}if(!Me(qe))return;let ze=Fe.offset;return ze>0&&Fe.prevCodePoint()===8205&&(ze=Fe.offset),ze}function It(re){return 127995<=re&&re<=127999}var ee;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class ne{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return ne.cache.get(Array.from(Ce))}static getLocales(){return ne._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,I=ne,ne.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new f.LRUCachedComputed(re=>{function Ce(ce){const de=new Map;for(let we=0;we<ce.length;we+=2)de.set(ce[we],ce[we+1]);return de}function Fe(ce,de){const we=new Map(ce);for(const[ye,Oe]of de)we.set(ye,Oe);return we}function qe(ce,de){if(!ce)return de;const we=new Map;for(const[ye,Oe]of ce)de.has(ye)&&we.set(ye,Oe);return we}const ze=I.ambiguousCharacterData.getValue();let ut=re.filter(ce=>!ce.startsWith("_")&&ce in ze);ut.length===0&&(ut=["_default"]);let Re;for(const ce of ut){const de=Ce(ze[ce]);Re=qe(Re,de)}const Ae=Ce(ze._common),De=Fe(Ae,Re);return new ne(De)}),ne._locales=new t.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(re=>!re.startsWith("_")));class Ee{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ee.getRawData())),this._data}static isInvisibleCharacter(Ce){return Ee.getData().has(Ce)}static get codePoints(){return Ee.getData()}}e.InvisibleCharacters=Ee,Ee._data=void 0}),define(pe[58],ve([0,1,8]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(L){return I(L,0)}e.hash=t;function I(L,_){switch(typeof L){case"object":return L===null?D(349,_):Array.isArray(L)?C(L,_):A(L,_);case"string":return P(L,_);case"boolean":return T(L,_);case"number":return D(L,_);case"undefined":return D(937,_);default:return D(617,_)}}e.doHash=I;function D(L,_){return(_<<5)-_+L|0}e.numberHash=D;function T(L,_){return D(L?433:863,_)}function P(L,_){_=D(149417,_);for(let a=0,s=L.length;a<s;a++)_=D(L.charCodeAt(a),_);return _}e.stringHash=P;function C(L,_){return _=D(104579,_),L.reduce((a,s)=>I(s,a),_)}function A(L,_){return _=D(181387,_),Object.keys(L).sort().reduce((a,s)=>(a=P(s,a),I(L[s],a)),_)}class R{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=I(_,this._value),this._value}}e.Hasher=R;var y;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function l(L,_,a=32){const s=a-_,m=~((1<<s)-1);return(L<<_|(m&L)>>>s)>>>0}function b(L,_=0,a=L.byteLength,s=0){for(let m=0;m<a;m++)L[_+m]=s}function p(L,_,a="0"){for(;L.length<_;)L=a+L;return L}function g(L,_=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(a=>a.toString(16).padStart(2,"0")).join(""):p((L>>>0).toString(16),_/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const a=_.length;if(a===0)return;const s=this._buff;let m=this._buffLen,o=this._leftoverHighSurrogate,S,r;for(o!==0?(S=o,r=-1,o=0):(S=_.charCodeAt(0),r=0);;){let i=S;if(f.isHighSurrogate(S))if(r+1<a){const n=_.charCodeAt(r+1);f.isLowSurrogate(n)?(r++,i=f.computeCodePoint(S,n)):i=65533}else{o=S;break}else f.isLowSurrogate(S)&&(i=65533);if(m=this._push(s,m,i),r++,r<a)S=_.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=o}_push(_,a,s){return s<128?_[a++]=s:s<2048?(_[a++]=192|(s&1984)>>>6,_[a++]=128|(s&63)>>>0):s<65536?(_[a++]=224|(s&61440)>>>12,_[a++]=128|(s&4032)>>>6,_[a++]=128|(s&63)>>>0):(_[a++]=240|(s&1835008)>>>18,_[a++]=128|(s&258048)>>>12,_[a++]=128|(s&4032)>>>6,_[a++]=128|(s&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=E._bigBlock32,a=this._buffDV;for(let c=0;c<64;c+=4)_.setUint32(c,a.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)_.setUint32(c,l(_.getUint32(c-12,!1)^_.getUint32(c-32,!1)^_.getUint32(c-56,!1)^_.getUint32(c-64,!1),1),!1);let s=this._h0,m=this._h1,o=this._h2,S=this._h3,r=this._h4,i,n,u;for(let c=0;c<80;c++)c<20?(i=m&o|~m&S,n=1518500249):c<40?(i=m^o^S,n=1859775393):c<60?(i=m&o|m&S|o&S,n=2400959708):(i=m^o^S,n=3395469782),u=l(s,5)+i+r+n+_.getUint32(c*4,!1)&4294967295,r=S,S=o,o=l(m,30),m=s,s=u;this._h0=this._h0+s&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[24],ve([0,1,16,8]),function(Z,e,f,t){"use strict";var I,D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(r,i,n){let u=r.get(i);return u===void 0&&(u=n,r.set(i,u)),u}e.getOrSet=P;function C(r){const i=[];return r.forEach((n,u)=>{i.push(`${u} => ${n}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=C;function A(r){const i=[];return r.forEach(n=>{i.push(n)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=A;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return n-u}value(){return this._value[this._pos]}}e.StringIterator=R;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class l{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let n=i.length-1;n>=0;n--,this._valueLen--){const u=this._value.charCodeAt(n);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var b;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(E||(E={}));class L{constructor(i){this._iter=i}static forUris(i=()=>!1){return new L(new p(i))}static forPaths(i=!1){return new L(new l(void 0,!i))}static forStrings(){return new L(new R)}static forConfigKeys(){return new L(new y)}clear(){this._root=void 0}fill(i,n){if(n){const u=n.slice(0);(0,f.shuffle)(u);for(let c of u)this.set(c,i)}else{const u=i.slice(0);(0,f.shuffle)(u);for(let c of u)this.set(c[0],c[1])}}set(i,n){const u=this._iter.reset(i);let c;this._root||(this._root=new g,this._root.segment=u.value());const d=[];for(c=this._root;;){const w=u.cmp(c.segment);if(w>0)c.left||(c.left=new g,c.left.segment=u.value()),d.push([-1,c]),c=c.left;else if(w<0)c.right||(c.right=new g,c.right.segment=u.value()),d.push([1,c]),c=c.right;else if(u.hasNext())u.next(),c.mid||(c.mid=new g,c.mid.segment=u.value()),d.push([0,c]),c=c.mid;else break}const h=c.value;c.value=n,c.key=i;for(let w=d.length-1;w>=0;w--){const v=d[w][1];v.updateHeight();const k=v.balanceFactor();if(k<-1||k>1){const O=d[w][0],U=d[w+1][0];if(O===1&&U===1)d[w][1]=v.rotateLeft();else if(O===-1&&U===-1)d[w][1]=v.rotateRight();else if(O===1&&U===-1)v.right=d[w+1][1]=d[w+1][1].rotateRight(),d[w][1]=v.rotateLeft();else if(O===-1&&U===1)v.left=d[w+1][1]=d[w+1][1].rotateLeft(),d[w][1]=v.rotateRight();else throw new Error;if(w>0)switch(d[w-1][0]){case-1:d[w-1][1].left=d[w][1];break;case 1:d[w-1][1].right=d[w][1];break;case 0:d[w-1][1].mid=d[w][1];break}else this._root=d[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const n=this._iter.reset(i);let u=this._root;for(;u;){const c=n.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(n.hasNext())n.next(),u=u.mid;else break}return u}has(i){const n=this._getNode(i);return!(n?.value===void 0&&n?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const u=this._iter.reset(i),c=[];let d=this._root;for(;d;){const h=u.cmp(d.segment);if(h>0)c.push([-1,d]),d=d.left;else if(h<0)c.push([1,d]),d=d.right;else if(u.hasNext())u.next(),c.push([0,d]),d=d.mid;else break}if(!!d){if(n?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this._min(d.right),{key:w,value:v,segment:k}=h;this._delete(h.key,!1),d.key=w,d.value=v,d.segment=k}else{const h=d.left??d.right;if(c.length>0){const[w,v]=c[c.length-1];switch(w){case-1:v.left=h;break;case 0:v.mid=h;break;case 1:v.right=h;break}}else this._root=h}for(let h=c.length-1;h>=0;h--){const w=c[h][1];w.updateHeight();const v=w.balanceFactor();if(v>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),c[h][1]=w.rotateLeft()):v<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),c[h][1]=w.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const n=this._iter.reset(i);let u=this._root,c;for(;u;){const d=n.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(n.hasNext())n.next(),c=u.value||c,u=u.mid;else break}return u&&u.value||c}findSuperstr(i){const n=this._iter.reset(i);let u=this._root;for(;u;){const c=n.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(n.hasNext())n.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[n,u]of this)i(u,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=n=>{if(!n)return!0;const u=n.balanceFactor();return u<-1||u>1?!1:i(n.left)&&i(n.right)};return i(this._root)}}e.TernarySearchTree=L;class _{constructor(i,n){this.uri=i,this.value=n}}class a{constructor(i,n){this[I]="ResourceMap",i instanceof a?(this.map=new Map(i.map),this.toKey=n??a.defaultToKey):(this.map=new Map,this.toKey=i??a.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),new _(i,n)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[u,c]of this.map)i(c.value,c.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=a,a.defaultToKey=r=>r.toString();var s;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class m{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,n=0){const u=this._map.get(i);if(!!u)return n!==0&&this.touch(u,n),u.value}set(i,n,u=0){let c=this._map.get(i);if(c)c.value=n,u!==0&&this.touch(c,u);else{switch(c={key:i,value:n,next:void 0,previous:void 0},u){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,n){const u=this._state;let c=this._head;for(;c;){if(n?i.bind(n)(c.value,c.key,this):i(c.value,c.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,n=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:u.key,done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}values(){const i=this,n=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:u.value,done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}entries(){const i=this,n=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:[u.key,u.value],done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._head,u=this.size;for(;n&&u>i;)this._map.delete(n.key),n=n.next,u--;this._head=n,this._size=u,n&&(n.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,u=i.previous;if(!n||!u)throw new Error("Invalid list");n.previous=u,u.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const u=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(u.previous=c,c.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const u=i.next,c=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=c,c.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,u)=>{i.push([u,n])}),i}fromJSON(i){this.clear();for(const[n,u]of i)this.set(n,u)}}e.LinkedMap=m;class o extends m{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class S{constructor(i){T.set(this,void 0),nt(this,T,i,"f")}get size(){return Le(this,T,"f").size}forEach(i,n){Le(this,T,"f").forEach(i,n)}get(i){return Le(this,T,"f").get(i)}has(i){return Le(this,T,"f").has(i)}entries(){return Le(this,T,"f").entries()}keys(){return Le(this,T,"f").keys()}values(){return Le(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Le(this,T,"f").entries()}}e.ReadonlyMapView=S}),define(pe[98],ve([0,1,24,8]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...G){return function(Q,oe){for(let me=0,Ie=G.length;me<Ie;me++){const xe=G[me](Q,oe);if(xe)return xe}return null}}e.or=I,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(G,Q,oe){if(!oe||oe.length<Q.length)return null;let me;return G?me=t.startsWithIgnoreCase(oe,Q):me=oe.indexOf(Q)===0,me?Q.length>0?[{start:0,end:Q.length}]:[]:null}function T(G,Q){const oe=Q.toLowerCase().indexOf(G.toLowerCase());return oe===-1?null:[{start:oe,end:oe+G.length}]}e.matchesContiguousSubString=T;function P(G,Q){return C(G.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=P;function C(G,Q,oe,me){if(oe===G.length)return[];if(me===Q.length)return null;if(G[oe]===Q[me]){let Ie=null;return(Ie=C(G,Q,oe+1,me+1))?L({start:me,end:me+1},Ie):null}return C(G,Q,oe,me+1)}function A(G){return 97<=G&&G<=122}function R(G){return 65<=G&&G<=90}e.isUpper=R;function y(G){return 48<=G&&G<=57}function l(G){return G===32||G===9||G===10||G===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>b.add(G.charCodeAt(0)));function p(G){return l(G)||b.has(G)}function g(G,Q){return G===Q||p(G)&&p(Q)}function E(G){return A(G)||R(G)||y(G)}function L(G,Q){return Q.length===0?Q=[G]:G.end===Q[0].start?Q[0].start=G.start:Q.unshift(G),Q}function _(G,Q){for(let oe=Q;oe<G.length;oe++){const me=G.charCodeAt(oe);if(R(me)||y(me)||oe>0&&!E(G.charCodeAt(oe-1)))return oe}return G.length}function a(G,Q,oe,me){if(oe===G.length)return[];if(me===Q.length)return null;if(G[oe]!==Q[me].toLowerCase())return null;{let Ie=null,xe=me+1;for(Ie=a(G,Q,oe+1,me+1);!Ie&&(xe=_(Q,xe))<Q.length;)Ie=a(G,Q,oe+1,xe),xe++;return Ie===null?null:L({start:me,end:me+1},Ie)}}function s(G){let Q=0,oe=0,me=0,Ie=0,xe=0;for(let tt=0;tt<G.length;tt++)xe=G.charCodeAt(tt),R(xe)&&Q++,A(xe)&&oe++,E(xe)&&me++,y(xe)&&Ie++;const Xe=Q/G.length,it=oe/G.length,st=me/G.length,ot=Ie/G.length;return{upperPercent:Xe,lowerPercent:it,alphaPercent:st,numericPercent:ot}}function m(G){const{upperPercent:Q,lowerPercent:oe}=G;return oe===0&&Q>.6}function o(G){const{upperPercent:Q,lowerPercent:oe,alphaPercent:me,numericPercent:Ie}=G;return oe>.2&&Q<.8&&me>.6&&Ie<.2}function S(G){let Q=0,oe=0,me=0,Ie=0;for(let xe=0;xe<G.length;xe++)me=G.charCodeAt(xe),R(me)&&Q++,A(me)&&oe++,l(me)&&Ie++;return(Q===0||oe===0)&&Ie===0?G.length<=30:Q<=5}function r(G,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!S(G)||Q.length>60)return null;const oe=s(Q);if(!o(oe)){if(!m(oe))return null;Q=Q.toLowerCase()}let me=null,Ie=0;for(G=G.toLowerCase();Ie<Q.length&&(me=a(G,Q,0,Ie))===null;)Ie=_(Q,Ie+1);return me}e.matchesCamelCase=r;function i(G,Q,oe=!1){if(!Q||Q.length===0)return null;let me=null,Ie=0;for(G=G.toLowerCase(),Q=Q.toLowerCase();Ie<Q.length&&(me=n(G,Q,0,Ie,oe))===null;)Ie=u(Q,Ie+1);return me}e.matchesWords=i;function n(G,Q,oe,me,Ie){if(oe===G.length)return[];if(me===Q.length)return null;if(g(G.charCodeAt(oe),Q.charCodeAt(me))){let xe=null,Xe=me+1;if(xe=n(G,Q,oe+1,me+1,Ie),!Ie)for(;!xe&&(Xe=u(Q,Xe))<Q.length;)xe=n(G,Q,oe+1,Xe,Ie),Xe++;return xe===null?null:L({start:me,end:me+1},xe)}else return null}function u(G,Q){for(let oe=Q;oe<G.length;oe++)if(p(G.charCodeAt(oe))||oe>0&&p(G.charCodeAt(oe-1)))return oe;return G.length}const c=I(e.matchesPrefix,r,T),d=I(e.matchesPrefix,r,P),h=new f.LRUCache(1e4);function w(G,Q,oe=!1){if(typeof G!="string"||typeof Q!="string")return null;let me=h.get(G);me||(me=new RegExp(t.convertSimple2RegExpPattern(G),"i"),h.set(G,me));const Ie=me.exec(Q);return Ie?[{start:Ie.index,end:Ie.index+Ie[0].length}]:oe?d(G,Q):c(G,Q)}e.matchesFuzzy=w;function v(G,Q){const oe=Se(G,G.toLowerCase(),0,Q,Q.toLowerCase(),0,!0);return oe?O(oe):null}e.matchesFuzzy2=v;function k(G,Q,oe,me,Ie,xe){const Xe=Math.min(13,G.length);for(;oe<Xe;oe++){const it=Se(G,Q,oe,me,Ie,xe,!1);if(it)return it}return[0,xe]}e.anyScore=k;function O(G){if(typeof G=="undefined")return[];const Q=[],oe=G[1];for(let me=G.length-1;me>1;me--){const Ie=G[me]+oe,xe=Q[Q.length-1];xe&&xe.end===Ie?xe.end=Ie+1:Q.push({start:Ie,end:Ie+1})}return Q}e.createMatches=O;const U=128;function F(){const G=[],Q=[];for(let oe=0;oe<=U;oe++)Q[oe]=0;for(let oe=0;oe<=U;oe++)G.push(Q.slice(0));return G}function M(G){const Q=[];for(let oe=0;oe<=G;oe++)Q[oe]=0;return Q}const V=M(2*U),$=M(2*U),N=F(),B=F(),x=F(),z=!1;function W(G,Q,oe,me,Ie){function xe(it,st,ot=" "){for(;it.length<st;)it=ot+it;return it}let Xe=` |   |${me.split("").map(it=>xe(it,3)).join("|")}
`;for(let it=0;it<=oe;it++)it===0?Xe+=" |":Xe+=`${Q[it-1]}|`,Xe+=G[it].slice(0,Ie+1).map(st=>xe(st.toString(),3)).join("|")+`
`;return Xe}function J(G,Q,oe,me){G=G.substr(Q),oe=oe.substr(me),console.log(W(B,G,G.length,oe,oe.length)),console.log(W(x,G,G.length,oe,oe.length)),console.log(W(N,G,G.length,oe,oe.length))}function se(G,Q){if(Q<0||Q>=G.length)return!1;const oe=G.codePointAt(Q);switch(oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(oe)}}function ie(G,Q){if(Q<0||Q>=G.length)return!1;switch(G.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function K(G,Q,oe){return Q[G]!==oe[G]}function Y(G,Q,oe,me,Ie,xe,Xe=!1){for(;Q<oe&&Ie<xe;)G[Q]===me[Ie]&&(Xe&&(V[Q]=Ie),Q+=1),Ie+=1;return Q===oe}e.isPatternInWord=Y;var le;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(le||(le={}));var fe;(function(G){G.Default=[-100,0];function Q(oe){return!oe||oe.length===2&&oe[0]===-100&&oe[1]===0}G.isDefault=Q})(fe=e.FuzzyScore||(e.FuzzyScore={}));function Se(G,Q,oe,me,Ie,xe,Xe){const it=G.length>U?U:G.length,st=me.length>U?U:me.length;if(oe>=it||xe>=st||it-oe>st-xe||!Y(Q,oe,it,Ie,xe,st,!0))return;Me(it,st,oe,xe,Q,Ie);let ot=1,tt=1,rt=oe,gt=xe;const Ne=[!1];for(ot=1,rt=oe;rt<it;ot++,rt++){const re=V[rt],Ce=$[rt],Fe=rt+1<it?$[rt+1]:st;for(tt=re-xe+1,gt=re;gt<Fe;tt++,gt++){let qe=Number.MIN_SAFE_INTEGER,ze=!1;gt<=Ce&&(qe=Ve(G,Q,rt,oe,me,Ie,gt,st,xe,N[ot-1][tt-1]===0,Ne));let ut=0;qe!==Number.MAX_SAFE_INTEGER&&(ze=!0,ut=qe+B[ot-1][tt-1]);const Re=gt>re,Ae=Re?B[ot][tt-1]+(N[ot][tt-1]>0?-5:0):0,De=gt>re+1&&N[ot][tt-1]>0,ce=De?B[ot][tt-2]+(N[ot][tt-2]>0?-5:0):0;if(De&&(!Re||ce>=Ae)&&(!ze||ce>=ut))B[ot][tt]=ce,x[ot][tt]=3,N[ot][tt]=0;else if(Re&&(!ze||Ae>=ut))B[ot][tt]=Ae,x[ot][tt]=2,N[ot][tt]=0;else if(ze)B[ot][tt]=ut,x[ot][tt]=1,N[ot][tt]=N[ot-1][tt-1]+1;else throw new Error("not possible")}}if(z&&J(G,oe,me,xe),!Ne[0]&&!Xe)return;ot--,tt--;const It=[B[ot][tt],xe];let ee=0,ne=0;for(;ot>=1;){let re=tt;do{const Ce=x[ot][re];if(Ce===3)re=re-2;else if(Ce===2)re=re-1;else break}while(re>=1);ee>1&&Q[oe+ot-1]===Ie[xe+tt-1]&&!K(re+xe-1,me,Ie)&&ee+1>N[ot][re]&&(re=tt),re===tt?ee++:ee=1,ne||(ne=re),ot--,tt=re-1,It.push(tt)}st===it&&(It[0]+=2);const Ee=ne-it;return It[0]-=Ee,It}e.fuzzyScore=Se;function Me(G,Q,oe,me,Ie,xe){let Xe=G-1,it=Q-1;for(;Xe>=oe&&it>=me;)Ie[Xe]===xe[it]&&($[Xe]=it,Xe--),it--}function Ve(G,Q,oe,me,Ie,xe,Xe,it,st,ot,tt){if(Q[oe]!==xe[Xe])return Number.MIN_SAFE_INTEGER;let rt=1,gt=!1;return Xe===oe-me?rt=G[oe]===Ie[Xe]?7:5:K(Xe,Ie,xe)&&(Xe===0||!K(Xe-1,Ie,xe))?(rt=G[oe]===Ie[Xe]?7:5,gt=!0):se(xe,Xe)&&(Xe===0||!se(xe,Xe-1))?rt=5:(se(xe,Xe-1)||ie(xe,Xe-1))&&(rt=5,gt=!0),rt>1&&oe===me&&(tt[0]=!0),gt||(gt=K(Xe,Ie,xe)||se(xe,Xe-1)||ie(xe,Xe-1)),oe===me?Xe>st&&(rt-=gt?3:5):ot?rt+=gt?2:0:rt+=gt?0:1,Xe+1===it&&(rt-=gt?3:5),rt}function Ge(G,Q,oe,me,Ie,xe,Xe){return q(G,Q,oe,me,Ie,xe,!0,Xe)}e.fuzzyScoreGracefulAggressive=Ge;function Ye(G,Q,oe,me,Ie,xe,Xe){return q(G,Q,oe,me,Ie,xe,!1,Xe)}e.fuzzyScoreGraceful=Ye;function q(G,Q,oe,me,Ie,xe,Xe,it){let st=Se(G,Q,oe,me,Ie,xe,it);if(st&&!Xe)return st;if(G.length>=3){const ot=Math.min(7,G.length-1);for(let tt=oe+1;tt<ot;tt++){const rt=te(G,tt);if(rt){const gt=Se(rt,rt.toLowerCase(),oe,me,Ie,xe,it);gt&&(gt[0]-=3,(!st||gt[0]>st[0])&&(st=gt))}}}return st}function te(G,Q){if(Q+1>=G.length)return;const oe=G[Q],me=G[Q+1];if(oe!==me)return G.slice(0,Q)+me+oe+G.slice(Q+2)}}),define(pe[142],ve([0,1,74,98,8]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const D=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(f.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${D.source}`,"g");function C(E){return E.replace(P,(L,_)=>_?L:`\\${L}`)}e.escapeIcons=C;const A=new RegExp(`\\\\${D.source}`,"g");function R(E){return E.replace(A,L=>`\\${L}`)}e.markdownEscapeEscapedIcons=R;const y=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function l(E){return E.indexOf(e.iconStartMarker)===-1?E:E.replace(y,(L,_,a,s)=>a?L:_||s||"")}e.stripIcons=l;function b(E){const L=E.indexOf(e.iconStartMarker);return L===-1?{text:E}:p(E,L)}e.parseLabelWithIcons=b;function p(E,L){const _=[];let a="";function s(c){if(c){a+=c;for(const d of c)_.push(S)}}let m=-1,o="",S=0,r,i,n=L;const u=E.length;for(s(E.substr(0,L));n<u;)r=E[n],i=E[n+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(m=n,s(o),o=e.iconStartMarker,n++):r===")"&&m!==-1?(S+=n-m+1,m=-1,o=""):m!==-1?T.test(r)?o+=r:(s(o),m=-1,o=""):s(r),n++;return s(o),{text:a,iconOffsets:_}}function g(E,L,_=!1){const{text:a,iconOffsets:s}=L;if(!s||s.length===0)return(0,t.matchesFuzzy)(E,a,_);const m=(0,I.ltrim)(a," "),o=a.length-m.length,S=(0,t.matchesFuzzy)(E,m,_);if(S)for(const r of S){const i=s[r.start+o]+o;r.start+=i,r.end+=i}return S}e.matchesFuzzyIconAware=g}),define(pe[99],ve([0,1,15,142]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(b="",p=!1){if(this.value=b,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(b,p=0){return this.value+=A(this.supportThemeIcons?(0,t.escapeIcons)(b):b).replace(/([ \t]+)/g,(g,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,p){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=D;function T(l){return P(l)?!l.value:Array.isArray(l)?l.every(T):!0}e.isEmptyMarkdownString=T;function P(l){return l instanceof D?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function C(l,b){return l===b?!0:!l||!b?!1:l.value===b.value&&l.isTrusted===b.isTrusted&&l.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=C;function A(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function R(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function y(l){const b=[],p=l.split("|").map(E=>E.trim());l=p[0];const g=p[1];if(g){const E=/height=(\d+)/.exec(g),L=/width=(\d+)/.exec(g),_=E?E[1]:"",a=L?L[1]:"",s=isFinite(parseInt(a)),m=isFinite(parseInt(_));s&&b.push(`width="${a}"`),m&&b.push(`height="${_}"`)}return{href:l,dimensions:b}}e.parseHrefAndDimensions=y}),define(pe[79],ve([0,1,24]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new f.LRUCache(1e4);function I(A){return C(A,"NFC",t)}e.normalizeNFC=I;const D=new f.LRUCache(1e4);function T(A){return C(A,"NFD",D)}e.normalizeNFD=T;const P=/[^\u0000-\u0080]/;function C(A,R,y){if(!A)return A;const l=y.get(A);if(l)return l;let b;return P.test(A)?b=A.normalize(R):b=A,y.set(A,b),b}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(R){return T(R).replace(A,"")}}()}),define(pe[47],ve([0,1,8]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const D="error",T="warning",P="warn",C="info",A="ignore";function R(l){return l?f.equalsIgnoreCase(D,l)?I.Error:f.equalsIgnoreCase(T,l)||f.equalsIgnoreCase(P,l)?I.Warning:f.equalsIgnoreCase(C,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function y(l){switch(l){case I.Error:return D;case I.Warning:return T;case I.Info:return C;default:return A}}I.toString=y}(t||(t={})),e.default=t}),define(pe[13],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(d){return Array.isArray(d)}e.isArray=f;function t(d){return typeof d=="string"}e.isString=t;function I(d){return Array.isArray(d)&&d.every(h=>t(h))}e.isStringArray=I;function D(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=D;function T(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=T;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function C(d){return d===!0||d===!1}e.isBoolean=C;function A(d){return typeof d=="undefined"}e.isUndefined=A;function R(d){return!y(d)}e.isDefined=R;function y(d){return A(d)||d===null}e.isUndefinedOrNull=y;function l(d,h){if(!d)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=l;function b(d){if(y(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=b;function p(...d){const h=[];for(let w=0;w<d.length;w++){const v=d[w];if(y(v))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);h.push(v)}return h}e.assertAllDefined=p;const g=Object.prototype.hasOwnProperty;function E(d){if(!D(d))return!1;for(let h in d)if(g.call(d,h))return!1;return!0}e.isEmptyObject=E;function L(d){return typeof d=="function"}e.isFunction=L;function _(...d){return d.length>0&&d.every(L)}e.areFunctions=_;function a(d,h){const w=Math.min(d.length,h.length);for(let v=0;v<w;v++)s(d[v],h[v])}e.validateConstraints=a;function s(d,h){if(t(h)){if(typeof d!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(L(h)){try{if(d instanceof h)return}catch{}if(!y(d)&&d.constructor===h||h.length===1&&h.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function m(d){let h=[],w=Object.getPrototypeOf(d);for(;Object.prototype!==w;)h=h.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return h}e.getAllPropertyNames=m;function o(d){const h=[];for(const w of m(d))typeof d[w]=="function"&&h.push(w);return h}e.getAllMethodNames=o;function S(d,h){const w=k=>function(){const O=Array.prototype.slice.call(arguments,0);return h(k,O)};let v={};for(const k of d)v[k]=w(k);return v}e.createProxyObject=S;function r(d){return d===null?void 0:d}e.withNullAsUndefined=r;function i(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=i;function n(d){return class{constructor(){return new Proxy({},{get(h,w){if(h[w])return h[w];throw new Error(`Not Implemented: ${d}->${String(w)}`)}})}}}e.NotImplementedProxy=n;function u(d,h="Unreachable"){throw new Error(h)}e.assertNever=u;function c(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=c}),define(pe[29],ve([0,1,9,12,8,13]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(n){return n===47||n===92}e.isPathSeparator=T;function P(n){return n.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=P;function C(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=C;function A(n,u=f.posix.sep){if(!n)return"";const c=n.length,d=n.charCodeAt(0);if(T(d)){if(T(n.charCodeAt(1))&&!T(n.charCodeAt(2))){let w=3;const v=w;for(;w<c&&!T(n.charCodeAt(w));w++);if(v!==w&&!T(n.charCodeAt(w+1))){for(w+=1;w<c;w++)if(T(n.charCodeAt(w)))return n.slice(0,w+1).replace(/[\\/]/g,u)}}return u}else if(L(d)&&n.charCodeAt(1)===58)return T(n.charCodeAt(2))?n.slice(0,2)+u:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(T(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=A;function R(n){if(!t.isWindows||!n||n.length<5)return!1;let u=n.charCodeAt(0);if(u!==92||(u=n.charCodeAt(1),u!==92))return!1;let c=2;const d=c;for(;c<n.length&&(u=n.charCodeAt(c),u!==92);c++);return!(d===c||(u=n.charCodeAt(c+1),isNaN(u)||u===92))}e.isUNC=R;const y=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(n,u=t.isWindows){const c=u?y:l;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||u&&b.test(n)||n==="."||n===".."||u&&n[n.length-1]==="."||u&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=p;function g(n,u,c){const d=n===u;return!c||d?d:!n||!u?!1:(0,I.equalsIgnoreCase)(n,u)}e.isEqual=g;function E(n,u,c,d=f.sep){if(n===u)return!0;if(!n||!u||u.length>n.length)return!1;if(c){if(!(0,I.startsWithIgnoreCase)(n,u))return!1;if(u.length===n.length)return!0;let w=u.length;return u.charAt(u.length-1)===d&&w--,n.charAt(w)===d}return u.charAt(u.length-1)!==d&&(u+=d),n.indexOf(u)===0}e.isEqualOrParent=E;function L(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=L;function _(n,u){return t.isWindows&&n.endsWith(":")&&(n+=f.sep),(0,f.isAbsolute)(n)||(n=(0,f.join)(u,n)),n=(0,f.normalize)(n),t.isWindows?(n=(0,I.rtrim)(n,f.sep),n.endsWith(":")&&(n+=f.sep)):(n=(0,I.rtrim)(n,f.sep),n||(n=f.sep)),n}e.sanitizeFilePath=_;function a(n){const u=(0,f.normalize)(n);return t.isWindows?n.length>3?!1:s(u)&&(n.length===2||u.charCodeAt(2)===92):u===f.posix.sep}e.isRootOrDriveLetter=a;function s(n,u){return(u!==void 0?u:t.isWindows)?L(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function m(n){return s(n)?n[0]:void 0}e.getDriveLetter=m;function o(n,u,c){return u.length>n.length?-1:n===u?0:(c&&(n=n.toLowerCase(),u=u.toLowerCase()),n.indexOf(u))}e.indexOfPath=o;function S(n){const u=n.split(":");let c,d,h;for(const w of u){const v=Number(w);(0,D.isNumber)(v)?d===void 0?d=v:h===void 0&&(h=v):c=c?[c,w].join(":"):w}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:d!==void 0?d:void 0,column:h!==void 0?h:d!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(n,u,c=8){let d="";for(let w=0;w<c;w++)d+=r.charAt(Math.floor(Math.random()*r.length));let h;return u?h=`${u}-${d}`:h=d,n?(0,f.join)(n,h):h}e.randomPath=i}),define(pe[25],ve([0,1,13]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.keys(g).forEach(L=>{g[L]&&typeof g[L]=="object"?E[L]=t(g[L]):E[L]=g[L]}),E}e.deepClone=t;function I(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const L=E.shift();Object.freeze(L);for(const _ in L)if(D.call(L,_)){const a=L[_];typeof a=="object"&&!Object.isFrozen(a)&&E.push(a)}}return g}e.deepFreeze=I;const D=Object.prototype.hasOwnProperty;function T(g,E){return P(g,E,new Set)}e.cloneAndChange=T;function P(g,E,L){if((0,f.isUndefinedOrNull)(g))return g;const _=E(g);if(typeof _!="undefined")return _;if((0,f.isArray)(g)){const a=[];for(const s of g)a.push(P(s,E,L));return a}if((0,f.isObject)(g)){if(L.has(g))throw new Error("Cannot clone recursive data-structure");L.add(g);const a={};for(let s in g)D.call(g,s)&&(a[s]=P(g[s],E,L));return L.delete(g),a}return g}function C(g,E,L=!0){return(0,f.isObject)(g)?((0,f.isObject)(E)&&Object.keys(E).forEach(_=>{_ in g?L&&((0,f.isObject)(g[_])&&(0,f.isObject)(E[_])?C(g[_],E[_],L):g[_]=E[_]):g[_]=E[_]}),g):E}e.mixin=C;function A(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let L,_;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(L=0;L<g.length;L++)if(!A(g[L],E[L]))return!1}else{const a=[];for(_ in g)a.push(_);a.sort();const s=[];for(_ in E)s.push(_);if(s.sort(),!A(a,s))return!1;for(L=0;L<a.length;L++)if(!A(g[a[L]],E[a[L]]))return!1}return!0}e.equals=A;function R(g){const E=new Set;return JSON.stringify(g,(L,_)=>{if((0,f.isObject)(_)||Array.isArray(_)){if(E.has(_))return"[Circular]";E.add(_)}return _})}e.safeStringify=R;function y(g,E,L){const _=E(g);return typeof _=="undefined"?L:_}e.getOrDefault=y;function l(g,E){const L=Object.create(null);return!g||!E||Object.keys(E).forEach(a=>{const s=g[a],m=E[a];A(s,m)||(L[a]=m)}),L}e.distinct=l;function b(g,E){const L=E.toLowerCase(),_=Object.keys(g).find(a=>a.toLowerCase()===L);return _?g[_]:g[E]}e.getCaseInsensitive=b;function p(g,E){const L=Object.create(null);for(const[_,a]of Object.entries(g))E(_,a)&&(L[_]=a);return L}e.filter=p}),define(pe[100],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function t(D){return D<0?0:D>255?255:D|0}e.toUint8=t;function I(D){return D<0?0:D>4294967295?4294967295:D|0}e.toUint32=I}),define(pe[2],ve([0,1,9,12]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,D=/^\//,T=/^\/\//;function P(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!I.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(r,i){return!r&&!i?"file":r}function A(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const R="",y="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(i,n,u,c,d,h=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=C(i,h),this.authority=n||R,this.path=A(this.scheme,u||R),this.query=c||R,this.fragment=d||R,P(this,h))}static isUri(i){return i instanceof b?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:n,authority:u,path:c,query:d,fragment:h}=i;return n===void 0?n=this.scheme:n===null&&(n=R),u===void 0?u=this.authority:u===null&&(u=R),c===void 0?c=this.path:c===null&&(c=R),d===void 0?d=this.query:d===null&&(d=R),h===void 0?h=this.fragment:h===null&&(h=R),n===this.scheme&&u===this.authority&&c===this.path&&d===this.query&&h===this.fragment?this:new g(n,u,c,d,h)}static parse(i,n=!1){const u=l.exec(i);return u?new g(u[2]||R,S(u[4]||R),S(u[5]||R),S(u[7]||R),S(u[9]||R),n):new g(R,R,R,R,R)}static file(i){let n=R;if(t.isWindows&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const u=i.indexOf(y,2);u===-1?(n=i.substring(2),i=y):(n=i.substring(2,u),i=i.substring(u)||y)}return new g("file",n,i,R,R)}static from(i){const n=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return P(n,!0),n}static joinPath(i,...n){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return t.isWindows&&i.scheme==="file"?u=b.file(f.win32.join(a(i,!0),...n)).path:u=f.posix.join(i.path,...n),i.with({path:u})}toString(i=!1){return s(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof b)return i;{const n=new g(i);return n._formatted=i.external,n._fsPath=i._sep===p?i.fsPath:null,n}}else return i}}e.URI=b;const p=t.isWindows?1:void 0;class g extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function L(r,i){let n,u=-1;for(let c=0;c<r.length;c++){const d=r.charCodeAt(c);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47)u!==-1&&(n+=encodeURIComponent(r.substring(u,c)),u=-1),n!==void 0&&(n+=r.charAt(c));else{n===void 0&&(n=r.substr(0,c));const h=E[d];h!==void 0?(u!==-1&&(n+=encodeURIComponent(r.substring(u,c)),u=-1),n+=h):u===-1&&(u=c)}}return u!==-1&&(n+=encodeURIComponent(r.substring(u))),n!==void 0?n:r}function _(r){let i;for(let n=0;n<r.length;n++){const u=r.charCodeAt(n);u===35||u===63?(i===void 0&&(i=r.substr(0,n)),i+=E[u]):i!==void 0&&(i+=r[n])}return i!==void 0?i:r}function a(r,i){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,t.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=a;function s(r,i){const n=i?_:L;let u="",{scheme:c,authority:d,path:h,query:w,fragment:v}=r;if(c&&(u+=c,u+=":"),(d||c==="file")&&(u+=y,u+=y),d){let k=d.indexOf("@");if(k!==-1){const O=d.substr(0,k);d=d.substr(k+1),k=O.indexOf(":"),k===-1?u+=n(O,!1):(u+=n(O.substr(0,k),!1),u+=":",u+=n(O.substr(k+1),!1)),u+="@"}d=d.toLowerCase(),k=d.indexOf(":"),k===-1?u+=n(d,!1):(u+=n(d.substr(0,k),!1),u+=d.substr(k))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const k=h.charCodeAt(1);k>=65&&k<=90&&(h=`/${String.fromCharCode(k+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const k=h.charCodeAt(0);k>=65&&k<=90&&(h=`${String.fromCharCode(k+32)}:${h.substr(2)}`)}u+=n(h,!0)}return w&&(u+="?",u+=n(w,!1)),v&&(u+="#",u+=i?v:L(v,!1)),u}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(r){return r.match(o)?r.replace(o,i=>m(i)):r}}),define(pe[59],ve([0,1,22,8,2]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(R){return JSON.stringify(R,C)}e.stringify=D;function T(R){let y=JSON.parse(R);return y=A(y),y}e.parse=T;var P;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext",R[R.Date=14]="Date"})(P=e.MarshalledId||(e.MarshalledId={}));function C(R,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,t.regExpFlags)(y)}:y}function A(R,y=0){if(!R||y>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return I.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof f.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let l=0;l<R.length;++l)R[l]=A(R[l],y+1);else for(const l in R)Object.hasOwnProperty.call(R,l)&&(R[l]=A(R[l],y+1))}return R}e.revive=A}),define(pe[10],ve([0,1,12,2]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(I=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,A,R){this._hosts[C]=A,this._ports[C]=R}setConnectionToken(C,A){this._connectionTokens[C]=A}rewrite(C){if(this._delegate)return this._delegate(C);const A=C.authority;let R=this._hosts[A];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const y=this._ports[A],l=this._connectionTokens[A];let b=`path=${encodeURIComponent(C.path)}`;return typeof l=="string"&&(b+=`&tkn=${encodeURIComponent(l)}`),t.URI.from({scheme:f.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${R}:${y}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new D;class T{asBrowserUri(C,A){const R=this.toUri(C,A);return R.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===I.file&&(f.isNative||typeof f.globals.importScripts=="function"&&f.globals.origin===`${I.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?R.with({scheme:I.vscodeFileResource,authority:R.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(C,A){const R=this.toUri(C,A);return R.scheme===I.vscodeFileResource?R.with({scheme:I.file,authority:R.authority!==T.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(C,A){return t.URI.isUri(C)?C:t.URI.parse(A.toUrl(C))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(pe[23],ve([0,1,29,10,9,12,8,2]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(b){return(0,P.uriToFsPath)(b,!0)}e.originalFSPath=C;class A{constructor(p){this._ignorePathCasing=p}compare(p,g,E=!1){return p===g?0:(0,T.compare)(this.getComparisonKey(p,E),this.getComparisonKey(g,E))}isEqual(p,g,E=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,E)===this.getComparisonKey(g,E)}getComparisonKey(p,g=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,g,E=!1){if(p.scheme===g.scheme){if(p.scheme===t.Schemas.file)return f.isEqualOrParent(C(p),C(g),this._ignorePathCasing(p))&&p.query===g.query&&(E||p.fragment===g.fragment);if((0,e.isEqualAuthority)(p.authority,g.authority))return f.isEqualOrParent(p.path,g.path,this._ignorePathCasing(p),"/")&&p.query===g.query&&(E||p.fragment===g.fragment)}return!1}joinPath(p,...g){return P.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return I.posix.basename(p.path)}extname(p){return I.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===t.Schemas.file?g=P.URI.file(I.dirname(C(p))).path:(g=I.posix.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===t.Schemas.file?g=P.URI.file(I.normalize(C(p))).path:g=I.posix.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.isEqualAuthority)(p.authority,g.authority))return;if(p.scheme===t.Schemas.file){const _=I.relative(C(p),C(g));return D.isWindows?f.toSlashes(_):_}let E=p.path||"/",L=g.path||"/";if(this._ignorePathCasing(p)){let _=0;for(const a=Math.min(E.length,L.length);_<a&&!(E.charCodeAt(_)!==L.charCodeAt(_)&&E.charAt(_).toLowerCase()!==L.charAt(_).toLowerCase());_++);E=L.substr(0,_)+E.substr(_)}return I.posix.relative(E,L)}resolvePath(p,g){if(p.scheme===t.Schemas.file){const E=P.URI.file(I.resolve(C(p),g));return p.with({authority:E.authority,path:E.path})}return g=f.toPosixPath(g),p.with({path:I.posix.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,T.equalsIgnoreCase)(p,g)}hasTrailingPathSeparator(p,g=I.sep){if(p.scheme===t.Schemas.file){const E=C(p);return E.length>f.getRoot(E).length&&E[E.length-1]===g}else{const E=p.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=I.sep){return(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=I.sep){let E=!1;if(p.scheme===t.Schemas.file){const L=C(p);E=L!==void 0&&L.length===f.getRoot(L).length&&L[L.length-1]===g}else{g="/";const L=p.path;E=L.length===1&&L.charCodeAt(L.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path+"/"}):p}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(b=>b.scheme===t.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new A(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(b,p){const g=[];for(let E=0;E<b.length;E++){const L=p(b[E]);b.some((_,a)=>a===E?!1:(0,e.isEqualOrParent)(L,p(_)))||g.push(b[E])}return g}e.distinctParents=R;var y;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(a=>{const[s,m]=a.split(":");s&&m&&E.set(s,m)});const _=g.path.substring(0,g.path.indexOf(";"));return _&&E.set(b.META_DATA_MIME,_),E}b.parseMetaData=p})(y=e.DataUri||(e.DataUri={}));function l(b,p,g){if(p){let E=b.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),b.with({scheme:g,authority:p,path:E})}return b.with({scheme:g})}e.toLocalResource=l}),define(pe[17],ve([0,1,21,15,3,6,23,12]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(K){return!!K&&typeof K.then=="function"}e.isThenable=C;function A(K){const Y=new f.CancellationTokenSource,le=K(Y.token),fe=new Promise((Se,Me)=>{const Ve=Y.token.onCancellationRequested(()=>{Ve.dispose(),Y.dispose(),Me(new t.CancellationError)});Promise.resolve(le).then(Ge=>{Ve.dispose(),Y.dispose(),Se(Ge)},Ge=>{Ve.dispose(),Y.dispose(),Me(Ge)})});return new class{cancel(){Y.cancel()}then(Se,Me){return fe.then(Se,Me)}catch(Se){return this.then(void 0,Se)}finally(Se){return fe.finally(Se)}}}e.createCancelablePromise=A;function R(K,Y,le){return new Promise((fe,Se)=>{const Me=Y.onCancellationRequested(()=>{Me.dispose(),fe(le)});K.then(fe,Se).finally(()=>Me.dispose())})}e.raceCancellation=R;function y(K,Y){return new Promise((le,fe)=>{const Se=Y.onCancellationRequested(()=>{Se.dispose(),fe(new t.CancellationError)});K.then(le,fe).finally(()=>Se.dispose())})}e.raceCancellationError=y;async function l(K){let Y=-1;const le=K.map((Se,Me)=>Se.then(Ve=>(Y=Me,Ve))),fe=await Promise.race(le);return K.forEach((Se,Me)=>{Me!==Y&&Se.cancel()}),fe}e.raceCancellablePromises=l;function b(K,Y,le){let fe;const Se=setTimeout(()=>{fe?.(void 0),le?.()},Y);return Promise.race([K.finally(()=>clearTimeout(Se)),new Promise(Me=>fe=Me)])}e.raceTimeout=b;function p(K){return new Promise((Y,le)=>{const fe=K();C(fe)?fe.then(Y,le):Y(fe)})}e.asPromise=p;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const le=()=>{this.queuedPromise=null;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(le,le).then(fe)})}return new Promise((le,fe)=>{this.queuedPromise.then(le,fe)})}return this.activePromise=Y(),new Promise((le,fe)=>{this.activePromise.then(Se=>{this.activePromise=null,le(Se)},Se=>{this.activePromise=null,fe(Se)})})}}e.Throttler=g;class E{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=E;class L{constructor(){this.promiseMap=new Map}queue(Y,le){const Se=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.promiseMap.get(Y)===Se&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Se),Se}}e.SequencerByKey=L;const _=(K,Y)=>{let le=!0;const fe=setTimeout(()=>{le=!1,Y()},K);return{isTriggered:()=>le,dispose:()=>{clearTimeout(fe),le=!1}}},a=K=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,K())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,le=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Se,Me)=>{this.doResolve=Se,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Se=this.task;return this.task=null,Se()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=le===e.MicrotaskDelay?a(fe):_(le,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class m{constructor(Y){this.delayer=new s(Y),this.throttler=new g}trigger(Y,le){return this.delayer.trigger(()=>this.throttler.queue(Y),le)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class o{constructor(){this._isOpen=!1,this._promise=new Promise((Y,le)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class S extends o{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function r(K,Y){return Y?new Promise((le,fe)=>{const Se=setTimeout(()=>{Me.dispose(),le()},K),Me=Y.onCancellationRequested(()=>{clearTimeout(Se),Me.dispose(),fe(new t.CancellationError)})}):A(le=>r(K,le))}e.timeout=r;function i(K,Y=0){const le=setTimeout(K,Y);return(0,D.toDisposable)(()=>clearTimeout(le))}e.disposableTimeout=i;function n(K){const Y=[];let le=0;const fe=K.length;function Se(){return le<fe?K[le++]():null}function Me(Ve){Ve!=null&&Y.push(Ve);const Ge=Se();return Ge?Ge.then(Me):Promise.resolve(Y)}return Promise.resolve(null).then(Me)}e.sequence=n;function u(K,Y=fe=>!!fe,le=null){let fe=0;const Se=K.length,Me=()=>{if(fe>=Se)return Promise.resolve(le);const Ve=K[fe++];return Promise.resolve(Ve()).then(Ye=>Y(Ye)?Promise.resolve(Ye):Me())};return Me()}e.first=u;function c(K,Y=fe=>!!fe,le=null){if(K.length===0)return Promise.resolve(le);let fe=K.length;const Se=()=>{fe=-1;for(const Me of K)Me.cancel?.()};return new Promise((Me,Ve)=>{for(const Ge of K)Ge.then(Ye=>{--fe>=0&&Y(Ye)?(Se(),Me(Ye)):fe===0&&Me(le)}).catch(Ye=>{--fe>=0&&(Se(),Ve(Ye))})})}e.firstParallel=c;class d{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((le,fe)=>{this.outstandingPromises.push({factory:Y,c:le,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const le=Y.factory();le.then(Y.c,Y.e),le.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class h extends d{constructor(){super(1)}}e.Queue=h;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new x;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,le=T.extUri){const fe=le.getComparisonKey(Y);let Se=this.queues.get(fe);return Se||(Se=new h,I.Event.once(Se.onFinished)(()=>{Se?.dispose(),this.queues.delete(fe),this.onDidQueueFinish()}),this.queues.set(fe,Se)),Se}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class v{constructor(Y,le){this._token=-1,typeof Y=="function"&&typeof le=="number"&&this.setIfNotSet(Y,le)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,le){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},le)}setIfNotSet(Y,le){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},le))}}e.TimeoutTimer=v;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,le){this.cancel(),this._token=setInterval(()=>{Y()},le)}}e.IntervalTimer=k;class O{constructor(Y,le){this.timeoutToken=-1,this.runner=Y,this.timeout=le,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class U{constructor(Y,le){le%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=le,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=U;class F extends O{constructor(Y,le){super(Y,le);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class M extends D.Disposable{constructor(Y,le){super();this.options=Y,this.handler=le,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,P.setTimeout0)(()=>{if(Y)return;const le=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(K,Y)=>{const le=requestIdleCallback(K,typeof Y=="number"?{timeout:Y}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(le))}}}}();class V{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(le){this._error=le}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function $(K,Y,le){let fe;for(let Se=0;Se<le;Se++)try{return await K()}catch(Me){fe=Me,await r(Y)}throw fe}e.retry=$;class N{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,le,fe){return this._pending={taskId:Y,cancel:()=>fe?.(),promise:le},le.then(()=>this.donePending(Y),()=>this.donePending(Y)),le}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let le,fe;const Se=new Promise((Me,Ve)=>{le=Me,fe=Ve});this._next={run:Y,promise:Se,promiseResolve:le,promiseReject:fe}}return this._next.promise}}e.TaskSequentializer=N;class B{constructor(Y,le=()=>Date.now()){this.interval=Y,this.nowFn=le,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,le)=>{this.completeCallback=Y,this.errorCallback=le})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(le=>{this.completeCallback(Y),this.resolved=!0,le()})}error(Y){return new Promise(le=>{this.errorCallback(Y),this.rejected=!0,le()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=x;var z;(function(K){async function Y(fe){let Se;const Me=await Promise.all(fe.map(Ve=>Ve.then(Ge=>Ge,Ge=>{Se||(Se=Ge)})));if(typeof Se!="undefined")throw Se;return Me}K.settled=Y;function le(fe){return new Promise(async(Se,Me)=>{try{await fe(Se,Me)}catch(Ve){Me(Ve)}})}K.withAsyncBody=le})(z=e.Promises||(e.Promises={}));var W;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(W||(W={}));class J{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const le={emitOne:fe=>this.emitOne(fe),emitMany:fe=>this.emitMany(fe),reject:fe=>this.reject(fe)};try{await Promise.resolve(Y(le)),this.resolve()}catch(fe){this.reject(fe)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}static fromArray(Y){return new J(le=>{le.emitMany(Y)})}static fromPromise(Y){return new J(async le=>{le.emitMany(await Y)})}static fromPromises(Y){return new J(async le=>{await Promise.all(Y.map(async fe=>le.emitOne(await fe)))})}static merge(Y){return new J(async le=>{await Promise.all(Y.map(async fe=>{for await(const Se of fe)le.emitOne(Se)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,le){return new J(async fe=>{for await(const Se of Y)fe.emitOne(le(Se))})}map(Y){return J.map(this,Y)}static filter(Y,le){return new J(async fe=>{for await(const Se of Y)le(Se)&&fe.emitOne(Se)})}filter(Y){return J.filter(this,Y)}static coalesce(Y){return J.filter(Y,le=>!!le)}coalesce(){return J.coalesce(this)}static async toPromise(Y){const le=[];for await(const fe of Y)le.push(fe);return le}toPromise(){return J.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class se extends J{constructor(Y,le){super(le);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function ie(K){const Y=new f.CancellationTokenSource,le=K(Y.token);return new se(Y,async fe=>{const Se=Y.token.onCancellationRequested(()=>{Se.dispose(),Y.dispose(),fe.reject(new t.CancellationError)});try{for await(const Me of le){if(Y.token.isCancellationRequested)return;fe.emitOne(Me)}Se.dispose(),Y.dispose()}catch(Me){Se.dispose(),Y.dispose(),fe.reject(Me)}})}e.createCancelableAsyncIterable=ie}),define(pe[101],ve([0,1,17,9]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new f.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),D=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(h,w,v=!1){const k=h||"",O=w||"",U=I.value.collator.compare(k,O);return I.value.collatorIsNumeric&&U===0&&k!==O?k<O?-1:1:U}e.compareFileNames=P;function C(h,w){const v=D.value.collator;return h=h||"",w=w||"",m(v,h,w)}e.compareFileNamesDefault=C;function A(h,w){const v=D.value.collator;return h=h||"",w=w||"",i(h,w)||m(v,h,w)}e.compareFileNamesUpper=A;function R(h,w){const v=D.value.collator;return h=h||"",w=w||"",r(h,w)||m(v,h,w)}e.compareFileNamesLower=R;function y(h,w){return h=h||"",w=w||"",h===w?0:h<w?-1:1}e.compareFileNamesUnicode=y;function l(h,w,v=!1){v||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase());const[k,O]=a(h),[U,F]=a(w);return k!==U?k<U?-1:1:O===F?0:O<F?-1:1}e.noIntlCompareFileNames=l;function b(h,w){const[v,k]=a(h),[O,U]=a(w);let F=I.value.collator.compare(k,U);if(F===0){if(I.value.collatorIsNumeric&&k!==U)return k<U?-1:1;if(F=I.value.collator.compare(v,O),I.value.collatorIsNumeric&&F===0&&v!==O)return v<O?-1:1}return F}e.compareFileExtensions=b;function p(h,w){h=h||"",w=w||"";const v=s(h),k=s(w),O=D.value.collator,U=T.value.collator;return m(U,v,k)||m(O,h,w)}e.compareFileExtensionsDefault=p;function g(h,w){h=h||"",w=w||"";const v=s(h),k=s(w),O=D.value.collator,U=T.value.collator;return m(U,v,k)||i(h,w)||m(O,h,w)}e.compareFileExtensionsUpper=g;function E(h,w){h=h||"",w=w||"";const v=s(h),k=s(w),O=D.value.collator,U=T.value.collator;return m(U,v,k)||r(h,w)||m(O,h,w)}e.compareFileExtensionsLower=E;function L(h,w){h=h||"",w=w||"";const v=s(h).toLowerCase(),k=s(w).toLowerCase();return v!==k?v<k?-1:1:h!==w?h<w?-1:1:0}e.compareFileExtensionsUnicode=L;const _=/^(.*?)(\.([^.]*))?$/;function a(h,w=!1){const v=h?_.exec(h):[];let k=[v&&v[1]||"",v&&v[3]||""];return w&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function s(h){const w=h?_.exec(h):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function m(h,w,v){let k=h.compare(w,v);return k!==0?k:w.length!==v.length?w.length<v.length?-1:1:0}function o(h){const w=h.charAt(0);return w.toLocaleUpperCase()!==w}function S(h){const w=h.charAt(0);return w.toLocaleLowerCase()!==w}function r(h,w){return o(h)&&S(w)?-1:S(h)&&o(w)?1:0}function i(h,w){return S(h)&&o(w)?-1:o(h)&&S(w)?1:0}function n(h,w,v=!1){return v||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase()),h===w?0:h<w?-1:1}function u(h,w,v=!1){const k=h.split(t.sep),O=w.split(t.sep),U=k.length-1,F=O.length-1;let M,V;for(let $=0;;$++){if(M=U===$,V=F===$,M&&V)return P(k[$],O[$],v);if(M)return-1;if(V)return 1;const N=n(k[$],O[$],v);if(N!==0)return N}}e.comparePaths=u;function c(h,w,v){const k=h.toLowerCase(),O=w.toLowerCase(),U=d(h,w,v);if(U)return U;const F=k.endsWith(v),M=O.endsWith(v);if(F!==M)return F?-1:1;const V=P(k,O);return V!==0?V:k.localeCompare(O)}e.compareAnything=c;function d(h,w,v){const k=h.toLowerCase(),O=w.toLowerCase(),U=k.startsWith(v),F=O.startsWith(v);if(U!==F)return U?-1:1;if(U&&F){if(k.length<O.length)return-1;if(k.length>O.length)return 1}return 0}e.compareByPrefix=d}),define(pe[102],ve([0,1,101,98,58,9,12,8]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,A=[C,[]];function R(N,B,x,z){if(!N||!B)return A;const W=N.length,J=B.length;if(W<J)return A;const se=N.toLowerCase();return y(B,x,J,N,se,W,z)}e.scoreFuzzy=R;function y(N,B,x,z,W,J,se){const ie=[],K=[];for(let Se=0;Se<x;Se++){const Me=Se*J,Ve=Me-J,Ge=Se>0,Ye=N[Se],q=B[Se];for(let te=0;te<J;te++){const G=te>0,Q=Me+te,oe=Q-1,me=Ve+te-1,Ie=G?ie[oe]:0,xe=Ge&&G?ie[me]:0,Xe=Ge&&G?K[me]:0;let it;!xe&&Ge?it=0:it=l(Ye,q,z,W,te,Xe),it&&xe+it>=Ie&&(se||Ge||W.startsWith(B,te))?(K[Q]=Xe+1,ie[Q]=xe+it):(K[Q]=C,ie[Q]=Ie)}}const Y=[];let le=x-1,fe=J-1;for(;le>=0&&fe>=0;){const Se=le*J+fe;K[Se]===C||(Y.push(fe),le--),fe--}return[ie[x*J-1],Y.reverse()]}function l(N,B,x,z,W,J){let se=0;if(!b(B,z[W]))return se;if(se+=1,J>0&&(se+=J*5),N===x[W]&&(se+=1),W===0)se+=8;else{const ie=p(x.charCodeAt(W-1));ie?se+=ie:(0,t.isUpper)(x.charCodeAt(W))&&J===0&&(se+=2)}return se}function b(N,B){return N===B?!0:N==="/"||N==="\\"?B==="/"||B==="\\":!1}function p(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function E(N,B,x=0,z=0){const W=B;return W.values&&W.values.length>1?L(N,W.values,x,z):_(N,B,x,z)}e.scoreFuzzy2=E;function L(N,B,x,z){let W=0;const J=[];for(const se of B){const[ie,K]=_(N,se,x,z);if(typeof ie!="number")return g;W+=ie,J.push(...K)}return[W,d(J)]}function _(N,B,x,z){const W=(0,t.fuzzyScore)(B.original,B.originalLowercase,x,N,N.toLowerCase(),z,!0);return W?[W[0],(0,t.createMatches)(W)]:g}const a=Object.freeze({score:0}),s=1<<18,m=1<<17,o=1<<16;function S(N,B,x,z){const W=z.values?z.values:[z];return(0,I.hash)({[z.normalized]:{values:W.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:N,description:B,allowNonContiguousMatches:x}})}function r(N,B,x,z,W){if(!N||!B.normalized)return a;const J=z.getItemLabel(N);if(!J)return a;const se=z.getItemDescription(N),ie=S(J,se,x,B),K=W[ie];if(K)return K;const Y=i(J,se,z.getItemPath(N),B,x);return W[ie]=Y,Y}e.scoreItemFuzzy=r;function i(N,B,x,z,W){const J=!x||!z.containsPathSeparator;return x&&(T.isLinux?z.pathNormalized===x:(0,P.equalsIgnoreCase)(z.pathNormalized,x))?{score:s,labelMatch:[{start:0,end:N.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:z.values&&z.values.length>1?n(N,B,x,z.values,J,W):u(N,B,x,z,J,W)}function n(N,B,x,z,W,J){let se=0;const ie=[],K=[];for(const Y of z){const{score:le,labelMatch:fe,descriptionMatch:Se}=u(N,B,x,Y,W,J);if(le===C)return a;se+=le,fe&&ie.push(...fe),Se&&K.push(...Se)}return{score:se,labelMatch:d(ie),descriptionMatch:d(K)}}function u(N,B,x,z,W,J){if(W||!B){const[se,ie]=R(N,z.normalized,z.normalizedLowercase,J&&!z.expectContiguousMatch);if(se){const K=(0,t.matchesPrefix)(z.normalized,N);let Y;return K?(Y=m,Y+=Math.round(z.normalized.length/N.length*100)):Y=o,{score:Y+se,labelMatch:K||c(ie)}}}if(B){let se=B;x&&(se=`${B}${D.sep}`);const ie=se.length,K=`${se}${N}`,[Y,le]=R(K,z.normalized,z.normalizedLowercase,J&&!z.expectContiguousMatch);if(Y){const fe=c(le),Se=[],Me=[];return fe.forEach(Ve=>{Ve.start<ie&&Ve.end>ie?(Se.push({start:0,end:Ve.end-ie}),Me.push({start:Ve.start,end:ie})):Ve.start>=ie?Se.push({start:Ve.start-ie,end:Ve.end-ie}):Me.push(Ve)}),{score:Y,labelMatch:Se,descriptionMatch:Me}}}return a}function c(N){const B=[];if(!N)return B;let x;for(const z of N)x&&x.end===z?x.end+=1:(x={start:z,end:z+1},B.push(x));return B}function d(N){const B=N.sort((W,J)=>W.start-J.start),x=[];let z;for(const W of B)!z||!h(z,W)?(z=W,x.push(W)):(z.start=Math.min(z.start,W.start),z.end=Math.max(z.end,W.end));return x}function h(N,B){return!(N.end<B.start||B.end<N.start)}function w(N,B,x,z,W,J){const se=r(N,x,z,W,J),ie=r(B,x,z,W,J),K=se.score,Y=ie.score;if((K===s||Y===s)&&K!==Y)return K===s?-1:1;if(K>o||Y>o){if(K!==Y)return K>Y?-1:1;if(K<m&&Y<m){const Ye=k(se.labelMatch,ie.labelMatch);if(Ye!==0)return Ye}const Ve=W.getItemLabel(N)||"",Ge=W.getItemLabel(B)||"";if(Ve.length!==Ge.length)return Ve.length-Ge.length}if(K!==Y)return K>Y?-1:1;const le=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,fe=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(le&&!fe)return-1;if(fe&&!le)return 1;const Se=v(N,se,W),Me=v(B,ie,W);return Se&&Me&&Se!==Me?Me>Se?-1:1:O(N,B,x,W)}e.compareItemsByFuzzyScore=w;function v(N,B,x){let z=-1,W=-1;if(B.descriptionMatch&&B.descriptionMatch.length?z=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(z=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(W=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const J=x.getItemDescription(N);J&&(W+=J.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(W=B.descriptionMatch[B.descriptionMatch.length-1].end);return W-z}function k(N,B){if(!N&&!B||(!N||!N.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!N||!N.length)return 1;const x=N[0].start,W=N[N.length-1].end-x,J=B[0].start,ie=B[B.length-1].end-J;return W===ie?0:ie<W?1:-1}function O(N,B,x,z){const W=z.getItemLabel(N)||"",J=z.getItemLabel(B)||"",se=z.getItemDescription(N),ie=z.getItemDescription(B),K=W.length+(se?se.length:0),Y=J.length+(ie?ie.length:0);if(K!==Y)return K-Y;const le=z.getItemPath(N),fe=z.getItemPath(B);return le&&fe&&le.length!==fe.length?le.length-fe.length:W!==J?(0,f.compareAnything)(W,J,x.normalized):se&&ie&&se!==ie?(0,f.compareAnything)(se,ie,x.normalized):le&&fe&&le!==fe?(0,f.compareAnything)(le,fe,x.normalized):0}function U(N){return N.startsWith('"')&&N.endsWith('"')}const F=" ";function M(N){typeof N!="string"&&(N="");const B=N.toLowerCase(),{pathNormalized:x,normalized:z,normalizedLowercase:W}=V(N),J=x.indexOf(D.sep)>=0,se=U(N);let ie;const K=N.split(F);if(K.length>1)for(const Y of K){const le=U(Y),{pathNormalized:fe,normalized:Se,normalizedLowercase:Me}=V(Y);Se&&(ie||(ie=[]),ie.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:fe,normalized:Se,normalizedLowercase:Me,expectContiguousMatch:le}))}return{original:N,originalLowercase:B,pathNormalized:x,normalized:z,normalizedLowercase:W,values:ie,containsPathSeparator:J,expectContiguousMatch:se}}e.prepareQuery=M;function V(N){let B;T.isWindows?B=N.replace(/\//g,D.sep):B=N.replace(/\\/g,D.sep);const x=(0,P.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:x,normalizedLowercase:x.toLowerCase()}}function $(N){return Array.isArray(N)?M(N.map(B=>B.original).join(F)):M(N.original)}e.pieceToQuery=$}),define(pe[32],ve([0,1,17,29,24,9,8]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",A="[^/\\\\]",R=/\//g;function y(B){switch(B){case 0:return"";case 1:return`${A}*?`;default:return`(?:${C}|${A}+${C}|${C}${A}+)*?`}}function l(B,x){if(!B)return[];const z=[];let W=!1,J=!1,se="";for(const ie of B){switch(ie){case x:if(!W&&!J){z.push(se),se="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":J=!0;break;case"]":J=!1;break}se+=ie}return se&&z.push(se),z}e.splitGlobAware=l;function b(B){if(!B)return"";let x="";const z=l(B,e.GLOB_SPLIT);if(z.every(W=>W===e.GLOBSTAR))x=".*";else{let W=!1;z.forEach((J,se)=>{if(J===e.GLOBSTAR){W||(x+=y(2),W=!0);return}let ie=!1,K="",Y=!1,le="";for(const fe of J){if(fe!=="}"&&ie){K+=fe;continue}if(Y&&(fe!=="]"||!le)){let Se;fe==="-"?Se=fe:(fe==="^"||fe==="!")&&!le?Se="^":fe===e.GLOB_SPLIT?Se="":Se=T.escapeRegExpCharacters(fe),le+=Se;continue}switch(fe){case"{":ie=!0;continue;case"[":Y=!0;continue;case"}":{x+=`(?:${l(K,",").map(Ve=>b(Ve)).join("|")})`,ie=!1,K="";break}case"]":x+="["+le+"]",Y=!1,le="";break;case"?":x+=A;continue;case"*":x+=y(1);continue;default:x+=T.escapeRegExpCharacters(fe)}}se<z.length-1&&(z[se+1]!==e.GLOBSTAR||se+2<z.length)&&(x+=C),W=!1})}return x}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,L=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,_=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new I.LRUCache(1e4),m=function(){return!1},o=function(){return null};function S(B,x){if(!B)return o;let z;typeof B!="string"?z=B.pattern:z=B,z=z.trim();const W=`${z}_${!!x.trimForExclusions}`;let J=s.get(W);if(J)return r(J,B);let se;if(p.test(z)){const ie=z.substr(4);J=function(K,Y){return typeof K=="string"&&K.endsWith(ie)?z:null}}else(se=g.exec(i(z,x)))?J=n(se[1],z):(x.trimForExclusions?L:E).test(z)?J=u(z,x):(se=_.exec(i(z,x)))?J=c(se[1].substr(1),z,!0):(se=a.exec(i(z,x)))?J=c(se[1],z,!1):J=d(z);return s.set(W,J),r(J,B)}function r(B,x){return typeof x=="string"?B:function(z,W){return t.isEqualOrParent(z,x.base)?B(D.relative(x.base,z),W):null}}function i(B,x){return x.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function n(B,x){const z=`/${B}`,W=`\\${B}`,J=function(ie,K){return typeof ie!="string"?null:K?K===B?x:null:ie===B||ie.endsWith(z)||ie.endsWith(W)?x:null},se=[B];return J.basenames=se,J.patterns=[x],J.allBasenames=se,J}function u(B,x){const z=N(B.slice(1,-1).split(",").map(K=>S(K,x)).filter(K=>K!==o),B),W=z.length;if(!W)return o;if(W===1)return z[0];const J=function(K,Y){for(let le=0,fe=z.length;le<fe;le++)if(z[le](K,Y))return B;return null},se=z.find(K=>!!K.allBasenames);se&&(J.allBasenames=se.allBasenames);const ie=z.reduce((K,Y)=>Y.allPaths?K.concat(Y.allPaths):K,[]);return ie.length&&(J.allPaths=ie),J}function c(B,x,z){const W=D.sep===D.posix.sep,J=W?B:B.replace(R,D.sep),se=D.sep+J,ie=D.posix.sep+B,K=z?function(Y,le){return typeof Y=="string"&&(Y===J||Y.endsWith(se)||!W&&(Y===B||Y.endsWith(ie)))?x:null}:function(Y,le){return typeof Y=="string"&&(Y===J||!W&&Y===B)?x:null};return K.allPaths=[(z?"*/":"./")+B],K}function d(B){try{const x=new RegExp(`^${b(B)}$`);return function(z){return x.lastIndex=0,typeof z=="string"&&x.test(z)?B:null}}catch{return o}}function h(B,x,z){return!B||typeof x!="string"?!1:w(B)(x,void 0,z)}e.match=h;function w(B,x={}){if(!B)return m;if(typeof B=="string"||U(B)){const z=S(B,x);if(z===o)return m;const W=function(J,se){return!!z(J,se)};return z.allBasenames&&(W.allBasenames=z.allBasenames),z.allPaths&&(W.allPaths=z.allPaths),W}return V(B,x)}e.parse=w;function v(B){if(!B)return;let x;return z=>(x||(x=(B()||Promise.resolve([])).then(W=>W?O(W):{})),x.then(W=>!!W[z]))}e.hasSiblingPromiseFn=v;function k(B){if(!B)return;let x;return z=>{if(!x){const W=B();x=W?O(W):{}}return!!x[z]}}e.hasSiblingFn=k;function O(B){const x={};for(const z of B)x[z]=!0;return x}function U(B){const x=B;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}e.isRelativePattern=U;function F(B){return B.allBasenames||[]}e.getBasenameTerms=F;function M(B){return B.allPaths||[]}e.getPathTerms=M;function V(B,x){const z=N(Object.getOwnPropertyNames(B).map(K=>$(K,B[K],x)).filter(K=>K!==o)),W=z.length;if(!W)return o;if(!z.some(K=>!!K.requiresSiblings)){if(W===1)return z[0];const K=function(fe,Se){for(let Me=0,Ve=z.length;Me<Ve;Me++){const Ge=z[Me](fe,Se);if(Ge)return Ge}return null},Y=z.find(fe=>!!fe.allBasenames);Y&&(K.allBasenames=Y.allBasenames);const le=z.reduce((fe,Se)=>Se.allPaths?fe.concat(Se.allPaths):fe,[]);return le.length&&(K.allPaths=le),K}const J=function(K,Y,le){let fe;for(let Se=0,Me=z.length;Se<Me;Se++){const Ve=z[Se];Ve.requiresSiblings&&le&&(Y||(Y=D.basename(K)),fe||(fe=Y.substr(0,Y.length-D.extname(K).length)));const Ge=Ve(K,Y,fe,le);if(Ge)return Ge}return null},se=z.find(K=>!!K.allBasenames);se&&(J.allBasenames=se.allBasenames);const ie=z.reduce((K,Y)=>Y.allPaths?K.concat(Y.allPaths):K,[]);return ie.length&&(J.allPaths=ie),J}function $(B,x,z){if(x===!1)return o;const W=S(B,z);if(W===o)return o;if(typeof x=="boolean")return W;if(x){const J=x.when;if(typeof J=="string"){const se=(ie,K,Y,le)=>{if(!le||!W(ie,K))return null;const fe=J.replace("$(basename)",Y),Se=le(fe);return(0,f.isThenable)(Se)?Se.then(Me=>Me?B:null):Se?B:null};return se.requiresSiblings=!0,se}}return W}function N(B,x){const z=B.filter(K=>!!K.basenames);if(z.length<2)return B;const W=z.reduce((K,Y)=>{const le=Y.basenames;return le?K.concat(le):K},[]);let J;if(x){J=[];for(let K=0,Y=W.length;K<Y;K++)J.push(x)}else J=z.reduce((K,Y)=>{const le=Y.patterns;return le?K.concat(le):K},[]);const se=function(K,Y){if(typeof K!="string")return null;if(!Y){let fe;for(fe=K.length;fe>0;fe--){const Se=K.charCodeAt(fe-1);if(Se===47||Se===92)break}Y=K.substr(fe)}const le=W.indexOf(Y);return le!==-1?J[le]:null};se.basenames=W,se.patterns=J,se.allBasenames=W;const ie=B.filter(K=>!K.basenames);return ie.push(se),ie}}),define(pe[80],ve([0,1,29,10,9,12,23,8,2]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(i,n,u){if(typeof i=="string"&&(i=C.URI.file(i)),u){const d=u.getWorkspaceFolder(i);if(d){const h=u.getWorkspace().folders.length>1;let w;if((0,T.isEqual)(d.uri,i)?w="":w=(0,T.relativePath)(d.uri,i),h){const v=d.name?d.name:(0,T.basename)(d.uri);w=w?v+" \u2022 "+w:v}return w}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(i.fsPath))return(0,I.normalize)(y(i.fsPath));let c=(0,I.normalize)(i.fsPath);return!D.isWindows&&n?.userHome&&(c=b(c,n.userHome.fsPath)),c}e.getPathLabel=A;function R(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const n=(0,T.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,f.isRootOrDriveLetter)(n)?y(n):n}e.getBaseLabel=R;function y(i,n){return(0,f.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=y;let l=Object.create(null);function b(i,n){if(D.isWindows||!i||!n)return i;let u=l.original===n?l.normalized:void 0;return u||(u=`${(0,P.rtrim)(n,I.posix.sep)}${I.posix.sep}`,l={original:n,normalized:u}),(D.isLinux?i.startsWith(u):(0,P.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=b;function p(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=p;const g="\u2026",E="\\\\",L="~";function _(i,n=I.sep){const u=new Array(i.length);let c=!1;for(let d=0;d<i.length;d++){let h=i[d];if(h===""){u[d]=`.${n}`;continue}if(!h){u[d]=h;continue}c=!0;let w="";h.indexOf(E)===0?(w=h.substr(0,h.indexOf(E)+E.length),h=h.substr(h.indexOf(E)+E.length)):h.indexOf(n)===0?(w=h.substr(0,h.indexOf(n)+n.length),h=h.substr(h.indexOf(n)+n.length)):h.indexOf(L)===0&&(w=h.substr(0,h.indexOf(L)+L.length),h=h.substr(h.indexOf(L)+L.length));const v=h.split(n);for(let k=1;c&&k<=v.length;k++)for(let O=v.length-k;c&&O>=0;O--){c=!1;let U=v.slice(O,O+k).join(n);for(let F=0;!c&&F<i.length;F++)if(F!==d&&i[F]&&i[F].indexOf(U)>-1){const M=O+k===v.length,V=O>0&&i[F].indexOf(n)>-1?n+U:U,$=i[F].endsWith(V);c=!M||$}if(!c){let F="";(v[0].endsWith(":")||w!=="")&&(O===1&&(O=0,k++,U=v[0]+n+U),O>0&&(F=v[0]+n),F=w+F),O>0&&(F=F+g+n),F=F+U,O+k<v.length&&(F=F+n+g),u[d]=F}}c&&(u[d]=h)}return u}e.shorten=_;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function s(i,n=Object.create(null)){const u=[];let c=!1,d="";for(const h of i)if(h==="$"||c&&h==="{")d&&u.push({value:d,type:a.TEXT}),d="",c=!0;else if(h==="}"&&c){const w=n[d];if(typeof w=="string")w.length&&u.push({value:w,type:a.VARIABLE});else if(w){const v=u[u.length-1];(!v||v.type!==a.SEPARATOR)&&u.push({value:w.label,type:a.SEPARATOR})}d="",c=!1}else d+=h;return d&&!c&&u.push({value:d,type:a.TEXT}),u.filter((h,w)=>{if(h.type===a.SEPARATOR){const v=u[w-1],k=u[w+1];return[v,k].every(O=>O&&(O.type===a.VARIABLE||O.type===a.TEXT)&&O.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=s;function m(i,n){return D.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function o(i,n){return D.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function S(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=S;function r(i){const n=i.indexOf("/")!==-1?I.posix:I.win32,u=n.basename(i),c=n.dirname(i);return u.length?{name:u,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(pe[103],ve([0,1,2]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class I{constructor(y){this._uriTransformer=y}transformIncoming(y){const l=this._uriTransformer.transformIncoming(y);return l===y?y:t(f.URI.from(l))}transformOutgoing(y){const l=this._uriTransformer.transformOutgoing(y);return l===y?y:t(f.URI.from(l))}transformOutgoingURI(y){const l=this._uriTransformer.transformOutgoing(y);return l===y?y:f.URI.from(l)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function D(R,y,l){if(!R||l>200)return null;if(typeof R=="object"){if(R instanceof f.URI)return y.transformOutgoing(R);for(let b in R)if(Object.hasOwnProperty.call(R,b)){const p=D(R[b],y,l+1);p!==null&&(R[b]=p)}}return null}function T(R,y){const l=D(R,y,0);return l===null?R:l}e.transformOutgoingURIs=T;function P(R,y,l,b){if(!R||b>200)return null;if(typeof R=="object"){if(R.$mid===1)return l?f.URI.revive(y.transformIncoming(R)):y.transformIncoming(R);for(let p in R)if(Object.hasOwnProperty.call(R,p)){const g=P(R[p],y,l,b+1);g!==null&&(R[p]=g)}}return null}function C(R,y){const l=P(R,y,!1,0);return l===null?R:l}e.transformIncomingURIs=C;function A(R,y){const l=P(R,y,!0,0);return l===null?R:l}e.transformAndReviveIncomingURIs=A}),define(pe[33],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return f.test(C)}e.isUUID=t;const I=new Uint8Array(16),D=[];for(let C=0;C<256;C++)D.push(C.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(C){for(let A=0;A<C.length;A++)C[A]=Math.floor(Math.random()*256);return C};function P(){T(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let C=0,A="";return A+=D[I[C++]],A+=D[I[C++]],A+=D[I[C++]],A+=D[I[C++]],A+="-",A+=D[I[C++]],A+=D[I[C++]],A+="-",A+=D[I[C++]],A+=D[I[C++]],A+="-",A+=D[I[C++]],A+=D[I[C++]],A+="-",A+=D[I[C++]],A+=D[I[C++]],A+=D[I[C++]],A+=D[I[C++]],A+=D[I[C++]],A+=D[I[C++]],A}e.generateUuid=P}),define(pe[143],ve([0,1,104]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(D="utf8"){this.stringDecoder=new f.StringDecoder(D),this.remaining=null}write(D){const T=[],P=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(P.length<1)return T;let C=0,A,R=C;for(;R<P.length;)if(A=P.charCodeAt(R),A===13||A===10){if(T.push(P.substring(C,R)),R++,R<P.length){const y=A;A=P.charCodeAt(R),(y===13&&A===10||y===10&&A===13)&&R++}C=R}else R++;return this.remaining=C<P.length?P.substr(C):null,T}end(){return this.remaining}}e.LineDecoder=t}),define(pe[30],ve([0,1,60,81,291,17,29,79,9,12,23,2]),function(Z,e,f,t,I,D,T,P,C,A,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var l;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(l=e.RimRafMode||(e.RimRafMode={}));async function b(M,V=l.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return V===l.UNLINK?g(M):p(M)}async function p(M){try{const V=(0,T.randomPath)((0,t.tmpdir)());try{await f.promises.rename(M,V)}catch{return g(M)}g(V).catch($=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function g(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function E(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");f.rmdirSync(M,{recursive:!0})}e.rimrafSync=E;async function L(M,V){return s(await(V?_(M):(0,I.promisify)(f.readdir)(M)))}async function _(M){try{return await(0,I.promisify)(f.readdir)(M,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const V=[],$=await L(M);for(const N of $){let B=!1,x=!1,z=!1;try{const W=await e.Promises.lstat((0,C.join)(M,N));B=W.isFile(),x=W.isDirectory(),z=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}V.push({name:N,isFile:()=>B,isDirectory:()=>x,isSymbolicLink:()=>z})}return V}function a(M){return s(f.readdirSync(M))}e.readdirSync=a;function s(M){return M.map(V=>typeof V=="string"?A.isMacintosh?(0,P.normalizeNFC)(V):V:(V.name=A.isMacintosh?(0,P.normalizeNFC)(V.name):V.name,V))}async function m(M){const V=await L(M),$=[];for(const N of V)await S.existsDirectory((0,C.join)(M,N))&&$.push(N);return $}function o(M,V=1e3){return new Promise($=>{let N=!1;const B=setInterval(()=>{N||(N=!0,f.access(M,x=>{N=!1,x&&(clearInterval(B),$(void 0))}))},V)})}e.whenDeleted=o;var S;(function(M){async function V(B){let x;try{if(x=await e.Promises.lstat(B),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(A.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw W}throw z}}M.stat=V;async function $(B){try{const{stat:x,symbolicLink:z}=await M.stat(B);return x.isFile()&&z?.dangling!==!0}catch{}return!1}M.existsFile=$;async function N(B){try{const{stat:x,symbolicLink:z}=await M.stat(B);return x.isDirectory()&&z?.dangling!==!0}catch{}return!1}M.existsDirectory=N})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new D.ResourceQueue;function i(M,V,$){return r.queueFor(y.URI.file(M),R.extUriBiasedIgnorePathCase).queue(()=>{const N=d($);return new Promise((B,x)=>u(M,V,N,z=>z?x(z):B()))})}let n=!0;function u(M,V,$,N){if(!n)return f.writeFile(M,V,{mode:$.mode,flag:$.flag},N);f.open(M,$.flag,$.mode,(B,x)=>{if(B)return N(B);f.writeFile(x,V,z=>{if(z)return f.close(x,()=>N(z));f.fdatasync(x,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),n=!1),f.close(x,J=>N(J))))})})}function c(M,V,$){const N=d($);if(!n)return f.writeFileSync(M,V,{mode:N.mode,flag:N.flag});const B=f.openSync(M,N.flag,N.mode);try{f.writeFileSync(B,V);try{f.fdatasyncSync(B)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),n=!1}}finally{f.closeSync(B)}}e.writeFileSync=c;function d(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function h(M,V){if(M===V)return;async function $(N){try{const B=await e.Promises.lstat(N);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(N,B.atime,new Date)}catch{}}try{await e.Promises.rename(M,V),await $(V)}catch(N){if(M.toLowerCase()!==V.toLowerCase()&&N.code==="EXDEV"||M.endsWith("."))await w(M,V,{preserveSymlinks:!1}),await b(M,l.MOVE),await $(V);else throw N}}async function w(M,V,$){return k(M,V,{root:{source:M,target:V},options:$,handledSourcePaths:new Set})}const v=511;async function k(M,V,$){if($.handledSourcePaths.has(M))return;$.handledSourcePaths.add(M);const{stat:N,symbolicLink:B}=await S.stat(M);if(B){if($.options.preserveSymlinks)try{return await F(M,V,$)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(B.dangling)return}return N.isDirectory()?O(M,V,N.mode&v,$):U(M,V,N.mode&v)}async function O(M,V,$,N){await e.Promises.mkdir(V,{recursive:!0,mode:$});const B=await L(M);for(const x of B)await k((0,C.join)(M,x),(0,C.join)(V,x),N)}async function U(M,V,$){await e.Promises.copyFile(M,V),await e.Promises.chmod(V,$)}async function F(M,V,$){let N=await e.Promises.readlink(M);(0,T.isEqualOrParent)(N,$.root.source,!A.isLinux)&&(N=(0,C.join)($.root.target,N.substr($.root.source.length+1))),await e.Promises.symlink(N,V)}e.Promises=new class{get access(){return(0,I.promisify)(f.access)}get stat(){return(0,I.promisify)(f.stat)}get lstat(){return(0,I.promisify)(f.lstat)}get utimes(){return(0,I.promisify)(f.utimes)}get read(){return(M,V,$,N,B)=>new Promise((x,z)=>{f.read(M,V,$,N,B,(W,J,se)=>W?z(W):x({bytesRead:J,buffer:se}))})}get readFile(){return(0,I.promisify)(f.readFile)}get write(){return(M,V,$,N,B)=>new Promise((x,z)=>{f.write(M,V,$,N,B,(W,J,se)=>W?z(W):x({bytesWritten:J,buffer:se}))})}get appendFile(){return(0,I.promisify)(f.appendFile)}get fdatasync(){return(0,I.promisify)(f.fdatasync)}get truncate(){return(0,I.promisify)(f.truncate)}get rename(){return(0,I.promisify)(f.rename)}get copyFile(){return(0,I.promisify)(f.copyFile)}get open(){return(0,I.promisify)(f.open)}get close(){return(0,I.promisify)(f.close)}get symlink(){return(0,I.promisify)(f.symlink)}get readlink(){return(0,I.promisify)(f.readlink)}get chmod(){return(0,I.promisify)(f.chmod)}get mkdir(){return(0,I.promisify)(f.mkdir)}get unlink(){return(0,I.promisify)(f.unlink)}get rmdir(){return(0,I.promisify)(f.rmdir)}get realpath(){return(0,I.promisify)(f.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return L}get readDirsInDir(){return m}get writeFile(){return i}get rm(){return b}get move(){return h}get copy(){return w}}}),define(pe[105],ve([0,1,60,9,12,8,30]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(l){if(I.isLinux)return l;const b=(0,t.dirname)(l);if(l===b)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const E=(0,T.readdirSync)(b).filter(L=>L.toLowerCase()===p);if(E.length===1){const L=P(b);if(L)return(0,t.join)(L,E[0])}else if(E.length>1){const L=E.indexOf(p);if(L>=0){const _=P(b);if(_)return(0,t.join)(_,E[L])}}}catch{}return null}e.realcaseSync=P;async function C(l){if(I.isLinux)return l;const b=(0,t.dirname)(l);if(l===b)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const E=(await T.Promises.readdir(b)).filter(L=>L.toLowerCase()===p);if(E.length===1){const L=await C(b);if(L)return(0,t.join)(L,E[0])}else if(E.length>1){const L=E.indexOf(p);if(L>=0){const _=await C(b);if(_)return(0,t.join)(_,E[L])}}}catch{}return null}e.realcase=C;async function A(l){try{return await T.Promises.realpath(l)}catch{const p=y(l);return await T.Promises.access(p,f.constants.R_OK),p}}e.realpath=A;function R(l){try{return f.realpathSync(l)}catch{const p=y(l);return f.accessSync(p,f.constants.R_OK),p}}e.realpathSync=R;function y(l){return(0,D.rtrim)((0,t.normalize)(l),t.sep)}});var je=this&&this.__decorate||function(Z,e,f,t){var I=arguments.length,D=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,f):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(Z,e,f,t);else for(var P=Z.length-1;P>=0;P--)(T=Z[P])&&(D=(I<3?T(D):I>3?T(e,f,D):T(e,f))||D);return I>3&&D&&Object.defineProperty(e,f,D),D};define(pe[106],ve([0,1,16,17,22,21,56,15,3,6,59,8,13]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function p(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var L;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(L||(L={}));class _{constructor(z){this.buffer=z,this.pos=0}read(z){const W=this.buffer.slice(this.pos,this.pos+z);return this.pos+=W.byteLength,W}}class a{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var s;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(s||(s={}));function m(x){const z=I.VSBuffer.alloc(4);return z.writeUInt32BE(x,0),z}function o(x){return x.read(4).readUInt32BE(0)}function S(x){const z=I.VSBuffer.alloc(1);return z.writeUInt8(x,0),z}const r={Undefined:S(s.Undefined),String:S(s.String),Buffer:S(s.Buffer),VSBuffer:S(s.VSBuffer),Array:S(s.Array),Object:S(s.Object)},i=typeof Buffer!="undefined";function n(x,z){if(typeof z=="undefined")x.write(r.Undefined);else if(typeof z=="string"){const W=I.VSBuffer.fromString(z);x.write(r.String),x.write(m(W.byteLength)),x.write(W)}else if(i&&Buffer.isBuffer(z)){const W=I.VSBuffer.wrap(z);x.write(r.Buffer),x.write(m(W.byteLength)),x.write(W)}else if(z instanceof I.VSBuffer)x.write(r.VSBuffer),x.write(m(z.byteLength)),x.write(z);else if(Array.isArray(z)){x.write(r.Array),x.write(m(z.length));for(const W of z)n(x,W)}else{const W=I.VSBuffer.fromString(JSON.stringify(z));x.write(r.Object),x.write(m(W.byteLength)),x.write(W)}}function u(x){switch(x.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return x.read(o(x)).toString();case s.Buffer:return x.read(o(x)).buffer;case s.VSBuffer:return x.read(o(x));case s.Array:{const W=o(x),J=[];for(let se=0;se<W;se++)J.push(u(x));return J}case s.Object:return JSON.parse(x.read(o(x)).toString())}}class c{constructor(z,W,J=null,se=1e3){this.protocol=z,this.ctx=W,this.logger=J,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ie=>this.onRawMessage(ie)),this.sendResponse({type:200})}registerChannel(z,W){this.channels.set(z,W),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const W=this.send([z.type]);this.logger&&this.logger.logOutgoing(W,0,1,E(z.type));return}case 201:case 202:case 204:case 203:{const W=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(W,z.id,1,E(z.type),z.data);return}}}send(z,W=void 0){const J=new a;return n(J,z),n(J,W),this.sendBuffer(J.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const W=new _(z),J=u(W),se=u(W),ie=J[0];switch(ie){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],1,`${p(ie)}: ${J[2]}.${J[3]}`,se),this.onPromise({type:ie,id:J[1],channelName:J[2],name:J[3],arg:se});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],1,`${p(ie)}: ${J[2]}.${J[3]}`,se),this.onEventListen({type:ie,id:J[1],channelName:J[2],name:J[3],arg:se});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],1,`${p(ie)}`),this.disposeActiveRequest({type:ie,id:J[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],1,`${p(ie)}`),this.disposeActiveRequest({type:ie,id:J[1]})}}onPromise(z){const W=this.channels.get(z.channelName);if(!W){this.collectPendingRequest(z);return}const J=new D.CancellationTokenSource;let se;try{se=W.call(this.ctx,z.name,z.arg,J.token)}catch(Y){se=Promise.reject(Y)}const ie=z.id;se.then(Y=>{this.sendResponse({id:ie,data:Y,type:201}),this.activeRequests.delete(z.id)},Y=>{Y instanceof Error?this.sendResponse({id:ie,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ie,data:Y,type:203}),this.activeRequests.delete(z.id)});const K=(0,A.toDisposable)(()=>J.cancel());this.activeRequests.set(z.id,K)}onEventListen(z){const W=this.channels.get(z.channelName);if(!W){this.collectPendingRequest(z);return}const J=z.id,ie=W.listen(this.ctx,z.name,z.arg)(K=>this.sendResponse({id:J,data:K,type:204}));this.activeRequests.set(z.id,ie)}disposeActiveRequest(z){const W=this.activeRequests.get(z.id);W&&(W.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let W=this.pendingRequests.get(z.channelName);W||(W=[],this.pendingRequests.set(z.channelName,W));const J=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:z,timeoutTimer:J})}flushPendingRequests(z){const W=this.pendingRequests.get(z);if(W){for(const J of W)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var d;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(z,W=null){this.protocol=z,this.isDisposed=!1,this.state=L.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=W}getChannel(z){const W=this;return{call(J,se,ie){return W.isDisposed?Promise.reject(P.canceled()):W.requestPromise(z,J,se,ie)},listen(J,se){return W.isDisposed?Promise.reject(P.canceled()):W.requestEvent(z,J,se)}}}requestPromise(z,W,J,se=D.CancellationToken.None){const ie=this.lastRequestId++,Y={id:ie,type:100,channelName:z,name:W,arg:J};if(se.isCancellationRequested)return Promise.reject(P.canceled());let le;return new Promise((Se,Me)=>{if(se.isCancellationRequested)return Me(P.canceled());const Ve=()=>{const te=G=>{switch(G.type){case 201:this.handlers.delete(ie),Se(G.data);break;case 202:{this.handlers.delete(ie);const Q=new Error(G.data.message);Q.stack=G.data.stack,Q.name=G.data.name,Me(Q);break}case 203:this.handlers.delete(ie),Me(G.data);break}};this.handlers.set(ie,te),this.sendRequest(Y)};let Ge=null;this.state===L.Idle?Ve():(Ge=(0,t.createCancelablePromise)(te=>this.whenInitialized()),Ge.then(()=>{Ge=null,Ve()}));const Ye=()=>{Ge?(Ge.cancel(),Ge=null):this.sendRequest({id:ie,type:101}),Me(P.canceled())},q=se.onCancellationRequested(Ye);le=(0,A.combinedDisposable)((0,A.toDisposable)(Ye),q),this.activeRequests.add(le)}).finally(()=>{this.activeRequests.delete(le)})}requestEvent(z,W,J){const se=this.lastRequestId++,K={id:se,type:102,channelName:z,name:W,arg:J};let Y=null;const le=new C.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(Se=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(le),this.sendRequest(K)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(le),this.sendRequest({id:se,type:103}))}}),fe=Se=>le.fire(Se.data);return this.handlers.set(se,fe),le.event}sendRequest(z){switch(z.type){case 100:case 102:{const W=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(W,z.id,0,`${p(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const W=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(W,z.id,0,p(z.type));return}}}send(z,W=void 0){const J=new a;return n(J,z),n(J,W),this.sendBuffer(J.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const W=new _(z),J=u(W),se=u(W),ie=J[0];switch(ie){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,E(ie)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,J[1],0,E(ie),se),this.onResponse({type:J[0],id:J[1],data:se})}}onResponse(z){if(z.type===200){this.state=L.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(z.id);W&&W(z)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===L.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}je([T.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class w{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:W,onDidClientDisconnect:J})=>{C.Event.once(W.onMessage)(ie=>{const K=new _(ie),Y=u(K),le=new c(W,Y),fe=new h(W);this.channels.forEach((Me,Ve)=>le.registerChannel(Ve,Me));const Se={channelServer:le,channelClient:fe,ctx:Y};this._connections.add(Se),this._onDidAddConnection.fire(Se),J(()=>{le.dispose(),fe.dispose(),this._connections.delete(Se),this._onDidRemoveConnection.fire(Se)})})})}get connections(){const z=[];return this._connections.forEach(W=>z.push(W)),z}getChannel(z,W){const J=this;return{call(se,ie,K){let Y;if((0,l.isFunction)(W)){let fe=(0,f.getRandomElement)(J.connections.filter(W));Y=fe?Promise.resolve(fe):C.Event.toPromise(C.Event.filter(J.onDidAddConnection,W))}else Y=W.routeCall(J,se,ie);const le=Y.then(fe=>fe.channelClient.getChannel(z));return k(le).call(se,ie,K)},listen(se,ie){if((0,l.isFunction)(W))return J.getMulticastEvent(z,W,se,ie);const K=W.routeEvent(J,se,ie).then(Y=>Y.channelClient.getChannel(z));return k(K).listen(se,ie)}}}getMulticastEvent(z,W,J,se){const ie=this;let K=new A.DisposableStore;const Y=new C.Emitter({onFirstListenerAdd:()=>{K=new A.DisposableStore;const le=new C.EventMultiplexer,fe=new Map,Se=Ve=>{const Ye=Ve.channelClient.getChannel(z).listen(J,se),q=le.add(Ye);fe.set(Ve,q)},Me=Ve=>{const Ge=fe.get(Ve);!Ge||(Ge.dispose(),fe.delete(Ve))};ie.connections.filter(W).forEach(Se),C.Event.filter(ie.onDidAddConnection,W)(Se,void 0,K),ie.onDidRemoveConnection(Me,void 0,K),le.event(Y.fire,Y,K),K.add(le)},onLastListenerRemove:()=>{K.dispose()}});return Y.event}registerChannel(z,W){this.channels.set(z,W),this._connections.forEach(J=>{J.channelServer.registerChannel(z,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class v{constructor(z,W,J=null){const se=new a;n(se,W),z.send(se.buffer),this.channelClient=new h(z,J),this.channelServer=new c(z,W,J)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,W){this.channelServer.registerChannel(z,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=v;function k(x){return{call(z,W,J){return x.then(se=>se.call(z,W,J))},listen(z,W){const J=new C.Relay;return x.then(se=>J.input=se.listen(z,W)),J.event}}}e.getDelayedChannel=k;function O(x){let z=!1;return{call(W,J,se){return z?x.call(W,J,se):(0,t.timeout)(0).then(()=>z=!0).then(()=>x.call(W,J,se))},listen(W,J){if(z)return x.listen(W,J);const se=new C.Relay;return(0,t.timeout)(0).then(()=>z=!0).then(()=>se.input=x.listen(W,J)),se.event}}}e.getNextTickChannel=O;class U{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const W of z.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await C.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=U;var F;(function(x){function z(ie,K){const Y=ie,le=K&&K.disableMarshalling,fe=new Map;for(const Se in Y)J(Se)&&fe.set(Se,C.Event.buffer(Y[Se],!0));return new class{listen(Se,Me,Ve){const Ge=fe.get(Me);if(Ge)return Ge;if(se(Me)){const Ye=Y[Me];if(typeof Ye=="function")return Ye.call(Y,Ve)}throw new Error(`Event not found: ${Me}`)}call(Se,Me,Ve){const Ge=Y[Me];if(typeof Ge=="function"){if(!le&&Array.isArray(Ve))for(let Ye=0;Ye<Ve.length;Ye++)Ve[Ye]=(0,R.revive)(Ve[Ye]);return Ge.apply(Y,Ve)}throw new Error(`Method not found: ${Me}`)}}}x.fromService=z;function W(ie,K){const Y=K&&K.disableMarshalling;return new Proxy({},{get(le,fe){if(typeof fe=="string")return K?.properties?.has(fe)?K.properties.get(fe):se(fe)?function(Se){return ie.listen(fe,Se)}:J(fe)?ie.listen(fe):async function(...Se){let Me;K&&!(0,l.isUndefinedOrNull)(K.context)?Me=[K.context,...Se]:Me=Se;const Ve=await ie.call(fe,Me);return Y?Ve:(0,R.revive)(Ve)};throw new Error(`Property not found: ${String(fe)}`)}})}x.toService=W;function J(ie){return ie[0]==="o"&&ie[1]==="n"&&y.isUpperAsciiLetter(ie.charCodeAt(2))}function se(ie){return/^onDynamic/.test(ie)&&y.isUpperAsciiLetter(ie.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let z=x.toString();if(z!=="[object Object]")return z}return x}function $(x){return Array.isArray(x)?x.map(V):V(x)}function N(x,z,W,J,se,ie,K){K=$(K);const Y=M[se],le=Y[J%Y.length];let fe=[`%c[${x}]%c[${String(z).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${le}`];/\($/.test(ie)?(fe=fe.concat(K),fe.push(")")):fe.push(K),console.log.apply(console,fe)}e.logWithColors=N;class B{constructor(z,W){this._outgoingPrefix=z,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,W,J,se,ie){this._totalOutgoing+=z,N(this._outgoingPrefix,this._totalOutgoing,z,W,J,se,ie)}logIncoming(z,W,J,se,ie){this._totalIncoming+=z,N(this._incomingPrefix,this._totalIncoming,z,W,J,se,ie)}}e.IPCLogger=B}),define(pe[107],ve([0,1,22,3,6,106]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let u=0;function c(h,w){if(!n.has(h)){const v=String(++u);n.set(h,v)}return n.get(h)}function d(h,w,v,k){if(!i.enableDiagnostics)return;const O=c(h,w);if(k instanceof f.VSBuffer||k instanceof Uint8Array||k instanceof ArrayBuffer||ArrayBuffer.isView(k)){const U=f.VSBuffer.alloc(k.byteLength);U.set(k),i.records.push({timestamp:Date.now(),id:O,label:w,type:v,buff:U})}else i.records.push({timestamp:Date.now(),id:O,label:w,type:v,data:k})}i.traceSocketEvent=d})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function R(){return A||(A=f.VSBuffer.alloc(0)),A}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,u){if(n===0)return R();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const w=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=n),w}if(this._chunks[0].byteLength>n){const w=this._chunks[0].slice(0,n);return u&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),w}let c=f.VSBuffer.alloc(n),d=0,h=0;for(;n>0;){const w=this._chunks[h];if(w.byteLength>n){const v=w.slice(0,n);c.set(v,d),d+=n,u&&(this._chunks[h]=w.slice(n),this._totalLength-=n),n-=n}else c.set(w,d),d+=w.byteLength,u?(this._chunks.shift(),this._totalLength-=w.byteLength):h++,n-=w.byteLength}return c}}e.ChunkStream=y;var l;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(l||(l={}));function b(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(n,u,c,d){this.type=n,this.id=u,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends I.Disposable{constructor(n){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,d=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new g(c,d,h,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class L{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=f.VSBuffer.alloc(13);u.writeUInt8(n.type,0),u.writeUInt32BE(n.id,1),u.writeUInt32BE(n.ack,5),u.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(u,n.data)}_bufferAdd(n,u){const c=this._totalLength===0;return this._data.push(n,u),this._totalLength+=n.byteLength+u.byteLength,c}_bufferTake(){const n=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,u){this._bufferAdd(n,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class _ extends I.Disposable{constructor(n){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new L(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new g(1,0,0,n))}}e.Protocol=_;class a extends D.IPCClient{constructor(n,u,c=null){super(n,u,c);this.protocol=n}static fromSocket(n,u){return new a(new _(n),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=a;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class m{constructor(n){this.data=n,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],u=0,c=this._first;for(;c;)n[u++]=c.data,c=c.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const u=new m(n);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class S{constructor(){this.lastRuns=[];const n=Date.now();for(let u=0;u<S._HISTORY_LENGTH;u++)this.lastRuns[u]=n-1e3*u;setInterval(()=>{for(let u=S._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const n=Date.now(),u=(1+S._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<S._HISTORY_LENGTH;d++)n-this.lastRuns[d]<=u&&c++;return 1-c/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class r{constructor(n,u=null,c=S.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new L(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new g(5,0,0,R());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new g(7,0,0,R());this._socketWriter.write(n)}sendResume(){const n=new g(8,0,0,R());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,u){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new L(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,R());this._socketWriter.write(n);const u=this._outgoingUnackMsg.toArray();for(let c=0,d=u.length;c<d;c++)this._socketWriter.write(u[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new g(6,0,0,R())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let c=0,d=u.length;c<d;c++)this._socketWriter.write(u[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new g(1,u,this._incomingAckId,n);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(n){const u=new g(2,0,0,n);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),u=Date.now()-n.writtenTime,c=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&c>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-u,2e4-c,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,R());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(pe[108],ve([0,1,100]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(P){const C=(0,f.toUint8)(P);this._defaultValue=C,this._asciiMap=t._createAsciiMap(C),this._map=new Map}static _createAsciiMap(P){const C=new Uint8Array(256);for(let A=0;A<256;A++)C[A]=P;return C}set(P,C){const A=(0,f.toUint8)(C);P>=0&&P<256?this._asciiMap[P]=A:this._map.set(P,A)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(I||(I={}));class D{constructor(){this._actual=new t(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=D}),define(pe[144],ve([0,1,108]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends f.CharacterClassifier{constructor(P){super(0);for(let C=0,A=P.length;C<A;C++)this.set(P.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function D(T){const P={};return C=>(P.hasOwnProperty(C)||(P[C]=T(C)),P[C])}e.getMapForWordSeparators=D(T=>new I(T))}),define(pe[48],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(I,D){this.lineNumber=I,this.column=D}with(I=this.lineNumber,D=this.column){return I===this.lineNumber&&D===this.column?this:new f(I,D)}delta(I=0,D=0){return this.with(this.lineNumber+I,this.column+D)}equals(I){return f.equals(this,I)}static equals(I,D){return!I&&!D?!0:!!I&&!!D&&I.lineNumber===D.lineNumber&&I.column===D.column}isBefore(I){return f.isBefore(this,I)}static isBefore(I,D){return I.lineNumber<D.lineNumber?!0:D.lineNumber<I.lineNumber?!1:I.column<D.column}isBeforeOrEqual(I){return f.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,D){return I.lineNumber<D.lineNumber?!0:D.lineNumber<I.lineNumber?!1:I.column<=D.column}static compare(I,D){const T=I.lineNumber|0,P=D.lineNumber|0;if(T===P){const C=I.column|0,A=D.column|0;return C-A}return T-P}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new f(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=f}),define(pe[41],ve([0,1,48]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(D,T,P,C){D>P||D===P&&T>C?(this.startLineNumber=P,this.startColumn=C,this.endLineNumber=D,this.endColumn=T):(this.startLineNumber=D,this.startColumn=T,this.endLineNumber=P,this.endColumn=C)}isEmpty(){return t.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return t.containsPosition(this,D)}static containsPosition(D,T){return!(T.lineNumber<D.startLineNumber||T.lineNumber>D.endLineNumber||T.lineNumber===D.startLineNumber&&T.column<D.startColumn||T.lineNumber===D.endLineNumber&&T.column>D.endColumn)}static strictContainsPosition(D,T){return!(T.lineNumber<D.startLineNumber||T.lineNumber>D.endLineNumber||T.lineNumber===D.startLineNumber&&T.column<=D.startColumn||T.lineNumber===D.endLineNumber&&T.column>=D.endColumn)}containsRange(D){return t.containsRange(this,D)}static containsRange(D,T){return!(T.startLineNumber<D.startLineNumber||T.endLineNumber<D.startLineNumber||T.startLineNumber>D.endLineNumber||T.endLineNumber>D.endLineNumber||T.startLineNumber===D.startLineNumber&&T.startColumn<D.startColumn||T.endLineNumber===D.endLineNumber&&T.endColumn>D.endColumn)}strictContainsRange(D){return t.strictContainsRange(this,D)}static strictContainsRange(D,T){return!(T.startLineNumber<D.startLineNumber||T.endLineNumber<D.startLineNumber||T.startLineNumber>D.endLineNumber||T.endLineNumber>D.endLineNumber||T.startLineNumber===D.startLineNumber&&T.startColumn<=D.startColumn||T.endLineNumber===D.endLineNumber&&T.endColumn>=D.endColumn)}plusRange(D){return t.plusRange(this,D)}static plusRange(D,T){let P,C,A,R;return T.startLineNumber<D.startLineNumber?(P=T.startLineNumber,C=T.startColumn):T.startLineNumber===D.startLineNumber?(P=T.startLineNumber,C=Math.min(T.startColumn,D.startColumn)):(P=D.startLineNumber,C=D.startColumn),T.endLineNumber>D.endLineNumber?(A=T.endLineNumber,R=T.endColumn):T.endLineNumber===D.endLineNumber?(A=T.endLineNumber,R=Math.max(T.endColumn,D.endColumn)):(A=D.endLineNumber,R=D.endColumn),new t(P,C,A,R)}intersectRanges(D){return t.intersectRanges(this,D)}static intersectRanges(D,T){let P=D.startLineNumber,C=D.startColumn,A=D.endLineNumber,R=D.endColumn,y=T.startLineNumber,l=T.startColumn,b=T.endLineNumber,p=T.endColumn;return P<y?(P=y,C=l):P===y&&(C=Math.max(C,l)),A>b?(A=b,R=p):A===b&&(R=Math.min(R,p)),P>A||P===A&&C>R?null:new t(P,C,A,R)}equalsRange(D){return t.equalsRange(this,D)}static equalsRange(D,T){return!!D&&!!T&&D.startLineNumber===T.startLineNumber&&D.startColumn===T.startColumn&&D.endLineNumber===T.endLineNumber&&D.endColumn===T.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(D){return new f.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(D){return new f.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,T){return new t(this.startLineNumber,this.startColumn,D,T)}setStartPosition(D,T){return new t(D,T,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(D){return new t(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}static fromPositions(D,T=D){return new t(D.lineNumber,D.column,T.lineNumber,T.column)}static lift(D){return D?new t(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,T){return!(D.endLineNumber<T.startLineNumber||D.endLineNumber===T.startLineNumber&&D.endColumn<T.startColumn||T.endLineNumber<D.startLineNumber||T.endLineNumber===D.startLineNumber&&T.endColumn<D.startColumn)}static areIntersecting(D,T){return!(D.endLineNumber<T.startLineNumber||D.endLineNumber===T.startLineNumber&&D.endColumn<=T.startColumn||T.endLineNumber<D.startLineNumber||T.endLineNumber===D.startLineNumber&&T.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,T){if(D&&T){const A=D.startLineNumber|0,R=T.startLineNumber|0;if(A===R){const y=D.startColumn|0,l=T.startColumn|0;if(y===l){const b=D.endLineNumber|0,p=T.endLineNumber|0;if(b===p){const g=D.endColumn|0,E=T.endColumn|0;return g-E}return b-p}return y-l}return A-R}return(D?1:0)-(T?1:0)}static compareRangesUsingEnds(D,T){return D.endLineNumber===T.endLineNumber?D.endColumn===T.endColumn?D.startLineNumber===T.startLineNumber?D.startColumn-T.startColumn:D.startLineNumber-T.startLineNumber:D.endColumn-T.endColumn:D.endLineNumber-T.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}}e.Range=t}),define(pe[145],ve([0,1,48,41]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class D extends t.Range{constructor(P,C,A,R){super(P,C,A,R);this.selectionStartLineNumber=P,this.selectionStartColumn=C,this.positionLineNumber=A,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return D.selectionsEqual(this,P)}static selectionsEqual(P,C){return P.selectionStartLineNumber===C.selectionStartLineNumber&&P.selectionStartColumn===C.selectionStartColumn&&P.positionLineNumber===C.positionLineNumber&&P.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,C){return this.getDirection()===0?new D(this.startLineNumber,this.startColumn,P,C):new D(P,C,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new f.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,C){return this.getDirection()===0?new D(P,C,this.endLineNumber,this.endColumn):new D(this.endLineNumber,this.endColumn,P,C)}static fromPositions(P,C=P){return new D(P.lineNumber,P.column,C.lineNumber,C.column)}static fromRange(P,C){return C===0?new D(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new D(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new D(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,C){if(P&&!C||!P&&C)return!1;if(!P&&!C)return!0;if(P.length!==C.length)return!1;for(let A=0,R=P.length;A<R;A++)if(!this.selectionsEqual(P[A],C[A]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,C,A,R,y){return y===0?new D(P,C,A,R):new D(A,R,P,C)}}e.Selection=D}),define(pe[146],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class t{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let C=0,A=P.notIn.length;C<A;C++)switch(P.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,C){if(P.getTokenCount()===0)return!0;const A=P.findTokenIndexAtOffset(C-2),R=P.getStandardTokenType(A);return this.isOK(R)}_findNeutralCharacterInRange(P,C){for(let A=P;A<=C;A++){const R=String.fromCharCode(A);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of P)D(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),D(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),D(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),D(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&D(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=I;function D(T,P,C){T.has(P)?T.get(P).push(C):T.set(P,[C])}}),define(pe[82],ve([0,1,32,9]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(D,T,P,C){if(Array.isArray(D)){let A=0;for(const R of D){const y=I(R,T,P,C);if(y===10)return y;y>A&&(A=y)}return A}else{if(typeof D=="string")return C?D==="*"?5:D===P?10:0:0;if(D){const{language:A,pattern:R,scheme:y,hasAccessToAllModels:l}=D;if(!C&&!l)return 0;let b=0;if(y)if(y===T.scheme)b=10;else if(y==="*")b=5;else return 0;if(A)if(A===P)b=10;else if(A==="*")b=Math.max(b,5);else return 0;if(R){let p;if(typeof R=="string"?p=R:p={...R,base:(0,t.normalize)(R.base)},p===T.fsPath||(0,f.match)(p,T.fsPath))b=10;else return 0}return b}else return 0}}e.score=I}),define(pe[147],ve([0,1,108]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(p,g,E){const L=new Uint8Array(p*g);for(let _=0,a=p*g;_<a;_++)L[_]=E;this._data=L,this.rows=p,this.cols=g}get(p,g){return this._data[p*this.cols+g]}set(p,g,E){this._data[p*this.cols+g]=E}}e.Uint8Matrix=I;class D{constructor(p){let g=0,E=0;for(let _=0,a=p.length;_<a;_++){const[s,m,o]=p[_];m>g&&(g=m),s>E&&(E=s),o>E&&(E=o)}g++,E++;const L=new I(E,g,0);for(let _=0,a=p.length;_<a;_++){const[s,m,o]=p[_];L.set(s,m,o)}this._states=L,this._maxCharCode=g}nextState(p,g){return g<0||g>=this._maxCharCode?0:this._states.get(p,g)}}e.StateMachine=D;let T=null;function P(){return T===null&&(T=new D([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var C;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(C||(C={}));let A=null;function R(){if(A===null){A=new f.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<b.length;g++)A.set(b.charCodeAt(g),1);const p=".,;";for(let g=0;g<p.length;g++)A.set(p.charCodeAt(g),2)}return A}class y{static _createLink(p,g,E,L,_){let a=_-1;do{const s=g.charCodeAt(a);if(p.get(s)!==2)break;a--}while(a>L);if(L>0){const s=g.charCodeAt(L-1),m=g.charCodeAt(a);(s===40&&m===41||s===91&&m===93||s===123&&m===125)&&a--}return{range:{startLineNumber:E,startColumn:L+1,endLineNumber:E,endColumn:a+2},url:g.substring(L,a+1)}}static computeLinks(p,g=P()){const E=R(),L=[];for(let _=1,a=p.getLineCount();_<=a;_++){const s=p.getLineContent(_),m=s.length;let o=0,S=0,r=0,i=1,n=!1,u=!1,c=!1,d=!1;for(;o<m;){let h=!1;const w=s.charCodeAt(o);if(i===13){let v;switch(w){case 40:n=!0,v=0;break;case 41:v=n?0:1;break;case 91:c=!0,u=!0,v=0;break;case 93:c=!1,v=u?0:1;break;case 123:d=!0,v=0;break;case 125:v=d?0:1;break;case 39:v=r===34||r===96?0:1;break;case 34:v=r===39||r===96?0:1;break;case 96:v=r===39||r===34?0:1;break;case 42:v=r===42?1:0;break;case 124:v=r===124?1:0;break;case 32:v=c?0:1;break;default:v=E.get(w)}v===1&&(L.push(y._createLink(E,s,_,S,o)),h=!0)}else if(i===12){let v;w===91?(u=!0,v=0):v=E.get(w),v===1?h=!0:i=13}else i=g.nextState(i,w),i===0&&(h=!0);h&&(i=1,n=!1,u=!1,d=!1,S=o+1,r=w),o++}i===13&&L.push(y._createLink(E,s,_,S,m))}return L}}e.LinkComputer=y;function l(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:y.computeLinks(b)}e.computeLinks=l}),define(pe[148],ve([0,1,3,6]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,C){return this._map.set(P,C),this.fire([P]),(0,t.toDisposable)(()=>{this._map.get(P)===C&&(this._map.delete(P),this.fire([P]))})}registerFactory(P,C){this._factories.get(P)?.dispose();const A=new D(this,P,C);return this._factories.set(P,A),(0,t.toDisposable)(()=>{const R=this._factories.get(P);!R||R!==A||(this._factories.delete(P),R.dispose())})}async getOrCreate(P){const C=this.get(P);if(C)return C;const A=this._factories.get(P);return!A||A.isResolved?null:(await A.resolve(),this.get(P))}get(P){return this._map.get(P)||null}isResolved(P){if(this.get(P))return!0;const A=this._factories.get(P);return!!(!A||A.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class D extends t.Disposable{constructor(P,C,A){super();this._registry=P,this._languageId=C,this._factory=A,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(pe[109],ve([0,1,25]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(E){E[E.Both=0]="Both",E[E.Right=1]="Right",E[E.Left=2]="Left",E[E.None=3]="None"})(D=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var T;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class A{constructor(L){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,L.tabSize|0),this.indentSize=L.tabSize|0,this.insertSpaces=Boolean(L.insertSpaces),this.defaultEOL=L.defaultEOL|0,this.trimAutoWhitespace=Boolean(L.trimAutoWhitespace),this.bracketPairColorizationOptions=L.bracketPairColorizationOptions}equals(L){return this.tabSize===L.tabSize&&this.indentSize===L.indentSize&&this.insertSpaces===L.insertSpaces&&this.defaultEOL===L.defaultEOL&&this.trimAutoWhitespace===L.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,L.bracketPairColorizationOptions)}createChangeEvent(L){return{tabSize:this.tabSize!==L.tabSize,indentSize:this.indentSize!==L.indentSize,insertSpaces:this.insertSpaces!==L.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==L.trimAutoWhitespace}}}e.TextModelResolvedOptions=A;class R{constructor(L,_){this._findMatchBrand=void 0,this.range=L,this.matches=_}}e.FindMatch=R;var y;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var l;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None"})(l=e.PositionAffinity||(e.PositionAffinity={}));var b;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b=e.ModelConstants||(e.ModelConstants={}));class p{constructor(L,_,a,s,m,o){this.identifier=L,this.range=_,this.text=a,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=m,this._isTracked=o}}e.ValidAnnotatedEditOperation=p;class g{constructor(L,_,a){this.reverseEdits=L,this.changes=_,this.trimAutoWhitespaceLineNumbers=a}}e.ApplyEditsResult=g}),define(pe[149],ve([0,1,8,144,48,41,109]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class C{constructor(a,s,m,o){this.searchString=a,this.isRegex=s,this.matchCase=m,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=A(this.searchString):a=this.searchString.indexOf(`
`)>=0;let s=null;try{s=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!s)return null;let m=!this.isRegex&&!a;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new R(s,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=C;function A(_){if(!_||_.length===0)return!1;for(let a=0,s=_.length;a<s;a++)if(_.charCodeAt(a)===92){if(a++,a>=s)break;const o=_.charCodeAt(a);if(o===110||o===114||o===87)return!0}return!1}e.isMultilineRegexSource=A;class R{constructor(a,s,m){this.regex=a,this.wordSeparators=s,this.simpleSearch=m}}e.SearchData=R;function y(_,a,s){if(!s)return new T.FindMatch(_,null);const m=[];for(let o=0,S=a.length;o<S;o++)m[o]=a[o];return new T.FindMatch(_,m)}e.createFindMatch=y;class l{constructor(a){const s=[];let m=0;for(let o=0,S=a.length;o<S;o++)a.charCodeAt(o)===10&&(s[m++]=o);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(a){const s=this._lineFeedsOffsets;let m=0,o=s.length-1;if(o===-1||a<=s[0])return 0;for(;m<o;){const S=m+((o-m)/2>>0);s[S]>=a?o=S-1:s[S+1]>=a?(m=S,o=S):m=S+1}return m+1}}class b{static findMatches(a,s,m,o,S){const r=s.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,m,new L(r.wordSeparators,r.regex),o,S):this._doFindMatchesLineByLine(a,m,r,o,S):[]}static _getMultilineMatchRange(a,s,m,o,S,r){let i,n=0;o?(n=o.findLineFeedCountBeforeOffset(S),i=s+S+n):i=s+S;let u;if(o){const w=o.findLineFeedCountBeforeOffset(S+r.length)-n;u=i+r.length+w}else u=i+r.length;const c=a.getPositionAt(i),d=a.getPositionAt(u);return new D.Range(c.lineNumber,c.column,d.lineNumber,d.column)}static _doFindMatchesMultiline(a,s,m,o,S){const r=a.getOffsetAt(s.getStartPosition()),i=a.getValueInRange(s,1),n=a.getEOL()===`\r
`?new l(i):null,u=[];let c=0,d;for(m.reset(0);d=m.next(i);)if(u[c++]=y(this._getMultilineMatchRange(a,r,i,n,d.index,d[0]),d,o),c>=S)return u;return u}static _doFindMatchesLineByLine(a,s,m,o,S){const r=[];let i=0;if(s.startLineNumber===s.endLineNumber){const u=a.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return i=this._findMatchesInLine(m,u,s.startLineNumber,s.startColumn-1,i,r,o,S),r}const n=a.getLineContent(s.startLineNumber).substring(s.startColumn-1);i=this._findMatchesInLine(m,n,s.startLineNumber,s.startColumn-1,i,r,o,S);for(let u=s.startLineNumber+1;u<s.endLineNumber&&i<S;u++)i=this._findMatchesInLine(m,a.getLineContent(u),u,0,i,r,o,S);if(i<S){const u=a.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);i=this._findMatchesInLine(m,u,s.endLineNumber,0,i,r,o,S)}return r}static _findMatchesInLine(a,s,m,o,S,r,i,n){const u=a.wordSeparators;if(!i&&a.simpleSearch){const h=a.simpleSearch,w=h.length,v=s.length;let k=-w;for(;(k=s.indexOf(h,k+w))!==-1;)if((!u||E(u,s,v,k,w))&&(r[S++]=new T.FindMatch(new D.Range(m,k+1+o,m,k+1+w+o),null),S>=n))return S;return S}const c=new L(a.wordSeparators,a.regex);let d;c.reset(0);do if(d=c.next(s),d&&(r[S++]=y(new D.Range(m,d.index+1+o,m,d.index+1+d[0].length+o),d,i),S>=n))return S;while(d);return S}static findNextMatch(a,s,m,o){const S=s.parseSearchRequest();if(!S)return null;const r=new L(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(a,m,r,o):this._doFindNextMatchLineByLine(a,m,r,o)}static _doFindNextMatchMultiline(a,s,m,o){const S=new I.Position(s.lineNumber,1),r=a.getOffsetAt(S),i=a.getLineCount(),n=a.getValueInRange(new D.Range(S.lineNumber,S.column,i,a.getLineMaxColumn(i)),1),u=a.getEOL()===`\r
`?new l(n):null;m.reset(s.column-1);let c=m.next(n);return c?y(this._getMultilineMatchRange(a,r,n,u,c.index,c[0]),c,o):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(a,new I.Position(1,1),m,o):null}static _doFindNextMatchLineByLine(a,s,m,o){const S=a.getLineCount(),r=s.lineNumber,i=a.getLineContent(r),n=this._findFirstMatchInLine(m,i,r,s.column,o);if(n)return n;for(let u=1;u<=S;u++){const c=(r+u-1)%S,d=a.getLineContent(c+1),h=this._findFirstMatchInLine(m,d,c+1,1,o);if(h)return h}return null}static _findFirstMatchInLine(a,s,m,o,S){a.reset(o-1);const r=a.next(s);return r?y(new D.Range(m,r.index+1,m,r.index+1+r[0].length),r,S):null}static findPreviousMatch(a,s,m,o){const S=s.parseSearchRequest();if(!S)return null;const r=new L(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(a,m,r,o):this._doFindPreviousMatchLineByLine(a,m,r,o)}static _doFindPreviousMatchMultiline(a,s,m,o){const S=this._doFindMatchesMultiline(a,new D.Range(1,1,s.lineNumber,s.column),m,o,10*P);if(S.length>0)return S[S.length-1];const r=a.getLineCount();return s.lineNumber!==r||s.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new I.Position(r,a.getLineMaxColumn(r)),m,o):null}static _doFindPreviousMatchLineByLine(a,s,m,o){const S=a.getLineCount(),r=s.lineNumber,i=a.getLineContent(r).substring(0,s.column-1),n=this._findLastMatchInLine(m,i,r,o);if(n)return n;for(let u=1;u<=S;u++){const c=(S+r-u-1)%S,d=a.getLineContent(c+1),h=this._findLastMatchInLine(m,d,c+1,o);if(h)return h}return null}static _findLastMatchInLine(a,s,m,o){let S=null,r;for(a.reset(0);r=a.next(s);)S=y(new D.Range(m,r.index+1,m,r.index+1+r[0].length),r,o);return S}}e.TextModelSearch=b;function p(_,a,s,m,o){if(m===0)return!0;const S=a.charCodeAt(m-1);if(_.get(S)!==0||S===13||S===10)return!0;if(o>0){const r=a.charCodeAt(m);if(_.get(r)!==0)return!0}return!1}function g(_,a,s,m,o){if(m+o===s)return!0;const S=a.charCodeAt(m+o);if(_.get(S)!==0||S===13||S===10)return!0;if(o>0){const r=a.charCodeAt(m+o-1);if(_.get(r)!==0)return!0}return!1}function E(_,a,s,m,o){return p(_,a,s,m,o)&&g(_,a,s,m,o)}e.isValidMatch=E;class L{constructor(a,s){this._wordSeparators=a,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const s=a.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(m=this._searchRegex.exec(a),!m))return null;const o=m.index,S=m[0].length;if(o===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){f.getNextCodePoint(a,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=S,!this._wordSeparators||E(this._wordSeparators,a,s,o,S))return m}while(m);return null}}e.Searcher=L}),define(pe[110],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(P=""){let C="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)P.indexOf(A)>=0||(C+="\\"+A);return C+="\\s]+)",new RegExp(C,"g")}e.DEFAULT_WORD_REGEXP=f();function t(P){let C=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)C=P;else{let A="g";P.ignoreCase&&(A+="i"),P.multiline&&(A+="m"),P.unicode&&(A+="u"),C=new RegExp(P.source,A)}return C.lastIndex=0,C}e.ensureValidWordDefinition=t;const I={maxLen:1e3,windowSize:15,timeBudget:150};function D(P,C,A,R,y=I){if(A.length>y.maxLen){let E=P-y.maxLen/2;return E<0?E=0:R+=E,A=A.substring(E,P+y.maxLen/2),D(P,C,A,R,y)}const l=Date.now(),b=P-1-R;let p=-1,g=null;for(let E=1;!(Date.now()-l>=y.timeBudget);E++){const L=b-y.windowSize*E;C.lastIndex=Math.max(0,L);const _=T(C,A,b,p);if(!_&&g||(g=_,L<=0))break;p=L}if(g){const E={word:g[0],startColumn:R+1+g.index,endColumn:R+1+g.index+g[0].length};return C.lastIndex=0,E}return null}e.getWordAtText=D;function T(P,C,A,R){let y;for(;y=P.exec(C);){const l=y.index||0;if(l<=A&&P.lastIndex>=A)return y;if(R>0&&l>R)return null}return null}}),define(pe[111],ve([0,1,22,12]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(I||(I={}));function D(y){for(let l=0,b=y.length;l<b;l+=4){const p=y[l+0],g=y[l+1],E=y[l+2],L=y[l+3];y[l+0]=L,y[l+1]=E,y[l+2]=g,y[l+3]=p}}function T(y){const l=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return t.isLittleEndian()||D(l),f.VSBuffer.wrap(l)}function P(y){const l=y.buffer;if(t.isLittleEndian()||D(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function C(y){const l=new Uint32Array(A(y));let b=0;if(l[b++]=y.id,y.type==="full")l[b++]=1,l[b++]=y.data.length,l.set(y.data,b),b+=y.data.length;else{l[b++]=2,l[b++]=y.deltas.length;for(const p of y.deltas)l[b++]=p.start,l[b++]=p.deleteCount,p.data?(l[b++]=p.data.length,l.set(p.data,b),b+=p.data.length):l[b++]=0}return T(l)}e.encodeSemanticTokensDto=C;function A(y){let l=0;if(l+=1+1,y.type==="full")l+=1+y.data.length;else{l+=1,l+=(1+1+1)*y.deltas.length;for(const b of y.deltas)b.data&&(l+=b.data.length)}return l}function R(y){const l=P(y);let b=0;const p=l[b++];if(l[b++]===1){const _=l[b++],a=l.subarray(b,b+_);return b+=_,{id:p,type:"full",data:a}}const E=l[b++],L=[];for(let _=0;_<E;_++){const a=l[b++],s=l[b++],m=l[b++];let o;m>0&&(o=l.subarray(b,b+m),b+=m),L[_]={start:a,deleteCount:s,data:o}}return{id:p,type:"delta",deltas:L}}e.decodeSemanticTokensDto=R}),define(pe[112],ve([0,1,16,100]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,A){C=(0,t.toUint32)(C);const R=this.values,y=this.prefixSum,l=A.length;return l===0?!1:(this.values=new Uint32Array(R.length+l),this.values.set(R.subarray(0,C),0),this.values.set(R.subarray(C),C+l),this.values.set(A,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(C,A){return C=(0,t.toUint32)(C),A=(0,t.toUint32)(A),this.values[C]===A?!1:(this.values[C]=A,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,A){C=(0,t.toUint32)(C),A=(0,t.toUint32)(A);const R=this.values,y=this.prefixSum;if(C>=R.length)return!1;const l=R.length-C;return A>=l&&(A=l),A===0?!1:(this.values=new Uint32Array(R.length-A),this.values.set(R.subarray(0,C),0),this.values.set(R.subarray(C+A),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(C){return C<0?0:(C=(0,t.toUint32)(C),this._getPrefixSum(C))}_getPrefixSum(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let A=this.prefixSumValidIndex[0]+1;A===0&&(this.prefixSum[0]=this.values[0],A++),C>=this.values.length&&(C=this.values.length-1);for(let R=A;R<=C;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalSum();let A=0,R=this.values.length-1,y=0,l=0,b=0;for(;A<=R;)if(y=A+(R-A)/2|0,l=this.prefixSum[y],b=l-this.values[y],C<b)R=y-1;else if(C>=l)A=y+1;else break;return new T(y,C-b)}}e.PrefixSumComputer=I;class D{constructor(C){this._values=C,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(C){return this._ensureValid(),C===0?0:this._prefixSum[C-1]}getIndexOf(C){this._ensureValid();const A=this._indexBySum[C],R=A>0?this._prefixSum[A-1]:0;return new T(A,C-R)}removeValues(C,A){this._values.splice(C,A),this._invalidate(C)}insertValues(C,A){this._values=(0,f.arrayInsert)(this._values,C,A),this._invalidate(C)}_invalidate(C){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,C-1)}_ensureValid(){if(!this._isValid){for(let C=this._validEndIndex+1,A=this._values.length;C<A;C++){const R=this._values[C],y=C>0?this._prefixSum[C-1]:0;this._prefixSum[C]=y+R;for(let l=0;l<R;l++)this._indexBySum[y+l]=C}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(C,A){this._values[C]!==A&&(this._values[C]=A,this._invalidate(C))}}e.ConstantTimePrefixSumComputer=D;class T{constructor(C,A){this.index=C,this.remainder=A,this._prefixSumIndexOfResultBrand=void 0,this.index=C,this.remainder=A}}e.PrefixSumIndexOfResult=T}),define(pe[150],ve([0,1,8,48,112]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class D{constructor(P,C,A,R){this._uri=P,this._lines=C,this._eol=A,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const C=P.changes;for(const A of C)this._acceptDeleteRange(A.range),this._acceptInsertText(new t.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,C=this._lines.length,A=new Uint32Array(C);for(let R=0;R<C;R++)A[R]=this._lines[R].length+P;this._lineStarts=new I.PrefixSumComputer(A)}}_setLineText(P,C){this._lines[P]=C,this._lineStarts&&this._lineStarts.setValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,C){if(C.length===0)return;const A=(0,f.splitLines)(C);if(A.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+A[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}A[A.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+A[0]);const R=new Uint32Array(A.length-1);for(let y=1;y<A.length;y++)this._lines.splice(P.lineNumber+y-1,0,A[y]),R[y-1]=A[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,R)}}e.MirrorTextModel=D}),define(pe[151],ve([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(pe[152],ve([0,1,151]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,D=I*24,T=D*7,P=D*30,C=D*365;function A(y,l,b){typeof y!="number"&&(y=y.getTime());const p=Math.round((new Date().getTime()-y)/1e3);if(p<-30)return(0,f.localize)(0,null,A(new Date().getTime()+p*1e3,!1));if(p<30)return(0,f.localize)(1,null);let g;return p<t?(g=p,l?g===1?b?(0,f.localize)(2,null,g):(0,f.localize)(3,null,g):b?(0,f.localize)(4,null,g):(0,f.localize)(5,null,g):g===1?b?(0,f.localize)(6,null,g):(0,f.localize)(7,null,g):b?(0,f.localize)(8,null,g):(0,f.localize)(9,null,g)):p<I?(g=Math.floor(p/t),l?g===1?b?(0,f.localize)(10,null,g):(0,f.localize)(11,null,g):b?(0,f.localize)(12,null,g):(0,f.localize)(13,null,g):g===1?b?(0,f.localize)(14,null,g):(0,f.localize)(15,null,g):b?(0,f.localize)(16,null,g):(0,f.localize)(17,null,g)):p<D?(g=Math.floor(p/I),l?g===1?b?(0,f.localize)(18,null,g):(0,f.localize)(19,null,g):b?(0,f.localize)(20,null,g):(0,f.localize)(21,null,g):g===1?b?(0,f.localize)(22,null,g):(0,f.localize)(23,null,g):b?(0,f.localize)(24,null,g):(0,f.localize)(25,null,g)):p<T?(g=Math.floor(p/D),l?g===1?(0,f.localize)(26,null,g):(0,f.localize)(27,null,g):g===1?(0,f.localize)(28,null,g):(0,f.localize)(29,null,g)):p<P?(g=Math.floor(p/T),l?g===1?b?(0,f.localize)(30,null,g):(0,f.localize)(31,null,g):b?(0,f.localize)(32,null,g):(0,f.localize)(33,null,g):g===1?b?(0,f.localize)(34,null,g):(0,f.localize)(35,null,g):b?(0,f.localize)(36,null,g):(0,f.localize)(37,null,g)):p<C?(g=Math.floor(p/P),l?g===1?b?(0,f.localize)(38,null,g):(0,f.localize)(39,null,g):b?(0,f.localize)(40,null,g):(0,f.localize)(41,null,g):g===1?b?(0,f.localize)(42,null,g):(0,f.localize)(43,null,g):b?(0,f.localize)(44,null,g):(0,f.localize)(45,null,g)):(g=Math.floor(p/C),l?g===1?b?(0,f.localize)(46,null,g):(0,f.localize)(47,null,g):b?(0,f.localize)(48,null,g):(0,f.localize)(49,null,g):g===1?b?(0,f.localize)(50,null,g):(0,f.localize)(51,null,g):b?(0,f.localize)(52,null,g):(0,f.localize)(53,null,g))}e.fromNow=A;function R(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(pe[153],ve([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(pe[49],ve([0,1,16,13,153]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(A,R){return R&&(A.stack||A.stacktrace)?I.localize(0,null,P(A),T(A.stack)||T(A.stacktrace)):P(A)}function T(A){return Array.isArray(A)?A.join(`
`):A}function P(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?I.localize(1,null,A.message):A.message||I.localize(2,null)}function C(A=null,R=!1){if(!A)return I.localize(3,null);if(Array.isArray(A)){const y=f.coalesce(A),l=C(y[0],R);return y.length>1?I.localize(4,null,l,y.length):l}if(t.isString(A))return A;if(A.detail){const y=A.detail;if(y.error)return D(y.error,R);if(y.exception)return D(y.exception,R)}return A.stack?D(A,R):A.message?A.message:I.localize(5,null)}e.toErrorMessage=C}),define(pe[154],ve([19,20]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(pe[113],ve([0,1,37,29,10,25,9,12,40,96,13,143,30,154]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function p(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(o,S){if(P.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};S&&(r.cwd=S);const i=f.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],r);return new Promise(n=>{i.once("error",u=>{n({success:!1,error:u})}),i.once("exit",(u,c)=>{n(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?p(r.status):1})}else if(P.isLinux||P.isMacintosh)try{const r=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(i=>{f.execFile(r,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,u,c)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function E(o){!o||(delete o.DEBUG,P.isMacintosh&&delete o.DYLD_LIBRARY_PATH,P.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function L(o=C.env){return o.comspec||"cmd.exe"}e.getWindowsShell=L;class _{constructor(S,r,i,n){if(r!==void 0&&i!==void 0&&n!==void 0)this.cmd=S,this.args=r,this.shell=i,this.options=n;else{const u=S;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(C.env).forEach(c=>{u[c]=C.env[c]}),Object.keys(this.options.env).forEach(c=>{u[c]=this.options.env[c]}),this.options.env=u}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const r=S.lastIndexOf(T.sep);return r!==-1&&(S=S.substring(r+1)),_.WellKnowCommands[S]?S:"other"}start(S){return P.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(C.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(r=>{let i,n;const u=new Promise((c,d)=>{i=c,n=d});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=f.exec(c,this.options,(d,h,w)=>{this.childProcess=null;const v=d;v&&v.killed?n({killed:this.terminateRequested,stdout:h.toString(),stderr:w.toString()}):this.handleExec(i,S,d,h,w)})}else{let c=null;const d=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,i,S,n);const w={terminated:this.terminateRequested};R.isNumber(h)&&(w.cmdCode=h),i(w)};if(this.shell&&P.isWindows){const h=D.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let w=!1,v=!1;const k=[];let O=this.ensureQuotes(this.cmd);k.push(O.value),w=O.quoted,this.args&&this.args.forEach(F=>{O=this.ensureQuotes(F),k.push(O.value),v=v&&O.quoted});const U=["/s","/c"];w?v?U.push('"'+k.join(" ")+'"'):k.length>1?U.push('"'+k[0]+'" '+k.slice(1).join(" ")):U.push('"'+k[0]+'"'):U.push(k.join(" ")),c=f.spawn(L(),U,h)}else this.cmd&&(c=f.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(R.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",h=>{this.childProcess=null,n({terminated:this.terminateRequested,error:h})}),c.pid&&(this.childProcess.on("close",d),this.handleSpawn(c,i,S,n,!0)))}return u})}handleClose(S,r,i,n){}ensureQuotes(S){return _.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,g(S,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!P.isWindows)return S(!1);const r=f.spawn(L(),["/s","/c"]);r.on("error",i=>S(!0)),r.on("exit",i=>S(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class a extends _{constructor(S,r,i,n){super(S,r,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,r,i,n,u){[n,u].forEach((c,d)=>{const h=new y.LineDecoder;h.write(c).forEach(k=>{r({line:k,source:d===0?0:1})});const v=h.end();v&&r({line:v,source:d===0?0:1})}),S({terminated:this.terminateRequested,error:i})}handleSpawn(S,r,i,n,u){const c=new y.LineDecoder,d=new y.LineDecoder;S.stdout.on("data",h=>{c.write(h).forEach(v=>i({line:v,source:0}))}),S.stderr.on("data",h=>{d.write(h).forEach(v=>i({line:v,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=d}handleClose(S,r,i,n){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&i({line:u,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&i({line:c,source:1})}}e.LineProcess=a;function s(o){let S=[],r=!1;const i=function(n){if(r){S.push(n);return}(!o.send(n,c=>{if(c&&console.error(c),r=!1,S.length>0){const d=S.slice(0);S=[],d.forEach(h=>i(h))}})||P.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=s;var m;(function(o){async function S(r,i,n){if(T.isAbsolute(r))return r;if(i===void 0&&(i=C.cwd()),T.dirname(r)!=="."||(n===void 0&&R.isString(C.env.PATH)&&(n=C.env.PATH.split(T.delimiter)),n===void 0||n.length===0))return T.join(i,r);async function c(d){if(await l.Promises.exists(d)){let h;try{h=await l.Promises.stat(d)}catch(w){w.message.startsWith("EACCES")&&(h=await l.Promises.lstat(d))}return h?!h.isDirectory():!1}return!1}for(let d of n){let h;if(T.isAbsolute(d)?h=T.join(d,r):h=T.join(i,d,r),await c(h))return h;let w=h+".com";if(await c(w)||(w=h+".exe",await c(w)))return w}return T.join(i,r)}o.findExecutable=S})(m=e.win32||(e.win32={}))}),define(pe[155],ve([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(pe[114],ve([0,1,155,12,110,16,25]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=C;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class R{constructor(ne,Ee,re,Ce){this.id=ne,this.name=Ee,this.defaultValue=re,this.schema=Ce}applyUpdate(ne,Ee){return l(ne,Ee)}compute(ne,Ee,re){return re}}class y{constructor(ne,Ee){this.newValue=ne,this.didChange=Ee}}e.ApplyUpdateResult=y;function l(ee,ne){if(typeof ee!="object"||typeof ne!="object"||!ee||!ne)return new y(ne,ee!==ne);if(Array.isArray(ee)||Array.isArray(ne)){const re=Array.isArray(ee)&&Array.isArray(ne)&&D.equals(ee,ne);return new y(ne,re)}let Ee=!1;for(const re in ne)if(ne.hasOwnProperty(re)){const Ce=l(ee[re],ne[re]);Ce.didChange&&(ee[re]=Ce.newValue,Ee=!0)}return new y(ee,Ee)}class b{constructor(ne){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0}applyUpdate(ne,Ee){return l(ne,Ee)}validate(ne){return this.defaultValue}}class p{constructor(ne,Ee,re,Ce){this.id=ne,this.name=Ee,this.defaultValue=re,this.schema=Ce}applyUpdate(ne,Ee){return l(ne,Ee)}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,Ee,re){return re}}function g(ee,ne){return typeof ee=="undefined"?ne:ee==="false"?!1:Boolean(ee)}e.boolean=g;class E extends p{constructor(ne,Ee,re,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="boolean",Ce.default=re);super(ne,Ee,re,Ce)}validate(ne){return g(ne,this.defaultValue)}}function L(ee,ne,Ee,re){if(typeof ee=="undefined")return ne;let Ce=parseInt(ee,10);return isNaN(Ce)?ne:(Ce=Math.max(Ee,Ce),Ce=Math.min(re,Ce),Ce|0)}e.clampedInt=L;class _ extends p{constructor(ne,Ee,re,Ce,Fe,qe=void 0){typeof qe!="undefined"&&(qe.type="integer",qe.default=re,qe.minimum=Ce,qe.maximum=Fe);super(ne,Ee,re,qe);this.minimum=Ce,this.maximum=Fe}static clampedInt(ne,Ee,re,Ce){return L(ne,Ee,re,Ce)}validate(ne){return _.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class a extends p{constructor(ne,Ee,re,Ce,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=re);super(ne,Ee,re,Fe);this.validationFn=Ce}static clamp(ne,Ee,re){return ne<Ee?Ee:ne>re?re:ne}static float(ne,Ee){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return Ee;const re=parseFloat(ne);return isNaN(re)?Ee:re}validate(ne){return this.validationFn(a.float(ne,this.defaultValue))}}class s extends p{static string(ne,Ee){return typeof ne!="string"?Ee:ne}constructor(ne,Ee,re,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.default=re);super(ne,Ee,re,Ce)}validate(ne){return s.string(ne,this.defaultValue)}}function m(ee,ne,Ee){return typeof ee!="string"||Ee.indexOf(ee)===-1?ne:ee}e.stringSet=m;class o extends p{constructor(ne,Ee,re,Ce,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=Ce,Fe.default=re);super(ne,Ee,re,Fe);this._allowedValues=Ce}validate(ne){return m(ne,this.defaultValue,this._allowedValues)}}class S extends R{constructor(ne,Ee,re,Ce,Fe,qe,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.enum=Fe,ze.default=Ce);super(ne,Ee,re,ze);this._allowedValues=Fe,this._convert=qe}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function r(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,Ee,re){return re===0?ne.accessibilitySupport:re}}class n extends R{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:f.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{insertSpace:g(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var u;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(u=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(ee){switch(ee){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function w(ee){switch(ee){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class v extends b{constructor(){super(128)}compute(ne,Ee,re){const Ce=["monaco-editor"];return Ee.get(33)&&Ce.push(Ee.get(33)),ne.extraEditorClassName&&Ce.push(ne.extraEditorClassName),Ee.get(66)==="default"?Ce.push("mouse-default"):Ee.get(66)==="copy"&&Ce.push("mouse-copy"),Ee.get(100)&&Ce.push("showUnused"),Ee.get(126)&&Ce.push("showDeprecated"),Ce.join(" ")}}class k extends E{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(ne,Ee,re){return re&&ne.emptySelectionClipboard}}class O extends R{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:f.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:f.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{cursorMoveOnType:g(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":m(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":m(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ee.loop,this.defaultValue.loop)}}}class U extends R{constructor(){super(45,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?U.OFF:ne==="true"?U.ON:ne:Boolean(ne)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class F extends b{constructor(){super(44)}compute(ne,Ee,re){return ne.fontInfo}}class M extends p{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(ne){const Ee=a.float(ne,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ee,6,100)}compute(ne,Ee,re){return ne.fontInfo.fontSize}}class V extends R{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(_.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class $ extends R{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:re,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:re,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:re,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:re,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:re,description:f.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{multiple:m(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??m(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??m(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??m(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??m(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??m(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class N extends R{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,minimum:0,maximum:1e4,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:f.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:f.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:g(Ee.enabled,this.defaultValue.enabled),delay:_.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:g(Ee.sticky,this.defaultValue.sticky),above:g(Ee.above,this.defaultValue.above)}}}var B;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class x extends b{constructor(){super(131)}compute(ne,Ee,re){return x.computeLayout(Ee,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const Ee=ne.height/ne.lineHeight,re=ne.scrollBeyondLastLine?Ee-1:0,Ce=(ne.viewLineCount+re)/(ne.pixelRatio*ne.height),Fe=Math.floor(ne.viewLineCount/Ce);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:re,desiredRatio:Ce,minimapLineCount:Fe}}static _computeMinimapLayout(ne,Ee){const re=ne.outerWidth,Ce=ne.outerHeight,Fe=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*Ce),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ce};const qe=Ee.stableMinimapLayoutInput,ze=qe&&ne.outerHeight===qe.outerHeight&&ne.lineHeight===qe.lineHeight&&ne.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&ne.pixelRatio===qe.pixelRatio&&ne.scrollBeyondLastLine===qe.scrollBeyondLastLine&&ne.minimap.enabled===qe.minimap.enabled&&ne.minimap.side===qe.minimap.side&&ne.minimap.size===qe.minimap.size&&ne.minimap.showSlider===qe.minimap.showSlider&&ne.minimap.renderCharacters===qe.minimap.renderCharacters&&ne.minimap.maxColumn===qe.minimap.maxColumn&&ne.minimap.scale===qe.minimap.scale&&ne.verticalScrollbarWidth===qe.verticalScrollbarWidth&&ne.isViewportWrapping===qe.isViewportWrapping,ut=ne.lineHeight,Re=ne.typicalHalfwidthCharacterWidth,Ae=ne.scrollBeyondLastLine,De=ne.minimap.renderCharacters;let ce=Fe>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const de=ne.minimap.maxColumn,we=ne.minimap.size,ye=ne.minimap.side,Oe=ne.verticalScrollbarWidth,Ke=ne.viewLineCount,We=ne.remainingWidth,Ze=ne.isViewportWrapping,lt=De?2:3;let ct=Math.floor(Fe*Ce);const $e=ct/Fe;let be=!1,_e=!1,he=lt*ce,X=ce/Fe,ke=1;if(we==="fill"||we==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:wt,desiredRatio:bt,minimapLineCount:Ut}=x.computeContainedMinimapLineCount({viewLineCount:Ke,scrollBeyondLastLine:Ae,height:Ce,lineHeight:ut,pixelRatio:Fe});if(Ke/Ut>1)be=!0,_e=!0,ce=1,he=1,X=ce/Fe;else{let Ft=!1,kt=ce+1;if(we==="fit"){const yt=Math.ceil((Ke+wt)*he);Ze&&ze&&We<=Ee.stableFitRemainingWidth?(Ft=!0,kt=Ee.stableFitMaxMinimapScale):Ft=yt>ct}if(we==="fill"||Ft){be=!0;const yt=ce;he=Math.min(ut*Fe,Math.max(1,Math.floor(1/bt))),Ze&&ze&&We<=Ee.stableFitRemainingWidth&&(kt=Ee.stableFitMaxMinimapScale),ce=Math.min(kt,Math.max(1,Math.floor(he/lt))),ce>yt&&(ke=Math.min(2,ce/yt)),X=ce/Fe/ke,ct=Math.ceil(Math.max(ft,Ke+wt)*he),Ze?(Ee.stableMinimapLayoutInput=ne,Ee.stableFitRemainingWidth=We,Ee.stableFitMaxMinimapScale=ce):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Be=Math.floor(de*X),Je=Math.min(Be,Math.max(0,Math.floor((We-Oe-2)*X/(Re+X)))+e.MINIMAP_GUTTER_WIDTH);let Qe=Math.floor(Fe*Je);const pt=Qe/Fe;Qe=Math.floor(Qe*ke);const St=De?1:2,Ct=ye==="left"?0:re-Je-Oe;return{renderMinimap:St,minimapLeft:Ct,minimapWidth:Je,minimapHeightIsEditorHeight:be,minimapIsSampling:_e,minimapScale:ce,minimapLineHeight:he,minimapCanvasInnerWidth:Qe,minimapCanvasInnerHeight:ct,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:$e}}static computeLayout(ne,Ee){const re=Ee.outerWidth|0,Ce=Ee.outerHeight|0,Fe=Ee.lineHeight|0,qe=Ee.lineNumbersDigitCount|0,ze=Ee.typicalHalfwidthCharacterWidth,ut=Ee.maxDigitWidth,Re=Ee.pixelRatio,Ae=Ee.viewLineCount,De=ne.get(123),ce=De==="inherit"?ne.get(122):De,de=ce==="inherit"?ne.get(118):ce,we=ne.get(121),ye=ne.get(2),Oe=Ee.isDominatedByLongLines,Ke=ne.get(50),We=ne.get(60).renderType!==0,Ze=ne.get(61),lt=ne.get(94),ct=ne.get(65),$e=ne.get(92),be=$e.verticalScrollbarSize,_e=$e.verticalHasArrows,he=$e.arrowSize,X=$e.horizontalScrollbarSize,ke=ne.get(58),Be=ne.get(37);let Je;if(typeof ke=="string"&&/^\d+(\.\d+)?ch$/.test(ke)){const Et=parseFloat(ke.substr(0,ke.length-2));Je=_.clampedInt(Et*ze,0,0,1e3)}else Je=_.clampedInt(ke,0,0,1e3);Be&&(Je+=16);let Qe=0;if(We){const Et=Math.max(qe,Ze);Qe=Math.round(Et*ut)}let pt=0;Ke&&(pt=Fe);let St=0,Ct=St+pt,ft=Ct+Qe,wt=ft+Je;const bt=re-pt-Qe-Je;let Ut=!1,Pt=!1,Ft=-1;ye!==2&&(ce==="inherit"&&Oe?(Ut=!0,Pt=!0):de==="on"||de==="bounded"?Pt=!0:de==="wordWrapColumn"&&(Ft=we));const kt=x._computeMinimapLayout({outerWidth:re,outerHeight:Ce,lineHeight:Fe,typicalHalfwidthCharacterWidth:ze,pixelRatio:Re,scrollBeyondLastLine:lt,minimap:ct,verticalScrollbarWidth:be,viewLineCount:Ae,remainingWidth:bt,isViewportWrapping:Pt},Ee.memory||new A);kt.renderMinimap!==0&&kt.minimapLeft===0&&(St+=kt.minimapWidth,Ct+=kt.minimapWidth,ft+=kt.minimapWidth,wt+=kt.minimapWidth);const yt=bt-kt.minimapWidth,Qt=Math.max(1,Math.floor((yt-be-2)/ze)),Vt=_e?he:0;return Pt&&(Ft=Math.max(1,Qt),de==="bounded"&&(Ft=Math.min(Ft,we))),{width:re,height:Ce,glyphMarginLeft:St,glyphMarginWidth:pt,lineNumbersLeft:Ct,lineNumbersWidth:Qe,decorationsLeft:ft,decorationsWidth:Je,contentLeft:wt,contentWidth:yt,minimap:kt,viewportColumn:Qt,isWordWrapMinified:Ut,isViewportWrapping:Pt,wrappingColumn:Ft,verticalScrollbarWidth:be,horizontalScrollbarHeight:X,overviewRuler:{top:Vt,width:be,height:Ce-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=x;class z extends R{constructor(){const ne={enabled:!0};super(57,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:f.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:g(ne.enabled,this.defaultValue.enabled)}}}class W extends R{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:f.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:f.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:f.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:g(Ee.enabled,this.defaultValue.enabled),fontSize:_.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class J extends a{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>a.clamp(ne,0,150),{markdownDescription:f.localize(47,null)})}compute(ne,Ee,re){return ne.fontInfo.lineHeight}}class se extends R{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:f.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(49,null),f.localize(50,null),f.localize(51,null)],default:ne.size,description:f.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:f.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:f.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:f.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:f.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:g(Ee.enabled,this.defaultValue.enabled),size:m(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(Ee.side,this.defaultValue.side,["right","left"]),showSlider:m(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:_.clampedInt(Ee.scale,1,1,3),maxColumn:_.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ie(ee){return ee==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class K extends R{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{top:_.clampedInt(Ee.top,0,0,1e3),bottom:_.clampedInt(Ee.bottom,0,0,1e3)}}}class Y extends R{constructor(){const ne={enabled:!0,cycle:!1};super(76,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:f.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:f.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:g(Ee.enabled,this.defaultValue.enabled),cycle:g(Ee.cycle,this.defaultValue.cycle)}}}class le extends b{constructor(){super(129)}compute(ne,Ee,re){return ne.pixelRatio}}class fe extends R{constructor(){const ne={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:f.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:f.localize(63,null)},other:{type:"boolean",default:ne.other,description:f.localize(64,null)}}}],default:ne,description:f.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const Ee=ne,re={other:g(Ee.other,this.defaultValue.other),comments:g(Ee.comments,this.defaultValue.comments),strings:g(Ee.strings,this.defaultValue.strings)};return re.other&&re.comments&&re.strings?!0:!re.other&&!re.comments&&!re.strings?!1:re}return this.defaultValue}}var Se;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends R{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(66,null),f.localize(67,null),f.localize(68,null),f.localize(69,null)],default:"on",description:f.localize(70,null)})}validate(ne){let Ee=this.defaultValue.renderType,re=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(Ee=4,re=ne):ne==="interval"?Ee=3:ne==="relative"?Ee=2:ne==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:re}}}function Ve(ee){const ne=ee.get(87);return ne==="editable"?ee.get(81):ne!=="on"}e.filterValidationDecorations=Ve;class Ge extends R{constructor(){const ne=[],Ee={type:"number",description:f.localize(71,null)};super(91,"rulers",ne,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:f.localize(72,null),format:"color-hex"}}}]},default:ne,description:f.localize(73,null)})}validate(ne){if(Array.isArray(ne)){const Ee=[];for(let re of ne)if(typeof re=="number")Ee.push({column:_.clampedInt(re,0,0,1e4),color:null});else if(re&&typeof re=="object"){const Ce=re;Ee.push({column:_.clampedInt(Ce.column,0,0,1e4),color:Ce.color})}return Ee.sort((re,Ce)=>re.column-Ce.column),Ee}return this.defaultValue}}function Ye(ee,ne){if(typeof ee!="string")return ne;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends R{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(74,null),f.localize(75,null),f.localize(76,null)],default:"auto",description:f.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)],default:"auto",description:f.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:f.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:f.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne,re=_.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ce=_.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:_.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ye(Ee.vertical,this.defaultValue.vertical),horizontal:Ye(Ee.horizontal,this.defaultValue.horizontal),useShadows:g(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:re,horizontalSliderSize:_.clampedInt(Ee.horizontalSliderSize,re,0,1e3),verticalScrollbarSize:Ce,verticalSliderSize:_.clampedInt(Ee.verticalSliderSize,Ce,0,1e3),scrollByPage:g(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class te extends R{constructor(){const ne={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",ne,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.nonBasicASCII,description:f.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ne.invisibleCharacters,description:f.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ne.ambiguousCharacters,description:f.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeComments,description:f.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeStrings,description:f.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ne.allowedCharacters,description:f.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ne.allowedLocales,description:f.localize(91,null)}})}applyUpdate(ne,Ee){let re=!1;Ee.allowedCharacters&&(T.equals(ne.allowedCharacters,Ee.allowedCharacters)||(ne={...ne,allowedCharacters:Ee.allowedCharacters},re=!0)),Ee.allowedLocales&&(T.equals(ne.allowedLocales,Ee.allowedLocales)||(ne={...ne,allowedLocales:Ee.allowedLocales},re=!0));const Ce=super.applyUpdate(ne,Ee);return re?new y(Ce.newValue,!0):Ce}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{nonBasicASCII:me(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ne.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ne.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ne,Ee){if(typeof ne!="object"||!ne)return Ee;const re={};for(const[Ce,Fe]of Object.entries(ne))Fe===!0&&(re[Ce]=!0);return re}}class G extends R{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:f.localize(92,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:g(Ee.enabled,this.defaultValue.enabled),mode:m(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends R{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:f.localize(93,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:g(ne.enabled,this.defaultValue.enabled)}}}class oe extends R{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(94,null),f.localize(95,null),f.localize(96,null)],default:ne.bracketPairs,description:f.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(98,null),f.localize(99,null),f.localize(100,null)],default:ne.bracketPairsHorizontal,description:f.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:f.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:f.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:f.localize(104,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{bracketPairs:me(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:g(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function me(ee,ne,Ee){const re=Ee.indexOf(ee);return re===-1?ne:Ee[re]}class Ie extends R{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(105,null),f.localize(106,null)],default:ne.insertMode,description:f.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:f.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:f.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:f.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:f.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:f.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:f.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:f.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:f.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(146,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{insertMode:m(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ee.preview,this.defaultValue.preview),previewMode:m(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ee.showMethods,this.defaultValue.showMethods),showFunctions:g(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:g(Ee.showFields,this.defaultValue.showFields),showVariables:g(Ee.showVariables,this.defaultValue.showVariables),showClasses:g(Ee.showClasses,this.defaultValue.showClasses),showStructs:g(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ee.showModules,this.defaultValue.showModules),showProperties:g(Ee.showProperties,this.defaultValue.showProperties),showEvents:g(Ee.showEvents,this.defaultValue.showEvents),showOperators:g(Ee.showOperators,this.defaultValue.showOperators),showUnits:g(Ee.showUnits,this.defaultValue.showUnits),showValues:g(Ee.showValues,this.defaultValue.showValues),showConstants:g(Ee.showConstants,this.defaultValue.showConstants),showEnums:g(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ee.showKeywords,this.defaultValue.showKeywords),showWords:g(Ee.showWords,this.defaultValue.showWords),showColors:g(Ee.showColors,this.defaultValue.showColors),showFiles:g(Ee.showFiles,this.defaultValue.showFiles),showReferences:g(Ee.showReferences,this.defaultValue.showReferences),showFolders:g(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ee.showUsers,this.defaultValue.showUsers),showIssues:g(Ee.showIssues,this.defaultValue.showIssues)}}}class xe extends R{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(147,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Xe extends b{constructor(){super(130)}compute(ne,Ee,re){return Ee.get(81)?!0:ne.tabFocusMode}}var it;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(it=e.WrappingIndent||(e.WrappingIndent={}));function st(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ot extends b{constructor(){super(132)}compute(ne,Ee,re){const Ce=Ee.get(131);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:Ce.isWordWrapMinified,isViewportWrapping:Ce.isViewportWrapping,wrappingColumn:Ce.wrappingColumn}}}const tt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?rt:t.isLinux?gt:tt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ne(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var It;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=41]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=43]="fontFamily",ee[ee.fontInfo=44]="fontInfo",ee[ee.fontLigatures=45]="fontLigatures",ee[ee.fontSize=46]="fontSize",ee[ee.fontWeight=47]="fontWeight",ee[ee.formatOnPaste=48]="formatOnPaste",ee[ee.formatOnType=49]="formatOnType",ee[ee.glyphMargin=50]="glyphMargin",ee[ee.gotoLocation=51]="gotoLocation",ee[ee.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ee[ee.hover=53]="hover",ee[ee.inDiffEditor=54]="inDiffEditor",ee[ee.inlineSuggest=55]="inlineSuggest",ee[ee.letterSpacing=56]="letterSpacing",ee[ee.lightbulb=57]="lightbulb",ee[ee.lineDecorationsWidth=58]="lineDecorationsWidth",ee[ee.lineHeight=59]="lineHeight",ee[ee.lineNumbers=60]="lineNumbers",ee[ee.lineNumbersMinChars=61]="lineNumbersMinChars",ee[ee.linkedEditing=62]="linkedEditing",ee[ee.links=63]="links",ee[ee.matchBrackets=64]="matchBrackets",ee[ee.minimap=65]="minimap",ee[ee.mouseStyle=66]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=68]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=70]="multiCursorModifier",ee[ee.multiCursorPaste=71]="multiCursorPaste",ee[ee.occurrencesHighlight=72]="occurrencesHighlight",ee[ee.overviewRulerBorder=73]="overviewRulerBorder",ee[ee.overviewRulerLanes=74]="overviewRulerLanes",ee[ee.padding=75]="padding",ee[ee.parameterHints=76]="parameterHints",ee[ee.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=79]="quickSuggestions",ee[ee.quickSuggestionsDelay=80]="quickSuggestionsDelay",ee[ee.readOnly=81]="readOnly",ee[ee.renameOnType=82]="renameOnType",ee[ee.renderControlCharacters=83]="renderControlCharacters",ee[ee.renderFinalNewline=84]="renderFinalNewline",ee[ee.renderLineHighlight=85]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=87]="renderValidationDecorations",ee[ee.renderWhitespace=88]="renderWhitespace",ee[ee.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ee[ee.roundedSelection=90]="roundedSelection",ee[ee.rulers=91]="rulers",ee[ee.scrollbar=92]="scrollbar",ee[ee.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=94]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=95]="scrollPredominantAxis",ee[ee.selectionClipboard=96]="selectionClipboard",ee[ee.selectionHighlight=97]="selectionHighlight",ee[ee.selectOnLineNumbers=98]="selectOnLineNumbers",ee[ee.showFoldingControls=99]="showFoldingControls",ee[ee.showUnused=100]="showUnused",ee[ee.snippetSuggestions=101]="snippetSuggestions",ee[ee.smartSelect=102]="smartSelect",ee[ee.smoothScrolling=103]="smoothScrolling",ee[ee.stickyTabStops=104]="stickyTabStops",ee[ee.stopRenderingLineAfter=105]="stopRenderingLineAfter",ee[ee.suggest=106]="suggest",ee[ee.suggestFontSize=107]="suggestFontSize",ee[ee.suggestLineHeight=108]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ee[ee.suggestSelection=110]="suggestSelection",ee[ee.tabCompletion=111]="tabCompletion",ee[ee.tabIndex=112]="tabIndex",ee[ee.unicodeHighlighting=113]="unicodeHighlighting",ee[ee.unusualLineTerminators=114]="unusualLineTerminators",ee[ee.useShadowDOM=115]="useShadowDOM",ee[ee.useTabStops=116]="useTabStops",ee[ee.wordSeparators=117]="wordSeparators",ee[ee.wordWrap=118]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=121]="wordWrapColumn",ee[ee.wordWrapOverride1=122]="wordWrapOverride1",ee[ee.wordWrapOverride2=123]="wordWrapOverride2",ee[ee.wrappingIndent=124]="wrappingIndent",ee[ee.wrappingStrategy=125]="wrappingStrategy",ee[ee.showDeprecated=126]="showDeprecated",ee[ee.inlayHints=127]="inlayHints",ee[ee.editorClassName=128]="editorClassName",ee[ee.pixelRatio=129]="pixelRatio",ee[ee.tabFocusMode=130]="tabFocusMode",ee[ee.layoutInfo=131]="layoutInfo",ee[ee.wrappingInfo=132]="wrappingInfo"})(It=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new E(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(148,null)})),acceptSuggestionOnEnter:Ne(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(149,null),""],markdownDescription:f.localize(150,null)})),accessibilitySupport:Ne(new i),accessibilityPageSize:Ne(new _(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(151,null)})),ariaLabel:Ne(new s(4,"ariaLabel",f.localize(152,null))),autoClosingBrackets:Ne(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(153,null),f.localize(154,null),""],description:f.localize(155,null)})),autoClosingDelete:Ne(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(156,null),""],description:f.localize(157,null)})),autoClosingOvertype:Ne(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(158,null),""],description:f.localize(159,null)})),autoClosingQuotes:Ne(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(160,null),f.localize(161,null),""],description:f.localize(162,null)})),autoIndent:Ne(new S(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[f.localize(163,null),f.localize(164,null),f.localize(165,null),f.localize(166,null),f.localize(167,null)],description:f.localize(168,null)})),automaticLayout:Ne(new E(10,"automaticLayout",!1)),autoSurround:Ne(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(169,null),f.localize(170,null),f.localize(171,null),""],description:f.localize(172,null)})),bracketPairColorization:Ne(new Q),bracketPairGuides:Ne(new oe),stickyTabStops:Ne(new E(104,"stickyTabStops",!1,{description:f.localize(173,null)})),codeLens:Ne(new E(14,"codeLens",!0,{description:f.localize(174,null)})),codeLensFontFamily:Ne(new s(15,"codeLensFontFamily","",{description:f.localize(175,null)})),codeLensFontSize:Ne(new _(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(176,null)})),colorDecorators:Ne(new E(17,"colorDecorators",!0,{description:f.localize(177,null)})),columnSelection:Ne(new E(18,"columnSelection",!1,{description:f.localize(178,null)})),comments:Ne(new n),contextmenu:Ne(new E(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new E(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(179,null)})),cursorBlinking:Ne(new S(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:f.localize(180,null)})),cursorSmoothCaretAnimation:Ne(new E(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(181,null)})),cursorStyle:Ne(new S(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:f.localize(182,null)})),cursorSurroundingLines:Ne(new _(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(183,null)})),cursorSurroundingLinesStyle:Ne(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(184,null),f.localize(185,null)],description:f.localize(186,null)})),cursorWidth:Ne(new _(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(187,null)})),disableLayerHinting:Ne(new E(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new E(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new E(30,"domReadOnly",!1)),dragAndDrop:Ne(new E(31,"dragAndDrop",!0,{description:f.localize(188,null)})),emptySelectionClipboard:Ne(new k),extraEditorClassName:Ne(new s(33,"extraEditorClassName","")),fastScrollSensitivity:Ne(new a(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:f.localize(189,null)})),find:Ne(new O),fixedOverflowWidgets:Ne(new E(36,"fixedOverflowWidgets",!1)),folding:Ne(new E(37,"folding",!0,{description:f.localize(190,null)})),foldingStrategy:Ne(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(191,null),f.localize(192,null)],description:f.localize(193,null)})),foldingHighlight:Ne(new E(39,"foldingHighlight",!0,{description:f.localize(194,null)})),foldingImportsByDefault:Ne(new E(40,"foldingImportsByDefault",!1,{description:f.localize(195,null)})),foldingMaximumRegions:Ne(new _(41,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(196,null)})),unfoldOnClickAfterEndOfLine:Ne(new E(42,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(197,null)})),fontFamily:Ne(new s(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(198,null)})),fontInfo:Ne(new F),fontLigatures2:Ne(new U),fontSize:Ne(new M),fontWeight:Ne(new V),formatOnPaste:Ne(new E(48,"formatOnPaste",!1,{description:f.localize(199,null)})),formatOnType:Ne(new E(49,"formatOnType",!1,{description:f.localize(200,null)})),glyphMargin:Ne(new E(50,"glyphMargin",!0,{description:f.localize(201,null)})),gotoLocation:Ne(new $),hideCursorInOverviewRuler:Ne(new E(52,"hideCursorInOverviewRuler",!1,{description:f.localize(202,null)})),hover:Ne(new N),inDiffEditor:Ne(new E(54,"inDiffEditor",!1)),letterSpacing:Ne(new a(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>a.clamp(ee,-5,20),{description:f.localize(203,null)})),lightbulb:Ne(new z),lineDecorationsWidth:Ne(new p(58,"lineDecorationsWidth",10)),lineHeight:Ne(new J),lineNumbers:Ne(new Me),lineNumbersMinChars:Ne(new _(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new E(62,"linkedEditing",!1,{description:f.localize(204,null)})),links:Ne(new E(63,"links",!0,{description:f.localize(205,null)})),matchBrackets:Ne(new o(64,"matchBrackets","always",["always","near","never"],{description:f.localize(206,null)})),minimap:Ne(new se),mouseStyle:Ne(new o(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new a(67,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:f.localize(207,null)})),mouseWheelZoom:Ne(new E(68,"mouseWheelZoom",!1,{markdownDescription:f.localize(208,null)})),multiCursorMergeOverlapping:Ne(new E(69,"multiCursorMergeOverlapping",!0,{description:f.localize(209,null)})),multiCursorModifier:Ne(new S(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ie,{markdownEnumDescriptions:[f.localize(210,null),f.localize(211,null)],markdownDescription:f.localize(212,null)})),multiCursorPaste:Ne(new o(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(213,null),f.localize(214,null)],markdownDescription:f.localize(215,null)})),occurrencesHighlight:Ne(new E(72,"occurrencesHighlight",!0,{description:f.localize(216,null)})),overviewRulerBorder:Ne(new E(73,"overviewRulerBorder",!0,{description:f.localize(217,null)})),overviewRulerLanes:Ne(new _(74,"overviewRulerLanes",3,0,3)),padding:Ne(new K),parameterHints:Ne(new Y),peekWidgetDefaultFocus:Ne(new o(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(218,null),f.localize(219,null)],description:f.localize(220,null)})),definitionLinkOpensInPeek:Ne(new E(78,"definitionLinkOpensInPeek",!1,{description:f.localize(221,null)})),quickSuggestions:Ne(new fe),quickSuggestionsDelay:Ne(new _(80,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(222,null)})),readOnly:Ne(new E(81,"readOnly",!1)),renameOnType:Ne(new E(82,"renameOnType",!1,{description:f.localize(223,null),markdownDeprecationMessage:f.localize(224,null)})),renderControlCharacters:Ne(new E(83,"renderControlCharacters",!0,{description:f.localize(225,null),restricted:!0})),renderFinalNewline:Ne(new E(84,"renderFinalNewline",!0,{description:f.localize(226,null)})),renderLineHighlight:Ne(new o(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(227,null)],description:f.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Ne(new E(86,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(229,null)})),renderValidationDecorations:Ne(new o(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new o(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(230,null),f.localize(231,null),f.localize(232,null),""],description:f.localize(233,null)})),revealHorizontalRightPadding:Ne(new _(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ne(new E(90,"roundedSelection",!0,{description:f.localize(234,null)})),rulers:Ne(new Ge),scrollbar:Ne(new q),scrollBeyondLastColumn:Ne(new _(93,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(235,null)})),scrollBeyondLastLine:Ne(new E(94,"scrollBeyondLastLine",!0,{description:f.localize(236,null)})),scrollPredominantAxis:Ne(new E(95,"scrollPredominantAxis",!0,{description:f.localize(237,null)})),selectionClipboard:Ne(new E(96,"selectionClipboard",!0,{description:f.localize(238,null),included:t.isLinux})),selectionHighlight:Ne(new E(97,"selectionHighlight",!0,{description:f.localize(239,null)})),selectOnLineNumbers:Ne(new E(98,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new o(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(240,null),f.localize(241,null)],description:f.localize(242,null)})),showUnused:Ne(new E(100,"showUnused",!0,{description:f.localize(243,null)})),showDeprecated:Ne(new E(126,"showDeprecated",!0,{description:f.localize(244,null)})),inlayHints:Ne(new W),snippetSuggestions:Ne(new o(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null),f.localize(248,null)],description:f.localize(249,null)})),smartSelect:Ne(new xe),smoothScrolling:Ne(new E(103,"smoothScrolling",!1,{description:f.localize(250,null)})),stopRenderingLineAfter:Ne(new _(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new Ie),inlineSuggest:Ne(new G),suggestFontSize:Ne(new _(107,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(251,null)})),suggestLineHeight:Ne(new _(108,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(252,null)})),suggestOnTriggerCharacters:Ne(new E(109,"suggestOnTriggerCharacters",!0,{description:f.localize(253,null)})),suggestSelection:Ne(new o(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(254,null),f.localize(255,null),f.localize(256,null)],description:f.localize(257,null)})),tabCompletion:Ne(new o(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),tabIndex:Ne(new _(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new te),unusualLineTerminators:Ne(new o(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(262,null),f.localize(263,null),f.localize(264,null)],description:f.localize(265,null)})),useShadowDOM:Ne(new E(115,"useShadowDOM",!0)),useTabStops:Ne(new E(116,"useTabStops",!0,{description:f.localize(266,null)})),wordSeparators:Ne(new s(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:f.localize(267,null)})),wordWrap:Ne(new o(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(268,null),f.localize(269,null),f.localize(270,null),f.localize(271,null)],description:f.localize(272,null)})),wordWrapBreakAfterCharacters:Ne(new s(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new s(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new _(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(273,null)})),wordWrapOverride1:Ne(new o(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new o(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new S(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[f.localize(274,null),f.localize(275,null),f.localize(276,null),f.localize(277,null)],description:f.localize(278,null)})),wrappingStrategy:Ne(new o(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(279,null),f.localize(280,null)],description:f.localize(281,null)})),editorClassName:Ne(new v),pixelRatio:Ne(new le),tabFocusMode:Ne(new Xe),layoutInfo:Ne(new x),wrappingInfo:Ne(new ot)}}),define(pe[156],ve([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[157],ve([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[158],ve([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[159],ve([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[160],ve([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(pe[161],ve([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(pe[162],ve([19,20]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[163],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[164],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[165],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[166],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[167],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[168],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[169],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[170],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[171],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(pe[172],ve([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(pe[173],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[174],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[175],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[176],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[177],ve([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[178],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var f;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var t;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var I;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[179],ve([0,1,158]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function D(l){return l=l.trim(),l==="*"||t.test(l)}e.isValidVersionStr=D;function T(l){if(!D(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=l.match(t);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=T;function P(l){if(!l)return null;let b=l.majorBase,p=l.majorMustEqual,g=l.minorBase,E=l.minorMustEqual,L=l.patchBase,_=l.patchMustEqual;l.hasCaret&&(b===0||(E=!1),_=!1);let a=0;if(l.preRelease){const s=I.exec(l.preRelease);if(s){const[,m,o,S]=s;a=Date.UTC(Number(m),Number(o)-1,Number(S))}}return{majorBase:b,majorMustEqual:p,minorBase:g,minorMustEqual:E,patchBase:L,patchMustEqual:_,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=P;function C(l,b,p){let g;typeof l=="string"?g=P(T(l)):g=l;let E;b instanceof Date?E=b.getTime():typeof b=="string"&&(E=new Date(b).getTime());let L;if(typeof p=="string"?L=P(T(p)):L=p,!g||!L)return!1;let _=g.majorBase,a=g.minorBase,s=g.patchBase,m=L.majorBase,o=L.minorBase,S=L.patchBase,r=L.notBefore,i=L.majorMustEqual,n=L.minorMustEqual,u=L.patchMustEqual;return L.isMinimum?_>m?!0:_<m?!1:a>o?!0:a<o||E&&E<r?!1:s>=S:(_===1&&m===0&&(!i||!n||!u)&&(m=1,o=0,S=0,i=!0,n=!1,u=!1),_<m?!1:_>m?!i:a<o?!1:a>o?!n:s<S?!1:s>S?!u:!(E&&E<r))}e.isValidVersion=C;function A(l,b,p,g){return p.isBuiltin||typeof p.main=="undefined"?!0:y(l,b,p.engines.vscode,g)}e.isValidExtensionVersion=A;function R(l,b,p){return l==="*"||y(b,p,l)}e.isEngineValid=R;function y(l,b,p,g=[]){let E=P(T(p));if(!E)return g.push(f.localize(0,null,p)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return g.push(f.localize(1,null,p)),!1}else if(!E.majorMustEqual)return g.push(f.localize(2,null,p)),!1;return C(l,b,E)?!0:(g.push(f.localize(3,null,l,p)),!1)}}),define(pe[115],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(I,D=[],T=!1){this.ctor=I,this.staticArguments=D,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=f}),define(pe[61],ve([0,1,115]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function I(T,P,C){P instanceof f.SyncDescriptor||(P=new f.SyncDescriptor(P,[],C)),t.push([T,P])}e.registerSingleton=I;function D(){return t}e.getSingletonServiceDescriptors=D}),define(pe[180],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=f;class t{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let T of this._nodes.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const P=this.lookupOrInsertNode(D),C=this.lookupOrInsertNode(T);P.outgoing.set(this._hashFn(T),C),C.incoming.set(this._hashFn(D),P)}removeNode(D){const T=this._hashFn(D);this._nodes.delete(T);for(let P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(D){const T=this._hashFn(D);let P=this._nodes.get(T);return P||(P=new f(D),this._nodes.set(T,P)),P}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[T,P]of this._nodes)D.push(`${T}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,T]of this._nodes){const P=new Set([D]),C=this._findCycle(T,P);if(C)return C}}_findCycle(D,T){for(let[P,C]of D.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const A=this._findCycle(C,T);if(A)return A;T.delete(P)}}}e.Graph=t}),define(pe[4],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(C){return C[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(f=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(T,P,C,A){P[f.DI_TARGET]===P?P[f.DI_DEPENDENCIES].push({id:T,index:C,optional:A}):(P[f.DI_DEPENDENCIES]=[{id:T,index:C,optional:A}],P[f.DI_TARGET]=P)}function I(T){if(f.serviceIds.has(T))return f.serviceIds.get(T);const P=function(C,A,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,C,R,!1)};return P.toString=()=>T,f.serviceIds.set(T,P),P}e.createDecorator=I;function D(T){return T}e.refineServiceDecorator=D}),define(pe[181],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,f.createDecorator)("modelService");function t(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(pe[182],ve([0,1,3,6,82,181]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function T(C){return typeof C=="string"?!1:Array.isArray(C)?C.every(T):!!C.exclusive}class P{constructor(){this._clock=0,this._entries=[],this._onDidChange=new f.Emitter}get onDidChange(){return this._onDidChange.event}register(A,R){let y={selector:A,provider:R,_score:-1,_time:this._clock++};return this._entries.push(y),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(y){const l=this._entries.indexOf(y);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),y=void 0)}})}has(A){return this.all(A).length>0}all(A){if(!A)return[];this._updateScores(A);const R=[];for(let y of this._entries)y._score>0&&R.push(y.provider);return R}ordered(A){const R=[];return this._orderedForEach(A,y=>R.push(y.provider)),R}orderedGroups(A){const R=[];let y,l;return this._orderedForEach(A,b=>{y&&l===b._score?y.push(b.provider):(l=b._score,y=[b.provider],R.push(y))}),R}_orderedForEach(A,R){if(!!A){this._updateScores(A);for(const y of this._entries)y._score>0&&R(y)}}_updateScores(A){const R={uri:A.uri.toString(),language:A.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let y of this._entries)if(y._score=(0,I.score)(y.selector,A.uri,A.getLanguageId(),(0,D.shouldSynchronizeModel)(A)),T(y.selector)&&y._score>0){for(let l of this._entries)l._score=0;y._score=1e3;break}this._entries.sort(P._compareByScoreAndTime)}}static _compareByScoreAndTime(A,R){return A._score<R._score?1:A._score>R._score?-1:A._time<R._time?1:A._time>R._time?-1:0}}e.LanguageFeatureRegistry=P}),define(pe[83],ve([0,1,2,41,182,148,74]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var C;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(C=e.FontStyle||(e.FontStyle={}));var A;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var R;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var y;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=1024]="ITALIC_MASK",v[v.BOLD_MASK=2048]="BOLD_MASK",v[v.UNDERLINE_MASK=4096]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(y=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&768)>>>8}static getFontStyle(k){return(k&15360)>>>10}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){const O=this.getForeground(k);let U="mtk"+O;const F=this.getFontStyle(k);return F&1&&(U+=" mtki"),F&2&&(U+=" mtkb"),F&4&&(U+=" mtku"),F&8&&(U+=" mtks"),U}static getInlineStyleFromMetadata(k,O){const U=this.getForeground(k),F=this.getFontStyle(k);let M=`color: ${O[U]};`;F&1&&(M+="font-style: italic;"),F&2&&(M+="font-weight: bold;");let V="";return F&4&&(V+=" underline"),F&8&&(V+=" line-through"),V&&(M+=`text-decoration:${V};`),M}static getPresentationFromMetadata(k){const O=this.getForeground(k),U=this.getFontStyle(k);return{foreground:O,italic:Boolean(U&1),bold:Boolean(U&2),underline:Boolean(U&4),strikethrough:Boolean(U&8)}}}e.TokenMetadata=l;var b;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var p;(function(v){const k=new Map;k.set(0,T.Codicon.symbolMethod),k.set(1,T.Codicon.symbolFunction),k.set(2,T.Codicon.symbolConstructor),k.set(3,T.Codicon.symbolField),k.set(4,T.Codicon.symbolVariable),k.set(5,T.Codicon.symbolClass),k.set(6,T.Codicon.symbolStruct),k.set(7,T.Codicon.symbolInterface),k.set(8,T.Codicon.symbolModule),k.set(9,T.Codicon.symbolProperty),k.set(10,T.Codicon.symbolEvent),k.set(11,T.Codicon.symbolOperator),k.set(12,T.Codicon.symbolUnit),k.set(13,T.Codicon.symbolValue),k.set(15,T.Codicon.symbolEnum),k.set(14,T.Codicon.symbolConstant),k.set(15,T.Codicon.symbolEnum),k.set(16,T.Codicon.symbolEnumMember),k.set(17,T.Codicon.symbolKeyword),k.set(27,T.Codicon.symbolSnippet),k.set(18,T.Codicon.symbolText),k.set(19,T.Codicon.symbolColor),k.set(20,T.Codicon.symbolFile),k.set(21,T.Codicon.symbolReference),k.set(22,T.Codicon.symbolCustomColor),k.set(23,T.Codicon.symbolFolder),k.set(24,T.Codicon.symbolTypeParameter),k.set(25,T.Codicon.account),k.set(26,T.Codicon.issues);function O(M){let V=k.get(M);return V||(console.info("No codicon found for CompletionItemKind "+M),V=T.Codicon.symbolProperty),V}v.toIcon=O;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function F(M,V){let $=U.get(M);return typeof $=="undefined"&&!V&&($=9),$}v.fromString=F})(p=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(v){v[v.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var L;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(v){return v&&f.URI.isUri(v.uri)&&t.Range.isIRange(v.range)&&(t.Range.isIRange(v.originSelectionRange)||t.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=o;var S;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var r;(function(v){v[v.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(v){const k=new Map;k.set(0,T.Codicon.symbolFile),k.set(1,T.Codicon.symbolModule),k.set(2,T.Codicon.symbolNamespace),k.set(3,T.Codicon.symbolPackage),k.set(4,T.Codicon.symbolClass),k.set(5,T.Codicon.symbolMethod),k.set(6,T.Codicon.symbolProperty),k.set(7,T.Codicon.symbolField),k.set(8,T.Codicon.symbolConstructor),k.set(9,T.Codicon.symbolEnum),k.set(10,T.Codicon.symbolInterface),k.set(11,T.Codicon.symbolFunction),k.set(12,T.Codicon.symbolVariable),k.set(13,T.Codicon.symbolConstant),k.set(14,T.Codicon.symbolString),k.set(15,T.Codicon.symbolNumber),k.set(16,T.Codicon.symbolBoolean),k.set(17,T.Codicon.symbolArray),k.set(18,T.Codicon.symbolObject),k.set(19,T.Codicon.symbolKey),k.set(20,T.Codicon.symbolNull),k.set(21,T.Codicon.symbolEnumMember),k.set(22,T.Codicon.symbolStruct),k.set(23,T.Codicon.symbolEvent),k.set(24,T.Codicon.symbolOperator),k.set(25,T.Codicon.symbolTypeParameter);function O(U){let F=k.get(U);return F||(console.info("No codicon found for SymbolKind "+U),F=T.Codicon.symbolProperty),F}v.toIcon=O})(i=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(k){this.value=k}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var u;(function(v){function k(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}v.is=k})(u=e.Command||(e.Command={}));var c;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var h;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(h=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new D.TokenizationRegistry;var w;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[116],ve([0,1,13,2,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function D(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationOverrides=D;function T(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||f.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(E){E[E.USER=1]="USER",E[E.USER_LOCAL=2]="USER_LOCAL",E[E.USER_REMOTE=3]="USER_REMOTE",E[E.WORKSPACE=4]="WORKSPACE",E[E.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",E[E.DEFAULT=6]="DEFAULT",E[E.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(E){switch(E){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function A(E,L){const _=Object.create(null);for(let a in E)R(_,a,E[a],L);return _}e.toValuesTree=A;function R(E,L,_,a){const s=L.split("."),m=s.pop();let o=E;for(let S=0;S<s.length;S++){let r=s[S],i=o[r];switch(typeof i){case"undefined":i=o[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${L} as ${s.slice(0,S+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[m]=_}catch{a(`Ignoring ${L} as ${s.join(".")} is ${JSON.stringify(o)}`)}else a(`Ignoring ${L} as ${s.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=R;function y(E,L){const _=L.split(".");l(E,_)}e.removeFromValueTree=y;function l(E,L){const _=L.shift();if(L.length===0){delete E[_];return}if(Object.keys(E).indexOf(_)!==-1){const a=E[_];typeof a=="object"&&!Array.isArray(a)&&(l(a,L),Object.keys(a).length===0&&delete E[_])}}function b(E,L,_){function a(o,S){let r=o;for(const i of S){if(typeof r!="object"||r===null)return;r=r[i]}return r}const s=L.split("."),m=a(E,s);return typeof m=="undefined"?_:m}e.getConfigurationValue=b;function p(E,L,_){Object.keys(L).forEach(a=>{a!=="__proto__"&&(a in E?f.isObject(E[a])&&f.isObject(L[a])?p(E[a],L[a],_):_&&(E[a]=L[a]):E[a]=L[a])})}e.merge=p;function g(E,L,_){const a=E.inspect(L),s=E.inspect(_);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:a.defaultValue}e.getMigratedSettingValue=g}),define(pe[62],ve([0,1,12,8,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let D=f.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",f.isMacintosh),T.set("isLinux",f.isLinux),T.set("isWindows",f.isWindows),T.set("isWeb",f.isWeb),T.set("isMacNative",f.isMacintosh&&!f.isWeb),T.set("isEdge",D.indexOf("Edg/")>=0),T.set("isFirefox",D.indexOf("Firefox")>=0),T.set("isChrome",D.indexOf("Chrome")>=0),T.set("isSafari",D.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var C;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return l.INSTANCE}static true(){return b.INSTANCE}static has(F){return p.create(F)}static equals(F,M){return g.create(F,M)}static notEquals(F,M){return _.create(F,M)}static regex(F,M){return i.create(F,M)}static in(F,M){return E.create(F,M)}static not(F){return a.create(F)}static and(...F){return c.create(F,null)}static or(...F){return d.create(F,null,!0)}static greater(F,M){return m.create(F,M)}static greaterEquals(F,M){return o.create(F,M)}static smaller(F,M){return S.create(F,M)}static smallerEquals(F,M){return r.create(F,M)}static deserialize(F,M=!1){if(!!F)return this._deserializeOrExpression(F,M)}static _deserializeOrExpression(F,M){let V=F.split("||");return d.create(V.map($=>this._deserializeAndExpression($,M)),null,!0)}static _deserializeAndExpression(F,M){let V=F.split("&&");return c.create(V.map($=>this._deserializeOne($,M)),null)}static _deserializeOne(F,M){if(F=F.trim(),F.indexOf("!=")>=0){let V=F.split("!=");return _.create(V[0].trim(),this._deserializeValue(V[1],M))}if(F.indexOf("==")>=0){let V=F.split("==");return g.create(V[0].trim(),this._deserializeValue(V[1],M))}if(F.indexOf("=~")>=0){let V=F.split("=~");return i.create(V[0].trim(),this._deserializeRegexValue(V[1],M))}if(F.indexOf(" in ")>=0){let V=F.split(" in ");return E.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const V=F.split(">=");return o.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const V=F.split(">");return m.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const V=F.split("<=");return r.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const V=F.split("<");return S.create(V[0].trim(),V[1].trim())}return/^\!\s*/.test(F)?a.create(F.substr(1).trim()):p.create(F)}static _deserializeValue(F,M){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let V=/^'([^']*)'$/.exec(F);return V?V[1].trim():F}static _deserializeRegexValue(F,M){if((0,t.isFalsyOrWhitespace)(F)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let V=F.indexOf("/"),$=F.lastIndexOf("/");if(V===$||V<0){if(M)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let N=F.slice(V+1,$),B=F[$+1]==="i"?"i":"";try{return new RegExp(N,B)}catch(x){if(M)throw new Error(`bad regexp-value '${F}', parse error: ${x}`);return console.warn(`bad regexp-value '${F}', parse error: ${x}`),null}}}e.ContextKeyExpr=A;function R(U,F){const M=U?U.substituteConstants():void 0,V=F?F.substituteConstants():void 0;return!M&&!V?!0:!M||!V?!1:M.equals(V)}e.expressionsAreEqualWithConstantSubstitution=R;function y(U,F){return U.cmp(F)}class l{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=l,l.INSTANCE=new l;class b{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class p{constructor(F,M){this.key=F,this.negated=M,this.type=2}static create(F,M=null){const V=T.get(F);return typeof V=="boolean"?V?b.INSTANCE:l.INSTANCE:new p(F,M)}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?b.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class g{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=4}static create(F,M,V=null){if(typeof M=="boolean")return M?p.create(F,V):a.create(F,V);const $=T.get(F);return typeof $=="boolean"?M===($?"true":"false")?b.INSTANCE:l.INSTANCE:new g(F,M,V)}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const M=F?"true":"false";return this.value===M?b.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class E{constructor(F,M){this.key=F,this.valueKey=M,this.type=10,this.negated=null}static create(F,M){return new E(F,M)}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const M=F.getValue(this.valueKey),V=F.getValue(this.key);return Array.isArray(M)?M.indexOf(V)>=0:typeof V=="string"&&typeof M=="object"&&M!==null?P.call(M,V):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=L.create(this)),this.negated}}e.ContextKeyInExpr=E;class L{constructor(F){this._actual=F,this.type=11}static create(F){return new L(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new L(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=L;class _{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=5}static create(F,M,V=null){if(typeof M=="boolean")return M?a.create(F,V):p.create(F,V);const $=T.get(F);return typeof $=="boolean"?M===($?"true":"false")?l.INSTANCE:b.INSTANCE:new _(F,M,V)}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const M=F?"true":"false";return this.value===M?l.INSTANCE:b.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class a{constructor(F,M){this.key=F,this.negated=M,this.type=3}static create(F,M=null){const V=T.get(F);return typeof V=="boolean"?V?l.INSTANCE:b.INSTANCE:new a(F,M)}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?l.INSTANCE:b.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=a;function s(U,F){if(typeof U=="string"){const M=parseFloat(U);isNaN(M)||(U=M)}return typeof U=="string"||typeof U=="number"?F(U):l.INSTANCE}class m{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=12}static create(F,M,V=null){return s(M,$=>new m(F,$,V))}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=m;class o{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=13}static create(F,M,V=null){return s(M,$=>new o(F,$,V))}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class S{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=14}static create(F,M,V=null){return s(M,$=>new S(F,$,V))}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=S;class r{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=15}static create(F,M,V=null){return s(M,$=>new r(F,$,V))}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(F,M){this.key=F,this.regexp=M,this.type=7,this.negated=null}static create(F,M){return new i(F,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const M=this.regexp?this.regexp.source:"",V=F.regexp?F.regexp.source:"";return M<V?-1:M>V?1:0}equals(F){if(F.type===this.type){const M=this.regexp?this.regexp.source:"",V=F.regexp?F.regexp.source:"";return this.key===F.key&&M===V}return!1}substituteConstants(){return this}evaluate(F){let M=F.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{constructor(F){this._actual=F,this.type=8}static create(F){return new n(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new n(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function u(U){let F=null;for(let M=0,V=U.length;M<V;M++){const $=U[M].substituteConstants();if(U[M]!==$&&F===null){F=[];for(let N=0;N<M;N++)F[N]=U[N]}F!==null&&(F[M]=$)}return F===null?U:F}class c{constructor(F,M){this.expr=F,this.negated=M,this.type=6}static create(F,M){return c._normalizeArr(F,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let M=0,V=this.expr.length;M<V;M++){const $=y(this.expr[M],F.expr[M]);if($!==0)return $}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].equals(F.expr[M]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:c.create(F,this.negated)}evaluate(F){for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].evaluate(F))return!1;return!0}static _normalizeArr(F,M){const V=[];let $=!1;for(const N of F)if(!!N){if(N.type===1){$=!0;continue}if(N.type===0)return l.INSTANCE;if(N.type===6){V.push(...N.expr);continue}V.push(N)}if(V.length===0&&$)return b.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(y);for(let N=1;N<V.length;N++)V[N-1].equals(V[N])&&(V.splice(N,1),N--);if(V.length===1)return V[0];for(;V.length>1;){const N=V[V.length-1];if(N.type!==9)break;V.pop();const B=V.pop(),x=V.length===0,z=d.create(N.expr.map(W=>c.create([W,B],null)),null,x);z&&(V.push(z),V.sort(y))}return V.length===1?V[0]:new c(V,M)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let M of this.expr)F.push(...M.keys());return F}map(F){return new c(this.expr.map(M=>M.map(F)),null)}negate(){if(!this.negated){const F=[];for(let M of this.expr)F.push(M.negate());this.negated=d.create(F,this,!0)}return this.negated}}class d{constructor(F,M){this.expr=F,this.negated=M,this.type=9}static create(F,M,V){return d._normalizeArr(F,M,V)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let M=0,V=this.expr.length;M<V;M++){const $=y(this.expr[M],F.expr[M]);if($!==0)return $}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].equals(F.expr[M]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:d.create(F,this.negated,!1)}evaluate(F){for(let M=0,V=this.expr.length;M<V;M++)if(this.expr[M].evaluate(F))return!0;return!1}static _normalizeArr(F,M,V){let $=[],N=!1;if(F){for(let B=0,x=F.length;B<x;B++){const z=F[B];if(!!z){if(z.type===0){N=!0;continue}if(z.type===1)return b.INSTANCE;if(z.type===9){$=$.concat(z.expr);continue}$.push(z)}}if($.length===0&&N)return l.INSTANCE;$.sort(y)}if($.length!==0){if($.length===1)return $[0];for(let B=1;B<$.length;B++)$[B-1].equals($[B])&&($.splice(B,1),B--);if($.length===1)return $[0];if(V){for(let B=0;B<$.length;B++)for(let x=B+1;x<$.length;x++)k($[B],$[x])&&($.splice(x,1),x--);if($.length===1)return $[0]}return new d($,M)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let M of this.expr)F.push(...M.keys());return F}map(F){return new d(this.expr.map(M=>M.map(F)),null)}negate(){if(!this.negated){let F=[];for(let M of this.expr)F.push(M.negate());for(;F.length>1;){const M=F.shift(),V=F.shift(),$=[];for(const B of O(M))for(const x of O(V))$.push(c.create([B,x],null));const N=F.length===0;F.unshift(d.create($,null,N))}this.negated=F[0]}return this.negated}}class h extends p{constructor(F,M,V){super(F,null);this._defaultValue=M,typeof V=="object"?h._info.push({...V,key:F}):V!==!0&&h._info.push({key:F,description:V,type:M!=null?typeof M:void 0})}static all(){return h._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return g.create(this.key,F)}notEqualsTo(F){return _.create(this.key,F)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(U,F){return U<F?-1:U>F?1:0}function v(U,F,M,V){return U<M?-1:U>M?1:F<V?-1:F>V?1:0}function k(U,F){if(F.type===6&&U.type!==9&&U.type!==6){for(const $ of F.expr)if(U.equals($))return!0}const M=U.negate(),V=O(M).concat(O(F));V.sort(y);for(let $=0;$<V.length;$++){const B=V[$].negate();for(let x=$+1;x<V.length;x++){const z=V[x];if(B.equals(z))return!0}}return!1}e.implies=k;function O(U){return U.type===9?U.expr:[U]}}),define(pe[183],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[184],ve([0,1,10,157,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var D;(function(a){a.WIN32_X64="win32-x64",a.WIN32_IA32="win32-ia32",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function T(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function P(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function C(a,s){switch(a){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function A(a,s){return s==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function R(a,s,m){return A(s,m)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===m?!0:y(m).includes(a)}e.isTargetPlatformCompatible=R;function y(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function l(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=l;var b;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var g;(function(a){a.Install="install",a.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var E;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var L;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(L=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class _ extends Error{constructor(s,m){super(s);this.code=m,this.name=m}}e.ExtensionManagementError=_,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=f.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(pe[185],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(pe[186],ve([0,1,37,10,9,12,96,30,113,159,185]),function(Z,e,f,t,I,D,T,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=A.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends l{openTerminal(s,m){return this.spawnTerminal(f,s,C.getWindowsShell(),m)}spawnTerminal(s,m,o,S){const r=m.windowsExec||b.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const i=I.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return s.spawn(r,S?[S]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),(i==="wt"||i==="wt.exe")&&n.push("-d ."),new Promise((u,c)=>{const d=E(process),h=s.spawn(o,n,{cwd:S,env:d});h.on("error",c),h.on("exit",()=>u())})}runInTerminal(s,m,o,S,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:b.getDefaultTerminalWindows();return new Promise((n,u)=>{const c=`"${m} - ${y}"`,d=`""${o.join('" "')}" & pause"`,h=["/c","start",c,"/wait",i,"/c",d],w=Object.assign({},E(process),S);Object.keys(w).filter(O=>w[O]===null).forEach(O=>delete w[O]);const v={cwd:m,env:w,windowsVerbatimArguments:!0};f.spawn(b.CMD,h,v).on("error",O=>{u(L(O))}),n(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class p extends l{openTerminal(s,m){return this.spawnTerminal(f,s,m)}runInTerminal(s,m,o,S,r){const i=r.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((n,u)=>{if(i===R.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const c=i===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Z).fsPath,"-t",s||y,"-w",m];for(let k of o)h.push("-a"),h.push(k);if(S){const k=Object.assign({},E(process),S);for(let O in k){const U=k[O];U===null?(h.push("-u"),h.push(O)):(h.push("-e"),h.push(`${O}=${U}`))}}let w="";const v=f.spawn(p.OSASCRIPT,h);v.on("error",k=>{u(L(k))}),v.stderr.on("data",k=>{w+=k.toString()}),v.on("exit",k=>{if(k===0)n(void 0);else if(w){const O=w.split(`
`,1);u(new Error(O[0]))}else u(new Error(A.localize(1,null,c,k)))})}else u(new Error(A.localize(2,null,i)))})}spawnTerminal(s,m,o){const S=m.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const n=["-a",S];o&&n.push(o);const u=E(process),c=s.spawn("/usr/bin/open",n,{cwd:o,env:u});c.on("error",i),c.on("exit",()=>r())})}}e.MacExternalTerminalService=p,p.OSASCRIPT="/usr/bin/osascript";class g extends l{openTerminal(s,m){return this.spawnTerminal(f,s,m)}runInTerminal(s,m,o,S,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((n,u)=>{let c=[];i.then(d=>{d.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const h=`${_(o)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;c.push(`''${h}''`);const w=Object.assign({},E(process),S);Object.keys(w).filter(U=>w[U]===null).forEach(U=>delete w[U]);const v={cwd:m,env:w};let k="";const O=f.spawn(d,c,v);O.on("error",U=>{u(L(U))}),O.stderr.on("data",U=>{k+=U.toString()}),O.on("exit",U=>{if(U===0)n(void 0);else if(k){const F=k.split(`
`,1);u(new Error(F[0]))}else u(new Error(A.localize(4,null,d,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await P.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{s?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,m,o){const S=m.linuxExec?Promise.resolve(m.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{S.then(n=>{const u=E(process),c=s.spawn(n,[],{cwd:o,env:u});c.on("error",i),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=A.localize(3,null);function E(a){const s={...a.env};return(0,T.sanitizeProcessEnvironment)(s),s}function L(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(A.localize(5,null,a.path)):a}function _(a){let s="";for(let m of a)m.indexOf(" ")>=0?s+='"'+m+'"':s+=m,s+=" ";return s}}),define(pe[42],ve([0,1,24,9,8,13,2,160,4]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function A($){return $.create===!0}e.isFileOpenForWriteOptions=A;var R;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var y;(function($){$[$.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var l;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b($){return!!($.capabilities&2)}e.hasReadWriteCapability=b;function p($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=p;function g($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=E;function L($){return b($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=L;var _;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(N,B){super(N);this.code=B}}e.FileSystemProviderError=a;function s($,N){const B=new a($.toString(),N);return o(B,N),B}e.createFileSystemProviderError=s;function m($){return $||s((0,P.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=m;function o($,N){return $.name=N?`${N} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=o;function S($){if(!$)return _.Unknown;if($ instanceof a)return $.code;const N=/^(.+) \(FileSystemError\)$/.exec($.name);if(!N)return _.Unknown;switch(N[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=S;function r($){if($ instanceof h)return $.fileOperationResult;switch(S($)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(N,B,x){this.resource=N,this.operation=B,this.target=x}isOperation(N){return this.operation===N}}e.FileOperationEvent=n;var u;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor(N,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=N;const x=new Map;for(const z of N){const W=x.get(z.type);switch(W?W.push([z.resource,z]):x.set(z.type,[[z.resource,z]]),z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}}for(const[z,W]of x)switch(z){case 1:this.added=f.TernarySearchTree.forUris(()=>B),this.added.fill(W);break;case 0:this.updated=f.TernarySearchTree.forUris(()=>B),this.updated.fill(W);break;case 2:this.deleted=f.TernarySearchTree.forUris(()=>B),this.deleted.fill(W);break}}contains(N,...B){return this.doContains(N,{includeChildren:!1},...B)}affects(N,...B){return this.doContains(N,{includeChildren:!0},...B)}doContains(N,B,...x){if(!N)return!1;const z=x.length>0;return!!((!z||x.includes(1))&&(this.added?.get(N)||B.includeChildren&&this.added?.findSuperstr(N))||(!z||x.includes(0))&&(this.updated?.get(N)||B.includeChildren&&this.updated?.findSuperstr(N))||(!z||x.includes(2))&&(this.deleted?.findSubstr(N)||B.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function d($,N,B){return!$||!N||$===N||N.length>$.length?!1:(N.charAt(N.length-1)!==t.sep&&(N+=t.sep),B?(0,I.startsWithIgnoreCase)($,N):$.indexOf(N)===0)}e.isParent=d;class h extends Error{constructor(N,B,x){super(N);this.fileOperationResult=B,this.options=x}}e.FileOperationError=h;class w extends h{constructor(N,B,x){super(N,2,x);this.stat=B}}e.NotModifiedSinceFileOperationError=w;var v;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=O;async function U($,N){if(!N.hasProvider(T.URI.from({scheme:$.scheme})))return new Promise(B=>{const x=N.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===$.scheme&&z.added&&(x.dispose(),B())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(N){return(0,D.isNumber)(N)||(N=0),N<F.KB?(0,P.localize)(1,null,N.toFixed(0)):N<F.MB?(0,P.localize)(2,null,(N/F.KB).toFixed(2)):N<F.GB?(0,P.localize)(3,null,(N/F.MB).toFixed(2)):N<F.TB?(0,P.localize)(4,null,(N/F.GB).toFixed(2)):(0,P.localize)(5,null,(N/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var M;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function V($){return{maxFileSize:$===0?300*F.MB:16*F.GB,maxHeapSize:$===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=V}),define(pe[84],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...I){this._entries=new Map;for(let[D,T]of I)this.set(D,T)}set(I,D){const T=this._entries.get(I);return this._entries.set(I,D),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=f}),define(pe[187],ve([0,1,17,15,115,180,4,84]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class A extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class R{constructor(p=new P.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=p,this._strict=g,this._parent=E,this._services.set(T.IInstantiationService,this)}createChild(p){return new R(p,this._strict,this)}invokeFunction(p,...g){let E=l.traceInvocation(p),L=!1;try{return p({get:a=>{if(L)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(a,E);if(!s)throw new Error(`[invokeFunction] unknown service '${a}'`);return s}},...g)}finally{L=!0,E.stop()}}createInstance(p,...g){let E,L;return p instanceof I.SyncDescriptor?(E=l.traceCreation(p.ctor),L=this._createInstance(p.ctor,p.staticArguments.concat(g),E)):(E=l.traceCreation(p),L=this._createInstance(p,g,E)),E.stop(),L}_createInstance(p,g=[],E){let L=T._util.getServiceDependencies(p).sort((s,m)=>s.index-m.index),_=[];for(const s of L){let m=this._getOrCreateServiceInstance(s.id,E);if(!m&&this._strict&&!s.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${s.id}.`);_.push(m)}let a=L.length>0?L[0].index:g.length;if(g.length!==a){console.warn(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${g.length} static arguments`);let s=a-g.length;s>0?g=g.concat(new Array(s)):g=g.slice(0,a)}return new p(...[...g,..._])}_setServiceInstance(p,g){if(this._services.get(p)instanceof I.SyncDescriptor)this._services.set(p,g);else if(this._parent)this._parent._setServiceInstance(p,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let g=this._services.get(p);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):g}_getOrCreateServiceInstance(p,g){let E=this._getServiceInstanceOrDescriptor(p);return E instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,E,g.branch(p,!0)):(g.branch(p,!1),E)}_safeCreateAndCacheServiceInstance(p,g,E){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,g,E)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,g,E){const L=new D.Graph(s=>s.id.toString());let _=0;const a=[{id:p,desc:g,_trace:E}];for(;a.length;){const s=a.pop();if(L.lookupOrInsertNode(s),_++>1e3)throw new A(L);for(let m of T._util.getServiceDependencies(s.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(m.id);if(!o&&!m.optional&&console.warn(`[createInstance] ${p} depends on ${m.id} which is NOT registered.`),o instanceof I.SyncDescriptor){const S={id:m.id,desc:o,_trace:s._trace.branch(m.id,!0)};L.insertEdge(s,S),a.push(S)}}}for(;;){const s=L.roots();if(s.length===0){if(!L.isEmpty())throw new A(L);break}for(const{data:m}of s){if(this._getServiceInstanceOrDescriptor(m.id)instanceof I.SyncDescriptor){const S=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,S)}L.removeNode(m)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,g,E=[],L,_){if(this._services.get(p)instanceof I.SyncDescriptor)return this._createServiceInstance(g,E,L,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,g,E,L,_);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(p,g=[],E,L){if(E){const _=new f.IdleValue(()=>this._createInstance(p,g,L));return new Proxy(Object.create(null),{get(a,s){if(s in a)return a[s];let m=_.value,o=m[s];return typeof o!="function"||(o=o.bind(m),a[s]=o),o},set(a,s,m){return _.value[s]=m,!0}})}else return this._createInstance(p,g,L)}}e.InstantiationService=R;var y;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(y||(y={}));class l{constructor(p,g){this.type=p,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return C?new l(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(p){return C?new l(0,p.name):l._None}branch(p,g){let E=new l(2,p.toString());return this._dep.push([p,g,E]),E}stop(){let p=Date.now()-this._start;l._totals+=p;let g=!1;function E(_,a){let s=[],m=new Array(_+1).join("	");for(const[o,S,r]of a._dep)if(S&&r){g=!0,s.push(`${m}CREATES -> ${o}`);let i=E(_+1,r);i&&s.push(i)}else s.push(`${m}uses -> ${o}`);return s.join(`
`)}let L=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(p>2||g)&&console.log(L.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(pe[11],ve([0,1,49,3,6,12,4]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function P(){return new Date().toISOString()}var C;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function A(S,r,i){switch(r){case C.Trace:S.trace(i);break;case C.Debug:S.debug(i);break;case C.Info:S.info(i);break;case C.Warning:S.warn(i);break;case C.Error:S.error(i);break;case C.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}e.log=A;function R(S){let r="";for(let i=0;i<S.length;i++){let n=S[i];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}r+=(i>0?" ":"")+n}return r}e.format=R;class y extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class l extends y{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,R([r,...i]))}debug(r,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,R([r,...i]))}info(r,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,R([r,...i]))}warn(r,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,R([r,...i]))}error(r,...i){if(this.checkLogLevel(C.Error))if(r instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=r.stack,this.log(C.Error,R(n))}else this.log(C.Error,R([r,...i]))}critical(r,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,R([r,...i]))}flush(){}}e.AbstractMessageLogger=l;class b extends y{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!D.isWindows}trace(r,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}debug(r,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}info(r,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,r,...i):console.log(`[main ${P()}]`,r,...i))}warn(r,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,r,...i):console.warn(`[main ${P()}]`,r,...i))}error(r,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,r,...i):console.error(`[main ${P()}]`,r,...i))}critical(r,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,r,...i):console.error(`[main ${P()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class p extends y{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=p;class g extends y{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,f.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class E extends y{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const n of this.logServices)n.trace(r,...i)}debug(r,...i){for(const n of this.logServices)n.debug(r,...i)}info(r,...i){for(const n of this.logServices)n.info(r,...i)}warn(r,...i){for(const n of this.logServices)n.warn(r,...i)}error(r,...i){for(const n of this.logServices)n.error(r,...i)}critical(r,...i){for(const n of this.logServices)n.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=E;class L extends I.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=L;class _ extends I.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(n))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let n=this.loggers.get(r.toString());return n||(n=this.doCreateLogger(r,i?.always?C.Trace:this.logLevel,i),this.loggers.set(r.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class a{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=a;function s(S){if(S.verbose)return C.Trace;if(typeof S.logLevel=="string"){const r=m(S.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function m(S){switch(S){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=m;function o(S){switch(S){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=o}),define(pe[188],ve([0,1,42,11]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(P,C,A,R,y){try{const l=await new Promise((p,g)=>{Z(["spdlog"],p,g)});l.setFlushOn(t.LogLevel.Trace);const b=await l.createAsyncRotatingLogger(P,C,A,R);return y&&b.clearFormatters(),b}catch(l){console.error(l)}return null}function D(P,C,A){switch(C){case t.LogLevel.Trace:P.trace(A);break;case t.LogLevel.Debug:P.debug(A);break;case t.LogLevel.Info:P.info(A);break;case t.LogLevel.Warning:P.warn(A);break;case t.LogLevel.Error:P.error(A);break;case t.LogLevel.Critical:P.critical(A);break;default:throw new Error("Invalid log level")}}class T extends t.AbstractMessageLogger{constructor(C,A,R,y,l){super();this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(C,A,R,y),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(C,A,R,y){const l=R?6:1,b=30/l*f.ByteSize.MB,p=await I(C,A,b,l,y);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:g,message:E}of this.buffer)D(this._logger,g,E);this.buffer=[]}}log(C,A){this._logger?D(this._logger,C,A):this.getLevel()<=C&&this.buffer.push({level:C,message:A})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(pe[117],ve([0,1,47,161,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var T;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function A(p,g){return g-p}C.compare=A;const R=Object.create(null);R[C.Error]=(0,t.localize)(0,null),R[C.Warning]=(0,t.localize)(1,null),R[C.Info]=(0,t.localize)(2,null);function y(p){return R[p]||""}C.toString=y;function l(p){switch(p){case f.default.Error:return C.Error;case f.default.Warning:return C.Warning;case f.default.Info:return C.Info;case f.default.Ignore:return C.Hint}}C.fromSeverity=l;function b(p){switch(p){case C.Error:return f.default.Error;case C.Warning:return f.default.Warning;case C.Info:return f.default.Info;case C.Hint:return f.default.Ignore}}C.toSeverity=b}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(C){const A="";function R(l){return y(l,!0)}C.makeKey=R;function y(l,b){let p=[A];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(A),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(A),l.severity!==void 0&&l.severity!==null?p.push(T.toString(l.severity)):p.push(A),l.message&&b?p.push(l.message.replace("\xA6","\\\xA6")):p.push(A),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(A),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(A),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(A),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(A),p.push(A),p.join("\xA6")}C.makeKeyOptionalMessage=y})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(pe[189],ve([0,1,3,47,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var D;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(D=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new C,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=P;class C{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=C}),define(pe[190],ve([0,1,6,8,2,4]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function T(C,A){return I.URI.isUri(C)?(0,t.equalsIgnoreCase)(C.scheme,A):(0,t.startsWithIgnoreCase)(C,A+":")}e.matchesScheme=T;function P(C,...A){return A.some(R=>T(C,R))}e.matchesSomeScheme=P}),define(pe[191],ve([0,1,10,12,40,23]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const P=t.globals.vscode.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const P=(0,D.dirname)(f.FileAccess.asFileUri("",Z));T=Z.__$__nodeRequire((0,D.joinPath)(P,"product.json").fsPath);const C=Z.__$__nodeRequire((0,D.joinPath)(P,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:C.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var He=this&&this.__param||function(Z,e){return function(f,t){e(f,t,Z)}};define(pe[118],ve([0,1,17,21,6,4]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,D.createDecorator)("progressService");var T;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let C=class extends I.Disposable{constructor(y,l){super();this.deferred=new f.DeferredPromise,l.withProgress(y,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};C=je([He(1,e.IProgressService)],C),e.UnmanagedProgress=C;class A extends I.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(y){this.stop();const l=++this.currentOperationId,b=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:b.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,D.createDecorator)("editorProgressService")}),define(pe[50],ve([0,1,55,13]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(T,P){f.ok(t.isString(T)),f.ok(t.isObject(P)),f.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new I}),define(pe[192],ve([0,1,3,50]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class D{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,A){this.schemasById[I(C)]=A,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new D;t.Registry.add(e.Extensions.JSONContribution,T)}),define(pe[119],ve([0,1,16,3,13,156,192,50]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=P.Registry.as(T.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(m,o=!0){this.registerConfigurations([m],o)}registerConfigurations(m,o=!0){const S=this.doRegisterConfigurations(m,o);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(m){const o=this.doDeregisterConfigurations(m);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:m,remove:o}){const S=[];S.push(...this.doDeregisterConfigurations(o)),S.push(...this.doRegisterConfigurations(m,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,f.distinct)(S)})}registerDefaultConfigurations(m){const o=[],S=[];for(const{overrides:r,source:i}of m)for(const n in r)if(o.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const u={...this.configurationDefaultsOverrides.get(n)?.value||{},...r[n]};this.configurationDefaultsOverrides.set(n,{source:i,value:u});const c={type:"object",default:u,description:D.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:I.isString(i)?void 0:i};S.push(...p(n)),this.configurationProperties[n]=c,this.defaultLanguageConfigurationOverridesNode.properties[n]=c}else{this.configurationDefaultsOverrides.set(n,{value:r[n],source:i});const u=this.configurationProperties[n];u&&(this.updatePropertyDefaultValue(n,u),this.updateSchema(n,u))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(m){const o=[];for(const{overrides:S,source:r}of m)for(const i in S){const n=this.configurationDefaultsOverrides.get(i),u=I.isString(r)?r:r?.id,c=I.isString(n?.source)?n?.source:n?.source?.id;if(u===c)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const d=this.configurationProperties[i];d&&(this.updatePropertyDefaultValue(i,d),this.updateSchema(i,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const o of m)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(m,o){const S=[];return m.forEach(r=>{S.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),S}doDeregisterConfigurations(m){const o=[],S=r=>{if(r.properties)for(const i in r.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>S(i))};for(const r of m){S(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(m,o=!0,S,r,i=3){i=I.isUndefinedOrNull(m.scope)?i:m.scope;let n=[],u=m.properties;if(u)for(let d in u){if(o&&_(d)){delete u[d];continue}const h=u[d];if(h.source=S,h.defaultDefaultValue=u[d].default,this.updatePropertyDefaultValue(d,h),e.OVERRIDE_PROPERTY_REGEX.test(d)?h.scope=void 0:(h.scope=I.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=I.isUndefinedOrNull(h.restricted)?!!r?.includes(d):h.restricted),u[d].hasOwnProperty("included")&&!u[d].included){this.excludedConfigurationProperties[d]=u[d],delete u[d];continue}else this.configurationProperties[d]=u[d];!u[d].deprecationMessage&&u[d].markdownDeprecationMessage&&(u[d].deprecationMessage=u[d].markdownDeprecationMessage),n.push(d)}let c=m.allOf;if(c)for(let d of c)n.push(...this.validateAndRegisterProperties(d,o,S,r,i));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(m){const o=S=>{let r=S.properties;if(r)for(const n in r)this.updateSchema(n,r[n]);let i=S.allOf;i&&i.forEach(o)};o(m)}updateSchema(m,o){switch(e.allSettings.properties[m]=o,o.scope){case 1:e.applicationSettings.properties[m]=o;break;case 2:e.machineSettings.properties[m]=o;break;case 6:e.machineOverridableSettings.properties[m]=o;break;case 3:e.windowSettings.properties[m]=o;break;case 4:e.resourceSettings.properties[m]=o;break;case 5:e.resourceSettings.properties[m]=o,this.resourceLanguageSettingsSchema.properties[m]=o;break}}removeFromSchema(m,o){switch(delete e.allSettings.properties[m],o.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m],delete this.resourceLanguageSettingsSchema.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const o=`[${m}]`,S={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,S),e.allSettings.properties[o]=S,e.applicationSettings.properties[o]=S,e.machineSettings.properties[o]=S,e.machineOverridableSettings.properties[o]=S,e.windowSettings.properties[o]=S,e.resourceSettings.properties[o]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const m={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,o){const S=this.configurationDefaultsOverrides.get(m);let r=S?.value,i=S?.source;I.isUndefined(r)&&(r=o.defaultDefaultValue,i=void 0),I.isUndefined(r)&&(r=E(o.type)),o.default=r,o.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",b=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(s){const m=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let o=b.exec(s);for(;o?.length;){const S=o[1].trim();S&&m.push(S),o=b.exec(s)}}return(0,f.distinct)(m)}e.overrideIdentifiersFromKey=p;function g(s){return s.reduce((m,o)=>`${m}[${o}]`,"")}e.keyFromOverrideIdentifiers=g;function E(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const L=new y;P.Registry.add(e.Extensions.Configuration,L);function _(s){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?D.localize(7,null,s):L.getConfigurationProperties()[s]!==void 0?D.localize(8,null,s):null:D.localize(6,null)}e.validateProperty=_;function a(){const s=[],m=L.getConfigurationProperties();for(const o of Object.keys(m))s.push([o,m[o].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=a}),define(pe[193],ve([0,1,16,3,57,6,24,25,13,2,116,119,50]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(r={},i=[],n=[]){this._contents=r,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const n=this.getContentsForOverrideIdentifer(i);return n?r?(0,R.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return f.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return f.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),n=P.deepClone(this.overrides),u=[...this.keys];for(const c of r){this.mergeContents(i,c.contents);for(const d of c.overrides){const[h]=n.filter(w=>f.equals(w.identifiers,d.identifiers));h?(this.mergeContents(h.contents,d.contents),h.keys.push(...d.keys),h.keys=f.distinct(h.keys)):n.push(P.deepClone(d))}for(const d of c.keys)u.indexOf(d)===-1&&u.push(d)}return new b(i,u,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const u of f.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[u],d=i[u];d&&(typeof c=="object"&&typeof d=="object"?(c=P.deepClone(c),this.mergeContents(c,d)):c=d),n[u]=c}return new b(n,this.keys,this.overrides)}mergeContents(r,i){for(const n of Object.keys(i)){if(n in r&&C.isObject(r[n])&&C.isObject(i[n])){this.mergeContents(r[n],i[n]);continue}r[n]=P.deepClone(i[n])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,n=null;const u=c=>{c&&(n?this.mergeContents(n,c):n=P.deepClone(c))};for(const c of this.overrides)f.equals(c.identifiers,[r])?i=c.contents:c.identifiers.includes(r)&&u(c.contents);return u(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,R.addToValueTree)(this.contents,r,i,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let n=0;n<i;n++)r.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class p extends b{constructor(r={}){const i=l.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(i),u=Object.create(null),c=[];for(const d in i){const h=r[d],w=h!==void 0?h:i[d].default;(0,R.addToValueTree)(u,d,w,v=>console.error(`Conflict in default settings: ${v}`))}for(const d of Object.keys(u))y.OVERRIDE_PROPERTY_REGEX.test(d)&&c.push({identifiers:(0,y.overrideIdentifiersFromKey)(d),keys:Object.keys(u[d]),contents:(0,R.toValuesTree)(u[d],h=>console.error(`Conflict in default settings file: ${h}`))});super(u,n,c)}}e.DefaultConfigurationModel=p;class g{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!C.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:n,keys:u,overrides:c,restricted:d}=this.doParseRaw(r,i);this._configurationModel=new b(n,u,c),this._restrictedConfigurations=d||[]}doParseContent(r){let i={},n=null,u=[],c=[],d=[];function h(v){Array.isArray(u)?u.push(v):n!==null&&(u[n]=v)}let w={onObjectBegin:()=>{let v={};h(v),c.push(u),u=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{u=c.pop()},onArrayBegin:()=>{let v=[];h(v),c.push(u),u=v,n=null},onArrayEnd:()=>{u=c.pop()},onLiteralValue:h,onError:(v,k,O)=>{d.push({error:v,offset:k,length:O})}};if(r)try{I.visit(r,w),i=u[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return i}doParseRaw(r,i){const n=l.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),u=this.filter(r,n,!0,i);r=u.raw;const c=(0,R.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),d=Object.keys(r),h=this.toOverrides(r,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:c,keys:d,overrides:h,restricted:u.restricted}}filter(r,i,n,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:r,restricted:[]};const c={},d=[];for(let h in r)if(y.OVERRIDE_PROPERTY_REGEX.test(h)&&n){const w=this.filter(r[h],i,!1,u);c[h]=w.raw,d.push(...w.restricted)}else{const w=i[h],v=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&d.push(h),(v===void 0||u.scopes===void 0||u.scopes.includes(v))&&(u.skipRestricted&&w?.restricted||(c[h]=r[h]))}return{raw:c,restricted:d}}toOverrides(r,i){const n=[];for(const u of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(u)){const c={};for(const d in r[u])c[d]=r[u][d];n.push({identifiers:(0,y.overrideIdentifiersFromKey)(u),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,i)})}return n}}e.ConfigurationModelParser=g;class E extends D.Disposable{constructor(r,i,n,u){super();this.userSettingsResource=r,this.scopes=i,this.fileService=u,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class L{constructor(r,i,n=new b,u=new b,c=new T.ResourceMap,d=new b,h=new T.ResourceMap,w=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=u,this._folderConfigurations=c,this._memoryConfiguration=d,this._memoryConfigurationByResource=h,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(r)}updateValue(r,i,n={}){let u;n.resource?(u=this._memoryConfigurationByResource.get(n.resource),u||(u=new b,this._memoryConfigurationByResource.set(n.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(r):u.setValue(r,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,n){const u=this.getConsolidateConfigurationModel(i,n),c=this.getFolderConfigurationModelForResource(i.resource,n),d=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,h=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),w=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),v=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),O=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,U=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(r):c.freeze().getValue(r):void 0,F=i.overrideIdentifier?d.override(i.overrideIdentifier).getValue(r):d.getValue(r),M=u.getValue(r),V=f.distinct(f.flatten(u.overrides.map($=>$.identifiers))).filter($=>u.getOverrideValue(r,$)!==void 0);return{defaultValue:h,userValue:w,userLocalValue:v,userRemoteValue:k,workspaceValue:O,workspaceFolderValue:U,memoryValue:F,value:M,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:c?.freeze().getValue(r),override:i.overrideIdentifier?c?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:d.getValue(r),override:i.overrideIdentifier?d.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:u,updated:c,removed:d}=m(this._defaultConfiguration,r);i=[...u,...c,...d]}for(const u of i)for(const c of(0,y.overrideIdentifiersFromKey)(u)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=r.getKeysForOverrideIdentifier(c),w=[...h.filter(v=>d.indexOf(v)===-1),...d.filter(v=>h.indexOf(v)===-1),...d.filter(v=>!P.equals(this._defaultConfiguration.override(c).getValue(v),r.override(c).getValue(v)))];n.push([c,w])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:u,overrides:c}=m(this.localUserConfiguration,r),d=[...i,...n,...u];return d.length&&this.updateLocalUserConfiguration(r),{keys:d,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:u,overrides:c}=m(this.remoteUserConfiguration,r);let d=[...i,...n,...u];return d.length&&this.updateRemoteUserConfiguration(r),{keys:d,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:u,overrides:c}=m(this.workspaceConfiguration,r);let d=[...i,...n,...u];return d.length&&this.updateWorkspaceConfiguration(r),{keys:d,overrides:c}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:u,updated:c,removed:d,overrides:h}=m(n,i);let w=[...u,...c,...d];return(w.length||!n)&&this.updateFolderConfiguration(r,i),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:u,removed:c,overrides:d}=m(i,void 0);return{keys:[...n,...u,...c],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let n=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?n.override(r.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:r},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const u=i.getFolder(r);u&&(n=this.getFolderConsolidatedConfiguration(u.uri)||n);const c=this._memoryConfigurationByResource.get(r);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(r);u?(i=n.merge(u),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=n}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:n,overrides:u,keys:c}=this._folderConfigurations.get(i);return r.push([i,{contents:n,overrides:u,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.user),u=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((d,h)=>(d.set(A.URI.revive(h[0]),this.parseConfigurationModel(h[1])),d),new T.ResourceMap);return new L(i,n,new b,u,c,new b,new T.ResourceMap,!1)}static parseConfigurationModel(r){return new b(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=L;function _(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const r=new Set,i=new Map;for(const u of S)u.keys.forEach(c=>r.add(c)),u.overrides.forEach(([c,d])=>{const h=(0,T.getOrSet)(i,c,new Set);d.forEach(w=>h.add(w))});const n=[];return i.forEach((u,c)=>n.push([c,[...u.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=_;class a{constructor(r,i,n,u){this.change=r,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=u,this._previousConfiguration=void 0;const c=new Set;r.keys.forEach(h=>c.add(h)),r.overrides.forEach(([,h])=>h.forEach(w=>c.add(w))),this.affectedKeys=[...c.values()];const d=new b;this.affectedKeys.forEach(h=>d.setValue(h,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=L.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!P.equals(n,u)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let n=(0,R.toValuesTree)({[i]:!0},()=>{}),u;for(;typeof n=="object"&&(u=Object.keys(n)[0]);){if(r=r[u],!r)return!1;n=n[u]}return!0}}e.ConfigurationChangeEvent=a;class s extends a{constructor(r,i,n,u){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=n,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=s;function m(S,r){const{added:i,removed:n,updated:u}=o(r,S),c=[],d=S?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const w=h.filter(v=>!d.includes(v));for(const v of w)c.push([v,r.getKeysForOverrideIdentifier(v)])}if(S){const w=d.filter(v=>!h.includes(v));for(const v of w)c.push([v,S.getKeysForOverrideIdentifier(v)])}if(r&&S){for(const w of d)if(h.includes(w)){const v=o({contents:S.getOverrideValue(void 0,w)||{},keys:S.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});c.push([w,[...v.added,...v.removed,...v.updated]])}}return{added:i,removed:n,updated:u,overrides:c}}function o(S,r){const i=S?r?S.keys.filter(c=>r.keys.indexOf(c)===-1):[...S.keys]:[],n=r?S?r.keys.filter(c=>S.keys.indexOf(c)===-1):[...r.keys]:[],u=[];if(S&&r){for(const c of r.keys)if(S.keys.indexOf(c)!==-1){const d=(0,R.getConfigurationValue)(r.contents,c),h=(0,R.getConfigurationValue)(S.contents,c);P.equals(d,h)||u.push(c)}}return{added:i,removed:n,updated:u}}}),define(pe[120],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var t;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(T,P=t.Unknown,C){super(T);this._message=T,this._code=P,this._detail=C,this.isHandled=P===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(T){return T instanceof I&&T._code===t.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof I&&T._code===t.NoResolverFound}static isHandled(T){return T instanceof I&&T.isHandled}}e.RemoteAuthorityResolverError=I}),define(pe[63],ve([0,1,10]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(A){return A.scheme===f.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=t;function I(A){if(!A)return;const R=A.indexOf("+");return R<0?A:A.substr(0,R)}e.getRemoteName=I;function D(A){return A.scheme!==f.Schemas.file&&A.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=D;function T(A){if(A.folders.length)return A.folders.every(R=>D(R.uri))?A.folders[0].uri:void 0;if(A.configuration&&D(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=T;function P(A){return T(A)?.scheme}e.getVirtualWorkspaceScheme=P;function C(A){return T(A)!==void 0}e.isVirtualWorkspace=C}),define(pe[27],ve([0,1,8,4,63]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=D;function T(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,p){if(typeof b=="undefined"||b===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof b=="string"||typeof p=="string"){let g=typeof b=="string"?b:b.value,E=typeof p=="string"?p:p.value;return f.equalsIgnoreCase(g,E)}return b._lower===p._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=C;function A(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function R(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function y(l,b){if(b){const p=`onResolveRemoteAuthority:${(0,I.getRemoteName)(b)}`;return l.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[194],ve([0,1,8,27]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(p,g){return p.uuid&&g.uuid?p.uuid===g.uuid:p.id===g.id?!0:(0,f.compareIgnoreCase)(p.id,g.id)===0}e.areSameExtensions=I;class D{constructor(g,E){this.version=E,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof D?I(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=D;function T(p,g){return`${p}.${g}`}e.getExtensionId=T;function P(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function C(p,g){return P(T(p,g))}e.getGalleryExtensionId=C;function A(p,g){const E=[],L=_=>{for(const a of E)if(a.some(s=>I(g(s),g(_))))return a;return null};for(const _ of p){const a=L(_);a?a.push(_):E.push([_])}return E}e.groupByExtension=A;function R(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function y(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function l(p){const g=new Set;if(p.malicious)for(const E of p.malicious)g.add(E.id);return g}e.getMaliciousExtensionsSet=l;function b(p,g){const E=[],L=g.manifest.extensionDependencies?.slice(0)??[];for(;L.length;){const _=L.shift();if(_&&E.every(a=>!I(a.identifier,{id:_}))){const a=p.filter(s=>I(s.identifier,{id:_}));a.length===1&&(E.push(a[0]),L.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=b}),define(pe[121],ve([0,1,3,12,4,11]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var T;(function(p){p.Http="http",p.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=y;function l(p,g){return g?g!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=l;let b=class{constructor(g){this.logService=g,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],E=Array.from(this._tunnels.values());for(let L of E){const _=Array.from(L.values());for(let a of _){const s=await a.value;s&&g.push(s)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:E}of g.values())await E.then(L=>L?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,E,L,_,a=!1,s=P.Private,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${L} on local port ${_}.`),!g)return;E||(E="localhost");const o=this.retainOrCreateTunnel(g,E,L,_,a,s,m);return o?o.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,L);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(S);return(S.tunnelRemoteHost!==E||S.tunnelRemotePort!==L)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const E=this._tunnels.get(g.tunnelRemoteHost);if(E){const L=E.get(g.tunnelRemotePort);L&&(L.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,L))}}}}async tryDisposeTunnel(g,E,L){if(L.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${E}.`);const _=L.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(E),_}}async closeTunnel(g,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${E} `);const L=this._tunnels.get(g);if(L&&L.has(E)){const _=L.get(E);_.refcount=0,await this.tryDisposeTunnel(g,E,_)}}addTunnelToMap(g,E,L){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(E,{refcount:1,value:L})}async removeEmptyTunnelFromMap(g,E){const L=this._tunnels.get(g);L&&(await L.get(E)||L.delete(E),L.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,E){let L=[g];R(g)?(L.push(...e.LOCALHOST_ADDRESSES),L.push(...e.ALL_INTERFACES_ADDRESSES)):y(g)&&L.push(...e.ALL_INTERFACES_ADDRESSES);const _=L.map(a=>this._tunnels.get(a));for(const a of _){const s=a?.get(E);if(s)return s}}canTunnel(g){return!!A(g)}createWithProvider(g,E,L,_,a,s,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${L} on local port ${_}.`);const S={elevationRequired:a?l(_===void 0?L:_):!1},r={remoteAddress:{host:E,port:L},localAddressPort:_,privacy:s,public:s!==P.Private,protocol:m},i=g.forwardPort(r,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(E,L,i),i}};b=je([He(0,D.ILogService)],b),e.AbstractTunnelService=b}),define(pe[195],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{constructor(){this.validators=new Map}vsda(){return new Promise((I,D)=>Z(["vsda"],I,D))}async createNewMessage(I){try{const D=await this.vsda(),T=new D.validator;if(T){const P=String(f._nextId++);return this.validators.set(P,T),{id:P,data:T.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,D){if(!I.id)return!0;const T=this.validators.get(I.id);if(!T)return!1;this.validators.delete(I.id);try{return T.validate(D)==="ok"}catch{return!1}}async sign(I){try{const D=await this.vsda(),T=new D.signer;if(T)return T.sign(I)}catch{}return I}}e.SignService=f,f._nextId=1}),define(pe[196],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,D,T=5){let P;return P=D(C=>{const A=typeof C=="string"?C:C.data;let R=this._terminalBufferMap.get(I);if(R){R.data.push(A);return}const y=setTimeout(()=>this.flushBuffer(I),T);R={data:[A],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(I),P.dispose()}},this._terminalBufferMap.set(I,R)}),P}stopBuffering(I){const D=this._terminalBufferMap.get(I);D&&D.dispose()}flushBuffer(I){const D=this._terminalBufferMap.get(I);D&&(this._terminalBufferMap.delete(I),this._callback(I,D.data.join("")))}}e.TerminalDataBufferer=f}),define(pe[197],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(pe[85],ve([0,1,74,3,6,4,50,197]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var C;(function(E){function L(_){return _&&typeof _=="object"&&typeof _.id=="string"}E.isThemeColor=L})(C=e.ThemeColor||(e.ThemeColor={}));function A(E){return{id:E}}e.themeColorFromId=A;var R;(function(E){function L(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||C.isThemeColor(i.color))}E.isThemeIcon=L;const _=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function a(i){const n=_.exec(i);if(!n)return;let[,u]=n;return{id:u}}E.fromString=a;function s(i){return{id:i}}E.fromId=s;function m(i,n){let u=i.id;const c=u.lastIndexOf("~");return c!==-1&&(u=u.substring(0,c)),n&&(u=`${u}~${n}`),{id:u}}E.modify=m;function o(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}E.getModifier=o;function S(i,n){return i.id===n.id&&i.color?.id===n.color?.id}E.isEqual=S;function r(i,n){return{id:i.id,color:n?A(n):void 0}}E.asThemeIcon=r,E.asClassNameArray=f.CSSIcon.asClassNameArray,E.asClassName=f.CSSIcon.asClassName,E.asCSSSelector=f.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function y(E){switch(E){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(L){return this.themingParticipants.push(L),this.onThemingParticipantAddedEmitter.fire(L),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(L);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new l;T.Registry.add(e.Extensions.ThemingContribution,b);function p(E){return b.onColorThemeChange(E)}e.registerThemingParticipant=p;class g extends I.Disposable{constructor(L){super();this.themeService=L,this.theme=L.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(L){this.theme=L,this.updateStyles()}updateStyles(){}getColor(L,_){let a=this.theme.getColor(L);return a&&_&&(a=_(a,this.theme)),a?a.toString():null}}e.Themable=g}),define(pe[43],ve([0,1,24,23,2,4]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var T;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function P(l){const b=l;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=P;function C(l){const b=l;return!!(b&&typeof b=="object"&&I.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=C;class A{constructor(b,p,g,E,L){this._id=b,this._transient=g,this._configuration=E,this._ignorePathCasing=L,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=p}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=A;class R{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,t.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function y(l){return new R({uri:l,index:0,name:(0,t.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=y}),define(pe[198],ve([0,1,29,57,140,80,10,9,12,23,2,162,4,63,43]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(N){return(typeof N=="string"?(0,P.extname)(N):(0,A.extname)(N))===g}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function L(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=L;function _(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=_;function a(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=a;function s(N){return N&&N.hasOwnProperty("folderUri")}e.isFolderBackupInfo=s;function m(N){return N&&N.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=m;function o(N){const B=N;return typeof B?.id=="string"&&R.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=o;function S(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=S;function r(N){const B=N;return typeof B?.id=="string"&&R.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=r;function i(N){const B=N;if(B?.uri)return{id:B.id,uri:R.URI.revive(B.uri)};const x=N;if(x?.configPath)return{id:x.id,configPath:R.URI.revive(x.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=i;function n(N,B){return A.extUriBiasedIgnorePathCase.isEqualOrParent(N,B.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function u(N){return c(N)||d(N)}e.isStoredWorkspaceFolder=u;function c(N){const B=N;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=c;function d(N){const B=N;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=d;function h(N,B,x,z,W=!C.isWindows,J){if(N.scheme!==z.scheme)return{name:x,uri:N.toString(!0)};let se=B?void 0:J.relativePath(z,N);if(se!==void 0)se.length===0?se=".":C.isWindows&&N.scheme===T.Schemas.file&&!W&&(se=se.replace(/\//g,"\\"));else if(N.scheme===T.Schemas.file)se=N.fsPath,C.isWindows&&(se=(0,D.normalizeDriveLetter)(se),W&&(se=(0,f.toSlashes)(se)));else{if(!J.isEqualAuthority(N.authority,z.authority))return{name:x,uri:N.toString(!0)};se=N.path}return{name:x,path:se}}e.getStoredWorkspaceFolder=h;function w(N,B,x){let z=[],W=new Set;const J=x.dirname(B);for(let se of N){let ie;if(c(se))se.path&&(ie=x.resolvePath(J,se.path));else if(d(se))try{ie=R.URI.parse(se.uri),ie.path[0]!=="/"&&(ie=ie.with({path:"/"+ie.path}))}catch(K){console.warn(K)}if(ie){let K=x.getComparisonKey(ie);if(!W.has(K)){W.add(K);const Y=se.name||x.basenameOrAuthority(ie);z.push(new p.WorkspaceFolder({uri:ie,name:Y,index:z.length},se))}}}return z}e.toWorkspaceFolders=w;function v(N,B,x,z,W){let J=k(B,N);const se=W.dirname(B),ie=W.dirname(z),K=[],Y=O(J.folders);for(const Me of J.folders){const Ve=c(Me)?W.resolvePath(se,Me.path):R.URI.parse(Me.uri);let Ge;x?Ge=!1:Ge=!c(Me)||(0,P.isAbsolute)(Me.path),K.push(h(Ve,Ge,Me.name,ie,Y,W))}const le={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},fe=I.setProperty(N,["folders"],K,le);let Se=I.applyEdits(N,fe);return(0,A.isEqualAuthority)(J.remoteAuthority,(0,b.getRemoteAuthority)(z))&&(Se=I.applyEdits(Se,I.removeProperty(Se,["remoteAuthority"],le))),Se}e.rewriteWorkspaceFileForNewLocation=v;function k(N,B){let x=t.parse(B);if(x&&Array.isArray(x.folders))x.folders=x.folders.filter(z=>u(z));else throw new Error(`${N} looks like an invalid workspace file.`);return x}function O(N){return C.isWindows?N.some(B=>c(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function U(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function F(N){return typeof N.folderUri=="string"}function M(N){return typeof N.fileUri=="string"}function V(N,B){const x={workspaces:[],files:[]};if(N){const z=function(J,se){for(let ie=0;ie<J.length;ie++)try{se(J[ie],ie)}catch(K){B.warn(`Error restoring recent entry ${JSON.stringify(J[ie])}: ${K.toString()}. Skip entry.`)}},W=N;if(Array.isArray(W.entries))z(W.entries,J=>{const se=J.label,ie=J.remoteAuthority;U(J)?x.workspaces.push({label:se,remoteAuthority:ie,workspace:{id:J.workspace.id,configPath:R.URI.parse(J.workspace.configPath)}}):F(J)?x.workspaces.push({label:se,remoteAuthority:ie,folderUri:R.URI.parse(J.folderUri)}):M(J)&&x.files.push({label:se,remoteAuthority:ie,fileUri:R.URI.parse(J.fileUri)})});else{const J=N;Array.isArray(J.workspaces3)&&z(J.workspaces3,(se,ie)=>{const K=Array.isArray(J.workspaceLabels)&&J.workspaceLabels[ie]||void 0;typeof se=="object"&&typeof se.id=="string"&&typeof se.configURIPath=="string"?x.workspaces.push({label:K,workspace:{id:se.id,configPath:R.URI.parse(se.configURIPath)}}):typeof se=="string"&&x.workspaces.push({label:K,folderUri:R.URI.parse(se)})}),Array.isArray(J.files2)&&z(J.files2,(se,ie)=>{const K=Array.isArray(J.fileLabels)&&J.fileLabels[ie]||void 0;typeof se=="string"&&x.files.push({label:K,fileUri:R.URI.parse(se)})})}}return x}e.restoreRecentlyOpened=V;function $(N){const B={entries:[]};for(const x of N.workspaces)_(x)?B.entries.push({folderUri:x.folderUri.toString(),label:x.label,remoteAuthority:x.remoteAuthority}):B.entries.push({workspace:{id:x.workspace.id,configPath:x.workspace.configPath.toString()},label:x.label,remoteAuthority:x.remoteAuthority});for(const x of N.files)B.entries.push({fileUri:x.fileUri.toString(),label:x.label,remoteAuthority:x.remoteAuthority});return B}e.toStoreData=$}),define(pe[86],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const D=this._idPool++;return this._data.set(D,I),this.logDebugInfo(),D}get(I,D){return this._data.has(I)?this._data.get(I)[D]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(pe[44],ve([0,1,10,23,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(P=>{const C=this._providerInfo.get(P.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(P,C){C===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,C)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(pe[26],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(pe[199],ve([0,1,17]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(T,P,C){this._deferredPromises=new Map,this._id=T,this._shared=P,this._storage=C,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of A.values())R.complete()}catch(R){for(const y of A.values())y.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,P){let C=this._value[T];return typeof C=="undefined"&&(C=P),C}update(T,P){this._value[T]=P;let C=this._deferredPromises.get(T);if(C!==void 0)return C.p;const A=new f.DeferredPromise;return this._deferredPromises.set(T,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{constructor(T,P){super(T.identifier.value,!0,P);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=I}),define(pe[200],ve([0,1,3,2,11]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let D=class{constructor(P,C){this._logService=P,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,C,A){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptModelChanged(C.value,A)}$acceptDirtyStateChanged(P,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptDirty(C)}$acceptModelSaved(P){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(P,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,C);const A=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));A.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};D=je([He(0,I.ILogService)],D),e.ExtHostNotebookDocuments=D}),define(pe[14],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class t{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[201],ve([0,1,27,3]),function(Z,e,f,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class D{constructor(P,C){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(P.identifier),nt(this,I,C,"f"),Le(this,I,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(P){return Le(this,I,"f").get(this._id,P)}store(P,C){return Le(this,I,"f").store(this._id,P,C)}delete(P){return Le(this,I,"f").delete(this._id,P)}}e.ExtensionSecrets=D,I=new WeakMap}),define(pe[122],ve([0,1,4,3]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(pe[64],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,I=(_,a)=>{const s={controllerId:a};return t.set(_,s),s};e.createPrivateApiFor=I;const D=_=>t.get(_);e.getPrivateApiFor=D;const T=(_,a,s,m)=>{let o=s;return{enumerable:!0,configurable:!1,get(){return o},set(S){if(!m(o,S)){const r=o;o=S,_.listener?.({op:3,key:a,value:S,previous:r})}}}},P=(_,a)=>_===a,C={range:(_,a)=>_===a?!0:!_||!a?!1:_.isEqual(a),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(_,a)=>!(_.length!==a.length||_.some(s=>!a.find(m=>s.id===m.id)))},A=Object.keys(C),R=(_,a)=>({range:T(_,"range",void 0,C.range),label:T(_,"label",a,C.label),description:T(_,"description",void 0,C.description),canResolveChildren:T(_,"canResolveChildren",!1,C.canResolveChildren),busy:T(_,"busy",!1,C.busy),error:T(_,"error",void 0,C.error),tags:T(_,"tags",[],C.tags)}),y=(_,a)=>{const s=new Map;for(const m of A)C[m](_[m],a[m])||s.set(m,a[m]);return s};e.diffTestItems=y;class l extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=l;class b extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class p extends Error{constructor(a,s,m){super(`TestItem with ID "${a}" is from controller "${s}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=p;const g=_=>{const a=(0,e.getPrivateApiFor)(_);let s=new Map;return{get size(){return s.size},forEach(m,o){for(const S of s.values())m.call(o,S,this)},replace(m){const o=new Map,S=new Set(s.keys()),r={op:4,ops:[]};for(const i of m){if(!(i instanceof E))throw new b(i.id);const n=(0,e.getPrivateApiFor)(i).controllerId;if(n!==a.controllerId)throw new p(i.id,n,a.controllerId);if(o.has(i.id))throw new l(i.id);o.set(i.id,i),S.delete(i.id),r.ops.push({op:0,item:i})}for(const i of S.keys())r.ops.push({op:1,id:i});a.listener?.(r),s=o},add(m){if(!(m instanceof E))throw new b(m.id);s.set(m.id,m),a.listener?.({op:0,item:m})},delete(m){s.delete(m)&&a.listener?.({op:1,id:m})},get(m){return s.get(m)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class E{constructor(a,s,m,o){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const S=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof L?void 0:S.parent}},children:{value:g(this),enumerable:!0,writable:!1},...R(S,m)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=E;class L extends E{constructor(a,s){super(a,a,s,void 0)}}e.TestItemRootImpl=L}),define(pe[51],ve([0,1,4,121,3,14]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(C){function A(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:y.protocol}}C.fromApiTunnel=A;function R(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==t.TunnelPrivacyId.ConstantPrivate&&y.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}C.fromServiceTunnel=R})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let P=class{constructor(A){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,R){}async getTunnels(){return[]}async setTunnelFactory(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,R){return{dispose:()=>{}}}async $providePortAttributes(A,R,y,l,b){return[]}async $forwardPort(A,R){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=je([He(0,D.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[7],ve([0,1,16,15,99,24,95,8,13,2,33,42,120]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l){"use strict";var b,p,g,E,L,_,a,s,m,o,S,r,i,n,u,c,d,h,w,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(j){function H(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(H,j),Object.setPrototypeOf(H.prototype,j.prototype),H}let O=L=class{constructor(H){b.set(this,void 0),nt(this,b,H,"f")}static from(...H){let ue=H;return new L(function(){if(ue){for(const Pe of ue)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ue=void 0}})}dispose(){typeof Le(this,b,"f")=="function"&&(Le(this,b,"f").call(this),nt(this,b,void 0,"f"))}};b=new WeakMap,O=L=je([k],O),e.Disposable=O;let U=_=class{constructor(H,ue){if(H<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=H,this._character=ue}static Min(...H){if(H.length===0)throw new TypeError;let ue=H[0];for(let Pe=1;Pe<H.length;Pe++){const et=H[Pe];et.isBefore(ue)&&(ue=et)}return ue}static Max(...H){if(H.length===0)throw new TypeError;let ue=H[0];for(let Pe=1;Pe<H.length;Pe++){const et=H[Pe];et.isAfter(ue)&&(ue=et)}return ue}static isPosition(H){if(!H)return!1;if(H instanceof _)return!0;let{line:ue,character:Pe}=H;return typeof ue=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,ue=0){if(H===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof H=="undefined"?Pe=0:typeof H=="number"?Pe=H:(Pe=typeof H.lineDelta=="number"?H.lineDelta:0,ue=typeof H.characterDelta=="number"?H.characterDelta:0),Pe===0&&ue===0?this:new _(this.line+Pe,this.character+ue)}with(H,ue=this.character){if(H===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof H=="undefined"?Pe=this.line:typeof H=="number"?Pe=H:(Pe=typeof H.line=="number"?H.line:this.line,ue=typeof H.character=="number"?H.character:this.character),Pe===this.line&&ue===this.character?this:new _(Pe,ue)}toJSON(){return{line:this.line,character:this.character}}};U=_=je([k],U),e.Position=U;let F=a=class{constructor(H,ue,Pe,et){let at,dt;if(typeof H=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new U(H,ue),dt=new U(Pe,et)):H instanceof U&&ue instanceof U&&(at=H,dt=ue),!at||!dt)throw new Error("Invalid arguments");at.isBefore(dt)?(this._start=at,this._end=dt):(this._start=dt,this._end=at)}static isRange(H){return H instanceof a?!0:H?U.isPosition(H.start)&&U.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof a?this.contains(H._start)&&this.contains(H._end):H instanceof U?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const ue=U.Max(H.start,this._start),Pe=U.Min(H.end,this._end);if(!ue.isAfter(Pe))return new a(ue,Pe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ue=U.Min(H.start,this._start),Pe=U.Max(H.end,this.end);return new a(ue,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,ue=this.end){if(H===null||ue===null)throw(0,t.illegalArgument)();let Pe;return H?U.isPosition(H)?Pe=H:(Pe=H.start||this.start,ue=H.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ue.isEqual(this.end)?this:new a(Pe,ue)}toJSON(){return[this.start,this.end]}};F=a=je([k],F),e.Range=F;let M=s=class extends F{constructor(H,ue,Pe,et){let at,dt;if(typeof H=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new U(H,ue),dt=new U(Pe,et)):H instanceof U&&ue instanceof U&&(at=H,dt=ue),!at||!dt)throw new Error("Invalid arguments");super(at,dt);this._anchor=at,this._active=dt}static isSelection(H){return H instanceof s?!0:H?F.isRange(H)&&U.isPosition(H.anchor)&&U.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=s=je([k],M),e.Selection=M;class V{constructor(H,ue,Pe){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(ue),this.connectionToken=Pe}}e.ResolvedAuthority=V;class $ extends Error{constructor(H,ue=l.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(H);this._message=H,this._code=ue,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(H,ue){return new $(H,l.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(H){return new $(H,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var N;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var B;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=m=class{constructor(H,ue){this._range=H,this._newText=ue}static isTextEdit(H){return H instanceof m?!0:H?F.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ue){return new m(H,ue)}static insert(H,ue){return m.replace(new F(H,H),ue)}static delete(H){return m.replace(H,"")}static setEndOfLine(H){const ue=new m(new F(new U(0,0),new U(0,0)),"");return ue.newEol=H,ue}get range(){return this._range}set range(H){if(H&&!F.isRange(H))throw(0,t.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,t.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,t.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};x=m=je([k],x),e.TextEdit=x;var z;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let W=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,ue,Pe,et){this._edits.push({_type:1,from:H,to:ue,options:Pe,metadata:et})}createFile(H,ue,Pe){this._edits.push({_type:1,from:void 0,to:H,options:ue,metadata:Pe})}deleteFile(H,ue,Pe){this._edits.push({_type:1,from:H,to:void 0,options:ue,metadata:Pe})}replaceNotebookMetadata(H,ue,Pe){this._edits.push({_type:3,metadata:Pe,uri:H,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(H,ue,Pe,et,at){let dt,mt,At=[],Lt;if($t.isNotebookRange(ue)&&Bt.isNotebookCellDataArray(Pe)&&!Bt.isNotebookCellDataArray(et)?(dt=ue.start,mt=ue.end,At=Pe,Lt=et):typeof ue=="number"&&typeof Pe=="number"&&Bt.isNotebookCellDataArray(et)&&(dt=ue,mt=Pe,At=et,Lt=at),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||At.length>0)&&this._edits.push({_type:5,uri:H,index:dt,count:mt-dt,cells:At,metadata:Lt})}replaceNotebookCellMetadata(H,ue,Pe,et){this._edits.push({_type:3,metadata:et,uri:H,edit:{editType:8,index:ue,metadata:Pe}})}replace(H,ue,Pe,et){this._edits.push({_type:2,uri:H,edit:new x(ue,Pe),metadata:et})}insert(H,ue,Pe,et){this.replace(H,new F(ue,ue),Pe,et)}delete(H,ue,Pe){this.replace(H,ue,"",Pe)}has(H){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===H.toString())}set(H,ue){if(ue)for(const Pe of ue)Pe&&this._edits.push({_type:2,uri:H,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const et=this._edits[Pe];et._type===2&&et.uri.toString()===H.toString()&&(this._edits[Pe]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(H){const ue=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===H.toString()&&ue.push(Pe.edit);return ue}entries(){const H=new D.ResourceMap;for(let ue of this._edits)if(ue._type===2){let Pe=H.get(ue.uri);Pe||(Pe=[ue.uri,[]],H.set(ue.uri,Pe)),Pe[1].push(ue.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};W=je([k],W),e.WorkspaceEdit=W;let J=o=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof o?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=o._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ue=this._tabstop++){if(typeof H=="function"){const Pe=new o;Pe._tabstop=this._tabstop,H(Pe),this._tabstop=Pe._tabstop,H=Pe.value}else H=o._escape(H);return this.value+="${",this.value+=ue,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ue=this._tabstop++){const Pe=H.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(H,ue){if(typeof ue=="function"){const Pe=new o;Pe._tabstop=this._tabstop,ue(Pe),this._tabstop=Pe._tabstop,ue=Pe.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};J=o=je([k],J),e.SnippetString=J;var se;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ie;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=S=class{constructor(H,ue){if(this.uri=H,ue)if(ue instanceof F)this.range=ue;else if(ue instanceof U)this.range=new F(ue,ue);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof S?!0:H?F.isRange(H.range)&&A.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=S=je([k],K),e.Location=K;let Y=class{constructor(H,ue){this.location=H,this.message=ue}static is(H){return H?typeof H.message=="string"&&H.location&&F.isRange(H.location.range)&&A.URI.isUri(H.location.uri):!1}static isEqual(H,ue){return H===ue?!0:!H||!ue?!1:H.message===ue.message&&H.location.range.isEqual(ue.location.range)&&H.location.uri.toString()===ue.location.uri.toString()}};Y=je([k],Y),e.DiagnosticRelatedInformation=Y;let le=class{constructor(H,ue,Pe=ie.Error){if(!F.isRange(H))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=H,this.message=ue,this.severity=Pe}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ue){return H===ue?!0:!H||!ue?!1:H.message===ue.message&&H.severity===ue.severity&&H.code===ue.code&&H.severity===ue.severity&&H.source===ue.source&&H.range.isEqual(ue.range)&&(0,f.equals)(H.tags,ue.tags)&&(0,f.equals)(H.relatedInformation,ue.relatedInformation,Y.isEqual)}};le=je([k],le),e.Diagnostic=le;let fe=class{constructor(H,ue){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ue}};fe=je([k],fe),e.Hover=fe;var Se;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor(H,ue=Se.Text){this.range=H,this.kind=ue}toJSON(){return{range:this.range,kind:Se[this.kind]}}};Me=je([k],Me),e.DocumentHighlight=Me;var Ve;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var Ge;(function(j){j[j.Deprecated=1]="Deprecated"})(Ge=e.SymbolTag||(e.SymbolTag={}));let Ye=r=class{constructor(H,ue,Pe,et,at){this.name=H,this.kind=ue,this.containerName=at,typeof Pe=="string"&&(this.containerName=Pe),et instanceof K?this.location=et:Pe instanceof F&&(this.location=new K(et,Pe)),r.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};Ye=r=je([k],Ye),e.SymbolInformation=Ye;let q=i=class{constructor(H,ue,Pe,et,at){this.name=H,this.detail=ue,this.kind=Pe,this.range=et,this.selectionRange=at,this.children=[],i.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(i.validate)}};q=i=je([k],q),e.DocumentSymbol=q;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(H,ue){this.title=H,this.kind=ue}};G=je([k],G),e.CodeAction=G;let Q=n=class{constructor(H){this.value=H}append(H){return new n(this.value?this.value+n.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+n.sep)}};Q.sep=".",Q=n=je([k],Q),e.CodeActionKind=Q,Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll");let oe=class{constructor(H,ue){if(this.range=H,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=je([k],oe),e.SelectionRange=oe;class me{constructor(H,ue,Pe,et,at,dt){this.kind=H,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.CallHierarchyItem=me;class Ie{constructor(H,ue){this.fromRanges=ue,this.from=H}}e.CallHierarchyIncomingCall=Ie;class xe{constructor(H,ue){this.fromRanges=ue,this.to=H}}e.CallHierarchyOutgoingCall=xe;var Xe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor(H,ue){this.range=H,this.command=ue}get isResolved(){return!!this.command}};it=je([k],it),e.CodeLens=it;let st=u=class{constructor(H,ue=!1){p.set(this,void 0),nt(this,p,new I.MarkdownString(H,{supportThemeIcons:ue}),"f")}static isMarkdownString(H){return H instanceof u?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Le(this,p,"f").value}set value(H){Le(this,p,"f").value=H}get isTrusted(){return Le(this,p,"f").isTrusted}set isTrusted(H){Le(this,p,"f").isTrusted=H}get supportThemeIcons(){return Le(this,p,"f").supportThemeIcons}set supportThemeIcons(H){Le(this,p,"f").supportThemeIcons=H}get supportHtml(){return Le(this,p,"f").supportHtml}set supportHtml(H){Le(this,p,"f").supportHtml=H}appendText(H){return Le(this,p,"f").appendText(H),this}appendMarkdown(H){return Le(this,p,"f").appendMarkdown(H),this}appendCodeblock(H,ue){return Le(this,p,"f").appendCodeblock(ue??"",H),this}};p=new WeakMap,st=u=je([k],st),e.MarkdownString=st;let ot=class{constructor(H,ue){this.label=H,this.documentation=ue}};ot=je([k],ot),e.ParameterInformation=ot;let tt=class{constructor(H,ue){this.label=H,this.documentation=ue,this.parameters=[]}};tt=je([k],tt),e.SignatureInformation=tt;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=je([k],rt),e.SignatureHelp=rt;var gt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let It=class{constructor(H){this.label=H}toString(){return this.label}};It=je([k],It),e.InlayHintLabelPart=It;let ee=class{constructor(H,ue,Pe){this.label=H,this.position=ue,this.kind=Pe}};ee=je([k],ee),e.InlayHint=ee;var ne;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(j){j[j.Deprecated=1]="Deprecated"})(re=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(H,ue){this.label=H,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=je([k],Ce),e.CompletionItem=Ce;let Fe=class{constructor(H=[],ue=!1){this.items=H,this.isIncomplete=ue}};Fe=je([k],Fe),e.CompletionList=Fe;let qe=class{constructor(H,ue,Pe){this.text=H,this.range=ue,this.command=Pe}};qe=je([k],qe),e.InlineSuggestion=qe;let ze=class{constructor(H){this.items=H}};ze=je([k],ze),e.InlineSuggestions=ze;var ut;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ut=e.ViewColumn||(e.ViewColumn={}));var Re;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ce;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var de;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var we;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(we=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ye;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(ye=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function H(ue){switch(ue){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=H}(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Oe=class{constructor(H,ue){if(ue&&!A.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!F.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.target=ue}};Oe=je([k],Oe),e.DocumentLink=Oe;let Ke=class{constructor(H,ue,Pe,et){this.red=H,this.green=ue,this.blue=Pe,this.alpha=et}};Ke=je([k],Ke),e.Color=Ke;let We=class{constructor(H,ue){if(ue&&!(ue instanceof Ke))throw(0,t.illegalArgument)("color");if(!F.isRange(H)||H.isEmpty)throw(0,t.illegalArgument)("range");this.range=H,this.color=ue}};We=je([k],We),e.ColorInformation=We;let Ze=class{constructor(H){if(!H||typeof H!="string")throw(0,t.illegalArgument)("label");this.label=H}};Ze=je([k],Ze),e.ColorPresentation=Ze;var lt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(lt=e.ColorFormat||(e.ColorFormat={}));var ct;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ct=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class $e{constructor(H,ue,Pe){if(this.startIndex=H,this.length=ue,this.tooltip=Pe,typeof H!="number"||H<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=$e;var be;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(be=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(H){this.options=H,typeof H!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=_e;var he;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let ke=c=class{constructor(H,ue){if(this.label=ue,typeof H!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};ke.Clean=new c("clean","Clean"),ke.Build=new c("build","Build"),ke.Rebuild=new c("rebuild","Rebuild"),ke.Test=new c("test","Test"),ke=c=je([k],ke),e.TaskGroup=ke;function Be(j){let H="";for(let ue=0;ue<j.length;ue++)H+=j[ue].replace(/,/g,",,")+",";return H}let Je=class{constructor(H,ue,Pe){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=H,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Pe):this._options=ue)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,t.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)H.push(ue);return Be(H)}};Je=je([k],Je),e.ProcessExecution=Je;let Qe=class{constructor(H,ue,Pe){if(this._args=[],Array.isArray(ue)){if(!H)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H,this._args=ue,this._options=Pe}else{if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,t.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)H.push(typeof ue=="string"?ue:ue.value);return Be(H)}};Qe=je([k],Qe),e.ShellExecution=Qe;var pt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class Ct{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=Ct;let ft=d=class{constructor(H,ue,Pe,et,at,dt){this.__deprecated=!1,this._definition=this.definition=H;let mt;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Pe,this.execution=et,mt=at,this.__deprecated=!0):ue===St.Global||ue===St.Workspace?(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt):(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Je?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const ue=this._definition.type;(d.EmptyType===ue||d.ProcessType===ue||d.ShellType===ue||d.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=d=je([k],ft),e.Task=ft;var wt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(H,ue=Ut.None){this.collapsibleState=ue,A.URI.isUri(H)?this.resourceUri=H:this.label=H}};bt=je([k],bt),e.TreeItem=bt;var Ut;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor(H){this._value=H}async asString(){return JSON.stringify(this._value)}};Pt=je([k],Pt),e.TreeDataTransferItem=Pt;let Ft=class{constructor(){this._items=new Map}get(H){return this._items.get(H)}set(H,ue){this._items.set(H,ue)}forEach(H){this._items.forEach(H)}};Ft=je([k],Ft),e.TreeDataTransfer=Ft;let kt=class{constructor(H,ue){this.id=H,this.color=ue}};kt=je([k],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let yt=class{constructor(H){this.id=H}};yt=je([k],yt),e.ThemeColor=yt;var Qt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(H,ue){if(typeof H!="string"&&(!H||!A.URI.isUri(H)&&!A.URI.isUri(H.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof H=="string"?this.baseUri=A.URI.file(H):A.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=ue}get base(){return this._base}set base(H){this._base=H,this._baseUri=A.URI.file(H)}get baseUri(){return this._baseUri}set baseUri(H){this._baseUri=H,this._base=H.fsPath}};Vt=je([k],Vt),e.RelativePattern=Vt;let Et=class{constructor(H,ue,Pe,et){this.enabled=typeof H=="boolean"?H:!0,typeof ue=="string"&&(this.condition=ue),typeof Pe=="string"&&(this.hitCondition=Pe),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Et=je([k],Et),e.Breakpoint=Et;let Xt=class extends Et{constructor(H,ue,Pe,et,at){super(ue,Pe,et,at);if(H===null)throw(0,t.illegalArgument)("location");this.location=H}};Xt=je([k],Xt),e.SourceBreakpoint=Xt;let qt=class extends Et{constructor(H,ue,Pe,et,at){super(ue,Pe,et,at);this.functionName=H}};qt=je([k],qt),e.FunctionBreakpoint=qt;let Yt=class extends Et{constructor(H,ue,Pe,et,at,dt,mt){super(et,at,dt,mt);if(!ue)throw(0,t.illegalArgument)("dataId");this.label=H,this.dataId=ue,this.canPersist=Pe}};Yt=je([k],Yt),e.DataBreakpoint=Yt;let ai=class{constructor(H,ue,Pe){this.command=H,this.args=ue||[],this.options=Pe}};ai=je([k],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(H,ue){this.port=H,this.host=ue}};Rt=je([k],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(H){this.path=H}};Jt=je([k],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(H){this.implementation=H}};li=je([k],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor(H,ue){this.range=H,this.expression=ue}};jt=je([k],jt),e.EvaluatableExpression=jt;var Zt;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let vt=class{constructor(H,ue){this.range=H,this.text=ue}};vt=je([k],vt),e.InlineValueText=vt;let ci=class{constructor(H,ue,Pe=!0){this.range=H,this.variableName=ue,this.caseSensitiveLookup=Pe}};ci=je([k],ci),e.InlineValueVariableLookup=ci;let Ot=class{constructor(H,ue){this.range=H,this.expression=ue}};Ot=je([k],Ot),e.InlineValueEvaluatableExpression=Ot;let Wt=class{constructor(H,ue){this.frameId=H,this.stoppedLocation=ue}};Wt=je([k],Wt),e.InlineValueContext=Wt;var vi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=h=class extends Error{constructor(H,ue=y.FileSystemProviderErrorCode.Unknown,Pe){super(A.URI.isUri(H)?H.toString(!0):H);this.code=Pe?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(H){return new h(H,y.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(H){return new h(H,y.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(H){return new h(H,y.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(H){return new h(H,y.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(H){return new h(H,y.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(H){return new h(H,y.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};ui=h=je([k],ui),e.FileSystemError=ui;let ei=class{constructor(H,ue,Pe){this.start=H,this.end=ue,this.kind=Pe}};ei=je([k],ei),e.FoldingRange=ei;var yi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(yi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(H,ue=[]){this.tokenTypes=H,this.tokenModifiers=ue}}e.SemanticTokensLegend=Di;function di(j){return typeof j=="undefined"||(0,C.isStringArray)(j)}class Gt{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let ue=0,Pe=H.tokenTypes.length;ue<Pe;ue++)this._tokenTypeStrToInt.set(H.tokenTypes[ue],ue);for(let ue=0,Pe=H.tokenModifiers.length;ue<Pe;ue++)this._tokenModifierStrToInt.set(H.tokenModifiers[ue],ue)}}push(H,ue,Pe,et,at){if(typeof H=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"&&(typeof at=="number"||typeof at=="undefined"))return typeof at=="undefined"&&(at=0),this._pushEncoded(H,ue,Pe,et,at);if(F.isRange(H)&&typeof ue=="string"&&di(Pe))return this._push(H,ue,Pe);throw(0,t.illegalArgument)()}_push(H,ue,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const et=H.start.line,at=H.start.character,dt=H.end.character-H.start.character,mt=this._tokenTypeStrToInt.get(ue);let At=0;if(Pe)for(const Lt of Pe){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Lt);At|=1<<Nt>>>0}this._pushEncoded(et,at,dt,mt,At)}_pushEncoded(H,ue,Pe,et,at){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Lt=0,Nt=0;for(let xt=0;xt<At;xt++){let Ht=this._data[5*xt],gi=this._data[5*xt+1];Ht===0?(Ht=Lt,gi+=Nt):Ht+=Lt,this._data[5*xt]=Ht,this._data[5*xt+1]=gi,Lt=Ht,Nt=gi}}let dt=H,mt=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=et,this._data[this._dataLen++]=at,this._prevLine=H,this._prevChar=ue}static _sortAndDeltaEncode(H){let ue=[];const Pe=H.length/5|0;for(let mt=0;mt<Pe;mt++)ue[mt]=mt;ue.sort((mt,At)=>{const Lt=H[5*mt],Nt=H[5*At];if(Lt===Nt){const xt=H[5*mt+1],Ht=H[5*At+1];return xt-Ht}return Lt-Nt});const et=new Uint32Array(H.length);let at=0,dt=0;for(let mt=0;mt<Pe;mt++){const At=5*ue[mt],Lt=H[At+0],Nt=H[At+1],xt=H[At+2],Ht=H[At+3],gi=H[At+4],zi=Lt-at,Ji=zi===0?Nt-dt:Nt,pi=5*mt;et[pi+0]=zi,et[pi+1]=Ji,et[pi+2]=xt,et[pi+3]=Ht,et[pi+4]=gi,at=Lt,dt=Nt}return et}build(H){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),H):new hi(Gt._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=Gt;class hi{constructor(H,ue){this.resultId=ue,this.data=H}}e.SemanticTokens=hi;class ki{constructor(H,ue,Pe){this.start=H,this.deleteCount=ue,this.data=Pe}}e.SemanticTokensEdit=ki;class Kt{constructor(H,ue){this.resultId=ue,this.edits=H}}e.SemanticTokensEdits=Kt;var Ii;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new kt("arrow-left")},ii=je([k],ii),e.QuickInputButtons=ii;var Ai;(function(j){j[j.Separator=-1]="Separator",j[j.Default=1]="Default"})(Ai=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor(H,ue,Pe){this.badge=H,this.tooltip=ue,this.color=Pe}static validate(H){if(H.badge){let ue=(0,P.nextCharLength)(H.badge,0);if(ue<H.badge.length&&(ue+=(0,P.nextCharLength)(H.badge,ue)),H.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor(H){this.kind=H}};ni=je([k],ni),e.ColorTheme=ni;var Ue;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(Ue=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(H,ue){if(H<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");H<=ue?(this._start=H,this._end=ue):(this._start=ue,this._end=H)}static isNotebookRange(H){return H instanceof $t?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let ue=this._start,Pe=this._end;return H.start!==void 0&&(ue=H.start),H.end!==void 0&&(Pe=H.end),ue===this._start&&Pe===this._end?this:new $t(ue,Pe)}}e.NotebookRange=$t;class Bt{constructor(H,ue,Pe,et,at,dt,mt){this.kind=H,this.value=ue,this.languageId=Pe,this.mime=et,this.outputs=at??[],this.metadata=dt,this.executionSummary=mt,Bt.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ue=>Bt.isNotebookCellData(ue))}static isNotebookCellData(H){return!0}}e.NotebookCellData=Bt;class _t{constructor(H){this.cells=H}}e.NotebookData=_t;class Mt{constructor(H,ue){this.data=H,this.mime=ue;const Pe=(0,T.normalizeMimeType)(ue,!0);if(!Pe)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(H){return H instanceof Mt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ue={name:H.name,message:H.message,stack:H.stack};return Mt.json(ue,"application/vnd.code.notebook.error")}static stdout(H){return Mt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Mt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ue="application/octet-stream"){return new Mt(H,ue)}static text(H,ue=T.Mimes.text){const Pe=Le(Mt,g,"f",E).encode(String(H));return new Mt(Pe,ue)}static json(H,ue="application/json"){const Pe=JSON.stringify(H,void 0,"	");return Mt.text(Pe,ue)}}e.NotebookCellOutputItem=Mt,g=Mt,E={value:new TextEncoder};class ri{constructor(H,ue,Pe){this.items=ri.ensureUniqueMimeTypes(H,!0),typeof ue=="string"?(this.id=ue,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=ue??Pe)}static isNotebookCellOutput(H){return H instanceof ri?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,C.isArray)(H.items)}static ensureUniqueMimeTypes(H,ue=!1){const Pe=new Set,et=new Set;for(let at=0;at<H.length;at++){const dt=H[at],mt=(0,T.normalizeMimeType)(dt.mime);if(!Pe.has(mt)){Pe.add(mt);continue}et.add(at),ue&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return et.size===0?H:H.filter((at,dt)=>!et.has(dt))}}e.NotebookCellOutput=ri;var Ei;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ti;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ti=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Li{constructor(H,ue){this.text=H,this.alignment=ue}}e.NotebookCellStatusBarItem=Li;var Fi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Fi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(H,ue=[]){this.uri=H,this.provides=(0,f.asArray)(ue)}}e.NotebookRendererScript=_i;let mi=class{constructor(H,ue){this.label=H,this.timestamp=ue}};mi=je([k],mi),e.TimelineItem=mi;var Mi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Mi=e.ExtensionMode||(e.ExtensionMode={}));var Oi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(H,ue){this.ranges=H,this.wordPattern=ue}}e.LinkedEditingRanges=Ui;class ae{constructor(H,ue){this._port=H,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ae;var ge;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ge=e.TestResultState||(e.TestResultState={}));var Te;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Te=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ht=class{constructor(H=void 0,ue=void 0,Pe=void 0){this.include=H,this.exclude=ue,this.profile=Pe}};ht=je([k],ht),e.TestRunRequest=ht;let Dt=w=class{constructor(H){this.message=H}static diff(H,ue,Pe){const et=new w(H);return et.expectedOutput=ue,et.actualOutput=Pe,et}};Dt=w=je([k],Dt),e.TestMessage=Dt;let Tt=class{constructor(H){this.id=H}};Tt=je([k],Tt),e.TestTag=Tt;let si=class{constructor(H,ue){this.covered=H,this.total=ue}};si=je([k],si),e.CoveredCount=si;let Bi=v=class{constructor(H,ue,Pe,et){this.uri=H,this.statementCoverage=ue,this.branchCoverage=Pe,this.functionCoverage=et}static fromDetails(H,ue){const Pe=new si(0,0),et=new si(0,0),at=new si(0,0);for(const mt of ue)if("branches"in mt){Pe.total+=1,Pe.covered+=mt.executionCount>0?1:0;for(const At of mt.branches)et.total+=1,et.covered+=At.executionCount>0?1:0}else at.total+=1,at.covered+=mt.executionCount>0?1:0;const dt=new v(H,Pe,et.total>0?et:void 0,at.total>0?at:void 0);return dt.detailedCoverage=ue,dt}};Bi=v=je([k],Bi),e.FileCoverage=Bi;let xi=class{constructor(H,ue,Pe=[]){this.executionCount=H,this.location=ue,this.branches=Pe}};xi=je([k],xi),e.StatementCoverage=xi;let Wi=class{constructor(H,ue){this.executionCount=H,this.location=ue}};Wi=je([k],Wi),e.BranchCoverage=Wi;let $i=class{constructor(H,ue){this.executionCount=H,this.location=ue}};$i=je([k],$i),e.FunctionCoverage=$i;var Ki;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(H,ue,Pe,et,at,dt){this.kind=H,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.TypeHierarchyItem=Yi}),define(pe[123],ve([0,1,55,10,8,150,110,7,16]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function R(p,g){g?A.set(p,g):A.delete(p)}e.setWordDefinitionFor=R;function y(p){return A.get(p)}e.getWordDefinitionFor=y;class l extends D.MirrorTextModel{constructor(g,E,L,_,a,s,m,o){super(E,L,_,a);this._proxy=g,this._languageId=s,this._isDirty=m,this._notebook=o,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,C.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(E){return E?g._getTextInRange(E):g.getText()},get eol(){return g._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(E){return g._lineAt(E)},offsetAt(E){return g._offsetAt(E)},positionAt(E){return g._positionAt(E)},validateRange(E){return g._validateRange(E)},validatePosition(E){return g._validatePosition(E)},getWordRangeAtPosition(E,L){return g._getWordRangeAtPosition(E,L)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,f.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,f.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const E=this._validateRange(g);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const L=this._eol,_=E.start.line,a=E.end.line,s=[];s.push(this._lines[_].substring(E.start.character));for(let m=_+1;m<a;m++)s.push(this._lines[m]);return s.push(this._lines[a].substring(0,E.end.character)),s.join(L)}_lineAt(g){let E;if(g instanceof P.Position?E=g.line:typeof g=="number"&&(E=g),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new b(E,this._lines[E],E===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(g),L=this._lines[E.index].length;return new P.Position(E.index,Math.min(E.remainder,L))}_validateRange(g){if(!(g instanceof P.Range))throw new Error("Invalid argument");const E=this._validatePosition(g.start),L=this._validatePosition(g.end);return E===g.start&&L===g.end?g:new P.Range(E.line,E.character,L.line,L.character)}_validatePosition(g){if(!(g instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:E,character:L}=g,_=!1;if(E<0)E=0,L=0,_=!0;else if(E>=this._lines.length)E=this._lines.length-1,L=this._lines[E].length,_=!0;else{const a=this._lines[E].length;L<0?(L=0,_=!0):L>a&&(L=a,_=!0)}return _?new P.Position(E,L):g}_getWordRangeAtPosition(g,E){const L=this._validatePosition(g);if(!E)E=y(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const _=(0,T.getWordAtText)(L.character+1,(0,T.ensureValidWordDefinition)(E),this._lines[L.line],0);if(_)return new P.Range(L.line,_.startColumn-1,L.line,_.endColumn-1)}}e.ExtHostDocumentData=l;class b{constructor(g,E,L){this._line=g,this._text=E,this._isLastLine=L}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(pe[202],ve([0,1,7,3,112,6,82,24,2,33]),function(Z,e,f,t,I,D,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(l,b,p,g){this._notebook=p,this._selector=g,this._disposables=new D.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(L=>{const _=this._cellUris.get(L.document.uri);_!==void 0&&(this._cellLengths.setValue(_,this._cells[_].document.getText().length+1),this._cellLines.setValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=L=>{L===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(L=>E(L.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const l=[],b=[];for(const p of this._notebook.getCells())p.kind===f.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,p.document.uri,p.document.languageId,!0))&&(this._cellUris.set(p.document.uri,this._cells.length),this._cells.push(p),l.push(p.document.getText().length+1),b.push(p.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(l){if(!l){let _="";for(const a of this._cells)_+=a.document.getText()+`
`;return _=_.slice(0,-1),_}if(l.isEmpty)return"";const b=this.locationAt(l.start),p=this.locationAt(l.end),g=this._cellUris.get(b.uri),E=this._cellUris.get(p.uri);if(g===void 0||E===void 0)return"";if(g===E)return this._cells[g].document.getText(new f.Range(b.range.start,p.range.end));const L=[this._cells[g].document.getText(new f.Range(b.range.start,new f.Position(this._cells[g].document.lineCount,0)))];for(let _=g+1;_<E;_++)L.push(this._cells[_].document.getText());return L.push(this._cells[E].document.getText(new f.Range(new f.Position(0,0),p.range.end))),L.join(`
`)}offsetAt(l){const b=this._cellLines.getIndexOf(l.line),p=this._cellLengths.getPrefixSum(b.index-1),g=this._cells[b.index].document.offsetAt(l.with(b.remainder));return p+g}positionAt(l){if(typeof l=="number"){const p=this._cellLengths.getIndexOf(l),g=this._cellLines.getPrefixSum(p.index-1);return this._cells[p.index].document.positionAt(p.remainder).translate(g)}const b=this._cellUris.get(l.uri);if(b!==void 0){const p=this._cellLines.getPrefixSum(b-1);return new f.Position(p+l.range.start.line,l.range.start.character)}return new f.Position(0,0)}locationAt(l){f.Range.isRange(l)||(l=new f.Range(l,l));const b=this._cellLines.getIndexOf(l.start.line);let p=b;l.isEmpty||(p=this._cellLines.getIndexOf(l.end.line));const g=new f.Position(b.remainder,l.start.character),E=new f.Position(p.remainder,l.end.character),L=new f.Range(g,E),_=this._cells[b.index];return new f.Location(_.document.uri,_.document.validateRange(L))}contains(l){return this._cellUris.has(l)}validateRange(l){const b=this.validatePosition(l.start),p=this.validatePosition(l.end);return l.with(b,p)}validatePosition(l){const b=this._cellLines.getIndexOf(l.line),p=new f.Position(b.remainder,l.character),g=this._cells[b.index].document.validatePosition(p),E=this._cellLines.getPrefixSum(b.index-1);return new f.Position(E+g.line,g.character)}}e.ExtHostNotebookConcatDocument=R}),define(pe[203],ve([0,1,7,14,3]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let D=class{constructor(P){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let C=P==="light"?f.ColorThemeKind.Light:P==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};D=je([He(0,t.IExtHostRpcService)],D),e.ExtHostTheming=D}),define(pe[65],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class t{constructor(D){D?(this.transformIncoming=D.transformIncoming.bind(D),this.transformOutgoing=D.transformOutgoing.bind(D),this.transformOutgoingURI=D.transformOutgoingURI.bind(D),this.transformOutgoingScheme=D.transformOutgoingScheme.bind(D)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=t}),define(pe[204],ve([0,1,22]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(C){let A=this.buffers.indexOf(C);return A<0&&(A=this.buffers.length,this.buffers.push(C)),A}}function I(P,C){if(C.serializeBuffersForPostMessage){const A=new t,R=(b,p)=>{if(p instanceof ArrayBuffer){const g=A.add(p);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(p)){const g=D(p);if(g){const E=A.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:g,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},y=JSON.stringify(P,R),l=A.buffers.map(b=>{const p=new Uint8Array(b);return f.VSBuffer.wrap(p)});return{message:y,buffers:l}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=I;function D(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(P,C){const A=C.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),R=C.length?(l,b)=>{if(typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:g}=p,E=A[g];if(p.view)switch(p.view.type){case 1:return new Int8Array(E,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return b}:void 0;return{message:JSON.parse(P,R),arrayBuffers:A}}e.deserializeWebviewMessage=T}),define(pe[205],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(t){function I(T){const P=new Map;return T.types.forEach((C,A)=>{P.set(C,{asString:async()=>T.items[A].asString})}),P}t.toITreeDataTransfer=I;async function D(T){const P={types:[],items:[]},C=Array.from(T.entries());for(const A of C)P.types.push(A[0]),P.items.push({asString:await A[1].asString()});return P}t.toTreeDataTransferDTO=D})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(pe[87],ve([0,1,10,2]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(P,C){return P.scheme===f.Schemas.http||P.scheme===f.Schemas.https?P:(C&&C.authority&&C.isRemote&&P.scheme===f.Schemas.file&&(P=t.URI.from({scheme:f.Schemas.vscodeRemote,authority:C.authority,path:P.path})),t.URI.from({scheme:f.Schemas.https,authority:`${P.scheme}+${D(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=I;function D(P){return P.replace(/./g,C=>{const A=C.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?C:"-"+A.toString(16).padStart(4,"0")})}function T(P){return P.replace(/-([0-9a-f]{4})/g,(C,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=T}),define(pe[206],ve([0,1,3,6,87]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(P,C,A){this._proxy=P,this._editors=C,this._initData=A,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const R=C.getVisibleTextEditors();for(const y of this._insets.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,C,A,R,y){let l;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===P){l=a;break}if(!l)throw new Error("not a visible editor");const b=this,p=this._handlePool++,g=new f.Emitter,E=new f.Emitter,L=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,I.asWebviewUri)(a,b._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(a){this._options=a,b._proxy.$setOptions(p,a)}get options(){return this._options}set html(a){this._html=a,b._proxy.$setHtml(p,a)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(a){return b._proxy.$postMessage(p,a)}},_=new class{constructor(){this.editor=P,this.line=C,this.height=A,this.webview=L,this.onDidDispose=E.event}dispose(){b._insets.has(p)&&(b._insets.delete(p),b._proxy.$disposeEditorInset(p),E.fire(),E.dispose(),g.dispose())}};return this._proxy.$createEditorInset(p,l.id,l.value.document.uri,C+1,A,R||{},y.identifier,y.extensionLocation),this._insets.set(p,{editor:P,inset:_,onDidReceiveMessage:g}),_}$onDidDispose(P){const C=this._insets.get(P);C&&C.inset.dispose()}$onDidReceiveMessage(P,C){const A=this._insets.get(P);A&&A.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=D}),define(pe[207],ve([0,1,172,13,2,6,4,62,50,42,16,10]),function(Z,e,f,t,I,D,T,P,C,A,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,f.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,f.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,f.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,f.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,f.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,f.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,f.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,f.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,f.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,f.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,f.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,f.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,f.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,f.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,f.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,f.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,f.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,f.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,f.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,f.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,f.localize)(22,null)),e.EditorTabsVisibleContext=new P.RawContextKey("editorTabsVisible",!0,(0,f.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(F,M,V){for(const $ of V.visibleEditorPanes)if($.group.id===M&&F.matches($.input))return $.getViewState()}e.findViewStateForEditor=l;function b(F){if(m(F))return!1;const M=F;return I.URI.isUri(M?.resource)}e.isResourceEditorInput=b;function p(F){if(m(F))return!1;const M=F;return M?.original!==void 0&&M.modified!==void 0}e.isResourceDiffEditorInput=p;function g(F){if(m(F)||p(F))return!1;const M=F;return M?.primary!==void 0&&M.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function E(F){if(m(F))return!1;const M=F;return M?M.resource===void 0||M.resource.scheme===y.Schemas.untitled||M.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;var L;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(L=e.Verbosity||(e.Verbosity={}));var _;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var a;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends D.Disposable{}e.AbstractEditorInput=s;function m(F){return F instanceof s}e.isEditorInput=m;function o(F){const M=F;return I.URI.isUri(M?.preferredResource)}function S(F){const M=F;return m(M?.primary)&&m(M?.secondary)}e.isSideBySideEditorInput=S;function r(F){const M=F;return m(M?.modified)&&m(M?.original)}e.isDiffEditorInput=r;function i(F){return m(F?.editor)}e.isEditorInputWithOptions=i;function n(F){const M=F;return i(F)&&M?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function u(F){const M=F;return typeof M?.groupId=="number"&&m(M.editor)}e.isEditorIdentifier=u;var c;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var d;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(d=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var h;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class w{getOriginalUri(M,V){if(!M)return;if(V?.supportSideBySide){const{primary:N,secondary:B}=this.getSideEditors(M);if(N&&B){if(V?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===h.ANY)return this.getOriginalUri(N,{filterByScheme:V.filterByScheme})??this.getOriginalUri(B,{filterByScheme:V.filterByScheme});M=V.supportSideBySide===h.PRIMARY?N:B}}if(p(M)||g(M))return;const $=o(M)?M.preferredResource:M.resource;return!$||!V||!V.filterByScheme?$:this.filterUri($,V.filterByScheme)}getSideEditors(M){return S(M)||g(M)?{primary:M.primary,secondary:M.secondary}:r(M)||p(M)?{primary:M.modified,secondary:M.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(M,V){if(!M)return;if(V?.supportSideBySide){const{primary:N,secondary:B}=this.getSideEditors(M);if(N&&B){if(V?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===h.ANY)return this.getCanonicalUri(N,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(B,{filterByScheme:V.filterByScheme});M=V.supportSideBySide===h.PRIMARY?N:B}}if(p(M)||g(M))return;const $=M.resource;return!$||!V||!V.filterByScheme?$:this.filterUri($,V.filterByScheme)}filterUri(M,V){if(Array.isArray(V)){if(V.some($=>M.scheme===$))return M}else if(V===M.scheme)return M}}e.EditorResourceAccessor=new w;var v;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class k{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(M){const V=this.instantiationService=M.get(T.IInstantiationService);for(const[$,N]of this.editorSerializerConstructors)this.createEditorSerializer($,N,V);this.editorSerializerConstructors.clear()}createEditorSerializer(M,V,$){const N=$.createInstance(V);this.editorSerializerInstances.set(M,N)}registerFileEditorFactory(M){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=M}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(M,V){if(this.editorSerializerConstructors.has(M)||this.editorSerializerInstances.has(M))throw new Error(`A editor serializer with type ID '${M}' was already registered.`);return this.instantiationService?this.createEditorSerializer(M,V,this.instantiationService):this.editorSerializerConstructors.set(M,V),(0,D.toDisposable)(()=>{this.editorSerializerConstructors.delete(M),this.editorSerializerInstances.delete(M)})}getEditorSerializer(M){return this.editorSerializerInstances.get(typeof M=="string"?M:M.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new k);async function O(F,M){if(!F||!F.length)return[];const V=await Promise.all(F.map(async $=>{const N=I.URI.revive($.fileUri);if(!N||!await M.canHandleResource(N))return;let x=$.exists,z=$.type;if(typeof x!="boolean"||typeof z!="number")try{z=(await M.resolve(N)).isDirectory?A.FileType.Directory:A.FileType.Unknown,x=!0}catch{x=!1}if(!x&&$.openOnlyIfExists||z===A.FileType.Directory)return;const W={selection:x?$.selection:void 0,pinned:!0,override:$.editorOverrideId};let J;return x?J={resource:N,options:W}:J={resource:N,options:W,forceUntitled:!0},J}));return(0,R.coalesce)(V)}e.pathsToEditors=O;var U;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}))}),define(pe[124],ve([0,1,3,17,173]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class D{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,C,A,R){const y={command:P};if(C&&Object.keys(C).length>0&&(y.arguments=C),this.internalSend("request",y),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.pendingRequests.get(y.seq);if(b){this.pendingRequests.delete(y.seq);const p={type:"response",seq:0,request_seq:y.seq,success:!1,command:P,message:(0,I.localize)(0,null,R,P)};b(p)}},R)}return A&&this.pendingRequests.set(y.seq,A),y.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,C){return P.type!=="event"||C.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,t.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const C=P,A=this.pendingRequests.get(C.request_seq);A&&(this.pendingRequests.delete(C.request_seq),A(C));break}}}}internalSend(P,C){C.type=P,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((C,A)=>P.set(A,C)),await(0,t.timeout)(500),P.forEach((C,A)=>{C({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=D}),define(pe[208],ve([0,1,8,2,9,25,10]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function C(r,i,n){return r.replace(P,function(u,c){return i&&c.length>0&&c[0]!=="_"?u:n&&n.hasOwnProperty(c)?n[c]:u})}e.formatPII=C;function A(r){const i={};for(const n of Object.keys(r))n.startsWith("!")||(i[n]=r[n]);return i}e.filterExceptionsFromTelemetry=A;function R(r){return r.configuration.request==="attach"&&!y(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function y(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(i,"extensionhost")||(0,f.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?y(r.parentSession):void 0}e.getExtensionHostDebugSession=y;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function b(r,i,n){let u,c=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=d.exec(r);){const w=h.index+1,v=w+h[0].length;if(w<=i&&v>=n){u=h[0],c=w;break}}if(u){const w=/\w+/g;let v=null;for(;(v=w.exec(u))&&!(v.index+1+c+v[0].length>=n););v&&(u=u.substring(0,w.lastIndex))}return u?{start:c,end:c+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(r){return!!(r&&r.match(p))}e.isUri=g;function E(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(g(r.path))return t.URI.parse(r.path);if((0,I.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function L(r){if(typeof r.path=="object"){const i=t.URI.revive(r.path);if(i)return i.scheme===T.Schemas.file?i.fsPath:i.toString()}return r.path}function _(r,i){const n=i?E:L,u=(0,D.deepClone)(r);return s(u,(c,d)=>{c&&d&&(d.path=n(d))}),u}e.convertToDAPaths=_;function a(r,i){const n=i?E:L,u=(0,D.deepClone)(r);return s(u,(c,d)=>{!c&&d&&(d.path=n(d))}),u}e.convertToVSCPaths=a;function s(r,i){switch(r.type){case"event":{const n=r;switch(n.event){case"output":i(!1,n.body.source);break;case"loadedSource":i(!1,n.body.source);break;case"breakpoint":i(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=r;switch(n.command){case"setBreakpoints":i(!0,n.arguments.source);break;case"breakpointLocations":i(!0,n.arguments.source);break;case"source":i(!0,n.arguments.source);break;case"gotoTargets":i(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(u=>i(!1,u));break;default:break}break}case"response":{const n=r;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(u=>i(!1,u.source));break;case"loadedSources":n.body.sources.forEach(u=>i(!1,u));break;case"scopes":n.body.scopes.forEach(u=>i(!1,u.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(u=>i(!1,u.source));break;case"setBreakpoints":n.body.breakpoints.forEach(u=>i(!1,u.source));break;default:break}break}}}function m(r){return r.filter(i=>!i.presentation?.hidden).sort((i,n)=>i.presentation?n.presentation?i.presentation.group?n.presentation.group?i.presentation.group!==n.presentation.group?i.presentation.group.localeCompare(n.presentation.group):o(i.presentation.order,n.presentation.order):-1:n.presentation.group?1:o(i.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=m;function o(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function S(r,i){const n=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(n!=="none"&&(await i.saveAll(),n==="allEditorsInActiveGroup")){const u=i.activeEditorPane;u&&u.input.resource?.scheme===T.Schemas.untitled&&await i.save({editor:u.input,groupId:u.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(pe[209],ve([0,1,30,37,174,125,9,8,25,12,184,124]),function(Z,e,f,t,I,D,T,P,C,A,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends y.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",s=>this.handleData(s))}sendMessage(_){if(this.outputStream){const a=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${l.TWO_CRLF}${a}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+a))}continue}}else{const a=this.rawData.indexOf(l.TWO_CRLF);if(a!==-1){const m=this.rawData.toString("utf8",0,a).split(l.HEADER_LINESEPARATOR);for(const o of m){const S=o.split(l.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(a+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class b extends l{startSession(){return new Promise((_,a)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",m=>{s?this._onError.fire(m):a(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class p extends b{constructor(_){super();this.adapterServer=_}createConnection(_){return D.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=p;class g extends b{constructor(_){super();this.adapterServer=_}createConnection(_){return D.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=g;class E extends l{constructor(_,a,s){super();this.adapterExecutable=_,this.debugType=a,this.outputService=s}async startSession(){const _=this.adapterExecutable.command,a=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(_)if(T.isAbsolute(_)){if(!await f.Promises.exists(_))throw new Error(I.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let m=process.env;if(s.env&&Object.keys(s.env).length>0&&(m=C.mixin(C.deepClone(process.env),s.env)),_==="node")if(Array.isArray(a)&&a.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(r.cwd=s.cwd);const i=t.fork(a[0],a.slice(1),r);if(!i.pid)throw new Error(I.localize(2,null,a[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const S={env:m};s.cwd&&(S.cwd=s.cwd),this.serverProcess=t.spawn(_,a,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,r)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const o=this.outputService;if(o){const S=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=o.getChannel(R.ExtensionsChannelId);i&&i.append(S(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((_,a)=>{const s=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,o,S){if(m)return a(m)});s.on("exit",_),s.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,a){if(!_)return;const s=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?s.runtime=T.join(a,_.runtime):s.runtime=_.runtime),_.runtimeArgs&&(s.runtimeArgs=_.runtimeArgs),_.program&&(T.isAbsolute(_.program)?s.program=_.program:s.program=T.join(a,_.program)),_.args&&(s.args=_.args);const m=_;return m.win&&(s.win=E.extract(m.win,a)),m.winx86&&(s.winx86=E.extract(m.winx86,a)),m.windows&&(s.windows=E.extract(m.windows,a)),m.osx&&(s.osx=E.extract(m.osx,a)),m.linux&&(s.linux=E.extract(m.linux,a)),s}static platformAdapterExecutable(_,a){let s=Object.create(null);a=a.toLowerCase();for(const n of _)if(n.contributes){const u=n.contributes.debuggers;u&&u.length>0&&u.filter(c=>typeof c.type=="string"&&P.equalsIgnoreCase(c.type,a)).forEach(c=>{const d=E.extract(c,n.extensionLocation.fsPath);s=C.mixin(s,d,n.isBuiltin)})}let m;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=s.winx86||s.win||s.windows:A.isWindows?m=s.win||s.windows:A.isMacintosh?m=s.osx:A.isLinux&&(m=s.linux),m=m||s;const o=m.program||s.program,S=m.args||s.args,r=m.runtime||s.runtime,i=m.runtimeArgs||s.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof o=="string"?[o]:[]).concat(S||[])};if(o)return{type:"executable",command:o,args:S||[]}}}e.ExecutableDebugAdapter=E}),define(pe[210],ve([0,1,37,12,29,186]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(l,b){return new Promise((p,g)=>{let E="";const L=f.spawn(l,b);L.pid&&L.stdout.on("data",_=>{E+=_.toString()}),L.on("error",_=>{g(_)}),L.on("close",_=>{p(E)})})}let P;function C(l,b){if(!P)if(t.isWindows)P=new D.WindowsExternalTerminalService;else if(t.isMacintosh)P=new D.MacExternalTerminalService;else if(t.isLinux)P=new D.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const p=b.getConfiguration("terminal");return P.runInTerminal(l.title,l.cwd,l.args,l.env||{},p.external||{})}e.runInExternalTerminal=C;async function A(l){if(l)if(t.isWindows){const b=await new Promise((p,g)=>{Z(["windows-process-tree"],p,g)});return new Promise(p=>{b.getProcessTree(l,g=>{p(g.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(l)]).then(b=>{const p=b.trim();return!(p.length===0||p.indexOf(" tmux")>=0)},b=>!0);return Promise.resolve(!0)}e.hasChildProcesses=A;var R;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(R||(R={}));function y(l,b,p,g){l=l.trim().toLowerCase();let E;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?E=1:l.indexOf("cmd.exe")>=0?E=0:l.indexOf("bash")>=0?E=2:t.isWindows?E=0:E=2;let L,_=" ";switch(E){case 1:if(L=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),p){const a=(0,I.getDriveLetter)(p);a&&(_+=`${a}:; `),_+=`cd ${L(p)}; `}if(g)for(const a in g){const s=g[a];s===null?_+=`Remove-Item env:${a}; `:_+=`\${env:${a}}='${s}'; `}if(b.length>0){const a=L(b.shift());_+=a[0]==="'"?`& ${a} `:`${a} `;for(const s of b)_+=`${L(s)} `}break;case 0:if(L=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),p){const a=(0,I.getDriveLetter)(p);a&&(_+=`${a}: && `),_+=`cd ${L(p)} && `}if(g){_+='cmd /C "';for(const a in g){let s=g[a];s===null?_+=`set "${a}=" && `:(s=s.replace(/[\^\&\|\<\>]/g,m=>`^${m}`),_+=`set "${a}=${s}" && `)}}for(const a of b)_+=`${L(a)} `;g&&(_+='"');break;case 2:{L=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const a=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(p&&(_+=`cd ${L(p)} ; `),g){_+="/usr/bin/env";for(const s in g){const m=g[s];m===null?_+=` -u ${a(s)}`:_+=` ${a(`${s}=${m}`)}`}_+=" "}for(const s of b)_+=`${L(s)} `;break}}return _}e.prepareCommand=y}),define(pe[126],ve([0,1,32,78,95,10,9,12,62]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var A;(function(w){w[w.Markup=1]="Markup",w[w.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(w){w[w.Running=1]="Running",w[w.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(w){w[w.Pending=2]="Pending",w[w.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(w){w[w.WithHardKernelDependency=0]="WithHardKernelDependency",w[w.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",w[w.Pure=2]="Pure",w[w.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(w){w.Always="always",w.Never="never",w.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(w){w[w.ModelChange=1]="ModelChange",w[w.Move=2]="Move",w[w.ChangeLanguage=5]="ChangeLanguage",w[w.Initialize=6]="Initialize",w[w.ChangeCellMetadata=7]="ChangeCellMetadata",w[w.Output=8]="Output",w[w.OutputItem=9]="OutputItem",w[w.ChangeCellContent=10]="ChangeCellContent",w[w.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",w[w.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",w[w.ChangeCellMime=13]="ChangeCellMime",w[w.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(w){w[w.Handle=0]="Handle",w[w.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var E;(function(w){w[w.Replace=1]="Replace",w[w.Output=2]="Output",w[w.Metadata=3]="Metadata",w[w.CellLanguage=4]="CellLanguage",w[w.DocumentMetadata=5]="DocumentMetadata",w[w.Move=6]="Move",w[w.OutputItems=7]="OutputItems",w[w.PartialMetadata=8]="PartialMetadata",w[w.PartialInternalMetadata=9]="PartialInternalMetadata"})(E=e.CellEditType||(e.CellEditType={}));var L;(function(w){w.scheme=D.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function k($,N){return $.with({scheme:w.scheme,fragment:`ch${N.toString().padStart(7,"0")}${$.scheme!==D.Schemas.file?$.scheme:""}`})}w.generate=k;function O($){if($.scheme!==w.scheme)return;const N=v.exec($.fragment);return N?{handle:Number(N[1]),notebook:$.with({scheme:$.fragment.substring(N[0].length)||D.Schemas.file,fragment:null})}:void 0}w.parse=O;function U($,N,B){return $.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`ch${N.toString().padStart(7,"0")},${B??""},${$.scheme!==D.Schemas.file?$.scheme:""}`})}w.generateCellOutputUri=U;function F($){if($.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const N=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($.fragment);if(!N)return;const B=Number(N[1]),x=N[2]&&N[2]!==""?N[2]:void 0,z=N[3];return{handle:B,outputId:x,notebook:$.with({scheme:z||D.Schemas.file,fragment:null})}}w.parseCellOutputUri=F;function M($,N,B){return $.with({scheme:B,fragment:`ch${N.toString().padStart(7,"0")}${$.scheme!==D.Schemas.file?$.scheme:""}`})}w.generateCellUri=M;function V($,N){if($.scheme!==N)return;const B=v.exec($.fragment);return B?{handle:Number(B[1]),notebook:$.with({scheme:$.fragment.substring(B[0].length)||D.Schemas.file,fragment:null})}:void 0}w.parseCellUri=V})(L=e.CellUri||(e.CellUri={}));const _=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function a(w){return _.get(w)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=a;function s(w){return _.get(w)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function m(w){return _.get(w)?.mergeable??!1}e.mimeTypeIsMergeable=m;const o=w=>P.isWindows?w.replace(/\//g,"\\"):w;class S{constructor(v=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(v)].map(O=>({pattern:O,matches:f.parse(o(O))}))}sort(v){const k=new Map(t.Iterable.map(v,U=>[U,o(U)]));let O=[];for(const{matches:U}of this.order)for(const[F,M]of k)if(U(M)){O.push(F),k.delete(F);break}return k.size&&(O=O.concat([...k.keys()].sort((U,F)=>this.defaultOrder.indexOf(U)-this.defaultOrder.indexOf(F)))),O}prioritize(v,k){const O=this.findIndex(v);if(O===-1){this.order.unshift({pattern:v,matches:f.parse(o(v))});return}const U=new Set(k.map(M=>this.findIndex(M,O)));U.delete(-1);const F=Array.from(U).sort();this.order.splice(O+1,0,...F.map(M=>this.order[M]));for(let M=F.length-1;M>=0;M--)this.order.splice(F[M],1)}toArray(){return this.order.map(v=>v.pattern)}findIndex(v,k=this.order.length){const O=o(v);for(let U=0;U<k;U++)if(this.order[U].matches(O))return U;return-1}}e.MimeTypeDisplayOrder=S;function r(w,v,k,O=(U,F)=>U===F){const U=[];function F($,N,B){if(N===0&&B.length===0)return;const x=U[U.length-1];x&&x.start+x.deleteCount===$?(x.deleteCount+=N,x.toInsert.push(...B)):U.push({start:$,deleteCount:N,toInsert:B})}let M=0,V=0;for(;;){if(M===w.length){F(M,0,v.slice(V));break}if(V===v.length){F(M,w.length-M,[]);break}const $=w[M],N=v[V];if(O($,N)){M+=1,V+=1;continue}k(N)?(F(M,1,[]),M+=1):(F(M,0,[N]),V+=1)}return U}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(w){w.default="default",w.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(w){const v=w;return!!((typeof v.include=="string"||f.isRelativePattern(v.include))&&(typeof v.exclude=="string"||f.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=n;function u(w,v,k){if(Array.isArray(w.viewType)&&w.viewType.indexOf(v)>=0||w.viewType===v)return!0;if(w.filenamePattern){const O=n(w.filenamePattern)?w.filenamePattern.include:w.filenamePattern,U=n(w.filenamePattern)?w.filenamePattern.exclude:void 0;if(f.match(O,(0,T.basename)(k.fsPath).toLowerCase()))return!(U&&f.match(U,(0,T.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class c{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)v[k]=this.textModel.cells[k].getHashValue();return v}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"notebook.interactiveWindow.collapseCellInputCode"};var d;(function(w){w[w.Left=1]="Left",w[w.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class h{static create(v){return`${h._prefix}${v}`}static parse(v){if(v.startsWith(h._prefix))return v.substring(h._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=h,h._prefix="notebook/"}),define(pe[211],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(pe[212],ve([0,1,4,62]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,f.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(pe[213],ve([0,1,176,4,62]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[214],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=f;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t}),define(pe[127],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var f;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(f=e.TestResultState||(e.TestResultState={}));var t;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var D;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(D=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(y,l)=>{l.expand!==void 0&&(y.expand=l.expand),l.item!==void 0&&(y.item=y.item?Object.assign(y.item,l.item):l.item)};e.applyTestItemUpdate=T;var P;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var C;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(l){}update(l){}remove(l,b){}complete(){}}e.IncrementalChangeCollector=A;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const b=this.createChangeCollector();for(const p of l)switch(p[0]){case 0:{const g=p[1];if(g.parent){if(this.items.has(g.parent)){const E=this.items.get(g.parent);E.children.add(g.item.extId);const L=this.createItem(g,E);this.items.set(g.item.extId,L),b.add(L)}}else{const E=this.createItem(g);this.roots.add(E),this.items.set(g.item.extId,E),b.add(E)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=p[1],E=this.items.get(g.extId);if(!E)break;g.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,g),b.update(E);break}case 2:{const g=this.items.get(p[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const E=[[p[1]]];for(;E.length;)for(const L of E.pop()){const _=this.items.get(L);_&&(E.push(_.children),this.items.delete(L),b.remove(_,_!==g),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(p[1]);break;case 3:this.updatePendingRoots(p[1]);break;case 5:this._tags.set(p[1].id,p[1]);break;case 6:this._tags.delete(p[1]);break}b.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=R}),define(pe[88],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(D){D.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{constructor(T,P=T.length){if(this.path=T,this.viewEnd=P,T.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,P,C=T.parent){if(T.id===P)return new I([P]);let A=[T.id];for(let R=C;R&&R.id!==P;R=R.parent)A.push(R.id);return A.push(P),new I(A.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const P=T.indexOf("\0");return P===-1?T:T.slice(0,P)}static fromString(T){return new I(T.split("\0"))}static join(T,P){return new I([...T.path,P])}static joinToString(T,P){return T.toString()+"\0"+P}static compare(T,P){return T===P?0:P.startsWith(T+"\0")?2:T.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new I(this.path,T)}compare(T){if(typeof T=="string")return I.compare(this.toString(),T);for(let P=0;P<T.viewEnd&&P<this.viewEnd;P++)if(T.path[P]!==this.path[P])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=I}),define(pe[215],ve([0,1,9,40,13,25,12,80,177]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(y,l,b){this._contributedVariables=new Map,this._context=y,this._labelService=l,b&&(this._envVariablesPromise=b.then(p=>this.prepareEnv(p)))}prepareEnv(y){if(T.isWindows){const l=Object.create(null);return Object.keys(y).forEach(b=>{l[b.toLowerCase()]=y[b]}),l}return y}resolveWithEnvironment(y,l,b){return this.recursiveResolve(this.prepareEnv(y),l?l.uri:void 0,b)}async resolveAsync(y,l){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,l)}async resolveAnyBase(y,l,b,p){const g=D.deepClone(l);return T.isWindows&&g.windows?Object.keys(g.windows).forEach(E=>g[E]=g.windows[E]):T.isMacintosh&&g.osx?Object.keys(g.osx).forEach(E=>g[E]=g.osx[E]):T.isLinux&&g.linux&&Object.keys(g.linux).forEach(E=>g[E]=g.linux[E]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,g,b,p)}async resolveAnyAsync(y,l,b){return this.resolveAnyBase(y,l,b)}async resolveAnyMap(y,l,b){const p=new Map;return{newConfig:await this.resolveAnyBase(y,l,b,p),resolvedVariables:p}}resolveWithInteractionReplace(y,l,b,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,l,b,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,l){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,l)}recursiveResolve(y,l,b,p,g){if(I.isString(b))return this.resolveString(y,l,b,p,g);if(I.isArray(b))return b.map(E=>this.recursiveResolve(y,l,E,p,g));if(I.isObject(b)){let E=Object.create(null);return Object.keys(b).forEach(L=>{const _=this.resolveString(y,l,L,p,g);E[_]=this.recursiveResolve(y,l,b[L],p,g)}),E}return b}resolveString(y,l,b,p,g){return b.replace(A.VARIABLE_REGEXP,(L,_)=>{if(_.includes(A.VARIABLE_LHS))return L;let a=this.evaluateSingleVariable(y,L,_,l,p);return g&&g.set(_,a),a!==L&&I.isString(a)&&a.match(A.VARIABLE_REGEXP)&&(a=this.resolveString(y,l,a,p,g)),a})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,l,b,p,g){let E;const L=b.split(":");L.length>1&&(b=L[0],E=L[1]);const _=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,C.localize)(0,null,l))},a=()=>{const m=_();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,C.localize)(1,null,l,f.basename(m)))},s=()=>{if(E){const m=this._context.getFolderUri(E);if(m)return m;throw new Error((0,C.localize)(2,null,l,E))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,l)):new Error((0,C.localize)(4,null,l))};switch(b){case"env":if(E){if(y){const m=y[T.isWindows?E.toLowerCase():E];if(I.isString(m))return m}return""}throw new Error((0,C.localize)(5,null,l));case"config":if(E){const m=this._context.getConfigurationValue(p,E);if(I.isUndefinedOrNull(m))throw new Error((0,C.localize)(6,null,l,E));if(I.isObject(m))throw new Error((0,C.localize)(7,null,l,E));return m}throw new Error((0,C.localize)(8,null,l));case"command":return this.resolveFromMap(l,E,g,"command");case"input":return this.resolveFromMap(l,E,g,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return p||E?(0,P.normalizeDriveLetter)(this.fsPath(s())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(s()));case"lineNumber":{const m=this._context.getLineNumber();if(m)return m;throw new Error((0,C.localize)(9,null,l))}case"selectedText":{const m=this._context.getSelectedText();if(m)return m;throw new Error((0,C.localize)(10,null,l))}case"file":return _();case"fileWorkspaceFolder":return a();case"relativeFile":return p||E?f.relative(this.fsPath(s()),_()):_();case"relativeFileDirname":{const m=f.dirname(_());if(p||E){const o=f.relative(this.fsPath(s()),m);return o.length===0?".":o}return m}case"fileDirname":return f.dirname(_());case"fileExtname":return f.extname(_());case"fileBasename":return f.basename(_());case"fileBasenameNoExtension":{const m=f.basename(_());return m.slice(0,m.length-f.extname(m).length)}case"fileDirnameBasename":return f.basename(f.dirname(_()));case"execPath":{const m=this._context.getExecPath();return m||l}case"execInstallFolder":{const m=this._context.getAppRoot();return m||l}case"pathSeparator":return f.sep;default:try{const m=E?`${b}:${E}`:b;return this.resolveFromMap(l,m,g,void 0)}catch{return l}}}}resolveFromMap(y,l,b,p){if(l&&b){const g=p===void 0?b[l]:b[p+":"+l];if(typeof g=="string")return g;throw new Error((0,C.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[128],ve([0,1,4,207]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var D;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var P;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function A(p){const g=p;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=A;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function l(p){const g=p;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=l;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(pe[216],ve([0,1,4,128]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(D){const T=D;return typeof D=="number"||(0,t.isEditorGroup)(T)}e.isPreferredGroup=I}),define(pe[18],ve([0,1,16,22,99,292,59,25,13,2,41,83,178,117,64,126,88,216,7]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(be){function _e(X){const{selectionStartLineNumber:ke,selectionStartColumn:Be,positionLineNumber:Je,positionColumn:Qe}=X,pt=new _.Position(ke-1,Be-1),St=new _.Position(Je-1,Qe-1);return new _.Selection(pt,St)}be.to=_e;function he(X){const{anchor:ke,active:Be}=X;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}be.from=he})(a=e.Selection||(e.Selection={}));var s;(function(be){function _e(X){if(!X)return;const{start:ke,end:Be}=X;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}be.from=_e;function he(X){if(!X)return;const{startLineNumber:ke,startColumn:Be,endLineNumber:Je,endColumn:Qe}=X;return new _.Range(ke-1,Be-1,Je-1,Qe-1)}be.to=he})(s=e.Range||(e.Range={}));var m;(function(be){function _e(he){switch(he){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 3:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}be.to=_e})(m=e.TokenType||(e.TokenType={}));var o;(function(be){function _e(X){return new _.Position(X.lineNumber-1,X.column-1)}be.to=_e;function he(X){return{lineNumber:X.line+1,column:X.character+1}}be.from=he})(o=e.Position||(e.Position={}));var S;(function(be){function _e(ke,Be){return(0,f.coalesce)((0,f.asArray)(ke).map(Je=>he(Je,Be)))}be.from=_e;function he(ke,Be){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:X(ke.scheme,Be),pattern:typeof ke.pattern=="undefined"?void 0:Ee.from(ke.pattern),exclusive:ke.exclusive}}function X(ke,Be){return Be&&typeof ke=="string"?Be.transformOutgoingScheme(ke):ke}})(S=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(be){function _e(X){switch(X){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}be.from=_e;function he(X){switch(X){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}be.to=he})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(be){function _e(X){let ke;return X.code&&((0,C.isString)(X.code)||(0,C.isNumber)(X.code)?ke=String(X.code):ke={value:String(X.code.value),target:X.code.target}),{...s.from(X.range),message:X.message,source:X.source,code:ke,severity:u.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(n.from),tags:Array.isArray(X.tags)?(0,f.coalesce)(X.tags.map(r.from)):void 0}}be.from=_e;function he(X){const ke=new _.Diagnostic(s.to(X),X.message,u.to(X.severity));return ke.source=X.source,ke.code=(0,C.isString)(X.code)?X.code:X.code?.value,ke.relatedInformation=X.relatedInformation&&X.relatedInformation.map(n.to),ke.tags=X.tags&&(0,f.coalesce)(X.tags.map(r.to)),ke}be.to=he})(i=e.Diagnostic||(e.Diagnostic={}));var n;(function(be){function _e(X){return{...s.from(X.location.range),message:X.message,resource:X.location.uri}}be.from=_e;function he(X){return new _.DiagnosticRelatedInformation(new _.Location(X.resource,s.to(X)),X.message)}be.to=he})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(be){function _e(X){switch(X){case _.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}be.from=_e;function he(X){switch(X){case b.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}be.to=he})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(be){function _e(X){return typeof X=="number"&&X>=_.ViewColumn.One?X-1:X===_.ViewColumn.Beside?L.SIDE_GROUP:L.ACTIVE_GROUP}be.from=_e;function he(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=he})(c=e.ViewColumn||(e.ViewColumn={}));function d(be){return typeof be.range!="undefined"}function h(be){return be.length===0?!0:!!d(be[0])}e.isDecorationOptionsArr=h;var w;(function(be){function _e(Qe){return Qe.map(be.from)}be.fromMany=_e;function he(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function X(Qe){let pt;if(he(Qe)){const{language:wt,value:bt}=Qe;pt={value:"```"+wt+`
`+bt+"\n```\n"}}else _.MarkdownString.isMarkdownString(Qe)?pt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml}:typeof Qe=="string"?pt={value:Qe}:pt={value:""};const St=Object.create(null);pt.uris=St;const Ct=wt=>{try{let bt=A.URI.parse(wt,!0);bt=bt.with({query:ke(bt.query,St)}),St[wt]=bt}catch{}return""},ft=new D.Renderer;return ft.link=Ct,ft.image=wt=>Ct(I.parseHrefAndDimensions(wt).href),D(pt.value,{renderer:ft}),pt}be.from=X;function ke(Qe,pt){if(!Qe)return Qe;let St;try{St=(0,T.parse)(Qe)}catch{}if(!St)return Qe;let Ct=!1;return St=(0,P.cloneAndChange)(St,ft=>{if(A.URI.isUri(ft)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return pt[wt]=ft,Ct=!0,wt}else return}),Ct?JSON.stringify(St):Qe}function Be(Qe){const pt=new _.MarkdownString(Qe.value,Qe.supportThemeIcons);return pt.isTrusted=Qe.isTrusted,pt.supportHtml=Qe.supportHtml,pt}be.to=Be;function Je(Qe){if(!!Qe)return typeof Qe=="string"?Qe:be.from(Qe)}be.fromStrict=Je})(w=e.MarkdownString||(e.MarkdownString={}));function v(be){return h(be)?be.map(_e=>({range:s.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?w.fromMany(_e.hoverMessage):_e.hoverMessage?w.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):be.map(_e=>({range:s.from(_e)}))}e.fromRangeOrRangeWithMessage=v;function k(be){return typeof be=="undefined"?be:typeof be=="string"?A.URI.file(be):be}e.pathOrURIToURI=k;var O;(function(be){function _e(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?k(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}be.from=_e})(O=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(be){function _e(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?k(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}be.from=_e})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(be){function _e(he){if(typeof he=="undefined")return he;switch(he){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=_e})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(be){function _e(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?F.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?U.from(he.light):void 0,dark:he.dark?U.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?k(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}be.from=_e})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(be){function _e(X){return{text:X.newText,eol:X.newEol&&gt.from(X.newEol),range:s.from(X.range)}}be.from=_e;function he(X){const ke=new _.TextEdit(s.to(X.range),X.text);return ke.newEol=typeof X.eol=="undefined"?void 0:gt.to(X.eol),ke}be.to=he})(V=e.TextEdit||(e.TextEdit={}));var $;(function(be){function _e(X,ke,Be){const Je={edits:[]};if(X instanceof _.WorkspaceEdit)for(let Qe of X._allEntries())if(Qe._type===1)Je.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const pt=ke?.getDocument(Qe.uri);Je.edits.push({_type:2,resource:Qe.uri,edit:V.from(Qe.edit),modelVersionId:pt?.version,metadata:Qe.metadata})}else Qe._type===3?Je.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Be?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version}):Qe._type===5&&Je.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Be?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(ut.from)}});return Je}be.from=_e;function he(X){const ke=new _.WorkspaceEdit;for(const Be of X.edits)Be.edit?ke.replace(A.URI.revive(Be.resource),s.to(Be.edit.range),Be.edit.text):ke.renameFile(A.URI.revive(Be.oldUri),A.URI.revive(Be.newUri),Be.options);return ke}be.to=he})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(be){const _e=Object.create(null);_e[_.SymbolKind.File]=0,_e[_.SymbolKind.Module]=1,_e[_.SymbolKind.Namespace]=2,_e[_.SymbolKind.Package]=3,_e[_.SymbolKind.Class]=4,_e[_.SymbolKind.Method]=5,_e[_.SymbolKind.Property]=6,_e[_.SymbolKind.Field]=7,_e[_.SymbolKind.Constructor]=8,_e[_.SymbolKind.Enum]=9,_e[_.SymbolKind.Interface]=10,_e[_.SymbolKind.Function]=11,_e[_.SymbolKind.Variable]=12,_e[_.SymbolKind.Constant]=13,_e[_.SymbolKind.String]=14,_e[_.SymbolKind.Number]=15,_e[_.SymbolKind.Boolean]=16,_e[_.SymbolKind.Array]=17,_e[_.SymbolKind.Object]=18,_e[_.SymbolKind.Key]=19,_e[_.SymbolKind.Null]=20,_e[_.SymbolKind.EnumMember]=21,_e[_.SymbolKind.Struct]=22,_e[_.SymbolKind.Event]=23,_e[_.SymbolKind.Operator]=24,_e[_.SymbolKind.TypeParameter]=25;function he(ke){return typeof _e[ke]=="number"?_e[ke]:6}be.from=he;function X(ke){for(const Be in _e)if(_e[Be]===ke)return Number(Be);return _.SymbolKind.Property}be.to=X})(N=e.SymbolKind||(e.SymbolKind={}));var B;(function(be){function _e(X){switch(X){case _.SymbolTag.Deprecated:return 1}}be.from=_e;function he(X){switch(X){case 1:return _.SymbolTag.Deprecated}}be.to=he})(B=e.SymbolTag||(e.SymbolTag={}));var x;(function(be){function _e(X){return{name:X.name,kind:N.from(X.kind),tags:X.tags&&X.tags.map(B.from),containerName:X.containerName,location:ie.from(X.location)}}be.from=_e;function he(X){const ke=new _.SymbolInformation(X.name,N.to(X.kind),X.containerName,ie.to(X.location));return ke.tags=X.tags&&X.tags.map(B.to),ke}be.to=he})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(be){function _e(X){const ke={name:X.name||"!!MISSING: name!!",detail:X.detail,range:s.from(X.range),selectionRange:s.from(X.selectionRange),kind:N.from(X.kind),tags:X.tags?.map(B.from)??[]};return X.children&&(ke.children=X.children.map(_e)),ke}be.from=_e;function he(X){const ke=new _.DocumentSymbol(X.name,X.detail,N.to(X.kind),s.to(X.range),s.to(X.selectionRange));return(0,f.isNonEmptyArray)(X.tags)&&(ke.tags=X.tags.map(B.to)),X.children&&(ke.children=X.children.map(he)),ke}be.to=he})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(be){function _e(X){const ke=new _.CallHierarchyItem(N.to(X.kind),X.name,X.detail||"",A.URI.revive(X.uri),s.to(X.range),s.to(X.selectionRange));return ke._sessionId=X._sessionId,ke._itemId=X._itemId,ke}be.to=_e;function he(X,ke,Be){if(ke=ke??X._sessionId,Be=Be??X._itemId,ke===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Be,name:X.name,detail:X.detail,kind:N.from(X.kind),uri:X.uri,range:s.from(X.range),selectionRange:s.from(X.selectionRange),tags:X.tags?.map(B.from)}}be.from=he})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var J;(function(be){function _e(he){return new _.CallHierarchyIncomingCall(W.to(he.from),he.fromRanges.map(X=>s.to(X)))}be.to=_e})(J=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var se;(function(be){function _e(he){return new _.CallHierarchyOutgoingCall(W.to(he.to),he.fromRanges.map(X=>s.to(X)))}be.to=_e})(se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ie;(function(be){function _e(X){return{range:X.range&&s.from(X.range),uri:X.uri}}be.from=_e;function he(X){return new _.Location(A.URI.revive(X.uri),s.to(X.range))}be.to=he})(ie=e.location||(e.location={}));var K;(function(be){function _e(X){const ke=X,Be=X;return{originSelectionRange:ke.originSelectionRange?s.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Be.uri,range:s.from(ke.targetRange?ke.targetRange:Be.range),targetSelectionRange:ke.targetSelectionRange?s.from(ke.targetSelectionRange):void 0}}be.from=_e;function he(X){return{targetUri:A.URI.revive(X.uri),targetRange:s.to(X.range),targetSelectionRange:X.targetSelectionRange?s.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?s.to(X.originSelectionRange):void 0}}be.to=he})(K=e.DefinitionLink||(e.DefinitionLink={}));var Y;(function(be){function _e(X){return{range:s.from(X.range),contents:w.fromMany(X.contents)}}be.from=_e;function he(X){return new _.Hover(X.contents.map(w.to),s.to(X.range))}be.to=he})(Y=e.Hover||(e.Hover={}));var le;(function(be){function _e(X){return{range:s.from(X.range),expression:X.expression}}be.from=_e;function he(X){return new _.EvaluatableExpression(s.to(X.range),X.expression)}be.to=he})(le=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(be){function _e(X){if(X instanceof _.InlineValueText)return{type:"text",range:s.from(X.range),text:X.text};if(X instanceof _.InlineValueVariableLookup)return{type:"variable",range:s.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}be.from=_e;function he(X){switch(X.type){case"text":return{range:s.to(X.range),text:X.text};case"variable":return{range:s.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:s.to(X.range),expression:X.expression}}}be.to=he})(fe=e.InlineValue||(e.InlineValue={}));var Se;(function(be){function _e(X){return{frameId:X.frameId,stoppedLocation:s.from(X.stoppedLocation)}}be.from=_e;function he(X){return new _.InlineValueContext(X.frameId,s.to(X.stoppedLocation))}be.to=he})(Se=e.InlineValueContext||(e.InlineValueContext={}));var Me;(function(be){function _e(X){return{range:s.from(X.range),kind:X.kind}}be.from=_e;function he(X){return new _.DocumentHighlight(s.to(X.range),X.kind)}be.to=he})(Me=e.DocumentHighlight||(e.DocumentHighlight={}));var Ve;(function(be){function _e(he){switch(he){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}be.to=_e})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(be){function _e(he){return{triggerKind:Ve.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}be.to=_e})(Ge=e.CompletionContext||(e.CompletionContext={}));var Ye;(function(be){function _e(X){switch(X){case _.CompletionItemTag.Deprecated:return 1}}be.from=_e;function he(X){switch(X){case 1:return _.CompletionItemTag.Deprecated}}be.to=he})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(be){const _e=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function he(Be){return _e.get(Be)??9}be.from=he;const X=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function ke(Be){return X.get(Be)??_.CompletionItemKind.Property}be.to=ke})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(be){function _e(he,X){const ke=new _.CompletionItem(he.label);return ke.insertText=he.insertText,ke.kind=q.to(he.kind),ke.tags=he.tags?.map(Ye.to),ke.detail=he.detail,ke.documentation=I.isMarkdownString(he.documentation)?w.to(he.documentation):he.documentation,ke.sortText=he.sortText,ke.filterText=he.filterText,ke.preselect=he.preselect,ke.commitCharacters=he.commitCharacters,R.Range.isIRange(he.range)?ke.range=s.to(he.range):typeof he.range=="object"&&(ke.range={inserting:s.to(he.range.insert),replacing:s.to(he.range.replace)}),ke.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?ke.insertText=new _.SnippetString(he.insertText):(ke.insertText=he.insertText,ke.textEdit=ke.range instanceof _.Range?new _.TextEdit(ke.range,ke.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ke.additionalTextEdits=he.additionalTextEdits.map(Be=>V.to(Be))),ke.command=X&&he.command?X.fromInternal(he.command):void 0,ke}be.to=_e})(te=e.CompletionItem||(e.CompletionItem={}));var G;(function(be){function _e(X){return{label:X.label,documentation:X.documentation?w.fromStrict(X.documentation):void 0}}be.from=_e;function he(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?w.to(X.documentation):X.documentation}}be.to=he})(G=e.ParameterInformation||(e.ParameterInformation={}));var Q;(function(be){function _e(X){return{label:X.label,documentation:X.documentation?w.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(G.from):[],activeParameter:X.activeParameter}}be.from=_e;function he(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?w.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(G.to):[],activeParameter:X.activeParameter}}be.to=he})(Q=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(be){function _e(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(Q.from):[]}}be.from=_e;function he(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(Q.to):[]}}be.to=he})(oe=e.SignatureHelp||(e.SignatureHelp={}));var me;(function(be){function _e(he,X){const ke=new _.InlayHint(typeof X.label=="string"?X.label:X.label.map(Ie.to.bind(void 0,he)),o.to(X.position),xe.to(X.kind));return ke.tooltip=I.isMarkdownString(X.tooltip)?w.to(X.tooltip):X.tooltip,ke.whitespaceAfter=X.whitespaceAfter,ke.whitespaceBefore=X.whitespaceBefore,ke}be.to=_e})(me=e.InlayHint||(e.InlayHint={}));var Ie;(function(be){function _e(he,X){const ke=new _.InlayHintLabelPart(X.label);return ke.collapsible=X.collapsible,y.Command.is(X.action)?ke.action=he.fromInternal(X.action):X.action&&(ke.action=ie.to(X.action)),ke}be.to=_e})(Ie=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var xe;(function(be){function _e(X){return X}be.from=_e;function he(X){return X}be.to=he})(xe=e.InlayHintKind||(e.InlayHintKind={}));var Xe;(function(be){function _e(X){return{range:s.from(X.range),url:X.target,tooltip:X.tooltip}}be.from=_e;function he(X){let ke;if(X.url)try{ke=typeof X.url=="string"?A.URI.parse(X.url,!0):A.URI.revive(X.url)}catch{}return new _.DocumentLink(s.to(X.range),ke)}be.to=he})(Xe=e.DocumentLink||(e.DocumentLink={}));var it;(function(be){function _e(X){const ke=new _.ColorPresentation(X.label);return X.textEdit&&(ke.textEdit=V.to(X.textEdit)),X.additionalTextEdits&&(ke.additionalTextEdits=X.additionalTextEdits.map(Be=>V.to(Be))),ke}be.to=_e;function he(X){return{label:X.label,textEdit:X.textEdit?V.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(ke=>V.from(ke)):void 0}}be.from=he})(it=e.ColorPresentation||(e.ColorPresentation={}));var st;(function(be){function _e(X){return new _.Color(X[0],X[1],X[2],X[3])}be.to=_e;function he(X){return[X.red,X.green,X.blue,X.alpha]}be.from=he})(st=e.Color||(e.Color={}));var ot;(function(be){function _e(X){return{range:s.from(X.range)}}be.from=_e;function he(X){return new _.SelectionRange(s.to(X.range))}be.to=he})(ot=e.SelectionRange||(e.SelectionRange={}));var tt;(function(be){function _e(he){switch(he){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}be.to=_e})(tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var rt;(function(be){function _e(X){switch(X){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}be.from=_e;function he(X){switch(X){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}be.to=he})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(be){function _e(X){if(X===_.EndOfLine.CRLF)return 1;if(X===_.EndOfLine.LF)return 0}be.from=_e;function he(X){if(X===1)return _.EndOfLine.CRLF;if(X===0)return _.EndOfLine.LF}be.to=he})(gt=e.EndOfLine||(e.EndOfLine={}));var Ne;(function(be){function _e(he){if(typeof he=="object")return he.viewId;switch(he){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=_e})(Ne=e.ProgressLocation||(e.ProgressLocation={}));var It;(function(be){function _e(he){const X={start:he.start+1,end:he.end+1};return he.kind&&(X.kind=ee.from(he.kind)),X}be.from=_e})(It=e.FoldingRange||(e.FoldingRange={}));var ee;(function(be){function _e(he){if(he)switch(he){case _.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}be.from=_e})(ee=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ne;(function(be){function _e(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?s.from(he.selection):void 0,override:typeof he.override=="boolean"?l.EditorResolution.DISABLED:void 0}}be.from=_e})(ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(be){function _e(ke){return ke instanceof _.RelativePattern||typeof ke=="string"?ke:he(ke)||X(ke)?new _.RelativePattern(ke.baseUri??ke.base,ke.pattern):ke}be.from=_e;function he(ke){const Be=ke;return Be&&A.URI.isUri(Be.baseUri)&&typeof Be.pattern=="string"}be.isRelativePattern=he;function X(ke){const Be=ke;return Be&&typeof Be.base=="string"&&typeof Be.pattern=="string"}})(Ee=e.GlobPattern||(e.GlobPattern={}));var re;(function(be){function _e(he){if(he){if(Array.isArray(he))return he.map(_e);if(typeof he=="string")return he;{const X=he;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:Ee.from(X.pattern),exclusive:X.exclusive}}}else return}be.from=_e})(re=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(be){function _e(X){return{start:X.start,end:X.end}}be.from=_e;function he(X){return new _.NotebookRange(X.start,X.end)}be.to=he})(Ce=e.NotebookRange||(e.NotebookRange={}));var Fe;(function(be){function _e(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}be.to=_e;function he(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}be.from=he})(Fe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(be){function _e(X){switch(X){case _.NotebookCellKind.Markup:return g.CellKind.Markup;case _.NotebookCellKind.Code:default:return g.CellKind.Code}}be.from=_e;function he(X){switch(X){case g.CellKind.Markup:return _.NotebookCellKind.Markup;case g.CellKind.Code:default:return _.NotebookCellKind.Code}}be.to=he})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var ze;(function(be){function _e(X){const ke={metadata:X.metadata??Object.create(null),cells:[]};for(let Be of X.cells)_.NotebookCellData.validate(Be),ke.cells.push(ut.from(Be));return ke}be.from=_e;function he(X){const ke=new _.NotebookData(X.cells.map(ut.to));return(0,C.isEmptyObject)(X.metadata)||(ke.metadata=X.metadata),ke}be.to=he})(ze=e.NotebookData||(e.NotebookData={}));var ut;(function(be){function _e(X){return{cellKind:qe.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:Fe.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ae.from):[]}}be.from=_e;function he(X){return new _.NotebookCellData(qe.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ae.to):void 0,X.metadata,X.internalMetadata?Fe.to(X.internalMetadata):void 0)}be.to=he})(ut=e.NotebookCellData||(e.NotebookCellData={}));var Re;(function(be){function _e(X){return{mime:X.mime,valueBytes:t.VSBuffer.wrap(X.data)}}be.from=_e;function he(X){return new _.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}be.to=he})(Re=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(be){function _e(X){return{outputId:X.id,items:X.items.map(Re.from),metadata:X.metadata}}be.from=_e;function he(X){const ke=X.items.map(Re.to);return new _.NotebookCellOutput(ke,X.outputId,X.metadata)}be.to=he})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(be){function _e(ke){if(ke!=null){if(ke instanceof _.RelativePattern||typeof ke=="string")return ke;if(Ee.isRelativePattern(ke))return new _.RelativePattern(ke.baseUri,ke.pattern);if(X(ke))return{include:Ee.from(ke.include)||void 0,exclude:Ee.from(ke.exclude)||void 0}}}be.from=_e;function he(ke){return typeof ke=="string"?ke:Ee.isRelativePattern(ke)?new _.RelativePattern(ke.baseUri,ke.pattern):{include:ke.include,exclude:ke.exclude}}be.to=he;function X(ke){const Be=ke,Je=Ee.from(Be.include);if(!(Je&&Je instanceof _.RelativePattern||typeof Je=="string"))return!1;const Qe=Ee.from(Be.exclude);return!!(Qe&&Qe instanceof _.RelativePattern||typeof Qe=="string")}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ce;(function(be){function _e(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?O.from(he.top):void 0}}be.from=_e})(ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var de;(function(be){function _e(he,X,ke){const Be=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Be,ke),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}be.from=_e})(de=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var we;(function(be){function _e(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}be.from=_e})(we=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ye;(function(be){function _e(X){return{uri:X.uri,provides:X.provides}}be.from=_e;function he(X){return new _.NotebookRendererScript(A.URI.revive(X.uri),X.provides)}be.to=he})(ye=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Oe;(function(be){function _e(X){return{message:w.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location?ie.from(X.location):void 0}}be.from=_e;function he(X){const ke=new _.TestMessage(typeof X.message=="string"?X.message:w.to(X.message));return ke.actualOutput=X.actual,ke.expectedOutput=X.expected,ke.location=X.location?ie.to(X.location):void 0,ke}be.to=he})(Oe=e.TestMessage||(e.TestMessage={}));var Ke;(function(be){let _e;(function(he){he.Delimiter="\0"})(_e||(_e={})),be.namespace=(he,X)=>he+"\0"+X,be.denamespace=he=>{const X=he.indexOf("\0");return{ctrlId:he.slice(0,X),tagId:he.slice(X+1)}}})(Ke=e.TestTag||(e.TestTag={}));var We;(function(be){function _e(Be){const Je=(0,p.getPrivateApiFor)(Be).controllerId;return{extId:E.TestId.fromExtHostTestItem(Be,Je).toString(),label:Be.label,uri:Be.uri,tags:Be.tags.map(Qe=>Ke.namespace(Je,Qe.id)),range:s.from(Be.range)||null,description:Be.description||null,error:Be.error&&w.fromStrict(Be.error)||null}}be.from=_e;function he(Be){return{parent:void 0,error:void 0,id:E.TestId.fromString(Be.extId).localId,label:Be.label,uri:A.URI.revive(Be.uri),tags:(Be.tags||[]).map(Je=>{const{tagId:Qe}=Ke.denamespace(Je);return new _.TestTag(Qe)}),range:s.to(Be.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Be.description||void 0}}be.toPlain=he;function X(Be){const Je=E.TestId.fromString(Be.extId),Qe=new p.TestItemImpl(Je.controllerId,Je.localId,Be.label,A.URI.revive(Be.uri));return Qe.range=s.to(Be.range||void 0),Qe.description=Be.description||void 0,Qe}function ke(Be){let Je;for(const Qe of Be.tests){const pt=X(Qe.item);(0,p.getPrivateApiFor)(pt).parent=Je,Je=pt}return Je}be.toItemFromContext=ke})(We=e.TestItem||(e.TestItem={})),function(be){function _e(X){return{id:X.id}}be.from=_e;function he(X){return new _.TestTag(X.id)}be.to=he}(Ke=e.TestTag||(e.TestTag={}));var Ze;(function(be){const _e=(X,ke)=>{const Be={...We.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Qe=>Qe.type===0).map(Oe.to)})),children:X.children.map(Je=>ke.get(Je)).filter(C.isDefined).map(Je=>_e(Je,ke))};for(const Je of Be.children)Je.parent=Be;return Be};function he(X){const ke=[],Be=new Map;for(const Je of X.items)Be.set(Je.item.extId,Je),X.request.targets.some(Qe=>Qe.controllerId===Je.controllerId&&Qe.testIds.includes(Je.item.extId))&&ke.push(Je);return{completedAt:X.completedAt,results:ke.map(Je=>_e(Je,Be))}}be.to=he})(Ze=e.TestResults||(e.TestResults={}));var lt;(function(be){function _e(Be){return{covered:Be.covered,total:Be.covered}}function he(Be){return"line"in Be?o.from(Be):s.from(Be)}function X(Be){return"branches"in Be?{count:Be.executionCount,location:he(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Je=>({count:Je.executionCount,location:Je.location&&he(Je.location)})):void 0}:{type:0,count:Be.executionCount,location:he(Be.location)}}be.fromDetailed=X;function ke(Be){return{uri:Be.uri,statement:_e(Be.statementCoverage),branch:Be.branchCoverage&&_e(Be.branchCoverage),function:Be.functionCoverage&&_e(Be.functionCoverage),details:Be.detailedCoverage?.map(X)}}be.fromFile=ke})(lt=e.TestCoverage||(e.TestCoverage={}));var ct;(function(be){function _e(he){switch(he){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}be.to=_e})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var $e;(function(be){function _e(X){const ke=new _.TypeHierarchyItem(N.to(X.kind),X.name,X.detail||"",A.URI.revive(X.uri),s.to(X.range),s.to(X.selectionRange));return ke._sessionId=X._sessionId,ke._itemId=X._itemId,ke}be.to=_e;function he(X,ke,Be){if(ke=ke??X._sessionId,Be=Be??X._itemId,ke===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Be,kind:N.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:s.from(X.range),selectionRange:s.from(X.selectionRange),tags:X.tags?.map(B.from)}}be.from=he})($e=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(pe[217],ve([0,1,2,15,7,18,93]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(A,R,y,l={timeout:1500,errors:3}){this._logService=A,this._documents=R,this._mainThreadBulkEdits=y,this._thresholds=l,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(R,y,l)=>{const p={dispose:this._callbacks.push([R,y,A])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(A,R){const y=f.URI.revive(A);let l=!1;const b=setTimeout(()=>l=!0,this._thresholds.timeout),p=[];try{for(let g of[...this._callbacks]){if(l)break;const E=this._documents.getDocument(y),L=await this._deliverEventAsyncAndBlameBadListeners(g,{document:E,reason:D.TextDocumentSaveReason.to(R)});p.push(L)}}finally{clearTimeout(b)}return p}_deliverEventAsyncAndBlameBadListeners([A,R,y],l){const b=this._badListeners.get(A);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,A,R,l).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const g=this._badListeners.get(A);this._badListeners.set(A,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,R,y,l){const b=[],p=Date.now(),{document:g,reason:E}=l,{version:L}=g,_=Object.freeze({document:g,reason:E,waitUntil(a){if(Object.isFrozen(b))throw(0,t.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(a))}});try{R.apply(y,[_])}catch(a){return Promise.reject(a)}return Object.freeze(b),new Promise((a,s)=>{const m=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(m),a(o)}).catch(o=>{clearTimeout(m),s(o)})}).then(a=>{const s={edits:[]};for(const m of a)if(Array.isArray(m)&&m.every(o=>o instanceof I.TextEdit))for(const{newText:o,newEol:S,range:r}of m)s.edits.push({_type:2,resource:g.uri,edit:{range:r&&D.Range.from(r),text:o,eol:S&&D.EndOfLine.from(S)}});if(s.edits.length!==0)return L===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(pe[218],ve([0,1,10,25,2,18,126]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(y,l,b,p){this.start=y,this.deletedCount=l,this.deletedItems=b,this.items=p}static asApiEvents(y){return y.map(l=>({start:l.start,deletedCount:l.deletedCount,deletedItems:l.deletedItems,items:l.items.map(b=>b.apiCell)}))}}class C{constructor(y,l,b){this.notebook=y,this._extHostDocument=l,this._cellData=b,this.handle=b.handle,this.uri=I.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(y,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return y._mime},set mime(b){y._mime=b},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}})}return this._apiCell}setOutputs(y){this._outputs=y.map(D.NotebookCellOutput.to)}setOutputItems(y,l,b){const p=b.map(D.NotebookCellOutputItem.to),g=this._outputs.find(E=>E.id===y);g&&(l||(g.items.length=0),g.items.push(...p))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=C;class A{constructor(y,l,b,p,g,E){this._proxy=y,this._textDocumentsAndEditors=l,this._textDocuments=b,this._emitter=p,this.uri=g,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=E.viewType,this._metadata=Object.freeze(E.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,E.cells]],!0),this._versionId=E.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this;this._notebook={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===f.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(l){return l=y._validateIndex(l),y._cells[l].apiCell},getCells(l){return(l?y._getCells(l):y._cells).map(p=>p.apiCell)},save(){return y._save()}}}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,l){this._versionId=y.versionId,this._isDirty=l;for(const b of y.rawEvents)b.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===T.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let l=y.start|0,b=y.end|0;return l<0&&(l=0),b>this._cells.length&&(b=this._cells.length),y.with({start:l,end:b})}_getCells(y){y=this._validateRange(y);const l=[];for(let b=y.start;b<y.end;b++)l.push(this._cells[b]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,l){if(this._disposed)return;const b=[],p=[],g=[];y.reverse().forEach(E=>{const _=E[2].map(m=>{const o=new C(this,this._textDocumentsAndEditors,m);return l||p.push(C.asModelAddData(this.apiNotebook,m)),o}),a=new P(E[0],E[1],[],_),s=this._cells.splice(E[0],E[1],..._);for(const m of s)g.push(m.uri),a.deletedItems.push(m.apiCell);b.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:g}),l||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(b)}))}_moveCell(y,l){const b=this._cells.splice(y,1);this._cells.splice(l,0,...b);const p=[new P(y,1,b.map(g=>g.apiCell),[]),new P(l,0,[],b)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(p)}))}_setCellOutputs(y,l){const b=this._cells[y];b.setOutputs(l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(y,l,b,p){const g=this._cells[y];g.setOutputItems(l,b,p),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(y,l){const b=this._cells[y];b.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(b.uri,l)}_changeCellMime(y,l){const b=this._cells[y];b.apiCell.mime=l}_changeCellMetadata(y,l){const b=this._cells[y],p=b.apiCell.metadata;b.setMetadata(l);const g=b.apiCell.metadata;(0,t.equals)(p,g)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(y,l){this._cells[y].setInternalMetadata(l)}getCellFromApiCell(y){return this._cells.find(l=>l.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(l=>l.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(pe[129],ve([0,1,7,18,15]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:A})}replaceCells(C,A,R){this._throwIfFinalized(),!(C===A&&R.length===0)&&this._collectedEdits.push({editType:1,index:C,count:A-C,cells:R.map(t.NotebookCellData.from)})}}class T{constructor(C,A,R,y,l,b){this.id=C,this._proxy=A,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=y,this._viewColumn=b}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(A){if(!Array.isArray(A)||!A.every(f.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");C._selections=A,C._trySetSelections(A)},get visibleRanges(){return C._visibleRanges},revealRange(A,R){C._proxy.$tryRevealRange(C.id,t.NotebookRange.from(A),R??f.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(A){const R=new D(this.document.version);return A(R),C._applyEdit(R.finalize())},setDecorations(A,R){return C.setDecorations(A,R)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(t.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const A=[];let R=-1;for(let y=0;y<C.cellEdits.length;y++){if(R<0){A.push(C.cellEdits[y]),R++;continue}const b=A[R],p=C.cellEdits[y];if(b.editType===1&&p.editType===1&&b.index===p.index){b.cells.push(...C.cellEdits[y].cells),b.count+=C.cellEdits[y].count;continue}A.push(C.cellEdits[y]),R++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,A)}setDecorations(C,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return A.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(A),C.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(pe[219],ve([0,1,18,118,165,21,56,15]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,b,p){const g=this._handles++,{title:E,location:L,cancellable:_}=b,a={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(g,{location:f.ProgressLocation.from(L),title:E,source:a,cancellable:_},l.isUnderDevelopment?void 0:l.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(g,p,!!_)}_withProgress(l,b,p){let g;p&&(g=new D.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,g));const E=_=>{this._proxy.$progressEnd(_),this._mapHandleToCancellationSource.delete(_),g&&g.dispose()};let L;try{L=b(new R(this._proxy,l),p&&g?g.token:D.CancellationToken.None)}catch(_){throw E(l),_}return L.then(_=>E(l),_=>E(l)),L}$acceptProgressCanceled(l){const b=this._mapHandleToCancellationSource.get(l);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=C;function A(y,l){return y.message=l.message,typeof l.increment=="number"&&(typeof y.increment=="number"?y.increment+=l.increment:y.increment=l.increment),y}class R extends t.Progress{constructor(l,b){super(p=>this.throttledReport(p));this._proxy=l,this._handle=b}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}je([(0,T.throttle)(100,(y,l)=>A(y,l),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(pe[130],ve([0,1,55,15,77,18,7]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(l,b,p){const g=P._Keys.nextId();l.$registerTextEditorDecorationType(b.identifier,g,D.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:g,dispose(){l.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=P,P._Keys=new I.IdGenerator("TextEditorDecorationType");class C{constructor(l,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,b){this._throwIfFinalized();let p=null;if(l instanceof T.Position)p=new T.Range(l,l);else if(l instanceof T.Range)p=l;else throw new Error("Unrecognized location");this._pushEdit(p,b,!1)}insert(l,b){this._throwIfFinalized(),this._pushEdit(new T.Range(l,l),b,!0)}delete(l){this._throwIfFinalized();let b=null;if(l instanceof T.Range)b=l;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(l,b,p){const g=this._document.validateRange(l);this._collectedEdits.push({range:g,text:b,forceMoveMarkers:p})}setEndOfLine(l){if(this._throwIfFinalized(),l!==T.EndOfLine.LF&&l!==T.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=C;class A{constructor(l,b,p,g){this._proxy=l,this._id=b,this._accept(p),this._logService=g;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(L){E._setTabSize(L)},get insertSpaces(){return E._insertSpaces},set insertSpaces(L){E._setInsertSpaces(L)},get cursorStyle(){return E._cursorStyle},set cursorStyle(L){E._setCursorStyle(L)},get lineNumbers(){return E._lineNumbers},set lineNumbers(L){E._setLineNumbers(L)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=D.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(l){const b=this._validateTabSize(l);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const b=this._validateInsertSpaces(l);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:D.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let p=!1;if(typeof l.tabSize!="undefined"){const g=this._validateTabSize(l.tabSize);g==="auto"?(p=!0,b.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,p=!0,b.tabSize=g)}if(typeof l.insertSpaces!="undefined"){const g=this._validateInsertSpaces(l.insertSpaces);g==="auto"?(p=!0,b.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,p=!0,b.insertSpaces=g)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,p=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,p=!0,b.lineNumbers=D.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(l,b){b.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=A;class R{constructor(l,b,p,g,E,L,_,a){this.id=l,this._proxy=b,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new A(this._proxy,this.id,L,p),this._visibleRanges=_,this._viewColumn=a;const s=this;this.value=Object.freeze({get document(){return g.getValue()},set document(m){throw(0,t.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(m){if(!(m instanceof T.Selection))throw(0,t.illegalArgument)("selection");s._selections=[m],s._trySetSelection()},get selections(){return s._selections},set selections(m){if(!Array.isArray(m)||m.some(o=>!(o instanceof T.Selection)))throw(0,t.illegalArgument)("selections");s._selections=m,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(m){throw(0,t.readonly)("visibleRanges")},get options(){return s._options.value},set options(m){s._disposed||s._options.assign(m)},get viewColumn(){return s._viewColumn},set viewColumn(m){throw(0,t.readonly)("viewColumn")},edit(m,o={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new C(g.getValue(),o);return m(S),s._applyEdit(S)},insertSnippet(m,o,S={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!o||Array.isArray(o)&&o.length===0)r=s._selections.map(i=>D.Range.from(i));else if(o instanceof T.Position){const{lineNumber:i,column:n}=D.Position.from(o);r=[{startLineNumber:i,startColumn:n,endLineNumber:i,endColumn:n}]}else if(o instanceof T.Range)r=[D.Range.from(o)];else{r=[];for(const i of o)if(i instanceof T.Range)r.push(D.Range.from(i));else{const{lineNumber:n,column:u}=D.Position.from(i);r.push({startLineNumber:n,startColumn:u,endLineNumber:n,endColumn:u})}}return b.$tryInsertSnippet(l,m.value,r,S)},setDecorations(m,o){const S=o.length===0;S&&!s._hasDecorationsForKey.has(m.key)||(S?s._hasDecorationsForKey.delete(m.key):s._hasDecorationsForKey.add(m.key),s._runOnProxy(()=>{if(D.isDecorationOptionsArr(o))return b.$trySetDecorations(l,m.key,D.fromRangeOrRangeWithMessage(o));{const r=new Array(4*o.length);for(let i=0,n=o.length;i<n;i++){const u=o[i];r[4*i]=u.start.line+1,r[4*i+1]=u.start.character+1,r[4*i+2]=u.end.line+1,r[4*i+3]=u.end.character+1}return b.$trySetDecorationsFast(l,m.key,r)}}))},revealRange(m,o){s._runOnProxy(()=>b.$tryRevealRange(l,D.Range.from(m),o||T.TextEditorRevealType.Default))},show(m){b.$tryShowEditor(l,D.ViewColumn.from(m))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,f.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,f.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,f.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,f.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(D.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(E=>E.range);p.sort((E,L)=>E.end.line===L.end.line?E.end.character===L.end.character?E.start.line===L.start.line?E.start.character-L.start.character:E.start.line-L.start.line:E.end.character-L.end.character:E.end.line-L.end.line);for(let E=0,L=p.length-1;E<L;E++){const _=p[E].end;if(p[E+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(E=>({range:D.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?D.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=R}),define(pe[220],ve([0,1,17,3,6,13,64,18,127,88]),function(Z,e,f,t,I,D,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends I.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const b=this.diff[this.diff.length-1];if(b&&l[0]===1){if(b[0]===1&&b[1].extId===l[1].extId){(0,C.applyTestItemUpdate)(b[1],l[1]);return}if(b[0]===0&&b[1].item.extId===l[1].extId){(0,C.applyTestItemUpdate)(b[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,b){const p=this.tree.get(l);if(!!p){if((p.expandLevels===void 0||b>p.expandLevels)&&(p.expandLevels=b),p.expand===1){const g=this.resolveChildren(p);return g.isOpen()?this.expandChildren(p,b-1):g.wait().then(()=>this.expandChildren(p,b-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,b-1)):this.expandChildren(p,b-1)}}dispose(){for(const l of this.tree.values())(0,T.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,b){switch(b.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(l.fullId,b.id));break;case 0:this.upsertItem(b.item,l);break;case 4:for(const p of b.ops)this.onTestItemEvent(l,p);break;case 3:{const{key:p,value:g,previous:E}=b,L=l.fullId.toString();switch(p){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(g,E,L);break;case"range":this.pushDiff([1,{extId:L,item:{range:P.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:L,item:{error:P.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:L,item:{[p]:g??null}}]);break}break}default:(0,D.assertNever)(b)}}upsertItem(l,b){if(!(l instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const p=A.TestId.fromExtHostTestItem(l,this.root.id,b?.actual),g=(0,T.getPrivateApiFor)(l);g.parent&&g.parent!==b?.actual&&g.parent.children.delete(l.id);let E=this.tree.get(p.toString());if(!E){E={fullId:p,actual:l,parent:b?p.parentId:null,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(E.fullId.toString(),E),this.setItemParent(l,b),this.pushDiff([0,{parent:E.parent&&E.parent.toString(),controllerId:this.controllerId,expand:E.expand,item:P.TestItem.from(l)}]),this.connectItemAndChildren(l,E,b);return}if(E.actual===l){this.connectItem(l,E,b);return}const L=E.actual.children,_=E.actual,a=(0,T.diffTestItems)(_,l);(0,T.getPrivateApiFor)(_).listener=void 0,E.actual=l,E.expand=0;for(const[s,m]of a)this.onTestItemEvent(E,{op:3,key:s,value:m,previous:_[s]});this.connectItemAndChildren(l,E,b);for(const s of L)l.children.get(s.id)||this.removeItem(A.TestId.joinToString(p,s.id))}diffTagRefs(l,b,p){const g=new Set(b.map(E=>E.id));for(const E of l)g.delete(E.id)||this.incrementTagRefs(E);this.pushDiff([1,{extId:p,item:{tags:l.map(E=>P.TestTag.namespace(this.controllerId,E.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const b=this.tags.get(l.id);b?b.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const b=this.tags.get(l);b&&!--b.refCount&&(this.tags.delete(l),this.pushDiff([6,P.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,b){(0,T.getPrivateApiFor)(l).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(l,b,p){this.setItemParent(l,p);const g=(0,T.getPrivateApiFor)(l);g.parent=p?.actual,g.listener=E=>this.onTestItemEvent(b,E),this.updateExpandability(b)}connectItemAndChildren(l,b,p){this.connectItem(l,b,p);for(const g of l.children)this.upsertItem(g,b)}updateExpandability(l){let b;this._resolveHandler?l.resolveBarrier?b=l.resolveBarrier.isOpen()?3:2:b=l.actual.canResolveChildren?1:0:b=0,b!==l.expand&&(l.expand=b,this.pushDiff([1,{extId:l.fullId.toString(),expand:b}]),b===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,b){if(b<0)return;const p=[];for(const g of l.actual.children){const E=this.expand(A.TestId.joinToString(l.fullId,g.id),b);(0,f.isThenable)(E)&&p.push(E)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const E=new f.Barrier;return E.open(),E}l.expand=2,this.pushExpandStateUpdate(l);const b=l.resolveBarrier=new f.Barrier,p=E=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=E.stack||E.message||String(E))};let g;try{g=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(E){p(E)}return(0,f.isThenable)(g)?g.catch(p).then(()=>{b.open(),this.updateExpandability(l)}):(b.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const b=this.tree.get(l);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const p=[b];for(;p.length;){const g=p.pop();if(!!g){(0,T.getPrivateApiFor)(g.actual).listener=void 0;for(const E of g.actual.tags)this.decrementTagRefs(E.id);this.tree.delete(g.fullId.toString());for(const E of g.actual.children)p.push(this.tree.get(A.TestId.joinToString(g.fullId,E.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=R}),define(pe[221],ve([0,1,4,183]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(t.IEnvironmentService)}),define(pe[222],ve([0,1,27,3,9]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class D{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=D;class T{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let y of R.activationEvents)y==="onUri"&&(y=`onUri:${f.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(R)}}keepOnly(R){const y=new Set;R.forEach(l=>y.add(f.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>y.has(f.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,y){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const l=T._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(l.map(b=>b.identifier)),y.length>0){const b=new Set;y.forEach(p=>b.add(f.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>!b.has(f.ExtensionIdentifier.toKey(p.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new D(l)}static _findLoopingExtensions(R){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,L){this.addNode(E),this.addNode(L),this._arcs.has(E)?this._arcs.get(E).push(L):this._arcs.set(E,[L])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,L){const _=y.getArcs(E);for(let a=0;a<_.length;a++)if(!L.has(_[a]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let E of R){const L=f.ExtensionIdentifier.toKey(E.identifier);if(l.set(L,E),E.extensionDependencies)for(let _ of E.extensionDependencies){const a=f.ExtensionIdentifier.toKey(_);y.addArc(L,a)}}let b=new Set;y.getNodes().filter(E=>y.getArcs(E).length===0).forEach(E=>b.add(E));let p=y.getNodes().filter(E=>!b.has(E)),g;do{g=!1;for(let E=0;E<p.length;E++){const L=p[E];y.hasOnlyGoodArcs(L,b)&&(p.splice(E,1),E--,b.add(L),g=!0)}}while(g);return p.map(E=>l.get(E))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const y=this._activationMap.get(R);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const y=this._extensionsMap.get(f.ExtensionIdentifier.toKey(R));return y||void 0}}e.ExtensionDescriptionRegistry=T;var P;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(P||(P={}));function C(A,R){const y=A.isBuiltin?0:A.isUnderDevelopment?2:1,l=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(y!==l)return y-l;const b=I.posix.basename(A.extensionLocation.path),p=I.posix.basename(R.extensionLocation.path);return b<p?-1:b>p?1:0}}),define(pe[223],ve([0,1,22]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function D(P){const C=f.VSBuffer.alloc(1);switch(P){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=D;function T(P,C){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=T}),define(pe[28],ve([0,1,3,2,4,27,194]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new D.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var P;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class A{constructor(m){this.dependency=m}}e.MissingExtensionDependency=A;var R;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;function l(s,m){return s.enabledApiProposals?s.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=l;function b(s,m){if(!l(s,m))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=b;class p{constructor(m,o,S,r){this.codeLoadingTime=m,this.activateCallTime=o,this.activateResolvedTime=S,this.activationReason=r}}e.ActivationTimes=p;class g{constructor(m,o){this.description=m,this.value=o}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var E;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(E=e.ActivationKind||(e.ActivationKind={}));function L(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=L;function _(s,m){return{identifier:new D.ExtensionIdentifier((0,T.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!m,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=_;class a{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(m){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(m,o){return Promise.resolve()}_onWillActivateExtension(m){}_onDidActivateExtension(m,o,S,r,i){}_onDidActivateExtensionError(m,o){}_onExtensionRuntimeError(m,o){}_onExtensionHostExit(m){}}e.NullExtensionService=a}),define(pe[224],ve([0,1,15,27,28,11]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class P{constructor(g,E,L,_){this.startup=g,this.codeLoadingTime=E,this.activateCallTime=L,this.activateResolvedTime=_}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class C{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,E){return g===-1||E===-1?-1:E-g}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class A{constructor(g,E,L,_,a,s){this.activationFailed=g,this.activationFailedError=E,this.activationTimes=L,this.module=_,this.exports=a,this.subscriptions=s}}e.ActivatedExtension=A;class R extends A{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class y extends A{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class l extends A{constructor(g){super(!0,g,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let b=class{constructor(g,E,L,_,a){this._logService=a,this._isDisposed=!1,this._registry=g,this._resolvedExtensionsSet=new Set,E.forEach(s=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,L.forEach(s=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(s),s)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(g){const E=t.ExtensionIdentifier.toKey(g);return this._activatedExtensions.has(E)}getActivatedExtension(g){const E=t.ExtensionIdentifier.toKey(g),L=this._activatedExtensions.get(E);if(!L)throw new Error("Extension `"+g.value+"` is not known or not activated");return L}activateByEvent(g,E){if(this._alreadyActivatedEvents[g])return T;const L=this._registry.getExtensionDescriptionsForActivationEvent(g);return this._activateExtensions(L.map(_=>({id:_.identifier,reason:{startup:E,extensionId:_.identifier,activationEvent:g}}))).then(()=>{this._alreadyActivatedEvents[g]=!0})}activateById(g,E){const L=this._registry.getExtensionDescription(g);if(!L)throw new Error("Extension `"+g+"` is not known");return this._activateExtensions([{id:L.identifier,reason:E}])}_handleActivateRequest(g,E,L){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id))){E[t.ExtensionIdentifier.toKey(g.id)]=g;return}const _=this._registry.getExtensionDescription(g.id);if(!_){const m=new Error(`Cannot activate unknown extension '${g.id.value}'`);this._host.onExtensionActivationError(g.id,m,new I.MissingExtensionDependency(g.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(g.id),new l(m));return}const a=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let s=!0;for(let m=0,o=a.length;m<o;m++){const S=a[m];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(S)))continue;const r=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(S));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const c=_.displayName||_.identifier.value,d=this._registry.getExtensionDescription(S),h=d&&d.displayName||S,w=new Error(`Cannot activate the '${c}' extension because its dependency '${h}' failed to activate`);w.detail=r.activationFailedError,this._host.onExtensionActivationError(_.identifier,w,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new l(w));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(S))){s=!1,E[t.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(S)),reason:g.reason};continue}const i=this._registry.getExtensionDescription(S);if(i){if(!i.main&&!i.browser)continue;s=!1,E[t.ExtensionIdentifier.toKey(S)]={id:i.identifier,reason:g.reason};continue}const n=_.displayName||_.identifier.value,u=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(_.identifier,u,new I.MissingExtensionDependency(S)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(_.identifier),new l(u));return}s?E[t.ExtensionIdentifier.toKey(_.identifier)]=g:L.push(g)}_activateExtensions(g){if(g.length===0||(g=g.filter(a=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(a.id))),g.length===0))return Promise.resolve(void 0);const E=Object.create(null),L=[];for(let a=0,s=g.length;a<s;a++)this._handleActivateRequest(g[a],E,L);for(let a=0,s=L.length;a<s;a++){const m=t.ExtensionIdentifier.toKey(L[a].id);E[m]&&delete E[m]}const _=Object.keys(E).map(a=>E[a]);return L.length===0?Promise.all(_.map(a=>this._activateExtension(a.id,a.reason))).then(a=>{}):this._activateExtensions(_).then(a=>this._activateExtensions(L))}_activateExtension(g,E){const L=t.ExtensionIdentifier.toKey(g);if(this._activatedExtensions.has(L))return Promise.resolve(void 0);const _=this._activatingExtensions.get(L);if(_)return _;const a=this._host.actualActivateExtension(g,E).then(void 0,s=>{const m=new Error;return s&&s.name&&(m.name=s.name),s&&s.message?m.message=`Activating extension '${g.value}' failed: ${s.message}.`:m.message=`Activating extension '${g.value}' failed: ${s}.`,s&&s.stack&&(m.stack=s.stack),this._isDisposed&&f.isCancellationError(s)?new l(s):(this._host.onExtensionActivationError(g,m,null),this._logService.error(`Activating extension ${g.value} failed due to an error:`),this._logService.error(s),new l(s))}).then(s=>{this._activatedExtensions.set(L,s),this._activatingExtensions.delete(L)});return this._activatingExtensions.set(L,a),a}};b=je([He(4,D.ILogService)],b),e.ExtensionsActivator=b}),define(pe[225],ve([0,1,11,26,28]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends f.LogService{constructor(P,C){super(P.createLogger(C.logFile,{name:I.ExtensionHostLogFileName}))}};D=je([He(0,f.ILoggerService),He(1,t.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(pe[226],ve([0,1,15]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,T)=>{this._actualOk=D,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,f.onUnexpectedError)(D))}then(D,T){return this._ensureActual().then(D,T)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=t}),define(pe[52],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(A,R){this._proxyIdentifierBrand=void 0,this.isMain=A,this.sid=R,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const t=[];function I(C){const A=new f(!0,C);return t[A.nid]=A,A}e.createMainContextProxyIdentifier=I;function D(C){const A=new f(!1,C);return t[A.nid]=A,A}e.createExtHostContextProxyIdentifier=D;function T(C){return t[C].sid}e.getStringIdentifierForProxy=T;class P{constructor(A){this.value=A}}e.SerializableObjectWithBuffers=P}),define(pe[5],ve([0,1,59,2,52]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var D;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(a){a.name="$ident";function s(o,S){return Object.defineProperty(o,a.name,{value:S,enumerable:!0}),o}a.mixin=s;function m(o){return o[a.name]}a.of=m})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class b{static mixin(s){return s._id=b._n++,s}}e.IdObject=b,b._n=0;var p;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(p=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function L(a){if(a&&a.edits)for(const s of a.edits)typeof s.resource=="object"?s.resource=t.URI.revive(s.resource):(s.newUri=t.URI.revive(s.newUri),s.oldUri=t.URI.revive(s.oldUri)),s.metadata&&s.metadata.iconPath&&(s.metadata=(0,f.revive)(s.metadata));return a}e.reviveWorkspaceEditDto=L;var _;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(pe[89],ve([0,1,5,3,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class D{constructor(P){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,C){return this._proxy.$getPassword(P,C)}store(P,C,A){return this._proxy.$setPassword(P,C,A)}delete(P,C){return this._proxy.$deletePassword(P,C)}}e.ExtHostSecretState=D,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(pe[66],ve([0,1,4,11,5,14]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(C,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(I.MainContext.MainThreadTelemetry)}report(C,A,R){const y=this.getUsageKey(C,A);this._reportedUsages.has(y)||(this._reportedUsages.add(y),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:C}))}getUsageKey(C,A){return`${C}-${A.identifier.value}`}};T=je([He(0,D.IExtHostRpcService),He(1,t.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(P,C,A){}})}),define(pe[227],ve([0,1,3,5,7,27]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,A,R,y={}){const l=D.ExtensionIdentifier.toKey(C.identifier),b=this._inFlightRequests.get(l)||[],p=[...R].sort().join(" ");let g=b.find(E=>E.scopes===p);if(g)return g.result;{const E=this._getSession(C,l,A,R,y);g={scopes:p,result:E},b.push(g),this._inFlightRequests.set(l,b);try{await E}finally{const L=b.findIndex(_=>_.scopes===p);L>-1&&(b.splice(L),this._inFlightRequests.set(l,b))}return E}}async _getSession(C,A,R,y,l={}){await this._proxy.$ensureProvider(R);const b=C.displayName||C.name;return this._proxy.$getSession(R,y,A,b,l)}async removeSession(C,A){const R=this._authenticationProviders.get(C);return R?R.provider.removeSession(A):this._proxy.$removeSession(C,A)}registerAuthenticationProvider(C,A,R,y){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:A,provider:R,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===C)||this._providers.push({id:C,label:A});const l=R.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(C,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,A,y?.supportsMultipleAccounts??!1),new I.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(C);const b=this._providers.findIndex(p=>p.id===C);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,A){const R=this._authenticationProviders.get(C);if(R)return Promise.resolve(R.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,A){return this._onDidChangeSessions.fire({provider:{id:C,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(pe[228],ve([0,1,5,14,18]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(P,C){this._extHostDocumentsAndEditors=C,this._proxy=P.getProxy(f.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const C=I.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};D=je([He(0,t.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(pe[229],ve([0,1,5]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(D){const T=D.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(P){return T.$writeText(P)}})}}e.ExtHostClipboard=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[38],ve([0,1,13,7,18,25,5,16,11,59,41,48,2,6,4,14,64,22,52,49]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(u,c){s.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,nt(this,s,u.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=c,this.converter=new o(this,d=>{const h=this._apiCommands.get(d);return h?.result===r.Void?h:void 0},c),this._argumentProcessors=[{processArgument(d){return(0,A.revive)(d)}},{processArgument(d){return(0,D.cloneAndChange)(d,function(h){if(R.Range.isIRange(h))return I.Range.to(h);if(y.Position.isIPosition(h))return I.Position.to(h);if(R.Range.isIRange(h.range)&&l.URI.isUri(h.uri))return I.location.to(h);if(h instanceof L.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const c=this.registerCommand(!1,u.id,async(...d)=>{const h=u.args.map((v,k)=>{if(!v.validate(d[k]))throw new Error(`Invalid argument '${v.name}' when running '${u.id}', received: ${d[k]}`);return v.convert(d[k])}),w=await this.executeCommand(u.internalId,...h);return u.result.convert(w,d,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,c,d,h,w,v){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:d,thisArg:h,description:w,extension:v}),u&&Le(this,s,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&u&&Le(this,s,"f").$unregisterCommand(c)})}executeCommand(u,...c){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,c,!0)}async _doExecuteCommand(u,c,d){if(this._commands.has(u))return this._executeContributedCommand(u,c,!1);{let h=!1;const w=(0,D.cloneAndChange)(c,function(v){if(v instanceof t.Position)return I.Position.from(v);if(v instanceof t.Range)return I.Range.from(v);if(v instanceof t.Location)return I.location.from(v);if(t.NotebookRange.isNotebookRange(v))return I.NotebookRange.from(v);if(v instanceof ArrayBuffer)return h=!0,L.VSBuffer.wrap(new Uint8Array(v));if(v instanceof Uint8Array)return h=!0,L.VSBuffer.wrap(v);if(!Array.isArray(v))return v});try{const v=await Le(this,s,"f").$executeCommand(u,h?new _.SerializableObjectWithBuffers(w):w,d);return(0,A.revive)(v)}catch(v){if(v instanceof Error&&v.message==="$executeCommand:retry")return this._doExecuteCommand(u,c,!1);throw v}}}async _executeContributedCommand(u,c,d){const h=this._commands.get(u);if(!h)throw new Error("Unknown command");let{callback:w,thisArg:v,description:k}=h;if(k)for(let O=0;O<k.args.length;O++)try{(0,f.validateConstraint)(c[O],k.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${k.args[O].name}' - ${k.args[O].description}`)}try{return await w.apply(v,c)}catch(O){if(u===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...c);U&&(u=U.command)}throw this._logService.error(O,u,h.extension?.identifier),d?new class extends Error{constructor(){super((0,a.toErrorMessage)(O));this.id=u,this.source=h.extension?.displayName??h.extension?.name}}:O}}$executeContributedCommand(u,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(c=c.map(d=>this._argumentProcessors.reduce((h,w)=>w.processArgument(h),d)),this._executeContributedCommand(u,c,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),Le(this,s,"f").$getCommands().then(c=>(u&&(c=c.filter(d=>d[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[c,d]of this._commands){let{description:h}=d;h&&(u[c]=h)}return Promise.resolve(u)}};s=new WeakMap,m=je([He(0,g.IExtHostRpcService),He(1,C.ILogService)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class o{constructor(u,c,d){this._commands=u,this._lookupApiCommand=c,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,c){if(!u)return;const d={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return d;const h=this._lookupApiCommand(u.command);if(h)d.id=h.internalId,d.arguments=h.args.map((w,v)=>w.convert(u.arguments&&u.arguments[v]));else if((0,P.isNonEmptyArray)(u.arguments)){const w=++this._cachIdPool;this._cache.set(w,u),c.add((0,b.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),d.$ident=w,d.id=this.delegatingCommandId,d.arguments=[w],this._logService.trace("CommandsConverter#CREATE",u.command,w)}return d}fromInternal(u){const c=T.ObjectIdentifier.of(u);return typeof c=="number"?this._cache.get(c):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const c=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class S{constructor(u,c,d,h){this.name=u,this.description=c,this.validate=d,this.convert=h}optional(){return new S(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,c){return new S(u??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",n=>l.URI.isUri(n),n=>n),S.Position=new S("position","A position in a text document",n=>t.Position.isPosition(n),I.Position.from),S.Range=new S("range","A range in a text document",n=>t.Range.isRange(n),I.Range.from),S.Selection=new S("selection","A selection in a text document",n=>t.Selection.isSelection(n),I.Selection.from),S.Number=new S("number","",n=>typeof n=="number",n=>n),S.String=new S("string","",n=>typeof n=="string",n=>n),S.CallHierarchyItem=new S("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",n=>n instanceof E.TestItemImpl,I.TestItem.from);class r{constructor(u,c){this.description=u,this.convert=c}}e.ApiCommandResult=r,r.Void=new r("no result",n=>n);class i{constructor(u,c,d,h,w){this.id=u,this.internalId=c,this.description=d,this.args=h,this.result=w}}e.ApiCommand=i}),define(pe[230],ve([0,1,18,7,83,38,16,111]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(f.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,b)=>{if((0,T.isFalsyOrEmpty)(l))return;class p extends t.SymbolInformation{static to(E){const L=new p(E.name,f.SymbolKind.to(E.kind),E.containerName||"",new t.Location(b[0],f.Range.to(E.range)));return L.detail=E.detail,L.range=L.location.range,L.selectionRange=f.Range.to(E.selectionRange),L.children=E.children?E.children.map(p.to):[],L}}return l.map(p.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(f.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(f.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(b=>t.Position.isPosition(b)),l=>l.map(f.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(b=>{let p;for(const g of b.reverse())p=new t.SelectionRange(f.Range.to(g),p);return p}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(f.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:f.Range.to(l.range),placeholder:l.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return f.WorkspaceEdit.to(l)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(f.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,P.decodeSemanticTokensDto)(l);if(b.type==="full")return new t.SemanticTokens(b.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,P.decodeSemanticTokensDto)(l);if(b.type==="full")return new t.SemanticTokens(b.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,b,p)=>{if(!l)return new t.CompletionList([]);const g=l.suggestions.map(E=>f.CompletionItem.to(E,p));return new t.CompletionList(g,l.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return f.SignatureHelp.to(l)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,b,p)=>R(g=>new t.CodeLens(f.Range.to(g.range),g.command&&p.fromInternal(g.command)))(l))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>t.Range.isRange(l),l=>t.Selection.isSelection(l)?f.Selection.from(l):f.Range.from(l)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,b,p)=>R(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(g.command)}else{const E=new t.CodeAction(g.title,g.kind?new t.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=f.WorkspaceEdit.to(g.edit)),g.command&&(E.command=p.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(l))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(b=>new t.ColorInformation(f.Range.to(b.range),f.Color.to(b.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",l=>l instanceof t.Color,f.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:f.Range.from(l.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(f.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,b,p)=>l.map(f.InlayHint.to.bind(void 0,p)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(b=>f.NotebookExclusiveDocumentPattern.to(b))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(f.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[f.ViewColumn.from(l),void 0]:[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[f.ViewColumn.from(l),void 0]:[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void)];class A{static register(b){C.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=A;function R(l){return b=>{if(Array.isArray(b))return b.map(l)}}function y(l){if(!Array.isArray(l))return;const b=[];for(const p of l)I.isLocationLink(p)?b.push(f.DefinitionLink.to(p)):b.push(f.location.to(p));return b}}),define(pe[231],ve([0,1,17,56,3,6,2,83,27,18,7,28,5]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(p,g,E){const L=p.getProxy(l.MainContext.MainThreadComments);class _{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const u=this._commentControllers.get(n.handle);return u||n}else if(n&&n.$mid===7){const u=this._commentControllers.get(n.commentControlHandle);if(!u)return n;const c=u.getCommentThread(n.commentThreadHandle);return c||n}else if(n&&n.$mid===8){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const c=u.getCommentThread(n.thread.commentThreadHandle);return c?{thread:c,text:n.text}:n}else if(n&&n.$mid===9){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const c=u.getCommentThread(n.thread.commentThreadHandle);if(!c)return n;let d=n.commentUniqueId,h=c.getCommentByUniqueId(d);return h||n}else if(n&&n.$mid===10){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const c=u.getCommentThread(n.thread.commentThreadHandle);if(!c)return n;let d=n.text,h=n.commentUniqueId,w=c.getCommentByUniqueId(h);return w?(w.body=d,w):n}return n}})}createCommentController(n,u,c){const d=_.handlePool++,h=new s(n,d,u,c);this._commentControllers.set(h.handle,h);const w=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(n.identifier))||[];return w.push(h),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(n.identifier),w),h.value}$createCommentThreadTemplate(n,u,c){const d=this._commentControllers.get(n);!d||d.$createCommentThreadTemplate(u,c)}async $updateCommentThreadTemplate(n,u,c){const d=this._commentControllers.get(n);!d||d.$updateCommentThreadTemplate(u,c)}$deleteCommentThread(n,u){const c=this._commentControllers.get(n);c&&c.$deleteCommentThread(u)}$provideCommentingRanges(n,u,c){const d=this._commentControllers.get(n);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const h=E.getDocument(T.URI.revive(u));return(0,f.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(h,c)).then(w=>w?w.map(v=>A.Range.from(v)):void 0)}$toggleReaction(n,u,c,d,h){const w=this._commentControllers.get(n);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const v=w.getCommentThread(u);if(v){const k=v.getCommentByUniqueId(d.uniqueIdInThread);if(w!==void 0&&k&&w.reactionHandler)return w.reactionHandler(k,S(h))}return Promise.resolve(void 0)})}dispose(){}}_.handlePool=0;class a{constructor(n,u,c,d,h,w,v){this._commentControllerHandle=u,this._id=c,this._uri=d,this._range=h,this._comments=w,this.extensionDescription=v,this.handle=a._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputDisposables.value=new D.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),L.$createCommentThread(u,this.handle,this._id,this._uri,A.Range.from(this._range),v.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this._localDisposables.push({dispose:()=>{L.$deleteCommentThread(u,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(O){k.range=O},get comments(){return k.comments},set comments(O){k.comments=O},get collapsibleState(){return k.collapsibleState},set collapsibleState(O){k.collapsibleState=O},get canReply(){return k.canReply},set canReply(O){k.canReply=O},get contextValue(){return k.contextValue},set contextValue(O){k.contextValue=O},get label(){return k.label},set label(O){k.label=O},dispose:()=>{k.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new D.DisposableStore);const n=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),u={};n("range")&&(u.range=A.Range.from(this._range)),n("label")&&(u.label=this.label),n("contextValue")&&(u.contextValue=this.contextValue??null),n("comments")&&(u.comments=this._comments.map(c=>m(this,c,this._commentsMap))),n("collapsibleState")&&(u.collapseState=r(this._collapseState)),n("canReply")&&(u.canReply=this.canReply),this.modifications={},L.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(n){for(let u of this._commentsMap){let c=u[0],d=u[1];if(n===d)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}a._handlePool=0,je([(0,t.debounce)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(n,u,c,d){this._extension=n,this._handle=u,this._id=c,this._label=d,this._threads=new Map,L.$registerCommentController(this.handle,c,d);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(w){h.options=w},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(w){h.commentingRangeProvider=w},get reactionHandler(){return h.reactionHandler},set reactionHandler(w){h.reactionHandler=w},createCommentThread(w,v,k){return h.createCommentThread(w,v,k).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{L.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,L.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,L.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,L.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,u,c,d){if(typeof n=="string"){const h=new a(this.id,this.handle,n,u,c,d,this._extension);return this._threads.set(h.handle,h),h}else{const h=new a(this.id,this.handle,void 0,n,u,c,this._extension);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(n,u){const c=new a(this.id,this.handle,void 0,T.URI.revive(n),A.Range.to(u),[],this._extension);return c.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(n,u){let c=this._threads.get(n);c&&(c.range=A.Range.to(u))}$deleteCommentThread(n){let u=this._threads.get(n);u&&u.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function m(i,n,u){let c=u.get(n);c||(c=++i.commentHandle,u.set(n,c));const d=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;n.detail&&(0,y.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let h;return n.detail&&typeof n.detail!="string"?h={source:n.detail,$mid:14}:h=n.detail,{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:c,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:d,label:n.label,commentReactions:n.reactions?n.reactions.map(w=>o(w)):void 0,detail:h}}function o(i){return{label:i.label,iconPath:i.iconPath?A.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function S(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?T.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function r(i){if(i!==void 0)switch(i){case R.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new _}e.createExtHostComments=b}),define(pe[131],ve([0,1,2,5,7,4,14,11,16,8,9]),function(Z,e,f,t,I,D,T,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class Ci{constructor(b,p){this._logService=p,this._provider=new Map,this._proxy=b.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,p){const g=Ci._handlePool++;this._provider.set(g,{provider:b,extensionId:p}),this._proxy.$registerDecorationProvider(g,p.value);const E=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(L=>{if(!L){this._proxy.$onDidChange(g,null);return}let _=(0,C.asArray)(L);if(_.length<=Ci._maxEventSize){this._proxy.$onDidChange(g,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,_.length);const a=_.map(o=>({uri:o,rank:(0,A.count)(o.path,"/")})),s=(0,C.groupBy)(a,(o,S)=>o.rank-S.rank||(0,A.compare)(o.uri.path,S.uri.path));let m=[];e:for(let o of s){let S;for(let r of o){let i=(0,R.dirname)(r.uri.path);if(S!==i&&(S=i,m.push(r.uri)>=Ci._maxEventSize))break e}}this._proxy.$onDidChange(g,m)});return new I.Disposable(()=>{E?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(b,p,g){if(!this._provider.has(b))return Object.create(null);const E=Object.create(null),{provider:L,extensionId:_}=this._provider.get(b);return await Promise.all(p.map(async a=>{try{const{uri:s,id:m}=a,o=await Promise.resolve(L.provideFileDecoration(f.URI.revive(s),g));if(!o)return;try{I.FileDecoration.validate(o),E[m]=[o.propagate,o.tooltip,o.badge,o.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${_.value}': ${S}`)}}catch(s){this._logService.error(s)}})),E}};y._handlePool=0,y._maxEventSize=250,y=je([He(0,T.IExtHostRpcService),He(1,P.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,D.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[232],ve([0,1,163,117,2,5,7,18,3,11,24,44]),function(Z,e,f,t,I,D,T,P,C,A,R,y){"use strict";var l,b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(_,a,s,m,o,S){this._name=_,this._owner=a,this._maxDiagnosticsPerFile=s,l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,nt(this,p,new R.ResourceMap(r=>m.getComparisonKey(r)),"f"),nt(this,l,o,"f"),nt(this,b,S,"f")}dispose(){this._isDisposed||(Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,l,"f")&&Le(this,l,"f").$clear(this._owner),Le(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(_,a){if(!_){this.clear();return}this._checkDisposed();let s=[];if(I.URI.isUri(_)){if(!a){this.delete(_);return}Le(this,p,"f").set(_,a.slice()),s=[_]}else if(Array.isArray(_)){s=[];let o;_=[..._].sort(g._compareIndexedTuplesByUri);for(const S of _){const[r,i]=S;if((!o||r.toString()!==o.toString())&&(o&&Le(this,p,"f").get(o).length===0&&Le(this,p,"f").delete(o),o=r,s.push(r),Le(this,p,"f").set(r,[])),i){const n=Le(this,p,"f").get(r);n&&n.push(...i)}else{const n=Le(this,p,"f").get(r);n&&(n.length=0)}}}if(Le(this,b,"f").fire(s),!Le(this,l,"f"))return;const m=[];for(let o of s){let S=[];const r=Le(this,p,"f").get(o);if(r)if(r.length>this._maxDiagnosticsPerFile){S=[];const i=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let u of r)if(u.severity===i[n]&&S.push(P.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;S.push({severity:t.MarkerSeverity.Info,message:(0,f.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=r.map(i=>P.Diagnostic.from(i));m.push([o,S])}Le(this,l,"f").$changeMany(this._owner,m)}delete(_){this._checkDisposed(),Le(this,b,"f").fire([_]),Le(this,p,"f").delete(_),Le(this,l,"f")&&Le(this,l,"f").$changeMany(this._owner,[[_,void 0]])}clear(){this._checkDisposed(),Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,p,"f").clear(),Le(this,l,"f")&&Le(this,l,"f").$clear(this._owner)}forEach(_,a){this._checkDisposed();for(let s of Le(this,p,"f").keys())_.apply(a,[s,this.get(s),this])}get(_){this._checkDisposed();const a=Le(this,p,"f").get(_);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(_){return this._checkDisposed(),Array.isArray(Le(this,p,"f").get(_))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(_,a){return _[0].toString()<a[0].toString()?-1:_[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=g,l=new WeakMap,b=new WeakMap,p=new WeakMap;let E=class oi{constructor(_,a,s){this._logService=a,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=_.getProxy(D.MainContext.MainThreadDiagnostics)}static _mapper(_){const a=new R.ResourceMap;for(const s of _)a.set(s,s);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(_,a){const{_collections:s,_proxy:m,_onDidChangeDiagnostics:o,_logService:S,_fileSystemInfoService:r}=this,i=new class{$changeMany(c,d){m.$changeMany(c,d),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",_.value,c,d.length===0?"CLEARING":d)}$clear(c){m.$clear(c),S.trace("[DiagnosticCollection] remove all (extension, owner)",_.value,c)}dispose(){m.dispose()}};let n;if(!a)a="_generated_diagnostic_collection_name_#"+oi._idPool++,n=a;else if(!s.has(a))n=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do n=a+oi._idPool++;while(s.has(n))}return new class extends g{constructor(){super(a,n,oi._maxDiagnosticsPerFile,r.extUri,i,o);s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(_){if(_)return this._getDiagnostics(_);{const a=new Map,s=[];for(const m of this._collections.values())m.forEach((o,S)=>{let r=a.get(o.toString());typeof r=="undefined"&&(r=s.length,a.set(o.toString(),r),s.push([o,[]])),s[r][1]=s[r][1].concat(...S)});return s}}_getDiagnostics(_){let a=[];for(let s of this._collections.values())s.has(_)&&(a=a.concat(s.get(_)));return a}$acceptMarkersChange(_){if(!this._mirrorCollection){const a="_generated_mirror",s=new g(a,a,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,s),this._mirrorCollection=s}for(const[a,s]of _)this._mirrorCollection.set(I.URI.revive(a),s.map(P.Diagnostic.to))}};E._idPool=0,E._maxDiagnosticsPerFile=1e3,E=je([He(1,A.ILogService),He(2,y.IExtHostFileSystemInfo)],E),e.ExtHostDiagnostics=E}),define(pe[233],ve([0,1,2,5]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(T){this._proxy=T.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(P=>P?P.map(C=>f.URI.revive(C)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(P=>P?f.URI.revive(P):void 0)}}e.ExtHostDialogs=I}),define(pe[234],ve([0,1,15,2,7,5,10,21,8]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(y,l,b){this._documentsAndEditors=l,this._logService=b,this._documentContentProviders=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,l){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const b=A._handlePool++;this._documentContentProviders.set(b,l),this._proxy.$registerTextContentProvider(b,y);let p;return typeof l.onDidChange=="function"&&(p=l.onDidChange(g=>{if(g.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(E=>{if(!E&&typeof E!="string")return;const L=this._documentsAndEditors.getDocument(g);if(!L)return;const _=(0,C.splitLines)(E);if(!L.equalLines(_))return this._proxy.$onVirtualDocumentChange(g,E)},f.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(y,l){const b=this._documentContentProviders.get(y);return b?Promise.resolve(b.provideTextDocumentContent(t.URI.revive(l),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(pe[235],ve([0,1,3,6,2,5,123,18,13,25,7]),function(Z,e,f,t,I,D,T,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(b,p){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(D.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const E of g)this._onDidRemoveDocument.fire(E.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const E of g)this._onDidAddDocument.fire(E.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const p=this._documentsAndEditors.getDocument(b);if(p)return p}getDocument(b){const p=this.getDocumentData(b);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return p.document}ensureDocumentData(b){const p=this._documentsAndEditors.getDocument(b);if(p)return Promise.resolve(p);let g=this._documentLoader.get(b.toString());return g||(g=this._proxy.$tryOpenDocument(b).then(E=>{this._documentLoader.delete(b.toString());const L=I.URI.revive(E);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(L))},E=>(this._documentLoader.delete(b.toString()),Promise.reject(E))),this._documentLoader.set(b.toString(),g)),g}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(p=>I.URI.revive(p))}$acceptModelLanguageChanged(b,p){const g=I.URI.revive(b),E=this._documentsAndEditors.getDocument(g);if(!E)throw new Error("unknown document");this._onDidRemoveDocument.fire(E.document),E._acceptLanguageId(p),this._onDidAddDocument.fire(E.document)}$acceptModelSaved(b){const p=I.URI.revive(b),g=this._documentsAndEditors.getDocument(p);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(b,p){const g=I.URI.revive(b),E=this._documentsAndEditors.getDocument(g);if(!E)throw new Error("unknown document");E._acceptIsDirty(p),this._onDidChangeDocument.fire({document:E.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,p,g){const E=I.URI.revive(b),L=this._documentsAndEditors.getDocument(E);if(!L)throw new Error("unknown document");L._acceptIsDirty(g),L.onEvents(p);let _;p.isUndoing?_=R.TextDocumentChangeReason.Undo:p.isRedoing&&(_=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:L.document,contentChanges:p.changes.map(a=>({range:P.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:_}))}setWordDefinitionFor(b,p){(0,T.setWordDefinitionFor)(b,p)}}e.ExtHostDocuments=y}),define(pe[45],ve([0,1,55,3,6,2,4,5,123,14,130,18,11,24,10,78,92]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class L{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(s,m){this._extHostRpc=s,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const m=[],o=[],S=[];if(s.removedDocuments)for(const r of s.removedDocuments){const i=D.URI.revive(r),n=this._documents.get(i);n?.unref()&&(this._documents.delete(i),m.push(n.value))}if(s.addedDocuments)for(const r of s.addedDocuments){const i=D.URI.revive(r.uri);let n=this._documents.get(i);if(n&&i.scheme!==p.Schemas.vscodeNotebookCell&&i.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);n||(n=new L(new C.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,n),o.push(n.value)),n.ref()}if(s.removedEditors)for(const r of s.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&S.push(i)}if(s.addedEditors)for(const r of s.addedEditors){const i=D.URI.revive(r.documentUri);f.ok(this._documents.has(i),`document '${i}' does not exist`),f.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const n=this._documents.get(i).value,u=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>n.document),r.selections.map(y.Selection.to),r.options,r.visibleRanges.map(c=>y.Range.to(c)),typeof r.editorPosition=="number"?y.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,u)}s.newActiveEditor!==void 0&&(f.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,I.dispose)(m),(0,I.dispose)(S),s.removedDocuments&&this._onDidRemoveDocuments.fire(m),s.addedDocuments&&this._onDidAddDocuments.fire(o),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return s?m:m?.value}allEditors(){return[...this._editors.values()]}};_=je([He(0,A.IExtHostRpcService),He(1,l.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[53],ve([0,1,18,5,2,3,4,14,17]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");let A=class{constructor(y){this._onDidChangeTabs=new D.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new D.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=y.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let l=-1;this._tabs=y.map((p,g)=>(p.isActive&&(l=g),Object.freeze({label:p.label,viewColumn:f.ViewColumn.to(p.viewColumn),index:g,resource:I.URI.revive(p.resource),additionalResourcesAndViewIds:p.additionalResourcesAndViewIds.map(({resource:E,viewId:L})=>({resource:I.URI.revive(E),viewId:L})),viewId:p.editorId,isActive:p.isActive,move:async(E,L)=>{this._proxy.$moveTab(p,E,f.ViewColumn.from(L)),await(0,C.raceTimeout)(D.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(p),await(0,C.raceTimeout)(D.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((p,g)=>p.viewColumn===g.viewColumn?p.index-g.index:p.viewColumn-g.viewColumn);const b=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==b&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};A=je([He(0,P.IExtHostRpcService)],A),e.ExtHostEditorTabs=A}),define(pe[236],ve([0,1,2,5,6,7,18,147,8,22,28]),function(Z,e,f,t,I,D,T,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const g=this._schemes.indexOf(p);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),g=[];let E,L,_=14,a=14;for(const s of p){let m=E?(0,C.commonPrefixLength)(E,s):0;for(m===0?L=1:L=a;m<s.length;m++)m+1===s.length?(_=a,a=9):a+=1,g.push([L,s.toUpperCase().charCodeAt(m),a]),g.push([L,s.toLowerCase().charCodeAt(m),a]),L=a;E=s,a=_}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new P.StateMachine(g)}}provideDocumentLinks(p){this._initStateMachine();const g=[],E=P.LinkComputer.computeLinks({getLineContent(L){return p.lineAt(L-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const L of E){const _=T.DocumentLink.to(L);_.target&&g.push(_)}return g}}class l{constructor(p,g){this._extHostLanguageFeatures=g,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,g,E,L={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const _=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(_,E);let a=2;L.isCaseSensitive&&(a+=1024),L.isReadonly&&(a+=2048),typeof E.copy=="function"&&(a+=8),typeof E.open=="function"&&typeof E.close=="function"&&typeof E.read=="function"&&typeof E.write=="function"&&((0,R.checkProposedApiEnabled)(p,"fsChunks"),a+=4),this._proxy.$registerFileSystemProvider(_,g,a).catch(m=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${g}`),console.error(m)});const s=E.onDidChangeFile(m=>{const o=[];for(const S of m){let{uri:r,type:i}=S;if(r.scheme!==g)continue;let n;switch(i){case D.FileChangeType.Changed:n=0;break;case D.FileChangeType.Created:n=1;break;case D.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:n})}this._proxy.$onFileSystemChange(_,o)});return(0,I.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(p){const{type:g,ctime:E,mtime:L,size:_,permissions:a}=p;return{type:g,ctime:E,mtime:L,size:_,permissions:a}}$stat(p,g){return Promise.resolve(this._getFsProvider(p).stat(f.URI.revive(g))).then(E=>l._asIStat(E))}$readdir(p,g){return Promise.resolve(this._getFsProvider(p).readDirectory(f.URI.revive(g)))}$readFile(p,g){return Promise.resolve(this._getFsProvider(p).readFile(f.URI.revive(g))).then(E=>A.VSBuffer.wrap(E))}$writeFile(p,g,E,L){return Promise.resolve(this._getFsProvider(p).writeFile(f.URI.revive(g),E.buffer,L))}$delete(p,g,E){return Promise.resolve(this._getFsProvider(p).delete(f.URI.revive(g),E))}$rename(p,g,E,L){return Promise.resolve(this._getFsProvider(p).rename(f.URI.revive(g),f.URI.revive(E),L))}$copy(p,g,E,L){const _=this._getFsProvider(p);if(!_.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(_.copy(f.URI.revive(g),f.URI.revive(E),L))}$mkdir(p,g){return Promise.resolve(this._getFsProvider(p).createDirectory(f.URI.revive(g)))}$watch(p,g,E,L){const _=this._getFsProvider(p).watch(f.URI.revive(E),L);this._watches.set(g,_)}$unwatch(p,g){const E=this._watches.get(g);E&&(E.dispose(),this._watches.delete(g))}$open(p,g,E){const L=this._getFsProvider(p);if(!L.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(L.open(f.URI.revive(g),E))}$close(p,g){const E=this._getFsProvider(p);if(!E.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(E.close(g))}$read(p,g,E,L){const _=this._getFsProvider(p);if(!_.read)throw new Error('FileSystemProvider does not implement "read"');const a=A.VSBuffer.alloc(L);return Promise.resolve(_.read(g,E,a.buffer,0,L)).then(s=>a.slice(0,s))}$write(p,g,E,L){const _=this._getFsProvider(p);if(!_.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(_.write(g,E,L.buffer,0,L.byteLength))}_getFsProvider(p){const g=this._fsProvider.get(p);if(!g){const E=new Error;throw E.name="ENOPRO",E.message="no provider",E}return g}}e.ExtHostFileSystem=l}),define(pe[67],ve([0,1,5,42,7,22,4,14,44,6]),function(Z,e,f,t,I,D,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class zt{constructor(l,b){this._fileSystemProvider=new Map,this._proxy=l.getProxy(f.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(g){try{const E=p._fileSystemProvider.get(g.scheme);if(!E)return await p._proxy.$stat(g);await p._proxy.$ensureActivation(g.scheme);const L=await E.stat(g);return{type:L.type,ctime:L.ctime,mtime:L.mtime,size:L.size,permissions:L.permissions}}catch(E){zt._handleError(E)}},async readDirectory(g){try{const E=p._fileSystemProvider.get(g.scheme);return E?(await p._proxy.$ensureActivation(g.scheme),(await E.readDirectory(g)).slice()):await p._proxy.$readdir(g)}catch(E){return zt._handleError(E)}},async createDirectory(g){try{return await p._proxy.$mkdir(g)}catch(E){return zt._handleError(E)}},async readFile(g){try{const E=p._fileSystemProvider.get(g.scheme);return E?(await p._proxy.$ensureActivation(g.scheme),(await E.readFile(g)).slice()):(await p._proxy.$readFile(g)).buffer}catch(E){return zt._handleError(E)}},async writeFile(g,E){try{return await p._proxy.$writeFile(g,D.VSBuffer.wrap(E))}catch(L){return zt._handleError(L)}},async delete(g,E){try{const L=p._fileSystemProvider.get(g.scheme);return L?(await p._proxy.$ensureActivation(g.scheme),await L.delete(g,{recursive:!1,...E})):await p._proxy.$delete(g,{recursive:!1,useTrash:!1,...E})}catch(L){return zt._handleError(L)}},async rename(g,E,L){try{return await p._proxy.$rename(g,E,{overwrite:!1,...L})}catch(_){return zt._handleError(_)}},async copy(g,E,L){try{return await p._proxy.$copy(g,E,{overwrite:!1,...L})}catch(_){return zt._handleError(_)}},isWritableFileSystem(g){const E=b.getCapabilities(g);if(typeof E=="number")return!(E&2048)}})}static _handleError(l){if(l instanceof I.FileSystemError)throw l;if(!(l instanceof Error))throw new I.FileSystemError(String(l));if(l.name==="ENOPRO")throw I.FileSystemError.Unavailable(l.message);switch(l.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(l.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(l.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(l.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(l.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(l.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(l.message);default:throw new I.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,b){return this._fileSystemProvider.set(l,b),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(l))}};R=je([He(0,P.IExtHostRpcService),He(1,C.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[237],ve([0,1,3,32,2,5,18,7]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(y,l,b,p,g,E,L,_){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter;const a=this.ensureWatching(y,b,g);this._config=0,E&&(this._config+=1),L&&(this._config+=2),_&&(this._config+=4);const s=(0,t.parse)(g),m=typeof g=="string",o=p(S=>{if(!E)for(let r of S.created){const i=I.URI.revive(r);s(i.fsPath)&&(!m||l.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!L)for(let r of S.changed){const i=I.URI.revive(r);s(i.fsPath)&&(!m||l.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!_)for(let r of S.deleted){const i=I.URI.revive(r);s(i.fsPath)&&(!m||l.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=P.Disposable.from(a,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(y,l,b){let p=P.Disposable.from();if(typeof b=="string")return p;const g=y.getProxy(D.MainContext.MainThreadFileSystem);let E=!1;(b.pattern.includes(t.GLOBSTAR)||b.pattern.includes(t.GLOB_SPLIT))&&(E=!0);const L=Math.random();return g.$watch(l.identifier.value,L,b.baseUri,{recursive:E,excludes:[]}),P.Disposable.from({dispose:()=>g.$unwatch(L)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(y,l,b){this._mainContext=y,this._logService=l,this._extHostDocumentsAndEditors=b,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,l,b,p,g,E){return new C(this._mainContext,y,l,this._onFileSystemEvent.event,b,p,g,E)}$onFileEvent(y){this._onFileSystemEvent.fire(y)}$onDidRunFileOperation(y,l){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(b=>({oldUri:I.URI.revive(b.source),newUri:I.URI.revive(b.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(b=>I.URI.revive(b.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(b=>I.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,l){return(b,p,g)=>{const E=function(_){b.call(p,_)};return E.extension=y,l.event(E,void 0,g)}}async $onWillRunFileOperation(y,l,b,p){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(g=>({oldUri:I.URI.revive(g.source),newUri:I.URI.revive(g.target)}))},b,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(g=>I.URI.revive(g.target))},b,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(g=>I.URI.revive(g.target))},b,p)}}async _fireWillEvent(y,l,b,p){const g=new Set,E=[];if(await y.fireAsync(l,p,async(_,a)=>{const s=Date.now(),m=await Promise.resolve(_);m instanceof P.WorkspaceEdit&&(E.push(m),g.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-s>b&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),p.isCancellationRequested||E.length===0)return;const L={edits:[]};for(let _ of E){let{edits:a}=T.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);L.edits=L.edits.concat(a)}return{edit:L,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=A}),define(pe[238],ve([0,1,2,38]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(T,P,C,A){this._extHostNotebooks=P,this._textDocumentsAndEditors=C,this._commands=A;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new t.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new t.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new t.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new t.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:f.URI.revive(y.notebookUri),inputUri:f.URI.revive(y.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:f.URI.revive(y.notebookUri),inputUri:f.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(T,P,C,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:C,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=I}),define(pe[239],ve([0,1,6,5]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(T){this._handlePool=0,this._proxy=T.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,T),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=I}),define(pe[240],ve([0,1,2,25,18,7,5,8,41,16,13,145,21,6,111,77,86,46,15,3,17]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentSymbols(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentSymbols(G,te);if(!(0,A.isFalsyOrEmpty)(Q))return Q[0]instanceof D.DocumentSymbol?Q.map(I.DocumentSymbol.from):m._asDocumentSymbolTree(Q)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((Q,oe)=>{let me=Q.location.range.start.compareTo(oe.location.range.start);return me===0&&(me=oe.location.range.end.compareTo(Q.location.range.end)),me});const te=[],G=[];for(const Q of q){const oe={name:Q.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Q.kind),tags:Q.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:I.Range.from(Q.location.range),selectionRange:I.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(oe),te.push(oe);break}const me=G[G.length-1];if(C.Range.containsRange(me.range,oe.range)&&!C.Range.equalsRange(me.range,oe.range)){me.children&&me.children.push(oe),G.push(oe);break}G.pop()}}return te}}class o{constructor(q,te,G){this._documents=q,this._commands=te,this._provider=G,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideCodeLenses(G,te);if(!Q||te.isCancellationRequested)return;const oe=this._cache.add(Q),me=new b.DisposableStore;this._disposables.set(oe,me);const Ie={cacheId:oe,lenses:[]};for(let xe=0;xe<Q.length;xe++)Ie.lenses.push({cacheId:[oe,xe],range:I.Range.from(Q[xe].range),command:this._commands.toInternal(Q[xe].command,me)});return Ie}async resolveCodeLens(q,te){const G=q.cacheId&&this._cache.get(...q.cacheId);if(!G)return;let Q;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this._provider.resolveCodeLens(G,te),Q||(Q=G),te.isCancellationRequested)return;const oe=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!oe)return q.command=this._commands.toInternal(Q.command??o._badCmd,oe),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Ye){return Array.isArray(Ye)?Ye.map(I.DefinitionLink.from):Ye?[I.DefinitionLink.from(Ye)]:[]}class r{constructor(q,te){this._documents=q,this._provider=te}async provideDefinition(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDefinition(Q,oe,G);return S(me)}}class i{constructor(q,te){this._documents=q,this._provider=te}async provideDeclaration(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDeclaration(Q,oe,G);return S(me)}}class n{constructor(q,te){this._documents=q,this._provider=te}async provideImplementation(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideImplementation(Q,oe,G);return S(me)}}class u{constructor(q,te){this._documents=q,this._provider=te}async provideTypeDefinition(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideTypeDefinition(Q,oe,G);return S(me)}}class c{constructor(q,te){this._documents=q,this._provider=te}async provideHover(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideHover(Q,oe,G);if(!(!me||(0,A.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=Q.getWordRangeAtPosition(oe)),me.range||(me.range=new D.Range(oe,oe)),I.Hover.from(me)}}class d{constructor(q,te){this._documents=q,this._provider=te}async provideEvaluatableExpression(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideEvaluatableExpression(Q,oe,G);if(me)return I.EvaluatableExpression.from(me)}}class h{constructor(q,te){this._documents=q,this._provider=te}async provideInlineValues(q,te,G,Q){const oe=this._documents.getDocument(q),me=await this._provider.provideInlineValues(oe,I.Range.to(te),I.InlineValueContext.to(G),Q);if(Array.isArray(me))return me.map(Ie=>I.InlineValue.from(Ie))}}class w{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentHighlights(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideDocumentHighlights(Q,oe,G);if(Array.isArray(me))return me.map(I.DocumentHighlight.from)}}class v{constructor(q,te){this._documents=q,this._provider=te}async provideLinkedEditingRanges(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.provideLinkedEditingRanges(Q,oe,G);if(me&&Array.isArray(me.ranges))return{ranges:(0,A.coalesce)(me.ranges.map(I.Range.from)),wordPattern:me.wordPattern}}}class k{constructor(q,te){this._documents=q,this._provider=te}async provideReferences(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=await this._provider.provideReferences(oe,me,G,Q);if(Array.isArray(Ie))return Ie.map(I.location.from)}}class O{constructor(q,te,G,Q,oe,me,Ie){this._documents=q,this._commands=te,this._diagnostics=G,this._provider=Q,this._logService=oe,this._extension=me,this._apiDeprecation=Ie,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,te,G,Q){const oe=this._documents.getDocument(q),me=y.Selection.isISelection(te)?I.Selection.to(te):I.Range.to(te),Ie=[];for(const tt of this._diagnostics.getDiagnostics(q))if(me.intersection(tt.range)&&Ie.push(tt)>O._maxCodeActionsPerFile)break;const xe={diagnostics:Ie,only:G.only?new D.CodeActionKind(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},Xe=await this._provider.provideCodeActions(oe,me,xe,Q);if(!(0,A.isNonEmptyArray)(Xe)||Q.isCancellationRequested)return;const it=this._cache.add(Xe),st=new b.DisposableStore;this._disposables.set(it,st);const ot=[];for(let tt=0;tt<Xe.length;tt++){const rt=Xe[tt];!rt||(O._isCommand(rt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:rt.title,command:this._commands.toInternal(rt,st)})):(xe.only&&(rt.kind?xe.only.contains(rt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ot.push({cacheId:[it,tt],title:rt.title,command:rt.command&&this._commands.toInternal(rt.command,st),diagnostics:rt.diagnostics&&rt.diagnostics.map(I.Diagnostic.from),edit:rt.edit&&I.WorkspaceEdit.from(rt.edit),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,disabled:rt.disabled?.reason})))}return{cacheId:it,actions:ot}}async resolveCodeAction(q,te){const[G,Q]=q,oe=this._cache.get(G,Q);if(!oe||O._isCommand(oe)||!this._provider.resolveCodeAction)return;const me=await this._provider.resolveCodeAction(oe,te)??oe;return me?.edit?I.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}O._maxCodeActionsPerFile=1e3;class U{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentFormattingEdits(q,te,G){const Q=this._documents.getDocument(q),oe=await this._provider.provideDocumentFormattingEdits(Q,te,G);if(Array.isArray(oe))return oe.map(I.TextEdit.from)}}class F{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeFormattingEdits(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Range.to(te),Ie=await this._provider.provideDocumentRangeFormattingEdits(oe,me,G,Q);if(Array.isArray(Ie))return Ie.map(I.TextEdit.from)}}class M{constructor(q,te){this._documents=q,this._provider=te,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,te,G,Q,oe){const me=this._documents.getDocument(q),Ie=I.Position.to(te),xe=await this._provider.provideOnTypeFormattingEdits(me,Ie,G,Q,oe);if(Array.isArray(xe))return xe.map(I.TextEdit.from)}}class V{constructor(q,te){this._provider=q,this._logService=te,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,te){const G=T.IdObject.mixin({symbols:[]}),Q=await this._provider.provideWorkspaceSymbols(q,te);if((0,A.isNonEmptyArray)(Q))for(const oe of Q){if(!oe)continue;if(!oe.name){this._logService.warn("INVALID SymbolInformation, lacks name",oe);continue}const me=T.IdObject.mixin(I.WorkspaceSymbol.from(oe));this._symbolCache.set(me._id,oe),G.symbols.push(me)}return G.symbols.length>0&&this._resultCache.set(G._id,[G.symbols[0]._id,G.symbols[G.symbols.length-1]._id]),G}async resolveWorkspaceSymbol(q,te){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const G=this._symbolCache.get(q._id);if(G){const Q=await this._provider.resolveWorkspaceSymbol(G,te);return Q&&(0,t.mixin)(q,I.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){const te=this._resultCache.get(q);if(te){for(let[G,Q]=te;G<=Q;G++)this._symbolCache.delete(G);this._resultCache.delete(q)}}}class ${constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te);try{const Ie=await this._provider.provideRenameEdits(oe,me,G,Q);return Ie?I.WorkspaceEdit.from(Ie):void 0}catch(Ie){const xe=$._asMessage(Ie);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(q,te,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Q=this._documents.getDocument(q),oe=I.Position.to(te);try{const me=await this._provider.prepareRename(Q,oe,G);let Ie,xe;if(D.Range.isRange(me)?(Ie=me,xe=Q.getText(me)):(0,R.isObject)(me)&&(Ie=me.range,xe=me.placeholder),!Ie||!xe)return;if(Ie.start.line>oe.line||Ie.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ie),text:xe}}catch(me){const Ie=$._asMessage(me);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(me)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class N{constructor(q,te){this.resultId=q,this.tokens=te}}class B{constructor(q,te){this._documents=q,this._provider=te,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,te,G){const Q=this._documents.getDocument(q),oe=te!==0?this._previousResults.get(te):null;let me=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Q,oe.resultId,G):await this._provider.provideDocumentSemanticTokens(Q,G);return oe&&this._previousResults.delete(te),me?(me=B._fixProvidedSemanticTokens(me),this._send(B._convertToEdits(oe,me),me)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return B._isSemanticTokens(q)?B._isCorrectSemanticTokens(q)?q:new D.SemanticTokens(new Uint32Array(q.data),q.resultId):B._isSemanticTokensEdits(q)?B._isCorrectSemanticTokensEdits(q)?q:new D.SemanticTokensEdits(q.edits.map(te=>new D.SemanticTokensEdit(te.start,te.deleteCount,te.data?new Uint32Array(te.data):te.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const te of q.edits)if(!(te.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,te){if(!B._isSemanticTokens(te)||!q||!q.tokens)return te;const G=q.tokens,Q=G.length,oe=te.data,me=oe.length;let Ie=0;const xe=Math.min(Q,me);for(;Ie<xe&&G[Ie]===oe[Ie];)Ie++;if(Ie===Q&&Ie===me)return new D.SemanticTokensEdits([],te.resultId);let Xe=0;const it=xe-Ie;for(;Xe<it&&G[Q-Xe-1]===oe[me-Xe-1];)Xe++;return new D.SemanticTokensEdits([{start:Ie,deleteCount:Q-Ie-Xe,data:oe.subarray(Ie,me-Xe)}],te.resultId)}_send(q,te){if(B._isSemanticTokens(q)){const G=this._nextResultId++;return this._previousResults.set(G,new N(q.resultId,q.data)),(0,p.encodeSemanticTokensDto)({id:G,type:"full",data:q.data})}if(B._isSemanticTokensEdits(q)){const G=this._nextResultId++;return B._isSemanticTokens(te)?this._previousResults.set(G,new N(te.resultId,te.data)):this._previousResults.set(G,new N(q.resultId)),(0,p.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class x{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeSemanticTokens(q,te,G){const Q=this._documents.getDocument(q),oe=await this._provider.provideDocumentRangeSemanticTokens(Q,I.Range.to(te),G);return oe?this._send(oe):null}_send(q){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=x;class z{constructor(q,te,G,Q,oe){this._documents=q,this._commands=te,this._provider=G,this._apiDeprecation=Q,this._extension=oe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=oe.getWordRangeAtPosition(me)||new D.Range(me,me),xe=Ie.with({end:me}),Xe=new L.StopWatch(!0),it=await this._provider.provideCompletionItems(oe,me,Q,I.CompletionContext.to(G));if(!it||Q.isCancellationRequested)return;const st=Array.isArray(it)?new D.CompletionList(it):it,ot=z.supportsResolving(this._provider)?this._cache.add(st.items):this._cache.add([]),tt=new b.DisposableStore;this._disposables.set(ot,tt);const rt=[],gt={x:ot,b:rt,a:{replace:I.Range.from(Ie),insert:I.Range.from(xe)},c:st.isIncomplete||void 0,d:Xe.elapsed()};for(let Ne=0;Ne<st.items.length;Ne++){const It=st.items[Ne],ee=this._convertCompletionItem(It,[ot,Ne],xe,Ie);rt.push(ee)}return gt}async resolveCompletionItem(q,te){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveCompletionItem(G,te);if(!!Q)return this._convertCompletionItem(Q,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,te,G,Q){const oe=this._disposables.get(te[0]);if(!oe)throw Error("DisposableStore is missing...");const me={x:te,a:q.label,b:q.kind!==void 0?I.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(I.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(q.command,oe)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=q.textEdit.newText):typeof q.insertText=="string"?me.h=q.insertText:q.insertText instanceof D.SnippetString&&(me.h=q.insertText.value,me.i|=4);let Ie;return q.textEdit?Ie=q.textEdit.range:q.range&&(Ie=q.range),D.Range.isRange(Ie)?me.j=I.Range.from(Ie):Ie&&(!G?.isEqual(Ie.inserting)||!Q?.isEqual(Ie.replacing))&&(me.j={insert:I.Range.from(Ie.inserting),replace:I.Range.from(Ie.replacing)}),me}}class W{constructor(q,te,G){this._documents=q,this._provider=te,this._commands=G,this._cache=new E.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=await this._provider.provideInlineCompletionItems(oe,me,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text,isSnippetText:G.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(G.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:G.triggerKind},Q);if(!Ie||Q.isCancellationRequested)return;const xe=(0,R.isArray)(Ie)?{items:Ie}:Ie,Xe=this._cache.add(xe.items);let it;return{pid:Xe,items:xe.items.map((st,ot)=>{let tt;return st.command&&(it||(it=new b.DisposableStore,this._disposables.set(Xe,it)),tt=this._commands.toInternal(st.command,it)),{text:st.text,range:st.range?I.Range.from(st.range):void 0,command:tt,idx:ot}})}}disposeCompletions(q){this._cache.delete(q);const te=this._disposables.get(q);te&&te.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,te){const G=this._cache.get(q,te);G&&J.get(this._provider).fireOnDidShowCompletionItem({completionItem:G})}}class J{constructor(){this._onDidShowCompletionItemEmitter=new a.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let te=J.map.get(q);return te||(te=new J,J.map.set(q,te)),te}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=J,J.map=new WeakMap;class se{constructor(q,te){this._documents=q,this._provider=te,this._cache=new E.Cache("SignatureHelp")}async provideSignatureHelp(q,te,G,Q){const oe=this._documents.getDocument(q),me=I.Position.to(te),Ie=this.reviveContext(G),xe=await this._provider.provideSignatureHelp(oe,me,Q,Ie);if(xe){const Xe=this._cache.add([xe]);return{...I.SignatureHelp.from(xe),id:Xe}}}reviveContext(q){let te;if(q.activeSignatureHelp){const G=I.SignatureHelp.to(q.activeSignatureHelp),Q=this._cache.get(q.activeSignatureHelp.id,0);Q?(te=Q,te.activeSignature=G.activeSignature,te.activeParameter=G.activeParameter):te=G}return{...q,activeSignatureHelp:te}}releaseSignatureHelp(q){this._cache.delete(q)}}class ie{constructor(q,te,G){this._documents=q,this._commands=te,this._provider=G,this._cache=new E.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(q,te,G){const Q=this._documents.getDocument(q),oe=I.Range.to(te),me=await this._provider.provideInlayHints(Q,oe,G);if(!Array.isArray(me)||me.length===0||G.isCancellationRequested)return;const Ie=this._cache.add(me);this._disposables.set(Ie,new b.DisposableStore);const xe={hints:[],cacheId:Ie};for(let Xe=0;Xe<me.length;Xe++)this._isValidInlayHint(me[Xe],oe)&&xe.hints.push(this._convertInlayHint(me[Xe],[Ie,Xe]));return xe}async resolveInlayHint(q,te){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveInlayHint(G,te);if(!!Q&&!!this._isValidInlayHint(Q))return this._convertInlayHint(Q,q)}releaseHints(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_isValidInlayHint(q,te){return q.label.length===0||Array.isArray(q.label)&&q.label.every(G=>G.label.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):te&&!te.contains(q.position)?(console.log("INVALID inlay hint, position outside range",q),!1):!0}_convertInlayHint(q,te){const G=this._disposables.get(te[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:te,tooltip:q.tooltip&&I.MarkdownString.from(q.tooltip),position:I.Position.from(q.position),kind:I.InlayHintKind.from(q.kind??D.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter};return typeof q.label=="string"?Q.label=q.label:Q.label=q.label.map(oe=>{let me={label:oe.label};return me.collapsible=oe.collapsible,D.Location.isLocation(oe.action)?me.action=I.location.from(oe.action):oe.action&&(me.action=this._commands.toInternal(oe.action,G)),me}),Q}}class K{constructor(q,te){this._documents=q,this._provider=te,this._cache=new E.Cache("DocumentLink")}async provideLinks(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentLinks(G,te);if(!(!Array.isArray(Q)||Q.length===0)&&!te.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Q.filter(K._validateLink).map(I.DocumentLink.from)};{const oe=this._cache.add(Q),me={links:[],id:oe};for(let Ie=0;Ie<Q.length;Ie++){if(!K._validateLink(Q[Ie]))continue;const xe=I.DocumentLink.from(Q[Ie]);xe.cacheId=[oe,Ie],me.links.push(xe)}return me}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,te){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...q);if(!G)return;const Q=await this._provider.resolveDocumentLink(G,te);if(!(!Q||!K._validateLink(Q)))return I.DocumentLink.from(Q)}releaseLinks(q){this._cache.delete(q)}}class Y{constructor(q,te){this._documents=q,this._provider=te}async provideColors(q,te){const G=this._documents.getDocument(q),Q=await this._provider.provideDocumentColors(G,te);return Array.isArray(Q)?Q.map(me=>({color:I.Color.from(me.color),range:I.Range.from(me.range)})):[]}async provideColorPresentations(q,te,G){const Q=this._documents.getDocument(q),oe=I.Range.to(te.range),me=I.Color.to(te.color),Ie=await this._provider.provideColorPresentations(me,{document:Q,range:oe},G);if(!!Array.isArray(Ie))return Ie.map(I.ColorPresentation.from)}}class le{constructor(q,te){this._documents=q,this._provider=te}async provideFoldingRanges(q,te,G){const Q=this._documents.getDocument(q),oe=await this._provider.provideFoldingRanges(Q,te,G);if(!!Array.isArray(oe))return oe.map(I.FoldingRange.from)}}class fe{constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}async provideSelectionRanges(q,te,G){const Q=this._documents.getDocument(q),oe=te.map(I.Position.to),me=await this._provider.provideSelectionRanges(Q,oe,G);if(!(0,A.isNonEmptyArray)(me))return[];if(me.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let xe=0;xe<oe.length;xe++){const Xe=[];Ie.push(Xe);let it=oe[xe],st=me[xe];for(;;){if(!st.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(I.SelectionRange.from(st)),!st.parent)break;it=st.range,st=st.parent}}return Ie}}class Se{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.prepareCallHierarchy(Q,oe,G);if(!me)return;const Ie=this._idPool.nextId();return this._cache.set(Ie,new Map),Array.isArray(me)?me.map(xe=>this._cacheAndConvertItem(Ie,xe)):[this._cacheAndConvertItem(Ie,me)]}async provideCallsTo(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(Q,G);if(!!oe)return oe.map(me=>({from:this._cacheAndConvertItem(q,me.from),fromRanges:me.fromRanges.map(Ie=>I.Range.from(Ie))}))}async provideCallsFrom(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(Q,G);if(!!oe)return oe.map(me=>({to:this._cacheAndConvertItem(q,me.to),fromRanges:me.fromRanges.map(Ie=>I.Range.from(Ie))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),Q=I.CallHierarchyItem.from(te,q,G.size.toString(36));return G.set(Q._itemId,te),Q}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class Me{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const Q=this._documents.getDocument(q),oe=I.Position.to(te),me=await this._provider.prepareTypeHierarchy(Q,oe,G);if(!me)return;const Ie=this._idPool.nextId();return this._cache.set(Ie,new Map),Array.isArray(me)?me.map(xe=>this._cacheAndConvertItem(Ie,xe)):[this._cacheAndConvertItem(Ie,me)]}async provideSupertypes(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(Q,G);if(!!oe)return oe.map(me=>this._cacheAndConvertItem(q,me))}async provideSubtypes(q,te,G){const Q=this._itemFromCache(q,te);if(!Q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(Q,G);if(!!oe)return oe.map(me=>this._cacheAndConvertItem(q,me))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),Q=I.TypeHierarchyItem.from(te,q,G.size.toString(36));return G.set(Q._itemId,te),Q}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class Ve{constructor(q,te){this.adapter=q,this.extension=te}}class Ge{constructor(q,te,G,Q,oe,me,Ie){this._adapter=new Map,this._uriTransformer=te,this._proxy=q.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=Q,this._diagnostics=oe,this._logService=me,this._apiDeprecation=Ie}_transformDocumentSelector(q){return I.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new D.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Ge._handlePool++}async _withAdapter(q,te,G,Q,oe){const me=this._adapter.get(q);if(!me||!(me.adapter instanceof te))return Q;const Ie=Date.now();this._logService.trace(`[${me.extension.identifier.value}] INVOKE provider '${te.name}'`);const xe=G(me.adapter,me.extension);return Promise.resolve(xe).catch(Xe=>{(0,_.isCancellationError)(Xe)||(this._logService.error(`[${me.extension.identifier.value}] provider FAILED`),this._logService.error(Xe))}).finally(()=>{this._logService.trace(`[${me.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),l.CancellationToken.isCancellationToken(oe)?(0,s.raceCancellationError)(xe,oe):xe}_addNewAdapter(q,te){const G=this._nextHandle();return this._adapter.set(G,new Ve(q,te)),G}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,te,G,Q){const oe=this._addNewAdapter(new m(this._documents,G),q),me=Q&&Q.label||Ge._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(te),me),this._createDisposable(oe)}$provideDocumentSymbols(q,te,G){return this._withAdapter(q,m,Q=>Q.provideDocumentSymbols(f.URI.revive(te),G),void 0)}registerCodeLensProvider(q,te,G){const Q=this._nextHandle(),oe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Q,new Ve(new o(this._documents,this._commands.converter,G),q)),this._proxy.$registerCodeLensSupport(Q,this._transformDocumentSelector(te),oe);let me=this._createDisposable(Q);if(oe!==void 0){const Ie=G.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(oe));me=D.Disposable.from(me,Ie)}return me}$provideCodeLenses(q,te,G){return this._withAdapter(q,o,Q=>Q.provideCodeLenses(f.URI.revive(te),G),void 0)}$resolveCodeLens(q,te,G){return this._withAdapter(q,o,Q=>Q.resolveCodeLens(te,G),void 0)}$releaseCodeLenses(q,te){this._withAdapter(q,o,G=>Promise.resolve(G.releaseCodeLenses(te)),void 0)}registerDefinitionProvider(q,te,G){const Q=this._addNewAdapter(new r(this._documents,G),q);return this._proxy.$registerDefinitionSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDefinition(q,te,G,Q){return this._withAdapter(q,r,oe=>oe.provideDefinition(f.URI.revive(te),G,Q),[])}registerDeclarationProvider(q,te,G){const Q=this._addNewAdapter(new i(this._documents,G),q);return this._proxy.$registerDeclarationSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDeclaration(q,te,G,Q){return this._withAdapter(q,i,oe=>oe.provideDeclaration(f.URI.revive(te),G,Q),[])}registerImplementationProvider(q,te,G){const Q=this._addNewAdapter(new n(this._documents,G),q);return this._proxy.$registerImplementationSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideImplementation(q,te,G,Q){return this._withAdapter(q,n,oe=>oe.provideImplementation(f.URI.revive(te),G,Q),[])}registerTypeDefinitionProvider(q,te,G){const Q=this._addNewAdapter(new u(this._documents,G),q);return this._proxy.$registerTypeDefinitionSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideTypeDefinition(q,te,G,Q){return this._withAdapter(q,u,oe=>oe.provideTypeDefinition(f.URI.revive(te),G,Q),[])}registerHoverProvider(q,te,G,Q){const oe=this._addNewAdapter(new c(this._documents,G),q);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(te)),this._createDisposable(oe)}$provideHover(q,te,G,Q){return this._withAdapter(q,c,oe=>oe.provideHover(f.URI.revive(te),G,Q),void 0)}registerEvaluatableExpressionProvider(q,te,G,Q){const oe=this._addNewAdapter(new d(this._documents,G),q);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(te)),this._createDisposable(oe)}$provideEvaluatableExpression(q,te,G,Q){return this._withAdapter(q,d,oe=>oe.provideEvaluatableExpression(f.URI.revive(te),G,Q),void 0)}registerInlineValuesProvider(q,te,G,Q){const oe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new h(this._documents,G),q);this._proxy.$registerInlineValuesProvider(me,this._transformDocumentSelector(te),oe);let Ie=this._createDisposable(me);if(oe!==void 0){const xe=G.onDidChangeInlineValues(Xe=>this._proxy.$emitInlineValuesEvent(oe));Ie=D.Disposable.from(Ie,xe)}return Ie}$provideInlineValues(q,te,G,Q,oe){return this._withAdapter(q,h,me=>me.provideInlineValues(f.URI.revive(te),G,Q,oe),void 0)}registerDocumentHighlightProvider(q,te,G){const Q=this._addNewAdapter(new w(this._documents,G),q);return this._proxy.$registerDocumentHighlightProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDocumentHighlights(q,te,G,Q){return this._withAdapter(q,w,oe=>oe.provideDocumentHighlights(f.URI.revive(te),G,Q),void 0)}registerLinkedEditingRangeProvider(q,te,G){const Q=this._addNewAdapter(new v(this._documents,G),q);return this._proxy.$registerLinkedEditingRangeProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideLinkedEditingRanges(q,te,G,Q){return this._withAdapter(q,v,async oe=>{const me=await oe.provideLinkedEditingRanges(f.URI.revive(te),G,Q);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?Ge._serializeRegExp(me.wordPattern):void 0}},void 0)}registerReferenceProvider(q,te,G){const Q=this._addNewAdapter(new k(this._documents,G),q);return this._proxy.$registerReferenceSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideReferences(q,te,G,Q,oe){return this._withAdapter(q,k,me=>me.provideReferences(f.URI.revive(te),G,Q,oe),void 0)}registerCodeActionProvider(q,te,G,Q){const oe=new b.DisposableStore,me=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,G,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(te),{providedKinds:Q?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:Q?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this._commands.converter.toInternal(Ie.command,oe)}))},Ge._extLabel(q),Boolean(G.resolveCodeAction)),oe.add(this._createDisposable(me)),oe}$provideCodeActions(q,te,G,Q,oe){return this._withAdapter(q,O,me=>me.provideCodeActions(f.URI.revive(te),G,Q,oe),void 0)}$resolveCodeAction(q,te,G){return this._withAdapter(q,O,Q=>Q.resolveCodeAction(te,G),void 0)}$releaseCodeActions(q,te){this._withAdapter(q,O,G=>Promise.resolve(G.releaseCodeActions(te)),void 0)}registerDocumentFormattingEditProvider(q,te,G){const Q=this._addNewAdapter(new U(this._documents,G),q);return this._proxy.$registerDocumentFormattingSupport(Q,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(Q)}$provideDocumentFormattingEdits(q,te,G,Q){return this._withAdapter(q,U,oe=>oe.provideDocumentFormattingEdits(f.URI.revive(te),G,Q),void 0)}registerDocumentRangeFormattingEditProvider(q,te,G){const Q=this._addNewAdapter(new F(this._documents,G),q);return this._proxy.$registerRangeFormattingSupport(Q,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(Q)}$provideDocumentRangeFormattingEdits(q,te,G,Q,oe){return this._withAdapter(q,F,me=>me.provideDocumentRangeFormattingEdits(f.URI.revive(te),G,Q,oe),void 0)}registerOnTypeFormattingEditProvider(q,te,G,Q){const oe=this._addNewAdapter(new M(this._documents,G),q);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(te),Q,q.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(q,te,G,Q,oe,me){return this._withAdapter(q,M,Ie=>Ie.provideOnTypeFormattingEdits(f.URI.revive(te),G,Q,oe,me),void 0)}registerWorkspaceSymbolProvider(q,te){const G=this._addNewAdapter(new V(te,this._logService),q);return this._proxy.$registerNavigateTypeSupport(G,typeof te.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(q,te,G){return this._withAdapter(q,V,Q=>Q.provideWorkspaceSymbols(te,G),{symbols:[]})}$resolveWorkspaceSymbol(q,te,G){return this._withAdapter(q,V,Q=>Q.resolveWorkspaceSymbol(te,G),void 0)}$releaseWorkspaceSymbols(q,te){this._withAdapter(q,V,G=>G.releaseWorkspaceSymbols(te),void 0)}registerRenameProvider(q,te,G){const Q=this._addNewAdapter(new $(this._documents,G,this._logService),q);return this._proxy.$registerRenameSupport(Q,this._transformDocumentSelector(te),$.supportsResolving(G)),this._createDisposable(Q)}$provideRenameEdits(q,te,G,Q,oe){return this._withAdapter(q,$,me=>me.provideRenameEdits(f.URI.revive(te),G,Q,oe),void 0)}$resolveRenameLocation(q,te,G,Q){return this._withAdapter(q,$,oe=>oe.resolveRenameLocation(f.URI.revive(te),G,Q),void 0)}registerDocumentSemanticTokensProvider(q,te,G,Q){const oe=this._addNewAdapter(new B(this._documents,G),q),me=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(te),Q,me);let Ie=this._createDisposable(oe);if(me){const xe=G.onDidChangeSemanticTokens(Xe=>this._proxy.$emitDocumentSemanticTokensEvent(me));Ie=D.Disposable.from(Ie,xe)}return Ie}$provideDocumentSemanticTokens(q,te,G,Q){return this._withAdapter(q,B,oe=>oe.provideDocumentSemanticTokens(f.URI.revive(te),G,Q),null)}$releaseDocumentSemanticTokens(q,te){this._withAdapter(q,B,G=>G.releaseDocumentSemanticColoring(te),void 0)}registerDocumentRangeSemanticTokensProvider(q,te,G,Q){const oe=this._addNewAdapter(new x(this._documents,G),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(te),Q),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(q,te,G,Q){return this._withAdapter(q,x,oe=>oe.provideDocumentRangeSemanticTokens(f.URI.revive(te),G,Q),null)}registerCompletionItemProvider(q,te,G,Q){const oe=this._addNewAdapter(new z(this._documents,this._commands.converter,G,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(oe,this._transformDocumentSelector(te),Q,z.supportsResolving(G),`${q.identifier.value}(${Q.join("")})`),this._createDisposable(oe)}$provideCompletionItems(q,te,G,Q,oe){return this._withAdapter(q,z,me=>me.provideCompletionItems(f.URI.revive(te),G,Q,oe),void 0,oe)}$resolveCompletionItem(q,te,G){return this._withAdapter(q,z,Q=>Q.resolveCompletionItem(te,G),void 0,G)}$releaseCompletionItems(q,te){this._withAdapter(q,z,G=>G.releaseCompletionItems(te),void 0)}registerInlineCompletionsProvider(q,te,G){const Q=this._addNewAdapter(new W(this._documents,G,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideInlineCompletions(q,te,G,Q,oe){return this._withAdapter(q,W,me=>me.provideInlineCompletions(f.URI.revive(te),G,Q,oe),void 0)}$handleInlineCompletionDidShow(q,te,G){this._withAdapter(q,W,async Q=>{Q.handleDidShowCompletionItem(te,G)},void 0)}$freeInlineCompletionsList(q,te){this._withAdapter(q,W,async G=>{G.disposeCompletions(te)},void 0)}registerSignatureHelpProvider(q,te,G,Q){const oe=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,me=this._addNewAdapter(new se(this._documents,G),q);return this._proxy.$registerSignatureHelpProvider(me,this._transformDocumentSelector(te),oe),this._createDisposable(me)}$provideSignatureHelp(q,te,G,Q,oe){return this._withAdapter(q,se,me=>me.provideSignatureHelp(f.URI.revive(te),G,Q,oe),void 0)}$releaseSignatureHelp(q,te){this._withAdapter(q,se,G=>G.releaseSignatureHelp(te),void 0)}registerInlayHintsProvider(q,te,G){const Q=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new ie(this._documents,this._commands.converter,G),q);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(te),typeof G.resolveInlayHint=="function",Q);let me=this._createDisposable(oe);if(Q!==void 0){const Ie=G.onDidChangeInlayHints(xe=>this._proxy.$emitInlayHintsEvent(Q));me=D.Disposable.from(me,Ie)}return me}$provideInlayHints(q,te,G,Q){return this._withAdapter(q,ie,oe=>oe.provideInlayHints(f.URI.revive(te),G,Q),void 0,Q)}$resolveInlayHint(q,te,G){return this._withAdapter(q,ie,Q=>Q.resolveInlayHint(te,G),void 0,G)}$releaseInlayHints(q,te){this._withAdapter(q,ie,G=>G.releaseHints(te),void 0)}registerDocumentLinkProvider(q,te,G){const Q=this._addNewAdapter(new K(this._documents,G),q);return this._proxy.$registerDocumentLinkProvider(Q,this._transformDocumentSelector(te),typeof G.resolveDocumentLink=="function"),this._createDisposable(Q)}$provideDocumentLinks(q,te,G){return this._withAdapter(q,K,Q=>Q.provideLinks(f.URI.revive(te),G),void 0)}$resolveDocumentLink(q,te,G){return this._withAdapter(q,K,Q=>Q.resolveLink(te,G),void 0)}$releaseDocumentLinks(q,te){this._withAdapter(q,K,G=>G.releaseLinks(te),void 0)}registerColorProvider(q,te,G){const Q=this._addNewAdapter(new Y(this._documents,G),q);return this._proxy.$registerDocumentColorProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideDocumentColors(q,te,G){return this._withAdapter(q,Y,Q=>Q.provideColors(f.URI.revive(te),G),[])}$provideColorPresentations(q,te,G,Q){return this._withAdapter(q,Y,oe=>oe.provideColorPresentations(f.URI.revive(te),G,Q),void 0)}registerFoldingRangeProvider(q,te,G){const Q=this._nextHandle(),oe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Q,new Ve(new le(this._documents,G),q)),this._proxy.$registerFoldingRangeProvider(Q,this._transformDocumentSelector(te),oe);let me=this._createDisposable(Q);if(oe!==void 0){const Ie=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));me=D.Disposable.from(me,Ie)}return me}$provideFoldingRanges(q,te,G,Q){return this._withAdapter(q,le,oe=>oe.provideFoldingRanges(f.URI.revive(te),G,Q),void 0)}registerSelectionRangeProvider(q,te,G){const Q=this._addNewAdapter(new fe(this._documents,G,this._logService),q);return this._proxy.$registerSelectionRangeProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$provideSelectionRanges(q,te,G,Q){return this._withAdapter(q,fe,oe=>oe.provideSelectionRanges(f.URI.revive(te),G,Q),[])}registerCallHierarchyProvider(q,te,G){const Q=this._addNewAdapter(new Se(this._documents,G),q);return this._proxy.$registerCallHierarchyProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$prepareCallHierarchy(q,te,G,Q){return this._withAdapter(q,Se,oe=>Promise.resolve(oe.prepareSession(f.URI.revive(te),G,Q)),void 0)}$provideCallHierarchyIncomingCalls(q,te,G,Q){return this._withAdapter(q,Se,oe=>oe.provideCallsTo(te,G,Q),void 0)}$provideCallHierarchyOutgoingCalls(q,te,G,Q){return this._withAdapter(q,Se,oe=>oe.provideCallsFrom(te,G,Q),void 0)}$releaseCallHierarchy(q,te){this._withAdapter(q,Se,G=>Promise.resolve(G.releaseSession(te)),void 0)}registerTypeHierarchyProvider(q,te,G){const Q=this._addNewAdapter(new Me(this._documents,G),q);return this._proxy.$registerTypeHierarchyProvider(Q,this._transformDocumentSelector(te)),this._createDisposable(Q)}$prepareTypeHierarchy(q,te,G,Q){return this._withAdapter(q,Me,oe=>Promise.resolve(oe.prepareSession(f.URI.revive(te),G,Q)),void 0)}$provideTypeHierarchySupertypes(q,te,G,Q){return this._withAdapter(q,Me,oe=>oe.provideSupertypes(te,G,Q),void 0)}$provideTypeHierarchySubtypes(q,te,G,Q){return this._withAdapter(q,Me,oe=>oe.provideSubtypes(te,G,Q),void 0)}$releaseTypeHierarchy(q,te){this._withAdapter(q,Me,G=>Promise.resolve(G.releaseSession(te)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,P.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Ge._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Ge._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ge._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ge._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Ge._serializeRegExp(q.beforeText),afterText:q.afterText?Ge._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Ge._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Ge._serializeOnEnterRule)}setLanguageConfiguration(q,te,G){let{wordPattern:Q}=G;if(Q&&(0,P.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this._documents.setWordDefinitionFor(te,Q):this._documents.setWordDefinitionFor(te,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const oe=this._nextHandle(),me={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ge._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?Ge._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ge._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,te,me),this._createDisposable(oe)}$setWordDefinitions(q){for(const te of q)this._documents.setWordDefinitionFor(te.languageId,new RegExp(te.regexSource,te.regexFlags))}}e.ExtHostLanguageFeatures=Ge,Ge._handlePool=0}),define(pe[241],ve([0,1,5,18,7,47,17,6]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(R,y,l,b){this._documents=y,this._commands=l,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,y){await this._proxy.$changeLanguage(R,y);const l=this._documents.getDocumentData(R);if(!l)throw new Error(`document '${R.toString}' NOT found`);return l.document}async tokenAtPosition(R,y){const l=R.version,b=t.Position.from(y),p=await this._proxy.$tokensAtPosition(R.uri,b),g={type:I.StandardTokenType.Other,range:R.getWordRangeAtPosition(y)??new I.Range(y.line,y.character,y.line,y.character)};if(!p)return g;const E={range:t.Range.to(p.range),type:t.TokenType.to(p.type)};return!E.range.contains(y)||l!==R.version?g:E}createLanguageStatusItem(R,y,l){const b=this._handlePool++,p=this._proxy,g=this._ids,E=`${R.identifier.value}/${y}`;if(g.has(E))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);g.add(E);const L={selector:l,id:y,name:R.displayName??R.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let _,a=new P.DisposableStore;const s=()=>{_?.dispose(),_=(0,T.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(b,{id:E,name:L.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(L.selector,this._uriTransformer),label:L.text,detail:L.detail??"",severity:L.severity===I.LanguageStatusSeverity.Error?D.default.Error:L.severity===I.LanguageStatusSeverity.Warning?D.default.Warning:D.default.Info,command:L.command&&this._commands.toInternal(L.command,a),accessibilityInfo:L.accessibilityInformation,busy:L.busy})},0)},m={dispose(){a.dispose(),_?.dispose(),p.$removeLanguageStatus(b),g.delete(E)},get id(){return L.id},get name(){return L.name},set name(o){L.name=o,s()},get selector(){return L.selector},set selector(o){L.selector=o,s()},get text(){return L.text},set text(o){L.text=o,s()},get detail(){return L.detail},set detail(o){L.detail=o,s()},get severity(){return L.severity},set severity(o){L.severity=o,s()},get accessibilityInformation(){return L.accessibilityInformation},set accessibilityInformation(o){L.accessibilityInformation=o,s()},get command(){return L.command},set command(o){L.command=o,s()},get busy(){return L.busy},set busy(o){L.busy=o,s()}};return s(),m}}e.ExtHostLanguages=C}),define(pe[132],ve([0,1,11,5,26,14,3]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends f.AbstractLoggerService{constructor(R,y){const l=new T.Emitter;super(y.logLevel,l.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,y,l){return new C(this._proxy,R,y,l)}};P=je([He(0,D.IExtHostRpcService),He(1,I.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class C extends f.AbstractMessageLogger{constructor(R,y,l,b){super(b?.always);this.proxy=R,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(y,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,y){const l=[[R,y]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(R){this.proxy.$log(this.file,R)}}}),define(pe[242],ve([0,1,5,11,28]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function D(P){return P&&P.title}let T=class{constructor(C,A){this._logService=A,this._proxy=C.getProxy(f.MainContext.MainThreadMessageService)}showMessage(C,A,R,y,l){const b={source:{identifier:C.identifier,label:C.displayName||C.name}};let p;typeof y=="string"||D(y)?p=[y,...l]:(b.modal=y?.modal,b.useCustom=y?.useCustom,b.detail=y?.detail,p=l),b.useCustom&&(0,I.checkProposedApiEnabled)(C,"resolvers");const g=[];for(let E=0;E<p.length;E++){const L=p[E];if(typeof L=="string")g.push({title:L,handle:E,isCloseAffordance:!1});else if(typeof L=="object"){let{title:_,isCloseAffordance:a}=L;g.push({title:_,isCloseAffordance:!!a,handle:E})}else this._logService.warn("Invalid message item:",L)}return this._proxy.$showMessage(A,R,b,g).then(E=>{if(typeof E=="number")return p[E]})}};T=je([He(1,t.ILogService)],T),e.ExtHostMessageService=T}),define(pe[243],ve([0,1,22,3,58,6,24,8,13,2,86,5,18,7,52,218,129]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class L{constructor(a,s,m,o,S){this._textDocumentsAndEditors=m,this._textDocuments=o,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,n=r.cell.handle,c=this._documents.get(i)?.getCell(n);if(c)return c.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const s=this._editors.get(a);if(!s)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(a){for(const[s,m]of this._editors)if(m.apiEditor===a)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,s){const m=this._documents.get(a);if(!m&&!s)throw new Error(`NO notebook document for '${a}'`);return m}_getProviderData(a){const s=this._notebookContentProviders.get(a);if(!s)throw new Error(`NO provider for '${a}'`);return s}registerNotebookContentProvider(a,s,m,o,S){if((0,P.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:a,provider:m});let r;return m.onDidChangeNotebookContentOptions&&(r=m.onDidChangeNotebookContentOptions(()=>{const i=l.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(s,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},s,l.NotebookDocumentContentOptions.from(o),L._convertNotebookRegistrationData(a,S)),new b.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(a,s){if(!s)return;const m=s.filenamePattern.map(o=>l.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(s.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:s.displayName,filenamePattern:m,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,s,m){const o=L._notebookStatusBarItemProviderHandlePool++,S=typeof m.onDidChangeCellStatusBarItems=="function"?L._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,S,s);let r;return S!==void 0&&(r=m.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(S))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,S),r&&r.dispose()})}async createNotebookDocument(a){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&l.NotebookData.from(a.content)});return A.URI.revive(s)}async openNotebookDocument(a){const s=this._documents.get(a);if(s)return s.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(a),o=this._documents.get(A.URI.revive(m));return(0,C.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(a,s){A.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let m;typeof s=="object"?m={position:l.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(l.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:m={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,m),S=o&&this._editors.get(o)?.apiEditor;if(S)return S;throw o?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,s,m,o){const S=this._notebookStatusBarItemProviders.get(a),r=A.URI.revive(s),i=this._documents.get(r);if(!i||!S)return;const n=i.getCellFromIndex(m);if(!n)return;const u=await S.provideCellStatusBarItems(n.apiCell,o);if(!u)return;const c=new D.DisposableStore,d=this._statusBarCache.add([c]),w=(Array.isArray(u)?u:[u]).map(v=>l.NotebookStatusBarItem.from(v,this._commandsConverter,c));return{cacheId:d,items:w}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,s,m,o,S){if((0,P.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,m),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},s,l.NotebookDocumentContentOptions.from(o),L._convertNotebookRegistrationData(a,S)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,s,m){const o=this._notebookSerializer.get(a);if(!o)throw new Error("NO serializer found");const S=await o.deserializeNotebook(s.buffer,m);return new p.SerializableObjectWithBuffers(l.NotebookData.from(S))}async $notebookToData(a,s,m){const o=this._notebookSerializer.get(a);if(!o)throw new Error("NO serializer found");const S=await o.serializeNotebook(l.NotebookData.to(s.value),m);return f.VSBuffer.wrap(S)}async $openNotebook(a,s,m,o,S){const{provider:r}=this._getProviderData(a),i=await r.openNotebook(A.URI.revive(s),{backupId:m,untitledDocumentData:o?.buffer},S);return new p.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(l.NotebookCellData.from)})}async $saveNotebook(a,s,m){const o=this.getNotebookDocument(A.URI.revive(s)),{provider:S}=this._getProviderData(a);return await S.saveNotebook(o.apiNotebook,m),!0}async $saveNotebookAs(a,s,m,o){const S=this.getNotebookDocument(A.URI.revive(s)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(A.URI.revive(m),S.apiNotebook,o),!0}async $backupNotebook(a,s,m){const o=this.getNotebookDocument(A.URI.revive(s)),S=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),i=String((0,I.hash)([o.uri.toString(),this._backupIdPool++])),n=A.URI.joinPath(r,i),u=await S.provider.backupNotebook(o.apiNotebook,{destination:n},m);return o.updateBackup(u),u.id}_createExtHostEditor(a,s,m){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const o=new E.ExtHostNotebookEditor(s,this._notebookEditorsProxy,a,m.visibleRanges.map(l.NotebookRange.to),m.selections.map(l.NotebookRange.to),typeof m.viewColumn=="number"?l.ViewColumn.to(m.viewColumn):void 0);this._editors.set(s,o)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const m of a.value.removedDocuments){const o=A.URI.revive(m),S=this._documents.get(o);S&&(S.dispose(),this._documents.delete(o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===o.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const m=[];for(const o of a.value.addedDocuments){const S=A.URI.revive(o.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const r=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){r._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){r._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){r._onDidChangeCellMetadata.fire(n)}},S,o);m.push(...o.cells.map(n=>g.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(S)?.dispose(),this._documents.set(S,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const m of a.value.addedEditors){if(this._editors.has(m.id))return;const o=A.URI.revive(m.documentUri),S=this._documents.get(o);S&&this._createExtHostEditor(S,m.id,m)}const s=[];if(a.value.removedEditors)for(const m of a.value.removedEditors){const o=this._editors.get(m);o&&(this._editors.delete(m),this._activeNotebookEditor?.id===o.id&&(this._activeNotebookEditor=void 0),s.push(o))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(o=>this._editors.get(o)).filter(o=>!!o);const m=new Set;this._visibleNotebookEditors.forEach(o=>m.add(o.id));for(const o of this._editors.values()){const S=m.has(o.id);o._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(o=>o).filter(o=>o.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=L,L._notebookStatusBarItemProviderHandlePool=0}),define(pe[244],ve([0,1,3,77,11,5,14,18]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(y,l){const b=C._Keys.nextId();y.$registerNotebookEditorDecorationType(b,P.NotebookDecorationRenderOptions.from(l)),this.value={key:b,dispose(){y.$removeNotebookEditorDecorationType(b)}}}}C._Keys=new t.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(y,l,b){this._logService=y,this._extHostRpc=l,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new C(this._extHostRpc.getProxy(D.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,l);const b=this._notebooksAndEditors.getEditorById(y);l.visibleRanges&&b._acceptVisibleRanges(l.visibleRanges.ranges.map(P.NotebookRange.to)),l.selections&&b._acceptSelections(l.selections.selections.map(P.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const l in y)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(P.ViewColumn.to(y[l]))}};A=je([He(0,I.ILogService),He(1,T.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(pe[245],ve([0,1,16,17,21,3,6,24,2,27,11,5,38,18,7,87,211,28,52]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(r,i,n,u,c){this._initData=i,this._extHostNotebook=n,this._commands=u,this._logService=c,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new D.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(y.MainContext.MainThreadNotebookKernels);const d=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",h=>!0,h=>{if(h&&"notebookEditor"in h&&"id"in h){const w=this._extHostNotebook.getIdByEditor(h.notebookEditor);return{id:h.id,extension:h.extension,notebookEditorId:w}}else if(h&&"notebookEditor"in h){const w=this._extHostNotebook.getIdByEditor(h.notebookEditor);if(w===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${h.notebookEditor.document.uri.toString()}`);return{notebookEditorId:w}}return h})],l.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(r,i,n,u,c,d){for(const W of this._kernelData.values())if(W.controller.id===i&&A.ExtensionIdentifier.equals(r.identifier,W.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const h=this._handlePool++,w=this;this._logService.trace(`NotebookController[${h}], CREATED by ${r.identifier.value}, ${i}`);const v=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${r.identifier}'`);let k=!1;const O=new T.DisposableStore,U=new D.Emitter,F=new D.Emitter,M={id:`${r.identifier.value}/${i}`,notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:u||r.identifier.value,preloads:d?d.map(b.NotebookRendererScript.from):[]};let V=c??v,$;this._proxy.$addKernel(h,M).catch(W=>{console.log(W),k=!0});let N=0;const B=()=>{if(k)return;const W=++N;Promise.resolve().then(()=>{W===N&&this._proxy.$updateKernel(h,M)})},x=new P.ResourceMap,z={get id(){return i},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return M.label},set label(W){M.label=W??r.displayName??r.name,B()},get detail(){return M.detail??""},set detail(W){M.detail=W,B()},get description(){return M.description??""},set description(W){M.description=W,B()},get kind(){return(0,L.checkProposedApiEnabled)(r,"notebookControllerKind"),M.kind??""},set kind(W){(0,L.checkProposedApiEnabled)(r,"notebookControllerKind"),M.kind=W,B()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(W){M.supportedLanguages=W,B()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(W){M.supportsExecutionOrder=W,B()},get rendererScripts(){return M.preloads?M.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(W){V=W??v},get interruptHandler(){return $},set interruptHandler(W){$=W,M.supportsInterrupt=Boolean(W),B()},createNotebookCellExecution(W){if(k)throw new Error("notebook controller is DISPOSED");if(!x.has(W.notebook.uri))throw w._logService.trace(`NotebookController[${h}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(J=>J.toString())),new Error(`notebook controller is NOT associated to notebook: ${W.notebook.uri.toString()}`);return w._createNotebookCellExecution(W)},dispose:()=>{k||(this._logService.trace(`NotebookController[${h}], DISPOSED`),k=!0,this._kernelData.delete(h),O.dispose(),U.dispose(),F.dispose(),this._proxy.$removeKernel(h))},updateNotebookAffinity(W,J){w._proxy.$updateNotebookPriority(h,W.uri,J)},onDidReceiveMessage:F.event,postMessage(W,J){return(0,L.checkProposedApiEnabled)(r,"notebookMessaging"),w._proxy.$postMessage(h,J&&w._extHostNotebook.getIdByEditor(J),W)},asWebviewUri(W){return(0,L.checkProposedApiEnabled)(r,"notebookMessaging"),(0,g.asWebviewUri)(W,w._initData.remote)}};return this._kernelData.set(h,{extensionId:r.identifier,controller:z,onDidReceiveMessage:F,onDidChangeSelection:U,associatedNotebooks:x}),z}$acceptNotebookAssociation(r,i,n){const u=this._kernelData.get(r);if(u){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));n?u.associatedNotebooks.set(c.uri,!0):u.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),n),u.onDidChangeSelection.fire({selected:n,notebook:c.apiNotebook})}}async $executeCells(r,i,n){const u=this._kernelData.get(r);if(!u)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),d=[];for(const h of n){const w=c.getCell(h);w&&d.push(w.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),d.length),await u.controller.executeHandler.call(u.controller,d,c.apiNotebook,u.controller)}catch(h){this._logService.error(`NotebookController[${r}] execute cells FAILED`,h),console.error(h)}}async $cancelCells(r,i,n){const u=this._kernelData.get(r);if(!u)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,c.apiNotebook);else for(const d of n){const h=c.getCell(d);h&&this._activeExecutions.get(h.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,n){const u=this._kernelData.get(r);if(!u)return;const c=this._extHostNotebook.getEditorById(i);u.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:n}))}$cellExecutionChanged(r,i,n){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)).getCell(i);c&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:n??p.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const u=new m(n.notebook,n,this._proxy);this._activeExecutions.set(n.uri,u);const c=u.onDidChangeState(()=>{u.state===s.Resolved&&(u.dispose(),c.dispose(),this._activeExecutions.delete(n.uri))});return u.asApiObject()}};a=je([He(4,R.ILogService)],a),e.ExtHostNotebookKernels=a;var s;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(s||(s={}));class m extends T.Disposable{constructor(r,i,n){super();this._document=r,this._cell=i,this._proxy=n,this._onDidChangeState=new D.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new o(10,u=>this.update(u)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new _.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const n=p.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return n===i.items?b.NotebookCellOutput.from(i):b.NotebookCellOutput.from({items:n,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,n){const u=this.cellIndexToHandle(i),c=this.validateAndConvertOutputs((0,f.asArray)(r));return this.updateSoon({editType:E.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:u,append:n,outputs:c})}async updateOutputItems(r,i,n){return r=p.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(r),!0),this.updateSoon({editType:E.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:r.map(b.NotebookCellOutputItem.from),outputId:i.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(n){r._executionOrder=n,r.update([{editType:E.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,executionOrder:r._executionOrder}])},start(n){if(r._state===s.Resolved||r._state===s.Started)throw new Error("Cannot call start again");r._state=s.Started,r._onDidChangeState.fire(),r.update({editType:E.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,runStartTime:n})},end(n,u){if(r._state===s.Resolved)throw new Error("Cannot call resolve twice");r._state=s.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._document.uri,r._cell.handle,new _.SerializableObjectWithBuffers({uri:r._document.uri,cellHandle:r._cell.handle,runEndTime:u,lastRunSuccess:n}))},clearOutput(n){return r.verifyStateForOutput(),r.updateOutputs([],n,!1)},appendOutput(n,u){return r.verifyStateForOutput(),r.updateOutputs(n,u,!0)},replaceOutput(n,u){return r.verifyStateForOutput(),r.updateOutputs(n,u,!1)},appendOutputItems(n,u){return r.verifyStateForOutput(),r.updateOutputItems(n,u,!0)},replaceOutputItems(n,u){return r.verifyStateForOutput(),r.updateOutputItems(n,u,!1)}})}}class o{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(pe[246],ve([0,1,3,5,129,28]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(C,A){this._extHostNotebook=A,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,A,R){const y=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(A)?.fire({editor:y.apiEditor,message:R})}createRendererMessaging(C,A){if(!C.contributes?.notebookRenderer?.some(b=>b.id===A))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${A})`);const R=(0,D.isProposedApiEnabled)(C,"notebookEditor"),y=new WeakMap;return{onDidReceiveMessage:(b,p,g)=>{const E=R?b:L=>{const _={};y.set(_,L.editor),b({editor:_,message:L.message})};return this.getOrCreateEmitterFor(A).event(E,p,g)},postMessage:(b,p)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,p]=[p,b]);const g=R?p:y.get(p),E=g&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(g);return this.proxy.$postMessage(E?.id,A,b)}}}getOrCreateEmitterFor(C){let A=this._rendererMessageEmitters.get(C);return A||(A=new f.Emitter({onLastListenerRemove:()=>{A?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,A),A)}}e.ExtHostNotebookRenderers=T}),define(pe[133],ve([0,1,5,6,4,14,11,212,67,26,44,152,22]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class b extends t.Disposable{constructor(E,L,_,a){super();this.id=E,this.name=L,this.logger=_,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(E){this.append(E+`
`)}append(E){this.write(E),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const E=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,E)}replace(E){const L=this.offset;this.write(E),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,L),this.visible&&this.logger.flush()}show(E,L){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof E=="boolean"?E:L))}hide(){this.proxy.$close(this.id)}write(E){this.offset+=l.VSBuffer.fromString(E).byteLength,this.logger.info(E)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=b;let p=class{constructor(E,L,_,a,s){this.extHostFileSystem=_,this.extHostFileSystemInfo=a,this.loggerService=s,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=E.getProxy(f.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(L.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(E){this.visibleChannelId=E;for(const[L,_]of this.channels)_.visible=L===this.visibleChannelId}createOutputChannel(E,L){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const _=this.doCreateOutputChannel(E,L);return _.then(a=>{this.channels.set(a.id,a),a.visible=a.id===this.visibleChannelId}),this.createExtHostOutputChannel(E,_)}async doCreateOutputChannel(E,L){const _=await this.createOutputDirectory(),a=this.extHostFileSystemInfo.extUri.joinPath(_,`${this.namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),m=await this.proxy.$register(E,!1,a,L.identifier.value);return new b(m,E,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(E,L){let _=!1;const a=()=>{if(_)throw new Error("Channel has been closed")};return{get name(){return E},append(s){a(),L.then(m=>m.append(s))},appendLine(s){a(),L.then(m=>m.appendLine(s))},clear(){a(),L.then(s=>s.clear())},replace(s){a(),L.then(m=>m.replace(s))},show(s,m){a(),L.then(o=>o.show(s,m))},hide(){a(),L.then(s=>s.hide())},dispose(){_=!0,L.then(s=>s.dispose())}}}};p=je([He(0,D.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,C.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,T.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(pe[247],ve([0,1,17,21,3,6,5,2,7,15,16,47,85,28]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(g,E,L){const _=g.getProxy(T.MainContext.MainThreadQuickOpen);class a{constructor(c,d){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=d}showQuickPick(c,d,h=t.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(c),v=++this._instances,k=_.$show(v,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},h),O={},U=k.then(()=>O);return Promise.race([U,w]).then(F=>{if(F!==O)return w.then(M=>{const V=[];for(let $=0;$<M.length;$++){const N=M[$];typeof N=="string"?V.push({label:N,handle:$}):N.kind===C.QuickPickItemKind.Separator?V.push({type:"separator",label:N.label}):V.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:$})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{d.onDidSelectItem(M[$])}),_.$setItems(v,V),k.then($=>{if(typeof $=="number")return M[$];if(Array.isArray($))return $.map(N=>M[N])})})}).then(void 0,F=>{if(!(0,A.isCancellationError)(F))return _.$setError(v,F),Promise.reject(F)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,d=t.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,_.$input(c,typeof this._validateInput=="function",d).then(void 0,h=>{if(!(0,A.isCancellationError)(h))return Promise.reject(h)})}$validateInput(c){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,d=t.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!h)return;const w=await this._workspace.getWorkspaceFolders2();if(!!w)return w.find(v=>v.uri.toString()===h.uri.toString())}createQuickPick(c){const d=new i(c,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(c){const d=new n(c,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(c,d){const h=this._sessions.get(c);h&&h._fireDidChangeValue(d)}$onDidAccept(c){const d=this._sessions.get(c);d&&d._fireDidAccept()}$onDidChangeActive(c,d){const h=this._sessions.get(c);h instanceof i&&h._fireDidChangeActive(d)}$onDidChangeSelection(c,d){const h=this._sessions.get(c);h instanceof i&&h._fireDidChangeSelection(d)}$onDidTriggerButton(c,d){const h=this._sessions.get(c);h&&h._fireDidTriggerButton(d)}$onDidTriggerItemButton(c,d,h){const w=this._sessions.get(c);w instanceof i&&w._fireDidTriggerItemButton(d,h)}$onDidHide(c){const d=this._sessions.get(c);d&&d._fireDidHide()}}class s{constructor(c,d){this._extensionId=c,this._onDidDispose=d,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((d,h)=>{const w=d===C.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(w,d)}),this.update({buttons:c.map((d,h)=>({...r(d),tooltip:d.tooltip,handle:d===C.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const d=this._handlesToButtons.get(c);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(c){if(!this._disposed){for(const d of Object.keys(c)){const h=c[d];this._pendingUpdate[d]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function m(u){if(u instanceof C.ThemeIcon)return{id:u.id};const c=S(u),d=o(u);return{dark:typeof c=="string"?P.URI.file(c):c,light:typeof d=="string"?P.URI.file(d):d}}function o(u){return typeof u=="object"&&"light"in u?u.light:u}function S(u){return typeof u=="object"&&"dark"in u?u.dark:u}function r(u){const c=m(u.iconPath);let d,h;return"id"in c?h=l.ThemeIcon.asClassName(c):d=c,{iconPath:d,iconClass:h}}class i extends s{constructor(c,d){super(c.identifier,d);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(h=>h.kind!==void 0)&&(0,b.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((h,w)=>{this._handlesToItems.set(w,h),this._itemsToHandles.set(h,w)});const d=[];for(let h=0;h<c.length;h++){const w=c[h];w.kind===C.QuickPickItemKind.Separator?d.push({type:"separator",label:w.label}):d.push({handle:h,label:w.label,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,buttons:w.buttons?.map((v,k)=>({...r(v),tooltip:v.tooltip,handle:k}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(c){const d=(0,R.coalesce)(c.map(h=>this._handlesToItems.get(h)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(c){const d=(0,R.coalesce)(c.map(h=>this._handlesToItems.get(h)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(c,d){const h=this._handlesToItems.get(c);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[d];w&&this._onDidTriggerItemButtonEmitter.fire({button:w,item:h})}}class n extends s{constructor(c,d){super(c,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?y.default.Error:y.default.Ignore})}}return new a(E,L)}e.createExtHostQuickOpen=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[248],ve([0,1,2,3,56,6,17,5,16,101,11,27,85,18,28]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p){"use strict";var g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function L(d){if(d)return typeof d.iconPath=="string"?f.URI.file(d.iconPath):f.URI.isUri(d.iconPath)||l.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function _(d,h){if(!d.iconPath&&!h.iconPath)return 0;if(d.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof d.iconPath=="string"?d.iconPath:f.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,v=typeof h.iconPath=="string"?h.iconPath:f.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,A.comparePaths)(w,v)}function a(d,h){let w=0;if(d.strikeThrough!==h.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==h.faded)return d.faded?1:-1;if(d.tooltip!==h.tooltip)return(d.tooltip||"").localeCompare(h.tooltip||"");if(w=_(d,h),w!==0)return w;if(d.light&&h.light)w=_(d.light,h.light);else{if(d.light)return 1;if(h.light)return-1}if(w!==0)return w;if(d.dark&&h.dark)w=_(d.dark,h.dark);else{if(d.dark)return 1;if(h.dark)return-1}return w}function s(d,h){if(d.command!==h.command)return d.command<h.command?-1:1;if(d.title!==h.title)return d.title<h.title?-1:1;if(d.tooltip!==h.tooltip){if(d.tooltip!==void 0&&h.tooltip!==void 0)return d.tooltip<h.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(d.arguments===h.arguments)return 0;if(d.arguments)if(h.arguments){if(d.arguments.length!==h.arguments.length)return d.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<d.arguments.length;w++){const v=d.arguments[w],k=h.arguments[w];if(v!==k)return v<k?-1:1}return 0}function m(d,h){let w=(0,A.comparePaths)(d.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(d.command&&h.command)w=s(d.command,h.command);else{if(d.command)return 1;if(h.command)return-1}if(w!==0)return w;if(d.decorations&&h.decorations)w=a(d.decorations,h.decorations);else{if(d.decorations)return 1;if(h.decorations)return-1}return w}function o(d,h){for(let w=0;w<d.length;w++)if(d[w]!==h[w])return!1;return!0}function S(d,h){return d.command===h.command&&d.title===h.title&&d.tooltip===h.tooltip&&(d.arguments&&h.arguments?o(d.arguments,h.arguments):d.arguments===h.arguments)}function r(d,h){return(0,C.equals)(d,h,S)}class i{constructor(h,w,v){this._extension=h,this._sourceControlHandle=v,g.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,nt(this,g,w,"f")}get value(){return this._value}set value(h){h=h??"",Le(this,g,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Le(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Le(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Le(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,w){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Le(this,g,"f").$showValidationMessage(this._sourceControlHandle,h,w)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=i,g=new WeakMap;class n{constructor(h,w,v,k,O){this._proxy=h,this._commands=w,this._sourceControlHandle=v,this._id=k,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,w){const v=this._resourceStatesCommandsMap.get(h);return v?(0,T.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(m),v=(0,C.sortedDiff)(this._resourceSnapshot,h,m).map(U=>{const F=U.toInsert.map(M=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,M);const $=M.resourceUri;let N;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const le=new D.DisposableStore;N=this._commands.converter.toInternal(M.command,le),this._resourceStatesDisposablesMap.set(V,le)}else this._resourceStatesCommandsMap.set(V,M.command);const B=L(M.decorations),x=M.decorations&&L(M.decorations.light)||B,z=M.decorations&&L(M.decorations.dark)||B,W=[x,z],J=M.decorations&&M.decorations.tooltip||"",se=M.decorations&&!!M.decorations.strikeThrough,ie=M.decorations&&!!M.decorations.faded,K=M.contextValue||"";return{rawResource:[V,$,W,J,se,ie,K,N],handle:V}});return{start:U.start,deleteCount:U.deleteCount,toInsert:F}}),k=v.map(({start:U,deleteCount:F,toInsert:M})=>[U,F,M.map(V=>V.rawResource)]),O=v.reverse();for(const{start:U,deleteCount:F,toInsert:M}of O){const V=M.map(N=>N.handle),$=this._handlesSnapshot.splice(U,F,...V);for(const N of $)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=h,k}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class u{constructor(h,w,v,k,O,U){this._extension=h,this._commands=v,this._id=k,this._label=O,this._rootUri=U,E.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new D.MutableDisposable,this._statusBarDisposables=new D.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,nt(this,E,w,"f"),this._inputBox=new i(h,Le(this,E,"f"),this.handle),Le(this,E,"f").$registerSourceControl(this.handle,k,O,U)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Le(this,E,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Le(this,E,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Le(this,E,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new D.DisposableStore,this._acceptInputCommand=h;const w=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Le(this,E,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new D.DisposableStore,this._actionButton=h;const w=h!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Le(this,E,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&r(this._statusBarCommands,h))return;this._statusBarDisposables.value=new D.DisposableStore,this._statusBarCommands=h;const w=(h||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));Le(this,E,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(h,w){const v=new n(Le(this,E,"f"),this._commands,this.handle,h,w),k=t.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,k),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const h=[],w=[];for(const[v,k]of this.createdResourceGroups){k.dispose();const O=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});t.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),O.dispose(),this._groups.delete(v.handle),Le(this,E,"f").$unregisterGroup(this.handle,v.handle)}),h.push([v.handle,v.id,v.label,v.features]);const U=v._takeResourceStateSnapshot();U.length>0&&w.push([v.handle,U]),this._groups.set(v.handle,v)}Le(this,E,"f").$registerGroups(this.handle,h,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(w=>{const v=w._takeResourceStateSnapshot();v.length!==0&&h.push([w.handle,v])}),h.length>0&&Le(this,E,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Le(this,E,"f").$unregisterSourceControl(this.handle)}}E=new WeakMap,u._handlePool=0,je([(0,I.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),je([(0,I.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let c=class Vi{constructor(h,w,v){this._commands=w,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=h.getProxy(P.MainContext.MainThreadSCM),this._telemetry=h.getProxy(P.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const O=this._sourceControls.get(k.sourceControlHandle);if(!O)return k;const U=O.getResourceGroup(k.groupHandle);return U?U.getResourceState(k.handle):k}else if(k&&k.$mid===4){const O=this._sourceControls.get(k.sourceControlHandle);return O?O.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const O=this._sourceControls.get(k.handle);return O||k}return k}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,w,v,k){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,v,k),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const O=Vi._handlePool++,U=new u(h,this._proxy,this._commands,w,v,k);this._sourceControls.set(O,U);const F=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(h.identifier))||[];return F.push(U),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(h.identifier),F),U}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(h.identifier)),v=w&&w[w.length-1];return v&&v.inputBox}$provideOriginalResource(h,w,v){const k=f.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,k.toString());const O=this._sourceControls.get(h);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(k,v)).then(U=>U||null)}$onInputBoxValueChange(h,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const v=this._sourceControls.get(h);return v&&v.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,v,k){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,w,v);const O=this._sourceControls.get(h);if(!O)return Promise.resolve(void 0);const U=O.getResourceGroup(w);return U?U.$executeResourceCommand(v,k):Promise.resolve(void 0)}$validateInput(h,w,v){this.logService.trace("ExtHostSCM#$validateInput",h);const k=this._sourceControls.get(h);return!k||!k.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>k.inputBox.validateInput(w,v)).then(O=>{if(!O)return Promise.resolve(void 0);const U=b.MarkdownString.fromStrict(O.message);return U?Promise.resolve([U,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};c._handlePool=0,c=je([He(2,R.ILogService)],c),e.ExtHostSCM=c});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[249],ve([0,1,7,5,166,6,18,13]),function(Z,e,f,t,I,D,T,P){"use strict";var C,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(p,g,E,L,_=f.StatusBarAlignment.Left,a){C.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new D.DisposableStore,nt(this,C,p,"f"),nt(this,A,g,"f"),this._entryId=R.ID_GEN++,this._extension=E,this._id=L,this._alignment=_,this._priority=this.validatePriority(a)}validatePriority(p){if(!!(0,P.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!R.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Le(this,A,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Le(this,A,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let g;this._name?g=this._name:g=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const L=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Le(this,C,"f").$setEntry(this._entryId,p,g,this._text,L,this._command?.internal,E,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,C=new WeakMap,A=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const g={message:p};return this._messages.unshift(g),this._update(),new f.Disposable(()=>{const E=this._messages.indexOf(g);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(p,g){this._proxy=p.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new y(this)}createStatusBarEntry(p,g,E,L){return new R(this._proxy,this._commands,p,g,E,L)}setStatusBarMessage(p,g){const E=this._statusMessage.setMessage(p);let L;return typeof g=="number"?L=setTimeout(()=>E.dispose(),g):typeof g!="undefined"&&g.then(()=>E.dispose(),()=>E.dispose()),new f.Disposable(()=>{E.dispose(),clearTimeout(L)})}}e.ExtHostStatusBar=l}),define(pe[90],ve([0,1,5,3,4]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class D{constructor(P){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,C){this._proxy.$registerExtensionStorageKeysToSync(P,C)}initializeExtensionStorage(P,C,A){return this._proxy.$initializeExtensionStorage(P,C).then(R=>R||A)}setValue(P,C,A){return this._proxy.$setValue(P,C,A)}$acceptValue(P,C,A){this._onDidChangeStorage.fire({shared:P,key:C,value:A})}}e.ExtHostStorage=D,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(pe[68],ve([0,1,4,26,11,67,2]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let P=class{constructor(A,R,y){this._logService=R,this._extHostFileSystem=y,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(A){return T.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,R=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(A){if(this._value)return T.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return T.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=je([He(0,t.IExtHostInitDataService),He(1,I.ILogService),He(2,D.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(pe[34],ve([0,1,3,5,4,2,14,6,7,167,15,214,21,33,196,85,13,17]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class _{constructor(u,c,d,h){this._proxy=u,this._id=c,this._creationOptions=d,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(v=>this._pidPromiseComplete=v);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(v,k=!0){w._checkDisposed(),w._proxy.$sendText(w._id,v,k)},show(v){w._checkDisposed(),w._proxy.$show(w._id,v)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(u,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,E.withNullAsUndefined)(u.shellPath),shellArgs:(0,E.withNullAsUndefined)(u.shellArgs),cwd:(0,E.withNullAsUndefined)(u.cwd),env:(0,E.withNullAsUndefined)(u.env),icon:(0,E.withNullAsUndefined)(r(u.iconPath)),color:g.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,E.withNullAsUndefined)(u.message),strictEnv:(0,E.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,E.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,E.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,E.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(u.location,c?.resolvedExtHostIdentifier),disablePersistence:(0,E.withNullAsUndefined)(u.disablePersistence)})}async createExtensionTerminal(u,c,d,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:g.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(u,c),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,c){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,c){return u===this._cols&&c===this._rows||u===0||c===0?!1:(this._cols=u,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=_;class a{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new f.Emitter,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,c){this._pty.setDimensions?.({columns:u,rows:c})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let s=1,m=class extends P.Disposable{constructor(u,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[d,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,c){const d=new _(this._proxy,(0,b.generateUuid)(),u,u.name),h=new a(u.pty);return d.createExtensionTerminal(u.location,this._serializeParentTerminal(u,c).resolvedExtHostIdentifier,r(u.iconPath),i(u.color)).then(w=>{const v=this._setupExtHostProcessListeners(w,h);this._terminalProcessDisposables[w]=v}),this._terminals.push(d),d.value}_serializeParentTerminal(u,c){if(c=c||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const d=u.location.parentTerminal;if(d){const h=this._terminals.find(w=>w.value===d);h&&(c.resolvedExtHostIdentifier=h._id)}}else u.location&&typeof u.location!="object"?c.location=u.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(u,c){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const h=new a(c),w=this._setupExtHostProcessListeners(u,h);this._terminalProcessDisposables[u]=w}async $acceptActiveTerminalChanged(u){const c=this._activeTerminal;if(u===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(u);d&&(this._activeTerminal=d,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,c){const d=this._getTerminalById(u);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:c})}async $acceptTerminalDimensions(u,c,d){const h=this._getTerminalById(u);h&&h.setDimensions(c,d)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(u,c,d){this._terminalProcesses.get(u)?.resize(c,d)}async $acceptTerminalTitleChange(u,c){const d=this._getTerminalById(u);d&&(d.name=c)}async $acceptTerminalClosed(u,c){const d=this._getTerminalObjectIndexById(this._terminals,u);if(d!==null){const h=this._terminals.splice(d,1)[0];h.setExitCode(c),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(u,c,d,h){if(c){const k=this._getTerminalObjectIndexById(this._terminals,c);if(k!==null){this._terminals[k]._id=u,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const w={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:D.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},v=new _(this._proxy,u,w,d);this._terminals.push(v),this._onDidOpenTerminal.fire(v.value),v.isOpen=!0}async $acceptTerminalProcessId(u,c){const d=this._getTerminalById(u);d&&d._setProcessId(c)}async $startExtensionTerminal(u,c){const d=this._getTerminalById(u);if(!d)return{message:(0,A.localize)(0,null,u)};d.isOpen||await new Promise(w=>{const v=this.onDidOpenTerminal(async k=>{k===d.value&&(v.dispose(),w())})});const h=this._terminalProcesses.get(u);h?h.startSendingEvents(c):this._extensionTerminalAwaitingStart[u]={initialDimensions:c}}_setupExtHostProcessListeners(u,c){const d=new P.DisposableStore;d.add(c.onProcessReady(w=>this._proxy.$sendProcessReady(u,w.pid,w.cwd))),d.add(c.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(u,w))),this._bufferer.startBuffering(u,c.onProcessData),d.add(c.onProcessExit(w=>this._onProcessExit(u,w))),this._terminalProcesses.set(u,c);const h=this._extensionTerminalAwaitingStart[u];return h&&c instanceof a&&(c.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),d}$acceptProcessAckDataEvent(u,c){this._terminalProcesses.get(u)?.acknowledgeDataEvent(c)}$acceptProcessInput(u,c){this._terminalProcesses.get(u)?.input(c)}$acceptTerminalInteraction(u){const c=this._getTerminalById(u);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(u,c,d){try{this._terminalProcesses.get(u)?.resize(c,d)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(u,c){this._terminalProcesses.get(u)?.shutdown(c)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(c=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:c}))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,c,d){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,d),this._proxy.$registerProfileProvider(c,u.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(u,c){const d=new l.CancellationTokenSource().token;let h=await this._profileProviders.get(u)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,c);return}this.createTerminalFromOptions(h.options,c)}}async $provideLinks(u,c){const d=this._getTerminalById(u);if(!d)return[];this._terminalLinkCache.delete(u);const h=this._terminalLinkCancellationSource.get(u);h&&h.dispose(!0);const w=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,w);const v=[],k={terminal:d.value,line:c},O=[];for(const M of this._linkProviders)O.push(L.Promises.withAsyncBody(async V=>{w.token.onCancellationRequested(()=>V({provider:M,links:[]}));const $=await M.provideTerminalLinks(k,w.token)||[];w.token.isCancellationRequested||V({provider:M,links:$})}));const U=await Promise.all(O);if(w.token.isCancellationRequested)return[];const F=new Map;for(const M of U)M&&M.links.length>0&&v.push(...M.links.map(V=>{const $={id:s++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return F.set($.id,{provider:M.provider,link:V}),$}));return this._terminalLinkCache.set(u,F),v}$activateLink(u,c){const d=this._terminalLinkCache.get(u)?.get(c);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(u,c){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const d=this._terminalProcessDisposables[u];d&&(d.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,c)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,c){const d=this._getTerminalObjectIndexById(u,c);return d!==null?u[d]:null}_getTerminalObjectIndexById(u,c){let d=null;return u.some((h,w)=>h._id===c?(d=w,!0):!1),d}getEnvironmentVariableCollection(u){let c=this._environmentVariableCollections.get(u.identifier.value);return c||(c=new o,this._setEnvironmentVariableCollection(u.identifier.value,c)),c}_syncEnvironmentVariableCollection(u,c){const d=(0,y.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(u,c.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(u){u.forEach(c=>{const d=c[0],h=new o(c[1]);this._setEnvironmentVariableCollection(d,h)})}$acceptDefaultProfile(u,c){this._defaultProfile=u,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(u,c){this._environmentVariableCollections.set(u,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,c)})}};m=je([He(1,T.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class o{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,c){this._setIfDiffers(u,{value:c,type:C.EnvironmentVariableMutatorType.Replace})}append(u,c){this._setIfDiffers(u,{value:c,type:C.EnvironmentVariableMutatorType.Append})}prepend(u,c){this._setIfDiffers(u,{value:c,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,c){const d=this.map.get(u);(!d||d.value!==c.value||d.type!==c.type)&&(this.map.set(u,c),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,c){this.map.forEach((d,h)=>u.call(c,h,d,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let S=class extends m{constructor(u){super(!1,u)}createTerminal(u,c,d){throw new R.NotSupportedError}createTerminalFromOptions(u,c){throw new R.NotSupportedError}};S=je([He(0,T.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function r(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function i(n){return g.ThemeColor.isThemeColor(n)?n:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[250],ve([0,1,16,22,21,3,76,58,6,25,13,33,5,14,64,18,7,220,127,88]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let m=class{constructor(k,O){this.resultsChangedEmitter=new D.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(l.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new S(this.proxy),O.registerArgumentProcessor({processArgument:U=>U?.$mid===13?g.TestItem.toItemFromContext(U):U})}createTestController(k,O,U){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const F=new C.DisposableStore,M=F.add(new L.SingleUseTestCollection(k));M.root.label=O;const V=new Map,$=this.proxy,N={items:M.root.children,get label(){return O},set label(x){O=x,M.root.label=x,$.$updateController(k,{label:O})},get refreshHandler(){return U},set refreshHandler(x){U=x,$.$updateController(k,{canRefresh:!!x})},get id(){return k},createRunProfile:(x,z,W,J,se)=>{let ie=(0,P.hash)(x);for(;V.has(ie);)ie++;const K=new h(this.proxy,k,ie,x,z,W,J,se);return V.set(ie,K),K},createTestItem(x,z,W){return new p.TestItemImpl(k,x,z,W)},createTestRun:(x,z,W=!0)=>this.runTracker.createTestRun(k,M,x,z,W),set resolveHandler(x){M.resolveHandler=x},get resolveHandler(){return M.resolveHandler},dispose:()=>{F.dispose()}};$.$registerTestController(k,O,!!U),F.add((0,C.toDisposable)(()=>$.$unregisterTestController(k)));const B={controller:N,collection:M,profiles:V};return this.controllers.set(k,B),F.add((0,C.toDisposable)(()=>this.controllers.delete(k))),F.add(M.onDidGenerateDiff(x=>$.$publishDiff(k,x))),N}createTestObserver(){return this.observer.checkout()}async runTests(k,O=I.CancellationToken.None){const U=r(k);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(U.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:k.include?.map(M=>M.id)??[F.collection.root.id],profileGroup:w[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:k.exclude?.map(M=>M.id)},O)}$provideFileCoverage(k,O,U){return(0,f.mapFind)(this.runTracker.trackers,M=>M.id===k?M.getCoverage(O):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(k,O,U,F){return(0,f.mapFind)(this.runTracker.trackers,V=>V.id===k?V.getCoverage(O):void 0)?.resolveFileCoverage(U,F)??Promise.resolve([])}$configureRunProfile(k,O){this.controllers.get(k)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(k,O){await this.controllers.get(k)?.controller.refreshHandler?.(O)}$publishTestResults(k){this.results=Object.freeze(k.map(O=>(0,A.deepFreeze)(g.TestResults.to(O))).concat(this.results).sort((O,U)=>U.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,O){const U=this.controllers.get(a.TestId.fromString(k).controllerId)?.collection;U&&(await U.expand(k,O<0?1/0:O),U.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,O){const U=this.controllers.get(k.controllerId);if(!U)return;const{collection:F,profiles:M}=U,V=M.get(k.profileId);if(!V)return;const $=k.testIds.map(z=>F.tree.get(z)).filter(R.isDefined),N=k.excludeExtIds.map(z=>U.collection.tree.get(z)).filter(R.isDefined).filter(z=>$.some(W=>W.fullId.compare(z.fullId)===2));if(!$.length)return;const B=new E.TestRunRequest($.some(z=>z.actual instanceof p.TestItemRootImpl)?void 0:$.map(z=>z.actual),N.map(z=>z.actual),V),x=this.runTracker.prepareForMainThreadTestRun(B,i.fromInternal(k,U.collection),O);try{await V.runHandler(B,O)}finally{x.isRunning&&!O.isCancellationRequested&&await D.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};m=je([He(0,b.IExtHostRpcService)],m),e.ExtHostTesting=m;class o extends C.Disposable{constructor(k,O,U){super();this.dto=k,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new D.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(U)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const O=this.dto.id,U=this.dto.controllerId,F=(0,y.generateUuid)(),M=new n(this.proxy,O,F),V=x=>(z,...W)=>{if(N){console.warn(`Setting the state of test "${z.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(z)||(this.ensureTestIsKnown(z),x(z,...W))},$=(x,z)=>{const W=z instanceof Array?z.map(g.TestMessage.from):[g.TestMessage.from(z)];if(x.uri&&x.range){const J={range:g.Range.from(x.range),uri:x.uri};for(const se of W)se.location=se.location||J}this.proxy.$appendTestMessagesInRun(O,F,a.TestId.fromExtHostTestItem(x,U).toString(),W)};let N=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return M.coverageProvider},set coverageProvider(x){M.coverageProvider=x},enqueued:V(x=>{this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(x,U).toString(),1)}),skipped:V(x=>{this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(x,U).toString(),5)}),started:V(x=>{this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(x,U).toString(),2)}),errored:V((x,z,W)=>{$(x,z),this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(x,U).toString(),6,W)}),failed:V((x,z,W)=>{$(x,z),this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(x,U).toString(),4,W)}),passed:V((x,z)=>{this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,z)}),appendOutput:(x,z,W)=>{N||(W&&(this.dto.isIncluded(W)?this.ensureTestIsKnown(W):W=void 0),this.proxy.$appendOutputToRun(O,F,t.VSBuffer.fromString(x),z&&g.location.from(z),W&&a.TestId.fromExtHostTestItem(W,U).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(O,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:B,coverage:M}),this.proxy.$startedTestRunTask(O,{id:F,name:k,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof p.TestItemImpl))throw new p.InvalidTestItemError(k.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const O=[],U=this.dto.colllection.root;for(;;){const F=g.TestItem.from(k);if(O.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),k===U))break;k=k.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class S{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,O,U){return this.getTracker(k,O,U)}cancelRunById(k){for(const O of this.tracked.values())if(O.id===k){O.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,O,U,F,M){const V=this.tracked.get(U);if(V)return V.createRun(F);const $=i.fromPublic(k,O,U,M),N=r(U);this.proxy.$startedExtensionTestRun({controllerId:k,profile:N&&{group:w[N.kind],id:N.profileId},exclude:U.exclude?.map(x=>x.id)??[],id:$.id,include:U.include?.map(x=>x.id)??[O.root.id],persist:M});const B=this.getTracker(U,$);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun($.id)),B.createRun(F)}getTracker(k,O,U){const F=new o(O,this.proxy,U);return this.tracked.set(k,F),F.onEnd(()=>this.tracked.delete(k)),F}}e.TestRunCoordinator=S;const r=v=>{if(!!v.profile){if(!(v.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return v.profile}};class i{constructor(k,O,U,F,M,V){this.controllerId=k,this.id=O,this.isPersisted=M,this.colllection=V,this.includePrefix=U.map($=>$+"\0"),this.excludePrefix=F.map($=>$+"\0")}static fromPublic(k,O,U,F){return new i(k,(0,y.generateUuid)(),U.include?.map(M=>a.TestId.fromExtHostTestItem(M,k).toString())??[k],U.exclude?.map(M=>a.TestId.fromExtHostTestItem(M,k).toString())??[],F,O)}static fromInternal(k,O){return new i(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,O)}isIncluded(k){const O=a.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(O===U||O.startsWith(U))return!1;for(const U of this.includePrefix)if(O===U||O.startsWith(U))return!0;return!1}}e.TestRunDto=i;class n{constructor(k,O,U){this.proxy=k,this.runId=O,this.taskId=U}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(k,O){const U=await this.fileCoverage;let F=U?.[k];return!this._coverageProvider||!U||!F?[]:(F.detailedCoverage||(F=U[k]=await this._coverageProvider.resolveFileCoverage?.(F,O)??F),F.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class u extends _.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,g.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:O,removed:U}=this;return{get added(){return[...k].map(F=>F.revived)},get updated(){return[...O].map(F=>F.revived)},get removed(){return[...U].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,O){return{...k,revived:g.TestItem.toPlain(k.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=c;class d{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(O=>O.revived)},dispose:(0,T.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class h{constructor(k,O,U,F,M,V,$=!1,N=void 0){this.controllerId=O,this.profileId=U,this._label=F,this.kind=M,this.runHandler=V,this._isDefault=$,this._tag=N,s.set(this,void 0),nt(this,s,k,"f");const B=w[M];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Le(this,s,"f").$publishTestRunProfile({profileId:U,controllerId:O,tag:N?g.TestTag.namespace(this.controllerId,N.id):null,label:F,group:B,isDefault:$,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?g.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){Le(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,s=new WeakMap;const w={[E.TestRunProfileKind.Coverage]:8,[E.TestRunProfileKind.Debug]:4,[E.TestRunProfileKind.Run]:2}}),define(pe[251],ve([0,1,3,16,5,130,18,7]),function(Z,e,f,t,I,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(R,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const y=this._extHostDocumentsAndEditors.allEditors();return R?y:y.map(l=>l.value)}async showTextDocument(R,y,l){let b;typeof y=="number"?b={position:T.ViewColumn.from(y),preserveFocus:l}:typeof y=="object"?b={position:T.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?T.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(R.uri,b),g=p&&this._extHostDocumentsAndEditors.getEditor(p);if(g)return g.value;throw p?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,y){return new D.TextEditorDecorationType(this._proxy,R,y).value}$acceptEditorPropertiesChanged(R,y){const l=this._extHostDocumentsAndEditors.getEditor(R);if(!l)throw new Error("unknown text editor");if(y.options&&l._acceptOptions(y.options),y.selections){const b=y.selections.selections.map(T.Selection.to);l._acceptSelections(b)}if(y.visibleRanges){const b=t.coalesce(y.visibleRanges.map(T.Range.to));l._acceptVisibleRanges(b)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...y.options,lineNumbers:T.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const b=P.TextEditorSelectionChangeKind.fromValue(y.selections.source),p=y.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:p,kind:b})}if(y.visibleRanges){const b=t.coalesce(y.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(R){for(const y in R){const l=this._extHostDocumentsAndEditors.getEditor(y);if(!l)throw new Error("Unknown text editor");const b=T.ViewColumn.to(R[y]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=C}),define(pe[252],ve([0,1,2,4,5,6,7]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class P{constructor(R,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(I.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const b=l.uri===void 0?void 0:f.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(C(b))?.get(l.handle)}return l}})}async $getTimeline(R,y,l,b,p){return this._providers.get(R)?.provideTimeline(f.URI.revive(y),l,b,p)}registerTimelineProvider(R,y,l,b){const p=new D.DisposableStore,g=this.convertTimelineItem(y.id,b,p).bind(this);let E;y.onDidChange&&(E=y.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:y.id}),this));const L=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:R,onDidChange:void 0,async provideTimeline(_,a,s,m){m?.resetCache&&(p.clear(),L.get(y.id)?.clear());const o=await y.provideTimeline(_,a,s);if(o==null)return;const S=g(_,m);return{...o,source:y.id,items:o.items.map(S)}},dispose(){for(const _ of L.values())_.get(y.id)?.clear();E?.dispose(),p.dispose()}})}convertTimelineItem(R,y,l){return(b,p)=>{let g;if(p?.cacheResults){let E=this._itemsBySourceAndUriMap.get(R);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(R,E));const L=C(b);g=E.get(L),g===void 0&&(g=new Map,E.set(L,g))}return E=>{const{iconPath:L,..._}=E,a=`${R}|${E.id??E.timestamp}`;g?.set(a,E);let s,m,o;return E.iconPath&&(L instanceof T.ThemeIcon?o={id:L.id,color:L.color}:f.URI.isUri(L)?(s=L,m=L):{light:s,dark:m}=L),{..._,id:_.id??void 0,handle:a,source:R,command:E.command?y.toInternal(E.command,l):void 0,icon:s,iconDark:m,themeIcon:o,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,D.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=P;function C(A){return A?.toString()}}),define(pe[253],ve([0,1,6,10,2,5]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(C){this._openers=new Map,this._proxy=C.getProxy(D.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,A,R,y){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const l=y.schemes.find(b=>!T.supportedSchemes.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,R),this._proxy.$registerUriOpener(A,y.schemes,C,y.label),(0,f.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(C,A,R){const y=this._openers.get(C);if(!y)throw new Error(`Unknown opener with id: ${C}`);const l=I.URI.revive(A);return y.canOpenExternalUri(l,R)}async $openUri(C,A,R){const y=this._openers.get(C);if(!y)throw new Error(`Unknown opener id: '${C}'`);return y.openExternalUri(I.URI.revive(A.resolvedUri),{sourceUri:I.URI.revive(A.sourceUri)},R)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(pe[254],ve([0,1,5,2,6,15,27]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(A,R){if(this.handles.has(T.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const y=P.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(A)),this.handlers.set(y,R),this._proxy.$registerUriHandler(y,A),(0,I.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(A)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(A,R){const y=this.handlers.get(A);if(!y)return Promise.resolve(void 0);try{y.handleUri(t.URI.revive(R))}catch(l){(0,D.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(A){return t.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=P,P.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[69],ve([0,1,3,10,2,179,204,87,5]),function(Z,e,f,t,I,D,T,P,C){"use strict";var A,R,y,l,b,p,g,E,L,_,a,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(d,h,w,v,k,O,U){A.set(this,void 0),R.set(this,void 0),y.set(this,void 0),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,""),E.set(this,void 0),L.set(this,!1),_.set(this,!1),a.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new f.Emitter),this._onDidDispose=Le(this,s,"f").event,nt(this,A,d,"f"),nt(this,R,h,"f"),nt(this,E,w,"f"),nt(this,l,v,"f"),nt(this,b,k,"f"),nt(this,p,O,"f"),nt(this,a,o(O),"f"),nt(this,y,U,"f")}dispose(){nt(this,L,!0,"f"),Le(this,s,"f").fire(),Le(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return nt(this,_,!0,"f"),(0,P.asWebviewUri)(d,Le(this,l,"f").remote)}get cspSource(){const d=Le(this,p,"f").extensionLocation;if(d.scheme===t.Schemas.https||d.scheme===t.Schemas.http){let h=d.toString();return h.endsWith("/")||(h+="/"),h+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,g,"f")}set html(d){this.assertNotDisposed(),Le(this,g,"f")!==d&&(nt(this,g,d,"f"),!Le(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(nt(this,_,!0,"f"),Le(this,y,"f").report("Webview vscode-resource: uris",Le(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,R,"f").$setHtml(Le(this,A,"f"),d))}get options(){return this.assertNotDisposed(),Le(this,E,"f")}set options(d){this.assertNotDisposed(),Le(this,R,"f").$setOptions(Le(this,A,"f"),i(Le(this,p,"f"),Le(this,b,"f"),d)),nt(this,E,d,"f")}async postMessage(d){if(Le(this,L,"f"))return!1;const h=(0,T.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Le(this,a,"f")});return Le(this,R,"f").$postMessage(Le(this,A,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Le(this,L,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,A=new WeakMap,R=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,_=new WeakMap,a=new WeakMap,s=new WeakMap;function o(c){try{const d=(0,D.normalizeVersion)((0,D.parseVersion)(c.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class S{constructor(d,h,w,v,k){this.initData=h,this.workspace=w,this._logService=v,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=d.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(d,h,w){const v=this.getWebview(d);if(v){const{message:k}=(0,T.deserializeWebviewMessage)(h,w.value);v._onMessageEmitter.fire(k)}}$onMissingCsp(d,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,h,w){const v=new m(d,this._webviewProxy,n(h),this.initData,this.workspace,w,this._deprecationService);return this._webviews.set(d,v),v._onDidDispose(()=>{this._webviews.delete(d)}),v}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=S;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function i(c,d,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||u(c,d)}}e.serializeWebviewOptions=i;function n(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(d=>I.URI.from(d))}}e.reviveOptions=n;function u(c,d){return[...(d?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(pe[255],ve([0,1,21,58,6,10,23,2,18,69,86,5,7]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(o,S){this.document=o,this._storagePath=S,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,S){await this.getEdit(o).undo(),S||this.disposeBackup()}async redo(o,S){await this.getEdit(o).redo(),S||this.disposeBackup()}disposeEdits(o){for(const S of o)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=s(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const S=this._edits.get(o,0);if(!S)throw new Error("No edit found");return S}}class p{constructor(){this._documents=new Map}get(o,S){return this._documents.get(this.key(o,S))}add(o,S,r){const i=this.key(o,S.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${o} resource:${S.uri}`);const n=new b(S,r);return this._documents.set(i,n),n}delete(o,S){const r=this.key(o,S.uri);this._documents.delete(r)}key(o,S){return`${o}@@@${S}`}}var g;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(g||(g={}));class E{constructor(){this._providers=new Map}addTextProvider(o,S,r){return this.add(0,o,S,r)}addCustomProvider(o,S,r){return this.add(1,o,S,r)}get(o){return this._providers.get(o)}add(o,S,r,i){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:o,extension:r,provider:i}),new l.Disposable(()=>this._providers.delete(S))}}class L{constructor(o,S,r,i,n){this._extHostDocuments=S,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=n,this._editorProviders=new E,this._documents=new p,this._proxy=o.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,S,r,i){const n=new I.DisposableStore;return _(r)?(n.add(this._editorProviders.addTextProvider(S,o,r)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(o),S,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(o))):(n.add(this._editorProviders.addCustomProvider(S,o,r)),this.supportEditing(r)&&n.add(r.onDidChangeCustomDocument(u=>{const c=this.getCustomDocumentEntry(S,u.document.uri);if(a(u)){const d=c.addEdit(u);this._proxy.$onDidEdit(u.document.uri,S,d,u.label)}else this._proxy.$onContentChange(u.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(o),S,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(o))),l.Disposable.from(n,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(o,S,r,i,n){const u=this._editorProviders.get(S);if(!u)throw new Error(`No provider found for '${S}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${S}'`);const c=P.URI.revive(o),d=await u.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:i?.buffer},n);let h;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(S,d,h),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(o,S){const r=this._editorProviders.get(S);if(!r)throw new Error(`No provider found for '${S}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${S}'`);const i=P.URI.revive(o),{document:n}=this.getCustomDocumentEntry(S,i);this._documents.delete(S,n),n.dispose()}async $resolveWebviewEditor(o,S,r,i,n,u){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const d=C.ViewColumn.to(n),h=this._extHostWebview.createNewWebview(S,i.webviewOptions,c.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(S,r,i.title,d,i.panelOptions,h),v=P.URI.revive(o);switch(c.type){case 1:{const{document:k}=this.getCustomDocumentEntry(r,v);return c.provider.resolveCustomEditor(k,w,u)}case 0:{const k=this._extHostDocuments.getDocument(v);return c.provider.resolveCustomTextEditor(k,w,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,S,r){this.getCustomDocumentEntry(S,o).disposeEdits(r)}async $onMoveCustomEditor(o,S,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const n=this._extHostWebviewPanels.getWebviewPanel(o);if(!n)throw new Error("No webview found");const u=P.URI.revive(S),c=this._extHostDocuments.getDocument(u);await i.provider.moveCustomTextEditor(c,n,f.CancellationToken.None)}async $undo(o,S,r,i){return this.getCustomDocumentEntry(S,o).undo(r,i)}async $redo(o,S,r,i){return this.getCustomDocumentEntry(S,o).redo(r,i)}async $revert(o,S,r){const i=this.getCustomDocumentEntry(S,o);await this.getCustomEditorProvider(S).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(o,S,r){const i=this.getCustomDocumentEntry(S,o);await this.getCustomEditorProvider(S).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(o,S,r,i){const n=this.getCustomDocumentEntry(S,o);return this.getCustomEditorProvider(S).saveCustomDocumentAs(n.document,P.URI.revive(r),i)}async $backup(o,S,r){const i=this.getCustomDocumentEntry(S,o),u=await this.getCustomEditorProvider(S).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(u),u.id}getCustomDocumentEntry(o,S){const r=this._documents.get(o,P.URI.revive(S));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(o){const r=this._editorProviders.get(o)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=L;function _(m){return typeof m.resolveCustomTextEditor=="function"}function a(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function s(m){const o=m.scheme===D.Schemas.file||m.scheme===D.Schemas.untitled?m.fsPath:m.toString();return(0,t.hash)(o)+""}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[256],ve([0,1,3,6,2,33,18,69,5,7]),function(Z,e,f,t,I,D,T,P,C,A){"use strict";var R,y,l,b,p,g,E,L,_,a,s,m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends t.Disposable{constructor(u,c,d,h,w,v,k){super();R.set(this,void 0),y.set(this,void 0),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,void 0),E.set(this,void 0),L.set(this,void 0),_.set(this,!0),a.set(this,!0),s.set(this,!1),m.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,m,"f").event,o.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Le(this,o,"f").event,nt(this,R,u,"f"),nt(this,y,c,"f"),nt(this,l,d,"f"),nt(this,p,v,"f"),nt(this,L,w,"f"),nt(this,g,h,"f"),nt(this,b,k,"f")}dispose(){Le(this,s,"f")||(nt(this,s,!0,"f"),Le(this,m,"f").fire(),Le(this,y,"f").$disposeWebview(Le(this,R,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,b,"f")}get viewType(){return this.assertNotDisposed(),Le(this,l,"f")}get title(){return this.assertNotDisposed(),Le(this,g,"f")}set title(u){this.assertNotDisposed(),Le(this,g,"f")!==u&&(nt(this,g,u,"f"),Le(this,y,"f").$setTitle(Le(this,R,"f"),u))}get iconPath(){return this.assertNotDisposed(),Le(this,E,"f")}set iconPath(u){this.assertNotDisposed(),Le(this,E,"f")!==u&&(nt(this,E,u,"f"),Le(this,y,"f").$setIconPath(Le(this,R,"f"),I.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Le(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,L,"f")=="number"&&Le(this,L,"f")<0))return Le(this,L,"f")}get active(){return this.assertNotDisposed(),Le(this,a,"f")}get visible(){return this.assertNotDisposed(),Le(this,_,"f")}_updateViewState(u){Le(this,s,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(nt(this,a,u.active,"f"),nt(this,_,u.visible,"f"),nt(this,L,u.viewColumn,"f"),Le(this,o,"f").fire({webviewPanel:this}))}reveal(u,c){this.assertNotDisposed(),Le(this,y,"f").$reveal(Le(this,R,"f"),{viewColumn:u?T.ViewColumn.from(u):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Le(this,s,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,_=new WeakMap,a=new WeakMap,s=new WeakMap,m=new WeakMap,o=new WeakMap;class r{constructor(u,c,d){this.webviews=c,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,D.generateUuid)()}createWebviewPanel(u,c,d,h,w={}){const v=typeof h=="object"?h.viewColumn:h,k={viewColumn:T.ViewColumn.from(v),preserveFocus:typeof h=="object"&&!!h.preserveFocus},O=(0,P.shouldSerializeBuffersForPostMessage)(u),U=r.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(u),U,c,{title:d,panelOptions:i(w),webviewOptions:(0,P.serializeWebviewOptions)(u,this.workspace,w),serializeBuffersForPostMessage:O},k);const F=this.webviews.createNewWebview(U,w,u);return this.createNewWebviewPanel(U,c,d,v,w,F)}$onDidChangeWebviewPanelViewStates(u){const c=Object.keys(u);c.sort((d,h)=>{const w=u[d],v=u[h];return w.active?1:v.active?-1:+w.visible-+v.visible});for(const d of c){const h=this.getWebviewPanel(d);if(!h)continue;const w=u[d];h._updateViewState({active:w.active,visible:w.visible,viewColumn:T.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,c,d){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:d,extension:u}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(u)}),new A.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(u,c,d,h){const w=this._serializers.get(c);if(!w)throw new Error(`No serializer found for '${c}'`);const{serializer:v,extension:k}=w,O=this.webviews.createNewWebview(u,d.webviewOptions,k),U=this.createNewWebviewPanel(u,c,d.title,h,d.panelOptions,O);await v.deserializeWebviewPanel(U,d.state)}createNewWebviewPanel(u,c,d,h,w,v){const k=new S(u,this._proxy,c,d,h,w,v);return this._webviewPanels.set(u,k),k}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=r;function i(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[257],ve([0,1,3,6,69,5,7]),function(Z,e,f,t,I,D,T){"use strict";var P,C,A,R,y,l,b,p,g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class L extends t.Disposable{constructor(s,m,o,S,r,i){super();P.set(this,void 0),C.set(this,void 0),A.set(this,void 0),R.set(this,void 0),y.set(this,!1),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Le(this,g,"f").event,E.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,E,"f").event,nt(this,A,o,"f"),nt(this,b,S,"f"),nt(this,P,s,"f"),nt(this,C,m,"f"),nt(this,R,r,"f"),nt(this,l,i,"f")}dispose(){Le(this,y,"f")||(nt(this,y,!0,"f"),Le(this,E,"f").fire(),Le(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,b,"f")}set title(s){this.assertNotDisposed(),Le(this,b,"f")!==s&&(nt(this,b,s,"f"),Le(this,C,"f").$setWebviewViewTitle(Le(this,P,"f"),s))}get description(){return this.assertNotDisposed(),Le(this,p,"f")}set description(s){this.assertNotDisposed(),Le(this,p,"f")!==s&&(nt(this,p,s,"f"),Le(this,C,"f").$setWebviewViewDescription(Le(this,P,"f"),s))}get visible(){return Le(this,l,"f")}get webview(){return Le(this,R,"f")}get viewType(){return Le(this,A,"f")}_setVisible(s){s===Le(this,l,"f")||Le(this,y,"f")||(nt(this,l,s,"f"),Le(this,g,"f").fire())}show(s){this.assertNotDisposed(),Le(this,C,"f").$show(Le(this,P,"f"),!!s)}assertNotDisposed(){if(Le(this,y,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,A=new WeakMap,R=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap;class _{constructor(s,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,m,o,S){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:o,extension:s}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(s),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(s,m,o,S,r){const i=this._viewProviders.get(m);if(!i)throw new Error(`No view provider found for '${m}'`);const{provider:n,extension:u}=i,c=this._extHostWebview.createNewWebview(s,{},u),d=new L(s,this._proxy,m,o,c,!0);this._webviewViews.set(s,d),await n.resolveWebviewView(d,{state:S},r)}async $onDidChangeWebviewViewVisibility(s,m){this.getWebviewView(s)._setVisible(m)}async $disposeWebviewView(s){const m=this.getWebviewView(s);this._webviewViews.delete(s),m.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const m=this._webviewViews.get(s);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=_}),define(pe[134],ve([0,1,3,5,2,10,8,4,14]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class ji{constructor(y){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=y.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,l){let b;if(typeof y=="string"){b=y;try{y=I.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,T.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,b,l)}async asExternalUri(y,l){if((0,T.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(y,l);return I.URI.from(b)}};A.InitialState={focused:!0},A=je([He(0,C.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(pe[258],ve([0,1,9,81,33,38,6,5,2,14]),function(Z,e,f,t,I,D,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends T.Disposable{constructor(l,b){super();const p=l.getProxy(P.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async g=>{const E=C.URI.file((0,f.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await p.$download(g,E),E})}};R=je([He(0,A.IExtHostRpcService),He(1,D.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(pe[259],ve([0,1,132,10,188,33]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends f.ExtHostLoggerService{doCreateLogger(C,A,R){return C.scheme===t.Schemas.file?new I.SpdLogLogger(R?.name||(0,D.generateUuid)(),C.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,A):super.doCreateLogger(C,A,R)}}e.ExtHostLoggerService=T}),define(pe[260],ve([0,1,60,9,2,68,6,10,17,30]),function(Z,e,f,t,I,D,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends D.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const S=await super._getWorkspaceStorageURI(o);if(S.scheme!==P.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const r=S.fsPath;let i=0;do{let n;i===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${i}`:`${r}-${i}`,await y(n);const u=t.join(n,"vscode.lock"),c=await g(this._logService,u,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),I.URI.file(n);i++}while(i<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function y(m){try{await A.Promises.stat(m);return}catch{}try{await A.Promises.mkdir(m,{recursive:!0})}catch{}}const l=1e3,b=10*60*1e3;class p extends T.Disposable{constructor(o,S){super();this.logService=o,this.filename=S,this._timer=this._register(new C.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await E(o,S);(!r||r.pid!==process.pid)&&(o.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await A.Promises.utimes(S,new Date,new Date)}catch(i){o.error(i),o.info(`Lock '${S}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+o};await A.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function g(m,o,S){try{const i={pid:process.pid,willReleaseAt:0};await A.Promises.writeFile(o,JSON.stringify(i),{flag:"wx"})}catch(i){m.error(i)}const r=await E(m,o);return!r||r.pid!==process.pid?S?(m.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),a(m,o)):(m.info(`Lock '${o}': Lock acquired.`),new p(m,o))}async function E(m,o){let S;try{S=await A.Promises.readFile(o)}catch(r){return m.error(r),null}try{return JSON.parse(String(S))}catch(r){return m.error(r),null}}async function L(m,o){let S;try{S=await A.Promises.stat(o)}catch(r){return m.error(r),0}return S.mtime.getTime()}function _(m){try{return process.kill(m,0),!0}catch{return!1}}async function a(m,o){const S=await E(m,o);if(!S)return m.info(`Lock '${o}': Could not read pid of lock holder.`),s(m,o);if(S.willReleaseAt){let c=S.willReleaseAt-Date.now();if(c<5e3){for(c>0?m.info(`Lock '${o}': The lockfile is scheduled to be released in ${c} ms.`):m.info(`Lock '${o}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,C.timeout)(Math.min(100,c)),await L(m,o)===0)return s(m,o);c=S.willReleaseAt-Date.now()}return s(m,o)}}if(!_(S.pid))return m.info(`Lock '${o}': The pid ${S.pid} appears to be gone.`),s(m,o);const r=await L(m,o),i=Date.now()-r;if(i<=b)return m.info(`Lock '${o}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;m.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,C.timeout)(2e3);const n=await L(m,o),u=Date.now()-n;return u<=b?(m.info(`Lock '${o}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(m.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),s(m,o))}async function s(m,o){m.info(`Lock '${o}': Deleting a stale lock.`);try{await A.Promises.unlink(o)}catch{}return g(m,o,!0)}}),define(pe[261],ve([0,1,33,14,34]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let D=class extends I.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,C,A){return this.createTerminalFromOptions({name:P,shellPath:C,shellArgs:A})}createTerminalFromOptions(P,C){const A=new I.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),P,P.name);return this._terminals.push(A),A.create(P,this._serializeParentTerminal(P,C)),A.value}};D=je([He(0,t.IExtHostRpcService)],D),e.ExtHostTerminalService=D}),define(pe[262],ve([0,1,5,14,171,6,26,2,37,23,30,7,12,51,3,121,94,11]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(d,h,w){this.remoteAddress=d,this.localAddress=h,this._dispose=w,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function a(c){const d=c.trim().split(`
`),h=[];return d.forEach(v=>{const k=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);k&&k.length>=3&&h.push({pid:parseInt(k[1],10),socket:parseInt(k[2],10)})}),h.reduce((v,k)=>(v[k.socket]=k,v),{})}e.getSockets=a;function s(...c){const d=[].concat(...c.map(o));return[...new Map(d.filter(h=>h.st==="0A").map(h=>{const w=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:m(w[0]),port:parseInt(w[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=s;function m(c){let d="";if(c.length===8)for(let h=c.length-2;h>=0;h-=2)d+=parseInt(c.substr(h,2),16),h!==0&&(d+=".");else for(let h=c.length-4;h>=0;h-=4)d+=parseInt(c.substr(h,4),16).toString(16),h!==0&&(d+=":");return d}e.parseIpAddress=m;function o(c){const d=c.trim().split(`
`),h=d.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return d.map(v=>v.trim().split(/\s+/).reduce((k,O,U)=>(k[h[U]||U]=O,k),{}))}e.loadConnectionTable=o;function S(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const d=c.trim().split(`
`),h=[];return d.forEach(w=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);v&&v.length>=4&&h.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),h}e.getRootProcesses=r;async function i(c,d,h){const w=h.reduce((k,O)=>(k[O.pid]=O,k),{}),v=[];return c.forEach(({socket:k,ip:O,port:U})=>{const F=d[k]?d[k].pid:void 0,M=F?w[F]?.cmd:void 0;F&&M&&!S(M)&&v.push({host:O,port:U,detail:M,pid:F})}),v}e.findPorts=i;function n(c,d,h){const w=new Map,v=r(d);for(const k of c){const O=h.get(k.port);if(O){w.set(k.port,O);continue}const U=v.find(F=>F.cmd.includes(`${k.port}`));if(U){let F=U,M;do M=v.find(V=>V.ppid===F.pid),M&&(F=M);while(M);w.set(k.port,{host:k.ip,port:k.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else w.set(k.port,{host:k.ip,port:k.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=n;let u=class extends D.Disposable{constructor(d,h,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(f.MainContext.MainThreadTunnelService),l.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(h,d.displayName);if(w){const v=new _(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,h){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:d,provider:h}),this._proxy.$registerPortsAttributesProvider(d,w),new y.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(d,h,w,v,k){const O=[];for(const F of d){const M=this._portAttributesProviders.get(F);if(!M)return[];O.push(...await Promise.all(h.map(async V=>M.provider.providePortAttributes(V,w,v,k))))}const U=O.filter(F=>!!F);return U.length>0?U.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let h=new E.MovingAverage,w;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),k=(await this.findCandidatePorts()).filter(U=>(0,g.isLocalhost)(U.host)||(0,g.isAllInterfaces)(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${k.map(U=>U.port).join(", ")}`);const O=new Date().getTime()-v;h.update(O),(!w||JSON.stringify(w)!==JSON.stringify(k))&&(w=k,await this._proxy.$onFoundNewCandidates(w)),await new Promise(U=>setTimeout(()=>U(),this.calculateDelay(h.value)))}}async setTunnelFactory(d){if(d){if(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory){this._forwardPortProvider=d.tunnelFactory;let h=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const w=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,D.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,h){if(this._extensionTunnels.has(d.host)){const w=this._extensionTunnels.get(d.host);w.has(d.port)&&(h&&w.get(d.port).disposeListener.dispose(),await w.get(d.port).tunnel.dispose(),w.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(d,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const v=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const k=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:v,disposeListener:k}),b.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const h=await Promise.all(d.map(v=>this._showCandidatePort(v.host,v.port,v.detail??""))),w=d.filter((v,k)=>h[k]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(v=>v.port).join(", ")} to ${w.map(v=>v.port).join(", ")}`),w}async findCandidatePorts(){let d="",h="";try{d=await R.Promises.readFile("/proc/net/tcp","utf8"),h=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=s(d,h),v=await new Promise(N=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,x,z)=>{N(x)})}),k=a(v),O=await R.Promises.readdir("/proc"),U=[];for(let N of O)try{const B=Number(N),x=A.joinPath(P.URI.file("/proc"),N);if((await R.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(B)){const W=await R.Promises.readlink(A.joinPath(x,"cwd").fsPath),J=await R.Promises.readFile(A.joinPath(x,"cmdline").fsPath,"utf8");U.push({pid:B,cwd:W,cmd:J})}}catch{}const F=[],M=w.filter(N=>{const B=k[N.socket];return B||F.push(N),B}),V=i(M,k,U);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const N=await new Promise(B=>{(0,C.exec)("ps -F -A -l | grep root",(x,z,W)=>{B(z)})});this._foundRootPorts=n(F,N,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return V.then(N=>$?N.concat($):N)}};u=je([He(0,t.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,L.ILogService)],u),e.ExtHostTunnelService=u}),define(pe[263],ve([0,1,17,22,21,15,3,6,103,226,52]),function(Z,e,f,t,I,D,T,P,C,A,R){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(w,v){try{return JSON.stringify(w,v)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class g{constructor(v,k){this.jsonString=v,this.referencedBuffers=k}}function E(w,v=null,k=!1){const O=[];return{jsonString:(k?l:JSON.stringify)(w,(F,M)=>{if(typeof M=="undefined")return p;if(typeof M=="object"){if(M instanceof t.VSBuffer){const V=O.push(M)-1;return{[b]:V}}if(v)return v(F,M)}return M}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=E;function L(w,v,k){return JSON.parse(w,(O,U)=>{if(U){const F=U[b];if(typeof F=="number")return v[F];if(k&&U.$mid===1)return k.transformIncoming(U)}return U})}e.parseJsonAndRestoreBufferRefs=L;function _(w,v){return JSON.stringify(w,v)}function a(w){return w?(v,k)=>k&&k.$mid===1?w.transformOutgoing(k):k:null}var s;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},S=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends P.Disposable{constructor(v,k=null,O=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=v,this._logger=k,this._uriTransformer=O,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let U=0,F=R.ProxyIdentifier.count;U<F;U++)this._locals[U]=null,this._proxies[U]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(U=>this._receiveOneMessage(U))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(v=>{this._pendingRPCReplies[v].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(v){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(v){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(v){this._responsiveState!==v&&(this._responsiveState=v,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(v){return this._uriTransformer?(0,C.transformIncomingURIs)(v,this._uriTransformer):v}getProxy(v){const{nid:k,sid:O}=v;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,O)),this._proxies[k]}_createProxy(v,k){let O={get:(U,F)=>(typeof F=="string"&&!U[F]&&F.charCodeAt(0)===36&&(U[F]=(...M)=>this._remoteCall(v,F,M)),F===r?k:U[F])};return new Proxy(Object.create(null),O)}set(v,k){return this._locals[v.nid]=k,k}assertRegistered(v){for(let k=0,O=v.length;k<O;k++){const U=v[k];if(!this._locals[U.nid])throw new Error(`Missing actor ${U.sid} (isMain: ${U.isMain})`)}}_receiveOneMessage(v){if(this._isDisposed)return;const k=v.byteLength,O=n.read(v,0),U=O.readUInt8(),F=O.readUInt32();switch(U){case 1:case 2:{let{rpcId:M,method:V,args:$}=c.deserializeRequestJSONArgs(O);this._uriTransformer&&($=(0,C.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(k,F,M,V,$,U===2);break}case 3:case 4:{let{rpcId:M,method:V,args:$}=c.deserializeRequestMixedArgs(O);this._uriTransformer&&($=(0,C.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(k,F,M,V,$,U===4);break}case 5:{this._logger&&this._logger.logIncoming(k,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(k,F);break}case 7:{this._receiveReply(k,F,void 0);break}case 9:{let M=c.deserializeReplyOKJSON(O);this._uriTransformer&&(M=(0,C.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(k,F,M);break}case 10:{const M=c.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(k,F,M);break}case 8:{let M=c.deserializeReplyOKVSBuffer(O);this._receiveReply(k,F,M);break}case 11:{let M=c.deserializeReplyErrError(O);this._uriTransformer&&(M=(0,C.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(k,F,M);break}case 12:{this._receiveReplyErr(k,F,void 0);break}default:console.error("received unexpected message"),console.error(v)}}_receiveRequest(v,k,O,U,F,M){this._logger&&this._logger.logIncoming(v,k,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(O)}.${U}(`,F);const V=String(k);let $,N;if(M){const x=new I.CancellationTokenSource;F.push(x.token),$=this._invokeHandler(O,U,F),N=()=>x.cancel()}else $=this._invokeHandler(O,U,F),N=o;this._cancelInvokedHandlers[V]=N;const B=c.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(B.byteLength,k,1,"ack"),this._protocol.send(B),$.then(x=>{delete this._cancelInvokedHandlers[V];const z=c.serializeReplyOK(k,x,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,k,1,"reply:",x),this._protocol.send(z)},x=>{delete this._cancelInvokedHandlers[V];const z=c.serializeReplyErr(k,x);this._logger&&this._logger.logOutgoing(z.byteLength,k,1,"replyErr:",x),this._protocol.send(z)})}_receiveCancel(v,k){this._logger&&this._logger.logIncoming(v,k,1,"receiveCancel");const O=String(k);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(v,k,O){this._logger&&this._logger.logIncoming(v,k,0,"receiveReply:",O);const U=String(k);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const F=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U],F.resolveOk(O)}_receiveReplyErr(v,k,O){this._logger&&this._logger.logIncoming(v,k,0,"receiveReplyErr:",O);const U=String(k);if(!this._pendingRPCReplies.hasOwnProperty(U))return;const F=this._pendingRPCReplies[U];delete this._pendingRPCReplies[U];let M;O&&(O.$isError?(M=new Error,M.name=O.name,M.message=O.message,M.stack=O.stack):M=O),F.resolveErr(M)}_invokeHandler(v,k,O){try{return Promise.resolve(this._doInvokeHandler(v,k,O))}catch(U){return Promise.reject(U)}}_doInvokeHandler(v,k,O){const U=this._locals[v];if(!U)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(v));let F=U[k];if(typeof F!="function")throw new Error("Unknown method "+k+" on actor "+(0,R.getStringIdentifierForProxy)(v));return F.apply(U,O)}_remoteCall(v,k,O){if(this._isDisposed)return Promise.reject(D.canceled());let U=null;if(O.length>0&&I.CancellationToken.isCancellationToken(O[O.length-1])&&(U=O.pop()),U&&U.isCancellationRequested)return Promise.reject(D.canceled());const F=c.serializeRequestArguments(O,this._uriReplacer),M=++this._lastMessageId,V=String(M),$=new A.LazyPromise;U&&U.onCancellationRequested(()=>{const B=c.serializeCancel(M);this._logger&&this._logger.logOutgoing(B.byteLength,M,0,"cancel"),this._protocol.send(c.serializeCancel(M))}),this._pendingRPCReplies[V]=$,this._onWillSendRequest(M);const N=c.serializeRequest(M,v,k,F,!!U);return this._logger&&this._logger.logOutgoing(N.byteLength,M,0,`request: ${(0,R.getStringIdentifierForProxy)(v)}.${k}(`,O),this._protocol.send(N),$}}e.RPCProtocol=i,y=S,i.UNRESPONSIVE_TIME=3*1e3;class n{constructor(v,k){this._buff=v,this._offset=k}static alloc(v,k,O){let U=new n(t.VSBuffer.alloc(O+1+4),0);return U.writeUInt8(v),U.writeUInt32(k),U}static read(v,k){return new n(v,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(v){this._buff.writeUInt8(v,this._offset),this._offset+=1}readUInt8(){const v=this._buff.readUInt8(this._offset);return this._offset+=1,v}writeUInt32(v){this._buff.writeUInt32BE(v,this._offset),this._offset+=4}readUInt32(){const v=this._buff.readUInt32BE(this._offset);return this._offset+=4,v}static sizeShortString(v){return 1+v.byteLength}writeShortString(v){this._buff.writeUInt8(v.byteLength,this._offset),this._offset+=1,this._buff.set(v,this._offset),this._offset+=v.byteLength}readShortString(){const v=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,O}static sizeLongString(v){return 4+v.byteLength}writeLongString(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readLongString(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,O}writeBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}static sizeVSBuffer(v){return 4+v.byteLength}writeVSBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readVSBuffer(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+v);return this._offset+=v,k}static sizeMixedArray(v){let k=0;k+=1;for(let O=0,U=v.length;O<U;O++){const F=v[O];switch(k+=1,F.type){case 1:k+=this.sizeLongString(F.value);break;case 2:k+=this.sizeVSBuffer(F.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(F.value);for(let M=0;M<F.buffers.length;++M)k+=this.sizeVSBuffer(F.buffers[M]);break;case 4:break}}return k}writeMixedArray(v){this._buff.writeUInt8(v.length,this._offset),this._offset+=1;for(let k=0,O=v.length;k<O;k++){const U=v[k];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let F=0;F<U.buffers.length;++F)this.writeBuffer(U.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const v=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(v);for(let O=0;O<v;O++)switch(this.readUInt8()){case 1:k[O]=this.readLongString();break;case 2:k[O]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),M=this.readLongString(),V=[];for(let $=0;$<F;++$)V.push(this.readVSBuffer());k[O]=new R.SerializableObjectWithBuffers(L(M,V,null));break}case 4:k[O]=void 0;break}return k}}n.sizeUInt32=4;var u;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(u||(u={}));class c{static _useMixedArgSerialization(v){for(let k=0,O=v.length;k<O;k++)if(v[k]instanceof t.VSBuffer||v[k]instanceof R.SerializableObjectWithBuffers||typeof v[k]=="undefined")return!0;return!1}static serializeRequestArguments(v,k){if(this._useMixedArgSerialization(v)){const O=[];for(let U=0,F=v.length;U<F;U++){const M=v[U];if(M instanceof t.VSBuffer)O[U]={type:2,value:M};else if(typeof M=="undefined")O[U]={type:4};else if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:$}=E(M.value,k);O[U]={type:3,value:t.VSBuffer.fromString(V),buffers:$}}else O[U]={type:1,value:t.VSBuffer.fromString(_(M,k))}}return{type:1,args:O}}return{type:0,args:_(v,k)}}static serializeRequest(v,k,O,U,F){switch(U.type){case 0:return this._requestJSONArgs(v,k,O,U.args,F);case 1:return this._requestMixedArgs(v,k,O,U.args,F)}}static _requestJSONArgs(v,k,O,U,F){const M=t.VSBuffer.fromString(O),V=t.VSBuffer.fromString(U);let $=0;$+=n.sizeUInt8(),$+=n.sizeShortString(M),$+=n.sizeLongString(V);let N=n.alloc(F?2:1,v,$);return N.writeUInt8(k),N.writeShortString(M),N.writeLongString(V),N.buffer}static deserializeRequestJSONArgs(v){const k=v.readUInt8(),O=v.readShortString(),U=v.readLongString();return{rpcId:k,method:O,args:JSON.parse(U)}}static _requestMixedArgs(v,k,O,U,F){const M=t.VSBuffer.fromString(O);let V=0;V+=n.sizeUInt8(),V+=n.sizeShortString(M),V+=n.sizeMixedArray(U);let $=n.alloc(F?4:3,v,V);return $.writeUInt8(k),$.writeShortString(M),$.writeMixedArray(U),$.buffer}static deserializeRequestMixedArgs(v){const k=v.readUInt8(),O=v.readShortString(),U=v.readMixedArray(),F=new Array(U.length);for(let M=0,V=U.length;M<V;M++){const $=U[M];typeof $=="string"?F[M]=JSON.parse($):F[M]=$}return{rpcId:k,method:O,args:F}}static serializeAcknowledged(v){return n.alloc(5,v,0).buffer}static serializeCancel(v){return n.alloc(6,v,0).buffer}static serializeReplyOK(v,k,O){if(typeof k=="undefined")return this._serializeReplyOKEmpty(v);if(k instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(v,k);if(k instanceof R.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:F}=E(k.value,O,!0);return this._serializeReplyOKJSONWithBuffers(v,U,F)}else return this._serializeReplyOKJSON(v,l(k,O))}static _serializeReplyOKEmpty(v){return n.alloc(7,v,0).buffer}static _serializeReplyOKVSBuffer(v,k){let O=0;O+=n.sizeVSBuffer(k);let U=n.alloc(8,v,O);return U.writeVSBuffer(k),U.buffer}static deserializeReplyOKVSBuffer(v){return v.readVSBuffer()}static _serializeReplyOKJSON(v,k){const O=t.VSBuffer.fromString(k);let U=0;U+=n.sizeLongString(O);let F=n.alloc(9,v,U);return F.writeLongString(O),F.buffer}static _serializeReplyOKJSONWithBuffers(v,k,O){const U=t.VSBuffer.fromString(k);let F=0;F+=n.sizeUInt32,F+=n.sizeLongString(U);for(const V of O)F+=n.sizeVSBuffer(V);let M=n.alloc(10,v,F);M.writeUInt32(O.length),M.writeLongString(U);for(const V of O)M.writeBuffer(V);return M.buffer}static deserializeReplyOKJSON(v){const k=v.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(v,k){const O=v.readUInt32(),U=v.readLongString(),F=[];for(let M=0;M<O;++M)F.push(v.readVSBuffer());return new R.SerializableObjectWithBuffers(L(U,F,k))}static serializeReplyErr(v,k){return k?this._serializeReplyErrEror(v,k):this._serializeReplyErrEmpty(v)}static _serializeReplyErrEror(v,k){const O=t.VSBuffer.fromString(l(D.transformErrorForSerialization(k),null));let U=0;U+=n.sizeLongString(O);let F=n.alloc(11,v,U);return F.writeLongString(O),F.buffer}static deserializeReplyErrError(v){const k=v.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(v){return n.alloc(12,v,0).buffer}}var d;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var h;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(h||(h={}))}),define(pe[264],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(pe[265],ve([0,1,29,10,9,12,23,2,4,63,43,221,264]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let b=class qi{constructor(g,E,L,_){this.localUserHome=g,this.remoteAgentService=E,this.environmentService=L,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome||g})()}hasValidBasename(g,E,L){return typeof E=="string"||typeof E=="undefined"?this.resolveOS.then(_=>this.doHasValidBasename(g,_,E)):this.doHasValidBasename(g,E,L)}doHasValidBasename(g,E,L){return g.scheme===t.Schemas.file||g.scheme===t.Schemas.vscodeRemote?(0,f.isValidBasename)(L??(0,T.basename)(g),E===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,E){if(g.remoteAuthority)return t.Schemas.vscodeRemote;const L=(0,A.getVirtualWorkspaceScheme)(E.getWorkspace());if(L)return L;const _=E.getWorkspace().folders[0];if(_)return _.uri.scheme;const a=E.getWorkspace().configuration;return a?a.scheme:t.Schemas.file}async userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?I.win32:I.posix)}async fileURI(g){let E="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const _=g.indexOf("/",2);_===-1?(E=g.substring(2),g="/"):(E=g.substring(2,_),g=g.substring(_)||"/")}return P.URI.from({scheme:t.Schemas.file,authority:E,path:g,query:"",fragment:""})}};b=je([He(1,l.IRemoteAgentService),He(2,y.IWorkbenchEnvironmentService),He(3,R.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(pe[70],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(T,P){this.line=T,this.character=P}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,P){return new f(0,0)}with(T){return new f(0,0)}}e.Position=f;class t{constructor(T,P,C,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(T,P),this.end=new f(C,A)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new t(0,0,0,0)}with(T){return new t(0,0,0,0)}}e.Range=t;var I;(function(D){D[D.Information=1]="Information",D[D.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[31],ve([0,1,16,32,25,29,8,4,9,15,70,13]),function(Z,e,f,t,I,D,T,P,C,A,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",p=(l.length+b.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var g;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var E;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(E=e.QueryType||(e.QueryType={}));function L(B){return!!B.preview}e.resultIsMatch=L;function _(B){return!!B.resource}e.isFileMatch=_;function a(B){return!!B.message}e.isProgressMessage=a;var s;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=m;class o{constructor(x,z,W){this.ranges=z;const J=Array.isArray(z)?z:[z];if(W&&W.matchLines===1&&S(J)){x=(0,T.getNLines)(x,W.matchLines);let se="",ie=0,K=0;const Y=Math.floor(W.charsPerLine/5),le=[];for(const fe of J){const Se=Math.max(fe.startColumn-Y,0),Me=fe.startColumn+W.charsPerLine;if(Se>K+Y+p){const Ve=l+(Se-K)+b;se+=Ve+x.slice(Se,Me),ie+=Se-(K+Ve.length)}else se+=x.slice(K,Me);le.push(new i(0,fe.startColumn-ie,fe.endColumn-ie)),K=Me}this.preview={text:se,matches:Array.isArray(this.ranges)?le:le[0]}}else{const se=Array.isArray(z)?z[0].startLineNumber:z.startLineNumber;this.preview={text:x,matches:(0,f.mapArrayOrNot)(z,ie=>new r(ie.startLineNumber-se,ie.startColumn,ie.endLineNumber-se,ie.endColumn))}}}}e.TextSearchMatch=o;function S(B){const x=B[0].startLineNumber;for(const z of B)if(z.startLineNumber!==x||z.endLineNumber!==x)return!1;return!0}class r{constructor(x,z,W,J){this.startLineNumber=x,this.startColumn=z,this.endLineNumber=W,this.endColumn=J}}e.SearchRange=r;class i extends r{constructor(x,z,W){super(x,z,x,W)}}e.OneLineRange=i;var n;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function u(B,x=!0){const z=B&&B.files&&B.files.exclude,W=x&&B&&B.search&&B.search.exclude;if(!z&&!W)return;if(!z||!W)return z||W;let J=Object.create(null);return J=I.mixin(J,I.deepClone(z)),J=I.mixin(J,I.deepClone(W),!0),J}e.getExcludes=u;function c(B,x){return B.excludePattern&&t.match(B.excludePattern,x)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&t.match(B.includePattern,x)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(z=>{const W=z.folder.fsPath;if(D.isEqualOrParent(x,W)){const J=C.relative(W,x);return!z.includePattern||!!t.match(z.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var d;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(x,z){super(x);this.code=z}}e.SearchError=h;function w(B){const x=B.message;if((0,A.isCancellationError)(B))return new h(x,d.canceled);try{const z=JSON.parse(x);return new h(z.message,z.code)}catch{return new h(x,d.other)}}e.deserializeSearchError=w;function v(B){const x={message:B.message,code:B.code};return new Error(JSON.stringify(x))}e.serializeSearchError=v;function k(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=k;function O(B){return B.type==="success"}e.isSerializedSearchSuccess=O;function U(B){return!!B.path}e.isSerializedFileMatch=U;function F(B,x){const z=B.searchPath?B.searchPath:B.relativePath;return(0,T.fuzzyContains)(z,x)}e.isFilePatternMatch=F;class M{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function V(B,x){const z={...B||{},...x||{}};return Object.keys(z).filter(W=>{const J=z[W];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=V;class ${constructor(x,z){this._parsedIncludeExpression=null,this._excludeExpression={...x.excludePattern||{},...z.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let W=x.includePattern;z.includePattern&&(W?W={...W,...z.includePattern}:W=z.includePattern),W&&(this._parsedIncludeExpression=t.parse(W))}matchesExcludesSync(x,z,W){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,z,W))}includedInQuerySync(x,z,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,z,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,z,W))}includedInQuery(x,z,W){const J=this._parsedExcludeExpression(x,z,W),se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(x,z,W):!0;return(0,y.isPromise)(J)?J.then(ie=>ie?!1:se()):se()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=$;function N(B){for(const x in B)if(typeof B[x]!="boolean")return!0;return!1}}),define(pe[35],ve([0,1,16,17,21,3,24,10,94,23,8,13,2,169,4,11,189,43,44,26,14,7,31,5]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a,s,m,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(v,k,O){return new A.ExtUri(U=>c(U,O)).isEqual(v,k)}function i(v,k,O){return r(v.uri,k.uri,O)?0:(0,R.compare)(v.uri.toString(),k.uri.toString())}function n(v,k,O){return v.index!==k.index?v.index<k.index?-1:1:r(v.uri,k.uri,O)?(0,R.compare)(v.name,k.name):(0,R.compare)(v.uri.toString(),k.uri.toString())}function u(v,k,O,U){const F=v.slice(0).sort((V,$)=>O(V,$,U)),M=k.slice(0).sort((V,$)=>O(V,$,U));return(0,f.delta)(F,M,(V,$)=>O(V,$,U))}function c(v,k){const O=k.getCapabilities(v.scheme);return!(O&&O&1024)}class d extends L.Workspace{constructor(k,O,U,F,M,V,$){super(k,U.map(N=>new L.WorkspaceFolder(N)),F,M,$);this._name=O,this._isUntitled=V,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris($),U.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(k,O,U,F){if(!k)return{workspace:null,added:[],removed:[]};const{id:M,name:V,folders:$,configuration:N,transient:B,isUntitled:x}=k,z=[],W=O;O?$.forEach((K,Y)=>{const le=l.URI.revive(K.uri),fe=d._findFolder(U||O,le,F);fe?(fe.name=K.name,fe.index=K.index,z.push(fe)):z.push({uri:le,name:K.name,index:Y})}):z.push(...$.map(({uri:K,name:Y,index:le})=>({uri:l.URI.revive(K),name:Y,index:le}))),z.sort((K,Y)=>K.index<Y.index?-1:1);const J=new d(M,V,z,!!B,N?l.URI.revive(N):null,!!x,K=>c(K,F)),{added:se,removed:ie}=u(W?W.workspaceFolders:[],J.workspaceFolders,i,F);return{workspace:J,added:se,removed:ie}}static _findFolder(k,O,U){for(let F=0;F<k.folders.length;F++){const M=k.workspaceFolders[F];if(r(M.uri,O,U))return M}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(k,O){return O&&this._structure.get(k)&&(k=(0,A.dirname)(k)),this._structure.findSubstr(k)}resolveWorkspaceFolder(k){return this._structure.get(k)}}let h=class{constructor(k,O,U,F){this._onDidChangeWorkspace=new D.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new D.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=U,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=k.getProxy(S.MainContext.MainThreadWorkspace),this._messageService=k.getProxy(S.MainContext.MainThreadMessageService);const M=O.workspace;this._confirmedWorkspace=M?new d(M.id,M.name,[],!!M.transient,M.configuration?l.URI.revive(M.configuration):null,!!M.isUntitled,V=>c(V,U)):void 0}$initializeWorkspace(k,O){this._trusted=O,this.$acceptWorkspaceData(k),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:P.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(k,O,U,...F){const M=[];if(Array.isArray(F)&&F.forEach(x=>{l.URI.isUri(x.uri)&&!M.some(z=>r(z.uri,x.uri,this._extHostFileSystemInfo))&&M.push({uri:x.uri,name:x.name||(0,A.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[O,U].some(x=>typeof x!="number"||x<0)||U===0&&M.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(O+U>V.length)return!1;const $=V.slice(0);$.splice(O,U,...M.map(x=>({uri:x.uri,name:x.name||(0,A.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<$.length;x++){const z=$[x];if($.some((W,J)=>J!==x&&r(z.uri,W.uri,this._extHostFileSystemInfo)))return!1}$.forEach((x,z)=>x.index=z);const{added:N,removed:B}=u(V,$,n,this._extHostFileSystemInfo);if(N.length===0&&B.length===0)return!1;if(this._proxy){const x=k.displayName||k.name;this._proxy.$updateWorkspaceFolders(x,O,U,M).then(void 0,z=>{this._unconfirmedWorkspace=void 0;const W={source:{identifier:k.identifier,label:k.displayName||k.name}};this._messageService.$showMessage(E.Severity.Error,(0,b.localize)(0,null,x,z.toString()),W,[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(k,O){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(k,O)}async getWorkspaceFolder2(k,O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(k,O)}async resolveWorkspaceFolder(k){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(k)}getPath(){if(!this._actualWorkspace)return;const{folders:k}=this._actualWorkspace;if(k.length!==0)return k[0].uri.fsPath}getRelativePath(k,O){let U,F="";if(typeof k=="string"?(U=l.URI.file(k),F=k):typeof k!="undefined"&&(U=k,F=k.fsPath),!U)return F;const M=this.getWorkspaceFolder(U,!0);if(!M)return F;typeof O=="undefined"&&this._actualWorkspace&&(O=this._actualWorkspace.folders.length>1);let V=(0,A.relativePath)(M.uri,U);return O&&M.name&&(V=`${M.name}/${V}`),V}trySetWorkspaceFolders(k){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:k,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(k){const{workspace:O,added:U,removed:F}=d.toExtHostWorkspace(k,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=O||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:F}))}findFiles(k,O,U,F,M=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let V;if(O===null?V=!1:O&&(typeof O=="string"?V=O:V=O.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:N}=w(k);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)($),(0,y.withUndefinedAsNull)(N),(0,y.withUndefinedAsNull)(V),(0,y.withUndefinedAsNull)(U),M).then(B=>Array.isArray(B)?B.map(x=>l.URI.revive(x)):[])}async findTextInFiles(k,O,U,F,M=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),$=typeof O.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:N,folder:B}=w(O.include),x=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,z={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:$,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:N,excludePattern:x},W=!1;if(this._activeSearchCallbacks[V]=J=>{if(W)return;const se=l.URI.revive(J.resource);J.results.forEach(ie=>{(0,o.resultIsMatch)(ie)?U({uri:se,preview:{text:ie.preview.text,matches:(0,f.mapArrayOrNot)(ie.preview.matches,K=>new m.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))},ranges:(0,f.mapArrayOrNot)(ie.ranges,K=>new m.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))}):U({uri:se,text:ie.text,lineNumber:ie.lineNumber})})},M.isCancellationRequested)return{};try{const J=await this._proxy.$startTextSearch(k,(0,y.withUndefinedAsNull)(B),z,V,M);return delete this._activeSearchCallbacks[V],J||{}}catch(J){throw delete this._activeSearchCallbacks[V],J}}$handleTextSearchResult(k,O){this._activeSearchCallbacks[O]&&this._activeSearchCallbacks[O](k)}saveAll(k){return this._proxy.$saveAll(k)}resolveProxy(k){return this._proxy.$resolveProxy(k)}get trusted(){return this._trusted}requestWorkspaceTrust(k){return this._proxy.$requestWorkspaceTrust(k)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=je([He(0,s.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,_.IExtHostFileSystemInfo),He(3,g.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function w(v){let k,O;return v&&(typeof v=="string"?k=v:(k=v.pattern,O=v.baseUri)),{includePattern:k,folder:O}}}),define(pe[36],ve([0,1,25,3,35,5,7,193,119,13,17,4,14,11,2]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(S,r){if(r){const i=r.split(".");let n=S;for(let u=0;n&&u<i.length;u++)n=n[i[u]];return n}}function E(S){return S instanceof p.URI}function L(S){return S&&S.uri instanceof p.URI&&S.languageId&&typeof S.languageId=="string"}function _(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function a(S){return S&&S.uri instanceof p.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function s(S){if(E(S))return{resource:S};if(L(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(_(S))return{overrideIdentifier:S.languageId};if(a(S))return{resource:S.uri};if(S===null)return{resource:null}}let m=class{constructor(r,i,n){this._proxy=r.getProxy(D.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=n,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new o(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,i))}};m=je([He(0,l.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,b.ILogService)],m),e.ExtHostConfiguration=m;class o{constructor(r,i,n,u){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=u,this._extHostWorkspace=i,this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,n))}getConfiguration(r,i,n){const u=s(i)||{},c=this._toReadonlyValue(r?g(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,u,n?.identifier);function d(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(w){return typeof g(c,w)!="undefined"},get:(w,v)=>{this._validateConfigurationAccess(r?`${r}.${w}`:w,u,n?.identifier);let k=g(c,w);if(typeof k=="undefined")k=v;else{let O;const U=(F,M)=>{let V;const $=()=>{O=O||(0,f.deepClone)(c),V=V||g(O,M)};return(0,A.isObject)(F)?new Proxy(F,{get:(N,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return $(),()=>V;if(O)return V=V||g(O,M),V[B];const x=N[B];return typeof B=="string"?U(x,`${M}.${B}`):x},set:(N,B,x)=>($(),V&&(V[B]=x),!0),deleteProperty:(N,B)=>($(),V&&delete V[B],!0),defineProperty:(N,B,x)=>($(),V&&Object.defineProperty(V,B,x),!0)}):F};k=U(k,w)}return k},update:(w,v,k,O)=>{w=r?`${r}.${w}`:w;const U=d(k);return v!==void 0?this._proxy.$updateConfigurationOption(U,w,v,u,O):this._proxy.$removeConfigurationOption(U,w,u,O)},inspect:w=>{w=r?`${r}.${w}`:w;const v=(0,f.deepClone)(this._configuration.inspect(w,u,this._extHostWorkspace.workspace));if(v)return{key:w,defaultValue:v.default?.value,globalValue:v.user?.value,workspaceValue:v.workspace?.value,workspaceFolderValue:v.workspaceFolder?.value,defaultLanguageValue:v.default?.override,globalLanguageValue:v.user?.override,workspaceLanguageValue:v.workspace?.override,workspaceFolderLanguageValue:v.workspaceFolder?.override,languageIds:v.overrideIdentifiers}}};return typeof c=="object"&&(0,f.mixin)(h,c,!1),Object.freeze(h)}_toReadonlyValue(r){const i=n=>(0,A.isObject)(n)?new Proxy(n,{get:(u,c)=>i(u[c]),set:(u,c,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(u,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(u,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return i(r)}_validateConfigurationAccess(r,i,n){const u=C.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=n?`[${n.value}] `:"";if(u===4){typeof i?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const n=new P.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,c)=>n.affectsConfiguration(u,s(c))})}_toMap(r){return r.reduce((i,n)=>(i.set(n[0],n[1]),i),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[71],ve([0,1,2,17,3,5,7,35,45,36,21,34,14,26,4,10,12,11,66,213,15]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a,s){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(M){function V(N){if(N!=null)return N}M.from=V;function $(N){if(N!=null)return N}M.to=$})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(M){function V(N){if(N!=null)return N}M.from=V;function $(N){if(N!=null)return N}M.to=$})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(M){function V(N){if(N!=null)return N}M.from=V;function $(N){if(N!=null)return N}M.to=$})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(M){function V(B){if(B){const x=B;return x&&!!x.process}else return!1}M.is=V;function $(B){if(B==null)return;const x={process:B.process,args:B.args};return B.options&&(x.options=r.from(B.options)),x}M.from=$;function N(B){if(B!=null)return new T.ProcessExecution(B.process,B.args,B.options)}M.to=N})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(M){function V(N){if(N!=null)return N}M.from=V;function $(N){if(N!=null)return N}M.to=$})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(M){function V(B){if(B){const x=B;return x&&(!!x.commandLine||!!x.command)}else return!1}M.is=V;function $(B){if(B==null)return;const x={};return B.commandLine!==void 0?x.commandLine=B.commandLine:(x.command=B.command,x.args=B.args),B.options&&(x.options=n.from(B.options)),x}M.from=$;function N(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new T.ShellExecution(B.commandLine,B.options):new T.ShellExecution(B.command,B.args?B.args:[],B.options)}M.to=N})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(M){function V(B){if(B){let x=B;return x&&x.customExecution==="customExecution"}else return!1}M.is=V;function $(B){return{customExecution:"customExecution"}}M.from=$;function N(B,x){return x.get(B)}M.to=N})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(M){function V($,N){let B;return $.scope!==void 0&&typeof $.scope!="number"?B=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===T.TaskScope.Workspace&&N&&N.workspaceFile?B=N.workspaceFile:B=a.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:B}}M.from=V})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(M){function V($){if($!=null)return{_id:$.id,isDefault:$.isDefault}}M.from=V})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(M){function V(B,x){if(B==null)return[];const z=[];for(let W of B){const J=$(W,x);J&&z.push(J)}return z}M.fromMany=V;function $(B,x){if(B==null)return;let z;B.execution instanceof T.ProcessExecution?z=i.from(B.execution):B.execution instanceof T.ShellExecution?z=u.from(B.execution):B.execution&&B.execution instanceof T.CustomExecution&&(z=c.from(B.execution));const W=o.from(B.definition);let J;return B.scope?typeof B.scope=="number"?J=B.scope:J=B.scope.uri:J=T.TaskScope.Workspace,!W||!J?void 0:{_id:B._id,definition:W,name:B.name,source:{extensionId:x.identifier.value,label:B.source,scope:J},execution:z,isBackground:B.isBackground,group:h.from(B.group),presentationOptions:S.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}M.from=$;async function N(B,x,z){if(B==null)return;let W;i.is(B.execution)?W=i.to(B.execution):u.is(B.execution)?W=u.to(B.execution):c.is(B.execution)&&(W=c.to(B._id,z));const J=o.to(B.definition);let se;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?se=B.source.scope:se=await x.resolveWorkspaceFolder(f.URI.revive(B.source.scope)):se=T.TaskScope.Workspace),!J||!se)return;const ie=new T.Task(J,se,B.name,B.source.label,W,B.problemMatchers);return B.isBackground!==void 0&&(ie.isBackground=B.isBackground),B.group!==void 0&&(ie.group=T.TaskGroup.from(B.group._id),ie.group&&B.group.isDefault&&(ie.group=new T.TaskGroup(ie.group.id,ie.group.label),B.group.isDefault&&(ie.group.isDefault=B.group.isDefault))),B.presentationOptions&&(ie.presentationOptions=S.to(B.presentationOptions)),B._id&&(ie._id=B._id),B.detail&&(ie.detail=B.detail),ie}M.to=N})(w=e.TaskDTO||(e.TaskDTO={}));var v;(function(M){function V(N){return N}M.from=V;function $(N){if(!!N)return Object.assign(Object.create(null),N)}M.to=$})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(V,$,N){this._id=$,this._task=N,m.set(this,void 0),nt(this,m,V,"f")}get task(){return this._task}terminate(){Le(this,m,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}m=new WeakMap;var O;(function(M){function V($){return{id:$._id,task:void 0}}M.from=V})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let U=class{constructor(V,$,N,B,x,z,W,J){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=V.getProxy(D.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=B,this._configurationService=x,this._terminalService=z,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,$,N){if(!N)return new T.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:$,provider:N,extension:V}),this._proxy.$registerTaskProvider(B,$),new T.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(V,$){this._proxy.$registerTaskSystem(V,$)}fetchTasks(V){return this._proxy.$fetchTasks(v.from(V)).then(async $=>{const N=[];for(let B of $){const x=await w.to(B,this._workspaceProvider,this._providedCustomExecutions2);x&&N.push(x)}return N})}get taskExecutions(){const V=[];return this._taskExecutions.forEach($=>V.push($)),V}terminateTask(V){if(!(V instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,$,N){const B=this._providedCustomExecutions2.get(V.id);B&&(this._activeCustomExecutions2.set(V.id,B),this._terminalService.attachPtyToTerminal($,await B.callback(N))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const $=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const $=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:$,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const $=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:V.exitCode})}$provideTasks(V,$){const N=this._handlers.get(V);if(!N)return Promise.reject(new Error("no handler found"));const B=[],x=(0,t.asPromise)(()=>N.provider.provideTasks(R.CancellationToken.None)).then(z=>this.provideTasksInternal($,B,N,z));return new Promise(z=>{x.then(W=>{Promise.all(B).then(()=>{z(W)})})})}async $resolveTask(V,$){const N=this._handlers.get(V);if(!N)return Promise.reject(new Error("no handler found"));if($.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${N.type}].`);const B=await w.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const x=await N.provider.resolveTask(B,R.CancellationToken.None);if(!x)return;this.checkDeprecation(x,N);const z=w.from(x,N.extension);if(!z)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(z.execution)&&await this.addCustomExecution(z,x,!0),await this.resolveTaskInternal(z)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,$,N){const B=await this._proxy.$createTaskId(V);!N&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,$.execution)),this._providedCustomExecutions2.set(B,$.execution)}async getTaskExecution(V,$){if(typeof V=="string"){const x=this._taskExecutionPromises.get(V);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let N=this._taskExecutionPromises.get(V.id);if(N)return N;const B=new Promise((x,z)=>{function W(J,se,ie){ie?x(new k(J,se.id,ie)):z("Unexpected: Task does not exist.")}$?W(this,V,$):w.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(J=>W(this,V,J))});return this._taskExecutionPromises.set(V.id,B),B.then(x=>(this._taskExecutions.set(V.id,x),x),x=>Promise.reject(x))}checkDeprecation(V,$){V._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let N=this._notProvidedCustomExecutions.values(),B=N.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=N.next()}};U=je([He(0,l.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,L.ILogService),He(7,_.IExtHostApiDeprecationService)],U),e.ExtHostTaskBase=U;let F=class extends U{constructor(V,$,N,B,x,z,W,J){super(V,$,N,B,x,z,W,J);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(V,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const N=w.from($,V);if(N===void 0)throw new Error("Task is not valid");if(c.is(N.execution))await this.addCustomExecution(N,$,!1);else throw new s.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),$);return this._proxy.$executeTask(N).catch(x=>{throw new Error(x)}),B}provideTasksInternal(V,$,N,B){const x=[];if(B)for(let z of B){this.checkDeprecation(z,N),(!z.definition||!V[z.definition.type])&&this._logService.warn(`The task [${z.source}, ${z.name}] uses an undefined task type. The task will be ignored in the future.`);const W=w.from(z,N.extension);W&&c.is(W.execution)?(x.push(W),$.push(this.addCustomExecution(W,z,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:N.extension}}async resolveTaskInternal(V){if(c.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,$){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,$,N){}};F=je([He(0,l.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,P.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,L.ILogService),He(7,_.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(pe[266],ve([0,1,16,75,32,80,24,10,9,23,8,13,2,149,175,116,43,128,265,31]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(d,h,w,v){this.configurationService=d,this.workspaceContextService=h,this.editorGroupsService=w,this.pathService=v}text(d,h,w={}){d=this.getContentPattern(d,w);const v=this.configurationService.getValue(),k=h&&h.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(h?.map(E.toWorkspaceFolder),w),type:2,contentPattern:d,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:v.search.usePCRE2||k||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}getContentPattern(d,h){const w=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const v={...d,wordSeparators:w.editor.wordSeparators};return this.isCaseSensitive(d,h)&&(v.isCaseSensitive=!0),this.isMultiline(d)&&(v.isMultiline=!0),v}file(d,h={}){return{...this.commonQuery(d,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}handleIncludeExclude(d,h){return d?(d=Array.isArray(d)?d.map(i):i(d),h?this.parseSearchPaths(d):{pattern:o(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],h={}){const w=this.handleIncludeExclude(h.includePattern,h.expandPatterns),v=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),k=d.length>1,O=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,h,v)):d.map(M=>this.getFolderQueryForRoot(M,h,v,k))).filter(M=>!!M),U={_reason:h._reason,folderQueries:O,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:v.pattern,includePattern:w.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const V=f.coalesce(f.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(B=>B.resource)))).filter(N=>(0,a.pathIncludedInQuery)(U,N.fsPath)),$=this.commonQueryFromFileList(V);return{...U,...$}}const F=h.extraFileResources&&h.extraFileResources.filter(M=>(0,a.pathIncludedInQuery)(U,M.fsPath));return U.extraFileResources=F&&F.length?F:void 0,U}commonQueryFromFileList(d){const h=[],w=new T.ResourceMap,v={};let k=!1;return d.forEach(O=>{if(O.scheme===P.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(O)){const F=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:C.dirname(O.fsPath)});let M=w.get(F);M||(k=!0,M={folder:F,includePattern:{}},h.push(M),w.set(F,M));const V=C.relative(F.fsPath,O.fsPath);(0,y.assertIsDefined)(M.includePattern)[V.replace(/\\/g,"/")]=!0}else O.fsPath&&(k=!0,v[O.fsPath]=!0)}),{folderQueries:h,includePattern:v,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(d,h){if(h.isSmartCase){if(d.isRegExp){if(R.containsUppercaseCharacter(d.pattern,!0))return!0}else if(R.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,b.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const h=$=>C.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),v=(Array.isArray(d)?d:S(d)).map($=>{const N=this.pathService.resolvedUserHome;return N?(0,D.untildify)($,N.scheme===P.Schemas.file?N.fsPath:N.path):$}),k=t.groupBy(v,$=>h($)?"searchPaths":"exprSegments"),O=(k.exprSegments||[]).map($=>R.rtrim($,"/")).map($=>R.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),r($))),U={},F=this.expandSearchPathPatterns(k.searchPaths||[]);F&&F.length&&(U.searchPaths=F);const M=f.flatten(O),V=o(...M);return V&&(U.pattern=V),U}getExcludesForFolder(d,h){return h.disregardExcludeSettings?void 0:(0,a.getExcludes)(d,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const h=f.flatten(d.map(v=>{let{pathPortion:k,globPortion:O}=m(v);O&&(O=n(O));const U=this.expandOneSearchPath(k);return f.flatten(U.map(F=>this.resolveOneSearchPathPattern(F,O)))})),w=new Map;return h.forEach(v=>{const k=v.searchPath.toString(),O=w.get(k);O?v.pattern&&(O.pattern=O.pattern||{},O.pattern[v.pattern]=!0):w.set(k,{searchPath:v.searchPath,pattern:v.pattern?o(v.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(d){if(C.isAbsolute(d)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==P.Schemas.file?[{searchPath:h[0].uri.with({path:d})}]:[{searchPath:l.URI.file(C.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=i(d),d.startsWith("../")||d===".."){const v=C.posix.resolve(h.path,d);return[{searchPath:h.with({path:v})}]}const w=n(d);return[{searchPath:h,pattern:w}]}else{if(d==="./"||d===".\\")return[];{const h=d.replace(/^\.[\/\\]/,""),v=this.workspaceContextService.getWorkspace().folders.map(k=>{const O=h.match(new RegExp(`^${R.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return O?{match:O,folder:k}:null}).filter(y.isDefined);if(v.length)return v.map(k=>{const O=k.match[1];return{searchPath:k.folder.uri,pattern:O&&n(O)}});{const k=d.match(/\.[\/\\](.+)[\/\\]?/),O=k?k[1]:d,U=p.localize(0,null,O);throw new Error(U)}}}}resolveOneSearchPathPattern(d,h){const w=d.pattern&&h?`${d.pattern}/${h}`:d.pattern||h,v=[{searchPath:d.searchPath,pattern:w}];return w&&!w.endsWith("**")&&v.push({searchPath:d.searchPath,pattern:w+"/**"}),v}getFolderQueryForSearchPath(d,h,w){const v=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(d.searchPath),h,w,!1);return v?{...v,includePattern:d.pattern}:null}getFolderQueryForRoot(d,h,w,v){let k;const O=l.URI.isUri(d)?d:d.uri;if(w.searchPaths){const $=w.searchPaths.filter(N=>(0,A.isEqual)(N.searchPath,O))[0];if($&&!$.pattern)return null;$&&(k=$.pattern)}const U=this.configurationService.getValue({resource:O}),M={...this.getExcludesForFolder(U,h)||{},...k||{}},V=l.URI.isUri(d)?(0,A.basename)(d):d.name;return{folder:O,folderName:v?V:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!U.search.followSymlinks}}};s=je([He(0,g.IConfigurationService),He(1,E.IWorkspaceContextService),He(2,L.IEditorGroupsService),He(3,_.IPathService)],s),e.QueryBuilder=s;function m(c){const d=c.match(/[\*\{\}\(\)\[\]\?]/);if(d){const h=d.index,w=c.substr(0,h).match(/[/|\\][^/\\]*$/);if(w){let v=c.substr(0,w.index);return v.match(/[/\\]/)||(v+="/"),{pathPortion:v,globPortion:c.substr((w.index||0)+1)}}}return{pathPortion:c}}function o(...c){return c.length?c.reduce((d,h)=>(d[h]=!0,d),Object.create(null)):void 0}function S(c){return I.splitGlobAware(c,",").map(d=>d.trim()).filter(d=>!!d.length)}function r(c){return[`**/${c}/**`,`**/${c}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function i(c){return c.replace(/\\/g,"/")}function n(c){return i(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(c,d){c=f.distinct(c,v=>v.toString());const h=[],w=d.getWorkspace();return c&&c.forEach(v=>{let k;if(d.getWorkbenchState()===2)k=(0,A.relativePath)(w.folders[0].uri,v),k&&k!=="."&&(k="./"+k);else{const O=d.getWorkspaceFolder(v);if(O){const U=O.name;if(w.folders.filter(M=>M.name===U).length===1){const M=(0,A.relativePath)(O.uri,v);M===""?k=`./${O.name}`:k=`./${O.name}/${M}`}else k=v.fsPath}}k&&h.push(k)}),h}e.resolveResourcesForSearchIncludes=u}),define(pe[267],ve([0,1,23,2,21,15,4,266,31,43]),function(Z,e,f,t,I,D,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function y(g,E){const L=E.activationEvents;if(!L)return Promise.resolve(void 0);const _=[],a=[];for(const i of L)if(/^workspaceContains:/.test(i)){const n=i.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||g.forceUsingSearch?a.push(n):_.push(n)}if(_.length===0&&a.length===0)return Promise.resolve(void 0);let s;const m=new Promise((i,n)=>{s=i}),o=i=>s({activationEvent:i}),S=Promise.all(_.map(i=>l(g,i,o))).then(()=>{}),r=b(g,E.identifier,a,o);return Promise.all([S,r]).then(()=>{s(void 0)}),m}e.checkActivateWorkspaceContainsExtension=y;async function l(g,E,L){for(const _ of g.folders)if(await g.exists(f.joinPath(t.URI.revive(_),E))){L(`workspaceContains:${E}`);return}}async function b(g,E,L,_){if(L.length===0)return Promise.resolve(void 0);const a=new I.CancellationTokenSource,s=g.checkExists(g.folders,L,a.token),m=setTimeout(async()=>{a.cancel(),g.logService.info(`Not activating extension '${E.value}': Timed out while searching for 'workspaceContains' pattern ${L.join(",")}`)},R);let o=!1;try{o=await s}catch(S){D.isCancellationError(S)||D.onUnexpectedError(S)}a.dispose(),clearTimeout(m),o&&_(`workspaceContains:${L.join(",")}`)}function p(g,E,L,_){const a=g.get(T.IInstantiationService),s=g.get(C.ISearchService),o=a.createInstance(P.QueryBuilder).file(E.map(S=>(0,A.toWorkspaceFolder)(t.URI.revive(S))),{_reason:"checkExists",includePattern:L,exists:!0});return s.fileSearch(o,_).then(S=>!!S.limitHit,S=>D.isCancellationError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!I:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(Z,f):I?I.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[39],ve([0,1,164,9,72,23,17,6,24,2,11,5,36,224,90,35,28,222,15,27,22,199,7,120,4,26,68,14,84,51,34,3,267,89,201,10]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a,s,m,o,S,r,i,n,u,c,d,h,w,v,k,O,U){"use strict";var F,M,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let $=class Gi extends P.Disposable{constructor(W,J,se,ie,K,Y,le,fe,Se,Me){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=J,this._extHostContext=se,this._initData=le,this._extHostWorkspace=ie,this._extHostConfiguration=K,this._logService=Y,this._extHostTunnelService=Se,this._extHostTerminalService=Me,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new L.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=fe,this._instaService=W.createChild(new c.ServiceCollection([p.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(Ge=>Ve.add(a.ExtensionIdentifier.toKey(Ge))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ge,Ye,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ge,_.transformErrorForSerialization(Ye),q)},actualActivateExtension:async(Ge,Ye)=>{if(Ve.has(a.ExtensionIdentifier.toKey(Ge)))return await this._mainThreadExtensionsProxy.$activateExtension(Ge,Ye),new b.HostExtension;const q=this._registry.getExtensionDescription(Ge);return this._activateExtension(q,Ye)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(W){_.onUnexpectedError(W)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let W=[];try{W=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch{}await Promise.all(W)}isActivated(W){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(W):!1}_activateByEvent(W,J){return this._activator.activateByEvent(W,J)}_activateById(W,J){return this._activator.activateById(W,J)}activateByIdWithErrors(W,J){return this._activateById(W,J).then(()=>{const se=this._activator.getActivatedExtension(W);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(W=>this._registry)}getExtensionExports(W){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(W).exports:null}async _realPathExtensionUri(W){if(W.scheme!==U.Schemas.file)return W;const J=await this._hostUtils.realpath(W.fsPath);return A.URI.file(J)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const W=C.TernarySearchTree.forUris(J=>D.extUriBiasedIgnorePathCase.ignorePathCasing(J));for(const J of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(J)){const se=await this._realPathExtensionUri(J.extensionLocation);W.set(se,J)}return W})()),this._extensionPathIndex}_deactivate(W){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(W))return J;const se=this._activator.getActivatedExtension(W);if(!se)return J;try{typeof se.module.deactivate=="function"&&(J=Promise.resolve(se.module.deactivate()).then(void 0,ie=>(this._logService.error(ie),Promise.resolve(void 0))))}catch(ie){this._logService.error(`An error occurred when deactivating the extension '${W.value}':`),this._logService.error(ie)}try{(0,P.dispose)(se.subscriptions)}catch(ie){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${W.value}':`),this._logService.error(ie)}return J}async _activateExtension(W,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(W.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(W.identifier),this._doActivateExtension(W,J).then(se=>{const ie=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(W.identifier,ie.codeLoadingTime,ie.activateCallTime,ie.activateResolvedTime,J),this._logExtensionActivationTimes(W,J,"success",ie),se},se=>{throw this._logExtensionActivationTimes(W,J,"failure"),se})}_logExtensionActivationTimes(W,J,se,ie){const K=N(W,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...ie||{},outcome:se})}_doActivateExtension(W,J){const se=N(W,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const ie=this._getEntryPoint(W);if(!ie)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${W.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${W.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const K=new b.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule(W.identifier,(0,D.joinPath)(W.extensionLocation,ie),K),this._loadExtensionContext(W)]).then(Y=>(I.mark(`code/extHost/willActivateExtension/${W.identifier.value}`),Gi._callActivate(this._logService,W.identifier,Y[0],Y[1],K))).then(Y=>(I.mark(`code/extHost/didActivateExtension/${W.identifier.value}`),Y))}_loadExtensionContext(W){const J=new m.ExtensionGlobalMemento(W,this._storage),se=new m.ExtensionMemento(W.identifier.value,!1,this._storage),ie=new O.ExtensionSecrets(W,this._secretState),K=W.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Y=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${W.identifier.value}`),Promise.all([J.whenReady,se.whenReady,this._storagePath.whenReady]).then(()=>{const le=this;let fe;const Se=(0,E.isProposedApiEnabled)(W,"ipc")?this._initData.messagePorts?.get(a.ExtensionIdentifier.toKey(W.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:se,secrets:ie,subscriptions:[],get extensionUri(){return W.extensionLocation},get extensionPath(){return W.extensionLocation.fsPath},asAbsolutePath(Me){return t.join(W.extensionLocation.fsPath,Me)},get storagePath(){return le._storagePath.workspaceValue(W)?.fsPath},get globalStoragePath(){return le._storagePath.globalValue(W).fsPath},get logPath(){return t.join(le._initData.logsLocation.fsPath,W.identifier.value)},get logUri(){return A.URI.joinPath(le._initData.logsLocation,W.identifier.value)},get storageUri(){return le._storagePath.workspaceValue(W)},get globalStorageUri(){return le._storagePath.globalValue(W)},get extensionMode(){return K},get extension(){return fe===void 0&&(fe=new B(le,W.identifier,W,Y)),fe},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(W,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le._extHostTerminalService.getEnvironmentVariableCollection(W)},messagePassingProtocol:Se&&{onDidReceiveMessage:w.Event.fromDOMEventEmitter(Se,"message",Me=>Me.data),postMessage:Se.postMessage.bind(Se)}})})}static _callActivate(W,J,se,ie,K){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(W,J,se,ie,K).then(Y=>new b.ActivatedExtension(!1,null,K.build(),se,Y,ie.subscriptions))}static _callActivateOptional(W,J,se,ie,K){if(typeof se.activate=="function")try{K.activateCallStart(),W.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Y=typeof global=="object"?global:self,le=se.activate.apply(Y,[ie]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(le).then(fe=>(K.activateResolveStop(),fe))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(se)}_activateOneStartupFinished(W,J){this._activateById(W.identifier,{startup:!1,extensionId:W.identifier,activationEvent:J}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const W of this._registry.getAllExtensionDescriptions())if(W.activationEvents)for(const J of W.activationEvents)J==="onStartupFinished"&&this._activateOneStartupFinished(W,J)}_handleEagerExtensions(){const W=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._register(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(J),ie=Promise.all([W,se]).then(()=>{});return Promise.race([ie,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ie}_handleWorkspaceContainsEagerExtensions(W){return W.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension(W,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(W,J){if(this.isActivated(J.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ie={logService:this._logService,folders:W.map(Y=>Y.uri),forceUsingSearch:se,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,le,fe)=>this._mainThreadWorkspaceProxy.$checkExists(Y,le,fe)},K=await(0,v.checkActivateWorkspaceContainsExtension)(ie,J);if(!!K)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:K.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(W){throw console.error(W),W}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:W,extensionTestsLocationURI:J}=this._initData.environment;if(!W||!J)throw new Error(f.localize(0,null));const se=await this._loadCommonJSModule(null,J,new b.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(f.localize(1,null,J.toString()));return new Promise((ie,K)=>{const Y=(Se,Me)=>{Se?K(Se):ie(typeof Me=="number"&&Me>0?1:0)},le=(0,D.originalFSPath)(J),fe=se.run(le,Y);fe&&fe.then&&fe.then(()=>{ie(0)}).catch(Se=>{K(Se instanceof Error&&Se.stack?Se.stack:String(Se))})})}async $extensionTestsExit(W){this._logService.info(`Extension host terminating: test runner requested exit with code ${W}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${W}`),this._logService.flush(),this._hostUtils.exit(W)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(W,J){return this._resolvers[W]=J,(0,P.toDisposable)(()=>{delete this._resolvers[W]})}async _activateAndGetResolver(W){const J=W.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const se=W.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(W,J){this._logService.info(`$resolveAuthority invoked for authority (${x(W)})`);const{authorityPrefix:se,resolver:ie}=await this._activateAndGetResolver(W);if(!ie)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ie)),I.mark(`code/extHost/willResolveAuthority/${se}`);const K=await ie.resolve(W,{resolveAttempt:J});I.mark(`code/extHost/didResolveAuthorityOK/${se}`);const Y={authority:W,host:K.host,port:K.port,connectionToken:K.connectionToken},le={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Y,options:le,tunnelInformation:{environmentTunnels:K.environmentTunnels,features:K.tunnelFeatures}}}}catch(K){if(I.mark(`code/extHost/didResolveAuthorityError/${se}`),K instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(W,J){this._logService.info(`$getCanonicalURI invoked for authority (${x(W)})`);const{authorityPrefix:se,resolver:ie}=await this._activateAndGetResolver(W);if(!ie)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${se}`);const K=A.URI.revive(J);if(typeof ie.getCanonicalURI=="undefined")return K;const Y=await(0,T.asPromise)(()=>ie.getCanonicalURI(K));return Y||K}$startExtensionHost(W){return this._registry.keepOnly(W),this._startExtensionHost()}$activateByEvent(W,J){return J===1?this._activateByEvent(W,!1):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(W,!1))}async $activate(W,J){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(W)?(await this._activateById(W,J),!0):!1}async $deltaExtensions(W,J){W.forEach(ie=>ie.extensionLocation=A.URI.revive(ie.extensionLocation));const se=await this.getExtensionPathIndex();return await Promise.all(J.map(async ie=>{const K=this._registry.getExtensionDescription(ie);K&&se.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(W.map(async ie=>{const K=await this._realPathExtensionUri(ie.extensionLocation);se.set(K,ie)})),this._registry.deltaExtensions(W,J),Promise.resolve(void 0)}async $test_latency(W){return W}async $test_up(W){return W.byteLength}async $test_down(W){let J=s.VSBuffer.alloc(W),se=Math.random()%256;for(let ie=0;ie<W;ie++)J.writeUInt8(se,ie);return J}async $updateRemoteConnectionData(W){this._remoteConnectionData=W,this._onDidChangeRemoteConnectionData.fire()}};$=je([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,u.IExtHostRpcService),He(3,g.IExtHostWorkspace),He(4,l.IExtHostConfiguration),He(5,R.ILogService),He(6,i.IExtHostInitDataService),He(7,n.IExtensionStoragePaths),He(8,d.IExtHostTunnelService),He(9,h.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function N(z,W){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:W.activationEvent,reasonId:W.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class B{constructor(W,J,se,ie){F.set(this,void 0),M.set(this,void 0),V.set(this,void 0),nt(this,F,W,"f"),nt(this,M,J,"f"),nt(this,V,se.identifier,"f"),this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=t.normalize((0,D.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ie}get isActive(){return Le(this,F,"f").isActivated(Le(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Le(this,F,"f").getExtensionExports(Le(this,V,"f"))}activate(){return Le(this,F,"f").activateByIdWithErrors(Le(this,V,"f"),{startup:!1,extensionId:Le(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,F=new WeakMap,M=new WeakMap,V=new WeakMap;function x(z){const W=z.indexOf("+");return W===-1?z:z.substring(0,W)}}),define(pe[54],ve([0,1,9,2,3,17,5,7,124,35,39,45,215,36,208,14,4,13,40,53]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let s=class{constructor(c,d,h,w,v,k){this._workspaceService=d,this._extensionService=h,this._editorsService=w,this._configurationService=v,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=c.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(U=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,d){const h=c;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let w=`debug:${encodeURIComponent(h.path||"")}`,v="?";return d&&(w+=`${v}session=${encodeURIComponent(d.id)}`,v="&"),w+=`${v}ref=${h.sourceReference}`,t.URI.parse(w)}else{if(h.path)return t.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const d=[];for(const h of c.getAllExtensionDescriptions())if(h.contributes){const w=h.contributes.debuggers;if(w&&w.length>0)for(const v of w)(0,p.isDebuggerMainContribution)(v)&&d.push(v.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(d=>c.push(d)),c}addBreakpoints(c){this.startBreakpoints();const d=c.filter(v=>{const k=v.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,v),!0)});this.fireBreakpointChanges(d,[],[]);const h=[],w=new Map;for(const v of d)if(v instanceof P.SourceBreakpoint){let k=w.get(v.location.uri.toString());k||(k={type:"sourceMulti",uri:v.location.uri,lines:[]},w.set(v.location.uri.toString(),k),h.push(k)),k.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof P.FunctionBreakpoint&&h.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(c){this.startBreakpoints();const d=c.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],d,[]);const h=d.filter(k=>k instanceof P.SourceBreakpoint).map(k=>k.id),w=d.filter(k=>k instanceof P.FunctionBreakpoint).map(k=>k.id),v=d.filter(k=>k instanceof P.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(h,w,v)}startDebugging(c,d,h){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,d,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,d,h){if(!d)return new P.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:w,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,h,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,w),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(c,d,h){if(!h)return new P.Disposable(()=>{});if(!this.definesDebugType(c,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:w,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,w),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(c,d){if(!d)return new P.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:h,factory:d}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==d)})}async $runInTerminal(c,d){return Promise.resolve(void 0)}async $substituteVariables(c,d){if(!this._variableResolver){const[v,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,k)}let h;const w=await this.getFolder(c);return w&&(h={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,d)}createDebugAdapter(c,d){if(c.type==="implementation")return new i(c.implementation)}createSignService(){}async $startDASession(c,d){const h=this,w=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const k=this.convertToDto(v),O=this.createDebugAdapter(k,w);if(!O)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const U=O;return this._debugAdapters.set(c,U),this.getDebugAdapterTrackers(w).then(F=>(F&&this._debugAdaptersTrackers.set(c,F),U.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const V=M,$={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(V.arguments.value);$.body={signature:N},U.sendResponse($)}else throw new Error("no signer")}catch(N){$.success=!1,$.message=N.message,U.sendResponse($)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(M),M=(0,p.convertToVSCPaths)(M,!0),h._debugServiceProxy.$acceptDAMessage(c,M)}),U.onError(M=>{F&&F.onError&&F.onError(M),this._debugServiceProxy.$acceptDAError(c,M.name,M.message,M.stack)}),U.onExit(M=>{F&&F.onExit&&F.onExit((0,L.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,L.withNullAsUndefined)(M),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),U.startSession()))})}$sendDAMessage(c,d){d=(0,p.convertToDAPaths)(d,!1);const h=this._debugAdaptersTrackers.get(c);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(d);const w=this._debugAdapters.get(c);w&&w.sendMessage(d)}$stopDASession(c){const d=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),d&&d.onWillStopSession&&d.onWillStopSession();const h=this._debugAdapters.get(c);return this._debugAdapters.delete(c),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const d=[],h=[],w=[];if(c.added)for(const v of c.added){const k=v.id;if(k&&!this._breakpoints.has(k)){let O;if(v.type==="function")O=new P.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")O=new P.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const U=t.URI.revive(v.uri);O=new P.SourceBreakpoint(new P.Location(U,new P.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}O._id=k,this._breakpoints.set(k,O),d.push(O)}}if(c.removed)for(const v of c.removed){const k=this._breakpoints.get(v);k&&(this._breakpoints.delete(v),h.push(k))}if(c.changed){for(const v of c.changed)if(v.id){const k=this._breakpoints.get(v.id);if(k){if(k instanceof P.FunctionBreakpoint&&v.type==="function"){const O=k;O.enabled=v.enabled,O.condition=v.condition,O.hitCondition=v.hitCondition,O.logMessage=v.logMessage,O.functionName=v.functionName}else if(k instanceof P.SourceBreakpoint&&v.type==="source"){const O=k;O.enabled=v.enabled,O.condition=v.condition,O.hitCondition=v.hitCondition,O.logMessage=v.logMessage,O.location=new P.Location(t.URI.revive(v.uri),new P.Position(v.line,v.character))}w.push(k)}}}this.fireBreakpointChanges(d,h,w)}$provideDebugConfigurations(c,d,h){return(0,D.asPromise)(async()=>{const w=this.getConfigProviderByHandle(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(d);return w.provideDebugConfigurations(v,h)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(c,d,h,w){return(0,D.asPromise)(async()=>{const v=this.getConfigProviderByHandle(c);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(d);return v.resolveDebugConfiguration(k,h,w)})}$resolveDebugConfigurationWithSubstitutedVariables(c,d,h,w){return(0,D.asPromise)(async()=>{const v=this.getConfigProviderByHandle(c);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(d);return v.resolveDebugConfigurationWithSubstitutedVariables(k,h,w)})}async $provideDebugAdapter(c,d){const h=this.getAdapterDescriptorFactoryByHandle(c);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(d);return this.getAdapterDescriptor(h,w).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(c){const d=await this.getSession(c);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(c){const d=await this.getSession(c);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,d){const h=await this.getSession(c);h&&h._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(c,d){const w={session:await this.getSession(c),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const d=this._adapterFactories.filter(h=>h.type===c);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(c){const d=this._adapterFactories.filter(h=>h.handle===c);if(d.length>0)return d[0].factory}getConfigProviderByHandle(c){const d=this._configProviders.filter(h=>h.handle===c);if(d.length>0)return d[0].provider}definesDebugType(c,d){if(c.contributes){const h=c.contributes.debuggers;if(h&&h.length>0){for(const w of h)if(w.label&&w.type&&w.type===d)return!0}}return!1}getDebugAdapterTrackers(c){const h=c.configuration.type,w=this._trackerFactories.filter(v=>v.type===h||v.type==="*").map(v=>(0,D.asPromise)(()=>v.factory.createDebugAdapterTracker(c)).then(k=>k,k=>null));return Promise.race([Promise.all(w).then(v=>{const k=v.filter(O=>!!O);if(k.length>0)return new r(k)}),new Promise((v,k)=>{const O=setTimeout(()=>{clearTimeout(O),k(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(c,d){const h=d.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new P.DebugAdapterServer(h));if(c){const v=await this._extensionService.getExtensionRegistry();return(0,D.asPromise)(()=>c.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,v))).then(k=>{if(k)return k})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,w))}daExecutableFromPackage(c,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,d,h){(c.length>0||d.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:d,changed:h}))}async getSession(c){if(c)if(typeof c=="string"){const d=this._debugSessions.get(c);if(d)return d}else{let d=this._debugSessions.get(c.id);if(!d){const h=await this.getFolder(c.folderUri),w=c.parent?this._debugSessions.get(c.parent):void 0;d=new m(this._debugServiceProxy,c.id,c.type,c.name,h,c.configuration,w),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(c){if(c){const d=t.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};s=je([He(0,g.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class m{constructor(c,d,h,w,v,k,O){this._debugServiceProxy=c,this._id=d,this._type=h,this._name=w,this._workspaceFolder=v,this._configuration=k,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,d)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=m;class o{constructor(c){this.value=Object.freeze({append(d){c.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=o;class S extends l.AbstractVariableResolverService{constructor(c,d,h,w,v){function k(){if(d){const O=d.activeEditor();if(O)return O.document.uri;const U=w.tabs.filter(F=>F.isActive);if(U.length>0){const F=U[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:U[0].resource}}}super({getFolderUri:O=>{const U=c.filter(F=>F.name===O);if(U&&U.length>0)return U[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(O,U)=>h.getConfiguration(void 0,O).get(U),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const O=k();if(O)return f.normalize(O.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const O=k();if(O){const U=v.getWorkspaceFolder(O);if(U)return f.normalize(U.uri.fsPath)}}},getSelectedText:()=>{if(d){const O=d.activeEditor();if(O&&!O.selection.isEmpty)return O.document.getText(O.selection)}},getLineNumber:()=>{if(d){const O=d.activeEditor();if(O)return String(O.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=S;class r{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(d=>d.onError?d.onError(c):void 0)}onExit(c,d){this.trackers.forEach(h=>h.onExit?h.onExit(c,d):void 0)}}class i extends C.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends s{constructor(c,d,h,w,v,k){super(c,d,h,w,v,k)}createVariableResolver(c,d,h){return new S(c,d,h,this._editorTabs)}};n=je([He(0,g.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],n),e.WorkerExtHostDebugService=n}),define(pe[268],ve([0,1,72,2,5,36,28,27,14,26,4,39,40,11,8]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let g=class{constructor(m,o,S,r,i,n,u){this._apiFactory=m,this._extensionRegistry=o,this._instaService=S,this._extHostConfiguration=r,this._extHostExtensionService=i,this._initData=n,this._logService=u,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new L(this._apiFactory,o,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(_,o)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(a,o,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(let o of m.nodeModuleName)this._factories.set(o,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(o=>m.alternativeModuleName(o))}};g=je([He(2,R.IInstantiationService),He(3,D.IExtHostConfiguration),He(4,y.IExtHostExtensionService),He(5,A.IExtHostInitDataService),He(6,b.ILogService)],g),e.RequireInterceptor=g;let E=class Hi{constructor(m){if(m.environment.appRoot&&Hi.aliased.size){const o=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),S="[a-z0-9_.-]",r=`@${S}+\\/${S}+|${S}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${i}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(m));if(!o)return;const[,S,r,i]=o,n=Hi.aliased.get(r);if(n!==void 0)return console.warn(`${r} as been renamed to ${n}, please update your imports`),S+n+i}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};E.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),E=je([He(0,A.IExtHostInitDataService)],E);class L{constructor(m,o,S,r,i){this._apiFactory=m,this._extensionPaths=o,this._extensionRegistry=S,this._configProvider=r,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,o){const S=this._extensionPaths.findSubstr(o);if(S){let r=this._extApiImpl.get(P.ExtensionIdentifier.toKey(S.identifier));return r||(r=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(S.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((i,n)=>r+=`	${n} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(m,o,S){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(I.MainContext.MainThreadTelemetry);const{environment:r}=S,i=o.getProxy(I.MainContext.MainThreadKeytar);if(r.appRoot){let n=r.appRoot.fsPath;l.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,u)=>i.$getPassword(n,u),setPassword:(n,u,c)=>i.$setPassword(n,u,c),deletePassword:(n,u)=>i.$deletePassword(n,u),findPassword:n=>i.$findPassword(n),findCredentials(n){return i.$findCredentials(n)}}}load(m,o){const S=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const o=m.length;if(o<=7||!this.alternativeNames)return;const S=o-7;if((m.charAt(S)==="/"||m.charAt(S)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};_=je([He(1,C.IExtHostRpcService),He(2,A.IExtHostInitDataService)],_);let a=class{constructor(m,o,S){this._extensionPaths=m,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(I.MainContext.MainThreadTelemetry);const r=S.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,n)=>{const u=t.URI.parse(i);return n?this.callOriginal(i,n):u.scheme==="http"||u.scheme==="https"?r.$openUri(u,i,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this._appUriScheme?r.$openUri(u,i,{}):this.callOriginal(i,n)}}load(m,o,S){const r=this._extensionPaths.findSubstr(o);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=S(m),this._impl}callOriginal(m,o){return this.sendNoForwardTelemetry(),this._original(m,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};a=je([He(2,C.IExtHostRpcService)],a)}),define(pe[269],ve([0,1,170,12,7,209,35,39,45,36,34,14,54,195,17,210,53]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let L=class extends l.ExtHostDebugServiceBase{constructor(s,m,o,S,r,i,n){super(s,m,o,S,r,n);this._terminalService=i,this._integratedTerminalInstances=new _}createDebugAdapter(s,m){switch(s.type){case"server":return new D.SocketDebugAdapter(s);case"pipeServer":return new D.NamedPipeDebugAdapter(s);case"executable":return new D.ExecutableDebugAdapter(s,m.type)}return super.createDebugAdapter(s,m)}daExecutableFromPackage(s,m){const o=D.ExecutableDebugAdapter.platformAdapterExecutable(m.getAllExtensionDescriptions(),s.type);if(o)return new I.DebugAdapterExecutable(o.command,o.args,o.options)}createSignService(){return new b.SignService}async $runInTerminal(s,m){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(k=>{this._integratedTerminalInstances.onTerminalClosed(k)}));const o=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=s.title||f.localize(0,null),n=JSON.stringify({shell:S,shellArgs:r});let u=await this._integratedTerminalInstances.checkout(n,i),c,d=!1;if(u)c=s.cwd;else{const k={shellPath:S,shellArgs:r,cwd:s.cwd,name:i,iconPath:new I.ThemeIcon("debug")};d=!0,u=this._terminalService.createTerminalFromOptions(k,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,n)}u.show(!0);const h=await u.processId;d?await new Promise(k=>setTimeout(k,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?u.sendText("cls"):S.indexOf("bash")>=0?u.sendText("clear"):t.isWindows?u.sendText("cls"):u.sendText("clear"));const w=(0,g.prepareCommand)(S,s.args,c,s.env);u.sendText(w);const v=this.onDidTerminateDebugSession(k=>{k.id===m&&(this._integratedTerminalInstances.free(u),v.dispose())});return h}else if(s.kind==="external")return(0,g.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,m)}createVariableResolver(s,m,o){return new l.ExtHostVariableResolverService(s,m,o,this._editorTabs,this._workspaceService)}};L=je([He(0,y.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,P.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,E.IExtHostEditorTabs)],L),e.ExtHostDebugService=L;class _{constructor(){this._terminalInstances=new Map}async checkout(s,m){const S=[...this._terminalInstances.entries()].map(([r,i])=>(0,p.createCancelablePromise)(async n=>{if(r.name!==m||i.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await r.processId))return null;const u=Date.now();return i.lastUsedAt+_.minUseDelay>u||n.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=u,r)}));return await(0,p.firstParallel)(S,r=>!!r)}insert(s,m){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:m})}free(s){const m=this._terminalInstances.get(s);m&&(m.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}_.minUseDelay=1e3}),define(pe[270],ve([0,1,9,2,113,35,54,45,36,43,34,14,26,71,10,11,66,53,23,81]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends b.ExtHostTaskBase{constructor(o,S,r,i,n,u,c,d,h){super(o,S,r,i,n,u,c,d);this.workspaceService=r,this.editorTabs=h,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,S){const r=S;if(!S.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=b.TaskHandleDTO.from(r,this.workspaceService),n=await this._proxy.$getTaskExecution(i);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(n,S);return this._proxy.$executeTask(i).catch(()=>{}),u}else{const i=b.TaskDTO.from(S,o);if(i===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,S,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),S);return this._proxy.$executeTask(i).catch(()=>{}),n}}provideTasksInternal(o,S,r,i){const n=[];if(i)for(let u of i){this.checkDeprecation(u,r),(!u.definition||!o[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const c=b.TaskDTO.from(u,r.extension);c&&(n.push(c),b.CustomExecutionDTO.is(c.execution)&&S.push(this.addCustomExecution(c,u,!0)))}return{tasks:n,extension:r.extension}}async resolveTaskInternal(o){return o}async getVariableResolver(o){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(o,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(o){let S=o&&o.length>0?o[0]:void 0;if(!S){const r=t.URI.file((0,a.homedir)());S=new A.WorkspaceFolder({uri:r,name:_.basename(r),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,S){const r=t.URI.revive(o),i={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(r),u=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(u),d=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(let h of S.variables)i.variables[h]=await c.resolveAsync(d,h);if(S.process!==void 0){let h;if(S.process.path!==void 0){h=S.process.path.split(f.delimiter);for(let w=0;w<h.length;w++)h[w]=await c.resolveAsync(d,h[w])}i.process=await I.win32.findExecutable(await c.resolveAsync(d,S.process.name),S.process.cwd!==void 0?await c.resolveAsync(d,S.process.cwd):void 0,h)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(o,S,r){return I.win32.findExecutable(o,S,r)}};s=je([He(0,y.IExtHostRpcService),He(1,l.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,P.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,g.ILogService),He(7,E.IExtHostApiDeprecationService),He(8,L.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(pe[271],ve([0,1,17,15,72,6,2,5,263,11,61,84,26,187,14,65,39,34]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(s,m,o,S,r){this._disposables=new D.DisposableStore,this._isTerminating=!1,this._hostUtils=o,this._rpcProtocol=new C.RPCProtocol(s,null,S),m=_._transform(m,this._rpcProtocol);const i=new y.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...m,messagePorts:r}),i.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),i.set(g.IURITransformerService,new g.URITransformerService(S)),i.set(E.IHostUtils,o);const n=new b.InstantiationService(i,!0);this._disposables.add(n.invokeFunction(h=>h.get(L.IExtHostTerminalService))),this._disposables.add(n.invokeFunction(h=>h.get(E.IExtHostExtensionService))),this._logService=n.invokeFunction(h=>h.get(A.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",m),this._extensionService=n.invokeFunction(h=>h.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const u=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(w,v)=>{let k="",O,U;for(const F of v)k+=`
	at ${F.toString()}`,U=F.getFileName(),!O&&U&&(O=h.findSubstr(T.URI.file(U)));return u.set(w,O),`${w.name||"Error"}: ${w.message||""}${k}`}});const c=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),d=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(h=>{const w=t.transformErrorForSerialization(h),v=u.get(h);v?c.$onExtensionRuntimeError(v.identifier,w):d.$onUnexpectedError(w)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(o=>{this._logService.error(o)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();Promise.race([(0,f.timeout)(5e3),m]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(s,m){s.extensions.forEach(S=>S.extensionLocation=T.URI.revive(m.transformIncomingURIs(S.extensionLocation))),s.environment.appRoot=T.URI.revive(m.transformIncomingURIs(s.environment.appRoot));const o=s.environment.extensionDevelopmentLocationURI;return o&&(s.environment.extensionDevelopmentLocationURI=o.map(S=>T.URI.revive(m.transformIncomingURIs(S)))),s.environment.extensionTestsLocationURI=T.URI.revive(m.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=T.URI.revive(m.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=T.URI.revive(m.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=T.URI.revive(m.transformIncomingURIs(s.logsLocation)),s.logFile=T.URI.revive(m.transformIncomingURIs(s.logFile)),s.workspace=m.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=_}),define(pe[272],ve([0,1,9,21,49,32,23,46,31]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(l,b,p){this.config=l,this.provider=b,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&D.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&D.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const b=this.config.folderQueries||[];return new Promise((p,g)=>{const E=L=>{this.resultCount++,l(L)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(L=>{const _=L.toString(),a=f.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,a)||this.matchFile(E,{base:L,basename:a})}),Promise.all(b.map(L=>this.searchInFolder(L,E))).then(L=>{p({limitHit:this.isLimitHit,stats:L[0]||void 0})},L=>{g(new Error((0,I.toErrorMessage)(L)))})})}async searchInFolder(l,b){const p=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(l),E=this.initDirectoryTree(),L=new C.QueryGlobTester(this.config,l),_=!L.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(p),a=P.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,p.token),m=a.elapsed(),o=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(S=>{const r=f.posix.relative(l.folder.path,S.path);if(_){const i=f.basename(S.path);this.matchFile(b,{base:l.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(E,l.folder,r,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,L,b),{providerTime:m,postProcessTime:o.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(l){const b=(0,C.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),p=(0,C.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},b,p,g){if(p===this.filePattern){const L=f.basename(this.filePattern);this.matchFile(g,{base:b,relativePath:this.filePattern,basename:L})}function E(L){const _=f.basename(L),a=f.dirname(L);let s=l[a];s||(s=l[a]=[],E(a)),s.push({base:b,relativePath:L,basename:_})}E(p)}matchDirectoryTree({rootEntries:l,pathToEntries:b},p,g){const E=this,L=this.filePattern;function _(a){const s=D.hasSiblingFn(()=>a.map(m=>m.basename));for(let m=0,o=a.length;m<o;m++){const S=a[m],{relativePath:r,basename:i}=S;if(p.matchesExcludesSync(r,i,L!==i?s:void 0))continue;const n=b[r];if(n)_(n);else{if(r===L)continue;E.matchFile(g,S)}if(E.isLimitHit)break}}_(l)}matchFile(l,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(b))}}class R{constructor(){this.sessions=new Map}fileSearch(l,b,p,g){const E=this.getSessionTokenSource(l.cacheKey),L=new A(l,b,E&&E.token);let _=0;const a=s=>{_+=s.length,p(s.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(L,R.BATCH_SIZE,a,g).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:s.stats}}))}clearCache(l){const b=this.getSessionTokenSource(l);b&&b.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new t.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:T.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,b,p,g){g.onCancellationRequested(()=>{l.cancel()});const E=_=>{_&&(L.push(_),b>0&&L.length>=b&&(p(L),L=[]))};let L=[];return l.search(E).then(_=>(L.length&&p(L),_),_=>(L.length&&p(L),Promise.reject(_)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(pe[135],ve([0,1,16,21,49,32,10,9,23,13,2,31]),function(Z,e,f,t,I,D,T,P,C,A,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(a,s,m,o){this.query=a,this.provider=s,this.fileUtils=m,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,s){const m=this.query.folderQueries||[],o=new t.CancellationTokenSource;return s.onCancellationRequested(()=>o.cancel()),new Promise((S,r)=>{this.collector=new p(a);let i=!1;const n=(u,c)=>{if(!i&&!this.isLimitHit){const d=this.resultSize(u);E(u)&&typeof this.query.maxResults=="number"&&this.resultCount+d>this.query.maxResults&&(this.isLimitHit=!0,i=!0,o.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const h=this.resultSize(u);this.resultCount+=h,(h>0||!E(u))&&this.collector.add(u,c)}};Promise.all(m.map((u,c)=>this.searchInFolder(u,d=>n(d,c),o.token))).then(u=>{o.dispose(),this.collector.flush();const c=u.some(d=>!!d&&!!d.limitHit);S({limitHit:this.isLimitHit||c,messages:(0,f.flatten)(u.map(d=>d?.message?(0,A.isArray)(d.message)?d.message:[d.message]:[])),stats:{type:this.processType}})},u=>{o.dispose();const c=(0,I.toErrorMessage)(u);r(new Error(c))})})}resultSize(a){return E(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,s){const m=Array.isArray(a.ranges)?a.ranges:[a.ranges],o=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:m.slice(0,s),preview:{matches:o.slice(0,s),text:a.preview.text},uri:a.uri}}async searchInFolder(a,s,m){const o=new y.QueryGlobTester(this.query,a),S=[],r={report:u=>{if(!this.validateProviderResult(u))return;const c=a.folder.scheme===T.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(u.uri))):void 0,d=C.relativePath(a.folder,u.uri);if(d){const h=o.includedInQuery(d,P.basename(d),c);(0,A.isPromise)(h)?S.push(h.then(w=>{w&&s(u)})):h&&s(u)}}},i=this.getSearchOptionsForFolder(a),n=await this.provider.provideTextSearchResults(b(this.query.contentPattern),i,r,m);return S.length&&await Promise.all(S),n}validateProviderResult(a){if(E(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const s=(0,y.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),m=(0,y.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),o={folder:R.URI.from(a.folder),excludes:m,includes:s,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=l;function b(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class p{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new L(512,s=>this.sendItems(s))}add(a,s){this._currentFileMatch&&(this._currentFolderIdx!==s||!C.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=s,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(g(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=p;function g(_){return E(_)?{preview:{matches:(0,f.mapArrayOrNot)(_.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:_.preview.text},ranges:(0,f.mapArrayOrNot)(_.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function E(_){return!!_.preview}e.extensionResultIsMatch=E;class L{constructor(a,s){this.maxBatchSize=a,this.cb=s,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,s){!a||this.addItemToBatch(a,s)}addItems(a,s){!a||this.addItemsToBatch(a,s)}addItemToBatch(a,s){this.batch.push(a),this.batchSize+=s,this.onUpdate()}addItemsToBatch(a,s){this.batch=this.batch.concat(a),this.batchSize+=s,this.onUpdate()}onUpdate(){this.totalNumberCompleted<L.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},L.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=L,L.TIMEOUT=4e3,L.START_BATCH_AFTER_COUNT=50}),define(pe[73],ve([0,1,6,5,4,272,14,65,11,2,135]),function(Z,e,f,t,I,D,T,P,C,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let y=class{constructor(g,E,L){this.extHostRpc=g,this._uriTransformer=E,this._logService=L,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new D.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,E){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const L=this._handlePool++;return this._textSearchProvider.set(L,E),this._proxy.$registerTextSearchProvider(L,this._transformScheme(g)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(L),this._proxy.$unregisterProvider(L)})}registerFileSearchProvider(g,E){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const L=this._handlePool++;return this._fileSearchProvider.set(L,E),this._proxy.$registerFileSearchProvider(L,this._transformScheme(g)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(L),this._proxy.$unregisterProvider(L)})}$provideFileSearchResults(g,E,L,_){const a=l(L),s=this._fileSearchProvider.get(g);if(s)return this._fileSearchManager.fileSearch(a,s,m=>{this._proxy.$handleFileMatch(g,E,m.map(o=>o.resource))},_);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,E,L,_){const a=this._textSearchProvider.get(g);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const s=l(L);return this.createTextSearchManager(s,a).search(o=>this._proxy.$handleTextMatch(g,E,o),_)}$enableExtensionHostSearch(){}createTextSearchManager(g,E){return new R.TextSearchManager(g,E,{readdir:L=>Promise.resolve([]),toCanonicalName:L=>L},"textSearchProvider")}};y=je([He(0,T.IExtHostRpcService),He(1,P.IURITransformerService),He(2,C.ILogService)],y),e.ExtHostSearch=y;function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>A.URI.revive(g))}}e.reviveQuery=l;function b(p){return{...p,folder:A.URI.revive(p.folder)}}}),define(pe[273],ve([0,1,61,133,35,131,36,38,45,34,71,54,73,90,51,66,134,67,44,89,122,53,132,11,225]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a,s,m,o,S,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(S.ILoggerService,o.ExtHostLoggerService),(0,f.registerSingleton)(S.ILogService,r.ExtHostLogService),(0,f.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,f.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,f.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,f.registerSingleton)(L.IExtHostConsumerFileSystem,L.ExtHostConsumerFileSystem),(0,f.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,f.registerSingleton)(D.IExtHostDecorations,D.ExtHostDecorations),(0,f.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,f.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,f.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,f.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,f.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,f.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,f.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService),(0,f.registerSingleton)(E.IExtHostWindow,E.ExtHostWindow),(0,f.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,f.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,f.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,f.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs)}),define(pe[91],ve([0,1,16,11,31,70]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}e.anchorGlob=T;function P(y,l,b,p){const g=(0,f.mapArrayOrNot)(b,C),E=new I.TextSearchMatch(l,g,p),L=E.preview.matches;return{ranges:(0,f.mapArrayOrNot)(g,A),uri:y,preview:{text:E.preview.text,matches:(0,f.mapArrayOrNot)(L,A)}}}e.createTextSearchResult=P;function C(y){return new I.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function A(y){return new D.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let R=class{constructor(l,b){this.prefix=l,this.logService=b}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};R=je([He(1,t.ILogService)],R),e.OutputChannel=R}),define(pe[274],ve([0,1,37,9,79,29,12,8,91,275]),function(Z,e,f,t,I,D,T,P,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(a,s,m,o){const S=l(a,s,m,o),r=s.folder.fsPath;return{cmd:f.spawn(R,S.args,{cwd:r}),rgDiskPath:R,siblingClauses:S.siblingClauses,rgArgs:S,cwd:r}}e.spawnRipgrepCmd=y;function l(a,s,m,o){const S=["--files","--hidden","--case-sensitive"];p([s],m,!1).forEach(i=>{const n=(0,C.anchorGlob)(i);if(S.push("-g",n),T.isMacintosh){const u=(0,I.normalizeNFD)(n);u!==n&&S.push("-g",u)}});const r=b([s],o,void 0,!1);return r.globArgs.forEach(i=>{const n=`!${(0,C.anchorGlob)(i)}`;if(S.push("-g",n),T.isMacintosh){const u=(0,I.normalizeNFD)(n);u!==n&&S.push("-g",u)}}),s.disregardIgnoreFiles!==!1?S.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&S.push("--no-ignore-parent"),s.ignoreSymlinks||S.push("--follow"),a.exists&&S.push("--quiet"),S.push("--no-config"),s.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:r.siblingClauses}}function b(a,s,m,o=!0){const S=[];let r={};return a.forEach(i=>{const n=Object.assign({},i.excludePattern||{},s||{}),u=g(n,o?i.folder.fsPath:void 0,m);S.push(...u.globArgs),u.siblingClauses&&(r=Object.assign(r,u.siblingClauses))}),{globArgs:S,siblingClauses:r}}e.foldersToRgExcludeGlobs=b;function p(a,s,m=!0){const o=[];return a.forEach(S=>{const r=Object.assign({},s||{},S.includePattern||{}),i=g(r,m?S.folder.fsPath:void 0);o.push(...i.globArgs)}),o}e.foldersToIncludeGlobs=p;function g(a,s,m){const o=[],S={};return Object.keys(a).forEach(r=>{if(m&&m.has(r)||!r)return;const i=a[r];r=L(s?E(s,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),o.push(_(r))):i&&i.when&&(S[r]=i)}),{globArgs:o,siblingClauses:S}}function E(a,s){return t.isAbsolute(s)?s:t.join(a,s)}e.getAbsoluteGlob=E;function L(a){return a=P.rtrim(a,"\\"),P.rtrim(a,"/")}function _(a){return D.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=_}),define(pe[276],ve([0,1,37,60,9,104,16,49,32,79,29,12,46,8,13,30,31,274,102]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(r=>r())});class s{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&C.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&C.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(n=>{const u=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),c=n.folder.fsPath;i.folderQueries.map(d=>d.folder.fsPath).filter(d=>d!==c).forEach(d=>{(0,R.isEqualOrParent)(d,c)&&(u[I.relative(c,d)]=!0)}),this.folderExcludePatterns.set(c,new o(u,c))})}cancel(){this.isCanceled=!0,a.forEach(i=>i())}walk(i,n,u,c,d){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return d(null,this.isLimitHit);n.forEach(h=>{const w=I.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,w)||this.matchFile(u,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(i,(h,w)=>{this.call(this.cmdTraversal,this,h,u,c,v=>{if(v){const k=(0,P.toErrorMessage)(v);console.error(k),this.errors.push(k),w(v,void 0)}else w(null,void 0)})},(h,w)=>{this.fileWalkSW.stop();const v=h?T.coalesce(h)[0]:null;d(v,this.isLimitHit)})}parallel(i,n,u){const c=new Array(i.length),d=new Array(i.length);let h=!1,w=0;if(i.length===0)return u(null,[]);i.forEach((v,k)=>{n(v,(O,U)=>{if(O?(h=!0,c[k]=null,d[k]=O):(c[k]=U,d[k]=null),++w===i.length)return u(h?d:null,c)})})}call(i,n,...u){try{i.apply(n,u)}catch(c){u[u.length-1](c)}}cmdTraversal(i,n,u,c){const d=i.folder.fsPath,h=y.isMacintosh;let w;const v=()=>w&&w.kill();a.add(v);let k=N=>{a.delete(v),k=()=>{},c(N)},O="";const U=this.initDirectoryTree();let F;const M=(0,L.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);w=M.cmd,F=!Object.keys(M.siblingClauses).length;const V=M.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let $=`${M.rgDiskPath} ${V}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&($+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),u({message:$}),this.cmdResultCount=0,this.collectStdout(w,"utf8",u,(N,B,x)=>{if(N){k(N);return}if(this.isLimitHit){k();return}const W=(O+(h?A.normalizeNFC(B||""):B)).split(`
`);if(x){const J=W.length;W[J-1]=W[J-1].trim(),W[J-1]||W.pop()}else O=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,F){for(const J of W)if(this.matchFile(n,{base:d,relativePath:J,searchPath:this.getSearchPath(i,J)}),this.isLimitHit){v();break}(x||this.isLimitHit)&&k();return}this.addDirectoryEntries(i,U,d,W,n),x&&(this.matchDirectoryTree(U,d,n),k())})}spawnFindCmd(i){const n=this.folderExcludePatterns.get(i.folder.fsPath),u=n.getBasenameTerms(),c=n.getPathTerms(),d=["-L","."];if(u.length||c.length){d.push("-not","(","(");for(const h of u)d.push("-name",h),d.push("-o");for(const h of c)d.push("-path",h),d.push("-o");d.pop(),d.push(")","-prune",")")}return d.push("-type","f"),f.spawn("find",d,{cwd:i.folder.fsPath})}readStdout(i,n,u){let c="";this.collectStdout(i,n,()=>{},(d,h,w)=>{if(d){u(d);return}c+=h,w&&u(null,c)})}collectStdout(i,n,u,c){let d=(v,k,O)=>{(v||O)&&(d=()=>{},this.cmdSW&&this.cmdSW.stop()),c(v,k,O)},h=!1;i.stdout?(this.forwardData(i.stdout,n,d),i.stdout.once("data",()=>h=!0)):u({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):u({message:"stderr is null"}),i.on("error",v=>{d(v)}),i.on("close",v=>{let k;!h&&(k=this.decodeData(w,n))&&S(k)?d(new Error(`command failed with error code ${v}: ${this.decodeData(w,n)}`)):(this.exists&&v===0&&(this.isLimitHit=!0),d(null,"",!0))})}forwardData(i,n,u){const c=new D.StringDecoder(n);return i.on("data",d=>{u(null,c.write(d))}),c}collectData(i){const n=[];return i.on("data",u=>{n.push(u)}),n}decodeData(i,n){const u=new D.StringDecoder(n);return i.map(c=>u.write(c)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:n},u,c,d){c.indexOf(this.filePattern)!==-1&&this.matchFile(d,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const h=w=>{const v=I.basename(w),k=I.dirname(w);let O=n[k];O||(O=n[k]=[],h(k)),O.push({base:u,relativePath:w,basename:v,searchPath:this.getSearchPath(i,w)})};c.forEach(h)}matchDirectoryTree({rootEntries:i,pathToEntries:n},u,c){const d=this,h=this.folderExcludePatterns.get(u),w=this.filePattern;function v(k){d.directoriesWalked++;const O=C.hasSiblingFn(()=>k.map(U=>U.basename));for(let U=0,F=k.length;U<F;U++){const M=k[U],{relativePath:V,basename:$}=M;if(h.test(V,$,w!==$?O:void 0))continue;const N=n[V];if(N)v(N);else{if(d.filesWalked++,V===w)continue;d.matchFile(c,M)}if(d.isLimitHit)break}}v(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,n,u,c,d){const h=i.folder,w=C.hasSiblingFn(()=>u);this.parallel(u,(v,k)=>{if(this.isCanceled||this.isLimitHit)return k(null);const O=n?[n,v].join(I.sep):v;if(this.folderExcludePatterns.get(i.folder.fsPath).test(O,v,this.config.filePattern!==v?w:void 0))return k(null);const U=[h.fsPath,O].join(I.sep);t.lstat(U,(F,M)=>{if(F||this.isCanceled||this.isLimitHit)return k(null);this.statLinkIfNeeded(U,M,(V,$)=>V||this.isCanceled||this.isLimitHit?k(null):$.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(U,M,(N,B)=>N||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?k(null):(this.walkedPaths[B]=!0,g.Promises.readdir(U).then(x=>{if(this.isCanceled||this.isLimitHit)return k(null);this.doWalk(i,O,x,c,z=>k(z||null))},x=>{k(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&p.isNumber($.size)&&$.size>this.maxFilesize||this.matchFile(c,{base:h.fsPath,relativePath:O,searchPath:this.getSearchPath(i,O)}),k(null,void 0)))})},v=>{const k=v&&T.coalesce(v);return d(k&&k.length>0?k[0]:void 0)})}matchFile(i,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,I.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(n))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,n,u){return n.isSymbolicLink()?t.stat(i,u):u(null,n)}realPathIfNeeded(i,n,u){return n.isSymbolicLink()?t.realpath(i,(c,d)=>c?u(c):u(null,d)):u(null,i)}getSearchPath(i,n){return i.folderName?I.join(i.folderName,n):n}}e.FileWalker=s;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new s(i)}search(i,n,u){this.walker.walk(this.folderQueries,this.extraFiles,i,n,(c,d)=>{u(c,{limitHit:d,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class o{constructor(i,n){this.expression=i,this.root=n,this.init(i)}init(i){let n,u;Object.keys(i).filter(c=>i[c]).forEach(c=>{I.isAbsolute(c)?(n=n||C.getEmptyExpression(),n[c]=i[c]):(u=u||C.getEmptyExpression(),u[c]=i[c])}),this.absoluteParsedExpr=n&&C.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=u&&C.parse(u,{trimForExclusions:!0})}test(i,n,u){return this.relativeParsedExpr&&this.relativeParsedExpr(i,n,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),n,u)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...C.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...C.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...C.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...C.getPathTerms(this.relativeParsedExpr)),i}}function S(r){const i=r.trim().split(`
`),n=i[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return b.uppercaseFirstLetter(i[i.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=S}),define(pe[277],ve([0,1,97,22]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===r)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const D=512,T=512,P=512*8,C=512*128;var A;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(A=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(i,n){super(i);this.decodeStreamErrorKind=n}}e.DecodeStreamError=R;class y{constructor(i){this.iconvLiteDecoder=i}static async create(i){let n;if(i!==e.UTF8)n=(await new Promise((c,d)=>{Z(["iconv-lite-umd"],c,d)})).getDecoder(g(i));else{const u=new TextDecoder;n={write(c){return u.decode(c,{stream:!0})},end(){return u.decode()}}}return new y(n)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function l(r,i){const n=i.minBytesRequiredForDetection??i.guessEncoding?P:T;return new Promise((u,c)=>{const d=(0,f.newWriteableStream)(U=>U.join("")),h=[];let w=0,v,k;const O=async()=>{try{const U=await S({buffer:t.VSBuffer.concat(h),bytesRead:w},i.guessEncoding);if(U.seemsBinary&&i.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);U.encoding=await i.overwriteEncoding(U.encoding),v=await y.create(U.encoding);const F=v.write(t.VSBuffer.concat(h).buffer);d.write(F),h.length=0,w=0,u({stream:d,detected:U})}catch(U){k?.dispose(),d.destroy(),c(U)}};k=(0,f.listenStream)(r,{onData:async U=>{v?d.write(v.write(U.buffer)):(h.push(U),w+=U.byteLength,w>=n&&(r.pause(),await O(),setTimeout(()=>r.resume())))},onError:U=>d.error(U),onEnd:async()=>{v||await O(),d.end(v?.end())}})})}e.toDecodeStream=l;async function b(r,i,n){const c=(await new Promise((w,v)=>{Z(["iconv-lite-umd"],w,v)})).getEncoder(g(i),n);let d=!1,h=!1;return{read(){if(h)return null;const w=r.read();if(typeof w!="string"){if(h=!0,!d&&n?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const v=c.end();return v&&v.length>0?(d=!0,t.VSBuffer.wrap(v)):null}return d=!0,t.VSBuffer.wrap(c.write(w))}}}e.toEncodeReadable=b;async function p(r){return(await new Promise((n,u)=>{Z(["iconv-lite-umd"],n,u)})).encodingExists(g(r))}e.encodingExists=p;function g(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=g;function E(r,i){if(!r||i<e.UTF16be_BOM.length)return null;const n=r.readUInt8(0),u=r.readUInt8(1);if(n===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const c=r.readUInt8(2);return n===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=E;const L=["ascii","utf-16","utf-32"];async function _(r){const i=await new Promise((h,w)=>{Z(["jschardet"],h,w)}),n=r.slice(0,C),u=m(n.buffer),c=i.detect(u);if(!c||!c.encoding)return null;const d=c.encoding.toLowerCase();return 0<=L.indexOf(d)?null:s(c.encoding)}const a={ibm866:"cp866",big5:"cp950"};function s(r){const i=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[i]||i}function m(r){let i="";for(let n=0;n<r.length;n++)i+=String.fromCharCode(r[n]);return i}function o(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=r.match(/windows(\d+)/);return i?"windows-"+i[1]:r}}}e.toCanonicalName=o;function S({buffer:r,bytesRead:i},n){let u=E(r,i),c=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&r){let d=!0,h=!0,w=!1;for(let v=0;v<i&&v<D;v++){const k=v%2==1,O=r.readUInt8(v)===0;if(O&&(w=!0),d&&(k&&!O||!k&&O)&&(d=!1),h&&(k&&O||!k&&!O)&&(h=!1),O&&!d&&!h)break}w&&(d?u=e.UTF16le:h?u=e.UTF16be:c=!0)}return n&&!c&&!u&&r?_(r.slice(0,i)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:c,encoding:u}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[136],ve([0,1,277,30,135]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class D extends I.TextSearchManager{constructor(P,C,A=t,R="searchProcess"){super(P,C,{readdir:y=>A.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,f.toCanonicalName)(y)},R)}}e.NativeTextSearchManager=D}),define(pe[278],ve([0,1,61,4]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(T){if(T&&this._dragOperations.has(T)){const P=this._dragOperations.get(T);return this._dragOperations.delete(T),P}}addDragOperationTransfer(T,P){this._dragOperations.set(T,P)}}e.TreeViewsDragAndDropService=I,(0,f.registerSingleton)(e.ITreeViewsDragAndDropService,I)}),define(pe[279],ve([0,1,168,23,2,3,6,17,7,13,16,18,21,205,278]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(_,a){if((0,A.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let s;return Array.isArray(_.highlights)&&(s=_.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),s=s.length?s:void 0),{label:_.label,highlights:s}}}class E{constructor(a,s,m){this._proxy=a,this.commands=s,this.logService=m,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeViewsDragAndDropService;function o(S){return S&&S.$treeViewId&&S.$treeItemHandle}s.registerArgumentProcessor({processArgument:S=>o(S)?this.convertArgument(S):Array.isArray(S)&&S.length>0?S.map(r=>o(r)?this.convertArgument(r):r):S})}registerTreeDataProvider(a,s,m){const o=this.createTreeView(a,{treeDataProvider:s},m);return{dispose:()=>o.dispose()}}createTreeView(a,s,m){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=s.dragAndDropController?.supportedMimeTypes,S=!!s.dragAndDropController?.handleDrag,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:o,hasHandleDrag:S}),i=this.createExtHostTreeView(a,s,m);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(n){i.message=n},get title(){return i.title},set title(n){i.title=n},get description(){return i.description},set description(n){i.description=n},reveal:(n,u)=>i.reveal(n,u),dispose:async()=>{await r,this.treeViews.delete(a),i.dispose()}}}$getChildren(a,s){const m=this.treeViews.get(a);return m?m.getChildren(s):Promise.reject(new Error((0,f.localize)(0,null,a)))}async $handleDrop(a,s,m,o,S,r){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,f.localize)(1,null,a)));const n=b.TreeDataTransferConverter.toITreeDataTransfer(s);return S===a&&r&&await this.addAdditionalTransferItems(n,i,r,o),i.onDrop(n,m)}async addAdditionalTransferItems(a,s,m,o){const S=this.treeDragAndDropService.removeDragOperationTransfer(o);let r;if(S)r=await S;else if(o&&s.handleDrag){const i=s.handleDrag(m);this.treeDragAndDropService.addDragOperationTransfer(o,i),r=await i}return r&&r.forEach((i,n)=>{i&&a.set(n,i)}),a}async $handleDrag(a,s,m){const o=this.treeViews.get(a);if(!o)return Promise.reject(new Error((0,f.localize)(2,null,a)));const S=await this.addAdditionalTransferItems(new Map,o,s,m);if(!!S)return b.TreeDataTransferConverter.toTreeDataTransferDTO(S)}async $hasResolve(a){const s=this.treeViews.get(a);if(!s)throw new Error((0,f.localize)(3,null,a));return s.hasResolve}$resolve(a,s,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,f.localize)(4,null,a));return o.resolveTreeItem(s,m)}$setExpanded(a,s,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,f.localize)(5,null,a));o.setExpanded(s,m)}$setSelection(a,s){const m=this.treeViews.get(a);if(!m)throw new Error((0,f.localize)(6,null,a));m.setSelection(s)}$setVisible(a,s){const m=this.treeViews.get(a);if(!m)throw new Error((0,f.localize)(7,null,a));m.setVisible(s)}createExtHostTreeView(a,s,m){const o=new L(a,s,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(a,o),o}convertArgument(a){const s=this.treeViews.get(a.$treeViewId);return s?s.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=E;class L extends T.Disposable{constructor(a,s,m,o,S,r){super();if(this.viewId=a,this.proxy=m,this.commands=o,this.logService=S,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,r.contributes&&r.contributes.views)for(const u in r.contributes.views)for(const c of r.contributes.views[u])c.id===a&&(this._title=c.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(u=>this._onDidChangeData.fire({message:!1,element:u}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(u=>this._onDidChangeData.fire({message:!1,element:u})));let i,n;this._register(D.Event.debounce(this._onDidChangeData.event,(u,c)=>(u||(u={message:!1,elements:[]}),c.element!==!1&&(i||(i=new Promise(d=>n=d),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(c.element)?u.elements.push(...c.element):u.elements.push(c.element)),c.message&&(u.message=!0),u),200,!0)(({message:u,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=n;return i=null,this.refresh(c).then(()=>d())})),u&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.isUndefinedOrNull)(a))}async getChildren(a){const s=a?this.getExtensionElement(a):void 0;if(a&&!s)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let m=this.getChildrenNodes(a);return m||(m=await this.fetchChildrenNodes(s)),m?m.map(o=>o.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,s){s=s||{select:!0,focus:!1};const m=(0,A.isUndefinedOrNull)(s.select)?!0:s.select,o=(0,A.isUndefinedOrNull)(s.focus)?!1:s.focus,S=(0,A.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(n=>n.item)},{select:m,focus:o,expand:S})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:o,expand:S})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,s){const m=this.getExtensionElement(a);m&&(s?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(a){(0,R.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a){const s=[];for(const m of a){const o=this.getExtensionElement(m);o&&s.push(o)}if(!(!this.dndController?.handleDrag||s.length===0))return this.dndController.handleDrag(s)}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,s){const m=this.getExtensionElement(s);if(!!m)return(0,P.asPromise)(()=>this.dndController?.handleDrop(a,m))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,s){if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(a);if(m){const o=this.nodes.get(m);if(o){const S=await this.dataProvider.resolveTreeItem(o.extensionItem,m,s)??o.extensionItem;return o.item.tooltip=this.getTooltip(S.tooltip),o.item.command=this.getCommand(o.disposableStore,S.command),o.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(s=>s?this.resolveUnknownParentChain(s).then(m=>this.resolveTreeNode(s,m[m.length-1]).then(o=>(m.push(o),m))):Promise.resolve([]))}resolveParent(a){const s=this.nodes.get(a);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,s){const m=this.nodes.get(a);return m?Promise.resolve(m):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(o=>this.createHandle(a,o,s,!0)).then(o=>this.getChildren(s?s.item.handle:void 0).then(()=>{const S=this.getExtensionElement(o);if(S){const r=this.nodes.get(S);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}getChildrenNodes(a){if(a){let s;if(typeof a=="string"){const m=this.getExtensionElement(a);s=m?this.nodes.get(m):void 0}else s=a;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const s=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=a?this.nodes.get(a):void 0,o=await this.dataProvider.getChildren(a);if(s.token.isCancellationRequested)return;const S=await Promise.all((0,R.coalesce)(o||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,m):null}));return s.token.isCancellationRequested?void 0:(0,R.coalesce)(S)}finally{s.dispose()}}refresh(a){if(a.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(a);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const s=new Set,m=a.map(S=>this.nodes.get(S));for(const S of m)if(S&&!s.has(S.item.handle)){let r=S;for(;r&&r.parent&&m.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&s.add(S.item.handle)}const o=[];return s.forEach(S=>{const r=this.elements.get(S);if(r){const i=this.nodes.get(r);i&&(!i.parent||!s.has(i.parent.item.handle))&&o.push(S)}}),o}refreshHandles(a){const s={};return Promise.all(a.map(m=>this.refreshNode(m).then(o=>{o&&(s[m]=o.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(a){const s=this.getExtensionElement(a);if(s){const m=this.nodes.get(s);if(m)return this.clearChildren(s),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(o=>{if(o){const S=this.createTreeNode(s,o,m.parent);return this.updateNodeCache(s,S,m,m.parent),m.dispose(),S}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,s,m){const o=this.createTreeNode(a,s,m);if(s.id&&this.elements.has(o.item.handle))throw new Error((0,f.localize)(8,null,s.id));return this.addNodeToCache(a,o),this.addNodeToParentCache(o,m),o}getTooltip(a){return C.MarkdownString.isMarkdownString(a)?y.MarkdownString.from(a):a}getCommand(a,s){return s?this.commands.toInternal(s,a):void 0}createTreeNode(a,s,m){const o=new T.DisposableStore,S=this.createHandle(a,s,m),r=this.getLightIconPath(s);return{item:{handle:S,parentHandle:m?m.item.handle:void 0,label:g(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(o,s.command),contextValue:s.contextValue,icon:r,iconDark:this.getDarkIconPath(s)||r,themeIcon:this.getThemeIcon(s),collapsibleState:(0,A.isUndefinedOrNull)(s.collapsibleState)?C.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:m,children:void 0,disposableStore:o,dispose(){o.dispose()}}}getThemeIcon(a){return a.iconPath instanceof C.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:s,label:m,resourceUri:o},S,r){if(s)return`${L.ID_HANDLE_PREFIX}/${s}`;const i=g(m,this.extension),n=S?S.item.handle:L.LABEL_HANDLE_PREFIX;let u=i?i.label:o?(0,t.basename)(o):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const c=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,d=this.getChildrenNodes(S)||[];let h,w=0;do{if(h=`${n}/${w}:${u}`,r||!this.elements.has(h)||c===h)break;w++}while(w<=d.length);return h}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon))return typeof a.iconPath=="string"||I.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return I.URI.isUri(a)?a:I.URI.file(a)}addNodeToCache(a,s){this.elements.set(s.item.handle,a),this.nodes.set(a,s)}updateNodeCache(a,s,m,o){this.elements.delete(s.item.handle),this.nodes.delete(a),s.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(a,s);const S=this.getChildrenNodes(o)||[],r=S.filter(i=>i.item.handle===m.item.handle)[0];r&&S.splice(S.indexOf(r),1,s)}addNodeToParentCache(a,s){s?(s.children||(s.children=[]),s.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const s=this.nodes.get(a);if(s){if(s.children)for(const m of s.children){const o=this.elements.get(m.item.handle);o&&this.clear(o)}s.children=void 0}}else this.clearAll()}clear(a){const s=this.nodes.get(a);if(s){if(s.children)for(const m of s.children){const o=this.elements.get(m.item.handle);o&&this.clear(o)}this.nodes.delete(a),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}L.LABEL_HANDLE_PREFIX="0",L.ID_HANDLE_PREFIX="1"}),define(pe[280],ve([0,1,21,15,3,47,2,114,109,146,82,42,5,230,229,38,231,36,232,233,234,217,235,45,39,236,237,240,241,242,133,219,247,248,249,90,34,251,279,18,7,254,69,134,35,75,206,239,63,131,71,54,73,11,65,14,26,243,203,51,66,227,252,202,68,67,257,255,256,228,44,250,253,89,53,122,245,70,246,10,190,244,200,238,6,28]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_,a,s,m,o,S,r,i,n,u,c,d,h,w,v,k,O,U,F,M,V,$,N,B,x,z,W,J,se,ie,K,Y,le,fe,Se,Me,Ve,Ge,Ye,q,te,G,Q,oe,me,Ie,xe,Xe,it,st,ot,tt,rt,gt,Ne,It,ee,ne,Ee,re,Ce,Fe,qe,ze,ut,Re,Ae,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ce(de){const we=de.get(Ye.IExtHostInitDataService),ye=de.get(rt.IExtHostFileSystemInfo),Oe=de.get(Xe.IExtHostConsumerFileSystem),Ke=de.get(r.IExtHostExtensionService),We=de.get(W.IExtHostWorkspace),Ze=de.get(ne.IExtHostTelemetry),lt=de.get(L.IExtHostConfiguration),ct=de.get(Ve.IURITransformerService),$e=de.get(Ge.IExtHostRpcService),be=de.get(U.IExtHostStorage),_e=de.get(xe.IExtensionStoragePaths),he=de.get(Me.ILoggerService),X=de.get(Me.ILogService),ke=de.get(G.IExtHostTunnelService),Be=de.get(Q.IExtHostApiDeprecationService),Je=de.get(z.IExtHostWindow),Qe=de.get(It.IExtHostSecretState),pt=de.get(ee.IExtHostEditorTabs);$e.set(l.ExtHostContext.ExtHostFileSystemInfo,ye),$e.set(l.ExtHostContext.ExtHostLogLevelServiceShape,he),$e.set(l.ExtHostContext.ExtHostWorkspace,We),$e.set(l.ExtHostContext.ExtHostConfiguration,lt),$e.set(l.ExtHostContext.ExtHostExtensionService,Ke),$e.set(l.ExtHostContext.ExtHostStorage,be),$e.set(l.ExtHostContext.ExtHostTunnelService,ke),$e.set(l.ExtHostContext.ExtHostWindow,Je),$e.set(l.ExtHostContext.ExtHostSecretState,Qe),$e.set(l.ExtHostContext.ExtHostTelemetry,Ze),$e.set(l.ExtHostContext.ExtHostEditorTabs,pt);const St=$e.set(l.ExtHostContext.ExtHostDecorations,de.get(Y.IExtHostDecorations)),Ct=$e.set(l.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),ft=$e.set(l.ExtHostContext.ExtHostCommands,de.get(g.IExtHostCommands)),wt=$e.set(l.ExtHostContext.ExtHostTerminalService,de.get(F.IExtHostTerminalService)),bt=$e.set(l.ExtHostContext.ExtHostDebugService,de.get(fe.IExtHostDebugService)),Ut=$e.set(l.ExtHostContext.ExtHostSearch,de.get(Se.IExtHostSearch)),Pt=$e.set(l.ExtHostContext.ExtHostTask,de.get(le.IExtHostTask)),Ft=$e.set(l.ExtHostContext.ExtHostOutputService,de.get(h.IExtHostOutputService)),kt=$e.set(l.ExtHostContext.ExtHostUrls,new B.ExtHostUrls($e)),yt=$e.set(l.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments($e,Ct)),Qt=$e.set(l.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider($e,Ct,X)),Vt=$e.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(X,yt,$e.getProxy(l.MainContext.MainThreadBulkEdits))),Et=$e.set(l.ExtHostContext.ExtHostNotebook,new q.ExtHostNotebookController($e,ft,Ct,yt,_e)),Xt=$e.set(l.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(X,Et)),qt=$e.set(l.ExtHostContext.ExtHostNotebookEditors,new ze.ExtHostNotebookEditors(X,$e,Et)),Yt=$e.set(l.ExtHostContext.ExtHostNotebookKernels,new Ee.ExtHostNotebookKernels($e,we,Et,ft,X)),ai=$e.set(l.ExtHostContext.ExtHostNotebookRenderers,new Ce.ExtHostNotebookRenderers($e,Et)),Rt=$e.set(l.ExtHostContext.ExtHostEditors,new M.ExtHostEditors($e,Ct)),Jt=$e.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews($e.getProxy(l.MainContext.MainThreadTreeViews),ft,X)),li=$e.set(l.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets($e.getProxy(l.MainContext.MainThreadEditorInsets),Rt,we)),jt=$e.set(l.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics($e,X,ye)),Zt=$e.set(l.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages($e,yt,ft.converter,ct)),vt=$e.set(l.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures($e,ct,yt,ft,jt,X,Be)),ci=$e.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem($e,vt)),Ot=$e.set(l.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService($e,X,Ct)),Wt=$e.set(l.ExtHostContext.ExtHostQuickOpen,(0,v.createExtHostQuickOpen)($e,We,ft)),vi=$e.set(l.ExtHostContext.ExtHostSCM,new k.ExtHostSCM($e,ft,X)),ui=$e.set(l.ExtHostContext.ExtHostComments,(0,E.createExtHostComments)($e,ft,yt)),ei=$e.set(l.ExtHostContext.ExtHostProgress,new w.ExtHostProgress($e.getProxy(l.MainContext.MainThreadProgress))),yi=$e.set(l.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService($e)),wi=$e.set(l.ExtHostContext.ExtHostTheming,new te.ExtHostTheming($e)),ti=$e.set(l.ExtHostContext.ExtHostAuthentication,new oe.ExtHostAuthentication($e)),Di=$e.set(l.ExtHostContext.ExtHostTimeline,new me.ExtHostTimeline($e,ft)),di=$e.set(l.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews($e,{remote:we.remote},We,X,Be)),Gt=$e.set(l.ExtHostContext.ExtHostWebviewPanels,new ot.ExtHostWebviewPanels($e,di,We)),hi=$e.set(l.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors($e,yt,_e,di,Gt)),ki=$e.set(l.ExtHostContext.ExtHostWebviewViews,new it.ExtHostWebviewViews($e,di)),Kt=$e.set(l.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting($e,ft)),Ii=$e.set(l.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners($e));$e.set(l.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive($e,Et,Ct,ft));const Pi=(0,J.values)(l.ExtHostContext);$e.assertRegistered(Pi);const ii=new tt.ExtHostBulkEdits($e,Ct),Ai=new p.ExtHostClipboard($e),fi=new d.ExtHostMessageService($e,X),bi=new a.ExtHostDialogs($e),ni=new O.ExtHostStatusBar($e,ft.converter);return b.ExtHostApiCommands.register(ft),function(Ue,$t,Bt){const _t=function(){let ae=!Ue.isUnderDevelopment;function ge(){ae||(X.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ae=!0)}return function Te(ht){if(Array.isArray(ht))ht.forEach(Te);else if(typeof ht=="string")ge();else{const Dt=ht;typeof Dt.scheme=="undefined"&&ge(),typeof Dt.exclusive=="boolean"&&(0,De.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return ht}}(),Mt={getSession(ae,ge,Te){return ti.getSession(Ue,ae,ge,Te)},async hasSession(ae,ge){return(0,De.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,ae,ge,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ae,ge,Te,ht){return ti.registerAuthenticationProvider(ae,ge,Te,ht)}},ri={registerCommand(ae,ge,Te){return ft.registerCommand(!0,ae,ge,Te,void 0,Ue)},registerTextEditorCommand(ae,ge,Te){return ft.registerCommand(!0,ae,(...ht)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){X.warn("Cannot execute "+ae+" because there is no active text editor.");return}return Dt.edit(Tt=>{ge.apply(Te,[Dt,Tt,...ht])}).then(Tt=>{Tt||X.warn("Edits from command "+ae+" were not applied.")},Tt=>{X.warn("An error occurred while running command "+ae,Tt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ae,ge,Te)=>((0,De.checkProposedApiEnabled)(Ue,"diffCommand"),ft.registerCommand(!0,ae,async(...ht)=>{const Dt=Ct.activeEditor(!0);if(!Dt){X.warn("Cannot execute "+ae+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Dt.id);ge.apply(Te,[Tt,...ht])},void 0,void 0,Ue)),executeCommand(ae,...ge){return ft.executeCommand(ae,...ge)},getCommands(ae=!1){return ft.getCommands(ae)}},Ei={get machineId(){return we.telemetryInfo.machineId},get sessionId(){return we.telemetryInfo.sessionId},get language(){return we.environment.appLanguage},get appName(){return we.environment.appName},get appRoot(){return we.environment.appRoot?.fsPath??""},get appHost(){return we.environment.appHost},get uriScheme(){return we.environment.appUriScheme},get clipboard(){return Ai.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ae=Date.now()-new Date(we.telemetryInfo.firstSessionDate).getTime();return isNaN(ae)?!1:ae<1e3*60*60*24},openExternal(ae,ge){return Je.openUri(ae,{allowTunneling:!!we.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(ae){if(ae.scheme===we.environment.appUriScheme)return kt.createAppUri(ae);try{return await Je.asExternalUri(ae,{allowTunneling:!!we.remote.authority})}catch(ge){if((0,qe.matchesScheme)(ae,Fe.Schemas.http)||(0,qe.matchesScheme)(ae,Fe.Schemas.https))return ae;throw ge}},get remoteName(){return(0,K.getRemoteName)(we.remote.authority)},get remoteAuthority(){return(0,De.checkProposedApiEnabled)(Ue,"resolvers"),we.remote.authority},get uiKind(){return we.uiKind}};we.environment.extensionTestsLocationURI||Object.freeze(Ei);const Si=we.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Ti={createTestController(ae,ge,Te){return Te&&(0,De.checkProposedApiEnabled)(Ue,"testRefresh"),Kt.createTestController(ae,ge,Te)},createTestObserver(){return(0,De.checkProposedApiEnabled)(Ue,"testObserver"),Kt.createTestObserver()},runTests(ae){return(0,De.checkProposedApiEnabled)(Ue,"testObserver"),Kt.runTests(ae)},get onDidChangeTestResults(){return(0,De.checkProposedApiEnabled)(Ue,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,De.checkProposedApiEnabled)(Ue,"testObserver"),Kt.results}},Ri={getExtension(ae){const ge=$t.getExtensionDescription(ae);if(ge)return new r.Extension(Ke,Ue.identifier,ge,Si)},get all(){return $t.getAllExtensionDescriptions().map(ae=>new r.Extension(Ke,Ue.identifier,ae,Si))},get onDidChange(){return $t.onDidChange}},Li={createDiagnosticCollection(ae){return jt.createDiagnosticCollection(Ue.identifier,ae)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:ae=>jt.getDiagnostics(ae),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(ae,ge){return Zt.changeLanguage(ae.uri,ge)},match(ae,ge){return(0,R.score)($.LanguageSelector.from(ae),ge.uri,ge.languageId,!0)},registerCodeActionsProvider(ae,ge,Te){return vt.registerCodeActionProvider(Ue,_t(ae),ge,Te)},registerCodeLensProvider(ae,ge){return vt.registerCodeLensProvider(Ue,_t(ae),ge)},registerDefinitionProvider(ae,ge){return vt.registerDefinitionProvider(Ue,_t(ae),ge)},registerDeclarationProvider(ae,ge){return vt.registerDeclarationProvider(Ue,_t(ae),ge)},registerImplementationProvider(ae,ge){return vt.registerImplementationProvider(Ue,_t(ae),ge)},registerTypeDefinitionProvider(ae,ge){return vt.registerTypeDefinitionProvider(Ue,_t(ae),ge)},registerHoverProvider(ae,ge){return vt.registerHoverProvider(Ue,_t(ae),ge,Ue.identifier)},registerEvaluatableExpressionProvider(ae,ge){return vt.registerEvaluatableExpressionProvider(Ue,_t(ae),ge,Ue.identifier)},registerInlineValuesProvider(ae,ge){return vt.registerInlineValuesProvider(Ue,_t(ae),ge,Ue.identifier)},registerDocumentHighlightProvider(ae,ge){return vt.registerDocumentHighlightProvider(Ue,_t(ae),ge)},registerLinkedEditingRangeProvider(ae,ge){return vt.registerLinkedEditingRangeProvider(Ue,_t(ae),ge)},registerReferenceProvider(ae,ge){return vt.registerReferenceProvider(Ue,_t(ae),ge)},registerRenameProvider(ae,ge){return vt.registerRenameProvider(Ue,_t(ae),ge)},registerDocumentSymbolProvider(ae,ge,Te){return vt.registerDocumentSymbolProvider(Ue,_t(ae),ge,Te)},registerWorkspaceSymbolProvider(ae){return vt.registerWorkspaceSymbolProvider(Ue,ae)},registerDocumentFormattingEditProvider(ae,ge){return vt.registerDocumentFormattingEditProvider(Ue,_t(ae),ge)},registerDocumentRangeFormattingEditProvider(ae,ge){return vt.registerDocumentRangeFormattingEditProvider(Ue,_t(ae),ge)},registerOnTypeFormattingEditProvider(ae,ge,Te,...ht){return vt.registerOnTypeFormattingEditProvider(Ue,_t(ae),ge,[Te].concat(ht))},registerDocumentSemanticTokensProvider(ae,ge,Te){return vt.registerDocumentSemanticTokensProvider(Ue,_t(ae),ge,Te)},registerDocumentRangeSemanticTokensProvider(ae,ge,Te){return vt.registerDocumentRangeSemanticTokensProvider(Ue,_t(ae),ge,Te)},registerSignatureHelpProvider(ae,ge,Te,...ht){return typeof Te=="object"?vt.registerSignatureHelpProvider(Ue,_t(ae),ge,Te):vt.registerSignatureHelpProvider(Ue,_t(ae),ge,typeof Te=="undefined"?[]:[Te,...ht])},registerCompletionItemProvider(ae,ge,...Te){return vt.registerCompletionItemProvider(Ue,_t(ae),ge,Te)},registerInlineCompletionItemProvider(ae,ge){return(0,De.checkProposedApiEnabled)(Ue,"inlineCompletions"),vt.registerInlineCompletionsProvider(Ue,_t(ae),ge)},registerDocumentLinkProvider(ae,ge){return vt.registerDocumentLinkProvider(Ue,_t(ae),ge)},registerColorProvider(ae,ge){return vt.registerColorProvider(Ue,_t(ae),ge)},registerFoldingRangeProvider(ae,ge){return vt.registerFoldingRangeProvider(Ue,_t(ae),ge)},registerSelectionRangeProvider(ae,ge){return vt.registerSelectionRangeProvider(Ue,ae,ge)},registerCallHierarchyProvider(ae,ge){return vt.registerCallHierarchyProvider(Ue,ae,ge)},registerTypeHierarchyProvider(ae,ge){return vt.registerTypeHierarchyProvider(Ue,ae,ge)},setLanguageConfiguration:(ae,ge)=>vt.setLanguageConfiguration(Ue,ae,ge),getTokenInformationAtPosition(ae,ge){return(0,De.checkProposedApiEnabled)(Ue,"tokenInformation"),Zt.tokenAtPosition(ae,ge)},registerInlayHintsProvider(ae,ge){return(0,De.checkProposedApiEnabled)(Ue,"inlayHints"),vt.registerInlayHintsProvider(Ue,ae,ge)},createLanguageStatusItem(ae,ge){return(0,De.checkProposedApiEnabled)(Ue,"languageStatus"),Zt.createLanguageStatusItem(Ue,ae,ge)}},Fi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(ae,ge,Te){const ht=await(T.URI.isUri(ae)?Promise.resolve(_i.openTextDocument(ae)):Promise.resolve(ae));return Rt.showTextDocument(ht,ge,Te)},createTextEditorDecorationType(ae){return Rt.createTextEditorDecorationType(Ue,ae)},onDidChangeActiveTextEditor(ae,ge,Te){return Rt.onDidChangeActiveTextEditor(ae,ge,Te)},onDidChangeVisibleTextEditors(ae,ge,Te){return Rt.onDidChangeVisibleTextEditors(ae,ge,Te)},onDidChangeTextEditorSelection(ae,ge,Te){return Rt.onDidChangeTextEditorSelection(ae,ge,Te)},onDidChangeTextEditorOptions(ae,ge,Te){return Rt.onDidChangeTextEditorOptions(ae,ge,Te)},onDidChangeTextEditorVisibleRanges(ae,ge,Te){return Rt.onDidChangeTextEditorVisibleRanges(ae,ge,Te)},onDidChangeTextEditorViewColumn(ae,ge,Te){return Rt.onDidChangeTextEditorViewColumn(ae,ge,Te)},onDidCloseTerminal(ae,ge,Te){return wt.onDidCloseTerminal(ae,ge,Te)},onDidOpenTerminal(ae,ge,Te){return wt.onDidOpenTerminal(ae,ge,Te)},onDidChangeActiveTerminal(ae,ge,Te){return wt.onDidChangeActiveTerminal(ae,ge,Te)},onDidChangeTerminalDimensions(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"terminalDimensions"),wt.onDidChangeTerminalDimensions(ae,ge,Te)},onDidChangeTerminalState(ae,ge,Te){return wt.onDidChangeTerminalState(ae,ge,Te)},onDidWriteTerminalData(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(ae,ge,Te)},get state(){return Je.state},onDidChangeWindowState(ae,ge,Te){return Je.onDidChangeWindowState(ae,ge,Te)},showInformationMessage(ae,...ge){return fi.showMessage(Ue,D.default.Info,ae,ge[0],ge.slice(1))},showWarningMessage(ae,...ge){return fi.showMessage(Ue,D.default.Warning,ae,ge[0],ge.slice(1))},showErrorMessage(ae,...ge){return fi.showMessage(Ue,D.default.Error,ae,ge[0],ge.slice(1))},showQuickPick(ae,ge,Te){return Array.isArray(ae)&&ae.some(ht=>ht.kind===N.QuickPickItemKind.Separator)&&(0,De.checkProposedApiEnabled)(Ue,"quickPickSeparators"),Wt.showQuickPick(ae,ge,Te)},showWorkspaceFolderPick(ae){return Wt.showWorkspaceFolderPick(ae)},showInputBox(ae,ge){return Wt.showInput(ae,ge)},showOpenDialog(ae){return bi.showOpenDialog(ae)},showSaveDialog(ae){return bi.showSaveDialog(ae)},createStatusBarItem(ae,ge,Te){let ht,Dt,Tt;return typeof ae=="string"?(ht=ae,Dt=ge,Tt=Te):(Dt=ae,Tt=ge),ni.createStatusBarEntry(Ue,ht,Dt,Tt)},setStatusBarMessage(ae,ge){return ni.setStatusBarMessage(ae,ge)},withScmProgress(ae){return Be.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ei.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(ge,Te)=>ae({report(ht){}}))},withProgress(ae,ge){return ei.withProgress(Ue,ae,ge)},createOutputChannel(ae){return Ft.createOutputChannel(ae,Ue)},createWebviewPanel(ae,ge,Te,ht){return Gt.createWebviewPanel(Ue,ae,ge,Te,ht)},createWebviewTextEditorInset(ae,ge,Te,ht){return(0,De.checkProposedApiEnabled)(Ue,"editorInsets"),li.createWebviewEditorInset(ae,ge,Te,ht,Ue)},createTerminal(ae,ge,Te){return typeof ae=="object"?"pty"in ae?wt.createExtensionTerminal(ae):wt.createTerminalFromOptions(ae):wt.createTerminal(ae,ge,Te)},registerTerminalLinkProvider(ae){return wt.registerLinkProvider(ae)},registerTerminalProfileProvider(ae,ge){return wt.registerProfileProvider(Ue,ae,ge)},registerTreeDataProvider(ae,ge){return Jt.registerTreeDataProvider(ae,ge,Ue)},createTreeView(ae,ge){return Jt.createTreeView(ae,ge,Ue)},registerWebviewPanelSerializer:(ae,ge)=>Gt.registerWebviewPanelSerializer(Ue,ae,ge),registerCustomEditorProvider:(ae,ge,Te={})=>hi.registerCustomEditorProvider(Ue,ae,ge,Te),registerFileDecorationProvider(ae){return St.registerFileDecorationProvider(ae,Ue.identifier)},registerUriHandler(ae){return kt.registerUriHandler(Ue.identifier,ae)},createQuickPick(){return Wt.createQuickPick(Ue)},createInputBox(){return Wt.createInputBox(Ue.identifier)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(ae,ge,Te){return wi.onDidChangeActiveColorTheme(ae,ge,Te)},registerWebviewViewProvider(ae,ge,Te){return ki.registerWebviewViewProvider(Ue,ae,ge,Te?.webviewOptions)},get activeNotebookEditor(){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(ae,ge,Te)},get visibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(ae,ge,Te)},onDidChangeNotebookEditorVisibleRanges(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(ae,ge,Te)},showNotebookDocument(ae,ge){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Et.showNotebookDocument(ae,ge)},registerExternalUriOpener(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ii.registerExternalUriOpener(Ue.identifier,ae,ge,Te)},get tabs(){return(0,De.checkProposedApiEnabled)(Ue,"tabs"),pt.tabs},get activeTab(){return(0,De.checkProposedApiEnabled)(Ue,"tabs"),pt.activeTab},get onDidChangeTabs(){return(0,De.checkProposedApiEnabled)(Ue,"tabs"),pt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,De.checkProposedApiEnabled)(Ue,"tabs"),pt.onDidChangeActiveTab},getInlineCompletionItemController(ae){return(0,De.checkProposedApiEnabled)(Ue,"inlineCompletions"),u.InlineCompletionController.get(ae)}},_i={get rootPath(){return Be.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),We.getPath()},set rootPath(ae){throw t.readonly()},getWorkspaceFolder(ae){return We.getWorkspaceFolder(ae)},get workspaceFolders(){return We.getWorkspaceFolders()},get name(){return We.name},set name(ae){throw t.readonly()},get workspaceFile(){return We.workspaceFile},set workspaceFile(ae){throw t.readonly()},updateWorkspaceFolders:(ae,ge,...Te)=>We.updateWorkspaceFolders(Ue,ae,ge||0,...Te),onDidChangeWorkspaceFolders:function(ae,ge,Te){return We.onDidChangeWorkspace(ae,ge,Te)},asRelativePath:(ae,ge)=>We.getRelativePath(ae,ge),findFiles:(ae,ge,Te,ht)=>We.findFiles($.GlobPattern.from(ae),$.GlobPattern.from(ge),Te,Ue.identifier,ht),findTextInFiles:(ae,ge,Te,ht)=>{(0,De.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Tt;return typeof ge=="object"?(Dt=ge,Tt=Te):(Dt={},Tt=ge,ht=Te),We.findTextInFiles(ae,Dt||{},Tt,Ue.identifier,ht)},saveAll:ae=>We.saveAll(ae),applyEdit(ae){return ii.applyWorkspaceEdit(ae)},createFileSystemWatcher:(ae,ge,Te,ht)=>Ot.createFileSystemWatcher(We,Ue,$.GlobPattern.from(ae),ge,Te,ht),get textDocuments(){return yt.getAllDocumentData().map(ae=>ae.document)},set textDocuments(ae){throw t.readonly()},openTextDocument(ae){let ge;const Te=ae;if(typeof ae=="string")ge=Promise.resolve(T.URI.file(ae));else if(T.URI.isUri(ae))ge=Promise.resolve(ae);else if(!Te||typeof Te=="object")ge=yt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ht=>yt.ensureDocumentData(ht).then(Dt=>Dt.document))},onDidOpenTextDocument:(ae,ge,Te)=>yt.onDidAddDocument(ae,ge,Te),onDidCloseTextDocument:(ae,ge,Te)=>yt.onDidRemoveDocument(ae,ge,Te),onDidChangeTextDocument:(ae,ge,Te)=>yt.onDidChangeDocument(ae,ge,Te),onDidSaveTextDocument:(ae,ge,Te)=>yt.onDidSaveDocument(ae,ge,Te),onWillSaveTextDocument:(ae,ge,Te)=>Vt.getOnWillSaveTextDocumentEvent(Ue)(ae,ge,Te),get notebookDocuments(){return Et.notebookDocuments.map(ae=>ae.apiNotebook)},async openNotebookDocument(ae,ge){let Te;if(T.URI.isUri(ae))Te=ae,await Et.openNotebookDocument(ae);else if(typeof ae=="string")Te=T.URI.revive(await Et.createNotebookDocument({viewType:ae,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ae,ge,Te,ht){return Et.registerNotebookSerializer(Ue,ae,ge,Te,(0,De.isProposedApiEnabled)(Ue,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(ae,ge,Te,ht)=>((0,De.checkProposedApiEnabled)(Ue,"notebookContentProvider"),Et.registerNotebookContentProvider(Ue,ae,ge,Te,(0,De.isProposedApiEnabled)(Ue,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(ae,ge,Te)=>Bt.onDidChangeConfiguration(ae,ge,Te),getConfiguration(ae,ge){return ge=arguments.length===1?void 0:ge,Bt.getConfiguration(ae,ge,Ue)},registerTextDocumentContentProvider(ae,ge){return Qt.registerTextDocumentContentProvider(ae,ge)},registerTaskProvider:(ae,ge)=>(Be.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Ue,ae,ge)),registerFileSystemProvider(ae,ge,Te){return(0,Ae.combinedDisposable)(ci.registerFileSystemProvider(Ue,ae,ge,Te),Oe.addFileSystemProvider(ae,ge))},get fs(){return Oe.value},registerFileSearchProvider:(ae,ge)=>((0,De.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Ut.registerFileSearchProvider(ae,ge)),registerTextSearchProvider:(ae,ge)=>((0,De.checkProposedApiEnabled)(Ue,"textSearchProvider"),Ut.registerTextSearchProvider(ae,ge)),registerRemoteAuthorityResolver:(ae,ge)=>((0,De.checkProposedApiEnabled)(Ue,"resolvers"),Ke.registerRemoteAuthorityResolver(ae,ge)),registerResourceLabelFormatter:ae=>((0,De.checkProposedApiEnabled)(Ue,"resolvers"),yi.$registerResourceLabelFormatter(ae)),onDidCreateFiles:(ae,ge,Te)=>Ot.onDidCreateFile(ae,ge,Te),onDidDeleteFiles:(ae,ge,Te)=>Ot.onDidDeleteFile(ae,ge,Te),onDidRenameFiles:(ae,ge,Te)=>Ot.onDidRenameFile(ae,ge,Te),onWillCreateFiles:(ae,ge,Te)=>Ot.getOnWillCreateFileEvent(Ue)(ae,ge,Te),onWillDeleteFiles:(ae,ge,Te)=>Ot.getOnWillDeleteFileEvent(Ue)(ae,ge,Te),onWillRenameFiles:(ae,ge,Te)=>Ot.getOnWillRenameFileEvent(Ue)(ae,ge,Te),openTunnel:ae=>((0,De.checkProposedApiEnabled)(Ue,"resolvers"),ke.openTunnel(Ue,ae).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,De.checkProposedApiEnabled)(Ue,"resolvers"),ke.getTunnels()},onDidChangeTunnels:(ae,ge,Te)=>((0,De.checkProposedApiEnabled)(Ue,"resolvers"),ke.onDidChangeTunnels(ae,ge,Te)),registerPortAttributesProvider:(ae,ge)=>((0,De.checkProposedApiEnabled)(Ue,"portsAttributes"),ke.registerPortsAttributesProvider(ae,ge)),registerTimelineProvider:(ae,ge)=>((0,De.checkProposedApiEnabled)(Ue,"timeline"),Di.registerTimelineProvider(ae,ge,Ue.identifier,ft.converter)),get isTrusted(){return We.trusted},requestWorkspaceTrust:ae=>((0,De.checkProposedApiEnabled)(Ue,"workspaceTrust"),We.requestWorkspaceTrust(ae)),onDidGrantWorkspaceTrust:(ae,ge,Te)=>We.onDidGrantWorkspaceTrust(ae,ge,Te)},mi={get inputBox(){return Be.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ue)},createSourceControl(ae,ge,Te){return vi.createSourceControl(Ue,ae,ge,Te)}},Mi={createCommentController(ae,ge){return ui.createCommentController(Ue,ae,ge)}},Oi={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(ae,ge,Te){return bt.onDidStartDebugSession(ae,ge,Te)},onDidTerminateDebugSession(ae,ge,Te){return bt.onDidTerminateDebugSession(ae,ge,Te)},onDidChangeActiveDebugSession(ae,ge,Te){return bt.onDidChangeActiveDebugSession(ae,ge,Te)},onDidReceiveDebugSessionCustomEvent(ae,ge,Te){return bt.onDidReceiveDebugSessionCustomEvent(ae,ge,Te)},onDidChangeBreakpoints(ae,ge,Te){return bt.onDidChangeBreakpoints(ae,ge,Te)},registerDebugConfigurationProvider(ae,ge,Te){return bt.registerDebugConfigurationProvider(ae,ge,Te||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ae,ge){return bt.registerDebugAdapterDescriptorFactory(Ue,ae,ge)},registerDebugAdapterTrackerFactory(ae,ge){return bt.registerDebugAdapterTrackerFactory(ae,ge)},startDebugging(ae,ge,Te){return!Te||typeof Te=="object"&&"configuration"in Te?bt.startDebugging(ae,ge,{parentSession:Te}):bt.startDebugging(ae,ge,Te||{})},stopDebugging(ae){return bt.stopDebugging(ae)},addBreakpoints(ae){return bt.addBreakpoints(ae)},removeBreakpoints(ae){return bt.removeBreakpoints(ae)},asDebugSourceUri(ae,ge){return bt.asDebugSourceUri(ae,ge)}},Ni={registerTaskProvider:(ae,ge)=>Pt.registerTaskProvider(Ue,ae,ge),fetchTasks:ae=>Pt.fetchTasks(ae),executeTask:ae=>Pt.executeTask(Ue,ae),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(ae,ge,Te)=>Pt.onDidStartTask(ae,ge,Te),onDidEndTask:(ae,ge,Te)=>Pt.onDidEndTask(ae,ge,Te),onDidStartTaskProcess:(ae,ge,Te)=>Pt.onDidStartTaskProcess(ae,ge,Te),onDidEndTaskProcess:(ae,ge,Te)=>Pt.onDidEndTaskProcess(ae,ge,Te)},Ui={createNotebookController(ae,ge,Te,ht,Dt){return Yt.createNotebookController(Ue,ae,ge,Te,ht,(0,De.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ae,ge)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ae,ge),get onDidSaveNotebookDocument(){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ae){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(ae)},createRendererMessaging(ae){return ai.createRendererMessaging(Ue,ae)},onDidChangeNotebookDocumentMetadata(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Xt.onDidChangeNotebookDocumentMetadata(ae,ge,Te)},onDidChangeNotebookCells(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Et.onDidChangeNotebookCells(ae,ge,Te)},onDidChangeNotebookCellExecutionState(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(ae,ge,Te)},onDidChangeCellOutputs(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Et.onDidChangeCellOutputs(ae,ge,Te)},onDidChangeCellMetadata(ae,ge,Te){return(0,De.checkProposedApiEnabled)(Ue,"notebookEditor"),Et.onDidChangeCellMetadata(ae,ge,Te)},createConcatTextDocument(ae,ge){return(0,De.checkProposedApiEnabled)(Ue,"notebookConcatTextDocument"),new Ie.ExtHostNotebookConcatDocument(Et,yt,ae,ge)}};return{version:we.version,authentication:Mt,commands:ri,comments:Mi,debug:Oi,env:Ei,extensions:Ri,languages:Li,notebooks:Ui,scm:mi,tasks:Ni,tests:Ti,window:Fi,workspace:_i,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:A.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:l.UIKind,Uri:T.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:re.TextSearchCompleteMessageType,TreeDataTransfer:N.TreeDataTransfer,TreeDataTransferItem:N.TreeDataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ce}),define(pe[281],ve([0,1,282,293,294,2,295]),function(Z,e,f,t,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(y,l,b,p,g,E){const L=E.environment.useHostProxy,_=typeof L=="boolean"?L:!E.remote.isRemote,a=(0,T.createProxyResolver)({resolveProxy:m=>y.resolveProxy(m),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(m,o,...S)=>{switch(m){case T.LogLevel.Trace:p.trace(o,...S);break;case T.LogLevel.Debug:p.debug(o,...S);break;case T.LogLevel.Info:p.info(o,...S);break;case T.LogLevel.Warning:p.warn(o,...S);break;case T.LogLevel.Error:p.error(o,...S);break;case T.LogLevel.Critical:p.critical(o,...S);break;case T.LogLevel.Off:break;default:r(m,o,S);break}function r(i,n,...u){p.error("Unknown log level",i),p.error(n,...u)}},getLogLevel:()=>p.getLevel(),proxyResolveTelemetry:m=>{g.$publicLog2("resolveProxy",m)},useHostProxy:_,env:process.env}),s=C(l,a);return R(b,s)}e.connectProxyResolver=P;function C(y,l){const b={config:y.getConfiguration("http").get("proxySupport")||"off"};y.onDidChangeConfiguration(g=>{b.config=y.getConfiguration("http").get("proxySupport")||"off"});const p={config:!!y.getConfiguration("http").get("systemCertificates")};return y.onDidChangeConfiguration(g=>{p.config=!!y.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,T.createHttpPatch)(f,l,{config:"off"},p,!0)),on:Object.assign({},f,(0,T.createHttpPatch)(f,l,{config:"on"},p,!0)),override:Object.assign({},f,(0,T.createHttpPatch)(f,l,{config:"override"},p,!0)),onRequest:Object.assign({},f,(0,T.createHttpPatch)(f,l,b,p,!0)),default:Object.assign(f,(0,T.createHttpPatch)(f,l,b,p,!1))},https:{off:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"off"},p,!0)),on:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"on"},p,!0)),override:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"override"},p,!0)),onRequest:Object.assign({},t,(0,T.createHttpPatch)(t,l,b,p,!0)),default:Object.assign(t,(0,T.createHttpPatch)(t,l,b,p,!1))},tls:Object.assign(I,(0,T.createTlsPatch)(I))}}const A=new Map;function R(y,l){return y.getExtensionPathIndex().then(b=>{const p=Z.__$__nodeRequire("module"),g=p._load;p._load=function(L,_,a){if(L==="tls")return l.tls;if(L!=="http"&&L!=="https")return g.apply(this,arguments);const s=l[L],m=b.findSubstr(D.URI.file(_.filename));let o=A.get(m);if(o||A.set(m,o={}),!o[L]){let S=s.default;o[L]={...S}}return o[L]}})}}),define(pe[137],ve([0,1,37,296,104,16,75,32,9,8,2,31,70,297,275,91]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class L{constructor(h){this.outputChannel=h}provideTextSearchResults(h,w,v,k){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((O,U)=>{k.onCancellationRequested(()=>z());const F=S(h,w),M=w.folder.fsPath,V=F.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.outputChannel.appendLine(`${E} ${V}
 - cwd: ${M}`);let $=f.spawn(E,F,{cwd:M});$.on("error",K=>{console.error(K),this.outputChannel.appendLine("Error: "+(K&&K.message)),U((0,y.serializeSearchError)(new y.SearchError(K&&K.message,y.SearchErrorCode.rgProcessError)))});let N=!1;const B=new s(w.maxResults,M,w.previewOptions);B.on("result",K=>{N=!0,J="",v.report(K)});let x=!1;const z=()=>{x=!0,$&&$.kill(),B&&B.cancel()};let W=!1;B.on("hitLimit",()=>{W=!0,z()});let J="";$.stdout.on("data",K=>{B.handleData(K),N||(J+=K)});let se=!1;$.stdout.once("data",()=>se=!0);let ie="";$.stderr.on("data",K=>{const Y=K.toString();this.outputChannel.appendLine(Y),ie+=Y}),$.on("close",()=>{if(this.outputChannel.appendLine(se?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),J&&this.outputChannel.appendLine(`Got data without result: ${J}`),this.outputChannel.appendLine(""),x)O({limitHit:W});else{B.flush(),$=null;let K;ie&&!se&&(K=_(ie))?U((0,y.serializeSearchError)(new y.SearchError(K.message,K.code))):O({limitHit:W})}})})}}e.RipgrepTextSearchEngine=L;function _(d){const h=d.split(`
`),w=h[0].trim();if(h.some(k=>k.startsWith("regex parse error")))return new y.SearchError(a(h),y.SearchErrorCode.regexParseError);const v=w.match(/grep config error: unknown encoding: (.*)/);if(v)return new y.SearchError(`Unknown encoding: ${v[1]}`,y.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new y.SearchError(w.charAt(0).toUpperCase()+w.substr(1),y.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new y.SearchError(w.charAt(0).toUpperCase()+w.substr(1),y.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new y.SearchError(w,y.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function a(d){const h=["Regex parse error"],w=d.filter(v=>v.startsWith("PCRE2:"));if(w.length>=1){const v=w[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const k=v.split(":")[1];h.push(":"+k)}}return h.join("")}e.buildRegexParseError=a;class s extends t.EventEmitter{constructor(h,w,v){super();this.maxResults=h,this.rootFolder=w,this.previewOptions=v,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,w){return super.on(h,w),this}handleData(h){if(this.isDone)return;const w=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(w)}handleDecodedData(h){let w=h.indexOf(`
`);const v=this.remainder+h;if(w>=0)w+=this.remainder.length;else{this.remainder=v;return}let k=0;for(;w>=0;)this.handleLine(v.substring(k,w).trim()),k=w+1,w=v.indexOf(`
`,k);this.remainder=v.substring(k)}handleLine(h){if(this.isDone||!h)return;let w;try{w=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(w.type==="match"){const v=m(w.data.path),k=R.URI.file(C.join(this.rootFolder,v)),O=this.createTextSearchMatch(w.data,k);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const v=m(w.data.path),k=R.URI.file(C.join(this.rootFolder,v));this.createTextSearchContext(w.data,k).forEach(U=>this.onResult(U))}}createTextSearchMatch(h,w){const v=h.line_number-1,k=m(h.lines),O=Buffer.from(k);let U=0,F=0,M=v;h.submatches.length===0&&h.submatches.push(k.length?{start:0,end:1,match:{text:k[0]}}:{start:0,end:0,match:{text:""}});const V=(0,D.coalesce)(h.submatches.map(($,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=m($.match),x=O.slice(U,$.start).toString().length,z=F+x,W=o(B),J=M,se=W.numLines+J,ie=W.numLines>0?W.lastLineLength:W.lastLineLength+z;return U=$.end,F=ie,M=se,new l.Range(J,z,se,ie)}));return(0,g.createTextSearchResult)(w,k,V,this.previewOptions)}createTextSearchContext(h,w){const v=m(h.lines),k=h.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((O,U)=>({text:O,uri:w,lineNumber:k+U}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=s;function m(d){return d.bytes?Buffer.from(d.bytes,"base64").toString():d.text}function o(d){const h=/\n/g;let w=0,v=-1,k;for(;k=h.exec(d);)w++,v=k.index;const O=v>=0?d.length-v-1:d.length;return{numLines:w,lastLineLength:O}}function S(d,h){const w=["--hidden"];w.push(d.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:k}=(0,T.groupBy)(h.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(k&&k.length){const U=new Set;k.forEach(F=>{U.add(F)}),w.push("-g","!*"),U.forEach(F=>{r(F).map(g.anchorGlob).forEach(M=>{w.push("-g",M)})})}v&&v.length&&v.forEach(U=>{w.push("-g",U)}),h.excludes.map(g.anchorGlob).forEach(U=>w.push("-g",`!${U}`)),h.maxFileSize&&w.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),h.followSymlinks&&w.push("--follow"),h.encoding&&h.encoding!=="utf8"&&w.push("--encoding",h.encoding),d.pattern==="--"&&(d.isRegExp=!0,d.pattern="\\-\\-"),d.isMultiline&&!d.isRegExp&&(d.pattern=(0,A.escapeRegExpCharacters)(d.pattern),d.isRegExp=!0),h.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),d.isRegExp&&(d.pattern=i(d.pattern),w.push("--engine","auto"));let O;if(d.isWordMatch){const F=(0,A.createRegExp)(d.pattern,!!d.isRegExp,{wholeWord:d.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",F)}else if(d.isRegExp){let U=u(d.pattern);U=c(U),w.push("--regexp",U)}else O=d.pattern,w.push("--fixed-strings");return w.push("--no-config"),h.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),d.isMultiline&&w.push("--multiline"),h.beforeContext&&w.push("--before-context",h.beforeContext+""),h.afterContext&&w.push("--after-context",h.afterContext+""),w.push("--"),O&&w.push(O),w.push("."),w}function r(d){const h=(0,P.splitGlobAware)(d,"/");return h.map((w,v)=>h.slice(0,v+1).join("/"))}e.spreadGlobComponents=r;function i(d){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;d.match(h);)d=d.replace(h,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;d.match(w);)d=d.replace(w,"$1\\x{$2}");return d}e.unicodeEscapesToPCRE2=i;const n=d=>d.type==="Assertion"&&d.kind==="lookbehind";function u(d){let h;try{h=new b.RegExpParser().parsePattern(d)}catch{return d}let w="",v=0;const k=(F,M,V)=>{w+=d.slice(v,F)+V,v=M},O=[];return new b.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const M=O[0];if(!M)k(F.start,F.end,"\\r?\\n");else if(!O.some(n))if(M.type==="CharacterClass")if(M.negate){const V=d.slice(M.start+2,F.start)+d.slice(F.end,M.end-1);if(M.parent?.type==="Quantifier"){const $=M.parent;k($.start,$.end,(V?`[^${V}]`:".")+($.greedy?"+":"*"))}else k(M.start,M.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=d.slice(M.start+1,F.start)+d.slice(F.end,M.end-1);k(M.start,M.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else M.type==="Quantifier"&&k(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){O.unshift(F)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(F){O.unshift(F)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(F){O.unshift(F)},onCharacterClassLeave(){O.shift()},onAssertionEnter(F){n(F)&&O.push(F)},onAssertionLeave(F){O[0]===F&&O.shift()}}).visit(h),w+=d.slice(v),w}e.fixRegexNewline=u;function c(d){return d.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(pe[283],ve([0,1,21,137,118,10]),function(Z,e,f,t,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,R,y,l){const b=new t.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===D.Schemas.userData){const p={...R,folder:R.folder.with({scheme:D.Schemas.file})},g=new I.Progress(E=>y.report({...E,uri:E.uri.with({scheme:R.folder.scheme})}));return this.withToken(l,E=>b.provideTextSearchResults(A,p,g,E))}else return this.withToken(l,p=>b.provideTextSearchResults(A,R,y,p))}async withToken(A,R){const y=P(A);this.inProgress.add(y);const l=await R(y.token);return this.inProgress.delete(y),l}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=T;function P(C){const A=new f.CancellationTokenSource;return C.onCancellationRequested(()=>A.cancel()),A}}),define(pe[284],ve([0,1,30,137,136]),function(Z,e,f,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class D{constructor(C){this.query=C}search(C,A,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const y={appendLine(b){R({message:b})}},l=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(y),f);return new Promise((b,p)=>l.search(g=>{A(g.map(T))},C).then(g=>b({limitHit:g.limitHit,type:"success",stats:g.stats}),p))}}e.TextSearchEngineAdapter=D;function T(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((C,A)=>{if(A.ranges){const R=A;return C+(Array.isArray(R.ranges)?R.ranges.length:1)}else return C+1},0)}}}),define(pe[285],ve([0,1,16,17,15,3,102,9,46,2,42,31,276,284]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class p{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let m;const o=L(s),S=new D.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(r=>this.doFileSearchWithEngine(l.Engine,o,i=>S.fire(i),r)),m.then(r=>S.fire(r),r=>S.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return S.event}textSearch(s){let m;const o=L(s),S=new D.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(r=>this.ripgrepTextSearch(o,i=>S.fire(i),r)),m.then(r=>S.fire(r),r=>S.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return S.event}ripgrepTextSearch(s,m,o){return s.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(s).search(o,m,m)}doFileSearch(s,m,o){return this.doFileSearchWithEngine(l.Engine,s,m,o)}doFileSearchWithEngine(s,m,o,S,r=p.BATCH_SIZE){let i=0;const n=c=>{Array.isArray(c)?(i+=c.length,o(c.map(d=>this.rawMatchToSearchItem(d)))):c.relativePath?(i++,o(this.rawMatchToSearchItem(c))):o(c)};if(m.sortByScore){let c=this.trySortedSearchFromCache(m,n,S);if(!c){const d=m.maxResults?Object.assign({},m,{maxResults:null}):m,h=new s(d);c=this.doSortedSearch(h,m,o,n,S)}return new Promise((d,h)=>{c.then(([w,v])=>{const k=v.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(k,o,r),d(w)},h)})}const u=new s(m);return this.doSearch(u,n,r,S).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,P.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,m,o,S,r){const i=new D.Emitter;let n=(0,t.createCancelablePromise)(c=>{let d=[];const h=w=>{Array.isArray(w)?d=w:(S(w),i.fire(w))};return this.doSearch(s,h,-1,c).then(w=>[w,d])}),u;if(m.cacheKey){u=this.getOrCreateCache(m.cacheKey);const c={promise:n,event:i.event,resolved:!1};u.resultsToSearchCache[m.filePattern||""]=c,n.then(()=>{c.resolved=!0},d=>{delete u.resultsToSearchCache[m.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([c,d])=>{const h=u?u.scorerCache:Object.create(null),w=(typeof m.maxResults!="number"||m.maxResults>0)&&C.StopWatch.create(!1);return this.sortResults(m,d,h,r).then(v=>{const k=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:k,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:v.length},messages:c.messages,limitHit:c.limitHit||typeof m.maxResults=="number"&&d.length>m.maxResults},v]})})}getOrCreateCache(s){const m=this.caches[s];return m||(this.caches[s]=new g)}trySortedSearchFromCache(s,m,o){const S=s.cacheKey&&this.caches[s.cacheKey];if(!S)return;const r=this.getResultsFromCache(S,s.filePattern||"",m,o);if(r)return r.then(([i,n,u])=>{const c=C.StopWatch.create(!1);return this.sortResults(s,n,S.scorerCache,o).then(d=>{const h=c.elapsed(),w={fromCache:!0,detailStats:u,type:this.processType,resultCount:n.length,sortingTime:h};return[{type:"success",limitHit:i.limitHit||typeof s.maxResults=="number"&&n.length>s.maxResults,stats:w},d]})})}sortResults(s,m,o,S){const r=(0,T.prepareQuery)(s.filePattern||""),i=(u,c)=>(0,T.compareItemsByFuzzyScore)(u,c,r,!0,E,o),n=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return f.topAsync(m,i,n,1e4,S)}sendProgress(s,m,o){if(o&&o>0)for(let S=0;S<s.length;S+=o)m(s.slice(S,S+o));else m(s)}getResultsFromCache(s,m,o,S){const r=C.StopWatch.create(!1),i=m.indexOf(P.sep)>=0;let n;for(const h in s.resultsToSearchCache)if(m.startsWith(h)){if(i&&h.indexOf(P.sep)<0&&h!=="")continue;const w=s.resultsToSearchCache[h];n={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!n)return null;const u=r.elapsed(),c=C.StopWatch.create(!1),d=n.event(o);return S&&S.onCancellationRequested(()=>{d.dispose()}),n.promise.then(([h,w])=>{if(S&&S.isCancellationRequested)throw(0,I.canceled)();const v=[],k=(0,T.prepareQuery)(m).normalizedLowercase;for(const O of w)!(0,y.isFilePatternMatch)(O,k)||v.push(O);return[h,v,{cacheWasResolved:n.resolved,cacheLookupTime:u,cacheFilterTime:c.elapsed(),cacheEntryCount:w.length}]})}doSearch(s,m,o,S){return new Promise((r,i)=>{let n=[];S&&S.onCancellationRequested(()=>s.cancel()),s.search(u=>{u&&(o?(n.push(u),o>0&&n.length>=o&&(m(n),n=[])):m(u))},u=>{m(u)},(u,c)=>{n.length&&m(n),u?i(u):r(c)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,o){return s.then(m,o)}catch(m){return this.then(void 0,m)}finally(m){return s.finally(m)}}}}e.SearchService=p,p.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(a){return(0,P.basename)(a.relativePath)}getItemDescription(a){return(0,P.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function L(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(_),extraFileResources:a.extraFileResources&&a.extraFileResources.map(s=>A.URI.revive(s))}}function _(a){return{...a,folder:A.URI.revive(a.folder)}}}),define(pe[286],ve([0,1,6,10,2,30,11,26,14,73,65,31,285,283,91,136]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends A.ExtHostSearch{constructor(_,a,s,m){super(_,s,m);this._pfs=D,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new p.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new b.RipgrepSearchProvider(o)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const _=new p.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new b.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(t.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(_,a){const s=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(_)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(_,a,s,m){const o=(0,A.reviveQuery)(s);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,a,o,m):super.$provideFileSearchResults(_,a,s,m)}doInternalFileSearch(_,a,s,m){const o=S=>{if((0,y.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(_,a,S.map(r=>I.URI.file(r.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,o,m)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,a){return new g.NativeTextSearchManager(_,a,void 0,"textSearchProvider")}};E=je([He(0,C.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,R.IURITransformerService),He(3,T.ILogService)],E),e.NativeExtHostSearch=E}),define(pe[138],ve([0,1,298,125,81,22,15,3,6,9,12,33,106,107,299]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(w,v=""){this.debugLabel=v,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=k=>{if(this.traceSocketEvent("error",{code:k?.code,message:k?.message}),k){if(k.code==="EPIPE")return;(0,T.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}traceSocketEvent(w,v){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,v)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const v=k=>{this.traceSocketEvent("read",k),w(D.VSBuffer.wrap(k))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(w){const v=k=>{this.traceSocketEvent("close",{hadError:k}),w({type:0,hadError:k,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(w){const v=()=>{this.traceSocketEvent("nodeEndReceived"),w()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(w){if(!this.socket.destroyed)try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,T.onUnexpectedError)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,T.onUnexpectedError)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const k=()=>{this.socket.off("close",k),this.socket.off("end",k),this.socket.off("error",k),this.socket.off("timeout",k),this.socket.off("drain",k),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",k),this.socket.on("end",k),this.socket.on("error",k),this.socket.on("timeout",k),this.socket.on("drain",k)})}}e.NodeSocket=g;var E;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var L;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(L||(L={}));class _ extends C.Disposable{constructor(w,v,k,O){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:k?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new a(this,v,k,O,this._onData,(U,F)=>this._write(U,F))),this._register(this._flowManager.onError(U=>{console.error(U),(0,T.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,v){this.socket.traceSocketEvent(w,v)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._flowManager.writeMessage(w)}_write(w,v){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let k=2;w.byteLength<126?k+=0:w.byteLength<2**16?k+=2:k+=8;const O=D.VSBuffer.alloc(k);if(v?O.writeUInt8(194,0):O.writeUInt8(130,0),w.byteLength<126)O.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){O.writeUInt8(126,1);let U=1;O.writeUInt8(w.byteLength>>>8&255,++U),O.writeUInt8(w.byteLength>>>0&255,++U)}else{O.writeUInt8(127,1);let U=1;O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(w.byteLength>>>24&255,++U),O.writeUInt8(w.byteLength>>>16&255,++U),O.writeUInt8(w.byteLength>>>8&255,++U),O.writeUInt8(w.byteLength>>>0&255,++U)}this.socket.write(D.VSBuffer.concat([O,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const v=this._incomingData.peek(this._state.readLen),k=v.readUInt8(0),O=(k&128)>>>7,U=(k&64)>>>6,F=v.readUInt8(1),M=(F&128)>>>7,V=F&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(U)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const v=this._incomingData.read(this._state.readLen),k=v.readUInt8(1),O=(k&128)>>>7;let U=k&127,F=1;U===126?U=v.readUInt8(++F)*2**8+v.readUInt8(++F):U===127&&(U=v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F));let M=0;O&&(M=v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F)),this._state.state=3,this._state.readLen=U,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const v=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),o(v,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(v,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=_;class a extends C.Disposable{constructor(w,v,k,O,U,F){super();this._tracer=w,this._onData=U,this._writeFn=F,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,v?(this._zlibInflateStream=this._register(new s(this._tracer,O,k,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(w){this._writeQueue.push(w),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const w=this._writeQueue.shift();if(this._zlibDeflateStream){const v=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(v,!0)}else this._writeFn(w,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,v){return new Promise((k,O)=>{w.write(v),w.flush(U=>k(U))})}acceptFrame(w,v,k){this._readQueue.push({data:w,isCompressed:v,isLastFrameOfMessage:k}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const v=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(v)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1}}_inflateFrame(w,v,k){return new Promise((O,U)=>{w.write(v),k&&w.write(D.VSBuffer.fromByteArray([0,0,255,255])),w.flush(F=>O(F))})}}class s extends C.Disposable{constructor(w,v,k,O){super();this._tracer=w,this._recordInflateBytes=v,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=p.createInflateRaw(O),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(D.VSBuffer.wrap(U))}),k&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",k.buffer),this._zlibInflate.write(k.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const v=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(v)})}}class m extends C.Disposable{constructor(w,v){super();this._tracer=w,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=p.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibDeflate.on("data",k=>{this._tracer.traceSocketEvent("zlibDeflateData",k),this._pendingDeflateData.push(D.VSBuffer.wrap(k))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let v=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,v=v.slice(0,v.byteLength-4),w(v)})}}function o(h,w){if(w===0)return;let v=h.byteLength>>>2;for(let V=0;V<v;V++){const $=h.readUInt32BE(V*4);h.writeUInt32BE($^w,V*4)}let k=v*4,O=h.byteLength-k;const U=w>>>24&255,F=w>>>16&255,M=w>>>8&255;O>=1&&h.writeUInt8(h.readUInt8(k)^U,k),O>=2&&h.writeUInt8(h.readUInt8(k+1)^F,k+1),O>=3&&h.writeUInt8(h.readUInt8(k+2)^M,k+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function r(){const h=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):w=(0,A.join)((0,I.tmpdir)(),`vscode-ipc-${h}.sock`),n(w),w}e.createRandomIPCHandle=r;function i(h,w,v){const k=(0,f.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${k}-${v}-${w}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${k.substr(0,8)}-${v}-${w}.sock`):O=(0,A.join)(h,`${v}-${w}.sock`),n(O),O}e.createStaticIPCHandle=i;function n(h){const w=S[R.platform];typeof w=="number"&&h.length>=w&&console.warn(`WARNING: IPC handle "${h}" is longer than ${w} chars, try a shorter --user-data-dir`)}class u extends l.IPCServer{constructor(w){super(u.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const v=P.Event.fromNodeEventEmitter(w,"connection");return P.Event.map(v,k=>({protocol:new b.Protocol(new g(k,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(k,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function c(h){return new Promise((w,v)=>{const k=(0,t.createServer)();k.on("error",v),k.listen(h,()=>{k.removeListener("error",v),w(new u(k))})})}e.serve=c;function d(h,w){return new Promise((v,k)=>{const O=(0,t.createConnection)(h,()=>{O.removeListener("error",k),v(b.Client.fromSocket(new g(O,`ipc-client${w}`),w))});O.once("error",k)})}e.connect=d}),define(pe[287],ve([0,1,138,282,60,38,2,198,11]),function(Z,e,f,t,I,D,T,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(l,b,p){this._commands=l,this.logService=b,this._ipcHandlePath=p,this._server=t.createServer((g,E)=>this.onRequest(g,E)),this.setup().catch(g=>(b.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,b){const p=[];l.setEncoding("utf8"),l.on("data",g=>p.push(g)),l.on("end",()=>{const g=JSON.parse(p.join(""));switch(g.type){case"open":this.open(g,b);break;case"openExternal":this.openExternal(g,b);break;case"status":this.getStatus(g,b);break;case"extensionManagement":this.manageExtensions(g,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${g.type}`,E=>{E&&this.logService.error(E)}),b.end();break}})}open(l,b){const{fileURIs:p,folderURIs:g,forceNewWindow:E,diffMode:L,addMode:_,forceReuseWindow:a,gotoLineMode:s,waitMarkerFilePath:m,remoteAuthority:o}=l,S=[];if(Array.isArray(g))for(const u of g)try{S.push({folderUri:T.URI.parse(u)})}catch{}if(Array.isArray(p))for(const u of p)try{(0,P.hasWorkspaceFileExtension)(u)?S.push({workspaceUri:T.URI.parse(u)}):S.push({fileUri:T.URI.parse(u)})}catch{}const r=m?T.URI.file(m):void 0,n={forceNewWindow:E,diffMode:L,addMode:_,gotoLineMode:s,forceReuseWindow:a,preferNewWindow:!a&&!r&&!_,waitMarkerFileURI:r,remoteAuthority:o};this._commands.executeCommand("_remoteCLI.windowOpen",S,n),b.writeHead(200),b.end()}async openExternal(l,b){for(const p of l.uris){const g=T.URI.parse(p),E=g.scheme==="file"?g:p;await this._commands.executeCommand("_remoteCLI.openExternal",E)}b.writeHead(200),b.end()}async manageExtensions(l,b){try{const p=L=>L?.map(_=>/\.vsix$/i.test(_)?T.URI.parse(_):_),g={list:l.list,install:p(l.install),uninstall:p(l.uninstall),force:l.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",g);b.writeHead(200),b.write(E)}catch(p){b.writeHead(500),b.write(String(p),g=>{g&&this.logService.error(g)})}b.end()}async getStatus(l,b){try{const p=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(p),b.end()}catch(p){b.writeHead(500),b.write(String(p),g=>{g&&this.logService.error(g)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let R=class extends A{constructor(l,b){super(l,b,(0,f.createRandomIPCHandle)())}};R=je([He(0,D.IExtHostCommands),He(1,C.ILogService)],R),e.CLIServer=R}),define(pe[288],ve([0,1,72,280,268,5,281,39,258,2,10,7,287,105]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class p extends I.RequireInterceptor{_installInterceptor(){const L=this,_=Z.__$__nodeRequire("module"),a=_._load;_._load=function(S,r,i){return S=m(S),L._factories.has(S)?L._factories.get(S).load(S,A.URI.file((0,b.realpathSync)(r.filename)),n=>a.apply(this,[n,r,i])):a.apply(this,arguments)};const s=_._resolveLookupPaths;_._resolveLookupPaths=(o,S)=>s.call(this,m(o),S);const m=o=>{for(let S of L._alternatives){let r=S(o);if(r){o=r;break}}return o}}}class g extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const L=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(p,L,this._registry).install(),f.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const s=process.send,m=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?s.apply(process,o):(m.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(L){return L.main}_loadCommonJSModule(L,_,a){if(_.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let s=null;a.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{L&&f.mark(`code/extHost/willLoadExtensionCode/${L.value}`),s=Z.__$__nodeRequire(_.fsPath)}catch(m){return Promise.reject(m)}finally{L&&f.mark(`code/extHost/didLoadExtensionCode/${L.value}`),a.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(L){if(!!this._initData.remote.isRemote)for(const _ in L){const a=L[_];a===null?delete process.env[_]:process.env[_]=a}}}e.ExtHostExtensionService=g}),define(pe[289],ve([0,1,61,261,270,269,286,288,262,54,39,73,71,34,51,68,260,259,11]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(R.IExtHostExtensionService,P.ExtHostExtensionService),(0,f.registerSingleton)(_.ILoggerService,L.ExtHostLoggerService),(0,f.registerSingleton)(g.IExtensionStoragePaths,E.ExtensionStoragePaths),(0,f.registerSingleton)(A.IExtHostDebugService,D.ExtHostDebugService),(0,f.registerSingleton)(y.IExtHostSearch,T.NativeExtHostSearch),(0,f.registerSingleton)(l.IExtHostTask,I.ExtHostTask),(0,f.registerSingleton)(b.IExtHostTerminalService,t.ExtHostTerminalService),(0,f.registerSingleton)(p.IExtHostTunnelService,C.ExtHostTunnelService)}),define(pe[290],ve([0,1,125,300,72,15,107,138,191,223,271,22,103,30,105,17,114,273,289]),function(Z,e,f,t,I,D,T,P,C,A,R,y,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const L=t(process.argv.slice(2),{string:["uriTransformerPath"],boolean:["skipWorkspaceStorageLock","useHostProxy"]});(function(){const i=Z.__$__nodeRequire("module"),n=i._load;i._load=function(u){if(u==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const _=process.exit.bind(process);function a(i){process.exit=function(n){if(i)_(n);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let s=function(i){_()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,n)=>{let u=null,c=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const d=108e5,h=3e5,w=new g.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),d),v=new g.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),h);process.on("message",(O,U)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const F=y.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let M;if(O.skipWebSocketFrames)M=new P.NodeSocket(U,"extHost-socket");else{const V=y.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));M=new P.WebSocketNodeSocket(new P.NodeSocket(U,"extHost-socket"),O.permessageDeflate,V,!1)}u?(w.cancel(),v.cancel(),u.beginAcceptReconnection(M,F),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(c),u=new T.PersistentProtocol(M,F),u.sendResume(),u.onDidDispose(()=>s("renderer disconnected")),i(u),u.onSocketClose(()=>{w.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(v.isScheduled())return;w.isScheduled()&&v.schedule()}});const k={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(k)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,u)=>{const c=f.createConnection(i,()=>{c.removeListener("error",u),n(new T.PersistentProtocol(new P.NodeSocket(c,"extHost-renderer")))});c.once("error",u),c.on("close",()=>{s("renderer closed the socket")})})}}async function o(){const i=await m();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(n=>{(0,A.isMessageOfType)(n,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||i.send(n)}drain(){return i.drain()}}}function S(i){return new Promise(n=>{const u=i.onMessage(c=>{u.dispose();const d=JSON.parse(c.toString()),h=d.commit,w=C.default.commit;h&&w&&h!==w&&_(55);let v=0;setInterval(function(){try{process.kill(d.parentPid,0),v=0}catch(O){O&&O.code==="EPERM"?(v++,v>=3&&s(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):s(`parent process ${d.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let k;try{k=Z.__$__nodeRequire("native-watchdog"),k.start(d.parentPid)}catch(O){(0,D.onUnexpectedError)(O)}i.send((0,A.createMessageOfType)(0)),n({protocol:i,initData:d})});i.send((0,A.createMessageOfType)(1))})}async function r(){const i=[];process.on("unhandledRejection",(v,k)=>{i.push(k),setTimeout(()=>{const O=i.indexOf(k);O>=0&&k.catch(U=>{i.splice(O,1),(0,D.isCancellationError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),v&&(0,D.onUnexpectedError)(v))})},1e3)}),process.on("rejectionHandled",v=>{const k=i.indexOf(v);k>=0&&i.splice(k,1)}),process.on("uncaughtException",function(v){(0,D.onUnexpectedError)(v)}),I.mark("code/extHost/willConnectToRenderer");const n=await o();I.mark("code/extHost/didConnectToRenderer");const u=await S(n);I.mark("code/extHost/didWaitForInitData");const{initData:c}=u;a(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=!!L.useHostProxy,c.environment.skipWorkspaceStorageLock=(0,E.boolean)(L.skipWorkspaceStorageLock,!1);const d=new class{constructor(){this.pid=process.pid}exit(k){_(k)}exists(k){return b.Promises.exists(k)}realpath(k){return(0,p.realpath)(k)}};let h=null;if(c.remote.authority&&L.uriTransformerPath)try{const k=Z.__$__nodeRequire(L.uriTransformerPath)(c.remote.authority);h=new l.URITransformer(k)}catch(v){console.error(v)}const w=new R.ExtensionHostMain(u.protocol,c,d,h);s=v=>w.terminate(v)}e.startExtensionHostProcess=r}),define(pe[301],ve([0,1,290]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.startExtensionHostProcess)().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0e435cf51d0e45293a94466fc3b1299ba70fa9b1/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
